/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/platform/files/common/files","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/state/electron-main/state","vs/platform/userDataProfile/electron-main/userDataProfile","vs/base/common/json","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/uriIdentity/common/uriIdentity","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],Z=function(q){for(var e=[],S=0,t=q.length;S<t;S++)e[S]=J[q[S]];return e};define(J[119],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function S(D){return D?D.replace(/\$\((.*?)\)/g,(C,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(C,l,g){this.id=C,this.definition=l,this.description=g,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function k(D,C){const l=["codicon","codicon-"+D];return C&&l.push("codicon-modifier-"+C),l}e.getClassNamesArray=k;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function l(E){if(E instanceof t)return["codicon","codicon-"+E.id];const y=C.exec(E.id);if(!y)return l(t.error);const[,f,h]=y,b=["codicon","codicon-"+f];return h&&b.push("codicon-modifier-"+h.substr(1)),b}D.asClassNameArray=l;function g(E){return l(E).join(" ")}D.asClassName=g;function I(E){return"."+l(E).join(".")}D.asCSSSelector=I})(R=e.CSSIcon||(e.CSSIcon={}))}),define(J[120],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(C,l){const g=Math.pow(10,l);return Math.round(C*g)/g}class t{constructor(l,g,I,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,I))|0,this.a=S(Math.max(Math.min(1,E),0),3)}static equals(l,g){return l.r===g.r&&l.g===g.g&&l.b===g.b&&l.a===g.a}}e.RGBA=t;class k{constructor(l,g,I,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=S(Math.max(Math.min(1,g),0),3),this.l=S(Math.max(Math.min(1,I),0),3),this.a=S(Math.max(Math.min(1,E),0),3)}static equals(l,g){return l.h===g.h&&l.s===g.s&&l.l===g.l&&l.a===g.a}static fromRGBA(l){const g=l.r/255,I=l.g/255,E=l.b/255,y=l.a,f=Math.max(g,I,E),h=Math.min(g,I,E);let b=0,w=0;const m=(h+f)/2,v=f-h;if(v>0){switch(w=Math.min(m<=.5?v/(2*m):v/(2-2*m),1),f){case g:b=(I-E)/v+(I<E?6:0);break;case I:b=(E-g)/v+2;break;case E:b=(g-I)/v+4;break}b*=60,b=Math.round(b)}return new k(b,w,m,y)}static _hue2rgb(l,g,I){return I<0&&(I+=1),I>1&&(I-=1),I<1/6?l+(g-l)*6*I:I<1/2?g:I<2/3?l+(g-l)*(2/3-I)*6:l}static toRGBA(l){const g=l.h/360,{s:I,l:E,a:y}=l;let f,h,b;if(I===0)f=h=b=E;else{const w=E<.5?E*(1+I):E+I-E*I,m=2*E-w;f=k._hue2rgb(m,w,g+1/3),h=k._hue2rgb(m,w,g),b=k._hue2rgb(m,w,g-1/3)}return new t(Math.round(f*255),Math.round(h*255),Math.round(b*255),y)}}e.HSLA=k;class R{constructor(l,g,I,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=S(Math.max(Math.min(1,g),0),3),this.v=S(Math.max(Math.min(1,I),0),3),this.a=S(Math.max(Math.min(1,E),0),3)}static equals(l,g){return l.h===g.h&&l.s===g.s&&l.v===g.v&&l.a===g.a}static fromRGBA(l){const g=l.r/255,I=l.g/255,E=l.b/255,y=Math.max(g,I,E),f=Math.min(g,I,E),h=y-f,b=y===0?0:h/y;let w;return h===0?w=0:y===g?w=((I-E)/h%6+6)%6:y===I?w=(E-g)/h+2:w=(g-I)/h+4,new R(Math.round(w*60),b,y,l.a)}static toRGBA(l){const{h:g,s:I,v:E,a:y}=l,f=E*I,h=f*(1-Math.abs(g/60%2-1)),b=E-f;let[w,m,v]=[0,0,0];return g<60?(w=f,m=h):g<120?(w=h,m=f):g<180?(m=f,v=h):g<240?(m=h,v=f):g<300?(w=h,v=f):g<=360&&(w=f,v=h),w=Math.round((w+b)*255),m=Math.round((m+b)*255),v=Math.round((v+b)*255),new t(w,m,v,y)}}e.HSVA=R;class D{constructor(l){if(l)if(l instanceof t)this.rgba=l;else if(l instanceof k)this._hsla=l,this.rgba=k.toRGBA(l);else if(l instanceof R)this._hsva=l,this.rgba=R.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(l){return D.Format.CSS.parseHex(l)||D.red}get hsla(){return this._hsla?this._hsla:k.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(l){return!!l&&t.equals(this.rgba,l.rgba)&&k.equals(this.hsla,l.hsla)&&R.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=D._relativeLuminanceForComponent(this.rgba.r),g=D._relativeLuminanceForComponent(this.rgba.g),I=D._relativeLuminanceForComponent(this.rgba.b),E=.2126*l+.7152*g+.0722*I;return S(E,4)}static _relativeLuminanceForComponent(l){const g=l/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(l){const g=this.getRelativeLuminance(),I=l.getRelativeLuminance();return g>I?(g+.05)/(I+.05):(I+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const g=this.getRelativeLuminance(),I=l.getRelativeLuminance();return g>I}isDarkerThan(l){const g=this.getRelativeLuminance(),I=l.getRelativeLuminance();return g<I}lighten(l){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new D(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:g,g:I,b:E,a:y}=this.rgba;return new D(new t(g,I,E,y*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const g=l.rgba,I=this.rgba.a,E=g.a,y=I+E*(1-I);if(y<1e-6)return D.transparent;const f=this.rgba.r*I/y+g.r*E*(1-I)/y,h=this.rgba.g*I/y+g.g*E*(1-I)/y,b=this.rgba.b*I/y+g.b*E*(1-I)/y;return new D(new t(f,h,b,y))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:g,g:I,b:E,a:y}=this.rgba;return new D(new t(l.rgba.r-y*(l.rgba.r-g),l.rgba.g-y*(l.rgba.g-I),l.rgba.b-y*(l.rgba.b-E),1))}flatten(...l){const g=l.reduceRight((I,E)=>D._flatten(E,I));return D._flatten(this,g)}static _flatten(l,g){const I=1-l.rgba.a;return new D(new t(I*g.rgba.r+l.rgba.a*l.rgba.r,I*g.rgba.g+l.rgba.a*l.rgba.g,I*g.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this._toString||(this._toString=D.Format.CSS.format(this)),this._toString}static getLighterColor(l,g,I){if(l.isLighterThan(g))return l;I=I||.5;const E=l.getRelativeLuminance(),y=g.getRelativeLuminance();return I=I*(y-E)/y,l.lighten(I)}static getDarkerColor(l,g,I){if(l.isDarkerThan(g))return l;I=I||.5;const E=l.getRelativeLuminance(),y=g.getRelativeLuminance();return I=I*(E-y)/E,l.darken(I)}}e.Color=D,D.white=new D(new t(255,255,255,1)),D.black=new D(new t(0,0,0,1)),D.red=new D(new t(255,0,0,1)),D.blue=new D(new t(0,0,255,1)),D.green=new D(new t(0,255,0,1)),D.cyan=new D(new t(0,255,255,1)),D.lightgrey=new D(new t(211,211,211,1)),D.transparent=new D(new t(0,0,0,0)),function(C){let l;(function(g){let I;(function(E){function y(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:C.Format.CSS.formatRGBA(n)}E.formatRGB=y;function f(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}E.formatRGBA=f;function h(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(n)}E.formatHSL=h;function b(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}E.formatHSLA=b;function w(n){const o=n.toString(16);return o.length!==2?"0"+o:o}function m(n){return`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}`}E.formatHex=m;function v(n,o=!1){return o&&n.rgba.a===1?C.Format.CSS.formatHex(n):`#${w(n.rgba.r)}${w(n.rgba.g)}${w(n.rgba.b)}${w(Math.round(n.rgba.a*255))}`}E.formatHexA=v;function d(n){return n.isOpaque()?C.Format.CSS.formatHex(n):C.Format.CSS.formatRGBA(n)}E.format=d;function p(n){const o=n.length;if(o===0||n.charCodeAt(0)!==35)return null;if(o===7){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),r=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6));return new C(new t(i,r,s,1))}if(o===9){const i=16*c(n.charCodeAt(1))+c(n.charCodeAt(2)),r=16*c(n.charCodeAt(3))+c(n.charCodeAt(4)),s=16*c(n.charCodeAt(5))+c(n.charCodeAt(6)),a=16*c(n.charCodeAt(7))+c(n.charCodeAt(8));return new C(new t(i,r,s,a/255))}if(o===4){const i=c(n.charCodeAt(1)),r=c(n.charCodeAt(2)),s=c(n.charCodeAt(3));return new C(new t(16*i+i,16*r+r,16*s+s))}if(o===5){const i=c(n.charCodeAt(1)),r=c(n.charCodeAt(2)),s=c(n.charCodeAt(3)),a=c(n.charCodeAt(4));return new C(new t(16*i+i,16*r+r,16*s+s,(16*a+a)/255))}return null}E.parseHex=p;function c(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(I=g.CSS||(g.CSS={}))})(l=C.Format||(C.Format={}))}(D=e.Color||(e.Color={}))}),define(J[52],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(D){return(C,l,g)=>{let I=null,E=null;if(typeof g.value=="function"?(I="value",E=g.value):typeof g.get=="function"&&(I="get",E=g.get),!E)throw new Error("not supported");g[I]=D(E,l)}}e.createDecorator=S;function t(D,C,l){let g=null,I=null;if(typeof l.value=="function"?(g="value",I=l.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",I=l.get),!I)throw new Error("not supported");const E=`$memoize$${C}`;l[g]=function(...y){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,y)}),this[E]}}e.memoize=t;function k(D,C,l){return S((g,I)=>{const E=`$debounce$${I}`,y=`$debounce$result$${I}`;return function(...f){this[y]||(this[y]=l?l():void 0),clearTimeout(this[E]),C&&(this[y]=C(this[y],...f),f=[this[y]]),this[E]=setTimeout(()=>{g.apply(this,f),this[y]=l?l():void 0},D)}})}e.debounce=k;function R(D,C,l){return S((g,I)=>{const E=`$throttle$timer$${I}`,y=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...b){if(this[y]||(this[y]=l?l():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),C&&(this[y]=C(this[y],...b)),this[h])return;const w=this[f]+D;w<=Date.now()?(this[f]=Date.now(),g.apply(this,[this[y]]),this[y]=l?l():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[f]=Date.now(),g.apply(this,[this[y]]),this[y]=l?l():void 0},w-Date.now()))}})}e.throttle=R}),define(J[17],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=S,e.errorHandler=new S;function t(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=t;function k(c){l(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function R(c){l(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=R;function D(c){if(c instanceof Error){const{name:n,message:o}=c,i=c.stacktrace||c.stack;return{$isError:!0,name:n,message:o,stack:i,noTelemetry:d.isErrorNoTelemetry(c)}}return c}e.transformErrorForSerialization=D;const C="Canceled";function l(c){return c instanceof g?!0:c instanceof Error&&c.name===C&&c.message===C}e.isCancellationError=l;class g extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=g;function I(){const c=new Error(C);return c.name=c.message,c}e.canceled=I;function E(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=E;function y(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=y;function f(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function h(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function b(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=b;class w extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=w;class m extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const o=new d;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=d;class p extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(J[24],Z([0,1,17]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(H,te=0){return H[H.length-(1+te)]}e.tail=t;function k(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=k;function R(H,te,ie=(oe,ge)=>oe===ge){if(H===te)return!0;if(!H||!te||H.length!==te.length)return!1;for(let oe=0,ge=H.length;oe<ge;oe++)if(!ie(H[oe],te[oe]))return!1;return!0}e.equals=R;function D(H,te){const ie=H.length-1;te<ie&&(H[te]=H[ie]),H.pop()}e.removeFastWithoutKeepingOrder=D;function C(H,te,ie){return l(H.length,oe=>ie(H[oe],te))}e.binarySearch=C;function l(H,te){let ie=0,oe=H-1;for(;ie<=oe;){const ge=(ie+oe)/2|0,Me=te(ge);if(Me<0)ie=ge+1;else if(Me>0)oe=ge-1;else return ge}return-(ie+1)}e.binarySearch2=l;function g(H,te){let ie=0,oe=H.length;if(oe===0)return 0;for(;ie<oe;){const ge=Math.floor((ie+oe)/2);te(H[ge])?oe=ge:ie=ge+1}return ie}e.findFirstInSorted=g;function I(H,te,ie){if(H=H|0,H>=te.length)throw new TypeError("invalid index");const oe=te[Math.floor(te.length*Math.random())],ge=[],Me=[],Le=[];for(const ke of te){const Ae=ie(ke,oe);Ae<0?ge.push(ke):Ae>0?Me.push(ke):Le.push(ke)}return H<ge.length?I(H,ge,ie):H<ge.length+Le.length?Le[0]:I(H-(ge.length+Le.length),Me,ie)}e.quickSelect=I;function E(H,te){const ie=[];let oe;for(const ge of H.slice(0).sort(te))!oe||te(oe[0],ge)!==0?(oe=[ge],ie.push(oe)):oe.push(ge);return ie}e.groupBy=E;function y(H,te,ie){const oe=[];function ge(ke,Ae,Ve){if(Ae===0&&Ve.length===0)return;const me=oe[oe.length-1];me&&me.start+me.deleteCount===ke?(me.deleteCount+=Ae,me.toInsert.push(...Ve)):oe.push({start:ke,deleteCount:Ae,toInsert:Ve})}let Me=0,Le=0;for(;;){if(Me===H.length){ge(Me,0,te.slice(Le));break}if(Le===te.length){ge(Me,H.length-Me,[]);break}const ke=H[Me],Ae=te[Le],Ve=ie(ke,Ae);Ve===0?(Me+=1,Le+=1):Ve<0?(ge(Me,1,[]),Me+=1):Ve>0&&(ge(Me,0,[Ae]),Le+=1)}return oe}e.sortedDiff=y;function f(H,te,ie){const oe=y(H,te,ie),ge=[],Me=[];for(const Le of oe)ge.push(...H.slice(Le.start,Le.start+Le.deleteCount)),Me.push(...Le.toInsert);return{removed:ge,added:Me}}e.delta=f;function h(H,te,ie){if(ie===0)return[];const oe=H.slice(0,ie).sort(te);return w(H,te,oe,ie,H.length),oe}e.top=h;function b(H,te,ie,oe,ge){return ie===0?Promise.resolve([]):new Promise((Me,Le)=>{(async()=>{const ke=H.length,Ae=H.slice(0,ie).sort(te);for(let Ve=ie,me=Math.min(ie+oe,ke);Ve<ke;Ve=me,me=Math.min(me+oe,ke)){if(Ve>ie&&await new Promise(we=>setTimeout(we)),ge&&ge.isCancellationRequested)throw new S.CancellationError;w(H,te,Ae,Ve,me)}return Ae})().then(Me,Le)})}e.topAsync=b;function w(H,te,ie,oe,ge){for(const Me=ie.length;oe<ge;oe++){const Le=H[oe];if(te(Le,ie[Me-1])<0){ie.pop();const ke=g(ie,Ae=>te(Le,Ae)<0);ie.splice(ke,0,Le)}}}function m(H){return H.filter(te=>!!te)}e.coalesce=m;function v(H){let te=0;for(let ie=0;ie<H.length;ie++)H[ie]&&(H[te]=H[ie],te+=1);H.length=te}e.coalesceInPlace=v;function d(H,te,ie){H.splice(ie,0,H.splice(te,1)[0])}e.move=d;function p(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=p;function c(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=c;function n(H,te=ie=>ie){const ie=new Set;return H.filter(oe=>{const ge=te(oe);return ie.has(ge)?!1:(ie.add(ge),!0)})}e.distinct=n;function o(H){const te=new Set;return ie=>{const oe=H(ie);return te.has(oe)?!1:(te.add(oe),!0)}}e.uniqueFilter=o;function i(H,te){const ie=r(H,te);if(ie!==-1)return H[ie]}e.findLast=i;function r(H,te){for(let ie=H.length-1;ie>=0;ie--){const oe=H[ie];if(te(oe))return ie}return-1}e.lastIndex=r;function s(H,te){return H.length>0?H[0]:te}e.firstOrDefault=s;function a(H,te){return H.length>0?H[H.length-1]:te}e.lastOrDefault=a;function u(H,te,ie=(oe,ge)=>oe===ge){let oe=0;for(let ge=0,Me=Math.min(H.length,te.length);ge<Me&&ie(H[ge],te[ge]);ge++)oe++;return oe}e.commonPrefixLength=u;function P(H){return[].concat(...H)}e.flatten=P;function M(H,te){let ie=typeof te=="number"?H:0;typeof te=="number"?ie=H:(ie=0,te=H);const oe=[];if(ie<=te)for(let ge=ie;ge<te;ge++)oe.push(ge);else for(let ge=ie;ge>te;ge--)oe.push(ge);return oe}e.range=M;function T(H,te,ie){return H.reduce((oe,ge)=>(oe[te(ge)]=ie?ie(ge):ge,oe),Object.create(null))}e.index=T;function F(H,te){return H.push(te),()=>U(H,te)}e.insert=F;function U(H,te){const ie=H.indexOf(te);if(ie>-1)return H.splice(ie,1),te}e.remove=U;function Q(H,te,ie){const oe=H.slice(0,te),ge=H.slice(te);return oe.concat(ie,ge)}e.arrayInsert=Q;function re(H,te){let ie;if(typeof te=="number"){let oe=te;ie=()=>{const ge=Math.sin(oe++)*179426549;return ge-Math.floor(ge)}}else ie=Math.random;for(let oe=H.length-1;oe>0;oe-=1){const ge=Math.floor(ie()*(oe+1)),Me=H[oe];H[oe]=H[ge],H[ge]=Me}}e.shuffle=re;function le(H,te){const ie=H.indexOf(te);ie>-1&&(H.splice(ie,1),H.unshift(te))}e.pushToStart=le;function ue(H,te){const ie=H.indexOf(te);ie>-1&&(H.splice(ie,1),H.push(te))}e.pushToEnd=ue;function se(H,te){for(const ie of te)H.push(ie)}e.pushMany=se;function de(H,te){return Array.isArray(H)?H.map(te):te(H)}e.mapArrayOrNot=de;function K(H){return Array.isArray(H)?H:[H]}e.asArray=K;function $(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=$;function _(H,te){for(const ie of H){const oe=te(ie);if(oe!==void 0)return oe}}e.mapFind=_;function A(H,te,ie){const oe=z(H,te),ge=H.length,Me=ie.length;H.length=ge+Me;for(let Le=ge-1;Le>=oe;Le--)H[Le+Me]=H[Le];for(let Le=0;Le<Me;Le++)H[Le+oe]=ie[Le]}e.insertInto=A;function W(H,te,ie,oe){const ge=z(H,te),Me=H.splice(ge,ie);return A(H,ge,oe),Me}e.splice=W;function z(H,te){return te<0?Math.max(te+H.length,0):Math.min(te,H.length)}var ee;(function(H){function te(ge){return ge<0}H.isLessThan=te;function ie(ge){return ge>0}H.isGreaterThan=ie;function oe(ge){return ge===0}H.isNeitherLessOrGreaterThan=oe,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function B(H,te){return(ie,oe)=>te(H(ie),H(oe))}e.compareBy=B;function j(...H){return(te,ie)=>{for(const oe of H){const ge=oe(te,ie);if(!ee.isNeitherLessOrGreaterThan(ge))return ge}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const L=(H,te)=>H-te;e.numberComparator=L;function O(H,te){if(H.length===0)return;let ie=H[0];for(let oe=1;oe<H.length;oe++){const ge=H[oe];te(ge,ie)>0&&(ie=ge)}return ie}e.findMaxBy=O;function N(H,te){if(H.length===0)return;let ie=H[0];for(let oe=1;oe<H.length;oe++){const ge=H[oe];te(ge,ie)>=0&&(ie=ge)}return ie}e.findLastMaxBy=N;function V(H,te){return O(H,(ie,oe)=>-te(ie,oe))}e.findMinBy=V;class x{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ie=this.firstIdx;for(;ie<this.items.length&&te(this.items[ie]);)ie++;const oe=ie===this.firstIdx?null:this.items.slice(this.firstIdx,ie);return this.firstIdx=ie,oe}takeFromEndWhile(te){let ie=this.lastIdx;for(;ie>=0&&te(this.items[ie]);)ie--;const oe=ie===this.lastIdx?null:this.items.slice(ie+1,this.lastIdx+1);return this.lastIdx=ie,oe}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ie=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ie}}e.ArrayQueue=x;class ne{constructor(te){this.iterate=te}forEach(te){this.iterate(ie=>(te(ie),!0))}toArray(){const te=[];return this.iterate(ie=>(te.push(ie),!0)),te}filter(te){return new ne(ie=>this.iterate(oe=>te(oe)?ie(oe):!0))}map(te){return new ne(ie=>this.iterate(oe=>ie(te(oe))))}some(te){let ie=!1;return this.iterate(oe=>(ie=te(oe),!ie)),ie}findFirst(te){let ie;return this.iterate(oe=>te(oe)?(ie=oe,!1):!0),ie}findLast(te){let ie;return this.iterate(oe=>(te(oe)&&(ie=oe),!0)),ie}findLastMaxBy(te){let ie,oe=!0;return this.iterate(ge=>((oe||ee.isGreaterThan(te(ge,ie)))&&(oe=!1,ie=ge),!0)),ie}}e.CallbackIterable=ne,ne.empty=new ne(H=>{})}),define(J[121],Z([0,1,17]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(l,g){if(!l)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=t;function k(l,g="Unreachable"){throw new Error(g)}e.assertNever=k;function R(l){if(!l)throw new S.BugIndicatingError("Assertion Failed")}e.assert=R;function D(l){if(!l()){debugger;l(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function C(l,g){let I=0;for(;I<l.length-1;){const E=l[I],y=l[I+1];if(!g(E,y))return!1;I++}return!0}e.checkAdjacentItems=C}),define(J[48],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const k=this;let R=!1,D;return function(){return R||(R=!0,D=t.apply(k,arguments)),D}}e.once=S}),define(J[57],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function k(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function D(){return R}t.empty=D;function*C(o){yield o}t.single=C;function l(o){return o||R}t.from=l;function g(o){return!o||o[Symbol.iterator]().next().done===!0}t.isEmpty=g;function I(o){return o[Symbol.iterator]().next().value}t.first=I;function E(o,i){for(const r of o)if(i(r))return!0;return!1}t.some=E;function y(o,i){for(const r of o)if(i(r))return r}t.find=y;function*f(o,i){for(const r of o)i(r)&&(yield r)}t.filter=f;function*h(o,i){let r=0;for(const s of o)yield i(s,r++)}t.map=h;function*b(...o){for(const i of o)for(const r of i)yield r}t.concat=b;function*w(o){for(const i of o)for(const r of i)yield r}t.concatNested=w;function m(o,i,r){let s=r;for(const a of o)s=i(s,a);return s}t.reduce=m;function v(o,i){let r=0;for(const s of o)i(s,r++)}t.forEach=v;function*d(o,i,r=o.length){for(i<0&&(i+=o.length),r<0?r+=o.length:r>o.length&&(r=o.length);i<r;i++)yield o[i]}t.slice=d;function p(o,i=Number.POSITIVE_INFINITY){const r=[];if(i===0)return[r,o];const s=o[Symbol.iterator]();for(let a=0;a<i;a++){const u=s.next();if(u.done)return[r,t.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=p;function c(o){return p(o)[0]}t.collect=c;function n(o,i,r=(s,a)=>s===a){const s=o[Symbol.iterator](),a=i[Symbol.iterator]();for(;;){const u=s.next(),P=a.next();if(u.done!==P.done)return!1;if(u.done)return!0;if(!r(u.value,P.value))return!1}}t.equals=n})(S=e.Iterable||(e.Iterable={}))}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(n,o=!1){let i=0;const r=n.length;let s="",a=0,u=16,P=0;function M(ue){let se=0,de=0;for(;se<ue;){const K=n.charCodeAt(i);if(K>=48&&K<=57)de=de*16+K-48;else if(K>=65&&K<=70)de=de*16+K-65+10;else if(K>=97&&K<=102)de=de*16+K-97+10;else break;i++,se++}return se<ue&&(de=-1),de}function T(ue){i=ue,s="",a=0,u=16,P=0}function F(){const ue=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&g(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&g(n.charCodeAt(i)))for(i++;i<n.length&&g(n.charCodeAt(i));)i++;else return P=3,n.substring(ue,i);let se=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&g(n.charCodeAt(i))){for(i++;i<n.length&&g(n.charCodeAt(i));)i++;se=i}else P=3;return n.substring(ue,se)}function U(){let ue="",se=i;for(;;){if(i>=r){ue+=n.substring(se,i),P=2;break}const de=n.charCodeAt(i);if(de===34){ue+=n.substring(se,i),i++;break}if(de===92){if(ue+=n.substring(se,i),i++,i>=r){P=2;break}switch(n.charCodeAt(i++)){case 34:ue+='"';break;case 92:ue+="\\";break;case 47:ue+="/";break;case 98:ue+="\b";break;case 102:ue+="\f";break;case 110:ue+=`
`;break;case 114:ue+="\r";break;case 116:ue+="	";break;case 117:{const $=M(4);$>=0?ue+=String.fromCharCode($):P=4;break}default:P=5}se=i;continue}if(de>=0&&de<=31)if(l(de)){ue+=n.substring(se,i),P=2;break}else P=6;i++}return ue}function Q(){if(s="",P=0,a=i,i>=r)return a=r,u=17;let ue=n.charCodeAt(i);if(C(ue)){do i++,s+=String.fromCharCode(ue),ue=n.charCodeAt(i);while(C(ue));return u=15}if(l(ue))return i++,s+=String.fromCharCode(ue),ue===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),u=14;switch(ue){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,s=U(),u=10;case 47:{const se=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<r&&!l(n.charCodeAt(i));)i++;return s=n.substring(se,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const de=r-1;let K=!1;for(;i<de;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,P=1),s=n.substring(se,i),u=13}return s+=String.fromCharCode(ue),i++,u=16}case 45:if(s+=String.fromCharCode(ue),i++,i===r||!g(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),u=11;default:for(;i<r&&re(ue);)i++,ue=n.charCodeAt(i);if(a!==i){switch(s=n.substring(a,i),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ue),i++,u=16}}function re(ue){if(C(ue)||l(ue))return!1;switch(ue){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ue;do ue=Q();while(ue>=12&&ue<=15);return ue}return{setPosition:T,getPosition:()=>i,scan:o?le:Q,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>P}}e.createScanner=D;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function E(n,o){const i=[],r=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function P(M,T,F,U){a.value=M,a.offset=T,a.length=F,a.type=U,a.colonOffset=void 0,s=a}try{d(n,{onObjectBegin:(M,T)=>{if(o<=M)throw r;s=void 0,u=o>M,i.push("")},onObjectProperty:(M,T,F)=>{if(o<T||(P(M,T,F,"property"),i[i.length-1]=M,o<=T+F))throw r},onObjectEnd:(M,T)=>{if(o<=M)throw r;s=void 0,i.pop()},onArrayBegin:(M,T)=>{if(o<=M)throw r;s=void 0,i.push(0)},onArrayEnd:(M,T)=>{if(o<=M)throw r;s=void 0,i.pop()},onLiteralValue:(M,T,F)=>{if(o<T||(P(M,T,F,c(M)),o<=T+F))throw r},onSeparator:(M,T,F)=>{if(o<=T)throw r;if(M===":"&&s&&s.type==="property")s.colonOffset=T,u=!1,s=void 0;else if(M===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(M){if(M!==r)throw M}return{path:i,previousNode:s,isAtPropertyKey:u,matches:M=>{let T=0;for(let F=0;T<M.length&&F<i.length;F++)if(M[T]===i[F]||M[T]==="*")T++;else if(M[T]!=="**")return!1;return T===M.length}}}e.getLocation=E;function y(n,o=[],i=R.DEFAULT){let r=null,s=[];const a=[];function u(M){Array.isArray(s)?s.push(M):r!==null&&(s[r]=M)}return d(n,{onObjectBegin:()=>{const M={};u(M),a.push(s),s=M,r=null},onObjectProperty:M=>{r=M},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const M=[];u(M),a.push(s),s=M,r=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:u,onError:(M,T,F)=>{o.push({error:M,offset:T,length:F})}},i),s[0]}e.parse=y;function f(n,o=[],i=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(M){r.type==="property"&&(r.length=M-r.offset,r=r.parent)}function a(M){return r.children.push(M),M}d(n,{onObjectBegin:M=>{r=a({type:"object",offset:M,length:-1,parent:r,children:[]})},onObjectProperty:(M,T,F)=>{r=a({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:M,offset:T,length:F,parent:r})},onObjectEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onArrayBegin:(M,T)=>{r=a({type:"array",offset:M,length:-1,parent:r,children:[]})},onArrayEnd:(M,T)=>{r.length=M+T-r.offset,r=r.parent,s(M+T)},onLiteralValue:(M,T,F)=>{a({type:c(M),offset:T,length:F,parent:r,value:M}),s(T+F)},onSeparator:(M,T,F)=>{r.type==="property"&&(M===":"?r.colonOffset=T:M===","&&s(T))},onError:(M,T,F)=>{o.push({error:M,offset:T,length:F})}},i);const P=r.children[0];return P&&delete P.parent,P}e.parseTree=f;function h(n,o){if(!n)return;let i=n;for(const r of o)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===r){i=a.children[1],s=!0;break}if(!s)return}else{const s=r;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=h;function b(n){if(!n.parent||!n.parent.children)return[];const o=b(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;o.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&o.push(i)}return o}e.getNodePath=b;function w(n){switch(n.type){case"array":return n.children.map(w);case"object":{const o=Object.create(null);for(const i of n.children){const r=i.children[1];r&&(o[i.children[0].value]=w(r))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=w;function m(n,o,i=!1){return o>=n.offset&&o<n.offset+n.length||i&&o===n.offset+n.length}e.contains=m;function v(n,o,i=!1){if(m(n,o,i)){const r=n.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const a=v(r[s],o,i);if(a)return a}return n}}e.findNodeAtOffset=v;function d(n,o,i=R.DEFAULT){const r=D(n,!1);function s(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function a(B){return B?j=>B(j,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=s(o.onObjectBegin),P=a(o.onObjectProperty),M=s(o.onObjectEnd),T=s(o.onArrayBegin),F=s(o.onArrayEnd),U=a(o.onLiteralValue),Q=a(o.onSeparator),re=s(o.onComment),le=a(o.onError),ue=i&&i.disallowComments,se=i&&i.allowTrailingComma;function de(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:ue||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(B){case 12:case 13:ue?K(10):re();break;case 16:K(1);break;case 15:case 14:break;default:return B}}}function K(B,j=[],L=[]){if(le(B),j.length+L.length>0){let O=r.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){de();break}else if(L.indexOf(O)!==-1)break;O=de()}}}function $(B){const j=r.getTokenValue();return B?U(j):P(j),de(),!0}function _(){switch(r.getToken()){case 11:{let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(K(2),B=0)}catch{K(2)}U(B);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return de(),!0}function A(){return r.getToken()!==10?(K(3,[],[2,5]),!1):($(!1),r.getToken()===6?(Q(":"),de(),ee()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function W(){u(),de();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||K(4,[],[]),Q(","),de(),r.getToken()===2&&se)break}else B&&K(6,[],[]);A()||K(4,[],[2,5]),B=!0}return M(),r.getToken()!==2?K(7,[2],[]):de(),!0}function z(){T(),de();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||K(4,[],[]),Q(","),de(),r.getToken()===4&&se)break}else B&&K(6,[],[]);ee()||K(4,[],[4,5]),B=!0}return F(),r.getToken()!==4?K(8,[4],[]):de(),!0}function ee(){switch(r.getToken()){case 3:return z();case 1:return W();case 10:return $(!0);default:return _()}}return de(),r.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):ee()?(r.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=d;function p(n,o){const i=D(n),r=[];let s,a=0,u;do switch(u=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==u&&r.push(n.substring(a,u)),o!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,o)),a=i.getPosition();break}while(s!==17);return r.join("")}e.stripComments=p;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[122],Z([0,1,43]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(g,I,E){let y,f,h,b,w;if(I){for(b=I.offset,w=b+I.length,h=b;h>0&&!l(g,h-1);)h--;let u=w;for(;u<g.length&&!l(g,u);)u++;f=g.substring(h,u),y=D(f,E)}else f=g,y=0,h=0,b=0,w=g.length;const m=C(E,g);let v=!1,d=0,p;E.insertSpaces?p=R(" ",E.tabSize||4):p="	";const c=(0,S.createScanner)(f,!1);let n=!1;function o(){return m+R(p,y+d)}function i(){let u=c.scan();for(v=!1;u===15||u===14;)v=v||u===14,u=c.scan();return n=u===16||c.getTokenError()!==0,u}const r=[];function s(u,P,M){!n&&P<w&&M>b&&g.substring(P,M)!==u&&r.push({offset:P,length:M-P,content:u})}let a=i();if(a!==17){const u=c.getTokenOffset()+h,P=R(p,y);s(P,h,u)}for(;a!==17;){let u=c.getTokenOffset()+c.getTokenLength()+h,P=i(),M="";for(;!v&&(P===12||P===13);){const F=c.getTokenOffset()+h;s(" ",u,F),u=c.getTokenOffset()+c.getTokenLength()+h,M=P===12?o():"",P=i()}if(P===2)a!==1&&(d--,M=o());else if(P===4)a!==3&&(d--,M=o());else{switch(a){case 3:case 1:d++,M=o();break;case 5:case 12:M=o();break;case 13:v?M=o():M=" ";break;case 6:M=" ";break;case 10:if(P===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?M=" ":P!==5&&P!==17&&(n=!0);break;case 16:n=!0;break}v&&(P===12||P===13)&&(M=o())}const T=c.getTokenOffset()+h;s(M,u,T),a=P}return r}e.format=t;function k(g,I){const E=JSON.stringify(g,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?E.replace(/\r\n|\r|\n/g,I.eol):E}e.toFormattedString=k;function R(g,I){let E="";for(let y=0;y<I;y++)E+=g;return E}function D(g,I){let E=0,y=0;const f=I.tabSize||4;for(;E<g.length;){const h=g.charAt(E);if(h===" ")y++;else if(h==="	")y+=f;else break;E++}return Math.floor(y/f)}function C(g,I){for(let E=0;E<I.length;E++){const y=I.charAt(E);if(y==="\r")return E+1<I.length&&I.charAt(E+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return g&&g.eol||`
`}e.getEOL=C;function l(g,I){return`\r
`.indexOf(g.charAt(I))!==-1}e.isEOL=l}),define(J[123],Z([0,1,43,122]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(g,I,E){return R(g,I,void 0,E)}e.removeProperty=k;function R(g,I,E,y,f){const h=I.slice(),b=[],w=(0,S.parseTree)(g,b);let m,v;for(;h.length>0&&(v=h.pop(),m=(0,S.findNodeAtLocation)(w,h),m===void 0&&E!==void 0);)typeof v=="string"?E={[v]:E}:E=[E];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,S.findNodeAtLocation)(m,[v]);if(d!==void 0)if(E===void 0){if(!d.parent)throw new Error("Malformed AST");const p=m.children.indexOf(d.parent);let c,n=d.parent.offset+d.parent.length;if(p>0){const o=m.children[p-1];c=o.offset+o.length}else c=m.offset+1,m.children.length>1&&(n=m.children[1].offset);return D(g,{offset:c,length:n-c,content:""},y)}else return D(g,{offset:d.offset,length:d.length,content:JSON.stringify(E)},y);else{if(E===void 0)return[];const p=`${JSON.stringify(v)}: ${JSON.stringify(E)}`,c=f?f(m.children.map(o=>o.children[0].value)):m.children.length;let n;if(c>0){const o=m.children[c-1];n={offset:o.offset+o.length,length:0,content:","+p}}else m.children.length===0?n={offset:m.offset+1,length:0,content:p}:n={offset:m.offset+1,length:0,content:p+","};return D(g,n,y)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(E!==void 0){const d=`${JSON.stringify(E)}`;let p;if(m.children.length===0||v===0)p={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const c=v===-1||v>m.children.length?m.children.length:v,n=m.children[c-1];p={offset:n.offset+n.length,length:0,content:","+d}}return D(g,p,y)}else{const d=v,p=m.children[d];let c;if(m.children.length===1)c={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const n=m.children[d-1],o=n.offset+n.length,i=m.offset+m.length;c={offset:o,length:i-2-o,content:""}}else c={offset:p.offset,length:m.children[d+1].offset-p.offset,content:""};return D(g,c,y)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(g,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(E)},y)}}e.setProperty=R;function D(g,I,E){let y=C(g,I),f=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;f>0&&!(0,t.isEOL)(y,f-1);)f--;for(;h<y.length&&!(0,t.isEOL)(y,h);)h++}const b=(0,t.format)(y,{offset:f,length:h-f},E);for(let m=b.length-1;m>=0;m--){const v=b[m];y=C(y,v),f=Math.min(f,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const w=g.length-(y.length-h)-f;return[{offset:f,length:w,content:y.substring(f,h)}]}e.withFormatting=D;function C(g,I){return g.substring(0,I.offset)+I.content+g.substring(I.offset+I.length)}e.applyEdit=C;function l(g,I){const E=I.slice(0).sort((f,h)=>{const b=f.offset-h.offset;return b===0?f.length-h.length:b});let y=g.length;for(let f=E.length-1;f>=0;f--){const h=E[f];if(h.offset+h.length<=y)g=C(g,h);else throw new Error("Overlapping edit");y=h.offset}return g}e.applyEdits=l}),define(J[124],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new S(()=>k(this.getValue()))}}e.Lazy=S}),define(J[2],Z([0,1,48,57]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function D(s){R=s}if(e.setDisposableTracker=D,k){const s="__is_disposable_tracked__";D(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==v.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function C(s){return R?.trackDisposable(s),s}function l(s){R?.markAsDisposed(s)}function g(s,a){R?.setParent(s,a)}function I(s,a){if(!!R)for(const u of s)R.setParent(u,a)}function E(s){return R?.markAsSingleton(s),s}e.markAsSingleton=E;function y(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=y;function f(s){if(t.Iterable.is(s)){const a=[];for(const u of s)if(u)try{u.dispose()}catch(P){a.push(P)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=f;function h(s){for(const a of s)y(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function b(...s){const a=w(()=>f(s));return I(s,a),a}e.combinedDisposable=b;function w(s){const a=C({dispose:(0,S.once)(()=>{l(a),s()})});return a}e.toDisposable=w;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return g(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,C(this),g(this._store,this)}dispose(){l(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&g(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,l(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&g(a,null),a}}e.MutableDisposable=d;class p{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,l(this))},this}}e.SafeDisposable=c;class n{constructor(){this.references=new Map}acquire(a,...u){let P=this.references.get(a);P||(P={counter:0,object:this.createReferencedObject(a,...u)},this.references.set(a,P));const{object:M}=P,T=(0,S.once)(()=>{--P.counter===0&&(this.destroyReferencedObject(a,P.object),this.references.delete(a))});return P.counter++,{object:M,dispose:T}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...u){const P=this.referenceCollection.acquire(a,...u);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(M){throw P.dispose(),M}}}e.AsyncReferenceCollection=o;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function r(s){const a=new m;try{s(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(J[125],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let R=this._first;for(;R!==S.Undefined;){const D=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=D}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const C=new S(R);if(this._first===S.Undefined)this._first=C,this._last=C;else if(D){const g=this._last;this._last=C,C.prev=g,g.next=C}else{const g=this._first;this._first=C,C.next=g,g.prev=C}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(C))}}shift(){if(this._first!==S.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==S.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===S.Undefined&&R.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):R.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):R.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function q(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function D(l){R.push(l,Date.now())}function C(){const l=[];for(let g=0;g<R.length;g+=2)l.push({name:R[g],startTime:R[g+1]});return l}return{mark:D,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(k+D.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function S(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),function(q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var t in S)(typeof exports=="object"?exports:q)[t]=S[t]}}(typeof self<"u"?self:this,function(){return function(q){var e={};function S(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return q[t].call(k.exports,k,k.exports,S),k.l=!0,k.exports}return S.m=q,S.c=e,S.d=function(t,k,R){S.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},S.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},S.t=function(t,k){if(1&k&&(t=S(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var D in t)S.d(R,D,function(C){return t[C]}.bind(null,D));return R},S.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return S.d(k,"a",k),k},S.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},S.p="",S(S.s=0)}([function(q,e,S){(function(t){var k;e=q.exports=L,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],l=e.src=[],g=0,I=g++;l[I]="0|[1-9]\\d*";var E=g++;l[E]="[0-9]+";var y=g++;l[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=g++;l[f]="("+l[I]+")\\.("+l[I]+")\\.("+l[I]+")";var h=g++;l[h]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var b=g++;l[b]="(?:"+l[I]+"|"+l[y]+")";var w=g++;l[w]="(?:"+l[E]+"|"+l[y]+")";var m=g++;l[m]="(?:-("+l[b]+"(?:\\."+l[b]+")*))";var v=g++;l[v]="(?:-?("+l[w]+"(?:\\."+l[w]+")*))";var d=g++;l[d]="[0-9A-Za-z-]+";var p=g++;l[p]="(?:\\+("+l[d]+"(?:\\."+l[d]+")*))";var c=g++,n="v?"+l[f]+l[m]+"?"+l[p]+"?";l[c]="^"+n+"$";var o="[v=\\s]*"+l[h]+l[v]+"?"+l[p]+"?",i=g++;l[i]="^"+o+"$";var r=g++;l[r]="((?:<|>)?=?)";var s=g++;l[s]=l[E]+"|x|X|\\*";var a=g++;l[a]=l[I]+"|x|X|\\*";var u=g++;l[u]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[m]+")?"+l[p]+"?)?)?";var P=g++;l[P]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[v]+")?"+l[p]+"?)?)?";var M=g++;l[M]="^"+l[r]+"\\s*"+l[u]+"$";var T=g++;l[T]="^"+l[r]+"\\s*"+l[P]+"$";var F=g++;l[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=g++;l[U]="(?:~>?)";var Q=g++;l[Q]="(\\s*)"+l[U]+"\\s+",C[Q]=new RegExp(l[Q],"g");var re=g++;l[re]="^"+l[U]+l[u]+"$";var le=g++;l[le]="^"+l[U]+l[P]+"$";var ue=g++;l[ue]="(?:\\^)";var se=g++;l[se]="(\\s*)"+l[ue]+"\\s+",C[se]=new RegExp(l[se],"g");var de=g++;l[de]="^"+l[ue]+l[u]+"$";var K=g++;l[K]="^"+l[ue]+l[P]+"$";var $=g++;l[$]="^"+l[r]+"\\s*("+o+")$|^$";var _=g++;l[_]="^"+l[r]+"\\s*("+n+")$|^$";var A=g++;l[A]="(\\s*)"+l[r]+"\\s*("+o+"|"+l[u]+")",C[A]=new RegExp(l[A],"g");var W=g++;l[W]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var z=g++;l[z]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var ee=g++;l[ee]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,l[B]),C[B]||(C[B]=new RegExp(l[B]));function j(X,ae){if(X instanceof L)return X;if(typeof X!="string"||X.length>R||!(ae?C[i]:C[c]).test(X))return null;try{return new L(X,ae)}catch{return null}}function L(X,ae){if(X instanceof L){if(X.loose===ae)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(X,ae);k("SemVer",X,ae),this.loose=ae;var he=X.trim().match(ae?C[i]:C[c]);if(!he)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<D)return Ie}return be}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=j,e.valid=function(X,ae){var he=j(X,ae);return he?he.version:null},e.clean=function(X,ae){var he=j(X.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof L||(X=new L(X,this.loose)),this.compareMain(X)||this.comparePre(X)},L.prototype.compareMain=function(X){return X instanceof L||(X=new L(X,this.loose)),N(this.major,X.major)||N(this.minor,X.minor)||N(this.patch,X.patch)},L.prototype.comparePre=function(X){if(X instanceof L||(X=new L(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],be=X.prerelease[ae];if(k("prerelease compare",ae,he,be),he===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(he===void 0)return-1;if(he!==be)return N(he,be)}while(++ae)},L.prototype.inc=function(X,ae){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,ae,he,be){typeof he=="string"&&(be=he,he=void 0);try{return new L(X,he).inc(ae,be).version}catch{return null}},e.diff=function(X,ae){if(H(X,ae))return null;var he=j(X),be=j(ae);if(he.prerelease.length||be.prerelease.length){for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in he)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&he[Ie]!==be[Ie])return Ie},e.compareIdentifiers=N;var O=/^[0-9]+$/;function N(X,ae){var he=O.test(X),be=O.test(ae);return he&&be&&(X=+X,ae=+ae),he&&!be?-1:be&&!he?1:X<ae?-1:X>ae?1:0}function V(X,ae,he){return new L(X,he).compare(new L(ae,he))}function x(X,ae,he){return V(X,ae,he)>0}function ne(X,ae,he){return V(X,ae,he)<0}function H(X,ae,he){return V(X,ae,he)===0}function te(X,ae,he){return V(X,ae,he)!==0}function ie(X,ae,he){return V(X,ae,he)>=0}function oe(X,ae,he){return V(X,ae,he)<=0}function ge(X,ae,he,be){var Ie;switch(ae){case"===":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ie=X===he;break;case"!==":typeof X=="object"&&(X=X.version),typeof he=="object"&&(he=he.version),Ie=X!==he;break;case"":case"=":case"==":Ie=H(X,he,be);break;case"!=":Ie=te(X,he,be);break;case">":Ie=x(X,he,be);break;case">=":Ie=ie(X,he,be);break;case"<":Ie=ne(X,he,be);break;case"<=":Ie=oe(X,he,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ie}function Me(X,ae){if(X instanceof Me){if(X.loose===ae)return X;X=X.value}if(!(this instanceof Me))return new Me(X,ae);k("comparator",X,ae),this.loose=ae,this.parse(X),this.semver===Le?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,ae){return N(ae,X)},e.major=function(X,ae){return new L(X,ae).major},e.minor=function(X,ae){return new L(X,ae).minor},e.patch=function(X,ae){return new L(X,ae).patch},e.compare=V,e.compareLoose=function(X,ae){return V(X,ae,!0)},e.rcompare=function(X,ae,he){return V(ae,X,he)},e.sort=function(X,ae){return X.sort(function(he,be){return e.compare(he,be,ae)})},e.rsort=function(X,ae){return X.sort(function(he,be){return e.rcompare(he,be,ae)})},e.gt=x,e.lt=ne,e.eq=H,e.neq=te,e.gte=ie,e.lte=oe,e.cmp=ge,e.Comparator=Me;var Le={};function ke(X,ae){if(X instanceof ke)return X.loose===ae?X:new ke(X.raw,ae);if(X instanceof Me)return new ke(X.value,ae);if(!(this instanceof ke))return new ke(X,ae);if(this.loose=ae,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ve(X,ae,he,be,Ie,Oe,We,Ue,Ne,ze,Be,qe,G){return((ae=Ae(he)?"":Ae(be)?">="+he+".0.0":Ae(Ie)?">="+he+"."+be+".0":">="+ae)+" "+(Ue=Ae(Ne)?"":Ae(ze)?"<"+(+Ne+1)+".0.0":Ae(Be)?"<"+Ne+"."+(+ze+1)+".0":qe?"<="+Ne+"."+ze+"."+Be+"-"+qe:"<="+Ue)).trim()}function me(X,ae){for(var he=0;he<X.length;he++)if(!X[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<X.length;he++)if(k(X[he].semver),X[he].semver!==Le&&X[he].semver.prerelease.length>0){var be=X[he].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function we(X,ae,he){try{ae=new ke(ae,he)}catch{return!1}return ae.test(X)}function Ee(X,ae,he,be){var Ie,Oe,We,Ue,Ne;switch(X=new L(X,be),ae=new ke(ae,be),he){case">":Ie=x,Oe=oe,We=ne,Ue=">",Ne=">=";break;case"<":Ie=ne,Oe=ie,We=x,Ue="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(X,ae,be))return!1;for(var ze=0;ze<ae.set.length;++ze){var Be=ae.set[ze],qe=null,G=null;if(Be.forEach(function(ce){ce.semver===Le&&(ce=new Me(">=0.0.0")),qe=qe||ce,G=G||ce,Ie(ce.semver,qe.semver,be)?qe=ce:We(ce.semver,G.semver,be)&&(G=ce)}),qe.operator===Ue||qe.operator===Ne||(!G.operator||G.operator===Ue)&&Oe(X,G.semver)||G.operator===Ne&&We(X,G.semver))return!1}return!0}Me.prototype.parse=function(X){var ae=this.loose?C[$]:C[_],he=X.match(ae);if(!he)throw new TypeError("Invalid comparator: "+X);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Le},Me.prototype.toString=function(){return this.value},Me.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===Le||(typeof X=="string"&&(X=new L(X,this.loose)),ge(X,this.operator,this.semver,this.loose))},Me.prototype.intersects=function(X,ae){if(!(X instanceof Me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new ke(X.value,ae),we(this.value,he,ae);if(X.operator==="")return he=new ke(this.value,ae),we(X.semver,he,ae);var be=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Oe=this.semver.version===X.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Ue=ge(this.semver,"<",X.semver,ae)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Ne=ge(this.semver,">",X.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return be||Ie||Oe&&We||Ue||Ne},e.Range=ke,ke.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},ke.prototype.toString=function(){return this.range},ke.prototype.parseRange=function(X){var ae=this.loose;X=X.trim(),k("range",X,ae);var he=ae?C[z]:C[W];X=X.replace(he,Ve),k("hyphen replace",X),X=X.replace(C[A],"$1$2$3"),k("comparator trim",X,C[A]),X=(X=(X=X.replace(C[Q],"$1~")).replace(C[se],"$1^")).split(/\s+/).join(" ");var be=ae?C[$]:C[_],Ie=X.split(" ").map(function(Oe){return function(We,Ue){return k("comp",We),We=function(Ne,ze){return Ne.trim().split(/\s+/).map(function(Be){return function(qe,G){k("caret",qe,G);var ce=G?C[K]:C[de];return qe.replace(ce,function(pe,fe,Se,De,Fe){var Qe;return k("caret",qe,pe,fe,Se,De,Fe),Ae(fe)?Qe="":Ae(Se)?Qe=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(De)?Qe=fe==="0"?">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+".0 <"+(+fe+1)+".0.0":Fe?(k("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Qe=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+Se+"."+(+De+1):">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+De+Fe+" <"+(+fe+1)+".0.0"):(k("no pr"),Qe=fe==="0"?Se==="0"?">="+fe+"."+Se+"."+De+" <"+fe+"."+Se+"."+(+De+1):">="+fe+"."+Se+"."+De+" <"+fe+"."+(+Se+1)+".0":">="+fe+"."+Se+"."+De+" <"+(+fe+1)+".0.0"),k("caret return",Qe),Qe})}(Be,ze)}).join(" ")}(We,Ue),k("caret",We),We=function(Ne,ze){return Ne.trim().split(/\s+/).map(function(Be){return function(qe,G){var ce=G?C[le]:C[re];return qe.replace(ce,function(pe,fe,Se,De,Fe){var Qe;return k("tilde",qe,pe,fe,Se,De,Fe),Ae(fe)?Qe="":Ae(Se)?Qe=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ae(De)?Qe=">="+fe+"."+Se+".0 <"+fe+"."+(+Se+1)+".0":Fe?(k("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Qe=">="+fe+"."+Se+"."+De+Fe+" <"+fe+"."+(+Se+1)+".0"):Qe=">="+fe+"."+Se+"."+De+" <"+fe+"."+(+Se+1)+".0",k("tilde return",Qe),Qe})}(Be,ze)}).join(" ")}(We,Ue),k("tildes",We),We=function(Ne,ze){return k("replaceXRanges",Ne,ze),Ne.split(/\s+/).map(function(Be){return function(qe,G){qe=qe.trim();var ce=G?C[T]:C[M];return qe.replace(ce,function(pe,fe,Se,De,Fe,Qe){k("xRange",qe,pe,fe,Se,De,Fe,Qe);var et=Ae(Se),Ke=et||Ae(De),Ye=Ke||Ae(Fe);return fe==="="&&Ye&&(fe=""),et?pe=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Ye?(Ke&&(De=0),Ye&&(Fe=0),fe===">"?(fe=">=",Ke?(Se=+Se+1,De=0,Fe=0):Ye&&(De=+De+1,Fe=0)):fe==="<="&&(fe="<",Ke?Se=+Se+1:De=+De+1),pe=fe+Se+"."+De+"."+Fe):Ke?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ye&&(pe=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0"),k("xRange return",pe),pe})}(Be,ze)}).join(" ")}(We,Ue),k("xrange",We),We=function(Ne,ze){return k("replaceStars",Ne,ze),Ne.trim().replace(C[ee],"")}(We,Ue),k("stars",We),We}(Oe,ae)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Oe){return!!Oe.match(be)})),Ie=Ie.map(function(Oe){return new Me(Oe,ae)})},ke.prototype.intersects=function(X,ae){if(!(X instanceof ke))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(be){return X.set.some(function(Ie){return Ie.every(function(Oe){return be.intersects(Oe,ae)})})})})},e.toComparators=function(X,ae){return new ke(X,ae).set.map(function(he){return he.map(function(be){return be.value}).join(" ").trim().split(" ")})},ke.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new L(X,this.loose));for(var ae=0;ae<this.set.length;ae++)if(me(this.set[ae],X))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(X,ae,he){var be=null,Ie=null;try{var Oe=new ke(ae,he)}catch{return null}return X.forEach(function(We){Oe.test(We)&&(be&&Ie.compare(We)!==-1||(Ie=new L(be=We,he)))}),be},e.minSatisfying=function(X,ae,he){var be=null,Ie=null;try{var Oe=new ke(ae,he)}catch{return null}return X.forEach(function(We){Oe.test(We)&&(be&&Ie.compare(We)!==1||(Ie=new L(be=We,he)))}),be},e.validRange=function(X,ae){try{return new ke(X,ae).range||"*"}catch{return null}},e.ltr=function(X,ae,he){return Ee(X,ae,"<",he)},e.gtr=function(X,ae,he){return Ee(X,ae,">",he)},e.outside=Ee,e.prerelease=function(X,ae){var he=j(X,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(X,ae,he){return X=new ke(X,he),ae=new ke(ae,he),X.intersects(ae)},e.coerce=function(X){if(X instanceof L)return X;if(typeof X!="string")return null;var ae=X.match(C[F]);return ae==null?null:j((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,S(1))},function(q,e){var S,t,k=q.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function C(w){if(S===setTimeout)return setTimeout(w,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(w,0);try{return S(w,0)}catch{try{return S.call(null,w,0)}catch{return S.call(this,w,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var l,g=[],I=!1,E=-1;function y(){I&&l&&(I=!1,l.length?g=l.concat(g):E=-1,g.length&&f())}function f(){if(!I){var w=C(y);I=!0;for(var m=g.length;m;){for(l=g,g=[];++E<m;)l&&l[E].run();E=-1,m=g.length}l=null,I=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(w)}}function h(w,m){this.fun=w,this.array=m}function b(){}k.nextTick=function(w){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];g.push(new h(w,m)),g.length!==1||I||C(f)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=b,k.addListener=b,k.once=b,k.off=b,k.removeListener=b,k.removeAllListeners=b,k.emit=b,k.prependListener=b,k.prependOnceListener=b,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(J[126],Z([0,1]),function(q,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(C,l,g){this.level=C,this.key=l,this.value=g,this.forward=[]}}const k=void 0;class R{constructor(C,l=2**16){this.comparator=C,this[S]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new t(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,k,k)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,l){return R._insert(this,C,l,this.comparator)&&(this._size+=1),this}delete(C){const l=R._delete(this,C,this.comparator);return l&&(this._size-=1),l}forEach(C,l){let g=this._header.forward[0];for(;g;)C.call(l,g.value,g.key,this),g=g.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",l=this._header.forward[0];for(;l;)C+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return C}static _search(C,l,g){let I=C._header;for(let E=C._level-1;E>=0;E--)for(;I.forward[E]&&g(I.forward[E].key,l)<0;)I=I.forward[E];if(I=I.forward[0],I&&g(I.key,l)===0)return I}static _insert(C,l,g,I){const E=[];let y=C._header;for(let f=C._level-1;f>=0;f--){for(;y.forward[f]&&I(y.forward[f].key,l)<0;)y=y.forward[f];E[f]=y}if(y=y.forward[0],y&&I(y.key,l)===0)return y.value=g,!1;{const f=R._randomLevel(C);if(f>C._level){for(let h=C._level;h<f;h++)E[h]=C._header;C._level=f}y=new t(f,l,g);for(let h=0;h<f;h++)y.forward[h]=E[h].forward[h],E[h].forward[h]=y;return!0}}static _randomLevel(C,l=.5){let g=1;for(;Math.random()<l&&g<C._maxLevel;)g+=1;return g}static _delete(C,l,g){const I=[];let E=C._header;for(let y=C._level-1;y>=0;y--){for(;E.forward[y]&&g(E.forward[y].key,l)<0;)E=E.forward[y];I[y]=E}if(E=E.forward[0],!E||g(E.key,l)!==0)return!1;for(let y=0;y<C._level&&I[y].forward[y]===E;y++)I[y].forward[y]=E.forward[y];for(;C._level>0&&C._header.forward[C._level-1]===k;)C._level-=1;return!0}}e.SkipList=R}),define(J[58],Z([0,1,17,2]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(p){const c=p;return c?typeof c.read=="function":!1}e.isReadable=k;function R(p){const c=p;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function D(p){const c=p;return c?R(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=D;function C(p,c){return new l(p,c)}e.newWriteableStream=C;class l{constructor(c,n){this.reducer=c,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c<"u"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(n=>n(c))}emitError(c){this.listeners.error.length===0?(0,S.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(n=>n(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,n){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(c,n){if(this.state.destroyed)return;let o;switch(c){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const i=o.indexOf(n);i>=0&&o.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(p,c){const n=[];let o;for(;(o=p.read())!==null;)n.push(o);return c(n)}e.consumeReadable=g;function I(p,c,n){const o=[];let i;for(;(i=p.read())!==null&&o.length<n;)o.push(i);return i===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return p.read()}}}e.peekReadable=I;function E(p,c){return new Promise((n,o)=>{const i=[];y(p,{onData:r=>{c&&i.push(r)},onError:r=>{c?o(r):n(void 0)},onEnd:()=>{n(c?c(i):void 0)}})})}e.consumeStream=E;function y(p,c){let n=!1;return p.on("error",o=>{n||c.onError(o)}),p.on("end",()=>{n||c.onEnd()}),p.on("data",o=>{n||c.onData(o)}),(0,t.toDisposable)(()=>n=!0)}e.listenStream=y;function f(p,c){return new Promise((n,o)=>{const i=new t.DisposableStore,r=[],s=P=>{if(r.push(P),r.length>c)return i.dispose(),p.pause(),n({stream:p,buffer:r,ended:!1})},a=P=>o(P),u=()=>n({stream:p,buffer:r,ended:!0});i.add((0,t.toDisposable)(()=>p.removeListener("error",a))),p.on("error",a),i.add((0,t.toDisposable)(()=>p.removeListener("end",u))),p.on("end",u),i.add((0,t.toDisposable)(()=>p.removeListener("data",s))),p.on("data",s)})}e.peekStream=f;function h(p,c){const n=C(c);return n.end(p),n}e.toStream=h;function b(){const p=C(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=b;function w(p){let c=!1;return{read:()=>c?null:(c=!0,p)}}e.toReadable=w;function m(p,c,n){const o=C(n);return y(p,{onData:i=>o.write(c.data(i)),onError:i=>o.error(c.error?c.error(i):i),onEnd:()=>o.end()}),o}e.transform=m;function v(p,c,n){let o=!1;return{read:()=>{const i=c.read();return o?i:(o=!0,i!==null?n([p,i]):p)}}}e.prefixedReadable=v;function d(p,c,n){let o=!1;const i=C(n);return y(c,{onData:r=>o?i.write(r):(o=!0,i.write(n([p,r]))),onError:r=>i.error(r),onEnd:()=>{o||(o=!0,i.write(p)),i.end()}}),i}e.prefixedStream=d}),define(J[18],Z([0,1,58]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class D{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return t?new D(Buffer.allocUnsafe(P)):new D(new Uint8Array(P))}static wrap(P){return t&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new D(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(P)):(k||(k=new TextEncoder),new D(k.encode(P)))}static fromByteArray(P){const M=D.alloc(P.length);for(let T=0,F=P.length;T<F;T++)M.buffer[T]=P[T];return M}static concat(P,M){if(typeof M>"u"){M=0;for(let U=0,Q=P.length;U<Q;U++)M+=P[U].byteLength}const T=D.alloc(M);let F=0;for(let U=0,Q=P.length;U<Q;U++){const re=P[U];T.set(re,F),F+=re.byteLength}return T}clone(){const P=D.alloc(this.byteLength);return P.set(this),P}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(P,M){return new D(this.buffer.subarray(P,M))}set(P,M){if(P instanceof D)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return g(this.buffer,P)}writeUInt32BE(P,M){I(this.buffer,P,M)}readUInt32LE(P){return E(this.buffer,P)}writeUInt32LE(P,M){y(this.buffer,P,M)}readUInt8(P){return f(this.buffer,P)}writeUInt8(P,M){h(this.buffer,P,M)}}e.VSBuffer=D;function C(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0}e.readUInt16LE=C;function l(u,P,M){u[M+0]=P&255,P=P>>>8,u[M+1]=P&255}e.writeUInt16LE=l;function g(u,P){return u[P]*2**24+u[P+1]*2**16+u[P+2]*2**8+u[P+3]}e.readUInt32BE=g;function I(u,P,M){u[M+3]=P,P=P>>>8,u[M+2]=P,P=P>>>8,u[M+1]=P,P=P>>>8,u[M]=P}e.writeUInt32BE=I;function E(u,P){return u[P+0]<<0>>>0|u[P+1]<<8>>>0|u[P+2]<<16>>>0|u[P+3]<<24>>>0}e.readUInt32LE=E;function y(u,P,M){u[M+0]=P&255,P=P>>>8,u[M+1]=P&255,P=P>>>8,u[M+2]=P&255,P=P>>>8,u[M+3]=P&255}e.writeUInt32LE=y;function f(u,P){return u[P]}e.readUInt8=f;function h(u,P,M){u[M]=P}e.writeUInt8=h;function b(u){return S.consumeReadable(u,P=>D.concat(P))}e.readableToBuffer=b;function w(u){return S.toReadable(u)}e.bufferToReadable=w;function m(u){return S.consumeStream(u,P=>D.concat(P))}e.streamToBuffer=m;async function v(u){return u.ended?D.concat(u.buffer):D.concat([...u.buffer,await m(u.stream)])}e.bufferedStreamToBuffer=v;function d(u){return S.toStream(u,P=>D.concat(P))}e.bufferToStream=d;function p(u){return S.transform(u,{data:P=>typeof P=="string"?D.fromString(P):D.wrap(P)},P=>D.concat(P))}e.streamToBufferReadableStream=p;function c(u){return S.newWriteableStream(P=>D.concat(P),u)}e.newWriteableBufferStream=c;function n(u,P){return S.prefixedReadable(u,P,M=>D.concat(M))}e.prefixedBufferReadable=n;function o(u,P){return S.prefixedStream(u,P,M=>D.concat(M))}e.prefixedBufferStream=o;function i(u){let P=0,M=0,T=0;const F=new Uint8Array(Math.floor(u.length/4*3)),U=re=>{switch(M){case 3:F[T++]=P|re,M=0;break;case 2:F[T++]=P|re>>>2,P=re<<6,M=3;break;case 1:F[T++]=P|re>>>4,P=re<<4,M=2;break;default:P=re<<2,M=1}};for(let re=0;re<u.length;re++){const le=u.charCodeAt(re);if(le>=65&&le<=90)U(le-65);else if(le>=97&&le<=122)U(le-97+26);else if(le>=48&&le<=57)U(le-48+52);else if(le===43||le===45)U(62);else if(le===47||le===95)U(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const Q=T;for(;M>0;)U(0);return D.wrap(F).slice(0,Q)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},P=!0,M=!1){const T=M?s:r;let F="";const U=u.byteLength%3;let Q=0;for(;Q<u.byteLength-U;Q+=3){const re=u[Q+0],le=u[Q+1],ue=u[Q+2];F+=T[re>>>2],F+=T[(re<<4|le>>>4)&63],F+=T[(le<<2|ue>>>6)&63],F+=T[ue&63]}if(U===1){const re=u[Q+0];F+=T[re>>>2],F+=T[re<<4&63],P&&(F+="==")}else if(U===2){const re=u[Q+0],le=u[Q+1];F+=T[re>>>2],F+=T[(re<<4|le>>>4)&63],F+=T[le<<2&63],P&&(F+="=")}return F}e.encodeBase64=a}),define(J[12],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(o){return typeof o=="string"}e.isString=S;function t(o){return Array.isArray(o)&&o.every(i=>S(i))}e.isStringArray=t;function k(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=k;function R(o){const i=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof i}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function C(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=C;function l(o){return o===!0||o===!1}e.isBoolean=l;function g(o){return typeof o>"u"}e.isUndefined=g;function I(o){return!E(o)}e.isDefined=I;function E(o){return g(o)||o===null}e.isUndefinedOrNull=E;function y(o,i){if(!o)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function f(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=f;function h(...o){const i=[];for(let r=0;r<o.length;r++){const s=o[r];if(E(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(s)}return i}e.assertAllDefined=h;const b=Object.prototype.hasOwnProperty;function w(o){if(!k(o))return!1;for(const i in o)if(b.call(o,i))return!1;return!0}e.isEmptyObject=w;function m(o){return typeof o=="function"}e.isFunction=m;function v(...o){return o.length>0&&o.every(m)}e.areFunctions=v;function d(o,i){const r=Math.min(o.length,i.length);for(let s=0;s<r;s++)p(o[s],i[s])}e.validateConstraints=d;function p(o,i){if(S(i)){if(typeof o!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(m(i)){try{if(o instanceof i)return}catch{}if(!E(o)&&o.constructor===i||i.length===1&&i.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function c(o){return o===null?void 0:o}e.withNullAsUndefined=c;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(J[49],Z([0,1,12]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(d=>{m[d]&&typeof m[d]=="object"?v[d]=t(m[d]):v[d]=m[d]}),v}e.deepClone=t;function k(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const d=v.shift();Object.freeze(d);for(const p in d)if(R.call(d,p)){const c=d[p];typeof c=="object"&&!Object.isFrozen(c)&&!(0,S.isTypedArray)(c)&&v.push(c)}}return m}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function D(m,v){return C(m,v,new Set)}e.cloneAndChange=D;function C(m,v,d){if((0,S.isUndefinedOrNull)(m))return m;const p=v(m);if(typeof p<"u")return p;if(Array.isArray(m)){const c=[];for(const n of m)c.push(C(n,v,d));return c}if((0,S.isObject)(m)){if(d.has(m))throw new Error("Cannot clone recursive data-structure");d.add(m);const c={};for(const n in m)R.call(m,n)&&(c[n]=C(m[n],v,d));return d.delete(m),c}return m}function l(m,v,d=!0){return(0,S.isObject)(m)?((0,S.isObject)(v)&&Object.keys(v).forEach(p=>{p in m?d&&((0,S.isObject)(m[p])&&(0,S.isObject)(v[p])?l(m[p],v[p],d):m[p]=v[p]):m[p]=v[p]}),m):v}e.mixin=l;function g(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let d,p;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(d=0;d<m.length;d++)if(!g(m[d],v[d]))return!1}else{const c=[];for(p in m)c.push(p);c.sort();const n=[];for(p in v)n.push(p);if(n.sort(),!g(c,n))return!1;for(d=0;d<c.length;d++)if(!g(m[c[d]],v[c[d]]))return!1}return!0}e.equals=g;function I(m){const v=new Set;return JSON.stringify(m,(d,p)=>{if((0,S.isObject)(p)||Array.isArray(p)){if(v.has(p))return"[Circular]";v.add(p)}return p})}e.safeStringify=I;function E(m,v){const d=Object.create(null);return!m||!v||Object.keys(v).forEach(c=>{const n=m[c],o=v[c];g(n,o)||(d[c]=o)}),d}e.distinct=E;function y(m,v){const d=v.toLowerCase(),p=Object.keys(m).find(c=>c.toLowerCase()===d);return p?m[p]:m[v]}e.getCaseInsensitive=y;function f(m,v){const d=Object.create(null);for(const[p,c]of Object.entries(m))v(p,c)&&(d[p]=c);return d}e.filter=f;function h(m){let v=[],d=Object.getPrototypeOf(m);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=h;function b(m){const v=[];for(const d of h(m))typeof m[d]=="function"&&v.push(d);return v}e.getAllMethodNames=b;function w(m,v){const d=c=>function(){const n=Array.prototype.slice.call(arguments,0);return v(c,n)},p={};for(const c of m)p[c]=d(c);return p}e.createProxyObject=w}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return S.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let l=0;l<C.length;l++)C[l]=Math.floor(Math.random()*256);return C};const R=new Uint8Array(16),D=[];for(let C=0;C<256;C++)D.push(C.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let l=0,g="";return g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g+="-",g+=D[R[l++]],g+=D[R[l++]],g+="-",g+=D[R[l++]],g+=D[R[l++]],g+="-",g+=D[R[l++]],g+=D[R[l++]],g+="-",g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g+=D[R[l++]],g}}()}),define(J[127],Z([0,1,76,29,48]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,C){if(await new Promise((I,E)=>{const y=t.createReadStream(D),f=S.createHash("sha1");y.pipe(f);const h=(0,k.once)((b,w)=>{y.removeAllListeners(),f.removeAllListeners(),b?E(b):I(w)});y.once("error",h),y.once("end",h),f.once("error",h),f.once("data",b=>h(void 0,b.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=R}),define(J[128],Z([0,1,30]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const C=D.replace(/\-/g,":").toLowerCase();return!t.has(C)}function R(){const D=(0,S.networkInterfaces)();for(const C in D){const l=D[C];if(l){for(const{mac:g}of l)if(k(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(J[92],Z([0,1,77]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(C,l,g,I=1){let E=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!E)return E=!0,y(0)},g);k(C,l,I,h=>{if(!E)return E=!0,clearTimeout(f),y(h)})})}e.findFreePort=t;function k(C,l,g,I){if(l===0)return I(0);const E=new S.Socket;E.once("connect",()=>(D(E),k(C+g,l-1,g,I))),E.once("data",()=>{}),E.once("error",y=>(D(E),y.code!=="ECONNREFUSED"?k(C+g,l-1,g,I):I(C))),E.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(C,l,g){let I=!1,E,y=1;const f=S.createServer({pauseOnConnect:!0});function h(b,w){I||(I=!0,f.removeAllListeners(),f.close(),E&&clearTimeout(E),w(b))}return new Promise(b=>{E=setTimeout(()=>{h(0,b)},g),f.on("listening",()=>{h(C,b)}),f.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&y<l?(C++,y++,f.listen(C,"127.0.0.1")):h(0,b)}),f.on("close",()=>{h(0,b)}),f.listen(C,"127.0.0.1")})}e.findFreePortFaster=R;function D(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(l){console.error(l)}}}),define(J[129],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[130],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(k,R){this.sender=k,this.onMessage=R}send(k){try{this.sender.send("vscode:message",k.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=S}),define(J[40],Z([0,1,15,17]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.mapListenerToWrapper=new WeakMap}on(D,C){const l=(g,...I)=>{this.validateEvent(D,g)&&C(g,...I)};return this.mapListenerToWrapper.set(C,l),S.ipcMain.on(D,l),this}once(D,C){return S.ipcMain.once(D,(l,...g)=>{this.validateEvent(D,l)&&C(l,...g)}),this}handle(D,C){return S.ipcMain.handle(D,(l,...g)=>this.validateEvent(D,l)?C(l,...g):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return S.ipcMain.removeHandler(D),this}removeListener(D,C){const l=this.mapListenerToWrapper.get(C);return l&&(S.ipcMain.removeListener(D,l),this.mapListenerToWrapper.delete(C)),this}validateEvent(D,C){if(!D||!D.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const l=C.senderFrame,g=l.url;if(!g)return!0;let I="unknown";try{I=new URL(g).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${g}'.`),!1}return I!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${I}'.`),!1):l.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${I}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(J[131],Z([0,1,15,40,12,129]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(l,g,I,E,y)=>{const f=C(l,E,I);f.popup({window:(0,k.withNullAsUndefined)(S.BrowserWindow.fromWebContents(l.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{f&&l.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=D;function C(l,g,I){const E=new S.Menu;return I.forEach(y=>{let f;y.type==="separator"?f=new S.MenuItem({type:y.type}):Array.isArray(y.submenu)?f=new S.MenuItem({submenu:C(l,g,y.submenu),label:y.label}):f=new S.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(h,b,w)=>l.sender.send(g,y.id,w)}),E.append(f)}),E}}),define(J[132],Z([11,10]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[133],Z([0,1,132]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,D=R*7,C=R*30,l=R*365;function g(E,y,f){typeof E!="number"&&(E=E.getTime());const h=Math.round((new Date().getTime()-E)/1e3);if(h<-30)return(0,S.localize)(0,null,g(new Date().getTime()+h*1e3,!1));if(h<30)return(0,S.localize)(1,null);let b;return h<t?(b=h,y?b===1?f?(0,S.localize)(2,null,b):(0,S.localize)(3,null,b):f?(0,S.localize)(4,null,b):(0,S.localize)(5,null,b):b===1?f?(0,S.localize)(6,null,b):(0,S.localize)(7,null,b):f?(0,S.localize)(8,null,b):(0,S.localize)(9,null,b)):h<k?(b=Math.floor(h/t),y?b===1?f?(0,S.localize)(10,null,b):(0,S.localize)(11,null,b):f?(0,S.localize)(12,null,b):(0,S.localize)(13,null,b):b===1?f?(0,S.localize)(14,null,b):(0,S.localize)(15,null,b):f?(0,S.localize)(16,null,b):(0,S.localize)(17,null,b)):h<R?(b=Math.floor(h/k),y?b===1?f?(0,S.localize)(18,null,b):(0,S.localize)(19,null,b):f?(0,S.localize)(20,null,b):(0,S.localize)(21,null,b):b===1?f?(0,S.localize)(22,null,b):(0,S.localize)(23,null,b):f?(0,S.localize)(24,null,b):(0,S.localize)(25,null,b)):h<D?(b=Math.floor(h/R),y?b===1?(0,S.localize)(26,null,b):(0,S.localize)(27,null,b):b===1?(0,S.localize)(28,null,b):(0,S.localize)(29,null,b)):h<C?(b=Math.floor(h/D),y?b===1?f?(0,S.localize)(30,null,b):(0,S.localize)(31,null,b):f?(0,S.localize)(32,null,b):(0,S.localize)(33,null,b):b===1?f?(0,S.localize)(34,null,b):(0,S.localize)(35,null,b):f?(0,S.localize)(36,null,b):(0,S.localize)(37,null,b)):h<l?(b=Math.floor(h/C),y?b===1?f?(0,S.localize)(38,null,b):(0,S.localize)(39,null,b):f?(0,S.localize)(40,null,b):(0,S.localize)(41,null,b):b===1?f?(0,S.localize)(42,null,b):(0,S.localize)(43,null,b):f?(0,S.localize)(44,null,b):(0,S.localize)(45,null,b)):(b=Math.floor(h/l),y?b===1?f?(0,S.localize)(46,null,b):(0,S.localize)(47,null,b):f?(0,S.localize)(48,null,b):(0,S.localize)(49,null,b):b===1?f?(0,S.localize)(50,null,b):(0,S.localize)(51,null,b):f?(0,S.localize)(52,null,b):(0,S.localize)(53,null,b))}e.fromNow=g;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(J[134],Z([11,10]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[44],Z([0,1,24,12,134]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(E,y){return y&&(E.stack||E.stacktrace)?k.localize(0,null,C(E),D(E.stack)||D(E.stacktrace)):C(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function C(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?k.localize(1,null,E.message):E.message||k.localize(2,null)}function l(E=null,y=!1){if(!E)return k.localize(3,null);if(Array.isArray(E)){const f=S.coalesce(E),h=l(f[0],y);return f.length>1?k.localize(4,null,h,f.length):h}if(t.isString(E))return E;if(E.detail){const f=E.detail;if(f.error)return R(f.error,y);if(f.exception)return R(f.exception,y)}return E.stack?R(E,y):E.message?E.message:k.localize(5,null)}e.toErrorMessage=l;function g(E){const y=E;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=g;function I(E,y){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=y,f}e.createErrorWithActions=I}),define(J[135],Z([11,10]),function(q,e){return q.create("vs/base/common/jsonErrorMessages",e)}),define(J[136],Z([0,1,135]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(J[137],Z([11,10]),function(q,e){return q.create("vs/base/common/platform",e)}),define(J[4],Z([0,1,137]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let k=!1,R=!1,D=!1,C=!1,l=!1,g=!1,I=!1,E=!1,y=!1,f,h=t,b,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const v=typeof m?.versions?.electron=="string",d=v&&m?.type==="renderer";if(typeof navigator=="object"&&!d)w=navigator.userAgent,k=w.indexOf("Windows")>=0,R=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=w.indexOf("Linux")>=0,g=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||t,h=f;else if(typeof m=="object"){k=m.platform==="win32",R=m.platform==="darwin",D=m.platform==="linux",C=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,I=v,y=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t,h=t;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const P=JSON.parse(u),M=P.availableLanguages["*"];f=P.locale,h=M||t,b=P._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");var p;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function c(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let n=0;R?n=1:k?n=3:D&&(n=2),e.isWindows=k,e.isMacintosh=R,e.isLinux=D,e.isLinuxSnap=C,e.isNative=l,e.isElectron=I,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isCI=y,e.platform=n,e.userAgent=w,e.language=h;var o;(function(u){function P(){return e.language}u.value=P;function M(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=M;function T(){return e.language==="en"}u.isDefault=T})(o=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=b,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,F=u.length;T<F;T++){const U=u[T];if(U.id===M.data.vscodeScheduleAsyncWork){u.splice(T,1),U.callback();return}}});let P=0;return M=>{const T=++P;u.push({id:T,callback:M}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return u=>setTimeout(u)})();var i;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:k?1:3;let r=!0,s=!1;function a(){if(!s){s=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(J[34],Z([0,1,4]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const k=S.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(J[9],Z([0,1,34]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,D=122,C=46,l=47,g=92,I=58,E=63;class y extends Error{constructor(p,c,n){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const i=p.indexOf(".")!==-1?"property":"argument";let r=`The "${p}" ${i} ${o} of type ${c}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,p){if(typeof d!="string")throw new y(p,"string",d)}function h(d){return d===l||d===g}function b(d){return d===l}function w(d){return d>=t&&d<=R||d>=k&&d<=D}function m(d,p,c,n){let o="",i=0,r=-1,s=0,a=0;for(let u=0;u<=d.length;++u){if(u<d.length)a=d.charCodeAt(u);else{if(n(a))break;a=l}if(n(a)){if(!(r===u-1||s===1))if(s===2){if(o.length<2||i!==2||o.charCodeAt(o.length-1)!==C||o.charCodeAt(o.length-2)!==C){if(o.length>2){const P=o.lastIndexOf(c);P===-1?(o="",i=0):(o=o.slice(0,P),i=o.length-1-o.lastIndexOf(c)),r=u,s=0;continue}else if(o.length!==0){o="",i=0,r=u,s=0;continue}}p&&(o+=o.length>0?`${c}..`:"..",i=2)}else o.length>0?o+=`${c}${d.slice(r+1,u)}`:o=d.slice(r+1,u),i=u-r-1;r=u,s=0}else a===C&&s!==-1?++s:s=-1}return o}function v(d,p){if(p===null||typeof p!="object")throw new y("pathObject","Object",p);const c=p.dir||p.root,n=p.base||`${p.name||""}${p.ext||""}`;return c?c===p.root?`${c}${n}`:`${c}${d}${n}`:n}e.win32={resolve(...d){let p="",c="",n=!1;for(let o=d.length-1;o>=-1;o--){let i;if(o>=0){if(i=d[o],f(i,"path"),i.length===0)continue}else p.length===0?i=S.cwd():(i=S.env[`=${p}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==p.toLowerCase()&&i.charCodeAt(2)===g)&&(i=`${p}\\`));const r=i.length;let s=0,a="",u=!1;const P=i.charCodeAt(0);if(r===1)h(P)&&(s=1,u=!0);else if(h(P))if(u=!0,h(i.charCodeAt(1))){let M=2,T=M;for(;M<r&&!h(i.charCodeAt(M));)M++;if(M<r&&M!==T){const F=i.slice(T,M);for(T=M;M<r&&h(i.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!h(i.charCodeAt(M));)M++;(M===r||M!==T)&&(a=`\\\\${F}\\${i.slice(T,M)}`,s=M)}}}else s=1;else w(P)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),s=2,r>2&&h(i.charCodeAt(2))&&(u=!0,s=3));if(a.length>0)if(p.length>0){if(a.toLowerCase()!==p.toLowerCase())continue}else p=a;if(n){if(p.length>0)break}else if(c=`${i.slice(s)}\\${c}`,n=u,u&&p.length>0)break}return c=m(c,!n,"\\",h),n?`${p}\\${c}`:`${p}${c}`||"."},normalize(d){f(d,"path");const p=d.length;if(p===0)return".";let c=0,n,o=!1;const i=d.charCodeAt(0);if(p===1)return b(i)?"\\":d;if(h(i))if(o=!0,h(d.charCodeAt(1))){let s=2,a=s;for(;s<p&&!h(d.charCodeAt(s));)s++;if(s<p&&s!==a){const u=d.slice(a,s);for(a=s;s<p&&h(d.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&!h(d.charCodeAt(s));)s++;if(s===p)return`\\\\${u}\\${d.slice(a)}\\`;s!==a&&(n=`\\\\${u}\\${d.slice(a,s)}`,c=s)}}}else c=1;else w(i)&&d.charCodeAt(1)===I&&(n=d.slice(0,2),c=2,p>2&&h(d.charCodeAt(2))&&(o=!0,c=3));let r=c<p?m(d.slice(c),!o,"\\",h):"";return r.length===0&&!o&&(r="."),r.length>0&&h(d.charCodeAt(p-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(d){f(d,"path");const p=d.length;if(p===0)return!1;const c=d.charCodeAt(0);return h(c)||p>2&&w(c)&&d.charCodeAt(1)===I&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let p,c;for(let i=0;i<d.length;++i){const r=d[i];f(r,"path"),r.length>0&&(p===void 0?p=c=r:p+=`\\${r}`)}if(p===void 0)return".";let n=!0,o=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++o;const i=c.length;i>1&&h(c.charCodeAt(1))&&(++o,i>2&&(h(c.charCodeAt(2))?++o:n=!1))}if(n){for(;o<p.length&&h(p.charCodeAt(o));)o++;o>=2&&(p=`\\${p.slice(o)}`)}return e.win32.normalize(p)},relative(d,p){if(f(d,"from"),f(p,"to"),d===p)return"";const c=e.win32.resolve(d),n=e.win32.resolve(p);if(c===n||(d=c.toLowerCase(),p=n.toLowerCase(),d===p))return"";let o=0;for(;o<d.length&&d.charCodeAt(o)===g;)o++;let i=d.length;for(;i-1>o&&d.charCodeAt(i-1)===g;)i--;const r=i-o;let s=0;for(;s<p.length&&p.charCodeAt(s)===g;)s++;let a=p.length;for(;a-1>s&&p.charCodeAt(a-1)===g;)a--;const u=a-s,P=r<u?r:u;let M=-1,T=0;for(;T<P;T++){const U=d.charCodeAt(o+T);if(U!==p.charCodeAt(s+T))break;U===g&&(M=T)}if(T!==P){if(M===-1)return n}else{if(u>P){if(p.charCodeAt(s+T)===g)return n.slice(s+T+1);if(T===2)return n.slice(s+T)}r>P&&(d.charCodeAt(o+T)===g?M=T:T===2&&(M=3)),M===-1&&(M=0)}let F="";for(T=o+M+1;T<=i;++T)(T===i||d.charCodeAt(T)===g)&&(F+=F.length===0?"..":"\\..");return s+=M,F.length>0?`${F}${n.slice(s,a)}`:(n.charCodeAt(s)===g&&++s,n.slice(s,a))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const p=e.win32.resolve(d);if(p.length<=2)return d;if(p.charCodeAt(0)===g){if(p.charCodeAt(1)===g){const c=p.charCodeAt(2);if(c!==E&&c!==C)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(w(p.charCodeAt(0))&&p.charCodeAt(1)===I&&p.charCodeAt(2)===g)return`\\\\?\\${p}`;return d},dirname(d){f(d,"path");const p=d.length;if(p===0)return".";let c=-1,n=0;const o=d.charCodeAt(0);if(p===1)return h(o)?d:".";if(h(o)){if(c=n=1,h(d.charCodeAt(1))){let s=2,a=s;for(;s<p&&!h(d.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&h(d.charCodeAt(s));)s++;if(s<p&&s!==a){for(a=s;s<p&&!h(d.charCodeAt(s));)s++;if(s===p)return d;s!==a&&(c=n=s+1)}}}}else w(o)&&d.charCodeAt(1)===I&&(c=p>2&&h(d.charCodeAt(2))?3:2,n=c);let i=-1,r=!0;for(let s=p-1;s>=n;--s)if(h(d.charCodeAt(s))){if(!r){i=s;break}}else r=!1;if(i===-1){if(c===-1)return".";i=c}return d.slice(0,i)},basename(d,p){p!==void 0&&f(p,"ext"),f(d,"path");let c=0,n=-1,o=!0,i;if(d.length>=2&&w(d.charCodeAt(0))&&d.charCodeAt(1)===I&&(c=2),p!==void 0&&p.length>0&&p.length<=d.length){if(p===d)return"";let r=p.length-1,s=-1;for(i=d.length-1;i>=c;--i){const a=d.charCodeAt(i);if(h(a)){if(!o){c=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(a===p.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return c===n?n=s:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=c;--i)if(h(d.charCodeAt(i))){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){f(d,"path");let p=0,c=-1,n=0,o=-1,i=!0,r=0;d.length>=2&&d.charCodeAt(1)===I&&w(d.charCodeAt(0))&&(p=n=2);for(let s=d.length-1;s>=p;--s){const a=d.charCodeAt(s);if(h(a)){if(!i){n=s+1;break}continue}o===-1&&(i=!1,o=s+1),a===C?c===-1?c=s:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||o===-1||r===0||r===1&&c===o-1&&c===n+1?"":d.slice(c,o)},format:v.bind(null,"\\"),parse(d){f(d,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return p;const c=d.length;let n=0,o=d.charCodeAt(0);if(c===1)return h(o)?(p.root=p.dir=d,p):(p.base=p.name=d,p);if(h(o)){if(n=1,h(d.charCodeAt(1))){let M=2,T=M;for(;M<c&&!h(d.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&h(d.charCodeAt(M));)M++;if(M<c&&M!==T){for(T=M;M<c&&!h(d.charCodeAt(M));)M++;M===c?n=M:M!==T&&(n=M+1)}}}}else if(w(o)&&d.charCodeAt(1)===I){if(c<=2)return p.root=p.dir=d,p;if(n=2,h(d.charCodeAt(2))){if(c===3)return p.root=p.dir=d,p;n=3}}n>0&&(p.root=d.slice(0,n));let i=-1,r=n,s=-1,a=!0,u=d.length-1,P=0;for(;u>=n;--u){if(o=d.charCodeAt(u),h(o)){if(!a){r=u+1;break}continue}s===-1&&(a=!1,s=u+1),o===C?i===-1?i=u:P!==1&&(P=1):i!==-1&&(P=-1)}return s!==-1&&(i===-1||P===0||P===1&&i===s-1&&i===r+1?p.base=p.name=d.slice(r,s):(p.name=d.slice(r,i),p.base=d.slice(r,s),p.ext=d.slice(i,s))),r>0&&r!==n?p.dir=d.slice(0,r-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let p="",c=!1;for(let n=d.length-1;n>=-1&&!c;n--){const o=n>=0?d[n]:S.cwd();f(o,"path"),o.length!==0&&(p=`${o}/${p}`,c=o.charCodeAt(0)===l)}return p=m(p,!c,"/",b),c?`/${p}`:p.length>0?p:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const p=d.charCodeAt(0)===l,c=d.charCodeAt(d.length-1)===l;return d=m(d,!p,"/",b),d.length===0?p?"/":c?"./":".":(c&&(d+="/"),p?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===l},join(...d){if(d.length===0)return".";let p;for(let c=0;c<d.length;++c){const n=d[c];f(n,"path"),n.length>0&&(p===void 0?p=n:p+=`/${n}`)}return p===void 0?".":e.posix.normalize(p)},relative(d,p){if(f(d,"from"),f(p,"to"),d===p||(d=e.posix.resolve(d),p=e.posix.resolve(p),d===p))return"";const c=1,n=d.length,o=n-c,i=1,r=p.length-i,s=o<r?o:r;let a=-1,u=0;for(;u<s;u++){const M=d.charCodeAt(c+u);if(M!==p.charCodeAt(i+u))break;M===l&&(a=u)}if(u===s)if(r>s){if(p.charCodeAt(i+u)===l)return p.slice(i+u+1);if(u===0)return p.slice(i+u)}else o>s&&(d.charCodeAt(c+u)===l?a=u:u===0&&(a=0));let P="";for(u=c+a+1;u<=n;++u)(u===n||d.charCodeAt(u)===l)&&(P+=P.length===0?"..":"/..");return`${P}${p.slice(i+a)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const p=d.charCodeAt(0)===l;let c=-1,n=!0;for(let o=d.length-1;o>=1;--o)if(d.charCodeAt(o)===l){if(!n){c=o;break}}else n=!1;return c===-1?p?"/":".":p&&c===1?"//":d.slice(0,c)},basename(d,p){p!==void 0&&f(p,"ext"),f(d,"path");let c=0,n=-1,o=!0,i;if(p!==void 0&&p.length>0&&p.length<=d.length){if(p===d)return"";let r=p.length-1,s=-1;for(i=d.length-1;i>=0;--i){const a=d.charCodeAt(i);if(a===l){if(!o){c=i+1;break}}else s===-1&&(o=!1,s=i+1),r>=0&&(a===p.charCodeAt(r)?--r===-1&&(n=i):(r=-1,n=s))}return c===n?n=s:n===-1&&(n=d.length),d.slice(c,n)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===l){if(!o){c=i+1;break}}else n===-1&&(o=!1,n=i+1);return n===-1?"":d.slice(c,n)},extname(d){f(d,"path");let p=-1,c=0,n=-1,o=!0,i=0;for(let r=d.length-1;r>=0;--r){const s=d.charCodeAt(r);if(s===l){if(!o){c=r+1;break}continue}n===-1&&(o=!1,n=r+1),s===C?p===-1?p=r:i!==1&&(i=1):p!==-1&&(i=-1)}return p===-1||n===-1||i===0||i===1&&p===n-1&&p===c+1?"":d.slice(p,n)},format:v.bind(null,"/"),parse(d){f(d,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return p;const c=d.charCodeAt(0)===l;let n;c?(p.root="/",n=1):n=0;let o=-1,i=0,r=-1,s=!0,a=d.length-1,u=0;for(;a>=n;--a){const P=d.charCodeAt(a);if(P===l){if(!s){i=a+1;break}continue}r===-1&&(s=!1,r=a+1),P===C?o===-1?o=a:u!==1&&(u=1):o!==-1&&(u=-1)}if(r!==-1){const P=i===0&&c?1:i;o===-1||u===0||u===1&&o===r-1&&o===i+1?p.base=p.name=d.slice(P,r):(p.name=d.slice(P,o),p.base=d.slice(P,r),p.ext=d.slice(o,r))}return i>0?p.dir=d.slice(0,i-1):c&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[78],Z([0,1,4]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(C,...l){const g=l.reduce((y,f)=>(y[f]=!0,y),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!g[y]).forEach(y=>{for(let f=0;f<I.length;f++)if(y.search(I[f])!==-1){delete C[y];break}})}e.sanitizeProcessEnvironment=R;function D(C){!C||(delete C.DEBUG,S.isMacintosh&&delete C.DYLD_LIBRARY_PATH,S.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(J[79],Z([0,1,4]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class k{constructor(D){this._highResolution=t&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new k(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[3],Z([0,1,17,48,2,125,79]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,l=!1;var g;(function(a){a.None=()=>k.Disposable.None;function u(O){if(l){const{onListenerDidAdd:N}=O,V=h.create();let x=0;O.onListenerDidAdd=()=>{++x===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),N?.()}}}function P(O){return(N,V=null,x)=>{let ne=!1,H;return H=O(te=>{if(!ne)return H?H.dispose():ne=!0,N.call(V,te)},null,x),ne&&H.dispose(),H}}a.once=P;function M(O,N,V){return le((x,ne=null,H)=>O(te=>x.call(ne,N(te)),null,H),V)}a.map=M;function T(O,N,V){return le((x,ne=null,H)=>O(te=>{N(te),x.call(ne,te)},null,H),V)}a.forEach=T;function F(O,N,V){return le((x,ne=null,H)=>O(te=>N(te)&&x.call(ne,te),null,H),V)}a.filter=F;function U(O){return O}a.signal=U;function Q(...O){return(N,V=null,x)=>(0,k.combinedDisposable)(...O.map(ne=>ne(H=>N.call(V,H),null,x)))}a.any=Q;function re(O,N,V,x){let ne=V;return M(O,H=>(ne=N(ne,H),ne),x)}a.reduce=re;function le(O,N){let V;const x={onFirstListenerAdd(){V=O(ne.fire,ne)},onLastListenerRemove(){V?.dispose()}};N||u(x);const ne=new w(x);return N?.add(ne),ne.event}function ue(O,N,V=100,x=!1,ne,H){let te,ie,oe,ge=0;const Me={leakWarningThreshold:ne,onFirstListenerAdd(){te=O(ke=>{ge++,ie=N(ie,ke),x&&!oe&&(Le.fire(ie),ie=void 0),clearTimeout(oe),oe=setTimeout(()=>{const Ae=ie;ie=void 0,oe=void 0,(!x||ge>1)&&Le.fire(Ae),ge=0},V)})},onLastListenerRemove(){te.dispose()}};H||u(Me);const Le=new w(Me);return H?.add(Le),Le.event}a.debounce=ue;function se(O,N=(x,ne)=>x===ne,V){let x=!0,ne;return F(O,H=>{const te=x||!N(H,ne);return x=!1,ne=H,te},V)}a.latch=se;function de(O,N,V){return[a.filter(O,N,V),a.filter(O,x=>!N(x),V)]}a.split=de;function K(O,N=!1,V=[]){let x=V.slice(),ne=O(ie=>{x?x.push(ie):te.fire(ie)});const H=()=>{x?.forEach(ie=>te.fire(ie)),x=null},te=new w({onFirstListenerAdd(){ne||(ne=O(ie=>te.fire(ie)))},onFirstListenerDidAdd(){x&&(N?setTimeout(H):H())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return te.event}a.buffer=K;class ${constructor(N){this.event=N,this.disposables=new k.DisposableStore}map(N){return new $(M(this.event,N,this.disposables))}forEach(N){return new $(T(this.event,N,this.disposables))}filter(N){return new $(F(this.event,N,this.disposables))}reduce(N,V){return new $(re(this.event,N,V,this.disposables))}latch(){return new $(se(this.event,void 0,this.disposables))}debounce(N,V=100,x=!1,ne){return new $(ue(this.event,N,V,x,ne,this.disposables))}on(N,V,x){return this.event(N,V,x)}once(N,V,x){return P(this.event)(N,V,x)}dispose(){this.disposables.dispose()}}function _(O){return new $(O)}a.chain=_;function A(O,N,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>O.on(N,x),H=()=>O.removeListener(N,x),te=new w({onFirstListenerAdd:ne,onLastListenerRemove:H});return te.event}a.fromNodeEventEmitter=A;function W(O,N,V=x=>x){const x=(...ie)=>te.fire(V(...ie)),ne=()=>O.addEventListener(N,x),H=()=>O.removeEventListener(N,x),te=new w({onFirstListenerAdd:ne,onLastListenerRemove:H});return te.event}a.fromDOMEventEmitter=W;function z(O){return new Promise(N=>P(O)(N))}a.toPromise=z;function ee(O,N){return N(void 0),O(V=>N(V))}a.runAndSubscribe=ee;function B(O,N){let V=null;function x(H){V?.dispose(),V=new k.DisposableStore,N(H,V)}x(void 0);const ne=O(H=>x(H));return(0,k.toDisposable)(()=>{ne.dispose(),V?.dispose()})}a.runAndSubscribeWithStore=B;class j{constructor(N,V){this.obs=N,this._counter=0,this._hasChanged=!1;const x={onFirstListenerAdd:()=>{N.addObserver(this)},onLastListenerRemove:()=>{N.removeObserver(this)}};V||u(x),this.emitter=new w(x),V&&V.add(this.emitter)}beginUpdate(N){this._counter++}handleChange(N,V){this._hasChanged=!0}endUpdate(N){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function L(O,N){return new j(O,N).emitter.event}a.fromObservable=L})(g=e.Event||(e.Event={}));class I{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${I._idPool++}`}start(u){this._stopWatch=new D.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}I._idPool=0;let E=-1;function y(a){const u=E;return E=a,{dispose(){E=u}}}e.setGlobalLeakWarningThreshold=y;class f{constructor(u,P=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=P,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,P){let M=E;if(typeof this.customThreshold=="number"&&(M=this.customThreshold),M<=0||P<M)return;this._stacks||(this._stacks=new Map);const T=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,T+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=M*.5;let F,U=0;for(const[Q,re]of this._stacks)(!F||U<re)&&(F=Q,U=re);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this._stacks.get(u.value)||0;this._stacks.set(u.value,F-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(u,P,M){this.callback=u,this.callbackThis=P,this.stack=M,this.subscription=new k.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class w{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=E>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new I(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const P of u)P.subscription.isset()&&(P.subscription.unset(),P.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,P,M)=>{this._listeners||(this._listeners=new R.LinkedList);const T=this._listeners.isEmpty();T&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let F,U;this._leakageMon&&this._listeners.size>=30&&(U=h.create(),F=this._leakageMon.check(U,this._listeners.size+1)),C&&(U=U??h.create());const Q=new b(u,P,U),re=this._listeners.push(Q);T&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,P);const le=Q.subscription.set(()=>{F?.(),this._disposed||(re(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return M instanceof k.DisposableStore?M.add(le):Array.isArray(M)&&M.push(le),le}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const P of this._listeners)this._deliveryQueue.push(this,P,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class m{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(u,P,M){this._queue.push(new d(u,P,M))}clear(u){const P=new R.LinkedList;for(const M of this._queue)M.emitter!==u&&P.push(M);this._queue=P}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(P){(0,S.onUnexpectedError)(P)}}}}e.EventDeliveryQueue=m;class v extends m{clear(u){this._queue.clear()}}class d{constructor(u,P,M){this.emitter=u,this.listener=P,this.event=M}}class p extends w{async fireAsync(u,P,M){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,u]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[T,F]=this._asyncDeliveryQueue.shift(),U=[],Q={...F,token:P,waitUntil:re=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");M&&(re=M(re,T.callback)),U.push(re)}};try{T.invoke(Q)}catch(re){(0,S.onUnexpectedError)(re);continue}Object.freeze(U),await Promise.allSettled(U).then(re=>{for(const le of re)le.status==="rejected"&&(0,S.onUnexpectedError)(le.reason)})}}}}e.AsyncEmitter=p;class c extends w{constructor(u){super(u),this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=c;class n extends c{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=n;class o extends w{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(P=>super.fire(P)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class i{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const P={event:u,listener:null};this.events.push(P),this.hasListeners&&this.hook(P);const M=()=>{this.hasListeners&&this.unhook(P);const T=this.events.indexOf(P);this.events.splice(T,1)};return(0,k.toDisposable)((0,t.once)(M))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(P=>this.emitter.fire(P))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.buffers=[]}wrapEvent(u){return(P,M,T)=>u(F=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>P.call(M,F)):P.call(M,F)},void 0,T)}bufferEvents(u){const P=[];this.buffers.push(P);const M=u();return this.buffers.pop(),P.forEach(T=>T()),M}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=g.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(J[22],Z([0,1,3]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,l){const g=setTimeout(C.bind(l),0);return{dispose(){clearTimeout(g)}}});var k;(function(C){function l(g){return g===C.None||g===C.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}C.isCancellationToken=l,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=k.Cancelled}dispose(l=!1){l&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=D}),define(J[138],Z([0,1,22]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new S.CancellationTokenSource,l=this.task(C.token);return this.result={promise:l,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=t;class k{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const l=JSON.stringify(C);return this.lastArgKey!==l&&(this.lastArgKey=l,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=k;class R{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const l=this.fn(C);return this._map.set(C,l),l}}e.CachedFunction=R}),define(J[93],Z([0,1,3,2]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=D=>({onDidChange:S.Event.None,value:D});e.staticObservableValue=k;class R extends t.Disposable{constructor(C){super(),this._value=C,this.changeEmitter=this._register(new S.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(C){C!==this._value&&(this._value=C,this.changeEmitter.fire(C))}}e.MutableObservableValue=R}),define(J[25],Z([0,1,138,124]),function(q,e,S,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function C(G,...ce){return ce.length===0?G:G.replace(D,function(pe,fe){const Se=parseInt(fe,10);return isNaN(Se)||Se<0||Se>=ce.length?pe:ce[Se]})}e.format=C;const l=/{([^}]+)}/g;function g(G,ce){return G.replace(l,(pe,fe)=>ce[fe]??pe)}e.format2=g;function I(G){return G.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=I;function E(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function y(G,ce){let pe=0;const fe=ce.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===fe&&pe++;return pe}e.count=y;function f(G,ce,pe="\u2026"){return G.length<=ce?G:`${G.substr(0,ce)}${pe}`}e.truncate=f;function h(G,ce=" "){const pe=b(G,ce);return w(pe,ce)}e.trim=h;function b(G,ce){if(!G||!ce)return G;const pe=ce.length;if(pe===0||G.length===0)return G;let fe=0;for(;G.indexOf(ce,fe)===fe;)fe=fe+pe;return G.substring(fe)}e.ltrim=b;function w(G,ce){if(!G||!ce)return G;const pe=ce.length,fe=G.length;if(pe===0||fe===0)return G;let Se=fe,De=-1;for(;De=G.lastIndexOf(ce,Se-1),!(De===-1||De+pe!==Se);){if(De===0)return"";Se=De}return G.substring(0,Se)}e.rtrim=w;function m(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(G){return G.replace(/\*/g,"")}e.stripWildcards=v;function d(G,ce,pe={}){if(!G)throw new Error("Cannot create regex from empty string");ce||(G=E(G)),pe.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let fe="";return pe.global&&(fe+="g"),pe.matchCase||(fe+="i"),pe.multiline&&(fe+="m"),pe.unicode&&(fe+="u"),new RegExp(G,fe)}e.createRegExp=d;function p(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function n(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=n;function o(G){return G.split(/\r\n|\r|\n/)}e.splitLines=o;function i(G){for(let ce=0,pe=G.length;ce<pe;ce++){const fe=G.charCodeAt(ce);if(fe!==32&&fe!==9)return ce}return-1}e.firstNonWhitespaceIndex=i;function r(G,ce=0,pe=G.length){for(let fe=ce;fe<pe;fe++){const Se=G.charCodeAt(fe);if(Se!==32&&Se!==9)return G.substring(ce,fe)}return G.substring(ce,pe)}e.getLeadingWhitespace=r;function s(G,ce=G.length-1){for(let pe=ce;pe>=0;pe--){const fe=G.charCodeAt(pe);if(fe!==32&&fe!==9)return pe}return-1}e.lastNonWhitespaceIndex=s;function a(G,ce,pe){const fe=[];let Se=0;for(const De of G.matchAll(ce)){if(fe.push(G.slice(Se,De.index)),De.index===void 0)throw new Error("match.index should be defined");Se=De.index+De[0].length,fe.push(pe(De[0],...De.slice(1),De.index,G,De.groups))}return fe.push(G.slice(Se)),Promise.all(fe).then(De=>De.join(""))}e.replaceAsync=a;function u(G,ce){return G<ce?-1:G>ce?1:0}e.compare=u;function P(G,ce,pe=0,fe=G.length,Se=0,De=ce.length){for(;pe<fe&&Se<De;pe++,Se++){const et=G.charCodeAt(pe),Ke=ce.charCodeAt(Se);if(et<Ke)return-1;if(et>Ke)return 1}const Fe=fe-pe,Qe=De-Se;return Fe<Qe?-1:Fe>Qe?1:0}e.compareSubstring=P;function M(G,ce){return T(G,ce,0,G.length,0,ce.length)}e.compareIgnoreCase=M;function T(G,ce,pe=0,fe=G.length,Se=0,De=ce.length){for(;pe<fe&&Se<De;pe++,Se++){let et=G.charCodeAt(pe),Ke=ce.charCodeAt(Se);if(et===Ke)continue;if(et>=128||Ke>=128)return P(G.toLowerCase(),ce.toLowerCase(),pe,fe,Se,De);U(et)&&(et-=32),U(Ke)&&(Ke-=32);const Ye=et-Ke;if(Ye!==0)return Ye}const Fe=fe-pe,Qe=De-Se;return Fe<Qe?-1:Fe>Qe?1:0}e.compareSubstringIgnoreCase=T;function F(G){return G>=48&&G<=57}e.isAsciiDigit=F;function U(G){return G>=97&&G<=122}e.isLowerAsciiLetter=U;function Q(G){return G>=65&&G<=90}e.isUpperAsciiLetter=Q;function re(G,ce){return G.length===ce.length&&T(G,ce)===0}e.equalsIgnoreCase=re;function le(G,ce){const pe=ce.length;return ce.length>G.length?!1:T(G,ce,0,pe)===0}e.startsWithIgnoreCase=le;function ue(G,ce){const pe=Math.min(G.length,ce.length);let fe;for(fe=0;fe<pe;fe++)if(G.charCodeAt(fe)!==ce.charCodeAt(fe))return fe;return pe}e.commonPrefixLength=ue;function se(G,ce){const pe=Math.min(G.length,ce.length);let fe;const Se=G.length-1,De=ce.length-1;for(fe=0;fe<pe;fe++)if(G.charCodeAt(Se-fe)!==ce.charCodeAt(De-fe))return fe;return pe}e.commonSuffixLength=se;function de(G){return 55296<=G&&G<=56319}e.isHighSurrogate=de;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function $(G,ce){return(G-55296<<10)+(ce-56320)+65536}e.computeCodePoint=$;function _(G,ce,pe){const fe=G.charCodeAt(pe);if(de(fe)&&pe+1<ce){const Se=G.charCodeAt(pe+1);if(K(Se))return $(fe,Se)}return fe}e.getNextCodePoint=_;function A(G,ce){const pe=G.charCodeAt(ce-1);if(K(pe)&&ce>1){const fe=G.charCodeAt(ce-2);if(de(fe))return $(fe,pe)}return pe}class W{constructor(ce,pe=0){this._str=ce,this._len=ce.length,this._offset=pe}get offset(){return this._offset}setOffset(ce){this._offset=ce}prevCodePoint(){const ce=A(this._str,this._offset);return this._offset-=ce>=65536?2:1,ce}nextCodePoint(){const ce=_(this._str,this._len,this._offset);return this._offset+=ce>=65536?2:1,ce}eol(){return this._offset>=this._len}}e.CodePointIterator=W;class z{constructor(ce,pe=0){this._iterator=new W(ce,pe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ce=Ie.getInstance(),pe=this._iterator,fe=pe.offset;let Se=ce.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const De=pe.offset,Fe=ce.getGraphemeBreakType(pe.nextCodePoint());if(he(Se,Fe)){pe.setOffset(De);break}Se=Fe}return pe.offset-fe}prevGraphemeLength(){const ce=Ie.getInstance(),pe=this._iterator,fe=pe.offset;let Se=ce.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const De=pe.offset,Fe=ce.getGraphemeBreakType(pe.prevCodePoint());if(he(Fe,Se)){pe.setOffset(De);break}Se=Fe}return fe-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=z;function ee(G,ce){return new z(G,ce).nextGraphemeLength()}e.nextCharLength=ee;function B(G,ce){return new z(G,ce).prevGraphemeLength()}e.prevCharLength=B;function j(G,ce){ce>0&&K(G.charCodeAt(ce))&&ce--;const pe=ce+ee(G,ce);return[pe-B(G,pe),pe]}e.getCharContainingOffset=j;let L;function O(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(G){return L||(L=O()),L.test(G)}e.containsRTL=N;const V=/^[\t\n\r\x20-\x7E]*$/;function x(G){return V.test(G)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=ne;function H(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=H;function te(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=te;function ie(G,ce){if(G.length<ce)return G;const pe=/\b/g;let fe=0;for(;pe.test(G)&&!(G.length-pe.lastIndex<ce);)fe=pe.lastIndex,pe.lastIndex+=1;return G.substring(fe).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Me=/\x1b\[0?m/g;function Le(G){return G&&(G=G.replace(oe,""),G=G.replace(ge,""),G=G.replace(Me,"")),G}e.removeAnsiEscapeCodes=Le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ke(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ke;function Ae(G){return ke(G)?G.substr(1):G}e.stripUTF8BOM=Ae;function Ve(G,ce){if(!G||!ce||G.length<ce.length)return!1;const pe=ce.length,fe=G.toLowerCase();let Se=0,De=-1;for(;Se<pe;){const Fe=fe.indexOf(ce[Se],De+1);if(Fe<0)return!1;De=Fe,Se++}return!0}e.fuzzyContains=Ve;function me(G,ce=!1){return G?(ce&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=me;function we(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=we;function Ee(G,ce=1){if(ce===0)return"";let pe=-1;do pe=G.indexOf(`
`,pe+1),ce--;while(ce>0&&pe>=0);return pe===-1?G:(G[pe-1]==="\r"&&pe--,G.substr(0,pe))}e.getNLines=Ee;function X(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=X;function ae(G){return Ie.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ae;function he(G,ce){return G===0?ce!==5&&ce!==7:G===2&&ce===3?!1:G===4||G===2||G===3||ce===4||ce===2||ce===3?!0:!(G===8&&(ce===8||ce===9||ce===11||ce===12)||(G===11||G===9)&&(ce===9||ce===10)||(G===12||G===10)&&ce===10||ce===5||ce===13||ce===7||G===1||G===13&&ce===14||G===6&&ce===6)}var be;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(be=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{constructor(){this._data=Oe()}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const pe=this._data,fe=pe.length/3;let Se=1;for(;Se<=fe;)if(ce<pe[3*Se])Se=2*Se;else if(ce>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}Ie._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(G,ce){if(G===0)return 0;const pe=Ue(G,ce);if(pe!==void 0)return pe;const fe=new W(ce,G);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=We;function Ue(G,ce){const pe=new W(ce,G);let fe=pe.prevCodePoint();for(;Ne(fe)||fe===65039||fe===8419;){if(pe.offset===0)return;fe=pe.prevCodePoint()}if(!te(fe))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Ne(G){return 127995<=G&&G<=127999}var ze;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Be{constructor(ce){this.confusableDictionary=ce}static getInstance(ce){return Be.cache.get(Array.from(ce))}static getLocales(){return Be._locales.getValue()}isAmbiguous(ce){return this.confusableDictionary.has(ce)}getPrimaryConfusable(ce){return this.confusableDictionary.get(ce)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Be,k=Be,Be.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.cache=new S.LRUCachedFunction(G=>{function ce(Ke){const Ye=new Map;for(let it=0;it<Ke.length;it+=2)Ye.set(Ke[it],Ke[it+1]);return Ye}function pe(Ke,Ye){const it=new Map(Ke);for(const[st,ht]of Ye)it.set(st,ht);return it}function fe(Ke,Ye){if(!Ke)return Ye;const it=new Map;for(const[st,ht]of Ke)Ye.has(st)&&it.set(st,ht);return it}const Se=k.ambiguousCharacterData.getValue();let De=G.filter(Ke=>!Ke.startsWith("_")&&Ke in Se);De.length===0&&(De=["_default"]);let Fe;for(const Ke of De){const Ye=ce(Se[Ke]);Fe=fe(Fe,Ye)}const Qe=ce(Se._common),et=pe(Qe,Fe);return new Be(et)}),Be._locales=new t.Lazy(()=>Object.keys(Be.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(ce){return qe.getData().has(ce)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe,qe._data=void 0}),define(J[31],Z([0,1,9,4,25,12]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function C(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=C;function l(s){return s.indexOf("/")===-1&&(s=C(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=l;function g(s,a=S.posix.sep){if(!s)return"";const u=s.length,P=s.charCodeAt(0);if(D(P)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let T=3;const F=T;for(;T<u&&!D(s.charCodeAt(T));T++);if(F!==T&&!D(s.charCodeAt(T+1))){for(T+=1;T<u;T++)if(D(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(m(P)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let M=s.indexOf("://");if(M!==-1){for(M+=3;M<u;M++)if(D(s.charCodeAt(M)))return s.slice(0,M+1)}return""}e.getRoot=g;function I(s){if(!t.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let u=2;const P=u;for(;u<s.length&&(a=s.charCodeAt(u),a!==92);u++);return!(P===u||(a=s.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,a=t.isWindows){const u=a?E:y;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||a&&f.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function b(s,a,u){const P=s===a;return!u||P?P:!s||!a?!1:(0,k.equalsIgnoreCase)(s,a)}e.isEqual=b;function w(s,a,u,P=S.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(u){if(!(0,k.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let T=a.length;return a.charAt(a.length-1)===P&&T--,s.charAt(T)===P}return a.charAt(a.length-1)!==P&&(a+=P),s.indexOf(a)===0}e.isEqualOrParent=w;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function v(s,a){return t.isWindows&&s.endsWith(":")&&(s+=S.sep),(0,S.isAbsolute)(s)||(s=(0,S.join)(a,s)),s=(0,S.normalize)(s),t.isWindows?(s=(0,k.rtrim)(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=(0,k.rtrim)(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=v;function d(s){const a=(0,S.normalize)(s);return t.isWindows?s.length>3?!1:p(a)&&(s.length===2||a.charCodeAt(2)===92):a===S.posix.sep}e.isRootOrDriveLetter=d;function p(s,a=t.isWindows){return a?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function c(s){return p(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,a,u){return a.length>s.length?-1:s===a?0:(u&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=n;function o(s){const a=s.split(":");let u,P,M;for(const T of a){const F=Number(T);(0,R.isNumber)(F)?P===void 0?P=F:M===void 0&&(M=F):u=u?[u,T].join(":"):T}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:P!==void 0?P:void 0,column:M!==void 0?M:P!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,a,u=8){let P="";for(let T=0;T<u;T++)P+=i.charAt(Math.floor(Math.random()*i.length));let M;return a?M=`${a}-${P}`:M=P,s?(0,S.join)(s,M):M}e.randomPath=r}),define(J[66],Z([0,1,25]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return k(m,0)}e.hash=t;function k(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?l(m,v):g(m,v);case"string":return C(m,v);case"boolean":return D(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=k;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function D(m,v){return R(m?433:863,v)}function C(m,v){v=R(149417,v);for(let d=0,p=m.length;d<p;d++)v=R(m.charCodeAt(d),v);return v}e.stringHash=C;function l(m,v){return v=R(104579,v),m.reduce((d,p)=>k(p,d),v)}function g(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((d,p)=>(d=C(p,d),k(m[p],d)),v)}class I{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=k(v,this._value),this._value}}e.Hasher=I;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function y(m,v,d=32){const p=d-v,c=~((1<<p)-1);return(m<<v|(c&m)>>>p)>>>0}function f(m,v=0,d=m.byteLength,p=0){for(let c=0;c<d;c++)m[v+c]=p}function h(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function b(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),v/4)}e.toHexString=b;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d===0)return;const p=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,o,i;for(n!==0?(o=n,i=-1,n=0):(o=v.charCodeAt(0),i=0);;){let r=o;if(S.isHighSurrogate(o))if(i+1<d){const s=v.charCodeAt(i+1);S.isLowSurrogate(s)?(i++,r=S.computeCodePoint(o,s)):r=65533}else{n=o;break}else S.isLowSurrogate(o)&&(r=65533);if(c=this._push(p,c,r),i++,i<d)o=v.charCodeAt(i);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(v,d,p){return p<128?v[d++]=p:p<2048?(v[d++]=192|(p&1984)>>>6,v[d++]=128|(p&63)>>>0):p<65536?(v[d++]=224|(p&61440)>>>12,v[d++]=128|(p&4032)>>>6,v[d++]=128|(p&63)>>>0):(v[d++]=240|(p&1835008)>>>18,v[d++]=128|(p&258048)>>>12,v[d++]=128|(p&4032)>>>6,v[d++]=128|(p&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=w._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,y(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let p=this._h0,c=this._h1,n=this._h2,o=this._h3,i=this._h4,r,s,a;for(let u=0;u<80;u++)u<20?(r=c&n|~c&o,s=1518500249):u<40?(r=c^n^o,s=1859775393):u<60?(r=c&n|c&o|n&o,s=2400959708):(r=c^n^o,s=3395469782),a=y(p,5)+r+i+s+v.getUint32(u*4,!1)&4294967295,i=o,o=n,n=y(c,30),c=p,p=a;this._h0=this._h0+p&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[32],Z([0,1,24,25]),function(q,e,S,t){"use strict";var k,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(i,r,s){let a=i.get(r);return a===void 0&&(a=s,i.set(r,a)),a}e.getOrSet=C;function l(i){const r=[];return i.forEach((s,a)=>{r.push(`${a} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}e.mapToString=l;function g(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}e.setToString=g;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class y{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var f;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(f||(f={}));class h{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(w||(w={}));class m{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new m(new h(r,s))}static forPaths(r=!1){return new m(new y(void 0,!r))}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(r,s){if(s){const a=s.slice(0);(0,S.shuffle)(a);for(const u of a)this.set(u,r)}else{const a=r.slice(0);(0,S.shuffle)(a);for(const u of a)this.set(u[0],u[1])}}set(r,s){const a=this._iter.reset(r);let u;this._root||(this._root=new b,this._root.segment=a.value());const P=[];for(u=this._root;;){const T=a.cmp(u.segment);if(T>0)u.left||(u.left=new b,u.left.segment=a.value()),P.push([-1,u]),u=u.left;else if(T<0)u.right||(u.right=new b,u.right.segment=a.value()),P.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new b,u.mid.segment=a.value()),P.push([0,u]),u=u.mid;else break}const M=u.value;u.value=s,u.key=r;for(let T=P.length-1;T>=0;T--){const F=P[T][1];F.updateHeight();const U=F.balanceFactor();if(U<-1||U>1){const Q=P[T][0],re=P[T+1][0];if(Q===1&&re===1)P[T][1]=F.rotateLeft();else if(Q===-1&&re===-1)P[T][1]=F.rotateRight();else if(Q===1&&re===-1)F.right=P[T+1][1]=P[T+1][1].rotateRight(),P[T][1]=F.rotateLeft();else if(Q===-1&&re===1)F.left=P[T+1][1]=P[T+1][1].rotateLeft(),P[T][1]=F.rotateRight();else throw new Error;if(T>0)switch(P[T-1][0]){case-1:P[T-1][1].left=P[T][1];break;case 1:P[T-1][1].right=P[T][1];break;case 0:P[T-1][1].mid=P[T][1];break}else this._root=P[0][1]}}return M}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const a=this._iter.reset(r),u=[];let P=this._root;for(;P;){const M=a.cmp(P.segment);if(M>0)u.push([-1,P]),P=P.left;else if(M<0)u.push([1,P]),P=P.right;else if(a.hasNext())a.next(),u.push([0,P]),P=P.mid;else break}if(!!P){if(s?(P.left=void 0,P.mid=void 0,P.right=void 0,P.height=1):(P.key=void 0,P.value=void 0),!P.mid&&!P.value)if(P.left&&P.right){const M=this._min(P.right),{key:T,value:F,segment:U}=M;this._delete(M.key,!1),P.key=T,P.value=F,P.segment=U}else{const M=P.left??P.right;if(u.length>0){const[T,F]=u[u.length-1];switch(T){case-1:F.left=M;break;case 0:F.mid=M;break;case 1:F.right=M;break}}else this._root=M}for(let M=u.length-1;M>=0;M--){const T=u[M][1];T.updateHeight();const F=T.balanceFactor();if(F>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),u[M][1]=T.rotateLeft()):F<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),u[M][1]=T.rotateRight()),M>0)switch(u[M-1][0]){case-1:u[M-1][1].left=u[M][1];break;case 1:u[M-1][1].right=u[M][1];break;case 0:u[M-1][1].mid=u[M][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let a=this._root,u;for(;a;){const P=s.cmp(a.segment);if(P>0)a=a.left;else if(P<0)a=a.right;else if(s.hasNext())s.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const s=this._iter.reset(r);let a=this._root;for(;a;){const u=s.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[s,a]of this)r(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=m;class v{constructor(r,s){this.uri=r,this.value=s}}class d{constructor(r,s){this[k]="ResourceMap",r instanceof d?(this.map=new Map(r.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=r??d.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new v(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[a,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=d,d.defaultToKey=i=>i.toString();class p{constructor(r,s){this[R]="ResourceSet",!r||typeof r=="function"?this._map=new d(r):(this._map=new d(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((a,u)=>r.call(s,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class n{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const a=this._map.get(r);if(!!a)return s!==0&&this.touch(a,s),a.value}set(r,s,a=0){let u=this._map.get(r);if(u)u.value=s,a!==0&&this.touch(u,a);else{switch(u={key:r,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const a=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.key,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:a.value,done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const P={value:[a.key,a.value],done:!1};return a=a.next,P}else return{value:void 0,done:!0}}};return u}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>r;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,a=r.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,a)=>{r.push([a,s])}),r}fromJSON(r){this.clear();for(const[s,a]of r)this.set(s,a)}}e.LinkedMap=n;class o extends n{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o}),define(J[80],Z([0,1,32]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function k(g){return l(g,"NFC",t)}e.normalizeNFC=k;const R=new S.LRUCache(1e4);function D(g){return l(g,"NFD",R)}e.normalizeNFD=D;const C=/[^\u0000-\u0080]/;function l(g,I,E){if(!g)return g;const y=E.get(g);if(y)return y;let f;return C.test(g)?f=g.normalize(I):f=g,E.set(g,f),f}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(I){return D(I).replace(g,"")}}()}),define(J[94],Z([0,1,25]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",D="warning",C="warn",l="info",g="ignore";function I(y){return y?S.equalsIgnoreCase(R,y)?k.Error:S.equalsIgnoreCase(D,y)||S.equalsIgnoreCase(C,y)?k.Warning:S.equalsIgnoreCase(l,y)?k.Info:k.Ignore:k.Ignore}k.fromValue=I;function E(y){switch(y){case k.Error:return R;case k.Warning:return D;case k.Info:return l;default:return g}}k.toString=E}(t||(t={})),e.default=t}),define(J[7],Z([0,1,9,4]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function C(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(i,r){return!i&&!r?"file":i}function g(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==E&&(r=E+r):r=E;break}return r}const I="",E="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,s,a,u,P,M=!1){typeof r=="object"?(this.scheme=r.scheme||I,this.authority=r.authority||I,this.path=r.path||I,this.query=r.query||I,this.fragment=r.fragment||I):(this.scheme=l(r,M),this.authority=s||I,this.path=g(this.scheme,a||I),this.query=u||I,this.fragment=P||I,C(this,M))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return d(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:a,path:u,query:P,fragment:M}=r;return s===void 0?s=this.scheme:s===null&&(s=I),a===void 0?a=this.authority:a===null&&(a=I),u===void 0?u=this.path:u===null&&(u=I),P===void 0?P=this.query:P===null&&(P=I),M===void 0?M=this.fragment:M===null&&(M=I),s===this.scheme&&a===this.authority&&u===this.path&&P===this.query&&M===this.fragment?this:new b(s,a,u,P,M)}static parse(r,s=!1){const a=y.exec(r);return a?new b(a[2]||I,o(a[4]||I),o(a[5]||I),o(a[7]||I),o(a[9]||I),s):new b(I,I,I,I,I)}static file(r){let s=I;if(t.isWindows&&(r=r.replace(/\\/g,E)),r[0]===E&&r[1]===E){const a=r.indexOf(E,2);a===-1?(s=r.substring(2),r=E):(s=r.substring(2,a),r=r.substring(a)||E)}return new b("file",s,r,I,I)}static from(r){const s=new b(r.scheme,r.authority,r.path,r.query,r.fragment);return C(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&r.scheme==="file"?a=f.file(S.win32.join(d(r,!0),...s)).path:a=S.posix.join(r.path,...s),r.with({path:a})}toString(r=!1){return p(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const s=new b(r);return s._formatted=r.external,s._fsPath=r._sep===h?r.fsPath:null,s}}else return r}}e.URI=f;const h=t.isWindows?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(r=!1){return r?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,r){let s,a=-1;for(let u=0;u<i.length;u++){const P=i.charCodeAt(u);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47)a!==-1&&(s+=encodeURIComponent(i.substring(a,u)),a=-1),s!==void 0&&(s+=i.charAt(u));else{s===void 0&&(s=i.substr(0,u));const M=w[P];M!==void 0?(a!==-1&&(s+=encodeURIComponent(i.substring(a,u)),a=-1),s+=M):a===-1&&(a=u)}}return a!==-1&&(s+=encodeURIComponent(i.substring(a))),s!==void 0?s:i}function v(i){let r;for(let s=0;s<i.length;s++){const a=i.charCodeAt(s);a===35||a===63?(r===void 0&&(r=i.substr(0,s)),r+=w[a]):r!==void 0&&(r+=i[s])}return r!==void 0?r:i}function d(i,r){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function p(i,r){const s=r?v:m;let a="",{scheme:u,authority:P,path:M,query:T,fragment:F}=i;if(u&&(a+=u,a+=":"),(P||u==="file")&&(a+=E,a+=E),P){let U=P.indexOf("@");if(U!==-1){const Q=P.substr(0,U);P=P.substr(U+1),U=Q.indexOf(":"),U===-1?a+=s(Q,!1):(a+=s(Q.substr(0,U),!1),a+=":",a+=s(Q.substr(U+1),!1)),a+="@"}P=P.toLowerCase(),U=P.indexOf(":"),U===-1?a+=s(P,!1):(a+=s(P.substr(0,U),!1),a+=P.substr(U))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const U=M.charCodeAt(1);U>=65&&U<=90&&(M=`/${String.fromCharCode(U+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const U=M.charCodeAt(0);U>=65&&U<=90&&(M=`${String.fromCharCode(U+32)}:${M.substr(2)}`)}a+=s(M,!0)}return T&&(a+="?",a+=s(T,!1)),F&&(a+="#",a+=r?F:m(F,!1)),a}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(n)?i.replace(n,r=>c(r)):i}}),define(J[139],Z([0,1,7]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(g){const I=g;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=t;function k(g){const I=[];let E;try{const y=JSON.parse(g.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),E=f.__$stack),I.push(...y)}catch{I.push("Unable to log remote console arguments",g.arguments)}return{args:I,stack:E}}e.parse=k;function R(g){if(typeof g!="string")return R(k(g).stack);const I=g;if(I){const E=D(I),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function D(g){if(!g)return g;const I=g.indexOf(`
`);return I===-1?g:g.substring(0,I)}function C(g,I){const{args:E,stack:y}=k(g),f=typeof E[0]=="string"&&E.length===1;let h=D(y);h&&(h=`(${h.trim()})`);let b=[];if(typeof E[0]=="string"?h&&f?b=[`%c[${I}] %c${E[0]} %c${h}`,l("blue"),l(""),l("grey")]:b=[`%c[${I}] %c${E[0]}`,l("blue"),l(""),...E.slice(1)]:b=[`%c[${I}]%`,l("blue"),...E],h&&!f&&b.push(h),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=C;function l(g){return`color: ${g}`}}),define(J[67],Z([0,1,18,25,7]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(g){return JSON.stringify(g,C)}e.stringify=R;function D(g){let I=JSON.parse(g);return I=l(I),I}e.parse=D;function C(g,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,t.regExpFlags)(I)}:I}function l(g,I=0){if(!g||I>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return k.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 14:return new Date(g.source)}if(g instanceof S.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let E=0;E<g.length;++E)g[E]=l(g[E],I+1);else for(const E in g)Object.hasOwnProperty.call(g,E)&&(g[E]=l(g[E],I+1))}return g}e.revive=l}),define(J[13],Z([0,1,4,7]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebook="vscode-notebook",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${k.vscodeRemoteResource}`}set(g,I,E){this._hosts[g]=I,this._ports[g]=E}setConnectionToken(g,I){this._connectionTokens[g]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const I=g.authority;let E=this._hosts[I];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const y=this._ports[I],f=this._connectionTokens[I];let h=`path=${encodeURIComponent(g.path)}`;return typeof f=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),t.URI.from({scheme:S.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${y}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new R;class D{asBrowserUri(g,I){const E=this.toUri(g,I);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(S.isNative||S.isWebWorker&&S.globals.origin===`${k.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(g,I){const E=this.toUri(g,I);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==D.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(g,I){return t.URI.isUri(g)?g:t.URI.parse(I.toUrl(g))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var C;(function(l){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(g.get("3"));const I="vscode-coi";function E(f){let h;typeof f=="string"?h=new URL(f).searchParams:f instanceof URL?h=f.searchParams:t.URI.isUri(f)&&(h=new URL(f.toString(!0)).searchParams);const b=h?.get(I);if(!!b)return g.get(b)}l.getHeadersFromQuery=E;function y(f,h,b){if(!globalThis.crossOriginIsolated)return;const w=h&&b?"3":b?"2":"1";f instanceof URLSearchParams?f.set(I,w):f[I]=w}l.addSearchParam=y})(C=e.COI||(e.COI={}))}),define(J[16],Z([0,1,31,13,9,4,25,7]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function l(f){return(0,C.uriToFsPath)(f,!0)}e.originalFSPath=l;class g{constructor(h){this._ignorePathCasing=h}compare(h,b,w=!1){return h===b?0:(0,D.compare)(this.getComparisonKey(h,w),this.getComparisonKey(b,w))}isEqual(h,b,w=!1){return h===b?!0:!h||!b?!1:this.getComparisonKey(h,w)===this.getComparisonKey(b,w)}getComparisonKey(h,b=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,b,w=!1){if(h.scheme===b.scheme){if(h.scheme===t.Schemas.file)return S.isEqualOrParent(l(h),l(b),this._ignorePathCasing(h))&&h.query===b.query&&(w||h.fragment===b.fragment);if((0,e.isEqualAuthority)(h.authority,b.authority))return S.isEqualOrParent(h.path,b.path,this._ignorePathCasing(h),"/")&&h.query===b.query&&(w||h.fragment===b.fragment)}return!1}joinPath(h,...b){return C.URI.joinPath(h,...b)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let b;return h.scheme===t.Schemas.file?b=C.URI.file(k.dirname(l(h))).path:(b=k.posix.dirname(h.path),h.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),b="/")),h.with({path:b})}normalizePath(h){if(!h.path.length)return h;let b;return h.scheme===t.Schemas.file?b=C.URI.file(k.normalize(l(h))).path:b=k.posix.normalize(h.path),h.with({path:b})}relativePath(h,b){if(h.scheme!==b.scheme||!(0,e.isEqualAuthority)(h.authority,b.authority))return;if(h.scheme===t.Schemas.file){const v=k.relative(l(h),l(b));return R.isWindows?S.toSlashes(v):v}let w=h.path||"/";const m=b.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const d=Math.min(w.length,m.length);v<d&&!(w.charCodeAt(v)!==m.charCodeAt(v)&&w.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);w=m.substr(0,v)+w.substr(v)}return k.posix.relative(w,m)}resolvePath(h,b){if(h.scheme===t.Schemas.file){const w=C.URI.file(k.resolve(l(h),b));return h.with({authority:w.authority,path:w.path})}return b=S.toPosixPath(b),h.with({path:k.posix.resolve(h.path,b)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,b){return h===b||h!==void 0&&b!==void 0&&(0,D.equalsIgnoreCase)(h,b)}hasTrailingPathSeparator(h,b=k.sep){if(h.scheme===t.Schemas.file){const w=l(h);return w.length>S.getRoot(w).length&&w[w.length-1]===b}else{const w=h.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,b=k.sep){return(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,b=k.sep){let w=!1;if(h.scheme===t.Schemas.file){const m=l(h);w=m!==void 0&&m.length===S.getRoot(m).length&&m[m.length-1]===b}else{b="/";const m=h.path;w=m.length===1&&m.charCodeAt(m.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path+"/"}):h}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new g(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(f,h){const b=[];for(let w=0;w<f.length;w++){const m=h(f[w]);f.some((v,d)=>d===w?!1:(0,e.isEqualOrParent)(m,h(v)))||b.push(f[w])}return b}e.distinctParents=I;var E;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function h(b){const w=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[p,c]=d.split(":");p&&c&&w.set(p,c)});const v=b.path.substring(0,b.path.indexOf(";"));return v&&w.set(f.META_DATA_MIME,v),w}f.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function y(f,h,b){if(h){let w=f.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),f.with({scheme:b,authority:h,path:w})}return f.with({scheme:b})}e.toLocalResource=y}),define(J[8],Z([0,1,22,17,3,2,16,4]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(j){return!!j&&typeof j.then=="function"}e.isThenable=l;function g(j){const L=new S.CancellationTokenSource,O=j(L.token),N=new Promise((V,x)=>{const ne=L.token.onCancellationRequested(()=>{ne.dispose(),L.dispose(),x(new t.CancellationError)});Promise.resolve(O).then(H=>{ne.dispose(),L.dispose(),V(H)},H=>{ne.dispose(),L.dispose(),x(H)})});return new class{cancel(){L.cancel()}then(V,x){return N.then(V,x)}catch(V){return this.then(void 0,V)}finally(V){return N.finally(V)}}}e.createCancelablePromise=g;function I(j,L,O){return new Promise((N,V)=>{const x=L.onCancellationRequested(()=>{x.dispose(),N(O)});j.then(N,V).finally(()=>x.dispose())})}e.raceCancellation=I;function E(j,L){return new Promise((O,N)=>{const V=L.onCancellationRequested(()=>{V.dispose(),N(new t.CancellationError)});j.then(O,N).finally(()=>V.dispose())})}e.raceCancellationError=E;async function y(j){let L=-1;const O=j.map((V,x)=>V.then(ne=>(L=x,ne))),N=await Promise.race(O);return j.forEach((V,x)=>{x!==L&&V.cancel()}),N}e.raceCancellablePromises=y;function f(j,L,O){let N;const V=setTimeout(()=>{N?.(void 0),O?.()},L);return Promise.race([j.finally(()=>clearTimeout(V)),new Promise(x=>N=x)])}e.raceTimeout=f;function h(j){return new Promise((L,O)=>{const N=j();l(N)?N.then(L,O):L(N)})}e.asPromise=h;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(O,O).then(N)})}return new Promise((O,N)=>{this.queuedPromise.then(O,N)})}return this.activePromise=L(),new Promise((O,N)=>{this.activePromise.then(V=>{this.activePromise=null,O(V)},V=>{this.activePromise=null,N(V)})})}}e.Throttler=b;class w{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=w;class m{constructor(){this.promiseMap=new Map}queue(L,O){const V=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(L)===V&&this.promiseMap.delete(L)});return this.promiseMap.set(L,V),V}}e.SequencerByKey=m;const v=(j,L)=>{let O=!0;const N=setTimeout(()=>{O=!1,L()},j);return{isTriggered:()=>O,dispose:()=>{clearTimeout(N),O=!1}}},d=j=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,j())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(L){this.defaultDelay=L,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,O=this.defaultDelay){this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(N):v(O,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class c{constructor(L){this.delayer=new p(L),this.throttler=new b}trigger(L,O){return this.delayer.trigger(()=>this.throttler.queue(L),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class n{constructor(){this._isOpen=!1,this._promise=new Promise((L,O)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(L){super(),this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function i(j,L){return L?new Promise((O,N)=>{const V=setTimeout(()=>{x.dispose(),O()},j),x=L.onCancellationRequested(()=>{clearTimeout(V),x.dispose(),N(new t.CancellationError)})}):g(O=>i(j,O))}e.timeout=i;function r(j,L=0){const O=setTimeout(j,L);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=r;function s(j){const L=[];let O=0;const N=j.length;function V(){return O<N?j[O++]():null}function x(ne){ne!=null&&L.push(ne);const H=V();return H?H.then(x):Promise.resolve(L)}return Promise.resolve(null).then(x)}e.sequence=s;function a(j,L=N=>!!N,O=null){let N=0;const V=j.length,x=()=>{if(N>=V)return Promise.resolve(O);const ne=j[N++];return Promise.resolve(ne()).then(te=>L(te)?Promise.resolve(te):x())};return x()}e.first=a;function u(j,L=N=>!!N,O=null){if(j.length===0)return Promise.resolve(O);let N=j.length;const V=()=>{N=-1;for(const x of j)x.cancel?.()};return new Promise((x,ne)=>{for(const H of j)H.then(te=>{--N>=0&&L(te)?(V(),x(te)):N===0&&x(O)}).catch(te=>{--N>=0&&(V(),ne(te))})})}e.firstParallel=u;class P{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(L){return this._size++,new Promise((O,N)=>{this.outstandingPromises.push({factory:L,c:O,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const O=L.factory();O.then(L.c,L.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=P;class M extends P{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new _;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,O=D.extUri){const N=O.getComparisonKey(L);let V=this.queues.get(N);return V||(V=new M,k.Event.once(V.onDrained)(()=>{V?.dispose(),this.queues.delete(N),this.onDidQueueDrain()}),this.queues.set(N,V)),V}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class F{constructor(L,O){this._token=-1,typeof L=="function"&&typeof O=="number"&&this.setIfNotSet(L,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},O)}setIfNotSet(L,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},O))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,O){this.cancel(),this._token=setInterval(()=>{L()},O)}}e.IntervalTimer=U;class Q{constructor(L,O){this.timeoutToken=-1,this.runner=L,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=Q;class re{constructor(L,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=re;class le extends Q{constructor(L,O){super(L,O),this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner?.(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=le;class ue extends R.Disposable{constructor(L,O){super(),this.options=L,this.handler=O,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.options.maxBufferedWork)return!1}else if(this.pending+L.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new Q(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,C.setTimeout0)(()=>{if(L)return;const O=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(j,L)=>{const O=requestIdleCallback(j,typeof L=="number"?{timeout:L}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(O))}}}}();class se{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=se;async function de(j,L,O){let N;for(let V=0;V<O;V++)try{return await j()}catch(x){N=x,await i(L)}throw N}e.retry=de;class K{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(L,O,N){return this._pending={taskId:L,cancel:()=>N?.(),promise:O},O.then(()=>this.donePending(L),()=>this.donePending(L)),O}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let O,N;const V=new Promise((x,ne)=>{O=x,N=ne});this._next={run:L,promise:V,promiseResolve:O,promiseReject:N}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=K;class ${constructor(L,O=()=>Date.now()){this.interval=L,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,O)=>{this.completeCallback=L,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(O=>{this.completeCallback(L),this.resolved=!0,O()})}error(L){return new Promise(O=>{this.errorCallback(L),this.rejected=!0,O()})}cancel(){new Promise(L=>{this.errorCallback(new t.CancellationError),this.rejected=!0,L()})}}e.DeferredPromise=_;var A;(function(j){async function L(N){let V;const x=await Promise.all(N.map(ne=>ne.then(H=>H,H=>{V||(V=H)})));if(typeof V<"u")throw V;return x}j.settled=L;function O(N){return new Promise(async(V,x)=>{try{await N(V,x)}catch(ne){x(ne)}})}j.withAsyncBody=O})(A=e.Promises||(e.Promises={}));var W;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(L(O)),this.resolve()}catch(N){this.reject(N)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(L){return new z(O=>{O.emitMany(L)})}static fromPromise(L){return new z(async O=>{O.emitMany(await L)})}static fromPromises(L){return new z(async O=>{await Promise.all(L.map(async N=>O.emitOne(await N)))})}static merge(L){return new z(async O=>{await Promise.all(L.map(async N=>{for await(const V of N)O.emitOne(V)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,O){return new z(async N=>{for await(const V of L)N.emitOne(O(V))})}map(L){return z.map(this,L)}static filter(L,O){return new z(async N=>{for await(const V of L)O(V)&&N.emitOne(V)})}filter(L){return z.filter(this,L)}static coalesce(L){return z.filter(L,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(L){const O=[];for await(const N of L)O.push(N);return O}toPromise(){return z.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class ee extends z{constructor(L,O){super(O),this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function B(j){const L=new S.CancellationTokenSource,O=j(L.token);return new ee(L,async N=>{const V=L.token.onCancellationRequested(()=>{V.dispose(),L.dispose(),N.reject(new t.CancellationError)});try{for await(const x of O){if(L.token.isCancellationRequested)return;N.emitOne(x)}V.dispose(),L.dispose()}catch(x){V.dispose(),L.dispose(),N.reject(x)}})}e.createCancelableAsyncIterable=B}),define(J[95],Z([0,1,24,8,31,32,9,4,25]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",E="[^/\\\\]",y=/\//g;function f(_,A){switch(_){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}${A?`|${I}${E}+`:""})*?`}}function h(_,A){if(!_)return[];const W=[];let z=!1,ee=!1,B="";for(const j of _){switch(j){case A:if(!z&&!ee){W.push(B),B="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}B+=j}return B&&W.push(B),W}e.splitGlobAware=h;function b(_){if(!_)return"";let A="";const W=h(_,e.GLOB_SPLIT);if(W.every(z=>z===e.GLOBSTAR))A=".*";else{let z=!1;W.forEach((ee,B)=>{if(ee===e.GLOBSTAR){if(z)return;A+=f(2,B===W.length-1)}else{let j=!1,L="",O=!1,N="";for(const V of ee){if(V!=="}"&&j){L+=V;continue}if(O&&(V!=="]"||!N)){let x;V==="-"?x=V:(V==="^"||V==="!")&&!N?x="^":V===e.GLOB_SPLIT?x="":x=(0,l.escapeRegExpCharacters)(V),N+=x;continue}switch(V){case"{":j=!0;continue;case"[":O=!0;continue;case"}":{A+=`(?:${h(L,",").map(H=>b(H)).join("|")})`,j=!1,L="";break}case"]":{A+="["+N+"]",O=!1,N="";break}case"?":A+=E;continue;case"*":A+=f(1);continue;default:A+=(0,l.escapeRegExpCharacters)(V)}}B<W.length-1&&(W[B+1]!==e.GLOBSTAR||B+2<W.length)&&(A+=I)}z=ee===e.GLOBSTAR})}return A}const w=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),o=function(){return!1},i=function(){return null};function r(_,A){if(!_)return i;let W;typeof _!="string"?W=_.pattern:W=_,W=W.trim();const z=`${W}_${!!A.trimForExclusions}`;let ee=n.get(z);if(ee)return s(ee,_);let B;return w.test(W)?ee=u(W.substr(4),W):(B=m.exec(a(W,A)))?ee=P(B[1],W):(A.trimForExclusions?d:v).test(W)?ee=M(W,A):(B=p.exec(a(W,A)))?ee=T(B[1].substr(1),W,!0):(B=c.exec(a(W,A)))?ee=T(B[1],W,!1):ee=F(W),n.set(z,ee),s(ee,_)}function s(_,A){if(typeof A=="string")return _;const W=function(z,ee){return(0,k.isEqualOrParent)(z,A.base,!C.isLinux)?_(z.substr(A.base.length+1),ee):null};return W.allBasenames=_.allBasenames,W.allPaths=_.allPaths,W.basenames=_.basenames,W.patterns=_.patterns,W}function a(_,A){return A.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function u(_,A){return function(W,z){return typeof W=="string"&&W.endsWith(_)?A:null}}function P(_,A){const W=`/${_}`,z=`\\${_}`,ee=function(j,L){return typeof j!="string"?null:L?L===_?A:null:j===_||j.endsWith(W)||j.endsWith(z)?A:null},B=[_];return ee.basenames=B,ee.patterns=[A],ee.allBasenames=B,ee}function M(_,A){const W=K(_.slice(1,-1).split(",").map(L=>r(L,A)).filter(L=>L!==i),_),z=W.length;if(!z)return i;if(z===1)return W[0];const ee=function(L,O){for(let N=0,V=W.length;N<V;N++)if(W[N](L,O))return _;return null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(ee.allPaths=j),ee}function T(_,A,W){const z=D.sep===D.posix.sep,ee=z?_:_.replace(y,D.sep),B=D.sep+ee,j=D.posix.sep+_;let L;return W?L=function(O,N){return typeof O=="string"&&(O===ee||O.endsWith(B)||!z&&(O===_||O.endsWith(j)))?A:null}:L=function(O,N){return typeof O=="string"&&(O===ee||!z&&O===_)?A:null},L.allPaths=[(W?"*/":"./")+_],L}function F(_){try{const A=new RegExp(`^${b(_)}$`);return function(W){return A.lastIndex=0,typeof W=="string"&&A.test(W)?_:null}}catch{return i}}function U(_,A,W){return!_||typeof A!="string"?!1:Q(_)(A,void 0,W)}e.match=U;function Q(_,A={}){if(!_)return o;if(typeof _=="string"||re(_)){const W=r(_,A);if(W===i)return o;const z=function(ee,B){return!!W(ee,B)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return se(_,A)}e.parse=Q;function re(_){const A=_;return A?typeof A.base=="string"&&typeof A.pattern=="string":!1}e.isRelativePattern=re;function le(_){return _.allBasenames||[]}e.getBasenameTerms=le;function ue(_){return _.allPaths||[]}e.getPathTerms=ue;function se(_,A){const W=K(Object.getOwnPropertyNames(_).map(L=>de(L,_[L],A)).filter(L=>L!==i)),z=W.length;if(!z)return i;if(!W.some(L=>!!L.requiresSiblings)){if(z===1)return W[0];const L=function(V,x){let ne;for(let H=0,te=W.length;H<te;H++){const ie=W[H](V,x);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(ne||(ne=[]),ne.push(ie))}return ne?(async()=>{for(const H of ne){const te=await H;if(typeof te=="string")return te}return null})():null},O=W.find(V=>!!V.allBasenames);O&&(L.allBasenames=O.allBasenames);const N=W.reduce((V,x)=>x.allPaths?V.concat(x.allPaths):V,[]);return N.length&&(L.allPaths=N),L}const ee=function(L,O,N){let V,x;for(let ne=0,H=W.length;ne<H;ne++){const te=W[ne];te.requiresSiblings&&N&&(O||(O=(0,D.basename)(L)),V||(V=O.substr(0,O.length-(0,D.extname)(L).length)));const ie=te(L,O,V,N);if(typeof ie=="string")return ie;(0,t.isThenable)(ie)&&(x||(x=[]),x.push(ie))}return x?(async()=>{for(const ne of x){const H=await ne;if(typeof H=="string")return H}return null})():null},B=W.find(L=>!!L.allBasenames);B&&(ee.allBasenames=B.allBasenames);const j=W.reduce((L,O)=>O.allPaths?L.concat(O.allPaths):L,[]);return j.length&&(ee.allPaths=j),ee}function de(_,A,W){if(A===!1)return i;const z=r(_,W);if(z===i)return i;if(typeof A=="boolean")return z;if(A){const ee=A.when;if(typeof ee=="string"){const B=(j,L,O,N)=>{if(!N||!z(j,L))return null;const V=ee.replace("$(basename)",O),x=N(V);return(0,t.isThenable)(x)?x.then(ne=>ne?_:null):x?_:null};return B.requiresSiblings=!0,B}}return z}function K(_,A){const W=_.filter(L=>!!L.basenames);if(W.length<2)return _;const z=W.reduce((L,O)=>{const N=O.basenames;return N?L.concat(N):L},[]);let ee;if(A){ee=[];for(let L=0,O=z.length;L<O;L++)ee.push(A)}else ee=W.reduce((L,O)=>{const N=O.patterns;return N?L.concat(N):L},[]);const B=function(L,O){if(typeof L!="string")return null;if(!O){let V;for(V=L.length;V>0;V--){const x=L.charCodeAt(V-1);if(x===47||x===92)break}O=L.substr(V)}const N=z.indexOf(O);return N!==-1?ee[N]:null};B.basenames=z,B.patterns=ee,B.allBasenames=z;const j=_.filter(L=>!L.basenames);return j.push(B),j}function $(_,A){return(0,S.equals)(_,A,(W,z)=>typeof W=="string"&&typeof z=="string"?W===z:typeof W!="string"&&typeof z!="string"?W.base===z.base&&W.pattern===z.pattern:!1)}e.patternsEquals=$}),define(J[35],Z([0,1,24,31,9,4,16,25]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function l(i,r){const{os:s,tildify:a,relative:u}=r;if(u){const T=g(i,u,s);if(typeof T=="string")return T}let P=i.fsPath;if(s===1&&!R.isWindows?P=P.replace(/\//g,"\\"):s!==1&&R.isWindows&&(P=P.replace(/\\/g,"/")),s!==1&&a?.userHome){const T=a.userHome.fsPath;let F;i.scheme!==a.userHome.scheme&&i.path.startsWith(k.posix.sep)?F=a.userHome.with({path:i.path}).fsPath:F=i.fsPath,P=y(F,T,s)}return(s===1?k.win32:k.posix).normalize(I(P,s===1))}e.getPathLabel=l;function g(i,r,s){const a=s===1?k.win32:k.posix,u=s===3?D.extUri:D.extUriIgnorePathCase,P=r.getWorkspace(),M=(0,S.firstOrDefault)(P.folders);if(!M)return;i.scheme!==M.uri.scheme&&i.path.startsWith(k.posix.sep)&&(i=M.uri.with({path:i.path}));const T=r.getWorkspaceFolder(i);if(!T)return;let F;if(u.isEqual(T.uri,i)?F="":F=u.relativePath(T.uri,i)??"",F&&(F=a.normalize(F)),P.folders.length>1&&!r.noPrefix){const U=T.name?T.name:u.basenameOrAuthority(T.uri);F=F?`${U} \u2022 ${F}`:U}return F}function I(i,r=R.isWindows){return(0,t.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let E=Object.create(null);function y(i,r,s=R.OS){if(s===1||!i||!r)return i;let a=E.original===r?E.normalized:void 0;a||(a=r,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,C.rtrim)(a,k.posix.sep)}${k.posix.sep}`,E={original:r,normalized:a});let u=i;return R.isWindows&&(u=(0,t.toSlashes)(u)),(s===3?u.startsWith(a):(0,C.startsWithIgnoreCase)(u,a))?`~/${u.substr(a.length)}`:i}e.tildify=y;function f(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=f;const h="\u2026",b="\\\\",w="~";function m(i,r=k.sep){const s=new Array(i.length);let a=!1;for(let u=0;u<i.length;u++){const P=i[u];if(P===""){s[u]=`.${r}`;continue}if(!P){s[u]=P;continue}a=!0;let M="",T=P;T.indexOf(b)===0?(M=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length)):T.indexOf(r)===0?(M=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(w)===0&&(M=T.substr(0,T.indexOf(w)+w.length),T=T.substr(T.indexOf(w)+w.length));const F=T.split(r);for(let U=1;a&&U<=F.length;U++)for(let Q=F.length-U;a&&Q>=0;Q--){a=!1;let re=F.slice(Q,Q+U).join(r);for(let le=0;!a&&le<i.length;le++)if(le!==u&&i[le]&&i[le].indexOf(re)>-1){const ue=Q+U===F.length,se=Q>0&&i[le].indexOf(r)>-1?r+re:re,de=i[le].endsWith(se);a=!ue||de}if(!a){let le="";(F[0].endsWith(":")||M!=="")&&(Q===1&&(Q=0,U++,re=F[0]+r+re),Q>0&&(le=F[0]+r),le=M+le),Q>0&&(le=le+h+r),le=le+re,Q+U<F.length&&(le=le+r+h),s[u]=le}}a&&(s[u]=P)}return s}e.shorten=m;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(i,r=Object.create(null)){const s=[];let a=!1,u="";for(const P of i)if(P==="$"||a&&P==="{")u&&s.push({value:u,type:v.TEXT}),u="",a=!0;else if(P==="}"&&a){const M=r[u];if(typeof M=="string")M.length&&s.push({value:M,type:v.VARIABLE});else if(M){const T=s[s.length-1];(!T||T.type!==v.SEPARATOR)&&s.push({value:M.label,type:v.SEPARATOR})}u="",a=!1}else u+=P;return u&&!a&&s.push({value:u,type:v.TEXT}),s.filter((P,M)=>{if(P.type===v.SEPARATOR){const T=s[M-1],F=s[M+1];return[T,F].every(U=>U&&(U.type===v.VARIABLE||U.type===v.TEXT)&&U.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=d;function p(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function c(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=c;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function o(i){const r=i.indexOf("/")!==-1?k.posix:k.win32,s=r.basename(i),a=r.dirname(i);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=o}),define(J[140],Z([0,1,7]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(I){return I.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const y=this._uriTransformer.transformIncoming(E);return y===E?E:t(S.URI.from(y))}transformOutgoing(E){const y=this._uriTransformer.transformOutgoing(E);return y===E?E:t(S.URI.from(y))}transformOutgoingURI(E){const y=this._uriTransformer.transformOutgoing(E);return y===E?E:S.URI.from(y)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,E,y){if(!I||y>200)return null;if(typeof I=="object"){if(I instanceof S.URI)return E.transformOutgoing(I);for(const f in I)if(Object.hasOwnProperty.call(I,f)){const h=R(I[f],E,y+1);h!==null&&(I[f]=h)}}return null}function D(I,E){const y=R(I,E,0);return y===null?I:y}e.transformOutgoingURIs=D;function C(I,E,y,f){if(!I||f>200)return null;if(typeof I=="object"){if(I.$mid===1)return y?S.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(const h in I)if(Object.hasOwnProperty.call(I,h)){const b=C(I[h],E,y,f+1);b!==null&&(I[h]=b)}}return null}function l(I,E){const y=C(I,E,!1,0);return y===null?I:y}e.transformIncomingURIs=l;function g(I,E){const y=C(I,E,!0,0);return y===null?I:y}e.transformAndReviveIncomingURIs=g}),define(J[81],Z([0,1,30,17,32,28,128]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const y=(0,S.networkInterfaces)();for(const f in y){const h=y[f];if(h)for(const{mac:b,internal:w}of h)w||(E+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let C;async function l(){return C||(C=(async()=>await g()||R.generateUuid())()),C}e.getMachineId=l;async function g(){try{const I=await new Promise((y,f)=>{q(["crypto"],y,f)}),E=(0,D.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){t.onUnexpectedError(I);return}}}),define(J[23],Z([0,1,29,30,141,8,31,80,9,4,16,7]),function(q,e,S,t,k,R,D,C,l,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function f(se,de=y.UNLINK){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return de===y.UNLINK?b(se):h(se)}async function h(se){try{const de=(0,D.randomPath)((0,t.tmpdir)());try{await S.promises.rename(se,de)}catch(K){return K.code==="ENOENT"?void 0:b(se)}b(de).catch(K=>{})}catch(de){if(de.code!=="ENOENT")throw de}}async function b(se){return(0,k.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function w(se){if((0,D.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function m(se,de){return p(await(de?v(se):(0,k.promisify)(S.readdir)(se)))}async function v(se){try{return await(0,k.promisify)(S.readdir)(se,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const de=[],K=await m(se);for(const $ of K){let _=!1,A=!1,W=!1;try{const z=await e.Promises.lstat((0,l.join)(se,$));_=z.isFile(),A=z.isDirectory(),W=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}de.push({name:$,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>W})}return de}function d(se){return p(S.readdirSync(se))}e.readdirSync=d;function p(se){return se.map(de=>typeof de=="string"?g.isMacintosh?(0,C.normalizeNFC)(de):de:(de.name=g.isMacintosh?(0,C.normalizeNFC)(de.name):de.name,de))}async function c(se){const de=await m(se),K=[];for(const $ of de)await o.existsDirectory((0,l.join)(se,$))&&K.push($);return K}function n(se,de=1e3){return new Promise(K=>{let $=!1;const _=setInterval(()=>{$||($=!0,S.access(se,A=>{$=!1,A&&(clearInterval(_),K(void 0))}))},de)})}e.whenDeleted=n;var o;(function(se){async function de(_){let A;try{if(A=await e.Promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(g.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw z}throw W}}se.stat=de;async function K(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isFile()&&W?.dangling!==!0}catch{}return!1}se.existsFile=K;async function $(_){try{const{stat:A,symbolicLink:W}=await se.stat(_);return A.isDirectory()&&W?.dangling!==!0}catch{}return!1}se.existsDirectory=$})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function r(se,de,K){return i.queueFor(E.URI.file(se),I.extUriBiasedIgnorePathCase).queue(()=>{const $=M(K);return new Promise((_,A)=>u(se,de,$,W=>W?A(W):_()))})}let s=!0;function a(se){s=se}e.configureFlushOnWrite=a;function u(se,de,K,$){if(!s)return S.writeFile(se,de,{mode:K.mode,flag:K.flag},$);S.open(se,K.flag,K.mode,(_,A)=>{if(_)return $(_);S.writeFile(A,de,W=>{if(W)return S.close(A,()=>$(W));S.fdatasync(A,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),a(!1)),S.close(A,ee=>$(ee))))})})}function P(se,de,K){const $=M(K);if(!s)return S.writeFileSync(se,de,{mode:$.mode,flag:$.flag});const _=S.openSync(se,$.flag,$.mode);try{S.writeFileSync(_,de);try{S.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),a(!1)}}finally{S.closeSync(_)}}e.writeFileSync=P;function M(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function T(se,de){if(se!==de)try{await e.Promises.rename(se,de)}catch(K){if(se.toLowerCase()!==de.toLowerCase()&&K.code==="EXDEV"||se.endsWith("."))await F(se,de,{preserveSymlinks:!1}),await f(se,y.MOVE);else throw K}}async function F(se,de,K){return Q(se,de,{root:{source:se,target:de},options:K,handledSourcePaths:new Set})}const U=511;async function Q(se,de,K){if(K.handledSourcePaths.has(se))return;K.handledSourcePaths.add(se);const{stat:$,symbolicLink:_}=await o.stat(se);if(_){if(K.options.preserveSymlinks)try{return await ue(se,de,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return $.isDirectory()?re(se,de,$.mode&U,K):le(se,de,$.mode&U)}async function re(se,de,K,$){await e.Promises.mkdir(de,{recursive:!0,mode:K});const _=await m(se);for(const A of _)await Q((0,l.join)(se,A),(0,l.join)(de,A),$)}async function le(se,de,K){await e.Promises.copyFile(se,de),await e.Promises.chmod(de,K)}async function ue(se,de,K){let $=await e.Promises.readlink(se);(0,D.isEqualOrParent)($,K.root.source,!g.isLinux)&&($=(0,l.join)(K.root.target,$.substr(K.root.source.length+1))),await e.Promises.symlink($,de)}e.Promises=new class{get access(){return(0,k.promisify)(S.access)}get stat(){return(0,k.promisify)(S.stat)}get lstat(){return(0,k.promisify)(S.lstat)}get utimes(){return(0,k.promisify)(S.utimes)}get read(){return(se,de,K,$,_)=>new Promise((A,W)=>{S.read(se,de,K,$,_,(z,ee,B)=>z?W(z):A({bytesRead:ee,buffer:B}))})}get readFile(){return(0,k.promisify)(S.readFile)}get write(){return(se,de,K,$,_)=>new Promise((A,W)=>{S.write(se,de,K,$,_,(z,ee,B)=>z?W(z):A({bytesWritten:ee,buffer:B}))})}get appendFile(){return(0,k.promisify)(S.appendFile)}get fdatasync(){return(0,k.promisify)(S.fdatasync)}get truncate(){return(0,k.promisify)(S.truncate)}get rename(){return(0,k.promisify)(S.rename)}get copyFile(){return(0,k.promisify)(S.copyFile)}get open(){return(0,k.promisify)(S.open)}get close(){return(0,k.promisify)(S.close)}get symlink(){return(0,k.promisify)(S.symlink)}get readlink(){return(0,k.promisify)(S.readlink)}get chmod(){return(0,k.promisify)(S.chmod)}get mkdir(){return(0,k.promisify)(S.mkdir)}get unlink(){return(0,k.promisify)(S.unlink)}get rmdir(){return(0,k.promisify)(S.rmdir)}get realpath(){return(0,k.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return c}get writeFile(){return r}get rm(){return f}get move(){return T}get copy(){return F}}}),define(J[96],Z([0,1,29,9,4,25,23]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(y){if(k.isLinux)return y;const f=(0,t.dirname)(y);if(y===f)return y;const h=((0,t.basename)(y)||y).toLowerCase();try{const w=(0,D.readdirSync)(f).filter(m=>m.toLowerCase()===h);if(w.length===1){const m=C(f);if(m)return(0,t.join)(m,w[0])}else if(w.length>1){const m=w.indexOf(h);if(m>=0){const v=C(f);if(v)return(0,t.join)(v,w[m])}}}catch{}return null}e.realcaseSync=C;async function l(y){if(k.isLinux)return y;const f=(0,t.dirname)(y);if(y===f)return y;const h=((0,t.basename)(y)||y).toLowerCase();try{const w=(await D.Promises.readdir(f)).filter(m=>m.toLowerCase()===h);if(w.length===1){const m=await l(f);if(m)return(0,t.join)(m,w[0])}else if(w.length>1){const m=w.indexOf(h);if(m>=0){const v=await l(f);if(v)return(0,t.join)(v,w[m])}}}catch{}return null}e.realcase=l;async function g(y){try{return await D.Promises.realpath(y)}catch{const h=E(y);return await D.Promises.access(h,S.constants.R_OK),h}}e.realpath=g;function I(y){try{return S.realpathSync(y)}catch{const h=E(y);return S.accessSync(h,S.constants.R_OK),h}}e.realpathSync=I;function E(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(J[142],Z([0,1,30,9,23]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var l;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(c,n,o){this.exePath=c,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function y({useAlternateBitness:p=!1}={}){return p?g===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:p=!1,findPreview:c=!1}={}){const n=y({useAlternateBitness:p});if(!n)return null;const o=t.join(n,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(o))return null;let i=-1,r=null;for(const u of await k.Promises.readdir(o)){let P=-1;if(c){const T=u.indexOf("-");if(T<0)continue;const F=u.substring(0,T);if(!R.test(F)||u.substring(T+1)!=="preview")continue;P=parseInt(F,10)}else{if(!R.test(u))continue;P=parseInt(u,10)}if(P<=i)continue;const M=t.join(o,u,"pwsh.exe");!await k.SymlinkSupport.existsFile(M)||(r=M,i=P)}if(!r)return null;const s=n.includes("x86")?" (x86)":"",a=c?" Preview":"";return new E(r,`PowerShell${a}${s}`,!0)}async function h({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const c=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=p?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(c))if(n.test(i)){const r=t.join(c,i,"pwsh.exe");return new E(r,o)}return null}function b(){const p=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new E(p,".NET Core PowerShell Global Tool")}function w(){const p=t.join(process.env.windir,g===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(p,"Windows PowerShell",!0)}async function*m(){let p=await f();p&&(yield p),p=await f({useAlternateBitness:!0}),p&&(yield p),p=await h(),p&&(yield p),p=b(),p&&(yield p),p=await f({findPreview:!0}),p&&(yield p),p=await h({findPreview:!0}),p&&(yield p),p=await f({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=w(),p&&(yield p)}async function*v(){for await(const p of m())await p.exists()&&(yield p)}e.enumeratePowerShellInstallations=v;async function d(){for await(const p of v())return p;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[82],Z([0,1,9,4,34,78,12,23]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function l(E=k.env){return E.comspec||"cmd.exe"}e.getWindowsShell=l;function g(E){let y=[],f=!1;const h=function(b){if(f){y.push(b);return}(!E.send(b,m=>{if(m&&console.error(m),f=!1,y.length>0){const v=y.slice(0);y=[],v.forEach(d=>h(d))}})||t.isWindows)&&(f=!0)};return{send:h}}e.createQueuedSender=g;var I;(function(E){async function y(f,h,b){if(S.isAbsolute(f))return f;if(h===void 0&&(h=k.cwd()),S.dirname(f)!=="."||(b===void 0&&D.isString(k.env.PATH)&&(b=k.env.PATH.split(S.delimiter)),b===void 0||b.length===0))return S.join(h,f);async function m(v){if(await C.Promises.exists(v)){let d;try{d=await C.Promises.stat(v)}catch(p){p.message.startsWith("EACCES")&&(d=await C.Promises.lstat(v))}return d?!d.isDirectory():!1}return!1}for(const v of b){let d;if(S.isAbsolute(v)?d=S.join(v,f):d=S.join(h,v,f),await m(d))return d;let p=d+".com";if(await m(p)||(p=d+".exe",await m(p)))return p}return S.join(h,f)}E.findExecutable=y})(I=e.win32||(e.win32={}))}),define(J[97],Z([0,1,50,13]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(D){return new Promise((C,l)=>{let g;const I=new Map;function E(f,h,b,w,m){const v=I.get(h);if(f===D||v){const d={name:y(b),cmd:b,pid:f,ppid:h,load:w,mem:m};I.set(f,d),f===D&&(g=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((p,c)=>p.pid-c.pid)))}}function y(f){const h=/--vscode-window-kind=shared-process/,b=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,p=/\\pipe\\winpty-control/,c=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(d.exec(f))return"electron-crash-reporter";if(p.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let o=n.exec(f);if(o&&o.length===2){if(o[1]==="renderer")return h.exec(f)?"shared-process":b.exec(f)?"issue-reporter":w.exec(f)?"process-explorer":"window";if(o[1]==="utility"){if(m.exec(f))return"utility-network-service";if(v.exec(f))return"extension-host"}return o[1]}const i=/[a-zA-Z-]+\.js/g;let r="";do o=i.exec(f),o&&(r+=o+" ");while(o);return r&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${r}`:f}if(process.platform==="win32"){const f=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,b)=>{q(["windows-process-tree"],h,b)}).then(h=>{h.getProcessList(D,b=>{if(!b){l(new Error(`Root process ${D} not found`));return}h.getProcessCpuUsage(b,w=>{const m=new Map;w.forEach(v=>{const d=f(v.commandLine||"");m.set(v.pid,{name:y(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),g=m.get(D),g?(m.forEach(v=>{const d=m.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((d,p)=>d.pid-p.pid))}),C(g)):l(new Error(`Root process ${D} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let f=function(){let h=[g];const b=[];for(;h.length;){const m=h.shift();m&&(b.push(m.pid),m.children&&(h=h.concat(m.children)))}let w=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);w+=" "+b.join(" "),(0,S.exec)(w,{},(m,v,d)=>{if(m||d)l(m||new Error(d.toString()));else{const p=v.toString().split(`
`);for(let c=0;c<b.length;c++){const n=I.get(b[c]);n.load=parseFloat(p[c])}if(!g){l(new Error(`Root process ${D} not found`));return}C(g)}})};(0,S.exec)("which ps",{},(h,b,w)=>{if(h||w)if(process.platform!=="linux")l(h||new Error(w.toString()));else{const m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,S.exec)(m,{},(v,d,p)=>{v||p?l(v||new Error(p.toString())):(R(d,E),f())})}else{const m=b.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,p,c)=>{d||c&&!c.includes("screen size is bogus")?l(d||new Error(c.toString())):(R(p,E),process.platform==="linux"?f():g?C(g):l(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=k;function R(D,C){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=D.toString().split(`
`);for(const I of g){const E=l.exec(I.trim());E&&E.length===6&&C(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(J[143],Z([0,1,30,4,142,82]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(f,h){return f===1?t.isWindows?E():R.getWindowsShell(h):g(f,h)}e.getSystemShell=D;function C(f,h){return f===1?t.isWindows?y(h):R.getWindowsShell(h):g(f,h)}e.getSystemShellSync=C;let l=null;function g(f,h){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!l){let b;if(t.isWindows)b="/bin/bash";else{if(b=h.SHELL,!b)try{b=(0,S.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}l=b}return l}let I=null;async function E(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function y(f){if(I)return I;const h=t.isWindows&&parseFloat((0,S.release)())>=10,b=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${f.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?w:R.getWindowsShell(f)}});var ve=this&&this.__decorate||function(q,e,S,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(q,e,S,t);else for(var C=q.length-1;C>=0;C--)(D=q[C])&&(R=(k<3?D(R):k>3?D(e,S,R):D(e,S))||R);return k>3&&R&&Object.defineProperty(e,S,R),R};define(J[45],Z([0,1,24,8,18,22,52,17,3,2,67,25,12]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function h(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function w(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(m||(m={}));class v{constructor(A){this.buffer=A,this.pos=0}read(A){const W=this.buffer.slice(this.pos,this.pos+A);return this.pos+=W.byteLength,W}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var p;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(p||(p={}));function c(_){const A=k.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function n(_){return _.read(4).readUInt32BE(0)}function o(_){const A=k.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const i={Undefined:o(p.Undefined),String:o(p.String),Buffer:o(p.Buffer),VSBuffer:o(p.VSBuffer),Array:o(p.Array),Object:o(p.Object)},r=typeof Buffer<"u";function s(_,A){if(typeof A>"u")_.write(i.Undefined);else if(typeof A=="string"){const W=k.VSBuffer.fromString(A);_.write(i.String),_.write(c(W.byteLength)),_.write(W)}else if(r&&Buffer.isBuffer(A)){const W=k.VSBuffer.wrap(A);_.write(i.Buffer),_.write(c(W.byteLength)),_.write(W)}else if(A instanceof k.VSBuffer)_.write(i.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(i.Array),_.write(c(A.length));for(const W of A)s(_,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(A));_.write(i.Object),_.write(c(W.byteLength)),_.write(W)}}function a(_){switch(_.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return _.read(n(_)).toString();case p.Buffer:return _.read(n(_)).buffer;case p.VSBuffer:return _.read(n(_));case p.Array:{const W=n(_),z=[];for(let ee=0;ee<W;ee++)z.push(a(_));return z}case p.Object:return JSON.parse(_.read(n(_)).toString())}}class u{constructor(A,W,z=null,ee=1e3){this.protocol=A,this.ctx=W,this.logger=z,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(A,W){this.channels.set(A,W),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const W=this.send([A.type]);this.logger?.logOutgoing(W,0,1,w(A.type));return}case 201:case 202:case 204:case 203:{const W=this.send([A.type,A.id],A.data);this.logger?.logOutgoing(W,A.id,1,w(A.type),A.data);return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onRawMessage(A){const W=new v(A),z=a(W),ee=a(W),B=z[0];switch(B){case 100:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}: ${z[2]}.${z[3]}`,ee),this.onPromise({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 102:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}: ${z[2]}.${z[3]}`,ee),this.onEventListen({type:B,id:z[1],channelName:z[2],name:z[3],arg:ee});case 101:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:z[1]});case 103:return this.logger?.logIncoming(A.byteLength,z[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:z[1]})}}onPromise(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=new R.CancellationTokenSource;let ee;try{ee=W.call(this.ctx,A.name,A.arg,z.token)}catch(L){ee=Promise.reject(L)}const B=A.id;ee.then(L=>{this.sendResponse({id:B,data:L,type:201}),this.activeRequests.delete(A.id)},L=>{L instanceof Error?this.sendResponse({id:B,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:B,data:L,type:203}),this.activeRequests.delete(A.id)});const j=(0,g.toDisposable)(()=>z.cancel());this.activeRequests.set(A.id,j)}onEventListen(A){const W=this.channels.get(A.channelName);if(!W){this.collectPendingRequest(A);return}const z=A.id,B=W.listen(this.ctx,A.name,A.arg)(j=>this.sendResponse({id:z,data:j,type:204}));this.activeRequests.set(A.id,B)}disposeActiveRequest(A){const W=this.activeRequests.get(A.id);W&&(W.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let W=this.pendingRequests.get(A.channelName);W||(W=[],this.pendingRequests.set(A.channelName,W));const z=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:A,timeoutTimer:z})}flushPendingRequests(A){const W=this.pendingRequests.get(A);if(W){for(const z of W)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var P;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(A,W=null){this.protocol=A,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=W}getChannel(A){const W=this;return{call(z,ee,B){return W.isDisposed?Promise.reject(new C.CancellationError):W.requestPromise(A,z,ee,B)},listen(z,ee){return W.isDisposed?l.Event.None:W.requestEvent(A,z,ee)}}}requestPromise(A,W,z,ee=R.CancellationToken.None){const B=this.lastRequestId++,L={id:B,type:100,channelName:A,name:W,arg:z};if(ee.isCancellationRequested)return Promise.reject(new C.CancellationError);let O;return new Promise((V,x)=>{if(ee.isCancellationRequested)return x(new C.CancellationError);const ne=()=>{const oe=ge=>{switch(ge.type){case 201:this.handlers.delete(B),V(ge.data);break;case 202:{this.handlers.delete(B);const Me=new Error(ge.data.message);Me.stack=ge.data.stack,Me.name=ge.data.name,x(Me);break}case 203:this.handlers.delete(B),x(ge.data);break}};this.handlers.set(B,oe),this.sendRequest(L)};let H=null;this.state===m.Idle?ne():(H=(0,t.createCancelablePromise)(oe=>this.whenInitialized()),H.then(()=>{H=null,ne()}));const te=()=>{H?(H.cancel(),H=null):this.sendRequest({id:B,type:101}),x(new C.CancellationError)},ie=ee.onCancellationRequested(te);O=(0,g.combinedDisposable)((0,g.toDisposable)(te),ie),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(A,W,z){const ee=this.lastRequestId++,j={id:ee,type:102,channelName:A,name:W,arg:z};let L=null;const O=new l.Emitter({onFirstListenerAdd:()=>{L=(0,t.createCancelablePromise)(V=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(O),this.sendRequest(j)})},onLastListenerRemove:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(O),this.sendRequest({id:ee,type:103}))}}),N=V=>O.fire(V.data);return this.handlers.set(ee,N),O.event}sendRequest(A){switch(A.type){case 100:case 102:{const W=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger?.logOutgoing(W,A.id,0,`${h(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const W=this.send([A.type,A.id]);this.logger?.logOutgoing(W,A.id,0,h(A.type));return}}}send(A,W=void 0){const z=new d;return s(z,A),s(z,W),this.sendBuffer(z.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch{return 0}}onBuffer(A){const W=new v(A),z=a(W),ee=a(W),B=z[0];switch(B){case 200:return this.logger?.logIncoming(A.byteLength,0,0,w(B)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(A.byteLength,z[1],0,w(B),ee),this.onResponse({type:z[0],id:z[1],data:ee})}}onResponse(A){if(A.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(A.id)?.(A)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,g.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:W,onDidClientDisconnect:z})=>{l.Event.once(W.onMessage)(B=>{const j=new v(B),L=a(j),O=new u(W,L),N=new M(W);this.channels.forEach((x,ne)=>O.registerChannel(ne,x));const V={channelServer:O,channelClient:N,ctx:L};this._connections.add(V),this._onDidAddConnection.fire(V),z(()=>{O.dispose(),N.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const A=[];return this._connections.forEach(W=>A.push(W)),A}getChannel(A,W){const z=this;return{call(ee,B,j){let L;if((0,y.isFunction)(W)){const N=(0,S.getRandomElement)(z.connections.filter(W));L=N?Promise.resolve(N):l.Event.toPromise(l.Event.filter(z.onDidAddConnection,W))}else L=W.routeCall(z,ee,B);const O=L.then(N=>N.channelClient.getChannel(A));return U(O).call(ee,B,j)},listen(ee,B){if((0,y.isFunction)(W))return z.getMulticastEvent(A,W,ee,B);const j=W.routeEvent(z,ee,B).then(L=>L.channelClient.getChannel(A));return U(j).listen(ee,B)}}}getMulticastEvent(A,W,z,ee){const B=this;let j=new g.DisposableStore;const L=new l.Emitter({onFirstListenerAdd:()=>{j=new g.DisposableStore;const O=new l.EventMultiplexer,N=new Map,V=ne=>{const te=ne.channelClient.getChannel(A).listen(z,ee),ie=O.add(te);N.set(ne,ie)},x=ne=>{const H=N.get(ne);!H||(H.dispose(),N.delete(ne))};B.connections.filter(W).forEach(V),l.Event.filter(B.onDidAddConnection,W)(V,void 0,j),B.onDidRemoveConnection(x,void 0,j),O.event(L.fire,L,j),j.add(O)},onLastListenerRemove:()=>{j.dispose()}});return L.event}registerChannel(A,W){this.channels.set(A,W),this._connections.forEach(z=>{z.channelServer.registerChannel(A,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class F{constructor(A,W,z=null){const ee=new d;s(ee,W),A.send(ee.buffer),this.channelClient=new M(A,z),this.channelServer=new u(A,W,z)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,W){this.channelServer.registerChannel(A,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function U(_){return{call(A,W,z){return _.then(ee=>ee.call(A,W,z))},listen(A,W){const z=new l.Relay;return _.then(ee=>z.input=ee.listen(A,W)),z.event}}}e.getDelayedChannel=U;function Q(_){let A=!1;return{call(W,z,ee){return A?_.call(W,z,ee):(0,t.timeout)(0).then(()=>A=!0).then(()=>_.call(W,z,ee))},listen(W,z){if(A)return _.listen(W,z);const ee=new l.Relay;return(0,t.timeout)(0).then(()=>A=!0).then(()=>ee.input=_.listen(W,z)),ee.event}}}e.getNextTickChannel=Q;class re{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const W of A.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await l.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=re;var le;(function(_){function A(B,j){const L=B,O=j&&j.disableMarshalling,N=new Map;for(const V in L)z(V)&&N.set(V,l.Event.buffer(L[V],!0));return new class{listen(V,x,ne){const H=N.get(x);if(H)return H;if(ee(x)){const te=L[x];if(typeof te=="function")return te.call(L,ne)}throw new Error(`Event not found: ${x}`)}call(V,x,ne){const H=L[x];if(typeof H=="function"){if(!O&&Array.isArray(ne))for(let te=0;te<ne.length;te++)ne[te]=(0,I.revive)(ne[te]);return H.apply(L,ne)}throw new Error(`Method not found: ${x}`)}}}_.fromService=A;function W(B,j){const L=j&&j.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return j?.properties?.has(N)?j.properties.get(N):ee(N)?function(V){return B.listen(N,V)}:z(N)?B.listen(N):async function(...V){let x;j&&!(0,y.isUndefinedOrNull)(j.context)?x=[j.context,...V]:x=V;const ne=await B.call(N,x);return L?ne:(0,I.revive)(ne)};throw new Error(`Property not found: ${String(N)}`)}})}_.toService=W;function z(B){return B[0]==="o"&&B[1]==="n"&&E.isUpperAsciiLetter(B.charCodeAt(2))}function ee(B){return/^onDynamic/.test(B)&&E.isUpperAsciiLetter(B.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const A=_.toString();if(A!=="[object Object]")return A}return _}function de(_){return Array.isArray(_)?_.map(se):se(_)}function K(_,A,W,z,ee,B,j){j=de(j);const L=ue[ee],O=L[z%L.length];let N=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(B)?(N=N.concat(j),N.push(")")):N.push(j),console.log.apply(console,N)}e.logWithColors=K;class ${constructor(A,W){this._outgoingPrefix=A,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,W,z,ee,B){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,W,z,ee,B)}logIncoming(A,W,z,ee,B){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,W,z,ee,B)}}e.IPCLogger=$}),define(J[144],Z([0,1,18,3,45]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(l){this.port=l,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",g=>S.VSBuffer.wrap(g.data)),l.start()}send(l){this.port.postMessage(l.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends k.IPCClient{constructor(l,g){const I=new R(l);super(I,g),this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=D}),define(J[98],Z([0,1,18,3,2,45]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let a=0;function u(M,T){if(!s.has(M)){const F=String(++a);s.set(M,F)}return s.get(M)}function P(M,T,F,U){if(!r.enableDiagnostics)return;const Q=u(M,T);if(U instanceof S.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const re=S.VSBuffer.alloc(U.byteLength);re.set(U),r.records.push({timestamp:Date.now(),id:Q,label:T,type:F,buff:re})}else r.records.push({timestamp:Date.now(),id:Q,label:T,type:F,data:U})}r.traceSocketEvent=P})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var l;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function I(){return g||(g=S.VSBuffer.alloc(0)),g}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const T=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),T}if(this._chunks[0].byteLength>s){const T=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),T}const u=S.VSBuffer.alloc(s);let P=0,M=0;for(;s>0;){const T=this._chunks[M];if(T.byteLength>s){const F=T.slice(0,s);u.set(F,P),P+=s,a&&(this._chunks[M]=T.slice(s),this._totalLength-=s),s-=s}else u.set(T,P),P+=T.byteLength,a?(this._chunks.shift(),this._totalLength-=T.byteLength):M++,s-=T.byteLength}return u}}e.ChunkStream=E;var y;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(s,a,u,P){this.type=s,this.id=a,this.ack=u,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,P=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new b(u,P,M,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=S.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(a,s.data)}_bufferAdd(s,a){const u=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,u}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends k.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new b(1,0,0,s))}}e.Protocol=v;class d extends R.IPCClient{constructor(s,a,u=null){super(s,a,u),this.protocol=s}static fromSocket(s,a){return new d(new v(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=d;class p{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=p;class c{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,a=this._first;for(;a;)a=a.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let a=0,u=this._first;for(;u;)s[a++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new c(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class o{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<o._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=o._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}load(){const s=Date.now(),a=(1+o._HISTORY_LENGTH)*1e3;let u=0;for(let P=0;P<o._HISTORY_LENGTH;P++)s-this.lastRuns[P]<=a&&u++;return 1-u/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class i{constructor(s,a=null,u=o.getInstance()){this._onControlMessage=new p,this.onControlMessage=this._onControlMessage.event,this._onMessage=new p,this.onMessage=this._onMessage.event,this._onDidDispose=new p,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new p,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new p,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(P=>this._receiveMessage(P))),this._socketDisposables.push(this._socket.onClose(P=>this._onSocketClose.fire(P))),a&&this._socketReader.acceptChunk(a),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new b(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new b(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new b(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,I());this._socketWriter.write(s);const a=this._outgoingUnackMsg.toArray();for(let u=0,P=a.length;u<P;u++)this._socketWriter.write(a[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new b(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let u=0,P=a.length;u<P;u++)this._socketWriter.write(a[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new b(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const a=new b(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,P=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&u>=2e4&&P>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:u});return}const M=Math.max(2e4-a,2e4-u,2e4-P,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},M)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,I());this._socketWriter.write(s)}_sendKeepAlive(){const s=new b(9,0,0,I());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(J[145],Z([0,1,40,18,3,2,45,130]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function l(I,E){const y=k.Event.fromNodeEventEmitter(S.validatedIpcMain,E,(h,b)=>({event:h,message:b})),f=k.Event.filter(y,({event:h})=>h.sender.id===I);return k.Event.map(f,({message:h})=>h&&t.VSBuffer.wrap(h))}class g extends D.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const E=k.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:y})=>y);return k.Event.map(E,y=>{const f=y.id;g.Clients.get(f)?.dispose();const b=new k.Emitter;g.Clients.set(f,(0,R.toDisposable)(()=>b.fire()));const w=l(f,"vscode:message"),m=k.Event.any(k.Event.signal(l(f,"vscode:disconnect")),b.event);return{protocol:new C.Protocol(y,w),onDidClientDisconnect:m}})}}e.Server=g,g.Clients=new Map}),define(J[99],Z([0,1,40,3,28,144]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(g,I){super({addEventListener:(E,y)=>g.addListener(E,y),removeEventListener:(E,y)=>g.removeListener(E,y),postMessage:E=>g.postMessage(E),start:()=>g.start(),close:()=>g.close()},I)}}e.Client=D;async function C(l){if(l.isDestroyed()||l.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,k.generateUuid)();l.webContents.send("vscode:createMessageChannel",g);const I=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:E}=await t.Event.toPromise(t.Event.once(t.Event.filter(I,y=>y.nonce===g)));return E}e.connect=C}),define(J[146],Z([0,1,50,8,18,22,139,17,3,2,49,82,78,45]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends f.ChannelServer{constructor(m){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",v=>k.VSBuffer.wrap(Buffer.from(v,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.Server=h;class b{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new t.Delayer(d),this.child=null,this._client=null}getChannel(m){const v=this;return{call(d,p,c){return v.requestPromise(m,d,p,c)},listen(d,p){return v.requestEvent(m,d,p)}}}requestPromise(m,v,d,p=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(m),n=(0,t.createCancelablePromise)(r=>c.call(v,d,r)),o=p.onCancellationRequested(()=>n.cancel()),i=(0,g.toDisposable)(()=>n.cancel());return this.activeRequests.add(i),n.finally(()=>{o.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(m,v,d){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let p;const c=new l.Emitter({onFirstListenerAdd:()=>{p=this.getCachedChannel(m).listen(v,d)(c.fire,c),this.activeRequests.add(p)},onLastListenerRemove:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,y.removeDangerousEnvVariables)(v.env),this.child=(0,S.fork)(this.modulePath,m,v);const d=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,D.isRemoteConsoleLog)(s)){(0,D.log)(s,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&c.send(s.buffer.toString("base64")),o=d.event,i={send:n,onMessage:o};this._client=new f.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,g.dispose)(u)),this.activeRequests.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:a})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=b}),define(J[83],Z([0,1,18,17,3,2,9,4,28,45,98]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:q.__$__nodeRequire("crypto"),zlib:q.__$__nodeRequire("zlib"),net:q.__$__nodeRequire("net"),os:q.__$__nodeRequire("os")}}class y{constructor(u,P=""){this.debugLabel=P,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,t.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,P){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const P=M=>{this.traceSocketEvent("read",M),u(S.VSBuffer.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(u){const P=M=>{this.traceSocketEvent("close",{hadError:M}),u({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(u){const P=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,t.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.NodeSocket=y;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class b extends R.Disposable{constructor(u,P,M,T){super(),this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this._flowManager=this._register(new w(this,P,M,T,this._onData,(F,U)=>this._write(F,U))),this._register(this._flowManager.onError(F=>{console.error(F),(0,t.onUnexpectedError)(F),this._onClose.fire({type:0,hadError:!0,error:F})})),this._incomingData=new I.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(F=>this._onClose.fire(F)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,P){this.socket.traceSocketEvent(u,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let M=2;u.byteLength<126?M+=0:u.byteLength<2**16?M+=2:M+=8;const T=S.VSBuffer.alloc(M);if(P?T.writeUInt8(194,0):T.writeUInt8(130,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let F=1;T.writeUInt8(u.byteLength>>>8&255,++F),T.writeUInt8(u.byteLength>>>0&255,++F)}else{T.writeUInt8(127,1);let F=1;T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(0,++F),T.writeUInt8(u.byteLength>>>24&255,++F),T.writeUInt8(u.byteLength>>>16&255,++F),T.writeUInt8(u.byteLength>>>8&255,++F),T.writeUInt8(u.byteLength>>>0&255,++F)}this.socket.write(S.VSBuffer.concat([T,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),M=P.readUInt8(0),T=(M&128)>>>7,F=(M&64)>>>6,U=P.readUInt8(1),Q=(U&128)>>>7,re=U&127;this._state.state=2,this._state.readLen=2+(Q?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(F)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),M=P.readUInt8(1),T=(M&128)>>>7;let F=M&127,U=1;F===126?F=P.readUInt8(++U)*2**8+P.readUInt8(++U):F===127&&(F=P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*0+P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U));let Q=0;T&&(Q=P.readUInt8(++U)*2**24+P.readUInt8(++U)*2**16+P.readUInt8(++U)*2**8+P.readUInt8(++U)),this._state.state=3,this._state.readLen=F,this._state.mask=Q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),d(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class w extends R.Disposable{constructor(u,P,M,T,F,U){super(),this._tracer=u,this._onData=F,this._writeFn=U,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new m(this._tracer,T,M,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(Q=>this._onError.fire(Q))),this._register(this._zlibDeflateStream.onError(Q=>this._onError.fire(Q)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:S.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(P,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,P){return new Promise((M,T)=>{u.write(P),u.flush(F=>M(F))})}acceptFrame(u,P,M){this._readQueue.push({data:u,isCompressed:P,isLastFrameOfMessage:M}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,P,M){return new Promise((T,F)=>{u.write(P),M&&u.write(S.VSBuffer.fromByteArray([0,0,255,255])),u.flush(U=>T(U))})}}class m extends R.Disposable{constructor(u,P,M,T){super(),this._tracer=u,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=E().zlib.createInflateRaw(T),this._zlibInflate.on("error",F=>{this._tracer.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this._onError.fire(F)}),this._zlibInflate.on("data",F=>{this._tracer.traceSocketEvent("zlibInflateData",F),this._pendingInflateData.push(S.VSBuffer.wrap(F))}),M&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this._zlibInflate.write(M.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.concat(this._recordedInflateBytes):S.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=S.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(P)})}}class v extends R.Disposable{constructor(u,P){super(),this._tracer=u,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=E().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",M=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibDeflate.on("data",M=>{this._tracer.traceSocketEvent("zlibDeflateData",M),this._pendingDeflateData.push(S.VSBuffer.wrap(M))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=S.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),u(P)})}}function d(a,u){if(u===0)return;const P=a.byteLength>>>2;for(let re=0;re<P;re++){const le=a.readUInt32BE(re*4);a.writeUInt32BE(le^u,re*4)}const M=P*4,T=a.byteLength-M,F=u>>>24&255,U=u>>>16&255,Q=u>>>8&255;T>=1&&a.writeUInt8(a.readUInt8(M)^F,M),T>=2&&a.writeUInt8(a.readUInt8(M+1)^U,M+1),T>=3&&a.writeUInt8(a.readUInt8(M+2)^Q,M+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function c(){const a=(0,l.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,D.join)(E().os.tmpdir(),`vscode-ipc-${a}.sock`),o(u),u}e.createRandomIPCHandle=c;function n(a,u,P){const M=E().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${u}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${M.substr(0,8)}-${P}-${u}.sock`):T=(0,D.join)(a,`${P}-${u}.sock`),o(T),T}e.createStaticIPCHandle=n;function o(a){const u=p[C.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends g.IPCServer{constructor(u){super(i.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const P=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(P,M=>({protocol:new I.Protocol(new y(M,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(M,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(a){return new Promise((u,P)=>{const M=E().net.createServer();M.on("error",P),M.listen(a,()=>{M.removeListener("error",P),u(new i(M))})})}e.serve=r;function s(a,u){return new Promise((P,M)=>{const T=E().net.createConnection(a,()=>{T.removeListener("error",M),P(I.Client.fromSocket(new y(T,`ipc-client${u}`),u))});T.once("error",M)})}e.connect=s}),define(J[100],Z([0,1,8,3,2,12]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function C(E){const y=E;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var l;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(l=e.StorageState||(e.StorageState={}));class g extends k.Disposable{constructor(y,f=Object.create(null)){super(),this.database=y,this.options=f,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new S.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((f,h)=>this.accept(h,f)),y.deleted?.forEach(f=>this.accept(f,void 0))}accept(y,f){if(this.state===l.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(f)?h=this.cache.delete(y):this.cache.get(y)!==f&&(this.cache.set(y,f),h=!0),h&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,f){const h=this.cache.get(y);return(0,R.isUndefinedOrNull)(h)?f:h}getBoolean(y,f){const h=this.get(y);return(0,R.isUndefinedOrNull)(h)?f:h==="true"}getNumber(y,f){const h=this.get(y);return(0,R.isUndefinedOrNull)(h)?f:parseInt(h,10)}async set(y,f){if(this.state===l.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(y);const h=String(f);if(this.cache.get(y)!==h)return this.cache.set(y,h),this.pendingInserts.set(y,h),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async delete(y){if(!(this.state===l.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(y){if(!!this.hasPending)return this.doFlush(y)}async doFlush(y){return this.flushDelayer.trigger(()=>this.flushPending(),y)}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert?.forEach((f,h)=>this.items.set(h,f)),y.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=I}),define(J[147],Z([0,1,8,3,32,9,23]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{constructor(I,E=Object.create(null)){this.path=I,this.options=E,this.name=(0,R.basename)(this.path),this.logger=new l(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const I=await this.whenConnected,E=new Map;return(await this.all(I,"SELECT * FROM ItemTable")).forEach(f=>E.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(I){const E=await this.whenConnected;return this.doUpdateItems(E,I)}doUpdateItems(I,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,k.mapToString)(E.insert):"0"}), delete(${E.delete?(0,k.setToString)(E.delete):"0"})`),this.transaction(I,()=>{const y=E.insert,f=E.delete;if(y&&y.size>0){const h=[];h.push([]);let b=0;y.forEach((w,m)=>{let v=h[b];v.length>C.MAX_HOST_PARAMETERS&&(b++,v=[],h.push(v)),v.push(m,w)}),h.forEach(w=>{this.prepare(I,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,m=>m.run(w),()=>{const m=[];let v=0;return y.forEach((d,p)=>{m.push(p),v+=d.length}),`Keys: ${m.join(", ")} Length: ${v}`})})}if(f&&f.size){const h=[];h.push([]);let b=0;f.forEach(w=>{let m=h[b];m.length>C.MAX_HOST_PARAMETERS&&(b++,m=[],h.push(m)),m.push(w)}),h.forEach(w=>{this.prepare(I,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,m=>m.run(w),()=>{const m=[];return f.forEach(v=>{m.push(v)}),`Keys: ${m.join(", ")}`})})}})}async close(I){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,I)}doClose(I,E){return new Promise((y,f)=>{I.db.close(h=>(h&&this.handleSQLiteError(I,`[storage ${this.name}] close(): ${h}`),this.path===C.IN_MEMORY_PATH?y():!I.isErroneous&&!I.isInMemory?this.backup().then(y,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),y())):typeof E=="function"?D.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const w=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:E()}).then(()=>w(),m=>(w(),Promise.reject(m)))})).then(y,f):f(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const I=this.toBackupPath(this.path);return D.Promises.copy(this.path,I,{preserveSymlinks:!1})}toBackupPath(I){return`${I}.backup`}async checkIntegrity(I){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${I})`);const E=await this.whenConnected,y=await this.get(E,I?"PRAGMA integrity_check":"PRAGMA quick_check"),f=I?y.integrity_check:y.quick_check;return E.isErroneous?`${f} (last error: ${E.lastError})`:E.isInMemory?`${f} (in-memory!)`:f}async connect(I,E=!0){this.logger.trace(`[storage ${this.name}] open(${I}, retryOnBusy: ${E})`);try{return await this.doConnect(I)}catch(y){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&E)return await(0,S.timeout)(C.BUSY_OPEN_TIMEOUT),this.connect(I,!1);try{await D.Promises.unlink(I);try{await D.Promises.rename(this.toBackupPath(I),I)}catch{}return await this.doConnect(I)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(C.IN_MEMORY_PATH)}}}handleSQLiteError(I,E){I.isErroneous=!0,I.lastError=E,this.logger.error(E)}doConnect(I){return new Promise((E,y)=>{new Promise((f,h)=>{q(["@vscode/sqlite3"],f,h)}).then(f=>{const h={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(I,b=>b?h.db&&b.code!=="SQLITE_CANTOPEN"?h.db.close(()=>y(b)):y(b):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(h),w=>h.db.close(()=>y(w)))),isInMemory:I===C.IN_MEMORY_PATH};h.db.on("error",b=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&h.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},y)})}exec(I,E){return new Promise((y,f)=>{I.db.exec(E,h=>h?(this.handleSQLiteError(I,`[storage ${this.name}] exec(): ${h}`),f(h)):y())})}get(I,E){return new Promise((y,f)=>{I.db.get(E,(h,b)=>h?(this.handleSQLiteError(I,`[storage ${this.name}] get(): ${h}`),f(h)):y(b))})}all(I,E){return new Promise((y,f)=>{I.db.all(E,(h,b)=>h?(this.handleSQLiteError(I,`[storage ${this.name}] all(): ${h}`),f(h)):y(b))})}transaction(I,E){return new Promise((y,f)=>{I.db.serialize(()=>{I.db.run("BEGIN TRANSACTION"),E(),I.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(I,`[storage ${this.name}] transaction(): ${h}`),f(h)):y())})})}prepare(I,E,y,f){const h=I.db.prepare(E),b=w=>{this.handleSQLiteError(I,`[storage ${this.name}] prepare(): ${w} (${E}). Details: ${f()}`)};h.on("error",b),y(h),h.finalize(w=>{w&&b(w),h.removeListener("error",b)})}}e.SQLiteStorageDatabase=C,C.IN_MEMORY_PATH=":memory:",C.BUSY_OPEN_TIMEOUT=2e3,C.MAX_HOST_PARAMETERS=256;class l{constructor(I){I&&typeof I.logTrace=="function"&&process.env[l.VSCODE_TRACE_STORAGE]&&(this.logTrace=I.logTrace),I&&typeof I.logError=="function"&&(this.logError=I.logError)}get isTracing(){return!!this.logTrace}trace(I){this.logTrace?.(I)}error(I){this.logError?.(I)}}l.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[148],Z([11,10]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[149],Z([11,10]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[150],Z([11,10]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[151],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[152],Z([11,10]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[153],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[154],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(J[155],Z([11,10]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(J[156],Z([11,10]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[157],Z([11,10]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[158],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[159],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[160],Z([11,10]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[161],Z([11,10]),function(q,e){return q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(J[162],Z([11,10]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[163],Z([11,10]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[164],Z([11,10]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[165],Z([11,10]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[166],Z([11,10]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[167],Z([11,10]),function(q,e){return q.create("vs/platform/shell/node/shellEnv",e)}),define(J[168],Z([11,10]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[169],Z([11,10]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[170],Z([11,10]),function(q,e){return q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(J[171],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(J[172],Z([11,10]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[173],Z([11,10]),function(q,e){return q.create("vs/platform/workspace/common/workspace",e)}),define(J[174],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[175],Z([11,10]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[176],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(J[177],Z([0,1,7]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(D){let C=[];try{Array.isArray(D.rootURIWorkspaces)&&(C=D.rootURIWorkspaces.map(l=>({workspace:{id:l.id,configPath:S.URI.parse(l.configURIPath)},remoteAuthority:l.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=k;function R(D){let C=[];try{Array.isArray(D.folderWorkspaceInfos)&&(C=D.folderWorkspaceInfos.map(l=>({folderUri:S.URI.parse(l.folderUri),remoteAuthority:l.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=R}),define(J[178],Z([0,1,3,2]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new S.Emitter,this._onReloadEmitter=new S.Emitter,this._onTerminateEmitter=new S.Emitter,this._onAttachEmitter=new S.Emitter}call(C,l,g){switch(l){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(C,l,g){switch(l){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(C){super(),this.channel=C}reload(C){this.channel.call("reload",[C])}get onReload(){return this.channel.listen("reload")}close(C){this.channel.call("close",[C])}get onClose(){return this.channel.listen("close")}attachSession(C,l,g){this.channel.call("attach",[C,l,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(C,l){this.channel.call("terminate",[C,l])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(C,l){return this.channel.call("openExtensionDevelopmentHostWindow",[C,l])}}e.ExtensionHostDebugChannelClient=R}),define(J[179],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class S{constructor(k){this.machineId=k}encryption(){return new Promise((k,R)=>q(["vscode-encrypt"],k,R))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch{return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch{return k}}}e.EncryptionMainService=S}),define(J[180],Z([0,1,133,52,13,9,34,16,7]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(b,w,m){this._args=b,this.paths=w,this.productService=m,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return l.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(l.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=D.env.VSCODE_PORTABLE;return b?l.URI.file((0,R.join)(b,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,R.resolve)(b):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,R.resolve)(b):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,R.resolve)(b);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(w=>/^[^:/?#]+?:\/\//.test(w)?l.URI.parse(w):l.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?l.URI.parse(b):l.URI.file((0,R.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return l.URI.file((0,R.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const b=D.env.VSCODE_PORTABLE;return b?l.URI.file((0,R.join)(b,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ve([t.memoize],g.prototype,"appRoot",null),ve([t.memoize],g.prototype,"userHome",null),ve([t.memoize],g.prototype,"userDataPath",null),ve([t.memoize],g.prototype,"appSettingsHome",null),ve([t.memoize],g.prototype,"tmpDir",null),ve([t.memoize],g.prototype,"cacheHome",null),ve([t.memoize],g.prototype,"stateResource",null),ve([t.memoize],g.prototype,"userRoamingDataHome",null),ve([t.memoize],g.prototype,"userDataSyncHome",null),ve([t.memoize],g.prototype,"userDataSyncLogResource",null),ve([t.memoize],g.prototype,"editSessionsLogResource",null),ve([t.memoize],g.prototype,"sync",null),ve([t.memoize],g.prototype,"machineSettingsResource",null),ve([t.memoize],g.prototype,"workspaceStorageHome",null),ve([t.memoize],g.prototype,"localHistoryHome",null),ve([t.memoize],g.prototype,"keyboardLayoutResource",null),ve([t.memoize],g.prototype,"argvResource",null),ve([t.memoize],g.prototype,"isExtensionDevelopment",null),ve([t.memoize],g.prototype,"untitledWorkspacesHome",null),ve([t.memoize],g.prototype,"installSourcePath",null),ve([t.memoize],g.prototype,"builtinExtensionsPath",null),ve([t.memoize],g.prototype,"extensionsPath",null),ve([t.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ve([t.memoize],g.prototype,"extensionDevelopmentKind",null),ve([t.memoize],g.prototype,"extensionTestsLocationURI",null),ve([t.memoize],g.prototype,"debugExtensionHost",null),ve([t.memoize],g.prototype,"serviceMachineIdResource",null),ve([t.memoize],g.prototype,"telemetryLogResource",null),ve([t.memoize],g.prototype,"disableWorkspaceTrust",null),ve([t.memoize],g.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=g;function I(h,b){return f(h["inspect-extensions"],h["inspect-brk-extensions"],5870,b,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function E(h,b){return f(h["inspect-search"],h["inspect-brk-search"],5876,b,h.extensionEnvironment)}e.parseSearchPort=E;function y(h,b){return f(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,b,h.extensionEnvironment)}e.parsePtyHostPort=y;function f(h,b,w,m,v,d){const c=Number(b||h)||(m?null:w),n=c?Boolean(!!b):!1;let o;if(d)try{o=JSON.parse(d)}catch{}return{port:c,break:n,debugId:v,env:o}}}),define(J[101],Z([0,1,272,4,151]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,k.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},category:{type:"string",cat:"e",description:(0,k.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(h,b,w=D){const m={},v=["_"],d=[];for(const o in b){const i=b[o];i.alias&&(m[o]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(o),i.deprecates&&v.push(...i.deprecates)):i.type==="boolean"&&(d.push(o),i.deprecates&&d.push(...i.deprecates))}const p=S(h,{string:v,boolean:d,alias:m}),c={},n=p;c._=p._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in b){const i=b[o];i.alias&&delete n[i.alias];let r=n[o];if(i.deprecates)for(const s of i.deprecates)n.hasOwnProperty(s)&&(r||(r=n[s],r&&w.onDeprecatedOption(s,i.deprecationMessage||(0,k.localize)(35,null,o))),delete n[s]);if(typeof r<"u"){if(i.type==="string[]"){if(Array.isArray(r)||(r=[r]),!i.allowEmptyValue){const s=r.filter(a=>a.length>0);s.length!==r.length&&(w.onEmptyValue(o),r=s.length>0?s:void 0)}}else i.type==="string"&&(Array.isArray(r)?(r=r.pop(),w.onMultipleValues(o,r)):!r&&!i.allowEmptyValue&&(w.onEmptyValue(o),r=void 0));c[o]=r,i.deprecationMessage&&w.onDeprecatedOption(o,i.deprecationMessage)}delete n[o]}for(const o in n)w.onUnknownOption(o);return c}e.parseArgs=C;function l(h,b){let w="";return b.args&&(Array.isArray(b.args)?w=` <${b.args.join("> <")}>`:w=` <${b.args}>`),b.alias?`-${b.alias} --${h}${w}`:`--${h}${w}`}function g(h,b){let w=0;const m=[];for(const c in h){const n=h[c],o=l(c,n);w=Math.max(w,o.length),m.push([o,n.description])}const v=w+2+1;if(b-v<25)return m.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const d=b-v-1,p=[];for(const c of m){const n=c[0],o=E(c[1],d),i=I(v-n.length-2);p.push("  "+n+i+o[0]);for(let r=1;r<o.length;r++)p.push(I(v)+o[r])}return p}e.formatOptions=g;function I(h){return" ".repeat(h)}function E(h,b){const w=[];for(;h.length;){const m=h.length<b?h.length:h.lastIndexOf(" ",b),v=h.slice(0,m).trim();h=h.slice(m),w.push(v)}return w}function y(h,b,w,m,v){const d=process.stdout.isTTY&&process.stdout.columns||80,p=v?.noInputFiles!==!0?`[${(0,k.localize)(36,null)}...]`:"",c=[`${h} ${w}`];c.push(""),c.push(`${(0,k.localize)(37,null)}: ${b} [${(0,k.localize)(38,null)}]${p}`),c.push(""),v?.noPipe!==!0&&(t.isWindows?c.push((0,k.localize)(39,null,b)):c.push((0,k.localize)(40,null,b)),c.push(""));const n={};for(const o in m){const i=m[o];if(i.description&&i.cat){let r=n[i.cat];r||(n[i.cat]=r={}),r[o]=i}}for(const o in n){const i=o,r=n[i];r&&(c.push(R[i]),c.push(...g(r,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=y;function f(h,b){return`${h||(0,k.localize)(41,null)}
${b||(0,k.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=f}),define(J[181],Z([0,1,77,178,101]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(C,l){super(),this.windowsMainService=C,this.userDataProfilesMainService=l}call(C,l,g){return l==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1]):super.call(C,l,g)}async openExtensionDevelopmentHostWindow(C,l){const g=(0,k.parseArgs)(C,k.OPTIONS);g.debugRenderer=l;const I=g.extensionDevelopmentPath;if(!I)return{success:!1};const E=this.userDataProfilesMainService.checkAndCreateProfileFromCli(g),y=E?await E:void 0,[f]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:g,profile:y});if(!l)return{success:!0};const h=f.win;if(!h)return{success:!0};const b=h.webContents.debugger;let w=b.isAttached()?1/0:0;const m=(0,S.createServer)(v=>{w++===0&&b.attach();let d=!1;const p=o=>{d||v.write(JSON.stringify(o)+"\0")},c=(o,i,r,s)=>p({method:i,params:r,sessionId:s});h.on("close",()=>{b.removeListener("message",c),v.end(),d=!0}),b.addListener("message",c);let n=Buffer.alloc(0);v.on("data",o=>{n=Buffer.concat([n,o]);for(let i=n.indexOf(0);i!==-1;i=n.indexOf(0)){let r;try{const s=n.slice(0,i).toString("utf8");n=n.slice(i+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}b.sendCommand(r.method,r.params,r.sessionId).then(s=>p({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>p({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),v.on("error",o=>{console.error("error on cdp pipe:",o)}),v.on("close",()=>{d=!0,--w===0&&b.detach()})});return await new Promise(v=>m.listen(0,v)),h.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(J[59],Z([0,1,273,152,101]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(y,f){const h={onUnknownOption:w=>{console.warn((0,t.localize)(0,null,w))},onMultipleValues:(w,m)=>{console.warn((0,t.localize)(1,null,w,m))},onEmptyValue:w=>{console.warn((0,t.localize)(2,null,w))},onDeprecatedOption:(w,m)=>{console.warn((0,t.localize)(3,null,w,m))}},b=(0,k.parseArgs)(y,k.OPTIONS,f?h:void 0);return b.goto&&b._.forEach(w=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,t.localize)(4,null))),b["max-memory"]&&S(parseInt(b["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),b}function C(y){const f=y.findIndex(h=>!/^-/.test(h));if(f>-1)return[...y.slice(0,f),...y.slice(f+1)]}function l(y){let[,...f]=y;process.env.VSCODE_DEV&&(f=C(f)||[]);const h=!E(process.env);return D(f,h)}e.parseMainProcessArgv=l;function g(y){const[,,...f]=y;return D(f,!0)}e.parseCLIProcessArgv=g;function I(y,...f){const h=y.indexOf("--");return h===-1?y.push(...f):y.splice(h,0,...f),y}e.addArg=I;function E(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function q(e,S,t,k){function R(C){const l=D(C),g=[l];return e.isAbsolute(l)||g.unshift(k),e.resolve(...g)}function D(C){const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,t);const I=C["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(E,"AppData","Roaming")}break;case"darwin":g=e.join(S.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,t)}return{getUserDataPath:R}}if(typeof define=="function")define(J[182],Z([0,274,30,13,16,34]),function(e,S,t,k,R,D){const C=R.dirname(k.FileAccess.asFileUri("",e)),l=e.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return q(S,t,l.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),t=require("os");module.exports=q(S,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[183],Z([0,1,30,180,182]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(C,l){super(C,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,k.getUserDataPath)(C)},l)}}e.NativeEnvironmentService=R}),define(J[184],Z([0,1,29,30,31]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(D){const C=(0,k.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(C,""),D&&console.log(`Marker file for --wait created: ${C}`),C}catch(l){D&&console.error(`Failed to create marker file for --wait: ${l}`);return}}e.createWaitMarkerFile=R}),define(J[185],Z([0,1,12,154]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(D,C,l){try{R(D,C,l)}catch{}return D}e.localizeManifest=k;function R(D,C,l){const g=(I,E,y)=>{const f=I[E];if((0,S.isString)(f)){const h=f,b=h.length;if(b>1&&h[0]==="%"&&h[b-1]==="%"){const w=h.substr(1,b-2);let m=C[w];m===void 0&&l&&(m=l[w]);const v=typeof m=="string"?m:m.message;if(v!==void 0){const d=l?.[w],p=typeof d=="string"?d:d?.message;if(y&&(E==="title"||E==="category")&&p&&p!==v){const c={value:v,original:p};I[E]=c}else I[E]=v}else console.warn(`[${D.name}]: ${(0,t.localize)(0,null,w)}`)}}else if((0,S.isObject)(f))for(const h in f)f.hasOwnProperty(h)&&(h==="commands"?g(f,h,!0):g(f,h,y));else if(Array.isArray(f))for(let h=0;h<f.length;h++)g(f,h,y)};for(const I in D)D.hasOwnProperty(I)&&g(D,I)}}),define(J[186],Z([0,1,16,94,156,187]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function l(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=l;function g(m){if(!l(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=m.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=g;function I(m){if(!m)return null;const v=m.majorBase,d=m.majorMustEqual,p=m.minorBase;let c=m.minorMustEqual;const n=m.patchBase;let o=m.patchMustEqual;m.hasCaret&&(v===0||(c=!1),o=!1);let i=0;if(m.preRelease){const r=C.exec(m.preRelease);if(r){const[,s,a,u]=r;i=Date.UTC(Number(s),Number(a)-1,Number(u))}}return{majorBase:v,majorMustEqual:d,minorBase:p,minorMustEqual:c,patchBase:n,patchMustEqual:o,isMinimum:m.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function E(m,v,d){let p;typeof m=="string"?p=I(g(m)):p=m;let c;v instanceof Date?c=v.getTime():typeof v=="string"&&(c=new Date(v).getTime());let n;if(typeof d=="string"?n=I(g(d)):n=d,!p||!n)return!1;const o=p.majorBase,i=p.minorBase,r=p.patchBase;let s=n.majorBase,a=n.minorBase,u=n.patchBase;const P=n.notBefore;let M=n.majorMustEqual,T=n.minorMustEqual,F=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:i>a?!0:i<a||c&&c<P?!1:r>=u:(o===1&&s===0&&(!M||!T||!F)&&(s=1,a=0,u=0,M=!0,T=!1,F=!1),o<s?!1:o>s?!M:i<a?!1:i>a?!T:r<u?!1:r>u?!F:!(c&&c<P))}e.isValidVersion=E;function y(m,v,d,p,c){const n=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return n.push([t.default.Error,k.localize(0,null)]),n;if(typeof p.name!="string")return n.push([t.default.Error,k.localize(1,null,"name")]),n;if(typeof p.version!="string")return n.push([t.default.Error,k.localize(2,null,"version")]),n;if(!p.engines)return n.push([t.default.Error,k.localize(3,null,"engines")]),n;if(typeof p.engines.vscode!="string")return n.push([t.default.Error,k.localize(4,null,"engines.vscode")]),n;if(typeof p.extensionDependencies<"u"&&!w(p.extensionDependencies))return n.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),n;if(typeof p.activationEvents<"u"){if(!w(p.activationEvents))return n.push([t.default.Error,k.localize(6,null,"activationEvents")]),n;if(typeof p.main>"u"&&typeof p.browser>"u")return n.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),n}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&n.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return n.push([t.default.Error,k.localize(9,null,"main")]),n;{const r=(0,S.joinPath)(d,p.main);(0,S.isEqualOrParent)(r,d)||n.push([t.default.Warning,k.localize(10,null,r.path,d.path)])}if(typeof p.activationEvents>"u")return n.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),n}if(typeof p.browser<"u"){if(typeof p.browser!="string")return n.push([t.default.Error,k.localize(12,null,"browser")]),n;{const r=(0,S.joinPath)(d,p.browser);(0,S.isEqualOrParent)(r,d)||n.push([t.default.Warning,k.localize(13,null,r.path,d.path)])}if(typeof p.activationEvents>"u")return n.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(p.version))return n.push([t.default.Error,k.localize(15,null)]),n;const o=[];if(!f(m,v,p,c,o))for(const r of o)n.push([t.default.Error,r]);return n}e.validateExtensionManifest=y;function f(m,v,d,p,c){return p||typeof d.main>"u"&&typeof d.browser>"u"?!0:b(m,v,d.engines.vscode,c)}e.isValidExtensionVersion=f;function h(m,v,d){return m==="*"||b(v,d,m)}e.isEngineValid=h;function b(m,v,d,p=[]){const c=I(g(d));if(!c)return p.push(k.localize(16,null,d)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return p.push(k.localize(17,null,d)),!1}else if(!c.majorMustEqual)return p.push(k.localize(18,null,d)),!1;return E(m,v,c)?!0:(p.push(k.localize(19,null,m,d)),!1)}function w(m){if(!Array.isArray(m))return!1;for(let v=0,d=m.length;v<d;v++)if(typeof m[v]!="string")return!1;return!0}}),define(J[188],Z([0,1,18,28]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,D,C){let l=C&&C.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const I=(await D.readFile(R.serviceMachineIdResource)).value.toString();l=(0,t.isUUID)(I)?I:null}catch{l=null}if(!l){l=(0,t.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(l))}catch{}}return C?.store("storage.serviceMachineId",l,-1,1),l}e.getServiceMachineId=k}),define(J[68],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(k,R=[],D=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=S}),define(J[189],Z([0,1,68]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(C,l,g){l instanceof S.SyncDescriptor||(l=new S.SyncDescriptor(l,[],Boolean(g))),t.push([C,l])}e.registerSingleton=R;function D(){return t}e.getSingletonServiceDescriptors=D}),define(J[190],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const C=this.lookupOrInsertNode(R),l=this.lookupOrInsertNode(D);C.outgoing.set(l.key,l),l.incoming.set(C.key,C)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(const C of this._nodes.values())C.outgoing.delete(D),C.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let C=this._nodes.get(D);return C||(C=new S(D,R),this._nodes.set(D,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[D,C]of this._nodes)R.push(`${D}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this._nodes){const C=new Set([R]),l=this._findCycle(D,C);if(l)return l}}_findCycle(R,D){for(const[C,l]of R.outgoing){if(D.has(C))return[...D,C].join(" -> ");D.add(C);const g=this._findCycle(l,D);if(g)return g;D.delete(C)}}}e.Graph=t}),define(J[5],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function C(l){return l[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=C})(S=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(D,C,l){C[S.DI_TARGET]===C?C[S.DI_DEPENDENCIES].push({id:D,index:l}):(C[S.DI_DEPENDENCIES]=[{id:D,index:l}],C[S.DI_TARGET]=C)}function k(D){if(S.serviceIds.has(D))return S.serviceIds.get(D);const C=function(l,g,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,l,I)};return C.toString=()=>D,S.serviceIds.set(D,C),C}e.createDecorator=k;function R(D){return D}e.refineServiceDecorator=R}),define(J[60],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(J[19],Z([0,1,12,7,5]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=R;function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var C;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function l(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=l;function g(m,v){const d=Object.create(null);for(const p in m)I(d,p,m[p],v);return d}e.toValuesTree=g;function I(m,v,d,p){const c=v.split("."),n=c.pop();let o=m;for(let i=0;i<c.length;i++){const r=c[i];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:p(`Ignoring ${v} as ${c.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=d}catch{p(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${v} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=I;function E(m,v){const d=v.split(".");y(m,d)}e.removeFromValueTree=E;function y(m,v){const d=v.shift();if(v.length===0){delete m[d];return}if(Object.keys(m).indexOf(d)!==-1){const p=m[d];typeof p=="object"&&!Array.isArray(p)&&(y(p,v),Object.keys(p).length===0&&delete m[d])}}function f(m,v,d){function p(o,i){let r=o;for(const s of i){if(typeof r!="object"||r===null)return;r=r[s]}return r}const c=v.split("."),n=p(m,c);return typeof n>"u"?d:n}e.getConfigurationValue=f;function h(m,v,d){Object.keys(v).forEach(p=>{p!=="__proto__"&&(p in m?S.isObject(m[p])&&S.isObject(v[p])?h(m[p],v[p],d):d&&(m[p]=v[p]):m[p]=v[p])})}e.merge=h;function b(m,v,d){const p=m.inspect(v),c=m.inspect(d);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:p.defaultValue}e.getMigratedSettingValue=b;function w(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(J[69],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,D){return this.secretVault[R]?.[D]??null}async setPassword(R,D,C){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][D]=C}async deletePassword(R,D){return this.secretVault[R]?.[D]?(delete this.secretVault[R][D],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const D=[];for(const C of Object.keys(this.secretVault[R]||{}))D.push({account:C,password:this.secretVault[R][C]});return D}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(J[84],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(D,C){return{}}async getSystemInfo(D,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,C){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=k}),define(J[102],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(J[36],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(J[26],Z([0,1,52,9,83,36,183,5]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,C.refineServiceDecorator)(R.IEnvironmentService);class l extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([S.memoize],l.prototype,"cachedLanguagesPath",null),ve([S.memoize],l.prototype,"backupHome",null),ve([S.memoize],l.prototype,"mainIPCHandle",null),ve([S.memoize],l.prototype,"mainLockfile",null),ve([S.memoize],l.prototype,"disableUpdates",null),ve([S.memoize],l.prototype,"disableKeytar",null),ve([S.memoize],l.prototype,"crossOriginIsolated",null),ve([S.memoize],l.prototype,"codeCachePath",null),ve([S.memoize],l.prototype,"useCodeCache",null),e.EnvironmentMainService=l}),define(J[191],Z([0,1,153,5]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function C(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function l(m,v,d){return C(v,d)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===d?!0:g(d).includes(m)}e.isTargetPlatformCompatible=l;function g(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function I(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=I;var E;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var y;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var f;(function(m){m.Install="install",m.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var h;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var b;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(b=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(v,d){super(v),this.code=d,this.name=d}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(J[192],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(J[193],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(J[103],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(J[194],Z([0,1,50,13,9,4,78,23,82,157,103]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=g.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{openTerminal(p,c){return this.spawnTerminal(S,p,l.getWindowsShell(),c)}spawnTerminal(p,c,n,o){const i=c.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=k.basename(i).toLowerCase();if(r==="cmder"||r==="cmder.exe")return p.spawn(i,o?[o]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return i.indexOf(" ")>=0&&s.push('""'),s.push(i),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((a,u)=>{const P=w(process),M=p.spawn(n,s,{cwd:o,env:P});M.on("error",u),M.on("exit",()=>a())})}runInTerminal(p,c,n,o,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((s,a)=>{const u=`"${c} - ${E}"`,P=`""${n.join('" "')}" & pause"`,M=["/c","start",u,"/wait",r,"/c",P],T=Object.assign({},w(process),o);Object.keys(T).filter(Q=>T[Q]===null).forEach(Q=>delete T[Q]);const F={cwd:c,env:T,windowsVerbatimArguments:!0};S.spawn(f.CMD,M,F).on("error",Q=>{a(m(Q))}),s(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class h extends y{openTerminal(p,c){return this.spawnTerminal(S,p,c)}runInTerminal(p,c,n,o,i){const r=i.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{if(r===I.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const u=r===I.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",M=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,q).fsPath,"-t",p||E,"-w",c];for(const U of n)M.push("-a"),M.push(U);if(o){const U=Object.assign({},w(process),o);for(const Q in U){const re=U[Q];re===null?(M.push("-u"),M.push(Q)):(M.push("-e"),M.push(`${Q}=${re}`))}}let T="";const F=S.spawn(h.OSASCRIPT,M);F.on("error",U=>{a(m(U))}),F.stderr.on("data",U=>{T+=U.toString()}),F.on("exit",U=>{if(U===0)s(void 0);else if(T){const Q=T.split(`
`,1);a(new Error(Q[0]))}else a(new Error(g.localize(1,null,u,U)))})}else a(new Error(g.localize(2,null,r)))})}spawnTerminal(p,c,n){const o=c.osxExec||I.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const s=["-a",o];n&&s.push(n);const a=w(process),u=p.spawn("/usr/bin/open",s,{cwd:n,env:a});u.on("error",r),u.on("exit",()=>i())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class b extends y{openTerminal(p,c){return this.spawnTerminal(S,p,c)}runInTerminal(p,c,n,o,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{const u=[];r.then(P=>{P.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const M=`${v(n)}; echo; read -p "${b.WAIT_MESSAGE}" -n1;`;u.push(`''${M}''`);const T=Object.assign({},w(process),o);Object.keys(T).filter(re=>T[re]===null).forEach(re=>delete T[re]);const F={cwd:c,env:T};let U="";const Q=S.spawn(P,u,F);Q.on("error",re=>{a(m(re))}),Q.stderr.on("data",re=>{U+=re.toString()}),Q.on("exit",re=>{if(re===0)s(void 0);else if(U){const le=U.split(`
`,1);a(new Error(le[0]))}else a(new Error(g.localize(4,null,P,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!b._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)b._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const p=await C.Promises.exists("/etc/debian_version");b._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{p?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return b._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(p,c,n){const o=c.linuxExec?Promise.resolve(c.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{o.then(s=>{const a=w(process),u=p.spawn(s,[],{cwd:n,env:a});u.on("error",r),u.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=b,b.WAIT_MESSAGE=g.localize(3,null);function w(d){const p={...d.env};return(0,D.sanitizeProcessEnvironment)(p),p}function m(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(g.localize(5,null,d.path)):d}function v(d){let p="";for(const c of d)c.indexOf(" ")>=0?p+='"'+c+'"':p+=c,p+=" ";return p}}),define(J[14],Z([0,1,32,9,25,12,7,159,5]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,l.createDecorator)("fileService");function g(K){return K.create===!0}e.isFileOpenForWriteOptions=g;var I;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(K){K[K.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var y;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=f;function h(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=h;function b(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=b;function w(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function m(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=m;function v(K){return f(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var d;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor($,_){super($),this.code=_}}e.FileSystemProviderError=p;function c(K,$){const _=new p(K.toString(),$);return o(_,$),_}e.createFileSystemProviderError=c;function n(K){return K||c((0,C.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=n;function o(K,$){return K.name=$?`${$} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=o;function i(K){if(!K)return d.Unknown;if(K instanceof p)return K.code;const $=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!$)return d.Unknown;switch($[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=i;function r(K){if(K instanceof T)return K.fileOperationResult;switch(i(K)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor($,_,A){this.resource=$,this.operation=_,this.target=A}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var u;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class P{constructor($,_){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const A=new Map;for(const W of $){const z=A.get(W.type);switch(z?z.push([W.resource,W]):A.set(W.type,[[W.resource,W]]),W.type){case 1:this.rawAdded.push(W.resource);break;case 0:this.rawUpdated.push(W.resource);break;case 2:this.rawDeleted.push(W.resource);break}}for(const[W,z]of A)switch(W){case 1:this.added=S.TernarySearchTree.forUris(()=>_),this.added.fill(z);break;case 0:this.updated=S.TernarySearchTree.forUris(()=>_),this.updated.fill(z);break;case 2:this.deleted=S.TernarySearchTree.forUris(()=>_),this.deleted.fill(z);break}}contains($,..._){return this.doContains($,{includeChildren:!1},..._)}affects($,..._){return this.doContains($,{includeChildren:!0},..._)}doContains($,_,...A){if(!$)return!1;const W=A.length>0;return!!((!W||A.includes(1))&&(this.added?.get($)||_.includeChildren&&this.added?.findSuperstr($))||(!W||A.includes(0))&&(this.updated?.get($)||_.includeChildren&&this.updated?.findSuperstr($))||(!W||A.includes(2))&&(this.deleted?.findSubstr($)||_.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=P;function M(K,$,_){return!K||!$||K===$||$.length>K.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),_?(0,k.startsWithIgnoreCase)(K,$):K.indexOf($)===0)}e.isParent=M;class T extends Error{constructor($,_,A){super($),this.fileOperationResult=_,this.options=A}}e.FileOperationError=T;class F extends T{constructor($,_,A){super($,2,A),this.stat=_}}e.NotModifiedSinceFileOperationError=F;var U;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var Q;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=re;async function le(K,$){if(!$.hasProvider(D.URI.from({scheme:K.scheme})))return new Promise(_=>{const A=$.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===K.scheme&&W.added&&(A.dispose(),_())})})}e.whenProviderRegistered=le,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize($){return(0,R.isNumber)($)||($=0),$<ue.KB?(0,C.localize)(1,null,$.toFixed(0)):$<ue.MB?(0,C.localize)(2,null,($/ue.KB).toFixed(2)):$<ue.GB?(0,C.localize)(3,null,($/ue.MB).toFixed(2)):$<ue.TB?(0,C.localize)(4,null,($/ue.GB).toFixed(2)):(0,C.localize)(5,null,($/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var se;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(se=e.Arch||(e.Arch={}));function de(K){return{maxFileSize:K===0?300*ue.MB:16*ue.GB,maxHeapSize:K===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=de}),define(J[195],Z([0,1,18,44,17,3,2,58,7,28,14]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends D.Disposable{constructor(f,h){super(),this.channel=f,this.extraCapabilities=h,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,g.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,h){const{buffer:b}=await this.channel.call("readFile",[f,h]);return b}readFileStream(f,h,b){const w=(0,C.newWriteableStream)(v=>S.VSBuffer.concat(v.map(d=>S.VSBuffer.wrap(d))).buffer),m=this.channel.listen("readFileStream",[f,h])(v=>{if(v instanceof S.VSBuffer)w.write(v.buffer);else{if(v==="end")w.end();else{let d=v;d instanceof Error||(d=(0,I.createFileSystemProviderError)((0,t.toErrorMessage)(d),I.FileSystemProviderErrorCode.Unknown)),w.error(d),w.end()}m.dispose()}});return b.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),m.dispose()}),w}writeFile(f,h,b){return this.channel.call("writeFile",[f,S.VSBuffer.wrap(h),b])}open(f,h){return this.channel.call("open",[f,h])}close(f){return this.channel.call("close",[f])}async read(f,h,b,w,m){const[v,d]=await this.channel.call("read",[f,h,m]);return b.set(v.buffer.slice(0,d),w),d}write(f,h,b,w,m){return this.channel.call("write",[f,h,S.VSBuffer.wrap(b),w,m])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,h){return this.channel.call("delete",[f,h])}rename(f,h,b){return this.channel.call("rename",[f,h,b])}copy(f,h,b){return this.channel.call("copy",[f,h,b])}cloneFile(f,h){return this.channel.call("cloneFile",[f,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const h=f;this._onDidChange.fire(h.map(b=>({resource:l.URI.revive(b.resource),type:b.type})))}else{const h=f;this._onDidWatchError.fire(h)}}))}watch(f,h){const b=(0,g.generateUuid)();return this.channel.call("watch",[this.sessionId,b,f,h]),(0,D.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,b]))}}e.DiskFileSystemProviderClient=E}),define(J[104],Z([0,1,18,17,160,14]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,E,y,f,h,b){let w;try{await C(I,E,y,f,h,b)}catch(m){w=m}finally{w&&h.errorTransformer&&(w=h.errorTransformer(w)),typeof w<"u"&&y.error(w),y.end()}}e.readFileIntoStream=D;async function C(I,E,y,f,h,b){l(b);const w=await I.open(E,{create:!1});try{l(b);let m=0,v=0,d=h&&typeof h.length=="number"?h.length:void 0,p=S.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),c=h&&typeof h.position=="number"?h.position:0,n=0;do v=await I.read(w,c,p.buffer,n,p.byteLength-n),c+=v,n+=v,m+=v,typeof d=="number"&&(d-=v),n===p.byteLength&&(await y.write(f(p)),p=S.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),n=0);while(v>0&&(typeof d!="number"||d>0)&&l(b)&&g(m,h));if(n>0){let o=n;typeof d=="number"&&(o=Math.min(n,d)),y.write(f(p.slice(0,o)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await I.close(w)}}function l(I){if(I.isCancellationRequested)throw(0,t.canceled)();return!0}function g(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[70],Z([0,1,95,2,9,4,7,14]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function l(m){return m.recursive===!0}e.isRecursiveWatchRequest=l;class g extends t.Disposable{constructor(v,d,p,c){super(),this.onFileChanges=v,this.onLogMessage=d,this.verboseLogging=p,this.options=c,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const v=new t.DisposableStore;this.watcherDisposables.value=v,this.watcher=this.createWatcher(v),this.watcher.setVerboseLogging(this.verboseLogging),v.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),v.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),v.add(this.watcher.onDidError(d=>this.onError(d)))}onError(v){this.options.restartOnError?this.restartCounter<g.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${v}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${v}`):this.error(v)}restart(v){this.restartCounter++,this.init(),this.watch(v)}async watch(v){this.requests=v,await this.watcher?.watch(v)}async setVerboseLogging(v){this.verboseLogging=v,await this.watcher?.setVerboseLogging(v)}error(v){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${v}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=g,g.MAX_RESTARTS=5;class I extends g{constructor(v,d,p){super(v,d,p,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class E extends g{constructor(v,d,p){super(v,d,p,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function y(m){return m.map(v=>({type:v.type,resource:D.URI.file(v.path)}))}e.toFileChanges=y;function f(m){const v=new w;for(const d of m)v.processEvent(d);return v.coalesce()}e.coalesceEvents=f;function h(m,v){return typeof v=="string"&&!v.startsWith(S.GLOBSTAR)&&!(0,k.isAbsolute)(v)?{base:m,pattern:v}:v}e.normalizeWatcherPattern=h;function b(m,v){const d=[];for(const p of v)d.push((0,S.parse)(h(m,p)));return d}e.parseWatcherPatterns=b;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(v){return R.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const d=this.mapPathToChange.get(this.toKey(v));let p=!1;if(d){const c=d.type,n=v.type;d.path!==v.path&&(v.type===2||v.type===1)?p=!0:c===1&&n===2?(this.mapPathToChange.delete(this.toKey(v)),this.coalesced.delete(d)):c===2&&n===1?d.type=0:c===1&&n===0||(d.type=n)}else p=!0;p&&(this.coalesced.add(v),this.mapPathToChange.set(this.toKey(v),v))}coalesce(){const v=[],d=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(v.push(p),!1):!0).sort((p,c)=>p.path.length-c.path.length).filter(p=>d.some(c=>(0,C.isParent)(p.path,c,!R.isLinux))?!1:(d.push(p.path),!0)).concat(v)}}}),define(J[196],Z([0,1,29,8,22,31,2,80,9,4,96,23,70]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends D.Disposable{constructor(w,m,v,d){super(),this.request=w,this.onDidFilesChange=m,this.onLogMessage=v,this.verboseLogging=d,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.onDidFilesChange(p)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,y.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,y.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await E.Promises.stat(w);this._register(await this.doWatch(w,m.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let m=w.path;try{m=await E.Promises.realpath(w.path),w.path===m&&(m=await(0,I.realcase)(w.path)??w.path),w.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${m})`)}catch{}return m}async doWatch(w,m){if(g.isMacintosh&&(0,R.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const v=new k.CancellationTokenSource(this.cts.token),d=new D.DisposableStore;try{const p=(0,l.basename)(w),c=(0,S.watch)(w);d.add((0,D.toDisposable)(()=>{c.removeAllListeners(),c.close()})),this.trace(`Started watching: '${w}'`);const n=new Set;if(m)try{for(const i of await E.Promises.readdir(w))n.add(i)}catch(i){this.error(i)}const o=new Map;d.add((0,D.toDisposable)(()=>{for(const[,i]of o)i.dispose();o.clear()})),c.on("error",(i,r)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),c.on("change",(i,r)=>{if(v.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let s="";if(r&&(s=r.toString(),g.isMacintosh&&(s=(0,C.normalizeNFC)(s))),!(!s||i!=="change"&&i!=="rename"))if(m)if(i==="rename"){o.get(s)?.dispose();const a=setTimeout(async()=>{if(o.delete(s),s===p&&!await E.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,l.join)(w,s));if(v.token.isCancellationRequested)return;let P;u?n.has(s)?P=0:(P=1,n.add(s)):(n.delete(s),P=2),this.onFileChange({path:(0,l.join)(this.request.path,s),type:P})},f.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,D.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(s)?a=0:(a=1,n.add(s)),this.onFileChange({path:(0,l.join)(this.request.path,s),type:a})}else if(i==="rename"||s!==p){const a=setTimeout(async()=>{const u=await E.Promises.exists(w);v.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),d.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);d.clear(),d.add((0,D.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(p){await E.Promises.exists(w)&&!v.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${p.toString()})`)}return(0,D.toDisposable)(()=>{v.dispose(!0),d.dispose()})}async onFileChange(w,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!m&&this.excludes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(v=>v(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const d=(0,y.coalesceEvents)(v);if(d.length>0){if(this.verboseLogging)for(const c of d)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.throttledFileChangesWorker.work(d)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(g.isLinux)return E.Promises.exists(w);try{const m=(0,l.basename)(w);return(await E.Promises.readdir((0,l.dirname)(w))).some(d=>d===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function h(b,w,m,v,d=512){const p=await E.Promises.open(b,"r"),c=Buffer.allocUnsafe(d),n=new k.CancellationTokenSource(v);let o,i=!1;const r={path:b,excludes:[],recursive:!1},s=new f(r,a=>{(async()=>{for(const{type:u}of a)if(u===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:P}=await E.Promises.read(p,c,0,d,null);if(!P||n.token.isCancellationRequested)break;w(c.slice(0,P))}}catch(P){o=new Error(P),n.dispose(!0)}finally{i=!1}}})()});return await s.ready,m(),new Promise((a,u)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(p)}catch(P){o=new Error(P)}o?u(o):a()})})}e.watchFileContents=h}),define(J[197],Z([0,1,3,95,2,4,196]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends k.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new S.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new S.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=S.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const I=this.normalizeRequests(g),E=I.filter(f=>{const h=this.watchers.get(f.path);return h?!(0,t.patternsEquals)(h.request.excludes,f.excludes)||!(0,t.patternsEquals)(h.request.includes,f.includes):!0}),y=Array.from(this.watchers.values()).filter(({request:f})=>!I.find(h=>h.path===f.path&&(0,t.patternsEquals)(h.excludes,f.excludes)&&(0,t.patternsEquals)(h.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.trace(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),y.length&&this.trace(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.stopWatching(f);for(const f of E)this.startWatching(f)}startWatching(g){const I=new D.NodeJSFileWatcherLibrary(g,y=>this._onDidChangeFile.fire(y),y=>this._onDidLogMessage.fire(y),this.verboseLogging),E={request:g,instance:I};this.watchers.set(g.path,E)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const I=this.watchers.get(g);I&&(this.watchers.delete(g),I.instance.dispose())}normalizeRequests(g){const I=new Map;for(const E of g){const y=R.isLinux?E.path:E.path.toLowerCase();I.set(y,E)}return Array.from(I.values())}async setVerboseLogging(g){this.verboseLogging=g;for(const[,I]of this.watchers)I.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,I){return I?`[File Watcher (node.js)] ${g} (path: ${I.request.path})`:`[File Watcher (node.js)] ${g}`}}e.NodeJSWatcher=C}),define(J[198],Z([0,1,70,197]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends S.AbstractNonRecursiveWatcherClient{constructor(D,C,l){super(D,C,l),this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(J[199],Z([0,1,13,45,146,70]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(l,g,I){super(l,g,I),this.init()}createWatcher(l){const g=l.add(new k.Client(S.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(g.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(g.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(J[85],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...k){this._entries=new Map;for(const[R,D]of k)this.set(R,D)}set(k,R){const D=this._entries.get(k);return this._entries.set(k,R),D}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=S}),define(J[200],Z([0,1,8,17,68,190,5,85]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const l=!1;class g extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new C.ServiceCollection,b=!1,w){this._activeInstantiations=new Set,this._services=h,this._strict=b,this._parent=w,this._services.set(D.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...b){const w=y.traceInvocation(h);let m=!1;try{return h({get:d=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(d,w);if(!p)throw new Error(`[invokeFunction] unknown service '${d}'`);return p}},...b)}finally{m=!0,w.stop()}}createInstance(h,...b){let w,m;return h instanceof k.SyncDescriptor?(w=y.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(b),w)):(w=y.traceCreation(h),m=this._createInstance(h,b,w)),w.stop(),m}_createInstance(h,b=[],w){const m=D._util.getServiceDependencies(h).sort((p,c)=>p.index-c.index),v=[];for(const p of m){const c=this._getOrCreateServiceInstance(p.id,w);c||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${p.id}.`,!1),v.push(c)}const d=m.length>0?m[0].index:b.length;if(b.length!==d){console.trace(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${b.length} static arguments`);const p=d-b.length;p>0?b=b.concat(new Array(p)):b=b.slice(0,d)}return new h(...b,...v)}_setServiceInstance(h,b){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,b);else if(this._parent)this._parent._setServiceInstance(h,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const b=this._services.get(h);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):b}_getOrCreateServiceInstance(h,b){const w=this._getServiceInstanceOrDescriptor(h);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,w,b.branch(h,!0)):(b.branch(h,!1),w)}_safeCreateAndCacheServiceInstance(h,b,w){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,b,w)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,b,w){const m=new R.Graph(p=>p.id.toString());let v=0;const d=[{id:h,desc:b,_trace:w}];for(;d.length;){const p=d.pop();if(m.lookupOrInsertNode(p),v++>1e3)throw new g(m);for(const c of D._util.getServiceDependencies(p.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`,!0),n instanceof k.SyncDescriptor){const o={id:c.id,desc:n,_trace:p._trace.branch(c.id,!0)};m.insertEdge(p,o),d.push(o)}}}for(;;){const p=m.roots();if(p.length===0){if(!m.isEmpty())throw new g(m);break}for(const{data:c}of p){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}m.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,b,w=[],m,v){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(b,w,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,b,w,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(h,b=[],w,m){if(w){const v=new S.IdleValue(()=>this._createInstance(h,b,m));return new Proxy(Object.create(null),{get(d,p){if(p in d)return d[p];const c=v.value;let n=c[p];return typeof n!="function"||(n=n.bind(c),d[p]=n),n},set(d,p,c){return v.value[p]=c,!0}})}else return this._createInstance(h,b,m)}_throwIfStrict(h,b){if(b&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=I;var E;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(E||(E={}));class y{constructor(h,b){this.type=h,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return l?new y(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):y._None}static traceCreation(h){return l?new y(0,h.name):y._None}branch(h,b){const w=new y(2,h.toString());return this._dep.push([h,b,w]),w}stop(){const h=Date.now()-this._start;y._totals+=h;let b=!1;function w(v,d){const p=[],c=new Array(v+1).join("	");for(const[n,o,i]of d._dep)if(o&&i){b=!0,p.push(`${c}CREATES -> ${n}`);const r=w(v+1,i);r&&p.push(r)}else p.push(`${c}uses -> ${n}`);return p.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${y._totals.toFixed(2)}ms)`];(h>2||b)&&console.log(m.join(`
`))}}e.Trace=y,y._None=new class extends y{constructor(){super(-1,null)}stop(){}branch(){return this}},y._totals=0}),define(J[6],Z([0,1,44,3,2,4,5]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function C(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=l.Info;function g(o,i,r){switch(i){case l.Trace:o.trace(r);break;case l.Debug:o.debug(r);break;case l.Info:o.info(r);break;case l.Warning:o.warn(r);break;case l.Error:o.error(r);break;case l.Critical:o.critical(r);break;default:throw new Error("Invalid log level")}}e.log=g;function I(o){let i="";for(let r=0;r<o.length;r++){let s=o[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(r>0?" ":"")+s}return i}e.format=I;class E extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class y extends E{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(l.Trace)&&this.log(l.Trace,I([i,...r]))}debug(i,...r){this.checkLogLevel(l.Debug)&&this.log(l.Debug,I([i,...r]))}info(i,...r){this.checkLogLevel(l.Info)&&this.log(l.Info,I([i,...r]))}warn(i,...r){this.checkLogLevel(l.Warning)&&this.log(l.Warning,I([i,...r]))}error(i,...r){if(this.checkLogLevel(l.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(l.Error,I(s))}else this.log(l.Error,I([i,...r]))}critical(i,...r){this.checkLogLevel(l.Critical)&&this.log(l.Critical,I([i,...r]))}flush(){}}e.AbstractMessageLogger=y;class f extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!R.isWindows}trace(i,...r){this.getLevel()<=l.Trace&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}debug(i,...r){this.getLevel()<=l.Debug&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}info(i,...r){this.getLevel()<=l.Info&&(this.useColors?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.log(`[main ${C()}]`,i,...r))}warn(i,...r){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,i,...r):console.warn(`[main ${C()}]`,i,...r))}error(i,...r){this.getLevel()<=l.Error&&(this.useColors?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,i,...r):console.error(`[main ${C()}]`,i,...r))}critical(i,...r){this.getLevel()<=l.Critical&&(this.useColors?console.error(`\x1B[90m[main ${C()}]\x1B[0m`,i,...r):console.error(`[main ${C()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class h extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...r){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends E{constructor(i,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,S.toErrorMessage)(i,this.getLevel()<=l.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class w extends E{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const s of this.logServices)s.trace(i,...r)}debug(i,...r){for(const s of this.logServices)s.debug(i,...r)}info(i,...r){for(const s of this.logServices)s.info(i,...r)}warn(i,...r){for(const s of this.logServices)s.warn(i,...r)}error(i,...r){for(const s of this.logServices)s.error(i,...r)}critical(i,...r){for(const s of this.logServices)s.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=w;class m extends k.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=m;class v extends k.Disposable{constructor(i,r){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,r?.always?l.Trace:this.logLevel,r),this.loggers.set(i.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class d{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return l.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=d;function p(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const i=c(o.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function c(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}e.parseLogLevel=c;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}e.LogLevelToString=n});var Y=this&&this.__param||function(q,e){return function(S,t){e(S,t,q)}};define(J[201],Z([0,1,69,3,2,6,4]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let C=class vt extends k.Disposable{constructor(g){super(),this.logService=g,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(g,I){let E;try{E=await this.withKeytar()}catch{return null}const y=await E.getPassword(g,I);if(y)try{let{content:f,hasNextChunk:h}=JSON.parse(y);if(!f||!h)return y;let b=1;for(;h;){const w=await E.getPassword(g,`${I}-${b}`),m=JSON.parse(w);f+=m.content,h=m.hasNextChunk,b++}return f}catch{return y}return y}async setPassword(g,I,E){let y;try{y=await this.withKeytar()}catch(b){throw this.surfaceKeytarLoadError?.(b),b}const f=3,h=async(b,w,m)=>{let v=0,d;for(;v<f;)try{await y.setPassword(b,w,m);return}catch(p){d=p,this.logService.warn("Error attempting to set a password: ",p?.message??p),v++,await new Promise(c=>setTimeout(c,200))}throw d};if(D.isWindows&&E.length>vt.MAX_PASSWORD_LENGTH){let b=0,w=0,m=!0;for(;m;){const v=E.substring(b,b+vt.PASSWORD_CHUNK_SIZE);b+=vt.PASSWORD_CHUNK_SIZE,m=E.length-b>0;const d={content:v,hasNextChunk:m};await h(g,w?`${I}-${w}`:I,JSON.stringify(d)),w++}}else await h(g,I,E);this._onDidChangePassword.fire({service:g,account:I})}async deletePassword(g,I){let E;try{E=await this.withKeytar()}catch(h){throw this.surfaceKeytarLoadError?.(h),h}const y=await E.getPassword(g,I);if(!y)return!1;const f=await E.deletePassword(g,I);try{let{content:h,hasNextChunk:b}=JSON.parse(y);if(h&&b){let w=1;for(;b;){const m=`${I}-${w}`,v=await E.getPassword(g,m);await E.deletePassword(g,m),b=JSON.parse(v).hasNextChunk,w++}}}catch{}return f&&this._onDidChangePassword.fire({service:g,account:I}),f}async findPassword(g){let I;try{I=await this.withKeytar()}catch{return null}return I.findPassword(g)}async findCredentials(g){let I;try{I=await this.withKeytar()}catch{return[]}return I.findCredentials(g)}clear(){return this._keytarCache instanceof S.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};C.MAX_PASSWORD_LENGTH=2500,C.PASSWORD_CHUNK_SIZE=C.MAX_PASSWORD_LENGTH-100,C=ve([Y(0,R.ILogService)],C),e.BaseCredentialsMainService=C}),define(J[202],Z([0,1,24,8,17,3,2,9,70,6]),function(q,e,S,t,k,R,D,C,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(y,f){super(),this.logService=y,this.options=f,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(y,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(y,f):this.watchNonRecursive(y,f)}watchUniversal(y,f){const h={path:this.toFilePath(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive},b=(0,S.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,D.toDisposable)(()=>{b(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,l.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const y=this.options?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.universalPathsToWatch)(0,l.isRecursiveWatchRequest)(f)&&y.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(y,f){const h={path:this.toFilePath(y),excludes:f.excludes,includes:f.includes,recursive:!1},b=(0,S.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,D.toDisposable)(()=>{b(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(y=>(0,k.onUnexpectedError)(y))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(y=>this._onDidChangeFile.fire((0,l.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(y){y.type==="error"&&this._onDidWatchError.fire(y.message),this.logService[y.type](y.message)}toFilePath(y){return(0,C.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(J[203],Z([0,1,24,8,18,22,3,66,57,2,32,13,71,16,58,158,14,104,6]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends g.Disposable{constructor(c){super(),this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(c,n){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${c}`);const o=new g.DisposableStore;return this.provider.set(c,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:n}),o.add(n.onDidChangeFile(i=>this._onDidFilesChange.fire(new w.FileChangesEvent(i,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:c}))),(0,g.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:n}),this.provider.delete(c),(0,g.dispose)(o)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(o){n.push(o)}}),!this.provider.has(c)&&await t.Promises.settled(n)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,n){const o=this.provider.get(c.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return l.Iterable.map(this.provider,([c,n])=>({scheme:c,capabilities:n.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new w.FileOperationError((0,b.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const n=this.provider.get(c.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,b.localize)(1,null,c.toString()),o}return n}async withReadProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n)||(0,w.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const n=await this.withProvider(c);if((0,w.hasOpenReadWriteCloseCapability)(n)||(0,w.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,n){try{return await this.doResolveFile(c,n)}catch(o){throw(0,w.toFileSystemProviderErrorCode)(o)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,b.localize)(2,null,this.resourceForError(c)),1):(0,w.ensureFileSystemProviderError)(o)}}async doResolveFile(c,n){const o=await this.withProvider(c),i=this.isPathCaseSensitive(o),r=n?.resolveTo,s=n?.resolveSingleChildDescendants,a=n?.resolveMetadata,u=await o.stat(c);let P;return this.toFileStat(o,c,u,void 0,!!a,(M,T)=>(P||(P=I.TernarySearchTree.forUris(()=>!i),P.set(c,!0),r&&P.fill(!0,r)),P.get(M.resource)||P.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&s?T===1:!1))}async toFileStat(c,n,o,i,r,s){const{providerExtUri:a}=this.getExtUri(c),u={resource:n,name:a.basename(n),isFile:(o.type&w.FileType.File)!==0,isDirectory:(o.type&w.FileType.Directory)!==0,isSymbolicLink:(o.type&w.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&w.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,w.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(u.isDirectory&&s(u,i)){try{const P=await c.readdir(n),M=await t.Promises.settled(P.map(async([T,F])=>{try{const U=a.joinPath(n,T),Q=r?await c.stat(U):{type:F};return await this.toFileStat(c,U,Q,P.length,r,s)}catch(U){return this.logService.trace(U),null}}));u.children=(0,S.coalesce)(M)}catch(P){this.logService.trace(P),u.children=[]}return u}return u}async resolveAll(c){return t.Promises.settled(c.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(c){const n=await this.withProvider(c),o=await n.stat(c);return this.toFileStat(n,c,o,void 0,!0,()=>!1)}async exists(c){const n=await this.withProvider(c);try{return!!await n.stat(c)}catch{return!1}}async canCreateFile(c,n){try{await this.doValidateCreateFile(c,n)}catch(o){return o}return!0}async doValidateCreateFile(c,n){if(!n?.overwrite&&await this.exists(c))throw new w.FileOperationError((0,b.localize)(3,null,this.resourceForError(c)),3,n)}async createFile(c,n=k.VSBuffer.fromString(""),o){await this.doValidateCreateFile(c,o);const i=await this.writeFile(c,n);return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,i)),i}async writeFile(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,c,o)||await this.mkdirp(i,r.dirname(c));let a;if((0,w.hasReadWriteCapability)(i)&&!(n instanceof k.VSBuffer))if((0,h.isReadableStream)(n)){const u=await(0,h.peekStream)(n,3);u.ended?a=k.VSBuffer.concat(u.buffer):a=u}else a=(0,h.peekReadable)(n,u=>k.VSBuffer.concat(u),3);else a=n;!(0,w.hasOpenReadWriteCloseCapability)(i)||(0,w.hasReadWriteCapability)(i)&&a instanceof k.VSBuffer?await this.doWriteUnbuffered(i,c,o,a):await this.doWriteBuffered(i,c,o,a instanceof k.VSBuffer?(0,k.bufferToReadable)(a):a),this._onDidRunOperation.fire(new w.FileOperationEvent(c,4))}catch(s){throw new w.FileOperationError((0,b.localize)(4,null,this.resourceForError(c),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),o)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,n,o){if(!!o?.unlock&&!(c.capabilities&8192))throw new Error((0,b.localize)(5,null,this.resourceForError(n)));let r;try{r=await c.stat(n)}catch{return}if((r.type&w.FileType.Directory)!==0)throw new w.FileOperationError((0,b.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==w.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,w.etag)({mtime:o.mtime,size:r.size}))throw new w.FileOperationError((0,b.localize)(7,null),3,o);return r}async readFile(c,n,o){const i=await this.withReadProvider(c);return n?.atomic?this.doReadFileAtomic(i,c,n,o):this.doReadFile(i,c,n,o)}async doReadFileAtomic(c,n,o,i){return new Promise((r,s)=>{this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(c,n,o,i);r(a)}catch(a){s(a)}})})}async doReadFile(c,n,o,i){const r=await this.doReadFileStream(c,n,{...o,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(c,n,o){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,n,o)}async doReadFileStream(c,n,o,i){const r=new R.CancellationTokenSource(i),s=this.validateReadFile(n,o).then(u=>u,u=>{throw r.cancel(),u});let a;try{return typeof o?.etag=="string"&&o.etag!==w.ETAG_DISABLED&&await s,o?.atomic&&(0,w.hasFileAtomicReadCapability)(c)||!((0,w.hasOpenReadWriteCloseCapability)(c)||(0,w.hasFileReadStreamCapability)(c))||(0,w.hasReadWriteCapability)(c)&&o?.preferUnbuffered?a=this.readFileUnbuffered(c,n,o):(0,w.hasFileReadStreamCapability)(c)?a=this.readFileStreamed(c,n,r.token,o):a=this.readFileBuffered(c,n,r.token,o),{...await s,value:a}}catch(u){a&&await(0,h.consumeStream)(a);const P=(0,b.localize)(8,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(u).toString());throw u instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(P,u.stat,o):new w.FileOperationError(P,(0,w.toFileOperationResult)(u),o)}}readFileStreamed(c,n,o,i=Object.create(null)){const r=c.readFileStream(n,i,o);return(0,h.transform)(r,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new w.FileOperationError((0,b.localize)(9,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(c,n,o,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,m.readFileIntoStream)(c,n,r,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new w.FileOperationError((0,b.localize)(10,null,this.resourceForError(n),(0,w.ensureFileSystemProviderError)(s).toString()),(0,w.toFileOperationResult)(s),i)},o),r}readFileUnbuffered(c,n,o){const i=(0,h.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,w.hasFileAtomicReadCapability)(c)?r=await c.readFile(n,{atomic:!0}):r=await c.readFile(n),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(n,r.byteLength,o),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(c,n){const o=await this.resolve(c,{resolveMetadata:!0});if(o.isDirectory)throw new w.FileOperationError((0,b.localize)(11,null,this.resourceForError(c)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.ETAG_DISABLED&&n.etag===o.etag)throw new w.NotModifiedSinceFileOperationError((0,b.localize)(12,null),o,n);return this.validateReadFileLimits(c,o.size,n),o}validateReadFileLimits(c,n,o){if(o?.limits){let i;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(i=9),typeof o.limits.size=="number"&&n>o.limits.size&&(i=7),typeof i=="number")throw new w.FileOperationError((0,b.localize)(13,null,this.resourceForError(c)),i)}}async canMove(c,n,o){return this.doCanMoveCopy(c,n,"move",o)}async canCopy(c,n,o){return this.doCanMoveCopy(c,n,"copy",o)}async doCanMoveCopy(c,n,o,i){if(c.toString()!==n.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,c,s,n,o,i)}catch(r){return r}return!0}async move(c,n,o){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,r,n,"move",!!o),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="move"?2:3,a)),a}async copy(c,n,o){const i=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(i,c,r,n,"copy",!!o),a=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,s==="copy"?3:2,a)),a}async doMoveCopy(c,n,o,i,r,s){if(n.toString()===i.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,n,o,i,r,s);if(a&&!u&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(i)),r==="copy"){if(c===o&&(0,w.hasFileFolderCopyCapability)(c))await c.copy(n,i,{overwrite:s});else{const P=await this.resolve(n);P.isDirectory?await this.doCopyFolder(c,P,o,i):await this.doCopyFile(c,n,o,i)}return r}else return c===o?(await c.rename(n,i,{overwrite:s}),r):(await this.doMoveCopy(c,n,o,i,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(c,n,o,i){if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(c,n,o,i);if((0,w.hasOpenReadWriteCloseCapability)(c)&&(0,w.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(c,n,o,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(c,n,o,i);if((0,w.hasReadWriteCapability)(c)&&(0,w.hasReadWriteCapability)(o))return this.doPipeUnbuffered(c,n,o,i)}async doCopyFolder(c,n,o,i){await o.mkdir(i),Array.isArray(n.children)&&await t.Promises.settled(n.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),o,s):this.doCopyFile(c,r.resource,o,s)}))}async doValidateMoveCopy(c,n,o,i,r,s){let a=!1;if(c===o){const{providerExtUri:P,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(a=P.isEqual(n,i)),a&&r==="copy")throw new Error((0,b.localize)(14,null,this.resourceForError(n),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,n))throw new Error((0,b.localize)(15,null,this.resourceForError(n),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!a){if(!s)throw new w.FileOperationError((0,b.localize)(16,null,this.resourceForError(n),this.resourceForError(i)),4);if(c===o){const{providerExtUri:P}=this.getExtUri(c);if(P.isEqualOrParent(n,i))throw new Error((0,b.localize)(17,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const n=this.isPathCaseSensitive(c);return{providerExtUri:n?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(n,c);const o=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(c,0,o)),o}async mkdirp(c,n){const o=[],{providerExtUri:i}=this.getExtUri(c);for(;!i.isEqual(n,i.dirname(n));)try{if(((await c.stat(n)).type&w.FileType.Directory)===0)throw new Error((0,b.localize)(18,null,this.resourceForError(n)));break}catch(r){if((0,w.toFileSystemProviderErrorCode)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(i.basename(n)),n=i.dirname(n)}for(let r=o.length-1;r>=0;r--){n=i.joinPath(n,o[r]);try{await c.mkdir(n)}catch(s){if((0,w.toFileSystemProviderErrorCode)(s)!==w.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(c,n){try{await this.doValidateDelete(c,n)}catch(o){return o}return!0}async doValidateDelete(c,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,b.localize)(19,null,this.resourceForError(c)));let r;try{r=await o.stat(c)}catch{}if(r)this.throwIfFileIsReadonly(c,r);else throw new w.FileOperationError((0,b.localize)(20,null,this.resourceForError(c)),1);if(!!!n?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,b.localize)(21,null,this.resourceForError(c)))}return o}async del(c,n){const o=await this.doValidateDelete(c,n),i=!!n?.useTrash,r=!!n?.recursive;await o.delete(c,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new w.FileOperationEvent(c,1))}async cloneFile(c,n){const o=await this.withProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===i&&this.getExtUri(o).providerExtUri.isEqual(c,n))return;if(o===i&&(0,w.hasFileCloneCapability)(o))return o.cloneFile(c,n);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(c,this.getExtUri(o).providerExtUri);return o===i&&(0,w.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(c,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,c,i,n))}watch(c,n={recursive:!1,excludes:[]}){const o=new g.DisposableStore;let i=!1,r=()=>{i=!0};return o.add((0,g.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(c,n);i?(0,g.dispose)(s):r=()=>(0,g.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(c,n){const o=await this.withProvider(c),i=(0,C.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(c),n]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:o.watch(c,n)},this.activeWatchers.set(i,r)),r.count+=1,(0,g.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,g.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,g.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,h.isReadableStream)(i)||(0,h.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(c,r,i):await this.doWriteReadableBufferedQueued(c,r,i)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,n,o){let i=0,r;if((0,h.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=k.VSBuffer.concat(o.buffer);await this.doWriteBuffer(c,n,s,s.byteLength,i,0),i+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,a)=>{(0,h.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(c,n,u,u.byteLength,i,0)}catch(P){return a(P)}i+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>a(u),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(c,n,o){let i=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(c,n,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(c,n,o,i,r,s){let a=0;for(;a<i;)a+=await c.write(n,r+a,o.buffer,s+a,i-a)}async doWriteUnbuffered(c,n,o,i){return this.writeQueue.queueFor(n,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,n,o,i))}async doWriteUnbufferedQueued(c,n,o,i){let r;i instanceof k.VSBuffer?r=i:(0,h.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,h.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await c.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,n,o,i))}async doPipeBufferedQueued(c,n,o,i){let r,s;try{r=await c.open(n,{create:!1}),s=await o.open(i,{create:!0,unlock:!1});const a=k.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,P=0,M=0;do M=await c.read(r,u,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(o,s,a,M,u,P),u+=M,P+=M,P===a.byteLength&&(P=0);while(M>0)}catch(a){throw(0,w.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,n,o,i))}async doPipeUnbufferedQueued(c,n,o,i){return o.writeFile(i,await c.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,n,o,i){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,n,o,i))}async doPipeUnbufferedToBufferedQueued(c,n,o,i){const r=await o.open(i,{create:!0,unlock:!1});try{const s=await c.readFile(n);await this.doWriteBuffer(o,r,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,w.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(c,n,o,i){const r=await(0,k.streamToBuffer)(this.readFileBuffered(c,n,R.CancellationToken.None));await this.doWriteUnbuffered(o,i,void 0,r)}throwIfFileSystemIsReadonly(c,n){if(c.capabilities&2048)throw new w.FileOperationError((0,b.localize)(22,null,this.resourceForError(n)),6);return c}throwIfFileIsReadonly(c,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,b.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===E.Schemas.file?c.fsPath:c.toString(!0)}};d=ve([Y(0,v.ILogService)],d),e.FileService=d}),define(J[86],Z([0,1,29,275,8,32,18,3,31,2,9,4,16,58,23,162,14,104,202,44,199,198]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(o)}`)}})();class n extends v.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new R.ResourceMap(s=>y.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async a=>{try{let u;a.isSymbolicLink()?u=(await this.stat((0,y.joinPath)(i,a.name))).type:u=this.toType(a),s.push([a.name,u])}catch(u){this.logService.trace(u)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let s;return r?.dangling?s=w.FileType.Unknown:i.isFile()?s=w.FileType.File:i.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,r&&(s|=w.FileType.SymbolicLink),s}async createResourceLock(i){const r=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const a=new k.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,g.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),a.open()})}async readFile(i,r){let s;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const a=this.toFilePath(i);return await h.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{s?.dispose()}}readFileStream(i,r,s){const a=(0,f.newWriteableStream)(u=>D.VSBuffer.concat(u.map(P=>D.VSBuffer.wrap(P))).buffer);return(0,m.readFileIntoStream)(this,i,a,u=>u.buffer,{...r,bufferSize:256*1024},s),a}async writeFile(i,r,s){let a;try{const u=this.toFilePath(i);if(!s.create||!s.overwrite){if(await h.Promises.exists(u)){if(!s.overwrite)throw(0,w.createFileSystemProviderError)((0,b.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.createFileSystemProviderError)((0,b.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(a,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){n.canFlush=i}async open(i,r){const s=this.toFilePath(i);let a;(0,w.isFileOpenForWriteOptions)(r)&&(a=await this.createResourceLock(i));let u;try{if((0,w.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:M}=await h.SymlinkSupport.stat(s);M.mode&128||await h.Promises.chmod(s,M.mode|128)}catch(M){this.logService.trace(M)}let P;if((0,w.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await h.Promises.truncate(s,0),P="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}P||(P="w")}else P="r";u=await h.Promises.open(s,P)}catch(P){throw a?.dispose(),(0,w.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,P):this.toFileSystemProviderError(P)}if(this.mapHandleToPos.set(u,0),(0,w.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,i),a){const P=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${s})`),this.mapHandleToLock.set(u,a),P&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${s})`),P.dispose())}return u}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&n.canFlush)try{await h.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await h.Promises.close(i)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,s,a,u){const P=this.normalizePos(i,r);let M=null;try{M=(await h.Promises.read(i,s,a,u,P)).bytesRead}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(i,P,M)}return M}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,s){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,a+s):this.mapHandleToPos.delete(i)))}async write(i,r,s,a,u){return(0,k.retry)(()=>this.doWrite(i,r,s,a,u),100,3)}async doWrite(i,r,s,a,u){const P=this.normalizePos(i,r);let M=null;try{M=(await h.Promises.write(i,s,a,u,P)).bytesWritten}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),T)}finally{this.updatePos(i,P,M)}return M}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const s=this.toFilePath(i);r.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r);if(a!==u)try{await this.validateTargetDeleted(i,r,"move",s.overwrite),await h.Promises.move(a,u)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,b.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async copy(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r);if(a!==u)try{await this.validateTargetDeleted(i,r,"copy",s.overwrite),await h.Promises.copy(a,u,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,b.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),P.toString()))),this.toFileSystemProviderError(P)}}async validateTargetDeleted(i,r,s,a){const u=this.toFilePath(i),P=this.toFilePath(r);let M=!1;if(!!(this.capabilities&1024)||(M=(0,l.isEqual)(u,P,!0)),M&&s==="copy")throw(0,w.createFileSystemProviderError)((0,b.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!M&&await h.Promises.exists(P)){if(!a)throw(0,w.createFileSystemProviderError)((0,b.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,s){const a=this.toFilePath(i),u=this.toFilePath(r),P=!!(this.capabilities&1024);if((0,l.isEqual)(a,u,!P))return;const M=new g.DisposableStore;try{const[T,F]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);M.add(T),M.add(F),s&&await h.Promises.mkdir((0,I.dirname)(u),{recursive:!0}),await h.Promises.copyFile(a,u)}catch(T){if(T.code==="ENOENT"&&!s)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(T)}finally{M.dispose()}}createUniversalWatcher(i,r,s){return new p.UniversalWatcherClient(a=>i(a),a=>r(a),s)}createNonRecursiveWatcher(i,r,s){return new c.NodeJSWatcherClient(a=>i(a),a=>r(a),s)}toFileSystemProviderError(i){if(i instanceof w.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=w.FileSystemProviderErrorCode.NoPermissions;break;default:r=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let s=this.toFileSystemProviderError(r);if(i&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(s=(0,w.createFileSystemProviderError)(r,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return s}}e.DiskFileSystemProvider=n,n.canFlush=!0}),define(J[204],Z([0,1,3,86,2,18,58,22]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class l extends k.Disposable{constructor(E,y){super(),this.provider=E,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(E,y,f){const h=this.getUriTransformer(E);switch(y){case"stat":return this.stat(h,f[0]);case"readdir":return this.readdir(h,f[0]);case"open":return this.open(h,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(h,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(h,f[0],f[1],f[2]);case"rename":return this.rename(h,f[0],f[1],f[2]);case"copy":return this.copy(h,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(h,f[0],f[1]);case"mkdir":return this.mkdir(h,f[0]);case"delete":return this.delete(h,f[0],f[1]);case"watch":return this.watch(h,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(E,y,f){const h=this.getUriTransformer(E);switch(y){case"fileChange":return this.onFileChange(h,f[0]);case"readFileStream":return this.onReadFileStream(h,f[0],f[1])}throw new Error(`Unknown event ${y}`)}stat(E,y){const f=this.transformIncoming(E,y,!0);return this.provider.stat(f)}readdir(E,y){const f=this.transformIncoming(E,y);return this.provider.readdir(f)}async readFile(E,y,f){const h=this.transformIncoming(E,y,!0),b=await this.provider.readFile(h,f);return R.VSBuffer.wrap(b)}onReadFileStream(E,y,f){const h=this.transformIncoming(E,y,!0),b=new C.CancellationTokenSource,w=new S.Emitter({onLastListenerRemove:()=>{b.cancel()}}),m=this.provider.readFileStream(h,f,b.token);return(0,D.listenStream)(m,{onData:v=>w.fire(R.VSBuffer.wrap(v)),onError:v=>w.fire(v),onEnd:()=>{w.fire("end"),w.dispose(),b.dispose()}}),w.event}writeFile(E,y,f,h){const b=this.transformIncoming(E,y);return this.provider.writeFile(b,f.buffer,h)}open(E,y,f){const h=this.transformIncoming(E,y,!0);return this.provider.open(h,f)}close(E){return this.provider.close(E)}async read(E,y,f){const h=R.VSBuffer.alloc(f),b=0,w=await this.provider.read(E,y,h.buffer,b,f);return[h,w]}write(E,y,f,h,b){return this.provider.write(E,y,f.buffer,h,b)}mkdir(E,y){const f=this.transformIncoming(E,y);return this.provider.mkdir(f)}delete(E,y,f){const h=this.transformIncoming(E,y);return this.provider.delete(h,f)}rename(E,y,f,h){const b=this.transformIncoming(E,y),w=this.transformIncoming(E,f);return this.provider.rename(b,w,h)}copy(E,y,f,h){const b=this.transformIncoming(E,y),w=this.transformIncoming(E,f);return this.provider.copy(b,w,h)}cloneFile(E,y,f){const h=this.transformIncoming(E,y),b=this.transformIncoming(E,f);return this.provider.cloneFile(h,b)}onFileChange(E,y){const f=new S.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(E,f))},onLastListenerRemove:()=>{(0,k.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return f.event}async watch(E,y,f,h,b){const w=this.sessionToWatcher.get(y);if(w){const m=this.transformIncoming(E,h),v=w.watch(f,m,b);this.watchRequests.set(y+f,v)}}async unwatch(E,y){const f=E+y,h=this.watchRequests.get(f);h&&((0,k.dispose)(h),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,E]of this.watchRequests)E.dispose();this.watchRequests.clear();for(const[,E]of this.sessionToWatcher)E.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=l;class g extends k.Disposable{constructor(E,y,f,h){super(),this.uriTransformer=E,this.logService=f,this.environmentService=h,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(y)}registerListeners(E){const y=this._register(new S.Emitter);this._register(y.event(f=>{E.fire(f.map(h=>({resource:this.uriTransformer.transformOutgoingURI(h.resource),type:h.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>y.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>E.fire(f)))}getRecursiveWatcherOptions(E){}getExtraExcludes(E){}watch(E,y,f){const h=this.getExtraExcludes(this.environmentService);return Array.isArray(h)&&(f.excludes=[...f.excludes,...h]),this.watcherRequests.set(E,this.fileWatcher.watch(y,f)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.watcherRequests.get(E)),this.watcherRequests.delete(E)})}dispose(){super.dispose();for(const[,E]of this.watcherRequests)E.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=g}),define(J[205],Z([0,1,15,161,4,7,14,9,204,140]),function(q,e,S,t,k,R,D,C,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I extends l.AbstractDiskFileSystemProviderChannel{constructor(f,h,b){super(f,h),this.environmentService=b}getUriTransformer(f){return g.DefaultURITransformer}transformIncoming(f,h){return R.URI.revive(h)}async delete(f,h,b){if(!b.useTrash)return super.delete(f,h,b);const w=this.transformIncoming(f,h),m=(0,C.normalize)(w.fsPath);try{await S.shell.trashItem(m)}catch{throw(0,D.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,C.basename)(m)):(0,t.localize)(1,null,(0,C.basename)(m)),D.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,h){return new E(f,h,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=I;class E extends l.AbstractSessionFileWatcher{watch(f,h,b){if(b.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,h,b)}}}),define(J[105],Z([0,1,6]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,D){switch(D){case S.LogLevel.Trace:return R.trace;case S.LogLevel.Debug:return R.debug;case S.LogLevel.Info:return R.info;case S.LogLevel.Warning:return R.warn;case S.LogLevel.Error:return R.error;case S.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class k extends S.AbstractLogger{constructor(D=S.DEFAULT_LOG_LEVEL){super(),this.buffer=[],this._logger=void 0,this.setLevel(D),this._register(this.onDidChangeLogLevel(C=>{this._logger?.setLevel(C)}))}set logger(D){this._logger=D;for(const{level:C,args:l}of this.buffer)t(D,C).apply(D,l);this.buffer=[]}_log(D,...C){this._logger?t(this._logger,D).apply(this._logger,C):this.getLevel()<=D&&this.buffer.push({level:D,args:C})}trace(D,...C){this._log(S.LogLevel.Trace,D,...C)}debug(D,...C){this._log(S.LogLevel.Debug,D,...C)}info(D,...C){this._log(S.LogLevel.Info,D,...C)}warn(D,...C){this._log(S.LogLevel.Warning,D,...C)}error(D,...C){this._log(S.LogLevel.Error,D,...C)}critical(D,...C){this._log(S.LogLevel.Critical,D,...C)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=k}),define(J[206],Z([0,1,8,18,16,14,5,105,6]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*R.ByteSize.MB;let I=class extends l.AbstractLogger{constructor(f,h,b,w,m){super(),this.name=f,this.resource=h,this.donotUseFormatters=w,this.fileService=m,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new S.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=l.LogLevel.Trace&&this._log(l.LogLevel.Trace,(0,l.format)(arguments))}debug(){this.getLevel()<=l.LogLevel.Debug&&this._log(l.LogLevel.Debug,(0,l.format)(arguments))}info(){this.getLevel()<=l.LogLevel.Info&&this._log(l.LogLevel.Info,(0,l.format)(arguments))}warn(){this.getLevel()<=l.LogLevel.Warning&&this._log(l.LogLevel.Warning,(0,l.format)(arguments))}error(){if(this.getLevel()<=l.LogLevel.Error){const f=arguments[0];if(f instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=f.stack,this._log(l.LogLevel.Error,(0,l.format)(h))}else this._log(l.LogLevel.Error,(0,l.format)(arguments))}}critical(){this.getLevel()<=l.LogLevel.Critical&&this._log(l.LogLevel.Critical,(0,l.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(f){if(f.fileOperationResult!==3)throw f}}_log(f,h){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>g&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(b)),b=""),this.donotUseFormatters?b+=h:b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(f)}] ${h}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(b))})}getCurrentTimestamp(){const f=w=>w<10?`0${w}`:w,h=w=>w<10?`00${w}`:w<100?`0${w}`:w,b=new Date;return`${b.getFullYear()}-${f(b.getMonth()+1)}-${f(b.getDate())} ${f(b.getHours())}:${f(b.getMinutes())}:${f(b.getSeconds())}.${h(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(f){switch(f){case l.LogLevel.Critical:return"critical";case l.LogLevel.Debug:return"debug";case l.LogLevel.Error:return"error";case l.LogLevel.Info:return"info";case l.LogLevel.Trace:return"trace";case l.LogLevel.Warning:return"warning"}return""}};I=ve([Y(4,R.IFileService)],I),e.FileLogger=I;let E=class extends l.AbstractLoggerService{constructor(f,h,b){super(f.getLevel(),f.onDidChangeLogLevel),this.instantiationService=h,this.fileService=b}doCreateLogger(f,h,b){const w=new C.BufferLogService(h);return(0,R.whenProviderRegistered)(f,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(I,b?.name||(0,k.basename)(f),f,w.getLevel(),!!b?.donotUseFormatters)),w}};E=ve([Y(0,l.ILogService),Y(1,D.IInstantiationService),Y(2,R.IFileService)],E),e.FileLoggerService=E}),define(J[207],Z([0,1,3,7,6]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y){this.service=y,this.onDidChangeLogLevel=S.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(y,f,h){switch(f){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class D{constructor(y){this.channel=y}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(y){D.setLevel(this.channel,y)}static setLevel(y,f){return y.call("setLevel",f)}}e.LogLevelChannelClient=D;class C{constructor(y){this.loggerService=y,this.loggers=new Map}listen(y,f){throw new Error(`Event not found: ${f}`)}async call(y,f,h){switch(f){case"createLogger":this.createLogger(t.URI.revive(h[0]),h[1]);return;case"log":return this.log(t.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${f}`)}createLogger(y,f){this.loggers.set(y.toString(),this.loggerService.createLogger(y,f))}consoleLog(y,f){let h=console.log;switch(y){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...f)}log(y,f){const h=this.loggers.get(y.toString());if(!h)throw new Error("Create the logger before logging");for(const[b,w]of f)(0,k.log)(h,b,w)}}e.LoggerChannel=C;class l extends k.AbstractLoggerService{constructor(y,f,h){super(y,f),this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(y,f)=>{this.channel.call("consoleLog",[y,f])}})}doCreateLogger(y,f,h){return new g(this.channel,y,f,h)}}e.LoggerChannelClient=l;class g extends k.AbstractMessageLogger{constructor(y,f,h,b){super(b?.always),this.channel=y,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[f,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(y,f){const h=[[y,f]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(y){this.channel.call("log",[this.file,y])}}class I extends k.LogService{constructor(y,f){super(f),this.parent=y,this._register(y.onDidChangeLogLevel(h=>f.setLevel(h)))}setLevel(y){super.setLevel(y),this.parent.setLevel(y)}}e.FollowerLogService=I}),define(J[106],Z([0,1,14,6]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function k(C,l,g,I,E){try{const y=await new Promise((h,b)=>{q(["spdlog"],h,b)});y.setFlushOn(t.LogLevel.Trace);const f=await y.createAsyncRotatingLogger(C,l,g,I);return E&&f.clearFormatters(),f}catch(y){console.error(y)}return null}function R(C,l,g){switch(l){case t.LogLevel.Trace:C.trace(g);break;case t.LogLevel.Debug:C.debug(g);break;case t.LogLevel.Info:C.info(g);break;case t.LogLevel.Warning:C.warn(g);break;case t.LogLevel.Error:C.error(g);break;case t.LogLevel.Critical:C.critical(g);break;default:throw new Error("Invalid log level")}}class D extends t.AbstractMessageLogger{constructor(l,g,I,E,y){super(),this.buffer=[],this.setLevel(y),this._loggerCreationPromise=this._createSpdLogLogger(l,g,I,E),this._register(this.onDidChangeLogLevel(f=>{this._logger?.setLevel(f)}))}async _createSpdLogLogger(l,g,I,E){const y=I?6:1,f=30/y*S.ByteSize.MB,h=await k(l,g,f,y,E);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:b,message:w}of this.buffer)R(this._logger,b,w);this.buffer=[]}}log(l,g){this._logger?R(this._logger,l,g):this.getLevel()<=l&&this.buffer.push({level:l,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=D}),define(J[208],Z([0,1,13,16,28,14,206,6,106]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends C.AbstractLoggerService{constructor(E,y){super(E.getLevel(),E.onDidChangeLogLevel),this.fileService=y}doCreateLogger(E,y,f){return E.scheme===S.Schemas.file?new l.SpdLogLogger(f?.name||(0,k.generateUuid)(),E.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,y):new D.FileLogger(f?.name??(0,t.basename)(E),E,y,!!f?.donotUseFormatters,this.fileService)}};g=ve([Y(0,C.ILogService),Y(1,R.IFileService)],g),e.LoggerService=g}),define(J[209],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(D){return!S(D)&&!t(D)&&!k(D)}e.isMenubarMenuItemAction=R}),define(J[38],Z([0,1,3,57,2,5]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends k.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(g){const I=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...g,...this.policyDefinitions},I!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(g),t.Iterable.reduce(this.policies.entries(),(E,[y,f])=>({...E,[y]:f}),{})}getPolicyValue(g){return this.policies.get(g)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(g,[I,E])=>({...g,[I]:{definition:E,value:this.policies.get(I)}}),{})}}e.AbstractPolicyService=D;class C{constructor(){this.onDidChange=S.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(J[210],Z([0,1,8,3,57,12,14,6,38]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function g(E,y){const f=[];for(const h of k.Iterable.concat(E.keys(),y.keys()))E.get(h)!==y.get(h)&&f.push(h);return f}let I=class extends l.AbstractPolicyService{constructor(y,f,h){super(),this.file=y,this.fileService=f,this.logService=h,this.throttledDelayer=this._register(new S.ThrottledDelayer(500));const b=t.Event.filter(f.onDidFilesChange,w=>w.affects(y));this._register(f.watch(y)),this._register(b(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(y){await this.refresh()}async read(){const y=new Map;try{const f=await this.fileService.readFile(this.file),h=JSON.parse(f.value.toString());if(!(0,R.isObject)(h))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(h))this.policyDefinitions[b]&&y.set(b,h[b])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return y}async refresh(){const y=await this.read(),f=g(this.policies,y);this.policies=y,f.length>0&&this._onDidChange.fire(f)}};I=ve([Y(1,D.IFileService),Y(2,C.ILogService)],I),e.FilePolicyService=I}),define(J[211],Z([0,1,3,2,38]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(l){this.service=l,this.disposables=new t.DisposableStore}listen(l,g){switch(g){case"onDidChange":return S.Event.map(this.service.onDidChange,I=>I.reduce((E,y)=>({...E,[y]:this.service.getPolicyValue(y)??null}),{}),this.disposables)}throw new Error(`Event not found: ${g}`)}call(l,g,I){switch(g){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(I)}throw new Error(`Call not found: ${g}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class D extends k.AbstractPolicyService{constructor(l,g){super(),this.channel=g;for(const I in l){const{definition:E,value:y}=l[I];this.policyDefinitions[I]=E,y!==void 0&&this.policies.set(I,y)}this.channel.listen("onDidChange")(I=>{for(const E in I){const y=I[E];y===null?this.policies.delete(E):this.policies.set(E,y)}this._onDidChange.fire(Object.keys(I))})}async initializePolicies(l){const g=await this.channel.call("registerPolicyDefinitions",l);for(const I in g)this.policies.set(I,g[I])}}e.PolicyChannelClient=D}),define(J[53],Z([0,1,13,4,34,16]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const C=t.globals.vscode.context.configuration();if(C)D=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const C=(0,R.dirname)(S.FileAccess.asFileUri("",q));D=q.__$__nodeRequire((0,R.joinPath)(C,"product.json").fsPath);const l=q.__$__nodeRequire((0,R.joinPath)(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),Object.assign(D,{version:l.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(J[20],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(J[212],Z([0,1,76,6,20]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(C,l){this.productService=C,this.logService=l,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(C,l){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(l);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",l),!1;const[,I,E]=g;let y=this.trustedExtensionUrlPublicKeys.get(C);if(!y){if(y=this.productService.trustedExtensionUrlPublicKeys[C],!y||y.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",C),!1;this.trustedExtensionUrlPublicKeys.set(C,[...y])}const f=Buffer.from(decodeURIComponent(E),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",l),!1;const h=f.slice(0,6),b=f.readUIntBE(0,6),w=Date.now()-b;if(w<0||w>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",l),!1;const m=f.slice(6),v=S.createVerify("SHA256");v.write(h),v.write(Buffer.from(I)),v.end();for(let d=0;d<y.length;d++){let p=y[d];if(p!==null){if(typeof p=="string")try{p=S.createPublicKey({key:Buffer.from(p,"base64"),format:"der",type:"spki"}),y[d]=p}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${C}:`,c),y[d]=null;continue}if(v.verify(p,m))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",l),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",l),!1}};R=ve([Y(0,k.IProductService),Y(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(J[61],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(J[46],Z([0,1,121,12]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(D,C){S.ok(t.isString(D)),S.ok(t.isObject(C)),S.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,C)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new k}),define(J[213],Z([0,1,3,46]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new S.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[k(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;t.Registry.add(e.Extensions.JSONContribution,D)}),define(J[62],Z([0,1,24,3,12,149,19,213,46]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=l.Registry.as(C.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const i=this.doRegisterConfigurations(n,o);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const i=[];i.push(...this.doDeregisterConfigurations(o)),i.push(...this.doRegisterConfigurations(n,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,S.distinct)(i)})}registerDefaultConfigurations(n){const o=[],i=[];for(const{overrides:r,source:s}of n)for(const a in r)if(o.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const u=this.configurationDefaultsOverrides.get(a),P=u?.valuesSources??new Map;if(s)for(const U of Object.keys(r[a]))P.set(U,s);const M={...u?.value||{},...r[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:M,valuesSources:P});const T=(0,D.getLanguageTagSettingPlainKey)(a),F={type:"object",default:M,description:R.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:M,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...b(a)),this.configurationProperties[a]=F,this.defaultLanguageConfigurationOverridesNode.properties[a]=F}else{this.configurationDefaultsOverrides.set(a,{value:r[a],source:s});const u=this.configurationProperties[a];u&&(this.updatePropertyDefaultValue(a,u),this.updateSchema(a,u))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:i,source:r}of n)for(const s in i){const a=this.configurationDefaultsOverrides.get(s),u=k.isString(r)?r:r?.id,P=k.isString(a?.source)?a?.source:a?.source?.id;if(u===P)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const M=this.configurationProperties[s];M&&(this.updatePropertyDefaultValue(s,M),this.updateSchema(s,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const i=[];return n.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(n){const o=[],i=r=>{if(r.properties)for(const s in r.properties){o.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>i(s))};for(const r of n){i(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,i,r,s=3){s=k.isUndefinedOrNull(n.scope)?s:n.scope;const a=[],u=n.properties;if(u)for(const M in u){const T=u[M];if(o&&d(M,T)){delete u[M];continue}if(T.source=i,T.defaultDefaultValue=u[M].default,this.updatePropertyDefaultValue(M,T),e.OVERRIDE_PROPERTY_REGEX.test(M)?T.scope=void 0:(T.scope=k.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=k.isUndefinedOrNull(T.restricted)?!!r?.includes(M):T.restricted),u[M].hasOwnProperty("included")&&!u[M].included){this.excludedConfigurationProperties[M]=u[M],delete u[M];continue}else this.configurationProperties[M]=u[M],u[M].policy?.name&&this.policyConfigurations.set(u[M].policy.name,M);!u[M].deprecationMessage&&u[M].markdownDeprecationMessage&&(u[M].deprecationMessage=u[M].markdownDeprecationMessage),a.push(M)}const P=n.allOf;if(P)for(const M of P)a.push(...this.validateAndRegisterProperties(M,o,i,r,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=i=>{const r=i.properties;if(r)for(const a in r)this.updateSchema(a,r[a]);i.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,i),e.allSettings.properties[o]=i,e.applicationSettings.properties[o]=i,e.machineSettings.properties[o]=i,e.machineOverridableSettings.properties[o]=i,e.windowSettings.properties[o]=i,e.resourceSettings.properties[o]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const i=this.configurationDefaultsOverrides.get(n);let r=i?.value,s=i?.source;k.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),k.isUndefined(r)&&(r=m(o.type)),o.default=r,o.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",h=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function b(c){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let o=h.exec(c);for(;o?.length;){const i=o[1].trim();i&&n.push(i),o=h.exec(c)}}return(0,S.distinct)(n)}e.overrideIdentifiersFromKey=b;function w(c){return c.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=w;function m(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new y;l.Registry.add(e.Extensions.Configuration,v);function d(c,n){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?R.localize(7,null,c):v.getConfigurationProperties()[c]!==void 0?R.localize(8,null,c):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,c,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=d;function p(){const c=[],n=v.getConfigurationProperties();for(const o of Object.keys(n))c.push([o,n[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=p}),define(J[107],Z([0,1,24,3,43,2,32,49,12,7,19,62,46]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(n={},o=[],i=[]){this._contents=n,this._keys=o,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,o){const i=this.getContentsForOverrideIdentifer(o);return i?n?(0,I.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const i of this.overrides)i.identifiers.includes(n)&&o.push(...i.keys);return S.distinct(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return S.distinct(n)}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=C.deepClone(this.contents),i=C.deepClone(this.overrides),r=[...this.keys];for(const s of n)if(!s.isEmpty()){this.mergeContents(o,s.contents);for(const a of s.overrides){const[u]=i.filter(P=>S.equals(P.identifiers,a.identifiers));u?(this.mergeContents(u.contents,a.contents),u.keys.push(...a.keys),u.keys=S.distinct(u.keys)):i.push(C.deepClone(a))}for(const a of s.keys)r.indexOf(a)===-1&&r.push(a)}return new f(o,r,i)}freeze(){return this.frozen=!0,this}clone(){return new f(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const i={};for(const r of S.distinct([...Object.keys(this.contents),...Object.keys(o)])){let s=this.contents[r];const a=o[r];a&&(typeof s=="object"&&typeof a=="object"?(s=C.deepClone(s),this.mergeContents(s,a)):s=a),i[r]=s}return new f(i,this.keys,this.overrides)}mergeContents(n,o){for(const i of Object.keys(o)){if(i in n&&l.isObject(n[i])&&l.isObject(o[i])){this.mergeContents(n[i],o[i]);continue}n[i]=C.deepClone(o[i])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?C.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let o=null,i=null;const r=s=>{s&&(i?this.mergeContents(i,s):i=C.deepClone(s))};for(const s of this.overrides)S.equals(s.identifiers,[n])?o=s.contents:s.identifiers.includes(n)&&r(s.contents);return r(o),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,I.addToValueTree)(this.contents,n,o,i=>{throw new Error(i)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let i=0;i<o;i++)n.indexOf(this.keys[i])===0&&(o=i);this.keys.splice(o,1,n)}removeKey(n){const o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=f;class h{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!l.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:i,keys:r,overrides:s,restricted:a}=this.doParseRaw(n,o);this._configurationModel=new f(i,r,s),this._restrictedConfigurations=a||[]}doParseContent(n){let o={},i=null,r=[];const s=[],a=[];function u(M){Array.isArray(r)?r.push(M):i!==null&&(r[i]=M)}const P={onObjectBegin:()=>{const M={};u(M),s.push(r),r=M,i=null},onObjectProperty:M=>{i=M},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const M=[];u(M),s.push(r),r=M,i=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:u,onError:(M,T,F)=>{a.push({error:M,offset:T,length:F})}};if(n)try{k.visit(n,P),o=r[0]||{}}catch(M){console.error(`Error while parsing settings file ${this._name}: ${M}`),this._parseErrors=[M]}return o}doParseRaw(n,o){const i=y.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,i,!0,o);n=r.raw;const s=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),a=Object.keys(n),u=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:s,keys:a,overrides:u,restricted:r.restricted}}filter(n,o,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const s={},a=[];for(const u in n)if(E.OVERRIDE_PROPERTY_REGEX.test(u)&&i){const P=this.filter(n[u],o,!1,r);s[u]=P.raw,a.push(...P.restricted)}else{const P=o[u],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&a.push(u),(M===void 0||r.scopes===void 0||r.scopes.includes(M))&&(r.skipRestricted&&P?.restricted||(s[u]=n[u]))}return{raw:s,restricted:a}}toOverrides(n,o){const i=[];for(const r of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const a in n[r])s[a]=n[r][a];i.push({identifiers:(0,E.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,I.toValuesTree)(s,o)})}return i}}e.ConfigurationModelParser=h;class b extends R.Disposable{constructor(n,o,i,r){super(),this.userSettingsResource=n,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class w{constructor(n,o,i,r,s=new f,a=new f,u=new D.ResourceMap,P=new f,M=new D.ResourceMap,T=!0){this._defaultConfiguration=n,this._policyConfiguration=o,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=P,this._memoryConfigurationByResource=M,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(n,o,i){return this.getConsolidatedConfigurationModel(n,o,i).getValue(n)}updateValue(n,o,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new f,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(n):r.setValue(n,o),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,i){const r=this.getConsolidatedConfigurationModel(n,o,i),s=this.getFolderConfigurationModelForResource(o.resource,i),a=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,u=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),M=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),T=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),F=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),Q=i?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,re=s?o.overrideIdentifier?s.freeze().override(o.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,le=o.overrideIdentifier?a.override(o.overrideIdentifier).getValue(n):a.getValue(n),ue=r.getValue(n),se=S.distinct(r.overrides.map(de=>de.identifiers).flat()).filter(de=>r.getOverrideValue(n,de)!==void 0);return{defaultValue:u,policyValue:P,applicationValue:M,userValue:T,userLocalValue:F,userRemoteValue:U,workspaceValue:Q,workspaceFolderValue:re,memoryValue:le,value:ue,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,policy:P!==void 0?{value:P}:void 0,application:M!==void 0?{value:M,override:o.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:s?.freeze().getValue(n),override:o.overrideIdentifier?s?.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,memory:le!==void 0?{value:a.getValue(n),override:o.overrideIdentifier?a.getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:se.length?se:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const i=[];if(!o){const{added:r,updated:s,removed:a}=d(this._defaultConfiguration,n);o=[...r,...s,...a]}for(const r of o)for(const s of(0,E.overrideIdentifiersFromKey)(r)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=n.getKeysForOverrideIdentifier(s),P=[...u.filter(M=>a.indexOf(M)===-1),...a.filter(M=>u.indexOf(M)===-1),...a.filter(M=>!C.equals(this._defaultConfiguration.override(s).getValue(M),n.override(s).getValue(M)))];i.push([s,P])}return this.updateDefaultConfiguration(n),{keys:o,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:i,removed:r}=d(this._policyConfiguration,n),s=[...o,...i,...r];return s.length&&this.updatePolicyConfiguration(n),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=d(this.applicationConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=d(this.localUserConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=d(this.remoteUserConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:i,removed:r,overrides:s}=d(this.workspaceConfiguration,n),a=[...o,...i,...r];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(n,o){const i=this.folderConfigurations.get(n),{added:r,updated:s,removed:a,overrides:u}=d(i,o),P=[...r,...s,...a];return(P.length||!i)&&this.updateFolderConfiguration(n,o),{keys:P,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:s,overrides:a}=d(o,void 0);return{keys:[...i,...r,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,o,i){let r=this.getConsolidatedConfigurationModelForResource(o,i);return o.overrideIdentifier&&(r=r.override(o.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:n},o){let i=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const r=o.getFolder(n);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const s=this._memoryConfigurationByResource.get(n);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(o=i.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=i}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const i=o.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:i,overrides:r,keys:s}=this._folderConfigurations.get(o);return n.push([o,{contents:i,overrides:r,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>o.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>o.add(r))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.policy),r=this.parseConfigurationModel(n.application),s=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((P,M)=>(P.set(g.URI.revive(M[0]),this.parseConfigurationModel(M[1])),P),new D.ResourceMap);return new w(o,i,r,s,new f,a,u,new f,new D.ResourceMap,!1)}static parseConfigurationModel(n){return new f(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=w;function m(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,o=new Map;for(const r of c)r.keys.forEach(s=>n.add(s)),r.overrides.forEach(([s,a])=>{const u=(0,D.getOrSet)(o,s,new Set);a.forEach(P=>u.add(P))});const i=[];return o.forEach((r,s)=>i.push([s,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=m;class v{constructor(n,o,i,r){this.change=n,this.previous=o,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(u=>s.add(u)),n.overrides.forEach(([,u])=>u.forEach(P=>s.add(P))),this.affectedKeys=[...s.values()];const a=new f;this.affectedKeys.forEach(u=>a.setValue(u,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const i=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!C.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let i=(0,I.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(n=n[r],!n)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=v;function d(c,n){const{added:o,removed:i,updated:r}=p(n,c),s=[],a=c?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const P=u.filter(M=>!a.includes(M));for(const M of P)s.push([M,n.getKeysForOverrideIdentifier(M)])}if(c){const P=a.filter(M=>!u.includes(M));for(const M of P)s.push([M,c.getKeysForOverrideIdentifier(M)])}if(n&&c){for(const P of a)if(u.includes(P)){const M=p({contents:c.getOverrideValue(void 0,P)||{},keys:c.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});s.push([P,[...M.added,...M.removed,...M.updated]])}}return{added:o,removed:i,updated:r,overrides:s}}function p(c,n){const o=c?n?c.keys.filter(s=>n.keys.indexOf(s)===-1):[...c.keys]:[],i=n?c?n.keys.filter(s=>c.keys.indexOf(s)===-1):[...n.keys]:[],r=[];if(c&&n){for(const s of n.keys)if(c.keys.indexOf(s)!==-1){const a=(0,I.getConfigurationValue)(n.contents,s),u=(0,I.getConfigurationValue)(c.contents,s);C.equals(a,u)||r.push(s)}}return{added:o,removed:i,updated:r}}}),define(J[214],Z([0,1,24,3,2,49,12,19,107,62,6,38,46]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends k.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(y.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:v,defaultsOverrides:d})=>this.onDidUpdateConfiguration(v,d))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(v,d){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:v})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=f;class h extends l.ConfigurationModel{constructor(v={}){const d=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(d),c=Object.create(null),n=[];for(const o in d){const i=v[o],r=i!==void 0?i:d[o].default;(0,C.addToValueTree)(c,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(c))g.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,g.overrideIdentifiersFromKey)(o),keys:Object.keys(c[o]),contents:(0,C.toValuesTree)(c[o],i=>console.error(`Conflict in default settings file: ${i}`))});super(c,p,n)}}e.DefaultConfigurationModel=h;class b{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new l.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=b;let w=class extends k.Disposable{constructor(v,d,p){super(),this.defaultConfiguration=v,this.policyService=d,this.logService=p,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new l.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(v=>this.onDidChangePolicies(v))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:v})=>this.update(await this.registerPolicyDefinitions(v),!0))),this._configurationModel}async registerPolicyDefinitions(v){const d={},p=[],c=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const n of v){const o=c[n];if(!o){p.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}p.push(n),d[o.policy.name]={type:o.type}}}return(0,D.isEmptyObject)(d)||await this.policyService.registerPolicyDefinitions(d),p}onDidChangePolicies(v){const d=y.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),p=(0,S.coalesce)(v.map(c=>d.get(c)));this.update(p,!0)}update(v,d){const p=y.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),c=[],n=this._configurationModel.isEmpty();for(const o of v){const i=p[o]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(n?r!==void 0:!(0,R.equals)(this._configurationModel.getValue(o),r))&&c.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&c.push([o,void 0])}if(c.length){const o=this._configurationModel;this._configurationModel=new l.ConfigurationModel;for(const i of o.keys)this._configurationModel.setValue(i,o.getValue(i));for(const[i,r]of c)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);d&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=ve([Y(1,E.IPolicyService),Y(2,I.ILogService)],w),e.PolicyConfiguration=w}),define(J[215],Z([0,1,8,3,2,16,19,107,214,38]),function(q,e,S,t,k,R,D,C,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(y,f,h,b){super(),this.settingsResource=y,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new l.DefaultConfiguration),this.policyConfiguration=h instanceof g.NullPolicyService?new l.NullPolicyConfiguration:this._register(new l.PolicyConfiguration(this.defaultConfiguration,h,b)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,f)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:m})=>this.onDidDefaultConfigurationChange(w,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[y,f,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(y,f,new C.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(y,f){const h=typeof y=="string"?y:void 0,b=(0,D.isConfigurationOverrides)(y)?y:(0,D.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(h,b,void 0)}updateValue(y,f,h,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.configuration.inspect(y,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const y=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(y)}onDidChangeUserConfiguration(y){const f=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(y);this.trigger(h,f,2)}onDidDefaultConfigurationChange(y,f){const h=this.configuration.toData(),b=this.configuration.compareAndUpdateDefaultConfiguration(y,f);this.trigger(b,h,7)}onDidPolicyConfigurationChange(y){const f=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(y);this.trigger(h,f,7)}trigger(y,f,h){const b=new C.ConfigurationChangeEvent(y,{data:f},this.configuration);b.source=h,b.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(y){switch(y){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(J[216],Z([0,1,17,5]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{constructor(C,l=k.Unknown,g){super(C),this._message=C,this._code=l,this._detail=g,this.isHandled=l===k.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===k.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===k.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}}e.RemoteAuthorityResolverError=R}),define(J[63],Z([0,1,13]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=t;function k(g){if(!g)return;const I=g.indexOf("+");return I<0?g:g.substr(0,I)}e.getRemoteName=k;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(g){const{host:I,port:E}=l(g);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.parseAuthorityWithPort=D;function C(g,I){let{host:E,port:y}=l(g);return typeof y>"u"&&(y=I),{host:E,port:y}}e.parseAuthorityWithOptionalPort=C;function l(g){const I=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=g.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(J[108],Z([0,1,25,5,63]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=R;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var l;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(l=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,w){if(typeof b>"u"||b===null)return typeof w>"u"||w===null;if(typeof w>"u"||w===null)return!1;if(typeof b=="string"||typeof w=="string"){const m=typeof b=="string"?b:b.value,v=typeof w=="string"?w:w.value;return S.equalsIgnoreCase(m,v)}return b._lower===w._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=g;function I(h){return E(h)}e.isApplicationScopedExtension=I;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function y(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function f(h,b){if(b){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(b)}`;return h.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[109],Z([0,1,25,191,108,4,7,17,34]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function g(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,S.compareIgnoreCase)(o.id,i.id)===0}e.areSameExtensions=g;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(i,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=i.id}static create(i){const r=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,r,s)}static parse(i){const r=I.exec(i);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?g(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(o){const i=y.exec(o);return i&&i[1]?[b(i[1]),i[2]]:[b(o),void 0]}e.getIdAndVersion=f;function h(o,i){return`${o}.${i}`}e.getExtensionId=h;function b(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function w(o,i){return b(h(o,i))}e.getGalleryExtensionId=w;function m(o,i){const r=[],s=a=>{for(const u of r)if(u.some(P=>g(i(P),i(a))))return u;return null};for(const a of o){const u=s(a);u?u.push(a):r.push([a])}return r}e.groupByExtension=m;function v(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function d(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=d,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function p(o,i){const r=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&r.every(u=>!g(u.identifier,{id:a}))){const u=o.filter(P=>g(P.identifier,{id:a}));u.length===1&&(r.push(u[0]),s.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function c(o,i){if(!R.isLinux)return!1;let r;try{r=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=c;async function n(o,i){const r=await c(o,i),s=(0,t.getTargetPlatform)(r?"alpine":R.platform,l.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(J[72],Z([0,1,8,18,2,32,7,109,14,5,6]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,g.createDecorator)("IExtensionsProfileScannerService");let E=class extends k.Disposable{constructor(f,h){super(),this.fileService=f,this.logService=h,this.resourcesAccessQueueMap=new R.ResourceMap}scanProfileExtensions(f){return this.withProfileExtensions(f)}addExtensionsToProfile(f,h){return this.withProfileExtensions(h,b=>(b=b.filter(w=>f.some(([m])=>!(0,C.areSameExtensions)(w.identifier,m.identifier))),b.push(...f.map(([w,m])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:m}))),b))}removeExtensionFromProfile(f,h){return this.withProfileExtensions(h,b=>b.filter(w=>!(0,C.areSameExtensions)(w.identifier,f)))}async withProfileExtensions(f,h){return this.getResourceAccessQueue(f).queue(async()=>{let b=[];try{const w=await this.fileService.readFile(f),m=JSON.parse(w.value.toString());for(const v of m){if(!v.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",v);continue}if(!v.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",v);continue}if(!v.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",v);continue}b.push({identifier:v.identifier,location:D.URI.revive(v.location),version:v.version,metadata:v.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(h){b=h(b);const w=b.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(f,t.VSBuffer.fromString(JSON.stringify(w)))}return b})}getResourceAccessQueue(f){let h=this.resourcesAccessQueueMap.get(f);return h||(h=new S.Queue,this.resourcesAccessQueueMap.set(f,h)),h}};E=ve([Y(0,l.IFileService),Y(1,I.ILogService)],E),e.ExtensionsProfileScannerService=E}),define(J[217],Z([0,1,8,18,22,17,3,2,28,98,216,63]),function(q,e,S,t,k,R,D,C,l,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var f;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function h(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(B){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),B),j.token}function w(B,j){if(B.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const L=new k.CancellationTokenSource;return B.onCancellationRequested(()=>L.cancel()),j.onCancellationRequested(()=>L.cancel()),L.token}class m{constructor(j){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((L,O)=>{this._resolvePromise=L,this._rejectPromise=O}),j.isCancellationRequested?this._timeout():this._disposables.add(j.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(j){this._state==="pending"?this._disposables.add(j):j.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(j))}reject(j){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(j))}}function v(B,j){const L=new m(j);return L.registerDisposable(B.onControlMessage(O=>{const N=JSON.parse(O.toString()),V=_(N);V?L.reject(V):L.resolve(N)})),L.promise}function d(B,j,L,O,N,V,x,ne){const H=new m(ne);return j.connect(L,O,N,V,x,(te,ie)=>{H.didTimeout?(te&&B.error(te),ie?.dispose()):te||!ie?H.reject(te):H.resolve(ie)}),H.promise}function p(B,j){const L=new m(j);return B.then(O=>{L.didTimeout||L.resolve(O)},O=>{L.didTimeout||L.reject(O)}),L.promise}async function c(B,j,L,O){const N=z(B,j);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await d(B.logService,B.socketFactory,B.host,B.port,(0,E.getRemoteServerRootPath)(B),`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${h(j)}-${B.reconnectionToken}`,O)}catch(ie){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(ie),ie}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let x,ne;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),x=B.reconnectionProtocol,ne=!1):(x=new g.PersistentProtocol(V,null),ne=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const H=await p(B.signService.createNewMessage((0,l.generateUuid)()),O),te={type:"auth",auth:B.connectionToken||"00000000000000000000",data:H.data};x.sendControl(t.VSBuffer.fromString(JSON.stringify(te)));try{const ie=await v(x,w(O,b(1e4)));if(ie.type!=="sign"||typeof ie.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await p(B.signService.validate(H,ie.signedData),O)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const ge=await p(B.signService.sign(ie.data),O),Me={type:"connectionType",commit:B.commit,signedData:ge,desiredConnectionType:j};return L&&(Me.args=L),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(t.VSBuffer.fromString(JSON.stringify(Me))),{protocol:x,ownsProtocol:ne}}catch(ie){throw ie&&ie.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(ie)),ie&&ie.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(ie)),ne&&$(x),ie}}async function n(B,j,L,O){const N=Date.now(),V=z(B,j),{protocol:x,ownsProtocol:ne}=await c(B,j,L,O),H=new m(O);return H.registerDisposable(x.onControlMessage(te=>{const ie=JSON.parse(te.toString()),oe=_(ie);oe?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(oe),ne&&$(x),H.reject(oe)):(B.reconnectionProtocol?.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ee(N)}!`),H.resolve({protocol:x,firstMessage:ie}))})),H.promise}async function o(B,j){const{protocol:L}=await n(B,1,void 0,j);return{protocol:L}}async function i(B,j,L){const{protocol:O,firstMessage:N}=await n(B,2,j,L),V=N&&N.debugPort;return{protocol:O,debugPort:V}}async function r(B,j,L){const O=Date.now(),N=z(B,3),{protocol:V}=await c(B,3,j,L);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ee(O)}!`),V}async function s(B,j,L){const{host:O,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,quality:B.quality,host:O,port:N,connectionToken:V,reconnectionToken:j,reconnectionProtocol:L,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function a(B,j,L){return P(B,async O=>{const{protocol:N}=await o(O,k.CancellationToken.None);return new de(B,j,L,O.reconnectionToken,N)})}e.connectRemoteAgentManagement=a;async function u(B,j){return P(B,async L=>{const{protocol:O,debugPort:N}=await i(L,j,k.CancellationToken.None);return new K(B,j,L.reconnectionToken,O,N)})}e.connectRemoteAgentExtensionHost=u;async function P(B,j){for(let O=1;;O++)try{const N=(0,l.generateUuid)(),V=await s(B,N,null);return await j(V)}catch(N){if(O<5)B.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),B.logService.error(N);else throw B.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),B.logService.error(N),se.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(N)),N}}async function M(B,j,L){const O=await s(B,(0,l.generateUuid)(),null);return await r(O,{host:j,port:L},k.CancellationToken.None)}e.connectRemoteAgentTunnel=M;function T(B){return(0,S.createCancelablePromise)(j=>new Promise((L,O)=>{const N=setTimeout(L,B*1e3);j.onCancellationRequested(()=>{clearTimeout(N),L()})}))}var F;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(j,L){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.type=0}}e.ConnectionLostEvent=U;class Q{constructor(j,L,O,N){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.durationSeconds=O,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=Q;class re{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=re;class le{constructor(j,L,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.type=4}}e.ConnectionGainEvent=le;class ue{constructor(j,L,O,N){this.reconnectionToken=j,this.millisSinceLastIncomingData=L,this.attempt=O,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ue;class se extends C.Disposable{constructor(j,L,O,N,V){super(),this._connectionType=j,this._options=L,this.reconnectionToken=O,this.protocol=N,this._reconnectionFailureIsFatal=V,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new le(this.reconnectionToken,0,0)),this._register(N.onSocketClose(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);x?x.type===0?(this._options.logService.info(`${ne} received socket close event (hadError: ${x.hadError}).`),x.error&&this._options.logService.error(x.error)):(this._options.logService.info(`${ne} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this._options.logService.error(x.event)):this._options.logService.info(`${ne} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(x=>{const ne=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),se._instances.push(this),this._register((0,C.toDisposable)(()=>{const x=se._instances.indexOf(this);x>=0&&se._instances.splice(x,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(se._permanentFailureMillisSinceLastIncomingData,se._permanentFailureAttempt,se._permanentFailureHandled)}static triggerPermanentFailure(j,L,O){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=j,this._permanentFailureAttempt=L,this._permanentFailureHandled=O,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(j=>j._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(j=>j._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||se._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const j=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const N=O<L.length?L[O]:L[L.length-1];try{if(N>0){const x=T(N);this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,x)),this._options.logService.info(`${j} waiting for ${N} seconds before reconnecting...`);try{await x}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this._options.logService.info(`${j} resolving connection...`);const V=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${j} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,b(y)),this._options.logService.info(`${j} reconnected!`),this._onDidStateChange.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this._options.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,R.isCancellationError)(V)){this._options.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(j,L,O){this._reconnectionFailureIsFatal?se.triggerPermanentFailure(j,L,O):this._gotoPermanentFailure(j,L,O)}_gotoPermanentFailure(j,L,O){this._onDidStateChange.fire(new ue(this.reconnectionToken,j,L,O)),$(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=se,se._permanentFailure=!1,se._permanentFailureMillisSinceLastIncomingData=0,se._permanentFailureAttempt=0,se._permanentFailureHandled=!1,se._instances=[];class de extends se{constructor(j,L,O,N,V){super(1,j,N,V,!0),this.client=this._register(new g.Client(V,{remoteAuthority:L,clientId:O},j.ipcLogger))}async _reconnect(j,L){await o(j,L)}}e.ManagementPersistentConnection=de;class K extends se{constructor(j,L,O,N,V){super(2,j,O,N,!1),this._startArguments=L,this.debugPort=V}async _reconnect(j,L){await i(j,this._startArguments,L)}}e.ExtensionHostPersistentConnection=K;function $(B){try{B.acceptDisconnect();const j=B.getSocket();B.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function _(B){if(B&&B.type==="error"){const j=new Error(`Connection error: ${B.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function A(B,j){for(;B.length<j;)B+=" ";return B}function W(B,j,L){return`[remote-connection][${A(h(B),13)}][${j.substr(0,5)}\u2026][${L?"reconnect":"initial"}]`}function z(B,j){return`${W(j,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ee(B){return`${Date.now()-B} ms`}}),define(J[218],Z([0,1,77,83]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,D,C,l,g){const I=y=>g(y,void 0),E=S.createConnection({host:k,port:R},()=>{E.removeListener("error",I);const y=Buffer.alloc(16);for(let w=0;w<16;w++)y[w]=Math.round(Math.random()*256);const f=y.toString("base64"),h=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${D}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];E.write(h.join(`\r
`)+`\r
\r
`);const b=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",b),g(void 0,new t.NodeSocket(E,l)))};E.on("data",b)});E.setNoDelay(!0),E.once("error",I)}}}),define(J[54],Z([0,1,18,166,62,5,46]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}e.isSuccess=C;function l(b){return b.res.statusCode===204}async function g(b){return l(b)?null:(await(0,S.streamToBuffer)(b.stream)).toString()}e.asText=g;async function I(b){if(!C(b))throw new Error("Server returned "+b.res.statusCode);return g(b)}e.asTextOrError=I;async function E(b){if(!C(b))throw new Error("Server returned "+b.res.statusCode);if(l(b))return null;const m=(await(0,S.streamToBuffer)(b.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=E;function y(b){h(b)}e.updateProxyConfigurationsScope=y;let f;function h(b){const w=D.Registry.as(k.Extensions.Configuration),m=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[f],remove:m?[m]:[]})}h(2)}),define(J[219],Z([0,1,18,22]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(C){this.service=C}listen(C,l){throw new Error("Invalid listen")}call(C,l,g,I=t.CancellationToken.None){switch(l){case"request":return this.service.request(g[0],I).then(async({res:E,stream:y})=>{const f=await(0,S.streamToBuffer)(y);return[{statusCode:E.statusCode,headers:E.headers},f]});case"resolveProxy":return this.service.resolveProxy(g[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(C){this.channel=C}async request(C,l){const[g,I]=await this.channel.call("request",[C],l);return{res:g,stream:(0,S.bufferToStream)(I)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=R}),define(J[220],Z([0,1,221,12]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(D,C){return D.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:D.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(D,C,l={}){const g=(0,S.parse)(D),I=l.proxyUrl||k(g,C);if(!I)return null;const E=(0,S.parse)(I);if(!/^https?:$/.test(E.protocol||""))return null;const y={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,t.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((f,h)=>{q(["http-proxy-agent"],f,h)}))(y):new(await new Promise((f,h)=>{q(["https-proxy-agent"],f,h)}))(y)}e.getProxyAgent=R}),define(J[110],Z([0,1,50,9,167,22,44,17,4,28,143,59,8]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let h;async function b(m,v,d){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(d)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=y.Promises.withAsyncBody(async(p,c)=>{const n=new R.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),c(new Error((0,k.localize)(0,null)))},f);try{p(await w(m,n.token))}catch(i){!(0,C.isCancellationError)(i)&&!n.token.isCancellationRequested?c(new Error((0,k.localize)(1,null,(0,D.toErrorMessage)(i)))):p({})}finally{clearTimeout(o),n.dispose()}})),h)}e.getResolvedShellEnv=b;async function w(m,v){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const p=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",p);const c=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const i=await(0,I.getSystemShell)(l.OS,o);return m.trace("getUnixShellEnvironment#shell",i),new Promise((r,s)=>{if(v.isCancellationRequested)return s((0,C.canceled)());const a=(0,t.basename)(i);let u,P;const M=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${M} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,P=["-Login","-Command"]):(u=`'${process.execPath}' ${M} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"?P=["-ic"]:P=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),u);const T=(0,S.spawn)(i,[...P,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});v.onCancellationRequested(()=>(T.kill(),s((0,C.canceled)()))),T.on("error",Q=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(Q)),s(Q)});const F=[];T.stdout.on("data",Q=>F.push(Q));const U=[];T.stderr.on("data",Q=>U.push(Q)),T.on("close",(Q,re)=>{const le=Buffer.concat(F).toString("utf8");m.trace("getUnixShellEnvironment#raw",le);const ue=Buffer.concat(U).toString("utf8");if(ue.trim()&&m.trace("getUnixShellEnvironment#stderr",ue),Q||re)return s(new Error((0,k.localize)(2,null,Q,re)));const se=n.exec(le),de=se?se[1]:"{}";try{const K=JSON.parse(de);d?K.ELECTRON_RUN_AS_NODE=d:delete K.ELECTRON_RUN_AS_NODE,p?K.ELECTRON_NO_ATTACH_CONSOLE=p:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",K),r(K)}catch(K){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),s(K)}})})}}),define(J[87],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[222],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.validators=new Map}vsda(){return new Promise((k,R)=>q(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.vsda(),D=new R.validator;if(D){const C=String(S._nextId++);return this.validators.set(C,D),{id:C,data:D.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const D=this.validators.get(k.id);if(!D)return!1;this.validators.delete(k.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(k)}catch{}return k}}e.SignService=S,S._nextId=1}),define(J[41],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(J[21],Z([0,1,15,40,8,3,2,4,34,12,5,6,41,26]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var h;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(h=e.ShutdownReason||(e.ShutdownReason={}));var b;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen",m[m.Eventually=4]="Eventually"})(b=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let w=class St extends D.Disposable{constructor(v,d,p){super(),this.logService=v,this.stateMainService=d,this.environmentMainService=p,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(St.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(St.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),C.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};S.app.addListener("before-quit",v);const d=()=>{this.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!C.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",d),S.app.once("will-quit",p=>{this.trace("Lifecycle#app.on(will-quit)"),p.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),S.app.removeListener("before-quit",v),S.app.removeListener("window-all-closed",d),S.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.trace("Lifecycle#onWillShutdown.fire()");const d=[];return this._onWillShutdown.fire({reason:v,join(p){d.push(p)}}),this.pendingWillShutdownPromise=(async()=>{try{await k.Promises.settled(d)}catch(p){this.logService.error(p)}try{await this.stateMainService.close()}catch(p){this.logService.error(p)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const d=this.phaseWhen.get(this._phase);d&&(d.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let d=this.phaseWhen.get(v);d||(d=new k.Barrier,this.phaseWhen.set(v,d)),await d.wait()}registerWindow(v){const d=new D.DisposableStore;this.windowCounter++,d.add(v.onWillLoad(c=>this._onWillLoadWindow.fire({window:v,workspace:c.workspace,reason:c.reason})));const p=(0,g.assertIsDefined)(v.win);p.on("close",c=>{const n=v.id;if(this.windowToCloseRequest.has(n)){this.windowToCloseRequest.delete(n);return}this.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),c.preventDefault(),this.unload(v,1).then(o=>{if(o){this.windowToCloseRequest.delete(n);return}this.windowToCloseRequest.add(n),this.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${n}`),this._onBeforeCloseWindow.fire(v),v.close()})}),p.on("closed",()=>{this.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,d.dispose(),this.windowCounter===0&&(!C.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,d){await this.unload(v,3)||v.reload(d)}unload(v,d){const p=this.mapWindowIdToPendingUnload.get(v.id);if(p)return p;const c=this.doUnload(v,d).finally(()=>{this.mapWindowIdToPendingUnload.delete(v.id)});return this.mapWindowIdToPendingUnload.set(v.id,c),c}async doUnload(v,d){if(!v.isReady)return!1;this.trace(`Lifecycle#unload() - window ID ${v.id}`);const p=this._quitRequested?2:d,c=await this.onBeforeUnloadWindowInRenderer(v,p);return c?(this.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(c)):(await this.onWillUnloadWindowInRenderer(v,p),!1)}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,d){return new Promise(p=>{const c=this.oneTimeListenerTokenGenerator++,n=`vscode:ok${c}`,o=`vscode:cancel${c}`;t.validatedIpcMain.once(n,()=>{p(!1)}),t.validatedIpcMain.once(o,()=>{p(!0)}),v.send("vscode:onBeforeUnload",{okChannel:n,cancelChannel:o,reason:d})})}onWillUnloadWindowInRenderer(v,d){return new Promise(p=>{const n=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(n,()=>p()),v.send("vscode:onWillUnload",{replyChannel:n,reason:d})})}quit(v){return this.trace(`Lifecycle#quit() - begin (willRestart: ${v})`),this.pendingQuitPromise?(this.trace("Lifecycle#quit() - returning pending quit promise"),this.pendingQuitPromise):(v&&this.stateMainService.setItem(St.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(d=>{this.pendingQuitPromiseResolve=d,this.trace("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.pendingQuitPromise)}trace(v){this.environmentMainService.args["enable-smoke-test-driver"]?this.logService.info(v):this.logService.trace(v)}async relaunch(v){this.trace("Lifecycle#relaunch()");const d=process.argv.slice(1);if(v?.addArgs&&d.push(...v.addArgs),v?.removeArgs)for(const n of v.removeArgs){const o=d.indexOf(n);o>=0&&d.splice(o,1)}const p=()=>{try{if(C.isWindows){const n=(0,l.cwd)();n!==process.cwd()&&process.chdir(n)}}catch(n){this.logService.error(n)}this.trace("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:d})};S.app.once("quit",p),await this.quit(!0)&&S.app.removeListener("quit",p)}async kill(v){this.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const d of S.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let p;d.webContents&&!d.webContents.isDestroyed()?p=new Promise(c=>d.once("closed",c)):p=Promise.resolve(),d.destroy(),await p}})()]),S.app.exit(v)}};w.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",w=ve([Y(0,E.ILogService),Y(1,y.IStateMainService),Y(2,f.IEnvironmentMainService)],w),e.LifecycleMainService=w}),define(J[223],Z([0,1,4,3,2,5,21]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let C=class extends k.Disposable{constructor(I){super(),this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((E,y)=>{q(["native-keymap"],E,y)});this._keyboardLayoutData=l(I),S.isCI||I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=l(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};C=ve([Y(0,D.ILifecycleMainService)],C),e.KeyboardLayoutMainService=C;function l(g){const I=g.getKeyMap(),E=g.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:E}}}),define(J[224],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(J[225],Z([0,1,8,18,12,36,14,6]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class l{constructor(E,y,f){this.storagePath=E,this.logService=y,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new S.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}}getItem(E,y){const f=this.storage[E];return(0,k.isUndefinedOrNull)(f)?y:f}setItem(E,y){this.setItems([{key:E,data:y}])}setItems(E){let y=!1;for(const{key:f,data:h}of E)this.storage[f]!==h&&((0,k.isUndefinedOrNull)(h)?(0,k.isUndefined)(this.storage[f])||(this.storage[f]=void 0,y=!0):(this.storage[f]=h,y=!0));y&&this.save()}removeItem(E){(0,k.isUndefined)(this.storage[E])||(this.storage[E]=void 0,this.save())}async save(E){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){if(!this.initializing)return;await this.initializing;const E=JSON.stringify(this.storage,null,4);if(E!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(E)),this.lastSavedStorageContents=E}catch(y){this.logService.error(y)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=l;let g=class{constructor(E,y,f){this.fileStorage=new l(E.stateResource,y,f)}async init(){await this.fileStorage.init()}getItem(E,y){return this.fileStorage.getItem(E,y)}};g=ve([Y(0,R.IEnvironmentService),Y(1,C.ILogService),Y(2,D.IFileService)],g),e.StateService=g}),define(J[226],Z([0,1,225]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,D){this.fileStorage.setItem(R,D)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(J[111],Z([0,1,4,34,7,28]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(g){if(S.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function C(g,I,E,y,f,h,b,w,m,v){const d=Object.create(null);d["common.machineId"]=b,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=f,d.version=h,d["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,S.PlatformToString)(S.platform),d["common.nodePlatform"]=t.platform,d["common.nodeArch"]=y,d["common.product"]=v||"desktop",w&&(d["common.msftInternal"]=w);let p=0;const c=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),S.isLinuxSnap&&(d["common.snap"]="true");const n=D(E);n&&(d["common.platformDetail"]=n);try{const o=await g.readFile(k.URI.file(m));d["common.source"]=o.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=C;function l(g){const I=t.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return g.some(y=>E===y)}e.verifyMicrosoftInternalDomain=l}),define(J[37],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(J[227],Z([0,1,30,57,8,43,13,9,4,7,81,23,97,84,14,20,37]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function v(o,i){const r=`${o}::${i.join(":")}`,s=m.get(r);if(s)return s;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,P=new Map,M=2e4;function T(U,Q,re,le){const ue=Q.substring(U.length+1);return k.Promises.withAsyncBody(async se=>{let de;try{de=await E.Promises.readdir(Q,{withFileTypes:!0})}catch{se();return}if(le.count>=M){le.count+=de.length,le.maxReached=!0,se();return}let K=de.length;if(K===0){se();return}let $=de;le.count+de.length>M&&(le.maxReached=!0,K=M-le.count,$=de.slice(0,K)),le.count+=de.length;for(const _ of $)if(_.isDirectory()){if(re.includes(_.name)||await T(U,(0,C.join)(Q,_.name),re,le),--K===0){se();return}}else{const A=_.name.lastIndexOf(".");if(A>=0){const W=_.name.substring(A+1);W&&u.set(W,(u.get(W)??0)+1)}for(const W of a)W.relativePathPattern?.test(ue)!==!1&&W.filePattern.test(_.name)&&P.set(W.tag,(P.get(W.tag)??0)+1);if(--K===0){se();return}}})}const F=k.Promises.withAsyncBody(async U=>{const Q={count:0,maxReached:!1};await T(o,o,i,Q);const re=await c(o);U({configFiles:d(P),fileTypes:d(u),fileCount:Q.count,maxFilesReached:Q.maxReached,launchConfigFiles:re})});return m.set(r,F),F}e.collectWorkspaceStats=v;function d(o){return[...t.Iterable.map(o.entries(),([i,r])=>({name:i,count:r}))].sort((i,r)=>r.count-i.count)}function p(){const o={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},i=S.cpus();return i&&i.length>0&&(o.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),o}e.getMachineInfo=p;async function c(o){try{const i=new Map,r=(0,C.join)(o,".vscode","launch.json"),s=await E.Promises.readFile(r),a=[],u=(0,R.parse)(s.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const P of u.configurations){const M=P.type;M&&(i.has(M)?i.set(M,i.get(M)+1):i.set(M,1))}return d(i)}catch{return[]}}e.collectLaunchConfigs=c;let n=class{constructor(i,r){this.telemetryService=i,this.productService=r}formatMachineInfo(i){const r=[];return r.push(`OS Version:       ${i.os}`),r.push(`CPUs:             ${i.cpus}`),r.push(`Memory (System):  ${i.memory}`),r.push(`VM:               ${i.vmHint}`),r.join(`
`)}formatEnvironment(i){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const s=S.cpus();return s&&s.length>0&&r.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),l.isWindows||r.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${i.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(i,r){return Promise.all([(0,y.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[a,u]=s,P=this.formatProcessList(i,a);return r.forEach(M=>{if((0,f.isRemoteDiagnosticError)(M))P+=`
${M.errorMessage}`,u+=`
${M.errorMessage}`;else if(P+=`

Remote: ${M.hostName}`,M.processes&&(P+=`
${this.formatProcessList(i,M.processes)}`),M.workspaceMetadata){u+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const F=M.workspaceMetadata[T];let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),u+=`|    Folder (${T}): ${U}`,u+=this.formatWorkspaceStats(F)}}}),{processInfo:P,workspaceInfo:u}})}async getSystemInfo(i,r){const{memory:s,vmHint:a,os:u,cpus:P}=p(),M={os:u,memory:s,cpus:P,vmHint:a,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:r};return l.isWindows||(M.load=`${S.loadavg().map(T=>Math.round(T)).join(", ")}`),l.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(i,r){const s=[];return(0,y.listProcesses)(i.mainPID).then(async a=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,a)),i.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),r.forEach(u=>{if((0,f.isRemoteDiagnosticError)(u))s.push(`
${u.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${u.hostName}`),s.push(this.formatMachineInfo(u.machineInfo)),u.processes&&s.push(this.formatProcessList(i,u.processes)),u.workspaceMetadata)for(const P of Object.keys(u.workspaceMetadata)){const M=u.workspaceMetadata[P];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),s.push(`Folder (${P}): ${T}`),s.push(this.formatWorkspaceStats(M))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const r=[];let a=0;const u=(F,U)=>{const Q=` ${F}(${U})`;a+Q.length>60?(r.push(P),P="|                 ",a=P.length):a+=Q.length,P+=Q};let P="|      File types:";const M=10,T=i.fileTypes.length>M?M:i.fileTypes.length;for(let F=0;F<T;F++){const U=i.fileTypes[F];u(U.name,U.count)}if(r.push(P),i.configFiles.length>=0&&(P="|      Conf files:",a=0,i.configFiles.forEach(F=>{u(F.name,F.count)}),r.push(P)),i.launchConfigFiles.length>0){let F="|      Launch Configs:";i.launchConfigFiles.forEach(U=>{F+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(F)}return r.join(`
`)}expandGPUFeatures(i){const r=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(r-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const r=[],s=[];return i.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const P=g.URI.revive(u);if(P.scheme===D.Schemas.file){const M=P.fsPath;s.push(v(M,["node_modules",".git"]).then(T=>{let F=`${T.fileCount} files`;T.maxFilesReached&&(F=`more than ${F}`),r.push(`|    Folder (${(0,C.basename)(M)}): ${F}`),r.push(this.formatWorkspaceStats(T))}).catch(T=>{r.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else r.push(`|    Folder (${P.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(i,r){const s=new Map;i.windows.forEach(u=>s.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(i.mainPID,s,a,r,0),a.join(`
`)}formatProcessItem(i,r,s,a,u){const P=u===0;let M;P?M=a.pid===i?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(M=`${M} (${r.get(a.pid)})`));const T=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);s.push(`${a.load.toFixed(0).padStart(5," ")}	${(T/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(i,r,s,F,u+1))}async getWorkspaceFileExtensions(i){const r=new Set;for(const{uri:s}of i.folders){const a=g.URI.revive(s);if(a.scheme!==D.Schemas.file)continue;const u=a.fsPath;try{(await v(u,["node_modules",".git"])).fileTypes.forEach(M=>r.add(M.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(i){for(const{uri:r}of i.folders){const s=g.URI.revive(r);if(s.scheme!==D.Schemas.file)continue;const a=s.fsPath;try{const u=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),u.fileTypes.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.launchConfigFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})}),u.configFiles.forEach(P=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:P.name,count:P.count})})}catch{}}}};n=ve([Y(0,w.ITelemetryService),Y(1,b.IProductService)],n),e.DiagnosticsService=n}),define(J[228],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:C,data:l}){return this.appenders.forEach(g=>g.log(C,l)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(J[73],Z([0,1,49,93,12,19,111,37]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class l{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(n,o){return Promise.resolve(void 0)}publicLog2(n,o){return this.publicLog(n,o)}publicLogError(n,o){return Promise.resolve(void 0)}publicLogError2(n,o){return this.publicLogError(n,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=l,e.NullTelemetryService=new l;class g{async publicLog(n,o,i){}async publicLogError(n,o,i){}}e.NullEndpointTelemetryService=g,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(c,n){return n.onDidChangeConfiguration(o=>{o.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(o.source),configurationKeys:m(o.sourceConfig)})})}e.configurationTelemetry=I;function E(c,n){return!(n.disableTelemetry||!c.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=E;function y(c){const n=c.getValue(C.TELEMETRY_SETTING_ID),o=c.getValue("telemetry.enableCrashReporter");if(c.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function f(c){const n={},o={},i={};w(c,i);for(let r in i){r=r.length>150?r.substr(r.length-149):r;const s=i[r];typeof s=="number"?o[r]=s:typeof s=="boolean"?o[r]=s?1:0:typeof s=="string"?(s.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${s.length}`),n[r]=s.substring(0,8191)):typeof s<"u"&&s!==null&&(n[r]=s)}return{properties:n,measurements:o}}e.validateTelemetryData=f;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function b(c){if(!c)return"none";for(const n of h)if(c.startsWith(`${n}+`))return n;return"other"}e.cleanRemoteAuthority=b;function w(c,n,o=0,i){if(!!c)for(const r of Object.getOwnPropertyNames(c)){const s=c[r],a=i?i+r:r;Array.isArray(s)?n[a]=(0,S.safeStringify)(s):s instanceof Date?n[a]=s.toISOString():(0,k.isObject)(s)?o<2?w(s,n,o+1,a+"."):n[a]=(0,S.safeStringify)(s):n[a]=s}}function m(c){if(!c)return[];const n=[];return v(n,"",c),n}function v(c,n,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(i=>v(c,n?`${n}.${i}`:i,o[i])):c.push(n)}function d(c,n){const o=c.msftInternalDomains||[],i=n.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(o)||i}e.isInternalTelemetry=d;function p(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=p}),define(J[229],Z([0,1,188,73]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,D,C,l,g,I,E){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`},f=await(0,S.getServiceMachineId)(C,g,I),{sessionId:h}=await E.getTelemetryInfo();return(0,t.supportsTelemetry)(D,C)&&(0,t.getTelemetryLevel)(l)===3&&(y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=h),y}e.resolveMarketplaceHeaders=k}),define(J[230],Z([0,1,2,49,93,4,25,168,19,62,53,20,46,37,73]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(v,d,p){this._configurationService=d,this._productService=p,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(v,d){this._experimentProperties[v]=d}_updateTelemetryLevel(){let v=(0,h.getTelemetryLevel)(this._configurationService);const d=this._productService.enabledTelemetryLevels;if(d){this._sendErrorTelemetry=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;v=Math.min(v,p)}this.telemetryLevel.value=v}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const v=await this._commonProperties,d=v.sessionID,p=v["common.machineId"],c=v["common.firstSessionDate"],n=v["common.msftInternal"];return{sessionId:d,machineId:p,firstSessionDate:c,msftInternal:n}}dispose(){this._disposables.dispose()}_log(v,d,p,c){return this.telemetryLevel.value<d?Promise.resolve(void 0):this._commonProperties.then(n=>{p=(0,t.mixin)(p,n),p=(0,t.mixin)(p,this._experimentProperties),p=(0,t.cloneAndChange)(p,o=>{if(typeof o=="string")return this._cleanupInfo(o,c)}),this._appenders.forEach(o=>o.log(v,p))},n=>{console.error(n)})}publicLog(v,d,p){return this._log(v,3,d,p)}publicLog2(v,d,p){return this.publicLog(v,d,p)}publicLogError(v,d){return this._sendErrorTelemetry?this._log(v,2,d,!0):Promise.resolve(void 0)}publicLogError2(v,d){return this.publicLogError(v,d)}_anonymizeFilePaths(v){let d=v;const p=[];for(const i of this._cleanupPatterns)for(;;){const r=i.exec(v);if(!r)break;p.push([r.index,i.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,n=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(d="";;){const i=n.exec(v);if(!i)break;!c.test(i[0])&&p.every(([r,s])=>i.index<r||i.index>=s)&&(d+=v.substring(o,i.index)+"<REDACTED: user-file-path>",o=n.lastIndex)}return o<v.length&&(d+=v.substr(o)),d}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const d=v.toLowerCase(),p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const c of p)if(c.regex.test(d))return`<REDACTED: ${c.label}>`;return v}_cleanupInfo(v,d){let p=v;d&&(p=this._anonymizeFilePaths(p));for(const c of this._cleanupPatterns)p=p.replace(c,"");return p=this._removePropertiesWithPossibleUserInfo(p),p}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ve([Y(1,l.IConfigurationService),Y(2,E.IProductService)],b),e.TelemetryService=b;function w(){const m=(0,C.localize)(0,null,I.default.nameLong),v=I.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=R.isWeb?"":(0,C.localize)(3,null),p=(0,C.localize)(4,null),c=(0,C.localize)(5,null),n=(0,C.localize)(6,null),o=(0,C.localize)(7,null),i=`
|       | ${p} | ${c} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${m} ${v} ${d}

&nbsp;

${o}
${i}

&nbsp;

${r}
`}y.Registry.as(g.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(g.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,C.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,C.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[231],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=k}),define(J[232],Z([0,1,119,3,2,5,46,231]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var l;(function(w){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}w.isThemeColor=m})(l=e.ThemeColor||(e.ThemeColor={}));function g(w){return{id:w}}e.themeColorFromId=g;var I;(function(w){function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||l.isThemeColor(r.color))}w.isThemeIcon=m;const v=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function d(r){const s=v.exec(r);if(!s)return;const[,a]=s;return{id:a}}w.fromString=d;function p(r){return{id:r}}w.fromId=p;function c(r,s){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),s&&(a=`${a}~${s}`),{id:a}}w.modify=c;function n(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}w.getModifier=n;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}w.isEqual=o;function i(r,s){return{id:r.id,color:s?g(s):void 0}}w.asThemeIcon=i,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function E(w){switch(w){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const f=new y;D.Registry.add(e.Extensions.ThemingContribution,f);function h(w){return f.onColorThemeChange(w)}e.registerThemingParticipant=h;class b extends k.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=b}),define(J[64],Z([0,1,15,3,2,4,19,5,41]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const g="#FFFFFF",I="#1E1E1E",E="#000000",y="#FFFFFF",f="theme",h="themeBackground",b="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let w=class extends k.Disposable{constructor(v,d){super(),this.stateMainService=v,this.configurationService=d,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,S.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const v=this.getColorScheme();if(v.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return v.dark?E:y;let d=this.stateMainService.getItem(h,null);if(!d)switch(this.stateMainService.getItem(f,"vs-dark").split(" ")[0]){case"vs":d=g;break;case"hc-black":d=E;break;case"hc-light":d=y;break;default:d=I}return R.isMacintosh&&d.toUpperCase()===I&&(d="#171717"),d}saveWindowSplash(v,d){this.stateMainService.setItems([{key:f,data:d.baseTheme},{key:h,data:d.colorInfo.background},{key:b,data:d}]),typeof v=="number"&&this.updateBackgroundColor(v,d)}updateBackgroundColor(v,d){for(const p of S.BrowserWindow.getAllWindows())if(p.id===v){p.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};w=ve([Y(0,l.IStateMainService),Y(1,D.IConfigurationService)],w),e.ThemeMainService=w}),define(J[112],Z([0,1,3,4,5,6]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var D;(function(b){b.Http="http",b.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var l;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(l=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(b){return e.LOCALHOST_ADDRESSES.indexOf(b)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(b){return e.ALL_INTERFACES_ADDRESSES.indexOf(b)>=0}e.isAllInterfaces=E;function y(b,w){return w?w!==1&&b<1024:!t.isWindows&&b<1024}e.isPortPrivileged=y;class f{constructor(w,m,v){this.remoteAddress=w,this.localAddress=m,this._dispose=v,this._onDispose=new S.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let h=class{constructor(w){this.logService=w,this._onTunnelOpened=new S.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new S.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new S.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],m=Array.from(this._tunnels.values());for(const v of m){const d=Array.from(v.values());for(const p of d){const c=await p.value;c&&w.push(c)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:m}of w.values())await m.then(v=>v?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,m,v,d,p=!1,c,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${d}.`),!w)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(w,m,v,d,p,c,n);return o?o.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(i);return(i.tunnelRemoteHost!==m||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const m=this._tunnels.get(w.tunnelRemoteHost);if(m){const v=m.get(w.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,v))}}}}async tryDisposeTunnel(w,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${m}.`);const d=v.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(m),d}}async closeTunnel(w,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${m} `);const v=this._tunnels.get(w);if(v&&v.has(m)){const d=v.get(m);d.refcount=0,await this.tryDisposeTunnel(w,m,d)}}addTunnelToMap(w,m,v){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(w,m){const v=this._tunnels.get(w);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,m){const v=[w];I(w)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):E(w)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const d=v.map(p=>this._tunnels.get(p));for(const p of d){const c=p?.get(m);if(c)return c}}canTunnel(w){return!!g(w)}createWithProvider(w,m,v,d,p,c,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${d}.`);const o=v;this._factoryInProgress.add(o);const r={elevationRequired:p?y(d===void 0?v:d):!1},s={remoteAddress:{host:m,port:v},localAddressPort:d,privacy:c,public:c?c!==C.Private:void 0,protocol:n},a=w.forwardPort(s,r);return a?(this.addTunnelToMap(m,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),a}};h=ve([Y(0,R.ILogService)],h),e.AbstractTunnelService=h}),define(J[233],Z([0,1,77,92,218,8,2,19,6,20,217,112,87]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(v,d,p,c,n){let o;for(let i=3;i&&(o?.dispose(),o=await new h(v,d,p,c,n).waitForReady(),!(n&&t.BROWSER_RESTRICTED_PORTS[n]||!t.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));i--);return o}class h extends D.Disposable{constructor(d,p,c,n,o){super(),this.defaultTunnelHost=p,this.suggestedLocalPort=o,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=S.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(p=>{p()})}async waitForReady(){let d=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),p=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address(),p||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),p=this._server.address()),this.tunnelLocalPort=p.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${p.port}`,this}async _onConnection(d){d.pause();const p=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,I.connectRemoteAgentTunnel)(this._options,p,this.tunnelRemotePort),n=c.getSocket().socket,o=c.readEntireBuffer();c.dispose(),o.byteLength>0&&d.write(o.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),n.end()}),d.on("close",()=>n.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),n.destroy()}),n.on("end",()=>d.end()),n.on("close",()=>d.end()),n.on("error",()=>{d.destroy()}),d.pipe(n),n.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),n.end()})}}let b=class extends E.AbstractTunnelService{constructor(d,p,c,n,o){super(p),this.socketFactory=d,this.signService=c,this.productService=n,this.configurationService=o}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,p,c,n,o,i,r){const s=this.getTunnelFromMap(p,c);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,p,c,n,o,i,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${p}:${c} on local port ${n}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=f(a,this.defaultTunnelHost,p,c,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(p,c,u),u}}};b=ve([Y(1,l.ILogService),Y(2,y.ISignService),Y(3,g.IProductService),Y(4,C.IConfigurationService)],b),e.BaseTunnelService=b;let w=class extends b{constructor(d,p,c,n){super(k.nodeSocketFactory,d,p,c,n)}};w=ve([Y(0,l.ILogService),Y(1,y.ISignService),Y(2,g.IProductService),Y(3,C.IConfigurationService)],w),e.TunnelService=w;let m=class extends D.Disposable{constructor(d,p,c,n){super(),this.logService=d,this.productService=p,this.signService=c,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(d,p,c,n,o,i,r,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${n} on local port ${o}.`),!this._tunnelServices.has(d)){const a=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(d,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(p,c,n,o,i,r,s)}};m=ve([Y(0,l.ILogService),Y(1,g.IProductService),Y(2,y.ISignService),Y(3,C.IConfigurationService)],m),e.SharedTunnelsService=m}),define(J[47],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(J[234],Z([0,1,4,169,62,46]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[235],Z([0,1,3,47]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(C){this.service=C}listen(C,l){switch(l){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${l}`)}call(C,l,g){switch(l){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(g)}throw new Error(`Call not found: ${l}`)}}e.UpdateChannel=k;class R{constructor(C){this.channel=C,this._onStateChange=new S.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(l=>this.state=l),this.channel.call("_getInitialState").then(l=>this.state=l)}get state(){return this._state}set state(C){this._state=C,this._onStateChange.fire(C)}checkForUpdates(C){return this.channel.call("checkForUpdates",C)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(C){return this.channel.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=R}),define(J[88],Z([0,1,8,22,3,19,26,21,6,20,54,47]),function(q,e,S,t,k,R,D,C,l,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(h,b,w){return`${w.updateUrl}/api/update/${h}/${b}/${w.commit}`}e.createUpdateURL=y;let f=class{constructor(b,w,m,v,d,p){this.lifecycleMainService=b,this.configurationService=w,this.environmentMainService=m,this.requestService=v,this.logService=d,this.productService=p,this._state=E.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.getUpdateMode(),w=this.getProductQuality(b);if(!w){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(w),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),b==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,m=>this.logService.error(m))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(b){return b==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(b=60*60*1e3){return(0,S.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(b){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(b){}getUpdateType(){return 1}doQuitAndInstall(){}};f=ve([Y(0,C.ILifecycleMainService),Y(1,R.IConfigurationService),Y(2,D.IEnvironmentMainService),Y(3,I.IRequestService),Y(4,l.ILogService),Y(5,g.IProductService)],f),e.AbstractUpdateService=f}),define(J[236],Z([0,1,15,52,3,2,19,26,21,6,20,54,37,47,88]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let b=class extends h.AbstractUpdateService{constructor(m,v,d,p,c,n,o){super(m,v,p,c,n,o),this.telemetryService=d,this.disposables=new R.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"error",(m,v)=>v)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(m,v,d)=>({url:v,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(m,v,d,p)=>({releaseNotes:v,version:d,productVersion:d,date:p}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(m){this.logService.error("UpdateService error:",m);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?m:void 0;this.setState(f.State.Idle(1,d))}buildUpdateFeedUrl(m){let v;this.productService.darwinUniversalAssetId?v=this.productService.darwinUniversalAssetId:v=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,h.createUpdateURL)(v,m,this.productService);try{S.autoUpdater.setFeedURL({url:d})}catch(p){this.logService.error("Failed to set update feed URL",p);return}return d}doCheckForUpdates(m){this.setState(f.State.CheckingForUpdates(m)),S.autoUpdater.checkForUpdates()}onUpdateAvailable(m){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(m))}onUpdateDownloaded(m){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:m.version}),this.setState(f.State.Ready(m)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ve([t.memoize],b.prototype,"onRawError",null),ve([t.memoize],b.prototype,"onRawUpdateNotAvailable",null),ve([t.memoize],b.prototype,"onRawUpdateAvailable",null),ve([t.memoize],b.prototype,"onRawUpdateDownloaded",null),b=ve([Y(0,l.ILifecycleMainService),Y(1,D.IConfigurationService),Y(2,y.ITelemetryService),Y(3,C.IEnvironmentMainService),Y(4,E.IRequestService),Y(5,g.ILogService),Y(6,I.IProductService)],b),e.DarwinUpdateService=b}),define(J[237],Z([0,1,50,29,8,3,9,26,21,6,37,47]),function(q,e,S,t,k,R,D,C,l,g,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{constructor(b,w,m){if(this.lifecycleMainService=b,this.logService=m,this._state=E.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,w.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}get state(){return this._state}setState(b){this.logService.info("update#setState",b.type),this._state=b,this._onStateChange.fire(b)}scheduleCheckForUpdates(b=60*60*1e3){return(0,k.timeout)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(b){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(b)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(b){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(b=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(b){}};y=ve([Y(0,l.ILifecycleMainService),Y(1,C.IEnvironmentMainService),Y(2,g.ILogService)],y);let f=class extends y{constructor(b,w,m,v,d,p){super(m,v,d),this.snap=b,this.snapRevision=w,this.telemetryService=p;const c=(0,t.watch)(D.dirname(this.snap)),n=R.Event.fromNodeEventEmitter(c,"change",(s,a)=>a),o=R.Event.filter(n,s=>s==="current"),r=R.Event.debounce(o,(s,a)=>a,2e3)(()=>this.checkForUpdates(!1));m.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(b=>{b?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const b=await new Promise((m,v)=>(0,t.realpath)(`${D.dirname(this.snap)}/current`,(d,p)=>d?v(d):m(p))),w=D.basename(b);return this.snapRevision!==w}isLatestVersion(){return this.isUpdateAvailable().then(void 0,b=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=ve([Y(2,l.ILifecycleMainService),Y(3,C.IEnvironmentMainService),Y(4,g.ILogService),Y(5,I.ITelemetryService)],f),e.SnapUpdateService=f}),define(J[55],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(J[238],Z([0,1,55,189,14,16,126,3,2]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class g{constructor(y){this.uri=y,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let I=class{constructor(y){this._fileService=y,this._dispooables=new l.DisposableStore,this._limit=2**16;const f=new Map,h=b=>{let w=f.get(b.scheme);return w===void 0&&(w=y.hasProvider(b)&&!this._fileService.hasCapability(b,1024),f.set(b.scheme,w)),w};this._dispooables.add(C.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new D.SkipList((b,w)=>this.extUri.compare(b,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(y){this._fileService.hasProvider(y)&&(y=(0,R.normalizePath)(y));const f=this._canonicalUris.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this._canonicalUris.set(y,new g(y)),this._checkTrim(),y)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const y=[...this._canonicalUris.entries()].sort((h,b)=>h[1].touch<b[1].touch?1:h[1].touch>b[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let h=0;h<f;h++)this._canonicalUris.set(y[h][0],y[h][1].touch())}};I=ve([Y(0,k.IFileService)],I),e.UriIdentityService=I,(0,t.registerSingleton)(S.IUriIdentityService,I,!0)}),define(J[113],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(J[239],Z([0,1,7]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(C){this.handler=C}listen(C,l){throw new Error(`Event not found: ${l}`)}call(C,l,g){switch(l){case"handleURL":return this.handler.handleURL(S.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${l}`)}}e.URLHandlerChannel=t;class k{constructor(C){this.channel=C}handleURL(C,l){return this.channel.call("handleURL",[C.toJSON(),l])}}e.URLHandlerChannelClient=k;class R{constructor(C){this.next=C}async routeCall(C,l,g,I){if(l!=="handleURL")throw new Error(`Call not found: ${l}`);if(g){const E=S.URI.revive(g);if(E&&E.query){const y=/\bwindowId=(\d+)/.exec(E.query);if(y){const f=y[1],h=new RegExp(`window:${f}`),b=C.connections.find(w=>h.test(w.ctx));if(b)return b}}}return this.next.routeCall(C,l,g,I)}routeEvent(C,l){throw new Error(`Event not found: ${l}`)}}e.URLHandlerRouter=R}),define(J[240],Z([0,1,8,2,7,20]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends t.Disposable{constructor(){super(...arguments),this.handlers=new Set}open(g,I){const E=[...this.handlers.values()];return(0,S.first)(E.map(y=>()=>y.handleURL(g,I)),void 0,!1).then(y=>y||!1)}registerHandler(g){return this.handlers.add(g),(0,t.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=D;let C=class extends D{constructor(g){super(),this.productService=g}create(g){let{authority:I,path:E,query:y,fragment:f}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return I&&E&&E.indexOf("/")!==0&&(E=`/${E}`),k.URI.from({scheme:this.productService.urlProtocol,authority:I,path:E,query:y,fragment:f})}};C=ve([Y(0,R.IProductService)],C),e.NativeURLService=C}),define(J[241],Z([0,1,15,8,3,2,4,7]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function l(I){try{return C.URI.parse(I)}catch{return null}}class g{constructor(E,y,f,h,b){if(this.urlService=y,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=E,D.isWindows){const v=h.isBuilt?[]:[`"${h.appRoot}"`];v.push("--open-url","--"),S.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,v)}const w=k.Event.map(k.Event.fromNodeEventEmitter(S.app,"open-url",(v,d)=>({event:v,url:d})),({event:v,url:d})=>(v.preventDefault(),d));this.disposables.add(w(v=>{const d=l(v);!d||this.urlService.open(d,{originalUrl:v})})),f.getWindows().filter(v=>v.isReady).length>0?this.flush():k.Event.once(f.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const y of this.uris)await this.urlService.open(y.uri,{originalUrl:y.url})||E.push(y);E.length!==0&&(this.uris=E,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(J[242],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(J[243],Z([0,1,15,2,13,7]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends t.Disposable{constructor(){super();const l=this.handleWebviewRequest.bind(this);S.protocol.registerFileProtocol(k.Schemas.vscodeWebview,l)}handleWebviewRequest(l,g){try{const I=R.URI.parse(l.url),E=D.validWebviewFilePaths.get(I.path);if(typeof E=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${E}`,f=k.FileAccess.asFileUri(y,q);return g({path:decodeURIComponent(f.fsPath),headers:{...k.COI.getHeadersFromQuery(l.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=D,D.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(J[74],Z([0,1,4]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(I){return!!I.workspaceUri}e.isWorkspaceToOpen=t;function k(I){return!!I.folderUri}e.isFolderToOpen=k;function R(I){return!!I.fileUri}e.isFileToOpen=R;function D(I){const E=C(I),y=I.getValue("window.menuBarVisibility");return y==="default"||E==="native"&&y==="compact"||S.isMacintosh&&S.isNative?"classic":y}e.getMenuBarVisibility=D;function C(I){if(S.isWeb)return"custom";const E=I.getValue("window");if(E){if(S.isMacintosh&&E.nativeTabs===!0||S.isMacintosh&&E.nativeFullScreen===!1)return"native";const h=E.titleBarStyle;if(h==="native"||h==="custom")return h}return S.isLinux?"native":"custom"}e.getTitleBarStyle=C;function l(I,E){if(!S.isWindows||S.isWeb||!E.isBuilt||C(I)==="native")return!1;const y=I.getValue("window.experimental.windowControlsOverlay.enabled");return typeof y=="boolean"?y:!0}e.useWindowControlsOverlay=l;function g(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=g}),define(J[114],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(C){C[C.INITIAL=1]="INITIAL",C[C.LOAD=2]="LOAD",C[C.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(C){C[C.CLOSE=1]="CLOSE",C[C.QUIT=2]="QUIT",C[C.RELOAD=3]="RELOAD",C[C.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(C=1){return{width:1024,height:768,mode:C}};e.defaultWindowState=k;var R;(function(C){C[C.Maximized=0]="Maximized",C[C.Normal=1]="Normal",C[C.Minimized=2]="Minimized",C[C.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(C){C[C.UNRESPONSIVE=1]="UNRESPONSIVE",C[C.CRASHED=2]="CRASHED",C[C.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(J[33],Z([0,1,5]),function(q,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(J[244],Z([0,1,15,22,3,66,2,28,69,102,6,20,33]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let h=class extends D.Disposable{constructor(w,m,v,d,p){super(),this.logService=w,this.windowsMainService=m,this.credentialsService=v,this.encryptionMainService=d,this.productService=p,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const w=k.Event.fromNodeEventEmitter(S.app,"login",(m,v,d,p,c)=>({event:m,webContents:v,req:d,authInfo:p,callback:c}));this._register(w(this.onLogin,this))}async onLogin({event:w,authInfo:m,req:v,callback:d}){if(!m.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&v.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let p;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),p=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(m);try{p=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(p?.username,p?.password)}async resolveProxyCredentials(w){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const m=await this.doResolveProxyCredentials(w);if(m)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),m;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(w){this.logService.trace("auth#doResolveProxyCredentials - enter",w);const m=String((0,R.hash)({scheme:w.scheme,host:w.host,port:w.port}));let v,d;try{const o=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m);if(o){const i=JSON.parse(await this.encryptionMainService.decrypt(o));v=i.username,d=i.password}}catch(o){this.logService.error(o)}if(this.state!==f.StoredCredentialsUsed&&typeof v=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:v,password:d};const p=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!p){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${p.id} to handle proxy login`);const c={authInfo:w,username:this.sessionCredentials?.username??v,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};p.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,c),this.state=f.LoginDialogShown;const n=await new Promise(o=>{const i=async(r,s,a)=>{if(s===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${p.id}`),p.win?.webContents.off("ipc-message",i),a){const u={username:a.username,password:a.password};try{if(a.remember){const P=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m,P)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,m)}catch(P){this.logService.error(P)}o({username:u.username,password:u.password})}else o(void 0)};p.win?.webContents.on("ipc-message",i)});return this.sessionCredentials=n,n}};h=ve([Y(0,I.ILogService),Y(1,y.IWindowsMainService),Y(2,l.ICredentialsMainService),Y(3,g.IEncryptionMainService),Y(4,E.IProductService)],h),e.ProxyAuthHandler=h}),define(J[245],Z([0,1,69,6,36,20,33,201]),function(q,e,S,t,k,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let l=class extends C.BaseCredentialsMainService{constructor(I,E,y,f){super(I),this.environmentMainService=E,this.productService=y,this.windowsMainService=f,this.surfaceKeytarLoadError=h=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",h.message??h)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new S.InMemoryCredentialsProvider,this._keytarCache;const I=await new Promise((E,y)=>{q(["keytar"],E,y)});return await I.findCredentials("test-keytar-loads"),this._keytarCache=I,this._keytarCache}};l=ve([Y(0,t.ILogService),Y(1,k.INativeEnvironmentService),Y(2,R.IProductService),Y(3,D.IWindowsMainService)],l),e.CredentialsNativeMainService=l}),define(J[246],Z([0,1,17,2,3,6,21,79,50,276,8,13,49,4,34,15,33]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const m=b.UtilityProcess,v=typeof m<"u";let d=class Wt{constructor(o,i,r){this._logService=o,this._windowsMainService=r,this._shutdown=!1,this._extHosts=new Map,i.onWillShutdown(s=>{this._shutdown=!0,s.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(o){const i=this._extHosts.get(o);if(!i)throw new Error("Unknown extension host!");return i}onDynamicStdout(o){return this._getExtHost(o).onStdout}onDynamicStderr(o){return this._getExtHost(o).onStderr}onDynamicMessage(o){return this._getExtHost(o).onMessage}onDynamicError(o){return this._getExtHost(o).onError}onDynamicExit(o){return this._getExtHost(o).onExit}async canUseUtilityProcess(){return v}async createExtensionHost(o){if(this._shutdown)throw(0,S.canceled)();const i=String(++Wt._lastId);let r;if(o){if(!v)throw new Error("Cannot use UtilityProcess!");r=new c(i,this._logService,this._windowsMainService)}else r=new p(i,this._logService);return this._extHosts.set(i,r),r.onExit(({pid:s,code:a,signal:u})=>{this._logService.info(`Extension host with pid ${s} exited with code: ${a}, signal: ${u}.`),setTimeout(()=>{r.dispose(),this._extHosts.delete(i)})}),{id:i}}async start(o,i){if(this._shutdown)throw(0,S.canceled)();return this._getExtHost(o).start(i)}async enableInspectPort(o){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(o);return i?i.enableInspectPort():!1}async kill(o){if(this._shutdown)throw(0,S.canceled)();const i=this._extHosts.get(o);!i||i.kill()}async _killAllNow(){for(const[,o]of this._extHosts)o.kill()}async _waitForAllExit(o){const i=[];for(const[,r]of this._extHosts)i.push(r.waitForExit(o));return I.Promises.settled(i).then(()=>{})}};d._lastId=0,d=ve([Y(0,R.ILogService),Y(1,D.ILifecycleMainService),Y(2,w.IWindowsMainService)],d),e.ExtensionHostStarter=d;let p=class extends t.Disposable{constructor(o,i){super(),this.id=o,this._logService=i,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){f.isCI&&this._logService.info("Calling fork to start extension host...");const i=C.StopWatch.create(!1);this._process=(0,l.fork)(E.FileAccess.asFileUri("bootstrap-fork",q).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,h.cwd)()},o));const r=i.elapsed(),s=this._process.pid;this._logService.info(`Starting extension host with pid ${s} (fork() took ${r} ms).`);const a=new g.StringDecoder("utf-8");this._process.stdout?.on("data",P=>{const M=typeof P=="string"?P:a.write(P);this._onStdout.fire(M)});const u=new g.StringDecoder("utf-8");this._process.stderr?.on("data",P=>{const M=typeof P=="string"?P:u.write(P);this._onStderr.fire(M)}),this._process.on("message",P=>{this._onMessage.fire(P)}),this._process.on("error",P=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(P)})}),this._process.on("exit",(P,M)=>{this._hasExited=!0,this._onExit.fire({pid:s,code:P,signal:M})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`Extension host with pid ${i} did not exit within ${o}ms.`),this._process.kill())}};p=ve([Y(1,R.ILogService)],p);let c=class extends t.Disposable{constructor(o,i,r){super(),this.id=o,this._logService=i,this._windowsMainService=r,this.onStdout=k.Event.None,this.onStderr=k.Event.None,this.onError=k.Event.None,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(o){const i=this._windowsMainService.getWindowById(o.responseWindowId);if(!i){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=i.win;if(!r||r.isDestroyed()||r.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const s=`extensionHost${this.id}`,a=E.FileAccess.asFileUri("bootstrap-fork.js",q).fsPath,u=["--type=extensionHost","--skipWorkspaceStorageLock"],P=o.execArgv||[],M={...o.env};for(const re of Object.keys(M))M[re]=String(M[re]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new m(a,u,{serviceName:s,env:M,execArgv:P}),this._register(k.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const T=k.Event.fromNodeEventEmitter(this._process,"exit",(re,le)=>le);this._register(T(re=>{this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:re,signal:""})}));const F=(re,le)=>{le.type==="Utility"&&le.name===s&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${le.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:le.exitCode,signal:""}))};b.app.on("child-process-gone",F),this._register((0,t.toDisposable)(()=>{b.app.off("child-process-gone",F)}));const{port1:U,port2:Q}=new b.MessageChannelMain;this._process.postMessage("port",null,[Q]),r.webContents.postMessage(o.responseChannel,o.responseNonce,[U])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(o){if(!this._process)return;const i=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${i} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,I.timeout)(o)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${i} did not exit within ${o}ms, will kill it now.`),this._process.kill())}};c=ve([Y(1,R.ILogService),Y(2,w.IWindowsMainService)],c)}),define(J[247],Z([0,1,15,3,2,243,33]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends k.Disposable{constructor(g){super(),this.windowsMainService=g,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,I){let E;if(typeof g.windowId=="number"){const{windowId:y}=g,f=this.windowsMainService.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);E=f.win.webContents}else{const{webContentsId:y}=g;if(E=S.webContents.fromId(y),!E)throw new Error(`Invalid webContentsId: ${y}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(I)}async findInFrame(g,I,E,y){const h=this.getFrameByName(g,I);if(typeof h.findInFrame=="function"){h.findInFrame(E,{findNext:y.findNext,forward:y.forward});const b=(w,m)=>{m.finalUpdate&&(this._onFoundInFrame.fire(m),h.removeListener("found-in-frame",b))};h.on("found-in-frame",b)}}async stopFindInFrame(g,I,E){const f=this.getFrameByName(g,I);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,I){const E=this.windowsMainService.getWindowById(g.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${g}`);const y=E.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===I);if(!y)throw new Error(`Unknown frame: ${I}`);return y}};C=ve([Y(0,D.IWindowsMainService)],C),e.WebviewMainService=C}),define(J[248],Z([0,1,8,3,2]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:l,getActiveWindowId:g}){super(),this.disposables=this._register(new k.DisposableStore),t.Event.latch(t.Event.any(C,l))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,S.createCancelablePromise)(()=>g()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(J[27],Z([0,1,173,9,32,16,7,5,13]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function g(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=g,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function I(o,i){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,t.basename)(o)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=I;function E(o){const i=o;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=E;function y(o){const i=o;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=y;var f;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function h(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=h;function b(o){const i=o;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=b;class w{constructor(i,r,s,a,u){this._id=i,this._transient=s,this._configuration=a,this._ignorePathCasing=u,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class m{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(o){return new m({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(o,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,i.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function p(o){let i;return D.URI.isUri(o)?i=o:i=o.configuration,i?.scheme===l.Schemas.tmp}e.isTemporaryWorkspace=p;function c(o,i){return!d(o,i)&&!p(o)}e.isSavedWorkspace=c;function n(o){return(typeof o=="string"?(0,t.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(J[249],Z([0,1,76,29,31,13,9,4,16,23,8,177,19,26,21,14,6,176,27]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let d=class{constructor(c,n,o,i){this.environmentMainService=c,this.configurationService=n,this.logService=o,this.lifecycleMainService=i,this.backupHome=this.environmentMainService.backupHome,this.workspacesJsonPath=(0,D.join)(this.backupHome,"workspaces.json"),this.workspacesJsonSaveSequentializer=new I.TaskSequentializer,this.lastKnownWorkspacesJsonContents=void 0,this.workspacesJsonWriteCounter=0,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=l.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,s)=>(0,k.isEqual)(r,s,!C.isLinux)},this.registerListeners()}registerListeners(){this.lifecycleMainService.onWillShutdown(c=>this.onWillShutdown(c))}onWillShutdown(c){c.join(this.workspacesJsonSaveSequentializer.join())}async initialize(){await this.workspacesJsonSaveSequentializer.join();let c=Object.create(null);try{const n=await this.readWorkspacesMetadata();n&&(c=JSON.parse(n))}catch{}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos),this.workspaces=await this.validateWorkspaces((0,E.deserializeWorkspaceInfos)(c)),this.folders=await this.validateFolders((0,E.deserializeFolderInfos)(c)),this.writeWorkspacesMetadata()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==b.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===b.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||b.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.emptyWindows.slice(0)}registerWorkspaceBackup(c,n){this.workspaces.some(i=>c.workspace.id===i.workspace.id)||(this.workspaces.push(c),this.writeWorkspacesMetadata());const o=this.getBackupPath(c.workspace.id);return n&&this.moveBackupFolderSync(o,n),o}moveBackupFolderSync(c,n){if(t.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),t.existsSync(n))try{t.renameSync(n,c)}catch(o){this.logService.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}unregisterWorkspaceBackup(c){const n=c.id,o=this.workspaces.findIndex(i=>i.workspace.id===n);o!==-1&&(this.workspaces.splice(o,1),this.writeWorkspacesMetadata())}registerFolderBackup(c){return this.folders.some(n=>this.backupUriComparer.isEqual(c.folderUri,n.folderUri))||(this.folders.push(c),this.writeWorkspacesMetadata()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackup(c){const n=this.folders.findIndex(o=>this.backupUriComparer.isEqual(c,o.folderUri));n!==-1&&(this.folders.splice(n,1),this.writeWorkspacesMetadata())}registerEmptyWindowBackup(c,n){const o=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,o))||(this.emptyWindows.push({backupFolder:o,remoteAuthority:n}),this.writeWorkspacesMetadata()),this.getBackupPath(o)}unregisterEmptyWindowBackup(c){const n=this.emptyWindows.findIndex(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,c));n!==-1&&(this.emptyWindows.splice(n,1),this.writeWorkspacesMetadata())}getBackupPath(c){return(0,D.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const n=new Set,o=[];for(const i of c){const r=i.workspace;if(!(0,v.isWorkspaceIdentifier)(r))return[];if(!n.has(r.id)){n.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==R.Schemas.file||await g.Promises.exists(r.configPath.fsPath)?o.push(i):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateFolders(c){if(!Array.isArray(c))return[];const n=[],o=new Set;for(const i of c){const r=i.folderUri,s=this.backupUriComparer.getComparisonKey(r);if(!o.has(s)){o.add(s);const a=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(a)?r.scheme!==R.Schemas.file||await g.Promises.exists(r.fsPath)?n.push(i):await this.convertToEmptyWindowBackup(a):await this.deleteStaleBackup(a)}}return n}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const n=[],o=new Set;for(const i of c){const r=i.backupFolder;if(typeof r!="string")return[];if(!o.has(r)){o.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?n.push(i):await this.deleteStaleBackup(s)}}return n}async deleteStaleBackup(c){try{await g.Promises.rm(c,g.RimRafMode.MOVE)}catch(n){this.logService.error(`Backup: Could not delete stale backup: ${n.toString()}`)}}async convertToEmptyWindowBackup(c){let n=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,n));)n=this.getRandomEmptyWindowId();const o=this.getBackupPath(n);try{await g.Promises.rename(c,o)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:n}),!0}convertToEmptyWindowBackupSync(c){let n=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,n));)n=this.getRandomEmptyWindowId();const o=this.getBackupPath(n);try{t.renameSync(c,o)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:n}),!0}async getDirtyWorkspaces(){const c=[];for(const n of this.workspaces)await this.hasBackups(n)&&c.push(n);for(const n of this.folders)await this.hasBackups(n)&&c.push(n);return c}hasBackups(c){let n;return(0,E.isEmptyWindowBackupInfo)(c)?n=c.backupFolder:(0,m.isFolderBackupInfo)(c)?n=this.getBackupPath(this.getFolderHash(c)):n=this.getBackupPath(c.workspace.id),this.doHasBackups(n)}async doHasBackups(c){try{const n=await g.Promises.readdir(c);for(const o of n)try{if((await g.Promises.readdir((0,D.join)(c,o))).length>0)return!0}catch{}}catch{}return!1}async readWorkspacesMetadata(){try{this.lastKnownWorkspacesJsonContents=await g.Promises.readFile(this.workspacesJsonPath,"utf8")}catch(c){c.code!=="ENOENT"&&this.logService.error(`Backup: Could not read workspaces.json: ${c.toString()}`)}return this.lastKnownWorkspacesJsonContents}writeWorkspacesMetadata(){this.workspacesJsonSaveSequentializer.hasPending()?this.workspacesJsonSaveSequentializer.setNext(()=>this.doWriteWorkspacesMetadata()):this.workspacesJsonSaveSequentializer.setPending(++this.workspacesJsonWriteCounter,this.doWriteWorkspacesMetadata())}async doWriteWorkspacesMetadata(){try{const c=JSON.stringify(this.serializeBackups());this.lastKnownWorkspacesJsonContents!==c&&(await g.Promises.writeFile(this.workspacesJsonPath,c),this.lastKnownWorkspacesJsonContents=c)}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const n=c.folderUri;let o;return n.scheme===R.Schemas.file?o=C.isLinux?n.fsPath:n.fsPath.toLowerCase():o=n.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};d=ve([Y(0,f.IEnvironmentMainService),Y(1,y.IConfigurationService),Y(2,w.ILogService),Y(3,h.ILifecycleMainService)],d),e.BackupMainService=d}),define(J[56],Z([0,1,15,8,66,35,2,80,4,12,23,150,5,6,27]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let b=class{constructor(m){this.logService=m,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(m,v){return this.doPick({...m,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},v)}pickFolder(m,v){return this.doPick({...m,pickFolders:!0,title:(0,E.localize)(1,null)},v)}pickFile(m,v){return this.doPick({...m,pickFiles:!0,title:(0,E.localize)(2,null)},v)}pickWorkspace(m,v){const d=(0,E.localize)(3,null),p=(0,R.mnemonicButtonLabel)((0,E.localize)(4,null)),c=h.WORKSPACE_FILTER;return this.doPick({...m,pickFiles:!0,title:d,filters:c,buttonLabel:p},v)}async doPick(m,v){const d={title:m.title,buttonLabel:m.buttonLabel,filters:m.filters,defaultPath:m.defaultPath};(typeof m.pickFiles=="boolean"||typeof m.pickFolders=="boolean")&&(d.properties=void 0,m.pickFiles&&m.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",m.pickFolders?"openDirectory":"openFile","createDirectory"]),l.isMacintosh&&d.properties.push("treatPackageAsDirectory");const p=await this.showOpenDialog(d,(0,g.withNullAsUndefined)(v||S.BrowserWindow.getFocusedWindow()));if(p&&p.filePaths&&p.filePaths.length>0)return p.filePaths}getWindowDialogQueue(m){if(m){let v=this.windowDialogQueues.get(m.id);return v||(v=new t.Queue,this.windowDialogQueues.set(m.id,v)),v}else return this.noWindowDialogueQueue}showMessageBox(m,v){return this.getWindowDialogQueue(v).queue(async()=>v?S.dialog.showMessageBox(v,m):S.dialog.showMessageBox(m))}async showSaveDialog(m,v){const d=this.acquireFileDialogLock(m,v);if(!d)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(v).queue(async()=>{let p;return v?p=await S.dialog.showSaveDialog(v,m):p=await S.dialog.showSaveDialog(m),p.filePath=this.normalizePath(p.filePath),p})}finally{(0,D.dispose)(d)}}normalizePath(m){return m&&l.isMacintosh&&(m=(0,C.normalizeNFC)(m)),m}normalizePaths(m){return m.map(v=>this.normalizePath(v))}async showOpenDialog(m,v){m.defaultPath&&(await I.Promises.exists(m.defaultPath)||(m.defaultPath=void 0));const d=this.acquireFileDialogLock(m,v);if(!d)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(v).queue(async()=>{let p;return v?p=await S.dialog.showOpenDialog(v,m):p=await S.dialog.showOpenDialog(m),p.filePaths=this.normalizePaths(p.filePaths),p})}finally{(0,D.dispose)(d)}}acquireFileDialogLock(m,v){if(!v)return D.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",m);let d=this.windowFileDialogLocks.get(v.id);d||(d=new Set,this.windowFileDialogLocks.set(v.id,d));const p=(0,k.hash)(m);if(!d.has(p))return this.logService.trace("[DialogMainService]: new file dialog lock created",m),d.add(p),(0,D.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",m),d?.delete(p),d?.size===0&&this.windowFileDialogLocks.delete(v.id)})}};b=ve([Y(0,f.ILogService)],b),e.DialogMainService=b}),define(J[250],Z([0,1,3,2,67,27]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends t.Disposable{constructor(l,g){super(),this.logService=l,this.storageMainService=g,this.onDidChangeApplicationStorageEmitter=this._register(new S.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(g.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(l,g){this._register(S.Event.debounce(l.onDidChangeStorage,(I,E)=>(I?I.push(E):I=[E],I),D.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&g.fire(this.serializeStorageChangeEvents(I,l))}))}serializeStorageChangeEvents(l,g){const I=new Map,E=new Set;return l.forEach(y=>{const f=g.get(y.key);typeof f=="string"?I.set(y.key,f):E.add(y.key)}),{changed:Array.from(I.entries()),deleted:Array.from(E.values())}}listen(l,g,I){switch(g){case"onDidChangeStorage":{const E=I.profile?(0,k.revive)(I.profile):void 0;if(!E)return this.onDidChangeApplicationStorageEmitter.event;let y=this.mapProfileToOnDidChangeProfileStorageEmitter.get(E.id);return y||(y=this._register(new S.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(E),y),this.mapProfileToOnDidChangeProfileStorageEmitter.set(E.id,y)),y.event}}throw new Error(`Event not found: ${g}`)}async call(l,g,I){const E=I.profile?(0,k.revive)(I.profile):void 0,y=(0,R.reviveIdentifier)(I.workspace),f=await this.withStorageInitialized(E,y);switch(g){case"getItems":return Array.from(f.items.entries());case"updateItems":{const h=I;if(h.insert)for(const[b,w]of h.insert)f.set(b,w);h.delete?.forEach(b=>f.delete(b));break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(l,g){let I;g?I=this.storageMainService.workspaceStorage(g):l?I=this.storageMainService.profileStorage(l):I=this.storageMainService.applicationStorage;try{await I.init()}catch(E){this.logService.error(`StorageIPC#init: Unable to init ${g?"workspace":l?"profile":"application"} storage due to ${E}`)}return I}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[39],Z([0,1,66,3,2,16,12,7,170,36,14,5,6,27,32,55,8,28,25]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function d(o){const i=o;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&((0,D.isUndefined)(i.extensionsResource)||C.URI.isUri(i.extensionsResource)))}e.isUserDataProfile=d,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function p(o,i){return{id:o.id,isDefault:o.isDefault,name:o.name,location:C.URI.revive(o.location).with({scheme:i}),globalStorageHome:C.URI.revive(o.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(o.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(o.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(o.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(o.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(o.extensionsResource)?.with({scheme:i}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.reviveProfile=p,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function c(o,i,r,s){return{id:(0,S.hash)(i.path).toString(16),name:o,location:i,isDefault:!1,globalStorageHome:(0,R.joinPath)(i,"globalStorage"),settingsResource:(0,R.joinPath)(i,"settings.json"),keybindingsResource:(0,R.joinPath)(i,"keybindings.json"),tasksResource:(0,R.joinPath)(i,"tasks.json"),snippetsHome:(0,R.joinPath)(i,"snippets"),extensionsResource:(0,R.joinPath)(i,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:s}}e.toUserDataProfile=c;let n=class extends k.Disposable{constructor(i,r,s,a){super(),this.environmentService=i,this.fileService=r,this.uriIdentityService=s,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}get profilesObject(){if(!this._profilesObject){const i=this.enabled?this.getStoredProfiles().map(u=>c(u.name,u.location,u.useDefaultFlags)):[];let r;const s=new h.ResourceMap,a=c((0,l.localize)(0,null),this.environmentService.userRoamingDataHome);if(i.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||i.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),i.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[P,M]of Object.entries(u.workspaces)){const T=C.URI.parse(P),F=C.URI.parse(M),U=i.find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,F));U&&s.set(T,U)}if(u.emptyWindow){const P=C.URI.parse(u.emptyWindow);r=i.find(M=>this.uriIdentityService.extUri.isEqual(M.location,P))}}this._profilesObject={profiles:i,workspaces:s,emptyWindow:r}}return this._profilesObject}async createTransientProfile(i){const r="Temp",s=new RegExp(`${(0,v.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const P of this.profiles){const M=s.exec(P.name),T=M?parseInt(M[1]):0;a=T>a?T:a}const u=`${r} ${a+1}`;return this.createProfile(u,void 0,i,!0)}async createProfile(i,r,s,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.doCreateProfile(i,r,a);return s&&await this.setProfileForWorkspace(s,u),u}async doCreateProfile(i,r,s){let a=this.profileCreationPromises.get(i);return a||(a=(async()=>{try{const u=this.profiles.find(T=>T.name===i);if(u)return u;const P=c(i,(0,R.joinPath)(this.profilesHome,(0,S.hash)((0,m.generateUuid)()).toString(16)),r,s);await this.fileService.createFolder(P.location);const M=[];return this._onWillCreateProfile.fire({profile:P,join(T){M.push(T)}}),await w.Promises.settled(M),this.updateProfiles([P],[],[]),P}finally{this.profileCreationPromises.delete(i)}})(),this.profileCreationPromises.set(i,a)),a}async updateProfile(i,r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(u=>u.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=c(r,a.location,s),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const s=[];this._onWillRemoveProfile.fire({profile:r,join(a){s.push(a)}}),await w.Promises.settled(s),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(i,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let s=this.getProfileForWorkspace(i);return s||(s=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(i,s)),s}async setProfileForWorkspace(i,r){this.setProfileForWorkspaceSync(i,r)}setProfileForWorkspaceSync(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(i,s)}unsetWorkspace(i,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(i,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(s=>!this.uriIdentityService.extUri.isEqual(s.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.getWorkspace(i);return C.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(i){return(0,f.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,f.isWorkspaceIdentifier)(i)?i.configPath:"empty-window"}isProfileAssociatedToWorkspace(i){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,i.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,i.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,i.location)))}updateProfiles(i,r,s){const a=[...this.profiles,...i],u=[];this.transientProfilesObject.profiles=[];for(let P of a)P.isDefault||r.some(M=>P.id===M.id)||(P=s.find(M=>P.id===M.id)??P,P.isTransient?this.transientProfilesObject.profiles.push(P):u.push({location:P.location,name:P.name,useDefaultFlags:P.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(i,r,s)}triggerProfilesChanges(i,r,s){this._onDidChangeProfiles.fire({added:i,removed:r,updated:s,all:this.profiles})}updateWorkspaceAssociation(i,r,s){s=r?.isTransient?!0:s,s||this.updateWorkspaceAssociation(i,void 0,!0);const a=this.getWorkspace(i),u=s?this.transientProfilesObject:this.profilesObject;C.URI.isUri(a)?(u.workspaces.delete(a),r&&u.workspaces.set(a,r)):u.emptyWindow=r,s||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[s,a]of this.profilesObject.workspaces.entries())i[s.toString()]=a.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:i,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=ve([Y(0,g.IEnvironmentService),Y(1,I.IFileService),Y(2,b.IUriIdentityService),Y(3,y.ILogService)],n),e.UserDataProfilesService=n}),define(J[89],Z([0,1,24,8,49,18,17,43,136,2,13,9,4,16,187,94,12,7,155,36,109,108,186,14,5,6,20,3,67,72,39,55,185]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P,M,T,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(K){function $(_,A){if(_===A)return!0;const W=Object.keys(_),z=new Set;for(const ee of Object.keys(A))z.add(ee);if(W.length!==z.size)return!1;for(const ee of W){if(_[ee]!==A[ee])return!1;z.delete(ee)}return z.size===0}K.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let Q=class extends g.Disposable{constructor($,_,A,W,z,ee,B,j,L,O,N){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=_,this.extensionsControlLocation=A,this.cacheLocation=W,this.userDataProfilesService=z,this.extensionsProfileScannerService=ee,this.fileService=B,this.logService=j,this.environmentService=L,this.productService=O,this.instantiationService=N,this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,f.joinPath)(this.cacheLocation,c.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ue,(0,f.joinPath)(this.cacheLocation,c.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(le,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,p.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,_,A){const[W,z]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(_)]),ee=A?await this.scanExtensionsUnderDevelopment($,[...W,...z]):[];return this.dedupExtensions(W,z,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const _=[];_.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),_.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[A,W]=await Promise.all(_);return this.applyScanOptions([...A,...W],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const _=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let W=await($.useCache&&!_.devMode&&_.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(_);return W=await this.applyScanOptions(W,1,$,!0),this.logService.trace("Scanned user extensions:",W.length),W}async scanExtensionsUnderDevelopment($,_){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const A=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(W=>W.scheme===I.Schemas.file).map(async W=>{const z=await this.createExtensionScannerInput(W,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(z)).map(B=>(B.type=_.find(j=>(0,p.areSameExtensions)(j.identifier,B.identifier))?.type??B.type,this.extensionsScanner.validate(B,z)))}))).flat();return this.applyScanOptions(A,"development",$,!0)}return[]}async scanExistingExtension($,_,A){const W=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanExtension(W);return!z||!A.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions($,_,A){const W=await this.createExtensionScannerInput($,!1,_,!0,A.language),z=await this.extensionsScanner.scanOneOrMultipleExtensions(W);return this.applyScanOptions(z,_,A,!0)}async scanMetadata($){const _=(0,f.joinPath)($,"package.json"),A=(await this.fileService.readFile(_)).value.toString();return JSON.parse(A).__metadata}async updateMetadata($,_){const A=(0,f.joinPath)($,"package.json"),W=(await this.fileService.readFile(A)).value.toString(),z=JSON.parse(W);_.isMachineScoped=_.isMachineScoped||void 0,_.isBuiltin=_.isBuiltin||void 0,_.installedTimestamp=_.installedTimestamp||void 0,z.__metadata={...z.__metadata,..._},await this.fileService.writeFile((0,f.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(z,null,"	")))}async applyScanOptions($,_,A,W){return A.includeAllVersions||($=this.dedupExtensions(_===0?$:void 0,_===1?$:void 0,_==="development"?$:void 0,await this.getTargetPlatform(),W)),A.includeInvalid||($=$.filter(z=>z.isValid)),$.sort((z,ee)=>{const B=E.basename(z.location.fsPath),j=E.basename(ee.location.fsPath);return B<j?-1:B>j?1:0})}dedupExtensions($,_,A,W,z){const ee=(j,L,O)=>{if(j.isValid&&!L.isValid)return!1;if(j.isValid===L.isValid){if(z&&h.gt(j.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(h.eq(j.manifest.version,L.manifest.version)){if(j.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===W)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return O?this.logService.warn(`Overwriting user extension ${j.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${j.location.path} with ${L.location.path}.`),!0},B=new Map;return $?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);(!O||ee(O,j,!1))&&B.set(L,j)}),_?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);if(!O&&$&&j.type===0){this.logService.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!O||ee(O,j,!1))&&B.set(L,j)}),A?.forEach(j=>{const L=c.ExtensionIdentifier.toKey(j.identifier.id),O=B.get(L);(!O||ee(O,j,!0))&&B.set(L,j),B.set(L,j)}),[...B.values()]}async scanDefaultSystemExtensions($,_){this.logService.trace("Started scanning system extensions");const A=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,_),z=await($&&!A.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(A);return this.logService.trace("Scanned system extensions:",z.length),z}async scanDevSystemExtensions($,_){const A=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!A?.length)return[];this.logService.trace("Started scanning dev system extensions");const W=_?await this.getBuiltInExtensionControl():{},z=[],ee=m.URI.file(E.normalize(E.join(I.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions")));for(const j of A){const L=W[j.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":z.push((0,f.joinPath)(ee,j.name));break;default:z.push(m.URI.file(L));break}}const B=await Promise.all(z.map(async j=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(j,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",B.length),(0,S.coalesce)(B)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,_,A,W,z,ee=!0){const B=await this.getTranslations(z??y.language),j=await this.getMtime($),L=_?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,O=L?await this.getMtime(L):void 0;return new re($,j,L,O,_,A,W,ee,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,z,B)}async getMtime($){try{const _=await this.fileService.stat($);if(typeof _.mtime=="number")return _.mtime}catch{}}};Q=ve([Y(4,M.IUserDataProfilesService),Y(5,P.IExtensionsProfileScannerService),Y(6,o.IFileService),Y(7,r.ILogService),Y(8,d.IEnvironmentService),Y(9,s.IProductService),Y(10,i.IInstantiationService)],Q),e.AbstractExtensionsScannerService=Q;class re{constructor($,_,A,W,z,ee,B,j,L,O,N,V,x,ne){this.location=$,this.mtime=_,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=W,this.profile=z,this.type=ee,this.excludeObsolete=B,this.validate=j,this.productVersion=L,this.productDate=O,this.productCommit=N,this.devMode=V,this.language=x,this.translations=ne}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,_){return(0,f.isEqual)($.location,_.location)&&$.mtime===_.mtime&&(0,f.isEqual)($.applicationExtensionslocation,_.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&$.profile===_.profile&&$.type===_.type&&$.excludeObsolete===_.excludeObsolete&&$.validate===_.validate&&$.productVersion===_.productVersion&&$.productDate===_.productDate&&$.productCommit===_.productCommit&&$.devMode===_.devMode&&$.language===_.language&&U.equals($.translations,_.translations)}}let le=class extends g.Disposable{constructor($,_,A,W,z){super(),this.obsoleteFile=$,this.extensionsProfileScannerService=_,this.uriIdentityService=A,this.fileService=W,this.logService=z}async scanExtensions($){const _=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let A={};if($.excludeObsolete&&$.type===1)try{const W=(await this.fileService.readFile(this.obsoleteFile)).value.toString();A=JSON.parse(W)}catch{}return(0,w.isEmptyObject)(A)?_:_.filter(W=>!A[p.ExtensionKey.create(W).toString()])}async scanExtensionsFromLocation($){const _=await this.fileService.resolve($.location);if(!_.children?.length)return[];const A=await Promise.all(_.children.map(async W=>{if(!W.isDirectory||$.type===1&&(0,f.basename)(W.resource).indexOf(".")===0)return null;const z=new re(W.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(z)}));return(0,S.coalesce)(A).sort((W,z)=>W.location.path<z.location.path?-1:1)}async scanExtensionsFromProfile($){let _=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){_=_.filter(W=>!W.metadata?.isApplicationScoped);const A=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,W=>!!W.metadata?.isApplicationScoped,$);_.push(...A)}return _}async scanExtensionsFromProfileResource($,_,A){const W=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!W.length)return[];const z=await Promise.all(W.map(async ee=>{if(_(ee)){const B=new re(ee.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(B,ee.metadata)}return null}));return(0,S.coalesce)(z)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,f.joinPath)($.location,"package.json"))){const _=await this.scanExtension($);return _?[_]:[]}else return await this.scanExtensions($)}catch(_){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,D.getErrorMessage)(_)),[]}}async scanExtension($,_){try{let A=await this.scanExtensionManifest($.location);if(A){A.publisher||(A.publisher=c.UNDEFINED_PUBLISHER),_=_??A.__metadata,delete A.__metadata;const W=(0,p.getGalleryExtensionId)(A.publisher,A.name),z=_?.id?{id:W,uuid:_.id}:{id:W},ee=_?.isSystem?0:$.type,B=ee===0||!!_?.isBuiltin;A=await this.translateManifest($.location,A,re.createNlsConfiguration($));const j={type:ee,identifier:z,manifest:A,location:$.location,isBuiltin:B,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return $.validate?this.validate(j,$):j}}catch(A){$.type!==0&&this.logService.error(A)}return null}validate($,_){let A=!0;const W=(0,n.validateExtensionManifest)(_.productVersion,_.productDate,_.location,$.manifest,$.isBuiltin);for(const[z,ee]of W)z===b.default.Error&&(A=!1,this.logService.error(this.formatMessage(_.location,ee)));return $.isValid=A,$.validations=W,$}async scanExtensionManifest($){const _=(0,f.joinPath)($,"package.json");let A;try{A=(await this.fileService.readFile(_)).value.toString()}catch(z){return(0,o.toFileOperationResult)(z)!==1&&this.logService.error(this.formatMessage($,(0,v.localize)(0,null,_.path,z.message))),null}let W;try{W=JSON.parse(A)}catch{const ee=[];(0,C.parse)(A,ee);for(const B of ee)this.logService.error(this.formatMessage($,(0,v.localize)(1,null,_.path,B.offset,B.length,(0,l.getParseErrorMessage)(B.error))));return null}return(0,C.getNodeType)(W)!=="object"?(this.logService.error(this.formatMessage($,(0,v.localize)(2,null,_.path))),null):W}async translateManifest($,_,A){const W=await this.getLocalizedMessages($,_,A);if(W)try{const z=[],ee=await this.resolveOriginalMessageBundle(W.default,z);if(z.length>0)return z.forEach(j=>{this.logService.error(this.formatMessage($,(0,v.localize)(3,null,W.default?.path,(0,l.getParseErrorMessage)(j.error))))}),_;if((0,C.getNodeType)(W)!=="object")return this.logService.error(this.formatMessage($,(0,v.localize)(4,null,W.default?.path))),_;const B=W.values||Object.create(null);return(0,F.localizeManifest)(_,B,ee)}catch{}return _}async getLocalizedMessages($,_,A){const W=(0,f.joinPath)($,"package.nls.json"),z=(L,O)=>{O.forEach(N=>{this.logService.error(this.formatMessage($,(0,v.localize)(5,null,L?.path,(0,l.getParseErrorMessage)(N.error))))})},ee=L=>{this.logService.error(this.formatMessage($,(0,v.localize)(6,null,L?.path)))},B=`${_.publisher}.${_.name}`,j=A.translations[B];if(j)try{const L=m.URI.file(j),O=(await this.fileService.readFile(L)).value.toString(),N=[],V=(0,C.parse)(O,N);return N.length>0?(z(L,N),{values:void 0,default:W}):(0,C.getNodeType)(V)!=="object"?(ee(L),{values:void 0,default:W}):{values:V.contents?V.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.fileService.exists(W))return;let O;try{O=await this.findMessageBundles($,A)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const N=(await this.fileService.readFile(O.localized)).value.toString(),V=[],x=(0,C.parse)(N,V);return V.length>0?(z(O.localized,V),{values:void 0,default:O.original}):(0,C.getNodeType)(x)!=="object"?(ee(O.localized),{values:void 0,default:O.original}):{values:x,default:O.original}}catch{return{values:void 0,default:O.original}}}}async resolveOriginalMessageBundle($,_){if($)try{const A=(await this.fileService.readFile($)).value.toString();return(0,C.parse)(A,_)}catch{}}findMessageBundles($,_){return new Promise((A,W)=>{const z=ee=>{const B=(0,f.joinPath)($,`package.nls.${ee}.json`);this.fileService.exists(B).then(j=>{j&&A({localized:B,original:(0,f.joinPath)($,"package.nls.json")});const L=ee.lastIndexOf("-");L===-1?A({localized:(0,f.joinPath)($,"package.nls.json"),original:null}):(ee=ee.substring(0,L),z(ee))})};if(_.devMode||_.pseudo||!_.language)return A({localized:(0,f.joinPath)($,"package.nls.json"),original:null});z(_.language)})}formatMessage($,_){return`[${$.path}]: ${_}`}};le=ve([Y(1,P.IExtensionsProfileScannerService),Y(2,T.IUriIdentityService),Y(3,o.IFileService),Y(4,r.ILogService)],le);let ue=class extends le{constructor($,_,A,W,z,ee){super(_,A,W,z,ee),this.cacheFile=$,this.cacheValidatorThrottler=this._register(new t.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new a.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const _=await this.readExtensionCache();if(this.input=$,_&&_.input&&re.equals(_.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),_.result.map(W=>(W.location=m.URI.revive(W.location),W));const A=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:A}),A}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),_=JSON.parse($.value.toString());return{result:_.result,input:(0,u.revive)(_.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,R.VSBuffer.fromString(JSON.stringify($)))}catch(_){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,D.getErrorMessage)(_))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const _=$.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(A,_))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(W){this.logService.error(W)}}};ue=ve([Y(2,P.IExtensionsProfileScannerService),Y(3,T.IUriIdentityService),Y(4,o.IFileService),Y(5,r.ILogService)],ue);function se(K,$){const _=(0,p.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:_,identifier:new c.ExtensionIdentifier(_),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:$,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=se;class de extends Q{constructor($,_,A,W,z,ee,B,j,L,O,N){super($,_,(0,f.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(W,c.MANIFEST_CACHE_FOLDER),z,ee,B,j,L,O,N),this.translationsPromise=(async()=>{if(y.translationsConfigFile)try{const V=await this.fileService.readFile(m.URI.file(y.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=de}),define(J[251],Z([0,1,7,36,72,89,14,5,6,20,39]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends R.NativeExtensionsScannerService{constructor(f,h,b,w,m,v,d){super(S.URI.file(m.builtinExtensionsPath),S.URI.file(m.extensionsPath),m.userHome,S.URI.file(m.userDataPath),f,h,b,w,m,v,d)}};E=ve([Y(0,I.IUserDataProfilesService),Y(1,k.IExtensionsProfileScannerService),Y(2,D.IFileService),Y(3,l.ILogService),Y(4,t.INativeEnvironmentService),Y(5,g.IProductService),Y(6,C.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(J[252],Z([0,1,15,40,2,32,13,9,4,7,28,36,6,39]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let h=class extends k.Disposable{constructor(w,m,v){super(),this.environmentService=w,this.logService=v,this.validRoots=R.TernarySearchTree.forPaths(!l.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(m.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(w.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:w}=S.session;w.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(m,v)=>this.handleResourceRequest(m,v)),w.protocol.interceptFileProtocol(D.Schemas.file,(m,v)=>this.handleFileRequest(m,v)),this._register((0,k.toDisposable)(()=>{w.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(w){const m=(0,C.normalize)(w);return this.validRoots.get(m)?k.Disposable.None:(this.validRoots.set(m,!0),(0,k.toDisposable)(()=>this.validRoots.delete(m)))}handleFileRequest(w,m){const v=g.URI.parse(w.url);return this.logService.error(`Refused to load resource ${v.fsPath} from ${D.Schemas.file}: protocol (original URL: ${w.url})`),m({error:-3})}handleResourceRequest(w,m){const v=this.requestToNormalizedFilePath(w);let d;return this.environmentService.crossOriginIsolated&&(v.endsWith("/workbench.html")?d=D.COI.CoopAndCoep:d=D.COI.getHeadersFromQuery(w.url)),this.validRoots.findSubstr(v)?m({path:v,headers:d}):this.validExtensions.has((0,C.extname)(v).toLowerCase())?m({path:v}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${v} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),m({error:-3}))}requestToNormalizedFilePath(w){const m=g.URI.parse(w.url),v=D.FileAccess.asFileUri(m);return(0,C.normalize)(v.fsPath)}createIPCObjectUrl(){let w;const m=g.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),v=m.toString(),d=async()=>w;return t.validatedIpcMain.handle(v,d),this.logService.trace(`IPC Object URL: Registered new channel ${v}.`),{resource:m,update:p=>w=p,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${v}.`),t.validatedIpcMain.removeHandler(v)}}}};h=ve([Y(0,E.INativeEnvironmentService),Y(1,f.IUserDataProfilesService),Y(2,y.ILogService)],h),e.ProtocolMainService=h}),define(J[253],Z([0,1,15,40,8,3,2,13,12,99,26,21,6,53,61,64,44,39,38]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let d=class extends D.Disposable{constructor(c,n,o,i,r,s,a,u,P){super(),this.machineId=c,this.userEnv=n,this.environmentMainService=o,this.userDataProfilesService=i,this.lifecycleMainService=r,this.logService=s,this.policyService=a,this.themeMainService=u,this.protocolMainService=P,this.firstWindowConnectionBarrier=new k.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(c,n)=>this.onWindowConnection(c,n)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(c,n)=>this.onWorkerConnection(c,n)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(c,n){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",n,[o])}onWorkerConnection(c,n){this.logService.trace("SharedProcess: onWorkerConnection",n);const o=new D.DisposableStore,i=s=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${s}')`,n),o.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",n))},r=S.BrowserWindow.fromId(n.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!n.reply.channel){i("unavailable");return}o.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,s=>s.window.win===r)(()=>i("load"))),o.add(R.Event.fromNodeEventEmitter(r,"closed")(()=>i("closed"))),r.webContents.postMessage(n.reply.channel,n.reply.nonce,c.ports)}onWillShutdown(){const c=this.window;!c||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch{}this.window=void 0},0))}send(c,...n){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${c}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(c,...n)}catch(o){this.logService.warn(`Error sending IPC message to channel '${c}' of shared process: ${(0,w.toErrorMessage)(o)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new S.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:f.default,policiesData:this.policyService.serialize()}),this.window.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,n)=>this._onDidError.fire({type:2,details:n})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,n,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:n}})))}async connect(){await this.whenIpcReady;const c=(0,l.assertIsDefined)(this.window);return(0,g.connect)(c)}async toggle(){await this.whenIpcReady,this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const c=this.window;return c?!c.isDestroyed()&&!c.webContents.isDestroyed():!1}};d=ve([Y(2,I.IEnvironmentMainService),Y(3,m.IUserDataProfilesService),Y(4,E.ILifecycleMainService),Y(5,y.ILogService),Y(6,v.IPolicyService),Y(7,b.IThemeMainService),Y(8,h.IProtocolMainService)],d),e.SharedProcess=d}),define(J[115],Z([0,1,8,3,2,71,12,100,5,39]),function(q,e,S,t,k,R,D,C,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,l.createDecorator)("storageService");var E;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class h extends k.Disposable{constructor(d={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=d,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new S.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,S.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,p){if(p===I){switch(d){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:d})}else this._onDidChangeValue.fire({scope:d,key:p,target:this.getKeyTargets(d)[p]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,p,c){return this.getStorage(p)?.get(d,c)}getBoolean(d,p,c){return this.getStorage(p)?.getBoolean(d,c)}getNumber(d,p,c){return this.getStorage(p)?.getNumber(d,c)}store(d,p,c,n){if((0,D.isUndefinedOrNull)(p)){this.remove(d,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,c,n),this.getStorage(c)?.set(d,p)})}remove(d,p){this.withPausedEmitters(()=>{this.updateKeyTarget(d,p,void 0),this.getStorage(p)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,p){const c=[],n=this.getKeyTargets(d);for(const o of Object.keys(n))n[o]===p&&c.push(o);return c}updateKeyTarget(d,p,c){const n=this.getKeyTargets(p);typeof c=="number"?n[d]!==c&&(n[d]=c,this.getStorage(p)?.set(I,JSON.stringify(n))):typeof n[d]=="number"&&(delete n[d],this.getStorage(p)?.set(I,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(d){switch(d){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(d){const p=this.get(I,d);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=E.NONE){this._onWillSaveState.fire({reason:d});const p=this.getStorage(-1),c=this.getStorage(0),n=this.getStorage(1);switch(d){case E.NONE:await S.Promises.settled([p?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await S.Promises.settled([p?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.getStorage(-1)?.items??new Map,p=this.getStorage(0)?.items??new Map,c=this.getStorage(1)?.items??new Map;return m(d,p,c,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(d,p){return this.emitWillSaveState(E.NONE),(0,g.isUserDataProfile)(d)?this.switchToProfile(d,p):this.switchToWorkspace(d,p)}canSwitchProfile(d,p){return!(d.id===p.id||b(p)&&b(d))}switchData(d,p,c,n){this.withPausedEmitters(()=>{if(n)for(const[o,i]of d)p.set(o,i);else{const o=new Set;for(const[i,r]of d)o.add(i),p.get(i)!==r&&this.emitDidChangeValue(c,i);for(const[i]of p.items)o.has(i)||this.emitDidChangeValue(c,i)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function b(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=b;class w extends h{constructor(){super(),this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.profileStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),this._register(this.applicationStorage.onDidChangeStorage(d=>this.emitDidChangeValue(-1,d)))}getStorage(d){switch(d){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function m(v,d,p,c,n,o){const i=U=>{try{return JSON.parse(U)}catch{return U}},r=new Map,s=new Map;v.forEach((U,Q)=>{r.set(Q,U),s.set(Q,i(U))});const a=new Map,u=new Map;d.forEach((U,Q)=>{a.set(Q,U),u.set(Q,i(U))});const P=new Map,M=new Map;p.forEach((U,Q)=>{P.set(Q,U),M.set(Q,i(U))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const T=[];if(r.forEach((U,Q)=>{T.push({key:Q,value:U})}),console.table(T),console.groupEnd(),console.log(s),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const U=[];a.forEach((Q,re)=>{U.push({key:re,value:Q})}),console.table(U),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${o})`);const F=[];P.forEach((U,Q)=>{F.push({key:Q,value:U})}),console.table(F),console.groupEnd(),console.log(M)}e.logStorage=m}),define(J[254],Z([0,1,24,8,3,2,9,79,7,23,100,147,6,115,37,27]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class w extends R.Disposable{constructor(o,i){super(),this.logService=o,this.fileService=i,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new k.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=I.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===I.StorageState.None)try{const o=await this.doCreate();this._storage.dispose(),this._storage=o,this._register(o.onDidChangeStorage(r=>this._onDidChangeStorage.fire({key:r}))),await this.doInit(o);const i=o.getBoolean(f.IS_NEW_KEY);i===void 0?o.set(f.IS_NEW_KEY,!0):i&&o.set(f.IS_NEW_KEY,!1)}catch(o){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.state=I.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===y.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this._storage.items}get(o,i){return this._storage.get(o,i)}set(o,i){return this._storage.set(o,i)}delete(o){return this._storage.delete(o)}async close(){const o=new C.StopWatch(!1);await this.doClose(),o.stop(),o.elapsed()>w.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(o),this._onDidCloseStorage.fire()}async logSlowClose(o){if(!!this.path)try{const i=(0,S.top)(Array.from(this._storage.items.entries()).map(([s,a])=>({key:s,length:a.length})),(s,a)=>a.length-s.length,5).map(s=>`${s.key}:${s.length}`).join(", "),r=(await this.fileService.stat(l.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=I.StorageState.Closed,await this._storage.close()}}w.LOG_SLOW_CLOSE_THRESHOLD=2e3;class m extends w{constructor(o,i,r,s){super(r,s),this.profile=o,this.options=i}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.profile.globalStorageHome.fsPath,m.STORAGE_NAME)}async doCreate(){return new I.Storage(new E.SQLiteStorageDatabase(this.path??E.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}m.STORAGE_NAME="state.vscdb";class v extends m{constructor(o,i,r,s){super(o,i,r,s)}}e.ProfileStorageMain=v;class d extends m{constructor(o,i,r,s){super(i.defaultProfile,o,r,s)}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(h.firstSessionDateStorageKey,void 0)===void 0&&o.set(h.firstSessionDateStorageKey,new Date().toUTCString());const r=o.get(h.currentSessionDateStorageKey,void 0),s=new Date().toUTCString();o.set(h.lastSessionDateStorageKey,typeof r>"u"?null:r),o.set(h.currentSessionDateStorageKey,s)}}e.ApplicationStorageMain=d;class p extends w{constructor(o,i,r,s,a){super(r,a),this.workspace=o,this.options=i,this.environmentService=s}get path(){if(!this.options.useInMemoryStorage)return(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,p.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:o,wasCreated:i}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new E.SQLiteStorageDatabase(o,{logging:this.createLoggingOptions()}),{hint:i?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),i=(0,D.join)(o,p.WORKSPACE_STORAGE_NAME);return await g.Promises.exists(o)?{storageFilePath:i,wasCreated:!1}:(await g.Promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:i,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let i;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?i={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(i={workspace:this.workspace.configPath.toString()}),i)try{const r=(0,D.join)(o,p.WORKSPACE_META_NAME);await g.Promises.exists(r)||await g.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}e.WorkspaceStorageMain=p,p.WORKSPACE_STORAGE_NAME="state.vscdb",p.WORKSPACE_META_NAME="workspace.json";class c extends w{get path(){}async doCreate(){return new I.Storage(new I.InMemoryStorageDatabase)}}e.InMemoryStorageMain=c}),define(J[255],Z([0,1,67,36,14,6,224,55,39]),function(q,e,S,t,k,R,D,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let g=class Dt extends l.UserDataProfilesService{constructor(E,y,f,h,b){super(f,h,y,b),this.stateService=E}getStoredProfiles(){return(0,S.revive)(this.stateService.getItem(Dt.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,S.revive)(this.stateService.getItem(Dt.PROFILE_ASSOCIATIONS_KEY,{}))}};g=ve([Y(0,D.IStateService),Y(1,C.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,R.ILogService)],g),e.UserDataProfilesService=g}),define(J[42],Z([0,1,7,36,14,5,6,41,55,39,255]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(g.IUserDataProfilesService);let E=class lt extends I.UserDataProfilesService{constructor(f,h,b,w,m){super(f,h,b,w,m),this.stateMainService=f}setEnablement(f){super.setEnablement(f),this.enabled||(this.saveStoredProfiles([]),this.saveStoredProfileAssociations({}))}isEnabled(){return this.enabled}checkAndCreateProfileFromCli(f){if(!!this.isEnabled()){if(f.profile){const h=this.profiles.find(b=>b.name===f.profile);return h?Promise.resolve(h):this.createProfile(f.profile)}if(f["profile-temp"])return this.createTransientProfile()}}saveStoredProfiles(f){f.length?this.stateMainService.setItem(lt.PROFILES_KEY,f):this.stateMainService.removeItem(lt.PROFILES_KEY)}saveStoredProfileAssociations(f){f.emptyWindow||f.workspaces?this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,f):this.stateMainService.removeItem(lt.PROFILE_ASSOCIATIONS_KEY)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",h=this.stateMainService.getItem(f,void 0);if(h){this.stateMainService.removeItem(f);const b=h.reduce((w,{workspace:m,profile:v})=>(w[S.URI.revive(m).toString()]=S.URI.revive(v).toString(),w),{});this.stateMainService.setItem(lt.PROFILE_ASSOCIATIONS_KEY,{workspaces:b})}return super.getStoredProfileAssociations()}};E=ve([Y(0,C.IStateMainService),Y(1,l.IUriIdentityService),Y(2,t.IEnvironmentService),Y(3,k.IFileService),Y(4,D.ILogService)],E),e.UserDataProfilesMainService=E}),define(J[256],Z([0,1,2,16,72,89,14,6,39,42]),function(q,e,S,t,k,R,D,C,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let I=class extends S.Disposable{constructor(y,f,h,b,w){super(),this.userDataProfilesService=y,this.fileService=f,this.extensionsScannerService=h,this.extensionsProfileScannerService=b,y.isEnabled()?(this._register(y.onWillCreateProfile(m=>{y.profiles.length===1&&m.join(this.initialize())})),this._register(y.onDidChangeProfiles(m=>{y.profiles.length===1&&this.uninitialize()}))):this.uninitialize().then(null,m=>w.error(m))}async initialize(){const y=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(y)}catch{}const f=await this.extensionsScannerService.scanUserExtensions({includeInvalid:!0});await this.extensionsProfileScannerService.addExtensionsToProfile(f.map(h=>[h,h.metadata]),y)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,t.joinPath)(this.userDataProfilesService.defaultProfile.location,l.EXTENSIONS_RESOURCE_NAME)}};I=ve([Y(0,g.IUserDataProfilesMainService),Y(1,D.IFileService),Y(2,R.IExtensionsScannerService),Y(3,k.IExtensionsProfileScannerService),Y(4,C.ILogService)],I),e.DefaultExtensionsProfileInitHandler=I}),define(J[257],Z([0,1,15,24,4,7,23,19,59,5,6,113,33,42]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,g.createDecorator)(e.ID);let h=class{constructor(w,m,v,d,p){this.logService=w,this.windowsMainService=m,this.urlService=v,this.configurationService=d,this.userDataProfilesMainService=p}async start(w,m){this.logService.trace("Received data from other instance: ",w,m),k.isMacintosh&&S.app.focus({steal:!0});const v=this.parseOpenUrl(w);if(v.length){let d=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(d=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),d.then(()=>{for(const{uri:p,url:c}of v)this.urlService.open(p,{originalUrl:c})})}else return this.startOpenWindow(w,m)}parseOpenUrl(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,t.coalesce)(w._urls.map(m=>{try{return{uri:R.URI.parse(m),url:m}}catch{return null}})):[]}async startOpenWindow(w,m){const v=(0,l.isLaunchedFromCli)(m)?0:4;let d=[];const p=w.wait&&w.waitMarkerFilePath?R.URI.file(w.waitMarkerFilePath):void 0,c=w.remote||void 0,n=this.userDataProfilesMainService.checkAndCreateProfileFromCli(w),o=n?await n:void 0,i={context:v,cli:w,userEnv:m,waitMarkerFileURI:p,remoteAuthority:c,profile:o};if(w.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,i);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let r=!1;if(w["new-window"]||w["unity-launch"]||o)r=!0;else if(w["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!k.isMacintosh}if(r)d=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const s=this.windowsMainService.getLastActiveWindow();s?(this.windowsMainService.openExistingWindow(s,i),d=[s]):d=this.windowsMainService.open({...i,forceEmpty:!0})}}else d=this.windowsMainService.open({...i,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(p&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,D.whenDeleted)(p.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}};h=ve([Y(0,I.ILogService),Y(1,y.IWindowsMainService),Y(2,E.IURLService),Y(3,C.IConfigurationService),Y(4,f.IUserDataProfilesMainService)],h),e.LaunchMainService=h}),define(J[90],Z([0,1,48,2,36,14,5,21,6,115,254,39,42]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let f=class extends t.Disposable{constructor(w,m,v,d,p){super(),this.logService=w,this.environmentService=m,this.userDataProfilesService=v,this.lifecycleMainService=d,this.fileService=p,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>(await this.lifecycleMainService.when(3),this.applicationStorage.init()))(),this._register(this.lifecycleMainService.onWillLoadWindow(w=>{w.window.profile&&this.profileStorage(w.window.profile).init(),w.workspace&&this.workspaceStorage(w.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(w=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=w.reason,w.join(this.applicationStorage.close());for(const[,m]of this.mapProfileToStorage)w.join(m.close());for(const[,m]of this.mapWorkspaceToStorage)w.join(m.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(w=>{w.join((async()=>{await this.fileService.exists(w.profile.globalStorageHome)||await this.fileService.createFolder(w.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(w=>{const m=this.mapProfileToStorage.get(w.profile.id);m&&w.join(m.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const w=new I.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,S.once)(w.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),w}profileStorage(w){if((0,g.isProfileUsingDefaultStorage)(w))return this.applicationStorage;let m=this.mapProfileToStorage.get(w.id);return m||(this.logService.trace(`StorageMainService: creating profile storage (${w.name})`),m=this.createProfileStorage(w),this.mapProfileToStorage.set(w.id,m),(0,S.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${w.name})`),this.mapProfileToStorage.delete(w.id)})),m}createProfileStorage(w){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.ProfileStorageMain(w,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(w){let m=this.mapWorkspaceToStorage.get(w.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${w.id})`),m=this.createWorkspaceStorage(w),this.mapWorkspaceToStorage.set(w.id,m),(0,S.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${w.id})`),this.mapWorkspaceToStorage.delete(w.id)})),m}createWorkspaceStorage(w){return this.shutdownReason===2?new I.InMemoryStorageMain(this.logService,this.fileService):new I.WorkspaceStorageMain(w,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};f=ve([Y(0,l.ILogService),Y(1,k.IEnvironmentService),Y(2,y.IUserDataProfilesMainService),Y(3,C.ILifecycleMainService),Y(4,R.IFileService)],f),e.StorageMainService=f,e.IApplicationStorageMainService=(0,D.createDecorator)("applicationStorageMainService");let h=class extends g.AbstractStorageService{constructor(w,m){super(),this.userDataProfilesService=w,this.storageMainService=m,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(w){if(w===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(w){if(w===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};h=ve([Y(0,E.IUserDataProfilesService),Y(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(J[258],Z([0,1,2,21,42]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends S.Disposable{constructor(C,l){super(),this.userDataProfilesService=l,this._register(C.onWillLoadWindow(g=>{g.reason===2&&this.unsetTransientProfileForWorkspace(g.window.openedWorkspace??"empty-window")})),this._register(C.onBeforeCloseWindow(g=>this.unsetTransientProfileForWorkspace(g.openedWorkspace??"empty-window")))}async unsetTransientProfileForWorkspace(C){this.userDataProfilesService.getOrSetProfileForWorkspace(C).isTransient&&(this.userDataProfilesService.unsetWorkspace(C,!0),await this.userDataProfilesService.cleanUpTransientProfiles())}};R=ve([Y(0,t.ILifecycleMainService),Y(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(J[116],Z([0,1,16,7,27]),function(q,e,S,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(l,g,I){for(const y of l){const f=y.openedWorkspace;if((0,k.isWorkspaceIdentifier)(f)){const h=I(f);if(h){if(h.folders.some(b=>S.extUriBiasedIgnorePathCase.isEqualOrParent(g,b.uri)))return y}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(g,f.configPath))return y}}const E=l.filter(y=>(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(g,y.openedWorkspace.uri));if(E.length)return E.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(l,g){for(const I of l)if((0,k.isWorkspaceIdentifier)(I.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.configPath,g)||(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(I.openedWorkspace.uri,g))return I}e.findWindowOnWorkspaceOrFolder=D;function C(l,g){const I=E=>g.some(y=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(E)));for(const E of l)if(E.config?.extensionDevelopmentPath?.some(y=>I(y)))return E}e.findWindowOnExtensionDevelopmentPath=C}),define(J[259],Z([0,1,15,2,4,16,7,19,21,6,41,33,114,27]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let h=class Rt extends t.Disposable{constructor(p,c,n,o,i){super(),this.windowsMainService=p,this.stateMainService=c,this.lifecycleMainService=n,this.logService=o,this.configurationService=i,this._state=b(this.stateMainService.getItem(Rt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){S.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(p=>this.onBeforeCloseWindow(p)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(p=>{p.newCount-p.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(p=>this.onBeforeCloseWindow(p))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const p=new Set,c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(c.lastActiveWindow=this.toWindowState(i),c.lastActiveWindow.uiState.mode===3&&p.add(c.lastActiveWindow.uiState.display))}const n=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);n&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(n),c.lastPluginDevelopmentHostWindow.uiState.mode===3&&(p.has(c.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!n.win?.isSimpleFullScreen()&&(c.lastPluginDevelopmentHostWindow.uiState.mode=1):p.add(c.lastPluginDevelopmentHostWindow.uiState.display))),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.toWindowState(i);return r.uiState.mode===3&&(p.has(r.uiState.display)?k.isMacintosh&&r.windowId!==c.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):p.add(r.uiState.display)),r}));const o=m(c);this.stateMainService.setItem(Rt.windowsStateStorageKey,o),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",o)}onBeforeCloseWindow(p){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(p);p.isExtensionDevelopmentHost&&!p.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!p.isExtensionDevelopmentHost&&p.openedWorkspace&&this._state.openedWindows.forEach(n=>{const o=(0,f.isWorkspaceIdentifier)(p.openedWorkspace)&&n.workspace?.id===p.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&n.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(n.folderUri,p.openedWorkspace.uri);(o||i)&&(n.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(p){return{windowId:p.id,workspace:(0,f.isWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)?p.openedWorkspace.uri:void 0,backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.serializeWindowState()}}getNewWindowState(p){const c=this.doGetNewWindowState(p),n=this.configurationService.getValue("window");if(c.mode===3){let o;c.hasDefaultState?o=!!(n?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(n.newWindowDimensions)>=0):o=!!(this.lifecycleMainService.wasRestarted||n?.restoreFullscreen),o||(c.mode=1)}return c}doGetNewWindowState(p){const c=this.windowsMainService.getLastActiveWindow();if(!p.extensionTestsPath){if(!!p.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=p.workspace;if((0,f.isWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===a.id).map(M=>M.uiState);if(P.length)return P[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(a)){const P=this.state.openedWindows.filter(M=>M.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(M.folderUri,a.uri)).map(M=>M.uiState);if(P.length)return P[0]}else if(p.backupPath){const P=this.state.openedWindows.filter(M=>M.backupPath===p.backupPath).map(M=>M.uiState);if(P.length)return P[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!c&&u)return u.uiState}let n;const o=S.screen.getAllDisplays();if(o.length===1)n=o[0];else{if(k.isMacintosh){const a=S.screen.getCursorScreenPoint();n=S.screen.getDisplayNearestPoint(a)}!n&&c&&(n=S.screen.getDisplayMatching(c.getBounds())),n||(n=S.screen.getPrimaryDisplay()||o[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(n.bounds.x+n.bounds.width/2-i.width/2),i.y=Math.round(n.bounds.y+n.bounds.height/2-i.height/2);const r=this.configurationService.getValue("window");let s=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,s=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,s=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&c){const a=c.serializeWindowState();a.mode===3?i.mode=3:i=a,s=i.mode!==3&&r.newWindowDimensions==="offset"}}return s&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(p){if(this.windowsMainService.getWindows().length===0)return p;p.x=typeof p.x=="number"?p.x:0,p.y=typeof p.y=="number"?p.y:0;const c=this.windowsMainService.getWindows().map(n=>n.getBounds());for(;c.some(n=>n.x===p.x||n.y===p.y);)p.x+=30,p.y+=30;return p}};h.windowsStateStorageKey="windowsState",h=ve([Y(0,E.IWindowsMainService),Y(1,I.IStateMainService),Y(2,l.ILifecycleMainService),Y(3,g.ILogService),Y(4,C.IConfigurationService)],h),e.WindowsStateHandler=h;function b(d){const p={openedWindows:[]},c=d||{openedWindows:[]};return c.lastActiveWindow&&(p.lastActiveWindow=w(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(p.lastPluginDevelopmentHostWindow=w(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(p.openedWindows=c.openedWindows.map(n=>w(n))),p}e.restoreWindowsState=b;function w(d){const p={uiState:d.uiState};return d.backupPath&&(p.backupPath=d.backupPath),d.remoteAuthority&&(p.remoteAuthority=d.remoteAuthority),d.folder&&(p.folderUri=D.URI.parse(d.folder)),d.workspaceIdentifier&&(p.workspace={id:d.workspaceIdentifier.id,configPath:D.URI.parse(d.workspaceIdentifier.configURIPath)}),p}function m(d){return{lastActiveWindow:d.lastActiveWindow&&v(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&v(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(p=>v(p))}}e.getWindowsStateStoreData=m;function v(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(J[91],Z([0,1,31,43,123,35,13,9,4,16,7,5,63,27]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function h(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=h;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function w(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=w;function m(M){return v(M)||d(M)}e.isStoredWorkspaceFolder=m;function v(M){const T=M;return typeof T?.path=="string"&&(!T.name||typeof T.name=="string")}function d(M){const T=M;return typeof T?.uri=="string"&&(!T.name||typeof T.name=="string")}function p(M,T,F,U,Q){if(M.scheme!==U.scheme)return{name:F,uri:M.toString(!0)};let re=T?void 0:Q.relativePath(U,M);if(re!==void 0)re.length===0?re=".":l.isWindows&&(re=c(re));else if(M.scheme===D.Schemas.file)re=M.fsPath,l.isWindows&&(re=c(re));else if(Q.isEqualAuthority(M.authority,U.authority))re=M.path;else return{name:F,uri:M.toString(!0)};return{name:F,path:re}}e.getStoredWorkspaceFolder=p;function c(M){return M=(0,R.normalizeDriveLetter)(M),(0,S.isUNC)(M)||(M=(0,S.toSlashes)(M)),M}function n(M,T,F){const U=[],Q=new Set,re=F.dirname(T);for(const le of M){let ue;if(v(le))le.path&&(ue=F.resolvePath(re,le.path));else if(d(le))try{ue=I.URI.parse(le.uri),ue.path[0]!==C.posix.sep&&(ue=ue.with({path:C.posix.sep+ue.path}))}catch(se){console.warn(se)}if(ue){const se=F.getComparisonKey(ue);if(!Q.has(se)){Q.add(se);const de=le.name||F.basenameOrAuthority(ue);U.push(new f.WorkspaceFolder({uri:ue,name:de,index:U.length},le))}}}return U}e.toWorkspaceFolders=n;function o(M,T,F,U,Q){const re=i(T,M),le=Q.dirname(T),ue=Q.dirname(U),se=[];for(const _ of re.folders){const A=v(_)?Q.resolvePath(le,_.path):I.URI.parse(_.uri);let W;F?W=!1:W=!v(_)||(0,C.isAbsolute)(_.path),se.push(p(A,W,_.name,ue,Q))}const de={insertSpaces:!1,tabSize:4,eol:l.isLinux||l.isMacintosh?`
`:`\r
`},K=k.setProperty(M,["folders"],se,de);let $=k.applyEdits(M,K);return(0,g.isEqualAuthority)(re.remoteAuthority,(0,y.getRemoteAuthority)(U))&&($=k.applyEdits($,k.removeProperty($,["remoteAuthority"],de))),$}e.rewriteWorkspaceFileForNewLocation=o;function i(M,T){const F=t.parse(T);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(U=>m(U));else throw new Error(`${M} looks like an invalid workspace file.`);return F}function r(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function s(M){return typeof M.folderUri=="string"}function a(M){return typeof M.fileUri=="string"}function u(M,T){const F={workspaces:[],files:[]};if(M){const U=function(re,le){for(let ue=0;ue<re.length;ue++)try{le(re[ue],ue)}catch(se){T.warn(`Error restoring recent entry ${JSON.stringify(re[ue])}: ${se.toString()}. Skip entry.`)}},Q=M;Array.isArray(Q.entries)&&U(Q.entries,re=>{const le=re.label,ue=re.remoteAuthority;r(re)?F.workspaces.push({label:le,remoteAuthority:ue,workspace:{id:re.workspace.id,configPath:I.URI.parse(re.workspace.configPath)}}):s(re)?F.workspaces.push({label:le,remoteAuthority:ue,folderUri:I.URI.parse(re.folderUri)}):a(re)&&F.files.push({label:le,remoteAuthority:ue,fileUri:I.URI.parse(re.fileUri)})})}return F}e.restoreRecentlyOpened=u;function P(M){const T={entries:[]};for(const F of M.workspaces)b(F)?T.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):T.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of M.files)T.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return T}e.toStoreData=P}),define(J[117],Z([0,1,76,29,13,4,16]),function(q,e,S,t,k,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function C(g){function I(){let E=g.scheme===k.Schemas.file?(0,D.originalFSPath)(g):g.toString();return R.isLinux||(E=E.toLowerCase()),(0,S.createHash)("md5").update(E).digest("hex")}return{id:I(),configPath:g}}e.getWorkspaceIdentifier=C;function l(g,I){function E(){if(g.scheme!==k.Schemas.file)return(0,S.createHash)("md5").update(g.toString()).digest("hex");if(!I)try{I=(0,t.statSync)(g.fsPath)}catch{return}let f;return R.isLinux?f=I.ino:R.isMacintosh?f=I.birthtime.getTime():R.isWindows&&(typeof I.birthtimeMs=="number"?f=Math.floor(I.birthtimeMs):f=I.birthtime.getTime()),(0,S.createHash)("md5").update(g.fsPath).update(f?String(f):"").digest("hex")}const y=E();if(typeof y=="string")return{id:y,uri:g}}e.getSingleFolderWorkspaceIdentifier=l}),define(J[51],Z([0,1,15,29,3,43,35,2,13,9,16,12,23,175,60,56,26,5,6,20,42,116,27,91,117]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let r=class extends C.Disposable{constructor(a,u,P,M,T,F){super(),this.environmentMainService=a,this.logService=u,this.userDataProfilesMainService=P,this.backupMainService=M,this.dialogMainService=T,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,u=>(0,t.readFileSync)(u,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,u=>y.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(a,u){if(!!this.isWorkspacePath(a)&&a.scheme===l.Schemas.file)try{const P=u(a.fsPath);return P instanceof Promise?P.then(M=>this.doResolveWorkspace(a,M),M=>{}):this.doResolveWorkspace(a,P)}catch{return}}isWorkspacePath(a){return(0,n.isUntitledWorkspace)(a,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,u){try{const P=this.doParseStoredWorkspace(a,u),M=(0,i.getWorkspaceIdentifier)(a);return{id:M.id,configPath:M.configPath,folders:(0,o.toWorkspaceFolders)(P.folders,M.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:P.remoteAuthority,transient:P.transient}}catch(P){this.logService.warn(P.toString())}}doParseStoredWorkspace(a,u){const P=(0,R.parse)(u);if(P&&Array.isArray(P.folders))P.folders=P.folders.filter(M=>(0,o.isStoredWorkspaceFolder)(M));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return P}async createUntitledWorkspace(a,u){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,u),T=P.configPath.fsPath;return await y.Promises.mkdir((0,g.dirname)(T),{recursive:!0}),await y.Promises.writeFile(T,JSON.stringify(M,null,"	")),P}createUntitledWorkspaceSync(a,u){const{workspace:P,storedWorkspace:M}=this.newUntitledWorkspace(a,u),T=P.configPath.fsPath;return(0,t.mkdirSync)((0,g.dirname)(T),{recursive:!0}),(0,y.writeFileSync)(T,JSON.stringify(M,null,"	")),P}newUntitledWorkspace(a=[],u){const P=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,I.joinPath)(this.untitledWorkspacesHome,P),T=(0,I.joinPath)(M,n.UNTITLED_WORKSPACE_NAME),F=[];for(const U of a)F.push((0,o.getStoredWorkspaceFolder)(U.uri,!0,U.name,M,I.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:F,remoteAuthority:u}}}async getWorkspaceIdentifier(a){return(0,i.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,n.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const u=(0,I.originalFSPath)(a.configPath);try{(0,y.rimrafSync)((0,g.dirname)(u));const P=(0,g.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,t.existsSync)(P)&&(0,y.writeFileSync)((0,g.join)(P,"obsolete"),"")}catch(P){this.logService.warn(`Unable to delete untitled workspace ${u} (${P}).`)}}getUntitledWorkspacesSync(){const a=[];try{const u=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(P=>(0,I.joinPath)(this.untitledWorkspacesHome,P,n.UNTITLED_WORKSPACE_NAME));for(const P of u){const M=(0,i.getWorkspaceIdentifier)(P),T=this.resolveLocalWorkspaceSync(P);T?a.push({workspace:M,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return a}async enterWorkspace(a,u,P){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,u,P))return;const T=this.doEnterWorkspace(a,(0,i.getWorkspaceIdentifier)(P));if(!!T)return this._onDidEnterWorkspace.fire({window:a,workspace:T.workspace}),T}async isValidTargetWorkspacePath(a,u,P){if(!P)return!0;if((0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,P))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(u,P)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,D.mnemonicButtonLabel)((0,f.localize)(0,null))],message:(0,f.localize)(1,null,(0,I.basename)(P)),detail:(0,f.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,E.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,u){if(!a.config)return;a.focus();let P;return a.config.extensionDevelopmentPath||(P=this.backupMainService.registerWorkspaceBackup({workspace:u,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=u,a.config.backupPath=P,{workspace:u,backupPath:P}}};r=ve([Y(0,w.IEnvironmentMainService),Y(1,v.ILogService),Y(2,p.IUserDataProfilesMainService),Y(3,h.IBackupMainService),Y(4,b.IDialogMainService),Y(5,d.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[118],Z([0,1,15,40,22,5,33,27,51,12,6]),function(q,e,S,t,k,R,D,C,l,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let E=class{constructor(f,h,b){this.windowsMainService=f,this.workspacesManagementMainService=h,this.logService=b}async getRemoteDiagnostics(f){const h=this.windowsMainService.getWindows();return(await Promise.all(h.map(w=>new Promise(m=>{const v=w.remoteAuthority;if(v){const d=`vscode:getDiagnosticInfoResponse${w.id}`,p={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?this.getFolderURIs(w):void 0};w.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:d,args:p}),t.validatedIpcMain.once(d,(c,n)=>{n||m({hostName:v,errorMessage:`Unable to resolve connection to '${v}'.`}),m(n)}),setTimeout(()=>{m({hostName:v,errorMessage:`Connection to '${v}' could not be established`})},5e3)}else m(void 0)})))).filter(w=>!!w)}async getMainDiagnostics(){this.logService.trace("Received request for main process info from other instance.");const f=[];for(const h of S.BrowserWindow.getAllWindows()){const b=this.windowsMainService.getWindowById(h.id);b?f.push(this.codeWindowToInfo(b)):f.push(this.browserWindowToInfo(h))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}codeWindowToInfo(f){const h=this.getFolderURIs(f),b=(0,g.assertIsDefined)(f.win);return this.browserWindowToInfo(b,h,f.remoteAuthority)}browserWindowToInfo(f,h=[],b){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:h,remoteAuthority:b}}getFolderURIs(f){const h=[],b=f.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(b))h.push(b.uri);else if((0,C.isWorkspaceIdentifier)(b)){const w=this.workspacesManagementMainService.resolveLocalWorkspaceSync(b.configPath);w&&w.folders.forEach(v=>{h.push(v.uri)})}return h}};E=ve([Y(0,D.IWindowsMainService),Y(1,l.IWorkspacesManagementMainService),Y(2,I.ILogService)],E),e.DiagnosticsMainService=E}),define(J[65],Z([0,1,50,15,30,141,52,3,35,2,13,9,4,7,96,81,23,92,165,56,26,5,21,6,20,64,33,27,51,18]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class extends g.Disposable{constructor(F,U,Q,re,le,ue,se,de,K){super(),this.sharedProcess=F,this.windowsMainService=U,this.dialogMainService=Q,this.lifecycleMainService=re,this.environmentMainService=le,this.logService=ue,this.productService=se,this.themeMainService=de,this.workspacesManagementMainService=K,this.onDidOpenWindow=C.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidTriggerSystemContextMenu=C.Event.filter(C.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:$,x:_,y:A})=>({windowId:$.id,x:_,y:A})),({windowId:$})=>!!this.windowsMainService.getWindowById($)),this.onDidMaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-blur",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-focus",($,_)=>_.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new C.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",($,_,A)=>A),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),C.Event.fromNodeEventEmitter(t.screen,"display-added"),C.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,a.toWorkspaceIdentifier)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(F){return this.windowsMainService.getWindowCount()}async getActiveWindowId(F){const U=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(U)return U.id}openWindow(F,U,Q){return Array.isArray(U)?this.doOpenWindow(F,U,Q):this.doOpenEmptyWindow(F,U)}async doOpenWindow(F,U,Q=Object.create(null)){U.length>0&&this.windowsMainService.open({context:5,contextWindowId:F,urisToOpen:U,cli:this.environmentMainService.args,forceNewWindow:Q.forceNewWindow,forceReuseWindow:Q.forceReuseWindow,preferNewWindow:Q.preferNewWindow,diffMode:Q.diffMode,mergeMode:Q.mergeMode,addMode:Q.addMode,gotoLineMode:Q.gotoLineMode,noRecentEntry:Q.noRecentEntry,waitMarkerFileURI:Q.waitMarkerFileURI,remoteAuthority:Q.remoteAuthority||void 0})}async doOpenEmptyWindow(F,U){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:F},U)}async toggleFullScreen(F){this.windowById(F)?.toggleFullScreen()}async handleTitleDoubleClick(F){this.windowById(F)?.handleTitleDoubleClick()}async isMaximized(F){const U=this.windowById(F);return U?.win?U.win.isMaximized():!1}async maximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.maximize()}async unmaximizeWindow(F){const U=this.windowById(F);U?.win&&U.win.unmaximize()}async minimizeWindow(F){const U=this.windowById(F);U?.win&&U.win.minimize()}async updateWindowControls(F,U){const Q=this.windowById(F);Q&&Q.updateWindowControls(U)}async focusWindow(F,U){U&&typeof U.windowId=="number"&&(F=U.windowId),this.windowById(F)?.focus({force:U?.force??!1})}async setMinimumSize(F,U,Q){const re=this.windowById(F);if(re?.win){const[le,ue]=re.win.getSize(),[se,de]=re.win.getMinimumSize(),[K,$]=[U??se,Q??de],[_,A]=[Math.max(le,K),Math.max(ue,$)];(se!==K||de!==$)&&re.win.setMinimumSize(K,$),(le!==_||ue!==A)&&re.win.setSize(_,A)}}async saveWindowSplash(F,U){this.themeMainService.saveWindowSplash(F,U)}async installShellCommand(F){const{source:U,target:Q}=await this.getShellCommandLink();try{const{symbolicLink:re}=await w.SymlinkSupport.stat(U);if(re&&!re.dangling){const le=await(0,h.realpath)(U);if(Q===le)return}await w.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await w.Promises.symlink(Q,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:le}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,l.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(le===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Q}' '${U}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ue)}catch{throw new Error((0,v.localize)(3,null,U))}}}async uninstallShellCommand(F){const{source:U}=await this.getShellCommandLink();try{await w.Promises.unlink(U)}catch(Q){switch(Q.code){case"EACCES":{const{response:re}=await this.showMessageBox(F,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,l.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,l.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const le=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(le)}catch{throw new Error((0,v.localize)(7,null,U))}break}case"ENOENT":break;default:throw Q}}}async getShellCommandLink(){const F=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),U=`/usr/local/bin/${this.productService.applicationName}`;if(!await w.Promises.exists(F))throw new Error((0,v.localize)(8,null,F));return{source:U,target:F}}async showMessageBox(F,U){return this.dialogMainService.showMessageBox(U,this.toBrowserWindow(F))}async showSaveDialog(F,U){return this.dialogMainService.showSaveDialog(U,this.toBrowserWindow(F))}async showOpenDialog(F,U){return this.dialogMainService.showOpenDialog(U,this.toBrowserWindow(F))}toBrowserWindow(F){const U=this.windowById(F);if(U?.win)return U.win}async pickFileFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFileFolder(U);Q&&this.doOpenPicked(await Promise.all(Q.map(async re=>await w.SymlinkSupport.existsDirectory(re)?{folderUri:f.URI.file(re)}:{fileUri:f.URI.file(re)})),U,F)}async pickFolderAndOpen(F,U){const Q=await this.dialogMainService.pickFolder(U);Q&&this.doOpenPicked(Q.map(re=>({folderUri:f.URI.file(re)})),U,F)}async pickFileAndOpen(F,U){const Q=await this.dialogMainService.pickFile(U);Q&&this.doOpenPicked(Q.map(re=>({fileUri:f.URI.file(re)})),U,F)}async pickWorkspaceAndOpen(F,U){const Q=await this.dialogMainService.pickWorkspace(U);Q&&this.doOpenPicked(Q.map(re=>({workspaceUri:f.URI.file(re)})),U,F)}doOpenPicked(F,U,Q){this.windowsMainService.open({context:3,contextWindowId:Q,cli:this.environmentMainService.args,urisToOpen:F,forceNewWindow:U.forceNewWindow})}async showItemInFolder(F,U){t.shell.showItemInFolder(U)}async setRepresentedFilename(F,U){this.windowById(F)?.setRepresentedFilename(U)}async setDocumentEdited(F,U){this.windowById(F)?.setDocumentEdited(U)}async openExternal(F,U){return y.isLinuxSnap?this.safeSnapOpenExternal(U):t.shell.openExternal(U),!0}safeSnapOpenExternal(F){const U=process.env.GDK_PIXBUF_MODULE_FILE,Q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(F),process.env.GDK_PIXBUF_MODULE_FILE=U,process.env.GDK_PIXBUF_MODULEDIR=Q}moveItemToTrash(F,U){return t.shell.trashItem(U)}async isAdmin(){let F;return y.isWindows?F=(await new Promise((U,Q)=>{q(["native-is-elevated"],U,Q)}))():F=process.getuid()===0,F}async writeElevated(F,U,Q,re){const le=await new Promise((ue,se)=>{q(["@vscode/sudo-prompt"],ue,se)});return new Promise((ue,se)=>{const de=[`"${this.cliPath}"`];re?.unlock&&de.push("--file-chmod"),de.push("--file-write",`"${U.fsPath}"`,`"${Q.fsPath}"`);const K={name:this.productService.nameLong.replace("-",""),icns:y.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};le.exec(de.join(" "),K,($,_,A)=>{_&&this.logService.trace(`[sudo-prompt] received stdout: ${_}`),A&&this.logService.trace(`[sudo-prompt] received stderr: ${A}`),$?se($):ue(void 0)})})}get cliPath(){return y.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):y.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return b.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(F,U,Q){process.kill(U,Q)}async readClipboardText(F,U){return t.clipboard.readText(U)}async writeClipboardText(F,U,Q){return t.clipboard.writeText(U,Q)}async readClipboardFindText(F){return t.clipboard.readFindText()}async writeClipboardFindText(F,U){return t.clipboard.writeFindText(U)}async writeClipboardBuffer(F,U,Q,re){return t.clipboard.writeBuffer(U,Buffer.from(Q.buffer),re)}async readClipboardBuffer(F,U){return P.VSBuffer.wrap(t.clipboard.readBuffer(U))}async hasClipboard(F,U,Q){return t.clipboard.has(U,Q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,U){this.windowById(F)?.updateTouchBar(U)}async notifyReady(F){this.windowById(F)?.setReady()}async relaunch(F,U){return this.lifecycleMainService.relaunch(U)}async reload(F,U){const Q=this.windowById(F);if(Q){if((0,a.isWorkspaceIdentifier)(Q.openedWorkspace)){const re=Q.openedWorkspace.configPath;if(re.scheme===I.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(re))?.transient)return this.openWindow(Q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(Q,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(F){this.closeWindowById(F,F)}async closeWindowById(F,U){const Q=this.windowById(U);if(Q?.win)return Q.win.close()}async quit(F){const U=this.windowsMainService.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&U.win?U.win.close():this.lifecycleMainService.quit()}async exit(F,U){await this.lifecycleMainService.kill(U)}async resolveProxy(F,U){const re=this.windowById(F)?.win?.webContents?.session;if(re)return re.resolveProxy(U)}findFreePort(F,U,Q,re,le=1){return(0,m.findFreePort)(U,Q,re,le)}async openDevTools(F,U){const Q=this.windowById(F);Q?.win&&Q.win.webContents.openDevTools(U)}async toggleDevTools(F){const U=this.windowById(F);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(F,U){const Q=this.windowById(F);Q?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&Q.win.webContents.sendInputEvent(U)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(F,U,Q,re){if(!y.isWindows)return;const le=await new Promise((ue,se)=>{q(["@vscode/windows-registry"],ue,se)});try{return le.GetStringRegKey(U,Q,re)}catch{return}}windowById(F){if(typeof F=="number")return this.windowsMainService.getWindowById(F)}};ve([D.memoize],M.prototype,"cliPath",null),M=ve([Y(1,s.IWindowsMainService),Y(2,d.IDialogMainService),Y(3,n.ILifecycleMainService),Y(4,p.IEnvironmentMainService),Y(5,o.ILogService),Y(6,i.IProductService),Y(7,r.IThemeMainService),Y(8,u.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(J[260],Z([0,1,15,40,30,35,2,13,4,97,163,84,118,56,26,5,6,65,53,20,61,74]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let n=class Ft{constructor(i,r,s,a,u,P,M,T,F){this.userEnv=i,this.environmentMainService=r,this.logService=s,this.diagnosticsService=a,this.diagnosticsMainService=u,this.dialogMainService=P,this.nativeHostMainService=M,this.protocolMainService=T,this.productService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async i=>{const[r,s]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(r,s);this.safeSend(i,"vscode:issueSystemInfoResponse",a)}),t.validatedIpcMain.on("vscode:listProcesses",async i=>{const r=[];try{r.push({name:(0,I.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(a=>{(0,E.isRemoteDiagnosticError)(a)?r.push({name:a.hostName,rootProcess:a}):a.processes&&r.push({name:a.hostName,rootProcess:a.processes})})}catch(s){this.logService.error(`Listing processes failed: ${s}`)}this.safeSend(i,"vscode:listProcessesResponse",r)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async i=>{const r={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const s=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(i,"vscode:issueReporterClipboardResponse",s.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async i=>{const r=await this.getPerformanceInfo();this.safeSend(i,"vscode:issuePerformanceInfoResponse",r)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const i={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(i,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(i,r)=>{const{id:s,from:a,args:u}=r;let P;switch(a){case"issueReporter":P=this.issueReporterParentWindow;break;case"processExplorer":P=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}P?.webContents.send("vscode:runAction",{id:s,from:a,args:u})}),t.validatedIpcMain.on("vscode:openExternal",(i,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),t.validatedIpcMain.on("vscode:closeIssueReporter",i=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",i=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async i=>{const r=await this.diagnosticsMainService.getMainDiagnostics();this.safeSend(i,"vscode:windowsInfoResponse",r.windows)})}safeSend(i,r,...s){i.sender.isDestroyed()||i.sender.send(r,...s)}async openReporter(i){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new D.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:i.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:i.zoomLevel,alwaysOnTop:!1},"issue-reporter"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:i,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:v.default}),this.issueReporterWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(i){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new D.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:i.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:i.zoomLevel,alwaysOnTop:!0},"process-explorer"),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:i,product:v.default}),this.processExplorerWindow.loadURL(C.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(i){i.isMinimized()&&i.restore(),i.focus()}createBrowserWindow(i,r,s,a){const u=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:i.width,height:i.height,minWidth:300,minHeight:200,x:i.x,y:i.y,title:s.title,backgroundColor:s.backgroundColor||Ft.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,`--vscode-window-kind=${a}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,c.zoomLevelToZoomFactor)(s.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:s.alwaysOnTop,experimentalDarkMode:!0});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[i,r]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(i,r)}getWindowPosition(i,r,s){let a;const u=S.screen.getAllDisplays();if(u.length===1)a=u[0];else{if(l.isMacintosh){const T=S.screen.getCursorScreenPoint();a=S.screen.getDisplayNearestPoint(T)}!a&&i&&(a=S.screen.getDisplayMatching(i.getBounds())),a||(a=S.screen.getPrimaryDisplay()||u[0])}const P={width:r,height:s},M=a.bounds;return P.x=M.x+M.width/2-P.width/2,P.y=M.y+M.height/2-P.height/2,M.width>0&&M.height>0&&(P.x<M.x&&(P.x=M.x),P.y<M.y&&(P.y=M.y),P.x>M.x+M.width&&(P.x=M.x),P.y>M.y+M.height&&(P.y=M.y),P.width>M.width&&(P.width=M.width),P.height>M.height&&(P.height=M.height)),P}async getPerformanceInfo(){try{const[i,r]=await Promise.all([this.diagnosticsMainService.getMainDiagnostics(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(i,r)}catch(i){throw this.logService.warn("issueService#getPerformanceInfo ",i.message),i}}};n.DEFAULT_BACKGROUND_COLOR="#1E1E1E",n=ve([Y(1,h.IEnvironmentMainService),Y(2,w.ILogService),Y(3,E.IDiagnosticsService),Y(4,y.IDiagnosticsMainService),Y(5,f.IDialogMainService),Y(6,m.INativeHostMainService),Y(7,p.IProtocolMainService),Y(8,d.IProductService)],n),e.IssueMainService=n}),define(J[261],Z([0,1,22,19,26,21,6,65,20,54,37,47,88]),function(q,e,S,t,k,R,D,C,l,g,I,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends y.AbstractUpdateService{constructor(b,w,m,v,d,p,c,n){super(b,w,v,d,p,n),this.telemetryService=m,this.nativeHostMainService=c}buildUpdateFeedUrl(b){return(0,y.createUpdateURL)(`linux-${process.arch}`,b,this.productService)}doCheckForUpdates(b){!this.url||(this.setState(E.State.CheckingForUpdates(b)),this.requestService.request({url:this.url},S.CancellationToken.None).then(g.asJson).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(w))}).then(void 0,w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!b});const m=b?w.message||w:void 0;this.setState(E.State.Idle(1,m))}))}async doDownloadUpdate(b){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):b.update.url&&this.nativeHostMainService.openExternal(void 0,b.update.url),this.setState(E.State.Idle(1))}};f=ve([Y(0,R.ILifecycleMainService),Y(1,t.IConfigurationService),Y(2,I.ITelemetryService),Y(3,k.IEnvironmentMainService),Y(4,g.IRequestService),Y(5,D.ILogService),Y(6,C.INativeHostMainService),Y(7,l.IProductService)],f),e.LinuxUpdateService=f}),define(J[262],Z([0,1,50,29,30,8,22,52,9,7,127,23,19,26,14,21,6,65,20,54,37,47,88]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(a,u=1e3){for(;!a();)await(0,R.timeout)(u)}let i;function r(){return typeof i>"u"&&(i=t.existsSync(l.join(l.dirname(process.execPath),"unins000.exe"))?0:1),i}let s=class extends n.AbstractUpdateService{constructor(u,P,M,T,F,U,Q,re,le){super(u,P,T,F,U,le),this.telemetryService=M,this.fileService=Q,this.nativeHostMainService=re}get cachePath(){const u=l.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(u,{recursive:!0}).then(()=>u)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(u){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),r()===1?P+="-archive":this.productService.target==="user"&&(P+="-user"),(0,n.createUpdateURL)(P,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(c.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},D.CancellationToken.None).then(d.asJson).then(P=>{const M=r();return!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(c.State.Idle(M)),Promise.resolve(null)):M===1?(this.setState(c.State.AvailableForDownload(P)),Promise.resolve(null)):(this.setState(c.State.Downloading(P)),this.cleanup(P.version).then(()=>this.getUpdatePackagePath(P.version).then(T=>E.Promises.exists(T).then(F=>{if(F)return Promise.resolve(T);const U=P.url,Q=P.hash,re=`${T}.tmp`;return this.requestService.request({url:U},D.CancellationToken.None).then(le=>this.fileService.writeFile(g.URI.file(re),le.stream)).then(Q?()=>(0,I.checksum)(re,P.hash):()=>{}).then(()=>E.Promises.rename(re,T)).then(()=>T)})).then(T=>{const F=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},F&&P.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(P)):this.setState(c.State.Ready(P))})))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const M=u?P.message||P:void 0;this.setState(c.State.Idle(r(),M))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(u){const P=await this.cachePath;return l.join(P,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const P=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,M=await this.cachePath,F=(await E.Promises.readdir(M)).filter(P).map(async U=>{try{await E.Promises.unlink(l.join(M,U))}catch{}});await Promise.all(F)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(c.State.Updating(u));const P=await this.cachePath;this.availableUpdate.updateFilePath=l.join(P,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,S.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,F=await new Promise((U,Q)=>{q(["windows-mutex"],U,Q)});o(()=>F.isActive(T)).then(()=>this.setState(c.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,S.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}async _applySpecificUpdate(u){if(this.state.type!=="idle")return;const P=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),M={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!P};this.setState(c.State.Downloading(M)),this.availableUpdate={packagePath:u},P?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(M)):this.setState(c.State.Ready(M))}};ve([C.memoize],s.prototype,"cachePath",null),s=ve([Y(0,b.ILifecycleMainService),Y(1,y.IConfigurationService),Y(2,p.ITelemetryService),Y(3,f.IEnvironmentMainService),Y(4,d.IRequestService),Y(5,w.ILogService),Y(6,h.IFileService),Y(7,m.INativeHostMainService),Y(8,v.IProductService)],s),e.Win32UpdateService=s}),define(J[263],Z([0,1,15,8,22,44,3,35,2,13,9,71,4,7,171,60,19,56,26,59,14,21,6,20,61,229,90,37,232,64,74,33,27,51,114,120,38,41,53,42]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P,M,T,F,U,Q,re,le,ue,se,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var K;(function(_){_[_.NONE=0]="NONE",_[_.NAVIGATING=1]="NAVIGATING",_[_.READY=2]="READY"})(K||(K={}));let $=class Lt extends l.Disposable{constructor(A,W,z,ee,B,j,L,O,N,V,x,ne,H,te,ie,oe,ge,Me,Le){super(),this.logService=W,this.environmentMainService=z,this.policyService=ee,this.userDataProfilesService=B,this.fileService=j,this.applicationStorageMainService=L,this.storageMainService=O,this.configurationService=N,this.themeMainService=V,this.workspacesManagementMainService=x,this.backupMainService=ne,this.telemetryService=H,this.dialogMainService=te,this.lifecycleMainService=ie,this.productService=oe,this.protocolMainService=ge,this.windowsMainService=Me,this.stateMainService=Le,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new D.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.transientIsNativeFullScreen=void 0,this.joinNativeFullScreenTransition=void 0,this.hasWindowControlOverlay=!1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ke,Ae]=this.restoreWindowState(A.state);this.windowState=ke,this.logService.trace("window#ctor: using window state",ke);const Ve=this.windowState.mode===0||this.windowState.mode===3,me=this.configurationService.getValue("window");let we=!1;typeof me?.experimental?.useSandbox=="boolean"?we=me.experimental.useSandbox:we=typeof se.default.quality=="string"&&se.default.quality!=="stable";const Ee={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:M.WindowMinimumSize.WIDTH,minHeight:M.WindowMinimumSize.HEIGHT,show:!Ve,title:this.productService.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,M.zoomLevelToZoomFactor)(me?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...we?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):y.isWindows&&!this.environmentMainService.isBuilt&&(Ee.icon=(0,I.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.useNativeFullScreen()&&(Ee.fullscreenable=!1),y.isMacintosh&&(Ee.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(Ee.acceptFirstMouse=!1));const X=y.isMacintosh&&me?.nativeTabs===!0;X&&(Ee.tabbingIdentifier=this.productService.nameShort);const ae=(0,M.getTitleBarStyle)(this.configurationService)==="custom";if(ae&&(Ee.titleBarStyle="hidden",y.isMacintosh||(Ee.frame=!1),(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const he=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),be=re.Color.fromHex(he).isDarker()?"#FFFFFF":"#000000";Ee.titleBarOverlay={height:29,color:he,symbolColor:be},this.hasWindowControlOverlay=!0}if((0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new S.BrowserWindow(Ee),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,y.isMacintosh&&ae&&this._win.setSheetOffset(22),ae&&(y.isWindows&&(0,M.useWindowControlsOverlay)(this.configurationService,this.environmentMainService)||y.isMacintosh)){const he=this.stateMainService.getItem(Lt.windowControlHeightStateStorageKey);he&&this.updateWindowControls({height:he})}y.isWindows&&ae&&this._win.hookWindowMessage(278,()=>{const[be,Ie]=this._win.getPosition(),Oe=S.screen.getCursorScreenPoint(),We=Oe.x-be,Ue=Oe.y-Ie;return(()=>!(We>30&&Ue>=0&&Ue<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:We,y:Ue})),0}),(y.isMacintosh||y.isWindows)&&Ae&&(!X||S.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),Ve&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",this.userDataProfilesService.profiles.find(A=>A.id===this.config?.profiles.profile.id)??this.userDataProfilesService.defaultProfile):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(A){y.isMacintosh?this._win.setRepresentedFilename(A):this.representedFilename=A}getRepresentedFilename(){return y.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(A){y.isMacintosh&&this._win.setDocumentEdited(A),this.documentEdited=A}isDocumentEdited(){return y.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(A){y.isMacintosh&&A?.force&&S.app.focus({steal:!0}),this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.whenReadyCallbacks.push(A)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(A=>{function W(){z.dispose(),ee.dispose(),A()}const z=this.onDidClose(()=>W()),ee=this.onWillLoad(()=>W())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(W,z,ee)=>this.onWindowError(3,{reason:ee,exitCode:z})),this._win.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",W=>{this._config&&(this._config.maximized=!0),S.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this._config&&(this._config.maximized=!1),S.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.joinNativeFullScreenTransition?.complete(),this.joinNativeFullScreenTransition=void 0}),this._register(this.configurationService.onDidChangeConfiguration(W=>this.onConfigurationUpdated(W))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(W,z)=>{const ee=await this.getMarketplaceHeaders();z({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,ee)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,r.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(A,W){switch(A){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:A,reason:W?.reason,code:W?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,h.localize)(1,null)),(0,C.mnemonicButtonLabel)((0,h.localize)(2,null))],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,h.localize)(5,null):void 0},this._win);if(z.response!==1){const ee=z.response===0;this.destroyWindow(ee,z.checkboxChecked)}}else if(A===2){let z;W?z=(0,h.localize)(7,null,W.reason,W.exitCode??"<unknown>"):z=(0,h.localize)(6,null);const ee=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(8,null)),(0,C.mnemonicButtonLabel)((0,h.localize)(9,null))],message:z,detail:(0,h.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,h.localize)(11,null):void 0},this._win),B=ee.response===0;this.destroyWindow(B,ee.checkboxChecked)}break}}async destroyWindow(A,W){const z=this._config?.workspace;if(W&&z)try{const ee=this.storageMainService.workspaceStorage(z);await ee.init(),ee.delete("memento/workbench.parts.editor"),await ee.close()}catch(ee){this.logService.error(ee)}if(this._onDidDestroy.fire(),this._win?.destroy(),A&&this._config){let ee,B;(0,F.isSingleFolderWorkspaceIdentifier)(z)?ee={folderUri:z.uri}:(0,F.isWorkspaceIdentifier)(z)?ee={workspaceUri:z.configPath}:B=!0;const[j]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:B,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});j.focus()}}onDidDeleteUntitledWorkspace(A){this._config?.workspace?.id===A.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(A){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const ee=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||ee!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=ee;const B=z||"",j=ee?`${ee},<local>`:"<local>";this.logService.trace(`Setting proxy to '${B}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:B,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(A){y.isMacintosh&&A.win&&this._win.addTabbedWindow(A.win)}load(A,W=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!W.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(A,W),this.readyState===0?this._config=A:this.pendingLoadConfig=A,this.readyState=1,this._win.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",q).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:A.workspace,reason:W.isReload?3:z?2:1})}updateConfiguration(A,W){const z=(this._config??this.pendingLoadConfig)?.userEnv;if(z){const ee=(0,d.isLaunchedFromCli)(z)&&!(0,d.isLaunchedFromCli)(A.userEnv),B=this.isExtensionDevelopmentHost;(ee||B)&&(A.userEnv={...z,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(A["disable-extensions"]=W.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this._win.isMaximized(),A.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),A.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(A)}async reload(A){const W=Object.assign({},this._config);W.workspace=await this.validateWorkspaceBeforeReload(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&A&&(W.verbose=A.verbose,W.debugId=A.debugId,W.extensionEnvironment=A.extensionEnvironment,W["inspect-extensions"]=A["inspect-extensions"],W["inspect-brk-extensions"]=A["inspect-brk-extensions"],W["extensions-dir"]=A["extensions-dir"]),W.isInitialStartup=!1,W.policiesData=this.policyService.serialize(),W.profiles={all:this.userDataProfilesService.profiles,profile:this.profile||this.userDataProfilesService.defaultProfile},this.load(W,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async validateWorkspaceBeforeReload(A){if((0,F.isWorkspaceIdentifier)(A.workspace)){const W=A.workspace.configPath;if(W.scheme===g.Schemas.file&&!await this.fileService.exists(W))return}else if((0,F.isSingleFolderWorkspaceIdentifier)(A.workspace)){const W=A.workspace.uri;if(W.scheme===g.Schemas.file&&!await this.fileService.exists(W))return}return A.workspace}serializeWindowState(){if(!this._win)return(0,Q.defaultWindowState)();if(this.isFullScreen){let z;try{z=S.screen.getDisplayMatching(this.getBounds())}catch{}const ee=(0,Q.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||ee.width,height:this.windowState.height||ee.height,x:this.windowState.x||0,y:this.windowState.y||0}}const A=Object.create(null);let W;if(!y.isMacintosh&&this._win.isMaximized()?W=0:W=1,W===0?A.mode=0:A.mode=1,W===1||W===0){let z;W===1?z=this.getBounds():z=this._win.getNormalBounds(),A.x=z.x,A.y=z.y,A.width=z.width,A.height=z.height}return A}updateWindowControls(A){A.height&&this.stateMainService.setItem(Lt.windowControlHeightStateStorageKey,A.height),y.isWindows&&this.hasWindowControlOverlay?this._win.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0}):y.isMacintosh&&A.height!==void 0&&this._win.setTrafficLightPosition({x:7,y:(A.height-15)/2})}restoreWindowState(A){(0,E.mark)("code/willRestoreCodeWindowState");let W=!1;if(A)try{const z=S.screen.getAllDisplays();W=z.length>1,A=this.validateWindowState(A,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[A||(0,Q.defaultWindowState)(),W]}validateWindowState(A,W){if(this.logService.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const B=this.getWorkingArea(W[0]);if(B){let j=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!B||(A.x<B.x&&(A.x=B.x),A.y<B.y&&(A.y=B.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",B),j(),A.width>B.width&&(A.width=B.width),A.height>B.height&&(A.height=B.height),A.x>B.x+B.width-128&&(A.x=B.x+B.width-A.width),A.y>B.y+B.height-128&&(A.y=B.y+B.height-A.height),j()}return A}if(A.display&&A.mode===3){const B=W.find(j=>j.id===A.display);if(B&&typeof B.bounds?.x=="number"&&typeof B.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const j=(0,Q.defaultWindowState)(3);return j.x=B.bounds.x,j.y=B.bounds.y,j}}let z,ee;try{z=S.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),ee=this.getWorkingArea(z)}catch{}if(z&&ee&&A.x+A.width>ee.x&&A.y+A.height>ee.y&&A.x<ee.x+ee.width&&A.y<ee.y+ee.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",ee),A}getWorkingArea(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,W]=this._win.getPosition(),[z,ee]=this._win.getSize();return{x:A,y:W,width:z,height:ee}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(A){this.useNativeFullScreen()?this.setNativeFullScreen(A):this.setSimpleFullScreen(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.transientIsNativeFullScreen=="boolean"?this.transientIsNativeFullScreen:this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(A){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this.doSetNativeFullScreen(A)}doSetNativeFullScreen(A){y.isMacintosh&&(this.transientIsNativeFullScreen=A,this.joinNativeFullScreenTransition=new t.DeferredPromise,Promise.race([this.joinNativeFullScreenTransition.p,(0,t.timeout)(1e3)]).finally(()=>this.transientIsNativeFullScreen=void 0)),this._win.setFullScreen(A)}setSimpleFullScreen(A){this._win.isFullScreen()&&this.doSetNativeFullScreen(!1),this._win.setSimpleFullScreen(A),this._win.webContents.focus()}useNativeFullScreen(){const A=this.configurationService.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let A=(0,M.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}setMenuBarVisibility(A,W=!0){y.isMacintosh||(A==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,h.localize)(12,null)),A==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(A)}):this.doSetMenuBarVisibility(A))}doSetMenuBarVisibility(A){const W=this.isFullScreen;switch(A){case"classic":this._win.setMenuBarVisibility(!W),this._win.autoHideMenuBar=W;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(A,W,...z){this.isReady?this.send(A,...z):this.ready().then(()=>{W.isCancellationRequested||this.send(A,...z)})}send(A,...W){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this._win.webContents.send(A,...W)}catch(z){this.logService.warn(`Error sending IPC message to channel '${A}' of window ${this._id}: ${(0,R.toErrorMessage)(z)}`)}}}updateTouchBar(A){!y.isMacintosh||this.touchBarGroups.forEach((W,z)=>{const ee=A[z];W.segments=this.createTouchBarGroupSegments(ee)})}createTouchBar(){if(!!y.isMacintosh){for(let A=0;A<10;A++){const W=this.createTouchBarGroup();this.touchBarGroups.push(W)}this._win.setTouchBar(new S.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(A=[]){const W=this.createTouchBarGroupSegments(A),z=new S.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:ee=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:z.segments[ee].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(A=[]){return A.map(z=>{let ee;z.icon&&!u.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===g.Schemas.file&&(ee=S.nativeImage.createFromPath(f.URI.revive(z.icon.dark).fsPath),ee.isEmpty()&&(ee=void 0));let B;return typeof z.title=="string"?B=z.title:B=z.title.value,{id:z.id,label:ee?void 0:B,icon:ee}})}dispose(){super.dispose(),this._win=null}};$.windowControlHeightStateStorageKey="windowControlHeight",$=ve([Y(1,n.ILogService),Y(2,v.IEnvironmentMainService),Y(3,le.IPolicyService),Y(4,de.IUserDataProfilesMainService),Y(5,p.IFileService),Y(6,s.IApplicationStorageMainService),Y(7,s.IStorageMainService),Y(8,w.IConfigurationService),Y(9,P.IThemeMainService),Y(10,U.IWorkspacesManagementMainService),Y(11,b.IBackupMainService),Y(12,a.ITelemetryService),Y(13,m.IDialogMainService),Y(14,c.ILifecycleMainService),Y(15,o.IProductService),Y(16,i.IProtocolMainService),Y(17,T.IWindowsMainService),Y(18,ue.IStateMainService)],$),e.CodeWindow=$}),define(J[75],Z([0,1,15,24,8,3,35,2,13,4,16,7,23,174,5,21,6,90,91,27,51]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let c=class nt extends C.Disposable{constructor(o,i,r,s){super(),this.logService=o,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.applicationStorageMainService=s,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(4).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){const i=[],r=[];for(const s of o)if((0,v.isRecentWorkspace)(s))!this.workspacesManagementMainService.isUntitledWorkspace(s.workspace)&&this.indexOfWorkspace(i,s.workspace)===-1&&i.push(s);else if((0,v.isRecentFolder)(s))this.indexOfFolder(i,s.folderUri)===-1&&i.push(s);else{const a=this.indexOfFile(r,s.fileUri)>=0,u=s.fileUri.scheme===l.Schemas.file&&nt.COMMON_FILES_FILTER.indexOf((0,I.basename)(s.fileUri))>=0;!a&&!u&&(r.push(s),g.isWindows&&s.fileUri.scheme===l.Schemas.file&&S.app.addRecentDocument(s.fileUri.fsPath))}await this.addEntriesFromStorage(i,r),i.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=nt.MAX_TOTAL_RECENT_ENTRIES),r.length>nt.MAX_TOTAL_RECENT_ENTRIES&&(r.length=nt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(o){const i=u=>{const P=this.location(u);for(const M of o)if(I.extUriBiasedIgnorePathCase.isEqual(M,P))return!1;return!0},r=await this.getRecentlyOpened(),s=r.workspaces.filter(i),a=r.files.filter(i);(s.length!==r.workspaces.length||a.length!==r.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:s}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(){const o=[],i=[];return await this.addEntriesFromStorage(o,i),{workspaces:o,files:i}}async addEntriesFromStorage(o,i){const r=await this.getRecentlyOpenedFromStorage();for(const s of r.workspaces){const a=(0,v.isRecentFolder)(s)?this.indexOfFolder(o,s.folderUri):this.indexOfWorkspace(o,s.workspace);a>=0?o[a].label=o[a].label||s.label:o.push(s)}for(const s of r.files){const a=this.indexOfFile(i,s.fileUri);a>=0?i[a].label=i[a].label||s.label:i.push(s)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let o;const i=this.applicationStorageMainService.get(nt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof i=="string")try{o=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}return(0,v.restoreRecentlyOpened)(o,this.logService)}async saveRecentlyOpened(o){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(nt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,v.toStoreData)(o)),-1,1)}location(o){return(0,v.isRecentFolder)(o)?o.folderUri:(0,v.isRecentFile)(o)?o.fileUri:o.workspace.configPath}indexOfWorkspace(o,i){return o.findIndex(r=>(0,v.isRecentWorkspace)(r)&&r.workspace.id===i.id)}indexOfFolder(o,i){return o.findIndex(r=>(0,v.isRecentFolder)(r)&&I.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}indexOfFile(o,i){return o.findIndex(r=>I.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!g.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!g.isWindows)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const i=[];for(const a of S.app.getJumpListSettings().removedItems){const u=a.args;if(u){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(u);P&&i.push(E.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let r=!1;const s=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,nt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const u=(0,v.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:P,description:M}=this.getWindowsJumpListLabel(u,a.label);let T;return E.URI.isUri(u)?T=`--folder-uri "${u.toString()}"`:(r=!0,T=`--file-uri "${u.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));s.length>0&&o.push({type:"custom",name:r?(0,f.localize)(2,null):(0,f.localize)(3,null),items:s})}o.push({type:"recent"});try{const i=S.app.setJumpList(o);i&&i!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${i}`)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(o,i){if(i)return{title:(0,D.splitName)(i).name,description:i};if(E.URI.isUri(o))return{title:(0,I.basename)(o),description:this.renderJumpListPathDescription(o)};if(this.workspacesManagementMainService.isUntitledWorkspace(o))return{title:(0,f.localize)(4,null),description:""};let r=(0,I.basename)(o.configPath);return r.endsWith(d.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-d.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,r),description:this.renderJumpListPathDescription(o.configPath)}}renderJumpListPathDescription(o){return o.scheme==="file"?(0,D.normalizeDriveLetter)(o.fsPath):o.toString()}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;S.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),i=[];let r=0;for(let a=0;a<o.workspaces.length&&r<nt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const u=this.location(o.workspaces[a]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);await y.Promises.exists(P)&&(i.push(P),r++)}}const s=[];for(let a=0;a<o.files.length&&r<nt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const u=this.location(o.files[a]);if(u.scheme===l.Schemas.file){const P=(0,I.originalFSPath)(u);if(nt.COMMON_FILES_FILTER.includes((0,I.basename)(u))||i.includes(P))continue;await y.Promises.exists(P)&&(s.push(P),r++)}}s.reverse().forEach(a=>S.app.addRecentDocument(a)),i.reverse().forEach(a=>S.app.addRecentDocument(a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c=ve([Y(0,w.ILogService),Y(1,p.IWorkspacesManagementMainService),Y(2,b.ILifecycleMainService),Y(3,m.IApplicationStorageMainService)],c),e.WorkspacesHistoryMainService=c}),define(J[264],Z([0,1,15,8,22,35,4,7,164,19,26,21,6,209,65,20,41,37,47,74,33,75]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let o=class At{constructor(s,a,u,P,M,T,F,U,Q,re,le){this.updateService=s,this.configurationService=a,this.windowsMainService=u,this.environmentMainService=P,this.telemetryService=M,this.workspacesHistoryMainService=T,this.stateMainService=F,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=re,this.productService=le,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(D.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const s=this.stateMainService.getItem(At.lastKnownMenubarStorageKey);s&&(s.menus&&(this.menubarMenus=s.menus),s.keybindings&&(this.keybindings=s.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,F,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:F?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,F,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(T,F,U)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,F,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const s=this.productService.twitterUrl;s&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(s,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const P=this.productService.licenseUrl;P&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(D.language){const T=P.indexOf("?")>0?"&":"?";this.openUrl(`${P}${T}lang=${D.language}`,"openLicenseUrl")}else this.openUrl(P,"openLicenseUrl")});const M=this.productService.privacyStatementUrl;M&&P&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(M,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(s=>this.onDidChangeWindowsCount(s)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const s=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof s!="boolean"?!0:s}get currentEnableNativeTabs(){if(!D.isMacintosh)return!1;const s=this.configurationService.getValue("window.nativeTabs");return typeof s!="boolean"?!1:s}updateMenu(s,a){this.menubarMenus=s.menus,this.keybindings=s.keybindings,this.stateMainService.setItem(At.lastKnownMenubarStorageKey,s),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(s){!D.isMacintosh||(s.oldCount===0&&s.newCount>0||s.oldCount>0&&s.newCount===0)&&(this.closedLastWindow=s.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!D.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const s=S.Menu.getApplicationMenu();if(s&&this.oldMenus.push(s),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(D.isMacintosh?new S.Menu:null);return}const a=new S.Menu;let u;if(D.isMacintosh){const M=new S.Menu;u=new S.MenuItem({label:this.productService.nameShort,submenu:M}),this.setMacApplicationMenu(M),a.append(u)}if(D.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const M=new S.Menu;M.append(new S.MenuItem({label:this.mnemonicLabel(l.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(M)}if(this.shouldDrawMenu("File")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(1,null)),submenu:M});this.setMenuById(M,"File"),a.append(T)}if(this.shouldDrawMenu("Edit")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(2,null)),submenu:M});this.setMenuById(M,"Edit"),a.append(T)}if(this.shouldDrawMenu("Selection")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(3,null)),submenu:M});this.setMenuById(M,"Selection"),a.append(T)}if(this.shouldDrawMenu("View")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(4,null)),submenu:M});this.setMenuById(M,"View"),a.append(T)}if(this.shouldDrawMenu("Go")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(5,null)),submenu:M});this.setMenuById(M,"Go"),a.append(T)}if(this.shouldDrawMenu("Run")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(6,null)),submenu:M});this.setMenuById(M,"Run"),a.append(T)}if(this.shouldDrawMenu("Terminal")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(7,null)),submenu:M});this.setMenuById(M,"Terminal"),a.append(T)}let P;if(this.shouldDrawMenu("Window")){const M=new S.Menu;P=new S.MenuItem({label:this.mnemonicLabel(l.localize(8,null)),submenu:M,role:"window"}),this.setMacWindowMenu(M)}if(P&&a.append(P),this.shouldDrawMenu("Help")){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(l.localize(9,null)),submenu:M,role:"help"});this.setMenuById(M,"Help"),a.append(T)}a.items&&a.items.length>0?S.Menu.setApplicationMenu(a):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(s){const a=this.createMenuItem(l.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let P;if(this.shouldDrawMenu("Preferences")){const ue=new S.Menu;this.setMenuById(ue,"Preferences"),P=new S.MenuItem({label:this.mnemonicLabel(l.localize(11,null)),submenu:ue})}const M=new S.Menu,T=new S.MenuItem({label:l.localize(12,null),role:"services",submenu:M}),F=new S.MenuItem({label:l.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new S.MenuItem({label:l.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new S.MenuItem({label:l.localize(15,null),role:"unhide"}),re=new S.MenuItem(this.likeAction("workbench.action.quit",{label:l.localize(16,null,this.productService.nameLong),click:async(ue,se,de)=>{const K=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.confirmBeforeQuit(de)&&this.nativeHostMainService.quit(void 0)}})),le=[a];le.push(...u),P&&le.push(i(),P),le.push(i(),T,i(),F,U,Q,i(),re),le.forEach(ue=>s.append(ue))}async confirmBeforeQuit(s){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(s)){const u={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(l.localize(17,null)),(0,R.mnemonicButtonLabel)(l.localize(18,null))],message:l.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:P}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,u);return P===0}return!0}shouldDrawMenu(s){if(!D.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(s){case"File":case"Help":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[s];case"Window":if(D.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[s]}}setMenu(s,a){a.forEach(u=>{if((0,f.isMenubarMenuItemSeparator)(u))s.append(i());else if((0,f.isMenubarMenuItemSubmenu)(u)){const P=new S.Menu,M=new S.MenuItem({label:this.mnemonicLabel(u.label),submenu:P});this.setMenu(P,u.submenu.items),s.append(M)}else(0,f.isMenubarMenuItemRecentAction)(u)?s.append(this.createOpenRecentMenuItem(u)):(0,f.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(s),D.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?s.append(new S.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):s.append(this.createMenuItem(u.label,u.id,!1,u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):s.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(s,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(s,this.menubarMenus[a].items)}insertCheckForUpdatesItems(s){const a=this.getUpdateMenuItems();a.length&&(a.forEach(u=>s.append(u)),s.append(i()))}createOpenRecentMenuItem(s){const a=C.URI.revive(s.uri),u=s.id,P=u==="openRecentFile"?{fileUri:a}:u==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new S.MenuItem(this.likeAction(u,{label:s.label,click:(M,T,F)=>{const U=this.isOptionClick(F);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[P],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:s.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(s){return!!(s&&(!D.isMacintosh&&(s.ctrlKey||s.shiftKey)||D.isMacintosh&&(s.metaKey||s.altKey)))}isKeyboardEvent(s){return!!(s.triggeredByAccelerator||s.altKey||s.ctrlKey||s.metaKey||s.shiftKey)}createRoleMenuItem(s,a,u){const P={label:this.mnemonicLabel(s),role:u,enabled:!0};return new S.MenuItem(this.withKeybinding(a,P))}setMacWindowMenu(s){const a=new S.MenuItem({label:l.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new S.MenuItem({label:l.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),P=new S.MenuItem({label:l.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),M=this.createMenuItem(l.localize(23,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(i()),T.push(this.createMenuItem(l.localize(24,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(l.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(l.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(l.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(l.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,u,i(),M,...T,i(),P].forEach(F=>s.append(F))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(l.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:l.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(l.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:l.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(l.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:l.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(l.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(s,a,u,P){const M=this.mnemonicLabel(s),T=typeof a=="function"?a:(le,ue,se)=>{const de=le?le.userSettingsLabel:null;let K=a;Array.isArray(a)&&(K=this.isOptionClick(se)?a[1]:a[0]),de&&se.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:de}):this.runActionInRenderer({type:"commandId",commandId:K})},F=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof P=="boolean"?P:!1,Q={label:M,click:T,enabled:F};U&&(Q.type="checkbox",Q.checked=U);let re;return typeof a=="string"?re=a:Array.isArray(a)&&(re=a[0]),D.isMacintosh&&(re==="editor.action.clipboardCutAction"?Q.role="cut":re==="editor.action.clipboardCopyAction"?Q.role="copy":re==="editor.action.clipboardPasteAction"&&(Q.role="paste"),re==="undo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(T,{inDevTools:le=>le.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(re,Q))}makeContextAwareClickHandler(s,a){return(u,P,M)=>{const T=S.BrowserWindow.getFocusedWindow();if(!T)return a.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return a.inDevTools(T.webContents.devToolsWebContents);s(u,P||T,M)}}runActionInRenderer(s){let a=S.BrowserWindow.getFocusedWindow();if(!a){const P=this.windowsMainService.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const u=a?this.windowsMainService.getWindowById(a.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",s),D.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(s.type==="commandId"&&s.commandId==="workbench.action.toggleDevTools"||s.type!=="commandId"&&s.userSettingsLabel==="alt+cmd+i"))return;if(s.type==="commandId"){const P={id:s.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",k.CancellationToken.None,P)}else{const P={userSettingsLabel:s.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,P)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",s)}withKeybinding(s,a){const u=typeof s=="string"?this.keybindings[s]:void 0;if(u?.label){if(u.isNative!==!1)a.accelerator=u.label,a.userSettingsLabel=u.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${u.label}]`:a.label=`${a.label} [${u.label}]`}}else a.accelerator=void 0;return a}likeAction(s,a,u=!a.accelerator){u&&(a=this.withKeybinding(s,a));const P=a.click;return a.click=(M,T,F)=>{this.reportMenuActionTelemetry(s),P?.(M,T,F)},a}openUrl(s,a){this.nativeHostMainService.openExternal(void 0,s),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(s){this.telemetryService.publicLog2("workbenchActionExecuted",{id:s,from:n})}mnemonicLabel(s){return(0,R.mnemonicMenuLabel)(s,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=ve([Y(0,v.IUpdateService),Y(1,g.IConfigurationService),Y(2,p.IWindowsMainService),Y(3,I.IEnvironmentMainService),Y(4,m.ITelemetryService),Y(5,c.IWorkspacesHistoryMainService),Y(6,w.IStateMainService),Y(7,E.ILifecycleMainService),Y(8,y.ILogService),Y(9,h.INativeHostMainService),Y(10,b.IProductService)],o),e.Menubar=o;function i(){return new S.MenuItem({type:"separator"})}}),define(J[265],Z([0,1,5,21,6,264]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let D=class{constructor(l,g,I){this.instantiationService=l,this.lifecycleMainService=g,this.logService=I,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(l,g){this.logService.trace("menubarService#updateMenubar",l),(await this.menubar).updateMenu(g,l)}};D=ve([Y(0,S.IInstantiationService),Y(1,t.ILifecycleMainService),Y(2,k.ILogService)],D),e.MenubarMainService=D}),define(J[266],Z([0,1,15,29,30,24,22,3,31,48,35,2,13,9,71,4,34,16,12,7,172,60,19,56,26,14,5,21,6,53,20,61,63,41,74,263,116,259,27,117,75,51,64,38,42]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P,M,T,F,U,Q,re,le,ue,se,de,K,$,_,A,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(j){return(0,se.isWorkspaceIdentifier)(j?.workspace)}function ee(j){return(0,se.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let B=class ut extends E.Disposable{constructor(L,O,N,V,x,ne,H,te,ie,oe,ge,Me,Le,ke,Ae,Ve,me,we){super(),this.machineId=L,this.initialUserEnv=O,this.logService=N,this.stateMainService=V,this.policyService=x,this.environmentMainService=ne,this.userDataProfilesMainService=H,this.lifecycleMainService=te,this.backupMainService=ie,this.configurationService=oe,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Me,this.instantiationService=Le,this.dialogMainService=ke,this.fileService=Ae,this.productService=Ve,this.protocolMainService=me,this.themeMainService=we,this._onDidOpenWindow=this._register(new C.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new C.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new C.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new C.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new C.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ue.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const O=new E.DisposableStore;if(O.add(C.Event.any(L.onDidClose,L.onDidDestroy)(()=>O.dispose())),L.config.extensionDevelopmentPath)for(const N of L.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(N));L.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,O){const N=this.environmentMainService.args,V=O?.remoteAuthority||void 0,x=!0,ne=O?.forceReuseWindow,H=!ne;return this.open({...L,cli:N,forceEmpty:x,forceNewWindow:H,forceReuseWindow:ne,remoteAuthority:V})}openExistingWindow(L,O){L.focus(),this.handleWaitMarkerFile(O,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const O=[],N=[],V=[],x=[],ne=[];let H,te=0;const ie=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const ke of ie)ee(ke)?L.addMode?O.push(ke):N.push(ke):z(ke)?V.push(ke):ke.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),H.filesToOpenOrCreate.push(ke)):ke.backupPath?ne.push({backupFolder:(0,f.basename)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):te++;L.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),L.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&L.waitMarkerFileURI&&(H.filesToWait={paths:(0,R.coalesce)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(x.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...x),ne.push(...this.backupMainService.getEmptyWindowBackups())):ne.length=0;const{windows:oe,filesOpenedInWindow:ge}=this.doOpen(L,V,N,ne,te,H,O);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${N.length}, emptyToRestore: ${ne.length}, emptyToOpen: ${te})`),oe.length>1)if(ge)ge.focus();else{const ke=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Ae=!0,Ve=!0;if(ke){const me=oe.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,Ve=!1)}if(Ae)for(let me=oe.length-1;me>=0;me--){const we=oe[me];if(!(we.openedWorkspace&&x.some(Ee=>we.openedWorkspace&&Ee.workspace.id===we.openedWorkspace.id)||we.backupPath&&ne.some(Ee=>we.backupPath&&Ee.backupFolder===(0,f.basename)(we.backupPath)))){we.focus(),Ve=!1;break}}Ve&&oe[oe.length-1].focus()}const Me=H&&H.filesToDiff.length>0,Le=H&&H.filesToMerge.length>0;if(!oe.some(ke=>ke.isExtensionDevelopmentHost)&&!Me&&!Le&&!L.noRecentEntry){const ke=[];for(const Ae of ie)z(Ae)&&!Ae.transient?ke.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):ee(Ae)?ke.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&ke.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ke)}return this.handleWaitMarkerFile(L,oe),oe}handleWaitMarkerFile(L,O){const N=L.waitMarkerFileURI;L.context===0&&N&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del(N)}catch{}})()}doOpen(L,O,N,V,x,ne,H){const te=[];let ie;function oe(me,we){te.push(me),we&&(ie=me,ne=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Me}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&H.length>0){const me=H[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(me);we&&oe(this.doAddFoldersToExistingWindow(we,H.map(Ee=>Ee.workspace.uri)))}const Le=N.length+O.length+V.length;if(ne&&Le===0){const me=ne.filesToOpenOrCreate[0]||ne.filesToDiff[0]||ne.filesToMerge[3],we=this.getWindows().filter(X=>ne&&(0,m.isEqualAuthority)(X.remoteAuthority,ne.remoteAuthority));let Ee;me?.fileUri&&!Me&&((L.context===4||L.context===0||L.context===1)&&(Ee=(0,le.findWindowOnFile)(we,me.fileUri,X=>X.configPath.scheme===y.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(X.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(we))),Ee?(0,se.isWorkspaceIdentifier)(Ee.openedWorkspace)?O.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?N.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(L,Ee,ne),!0):oe(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:ne,forceNewWindow:!0,remoteAuthority:ne.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,profile:L.profile}),!0)}const ke=(0,R.distinct)(O,me=>me.workspace.id);if(ke.length>0){const me=(0,R.coalesce)(ke.map(we=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.configPath)));if(me.length>0){const we=me[0],Ee=(0,m.isEqualAuthority)(ne?.remoteAuthority,we.remoteAuthority)?ne:void 0;oe(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}ke.forEach(we=>{if(me.some(ae=>ae.openedWorkspace&&ae.openedWorkspace.id===we.workspace.id))return;const Ee=we.remoteAuthority,X=(0,m.isEqualAuthority)(ne?.remoteAuthority,Ee)?ne:void 0;oe(this.doOpenFolderOrWorkspace(L,we,ge,X),!!X),ge=!0})}const Ae=(0,R.distinct)(N,me=>m.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(we=>(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),we.workspace.uri)));if(me.length>0){const we=me[0],Ee=(0,m.isEqualAuthority)(ne?.remoteAuthority,we.remoteAuthority)?ne:void 0;oe(this.doOpenFilesInExistingWindow(L,we,Ee),!!Ee),ge=!0}Ae.forEach(we=>{if(me.some(ae=>(0,se.isSingleFolderWorkspaceIdentifier)(ae.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(ae.openedWorkspace.uri,we.workspace.uri)))return;const Ee=we.remoteAuthority,X=(0,m.isEqualAuthority)(ne?.remoteAuthority,Ee)?ne:void 0;oe(this.doOpenFolderOrWorkspace(L,we,ge,X),!!X),ge=!0})}const Ve=(0,R.distinct)(V,me=>me.backupFolder);if(Ve.length>0&&Ve.forEach(me=>{const we=me.remoteAuthority,Ee=(0,m.isEqualAuthority)(ne?.remoteAuthority,we)?ne:void 0;oe(this.doOpenEmpty(L,!0,we,Ee,me),!!Ee),ge=!0}),te.length===0||ne){ne&&!x&&x++;const me=ne?ne.remoteAuthority:L.remoteAuthority;for(let we=0;we<x;we++)oe(this.doOpenEmpty(L,ge,me,ne),!!ne),ge=!0}return{windows:(0,R.distinct)(te),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(L,O,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:N}),O.focus();const V={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToMerge:N?.filesToMerge,filesToWait:N?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",D.CancellationToken.None,V),O}doAddFoldersToExistingWindow(L,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),L.focus();const N={foldersToAdd:O};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,N),L}doOpenEmpty(L,O,N,V,x){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:N,filesToOpen:V,forceNewWindow:O});let ne;return!O&&typeof L.contextWindowId=="number"&&(ne=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:N,forceNewWindow:O,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:ne,emptyWindowBackupInfo:x,profile:L.profile})}doOpenFolderOrWorkspace(L,O,N,V,x){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:V}),!N&&!x&&typeof L.contextWindowId=="number"&&(x=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:V,windowToUse:x,profile:L.profile})}getPathsToOpen(L){let O,N=!1,V=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(L),N=!0):L.forceEmpty?O=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(O=this.doExtractPathsFromCLI(L.cli),O.length===0&&O.push(Object.create(null)),N=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),V=!0),!L.addMode&&N){const x=O.filter(ne=>ee(ne));if(x.length>1){const ne=x[0].remoteAuthority;if(x.every(H=>(0,m.isEqualAuthority)(H.remoteAuthority,ne))){const H=this.workspacesManagementMainService.createUntitledWorkspaceSync(x.map(te=>({uri:te.workspace.uri})));O.push({workspace:H,remoteAuthority:ne}),O=O.filter(te=>!ee(te))}}}return L.initialStartup&&!V&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(x=>z(x)||ee(x)||x.backupPath)),O}doExtractPathsFromAPI(L){const O=[],N={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const V of(0,R.coalesce)(L.urisToOpen||[])){const x=this.resolveOpenable(V,N);if(x)x.label=V.label,O.push(x);else{const ne=this.resourceFromOpenable(V),H={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,p.localize)(0,null))],defaultId:0,message:ne.scheme===y.Schemas.file?(0,p.localize)(1,null):(0,p.localize)(2,null),detail:ne.scheme===y.Schemas.file?(0,p.localize)(3,null,(0,I.getPathLabel)(ne,{os:b.OS,tildify:this.environmentMainService})):(0,p.localize)(4,null,ne.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(H,(0,v.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(L){const O=[],N={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},V=L["folder-uri"];if(V)for(const H of V){const te=this.cliArgToUri(H);if(te){const ie=this.resolveOpenable({folderUri:te},N);ie&&O.push(ie)}}const x=L["file-uri"];if(x)for(const H of x){const te=this.cliArgToUri(H);if(te){const ie=this.resolveOpenable((0,se.hasWorkspaceFileExtension)(H)?{workspaceUri:te}:{fileUri:te},N);ie&&O.push(ie)}}const ne=L._;for(const H of ne){const te=N.remoteAuthority?this.doResolvePathRemote(H,N):this.doResolveFilePath(H,N);te&&O.push(te)}return O}cliArgToUri(L){try{const O=d.URI.parse(L);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${L}, ${O.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];L!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const V of O)if(V.workspace){const x=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority,rejectTransientWorkspaces:!0});z(x)&&N.push(x)}else if(V.folderUri){const x=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});ee(x)&&N.push(x)}else L!=="folders"&&V.backupPath&&N.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return N}}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,O=Object.create(null)){const N=this.resourceFromOpenable(L);return N.scheme===y.Schemas.file?((0,Q.isFileToOpen)(L)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,O)):this.doResolveRemoteOpenable(L,O)}doResolveRemoteOpenable(L,O){let N=this.resourceFromOpenable(L);const V=(0,F.getRemoteAuthority)(N)||O.remoteAuthority;if(N=(0,m.removeTrailingPathSeparator)((0,m.normalizePath)(N)),(0,Q.isFileToOpen)(L)){if(O.gotoLineMode){const{path:x,line:ne,column:H}=(0,l.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:x}),options:{selection:ne?{startLineNumber:ne,startColumn:H||1}:void 0},remoteAuthority:V}}return{fileUri:N,remoteAuthority:V}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,de.getWorkspaceIdentifier)(N),remoteAuthority:V};return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:V}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,O){let N,V;O.gotoLineMode&&({path:L,line:N,column:V}=(0,l.parseLineAndColumnAware)(L)),L=(0,l.sanitizeFilePath)((0,f.normalize)(L),(0,w.cwd)());try{const x=(0,t.statSync)(L);if(x.isFile()){if(!O.forceOpenWorkspaceAsFile){const ne=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(L));if(ne)return ne.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:r.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:V||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(d.URI.file(L),x),type:r.FileType.Directory,exists:!0};if(!b.isWindows&&L==="/dev/null")return{fileUri:d.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const ne=d.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([ne]),O.ignoreFileNotFound)return{fileUri:ne,type:r.FileType.File,exists:!1}}}doResolvePathRemote(L,O){const N=L.charCodeAt(0),V=O.remoteAuthority;let x,ne;O.gotoLineMode&&({path:L,line:x,column:ne}=(0,l.parseLineAndColumnAware)(L)),N!==47&&((0,l.isWindowsDriveLetter)(N)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,l.toSlashes)(L)),L=`/${L}`);const H=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:V,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return O.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,de.getWorkspaceIdentifier)(H),remoteAuthority:V};if(O.gotoLineMode||f.posix.basename(L).indexOf(".")!==-1)return{fileUri:H,options:{selection:x?{startLineNumber:x,startColumn:ne||1}:void 0},remoteAuthority:V}}return{workspace:(0,de.getSingleFolderWorkspaceIdentifier)(H),remoteAuthority:V}}shouldOpenNewWindow(L){const O=this.configurationService.getValue("window"),N=O?.openFoldersInNewWindow||"default",V=O?.openFilesInNewWindow||"off";let x=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(N==="on"||N==="off")&&(x=N==="on");let ne=!1;return L.forceNewWindow||L.forceReuseWindow?ne=!!L.forceNewWindow&&!L.forceReuseWindow:(b.isMacintosh?L.context===1&&(ne=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(ne=!0),!L.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(ne=V==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:ne}}openExtensionDevelopmentHostWindow(L,O){const N=(0,le.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(N)return this.lifecycleMainService.reload(N,O.cli),N.focus(),[N];let V=O.cli["folder-uri"]||[],x=O.cli["file-uri"]||[],ne=O.cli._;if(!ne.length&&!V.length&&!x.length&&!O.cli.extensionTestsPath){const ie=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,oe=ie&&(ie.workspace||ie.folderUri);oe&&(d.URI.isUri(oe)?oe.scheme===y.Schemas.file?ne=[oe.fsPath]:V=[oe.toString()]:oe.configPath.scheme===y.Schemas.file?ne=[(0,m.originalFSPath)(oe.configPath)]:x=[oe.configPath.toString()])}let H=O.remoteAuthority;for(const ie of L)if(ie.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=d.URI.parse(ie),ge=(0,F.getRemoteAuthority)(oe);ge&&(H?(0,m.isEqualAuthority)(ge,H)||this.logService.error("more than one extension development path authority"):H=ge)}ne=ne.filter(ie=>{const oe=d.URI.file(ie);return(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,m.isEqualAuthority)((0,F.getRemoteAuthority)(oe),H)}),V=V.filter(ie=>{const oe=this.cliArgToUri(ie);return oe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,m.isEqualAuthority)((0,F.getRemoteAuthority)(oe),H):!1}),x=x.filter(ie=>{const oe=this.cliArgToUri(ie);return oe&&!!(0,le.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,m.isEqualAuthority)((0,F.getRemoteAuthority)(oe),H):!1}),O.cli._=ne,O.cli["folder-uri"]=V,O.cli["file-uri"]=x;const te={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!ne.length&&!V.length&&!x.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:H,profile:O.profile};return this.open(te)}openInBrowserWindow(L){const O=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesMainService.profiles,profile:this.resolveProfileForBrowserWindow(L)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:P.default,isInitialStartup:L.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize()};let V;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||this.getLastActiveWindow(),V&&V.focus()),V){const x=V.config;!N.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(N.extensionDevelopmentPath=x.extensionDevelopmentPath,N.extensionDevelopmentKind=x.extensionDevelopmentKind,N["enable-proposed-api"]=x["enable-proposed-api"],N.verbose=x.verbose,N["inspect-extensions"]=x["inspect-extensions"],N["inspect-brk-extensions"]=x["inspect-brk-extensions"],N.debugId=x.debugId,N.extensionEnvironment=x.extensionEnvironment,N["extensions-dir"]=x["extensions-dir"],N["disable-extensions"]=x["disable-extensions"])}else{const x=this.windowsStateHandler.getNewWindowState(N);(0,h.mark)("code/willCreateCodeWindow");const ne=V=this.instantiationService.createInstance(re.CodeWindow,{state:x,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,h.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(ne),ut.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,g.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,g.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne)),ne.onDidTriggerSystemContextMenu(({x:te,y:ie})=>this._onDidTriggerSystemContextMenu.fire({window:ne,x:te,y:ie}));const H=(0,v.assertIsDefined)(ne.win?.webContents);H.removeAllListeners("devtools-reload-page"),H.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return N.windowId=V.id,V.isReady?this.lifecycleMainService.unload(V,4).then(x=>{x||this.doOpenInBrowserWindow(V,N,L)}):this.doOpenInBrowserWindow(V,N,L),V}doOpenInBrowserWindow(L,O,N){if(!O.extensionDevelopmentPath)if((0,se.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,se.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority});else{const V=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackup(V,O.remoteAuthority)}L.load(O)}resolveProfileForBrowserWindow(L){let O=L.profile;return O&&this.userDataProfilesMainService.setProfileForWorkspaceSync(L.workspace??"empty-window",O),O||(O=this.userDataProfilesMainService.getOrSetProfileForWorkspace(L.workspace??"empty-window",(L.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesMainService.defaultProfile)),O}onWindowClosed(L){const O=ut.WINDOWS.indexOf(L);ut.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=S.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,m.isEqualAuthority)(O.remoteAuthority,L)))}doGetLastActiveWindow(L){const O=Math.max.apply(Math,L.map(N=>N.lastFocusTime));return L.find(N=>N.lastFocusTime===O)}sendToFocused(L,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...O)}sendToAll(L,O,N){for(const V of this.getWindows())N&&N.indexOf(V.id)>=0||V.sendWhenReady(L,D.CancellationToken.None,O)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(L){const O=this.getWindows().filter(N=>N.id===L);return(0,R.firstOrDefault)(O)}getWindowByWebContents(L){const O=S.BrowserWindow.fromWebContents(L);if(!!O)return this.getWindowById(O.id)}};B.WINDOWS=[],B=ve([Y(2,u.ILogService),Y(3,U.IStateMainService),Y(4,A.IPolicyService),Y(5,i.IEnvironmentMainService),Y(6,W.IUserDataProfilesMainService),Y(7,a.ILifecycleMainService),Y(8,c.IBackupMainService),Y(9,n.IConfigurationService),Y(10,K.IWorkspacesHistoryMainService),Y(11,$.IWorkspacesManagementMainService),Y(12,s.IInstantiationService),Y(13,o.IDialogMainService),Y(14,r.IFileService),Y(15,M.IProductService),Y(16,T.IProtocolMainService),Y(17,_.IThemeMainService)],B),e.WindowsMainService=B}),define(J[267],Z([0,1,60,33,75,51]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(l,g,I,E){this.workspacesManagementMainService=l,this.windowsMainService=g,this.workspacesHistoryMainService=I,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(l,g){const I=this.windowsMainService.getWindowById(l);if(I)return this.workspacesManagementMainService.enterWorkspace(I,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(l,g,I){return this.workspacesManagementMainService.createUntitledWorkspace(g,I)}deleteUntitledWorkspace(l,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(l,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}getRecentlyOpened(l){return this.workspacesHistoryMainService.getRecentlyOpened()}addRecentlyOpened(l,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}removeRecentlyOpened(l,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}clearRecentlyOpened(l){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};D=ve([Y(0,R.IWorkspacesManagementMainService),Y(1,t.IWindowsMainService),Y(2,k.IWorkspacesHistoryMainService),Y(3,S.IBackupMainService)],D),e.WorkspacesMainService=D}),define(J[268],Z([0,1,15,40,29,30,18,44,17,31,48,43,35,2,13,9,4,12,7,28,81,131,45,145,99,244,148,60,249,19,69,181,84,118,56,102,179,26,59,110,192,212,193,246,103,194,195,14,205,86,68,5,85,260,223,257,21,6,207,265,65,20,63,253,87,41,250,90,111,37,228,230,73,47,235,236,261,237,262,113,239,240,241,242,247,33,266,248,27,91,75,267,51,245,38,211,42,256,219,54,72,89,251,258,8]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P,M,T,F,U,Q,re,le,ue,se,de,K,$,_,A,W,z,ee,B,j,L,O,N,V,x,ne,H,te,ie,oe,ge,Me,Le,ke,Ae,Ve,me,we,Ee,X,ae,he,be,Ie,Oe,We,Ue,Ne,ze,Be,qe,G,ce,pe,fe,Se,De,Fe,Qe,et,Ke,Ye,it,st,ht,_t,Ut,yt,Nt,Bt,zt,Tt,$t,qt,jt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let bt=class extends f.Disposable{constructor(ye,Pe,Re,Ce,Te,_e,Xe,tt,$e,je,Ge){super(),this.mainProcessNodeIpcServer=ye,this.userEnv=Pe,this.mainInstantiationService=Re,this.logService=Ce,this.environmentMainService=Te,this.lifecycleMainService=_e,this.configurationService=Xe,this.stateMainService=tt,this.fileService=$e,this.productService=je,this.userDataProfilesMainService=Ge,this.configureSession(),this.registerListeners()}configureSession(){const ye=$e=>$e?.startsWith(`${h.Schemas.vscodeWebview}://`),Pe=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler(($e,je,Ge,He)=>ye(He.requestingUrl)?Ge(Pe.has(je)):Ge(!1)),S.session.defaultSession.setPermissionCheckHandler(($e,je,Ge,He)=>ye(He.requestingUrl)?Pe.has(je):!1);const Re=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ce=$e=>{for(let je=$e;je;je=je.parent)if(je.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Te=$e=>$e.resourceType==="xhr"||Ce($e.frame),_e=$e=>{const je=$e.frame;if(!je||!this.windowsMainService)return!1;const Ge=S.BrowserWindow.getAllWindows();for(const He of Ge)if(je.processId===He.webContents.mainFrame.processId)return!0;return!1},Xe=($e,je)=>{if($e.path!=="/index.html")return!0;const Ge=je.frame;if(!Ge||!this.windowsMainService)return!1;for(const He of this.windowsMainService.getWindows())if(He.win&&Ge.processId===He.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest(($e,je)=>{const Ge=v.URI.parse($e.url);return Ge.scheme===h.Schemas.vscodeWebview&&!Xe(Ge,$e)?(this.logService.error("Blocked vscode-webview request",$e.url),je({cancel:!0})):Ge.scheme===h.Schemas.vscodeFileResource&&!_e($e)?(this.logService.error("Blocked vscode-file request",$e.url),je({cancel:!0})):Ge.path.endsWith(".svg")&&!Re.has(Ge.scheme)?je({cancel:!Te($e)}):je({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived(($e,je)=>{const Ge=$e.responseHeaders,He=Ge["content-type"]||Ge["Content-Type"];if(He&&Array.isArray(He)){const ot=v.URI.parse($e.url);if(ot.path.endsWith(".svg")&&Re.has(ot.scheme))return Ge["Content-Type"]=["image/svg+xml"],je({cancel:!1,responseHeaders:Ge});if(!ot.path.endsWith(h.Schemas.vscodeRemoteResource)&&He.some(dt=>dt.toLowerCase().includes("image/svg")))return je({cancel:!Te($e)})}return je({cancel:!1})});const tt=S.session.defaultSession;typeof tt.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&tt.setCodeCachePath((0,b.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,l.setUnexpectedErrorHandler)(Re=>this.onUnexpectedError(Re)),process.on("uncaughtException",Re=>(0,l.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,l.onUnexpectedError)(Re)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(Re,Ce)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Ce)}),S.app.on("activate",(Re,Ce)=>{this.logService.trace("app#activate"),Ce||this.windowsMainService?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Re,Ce)=>{Ce.on("will-navigate",Te=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Te.preventDefault()}),Ce.setWindowOpenHandler(({url:Te})=>(this.nativeHostMainService?.openExternal(void 0,Te),{action:"deny"}))});let ye=[],Pe;S.app.on("open-file",(Re,Ce)=>{this.logService.trace("app#open-file: ",Ce),Re.preventDefault(),ye.push(this.getWindowOpenableFromPathSync(Ce)),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ye,gotoLineMode:!1,preferNewWindow:!0}),ye=[],Pe=void 0},100)}),S.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ce=this.windowsMainService?.getWindowByWebContents(Re.sender);let Te,_e;return Ce?.config?(Te=Ce.config,_e={...process.env,...Ce.config.userEnv}):(Te=this.environmentMainService.args,_e=process.env),this.resolveShellEnvironment(Te,_e,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ce,Te)=>{const _e=this.validateNlsPath([Ce]);if(!_e||typeof Te!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(_e,D.VSBuffer.fromString(Te))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ce)=>{const Te=this.validateNlsPath(Ce);if(!Te)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Te)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}validateNlsPath(ye){let Pe;for(const Re of ye)typeof Re=="string"&&(typeof Pe!="string"?Pe=Re:Pe=(0,b.join)(Pe,Re));if(!(typeof Pe!="string"||!(0,b.isAbsolute)(Pe)||!(0,g.isEqualOrParent)(Pe,this.environmentMainService.cachedLanguagesPath,!w.isLinux)))return v.URI.file(Pe)}onUnexpectedError(ye){if(ye){const Pe={message:`[uncaught exception in main]: ${ye.message}`,stack:ye.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.logService.error(`[uncaught exception in main]: ${ye}`),ye.stack&&this.logService.error(ye.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ye=this.productService.win32AppUserModelId;w.isWindows&&ye&&S.app.setAppUserModelId(ye);try{w.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(He){this.logService.error(He)}const Pe=new o.Server;this.lifecycleMainService.onWillShutdown(He=>{He.reason===2&&Pe.dispose()}),this.logService.trace("Resolving machine identifier...");const Re=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ce,sharedProcessReady:Te,sharedProcessClient:_e}=this.setupSharedProcess(Re),Xe=await this.initServices(Re,Ce,Te);this.setUpHandlers(Xe);const tt=this.userDataProfilesMainService.checkAndCreateProfileFromCli(this.environmentMainService.args),$e=tt?await tt:void 0;Xe.invokeFunction(He=>this.initChannels(He,Pe,_e));const je=Xe.invokeFunction(He=>this.openFirstWindow(He,$e,Pe));Xe.invokeFunction(He=>this.afterWindowOpen(He,Ce)),this.environmentMainService.args.trace&&Xe.invokeFunction(He=>this.stopTracingEventually(He,je)),this._register(new Ot.RunOnceScheduler(()=>{this._register((0,Ot.runWhenIdle)(()=>this.lifecycleMainService.phase=4,2500))},2500)).schedule()}setUpHandlers(ye){this._register(ye.createInstance(r.ProxyAuthHandler)),this._register(ye.createInstance(Nt.DefaultExtensionsProfileInitHandler)),this._register(ye.createInstance(jt.UserDataTransientProfilesHandler))}async resolveMachineId(){let ye=this.stateMainService.getItem(ae.machineIdKey);return(!ye||w.isMacintosh&&ye==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ye=await(0,p.getMachineId)(),this.stateMainService.setItem(ae.machineIdKey,ye)),ye}setupSharedProcess(ye){const Pe=this._register(this.mainInstantiationService.createInstance(Ae.SharedProcess,ye,this.userEnv)),Re=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Te=await Pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new i.Client(Te,"main")})(),Ce=(async()=>(await Pe.whenReady(),Re))();return{sharedProcess:Pe,sharedProcessReady:Ce,sharedProcessClient:Re}}async initServices(ye,Pe,Re){const Ce=new V.ServiceCollection;switch(process.platform){case"win32":Ce.set(Oe.IUpdateService,new O.SyncDescriptor(Be.Win32UpdateService));break;case"linux":w.isLinuxSnap?Ce.set(Oe.IUpdateService,new O.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ce.set(Oe.IUpdateService,new O.SyncDescriptor(Ne.LinuxUpdateService));break;case"darwin":Ce.set(Oe.IUpdateService,new O.SyncDescriptor(Ue.DarwinUpdateService));break}Ce.set(De.IWindowsMainService,new O.SyncDescriptor(Fe.WindowsMainService,[ye,this.userEnv])),Ce.set(Q.IDialogMainService,new O.SyncDescriptor(Q.DialogMainService)),Ce.set(H.ILaunchMainService,new O.SyncDescriptor(H.LaunchMainService)),Ce.set(U.IDiagnosticsMainService,new O.SyncDescriptor(U.DiagnosticsMainService)),Ce.set(F.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Re.then(_e=>_e.getChannel("diagnostics"))))),Ce.set(x.IIssueMainService,new O.SyncDescriptor(x.IssueMainService,[this.userEnv])),Ce.set(re.IEncryptionMainService,new O.SyncDescriptor(le.EncryptionMainService,[ye])),Ce.set(ne.IKeyboardLayoutMainService,new O.SyncDescriptor(ne.KeyboardLayoutMainService)),Ce.set(Me.INativeHostMainService,new O.SyncDescriptor(Me.NativeHostMainService,[Pe])),Ce.set(M.ICredentialsMainService,new O.SyncDescriptor(ht.CredentialsNativeMainService)),Ce.set(fe.IWebviewManagerService,new O.SyncDescriptor(Se.WebviewMainService)),Ce.set(Ke.IWorkspacesService,new O.SyncDescriptor(it.WorkspacesMainService)),Ce.set(st.IWorkspacesManagementMainService,new O.SyncDescriptor(st.WorkspacesManagementMainService)),Ce.set(Ye.IWorkspacesHistoryMainService,new O.SyncDescriptor(Ye.WorkspacesHistoryMainService)),Ce.set(ge.IMenubarMainService,new O.SyncDescriptor(ge.MenubarMainService)),Ce.set(K.IExtensionUrlTrustService,new O.SyncDescriptor($.ExtensionUrlTrustService)),Ce.set(_.IExtensionHostStarter,new O.SyncDescriptor(A.ExtensionHostStarter)),Ce.set(Ee.IStorageMainService,new O.SyncDescriptor(Ee.StorageMainService)),Ce.set(Ee.IApplicationStorageMainService,new O.SyncDescriptor(Ee.ApplicationStorageMainService)),w.isWindows?Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.WindowsExternalTerminalService)):w.isMacintosh?Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.MacExternalTerminalService)):w.isLinux&&Ce.set(W.IExternalTerminalMainService,new O.SyncDescriptor(z.LinuxExternalTerminalService));const Te=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService,this.lifecycleMainService);if(Ce.set(a.IBackupMainService,Te),Ce.set(qe.IURLService,new O.SyncDescriptor(ce.NativeURLService)),(0,Ie.supportsTelemetry)(this.productService,this.environmentMainService)){const _e=(0,Ie.isInternalTelemetry)(this.productService,this.configurationService),Xe=(0,n.getDelayedChannel)(Re.then(He=>He.getChannel("telemetryAppender"))),tt=new he.TelemetryAppenderClient(Xe),$e=(0,X.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,ye,_e,this.environmentMainService.installSourcePath),je=(0,Ie.getPiiPathsFromEnvironment)(this.environmentMainService),Ge={appenders:[tt],commonProperties:$e,piiPaths:je,sendErrorTelemetry:!0};Ce.set(ae.ITelemetryService,new O.SyncDescriptor(be.TelemetryService,[Ge]))}else Ce.set(ae.ITelemetryService,Ie.NullTelemetryService);return Ce.set(Tt.IExtensionsProfileScannerService,new O.SyncDescriptor(Tt.ExtensionsProfileScannerService,void 0,!0)),Ce.set($t.IExtensionsScannerService,new O.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Te.initialize(),this.mainInstantiationService.createChild(Ce)}initChannels(ye,Pe,Re){const Ce=n.ProxyChannel.fromService(ye.get(H.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Ce);const Te=n.ProxyChannel.fromService(ye.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Te);const _e=new Ut.PolicyChannel(ye.get(_t.IPolicyService));Pe.registerChannel("policy",_e),Re.then(Ze=>Ze.registerChannel("policy",_e));const Xe=this.fileService.getProvider(h.Schemas.file);(0,m.assertType)(Xe instanceof L.DiskFileSystemProvider);const tt=new j.DiskFileSystemProviderChannel(Xe,this.logService,this.environmentMainService);Pe.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt),Re.then(Ze=>Ze.registerChannel(ee.LOCAL_FILE_SYSTEM_CHANNEL_NAME,tt));const $e=n.ProxyChannel.fromService(ye.get(yt.IUserDataProfilesMainService));Pe.registerChannel("userDataProfiles",$e),Re.then(Ze=>Ze.registerChannel("userDataProfiles",$e));const je=new Bt.RequestChannel(ye.get(zt.IRequestService));Re.then(Ze=>Ze.registerChannel("request",je));const Ge=new We.UpdateChannel(ye.get(Oe.IUpdateService));Pe.registerChannel("update",Ge);const He=n.ProxyChannel.fromService(ye.get(x.IIssueMainService));Pe.registerChannel("issue",He);const ot=n.ProxyChannel.fromService(ye.get(re.IEncryptionMainService));Pe.registerChannel("encryption",ot);const dt=n.ProxyChannel.fromService(ye.get(M.ICredentialsMainService));Pe.registerChannel("credentials",dt);const Et=n.ProxyChannel.fromService(ye.get(Ve.ISignService));Pe.registerChannel("sign",Et);const Ct=n.ProxyChannel.fromService(ye.get(ne.IKeyboardLayoutMainService));Pe.registerChannel("keyboardLayout",Ct),this.nativeHostMainService=ye.get(Me.INativeHostMainService);const Je=n.ProxyChannel.fromService(this.nativeHostMainService);Pe.registerChannel("nativeHost",Je),Re.then(Ze=>Ze.registerChannel("nativeHost",Je));const pt=n.ProxyChannel.fromService(ye.get(Ke.IWorkspacesService));Pe.registerChannel("workspaces",pt);const ft=n.ProxyChannel.fromService(ye.get(ge.IMenubarMainService));Pe.registerChannel("menubar",ft);const wt=n.ProxyChannel.fromService(ye.get(qe.IURLService));Pe.registerChannel("url",wt);const It=n.ProxyChannel.fromService(ye.get(K.IExtensionUrlTrustService));Pe.registerChannel("extensionUrlTrust",It);const Pt=n.ProxyChannel.fromService(ye.get(fe.IWebviewManagerService));Pe.registerChannel("webview",Pt);const at=this._register(new we.StorageDatabaseChannel(this.logService,ye.get(Ee.IStorageMainService)));Pe.registerChannel("storage",at),Re.then(Ze=>Ze.registerChannel("storage",at));const gt=n.ProxyChannel.fromService(ye.get(W.IExternalTerminalMainService));Pe.registerChannel("externalTerminal",gt);const mt=new oe.LogLevelChannel(ye.get(ie.ILogService));Pe.registerChannel("logLevel",mt),Re.then(Ze=>Ze.registerChannel("logLevel",mt));const xe=new oe.LoggerChannel(ye.get(ie.ILoggerService));Pe.registerChannel("logger",xe),Re.then(Ze=>Ze.registerChannel("logger",xe));const rt=new T.ElectronExtensionHostDebugBroadcastChannel(ye.get(De.IWindowsMainService),ye.get(yt.IUserDataProfilesMainService));Pe.registerChannel("extensionhostdebugservice",rt);const ct=n.ProxyChannel.fromService(ye.get(_.IExtensionHostStarter));Pe.registerChannel(_.ipcExtensionHostStarterChannelName,ct)}openFirstWindow(ye,Pe,Re){const Ce=this.windowsMainService=ye.get(De.IWindowsMainService),Te=ye.get(qe.IURLService),_e=ye.get(Me.INativeHostMainService);this.lifecycleMainService.phase=2;const Xe=[],tt=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(xe=>{try{return{uri:v.URI.parse(xe),url:xe}}catch{return}}).filter(xe=>{if(!xe||this.shouldBlockURI(xe.uri))return!1;const rt=this.getWindowOpenableFromProtocolLink(xe.uri);return rt?(Xe.push(rt),!1):!0}),$e=this,je=this.environmentMainService,Ge=this.productService,He=this.logService;Te.registerHandler({async handleURL(xe,rt){if(He.trace("app#handleURL: ",xe.toString(!0),rt),xe.scheme===Ge.urlProtocol&&xe.path==="workspace"&&(xe=xe.with({authority:"file",path:v.URI.parse(xe.query).path,query:""})),$e.shouldBlockURI(xe))return!0;let ct=!1;const Ze=new URLSearchParams(xe.query);Ze.get("windowId")==="_blank"&&(Ze.delete("windowId"),xe=xe.with({query:Ze.toString()}),ct=!0),ct||=w.isMacintosh&&Ce.getWindowCount()===0;const kt=$e.getWindowOpenableFromProtocolLink(xe);if(He.trace("app#handleURL: windowOpenableFromProtocolLink = ",kt),kt){const[Mt]=Ce.open({context:5,cli:{...je.args},urisToOpen:[kt],forceNewWindow:ct,gotoLineMode:!0});return Mt.focus(),!0}if(ct){const[Mt]=Ce.open({context:5,cli:{...je.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(xe)});return await Mt.ready(),Te.open(xe,rt)}return!1}});const ot=this._register(new Qe.ActiveWindowManager({onDidOpenWindow:_e.onDidOpenWindow,onDidFocusWindow:_e.onDidFocusWindow,getActiveWindowId:()=>_e.getActiveWindowId(-1)})),dt=new n.StaticRouter(xe=>ot.getActiveClientId().then(rt=>xe===rt)),Et=new G.URLHandlerRouter(dt),Ct=Re.getChannel("urlHandler",Et);Te.registerHandler(new G.URLHandlerChannelClient(Ct)),this._register(new pe.ElectronURLListener(tt,Te,Ce,this.environmentMainService,this.productService));const Je=this.environmentMainService.args,pt=global.macOpenFiles,ft=(0,se.isLaunchedFromCli)(process.env)?0:4,wt=Je._.length,It=!!Je["folder-uri"],Pt=!!Je["file-uri"],at=Je["skip-add-to-recently-opened"]===!0,gt=Je.wait&&Je.waitMarkerFilePath?v.URI.file(Je.waitMarkerFilePath):void 0,mt=Je.remote||void 0;if(Xe.length>0)return Ce.open({context:ft,cli:Je,urisToOpen:Xe,gotoLineMode:!0,initialStartup:!0});if(!wt&&!It&&!Pt){if(Je["new-window"]||Pe)return Ce.open({context:ft,cli:Je,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:at,waitMarkerFileURI:gt,initialStartup:!0,remoteAuthority:mt,profile:Pe});if(pt.length)return Ce.open({context:1,cli:Je,urisToOpen:pt.map(xe=>this.getWindowOpenableFromPathSync(xe)),noRecentEntry:at,waitMarkerFileURI:gt,initialStartup:!0})}return Ce.open({context:ft,cli:Je,forceNewWindow:Je["new-window"]||!wt&&Je["unity-launch"],diffMode:Je.diff,mergeMode:Je.merge,noRecentEntry:at,waitMarkerFileURI:gt,gotoLineMode:Je.goto,initialStartup:!0,remoteAuthority:mt,profile:Pe})}shouldBlockURI(ye){return!!(ye.authority===h.Schemas.file&&w.isWindows&&S.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,y.mnemonicButtonLabel)((0,s.localize)(0,null)),(0,y.mnemonicButtonLabel)((0,s.localize)(1,null))],defaultId:0,cancelId:1,message:(0,s.localize)(2,null,(0,y.getPathLabel)(ye,{os:w.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,s.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ye){if(!!ye.path){if(ye.authority===h.Schemas.file){const Pe=v.URI.file(ye.fsPath);return(0,et.hasWorkspaceFileExtension)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(ye.authority===h.Schemas.vscodeRemote){const Pe=ye.path.indexOf(b.posix.sep,1);if(Pe!==-1){const Re=ye.path.substring(1,Pe),Ce=ye.path.substring(Pe),Te=v.URI.from({scheme:h.Schemas.vscodeRemote,authority:Re,path:Ce,query:ye.query,fragment:ye.fragment});return(0,et.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Te}:/:[\d]+$/.test(Ce)?{fileUri:Te}:{folderUri:Te}}}}}getWindowOpenableFromPathSync(ye){try{if((0,k.statSync)(ye).isDirectory())return{folderUri:v.URI.file(ye)};if((0,et.hasWorkspaceFileExtension)(ye))return{workspaceUri:v.URI.file(ye)}}catch{}return{fileUri:v.URI.file(ye)}}afterWindowOpen(ye,Pe){const Re=ye.get(ae.ITelemetryService),Ce=ye.get(Oe.IUpdateService);this.lifecycleMainService.phase=3,this.handleSharedProcessErrors(Re,Pe),this.installMutex(),S.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Te,_e)=>{_e({url:Te.url.replace(/^vscode-remote-resource:/,"http:"),method:Te.method})}),(Ce instanceof Be.Win32UpdateService||Ce instanceof Ne.LinuxUpdateService||Ce instanceof Ue.DarwinUpdateService)&&Ce.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0),this.updateCrashReporterEnablement()}async installMutex(){const ye=this.productService.win32MutexName;if(w.isWindows&&ye)try{const Pe=await new Promise((Ce,Te)=>{q(["windows-mutex"],Ce,Te)}),Re=new Pe.Mutex(ye);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Pe){this.logService.error(Pe)}}handleSharedProcessErrors(ye,Pe){let Re=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Re=!0),this._register(Pe.onDidError(({type:Ce,details:Te})=>{let _e;switch(Ce){case 1:_e="SharedProcess: detected unresponsive window";break;case 2:_e=`SharedProcess: crashed (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break;case 3:_e=`SharedProcess: failed to load (detail: ${Te?.reason??"<unknown>"}, code: ${Te?.exitCode??"<unknown>"})`;break}(0,l.onUnexpectedError)(new Error(_e)),ye.publicLog2("sharedprocesserror",{type:Ce,reason:Te?.reason,code:Te?.exitCode,visible:Pe.isVisible(),shuttingdown:Re})}))}async resolveShellEnvironment(ye,Pe,Re){try{return await(0,de.getResolvedShellEnv)(this.logService,ye,Pe)}catch(Ce){const Te=(0,C.toErrorMessage)(Ce);Re?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Te):this.logService.error(Te)}return{}}async updateCrashReporterEnablement(){try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString(),Re=JSON.parse((0,E.stripComments)(Pe)),Te=(0,Ie.getTelemetryLevel)(this.configurationService)>=1;if(Re["enable-crash-reporter"]===void 0){const _e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Te},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,d.generateUuid)()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,_e.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(Xe))}else{const _e=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Te},`);_e!==Pe&&await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(_e))}}catch(ye){this.logService.error(ye)}}stopTracingEventually(ye,Pe){this.logService.info("Tracing: waiting for windows to get ready...");const Re=ye.get(Q.IDialogMainService);let Ce=!1;const Te=async Xe=>{if(Ce)return;Ce=!0;const tt=await S.contentTracing.stopRecording(`${(0,g.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Xe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${tt}`):Re.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,s.localize)(4,null),detail:(0,s.localize)(5,null,tt),buttons:[(0,y.mnemonicButtonLabel)((0,s.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))},_e=setTimeout(()=>Te(!0),3e4);Promise.all(Pe.map(Xe=>Xe.ready())).then(()=>{clearTimeout(_e),Te(!1)})}};bt=ve([Y(2,N.IInstantiationService),Y(3,ie.ILogService),Y(4,ue.IEnvironmentMainService),Y(5,te.ILifecycleMainService),Y(6,P.IConfigurationService),Y(7,me.IStateMainService),Y(8,B.IFileService),Y(9,Le.IProductService),Y(10,yt.IUserDataProfilesMainService)],bt),e.CodeApplication=bt}),define(J[269],Z([0,1,38,8,277,2]),function(q,e,S,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class D extends S.AbstractPolicyService{constructor(l){super(),this.productName=l,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(l){await this.throttler.queue(()=>new Promise((g,I)=>{try{this.watcher.value=(0,k.createWatcher)(this.productName,l,E=>{for(const y in E){const f=E[y];f===void 0?this.policies.delete(y):this.policies.set(y,f)}this._onDidChange.fire(Object.keys(E)),g()})}catch(E){I(E)}}))}}e.NativePolicyService=D}),define(J[270],Z([0,1,221,8,18,17,2,12,19,36,110,6,220,278]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let h=class extends D.Disposable{constructor(w,m,v){super(),this.environmentService=m,this.logService=v,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,m){this.logService.trace("RequestService#request (node) - begin",w.url);const{proxyUrl:v,strictSSL:d}=this;let p;try{p=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",o))}const c={...process.env,...p},n=w.agent?w.agent:await(0,y.getProxyAgent)(w.url||"",c,{proxyUrl:v,strictSSL:d});w.agent=n,w.strictSSL=d,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization});try{const o=await this._request(w,m);return this.logService.trace("RequestService#request (node) - success",w.url),o}catch(o){throw this.logService.trace("RequestService#request (node) - error",w.url,o),o}}async getNodeRequest(w){return((0,S.parse)(w.url).protocol==="https:"?await new Promise((d,p)=>{q(["https"],d,p)}):await new Promise((d,p)=>{q(["http"],d,p)})).request}_request(w,m){return t.Promises.withAsyncBody(async(v,d)=>{const p=(0,S.parse)(w.url),c=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),n={hostname:p.hostname,port:p.port?parseInt(p.port):p.protocol==="https:"?443:80,protocol:p.protocol,path:p.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,C.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(n.auth=w.user+":"+w.password);const o=c(n,i=>{const r=(0,C.isNumber)(w.followRedirects)?w.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...w,url:i.headers.location,followRedirects:r-1},m).then(v,d);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,f.createGunzip)())),v({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});o.on("error",d),w.timeout&&o.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&o.write(w.data),o.end(),m.onCancellationRequested(()=>{o.abort(),d(new R.CancellationError)})})}async resolveProxy(w){}};h=ve([Y(0,l.IConfigurationService),Y(1,g.INativeEnvironmentService),Y(2,E.ILogService)],h),e.RequestService=h}),define(J[271],Z([0,1,15,270]),function(q,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(D){return S.net.request}class R extends t.RequestService{request(C,l){return super.request({...C||{},getRawRequest:k},l)}}e.RequestMainService=R}),define(J[279],Z([0,1,15,29,7,24,8,44,17,31,48,35,13,9,71,4,34,25,23,45,83,268,10,19,215,227,26,59,184,14,203,86,68,200,85,21,105,6,208,106,53,20,61,252,112,233,54,271,87,222,41,226,73,64,42,38,269,210,2,55,238,39,234]),function(q,e,S,t,k,R,D,C,l,g,I,E,y,f,h,b,w,m,v,d,p,c,n,o,i,r,s,a,u,P,M,T,F,U,Q,re,le,ue,se,de,K,$,_,A,W,z,ee,B,j,L,O,N,V,x,ne,H,te,ie,oe,ge,Me,Le){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.startup()}catch(me){console.error(me.message),S.app.exit(1)}}async startup(){(0,l.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,we,Ee,X,ae,he,be,Ie]=this.createServices();try{try{await this.initServices(Ee,Ie,X,ae,be)}catch(Oe){throw this.handleStartupDataDirError(Ee,be.nameLong,Oe),Oe}await me.invokeFunction(async Oe=>{const We=Oe.get(ue.ILogService),Ue=Oe.get(re.ILifecycleMainService),Ne=Oe.get(P.IFileService),ze=await this.claimInstance(We,Ee,Ue,me,be,!0);return v.Promises.writeFile(Ee.mainLockfile,String(process.pid)).catch(Be=>{We.warn(`Error writing main lockfile: ${Be.stack}`)}),he.logger=new de.SpdLogLogger("main",(0,f.join)(Ee.logsPath,"main.log"),!0,!1,he.getLevel()),(0,I.once)(Ue.onWillShutdown)(Be=>{Ne.dispose(),X.dispose(),Be.join(v.Promises.unlink(Ee.mainLockfile).catch(()=>{}))}),me.createInstance(c.CodeApplication,ze,we).startup()})}catch(Oe){me.invokeFunction(this.quit,Oe)}}createServices(){const me=new Q.ServiceCollection,we=new oe.DisposableStore;process.once("exit",()=>we.dispose());const Ee={_serviceBrand:void 0,...K.default};me.set($.IProductService,Ee);const X=new s.EnvironmentMainService(this.resolveArgs(),Ee),ae=this.patchEnvironment(X);me.set(s.IEnvironmentMainService,X);const he=new le.BufferLogService,be=we.add(new ue.MultiplexLogService([new ue.ConsoleMainLogger((0,ue.getLogLevel)(X)),he]));me.set(ue.ILogService,be);const Ie=new M.FileService(be);me.set(P.IFileService,Ie);const Oe=new T.DiskFileSystemProvider(be);Ie.registerProvider(y.Schemas.file,Oe);const We=new Me.UriIdentityService(Ie);me.set(ge.IUriIdentityService,We),me.set(ue.ILoggerService,new se.LoggerService(be,Ie));const Ue=new N.StateMainService(X,be,Ie);me.set(O.IStateMainService,Ue);const Ne=new ne.UserDataProfilesMainService(Ue,We,X,Ie,be);me.set(ne.IUserDataProfilesMainService,Ne);const ze=b.isWindows&&Ee.win32RegValueName?we.add(new te.NativePolicyService(Ee.win32RegValueName)):X.policyFile?we.add(new ie.FilePolicyService(X.policyFile,Ie,be)):new H.NullPolicyService;me.set(H.IPolicyService,ze);const Be=new i.ConfigurationService(Ne.defaultProfile.settingsResource,Ie,ze,be);return me.set(o.IConfigurationService,Be),me.set(re.ILifecycleMainService,new F.SyncDescriptor(re.LifecycleMainService)),me.set(ee.IRequestService,new F.SyncDescriptor(B.RequestMainService,void 0,!0)),me.set(x.IThemeMainService,new F.SyncDescriptor(x.ThemeMainService)),me.set(j.ISignService,new F.SyncDescriptor(L.SignService)),me.set(W.ITunnelService,new F.SyncDescriptor(z.TunnelService)),me.set(_.IProtocolMainService,new F.SyncDescriptor(A.ProtocolMainService)),[new U.InstantiationService(me,!0),ae,X,Be,Ue,he,Ee,Ne]}patchEnvironment(me){const we={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const X=process.env[Ee];typeof X=="string"&&(we[Ee]=X)}),Object.assign(process.env,we),we}async initServices(me,we,Ee,X,ae){await D.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsPath,we.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),X.init(),Ee.initialize()]),we.setEnablement(ae.quality!=="stable"||Ee.getValue(Le.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(me,we,Ee,X,ae,he){let be;try{(0,h.mark)("code/willStartMainServer"),be=await(0,p.serve)(we.mainIPCHandle),(0,h.mark)("code/didStartMainServer"),(0,I.once)(Ee.onWillShutdown)(()=>be.dispose())}catch(Ie){if(Ie.code!=="EADDRINUSE")throw this.handleStartupDataDirError(we,ae.nameLong,Ie),Ie;let Oe;try{Oe=await(0,p.connect)(we.mainIPCHandle,"main")}catch(ze){if(!he||b.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,n.localize)(0,null,ae.nameShort),(0,n.localize)(1,null),ae.nameLong),ze;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(Be){throw me.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(me,we,Ee,X,ae,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw me.error(ze),Oe.dispose(),new Error(ze)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.showStartupWarningDialog((0,n.localize)(2,null,ae.nameShort),(0,n.localize)(3,null),ae.nameLong)},1e4));const Ue=d.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Ne=d.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return X.invokeFunction(async()=>{const ze=new r.DiagnosticsService(V.NullTelemetryService,ae),Be=await Ne.getMainDiagnostics(),qe=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),G=await ze.getDiagnostics(Be,qe);throw console.log(G),new l.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Ue,me),me.trace("Sending env to running instance..."),await Ue.start(we.args,process.env),Oe.dispose(),We&&clearTimeout(We),new l.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw me.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new l.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),be}handleStartupDataDirError(me,we,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const X=(0,R.coalesce)([me.userDataPath,me.extensionsPath,p.XDG_RUNTIME_DIR]).map(ae=>(0,E.getPathLabel)(k.URI.file(ae),{os:b.OS,tildify:me}));this.showStartupWarningDialog((0,n.localize)(4,null),(0,n.localize)(5,null,(0,C.toErrorMessage)(Ee),X.join(`
`)),we)}}showStartupWarningDialog(me,we,Ee){S.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,n.localize)(6,null))],message:me,detail:we,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(me,we){if(b.isWindows){const Ee=await me.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((X,ae)=>{q(["windows-foreground-love"],X,ae)})).allowSetForegroundWindow(Ee)}catch(X){we.error(X)}}}quit(me,we){const Ee=me.get(ue.ILogService),X=me.get(re.ILifecycleMainService);let ae=0;we&&(we.isExpected?we.message&&Ee.trace(we.message):(ae=1,we.stack?Ee.error(we.stack):Ee.error(`Startup error: ${we.toString()}`))),X.kill(ae)}resolveArgs(){const me=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const we=(0,u.createWaitMarkerFile)(me.verbose);we&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",we),me.waitMarkerFilePath=we)}return me}validatePaths(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const we=this.doValidatePaths(me._,me.goto);me._=we}return me}doValidatePaths(me,we){const Ee=(0,w.cwd)(),X=me.map(be=>{let Ie=String(be),Oe;we&&(Oe=(0,g.parseLineAndColumnAware)(Ie),Ie=Oe.path),Ie&&(Ie=this.preparePath(Ee,Ie));const We=(0,g.sanitizeFilePath)(Ie,Ee),Ue=(0,f.basename)(We);return Ue&&!(0,g.isValidBasename)(Ue)?null:we&&Oe?(Oe.path=We,this.toPath(Oe)):We}),ae=b.isWindows||b.isMacintosh,he=(0,R.distinct)(X,be=>be&&ae?be.toLowerCase():be||"");return(0,R.coalesce)(he)}preparePath(me,we){return b.isWindows&&(we=(0,m.rtrim)(we,'"')),we=(0,m.trim)((0,m.trim)(we," "),"	"),b.isWindows&&(we=(0,f.resolve)(me,we),we=(0,m.rtrim)(we,".")),we}toPath(me){const we=[me.path];return typeof me.line=="number"&&we.push(String(me.line)),typeof me.column=="number"&&we.push(String(me.column)),we.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ecad25c181c084a505add3e76b34932f0bcc4b25/core/vs/code/electron-main/main.js.map
