/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/severity","vs/platform/files/common/files","vs/platform/registry/common/platform","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/base/common/stopwatch","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/hash","fs","vs/editor/common/languages","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/mime","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(J){for(var e=[],l=0,t=J.length;l<t;l++)e[l]=De[J[l]];return e};define(De[75],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function l(_){return _?_.replace(/\$\((.*?)\)/g,(I,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=l;class t{constructor(I,w,C){this.id=I,this.definition=w,this.description=C,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(_,I){const w=["codicon","codicon-"+_];return I&&w.push("codicon-modifier-"+I),w}e.getClassNamesArray=D;var P;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function w(k){if(k instanceof t)return["codicon","codicon-"+k.id];const S=I.exec(k.id);if(!S)return w(t.error);const[,T,E]=S,g=["codicon","codicon-"+T];return E&&g.push("codicon-modifier-"+E.substr(1)),g}_.asClassNameArray=w;function C(k){return w(k).join(" ")}_.asClassName=C;function R(k){return"."+w(k).join(".")}_.asCSSSelector=R})(P=e.CSSIcon||(e.CSSIcon={}))}),define(De[76],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function l(_,I){const w=Object.create(null);for(const C of _){const R=I(C);let k=w[R];k||(k=w[R]=[]),k.push(C)}return w}e.groupBy=l;function t(_,I){const w=[],C=[];for(const R of _)I.has(R)||w.push(R);for(const R of I)_.has(R)||C.push(R);return{removed:w,added:C}}e.diffSets=t;function D(_,I){const w=[],C=[];for(const[R,k]of _)I.has(R)||w.push(k);for(const[R,k]of I)_.has(R)||C.push(k);return{removed:w,added:C}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(I,w){let C=this.map.get(I);C||(C=new Set,this.map.set(I,C)),C.add(w)}delete(I,w){const C=this.map.get(I);!C||(C.delete(w),C.size===0&&this.map.delete(I))}forEach(I,w){const C=this.map.get(I);!C||C.forEach(w)}}e.SetMap=P}),define(De[58],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(_){return(I,w,C)=>{let R=null,k=null;if(typeof C.value=="function"?(R="value",k=C.value):typeof C.get=="function"&&(R="get",k=C.get),!k)throw new Error("not supported");C[R]=_(k,w)}}e.createDecorator=l;function t(_,I,w){let C=null,R=null;if(typeof w.value=="function"?(C="value",R=w.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(C="get",R=w.get),!R)throw new Error("not supported");const k=`$memoize$${I}`;w[C]=function(...S){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,S)}),this[k]}}e.memoize=t;function D(_,I,w){return l((C,R)=>{const k=`$debounce$${R}`,S=`$debounce$result$${R}`;return function(...T){this[S]||(this[S]=w?w():void 0),clearTimeout(this[k]),I&&(this[S]=I(this[S],...T),T=[this[S]]),this[k]=setTimeout(()=>{C.apply(this,T),this[S]=w?w():void 0},_)}})}e.debounce=D;function P(_,I,w){return l((C,R)=>{const k=`$throttle$timer$${R}`,S=`$throttle$result$${R}`,T=`$throttle$lastRun$${R}`,E=`$throttle$pending$${R}`;return function(...g){if(this[S]||(this[S]=w?w():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),I&&(this[S]=I(this[S],...g)),this[E])return;const b=this[T]+_;b<=Date.now()?(this[T]=Date.now(),C.apply(this,[this[S]]),this[S]=w?w():void 0):(this[E]=!0,this[k]=setTimeout(()=>{this[E]=!1,this[T]=Date.now(),C.apply(this,[this[S]]),this[S]=w?w():void 0},b-Date.now()))}})}e.throttle=P}),define(De[10],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class l{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?p.isErrorNoTelemetry(i)?new p(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(u=>{u(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=l,e.errorHandler=new l;function t(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=t;function D(h){w(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=D;function P(h){w(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=P;function _(h){if(h instanceof Error){const{name:i,message:u}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:i,message:u,stack:o,noTelemetry:p.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=_;const I="Canceled";function w(h){return h instanceof C?!0:h instanceof Error&&h.name===I&&h.message===I}e.isCancellationError=w;class C extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=C;function R(){const h=new Error(I);return h.name=h.message,h}e.canceled=R;function k(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=k;function S(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=S;function T(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=T;function E(h){const i=new Error(`${h} has been disposed`);return i.name="DISPOSED",i}e.disposed=E;function g(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=g;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class m extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=v;class p extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof p)return i;const u=new p;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class a extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype);debugger}}e.BugIndicatingError=a}),define(De[17],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,le=0){return oe[oe.length-(1+le)]}e.tail=t;function D(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=D;function P(oe,le,me=(Z,ae)=>Z===ae){if(oe===le)return!0;if(!oe||!le||oe.length!==le.length)return!1;for(let Z=0,ae=oe.length;Z<ae;Z++)if(!me(oe[Z],le[Z]))return!1;return!0}e.equals=P;function _(oe,le){const me=oe.length-1;le<me&&(oe[le]=oe[me]),oe.pop()}e.removeFastWithoutKeepingOrder=_;function I(oe,le,me){return w(oe.length,Z=>me(oe[Z],le))}e.binarySearch=I;function w(oe,le){let me=0,Z=oe-1;for(;me<=Z;){const ae=(me+Z)/2|0,ee=le(ae);if(ee<0)me=ae+1;else if(ee>0)Z=ae-1;else return ae}return-(me+1)}e.binarySearch2=w;function C(oe,le){let me=0,Z=oe.length;if(Z===0)return 0;for(;me<Z;){const ae=Math.floor((me+Z)/2);le(oe[ae])?Z=ae:me=ae+1}return me}e.findFirstInSorted=C;function R(oe,le,me){if(oe=oe|0,oe>=le.length)throw new TypeError("invalid index");const Z=le[Math.floor(le.length*Math.random())],ae=[],ee=[],ie=[];for(const F of le){const H=me(F,Z);H<0?ae.push(F):H>0?ee.push(F):ie.push(F)}return oe<ae.length?R(oe,ae,me):oe<ae.length+ie.length?ie[0]:R(oe-(ae.length+ie.length),ee,me)}e.quickSelect=R;function k(oe,le){const me=[];let Z;for(const ae of oe.slice(0).sort(le))!Z||le(Z[0],ae)!==0?(Z=[ae],me.push(Z)):Z.push(ae);return me}e.groupBy=k;function S(oe,le,me){const Z=[];function ae(F,H,K){if(H===0&&K.length===0)return;const X=Z[Z.length-1];X&&X.start+X.deleteCount===F?(X.deleteCount+=H,X.toInsert.push(...K)):Z.push({start:F,deleteCount:H,toInsert:K})}let ee=0,ie=0;for(;;){if(ee===oe.length){ae(ee,0,le.slice(ie));break}if(ie===le.length){ae(ee,oe.length-ee,[]);break}const F=oe[ee],H=le[ie],K=me(F,H);K===0?(ee+=1,ie+=1):K<0?(ae(ee,1,[]),ee+=1):K>0&&(ae(ee,0,[H]),ie+=1)}return Z}e.sortedDiff=S;function T(oe,le,me){const Z=S(oe,le,me),ae=[],ee=[];for(const ie of Z)ae.push(...oe.slice(ie.start,ie.start+ie.deleteCount)),ee.push(...ie.toInsert);return{removed:ae,added:ee}}e.delta=T;function E(oe,le,me){if(me===0)return[];const Z=oe.slice(0,me).sort(le);return b(oe,le,Z,me,oe.length),Z}e.top=E;function g(oe,le,me,Z,ae){return me===0?Promise.resolve([]):new Promise((ee,ie)=>{(async()=>{const F=oe.length,H=oe.slice(0,me).sort(le);for(let K=me,X=Math.min(me+Z,F);K<F;K=X,X=Math.min(X+Z,F)){if(K>me&&await new Promise(de=>setTimeout(de)),ae&&ae.isCancellationRequested)throw new l.CancellationError;b(oe,le,H,K,X)}return H})().then(ee,ie)})}e.topAsync=g;function b(oe,le,me,Z,ae){for(const ee=me.length;Z<ae;Z++){const ie=oe[Z];if(le(ie,me[ee-1])<0){me.pop();const F=C(me,H=>le(ie,H)<0);me.splice(F,0,ie)}}}function m(oe){return oe.filter(le=>!!le)}e.coalesce=m;function v(oe){let le=0;for(let me=0;me<oe.length;me++)oe[me]&&(oe[le]=oe[me],le+=1);oe.length=le}e.coalesceInPlace=v;function p(oe,le,me){oe.splice(me,0,oe.splice(le,1)[0])}e.move=p;function a(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=a;function h(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=h;function i(oe,le=me=>me){const me=new Set;return oe.filter(Z=>{const ae=le(Z);return me.has(ae)?!1:(me.add(ae),!0)})}e.distinct=i;function u(oe){const le=new Set;return me=>{const Z=oe(me);return le.has(Z)?!1:(le.add(Z),!0)}}e.uniqueFilter=u;function o(oe,le){const me=r(oe,le);if(me!==-1)return oe[me]}e.findLast=o;function r(oe,le){for(let me=oe.length-1;me>=0;me--){const Z=oe[me];if(le(Z))return me}return-1}e.lastIndex=r;function s(oe,le){return oe.length>0?oe[0]:le}e.firstOrDefault=s;function n(oe,le){return oe.length>0?oe[oe.length-1]:le}e.lastOrDefault=n;function c(oe,le,me=(Z,ae)=>Z===ae){let Z=0;for(let ae=0,ee=Math.min(oe.length,le.length);ae<ee&&me(oe[ae],le[ae]);ae++)Z++;return Z}e.commonPrefixLength=c;function d(oe){return[].concat(...oe)}e.flatten=d;function f(oe,le){let me=typeof le=="number"?oe:0;typeof le=="number"?me=oe:(me=0,le=oe);const Z=[];if(me<=le)for(let ae=me;ae<le;ae++)Z.push(ae);else for(let ae=me;ae>le;ae--)Z.push(ae);return Z}e.range=f;function y(oe,le,me){return oe.reduce((Z,ae)=>(Z[le(ae)]=me?me(ae):ae,Z),Object.create(null))}e.index=y;function L(oe,le){return oe.push(le),()=>M(oe,le)}e.insert=L;function M(oe,le){const me=oe.indexOf(le);if(me>-1)return oe.splice(me,1),le}e.remove=M;function B(oe,le,me){const Z=oe.slice(0,le),ae=oe.slice(le);return Z.concat(me,ae)}e.arrayInsert=B;function A(oe,le){let me;if(typeof le=="number"){let Z=le;me=()=>{const ae=Math.sin(Z++)*179426549;return ae-Math.floor(ae)}}else me=Math.random;for(let Z=oe.length-1;Z>0;Z-=1){const ae=Math.floor(me()*(Z+1)),ee=oe[Z];oe[Z]=oe[ae],oe[ae]=ee}}e.shuffle=A;function W(oe,le){const me=oe.indexOf(le);me>-1&&(oe.splice(me,1),oe.unshift(le))}e.pushToStart=W;function U(oe,le){const me=oe.indexOf(le);me>-1&&(oe.splice(me,1),oe.push(le))}e.pushToEnd=U;function N(oe,le){for(const me of le)oe.push(me)}e.pushMany=N;function G(oe,le){return Array.isArray(oe)?oe.map(le):le(oe)}e.mapArrayOrNot=G;function z(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=z;function O(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=O;function x(oe,le){for(const me of oe){const Z=le(me);if(Z!==void 0)return Z}}e.mapFind=x;function V(oe,le,me){const Z=Y(oe,le),ae=oe.length,ee=me.length;oe.length=ae+ee;for(let ie=ae-1;ie>=Z;ie--)oe[ie+ee]=oe[ie];for(let ie=0;ie<ee;ie++)oe[ie+Z]=me[ie]}e.insertInto=V;function q(oe,le,me,Z){const ae=Y(oe,le),ee=oe.splice(ae,me);return V(oe,ae,Z),ee}e.splice=q;function Y(oe,le){return le<0?Math.max(le+oe.length,0):Math.min(le,oe.length)}var Q;(function(oe){function le(ae){return ae<0}oe.isLessThan=le;function me(ae){return ae>0}oe.isGreaterThan=me;function Z(ae){return ae===0}oe.isNeitherLessOrGreaterThan=Z,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function he(oe,le){return(me,Z)=>le(oe(me),oe(Z))}e.compareBy=he;function ve(...oe){return(le,me)=>{for(const Z of oe){const ae=Z(le,me);if(!Q.isNeitherLessOrGreaterThan(ae))return ae}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=ve;const ne=(oe,le)=>oe-le;e.numberComparator=ne;function pe(oe,le){if(oe.length===0)return;let me=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,me)>0&&(me=ae)}return me}e.findMaxBy=pe;function be(oe,le){if(oe.length===0)return;let me=oe[0];for(let Z=1;Z<oe.length;Z++){const ae=oe[Z];le(ae,me)>=0&&(me=ae)}return me}e.findLastMaxBy=be;function Te(oe,le){return pe(oe,(me,Z)=>-le(me,Z))}e.findMinBy=Te;class Le{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let me=this.firstIdx;for(;me<this.items.length&&le(this.items[me]);)me++;const Z=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,Z}takeFromEndWhile(le){let me=this.lastIdx;for(;me>=0&&le(this.items[me]);)me--;const Z=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,Z}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const le=this.items[this.firstIdx];return this.firstIdx++,le}removeLast(){const le=this.items[this.lastIdx];return this.lastIdx--,le}takeCount(le){const me=this.items.slice(this.firstIdx,this.firstIdx+le);return this.firstIdx+=le,me}}e.ArrayQueue=Le;class We{constructor(le){this.iterate=le}forEach(le){this.iterate(me=>(le(me),!0))}toArray(){const le=[];return this.iterate(me=>(le.push(me),!0)),le}filter(le){return new We(me=>this.iterate(Z=>le(Z)?me(Z):!0))}map(le){return new We(me=>this.iterate(Z=>me(le(Z))))}some(le){let me=!1;return this.iterate(Z=>(me=le(Z),!me)),me}findFirst(le){let me;return this.iterate(Z=>le(Z)?(me=Z,!1):!0),me}findLast(le){let me;return this.iterate(Z=>(le(Z)&&(me=Z),!0)),me}findLastMaxBy(le){let me,Z=!0;return this.iterate(ae=>((Z||Q.isGreaterThan(le(ae,me)))&&(Z=!1,me=ae),!0)),me}}e.CallbackIterable=We,We.empty=new We(oe=>{})}),define(De[48],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,C){if(!w)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function D(w,C="Unreachable"){throw new Error(C)}e.assertNever=D;function P(w){if(!w)throw new l.BugIndicatingError("Assertion Failed")}e.assert=P;function _(w){if(!w()){debugger;w(),(0,l.onUnexpectedError)(new l.BugIndicatingError("Assertion Failed"))}}e.assertFn=_;function I(w,C){let R=0;for(;R<w.length-1;){const k=w[R],S=w[R+1];if(!C(k,S))return!1;R++}return!0}e.checkAdjacentItems=I}),define(De[59],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function l(t){const D=this;let P=!1,_;return function(){return P||(P=!0,_=t.apply(D,arguments)),_}}e.once=l}),define(De[93],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(De[60],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(t){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}t.is=D;const P=Object.freeze([]);function _(){return P}t.empty=_;function*I(u){yield u}t.single=I;function w(u){return u||P}t.from=w;function C(u){return!u||u[Symbol.iterator]().next().done===!0}t.isEmpty=C;function R(u){return u[Symbol.iterator]().next().value}t.first=R;function k(u,o){for(const r of u)if(o(r))return!0;return!1}t.some=k;function S(u,o){for(const r of u)if(o(r))return r}t.find=S;function*T(u,o){for(const r of u)o(r)&&(yield r)}t.filter=T;function*E(u,o){let r=0;for(const s of u)yield o(s,r++)}t.map=E;function*g(...u){for(const o of u)for(const r of o)yield r}t.concat=g;function*b(u){for(const o of u)for(const r of o)yield r}t.concatNested=b;function m(u,o,r){let s=r;for(const n of u)s=o(s,n);return s}t.reduce=m;function v(u,o){let r=0;for(const s of u)o(s,r++)}t.forEach=v;function*p(u,o,r=u.length){for(o<0&&(o+=u.length),r<0?r+=u.length:r>u.length&&(r=u.length);o<r;o++)yield u[o]}t.slice=p;function a(u,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,u];const s=u[Symbol.iterator]();for(let n=0;n<o;n++){const c=s.next();if(c.done)return[r,t.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return s}}]}t.consume=a;function h(u){return a(u)[0]}t.collect=h;function i(u,o,r=(s,n)=>s===n){const s=u[Symbol.iterator](),n=o[Symbol.iterator]();for(;;){const c=s.next(),d=n.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!r(c.value,d.value))return!1}}t.equals=i})(l=e.Iterable||(e.Iterable={}))}),define(De[143],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(i){i.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function _(i,u=!1){let o=0;const r=i.length;let s="",n=0,c=16,d=0;function f(U){let N=0,G=0;for(;N<U;){const z=i.charCodeAt(o);if(z>=48&&z<=57)G=G*16+z-48;else if(z>=65&&z<=70)G=G*16+z-65+10;else if(z>=97&&z<=102)G=G*16+z-97+10;else break;o++,N++}return N<U&&(G=-1),G}function y(U){o=U,s="",n=0,c=16,d=0}function L(){const U=o;if(i.charCodeAt(o)===48)o++;else for(o++;o<i.length&&C(i.charCodeAt(o));)o++;if(o<i.length&&i.charCodeAt(o)===46)if(o++,o<i.length&&C(i.charCodeAt(o)))for(o++;o<i.length&&C(i.charCodeAt(o));)o++;else return d=3,i.substring(U,o);let N=o;if(o<i.length&&(i.charCodeAt(o)===69||i.charCodeAt(o)===101))if(o++,(o<i.length&&i.charCodeAt(o)===43||i.charCodeAt(o)===45)&&o++,o<i.length&&C(i.charCodeAt(o))){for(o++;o<i.length&&C(i.charCodeAt(o));)o++;N=o}else d=3;return i.substring(U,N)}function M(){let U="",N=o;for(;;){if(o>=r){U+=i.substring(N,o),d=2;break}const G=i.charCodeAt(o);if(G===34){U+=i.substring(N,o),o++;break}if(G===92){if(U+=i.substring(N,o),o++,o>=r){d=2;break}switch(i.charCodeAt(o++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const O=f(4);O>=0?U+=String.fromCharCode(O):d=4;break}default:d=5}N=o;continue}if(G>=0&&G<=31)if(w(G)){U+=i.substring(N,o),d=2;break}else d=6;o++}return U}function B(){if(s="",d=0,n=o,o>=r)return n=r,c=17;let U=i.charCodeAt(o);if(I(U)){do o++,s+=String.fromCharCode(U),U=i.charCodeAt(o);while(I(U));return c=15}if(w(U))return o++,s+=String.fromCharCode(U),U===13&&i.charCodeAt(o)===10&&(o++,s+=`
`),c=14;switch(U){case 123:return o++,c=1;case 125:return o++,c=2;case 91:return o++,c=3;case 93:return o++,c=4;case 58:return o++,c=6;case 44:return o++,c=5;case 34:return o++,s=M(),c=10;case 47:{const N=o-1;if(i.charCodeAt(o+1)===47){for(o+=2;o<r&&!w(i.charCodeAt(o));)o++;return s=i.substring(N,o),c=12}if(i.charCodeAt(o+1)===42){o+=2;const G=r-1;let z=!1;for(;o<G;){if(i.charCodeAt(o)===42&&i.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,d=1),s=i.substring(N,o),c=13}return s+=String.fromCharCode(U),o++,c=16}case 45:if(s+=String.fromCharCode(U),o++,o===r||!C(i.charCodeAt(o)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),c=11;default:for(;o<r&&A(U);)o++,U=i.charCodeAt(o);if(n!==o){switch(s=i.substring(n,o),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(U),o++,c=16}}function A(U){if(I(U)||w(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=B();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>o,scan:u?W:B,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>n,getTokenLength:()=>o-n,getTokenError:()=>d}}e.createScanner=_;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function C(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function k(i,u){const o=[],r=new Object;let s;const n={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(f,y,L,M){n.value=f,n.offset=y,n.length=L,n.type=M,n.colonOffset=void 0,s=n}try{p(i,{onObjectBegin:(f,y)=>{if(u<=f)throw r;s=void 0,c=u>f,o.push("")},onObjectProperty:(f,y,L)=>{if(u<y||(d(f,y,L,"property"),o[o.length-1]=f,u<=y+L))throw r},onObjectEnd:(f,y)=>{if(u<=f)throw r;s=void 0,o.pop()},onArrayBegin:(f,y)=>{if(u<=f)throw r;s=void 0,o.push(0)},onArrayEnd:(f,y)=>{if(u<=f)throw r;s=void 0,o.pop()},onLiteralValue:(f,y,L)=>{if(u<y||(d(f,y,L,h(f)),u<=y+L))throw r},onSeparator:(f,y,L)=>{if(u<=y)throw r;if(f===":"&&s&&s.type==="property")s.colonOffset=y,c=!1,s=void 0;else if(f===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:(c=!0,o[o.length-1]=""),s=void 0}}})}catch(f){if(f!==r)throw f}return{path:o,previousNode:s,isAtPropertyKey:c,matches:f=>{let y=0;for(let L=0;y<f.length&&L<o.length;L++)if(f[y]===o[L]||f[y]==="*")y++;else if(f[y]!=="**")return!1;return y===f.length}}}e.getLocation=k;function S(i,u=[],o=P.DEFAULT){let r=null,s=[];const n=[];function c(f){Array.isArray(s)?s.push(f):r!==null&&(s[r]=f)}return p(i,{onObjectBegin:()=>{const f={};c(f),n.push(s),s=f,r=null},onObjectProperty:f=>{r=f},onObjectEnd:()=>{s=n.pop()},onArrayBegin:()=>{const f=[];c(f),n.push(s),s=f,r=null},onArrayEnd:()=>{s=n.pop()},onLiteralValue:c,onError:(f,y,L)=>{u.push({error:f,offset:y,length:L})}},o),s[0]}e.parse=S;function T(i,u=[],o=P.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(f){r.type==="property"&&(r.length=f-r.offset,r=r.parent)}function n(f){return r.children.push(f),f}p(i,{onObjectBegin:f=>{r=n({type:"object",offset:f,length:-1,parent:r,children:[]})},onObjectProperty:(f,y,L)=>{r=n({type:"property",offset:y,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:f,offset:y,length:L,parent:r})},onObjectEnd:(f,y)=>{r.length=f+y-r.offset,r=r.parent,s(f+y)},onArrayBegin:(f,y)=>{r=n({type:"array",offset:f,length:-1,parent:r,children:[]})},onArrayEnd:(f,y)=>{r.length=f+y-r.offset,r=r.parent,s(f+y)},onLiteralValue:(f,y,L)=>{n({type:h(f),offset:y,length:L,parent:r,value:f}),s(y+L)},onSeparator:(f,y,L)=>{r.type==="property"&&(f===":"?r.colonOffset=y:f===","&&s(y))},onError:(f,y,L)=>{u.push({error:f,offset:y,length:L})}},o);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=T;function E(i,u){if(!i)return;let o=i;for(const r of u)if(typeof r=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let s=!1;for(const n of o.children)if(Array.isArray(n.children)&&n.children[0].value===r){o=n.children[1],s=!0;break}if(!s)return}else{const s=r;if(o.type!=="array"||s<0||!Array.isArray(o.children)||s>=o.children.length)return;o=o.children[s]}return o}e.findNodeAtLocation=E;function g(i){if(!i.parent||!i.parent.children)return[];const u=g(i.parent);if(i.parent.type==="property"){const o=i.parent.children[0].value;u.push(o)}else if(i.parent.type==="array"){const o=i.parent.children.indexOf(i);o!==-1&&u.push(o)}return u}e.getNodePath=g;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const u=Object.create(null);for(const o of i.children){const r=o.children[1];r&&(u[o.children[0].value]=b(r))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function m(i,u,o=!1){return u>=i.offset&&u<i.offset+i.length||o&&u===i.offset+i.length}e.contains=m;function v(i,u,o=!1){if(m(i,u,o)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=u;s++){const n=v(r[s],u,o);if(n)return n}return i}}e.findNodeAtOffset=v;function p(i,u,o=P.DEFAULT){const r=_(i,!1);function s(he){return he?()=>he(r.getTokenOffset(),r.getTokenLength()):()=>!0}function n(he){return he?ve=>he(ve,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=s(u.onObjectBegin),d=n(u.onObjectProperty),f=s(u.onObjectEnd),y=s(u.onArrayBegin),L=s(u.onArrayEnd),M=n(u.onLiteralValue),B=n(u.onSeparator),A=s(u.onComment),W=n(u.onError),U=o&&o.disallowComments,N=o&&o.allowTrailingComma;function G(){for(;;){const he=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:U||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(he){case 12:case 13:U?z(10):A();break;case 16:z(1);break;case 15:case 14:break;default:return he}}}function z(he,ve=[],ne=[]){if(W(he),ve.length+ne.length>0){let pe=r.getToken();for(;pe!==17;){if(ve.indexOf(pe)!==-1){G();break}else if(ne.indexOf(pe)!==-1)break;pe=G()}}}function O(he){const ve=r.getTokenValue();return he?M(ve):d(ve),G(),!0}function x(){switch(r.getToken()){case 11:{let he=0;try{he=JSON.parse(r.getTokenValue()),typeof he!="number"&&(z(2),he=0)}catch{z(2)}M(he);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return G(),!0}function V(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(O(!1),r.getToken()===6?(B(":"),G(),Q()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function q(){c(),G();let he=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(he||z(4,[],[]),B(","),G(),r.getToken()===2&&N)break}else he&&z(6,[],[]);V()||z(4,[],[2,5]),he=!0}return f(),r.getToken()!==2?z(7,[2],[]):G(),!0}function Y(){y(),G();let he=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(he||z(4,[],[]),B(","),G(),r.getToken()===4&&N)break}else he&&z(6,[],[]);Q()||z(4,[],[4,5]),he=!0}return L(),r.getToken()!==4?z(8,[4],[]):G(),!0}function Q(){switch(r.getToken()){case 3:return Y();case 1:return q();case 10:return O(!0);default:return x()}}return G(),r.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):Q()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=p;function a(i,u){const o=_(i),r=[];let s,n=0,c;do switch(c=o.getPosition(),s=o.scan(),s){case 12:case 13:case 17:n!==c&&r.push(i.substring(n,c)),u!==void 0&&r.push(o.getTokenValue().replace(/[^\r\n]/g,u)),n=o.getPosition();break}while(s!==17);return r.join("")}e.stripComments=a;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(De[77],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new l(()=>D(this.getValue()))}}e.Lazy=l}),define(De[6],Ie([1,0,59,60]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let P=null;function _(s){P=s}if(e.setDisposableTracker=_,D){const s="__is_disposable_tracked__";_(new class{trackDisposable(n){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[s]||console.log(c)},3e3)}setParent(n,c){if(n&&n!==v.None)try{n[s]=!0}catch{}}markAsDisposed(n){if(n&&n!==v.None)try{n[s]=!0}catch{}}markAsSingleton(n){}})}function I(s){return P?.trackDisposable(s),s}function w(s){P?.markAsDisposed(s)}function C(s,n){P?.setParent(s,n)}function R(s,n){if(!!P)for(const c of s)P.setParent(c,n)}function k(s){return P?.markAsSingleton(s),s}e.markAsSingleton=k;function S(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=S;function T(s){if(t.Iterable.is(s)){const n=[];for(const c of s)if(c)try{c.dispose()}catch(d){n.push(d)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=T;function E(s){for(const n of s)S(n)&&n.dispose();return[]}e.disposeIfDisposable=E;function g(...s){const n=b(()=>T(s));return R(s,n),n}e.combinedDisposable=g;function b(s){const n=I({dispose:(0,l.once)(()=>{w(n),s()})});return n}e.toDisposable=b;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{T(this._toDispose.values())}finally{this._toDispose.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(n),n}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,I(this),C(this._store,this)}dispose(){w(this),this._store.dispose()}_register(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(n)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(n){this._isDisposed||n===this._value||(this._value?.dispose(),n&&C(n,this),this._value=n)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const n=this._value;return this._value=void 0,n&&C(n,null),n}}e.MutableDisposable=p;class a{constructor(n){this._disposable=n,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(n){let c=n;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,w(this))},this}}e.SafeDisposable=h;class i{constructor(){this.references=new Map}acquire(n,...c){let d=this.references.get(n);d||(d={counter:0,object:this.createReferencedObject(n,...c)},this.references.set(n,d));const{object:f}=d,y=(0,l.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(n,d.object),this.references.delete(n))});return d.counter++,{object:f,dispose:y}}}e.ReferenceCollection=i;class u{constructor(n){this.referenceCollection=n}async acquire(n,...c){const d=this.referenceCollection.acquire(n,...c);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(f){throw d.dispose(),f}}}e.AsyncReferenceCollection=u;class o{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=o;function r(s){const n=new m;try{s(n)}finally{n.dispose()}}e.disposeOnReturn=r}),define(De[78],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class l{constructor(P){this.element=P,this.next=l.Undefined,this.prev=l.Undefined}}l.Undefined=new l(void 0);class t{constructor(){this._first=l.Undefined,this._last=l.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===l.Undefined}clear(){let P=this._first;for(;P!==l.Undefined;){const _=P.next;P.prev=l.Undefined,P.next=l.Undefined,P=_}this._first=l.Undefined,this._last=l.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,_){const I=new l(P);if(this._first===l.Undefined)this._first=I,this._last=I;else if(_){const C=this._last;this._last=I,I.prev=C,C.next=I}else{const C=this._first;this._first=I,I.next=C,C.prev=I}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(I))}}shift(){if(this._first!==l.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==l.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==l.Undefined&&P.next!==l.Undefined){const _=P.prev;_.next=P.next,P.next.prev=_}else P.prev===l.Undefined&&P.next===l.Undefined?(this._first=l.Undefined,this._last=l.Undefined):P.next===l.Undefined?(this._last=this._last.prev,this._last.next=l.Undefined):P.prev===l.Undefined&&(this._first=this._first.next,this._first.prev=l.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==l.Undefined;)yield P.element,P=P.next}}e.LinkedList=t}),function(J,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[144],Ie([0]),e):(J=typeof globalThis<"u"?globalThis:J||self,e(J.marked={}))}(this,function(J){"use strict";function e(oe,le){for(var me=0;me<le.length;me++){var Z=le[me];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(oe,Z.key,Z)}}function l(oe,le,me){return le&&e(oe.prototype,le),me&&e(oe,me),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,le){if(!!oe){if(typeof oe=="string")return D(oe,le);var me=Object.prototype.toString.call(oe).slice(8,-1);if(me==="Object"&&oe.constructor&&(me=oe.constructor.name),me==="Map"||me==="Set")return Array.from(oe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return D(oe,le)}}function D(oe,le){(le==null||le>oe.length)&&(le=oe.length);for(var me=0,Z=new Array(le);me<le;me++)Z[me]=oe[me];return Z}function P(oe,le){var me=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(me)return(me=me.call(oe)).next.bind(me);if(Array.isArray(oe)||(me=t(oe))||le&&oe&&typeof oe.length=="number"){me&&(oe=me);var Z=0;return function(){return Z>=oe.length?{done:!0}:{done:!1,value:oe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}J.defaults=_();function I(oe){J.defaults=oe}var w=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,S={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(le){return S[le]};function E(oe,le){if(le){if(w.test(oe))return oe.replace(C,T)}else if(R.test(oe))return oe.replace(k,T);return oe}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(oe){return oe.replace(g,function(le,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var m=/(^|[^\[])\^/g;function v(oe,le){oe=typeof oe=="string"?oe:oe.source,le=le||"";var me={replace:function(ae,ee){return ee=ee.source||ee,ee=ee.replace(m,"$1"),oe=oe.replace(ae,ee),me},getRegex:function(){return new RegExp(oe,le)}};return me}var p=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(oe,le,me){if(oe){var Z;try{Z=decodeURIComponent(b(me)).replace(p,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}le&&!a.test(me)&&(me=s(le,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var i={},u=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(oe,le){i[" "+oe]||(u.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=f(oe,"/",!0)),oe=i[" "+oe];var me=oe.indexOf(":")===-1;return le.substring(0,2)==="//"?me?le:oe.replace(o,"$1")+le:le.charAt(0)==="/"?me?le:oe.replace(r,"$1")+le:oe+le}var n={exec:function(){}};function c(oe){for(var le=1,me,Z;le<arguments.length;le++){me=arguments[le];for(Z in me)Object.prototype.hasOwnProperty.call(me,Z)&&(oe[Z]=me[Z])}return oe}function d(oe,le){var me=oe.replace(/\|/g,function(ee,ie,F){for(var H=!1,K=ie;--K>=0&&F[K]==="\\";)H=!H;return H?"|":" |"}),Z=me.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>le)Z.splice(le);else for(;Z.length<le;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function f(oe,le,me){var Z=oe.length;if(Z===0)return"";for(var ae=0;ae<Z;){var ee=oe.charAt(Z-ae-1);if(ee===le&&!me)ae++;else if(ee!==le&&me)ae++;else break}return oe.slice(0,Z-ae)}function y(oe,le){if(oe.indexOf(le[1])===-1)return-1;for(var me=oe.length,Z=0,ae=0;ae<me;ae++)if(oe[ae]==="\\")ae++;else if(oe[ae]===le[0])Z++;else if(oe[ae]===le[1]&&(Z--,Z<0))return ae;return-1}function L(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,le){if(le<1)return"";for(var me="";le>1;)le&1&&(me+=oe),le>>=1,oe+=oe;return me+oe}function B(oe,le,me,Z){var ae=le.href,ee=le.title?E(le.title):null,ie=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){Z.state.inLink=!0;var F={type:"link",raw:me,href:ae,title:ee,text:ie,tokens:Z.inlineTokens(ie)};return Z.state.inLink=!1,F}return{type:"image",raw:me,href:ae,title:ee,text:E(ie)}}function A(oe,le){var me=oe.match(/^(\s+)(?:```)/);if(me===null)return le;var Z=me[1];return le.split(`
`).map(function(ae){var ee=ae.match(/^\s+/);if(ee===null)return ae;var ie=ee[0];return ie.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var W=function(){function oe(me){this.options=me||J.defaults}var le=oe.prototype;return le.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var ee=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:f(ee,`
`)}}},le.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var ee=ae[0],ie=A(ee,ae[3]||"");return{type:"code",raw:ee,lang:ae[2]?ae[2].trim():ae[2],text:ie}}},le.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var ee=ae[2].trim();if(/#$/.test(ee)){var ie=f(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:ee,tokens:this.lexer.inline(ee)}}},le.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var ee=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},le.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var ee,ie,F,H,K,X,de,we,ce,Ce,ye,$e,Ve=ae[1].trim(),Ze=Ve.length>1,Ye={type:"list",raw:"",ordered:Ze,start:Ze?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=Ze?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=Ze?Ve:"[*+-]");for(var Oe=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&($e=!1,!(!(ae=Oe.exec(Z))||this.rules.block.hr.test(Z)));){if(ee=ae[0],Z=Z.substring(ee.length),we=ae[2].split(`
`,1)[0],ce=Z.split(`
`,1)[0],this.options.pedantic?(H=2,ye=we.trimLeft()):(H=ae[2].search(/[^ ]/),H=H>4?1:H,ye=we.slice(H),H+=ae[1].length),X=!1,!we&&/^ *$/.test(ce)&&(ee+=ce+`
`,Z=Z.substring(ce.length+1),$e=!0),!$e)for(var ot=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),re=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),se=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),Ee=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");Z&&(Ce=Z.split(`
`,1)[0],we=Ce,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(se.test(we)||Ee.test(we)||ot.test(we)||re.test(Z)));){if(we.search(/[^ ]/)>=H||!we.trim())ye+=`
`+we.slice(H);else if(!X)ye+=`
`+we;else break;!X&&!we.trim()&&(X=!0),ee+=Ce+`
`,Z=Z.substring(Ce.length+1)}Ye.loose||(de?Ye.loose=!0:/\n *\n *$/.test(ee)&&(de=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ye),ie&&(F=ie[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ee,task:!!ie,checked:F,loose:!1,text:ye}),Ye.raw+=ee}Ye.items[Ye.items.length-1].raw=ee.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var ue=Ye.items.length;for(K=0;K<ue;K++){this.lexer.state.top=!1,Ye.items[K].tokens=this.lexer.blockTokens(Ye.items[K].text,[]);var ke=Ye.items[K].tokens.filter(function(Be){return Be.type==="space"}),Ne=ke.every(function(Be){for(var ze=Be.raw.split(""),Qe=0,nt=P(ze),ct;!(ct=nt()).done;){var st=ct.value;if(st===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ye.loose&&ke.length&&Ne&&(Ye.loose=!0,Ye.items[K].loose=!0)}return Ye}},le.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var ee={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},le.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var ee=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var ee={type:"table",header:d(ae[1]).map(function(de){return{text:de}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=ae[0];var ie=ee.align.length,F,H,K,X;for(F=0;F<ie;F++)/^ *-+: *$/.test(ee.align[F])?ee.align[F]="right":/^ *:-+: *$/.test(ee.align[F])?ee.align[F]="center":/^ *:-+ *$/.test(ee.align[F])?ee.align[F]="left":ee.align[F]=null;for(ie=ee.rows.length,F=0;F<ie;F++)ee.rows[F]=d(ee.rows[F],ee.header.length).map(function(de){return{text:de}});for(ie=ee.header.length,H=0;H<ie;H++)ee.header[H].tokens=this.lexer.inline(ee.header[H].text);for(ie=ee.rows.length,H=0;H<ie;H++)for(X=ee.rows[H],K=0;K<X.length;K++)X[K].tokens=this.lexer.inline(X[K].text);return ee}}},le.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var ee=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:ee,tokens:this.lexer.inline(ee)}}},le.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:E(ae[1])}},le.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):E(ae[0]):ae[0]}},le.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var ee=ae[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=f(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var F=y(ae[2],"()");if(F>-1){var H=ae[0].indexOf("!")===0?5:4,K=H+ae[1].length+F;ae[2]=ae[2].substring(0,F),ae[0]=ae[0].substring(0,K).trim(),ae[3]=""}}var X=ae[2],de="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(X);we&&(X=we[1],de=we[3])}else de=ae[3]?ae[3].slice(1,-1):"";return X=X.trim(),/^</.test(X)&&(this.options.pedantic&&!/>$/.test(ee)?X=X.slice(1):X=X.slice(1,-1)),B(ae,{href:X&&X.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(Z,ae){var ee;if((ee=this.rules.inline.reflink.exec(Z))||(ee=this.rules.inline.nolink.exec(Z))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=ae[ie.toLowerCase()],!ie||!ie.href){var F=ee[0].charAt(0);return{type:"text",raw:F,text:F}}return B(ee,ie,ee[0],this.lexer)}},le.emStrong=function(Z,ae,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(Z);if(!!ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=ie[1]||ie[2]||"";if(!F||F&&(ee===""||this.rules.inline.punctuation.exec(ee))){var H=ie[0].length-1,K,X,de=H,we=0,ce=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,ae=ae.slice(-1*Z.length+H);(ie=ce.exec(ae))!=null;)if(K=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!K){if(X=K.length,ie[3]||ie[4]){de+=X;continue}else if((ie[5]||ie[6])&&H%3&&!((H+X)%3)){we+=X;continue}if(de-=X,!(de>0)){if(X=Math.min(X,X+de+we),Math.min(H,X)%2){var Ce=Z.slice(1,H+ie.index+X);return{type:"em",raw:Z.slice(0,H+ie.index+X+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ye=Z.slice(2,H+ie.index+X-1);return{type:"strong",raw:Z.slice(0,H+ie.index+X+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},le.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var ee=ae[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),F=/^ /.test(ee)&&/ $/.test(ee);return ie&&F&&(ee=ee.substring(1,ee.length-1)),ee=E(ee,!0),{type:"codespan",raw:ae[0],text:ee}}},le.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},le.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(Z,ae){var ee=this.rules.inline.autolink.exec(Z);if(ee){var ie,F;return ee[2]==="@"?(ie=E(this.options.mangle?ae(ee[1]):ee[1]),F="mailto:"+ie):(ie=E(ee[1]),F=ie),{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},le.url=function(Z,ae){var ee;if(ee=this.rules.inline.url.exec(Z)){var ie,F;if(ee[2]==="@")ie=E(this.options.mangle?ae(ee[0]):ee[0]),F="mailto:"+ie;else{var H;do H=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(H!==ee[0]);ie=E(ee[0]),ee[1]==="www."?F="http://"+ie:F=ie}return{type:"link",raw:ee[0],text:ie,href:F,tokens:[{type:"text",raw:ie,text:ie}]}}},le.inlineText=function(Z,ae){var ee=this.rules.inline.text.exec(Z);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):E(ee[0]):ee[0]:ie=E(this.options.smartypants?ae(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},oe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:n,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=v(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=v(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=v(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=v(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=v(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=v(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=c({},U),U.gfm=c({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=v(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=v(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=c({},U.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:n,paragraph:v(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:n,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:n,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=v(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=v(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=v(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=v(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=v(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=v(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=v(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=v(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=v(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=v(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=v(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=c({},N),N.pedantic=c({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=c({},N.normal,{escape:v(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=v(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=c({},N.gfm,{br:v(N.br).replace("{2,}","*").getRegex(),text:v(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(oe){var le="",me,Z,ae=oe.length;for(me=0;me<ae;me++)Z=oe.charCodeAt(me),Math.random()>.5&&(Z="x"+Z.toString(16)),le+="&#"+Z+";";return le}var O=function(){function oe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||J.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:U.normal,inline:N.normal};this.options.pedantic?(Z.block=U.pedantic,Z.inline=N.pedantic):this.options.gfm&&(Z.block=U.gfm,this.options.breaks?Z.inline=N.breaks:Z.inline=N.gfm),this.tokenizer.rules=Z}oe.lex=function(Z,ae){var ee=new oe(ae);return ee.lex(Z)},oe.lexInline=function(Z,ae){var ee=new oe(ae);return ee.inlineTokens(Z)};var le=oe.prototype;return le.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(de,we,ce){return we+"    ".repeat(ce.length)});for(var ie,F,H,K;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(ie=de.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.space(Z)){Z=Z.substring(ie.raw.length),ie.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(ie);continue}if(ie=this.tokenizer.code(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(ie=this.tokenizer.fences(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.heading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.hr(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.blockquote(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.list(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.html(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.def(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.lheading(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,we=Z.slice(1),ce=void 0;ee.options.extensions.startBlock.forEach(function(Ce){ce=Ce.call({lexer:this},we),typeof ce=="number"&&ce>=0&&(de=Math.min(de,ce))}),de<1/0&&de>=0&&(H=Z.substring(0,de+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(H))){F=ae[ae.length-1],K&&F.type==="paragraph"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie),K=H.length!==Z.length,Z=Z.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=`
`+ie.raw,F.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):ae.push(ie);continue}if(Z){var X="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(X);break}else throw new Error(X)}}return this.state.top=!0,ae},le.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},le.inlineTokens=function(Z,ae){var ee=this;ae===void 0&&(ae=[]);var ie,F,H,K=Z,X,de,we;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(X=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ce.includes(X[0].slice(X[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(X=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,X.index)+"["+M("a",X[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(X=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,X.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(de||(we=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ie=ye.call({lexer:ee},Z,ae))?(Z=Z.substring(ie.raw.length),ae.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.tag(Z)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.link(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(ie.raw.length),F=ae[ae.length-1],F&&ie.type==="text"&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(ie=this.tokenizer.emStrong(Z,K,we)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.codespan(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.br(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.del(Z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(ie=this.tokenizer.autolink(Z,z)){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(Z,z))){Z=Z.substring(ie.raw.length),ae.push(ie);continue}if(H=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,$e=Z.slice(1),Ve=void 0;ee.options.extensions.startInline.forEach(function(Ze){Ve=Ze.call({lexer:this},$e),typeof Ve=="number"&&Ve>=0&&(ye=Math.min(ye,Ve))}),ye<1/0&&ye>=0&&(H=Z.substring(0,ye+1))}(),ie=this.tokenizer.inlineText(H,G)){Z=Z.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(we=ie.raw.slice(-1)),de=!0,F=ae[ae.length-1],F&&F.type==="text"?(F.raw+=ie.raw,F.text+=ie.text):ae.push(ie);continue}if(Z){var Ce="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ae},l(oe,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),oe}(),x=function(){function oe(me){this.options=me||J.defaults}var le=oe.prototype;return le.code=function(Z,ae,ee){var ie=(ae||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(Z,ie);F!=null&&F!==Z&&(ee=!0,Z=F)}return Z=Z.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+E(ie,!0)+'">'+(ee?Z:E(Z,!0))+`</code></pre>
`:"<pre><code>"+(ee?Z:E(Z,!0))+`</code></pre>
`},le.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},le.html=function(Z){return Z},le.heading=function(Z,ae,ee,ie){if(this.options.headerIds){var F=this.options.headerPrefix+ie.slug(ee);return"<h"+ae+' id="'+F+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(Z,ae,ee){var ie=ae?"ol":"ul",F=ae&&ee!==1?' start="'+ee+'"':"";return"<"+ie+F+`>
`+Z+"</"+ie+`>
`},le.listitem=function(Z){return"<li>"+Z+`</li>
`},le.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(Z){return"<p>"+Z+`</p>
`},le.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},le.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},le.tablecell=function(Z,ae){var ee=ae.header?"th":"td",ie=ae.align?"<"+ee+' align="'+ae.align+'">':"<"+ee+">";return ie+Z+("</"+ee+`>
`)},le.strong=function(Z){return"<strong>"+Z+"</strong>"},le.em=function(Z){return"<em>"+Z+"</em>"},le.codespan=function(Z){return"<code>"+Z+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(Z){return"<del>"+Z+"</del>"},le.link=function(Z,ae,ee){if(Z=h(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<a href="'+E(Z)+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=">"+ee+"</a>",ie},le.image=function(Z,ae,ee){if(Z=h(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ee;var ie='<img src="'+Z+'" alt="'+ee+'"';return ae&&(ie+=' title="'+ae+'"'),ie+=this.options.xhtml?"/>":">",ie},le.text=function(Z){return Z},oe}(),V=function(){function oe(){}var le=oe.prototype;return le.strong=function(Z){return Z},le.em=function(Z){return Z},le.codespan=function(Z){return Z},le.del=function(Z){return Z},le.html=function(Z){return Z},le.text=function(Z){return Z},le.link=function(Z,ae,ee){return""+ee},le.image=function(Z,ae,ee){return""+ee},le.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var le=oe.prototype;return le.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(Z,ae){var ee=Z,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[Z];do ie++,ee=Z+"-"+ie;while(this.seen.hasOwnProperty(ee))}return ae||(this.seen[Z]=ie,this.seen[ee]=0),ee},le.slug=function(Z,ae){ae===void 0&&(ae={});var ee=this.serialize(Z);return this.getNextSafeSlug(ee,ae.dryrun)},oe}(),Y=function(){function oe(me){this.options=me||J.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new q}oe.parse=function(Z,ae){var ee=new oe(ae);return ee.parse(Z)},oe.parseInline=function(Z,ae){var ee=new oe(ae);return ee.parseInline(Z)};var le=oe.prototype;return le.parse=function(Z,ae){ae===void 0&&(ae=!0);var ee="",ie,F,H,K,X,de,we,ce,Ce,ye,$e,Ve,Ze,Ye,Oe,ot,re,se,Ee,ue=Z.length;for(ie=0;ie<ue;ie++){if(ye=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ee=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ee!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ee||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,b(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ce="",we="",K=ye.header.length,F=0;F<K;F++)we+=this.renderer.tablecell(this.parseInline(ye.header[F].tokens),{header:!0,align:ye.align[F]});for(ce+=this.renderer.tablerow(we),Ce="",K=ye.rows.length,F=0;F<K;F++){for(de=ye.rows[F],we="",X=de.length,H=0;H<X;H++)we+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:ye.align[H]});Ce+=this.renderer.tablerow(we)}ee+=this.renderer.table(ce,Ce);continue}case"blockquote":{Ce=this.parse(ye.tokens),ee+=this.renderer.blockquote(Ce);continue}case"list":{for($e=ye.ordered,Ve=ye.start,Ze=ye.loose,K=ye.items.length,Ce="",F=0;F<K;F++)Oe=ye.items[F],ot=Oe.checked,re=Oe.task,Ye="",Oe.task&&(se=this.renderer.checkbox(ot),Ze?Oe.tokens.length>0&&Oe.tokens[0].type==="paragraph"?(Oe.tokens[0].text=se+" "+Oe.tokens[0].text,Oe.tokens[0].tokens&&Oe.tokens[0].tokens.length>0&&Oe.tokens[0].tokens[0].type==="text"&&(Oe.tokens[0].tokens[0].text=se+" "+Oe.tokens[0].tokens[0].text)):Oe.tokens.unshift({type:"text",text:se}):Ye+=se),Ye+=this.parse(Oe.tokens,Ze),Ce+=this.renderer.listitem(Ye,re,ot);ee+=this.renderer.list(Ce,$e,Ve);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(Ce=ye.tokens?this.parseInline(ye.tokens):ye.text;ie+1<ue&&Z[ie+1].type==="text";)ye=Z[++ie],Ce+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=ae?this.renderer.paragraph(Ce):Ce;continue}default:{var ke='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return ee},le.parseInline=function(Z,ae){ae=ae||this.renderer;var ee="",ie,F,H,K=Z.length;for(ie=0;ie<K;ie++){if(F=Z[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(H=this.options.extensions.renderers[F.type].call({parser:this},F),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){ee+=H||"";continue}switch(F.type){case"escape":{ee+=ae.text(F.text);break}case"html":{ee+=ae.html(F.text);break}case"link":{ee+=ae.link(F.href,F.title,this.parseInline(F.tokens,ae));break}case"image":{ee+=ae.image(F.href,F.title,F.text);break}case"strong":{ee+=ae.strong(this.parseInline(F.tokens,ae));break}case"em":{ee+=ae.em(this.parseInline(F.tokens,ae));break}case"codespan":{ee+=ae.codespan(F.text);break}case"br":{ee+=ae.br();break}case"del":{ee+=ae.del(this.parseInline(F.tokens,ae));break}case"text":{ee+=ae.text(F.text);break}default:{var X='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return ee},oe}();function Q(oe,le,me){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof le=="function"&&(me=le,le=null),le=c({},Q.defaults,le||{}),L(le),me){var Z=le.highlight,ae;try{ae=O.lex(oe,le)}catch(K){return me(K)}var ee=function(X){var de;if(!X)try{le.walkTokens&&Q.walkTokens(ae,le.walkTokens),de=Y.parse(ae,le)}catch(we){X=we}return le.highlight=Z,X?me(X):me(null,de)};if(!Z||Z.length<3||(delete le.highlight,!ae.length))return ee();var ie=0;Q.walkTokens(ae,function(K){K.type==="code"&&(ie++,setTimeout(function(){Z(K.text,K.lang,function(X,de){if(X)return ee(X);de!=null&&de!==K.text&&(K.text=de,K.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function F(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(K.message+"",!0)+"</pre>";throw K}try{var H=O.lex(oe,le);if(le.walkTokens){if(le.async)return Promise.all(Q.walkTokens(H,le.walkTokens)).then(function(){return Y.parse(H,le)}).catch(F);Q.walkTokens(H,le.walkTokens)}return Y.parse(H,le)}catch(K){F(K)}}Q.options=Q.setOptions=function(oe){return c(Q.defaults,oe),I(Q.defaults),Q},Q.getDefaults=_,Q.defaults=J.defaults,Q.use=function(){for(var oe=arguments.length,le=new Array(oe),me=0;me<oe;me++)le[me]=arguments[me];var Z=c.apply(void 0,[{}].concat(le)),ae=Q.defaults.extensions||{renderers:{},childTokens:{}},ee;le.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var K=ae.renderers?ae.renderers[H.name]:null;K?ae.renderers[H.name]=function(){for(var X=arguments.length,de=new Array(X),we=0;we<X;we++)de[we]=arguments[we];var ce=H.renderer.apply(this,de);return ce===!1&&(ce=K.apply(this,de)),ce}:ae.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[H.level]?ae[H.level].unshift(H.tokenizer):ae[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ae.startBlock?ae.startBlock.push(H.start):ae.startBlock=[H.start]:H.level==="inline"&&(ae.startInline?ae.startInline.push(H.start):ae.startInline=[H.start]))}H.childTokens&&(ae.childTokens[H.name]=H.childTokens)})),ie.renderer&&function(){var H=Q.defaults.renderer||new x,K=function(we){var ce=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var Ve=ie.renderer[we].apply(H,ye);return Ve===!1&&(Ve=ce.apply(H,ye)),Ve}};for(var X in ie.renderer)K(X);Z.renderer=H}(),ie.tokenizer&&function(){var H=Q.defaults.tokenizer||new W,K=function(we){var ce=H[we];H[we]=function(){for(var Ce=arguments.length,ye=new Array(Ce),$e=0;$e<Ce;$e++)ye[$e]=arguments[$e];var Ve=ie.tokenizer[we].apply(H,ye);return Ve===!1&&(Ve=ce.apply(H,ye)),Ve}};for(var X in ie.tokenizer)K(X);Z.tokenizer=H}(),ie.walkTokens){var F=Q.defaults.walkTokens;Z.walkTokens=function(H){var K=[];return K.push(ie.walkTokens.call(this,H)),F&&(K=K.concat(F.call(this,H))),K}}ee&&(Z.extensions=ae),Q.setOptions(Z)})},Q.walkTokens=function(oe,le){for(var me=[],Z=function(){var F=ee.value;switch(me=me.concat(le.call(Q,F)),F.type){case"table":{for(var H=P(F.header),K;!(K=H()).done;){var X=K.value;me=me.concat(Q.walkTokens(X.tokens,le))}for(var de=P(F.rows),we;!(we=de()).done;)for(var ce=we.value,Ce=P(ce),ye;!(ye=Ce()).done;){var $e=ye.value;me=me.concat(Q.walkTokens($e.tokens,le))}break}case"list":{me=me.concat(Q.walkTokens(F.items,le));break}default:Q.defaults.extensions&&Q.defaults.extensions.childTokens&&Q.defaults.extensions.childTokens[F.type]?Q.defaults.extensions.childTokens[F.type].forEach(function(Ve){me=me.concat(Q.walkTokens(F[Ve],le))}):F.tokens&&(me=me.concat(Q.walkTokens(F.tokens,le)))}},ae=P(oe),ee;!(ee=ae()).done;)Z();return me},Q.parseInline=function(oe,le){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");le=c({},Q.defaults,le||{}),L(le);try{var me=O.lexInline(oe,le);return le.walkTokens&&Q.walkTokens(me,le.walkTokens),Y.parseInline(me,le)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+E(Z.message+"",!0)+"</pre>";throw Z}},Q.Parser=Y,Q.parser=Y.parse,Q.Renderer=x,Q.TextRenderer=V,Q.Lexer=O,Q.lexer=O.lex,Q.Tokenizer=W,Q.Slugger=q,Q.parse=Q;var he=Q.options,ve=Q.setOptions,ne=Q.use,pe=Q.walkTokens,be=Q.parseInline,Te=Q,Le=Y.parse,We=O.lex;J.Lexer=O,J.Parser=Y,J.Renderer=x,J.Slugger=q,J.TextRenderer=V,J.Tokenizer=W,J.getDefaults=_,J.lexer=We,J.marked=Q,J.options=he,J.parse=Te,J.parseInline=be,J.parser=Le,J.setOptions=ve,J.use=ne,J.walkTokens=pe,Object.defineProperty(J,"__esModule",{value:!0})}),define(De[94],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(I,w,C){return Math.min(Math.max(I,w),C)}e.clamp=l;function t(I,w){return(w+I%w)%w}e.rot=t;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class P{constructor(){this._n=1,this._val=0}update(w){return this._val=this._val+(w-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=P;class _{constructor(w){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(w),this._values.fill(0,0,w)}update(w){const C=this._values[this._index];return this._values[this._index]=w,this._index=(this._index+1)%this._values.length,this._sum-=C,this._sum+=w,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function J(D){const P=[];typeof D=="number"&&P.push("code/timeOrigin",D);function _(w){P.push(w,Date.now())}function I(){const w=[];for(let C=0;C<P.length;C+=2)w.push({name:P[C],startTime:P[C+1]});return w}return{mark:_,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const _ of performance.getEntriesByType("mark"))P.push({name:_.name,startTime:Math.round(D+_.startTime)});return P}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function l(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=l(t))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var t in l)(typeof exports=="object"?exports:J)[t]=l[t]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function l(t){if(e[t])return e[t].exports;var D=e[t]={i:t,l:!1,exports:{}};return J[t].call(D.exports,D,D.exports,l),D.l=!0,D.exports}return l.m=J,l.c=e,l.d=function(t,D,P){l.o(t,D)||Object.defineProperty(t,D,{enumerable:!0,get:P})},l.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},l.t=function(t,D){if(1&D&&(t=l(t)),8&D||4&D&&typeof t=="object"&&t&&t.__esModule)return t;var P=Object.create(null);if(l.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:t}),2&D&&typeof t!="string")for(var _ in t)l.d(P,_,function(I){return t[I]}.bind(null,_));return P},l.n=function(t){var D=t&&t.__esModule?function(){return t.default}:function(){return t};return l.d(D,"a",D),D},l.o=function(t,D){return Object.prototype.hasOwnProperty.call(t,D)},l.p="",l(l.s=0)}([function(J,e,l){(function(t){var D;e=J.exports=ne,D=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],C=0,R=C++;w[R]="0|[1-9]\\d*";var k=C++;w[k]="[0-9]+";var S=C++;w[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=C++;w[T]="("+w[R]+")\\.("+w[R]+")\\.("+w[R]+")";var E=C++;w[E]="("+w[k]+")\\.("+w[k]+")\\.("+w[k]+")";var g=C++;w[g]="(?:"+w[R]+"|"+w[S]+")";var b=C++;w[b]="(?:"+w[k]+"|"+w[S]+")";var m=C++;w[m]="(?:-("+w[g]+"(?:\\."+w[g]+")*))";var v=C++;w[v]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var p=C++;w[p]="[0-9A-Za-z-]+";var a=C++;w[a]="(?:\\+("+w[p]+"(?:\\."+w[p]+")*))";var h=C++,i="v?"+w[T]+w[m]+"?"+w[a]+"?";w[h]="^"+i+"$";var u="[v=\\s]*"+w[E]+w[v]+"?"+w[a]+"?",o=C++;w[o]="^"+u+"$";var r=C++;w[r]="((?:<|>)?=?)";var s=C++;w[s]=w[k]+"|x|X|\\*";var n=C++;w[n]=w[R]+"|x|X|\\*";var c=C++;w[c]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[m]+")?"+w[a]+"?)?)?";var d=C++;w[d]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[v]+")?"+w[a]+"?)?)?";var f=C++;w[f]="^"+w[r]+"\\s*"+w[c]+"$";var y=C++;w[y]="^"+w[r]+"\\s*"+w[d]+"$";var L=C++;w[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=C++;w[M]="(?:~>?)";var B=C++;w[B]="(\\s*)"+w[M]+"\\s+",I[B]=new RegExp(w[B],"g");var A=C++;w[A]="^"+w[M]+w[c]+"$";var W=C++;w[W]="^"+w[M]+w[d]+"$";var U=C++;w[U]="(?:\\^)";var N=C++;w[N]="(\\s*)"+w[U]+"\\s+",I[N]=new RegExp(w[N],"g");var G=C++;w[G]="^"+w[U]+w[c]+"$";var z=C++;w[z]="^"+w[U]+w[d]+"$";var O=C++;w[O]="^"+w[r]+"\\s*("+u+")$|^$";var x=C++;w[x]="^"+w[r]+"\\s*("+i+")$|^$";var V=C++;w[V]="(\\s*)"+w[r]+"\\s*("+u+"|"+w[c]+")",I[V]=new RegExp(w[V],"g");var q=C++;w[q]="^\\s*("+w[c]+")\\s+-\\s+("+w[c]+")\\s*$";var Y=C++;w[Y]="^\\s*("+w[d]+")\\s+-\\s+("+w[d]+")\\s*$";var Q=C++;w[Q]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)D(he,w[he]),I[he]||(I[he]=new RegExp(w[he]));function ve(ce,Ce){if(ce instanceof ne)return ce;if(typeof ce!="string"||ce.length>P||!(Ce?I[o]:I[h]).test(ce))return null;try{return new ne(ce,Ce)}catch{return null}}function ne(ce,Ce){if(ce instanceof ne){if(ce.loose===Ce)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof ne))return new ne(ce,Ce);D("SemVer",ce,Ce),this.loose=Ce;var ye=ce.trim().match(Ce?I[o]:I[h]);if(!ye)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ve=+$e;if(Ve>=0&&Ve<_)return Ve}return $e}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ve,e.valid=function(ce,Ce){var ye=ve(ce,Ce);return ye?ye.version:null},e.clean=function(ce,Ce){var ye=ve(ce.trim().replace(/^[=v]+/,""),Ce);return ye?ye.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof ne||(ce=new ne(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},ne.prototype.compareMain=function(ce){return ce instanceof ne||(ce=new ne(ce,this.loose)),be(this.major,ce.major)||be(this.minor,ce.minor)||be(this.patch,ce.patch)},ne.prototype.comparePre=function(ce){if(ce instanceof ne||(ce=new ne(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var Ce=0;do{var ye=this.prerelease[Ce],$e=ce.prerelease[Ce];if(D("prerelease compare",Ce,ye,$e),ye===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(ye===void 0)return-1;if(ye!==$e)return be(ye,$e)}while(++Ce)},ne.prototype.inc=function(ce,Ce){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,Ce,ye,$e){typeof ye=="string"&&($e=ye,ye=void 0);try{return new ne(ce,ye).inc(Ce,$e).version}catch{return null}},e.diff=function(ce,Ce){if(oe(ce,Ce))return null;var ye=ve(ce),$e=ve(Ce);if(ye.prerelease.length||$e.prerelease.length){for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==$e[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in ye)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&ye[Ve]!==$e[Ve])return Ve},e.compareIdentifiers=be;var pe=/^[0-9]+$/;function be(ce,Ce){var ye=pe.test(ce),$e=pe.test(Ce);return ye&&$e&&(ce=+ce,Ce=+Ce),ye&&!$e?-1:$e&&!ye?1:ce<Ce?-1:ce>Ce?1:0}function Te(ce,Ce,ye){return new ne(ce,ye).compare(new ne(Ce,ye))}function Le(ce,Ce,ye){return Te(ce,Ce,ye)>0}function We(ce,Ce,ye){return Te(ce,Ce,ye)<0}function oe(ce,Ce,ye){return Te(ce,Ce,ye)===0}function le(ce,Ce,ye){return Te(ce,Ce,ye)!==0}function me(ce,Ce,ye){return Te(ce,Ce,ye)>=0}function Z(ce,Ce,ye){return Te(ce,Ce,ye)<=0}function ae(ce,Ce,ye,$e){var Ve;switch(Ce){case"===":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),Ve=ce===ye;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ye=="object"&&(ye=ye.version),Ve=ce!==ye;break;case"":case"=":case"==":Ve=oe(ce,ye,$e);break;case"!=":Ve=le(ce,ye,$e);break;case">":Ve=Le(ce,ye,$e);break;case">=":Ve=me(ce,ye,$e);break;case"<":Ve=We(ce,ye,$e);break;case"<=":Ve=Z(ce,ye,$e);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ve}function ee(ce,Ce){if(ce instanceof ee){if(ce.loose===Ce)return ce;ce=ce.value}if(!(this instanceof ee))return new ee(ce,Ce);D("comparator",ce,Ce),this.loose=Ce,this.parse(ce),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,Ce){return be(Ce,ce)},e.major=function(ce,Ce){return new ne(ce,Ce).major},e.minor=function(ce,Ce){return new ne(ce,Ce).minor},e.patch=function(ce,Ce){return new ne(ce,Ce).patch},e.compare=Te,e.compareLoose=function(ce,Ce){return Te(ce,Ce,!0)},e.rcompare=function(ce,Ce,ye){return Te(Ce,ce,ye)},e.sort=function(ce,Ce){return ce.sort(function(ye,$e){return e.compare(ye,$e,Ce)})},e.rsort=function(ce,Ce){return ce.sort(function(ye,$e){return e.rcompare(ye,$e,Ce)})},e.gt=Le,e.lt=We,e.eq=oe,e.neq=le,e.gte=me,e.lte=Z,e.cmp=ae,e.Comparator=ee;var ie={};function F(ce,Ce){if(ce instanceof F)return ce.loose===Ce?ce:new F(ce.raw,Ce);if(ce instanceof ee)return new F(ce.value,Ce);if(!(this instanceof F))return new F(ce,Ce);if(this.loose=Ce,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function H(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function K(ce,Ce,ye,$e,Ve,Ze,Ye,Oe,ot,re,se,Ee,ue){return((Ce=H(ye)?"":H($e)?">="+ye+".0.0":H(Ve)?">="+ye+"."+$e+".0":">="+Ce)+" "+(Oe=H(ot)?"":H(re)?"<"+(+ot+1)+".0.0":H(se)?"<"+ot+"."+(+re+1)+".0":Ee?"<="+ot+"."+re+"."+se+"-"+Ee:"<="+Oe)).trim()}function X(ce,Ce){for(var ye=0;ye<ce.length;ye++)if(!ce[ye].test(Ce))return!1;if(Ce.prerelease.length){for(ye=0;ye<ce.length;ye++)if(D(ce[ye].semver),ce[ye].semver!==ie&&ce[ye].semver.prerelease.length>0){var $e=ce[ye].semver;if($e.major===Ce.major&&$e.minor===Ce.minor&&$e.patch===Ce.patch)return!0}return!1}return!0}function de(ce,Ce,ye){try{Ce=new F(Ce,ye)}catch{return!1}return Ce.test(ce)}function we(ce,Ce,ye,$e){var Ve,Ze,Ye,Oe,ot;switch(ce=new ne(ce,$e),Ce=new F(Ce,$e),ye){case">":Ve=Le,Ze=Z,Ye=We,Oe=">",ot=">=";break;case"<":Ve=We,Ze=me,Ye=Le,Oe="<",ot="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ce,Ce,$e))return!1;for(var re=0;re<Ce.set.length;++re){var se=Ce.set[re],Ee=null,ue=null;if(se.forEach(function(ke){ke.semver===ie&&(ke=new ee(">=0.0.0")),Ee=Ee||ke,ue=ue||ke,Ve(ke.semver,Ee.semver,$e)?Ee=ke:Ye(ke.semver,ue.semver,$e)&&(ue=ke)}),Ee.operator===Oe||Ee.operator===ot||(!ue.operator||ue.operator===Oe)&&Ze(ce,ue.semver)||ue.operator===ot&&Ye(ce,ue.semver))return!1}return!0}ee.prototype.parse=function(ce){var Ce=this.loose?I[O]:I[x],ye=ce.match(Ce);if(!ye)throw new TypeError("Invalid comparator: "+ce);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ne(ye[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===ie||(typeof ce=="string"&&(ce=new ne(ce,this.loose)),ae(ce,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(ce,Ce){if(!(ce instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new F(ce.value,Ce),de(this.value,ye,Ce);if(ce.operator==="")return ye=new F(this.value,Ce),de(ce.semver,ye,Ce);var $e=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ze=this.semver.version===ce.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Oe=ae(this.semver,"<",ce.semver,Ce)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),ot=ae(this.semver,">",ce.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return $e||Ve||Ze&&Ye||Oe||ot},e.Range=F,F.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},F.prototype.toString=function(){return this.range},F.prototype.parseRange=function(ce){var Ce=this.loose;ce=ce.trim(),D("range",ce,Ce);var ye=Ce?I[Y]:I[q];ce=ce.replace(ye,K),D("hyphen replace",ce),ce=ce.replace(I[V],"$1$2$3"),D("comparator trim",ce,I[V]),ce=(ce=(ce=ce.replace(I[B],"$1~")).replace(I[N],"$1^")).split(/\s+/).join(" ");var $e=Ce?I[O]:I[x],Ve=ce.split(" ").map(function(Ze){return function(Ye,Oe){return D("comp",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,ue){D("caret",Ee,ue);var ke=ue?I[z]:I[G];return Ee.replace(ke,function(Ne,Be,ze,Qe,nt){var ct;return D("caret",Ee,Ne,Be,ze,Qe,nt),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Qe)?ct=Be==="0"?">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+".0 <"+(+Be+1)+".0.0":nt?(D("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Qe+nt+" <"+Be+"."+ze+"."+(+Qe+1):">="+Be+"."+ze+"."+Qe+nt+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Qe+nt+" <"+(+Be+1)+".0.0"):(D("no pr"),ct=Be==="0"?ze==="0"?">="+Be+"."+ze+"."+Qe+" <"+Be+"."+ze+"."+(+Qe+1):">="+Be+"."+ze+"."+Qe+" <"+Be+"."+(+ze+1)+".0":">="+Be+"."+ze+"."+Qe+" <"+(+Be+1)+".0.0"),D("caret return",ct),ct})}(se,re)}).join(" ")}(Ye,Oe),D("caret",Ye),Ye=function(ot,re){return ot.trim().split(/\s+/).map(function(se){return function(Ee,ue){var ke=ue?I[W]:I[A];return Ee.replace(ke,function(Ne,Be,ze,Qe,nt){var ct;return D("tilde",Ee,Ne,Be,ze,Qe,nt),H(Be)?ct="":H(ze)?ct=">="+Be+".0.0 <"+(+Be+1)+".0.0":H(Qe)?ct=">="+Be+"."+ze+".0 <"+Be+"."+(+ze+1)+".0":nt?(D("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=">="+Be+"."+ze+"."+Qe+nt+" <"+Be+"."+(+ze+1)+".0"):ct=">="+Be+"."+ze+"."+Qe+" <"+Be+"."+(+ze+1)+".0",D("tilde return",ct),ct})}(se,re)}).join(" ")}(Ye,Oe),D("tildes",Ye),Ye=function(ot,re){return D("replaceXRanges",ot,re),ot.split(/\s+/).map(function(se){return function(Ee,ue){Ee=Ee.trim();var ke=ue?I[y]:I[f];return Ee.replace(ke,function(Ne,Be,ze,Qe,nt,ct){D("xRange",Ee,Ne,Be,ze,Qe,nt,ct);var st=H(ze),et=st||H(Qe),mt=et||H(nt);return Be==="="&&mt&&(Be=""),st?Ne=Be===">"||Be==="<"?"<0.0.0":"*":Be&&mt?(et&&(Qe=0),mt&&(nt=0),Be===">"?(Be=">=",et?(ze=+ze+1,Qe=0,nt=0):mt&&(Qe=+Qe+1,nt=0)):Be==="<="&&(Be="<",et?ze=+ze+1:Qe=+Qe+1),Ne=Be+ze+"."+Qe+"."+nt):et?Ne=">="+ze+".0.0 <"+(+ze+1)+".0.0":mt&&(Ne=">="+ze+"."+Qe+".0 <"+ze+"."+(+Qe+1)+".0"),D("xRange return",Ne),Ne})}(se,re)}).join(" ")}(Ye,Oe),D("xrange",Ye),Ye=function(ot,re){return D("replaceStars",ot,re),ot.trim().replace(I[Q],"")}(Ye,Oe),D("stars",Ye),Ye}(Ze,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(Ze){return!!Ze.match($e)})),Ve=Ve.map(function(Ze){return new ee(Ze,Ce)})},F.prototype.intersects=function(ce,Ce){if(!(ce instanceof F))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function($e){return ce.set.some(function(Ve){return Ve.every(function(Ze){return $e.intersects(Ze,Ce)})})})})},e.toComparators=function(ce,Ce){return new F(ce,Ce).set.map(function(ye){return ye.map(function($e){return $e.value}).join(" ").trim().split(" ")})},F.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new ne(ce,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(X(this.set[Ce],ce))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ce,Ce,ye){var $e=null,Ve=null;try{var Ze=new F(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&($e&&Ve.compare(Ye)!==-1||(Ve=new ne($e=Ye,ye)))}),$e},e.minSatisfying=function(ce,Ce,ye){var $e=null,Ve=null;try{var Ze=new F(Ce,ye)}catch{return null}return ce.forEach(function(Ye){Ze.test(Ye)&&($e&&Ve.compare(Ye)!==1||(Ve=new ne($e=Ye,ye)))}),$e},e.validRange=function(ce,Ce){try{return new F(ce,Ce).range||"*"}catch{return null}},e.ltr=function(ce,Ce,ye){return we(ce,Ce,"<",ye)},e.gtr=function(ce,Ce,ye){return we(ce,Ce,">",ye)},e.outside=we,e.prerelease=function(ce,Ce){var ye=ve(ce,Ce);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ce,Ce,ye){return ce=new F(ce,ye),Ce=new F(Ce,ye),ce.intersects(Ce)},e.coerce=function(ce){if(ce instanceof ne)return ce;if(typeof ce!="string")return null;var Ce=ce.match(I[L]);return Ce==null?null:ve((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,l(1))},function(J,e){var l,t,D=J.exports={};function P(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function I(b){if(l===setTimeout)return setTimeout(b,0);if((l===P||!l)&&setTimeout)return l=setTimeout,setTimeout(b,0);try{return l(b,0)}catch{try{return l.call(null,b,0)}catch{return l.call(this,b,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:P}catch{l=P}try{t=typeof clearTimeout=="function"?clearTimeout:_}catch{t=_}})();var w,C=[],R=!1,k=-1;function S(){R&&w&&(R=!1,w.length?C=w.concat(C):k=-1,C.length&&T())}function T(){if(!R){var b=I(S);R=!0;for(var m=C.length;m;){for(w=C,C=[];++k<m;)w&&w[k].run();k=-1,m=C.length}w=null,R=!1,function(v){if(t===clearTimeout)return clearTimeout(v);if((t===_||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(v);try{t(v)}catch{try{return t.call(null,v)}catch{return t.call(this,v)}}}(b)}}function E(b,m){this.fun=b,this.array=m}function g(){}D.nextTick=function(b){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];C.push(new E(b,m)),C.length!==1||R||I(T)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=g,D.addListener=g,D.once=g,D.off=g,D.removeListener=g,D.removeAllListeners=g,D.emit=g,D.prependListener=g,D.prependOnceListener=g,D.listeners=function(b){return[]},D.binding=function(b){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(b){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(De[95],Ie([1,0,10,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(a){const h=a;return h?typeof h.read=="function":!1}e.isReadable=D;function P(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=P;function _(a){const h=a;return h?P(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=_;function I(a,h){return new w(a,h)}e.newWriteableStream=I;class w{constructor(h,i){this.reducer=h,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h<"u"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(i=>i(h))}emitError(h){this.listeners.error.length===0?(0,l.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(i=>i(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,i){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(h,i){if(this.state.destroyed)return;let u;switch(h){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const o=u.indexOf(i);o>=0&&u.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(a,h){const i=[];let u;for(;(u=a.read())!==null;)i.push(u);return h(i)}e.consumeReadable=C;function R(a,h,i){const u=[];let o;for(;(o=a.read())!==null&&u.length<i;)u.push(o);return o===null&&u.length>0?h(u):{read:()=>{if(u.length>0)return u.shift();if(typeof o<"u"){const r=o;return o=void 0,r}return a.read()}}}e.peekReadable=R;function k(a,h){return new Promise((i,u)=>{const o=[];S(a,{onData:r=>{h&&o.push(r)},onError:r=>{h?u(r):i(void 0)},onEnd:()=>{i(h?h(o):void 0)}})})}e.consumeStream=k;function S(a,h){let i=!1;return a.on("error",u=>{i||h.onError(u)}),a.on("end",()=>{i||h.onEnd()}),a.on("data",u=>{i||h.onData(u)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=S;function T(a,h){return new Promise((i,u)=>{const o=new t.DisposableStore,r=[],s=d=>{if(r.push(d),r.length>h)return o.dispose(),a.pause(),i({stream:a,buffer:r,ended:!1})},n=d=>u(d),c=()=>i({stream:a,buffer:r,ended:!0});o.add((0,t.toDisposable)(()=>a.removeListener("error",n))),a.on("error",n),o.add((0,t.toDisposable)(()=>a.removeListener("end",c))),a.on("end",c),o.add((0,t.toDisposable)(()=>a.removeListener("data",s))),a.on("data",s)})}e.peekStream=T;function E(a,h){const i=I(h);return i.end(a),i}e.toStream=E;function g(){const a=I(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=g;function b(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}e.toReadable=b;function m(a,h,i){const u=I(i);return S(a,{onData:o=>u.write(h.data(o)),onError:o=>u.error(h.error?h.error(o):o),onEnd:()=>u.end()}),u}e.transform=m;function v(a,h,i){let u=!1;return{read:()=>{const o=h.read();return u?o:(u=!0,o!==null?i([a,o]):a)}}}e.prefixedReadable=v;function p(a,h,i){let u=!1;const o=I(i);return S(h,{onData:r=>u?o.write(r):(u=!0,o.write(i([a,r]))),onError:r=>o.error(r),onEnd:()=>{u||(u=!0,o.write(a)),o.end()}}),o}e.prefixedStream=p}),define(De[23],Ie([1,0,95]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let D,P;class _{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return t?new _(Buffer.allocUnsafe(d)):new _(new Uint8Array(d))}static wrap(d){return t&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new _(d)}static fromString(d,f){return!(f?.dontUseNodeBuffer||!1)&&t?new _(Buffer.from(d)):(D||(D=new TextEncoder),new _(D.encode(d)))}static fromByteArray(d){const f=_.alloc(d.length);for(let y=0,L=d.length;y<L;y++)f.buffer[y]=d[y];return f}static concat(d,f){if(typeof f>"u"){f=0;for(let M=0,B=d.length;M<B;M++)f+=d[M].byteLength}const y=_.alloc(f);let L=0;for(let M=0,B=d.length;M<B;M++){const A=d[M];y.set(A,L),L+=A.byteLength}return y}clone(){const d=_.alloc(this.byteLength);return d.set(this),d}toString(){return t?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(d,f){return new _(this.buffer.subarray(d,f))}set(d,f){if(d instanceof _)this.buffer.set(d.buffer,f);else if(d instanceof Uint8Array)this.buffer.set(d,f);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),f);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return C(this.buffer,d)}writeUInt32BE(d,f){R(this.buffer,d,f)}readUInt32LE(d){return k(this.buffer,d)}writeUInt32LE(d,f){S(this.buffer,d,f)}readUInt8(d){return T(this.buffer,d)}writeUInt8(d,f){E(this.buffer,d,f)}}e.VSBuffer=_;function I(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0}e.readUInt16LE=I;function w(c,d,f){c[f+0]=d&255,d=d>>>8,c[f+1]=d&255}e.writeUInt16LE=w;function C(c,d){return c[d]*2**24+c[d+1]*2**16+c[d+2]*2**8+c[d+3]}e.readUInt32BE=C;function R(c,d,f){c[f+3]=d,d=d>>>8,c[f+2]=d,d=d>>>8,c[f+1]=d,d=d>>>8,c[f]=d}e.writeUInt32BE=R;function k(c,d){return c[d+0]<<0>>>0|c[d+1]<<8>>>0|c[d+2]<<16>>>0|c[d+3]<<24>>>0}e.readUInt32LE=k;function S(c,d,f){c[f+0]=d&255,d=d>>>8,c[f+1]=d&255,d=d>>>8,c[f+2]=d&255,d=d>>>8,c[f+3]=d&255}e.writeUInt32LE=S;function T(c,d){return c[d]}e.readUInt8=T;function E(c,d,f){c[f]=d}e.writeUInt8=E;function g(c){return l.consumeReadable(c,d=>_.concat(d))}e.readableToBuffer=g;function b(c){return l.toReadable(c)}e.bufferToReadable=b;function m(c){return l.consumeStream(c,d=>_.concat(d))}e.streamToBuffer=m;async function v(c){return c.ended?_.concat(c.buffer):_.concat([...c.buffer,await m(c.stream)])}e.bufferedStreamToBuffer=v;function p(c){return l.toStream(c,d=>_.concat(d))}e.bufferToStream=p;function a(c){return l.transform(c,{data:d=>typeof d=="string"?_.fromString(d):_.wrap(d)},d=>_.concat(d))}e.streamToBufferReadableStream=a;function h(c){return l.newWriteableStream(d=>_.concat(d),c)}e.newWriteableBufferStream=h;function i(c,d){return l.prefixedReadable(c,d,f=>_.concat(f))}e.prefixedBufferReadable=i;function u(c,d){return l.prefixedStream(c,d,f=>_.concat(f))}e.prefixedBufferStream=u;function o(c){let d=0,f=0,y=0;const L=new Uint8Array(Math.floor(c.length/4*3)),M=A=>{switch(f){case 3:L[y++]=d|A,f=0;break;case 2:L[y++]=d|A>>>2,d=A<<6,f=3;break;case 1:L[y++]=d|A>>>4,d=A<<4,f=2;break;default:d=A<<2,f=1}};for(let A=0;A<c.length;A++){const W=c.charCodeAt(A);if(W>=65&&W<=90)M(W-65);else if(W>=97&&W<=122)M(W-97+26);else if(W>=48&&W<=57)M(W-48+52);else if(W===43||W===45)M(62);else if(W===47||W===95)M(63);else{if(W===61)break;throw new SyntaxError(`Unexpected base64 character ${c[A]}`)}}const B=y;for(;f>0;)M(0);return _.wrap(L).slice(0,B)}e.decodeBase64=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function n({buffer:c},d=!0,f=!1){const y=f?s:r;let L="";const M=c.byteLength%3;let B=0;for(;B<c.byteLength-M;B+=3){const A=c[B+0],W=c[B+1],U=c[B+2];L+=y[A>>>2],L+=y[(A<<4|W>>>4)&63],L+=y[(W<<2|U>>>6)&63],L+=y[U&63]}if(M===1){const A=c[B+0];L+=y[A>>>2],L+=y[A<<4&63],d&&(L+="==")}else if(M===2){const A=c[B+0],W=c[B+1];L+=y[A>>>2],L+=y[(A<<4|W>>>4)&63],L+=y[W<<2&63],d&&(L+="=")}return L}e.encodeBase64=n}),define(De[13],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function l(u){return typeof u=="string"}e.isString=l;function t(u){return Array.isArray(u)&&u.every(o=>l(o))}e.isStringArray=t;function D(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=D;function P(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}e.isTypedArray=P;function _(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=_;function I(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=I;function w(u){return u===!0||u===!1}e.isBoolean=w;function C(u){return typeof u>"u"}e.isUndefined=C;function R(u){return!k(u)}e.isDefined=R;function k(u){return C(u)||u===null}e.isUndefinedOrNull=k;function S(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=S;function T(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=T;function E(...u){const o=[];for(let r=0;r<u.length;r++){const s=u[r];if(k(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);o.push(s)}return o}e.assertAllDefined=E;const g=Object.prototype.hasOwnProperty;function b(u){if(!D(u))return!1;for(const o in u)if(g.call(u,o))return!1;return!0}e.isEmptyObject=b;function m(u){return typeof u=="function"}e.isFunction=m;function v(...u){return u.length>0&&u.every(m)}e.areFunctions=v;function p(u,o){const r=Math.min(u.length,o.length);for(let s=0;s<r;s++)a(u[s],o[s])}e.validateConstraints=p;function a(u,o){if(l(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(u instanceof o)return}catch{}if(!k(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function h(u){return u===null?void 0:u}e.withNullAsUndefined=h;function i(u){return typeof u>"u"?null:u}e.withUndefinedAsNull=i}),define(De[24],Ie([1,0,13]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const v=Array.isArray(m)?[]:{};return Object.keys(m).forEach(p=>{m[p]&&typeof m[p]=="object"?v[p]=t(m[p]):v[p]=m[p]}),v}e.deepClone=t;function D(m){if(!m||typeof m!="object")return m;const v=[m];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const a in p)if(P.call(p,a)){const h=p[a];typeof h=="object"&&!Object.isFrozen(h)&&!(0,l.isTypedArray)(h)&&v.push(h)}}return m}e.deepFreeze=D;const P=Object.prototype.hasOwnProperty;function _(m,v){return I(m,v,new Set)}e.cloneAndChange=_;function I(m,v,p){if((0,l.isUndefinedOrNull)(m))return m;const a=v(m);if(typeof a<"u")return a;if(Array.isArray(m)){const h=[];for(const i of m)h.push(I(i,v,p));return h}if((0,l.isObject)(m)){if(p.has(m))throw new Error("Cannot clone recursive data-structure");p.add(m);const h={};for(const i in m)P.call(m,i)&&(h[i]=I(m[i],v,p));return p.delete(m),h}return m}function w(m,v,p=!0){return(0,l.isObject)(m)?((0,l.isObject)(v)&&Object.keys(v).forEach(a=>{a in m?p&&((0,l.isObject)(m[a])&&(0,l.isObject)(v[a])?w(m[a],v[a],p):m[a]=v[a]):m[a]=v[a]}),m):v}e.mixin=w;function C(m,v){if(m===v)return!0;if(m==null||v===null||v===void 0||typeof m!=typeof v||typeof m!="object"||Array.isArray(m)!==Array.isArray(v))return!1;let p,a;if(Array.isArray(m)){if(m.length!==v.length)return!1;for(p=0;p<m.length;p++)if(!C(m[p],v[p]))return!1}else{const h=[];for(a in m)h.push(a);h.sort();const i=[];for(a in v)i.push(a);if(i.sort(),!C(h,i))return!1;for(p=0;p<h.length;p++)if(!C(m[h[p]],v[h[p]]))return!1}return!0}e.equals=C;function R(m){const v=new Set;return JSON.stringify(m,(p,a)=>{if((0,l.isObject)(a)||Array.isArray(a)){if(v.has(a))return"[Circular]";v.add(a)}return a})}e.safeStringify=R;function k(m,v){const p=Object.create(null);return!m||!v||Object.keys(v).forEach(h=>{const i=m[h],u=v[h];C(i,u)||(p[h]=u)}),p}e.distinct=k;function S(m,v){const p=v.toLowerCase(),a=Object.keys(m).find(h=>h.toLowerCase()===p);return a?m[a]:m[v]}e.getCaseInsensitive=S;function T(m,v){const p=Object.create(null);for(const[a,h]of Object.entries(m))v(a,h)&&(p[a]=h);return p}e.filter=T;function E(m){let v=[],p=Object.getPrototypeOf(m);for(;Object.prototype!==p;)v=v.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return v}e.getAllPropertyNames=E;function g(m){const v=[];for(const p of E(m))typeof m[p]=="function"&&v.push(p);return v}e.getAllMethodNames=g;function b(m,v){const p=h=>function(){const i=Array.prototype.slice.call(arguments,0);return v(h,i)},a={};for(const h of m)a[h]=p(h);return a}e.createProxyObject=b}),define(De[96],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var l;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l=e.Constants||(e.Constants={}));function t(P){return P<0?0:P>255?255:P|0}e.toUint8=t;function D(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=D}),define(De[34],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return l.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),_=[];for(let I=0;I<256;I++)_.push(I.toString(16).padStart(2,"0"));return function(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,C="";return C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C+="-",C+=_[P[w++]],C+=_[P[w++]],C+="-",C+=_[P[w++]],C+=_[P[w++]],C+="-",C+=_[P[w++]],C+=_[P[w++]],C+="-",C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C+=_[P[w++]],C}}()}),define(De[97],Ie([1,0,96]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(I){const w=(0,l.toUint8)(I);this._defaultValue=w,this._asciiMap=t._createAsciiMap(w),this._map=new Map}static _createAsciiMap(I){const w=new Uint8Array(256);for(let C=0;C<256;C++)w[C]=I;return w}set(I,w){const C=(0,l.toUint8)(w);I>=0&&I<256?this._asciiMap[I]=C:this._map.set(I,C)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=t;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class P{constructor(){this._actual=new t(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=P}),define(De[49],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class l{constructor(D,P){this.lineNumber=D,this.column=P}with(D=this.lineNumber,P=this.column){return D===this.lineNumber&&P===this.column?this:new l(D,P)}delta(D=0,P=0){return this.with(this.lineNumber+D,this.column+P)}equals(D){return l.equals(this,D)}static equals(D,P){return!D&&!P?!0:!!D&&!!P&&D.lineNumber===P.lineNumber&&D.column===P.column}isBefore(D){return l.isBefore(this,D)}static isBefore(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<P.column}isBeforeOrEqual(D){return l.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,P){return D.lineNumber<P.lineNumber?!0:P.lineNumber<D.lineNumber?!1:D.column<=P.column}static compare(D,P){const _=D.lineNumber|0,I=P.lineNumber|0;if(_===I){const w=D.column|0,C=P.column|0;return w-C}return _-I}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new l(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=l}),define(De[35],Ie([1,0,49]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(P,_,I,w){P>I||P===I&&_>w?(this.startLineNumber=I,this.startColumn=w,this.endLineNumber=P,this.endColumn=_):(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=I,this.endColumn=w)}isEmpty(){return t.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return t.containsPosition(this,P)}static containsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<P.startColumn||_.lineNumber===P.endLineNumber&&_.column>P.endColumn)}static strictContainsPosition(P,_){return!(_.lineNumber<P.startLineNumber||_.lineNumber>P.endLineNumber||_.lineNumber===P.startLineNumber&&_.column<=P.startColumn||_.lineNumber===P.endLineNumber&&_.column>=P.endColumn)}containsRange(P){return t.containsRange(this,P)}static containsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>P.endColumn)}strictContainsRange(P){return t.strictContainsRange(this,P)}static strictContainsRange(P,_){return!(_.startLineNumber<P.startLineNumber||_.endLineNumber<P.startLineNumber||_.startLineNumber>P.endLineNumber||_.endLineNumber>P.endLineNumber||_.startLineNumber===P.startLineNumber&&_.startColumn<=P.startColumn||_.endLineNumber===P.endLineNumber&&_.endColumn>=P.endColumn)}plusRange(P){return t.plusRange(this,P)}static plusRange(P,_){let I,w,C,R;return _.startLineNumber<P.startLineNumber?(I=_.startLineNumber,w=_.startColumn):_.startLineNumber===P.startLineNumber?(I=_.startLineNumber,w=Math.min(_.startColumn,P.startColumn)):(I=P.startLineNumber,w=P.startColumn),_.endLineNumber>P.endLineNumber?(C=_.endLineNumber,R=_.endColumn):_.endLineNumber===P.endLineNumber?(C=_.endLineNumber,R=Math.max(_.endColumn,P.endColumn)):(C=P.endLineNumber,R=P.endColumn),new t(I,w,C,R)}intersectRanges(P){return t.intersectRanges(this,P)}static intersectRanges(P,_){let I=P.startLineNumber,w=P.startColumn,C=P.endLineNumber,R=P.endColumn;const k=_.startLineNumber,S=_.startColumn,T=_.endLineNumber,E=_.endColumn;return I<k?(I=k,w=S):I===k&&(w=Math.max(w,S)),C>T?(C=T,R=E):C===T&&(R=Math.min(R,E)),I>C||I===C&&w>R?null:new t(I,w,C,R)}equalsRange(P){return t.equalsRange(this,P)}static equalsRange(P,_){return!!P&&!!_&&P.startLineNumber===_.startLineNumber&&P.startColumn===_.startColumn&&P.endLineNumber===_.endLineNumber&&P.endColumn===_.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(P){return new l.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(P){return new l.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,_){return new t(this.startLineNumber,this.startColumn,P,_)}setStartPosition(P,_){return new t(P,_,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}delta(P){return new t(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static collapseToStart(P){return new t(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,_=P){return new t(P.lineNumber,P.column,_.lineNumber,_.column)}static lift(P){return P?new t(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<P.startColumn)}static areIntersecting(P,_){return!(P.endLineNumber<_.startLineNumber||P.endLineNumber===_.startLineNumber&&P.endColumn<=_.startColumn||_.endLineNumber<P.startLineNumber||_.endLineNumber===P.startLineNumber&&_.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,_){if(P&&_){const C=P.startLineNumber|0,R=_.startLineNumber|0;if(C===R){const k=P.startColumn|0,S=_.startColumn|0;if(k===S){const T=P.endLineNumber|0,E=_.endLineNumber|0;if(T===E){const g=P.endColumn|0,b=_.endColumn|0;return g-b}return T-E}return k-S}return C-R}return(P?1:0)-(_?1:0)}static compareRangesUsingEnds(P,_){return P.endLineNumber===_.endLineNumber?P.endColumn===_.endColumn?P.startLineNumber===_.startLineNumber?P.startColumn-_.startColumn:P.startLineNumber-_.startLineNumber:P.endColumn-_.endColumn:P.endLineNumber-_.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.Range=t}),define(De[145],Ie([1,0,49,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class P extends t.Range{constructor(I,w,C,R){super(I,w,C,R),this.selectionStartLineNumber=I,this.selectionStartColumn=w,this.positionLineNumber=C,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return P.selectionsEqual(this,I)}static selectionsEqual(I,w){return I.selectionStartLineNumber===w.selectionStartLineNumber&&I.selectionStartColumn===w.selectionStartColumn&&I.positionLineNumber===w.positionLineNumber&&I.positionColumn===w.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,w){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,I,w):new P(I,w,this.startLineNumber,this.startColumn)}getPosition(){return new l.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(I,w){return this.getDirection()===0?new P(I,w,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,I,w)}static fromPositions(I,w=I){return new P(I.lineNumber,I.column,w.lineNumber,w.column)}static fromRange(I,w){return w===0?new P(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):new P(I.endLineNumber,I.endColumn,I.startLineNumber,I.startColumn)}static liftSelection(I){return new P(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,w){if(I&&!w||!I&&w)return!1;if(!I&&!w)return!0;if(I.length!==w.length)return!1;for(let C=0,R=I.length;C<R;C++)if(!this.selectionsEqual(I[C],w[C]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,w,C,R,k){return k===0?new P(I,w,C,R):new P(C,R,I,w)}}e.Selection=P}),define(De[146],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[147],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends l.CharacterClassifier{constructor(I){super(0);for(let w=0,C=I.length;w<C;w++)this.set(I.charCodeAt(w),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function P(_){const I={};return w=>(I.hasOwnProperty(w)||(I[w]=_(w)),I[w])}e.getMapForWordSeparators=P(_=>new D(_))}),define(De[98],Ie([1,0,60,6,78]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(S+="\\"+T);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=P();function _(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),S=new RegExp(k.source,T)}return S.lastIndex=0,S}e.ensureValidWordDefinition=_;const I=new D.LinkedList;I.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function w(k){const S=I.unshift(k);return(0,t.toDisposable)(S)}e.setDefaultGetWordAtTextConfig=w;function C(k,S,T,E,g){if(g||(g=l.Iterable.first(I)),T.length>g.maxLen){let a=k-g.maxLen/2;return a<0?a=0:E+=a,T=T.substring(a,k+g.maxLen/2),C(k,S,T,E,g)}const b=Date.now(),m=k-1-E;let v=-1,p=null;for(let a=1;!(Date.now()-b>=g.timeBudget);a++){const h=m-g.windowSize*a;S.lastIndex=Math.max(0,h);const i=R(S,T,m,v);if(!i&&p||(p=i,h<=0))break;v=h}if(p){const a={word:p[0],startColumn:E+1+p.index,endColumn:E+1+p.index+p[0].length};return S.lastIndex=0,a}return null}e.getWordAtText=C;function R(k,S,T,E){let g;for(;g=k.exec(S);){const b=g.index||0;if(b<=T&&k.lastIndex>=T)return g;if(E>0&&b>E)return null}return null}}),define(De[148],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(I.notIn))for(let w=0,C=I.notIn.length;w<C;w++)switch(I.notIn[w]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(I){switch(I){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(I,w){if(I.getTokenCount()===0)return!0;const C=I.findTokenIndexAtOffset(w-2),R=I.getStandardTokenType(C);return this.isOK(R)}_findNeutralCharacterInRange(I,w){for(let C=I;C<=w;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class D{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const w of I)P(this.autoClosingPairsOpenByStart,w.open.charAt(0),w),P(this.autoClosingPairsOpenByEnd,w.open.charAt(w.open.length-1),w),P(this.autoClosingPairsCloseByStart,w.close.charAt(0),w),P(this.autoClosingPairsCloseByEnd,w.close.charAt(w.close.length-1),w),w.close.length===1&&w.open.length===1&&P(this.autoClosingPairsCloseSingleChar,w.close,w)}}e.AutoClosingPairs=D;function P(_,I,w){_.has(I)?_.get(I).push(w):_.set(I,[w])}}),define(De[149],Ie([1,0,97]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var t;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class D{constructor(E,g,b){const m=new Uint8Array(E*g);for(let v=0,p=E*g;v<p;v++)m[v]=b;this._data=m,this.rows=E,this.cols=g}get(E,g){return this._data[E*this.cols+g]}set(E,g,b){this._data[E*this.cols+g]=b}}e.Uint8Matrix=D;class P{constructor(E){let g=0,b=0;for(let v=0,p=E.length;v<p;v++){const[a,h,i]=E[v];h>g&&(g=h),a>b&&(b=a),i>b&&(b=i)}g++,b++;const m=new D(b,g,0);for(let v=0,p=E.length;v<p;v++){const[a,h,i]=E[v];m.set(a,h,i)}this._states=m,this._maxCharCode=g}nextState(E,g){return g<0||g>=this._maxCharCode?0:this._states.get(E,g)}}e.StateMachine=P;let _=null;function I(){return _===null&&(_=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var w;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(w||(w={}));let C=null;function R(){if(C===null){C=new l.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<T.length;g++)C.set(T.charCodeAt(g),1);const E=".,;:";for(let g=0;g<E.length;g++)C.set(E.charCodeAt(g),2)}return C}class k{static _createLink(E,g,b,m,v){let p=v-1;do{const a=g.charCodeAt(p);if(E.get(a)!==2)break;p--}while(p>m);if(m>0){const a=g.charCodeAt(m-1),h=g.charCodeAt(p);(a===40&&h===41||a===91&&h===93||a===123&&h===125)&&p--}return{range:{startLineNumber:b,startColumn:m+1,endLineNumber:b,endColumn:p+2},url:g.substring(m,p+1)}}static computeLinks(E,g=I()){const b=R(),m=[];for(let v=1,p=E.getLineCount();v<=p;v++){const a=E.getLineContent(v),h=a.length;let i=0,u=0,o=0,r=1,s=!1,n=!1,c=!1,d=!1;for(;i<h;){let f=!1;const y=a.charCodeAt(i);if(r===13){let L;switch(y){case 40:s=!0,L=0;break;case 41:L=s?0:1;break;case 91:c=!0,n=!0,L=0;break;case 93:c=!1,L=n?0:1;break;case 123:d=!0,L=0;break;case 125:L=d?0:1;break;case 39:L=o===39?1:0;break;case 34:L=o===34?1:0;break;case 96:L=o===96?1:0;break;case 42:L=o===42?1:0;break;case 124:L=o===124?1:0;break;case 32:L=c?0:1;break;default:L=b.get(y)}L===1&&(m.push(k._createLink(b,a,v,u,i)),f=!0)}else if(r===12){let L;y===91?(n=!0,L=0):L=b.get(y),L===1?f=!0:r=13}else r=g.nextState(r,y),r===0&&(f=!0);f&&(r=1,s=!1,n=!1,d=!1,u=i+1,o=y),i++}r===13&&m.push(k._createLink(b,a,v,u,h))}return m}}e.LinkComputer=k;function S(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=S}),define(De[99],Ie([1,0,24]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(P=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var _;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(_=e.EndOfLinePreference||(e.EndOfLinePreference={}));var I;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(I=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var w;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(w=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class R{constructor(a,h){this._findMatchBrand=void 0,this.range=a,this.matches=h}}e.FindMatch=R;var k;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function S(p){return p&&typeof p.read=="function"}e.isITextSnapshot=S;var T;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(T=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class g{constructor(a,h,i,u,o,r){this.identifier=a,this.range=h,this.text=i,this.forceMoveMarkers=u,this.isAutoWhitespaceEdit=o,this._isTracked=r}}e.ValidAnnotatedEditOperation=g;class b{constructor(a,h,i){this.regex=a,this.wordSeparators=h,this.simpleSearch=i}}e.SearchData=b;class m{constructor(a,h,i){this.reverseEdits=a,this.changes=h,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=m;function v(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=v}),define(De[150],Ie([1,0,17,96]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(w){this.values=w,this.prefixSum=new Uint32Array(w.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(w,C){w=(0,t.toUint32)(w);const R=this.values,k=this.prefixSum,S=C.length;return S===0?!1:(this.values=new Uint32Array(R.length+S),this.values.set(R.subarray(0,w),0),this.values.set(R.subarray(w),w+S),this.values.set(C,w),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(w,C){return w=(0,t.toUint32)(w),C=(0,t.toUint32)(C),this.values[w]===C?!1:(this.values[w]=C,w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),!0)}removeValues(w,C){w=(0,t.toUint32)(w),C=(0,t.toUint32)(C);const R=this.values,k=this.prefixSum;if(w>=R.length)return!1;const S=R.length-w;return C>=S&&(C=S),C===0?!1:(this.values=new Uint32Array(R.length-C),this.values.set(R.subarray(0,w),0),this.values.set(R.subarray(w+C),w),this.prefixSum=new Uint32Array(this.values.length),w-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=w-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(w){return w<0?0:(w=(0,t.toUint32)(w),this._getPrefixSum(w))}_getPrefixSum(w){if(w<=this.prefixSumValidIndex[0])return this.prefixSum[w];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),w>=this.values.length&&(w=this.values.length-1);for(let R=C;R<=w;R++)this.prefixSum[R]=this.prefixSum[R-1]+this.values[R];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],w),this.prefixSum[w]}getIndexOf(w){w=Math.floor(w),this.getTotalSum();let C=0,R=this.values.length-1,k=0,S=0,T=0;for(;C<=R;)if(k=C+(R-C)/2|0,S=this.prefixSum[k],T=S-this.values[k],w<T)R=k-1;else if(w>=S)C=k+1;else break;return new _(k,w-T)}}e.PrefixSumComputer=D;class P{constructor(w){this._values=w,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(w){return this._ensureValid(),w===0?0:this._prefixSum[w-1]}getIndexOf(w){this._ensureValid();const C=this._indexBySum[w],R=C>0?this._prefixSum[C-1]:0;return new _(C,w-R)}removeValues(w,C){this._values.splice(w,C),this._invalidate(w)}insertValues(w,C){this._values=(0,l.arrayInsert)(this._values,w,C),this._invalidate(w)}_invalidate(w){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,w-1)}_ensureValid(){if(!this._isValid){for(let w=this._validEndIndex+1,C=this._values.length;w<C;w++){const R=this._values[w],k=w>0?this._prefixSum[w-1]:0;this._prefixSum[w]=k+R;for(let S=0;S<R;S++)this._indexBySum[k+S]=w}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(w,C){this._values[w]!==C&&(this._values[w]=C,this._invalidate(w))}}e.ConstantTimePrefixSumComputer=P;class _{constructor(w,C){this.index=w,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=w,this.remainder=C}}e.PrefixSumIndexOfResult=_}),define(De[151],Ie([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(De[152],Ie([1,0,151]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,P=D*24,_=P*7,I=P*30,w=P*365;function C(k,S,T){typeof k!="number"&&(k=k.getTime());const E=Math.round((new Date().getTime()-k)/1e3);if(E<-30)return(0,l.localize)(0,null,C(new Date().getTime()+E*1e3,!1));if(E<30)return(0,l.localize)(1,null);let g;return E<t?(g=E,S?g===1?T?(0,l.localize)(2,null,g):(0,l.localize)(3,null,g):T?(0,l.localize)(4,null,g):(0,l.localize)(5,null,g):g===1?T?(0,l.localize)(6,null,g):(0,l.localize)(7,null,g):T?(0,l.localize)(8,null,g):(0,l.localize)(9,null,g)):E<D?(g=Math.floor(E/t),S?g===1?T?(0,l.localize)(10,null,g):(0,l.localize)(11,null,g):T?(0,l.localize)(12,null,g):(0,l.localize)(13,null,g):g===1?T?(0,l.localize)(14,null,g):(0,l.localize)(15,null,g):T?(0,l.localize)(16,null,g):(0,l.localize)(17,null,g)):E<P?(g=Math.floor(E/D),S?g===1?T?(0,l.localize)(18,null,g):(0,l.localize)(19,null,g):T?(0,l.localize)(20,null,g):(0,l.localize)(21,null,g):g===1?T?(0,l.localize)(22,null,g):(0,l.localize)(23,null,g):T?(0,l.localize)(24,null,g):(0,l.localize)(25,null,g)):E<_?(g=Math.floor(E/P),S?g===1?(0,l.localize)(26,null,g):(0,l.localize)(27,null,g):g===1?(0,l.localize)(28,null,g):(0,l.localize)(29,null,g)):E<I?(g=Math.floor(E/_),S?g===1?T?(0,l.localize)(30,null,g):(0,l.localize)(31,null,g):T?(0,l.localize)(32,null,g):(0,l.localize)(33,null,g):g===1?T?(0,l.localize)(34,null,g):(0,l.localize)(35,null,g):T?(0,l.localize)(36,null,g):(0,l.localize)(37,null,g)):E<w?(g=Math.floor(E/I),S?g===1?T?(0,l.localize)(38,null,g):(0,l.localize)(39,null,g):T?(0,l.localize)(40,null,g):(0,l.localize)(41,null,g):g===1?T?(0,l.localize)(42,null,g):(0,l.localize)(43,null,g):T?(0,l.localize)(44,null,g):(0,l.localize)(45,null,g)):(g=Math.floor(E/w),S?g===1?T?(0,l.localize)(46,null,g):(0,l.localize)(47,null,g):T?(0,l.localize)(48,null,g):(0,l.localize)(49,null,g):g===1?T?(0,l.localize)(50,null,g):(0,l.localize)(51,null,g):T?(0,l.localize)(52,null,g):(0,l.localize)(53,null,g))}e.fromNow=C;function R(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[153],Ie([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(De[50],Ie([1,0,17,13,153]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function P(k,S){return S&&(k.stack||k.stacktrace)?D.localize(0,null,I(k),_(k.stack)||_(k.stacktrace)):I(k)}function _(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function w(k=null,S=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const T=l.coalesce(k),E=w(T[0],S);return T.length>1?D.localize(4,null,E,T.length):E}if(t.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return P(T.error,S);if(T.exception)return P(T.exception,S)}return k.stack?P(k,S):k.message?k.message:D.localize(5,null)}e.toErrorMessage=w;function C(k){const S=k;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=C;function R(k,S){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=S,T}e.createErrorWithActions=R}),define(De[154],Ie([19,20]),function(J,e){return J.create("vs/base/common/platform",e)}),define(De[11],Ie([1,0,154]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,P=!1,_=!1,I=!1,w=!1,C=!1,R=!1,k=!1,S=!1,T,E=t,g,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?m=e.globals.vscode.process:typeof process<"u"&&(m=process);const v=typeof m?.versions?.electron=="string",p=v&&m?.type==="renderer";if(typeof navigator=="object"&&!p)b=navigator.userAgent,D=b.indexOf("Windows")>=0,P=b.indexOf("Macintosh")>=0,k=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=b.indexOf("Linux")>=0,C=!0,T=l.getConfiguredDefaultLocale(l.localize(0,null))||t,E=T;else if(typeof m=="object"){D=m.platform==="win32",P=m.platform==="darwin",_=m.platform==="linux",I=_&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,R=v,S=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=t,E=t;const c=m.env.VSCODE_NLS_CONFIG;if(c)try{const d=JSON.parse(c),f=d.availableLanguages["*"];T=d.locale,E=f||t,g=d._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var a;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function h(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let i=0;P?i=1:D?i=3:_&&(i=2),e.isWindows=D,e.isMacintosh=P,e.isLinux=_,e.isLinuxSnap=I,e.isNative=w,e.isElectron=R,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=k,e.isCI=S,e.platform=i,e.userAgent=b,e.language=E;var u;(function(c){function d(){return e.language}c.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=f;function y(){return e.language==="en"}c.isDefault=y})(u=e.Language||(e.Language={})),e.locale=T,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let y=0,L=c.length;y<L;y++){const M=c[y];if(M.id===f.data.vscodeScheduleAsyncWork){c.splice(y,1),M.callback();return}}});let d=0;return f=>{const y=++d;c.push({id:y,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:y},"*")}}return c=>setTimeout(c)})();var o;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||k?2:D?1:3;let r=!0,s=!1;function n(){if(!s){s=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,r=new Uint16Array(c.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=n,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[40],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof l.globals.vscode<"u"&&typeof l.globals.vscode.process<"u"){const D=l.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return l.isWindows?"win32":l.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(De[9],Ie([1,0,40]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,P=90,_=122,I=46,w=47,C=92,R=58,k=63;class S extends Error{constructor(a,h,i){let u;typeof h=="string"&&h.indexOf("not ")===0?(u="must not be",h=h.replace(/^not /,"")):u="must be";const o=a.indexOf(".")!==-1?"property":"argument";let r=`The "${a}" ${o} ${u} of type ${h}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function T(p,a){if(typeof p!="string")throw new S(a,"string",p)}function E(p){return p===w||p===C}function g(p){return p===w}function b(p){return p>=t&&p<=P||p>=D&&p<=_}function m(p,a,h,i){let u="",o=0,r=-1,s=0,n=0;for(let c=0;c<=p.length;++c){if(c<p.length)n=p.charCodeAt(c);else{if(i(n))break;n=w}if(i(n)){if(!(r===c-1||s===1))if(s===2){if(u.length<2||o!==2||u.charCodeAt(u.length-1)!==I||u.charCodeAt(u.length-2)!==I){if(u.length>2){const d=u.lastIndexOf(h);d===-1?(u="",o=0):(u=u.slice(0,d),o=u.length-1-u.lastIndexOf(h)),r=c,s=0;continue}else if(u.length!==0){u="",o=0,r=c,s=0;continue}}a&&(u+=u.length>0?`${h}..`:"..",o=2)}else u.length>0?u+=`${h}${p.slice(r+1,c)}`:u=p.slice(r+1,c),o=c-r-1;r=c,s=0}else n===I&&s!==-1?++s:s=-1}return u}function v(p,a){if(a===null||typeof a!="object")throw new S("pathObject","Object",a);const h=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return h?h===a.root?`${h}${i}`:`${h}${p}${i}`:i}e.win32={resolve(...p){let a="",h="",i=!1;for(let u=p.length-1;u>=-1;u--){let o;if(u>=0){if(o=p[u],T(o,"path"),o.length===0)continue}else a.length===0?o=l.cwd():(o=l.env[`=${a}`]||l.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==a.toLowerCase()&&o.charCodeAt(2)===C)&&(o=`${a}\\`));const r=o.length;let s=0,n="",c=!1;const d=o.charCodeAt(0);if(r===1)E(d)&&(s=1,c=!0);else if(E(d))if(c=!0,E(o.charCodeAt(1))){let f=2,y=f;for(;f<r&&!E(o.charCodeAt(f));)f++;if(f<r&&f!==y){const L=o.slice(y,f);for(y=f;f<r&&E(o.charCodeAt(f));)f++;if(f<r&&f!==y){for(y=f;f<r&&!E(o.charCodeAt(f));)f++;(f===r||f!==y)&&(n=`\\\\${L}\\${o.slice(y,f)}`,s=f)}}}else s=1;else b(d)&&o.charCodeAt(1)===R&&(n=o.slice(0,2),s=2,r>2&&E(o.charCodeAt(2))&&(c=!0,s=3));if(n.length>0)if(a.length>0){if(n.toLowerCase()!==a.toLowerCase())continue}else a=n;if(i){if(a.length>0)break}else if(h=`${o.slice(s)}\\${h}`,i=c,c&&a.length>0)break}return h=m(h,!i,"\\",E),i?`${a}\\${h}`:`${a}${h}`||"."},normalize(p){T(p,"path");const a=p.length;if(a===0)return".";let h=0,i,u=!1;const o=p.charCodeAt(0);if(a===1)return g(o)?"\\":p;if(E(o))if(u=!0,E(p.charCodeAt(1))){let s=2,n=s;for(;s<a&&!E(p.charCodeAt(s));)s++;if(s<a&&s!==n){const c=p.slice(n,s);for(n=s;s<a&&E(p.charCodeAt(s));)s++;if(s<a&&s!==n){for(n=s;s<a&&!E(p.charCodeAt(s));)s++;if(s===a)return`\\\\${c}\\${p.slice(n)}\\`;s!==n&&(i=`\\\\${c}\\${p.slice(n,s)}`,h=s)}}}else h=1;else b(o)&&p.charCodeAt(1)===R&&(i=p.slice(0,2),h=2,a>2&&E(p.charCodeAt(2))&&(u=!0,h=3));let r=h<a?m(p.slice(h),!u,"\\",E):"";return r.length===0&&!u&&(r="."),r.length>0&&E(p.charCodeAt(a-1))&&(r+="\\"),i===void 0?u?`\\${r}`:r:u?`${i}\\${r}`:`${i}${r}`},isAbsolute(p){T(p,"path");const a=p.length;if(a===0)return!1;const h=p.charCodeAt(0);return E(h)||a>2&&b(h)&&p.charCodeAt(1)===R&&E(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let a,h;for(let o=0;o<p.length;++o){const r=p[o];T(r,"path"),r.length>0&&(a===void 0?a=h=r:a+=`\\${r}`)}if(a===void 0)return".";let i=!0,u=0;if(typeof h=="string"&&E(h.charCodeAt(0))){++u;const o=h.length;o>1&&E(h.charCodeAt(1))&&(++u,o>2&&(E(h.charCodeAt(2))?++u:i=!1))}if(i){for(;u<a.length&&E(a.charCodeAt(u));)u++;u>=2&&(a=`\\${a.slice(u)}`)}return e.win32.normalize(a)},relative(p,a){if(T(p,"from"),T(a,"to"),p===a)return"";const h=e.win32.resolve(p),i=e.win32.resolve(a);if(h===i||(p=h.toLowerCase(),a=i.toLowerCase(),p===a))return"";let u=0;for(;u<p.length&&p.charCodeAt(u)===C;)u++;let o=p.length;for(;o-1>u&&p.charCodeAt(o-1)===C;)o--;const r=o-u;let s=0;for(;s<a.length&&a.charCodeAt(s)===C;)s++;let n=a.length;for(;n-1>s&&a.charCodeAt(n-1)===C;)n--;const c=n-s,d=r<c?r:c;let f=-1,y=0;for(;y<d;y++){const M=p.charCodeAt(u+y);if(M!==a.charCodeAt(s+y))break;M===C&&(f=y)}if(y!==d){if(f===-1)return i}else{if(c>d){if(a.charCodeAt(s+y)===C)return i.slice(s+y+1);if(y===2)return i.slice(s+y)}r>d&&(p.charCodeAt(u+y)===C?f=y:y===2&&(f=3)),f===-1&&(f=0)}let L="";for(y=u+f+1;y<=o;++y)(y===o||p.charCodeAt(y)===C)&&(L+=L.length===0?"..":"\\..");return s+=f,L.length>0?`${L}${i.slice(s,n)}`:(i.charCodeAt(s)===C&&++s,i.slice(s,n))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const a=e.win32.resolve(p);if(a.length<=2)return p;if(a.charCodeAt(0)===C){if(a.charCodeAt(1)===C){const h=a.charCodeAt(2);if(h!==k&&h!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(b(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===C)return`\\\\?\\${a}`;return p},dirname(p){T(p,"path");const a=p.length;if(a===0)return".";let h=-1,i=0;const u=p.charCodeAt(0);if(a===1)return E(u)?p:".";if(E(u)){if(h=i=1,E(p.charCodeAt(1))){let s=2,n=s;for(;s<a&&!E(p.charCodeAt(s));)s++;if(s<a&&s!==n){for(n=s;s<a&&E(p.charCodeAt(s));)s++;if(s<a&&s!==n){for(n=s;s<a&&!E(p.charCodeAt(s));)s++;if(s===a)return p;s!==n&&(h=i=s+1)}}}}else b(u)&&p.charCodeAt(1)===R&&(h=a>2&&E(p.charCodeAt(2))?3:2,i=h);let o=-1,r=!0;for(let s=a-1;s>=i;--s)if(E(p.charCodeAt(s))){if(!r){o=s;break}}else r=!1;if(o===-1){if(h===-1)return".";o=h}return p.slice(0,o)},basename(p,a){a!==void 0&&T(a,"ext"),T(p,"path");let h=0,i=-1,u=!0,o;if(p.length>=2&&b(p.charCodeAt(0))&&p.charCodeAt(1)===R&&(h=2),a!==void 0&&a.length>0&&a.length<=p.length){if(a===p)return"";let r=a.length-1,s=-1;for(o=p.length-1;o>=h;--o){const n=p.charCodeAt(o);if(E(n)){if(!u){h=o+1;break}}else s===-1&&(u=!1,s=o+1),r>=0&&(n===a.charCodeAt(r)?--r===-1&&(i=o):(r=-1,i=s))}return h===i?i=s:i===-1&&(i=p.length),p.slice(h,i)}for(o=p.length-1;o>=h;--o)if(E(p.charCodeAt(o))){if(!u){h=o+1;break}}else i===-1&&(u=!1,i=o+1);return i===-1?"":p.slice(h,i)},extname(p){T(p,"path");let a=0,h=-1,i=0,u=-1,o=!0,r=0;p.length>=2&&p.charCodeAt(1)===R&&b(p.charCodeAt(0))&&(a=i=2);for(let s=p.length-1;s>=a;--s){const n=p.charCodeAt(s);if(E(n)){if(!o){i=s+1;break}continue}u===-1&&(o=!1,u=s+1),n===I?h===-1?h=s:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||u===-1||r===0||r===1&&h===u-1&&h===i+1?"":p.slice(h,u)},format:v.bind(null,"\\"),parse(p){T(p,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return a;const h=p.length;let i=0,u=p.charCodeAt(0);if(h===1)return E(u)?(a.root=a.dir=p,a):(a.base=a.name=p,a);if(E(u)){if(i=1,E(p.charCodeAt(1))){let f=2,y=f;for(;f<h&&!E(p.charCodeAt(f));)f++;if(f<h&&f!==y){for(y=f;f<h&&E(p.charCodeAt(f));)f++;if(f<h&&f!==y){for(y=f;f<h&&!E(p.charCodeAt(f));)f++;f===h?i=f:f!==y&&(i=f+1)}}}}else if(b(u)&&p.charCodeAt(1)===R){if(h<=2)return a.root=a.dir=p,a;if(i=2,E(p.charCodeAt(2))){if(h===3)return a.root=a.dir=p,a;i=3}}i>0&&(a.root=p.slice(0,i));let o=-1,r=i,s=-1,n=!0,c=p.length-1,d=0;for(;c>=i;--c){if(u=p.charCodeAt(c),E(u)){if(!n){r=c+1;break}continue}s===-1&&(n=!1,s=c+1),u===I?o===-1?o=c:d!==1&&(d=1):o!==-1&&(d=-1)}return s!==-1&&(o===-1||d===0||d===1&&o===s-1&&o===r+1?a.base=a.name=p.slice(r,s):(a.name=p.slice(r,o),a.base=p.slice(r,s),a.ext=p.slice(o,s))),r>0&&r!==i?a.dir=p.slice(0,r-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let a="",h=!1;for(let i=p.length-1;i>=-1&&!h;i--){const u=i>=0?p[i]:l.cwd();T(u,"path"),u.length!==0&&(a=`${u}/${a}`,h=u.charCodeAt(0)===w)}return a=m(a,!h,"/",g),h?`/${a}`:a.length>0?a:"."},normalize(p){if(T(p,"path"),p.length===0)return".";const a=p.charCodeAt(0)===w,h=p.charCodeAt(p.length-1)===w;return p=m(p,!a,"/",g),p.length===0?a?"/":h?"./":".":(h&&(p+="/"),a?`/${p}`:p)},isAbsolute(p){return T(p,"path"),p.length>0&&p.charCodeAt(0)===w},join(...p){if(p.length===0)return".";let a;for(let h=0;h<p.length;++h){const i=p[h];T(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.posix.normalize(a)},relative(p,a){if(T(p,"from"),T(a,"to"),p===a||(p=e.posix.resolve(p),a=e.posix.resolve(a),p===a))return"";const h=1,i=p.length,u=i-h,o=1,r=a.length-o,s=u<r?u:r;let n=-1,c=0;for(;c<s;c++){const f=p.charCodeAt(h+c);if(f!==a.charCodeAt(o+c))break;f===w&&(n=c)}if(c===s)if(r>s){if(a.charCodeAt(o+c)===w)return a.slice(o+c+1);if(c===0)return a.slice(o+c)}else u>s&&(p.charCodeAt(h+c)===w?n=c:c===0&&(n=0));let d="";for(c=h+n+1;c<=i;++c)(c===i||p.charCodeAt(c)===w)&&(d+=d.length===0?"..":"/..");return`${d}${a.slice(o+n)}`},toNamespacedPath(p){return p},dirname(p){if(T(p,"path"),p.length===0)return".";const a=p.charCodeAt(0)===w;let h=-1,i=!0;for(let u=p.length-1;u>=1;--u)if(p.charCodeAt(u)===w){if(!i){h=u;break}}else i=!1;return h===-1?a?"/":".":a&&h===1?"//":p.slice(0,h)},basename(p,a){a!==void 0&&T(a,"ext"),T(p,"path");let h=0,i=-1,u=!0,o;if(a!==void 0&&a.length>0&&a.length<=p.length){if(a===p)return"";let r=a.length-1,s=-1;for(o=p.length-1;o>=0;--o){const n=p.charCodeAt(o);if(n===w){if(!u){h=o+1;break}}else s===-1&&(u=!1,s=o+1),r>=0&&(n===a.charCodeAt(r)?--r===-1&&(i=o):(r=-1,i=s))}return h===i?i=s:i===-1&&(i=p.length),p.slice(h,i)}for(o=p.length-1;o>=0;--o)if(p.charCodeAt(o)===w){if(!u){h=o+1;break}}else i===-1&&(u=!1,i=o+1);return i===-1?"":p.slice(h,i)},extname(p){T(p,"path");let a=-1,h=0,i=-1,u=!0,o=0;for(let r=p.length-1;r>=0;--r){const s=p.charCodeAt(r);if(s===w){if(!u){h=r+1;break}continue}i===-1&&(u=!1,i=r+1),s===I?a===-1?a=r:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||i===-1||o===0||o===1&&a===i-1&&a===h+1?"":p.slice(a,i)},format:v.bind(null,"/"),parse(p){T(p,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return a;const h=p.charCodeAt(0)===w;let i;h?(a.root="/",i=1):i=0;let u=-1,o=0,r=-1,s=!0,n=p.length-1,c=0;for(;n>=i;--n){const d=p.charCodeAt(n);if(d===w){if(!s){o=n+1;break}continue}r===-1&&(s=!1,r=n+1),d===I?u===-1?u=n:c!==1&&(c=1):u!==-1&&(c=-1)}if(r!==-1){const d=o===0&&h?1:o;u===-1||c===0||c===1&&u===r-1&&u===o+1?a.base=a.name=p.slice(d,r):(a.name=p.slice(d,u),a.base=p.slice(d,r),a.ext=p.slice(u,r))}return o>0?a.dir=p.slice(0,o-1):h&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=l.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=l.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=l.platform==="win32"?e.win32.join:e.posix.join,e.resolve=l.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=l.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=l.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=l.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=l.platform==="win32"?e.win32.extname:e.posix.extname,e.format=l.platform==="win32"?e.win32.format:e.posix.format,e.parse=l.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=l.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=l.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=l.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(De[100],Ie([1,0,9]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(R){const k=(0,l.extname)(R),S=t[k.toLowerCase()];return S!==void 0?S:_(R)}e.getMediaOrTextMime=P;function _(R){const k=(0,l.extname)(R);return D[k.toLowerCase()]}e.getMediaMime=_;function I(R){for(const k in D)if(D[k]===R)return k}e.getExtensionForMimeType=I;const w=/^(.+)\/(.+?)(;.+)?$/;function C(R,k){const S=w.exec(R);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:k?void 0:R}e.normalizeMimeType=C}),define(De[101],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(I,...w){const C=w.reduce((S,T)=>(S[T]=!0,S),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(S=>!C[S]).forEach(S=>{for(let T=0;T<R.length;T++)if(S.search(R[T])!==-1){delete I[S];break}})}e.sanitizeProcessEnvironment=P;function _(I){!I||(delete I.DEBUG,l.isMacintosh&&delete I.DYLD_LIBRARY_PATH,l.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=_}),define(De[51],Ie([1,0,11]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=l.globals.performance&&typeof l.globals.performance.now=="function";class D{constructor(_){this._highResolution=t&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new D(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?l.globals.performance.now():Date.now()}}e.StopWatch=D}),define(De[4],Ie([1,0,10,59,6,78,51]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const I=!1,w=!1;var C;(function(n){n.None=()=>D.Disposable.None;function c(pe){if(w){const{onListenerDidAdd:be}=pe,Te=E.create();let Le=0;pe.onListenerDidAdd=()=>{++Le===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),be?.()}}}function d(pe){return(be,Te=null,Le)=>{let We=!1,oe;return oe=pe(le=>{if(!We)return oe?oe.dispose():We=!0,be.call(Te,le)},null,Le),We&&oe.dispose(),oe}}n.once=d;function f(pe,be,Te){return W((Le,We=null,oe)=>pe(le=>Le.call(We,be(le)),null,oe),Te)}n.map=f;function y(pe,be,Te){return W((Le,We=null,oe)=>pe(le=>{be(le),Le.call(We,le)},null,oe),Te)}n.forEach=y;function L(pe,be,Te){return W((Le,We=null,oe)=>pe(le=>be(le)&&Le.call(We,le),null,oe),Te)}n.filter=L;function M(pe){return pe}n.signal=M;function B(...pe){return(be,Te=null,Le)=>(0,D.combinedDisposable)(...pe.map(We=>We(oe=>be.call(Te,oe),null,Le)))}n.any=B;function A(pe,be,Te,Le){let We=Te;return f(pe,oe=>(We=be(We,oe),We),Le)}n.reduce=A;function W(pe,be){let Te;const Le={onFirstListenerAdd(){Te=pe(We.fire,We)},onLastListenerRemove(){Te?.dispose()}};be||c(Le);const We=new b(Le);return be?.add(We),We.event}function U(pe,be,Te=100,Le=!1,We,oe){let le,me,Z,ae=0;const ee={leakWarningThreshold:We,onFirstListenerAdd(){le=pe(F=>{ae++,me=be(me,F),Le&&!Z&&(ie.fire(me),me=void 0),clearTimeout(Z),Z=setTimeout(()=>{const H=me;me=void 0,Z=void 0,(!Le||ae>1)&&ie.fire(H),ae=0},Te)})},onLastListenerRemove(){le.dispose()}};oe||c(ee);const ie=new b(ee);return oe?.add(ie),ie.event}n.debounce=U;function N(pe,be=(Le,We)=>Le===We,Te){let Le=!0,We;return L(pe,oe=>{const le=Le||!be(oe,We);return Le=!1,We=oe,le},Te)}n.latch=N;function G(pe,be,Te){return[n.filter(pe,be,Te),n.filter(pe,Le=>!be(Le),Te)]}n.split=G;function z(pe,be=!1,Te=[]){let Le=Te.slice(),We=pe(me=>{Le?Le.push(me):le.fire(me)});const oe=()=>{Le?.forEach(me=>le.fire(me)),Le=null},le=new b({onFirstListenerAdd(){We||(We=pe(me=>le.fire(me)))},onFirstListenerDidAdd(){Le&&(be?setTimeout(oe):oe())},onLastListenerRemove(){We&&We.dispose(),We=null}});return le.event}n.buffer=z;class O{constructor(be){this.event=be,this.disposables=new D.DisposableStore}map(be){return new O(f(this.event,be,this.disposables))}forEach(be){return new O(y(this.event,be,this.disposables))}filter(be){return new O(L(this.event,be,this.disposables))}reduce(be,Te){return new O(A(this.event,be,Te,this.disposables))}latch(){return new O(N(this.event,void 0,this.disposables))}debounce(be,Te=100,Le=!1,We){return new O(U(this.event,be,Te,Le,We,this.disposables))}on(be,Te,Le){return this.event(be,Te,Le)}once(be,Te,Le){return d(this.event)(be,Te,Le)}dispose(){this.disposables.dispose()}}function x(pe){return new O(pe)}n.chain=x;function V(pe,be,Te=Le=>Le){const Le=(...me)=>le.fire(Te(...me)),We=()=>pe.on(be,Le),oe=()=>pe.removeListener(be,Le),le=new b({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}n.fromNodeEventEmitter=V;function q(pe,be,Te=Le=>Le){const Le=(...me)=>le.fire(Te(...me)),We=()=>pe.addEventListener(be,Le),oe=()=>pe.removeEventListener(be,Le),le=new b({onFirstListenerAdd:We,onLastListenerRemove:oe});return le.event}n.fromDOMEventEmitter=q;function Y(pe){return new Promise(be=>d(pe)(be))}n.toPromise=Y;function Q(pe,be){return be(void 0),pe(Te=>be(Te))}n.runAndSubscribe=Q;function he(pe,be){let Te=null;function Le(oe){Te?.dispose(),Te=new D.DisposableStore,be(oe,Te)}Le(void 0);const We=pe(oe=>Le(oe));return(0,D.toDisposable)(()=>{We.dispose(),Te?.dispose()})}n.runAndSubscribeWithStore=he;class ve{constructor(be,Te){this.obs=be,this._counter=0,this._hasChanged=!1;const Le={onFirstListenerAdd:()=>{be.addObserver(this)},onLastListenerRemove:()=>{be.removeObserver(this)}};Te||c(Le),this.emitter=new b(Le),Te&&Te.add(this.emitter)}beginUpdate(be){this._counter++}handleChange(be,Te){this._hasChanged=!0}endUpdate(be){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function ne(pe,be){return new ve(pe,be).emitter.event}n.fromObservable=ne})(C=e.Event||(e.Event={}));class R{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${R._idPool++}`}start(c){this._stopWatch=new _.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}R._idPool=0;let k=-1;function S(n){const c=k;return k=n,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=S;class T{constructor(c,d=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,d){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),f<=0||d<f)return;this._stacks||(this._stacks=new Map);const y=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let L,M=0;for(const[B,A]of this._stacks)(!L||M<A)&&(L=B,M=A);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${M}):`),console.warn(L)}return()=>{const L=this._stacks.get(c.value)||0;this._stacks.set(c.value,L-1)}}}class E{constructor(c){this.value=c}static create(){return new E(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g{constructor(c,d,f){this.callback=c,this.callbackThis=d,this.stack=f,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class b{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=k>0?new T(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new R(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const d of c)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,d,f)=>{this._listeners||(this._listeners=new P.LinkedList);const y=this._listeners.isEmpty();y&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let L,M;this._leakageMon&&this._listeners.size>=30&&(M=E.create(),L=this._leakageMon.check(M,this._listeners.size+1)),I&&(M=M??E.create());const B=new g(c,d,M),A=this._listeners.push(B);y&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,d);const W=B.subscription.set(()=>{L?.(),this._disposed||(A(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return f instanceof D.DisposableStore?f.add(W):Array.isArray(f)&&f.push(W),W}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new v);for(const d of this._listeners)this._deliveryQueue.push(this,d,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=b;class m{constructor(){this._queue=new P.LinkedList}get size(){return this._queue.size}push(c,d,f){this._queue.push(new p(c,d,f))}clear(c){const d=new P.LinkedList;for(const f of this._queue)f.emitter!==c&&d.push(f);this._queue=d}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(d){(0,l.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=m;class v extends m{clear(c){this._queue.clear()}}class p{constructor(c,d,f){this.emitter=c,this.listener=d,this.event=f}}class a extends b{async fireAsync(c,d,f){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new P.LinkedList);for(const y of this._listeners)this._asyncDeliveryQueue.push([y,c]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[y,L]=this._asyncDeliveryQueue.shift(),M=[],B={...L,token:d,waitUntil:A=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");f&&(A=f(A,y.callback)),M.push(A)}};try{y.invoke(B)}catch(A){(0,l.onUnexpectedError)(A);continue}Object.freeze(M),await Promise.allSettled(M).then(A=>{for(const W of A)W.status==="rejected"&&(0,l.onUnexpectedError)(W.reason)})}}}}e.AsyncEmitter=a;class h extends b{constructor(c){super(c),this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=h;class i extends h{constructor(c){super(c),this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=i;class u extends b{constructor(c){super(c),this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){!this.hasListeners()||(this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=u;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new b({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const d={event:c,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const f=()=>{this.hasListeners&&this.unhook(d);const y=this.events.indexOf(d);this.events.splice(y,1)};return(0,D.toDisposable)((0,t.once)(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(d=>this.emitter.fire(d))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class r{constructor(){this.buffers=[]}wrapEvent(c){return(d,f,y)=>c(L=>{const M=this.buffers[this.buffers.length-1];M?M.push(()=>d.call(f,L)):d.call(f,L)},void 0,y)}bufferEvents(c){const d=[];this.buffers.push(d);const f=c();return this.buffers.pop(),d.forEach(y=>y()),f}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=D.Disposable.None,this.emitter=new b({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(De[21],Ie([1,0,4]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,w){const C=setTimeout(I.bind(w),0);return{dispose(){clearTimeout(C)}}});var D;(function(I){function w(C){return C===I.None||C===I.Cancelled||C instanceof P?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new l.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=_}),define(De[155],Ie([1,0,21]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new l.CancellationTokenSource,w=this.task(I.token);return this.result={promise:w,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=t;class D{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const w=JSON.stringify(I);return this.lastArgKey!==w&&(this.lastArgKey=w,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=D;class P{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const w=this.fn(I);return this._map.set(I,w),w}}e.CachedFunction=P}),define(De[8],Ie([1,0,155,77]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function P(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=P;const _=/{(\d+)}/g;function I(ue,...ke){return ke.length===0?ue:ue.replace(_,function(Ne,Be){const ze=parseInt(Be,10);return isNaN(ze)||ze<0||ze>=ke.length?Ne:ke[ze]})}e.format=I;const w=/{([^}]+)}/g;function C(ue,ke){return ue.replace(w,(Ne,Be)=>ke[Be]??Ne)}e.format2=C;function R(ue){return ue.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.escape=R;function k(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function S(ue,ke){let Ne=0;const Be=ke.charCodeAt(0);for(let ze=ue.length-1;ze>=0;ze--)ue.charCodeAt(ze)===Be&&Ne++;return Ne}e.count=S;function T(ue,ke,Ne="\u2026"){return ue.length<=ke?ue:`${ue.substr(0,ke)}${Ne}`}e.truncate=T;function E(ue,ke=" "){const Ne=g(ue,ke);return b(Ne,ke)}e.trim=E;function g(ue,ke){if(!ue||!ke)return ue;const Ne=ke.length;if(Ne===0||ue.length===0)return ue;let Be=0;for(;ue.indexOf(ke,Be)===Be;)Be=Be+Ne;return ue.substring(Be)}e.ltrim=g;function b(ue,ke){if(!ue||!ke)return ue;const Ne=ke.length,Be=ue.length;if(Ne===0||Be===0)return ue;let ze=Be,Qe=-1;for(;Qe=ue.lastIndexOf(ke,ze-1),!(Qe===-1||Qe+Ne!==ze);){if(Qe===0)return"";ze=Qe}return ue.substring(0,ze)}e.rtrim=b;function m(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function p(ue,ke,Ne={}){if(!ue)throw new Error("Cannot create regex from empty string");ke||(ue=k(ue)),Ne.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Be="";return Ne.global&&(Be+="g"),Ne.matchCase||(Be+="i"),Ne.multiline&&(Be+="m"),Ne.unicode&&(Be+="u"),new RegExp(ue,Be)}e.createRegExp=p;function a(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function h(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function i(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=i;function u(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=u;function o(ue){for(let ke=0,Ne=ue.length;ke<Ne;ke++){const Be=ue.charCodeAt(ke);if(Be!==32&&Be!==9)return ke}return-1}e.firstNonWhitespaceIndex=o;function r(ue,ke=0,Ne=ue.length){for(let Be=ke;Be<Ne;Be++){const ze=ue.charCodeAt(Be);if(ze!==32&&ze!==9)return ue.substring(ke,Be)}return ue.substring(ke,Ne)}e.getLeadingWhitespace=r;function s(ue,ke=ue.length-1){for(let Ne=ke;Ne>=0;Ne--){const Be=ue.charCodeAt(Ne);if(Be!==32&&Be!==9)return Ne}return-1}e.lastNonWhitespaceIndex=s;function n(ue,ke,Ne){const Be=[];let ze=0;for(const Qe of ue.matchAll(ke)){if(Be.push(ue.slice(ze,Qe.index)),Qe.index===void 0)throw new Error("match.index should be defined");ze=Qe.index+Qe[0].length,Be.push(Ne(Qe[0],...Qe.slice(1),Qe.index,ue,Qe.groups))}return Be.push(ue.slice(ze)),Promise.all(Be).then(Qe=>Qe.join(""))}e.replaceAsync=n;function c(ue,ke){return ue<ke?-1:ue>ke?1:0}e.compare=c;function d(ue,ke,Ne=0,Be=ue.length,ze=0,Qe=ke.length){for(;Ne<Be&&ze<Qe;Ne++,ze++){const st=ue.charCodeAt(Ne),et=ke.charCodeAt(ze);if(st<et)return-1;if(st>et)return 1}const nt=Be-Ne,ct=Qe-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstring=d;function f(ue,ke){return y(ue,ke,0,ue.length,0,ke.length)}e.compareIgnoreCase=f;function y(ue,ke,Ne=0,Be=ue.length,ze=0,Qe=ke.length){for(;Ne<Be&&ze<Qe;Ne++,ze++){let st=ue.charCodeAt(Ne),et=ke.charCodeAt(ze);if(st===et)continue;if(st>=128||et>=128)return d(ue.toLowerCase(),ke.toLowerCase(),Ne,Be,ze,Qe);M(st)&&(st-=32),M(et)&&(et-=32);const mt=st-et;if(mt!==0)return mt}const nt=Be-Ne,ct=Qe-ze;return nt<ct?-1:nt>ct?1:0}e.compareSubstringIgnoreCase=y;function L(ue){return ue>=48&&ue<=57}e.isAsciiDigit=L;function M(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=M;function B(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=B;function A(ue,ke){return ue.length===ke.length&&y(ue,ke)===0}e.equalsIgnoreCase=A;function W(ue,ke){const Ne=ke.length;return ke.length>ue.length?!1:y(ue,ke,0,Ne)===0}e.startsWithIgnoreCase=W;function U(ue,ke){const Ne=Math.min(ue.length,ke.length);let Be;for(Be=0;Be<Ne;Be++)if(ue.charCodeAt(Be)!==ke.charCodeAt(Be))return Be;return Ne}e.commonPrefixLength=U;function N(ue,ke){const Ne=Math.min(ue.length,ke.length);let Be;const ze=ue.length-1,Qe=ke.length-1;for(Be=0;Be<Ne;Be++)if(ue.charCodeAt(ze-Be)!==ke.charCodeAt(Qe-Be))return Be;return Ne}e.commonSuffixLength=N;function G(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=G;function z(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=z;function O(ue,ke){return(ue-55296<<10)+(ke-56320)+65536}e.computeCodePoint=O;function x(ue,ke,Ne){const Be=ue.charCodeAt(Ne);if(G(Be)&&Ne+1<ke){const ze=ue.charCodeAt(Ne+1);if(z(ze))return O(Be,ze)}return Be}e.getNextCodePoint=x;function V(ue,ke){const Ne=ue.charCodeAt(ke-1);if(z(Ne)&&ke>1){const Be=ue.charCodeAt(ke-2);if(G(Be))return O(Be,Ne)}return Ne}class q{constructor(ke,Ne=0){this._str=ke,this._len=ke.length,this._offset=Ne}get offset(){return this._offset}setOffset(ke){this._offset=ke}prevCodePoint(){const ke=V(this._str,this._offset);return this._offset-=ke>=65536?2:1,ke}nextCodePoint(){const ke=x(this._str,this._len,this._offset);return this._offset+=ke>=65536?2:1,ke}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class Y{constructor(ke,Ne=0){this._iterator=new q(ke,Ne)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ke=Ve.getInstance(),Ne=this._iterator,Be=Ne.offset;let ze=ke.getGraphemeBreakType(Ne.nextCodePoint());for(;!Ne.eol();){const Qe=Ne.offset,nt=ke.getGraphemeBreakType(Ne.nextCodePoint());if(ye(ze,nt)){Ne.setOffset(Qe);break}ze=nt}return Ne.offset-Be}prevGraphemeLength(){const ke=Ve.getInstance(),Ne=this._iterator,Be=Ne.offset;let ze=ke.getGraphemeBreakType(Ne.prevCodePoint());for(;Ne.offset>0;){const Qe=Ne.offset,nt=ke.getGraphemeBreakType(Ne.prevCodePoint());if(ye(nt,ze)){Ne.setOffset(Qe);break}ze=nt}return Be-Ne.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Y;function Q(ue,ke){return new Y(ue,ke).nextGraphemeLength()}e.nextCharLength=Q;function he(ue,ke){return new Y(ue,ke).prevGraphemeLength()}e.prevCharLength=he;function ve(ue,ke){ke>0&&z(ue.charCodeAt(ke))&&ke--;const Ne=ke+Q(ue,ke);return[Ne-he(ue,Ne),Ne]}e.getCharContainingOffset=ve;let ne;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function be(ue){return ne||(ne=pe()),ne.test(ue)}e.containsRTL=be;const Te=/^[\t\n\r\x20-\x7E]*$/;function Le(ue){return Te.test(ue)}e.isBasicASCII=Le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=We;function oe(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=oe;function le(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=le;function me(ue,ke){if(ue.length<ke)return ue;const Ne=/\b/g;let Be=0;for(;Ne.test(ue)&&!(ue.length-Ne.lastIndex<ke);)Be=Ne.lastIndex,Ne.lastIndex+=1;return ue.substring(Be).replace(/^\s/,"")}e.lcut=me;const Z=/\x1B\x5B[12]?K/g,ae=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(ue){return ue&&(ue=ue.replace(Z,""),ue=ue.replace(ae,""),ue=ue.replace(ee,"")),ue}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function H(ue){return F(ue)?ue.substr(1):ue}e.stripUTF8BOM=H;function K(ue,ke){if(!ue||!ke||ue.length<ke.length)return!1;const Ne=ke.length,Be=ue.toLowerCase();let ze=0,Qe=-1;for(;ze<Ne;){const nt=Be.indexOf(ke[ze],Qe+1);if(nt<0)return!1;Qe=nt,ze++}return!0}e.fuzzyContains=K;function X(ue,ke=!1){return ue?(ke&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=X;function de(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=de;function we(ue,ke=1){if(ke===0)return"";let Ne=-1;do Ne=ue.indexOf(`
`,Ne+1),ke--;while(ke>0&&Ne>=0);return Ne===-1?ue:(ue[Ne-1]==="\r"&&Ne--,ue.substr(0,Ne))}e.getNLines=we;function ce(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=ce;function Ce(ue){return Ve.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=Ce;function ye(ue,ke){return ue===0?ke!==5&&ke!==7:ue===2&&ke===3?!1:ue===4||ue===2||ue===3||ke===4||ke===2||ke===3?!0:!(ue===8&&(ke===8||ke===9||ke===11||ke===12)||(ue===11||ue===9)&&(ke===9||ke===10)||(ue===12||ue===10)&&ke===10||ke===5||ke===13||ke===7||ue===1||ue===13&&ke===14||ue===6&&ke===6)}var $e;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Ze()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Ne=this._data,Be=Ne.length/3;let ze=1;for(;ze<=Be;)if(ke<Ne[3*ze])ze=2*ze;else if(ke>Ne[3*ze+1])ze=2*ze+1;else return Ne[3*ze+2];return 0}}Ve._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(ue,ke){if(ue===0)return 0;const Ne=Oe(ue,ke);if(Ne!==void 0)return Ne;const Be=new q(ke,ue);return Be.prevCodePoint(),Be.offset}e.getLeftDeleteOffset=Ye;function Oe(ue,ke){const Ne=new q(ke,ue);let Be=Ne.prevCodePoint();for(;ot(Be)||Be===65039||Be===8419;){if(Ne.offset===0)return;Be=Ne.prevCodePoint()}if(!le(Be))return;let ze=Ne.offset;return ze>0&&Ne.prevCodePoint()===8205&&(ze=Ne.offset),ze}function ot(ue){return 127995<=ue&&ue<=127999}var re;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(re||(re={})),e.noBreakWhitespace="\xA0";class se{constructor(ke){this.confusableDictionary=ke}static getInstance(ke){return se.cache.get(Array.from(ke))}static getLocales(){return se._locales.getValue()}isAmbiguous(ke){return this.confusableDictionary.has(ke)}getPrimaryConfusable(ke){return this.confusableDictionary.get(ke)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=se,D=se,se.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),se.cache=new l.LRUCachedFunction(ue=>{function ke(et){const mt=new Map;for(let wt=0;wt<et.length;wt+=2)mt.set(et[wt],et[wt+1]);return mt}function Ne(et,mt){const wt=new Map(et);for(const[Ct,ft]of mt)wt.set(Ct,ft);return wt}function Be(et,mt){if(!et)return mt;const wt=new Map;for(const[Ct,ft]of et)mt.has(Ct)&&wt.set(Ct,ft);return wt}const ze=D.ambiguousCharacterData.getValue();let Qe=ue.filter(et=>!et.startsWith("_")&&et in ze);Qe.length===0&&(Qe=["_default"]);let nt;for(const et of Qe){const mt=ke(ze[et]);nt=Be(nt,mt)}const ct=ke(ze._common),st=Ne(ct,nt);return new se(st)}),se._locales=new t.Lazy(()=>Object.keys(se.ambiguousCharacterData.getValue()).filter(ue=>!ue.startsWith("_")));class Ee{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ee.getRawData())),this._data}static isInvisibleCharacter(ke){return Ee.getData().has(ke)}static get codePoints(){return Ee.getData()}}e.InvisibleCharacters=Ee,Ee._data=void 0}),define(De[31],Ie([1,0,9,11,8,13]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function I(s){return s.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=I;function w(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function C(s,n=l.posix.sep){if(!s)return"";const c=s.length,d=s.charCodeAt(0);if(_(d)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let y=3;const L=y;for(;y<c&&!_(s.charCodeAt(y));y++);if(L!==y&&!_(s.charCodeAt(y+1))){for(y+=1;y<c;y++)if(_(s.charCodeAt(y)))return s.slice(0,y+1).replace(/[\\/]/g,n)}}return n}else if(m(d)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let f=s.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(_(s.charCodeAt(f)))return s.slice(0,f+1)}return""}e.getRoot=C;function R(s){if(!t.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let c=2;const d=c;for(;c<s.length&&(n=s.charCodeAt(c),n!==92);c++);return!(d===c||(n=s.charCodeAt(c+1),isNaN(n)||n===92))}e.isUNC=R;const k=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(s,n=t.isWindows){const c=n?k:S;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||n&&T.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=E;function g(s,n,c){const d=s===n;return!c||d?d:!s||!n?!1:(0,D.equalsIgnoreCase)(s,n)}e.isEqual=g;function b(s,n,c,d=l.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let y=n.length;return n.charAt(n.length-1)===d&&y--,s.charAt(y)===d}return n.charAt(n.length-1)!==d&&(n+=d),s.indexOf(n)===0}e.isEqualOrParent=b;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function v(s,n){return t.isWindows&&s.endsWith(":")&&(s+=l.sep),(0,l.isAbsolute)(s)||(s=(0,l.join)(n,s)),s=(0,l.normalize)(s),t.isWindows?(s=(0,D.rtrim)(s,l.sep),s.endsWith(":")&&(s+=l.sep)):(s=(0,D.rtrim)(s,l.sep),s||(s=l.sep)),s}e.sanitizeFilePath=v;function p(s){const n=(0,l.normalize)(s);return t.isWindows?s.length>3?!1:a(n)&&(s.length===2||n.charCodeAt(2)===92):n===l.posix.sep}e.isRootOrDriveLetter=p;function a(s,n=t.isWindows){return n?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function h(s){return a(s)?s[0]:void 0}e.getDriveLetter=h;function i(s,n,c){return n.length>s.length?-1:s===n?0:(c&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=i;function u(s){const n=s.split(":");let c,d,f;for(const y of n){const L=Number(y);(0,P.isNumber)(L)?d===void 0?d=L:f===void 0&&(f=L):c=c?[c,y].join(":"):y}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:f!==void 0?f:d!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,n,c=8){let d="";for(let y=0;y<c;y++)d+=o.charAt(Math.floor(Math.random()*o.length));let f;return n?f=`${n}-${d}`:f=d,s?(0,l.join)(s,f):f}e.randomPath=r}),define(De[61],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(m){return D(m,0)}e.hash=t;function D(m,v){switch(typeof m){case"object":return m===null?P(349,v):Array.isArray(m)?w(m,v):C(m,v);case"string":return I(m,v);case"boolean":return _(m,v);case"number":return P(m,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=D;function P(m,v){return(v<<5)-v+m|0}e.numberHash=P;function _(m,v){return P(m?433:863,v)}function I(m,v){v=P(149417,v);for(let p=0,a=m.length;p<a;p++)v=P(m.charCodeAt(p),v);return v}e.stringHash=I;function w(m,v){return v=P(104579,v),m.reduce((p,a)=>D(a,p),v)}function C(m,v){return v=P(181387,v),Object.keys(m).sort().reduce((p,a)=>(p=I(a,p),D(m[a],p)),v)}class R{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=D(v,this._value),this._value}}e.Hasher=R;var k;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function S(m,v,p=32){const a=p-v,h=~((1<<a)-1);return(m<<v|(h&m)>>>a)>>>0}function T(m,v=0,p=m.byteLength,a=0){for(let h=0;h<p;h++)m[v+h]=a}function E(m,v,p="0"){for(;m.length<v;)m=p+m;return m}function g(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(p=>p.toString(16).padStart(2,"0")).join(""):E((m>>>0).toString(16),v/4)}e.toHexString=g;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const p=v.length;if(p===0)return;const a=this._buff;let h=this._buffLen,i=this._leftoverHighSurrogate,u,o;for(i!==0?(u=i,o=-1,i=0):(u=v.charCodeAt(0),o=0);;){let r=u;if(l.isHighSurrogate(u))if(o+1<p){const s=v.charCodeAt(o+1);l.isLowSurrogate(s)?(o++,r=l.computeCodePoint(u,s)):r=65533}else{i=u;break}else l.isLowSurrogate(u)&&(r=65533);if(h=this._push(a,h,r),o++,o<p)u=v.charCodeAt(o);else break}this._buffLen=h,this._leftoverHighSurrogate=i}_push(v,p,a){return a<128?v[p++]=a:a<2048?(v[p++]=192|(a&1984)>>>6,v[p++]=128|(a&63)>>>0):a<65536?(v[p++]=224|(a&61440)>>>12,v[p++]=128|(a&4032)>>>6,v[p++]=128|(a&63)>>>0):(v[p++]=240|(a&1835008)>>>18,v[p++]=128|(a&258048)>>>12,v[p++]=128|(a&4032)>>>6,v[p++]=128|(a&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,T(this._buff,this._buffLen),this._buffLen>56&&(this._step(),T(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=b._bigBlock32,p=this._buffDV;for(let c=0;c<64;c+=4)v.setUint32(c,p.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)v.setUint32(c,S(v.getUint32(c-12,!1)^v.getUint32(c-32,!1)^v.getUint32(c-56,!1)^v.getUint32(c-64,!1),1),!1);let a=this._h0,h=this._h1,i=this._h2,u=this._h3,o=this._h4,r,s,n;for(let c=0;c<80;c++)c<20?(r=h&i|~h&u,s=1518500249):c<40?(r=h^i^u,s=1859775393):c<60?(r=h&i|h&u|i&u,s=2400959708):(r=h^i^u,s=3395469782),n=S(a,5)+r+o+s+v.getUint32(c*4,!1)&4294967295,o=u,u=i,i=S(h,30),h=a,a=n;this._h0=this._h0+a&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(De[25],Ie([1,0,17,8]),function(J,e,l,t){"use strict";var D,P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(o,r,s){let n=o.get(r);return n===void 0&&(n=s,o.set(r,n)),n}e.getOrSet=I;function w(o){const r=[];return o.forEach((s,n)=>{r.push(`${n} => ${s}`)}),`Map(${o.size}) {${r.join(", ")}}`}e.mapToString=w;function C(o){const r=[];return o.forEach(s=>{r.push(s)}),`Set(${o.size}) {${r.join(", ")}}`}e.setToString=C;class R{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=R;class k{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class S{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const n=this._value.charCodeAt(s);if(!(n===47||this._splitOnBackslash&&n===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,t.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var T;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(T||(T={}));class E{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,t.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=E;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(b||(b={}));class m{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new m(new E(r,s))}static forPaths(r=!1){return new m(new S(void 0,!r))}static forStrings(){return new m(new R)}static forConfigKeys(){return new m(new k)}clear(){this._root=void 0}fill(r,s){if(s){const n=s.slice(0);(0,l.shuffle)(n);for(const c of n)this.set(c,r)}else{const n=r.slice(0);(0,l.shuffle)(n);for(const c of n)this.set(c[0],c[1])}}set(r,s){const n=this._iter.reset(r);let c;this._root||(this._root=new g,this._root.segment=n.value());const d=[];for(c=this._root;;){const y=n.cmp(c.segment);if(y>0)c.left||(c.left=new g,c.left.segment=n.value()),d.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new g,c.right.segment=n.value()),d.push([1,c]),c=c.right;else if(n.hasNext())n.next(),c.mid||(c.mid=new g,c.mid.segment=n.value()),d.push([0,c]),c=c.mid;else break}const f=c.value;c.value=s,c.key=r;for(let y=d.length-1;y>=0;y--){const L=d[y][1];L.updateHeight();const M=L.balanceFactor();if(M<-1||M>1){const B=d[y][0],A=d[y+1][0];if(B===1&&A===1)d[y][1]=L.rotateLeft();else if(B===-1&&A===-1)d[y][1]=L.rotateRight();else if(B===1&&A===-1)L.right=d[y+1][1]=d[y+1][1].rotateRight(),d[y][1]=L.rotateLeft();else if(B===-1&&A===1)L.left=d[y+1][1]=d[y+1][1].rotateLeft(),d[y][1]=L.rotateRight();else throw new Error;if(y>0)switch(d[y-1][0]){case-1:d[y-1][1].left=d[y][1];break;case 1:d[y-1][1].right=d[y][1];break;case 0:d[y-1][1].mid=d[y][1];break}else this._root=d[0][1]}}return f}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const c=s.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const n=this._iter.reset(r),c=[];let d=this._root;for(;d;){const f=n.cmp(d.segment);if(f>0)c.push([-1,d]),d=d.left;else if(f<0)c.push([1,d]),d=d.right;else if(n.hasNext())n.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(s?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this._min(d.right),{key:y,value:L,segment:M}=f;this._delete(f.key,!1),d.key=y,d.value=L,d.segment=M}else{const f=d.left??d.right;if(c.length>0){const[y,L]=c[c.length-1];switch(y){case-1:L.left=f;break;case 0:L.mid=f;break;case 1:L.right=f;break}}else this._root=f}for(let f=c.length-1;f>=0;f--){const y=c[f][1];y.updateHeight();const L=y.balanceFactor();if(L>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),c[f][1]=y.rotateLeft()):L<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),c[f][1]=y.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let n=this._root,c;for(;n;){const d=s.cmp(n.segment);if(d>0)n=n.left;else if(d<0)n=n.right;else if(s.hasNext())s.next(),c=n.value||c,n=n.mid;else break}return n&&n.value||c}findSuperstr(r){const s=this._iter.reset(r);let n=this._root;for(;n;){const c=s.cmp(n.segment);if(c>0)n=n.left;else if(c<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(r){for(const[s,n]of this)r(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const n=s.balanceFactor();return n<-1||n>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=m;class v{constructor(r,s){this.uri=r,this.value=s}}class p{constructor(r,s){this[D]="ResourceMap",r instanceof p?(this.map=new Map(r.map),this.toKey=s??p.defaultToKey):(this.map=new Map,this.toKey=r??p.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new v(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[n,c]of this.map)r(c.value,c.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=p,p.defaultToKey=o=>o.toString();class a{constructor(r,s){this[P]="ResourceSet",!r||typeof r=="function"?this._map=new p(r):(this._map=new p(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((n,c)=>r.call(s,c,c,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=a;var h;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class i{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const n=this._map.get(r);if(!!n)return s!==0&&this.touch(n,s),n.value}set(r,s,n=0){let c=this._map.get(r);if(c)c.value=s,n!==0&&this.touch(c,n);else{switch(c={key:r,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const n=this._state;let c=this._head;for(;c;){if(s?r.bind(s)(c.value,c.key,this):r(c.value,c.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,s=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.key,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return c}values(){const r=this,s=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:n.value,done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return c}entries(){const r=this,s=this._state;let n=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const d={value:[n.key,n.value],done:!1};return n=n.next,d}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>r;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,n=r.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const n=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(n.previous=c,c.next=n),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const n=r.next,c=r.previous;r===this._head?(n.previous=void 0,this._head=n):(n.previous=c,c.next=n),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,n)=>{r.push([n,s])}),r}fromJSON(r){this.clear();for(const[s,n]of r)this.set(s,n)}}e.LinkedMap=i;class u extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(De[102],Ie([1,0,25,8]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...ee){return function(ie,F){for(let H=0,K=ee.length;H<K;H++){const X=ee[H](ie,F);if(X)return X}return null}}e.or=D,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(ee,ie,F){if(!F||F.length<ie.length)return null;let H;return ee?H=t.startsWithIgnoreCase(F,ie):H=F.indexOf(ie)===0,H?ie.length>0?[{start:0,end:ie.length}]:[]:null}function _(ee,ie){const F=ie.toLowerCase().indexOf(ee.toLowerCase());return F===-1?null:[{start:F,end:F+ee.length}]}e.matchesContiguousSubString=_;function I(ee,ie){return w(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=I;function w(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]===ie[H]){let K=null;return(K=w(ee,ie,F+1,H+1))?m({start:H,end:H+1},K):null}return w(ee,ie,F,H+1)}function C(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.isUpper=R;function k(ee){return 48<=ee&&ee<=57}function S(ee){return ee===32||ee===9||ee===10||ee===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>T.add(ee.charCodeAt(0)));function E(ee){return S(ee)||T.has(ee)}function g(ee,ie){return ee===ie||E(ee)&&E(ie)}function b(ee){return C(ee)||R(ee)||k(ee)}function m(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function v(ee,ie){for(let F=ie;F<ee.length;F++){const H=ee.charCodeAt(F);if(R(H)||k(H)||F>0&&!b(ee.charCodeAt(F-1)))return F}return ee.length}function p(ee,ie,F,H){if(F===ee.length)return[];if(H===ie.length)return null;if(ee[F]!==ie[H].toLowerCase())return null;{let K=null,X=H+1;for(K=p(ee,ie,F+1,H+1);!K&&(X=v(ie,X))<ie.length;)K=p(ee,ie,F+1,X),X++;return K===null?null:m({start:H,end:H+1},K)}}function a(ee){let ie=0,F=0,H=0,K=0,X=0;for(let ye=0;ye<ee.length;ye++)X=ee.charCodeAt(ye),R(X)&&ie++,C(X)&&F++,b(X)&&H++,k(X)&&K++;const de=ie/ee.length,we=F/ee.length,ce=H/ee.length,Ce=K/ee.length;return{upperPercent:de,lowerPercent:we,alphaPercent:ce,numericPercent:Ce}}function h(ee){const{upperPercent:ie,lowerPercent:F}=ee;return F===0&&ie>.6}function i(ee){const{upperPercent:ie,lowerPercent:F,alphaPercent:H,numericPercent:K}=ee;return F>.2&&ie<.8&&H>.6&&K<.2}function u(ee){let ie=0,F=0,H=0,K=0;for(let X=0;X<ee.length;X++)H=ee.charCodeAt(X),R(H)&&ie++,C(H)&&F++,S(H)&&K++;return(ie===0||F===0)&&K===0?ee.length<=30:ie<=5}function o(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!u(ee)||ie.length>60)return null;const F=a(ie);if(!i(F)){if(!h(F))return null;ie=ie.toLowerCase()}let H=null,K=0;for(ee=ee.toLowerCase();K<ie.length&&(H=p(ee,ie,0,K))===null;)K=v(ie,K+1);return H}e.matchesCamelCase=o;function r(ee,ie,F=!1){if(!ie||ie.length===0)return null;let H=null,K=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();K<ie.length&&(H=s(ee,ie,0,K,F))===null;)K=n(ie,K+1);return H}e.matchesWords=r;function s(ee,ie,F,H,K){if(F===ee.length)return[];if(H===ie.length)return null;if(g(ee.charCodeAt(F),ie.charCodeAt(H))){let X=null,de=H+1;if(X=s(ee,ie,F+1,H+1,K),!K)for(;!X&&(de=n(ie,de))<ie.length;)X=s(ee,ie,F+1,de,K),de++;return X?ee.charCodeAt(F)!==ie.charCodeAt(H)?X:m({start:H,end:H+1},X):null}else return null}function n(ee,ie){for(let F=ie;F<ee.length;F++)if(E(ee.charCodeAt(F))||F>0&&E(ee.charCodeAt(F-1)))return F;return ee.length}const c=D(e.matchesPrefix,o,_),d=D(e.matchesPrefix,o,I),f=new l.LRUCache(1e4);function y(ee,ie,F=!1){if(typeof ee!="string"||typeof ie!="string")return null;let H=f.get(ee);H||(H=new RegExp(t.convertSimple2RegExpPattern(ee),"i"),f.set(ee,H));const K=H.exec(ie);return K?[{start:K.index,end:K.index+K[0].length}]:F?d(ee,ie):c(ee,ie)}e.matchesFuzzy=y;function L(ee,ie){const F=Le(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return F?B(F):null}e.matchesFuzzy2=L;function M(ee,ie,F,H,K,X){const de=Math.min(13,ee.length);for(;F<de;F++){const we=Le(ee,ie,F,H,K,X,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(we)return we}return[0,X]}e.anyScore=M;function B(ee){if(typeof ee>"u")return[];const ie=[],F=ee[1];for(let H=ee.length-1;H>1;H--){const K=ee[H]+F,X=ie[ie.length-1];X&&X.end===K?X.end=K+1:ie.push({start:K,end:K+1})}return ie}e.createMatches=B;const A=128;function W(){const ee=[],ie=[];for(let F=0;F<=A;F++)ie[F]=0;for(let F=0;F<=A;F++)ee.push(ie.slice(0));return ee}function U(ee){const ie=[];for(let F=0;F<=ee;F++)ie[F]=0;return ie}const N=U(2*A),G=U(2*A),z=W(),O=W(),x=W(),V=!1;function q(ee,ie,F,H,K){function X(we,ce,Ce=" "){for(;we.length<ce;)we=Ce+we;return we}let de=` |   |${H.split("").map(we=>X(we,3)).join("|")}
`;for(let we=0;we<=F;we++)we===0?de+=" |":de+=`${ie[we-1]}|`,de+=ee[we].slice(0,K+1).map(ce=>X(ce.toString(),3)).join("|")+`
`;return de}function Y(ee,ie,F,H){ee=ee.substr(ie),F=F.substr(H),console.log(q(O,ee,ee.length,F,F.length)),console.log(q(x,ee,ee.length,F,F.length)),console.log(q(z,ee,ee.length,F,F.length))}function Q(ee,ie){if(ie<0||ie>=ee.length)return!1;const F=ee.codePointAt(ie);switch(F){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(F)}}function he(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ve(ee,ie,F){return ie[ee]!==F[ee]}function ne(ee,ie,F,H,K,X,de=!1){for(;ie<F&&K<X;)ee[ie]===H[K]&&(de&&(N[ie]=K),ie+=1),K+=1;return ie===F}e.isPatternInWord=ne;var pe;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var be;(function(ee){ee.Default=[-100,0];function ie(F){return!F||F.length===2&&F[0]===-100&&F[1]===0}ee.isDefault=ie})(be=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(ie,F){this.firstMatchCanBeWeak=ie,this.boostFullMatch=F}}e.FuzzyScoreOptions=Te,Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Le(ee,ie,F,H,K,X,de=Te.default){const we=ee.length>A?A:ee.length,ce=H.length>A?A:H.length;if(F>=we||X>=ce||we-F>ce-X||!ne(ie,F,we,K,X,ce,!0))return;We(we,ce,F,X,ie,K);let Ce=1,ye=1,$e=F,Ve=X;const Ze=[!1];for(Ce=1,$e=F;$e<we;Ce++,$e++){const se=N[$e],Ee=G[$e],ue=$e+1<we?G[$e+1]:ce;for(ye=se-X+1,Ve=se;Ve<ue;ye++,Ve++){let ke=Number.MIN_SAFE_INTEGER,Ne=!1;Ve<=Ee&&(ke=oe(ee,ie,$e,F,H,K,Ve,ce,X,z[Ce-1][ye-1]===0,Ze));let Be=0;ke!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Be=ke+O[Ce-1][ye-1]);const ze=Ve>se,Qe=ze?O[Ce][ye-1]+(z[Ce][ye-1]>0?-5:0):0,nt=Ve>se+1&&z[Ce][ye-1]>0,ct=nt?O[Ce][ye-2]+(z[Ce][ye-2]>0?-5:0):0;if(nt&&(!ze||ct>=Qe)&&(!Ne||ct>=Be))O[Ce][ye]=ct,x[Ce][ye]=3,z[Ce][ye]=0;else if(ze&&(!Ne||Qe>=Be))O[Ce][ye]=Qe,x[Ce][ye]=2,z[Ce][ye]=0;else if(Ne)O[Ce][ye]=Be,x[Ce][ye]=1,z[Ce][ye]=z[Ce-1][ye-1]+1;else throw new Error("not possible")}}if(V&&Y(ee,F,H,X),!Ze[0]&&!de.firstMatchCanBeWeak)return;Ce--,ye--;const Ye=[O[Ce][ye],X];let Oe=0,ot=0;for(;Ce>=1;){let se=ye;do{const Ee=x[Ce][se];if(Ee===3)se=se-2;else if(Ee===2)se=se-1;else break}while(se>=1);Oe>1&&ie[F+Ce-1]===K[X+ye-1]&&!ve(se+X-1,H,K)&&Oe+1>z[Ce][se]&&(se=ye),se===ye?Oe++:Oe=1,ot||(ot=se),Ce--,ye=se-1,Ye.push(ye)}ce===we&&de.boostFullMatch&&(Ye[0]+=2);const re=ot-we;return Ye[0]-=re,Ye}e.fuzzyScore=Le;function We(ee,ie,F,H,K,X){let de=ee-1,we=ie-1;for(;de>=F&&we>=H;)K[de]===X[we]&&(G[de]=we,de--),we--}function oe(ee,ie,F,H,K,X,de,we,ce,Ce,ye){if(ie[F]!==X[de])return Number.MIN_SAFE_INTEGER;let $e=1,Ve=!1;return de===F-H?$e=ee[F]===K[de]?7:5:ve(de,K,X)&&(de===0||!ve(de-1,K,X))?($e=ee[F]===K[de]?7:5,Ve=!0):Q(X,de)&&(de===0||!Q(X,de-1))?$e=5:(Q(X,de-1)||he(X,de-1))&&($e=5,Ve=!0),$e>1&&F===H&&(ye[0]=!0),Ve||(Ve=ve(de,K,X)||Q(X,de-1)||he(X,de-1)),F===H?de>ce&&($e-=Ve?3:5):Ce?$e+=Ve?2:0:$e+=Ve?0:1,de+1===we&&($e-=Ve?3:5),$e}function le(ee,ie,F,H,K,X,de){return Z(ee,ie,F,H,K,X,!0,de)}e.fuzzyScoreGracefulAggressive=le;function me(ee,ie,F,H,K,X,de){return Z(ee,ie,F,H,K,X,!1,de)}e.fuzzyScoreGraceful=me;function Z(ee,ie,F,H,K,X,de,we){let ce=Le(ee,ie,F,H,K,X,we);if(ce&&!de)return ce;if(ee.length>=3){const Ce=Math.min(7,ee.length-1);for(let ye=F+1;ye<Ce;ye++){const $e=ae(ee,ye);if($e){const Ve=Le($e,$e.toLowerCase(),F,H,K,X,we);Ve&&(Ve[0]-=3,(!ce||Ve[0]>ce[0])&&(ce=Ve))}}}return ce}function ae(ee,ie){if(ie+1>=ee.length)return;const F=ee[ie],H=ee[ie+1];if(F!==H)return ee.slice(0,ie)+H+F+ee.slice(ie+2)}}),define(De[156],Ie([1,0,75,102,8]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(l.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${P.source}`,"g");function w(b){return b.replace(I,(m,v)=>v?m:`\\${m}`)}e.escapeIcons=w;const C=new RegExp(`\\\\${P.source}`,"g");function R(b){return b.replace(C,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=R;const k=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function S(b){return b.indexOf(e.iconStartMarker)===-1?b:b.replace(k,(m,v,p,a)=>p?m:v||a||"")}e.stripIcons=S;function T(b){const m=b.indexOf(e.iconStartMarker);return m===-1?{text:b}:E(b,m)}e.parseLabelWithIcons=T;function E(b,m){const v=[];let p="";function a(c){if(c){p+=c;for(const d of c)v.push(u)}}let h=-1,i="",u=0,o,r,s=m;const n=b.length;for(a(b.substr(0,m));s<n;)o=b[s],r=b[s+1],o===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(h=s,a(i),i=e.iconStartMarker,s++):o===")"&&h!==-1?(u+=s-h+1,h=-1,i=""):h!==-1?_.test(o)?i+=o:(a(i),h=-1,i=""):a(o),s++;return a(i),{text:p,iconOffsets:v}}function g(b,m,v=!1){const{text:p,iconOffsets:a}=m;if(!a||a.length===0)return(0,t.matchesFuzzy)(b,p,v);const h=(0,D.ltrim)(p," "),i=p.length-h.length,u=(0,t.matchesFuzzy)(b,h,v);if(u)for(const o of u){const r=a[o.start+i]+i;o.start+=r,o.end+=r}return u}e.matchesFuzzyIconAware=g}),define(De[79],Ie([1,0,25]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new l.LRUCache(1e4);function D(C){return w(C,"NFC",t)}e.normalizeNFC=D;const P=new l.LRUCache(1e4);function _(C){return w(C,"NFD",P)}e.normalizeNFD=_;const I=/[^\u0000-\u0080]/;function w(C,R,k){if(!C)return C;const S=k.get(C);if(S)return S;let T;return I.test(C)?T=C.normalize(R):T=C,k.set(C,T),T}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return _(R).replace(C,"")}}()}),define(De[41],Ie([1,0,8]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(t||(t={})),function(D){const P="error",_="warning",I="warn",w="info",C="ignore";function R(S){return S?l.equalsIgnoreCase(P,S)?D.Error:l.equalsIgnoreCase(_,S)||l.equalsIgnoreCase(I,S)?D.Warning:l.equalsIgnoreCase(w,S)?D.Info:D.Ignore:D.Ignore}D.fromValue=R;function k(S){switch(S){case D.Error:return P;case D.Warning:return _;case D.Info:return w;default:return C}}D.toString=k}(t||(t={})),e.default=t}),define(De[2],Ie([1,0,9,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,P=/^\//,_=/^\/\//;function I(o,r){if(!o.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!P.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(o,r){return!o&&!r?"file":o}function C(o,r){switch(o){case"https":case"http":case"file":r?r[0]!==k&&(r=k+r):r=k;break}return r}const R="",k="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{constructor(r,s,n,c,d,f=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=w(r,f),this.authority=s||R,this.path=C(this.scheme,n||R),this.query=c||R,this.fragment=d||R,I(this,f))}static isUri(r){return r instanceof T?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return p(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:n,path:c,query:d,fragment:f}=r;return s===void 0?s=this.scheme:s===null&&(s=R),n===void 0?n=this.authority:n===null&&(n=R),c===void 0?c=this.path:c===null&&(c=R),d===void 0?d=this.query:d===null&&(d=R),f===void 0?f=this.fragment:f===null&&(f=R),s===this.scheme&&n===this.authority&&c===this.path&&d===this.query&&f===this.fragment?this:new g(s,n,c,d,f)}static parse(r,s=!1){const n=S.exec(r);return n?new g(n[2]||R,u(n[4]||R),u(n[5]||R),u(n[7]||R),u(n[9]||R),s):new g(R,R,R,R,R)}static file(r){let s=R;if(t.isWindows&&(r=r.replace(/\\/g,k)),r[0]===k&&r[1]===k){const n=r.indexOf(k,2);n===-1?(s=r.substring(2),r=k):(s=r.substring(2,n),r=r.substring(n)||k)}return new g("file",s,r,R,R)}static from(r){const s=new g(r.scheme,r.authority,r.path,r.query,r.fragment);return I(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let n;return t.isWindows&&r.scheme==="file"?n=T.file(l.win32.join(p(r,!0),...s)).path:n=l.posix.join(r.path,...s),r.with({path:n})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof T)return r;{const s=new g(r);return s._formatted=r.external,s._fsPath=r._sep===E?r.fsPath:null,s}}else return r}}e.URI=T;const E=t.isWindows?1:void 0;class g extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=E),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(o,r){let s,n=-1;for(let c=0;c<o.length;c++){const d=o.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)n!==-1&&(s+=encodeURIComponent(o.substring(n,c)),n=-1),s!==void 0&&(s+=o.charAt(c));else{s===void 0&&(s=o.substr(0,c));const f=b[d];f!==void 0?(n!==-1&&(s+=encodeURIComponent(o.substring(n,c)),n=-1),s+=f):n===-1&&(n=c)}}return n!==-1&&(s+=encodeURIComponent(o.substring(n))),s!==void 0?s:o}function v(o){let r;for(let s=0;s<o.length;s++){const n=o.charCodeAt(s);n===35||n===63?(r===void 0&&(r=o.substr(0,s)),r+=b[n]):r!==void 0&&(r+=o[s])}return r!==void 0?r:o}function p(o,r){let s;return o.authority&&o.path.length>1&&o.scheme==="file"?s=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?r?s=o.path.substr(1):s=o.path[1].toLowerCase()+o.path.substr(2):s=o.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=p;function a(o,r){const s=r?v:m;let n="",{scheme:c,authority:d,path:f,query:y,fragment:L}=o;if(c&&(n+=c,n+=":"),(d||c==="file")&&(n+=k,n+=k),d){let M=d.indexOf("@");if(M!==-1){const B=d.substr(0,M);d=d.substr(M+1),M=B.indexOf(":"),M===-1?n+=s(B,!1):(n+=s(B.substr(0,M),!1),n+=":",n+=s(B.substr(M+1),!1)),n+="@"}d=d.toLowerCase(),M=d.indexOf(":"),M===-1?n+=s(d,!1):(n+=s(d.substr(0,M),!1),n+=d.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}n+=s(f,!0)}return y&&(n+="?",n+=s(y,!1)),L&&(n+="#",n+=r?L:m(L,!1)),n}function h(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+h(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function u(o){return o.match(i)?o.replace(i,r=>h(r)):o}}),define(De[80],Ie([1,0,23,8,2]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(C){return JSON.stringify(C,I)}e.stringify=P;function _(C){let R=JSON.parse(C);return R=w(R),R}e.parse=_;function I(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function w(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return D.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 14:return new Date(C.source)}if(C instanceof l.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let k=0;k<C.length;++k)C[k]=w(C[k],R+1);else for(const k in C)Object.hasOwnProperty.call(C,k)&&(C[k]=w(C[k],R+1))}return C}e.revive=w}),define(De[12],Ie([1,0,11,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}setServerRootPath(C){this._remoteResourcesPath=`${C}/${D.vscodeRemoteResource}`}set(C,R,k){this._hosts[C]=R,this._ports[C]=k}setConnectionToken(C,R){this._connectionTokens[C]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const R=C.authority;let k=this._hosts[R];k&&k.indexOf(":")!==-1&&(k=`[${k}]`);const S=this._ports[R],T=this._connectionTokens[R];let E=`path=${encodeURIComponent(C.path)}`;return typeof T=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),t.URI.from({scheme:l.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${k}:${S}`,path:this._remoteResourcesPath,query:E})}}e.RemoteAuthorities=new P;class _{asBrowserUri(C,R){const k=this.toUri(C,R);return k.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===D.file&&(l.isNative||l.isWebWorker&&l.globals.origin===`${D.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?k.with({scheme:D.vscodeFileResource,authority:k.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(C,R){const k=this.toUri(C,R);return k.scheme===D.vscodeFileResource?k.with({scheme:D.file,authority:k.authority!==_.FALLBACK_AUTHORITY?k.authority:null,query:null,fragment:null}):k}toUri(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var I;(function(w){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(C.get("3"));const R="vscode-coi";function k(T){let E;typeof T=="string"?E=new URL(T).searchParams:T instanceof URL?E=T.searchParams:t.URI.isUri(T)&&(E=new URL(T.toString(!0)).searchParams);const g=E?.get(R);if(!!g)return C.get(g)}w.getHeadersFromQuery=k;function S(T,E,g){if(!globalThis.crossOriginIsolated)return;const b=E&&g?"3":g?"2":"1";T instanceof URLSearchParams?T.set(R,b):T[R]=b}w.addSearchParam=S})(I=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,31,12,9,11,8,2]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(T){return(0,I.uriToFsPath)(T,!0)}e.originalFSPath=w;class C{constructor(E){this._ignorePathCasing=E}compare(E,g,b=!1){return E===g?0:(0,_.compare)(this.getComparisonKey(E,b),this.getComparisonKey(g,b))}isEqual(E,g,b=!1){return E===g?!0:!E||!g?!1:this.getComparisonKey(E,b)===this.getComparisonKey(g,b)}getComparisonKey(E,g=!1){return E.with({path:this._ignorePathCasing(E)?E.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(E){return this._ignorePathCasing(E)}isEqualOrParent(E,g,b=!1){if(E.scheme===g.scheme){if(E.scheme===t.Schemas.file)return l.isEqualOrParent(w(E),w(g),this._ignorePathCasing(E))&&E.query===g.query&&(b||E.fragment===g.fragment);if((0,e.isEqualAuthority)(E.authority,g.authority))return l.isEqualOrParent(E.path,g.path,this._ignorePathCasing(E),"/")&&E.query===g.query&&(b||E.fragment===g.fragment)}return!1}joinPath(E,...g){return I.URI.joinPath(E,...g)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return D.posix.basename(E.path)}extname(E){return D.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let g;return E.scheme===t.Schemas.file?g=I.URI.file(D.dirname(w(E))).path:(g=D.posix.dirname(E.path),E.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),g="/")),E.with({path:g})}normalizePath(E){if(!E.path.length)return E;let g;return E.scheme===t.Schemas.file?g=I.URI.file(D.normalize(w(E))).path:g=D.posix.normalize(E.path),E.with({path:g})}relativePath(E,g){if(E.scheme!==g.scheme||!(0,e.isEqualAuthority)(E.authority,g.authority))return;if(E.scheme===t.Schemas.file){const v=D.relative(w(E),w(g));return P.isWindows?l.toSlashes(v):v}let b=E.path||"/";const m=g.path||"/";if(this._ignorePathCasing(E)){let v=0;for(const p=Math.min(b.length,m.length);v<p&&!(b.charCodeAt(v)!==m.charCodeAt(v)&&b.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);b=m.substr(0,v)+b.substr(v)}return D.posix.relative(b,m)}resolvePath(E,g){if(E.scheme===t.Schemas.file){const b=I.URI.file(D.resolve(w(E),g));return E.with({authority:b.authority,path:b.path})}return g=l.toPosixPath(g),E.with({path:D.posix.resolve(E.path,g)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,g){return E===g||E!==void 0&&g!==void 0&&(0,_.equalsIgnoreCase)(E,g)}hasTrailingPathSeparator(E,g=D.sep){if(E.scheme===t.Schemas.file){const b=w(E);return b.length>l.getRoot(b).length&&b[b.length-1]===g}else{const b=E.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,g=D.sep){return(0,e.hasTrailingPathSeparator)(E,g)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,g=D.sep){let b=!1;if(E.scheme===t.Schemas.file){const m=w(E);b=m!==void 0&&m.length===l.getRoot(m).length&&m[m.length-1]===g}else{g="/";const m=E.path;b=m.length===1&&m.charCodeAt(m.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(E,g)?E.with({path:E.path+"/"}):E}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(T=>T.scheme===t.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new C(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(T,E){const g=[];for(let b=0;b<T.length;b++){const m=E(T[b]);T.some((v,p)=>p===b?!1:(0,e.isEqualOrParent)(m,E(v)))||g.push(T[b])}return g}e.distinctParents=R;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function E(g){const b=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(p=>{const[a,h]=p.split(":");a&&h&&b.set(a,h)});const v=g.path.substring(0,g.path.indexOf(";"));return v&&b.set(T.META_DATA_MIME,v),b}T.parseMetaData=E})(k=e.DataUri||(e.DataUri={}));function S(T,E,g){if(E){let b=T.path;return b&&b[0]!==D.posix.sep&&(b=D.posix.sep+b),T.with({scheme:g,authority:E,path:b})}return T.with({scheme:g})}e.toLocalResource=S}),define(De[18],Ie([1,0,21,10,4,6,22,11]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(ve){return!!ve&&typeof ve.then=="function"}e.isThenable=w;function C(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token),be=new Promise((Te,Le)=>{const We=ne.token.onCancellationRequested(()=>{We.dispose(),ne.dispose(),Le(new t.CancellationError)});Promise.resolve(pe).then(oe=>{We.dispose(),ne.dispose(),Te(oe)},oe=>{We.dispose(),ne.dispose(),Le(oe)})});return new class{cancel(){ne.cancel()}then(Te,Le){return be.then(Te,Le)}catch(Te){return this.then(void 0,Te)}finally(Te){return be.finally(Te)}}}e.createCancelablePromise=C;function R(ve,ne,pe){return new Promise((be,Te)=>{const Le=ne.onCancellationRequested(()=>{Le.dispose(),be(pe)});ve.then(be,Te).finally(()=>Le.dispose())})}e.raceCancellation=R;function k(ve,ne){return new Promise((pe,be)=>{const Te=ne.onCancellationRequested(()=>{Te.dispose(),be(new t.CancellationError)});ve.then(pe,be).finally(()=>Te.dispose())})}e.raceCancellationError=k;async function S(ve){let ne=-1;const pe=ve.map((Te,Le)=>Te.then(We=>(ne=Le,We))),be=await Promise.race(pe);return ve.forEach((Te,Le)=>{Le!==ne&&Te.cancel()}),be}e.raceCancellablePromises=S;function T(ve,ne,pe){let be;const Te=setTimeout(()=>{be?.(void 0),pe?.()},ne);return Promise.race([ve.finally(()=>clearTimeout(Te)),new Promise(Le=>be=Le)])}e.raceTimeout=T;function E(ve){return new Promise((ne,pe)=>{const be=ve();w(be)?be.then(ne,pe):ne(be)})}e.asPromise=E;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const pe=()=>{this.queuedPromise=null;const be=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,be};this.queuedPromise=new Promise(be=>{this.activePromise.then(pe,pe).then(be)})}return new Promise((pe,be)=>{this.queuedPromise.then(pe,be)})}return this.activePromise=ne(),new Promise((pe,be)=>{this.activePromise.then(Te=>{this.activePromise=null,pe(Te)},Te=>{this.activePromise=null,be(Te)})})}}e.Throttler=g;class b{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=b;class m{constructor(){this.promiseMap=new Map}queue(ne,pe){const Te=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.promiseMap.get(ne)===Te&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Te),Te}}e.SequencerByKey=m;const v=(ve,ne)=>{let pe=!0;const be=setTimeout(()=>{pe=!1,ne()},ve);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(be),pe=!1}}},p=ve=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ve())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class a{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,pe=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Te,Le)=>{this.doResolve=Te,this.doReject=Le}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Te=this.task;return this.task=null,Te()}}));const be=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=pe===e.MicrotaskDelay?p(be):v(pe,be),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=a;class h{constructor(ne){this.delayer=new a(ne),this.throttler=new g}trigger(ne,pe){return this.delayer.trigger(()=>this.throttler.queue(ne),pe)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class i{constructor(){this._isOpen=!1,this._promise=new Promise((ne,pe)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class u extends i{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function o(ve,ne){return ne?new Promise((pe,be)=>{const Te=setTimeout(()=>{Le.dispose(),pe()},ve),Le=ne.onCancellationRequested(()=>{clearTimeout(Te),Le.dispose(),be(new t.CancellationError)})}):C(pe=>o(ve,pe))}e.timeout=o;function r(ve,ne=0){const pe=setTimeout(ve,ne);return(0,P.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=r;function s(ve){const ne=[];let pe=0;const be=ve.length;function Te(){return pe<be?ve[pe++]():null}function Le(We){We!=null&&ne.push(We);const oe=Te();return oe?oe.then(Le):Promise.resolve(ne)}return Promise.resolve(null).then(Le)}e.sequence=s;function n(ve,ne=be=>!!be,pe=null){let be=0;const Te=ve.length,Le=()=>{if(be>=Te)return Promise.resolve(pe);const We=ve[be++];return Promise.resolve(We()).then(le=>ne(le)?Promise.resolve(le):Le())};return Le()}e.first=n;function c(ve,ne=be=>!!be,pe=null){if(ve.length===0)return Promise.resolve(pe);let be=ve.length;const Te=()=>{be=-1;for(const Le of ve)Le.cancel?.()};return new Promise((Le,We)=>{for(const oe of ve)oe.then(le=>{--be>=0&&ne(le)?(Te(),Le(le)):be===0&&Le(pe)}).catch(le=>{--be>=0&&(Te(),We(le))})})}e.firstParallel=c;class d{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((pe,be)=>{this.outstandingPromises.push({factory:ne,c:pe,e:be}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const pe=ne.factory();pe.then(ne.c,ne.e),pe.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class f extends d{constructor(){super(1)}}e.Queue=f;class y{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new x;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,pe=_.extUri){const be=pe.getComparisonKey(ne);let Te=this.queues.get(be);return Te||(Te=new f,D.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.queues.delete(be),this.onDidQueueDrain()}),this.queues.set(be,Te)),Te}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=y;class L{constructor(ne,pe){this._token=-1,typeof ne=="function"&&typeof pe=="number"&&this.setIfNotSet(ne,pe)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},pe)}setIfNotSet(ne,pe){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},pe))}}e.TimeoutTimer=L;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,pe){this.cancel(),this._token=setInterval(()=>{ne()},pe)}}e.IntervalTimer=M;class B{constructor(ne,pe){this.timeoutToken=-1,this.runner=ne,this.timeout=pe,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class A{constructor(ne,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=pe,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=A;class W extends B{constructor(ne,pe){super(ne,pe),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class U extends P.Disposable{constructor(ne,pe){super(),this.options=ne,this.handler=pe,this.pendingWork=[],this.throttler=this._register(new P.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ve=>{(0,I.setTimeout0)(()=>{if(ne)return;const pe=Date.now()+15;ve(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(ve,ne)=>{const pe=requestIdleCallback(ve,typeof ne=="number"?{timeout:ne}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(pe))}}}}();class N{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(pe){this._error=pe}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function G(ve,ne,pe){let be;for(let Te=0;Te<pe;Te++)try{return await ve()}catch(Le){be=Le,await o(ne)}throw be}e.retry=G;class z{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ne,pe,be){return this._pending={taskId:ne,cancel:()=>be?.(),promise:pe},pe.then(()=>this.donePending(ne),()=>this.donePending(ne)),pe}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let pe,be;const Te=new Promise((Le,We)=>{pe=Le,be=We});this._next={run:ne,promise:Te,promiseResolve:pe,promiseReject:be}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=z;class O{constructor(ne,pe=()=>Date.now()){this.interval=ne,this.nowFn=pe,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,pe)=>{this.completeCallback=ne,this.errorCallback=pe})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(pe=>{this.completeCallback(ne),this.resolved=!0,pe()})}error(ne){return new Promise(pe=>{this.errorCallback(ne),this.rejected=!0,pe()})}cancel(){new Promise(ne=>{this.errorCallback(new t.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=x;var V;(function(ve){async function ne(be){let Te;const Le=await Promise.all(be.map(We=>We.then(oe=>oe,oe=>{Te||(Te=oe)})));if(typeof Te<"u")throw Te;return Le}ve.settled=ne;function pe(be){return new Promise(async(Te,Le)=>{try{await be(Te,Le)}catch(We){Le(We)}})}ve.withAsyncBody=pe})(V=e.Promises||(e.Promises={}));var q;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const pe={emitOne:be=>this.emitOne(be),emitMany:be=>this.emitMany(be),reject:be=>this.reject(be)};try{await Promise.resolve(ne(pe)),this.resolve()}catch(be){this.reject(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}static fromArray(ne){return new Y(pe=>{pe.emitMany(ne)})}static fromPromise(ne){return new Y(async pe=>{pe.emitMany(await ne)})}static fromPromises(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>pe.emitOne(await be)))})}static merge(ne){return new Y(async pe=>{await Promise.all(ne.map(async be=>{for await(const Te of be)pe.emitOne(Te)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,pe){return new Y(async be=>{for await(const Te of ne)be.emitOne(pe(Te))})}map(ne){return Y.map(this,ne)}static filter(ne,pe){return new Y(async be=>{for await(const Te of ne)pe(Te)&&be.emitOne(Te)})}filter(ne){return Y.filter(this,ne)}static coalesce(ne){return Y.filter(ne,pe=>!!pe)}coalesce(){return Y.coalesce(this)}static async toPromise(ne){const pe=[];for await(const be of ne)pe.push(be);return pe}toPromise(){return Y.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class Q extends Y{constructor(ne,pe){super(pe),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function he(ve){const ne=new l.CancellationTokenSource,pe=ve(ne.token);return new Q(ne,async be=>{const Te=ne.token.onCancellationRequested(()=>{Te.dispose(),ne.dispose(),be.reject(new t.CancellationError)});try{for await(const Le of pe){if(ne.token.isCancellationRequested)return;be.emitOne(Le)}Te.dispose(),ne.dispose()}catch(Le){Te.dispose(),ne.dispose(),be.reject(Le)}})}e.createCancelableAsyncIterable=he}),define(De[103],Ie([1,0,18,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new l.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),P=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(f,y,L=!1){const M=f||"",B=y||"",A=D.value.collator.compare(M,B);return D.value.collatorIsNumeric&&A===0&&M!==B?M<B?-1:1:A}e.compareFileNames=I;function w(f,y){const L=P.value.collator;return f=f||"",y=y||"",h(L,f,y)}e.compareFileNamesDefault=w;function C(f,y){const L=P.value.collator;return f=f||"",y=y||"",r(f,y)||h(L,f,y)}e.compareFileNamesUpper=C;function R(f,y){const L=P.value.collator;return f=f||"",y=y||"",o(f,y)||h(L,f,y)}e.compareFileNamesLower=R;function k(f,y){return f=f||"",y=y||"",f===y?0:f<y?-1:1}e.compareFileNamesUnicode=k;function S(f,y,L=!1){L||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase());const[M,B]=p(f),[A,W]=p(y);return M!==A?M<A?-1:1:B===W?0:B<W?-1:1}e.noIntlCompareFileNames=S;function T(f,y){const[L,M]=p(f),[B,A]=p(y);let W=D.value.collator.compare(M,A);if(W===0){if(D.value.collatorIsNumeric&&M!==A)return M<A?-1:1;if(W=D.value.collator.compare(L,B),D.value.collatorIsNumeric&&W===0&&L!==B)return L<B?-1:1}return W}e.compareFileExtensions=T;function E(f,y){f=f||"",y=y||"";const L=a(f),M=a(y),B=P.value.collator,A=_.value.collator;return h(A,L,M)||h(B,f,y)}e.compareFileExtensionsDefault=E;function g(f,y){f=f||"",y=y||"";const L=a(f),M=a(y),B=P.value.collator,A=_.value.collator;return h(A,L,M)||r(f,y)||h(B,f,y)}e.compareFileExtensionsUpper=g;function b(f,y){f=f||"",y=y||"";const L=a(f),M=a(y),B=P.value.collator,A=_.value.collator;return h(A,L,M)||o(f,y)||h(B,f,y)}e.compareFileExtensionsLower=b;function m(f,y){f=f||"",y=y||"";const L=a(f).toLowerCase(),M=a(y).toLowerCase();return L!==M?L<M?-1:1:f!==y?f<y?-1:1:0}e.compareFileExtensionsUnicode=m;const v=/^(.*?)(\.([^.]*))?$/;function p(f,y=!1){const L=f?v.exec(f):[];let M=[L&&L[1]||"",L&&L[3]||""];return y&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function a(f){const y=f?v.exec(f):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function h(f,y,L){const M=f.compare(y,L);return M!==0?M:y.length!==L.length?y.length<L.length?-1:1:0}function i(f){const y=f.charAt(0);return y.toLocaleUpperCase()!==y}function u(f){const y=f.charAt(0);return y.toLocaleLowerCase()!==y}function o(f,y){return i(f)&&u(y)?-1:u(f)&&i(y)?1:0}function r(f,y){return u(f)&&i(y)?-1:i(f)&&u(y)?1:0}function s(f,y,L=!1){return L||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase()),f===y?0:f<y?-1:1}function n(f,y,L=!1){const M=f.split(t.sep),B=y.split(t.sep),A=M.length-1,W=B.length-1;let U,N;for(let G=0;;G++){if(U=A===G,N=W===G,U&&N)return I(M[G],B[G],L);if(U)return-1;if(N)return 1;const z=s(M[G],B[G],L);if(z!==0)return z}}e.comparePaths=n;function c(f,y,L){const M=f.toLowerCase(),B=y.toLowerCase(),A=d(f,y,L);if(A)return A;const W=M.endsWith(L),U=B.endsWith(L);if(W!==U)return W?-1:1;const N=I(M,B);return N!==0?N:M.localeCompare(B)}e.compareAnything=c;function d(f,y,L){const M=f.toLowerCase(),B=y.toLowerCase(),A=M.startsWith(L),W=B.startsWith(L);if(A!==W)return A?-1:1;if(A&&W){if(M.length<B.length)return-1;if(M.length>B.length)return 1}return 0}e.compareByPrefix=d}),define(De[104],Ie([1,0,103,102,61,9,11,8]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const w=0,C=[w,[]];function R(z,O,x,V){if(!z||!O)return C;const q=z.length,Y=O.length;if(q<Y)return C;const Q=z.toLowerCase();return k(O,x,Y,z,Q,q,V)}e.scoreFuzzy=R;function k(z,O,x,V,q,Y,Q){const he=[],ve=[];for(let Te=0;Te<x;Te++){const Le=Te*Y,We=Le-Y,oe=Te>0,le=z[Te],me=O[Te];for(let Z=0;Z<Y;Z++){const ae=Z>0,ee=Le+Z,ie=ee-1,F=We+Z-1,H=ae?he[ie]:0,K=oe&&ae?he[F]:0,X=oe&&ae?ve[F]:0;let de;!K&&oe?de=0:de=S(le,me,V,q,Z,X),de&&K+de>=H&&(Q||oe||q.startsWith(O,Z))?(ve[ee]=X+1,he[ee]=K+de):(ve[ee]=w,he[ee]=H)}}const ne=[];let pe=x-1,be=Y-1;for(;pe>=0&&be>=0;){const Te=pe*Y+be;ve[Te]===w||(ne.push(be),pe--),be--}return[he[x*Y-1],ne.reverse()]}function S(z,O,x,V,q,Y){let Q=0;if(!T(O,V[q]))return Q;if(Q+=1,Y>0&&(Q+=Y*5),z===x[q]&&(Q+=1),q===0)Q+=8;else{const he=E(x.charCodeAt(q-1));he?Q+=he:(0,t.isUpper)(x.charCodeAt(q))&&Y===0&&(Q+=2)}return Q}function T(z,O){return z===O?!0:z==="/"||z==="\\"?O==="/"||O==="\\":!1}function E(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const g=[void 0,[]];function b(z,O,x=0,V=0){const q=O;return q.values&&q.values.length>1?m(z,q.values,x,V):v(z,O,x,V)}e.scoreFuzzy2=b;function m(z,O,x,V){let q=0;const Y=[];for(const Q of O){const[he,ve]=v(z,Q,x,V);if(typeof he!="number")return g;q+=he,Y.push(...ve)}return[q,d(Y)]}function v(z,O,x,V){const q=(0,t.fuzzyScore)(O.original,O.originalLowercase,x,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,t.createMatches)(q)]:g}const p=Object.freeze({score:0}),a=1<<18,h=1<<17,i=1<<16;function u(z,O,x,V){const q=V.values?V.values:[V];return(0,D.hash)({[V.normalized]:{values:q.map(Q=>({value:Q.normalized,expectContiguousMatch:Q.expectContiguousMatch})),label:z,description:O,allowNonContiguousMatches:x}})}function o(z,O,x,V,q){if(!z||!O.normalized)return p;const Y=V.getItemLabel(z);if(!Y)return p;const Q=V.getItemDescription(z),he=u(Y,Q,x,O),ve=q[he];if(ve)return ve;const ne=r(Y,Q,V.getItemPath(z),O,x);return q[he]=ne,ne}e.scoreItemFuzzy=o;function r(z,O,x,V,q){const Y=!x||!V.containsPathSeparator;return x&&(_.isLinux?V.pathNormalized===x:(0,I.equalsIgnoreCase)(V.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:z.length}],descriptionMatch:O?[{start:0,end:O.length}]:void 0}:V.values&&V.values.length>1?s(z,O,x,V.values,Y,q):n(z,O,x,V,Y,q)}function s(z,O,x,V,q,Y){let Q=0;const he=[],ve=[];for(const ne of V){const{score:pe,labelMatch:be,descriptionMatch:Te}=n(z,O,x,ne,q,Y);if(pe===w)return p;Q+=pe,be&&he.push(...be),Te&&ve.push(...Te)}return{score:Q,labelMatch:d(he),descriptionMatch:d(ve)}}function n(z,O,x,V,q,Y){if(q||!O){const[Q,he]=R(z,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(Q){const ve=(0,t.matchesPrefix)(V.normalized,z);let ne;return ve?(ne=h,ne+=Math.round(V.normalized.length/z.length*100)):ne=i,{score:ne+Q,labelMatch:ve||c(he)}}}if(O){let Q=O;x&&(Q=`${O}${P.sep}`);const he=Q.length,ve=`${Q}${z}`,[ne,pe]=R(ve,V.normalized,V.normalizedLowercase,Y&&!V.expectContiguousMatch);if(ne){const be=c(pe),Te=[],Le=[];return be.forEach(We=>{We.start<he&&We.end>he?(Te.push({start:0,end:We.end-he}),Le.push({start:We.start,end:he})):We.start>=he?Te.push({start:We.start-he,end:We.end-he}):Le.push(We)}),{score:ne,labelMatch:Te,descriptionMatch:Le}}}return p}function c(z){const O=[];if(!z)return O;let x;for(const V of z)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},O.push(x));return O}function d(z){const O=z.sort((q,Y)=>q.start-Y.start),x=[];let V;for(const q of O)!V||!f(V,q)?(V=q,x.push(q)):(V.start=Math.min(V.start,q.start),V.end=Math.max(V.end,q.end));return x}function f(z,O){return!(z.end<O.start||O.end<z.start)}function y(z,O,x,V,q,Y){const Q=o(z,x,V,q,Y),he=o(O,x,V,q,Y),ve=Q.score,ne=he.score;if((ve===a||ne===a)&&ve!==ne)return ve===a?-1:1;if(ve>i||ne>i){if(ve!==ne)return ve>ne?-1:1;if(ve<h&&ne<h){const le=M(Q.labelMatch,he.labelMatch);if(le!==0)return le}const We=q.getItemLabel(z)||"",oe=q.getItemLabel(O)||"";if(We.length!==oe.length)return We.length-oe.length}if(ve!==ne)return ve>ne?-1:1;const pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0,be=Array.isArray(he.labelMatch)&&he.labelMatch.length>0;if(pe&&!be)return-1;if(be&&!pe)return 1;const Te=L(z,Q,q),Le=L(O,he,q);return Te&&Le&&Te!==Le?Le>Te?-1:1:B(z,O,x,q)}e.compareItemsByFuzzyScore=y;function L(z,O,x){let V=-1,q=-1;if(O.descriptionMatch&&O.descriptionMatch.length?V=O.descriptionMatch[0].start:O.labelMatch&&O.labelMatch.length&&(V=O.labelMatch[0].start),O.labelMatch&&O.labelMatch.length){if(q=O.labelMatch[O.labelMatch.length-1].end,O.descriptionMatch&&O.descriptionMatch.length){const Y=x.getItemDescription(z);Y&&(q+=Y.length)}}else O.descriptionMatch&&O.descriptionMatch.length&&(q=O.descriptionMatch[O.descriptionMatch.length-1].end);return q-V}function M(z,O){if(!z&&!O||(!z||!z.length)&&(!O||!O.length))return 0;if(!O||!O.length)return-1;if(!z||!z.length)return 1;const x=z[0].start,q=z[z.length-1].end-x,Y=O[0].start,he=O[O.length-1].end-Y;return q===he?0:he<q?1:-1}function B(z,O,x,V){const q=V.getItemLabel(z)||"",Y=V.getItemLabel(O)||"",Q=V.getItemDescription(z),he=V.getItemDescription(O),ve=q.length+(Q?Q.length:0),ne=Y.length+(he?he.length:0);if(ve!==ne)return ve-ne;const pe=V.getItemPath(z),be=V.getItemPath(O);return pe&&be&&pe.length!==be.length?pe.length-be.length:q!==Y?(0,l.compareAnything)(q,Y,x.normalized):Q&&he&&Q!==he?(0,l.compareAnything)(Q,he,x.normalized):pe&&be&&pe!==be?(0,l.compareAnything)(pe,be,x.normalized):0}function A(z){return z.startsWith('"')&&z.endsWith('"')}const W=" ";function U(z){typeof z!="string"&&(z="");const O=z.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:q}=N(z),Y=x.indexOf(P.sep)>=0,Q=A(z);let he;const ve=z.split(W);if(ve.length>1)for(const ne of ve){const pe=A(ne),{pathNormalized:be,normalized:Te,normalizedLowercase:Le}=N(ne);Te&&(he||(he=[]),he.push({original:ne,originalLowercase:ne.toLowerCase(),pathNormalized:be,normalized:Te,normalizedLowercase:Le,expectContiguousMatch:pe}))}return{original:z,originalLowercase:O,pathNormalized:x,normalized:V,normalizedLowercase:q,values:he,containsPathSeparator:Y,expectContiguousMatch:Q}}e.prepareQuery=U;function N(z){let O;_.isWindows?O=z.replace(/\//g,P.sep):O=z.replace(/\\/g,P.sep);const x=(0,I.stripWildcards)(O).replace(/\s|"/g,"");return{pathNormalized:O,normalized:x,normalizedLowercase:x.toLowerCase()}}function G(z){return Array.isArray(z)?U(z.map(O=>O.original).join(W)):U(z.original)}e.pieceToQuery=G}),define(De[36],Ie([1,0,17,18,31,25,9,11,8]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",k="[^/\\\\]",S=/\//g;function T(x,V){switch(x){case 0:return"";case 1:return`${k}*?`;default:return`(?:${R}|${k}+${R}${V?`|${R}${k}+`:""})*?`}}function E(x,V){if(!x)return[];const q=[];let Y=!1,Q=!1,he="";for(const ve of x){switch(ve){case V:if(!Y&&!Q){q.push(he),he="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}he+=ve}return he&&q.push(he),q}e.splitGlobAware=E;function g(x){if(!x)return"";let V="";const q=E(x,e.GLOB_SPLIT);if(q.every(Y=>Y===e.GLOBSTAR))V=".*";else{let Y=!1;q.forEach((Q,he)=>{if(Q===e.GLOBSTAR){if(Y)return;V+=T(2,he===q.length-1)}else{let ve=!1,ne="",pe=!1,be="";for(const Te of Q){if(Te!=="}"&&ve){ne+=Te;continue}if(pe&&(Te!=="]"||!be)){let Le;Te==="-"?Le=Te:(Te==="^"||Te==="!")&&!be?Le="^":Te===e.GLOB_SPLIT?Le="":Le=(0,w.escapeRegExpCharacters)(Te),be+=Le;continue}switch(Te){case"{":ve=!0;continue;case"[":pe=!0;continue;case"}":{V+=`(?:${E(ne,",").map(oe=>g(oe)).join("|")})`,ve=!1,ne="";break}case"]":{V+="["+be+"]",pe=!1,be="";break}case"?":V+=k;continue;case"*":V+=T(1);continue;default:V+=(0,w.escapeRegExpCharacters)(Te)}}he<q.length-1&&(q[he+1]!==e.GLOBSTAR||he+2<q.length)&&(V+=R)}Y=Q===e.GLOBSTAR})}return V}const b=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new P.LRUCache(1e4),u=function(){return!1},o=function(){return null};function r(x,V){if(!x)return o;let q;typeof x!="string"?q=x.pattern:q=x,q=q.trim();const Y=`${q}_${!!V.trimForExclusions}`;let Q=i.get(Y);if(Q)return s(Q,x);let he;return b.test(q)?Q=c(q.substr(4),q):(he=m.exec(n(q,V)))?Q=d(he[1],q):(V.trimForExclusions?p:v).test(q)?Q=f(q,V):(he=a.exec(n(q,V)))?Q=y(he[1].substr(1),q,!0):(he=h.exec(n(q,V)))?Q=y(he[1],q,!1):Q=L(q),i.set(Y,Q),s(Q,x)}function s(x,V){if(typeof V=="string")return x;const q=function(Y,Q){return(0,D.isEqualOrParent)(Y,V.base,!I.isLinux)?x(Y.substr(V.base.length+1),Q):null};return q.allBasenames=x.allBasenames,q.allPaths=x.allPaths,q.basenames=x.basenames,q.patterns=x.patterns,q}function n(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function c(x,V){return function(q,Y){return typeof q=="string"&&q.endsWith(x)?V:null}}function d(x,V){const q=`/${x}`,Y=`\\${x}`,Q=function(ve,ne){return typeof ve!="string"?null:ne?ne===x?V:null:ve===x||ve.endsWith(q)||ve.endsWith(Y)?V:null},he=[x];return Q.basenames=he,Q.patterns=[V],Q.allBasenames=he,Q}function f(x,V){const q=z(x.slice(1,-1).split(",").map(ne=>r(ne,V)).filter(ne=>ne!==o),x),Y=q.length;if(!Y)return o;if(Y===1)return q[0];const Q=function(ne,pe){for(let be=0,Te=q.length;be<Te;be++)if(q[be](ne,pe))return x;return null},he=q.find(ne=>!!ne.allBasenames);he&&(Q.allBasenames=he.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function y(x,V,q){const Y=_.sep===_.posix.sep,Q=Y?x:x.replace(S,_.sep),he=_.sep+Q,ve=_.posix.sep+x;let ne;return q?ne=function(pe,be){return typeof pe=="string"&&(pe===Q||pe.endsWith(he)||!Y&&(pe===x||pe.endsWith(ve)))?V:null}:ne=function(pe,be){return typeof pe=="string"&&(pe===Q||!Y&&pe===x)?V:null},ne.allPaths=[(q?"*/":"./")+x],ne}function L(x){try{const V=new RegExp(`^${g(x)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?x:null}}catch{return o}}function M(x,V,q){return!x||typeof V!="string"?!1:B(x)(V,void 0,q)}e.match=M;function B(x,V={}){if(!x)return u;if(typeof x=="string"||A(x)){const q=r(x,V);if(q===o)return u;const Y=function(Q,he){return!!q(Q,he)};return q.allBasenames&&(Y.allBasenames=q.allBasenames),q.allPaths&&(Y.allPaths=q.allPaths),Y}return N(x,V)}e.parse=B;function A(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=A;function W(x){return x.allBasenames||[]}e.getBasenameTerms=W;function U(x){return x.allPaths||[]}e.getPathTerms=U;function N(x,V){const q=z(Object.getOwnPropertyNames(x).map(ne=>G(ne,x[ne],V)).filter(ne=>ne!==o)),Y=q.length;if(!Y)return o;if(!q.some(ne=>!!ne.requiresSiblings)){if(Y===1)return q[0];const ne=function(Te,Le){let We;for(let oe=0,le=q.length;oe<le;oe++){const me=q[oe](Te,Le);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(We||(We=[]),We.push(me))}return We?(async()=>{for(const oe of We){const le=await oe;if(typeof le=="string")return le}return null})():null},pe=q.find(Te=>!!Te.allBasenames);pe&&(ne.allBasenames=pe.allBasenames);const be=q.reduce((Te,Le)=>Le.allPaths?Te.concat(Le.allPaths):Te,[]);return be.length&&(ne.allPaths=be),ne}const Q=function(ne,pe,be){let Te,Le;for(let We=0,oe=q.length;We<oe;We++){const le=q[We];le.requiresSiblings&&be&&(pe||(pe=(0,_.basename)(ne)),Te||(Te=pe.substr(0,pe.length-(0,_.extname)(ne).length)));const me=le(ne,pe,Te,be);if(typeof me=="string")return me;(0,t.isThenable)(me)&&(Le||(Le=[]),Le.push(me))}return Le?(async()=>{for(const We of Le){const oe=await We;if(typeof oe=="string")return oe}return null})():null},he=q.find(ne=>!!ne.allBasenames);he&&(Q.allBasenames=he.allBasenames);const ve=q.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return ve.length&&(Q.allPaths=ve),Q}function G(x,V,q){if(V===!1)return o;const Y=r(x,q);if(Y===o)return o;if(typeof V=="boolean")return Y;if(V){const Q=V.when;if(typeof Q=="string"){const he=(ve,ne,pe,be)=>{if(!be||!Y(ve,ne))return null;const Te=Q.replace("$(basename)",pe),Le=be(Te);return(0,t.isThenable)(Le)?Le.then(We=>We?x:null):Le?x:null};return he.requiresSiblings=!0,he}}return Y}function z(x,V){const q=x.filter(ne=>!!ne.basenames);if(q.length<2)return x;const Y=q.reduce((ne,pe)=>{const be=pe.basenames;return be?ne.concat(be):ne},[]);let Q;if(V){Q=[];for(let ne=0,pe=Y.length;ne<pe;ne++)Q.push(V)}else Q=q.reduce((ne,pe)=>{const be=pe.patterns;return be?ne.concat(be):ne},[]);const he=function(ne,pe){if(typeof ne!="string")return null;if(!pe){let Te;for(Te=ne.length;Te>0;Te--){const Le=ne.charCodeAt(Te-1);if(Le===47||Le===92)break}pe=ne.substr(Te)}const be=Y.indexOf(pe);return be!==-1?Q[be]:null};he.basenames=Y,he.patterns=Q,he.allBasenames=Y;const ve=x.filter(ne=>!ne.basenames);return ve.push(he),ve}function O(x,V){return(0,l.equals)(x,V,(q,Y)=>typeof q=="string"&&typeof Y=="string"?q===Y:typeof q!="string"&&typeof Y!="string"?q.base===Y.base&&q.pattern===Y.pattern:!1)}e.patternsEquals=O}),define(De[105],Ie([1,0,10,156,22,8,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(I=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(m="",v=!1){if(this.value=m,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(m,v=0){return this.value+=S(this.supportThemeIcons?(0,t.escapeIcons)(m):m).replace(/([ \t]+)/g,(p,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,v){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(m,v,p){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(m),")"),p&&(this.value+=` "${this._escape(this._escape(p,'"'),")")}"`),this.value+=")",this}_escape(m,v){const p=new RegExp((0,P.escapeRegExpCharacters)(v),"g");return m.replace(p,(a,h)=>m.charAt(h-1)!=="\\"?`\\${a}`:a)}}e.MarkdownString=w;function C(b){return R(b)?!b.value:Array.isArray(b)?b.every(C):!0}e.isEmptyMarkdownString=C;function R(b){return b instanceof w?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function k(b,m){return b===m?!0:!b||!m?!1:b.value===m.value&&b.isTrusted===m.isTrusted&&b.supportThemeIcons===m.supportThemeIcons&&b.supportHtml===m.supportHtml&&(b.baseUri===m.baseUri||!!b.baseUri&&!!m.baseUri&&(0,D.isEqual)(_.URI.from(b.baseUri),_.URI.from(m.baseUri)))}e.markdownStringEqual=k;function S(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=S;function T(b){return b.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function E(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=E;function g(b){const m=[],v=b.split("|").map(a=>a.trim());b=v[0];const p=v[1];if(p){const a=/height=(\d+)/.exec(p),h=/width=(\d+)/.exec(p),i=a?a[1]:"",u=h?h[1]:"",o=isFinite(parseInt(u)),r=isFinite(parseInt(i));o&&m.push(`width="${u}"`),r&&m.push(`height="${i}"`)}return{href:b,dimensions:m}}e.parseHrefAndDimensions=g}),define(De[106],Ie([1,0,17,31,9,11,22,8]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(o,r){const{os:s,tildify:n,relative:c}=r;if(c){const y=C(o,c,s);if(typeof y=="string")return y}let d=o.fsPath;if(s===1&&!P.isWindows?d=d.replace(/\//g,"\\"):s!==1&&P.isWindows&&(d=d.replace(/\\/g,"/")),s!==1&&n?.userHome){const y=n.userHome.fsPath;let L;o.scheme!==n.userHome.scheme&&o.path.startsWith(D.posix.sep)?L=n.userHome.with({path:o.path}).fsPath:L=o.fsPath,d=S(L,y,s)}return(s===1?D.win32:D.posix).normalize(R(d,s===1))}e.getPathLabel=w;function C(o,r,s){const n=s===1?D.win32:D.posix,c=s===3?_.extUri:_.extUriIgnorePathCase,d=r.getWorkspace(),f=(0,l.firstOrDefault)(d.folders);if(!f)return;o.scheme!==f.uri.scheme&&o.path.startsWith(D.posix.sep)&&(o=f.uri.with({path:o.path}));const y=r.getWorkspaceFolder(o);if(!y)return;let L;if(c.isEqual(y.uri,o)?L="":L=c.relativePath(y.uri,o)??"",L&&(L=n.normalize(L)),d.folders.length>1&&!r.noPrefix){const M=y.name?y.name:c.basenameOrAuthority(y.uri);L=L?`${M} \u2022 ${L}`:M}return L}function R(o,r=P.isWindows){return(0,t.hasDriveLetter)(o,r)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=R;let k=Object.create(null);function S(o,r,s=P.OS){if(s===1||!o||!r)return o;let n=k.original===r?k.normalized:void 0;n||(n=r,P.isWindows&&(n=(0,t.toSlashes)(n)),n=`${(0,I.rtrim)(n,D.posix.sep)}${D.posix.sep}`,k={original:r,normalized:n});let c=o;return P.isWindows&&(c=(0,t.toSlashes)(c)),(s===3?c.startsWith(n):(0,I.startsWithIgnoreCase)(c,n))?`~/${c.substr(n.length)}`:o}e.tildify=S;function T(o,r){return o.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=T;const E="\u2026",g="\\\\",b="~";function m(o,r=D.sep){const s=new Array(o.length);let n=!1;for(let c=0;c<o.length;c++){const d=o[c];if(d===""){s[c]=`.${r}`;continue}if(!d){s[c]=d;continue}n=!0;let f="",y=d;y.indexOf(g)===0?(f=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length)):y.indexOf(r)===0?(f=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(b)===0&&(f=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length));const L=y.split(r);for(let M=1;n&&M<=L.length;M++)for(let B=L.length-M;n&&B>=0;B--){n=!1;let A=L.slice(B,B+M).join(r);for(let W=0;!n&&W<o.length;W++)if(W!==c&&o[W]&&o[W].indexOf(A)>-1){const U=B+M===L.length,N=B>0&&o[W].indexOf(r)>-1?r+A:A,G=o[W].endsWith(N);n=!U||G}if(!n){let W="";(L[0].endsWith(":")||f!=="")&&(B===1&&(B=0,M++,A=L[0]+r+A),B>0&&(W=L[0]+r),W=f+W),B>0&&(W=W+E+r),W=W+A,B+M<L.length&&(W=W+r+E),s[c]=W}}n&&(s[c]=d)}return s}e.shorten=m;var v;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function p(o,r=Object.create(null)){const s=[];let n=!1,c="";for(const d of o)if(d==="$"||n&&d==="{")c&&s.push({value:c,type:v.TEXT}),c="",n=!0;else if(d==="}"&&n){const f=r[c];if(typeof f=="string")f.length&&s.push({value:f,type:v.VARIABLE});else if(f){const y=s[s.length-1];(!y||y.type!==v.SEPARATOR)&&s.push({value:f.label,type:v.SEPARATOR})}c="",n=!1}else c+=d;return c&&!n&&s.push({value:c,type:v.TEXT}),s.filter((d,f)=>{if(d.type===v.SEPARATOR){const y=s[f-1],L=s[f+1];return[y,L].every(M=>M&&(M.type===v.VARIABLE||M.type===v.TEXT)&&M.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=p;function a(o,r){return P.isMacintosh||r?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):o.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function h(o,r){return P.isMacintosh||r?o.replace(/\(&&\w\)|&&/g,""):P.isWindows?o.replace(/&&|&/g,s=>s==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=h;function i(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(o){const r=o.indexOf("/")!==-1?D.posix:D.win32,s=r.basename(o),n=r.dirname(o);return s.length?{name:s,parentPath:n}:{name:n,parentPath:""}}e.splitName=u}),define(De[107],Ie([1,0,2]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class D{constructor(k){this._uriTransformer=k}transformIncoming(k){const S=this._uriTransformer.transformIncoming(k);return S===k?k:t(l.URI.from(S))}transformOutgoing(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:t(l.URI.from(S))}transformOutgoingURI(k){const S=this._uriTransformer.transformOutgoing(k);return S===k?k:l.URI.from(S)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function P(R,k,S){if(!R||S>200)return null;if(typeof R=="object"){if(R instanceof l.URI)return k.transformOutgoing(R);for(const T in R)if(Object.hasOwnProperty.call(R,T)){const E=P(R[T],k,S+1);E!==null&&(R[T]=E)}}return null}function _(R,k){const S=P(R,k,0);return S===null?R:S}e.transformOutgoingURIs=_;function I(R,k,S,T){if(!R||T>200)return null;if(typeof R=="object"){if(R.$mid===1)return S?l.URI.revive(k.transformIncoming(R)):k.transformIncoming(R);for(const E in R)if(Object.hasOwnProperty.call(R,E)){const g=I(R[E],k,S,T+1);g!==null&&(R[E]=g)}}return null}function w(R,k){const S=I(R,k,!1,0);return S===null?R:S}e.transformIncomingURIs=w;function C(R,k){const S=I(R,k,!0,0);return S===null?R:S}e.transformAndReviveIncomingURIs=C}),define(De[29],Ie([1,0,62,81,301,18,31,79,9,11,22,2]),function(J,e,l,t,D,P,_,I,w,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function T(N,G=S.UNLINK){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return G===S.UNLINK?g(N):E(N)}async function E(N){try{const G=(0,_.randomPath)((0,t.tmpdir)());try{await l.promises.rename(N,G)}catch(z){return z.code==="ENOENT"?void 0:g(N)}g(G).catch(z=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function g(N){return(0,D.promisify)(l.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function b(N){if((0,_.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function m(N,G){return a(await(G?v(N):(0,D.promisify)(l.readdir)(N)))}async function v(N){try{return await(0,D.promisify)(l.readdir)(N,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const G=[],z=await m(N);for(const O of z){let x=!1,V=!1,q=!1;try{const Y=await e.Promises.lstat((0,w.join)(N,O));x=Y.isFile(),V=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}G.push({name:O,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>q})}return G}function p(N){return a(l.readdirSync(N))}e.readdirSync=p;function a(N){return N.map(G=>typeof G=="string"?C.isMacintosh?(0,I.normalizeNFC)(G):G:(G.name=C.isMacintosh?(0,I.normalizeNFC)(G.name):G.name,G))}async function h(N){const G=await m(N),z=[];for(const O of G)await u.existsDirectory((0,w.join)(N,O))&&z.push(O);return z}function i(N,G=1e3){return new Promise(z=>{let O=!1;const x=setInterval(()=>{O||(O=!0,l.access(N,V=>{O=!1,V&&(clearInterval(x),z(void 0))}))},G)})}e.whenDeleted=i;var u;(function(N){async function G(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(C.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Y}throw q}}N.stat=G;async function z(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isFile()&&q?.dangling!==!0}catch{}return!1}N.existsFile=z;async function O(x){try{const{stat:V,symbolicLink:q}=await N.stat(x);return V.isDirectory()&&q?.dangling!==!0}catch{}return!1}N.existsDirectory=O})(u=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new P.ResourceQueue;function r(N,G,z){return o.queueFor(k.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const O=f(z);return new Promise((x,V)=>c(N,G,O,q=>q?V(q):x()))})}let s=!0;function n(N){s=N}e.configureFlushOnWrite=n;function c(N,G,z,O){if(!s)return l.writeFile(N,G,{mode:z.mode,flag:z.flag},O);l.open(N,z.flag,z.mode,(x,V)=>{if(x)return O(x);l.writeFile(V,G,q=>{if(q)return l.close(V,()=>O(q));l.fdatasync(V,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),n(!1)),l.close(V,Q=>O(Q))))})})}function d(N,G,z){const O=f(z);if(!s)return l.writeFileSync(N,G,{mode:O.mode,flag:O.flag});const x=l.openSync(N,O.flag,O.mode);try{l.writeFileSync(x,G);try{l.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),n(!1)}}finally{l.closeSync(x)}}e.writeFileSync=d;function f(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function y(N,G){if(N!==G)try{await e.Promises.rename(N,G)}catch(z){if(N.toLowerCase()!==G.toLowerCase()&&z.code==="EXDEV"||N.endsWith("."))await L(N,G,{preserveSymlinks:!1}),await T(N,S.MOVE);else throw z}}async function L(N,G,z){return B(N,G,{root:{source:N,target:G},options:z,handledSourcePaths:new Set})}const M=511;async function B(N,G,z){if(z.handledSourcePaths.has(N))return;z.handledSourcePaths.add(N);const{stat:O,symbolicLink:x}=await u.stat(N);if(x){if(z.options.preserveSymlinks)try{return await U(N,G,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return O.isDirectory()?A(N,G,O.mode&M,z):W(N,G,O.mode&M)}async function A(N,G,z,O){await e.Promises.mkdir(G,{recursive:!0,mode:z});const x=await m(N);for(const V of x)await B((0,w.join)(N,V),(0,w.join)(G,V),O)}async function W(N,G,z){await e.Promises.copyFile(N,G),await e.Promises.chmod(G,z)}async function U(N,G,z){let O=await e.Promises.readlink(N);(0,_.isEqualOrParent)(O,z.root.source,!C.isLinux)&&(O=(0,w.join)(z.root.target,O.substr(z.root.source.length+1))),await e.Promises.symlink(O,G)}e.Promises=new class{get access(){return(0,D.promisify)(l.access)}get stat(){return(0,D.promisify)(l.stat)}get lstat(){return(0,D.promisify)(l.lstat)}get utimes(){return(0,D.promisify)(l.utimes)}get read(){return(N,G,z,O,x)=>new Promise((V,q)=>{l.read(N,G,z,O,x,(Y,Q,he)=>Y?q(Y):V({bytesRead:Q,buffer:he}))})}get readFile(){return(0,D.promisify)(l.readFile)}get write(){return(N,G,z,O,x)=>new Promise((V,q)=>{l.write(N,G,z,O,x,(Y,Q,he)=>Y?q(Y):V({bytesWritten:Q,buffer:he}))})}get appendFile(){return(0,D.promisify)(l.appendFile)}get fdatasync(){return(0,D.promisify)(l.fdatasync)}get truncate(){return(0,D.promisify)(l.truncate)}get rename(){return(0,D.promisify)(l.rename)}get copyFile(){return(0,D.promisify)(l.copyFile)}get open(){return(0,D.promisify)(l.open)}get close(){return(0,D.promisify)(l.close)}get symlink(){return(0,D.promisify)(l.symlink)}get readlink(){return(0,D.promisify)(l.readlink)}get chmod(){return(0,D.promisify)(l.chmod)}get mkdir(){return(0,D.promisify)(l.mkdir)}get unlink(){return(0,D.promisify)(l.unlink)}get rmdir(){return(0,D.promisify)(l.rmdir)}get realpath(){return(0,D.promisify)(l.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return h}get writeFile(){return r}get rm(){return T}get move(){return y}get copy(){return L}}}),define(De[108],Ie([1,0,62,9,11,8,29]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(0,_.readdirSync)(T).filter(m=>m.toLowerCase()===E);if(b.length===1){const m=I(T);if(m)return(0,t.join)(m,b[0])}else if(b.length>1){const m=b.indexOf(E);if(m>=0){const v=I(T);if(v)return(0,t.join)(v,b[m])}}}catch{}return null}e.realcaseSync=I;async function w(S){if(D.isLinux)return S;const T=(0,t.dirname)(S);if(S===T)return S;const E=((0,t.basename)(S)||S).toLowerCase();try{const b=(await _.Promises.readdir(T)).filter(m=>m.toLowerCase()===E);if(b.length===1){const m=await w(T);if(m)return(0,t.join)(m,b[0])}else if(b.length>1){const m=b.indexOf(E);if(m>=0){const v=await w(T);if(v)return(0,t.join)(v,b[m])}}}catch{}return null}e.realcase=w;async function C(S){try{return await _.Promises.realpath(S)}catch{const E=k(S);return await _.Promises.access(E,l.constants.R_OK),E}}e.realpath=C;function R(S){try{return l.realpathSync(S)}catch{const E=k(S);return l.accessSync(E,l.constants.R_OK),E}}e.realpathSync=R;function k(S){return(0,P.rtrim)((0,t.normalize)(S),t.sep)}}),define(De[109],Ie([1,0,9,11,40,101,13,29]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(k=D.env){return k.comspec||"cmd.exe"}e.getWindowsShell=w;function C(k){let S=[],T=!1;const E=function(g){if(T){S.push(g);return}(!k.send(g,m=>{if(m&&console.error(m),T=!1,S.length>0){const v=S.slice(0);S=[],v.forEach(p=>E(p))}})||t.isWindows)&&(T=!0)};return{send:E}}e.createQueuedSender=C;var R;(function(k){async function S(T,E,g){if(l.isAbsolute(T))return T;if(E===void 0&&(E=D.cwd()),l.dirname(T)!=="."||(g===void 0&&_.isString(D.env.PATH)&&(g=D.env.PATH.split(l.delimiter)),g===void 0||g.length===0))return l.join(E,T);async function m(v){if(await I.Promises.exists(v)){let p;try{p=await I.Promises.stat(v)}catch(a){a.message.startsWith("EACCES")&&(p=await I.Promises.lstat(v))}return p?!p.isDirectory():!1}return!1}for(const v of g){let p;if(l.isAbsolute(v)?p=l.join(v,T):p=l.join(E,v,T),await m(p))return p;let a=p+".com";if(await m(a)||(a=p+".exe",await m(a)))return a}return l.join(E,T)}k.findExecutable=S})(R=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(J,e,l,t){var D=arguments.length,P=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,l):t,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(J,e,l,t);else for(var I=J.length-1;I>=0;I--)(_=J[I])&&(P=(D<3?_(P):D>3?_(e,l,P):_(e,l))||P);return D>3&&P&&Object.defineProperty(e,l,P),P};define(De[110],Ie([1,0,17,18,23,21,58,10,4,6,80,8,13]),function(J,e,l,t,D,P,_,I,w,C,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var T;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(T=e.RequestType||(e.RequestType={}));function E(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function b(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class v{constructor(V){this.buffer=V,this.pos=0}read(V){const q=this.buffer.slice(this.pos,this.pos+V);return this.pos+=q.byteLength,q}}class p{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(V){this.buffers.push(V)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function h(x){const V=D.VSBuffer.alloc(4);return V.writeUInt32BE(x,0),V}function i(x){return x.read(4).readUInt32BE(0)}function u(x){const V=D.VSBuffer.alloc(1);return V.writeUInt8(x,0),V}const o={Undefined:u(a.Undefined),String:u(a.String),Buffer:u(a.Buffer),VSBuffer:u(a.VSBuffer),Array:u(a.Array),Object:u(a.Object)},r=typeof Buffer<"u";function s(x,V){if(typeof V>"u")x.write(o.Undefined);else if(typeof V=="string"){const q=D.VSBuffer.fromString(V);x.write(o.String),x.write(h(q.byteLength)),x.write(q)}else if(r&&Buffer.isBuffer(V)){const q=D.VSBuffer.wrap(V);x.write(o.Buffer),x.write(h(q.byteLength)),x.write(q)}else if(V instanceof D.VSBuffer)x.write(o.VSBuffer),x.write(h(V.byteLength)),x.write(V);else if(Array.isArray(V)){x.write(o.Array),x.write(h(V.length));for(const q of V)s(x,q)}else{const q=D.VSBuffer.fromString(JSON.stringify(V));x.write(o.Object),x.write(h(q.byteLength)),x.write(q)}}function n(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(i(x)).toString();case a.Buffer:return x.read(i(x)).buffer;case a.VSBuffer:return x.read(i(x));case a.Array:{const q=i(x),Y=[];for(let Q=0;Q<q;Q++)Y.push(n(x));return Y}case a.Object:return JSON.parse(x.read(i(x)).toString())}}class c{constructor(V,q,Y=null,Q=1e3){this.protocol=V,this.ctx=q,this.logger=Y,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(he=>this.onRawMessage(he)),this.sendResponse({type:200})}registerChannel(V,q){this.channels.set(V,q),setTimeout(()=>this.flushPendingRequests(V),0)}sendResponse(V){switch(V.type){case 200:{const q=this.send([V.type]);this.logger?.logOutgoing(q,0,1,b(V.type));return}case 201:case 202:case 204:case 203:{const q=this.send([V.type,V.id],V.data);this.logger?.logOutgoing(q,V.id,1,b(V.type),V.data);return}}}send(V,q=void 0){const Y=new p;return s(Y,V),s(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onRawMessage(V){const q=new v(V),Y=n(q),Q=n(q),he=Y[0];switch(he){case 100:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(he)}: ${Y[2]}.${Y[3]}`,Q),this.onPromise({type:he,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 102:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(he)}: ${Y[2]}.${Y[3]}`,Q),this.onEventListen({type:he,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 101:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(he)}`),this.disposeActiveRequest({type:he,id:Y[1]});case 103:return this.logger?.logIncoming(V.byteLength,Y[1],1,`${E(he)}`),this.disposeActiveRequest({type:he,id:Y[1]})}}onPromise(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=new P.CancellationTokenSource;let Q;try{Q=q.call(this.ctx,V.name,V.arg,Y.token)}catch(ne){Q=Promise.reject(ne)}const he=V.id;Q.then(ne=>{this.sendResponse({id:he,data:ne,type:201}),this.activeRequests.delete(V.id)},ne=>{ne instanceof Error?this.sendResponse({id:he,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:he,data:ne,type:203}),this.activeRequests.delete(V.id)});const ve=(0,C.toDisposable)(()=>Y.cancel());this.activeRequests.set(V.id,ve)}onEventListen(V){const q=this.channels.get(V.channelName);if(!q){this.collectPendingRequest(V);return}const Y=V.id,he=q.listen(this.ctx,V.name,V.arg)(ve=>this.sendResponse({id:Y,data:ve,type:204}));this.activeRequests.set(V.id,he)}disposeActiveRequest(V){const q=this.activeRequests.get(V.id);q&&(q.dispose(),this.activeRequests.delete(V.id))}collectPendingRequest(V){let q=this.pendingRequests.get(V.channelName);q||(q=[],this.pendingRequests.set(V.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.sendResponse({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);q.push({request:V,timeoutTimer:Y})}flushPendingRequests(V){const q=this.pendingRequests.get(V);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete(V)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class f{constructor(V,q=null){this.protocol=V,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=q}getChannel(V){const q=this;return{call(Y,Q,he){return q.isDisposed?Promise.reject(new I.CancellationError):q.requestPromise(V,Y,Q,he)},listen(Y,Q){return q.isDisposed?w.Event.None:q.requestEvent(V,Y,Q)}}}requestPromise(V,q,Y,Q=P.CancellationToken.None){const he=this.lastRequestId++,ne={id:he,type:100,channelName:V,name:q,arg:Y};if(Q.isCancellationRequested)return Promise.reject(new I.CancellationError);let pe;return new Promise((Te,Le)=>{if(Q.isCancellationRequested)return Le(new I.CancellationError);const We=()=>{const Z=ae=>{switch(ae.type){case 201:this.handlers.delete(he),Te(ae.data);break;case 202:{this.handlers.delete(he);const ee=new Error(ae.data.message);ee.stack=ae.data.stack,ee.name=ae.data.name,Le(ee);break}case 203:this.handlers.delete(he),Le(ae.data);break}};this.handlers.set(he,Z),this.sendRequest(ne)};let oe=null;this.state===m.Idle?We():(oe=(0,t.createCancelablePromise)(Z=>this.whenInitialized()),oe.then(()=>{oe=null,We()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:he,type:101}),Le(new I.CancellationError)},me=Q.onCancellationRequested(le);pe=(0,C.combinedDisposable)((0,C.toDisposable)(le),me),this.activeRequests.add(pe)}).finally(()=>{this.activeRequests.delete(pe)})}requestEvent(V,q,Y){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:V,name:q,arg:Y};let ne=null;const pe=new w.Emitter({onFirstListenerAdd:()=>{ne=(0,t.createCancelablePromise)(Te=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(pe),this.sendRequest(ve)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(pe),this.sendRequest({id:Q,type:103}))}}),be=Te=>pe.fire(Te.data);return this.handlers.set(Q,be),pe.event}sendRequest(V){switch(V.type){case 100:case 102:{const q=this.send([V.type,V.id,V.channelName,V.name],V.arg);this.logger?.logOutgoing(q,V.id,0,`${E(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const q=this.send([V.type,V.id]);this.logger?.logOutgoing(q,V.id,0,E(V.type));return}}}send(V,q=void 0){const Y=new p;return s(Y,V),s(Y,q),this.sendBuffer(Y.buffer)}sendBuffer(V){try{return this.protocol.send(V),V.byteLength}catch{return 0}}onBuffer(V){const q=new v(V),Y=n(q),Q=n(q),he=Y[0];switch(he){case 200:return this.logger?.logIncoming(V.byteLength,0,0,b(he)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(V.byteLength,Y[1],0,b(he),Q),this.onResponse({type:Y[0],id:Y[1],data:Q})}}onResponse(V){if(V.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(V.id)?.(V)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,C.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}qe([_.memoize],f.prototype,"onDidInitializePromise",null),e.ChannelClient=f;class y{constructor(V){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,V(({protocol:q,onDidClientDisconnect:Y})=>{w.Event.once(q.onMessage)(he=>{const ve=new v(he),ne=n(ve),pe=new c(q,ne),be=new f(q);this.channels.forEach((Le,We)=>pe.registerChannel(We,Le));const Te={channelServer:pe,channelClient:be,ctx:ne};this._connections.add(Te),this._onDidAddConnection.fire(Te),Y(()=>{pe.dispose(),be.dispose(),this._connections.delete(Te),this._onDidRemoveConnection.fire(Te)})})})}get connections(){const V=[];return this._connections.forEach(q=>V.push(q)),V}getChannel(V,q){const Y=this;return{call(Q,he,ve){let ne;if((0,S.isFunction)(q)){const be=(0,l.getRandomElement)(Y.connections.filter(q));ne=be?Promise.resolve(be):w.Event.toPromise(w.Event.filter(Y.onDidAddConnection,q))}else ne=q.routeCall(Y,Q,he);const pe=ne.then(be=>be.channelClient.getChannel(V));return M(pe).call(Q,he,ve)},listen(Q,he){if((0,S.isFunction)(q))return Y.getMulticastEvent(V,q,Q,he);const ve=q.routeEvent(Y,Q,he).then(ne=>ne.channelClient.getChannel(V));return M(ve).listen(Q,he)}}}getMulticastEvent(V,q,Y,Q){const he=this;let ve=new C.DisposableStore;const ne=new w.Emitter({onFirstListenerAdd:()=>{ve=new C.DisposableStore;const pe=new w.EventMultiplexer,be=new Map,Te=We=>{const le=We.channelClient.getChannel(V).listen(Y,Q),me=pe.add(le);be.set(We,me)},Le=We=>{const oe=be.get(We);!oe||(oe.dispose(),be.delete(We))};he.connections.filter(q).forEach(Te),w.Event.filter(he.onDidAddConnection,q)(Te,void 0,ve),he.onDidRemoveConnection(Le,void 0,ve),pe.event(ne.fire,ne,ve),ve.add(pe)},onLastListenerRemove:()=>{ve.dispose()}});return ne.event}registerChannel(V,q){this.channels.set(V,q),this._connections.forEach(Y=>{Y.channelServer.registerChannel(V,q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class L{constructor(V,q,Y=null){const Q=new p;s(Q,q),V.send(Q.buffer),this.channelClient=new f(V,Y),this.channelServer=new c(V,q,Y)}getChannel(V){return this.channelClient.getChannel(V)}registerChannel(V,q){this.channelServer.registerChannel(V,q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function M(x){return{call(V,q,Y){return x.then(Q=>Q.call(V,q,Y))},listen(V,q){const Y=new w.Relay;return x.then(Q=>Y.input=Q.listen(V,q)),Y.event}}}e.getDelayedChannel=M;function B(x){let V=!1;return{call(q,Y,Q){return V?x.call(q,Y,Q):(0,t.timeout)(0).then(()=>V=!0).then(()=>x.call(q,Y,Q))},listen(q,Y){if(V)return x.listen(q,Y);const Q=new w.Relay;return(0,t.timeout)(0).then(()=>V=!0).then(()=>Q.input=x.listen(q,Y)),Q.event}}}e.getNextTickChannel=B;class A{constructor(V){this.fn=V}routeCall(V){return this.route(V)}routeEvent(V){return this.route(V)}async route(V){for(const q of V.connections)if(await Promise.resolve(this.fn(q.ctx)))return Promise.resolve(q);return await w.Event.toPromise(V.onDidAddConnection),await this.route(V)}}e.StaticRouter=A;var W;(function(x){function V(he,ve){const ne=he,pe=ve&&ve.disableMarshalling,be=new Map;for(const Te in ne)Y(Te)&&be.set(Te,w.Event.buffer(ne[Te],!0));return new class{listen(Te,Le,We){const oe=be.get(Le);if(oe)return oe;if(Q(Le)){const le=ne[Le];if(typeof le=="function")return le.call(ne,We)}throw new Error(`Event not found: ${Le}`)}call(Te,Le,We){const oe=ne[Le];if(typeof oe=="function"){if(!pe&&Array.isArray(We))for(let le=0;le<We.length;le++)We[le]=(0,R.revive)(We[le]);return oe.apply(ne,We)}throw new Error(`Method not found: ${Le}`)}}}x.fromService=V;function q(he,ve){const ne=ve&&ve.disableMarshalling;return new Proxy({},{get(pe,be){if(typeof be=="string")return ve?.properties?.has(be)?ve.properties.get(be):Q(be)?function(Te){return he.listen(be,Te)}:Y(be)?he.listen(be):async function(...Te){let Le;ve&&!(0,S.isUndefinedOrNull)(ve.context)?Le=[ve.context,...Te]:Le=Te;const We=await he.call(be,Le);return ne?We:(0,R.revive)(We)};throw new Error(`Property not found: ${String(be)}`)}})}x.toService=q;function Y(he){return he[0]==="o"&&he[1]==="n"&&k.isUpperAsciiLetter(he.charCodeAt(2))}function Q(he){return/^onDynamic/.test(he)&&k.isUpperAsciiLetter(he.charCodeAt(9))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const V=x.toString();if(V!=="[object Object]")return V}return x}function G(x){return Array.isArray(x)?x.map(N):N(x)}function z(x,V,q,Y,Q,he,ve){ve=G(ve);const ne=U[Q],pe=ne[Y%ne.length];let be=[`%c[${x}]%c[${String(V).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(he)?(be=be.concat(ve),be.push(")")):be.push(ve),console.log.apply(console,be)}e.logWithColors=z;class O{constructor(V,q){this._outgoingPrefix=V,this._incomingPrefix=q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(V,q,Y,Q,he){this._totalOutgoing+=V,z(this._outgoingPrefix,this._totalOutgoing,V,q,Y,Q,he)}logIncoming(V,q,Y,Q,he){this._totalIncoming+=V,z(this._incomingPrefix,this._totalIncoming,V,q,Y,Q,he)}}e.IPCLogger=O}),define(De[111],Ie([1,0,23,4,6,110]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var _;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(_=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let n=0;function c(f,y){if(!s.has(f)){const L=String(++n);s.set(f,L)}return s.get(f)}function d(f,y,L,M){if(!r.enableDiagnostics)return;const B=c(f,y);if(M instanceof l.VSBuffer||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const A=l.VSBuffer.alloc(M.byteLength);A.set(M),r.records.push({timestamp:Date.now(),id:B,label:y,type:L,buff:A})}else r.records.push({timestamp:Date.now(),id:B,label:y,type:L,data:M})}r.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=l.VSBuffer.alloc(0)),C}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,n){if(s===0)return R();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const y=this._chunks[0];return n&&(this._chunks.shift(),this._totalLength-=s),y}if(this._chunks[0].byteLength>s){const y=this._chunks[0].slice(0,s);return n&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),y}const c=l.VSBuffer.alloc(s);let d=0,f=0;for(;s>0;){const y=this._chunks[f];if(y.byteLength>s){const L=y.slice(0,s);c.set(L,d),d+=s,n&&(this._chunks[f]=y.slice(s),this._totalLength-=s),s-=s}else c.set(y,d),d+=y.byteLength,n?(this._chunks.shift(),this._totalLength-=y.byteLength):f++,s-=y.byteLength}return c}}e.ChunkStream=k;var S;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(S||(S={}));function T(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(s,n,c,d){this.type=s,this.id=n,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends D.Disposable{constructor(s){super(),this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(n=>this.acceptChunk(n))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const n=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=n.readUInt32BE(9),this._state.messageType=n.readUInt8(0),this._state.id=n.readUInt32BE(1),this._state.ack=n.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:T(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",n),this._onMessage.fire(new g(c,d,f,n)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const n=l.VSBuffer.alloc(13);n.writeUInt8(s.type,0),n.writeUInt32BE(s.id,1),n.writeUInt32BE(s.ack,5),n.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:T(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(n,s.data)}_bufferAdd(s,n){const c=this._totalLength===0;return this._data.push(s,n),this._totalLength+=s.byteLength+n.byteLength,c}_bufferTake(){const s=l.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,n){this._bufferAdd(s,n)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class v extends D.Disposable{constructor(s){super(),this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(n=>{n.type===1&&this._onMessage.fire(n.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new g(1,0,0,s))}}e.Protocol=v;class p extends P.IPCClient{constructor(s,n,c=null){super(s,n,c),this.protocol=s}static fromSocket(s,n){return new p(new v(s),n)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=p;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class h{constructor(s){this.data=s,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let s=0,n=this._first;for(;n;)n=n.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let n=0,c=this._first;for(;c;)s[n++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const n=new h(s);if(!this._first){this._first=n,this._last=n;return}this._last.next=n,this._last=n}}class u{constructor(){this.lastRuns=[];const s=Date.now();for(let n=0;n<u._HISTORY_LENGTH;n++)this.lastRuns[n]=s-1e3*n;setInterval(()=>{for(let n=u._HISTORY_LENGTH;n>=1;n--)this.lastRuns[n]=this.lastRuns[n-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const s=Date.now(),n=(1+u._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<u._HISTORY_LENGTH;d++)s-this.lastRuns[d]<=n&&c++;return 1-c/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class o{constructor(s,n=null,c=u.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),n&&this._socketReader.acceptChunk(n),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new g(5,0,0,R());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new g(7,0,0,R());this._socketWriter.write(s)}sendResume(){const s=new g(8,0,0,R());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,n){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(n)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,R());this._socketWriter.write(s);const n=this._outgoingUnackMsg.toArray();for(let c=0,d=n.length;c<d;c++)this._socketWriter.write(n[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const n=this._outgoingUnackMsg.peek();if(n&&n.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const n=Date.now();n-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=n,this._socketWriter.write(new g(6,0,0,R())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const n=this._outgoingUnackMsg.toArray();for(let c=0,d=n.length;c<d;c++)this._socketWriter.write(n[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const n=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new g(1,n,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const n=new g(2,0,0,s);this._socketWriter.write(n)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),n=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(n>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:n,timeSinceLastReceivedSomeData:c});return}const f=Math.max(2e4-n,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},f)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new g(3,0,this._incomingAckId,R());this._socketWriter.write(s)}_sendKeepAlive(){const s=new g(9,0,0,R());this._socketWriter.write(s)}}e.PersistentProtocol=o}),define(De[112],Ie([1,0,23,10,4,6,9,11,34,110,111]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function k(){return{crypto:J.__$__nodeRequire("crypto"),zlib:J.__$__nodeRequire("zlib"),net:J.__$__nodeRequire("net"),os:J.__$__nodeRequire("os")}}class S{constructor(c,d=""){this.debugLabel=d,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=f=>{if(this.traceSocketEvent("error",{code:f?.code,message:f?.message}),f){if(f.code==="EPIPE")return;(0,t.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,d){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,d)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const d=f=>{this.traceSocketEvent("read",f),c(l.VSBuffer.wrap(f))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(c){const d=f=>{this.traceSocketEvent("close",{hadError:f}),c({type:0,hadError:f,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(c){const d=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,t.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const f=()=>{this.socket.off("close",f),this.socket.off("end",f),this.socket.off("error",f),this.socket.off("timeout",f),this.socket.off("drain",f),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",f),this.socket.on("end",f),this.socket.on("error",f),this.socket.on("timeout",f),this.socket.on("drain",f)})}}e.NodeSocket=S;var T;(function(n){n[n.MinHeaderByteSize=2]="MinHeaderByteSize"})(T||(T={}));var E;(function(n){n[n.PeekHeader=1]="PeekHeader",n[n.ReadHeader=2]="ReadHeader",n[n.ReadBody=3]="ReadBody",n[n.Fin=4]="Fin"})(E||(E={}));class g extends P.Disposable{constructor(c,d,f,y){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:f?.byteLength||0,recordInflateBytes:y}),this._flowManager=this._register(new b(this,d,f,y,this._onData,(L,M)=>this._write(L,M))),this._register(this._flowManager.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this._onClose.fire({type:0,hadError:!0,error:L})})),this._incomingData=new R.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(L=>this._onClose.fire(L)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,d){this.socket.traceSocketEvent(c,d)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let f=2;c.byteLength<126?f+=0:c.byteLength<2**16?f+=2:f+=8;const y=l.VSBuffer.alloc(f);if(d?y.writeUInt8(194,0):y.writeUInt8(130,0),c.byteLength<126)y.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){y.writeUInt8(126,1);let L=1;y.writeUInt8(c.byteLength>>>8&255,++L),y.writeUInt8(c.byteLength>>>0&255,++L)}else{y.writeUInt8(127,1);let L=1;y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(0,++L),y.writeUInt8(c.byteLength>>>24&255,++L),y.writeUInt8(c.byteLength>>>16&255,++L),y.writeUInt8(c.byteLength>>>8&255,++L),y.writeUInt8(c.byteLength>>>0&255,++L)}this.socket.write(l.VSBuffer.concat([y,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),f=d.readUInt8(0),y=(f&128)>>>7,L=(f&64)>>>6,M=d.readUInt8(1),B=(M&128)>>>7,A=M&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(A===126?2:0)+(A===127?8:0),this._state.fin=y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(L)),this._state.firstFrameOfMessage=Boolean(y),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),f=d.readUInt8(1),y=(f&128)>>>7;let L=f&127,M=1;L===126?L=d.readUInt8(++M)*2**8+d.readUInt8(++M):L===127&&(L=d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*0+d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M));let B=0;y&&(B=d.readUInt8(++M)*2**24+d.readUInt8(++M)*2**16+d.readUInt8(++M)*2**8+d.readUInt8(++M)),this._state.state=3,this._state.readLen=L,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),p(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=g;class b extends P.Disposable{constructor(c,d,f,y,L,M){super(),this._tracer=c,this._onData=L,this._writeFn=M,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new m(this._tracer,y,f,{windowBits:15})),this._zlibDeflateStream=this._register(new v(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:l.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(d,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,d){return new Promise((f,y)=>{c.write(d),c.flush(L=>f(L))})}acceptFrame(c,d,f){this._readQueue.push({data:c,isCompressed:d,isLastFrameOfMessage:f}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,d,f){return new Promise((y,L)=>{c.write(d),f&&c.write(l.VSBuffer.fromByteArray([0,0,255,255])),c.flush(M=>y(M))})}}class m extends P.Disposable{constructor(c,d,f,y){super(),this._tracer=c,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=k().zlib.createInflateRaw(y),this._zlibInflate.on("error",L=>{this._tracer.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibInflate.on("data",L=>{this._tracer.traceSocketEvent("zlibInflateData",L),this._pendingInflateData.push(l.VSBuffer.wrap(L))}),f&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",f.buffer),this._zlibInflate.write(f.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?l.VSBuffer.concat(this._recordedInflateBytes):l.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=l.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(d)})}}class v extends P.Disposable{constructor(c,d){super(),this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=k().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",f=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:f?.message,code:f?.code}),this._onError.fire(f)}),this._zlibDeflate.on("data",f=>{this._tracer.traceSocketEvent("zlibDeflateData",f),this._pendingDeflateData.push(l.VSBuffer.wrap(f))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=l.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),c(d)})}}function p(n,c){if(c===0)return;const d=n.byteLength>>>2;for(let A=0;A<d;A++){const W=n.readUInt32BE(A*4);n.writeUInt32BE(W^c,A*4)}const f=d*4,y=n.byteLength-f,L=c>>>24&255,M=c>>>16&255,B=c>>>8&255;y>=1&&n.writeUInt8(n.readUInt8(f)^L,f),y>=2&&n.writeUInt8(n.readUInt8(f+1)^M,f+1),y>=3&&n.writeUInt8(n.readUInt8(f+2)^B,f+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const a={[2]:107,[1]:103};function h(){const n=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${n}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${n}.sock`):c=(0,_.join)(k().os.tmpdir(),`vscode-ipc-${n}.sock`),u(c),c}e.createRandomIPCHandle=h;function i(n,c,d){const f=k().crypto.createHash("md5").update(n).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${f}-${d}-${c}-sock`;let y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?y=(0,_.join)(e.XDG_RUNTIME_DIR,`vscode-${f.substr(0,8)}-${d}-${c}.sock`):y=(0,_.join)(n,`${d}-${c}.sock`),u(y),y}e.createStaticIPCHandle=i;function u(n){const c=a[I.platform];typeof c=="number"&&n.length>=c&&console.warn(`WARNING: IPC handle "${n}" is longer than ${c} chars, try a shorter --user-data-dir`)}class o extends C.IPCServer{constructor(c){super(o.toClientConnectionEvent(c)),this.server=c}static toClientConnectionEvent(c){const d=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(d,f=>({protocol:new R.Protocol(new S(f,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(f,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function r(n){return new Promise((c,d)=>{const f=k().net.createServer();f.on("error",d),f.listen(n,()=>{f.removeListener("error",d),c(new o(f))})})}e.serve=r;function s(n,c){return new Promise((d,f)=>{const y=k().net.createConnection(n,()=>{y.removeListener("error",f),d(R.Client.fromSocket(new S(y,`ipc-client${c}`),c))});y.once("error",f)})}e.connect=s}),define(De[157],Ie([1,0,36,9]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(P,_,I,w,C,R){if(Array.isArray(P)){let k=0;for(const S of P){const T=D(S,_,I,w,C,R);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof P=="string")return w?P==="*"?5:P===I?10:0:0;if(P){const{language:k,pattern:S,scheme:T,hasAccessToAllModels:E,notebookType:g}=P;if(!w&&!E)return 0;g&&C&&(_=C);let b=0;if(T)if(T===_.scheme)b=10;else if(T==="*")b=5;else return 0;if(k)if(k===I)b=10;else if(k==="*")b=Math.max(b,5);else return 0;if(g)if(g===R)b=10;else if(g==="*"&&R!==void 0)b=Math.max(b,5);else return 0;if(S){let m;if(typeof S=="string"?m=S:m={...S,base:(0,t.normalize)(S.base)},m===_.fsPath||(0,l.match)(m,_.fsPath))b=10;else return 0}return b}else return 0}}e.score=D}),define(De[158],Ie([1,0,8,49,150]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(I,w,C,R){this._uri=I,this._lines=w,this._eol=C,this._versionId=R,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const w=I.changes;for(const C of w)this._acceptDeleteRange(C.range),this._acceptInsertText(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,w=this._lines.length,C=new Uint32Array(w);for(let R=0;R<w;R++)C[R]=this._lines[R].length+I;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(I,w){this._lines[I]=w,this._lineStarts&&this._lineStarts.setValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,w){if(w.length===0)return;const C=(0,l.splitLines)(w);if(C.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}C[C.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]);const R=new Uint32Array(C.length-1);for(let k=1;k<C.length;k++)this._lines.splice(I.lineNumber+k-1,0,C[k]),R[k-1]=C[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,R)}}e.MirrorTextModel=P}),define(De[159],Ie([1,0,8,147,49,35,99]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class w{constructor(v,p,a,h){this.searchString=v,this.isRegex=p,this.matchCase=a,this.wordSeparators=h}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=C(this.searchString):v=this.searchString.indexOf(`
`)>=0;let p=null;try{p=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!p)return null;let a=!this.isRegex&&!v;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new _.SearchData(p,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,a?this.searchString:null)}}e.SearchParams=w;function C(m){if(!m||m.length===0)return!1;for(let v=0,p=m.length;v<p;v++){const a=m.charCodeAt(v);if(a===10)return!0;if(a===92){if(v++,v>=p)break;const h=m.charCodeAt(v);if(h===110||h===114||h===87)return!0}}return!1}e.isMultilineRegexSource=C;function R(m,v,p){if(!p)return new _.FindMatch(m,null);const a=[];for(let h=0,i=v.length;h<i;h++)a[h]=v[h];return new _.FindMatch(m,a)}e.createFindMatch=R;class k{constructor(v){const p=[];let a=0;for(let h=0,i=v.length;h<i;h++)v.charCodeAt(h)===10&&(p[a++]=h);this._lineFeedsOffsets=p}findLineFeedCountBeforeOffset(v){const p=this._lineFeedsOffsets;let a=0,h=p.length-1;if(h===-1||v<=p[0])return 0;for(;a<h;){const i=a+((h-a)/2>>0);p[i]>=v?h=i-1:p[i+1]>=v?(a=i,h=i):a=i+1}return a+1}}class S{static findMatches(v,p,a,h,i){const u=p.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(v,a,new b(u.wordSeparators,u.regex),h,i):this._doFindMatchesLineByLine(v,a,u,h,i):[]}static _getMultilineMatchRange(v,p,a,h,i,u){let o,r=0;h?(r=h.findLineFeedCountBeforeOffset(i),o=p+i+r):o=p+i;let s;if(h){const f=h.findLineFeedCountBeforeOffset(i+u.length)-r;s=o+u.length+f}else s=o+u.length;const n=v.getPositionAt(o),c=v.getPositionAt(s);return new P.Range(n.lineNumber,n.column,c.lineNumber,c.column)}static _doFindMatchesMultiline(v,p,a,h,i){const u=v.getOffsetAt(p.getStartPosition()),o=v.getValueInRange(p,1),r=v.getEOL()===`\r
`?new k(o):null,s=[];let n=0,c;for(a.reset(0);c=a.next(o);)if(s[n++]=R(this._getMultilineMatchRange(v,u,o,r,c.index,c[0]),c,h),n>=i)return s;return s}static _doFindMatchesLineByLine(v,p,a,h,i){const u=[];let o=0;if(p.startLineNumber===p.endLineNumber){const s=v.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return o=this._findMatchesInLine(a,s,p.startLineNumber,p.startColumn-1,o,u,h,i),u}const r=v.getLineContent(p.startLineNumber).substring(p.startColumn-1);o=this._findMatchesInLine(a,r,p.startLineNumber,p.startColumn-1,o,u,h,i);for(let s=p.startLineNumber+1;s<p.endLineNumber&&o<i;s++)o=this._findMatchesInLine(a,v.getLineContent(s),s,0,o,u,h,i);if(o<i){const s=v.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);o=this._findMatchesInLine(a,s,p.endLineNumber,0,o,u,h,i)}return u}static _findMatchesInLine(v,p,a,h,i,u,o,r){const s=v.wordSeparators;if(!o&&v.simpleSearch){const d=v.simpleSearch,f=d.length,y=p.length;let L=-f;for(;(L=p.indexOf(d,L+f))!==-1;)if((!s||g(s,p,y,L,f))&&(u[i++]=new _.FindMatch(new P.Range(a,L+1+h,a,L+1+f+h),null),i>=r))return i;return i}const n=new b(v.wordSeparators,v.regex);let c;n.reset(0);do if(c=n.next(p),c&&(u[i++]=R(new P.Range(a,c.index+1+h,a,c.index+1+c[0].length+h),c,o),i>=r))return i;while(c);return i}static findNextMatch(v,p,a,h){const i=p.parseSearchRequest();if(!i)return null;const u=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(v,a,u,h):this._doFindNextMatchLineByLine(v,a,u,h)}static _doFindNextMatchMultiline(v,p,a,h){const i=new D.Position(p.lineNumber,1),u=v.getOffsetAt(i),o=v.getLineCount(),r=v.getValueInRange(new P.Range(i.lineNumber,i.column,o,v.getLineMaxColumn(o)),1),s=v.getEOL()===`\r
`?new k(r):null;a.reset(p.column-1);const n=a.next(r);return n?R(this._getMultilineMatchRange(v,u,r,s,n.index,n[0]),n,h):p.lineNumber!==1||p.column!==1?this._doFindNextMatchMultiline(v,new D.Position(1,1),a,h):null}static _doFindNextMatchLineByLine(v,p,a,h){const i=v.getLineCount(),u=p.lineNumber,o=v.getLineContent(u),r=this._findFirstMatchInLine(a,o,u,p.column,h);if(r)return r;for(let s=1;s<=i;s++){const n=(u+s-1)%i,c=v.getLineContent(n+1),d=this._findFirstMatchInLine(a,c,n+1,1,h);if(d)return d}return null}static _findFirstMatchInLine(v,p,a,h,i){v.reset(h-1);const u=v.next(p);return u?R(new P.Range(a,u.index+1,a,u.index+1+u[0].length),u,i):null}static findPreviousMatch(v,p,a,h){const i=p.parseSearchRequest();if(!i)return null;const u=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(v,a,u,h):this._doFindPreviousMatchLineByLine(v,a,u,h)}static _doFindPreviousMatchMultiline(v,p,a,h){const i=this._doFindMatchesMultiline(v,new P.Range(1,1,p.lineNumber,p.column),a,h,10*I);if(i.length>0)return i[i.length-1];const u=v.getLineCount();return p.lineNumber!==u||p.column!==v.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(v,new D.Position(u,v.getLineMaxColumn(u)),a,h):null}static _doFindPreviousMatchLineByLine(v,p,a,h){const i=v.getLineCount(),u=p.lineNumber,o=v.getLineContent(u).substring(0,p.column-1),r=this._findLastMatchInLine(a,o,u,h);if(r)return r;for(let s=1;s<=i;s++){const n=(i+u-s-1)%i,c=v.getLineContent(n+1),d=this._findLastMatchInLine(a,c,n+1,h);if(d)return d}return null}static _findLastMatchInLine(v,p,a,h){let i=null,u;for(v.reset(0);u=v.next(p);)i=R(new P.Range(a,u.index+1,a,u.index+1+u[0].length),u,h);return i}}e.TextModelSearch=S;function T(m,v,p,a,h){if(a===0)return!0;const i=v.charCodeAt(a-1);if(m.get(i)!==0||i===13||i===10)return!0;if(h>0){const u=v.charCodeAt(a);if(m.get(u)!==0)return!0}return!1}function E(m,v,p,a,h){if(a+h===p)return!0;const i=v.charCodeAt(a+h);if(m.get(i)!==0||i===13||i===10)return!0;if(h>0){const u=v.charCodeAt(a+h-1);if(m.get(u)!==0)return!0}return!1}function g(m,v,p,a,h){return T(m,v,p,a,h)&&E(m,v,p,a,h)}e.isValidMatch=g;class b{constructor(v,p){this._wordSeparators=v,this._searchRegex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const p=v.length;let a;do{if(this._prevMatchStartIndex+this._prevMatchLength===p||(a=this._searchRegex.exec(v),!a))return null;const h=a.index,i=a[0].length;if(h===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){l.getNextCodePoint(v,p,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=h,this._prevMatchLength=i,!this._wordSeparators||g(this._wordSeparators,v,p,h,i))return a}while(a);return null}}e.Searcher=b}),define(De[113],Ie([1,0,23,11]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function P(k){for(let S=0,T=k.length;S<T;S+=4){const E=k[S+0],g=k[S+1],b=k[S+2],m=k[S+3];k[S+0]=m,k[S+1]=b,k[S+2]=g,k[S+3]=E}}function _(k){const S=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return t.isLittleEndian()||P(S),l.VSBuffer.wrap(S)}function I(k){const S=k.buffer;if(t.isLittleEndian()||P(S),S.byteOffset%4===0)return new Uint32Array(S.buffer,S.byteOffset,S.length/4);{const T=new Uint8Array(S.byteLength);return T.set(S),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function w(k){const S=new Uint32Array(C(k));let T=0;if(S[T++]=k.id,k.type==="full")S[T++]=1,S[T++]=k.data.length,S.set(k.data,T),T+=k.data.length;else{S[T++]=2,S[T++]=k.deltas.length;for(const E of k.deltas)S[T++]=E.start,S[T++]=E.deleteCount,E.data?(S[T++]=E.data.length,S.set(E.data,T),T+=E.data.length):S[T++]=0}return _(S)}e.encodeSemanticTokensDto=w;function C(k){let S=0;if(S+=1+1,k.type==="full")S+=1+k.data.length;else{S+=1,S+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(S+=T.data.length)}return S}function R(k){const S=I(k);let T=0;const E=S[T++];if(S[T++]===1){const v=S[T++],p=S.subarray(T,T+v);return T+=v,{id:E,type:"full",data:p}}const b=S[T++],m=[];for(let v=0;v<b;v++){const p=S[T++],a=S[T++],h=S[T++];let i;h>0&&(i=S.subarray(T,T+h),T+=h),m[v]={start:p,deleteCount:a,data:i}}return{id:E,type:"delta",deltas:m}}e.decodeSemanticTokensDto=R}),define(De[160],Ie([1,0,4,6]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class D{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,w){return this._map.set(I,w),this.fire([I]),(0,t.toDisposable)(()=>{this._map.get(I)===w&&(this._map.delete(I),this.fire([I]))})}registerFactory(I,w){this._factories.get(I)?.dispose();const C=new P(this,I,w);return this._factories.set(I,C),(0,t.toDisposable)(()=>{const R=this._factories.get(I);!R||R!==C||(this._factories.delete(I),R.dispose())})}async getOrCreate(I){const w=this.get(I);if(w)return w;const C=this._factories.get(I);return!C||C.isResolved?null:(await C.resolve(),this.get(I))}get(I){return this._map.get(I)||null}isResolved(I){if(this.get(I))return!0;const C=this._factories.get(I);return!!(!C||C.isResolved)}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=D;class P extends t.Disposable{constructor(I,w,C){super(),this._registry=I,this._languageId=w,this._factory=C,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const I=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,I&&!this._isDisposed&&this._register(this._registry.register(this._languageId,I))}}}),define(De[63],Ie([1,0,75,2,35,160]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class _{constructor(f,y,L){this._tokenBrand=void 0,this.offset=f,this.type=y,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=_;class I{constructor(f,y){this._tokenizationResultBrand=void 0,this.tokens=f,this.endState=y}}e.TokenizationResult=I;class w{constructor(f,y){this._encodedTokenizationResultBrand=void 0,this.tokens=f,this.endState=y}}e.EncodedTokenizationResult=w;var C;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(d){const f=new Map;f.set(0,l.Codicon.symbolMethod),f.set(1,l.Codicon.symbolFunction),f.set(2,l.Codicon.symbolConstructor),f.set(3,l.Codicon.symbolField),f.set(4,l.Codicon.symbolVariable),f.set(5,l.Codicon.symbolClass),f.set(6,l.Codicon.symbolStruct),f.set(7,l.Codicon.symbolInterface),f.set(8,l.Codicon.symbolModule),f.set(9,l.Codicon.symbolProperty),f.set(10,l.Codicon.symbolEvent),f.set(11,l.Codicon.symbolOperator),f.set(12,l.Codicon.symbolUnit),f.set(13,l.Codicon.symbolValue),f.set(15,l.Codicon.symbolEnum),f.set(14,l.Codicon.symbolConstant),f.set(15,l.Codicon.symbolEnum),f.set(16,l.Codicon.symbolEnumMember),f.set(17,l.Codicon.symbolKeyword),f.set(27,l.Codicon.symbolSnippet),f.set(18,l.Codicon.symbolText),f.set(19,l.Codicon.symbolColor),f.set(20,l.Codicon.symbolFile),f.set(21,l.Codicon.symbolReference),f.set(22,l.Codicon.symbolCustomColor),f.set(23,l.Codicon.symbolFolder),f.set(24,l.Codicon.symbolTypeParameter),f.set(25,l.Codicon.account),f.set(26,l.Codicon.issues);function y(B){let A=f.get(B);return A||(console.info("No codicon found for CompletionItemKind "+B),A=l.Codicon.symbolProperty),A}d.toIcon=y;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function M(B,A){let W=L.get(B);return typeof W>"u"&&!A&&(W=9),W}d.fromString=M})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var k;(function(d){d[d.Deprecated=1]="Deprecated"})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var g;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(g=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var b;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(b=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(d){return d&&t.URI.isUri(d.uri)&&D.Range.isIRange(d.range)&&(D.Range.isIRange(d.originSelectionRange)||D.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=v;var p;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var a;(function(d){d[d.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var h;(function(d){const f=new Map;f.set(0,l.Codicon.symbolFile),f.set(1,l.Codicon.symbolModule),f.set(2,l.Codicon.symbolNamespace),f.set(3,l.Codicon.symbolPackage),f.set(4,l.Codicon.symbolClass),f.set(5,l.Codicon.symbolMethod),f.set(6,l.Codicon.symbolProperty),f.set(7,l.Codicon.symbolField),f.set(8,l.Codicon.symbolConstructor),f.set(9,l.Codicon.symbolEnum),f.set(10,l.Codicon.symbolInterface),f.set(11,l.Codicon.symbolFunction),f.set(12,l.Codicon.symbolVariable),f.set(13,l.Codicon.symbolConstant),f.set(14,l.Codicon.symbolString),f.set(15,l.Codicon.symbolNumber),f.set(16,l.Codicon.symbolBoolean),f.set(17,l.Codicon.symbolArray),f.set(18,l.Codicon.symbolObject),f.set(19,l.Codicon.symbolKey),f.set(20,l.Codicon.symbolNull),f.set(21,l.Codicon.symbolEnumMember),f.set(22,l.Codicon.symbolStruct),f.set(23,l.Codicon.symbolEvent),f.set(24,l.Codicon.symbolOperator),f.set(25,l.Codicon.symbolTypeParameter);function y(L){let M=f.get(L);return M||(console.info("No codicon found for SymbolKind "+L),M=l.Codicon.symbolProperty),M}d.toIcon=y})(h=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(f){this.value=f}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var u;(function(d){function f(y){return!y||typeof y!="object"?!1:typeof y.id=="string"&&typeof y.title=="string"}d.is=f})(u=e.Command||(e.Command={}));var o;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(o=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var r;(function(d){d[d.Unresolved=0]="Unresolved",d[d.Resolved=1]="Resolved"})(r=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var n;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(n=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new P.TokenizationRegistry;var c;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(c=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[161],Ie([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(De[114],Ie([1,0,161,11,98,17,24,146]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var w;(function(re){re[re.None=0]="None",re[re.Keep=1]="Keep",re[re.Brackets=2]="Brackets",re[re.Advanced=3]="Advanced",re[re.Full=4]="Full"})(w=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=C;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class k{constructor(se,Ee,ue,ke){this.id=se,this.name=Ee,this.defaultValue=ue,this.schema=ke}applyUpdate(se,Ee){return T(se,Ee)}compute(se,Ee,ue){return ue}}class S{constructor(se,Ee){this.newValue=se,this.didChange=Ee}}e.ApplyUpdateResult=S;function T(re,se){if(typeof re!="object"||typeof se!="object"||!re||!se)return new S(se,re!==se);if(Array.isArray(re)||Array.isArray(se)){const ue=Array.isArray(re)&&Array.isArray(se)&&P.equals(re,se);return new S(se,!ue)}let Ee=!1;for(const ue in se)if(se.hasOwnProperty(ue)){const ke=T(re[ue],se[ue]);ke.didChange&&(re[ue]=ke.newValue,Ee=!0)}return new S(re,Ee)}class E{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return this.defaultValue}}class g{constructor(se,Ee,ue,ke){this.id=se,this.name=Ee,this.defaultValue=ue,this.schema=ke}applyUpdate(se,Ee){return T(se,Ee)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ee,ue){return ue}}function b(re,se){return typeof re>"u"?se:re==="false"?!1:Boolean(re)}e.boolean=b;class m extends g{constructor(se,Ee,ue,ke=void 0){typeof ke<"u"&&(ke.type="boolean",ke.default=ue),super(se,Ee,ue,ke)}validate(se){return b(se,this.defaultValue)}}function v(re,se,Ee,ue){if(typeof re>"u")return se;let ke=parseInt(re,10);return isNaN(ke)?se:(ke=Math.max(Ee,ke),ke=Math.min(ue,ke),ke|0)}e.clampedInt=v;class p extends g{constructor(se,Ee,ue,ke,Ne,Be=void 0){typeof Be<"u"&&(Be.type="integer",Be.default=ue,Be.minimum=ke,Be.maximum=Ne),super(se,Ee,ue,Be),this.minimum=ke,this.maximum=Ne}static clampedInt(se,Ee,ue,ke){return v(se,Ee,ue,ke)}validate(se){return p.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class a extends g{constructor(se,Ee,ue,ke,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=ue),super(se,Ee,ue,Ne),this.validationFn=ke}static clamp(se,Ee,ue){return se<Ee?Ee:se>ue?ue:se}static float(se,Ee){if(typeof se=="number")return se;if(typeof se>"u")return Ee;const ue=parseFloat(se);return isNaN(ue)?Ee:ue}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class h extends g{static string(se,Ee){return typeof se!="string"?Ee:se}constructor(se,Ee,ue,ke=void 0){typeof ke<"u"&&(ke.type="string",ke.default=ue),super(se,Ee,ue,ke)}validate(se){return h.string(se,this.defaultValue)}}function i(re,se,Ee){return typeof re!="string"||Ee.indexOf(re)===-1?se:re}e.stringSet=i;class u extends g{constructor(se,Ee,ue,ke,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=ke,Ne.default=ue),super(se,Ee,ue,Ne),this._allowedValues=ke}validate(se){return i(se,this.defaultValue,this._allowedValues)}}class o extends k{constructor(se,Ee,ue,ke,Ne,Be,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.enum=Ne,ze.default=ke),super(se,Ee,ue,ze),this._allowedValues=Ne,this._convert=Be}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function r(re){switch(re){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ee,ue){return ue===0?se.accessibilitySupport:ue}}class n extends k{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:l.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertSpace:b(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(re){re[re.Hidden=0]="Hidden",re[re.Blink=1]="Blink",re[re.Smooth=2]="Smooth",re[re.Phase=3]="Phase",re[re.Expand=4]="Expand",re[re.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(re){switch(re){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(re){re[re.Line=1]="Line",re[re.Block=2]="Block",re[re.Underline=3]="Underline",re[re.LineThin=4]="LineThin",re[re.BlockOutline=5]="BlockOutline",re[re.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(re){switch(re){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(re){switch(re){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class M extends E{constructor(){super(130)}compute(se,Ee,ue){const ke=["monaco-editor"];return Ee.get(34)&&ke.push(Ee.get(34)),se.extraEditorClassName&&ke.push(se.extraEditorClassName),Ee.get(67)==="default"?ke.push("mouse-default"):Ee.get(67)==="copy"&&ke.push("mouse-copy"),Ee.get(101)&&ke.push("showUnused"),Ee.get(128)&&ke.push("showDeprecated"),ke.join(" ")}}class B extends m{constructor(){super(33,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(se,Ee,ue){return ue&&se.emptySelectionClipboard}}class A extends k{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:l.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:l.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{cursorMoveOnType:b(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":i(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":i(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(Ee.loop,this.defaultValue.loop)}}}class W extends k{constructor(){super(46,"fontLigatures",W.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?W.OFF:se==="true"?W.ON:se:Boolean(se)?W.ON:W.OFF}}e.EditorFontLigatures=W,W.OFF='"liga" off, "calt" off',W.ON='"liga" on, "calt" on';class U extends E{constructor(){super(45)}compute(se,Ee,ue){return se.fontInfo}}class N extends g{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(se){const Ee=a.float(se,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ee,6,100)}compute(se,Ee,ue){return se.fontInfo.fontSize}}class G extends k{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.MINIMUM_VALUE,maximum:G.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(se){return se==="normal"||se==="bold"?se:String(p.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,G.MINIMUM_VALUE,G.MAXIMUM_VALUE))}}G.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],G.MINIMUM_VALUE=1,G.MAXIMUM_VALUE=1e3;class z extends k{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:ue,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:ue,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:ue,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:ue,description:l.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{multiple:i(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??i(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??i(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??i(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??i(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??i(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:h.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:h.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:h.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:h.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:h.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends k{constructor(){const se={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:se.above,description:l.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),delay:p.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:b(Ee.sticky,this.defaultValue.sticky),above:b(Ee.above,this.defaultValue.above)}}}var x;(function(re){re[re.None=0]="None",re[re.Text=1]="Text",re[re.Blocks=2]="Blocks"})(x=e.RenderMinimap||(e.RenderMinimap={}));class V extends E{constructor(){super(133)}compute(se,Ee,ue){return V.computeLayout(Ee,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const Ee=se.height/se.lineHeight,ue=se.scrollBeyondLastLine?Ee-1:0,ke=(se.viewLineCount+ue)/(se.pixelRatio*se.height),Ne=Math.floor(se.viewLineCount/ke);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:ue,desiredRatio:ke,minimapLineCount:Ne}}static _computeMinimapLayout(se,Ee){const ue=se.outerWidth,ke=se.outerHeight,Ne=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ke};const Be=Ee.stableMinimapLayoutInput,ze=Be&&se.outerHeight===Be.outerHeight&&se.lineHeight===Be.lineHeight&&se.typicalHalfwidthCharacterWidth===Be.typicalHalfwidthCharacterWidth&&se.pixelRatio===Be.pixelRatio&&se.scrollBeyondLastLine===Be.scrollBeyondLastLine&&se.minimap.enabled===Be.minimap.enabled&&se.minimap.side===Be.minimap.side&&se.minimap.size===Be.minimap.size&&se.minimap.showSlider===Be.minimap.showSlider&&se.minimap.renderCharacters===Be.minimap.renderCharacters&&se.minimap.maxColumn===Be.minimap.maxColumn&&se.minimap.scale===Be.minimap.scale&&se.verticalScrollbarWidth===Be.verticalScrollbarWidth&&se.isViewportWrapping===Be.isViewportWrapping,Qe=se.lineHeight,nt=se.typicalHalfwidthCharacterWidth,ct=se.scrollBeyondLastLine,st=se.minimap.renderCharacters;let et=Ne>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const mt=se.minimap.maxColumn,wt=se.minimap.size,Ct=se.minimap.side,ft=se.verticalScrollbarWidth,Dt=se.viewLineCount,Ft=se.remainingWidth,Ut=se.isViewportWrapping,Ge=st?2:3;let Nt=Math.floor(Ne*ke);const Rt=Nt/Ne;let Lt=!1,vt=!1,It=Ge*et,Ae=et/Ne,Re=1;if(wt==="fill"||wt==="fit"){const{typicalViewportLineCount:Je,extraLinesBeyondLastLine:lt,desiredRatio:kt,minimapLineCount:Et}=V.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:ct,height:ke,lineHeight:Qe,pixelRatio:Ne});if(Dt/Et>1)Lt=!0,vt=!0,et=1,It=1,Ae=et/Ne;else{let St=!1,gt=et+1;if(wt==="fit"){const Tt=Math.ceil((Dt+lt)*It);Ut&&ze&&Ft<=Ee.stableFitRemainingWidth?(St=!0,gt=Ee.stableFitMaxMinimapScale):St=Tt>Nt}if(wt==="fill"||St){Lt=!0;const Tt=et;It=Math.min(Qe*Ne,Math.max(1,Math.floor(1/kt))),Ut&&ze&&Ft<=Ee.stableFitRemainingWidth&&(gt=Ee.stableFitMaxMinimapScale),et=Math.min(gt,Math.max(1,Math.floor(It/Ge))),et>Tt&&(Re=Math.min(2,et/Tt)),Ae=et/Ne/Re,Nt=Math.ceil(Math.max(Je,Dt+lt)*It),Ut?(Ee.stableMinimapLayoutInput=se,Ee.stableFitRemainingWidth=Ft,Ee.stableFitMaxMinimapScale=et):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const _e=Math.floor(mt*Ae),te=Math.min(_e,Math.max(0,Math.floor((Ft-ft-2)*Ae/(nt+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ne*te);const je=Fe/Ne;Fe=Math.floor(Fe*Re);const it=st?1:2,Ke=Ct==="left"?0:ue-te-ft;return{renderMinimap:it,minimapLeft:Ke,minimapWidth:te,minimapHeightIsEditorHeight:Lt,minimapIsSampling:vt,minimapScale:et,minimapLineHeight:It,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:je,minimapCanvasOuterHeight:Rt}}static computeLayout(se,Ee){const ue=Ee.outerWidth|0,ke=Ee.outerHeight|0,Ne=Ee.lineHeight|0,Be=Ee.lineNumbersDigitCount|0,ze=Ee.typicalHalfwidthCharacterWidth,Qe=Ee.maxDigitWidth,nt=Ee.pixelRatio,ct=Ee.viewLineCount,st=se.get(125),et=st==="inherit"?se.get(124):st,mt=et==="inherit"?se.get(120):et,wt=se.get(123),Ct=se.get(2),ft=Ee.isDominatedByLongLines,Dt=se.get(51),Ft=se.get(61).renderType!==0,Ut=se.get(62),Ge=se.get(95),Nt=se.get(66),Rt=se.get(93),Lt=Rt.verticalScrollbarSize,vt=Rt.verticalHasArrows,It=Rt.arrowSize,Ae=Rt.horizontalScrollbarSize,Re=se.get(59),_e=se.get(38),te=se.get(100)!=="never";let Fe;if(typeof Re=="string"&&/^\d+(\.\d+)?ch$/.test(Re)){const xt=parseFloat(Re.substr(0,Re.length-2));Fe=p.clampedInt(xt*ze,0,0,1e3)}else Fe=p.clampedInt(Re,0,0,1e3);_e&&te&&(Fe+=16);let je=0;if(Ft){const xt=Math.max(Be,Ut);je=Math.round(xt*Qe)}let it=0;Dt&&(it=Ne);let Ke=0,Je=Ke+it,lt=Je+je,kt=lt+Fe;const Et=ue-it-je-Fe;let yt=!1,St=!1,gt=-1;Ct!==2&&(et==="inherit"&&ft?(yt=!0,St=!0):mt==="on"||mt==="bounded"?St=!0:mt==="wordWrapColumn"&&(gt=wt));const Tt=V._computeMinimapLayout({outerWidth:ue,outerHeight:ke,lineHeight:Ne,typicalHalfwidthCharacterWidth:ze,pixelRatio:nt,scrollBeyondLastLine:Ge,minimap:Nt,verticalScrollbarWidth:Lt,viewLineCount:ct,remainingWidth:Et,isViewportWrapping:St},Ee.memory||new R);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(Ke+=Tt.minimapWidth,Je+=Tt.minimapWidth,lt+=Tt.minimapWidth,kt+=Tt.minimapWidth);const Qt=Et-Tt.minimapWidth,bt=Math.max(1,Math.floor((Qt-Lt-2)/ze)),qt=vt?It:0;return St&&(gt=Math.max(1,bt),mt==="bounded"&&(gt=Math.min(gt,wt))),{width:ue,height:ke,glyphMarginLeft:Ke,glyphMarginWidth:it,lineNumbersLeft:Je,lineNumbersWidth:je,decorationsLeft:lt,decorationsWidth:Fe,contentLeft:kt,contentWidth:Qt,minimap:Tt,viewportColumn:bt,isWordWrapMinified:yt,isViewportWrapping:St,wrappingColumn:gt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:Ae,overviewRuler:{top:qt,width:Lt,height:ke-2*qt,right:0}}}}e.EditorLayoutInfoComputer=V;class q extends k{constructor(){const se={enabled:!0};super(58,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:l.localize(43,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}class Y extends k{constructor(){const se={enabled:!1,maxLineCount:5};super(105,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:l.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:l.localize(45,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Q extends k{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:l.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(47,null),l.localize(48,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(49,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),l.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:l.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:l.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:l.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:i(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:h.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:b(Ee.padding,this.defaultValue.padding)}}}class he extends a{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:l.localize(54,null)})}compute(se,Ee,ue){return se.fontInfo.lineHeight}}class ve extends k{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:l.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:l.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(57,null),l.localize(58,null),l.localize(59,null)],default:se.size,description:l.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:l.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:l.localize(62,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:l.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:l.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),autohide:b(Ee.autohide,this.defaultValue.autohide),size:i(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Ee.side,this.defaultValue.side,["right","left"]),showSlider:i(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(Ee.scale,1,1,3),maxColumn:p.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(re){return re==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class pe extends k{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(67,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{top:p.clampedInt(Ee.top,0,0,1e3),bottom:p.clampedInt(Ee.bottom,0,0,1e3)}}}class be extends k{constructor(){const se={enabled:!0,cycle:!1};super(77,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:l.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:l.localize(69,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),cycle:b(Ee.cycle,this.defaultValue.cycle)}}}class Te extends E{constructor(){super(131)}compute(se,Ee,ue){return se.pixelRatio}}class Le extends k{constructor(){const se={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(70,null),l.localize(71,null),l.localize(72,null)]}];super(80,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:se.strings,description:l.localize(73,null)},comments:{anyOf:Ee,default:se.comments,description:l.localize(74,null)},other:{anyOf:Ee,default:se.other,description:l.localize(75,null)}},default:se,markdownDescription:l.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const nt=se?"on":"off";return{comments:nt,strings:nt,other:nt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ee,comments:ue,strings:ke}=se,Ne=["on","inline","off"];let Be,ze,Qe;return typeof Ee=="boolean"?Be=Ee?"on":"off":Be=i(Ee,this.defaultValue.other,Ne),typeof ue=="boolean"?ze=ue?"on":"off":ze=i(ue,this.defaultValue.comments,Ne),typeof ke=="boolean"?Qe=ke?"on":"off":Qe=i(ke,this.defaultValue.strings,Ne),{other:Be,comments:ze,strings:Qe}}}var We;(function(re){re[re.Off=0]="Off",re[re.On=1]="On",re[re.Relative=2]="Relative",re[re.Interval=3]="Interval",re[re.Custom=4]="Custom"})(We=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends k{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(77,null),l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"on",description:l.localize(81,null)})}validate(se){let Ee=this.defaultValue.renderType,ue=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ee=4,ue=se):se==="interval"?Ee=3:se==="relative"?Ee=2:se==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:ue}}}function le(re){const se=re.get(88);return se==="editable"?re.get(82):se!=="on"}e.filterValidationDecorations=le;class me extends k{constructor(){const se=[],Ee={type:"number",description:l.localize(82,null)};super(92,"rulers",se,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:l.localize(83,null),format:"color-hex"}}}]},default:se,description:l.localize(84,null)})}validate(se){if(Array.isArray(se)){const Ee=[];for(const ue of se)if(typeof ue=="number")Ee.push({column:p.clampedInt(ue,0,0,1e4),color:null});else if(ue&&typeof ue=="object"){const ke=ue;Ee.push({column:p.clampedInt(ke.column,0,0,1e4),color:ke.color})}return Ee.sort((ue,ke)=>ue.column-ke.column),Ee}return this.defaultValue}}function Z(re,se){if(typeof re!="string")return se;switch(re){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends k{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(85,null),l.localize(86,null),l.localize(87,null)],default:"auto",description:l.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(89,null),l.localize(90,null),l.localize(91,null)],default:"auto",description:l.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:l.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:l.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:l.localize(95,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se,ue=p.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ke=p.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Z(Ee.vertical,this.defaultValue.vertical),horizontal:Z(Ee.horizontal,this.defaultValue.horizontal),useShadows:b(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ue,horizontalSliderSize:p.clampedInt(Ee.horizontalSliderSize,ue,0,1e3),verticalScrollbarSize:ke,verticalSliderSize:p.clampedInt(Ee.verticalSliderSize,ke,0,1e3),scrollByPage:b(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ee extends k{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:l.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:l.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:l.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:l.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:l.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:l.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:l.localize(102,null)}})}applyUpdate(se,Ee){let ue=!1;Ee.allowedCharacters&&se&&(_.equals(se.allowedCharacters,Ee.allowedCharacters)||(se={...se,allowedCharacters:Ee.allowedCharacters},ue=!0)),Ee.allowedLocales&&se&&(_.equals(se.allowedLocales,Ee.allowedLocales)||(se={...se,allowedLocales:Ee.allowedLocales},ue=!0));const ke=super.applyUpdate(se,Ee);return ue?new S(ke.newValue,!0):ke}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{nonBasicASCII:K(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:K(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:K(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(se.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(se,Ee){if(typeof se!="object"||!se)return Ee;const ue={};for(const[ke,Ne]of Object.entries(se))Ne===!0&&(ue[ke]=!0);return ue}}class ie extends k{constructor(){const se={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:l.localize(103,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),mode:i(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class F extends k{constructor(){const se={enabled:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:l.localize(105,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{enabled:b(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(106,null),l.localize(107,null),l.localize(108,null)],default:se.bracketPairs,description:l.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(110,null),l.localize(111,null),l.localize(112,null)],default:se.bracketPairsHorizontal,description:l.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:l.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:l.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(116,null),l.localize(117,null),l.localize(118,null)],default:se.highlightActiveIndentation,description:l.localize(119,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{bracketPairs:K(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:K(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:K(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function K(re,se,Ee){const ue=Ee.indexOf(re);return ue===-1?se:Ee[ue]}class X extends k{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(120,null),l.localize(121,null)],default:se.insertMode,description:l.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:l.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:l.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:l.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:l.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:l.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:l.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:l.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:l.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ee=se;return{insertMode:i(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:b(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:b(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:b(Ee.preview,this.defaultValue.preview),previewMode:i(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(Ee.showMethods,this.defaultValue.showMethods),showFunctions:b(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:b(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(Ee.showFields,this.defaultValue.showFields),showVariables:b(Ee.showVariables,this.defaultValue.showVariables),showClasses:b(Ee.showClasses,this.defaultValue.showClasses),showStructs:b(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:b(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:b(Ee.showModules,this.defaultValue.showModules),showProperties:b(Ee.showProperties,this.defaultValue.showProperties),showEvents:b(Ee.showEvents,this.defaultValue.showEvents),showOperators:b(Ee.showOperators,this.defaultValue.showOperators),showUnits:b(Ee.showUnits,this.defaultValue.showUnits),showValues:b(Ee.showValues,this.defaultValue.showValues),showConstants:b(Ee.showConstants,this.defaultValue.showConstants),showEnums:b(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:b(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(Ee.showKeywords,this.defaultValue.showKeywords),showWords:b(Ee.showWords,this.defaultValue.showWords),showColors:b(Ee.showColors,this.defaultValue.showColors),showFiles:b(Ee.showFiles,this.defaultValue.showFiles),showReferences:b(Ee.showReferences,this.defaultValue.showReferences),showFolders:b(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:b(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:b(Ee.showUsers,this.defaultValue.showUsers),showIssues:b(Ee.showIssues,this.defaultValue.showIssues)}}}class de extends k{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(163,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class we extends E{constructor(){super(132)}compute(se,Ee,ue){return Ee.get(82)?!0:se.tabFocusMode}}var ce;(function(re){re[re.None=0]="None",re[re.Same=1]="Same",re[re.Indent=2]="Indent",re[re.DeepIndent=3]="DeepIndent"})(ce=e.WrappingIndent||(e.WrappingIndent={}));function Ce(re){switch(re){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ye extends E{constructor(){super(134)}compute(se,Ee,ue){const ke=Ee.get(133);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:ke.isWordWrapMinified,isViewportWrapping:ke.isViewportWrapping,wrappingColumn:ke.wrappingColumn}}}class $e extends k{constructor(){const se={enabled:!0};super(32,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:l.localize(164,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:b(se.enabled,this.defaultValue.enabled)}}}const Ve="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ye="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?Ye:Ve,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(re){return e.editorOptionsRegistry[re.id]=re,re}var ot;(function(re){re[re.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",re[re.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",re[re.accessibilitySupport=2]="accessibilitySupport",re[re.accessibilityPageSize=3]="accessibilityPageSize",re[re.ariaLabel=4]="ariaLabel",re[re.autoClosingBrackets=5]="autoClosingBrackets",re[re.autoClosingDelete=6]="autoClosingDelete",re[re.autoClosingOvertype=7]="autoClosingOvertype",re[re.autoClosingQuotes=8]="autoClosingQuotes",re[re.autoIndent=9]="autoIndent",re[re.automaticLayout=10]="automaticLayout",re[re.autoSurround=11]="autoSurround",re[re.bracketPairColorization=12]="bracketPairColorization",re[re.guides=13]="guides",re[re.codeLens=14]="codeLens",re[re.codeLensFontFamily=15]="codeLensFontFamily",re[re.codeLensFontSize=16]="codeLensFontSize",re[re.colorDecorators=17]="colorDecorators",re[re.columnSelection=18]="columnSelection",re[re.comments=19]="comments",re[re.contextmenu=20]="contextmenu",re[re.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",re[re.cursorBlinking=22]="cursorBlinking",re[re.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",re[re.cursorStyle=24]="cursorStyle",re[re.cursorSurroundingLines=25]="cursorSurroundingLines",re[re.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",re[re.cursorWidth=27]="cursorWidth",re[re.disableLayerHinting=28]="disableLayerHinting",re[re.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",re[re.domReadOnly=30]="domReadOnly",re[re.dragAndDrop=31]="dragAndDrop",re[re.dropIntoEditor=32]="dropIntoEditor",re[re.emptySelectionClipboard=33]="emptySelectionClipboard",re[re.extraEditorClassName=34]="extraEditorClassName",re[re.fastScrollSensitivity=35]="fastScrollSensitivity",re[re.find=36]="find",re[re.fixedOverflowWidgets=37]="fixedOverflowWidgets",re[re.folding=38]="folding",re[re.foldingStrategy=39]="foldingStrategy",re[re.foldingHighlight=40]="foldingHighlight",re[re.foldingImportsByDefault=41]="foldingImportsByDefault",re[re.foldingMaximumRegions=42]="foldingMaximumRegions",re[re.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",re[re.fontFamily=44]="fontFamily",re[re.fontInfo=45]="fontInfo",re[re.fontLigatures=46]="fontLigatures",re[re.fontSize=47]="fontSize",re[re.fontWeight=48]="fontWeight",re[re.formatOnPaste=49]="formatOnPaste",re[re.formatOnType=50]="formatOnType",re[re.glyphMargin=51]="glyphMargin",re[re.gotoLocation=52]="gotoLocation",re[re.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",re[re.hover=54]="hover",re[re.inDiffEditor=55]="inDiffEditor",re[re.inlineSuggest=56]="inlineSuggest",re[re.letterSpacing=57]="letterSpacing",re[re.lightbulb=58]="lightbulb",re[re.lineDecorationsWidth=59]="lineDecorationsWidth",re[re.lineHeight=60]="lineHeight",re[re.lineNumbers=61]="lineNumbers",re[re.lineNumbersMinChars=62]="lineNumbersMinChars",re[re.linkedEditing=63]="linkedEditing",re[re.links=64]="links",re[re.matchBrackets=65]="matchBrackets",re[re.minimap=66]="minimap",re[re.mouseStyle=67]="mouseStyle",re[re.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",re[re.mouseWheelZoom=69]="mouseWheelZoom",re[re.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",re[re.multiCursorModifier=71]="multiCursorModifier",re[re.multiCursorPaste=72]="multiCursorPaste",re[re.occurrencesHighlight=73]="occurrencesHighlight",re[re.overviewRulerBorder=74]="overviewRulerBorder",re[re.overviewRulerLanes=75]="overviewRulerLanes",re[re.padding=76]="padding",re[re.parameterHints=77]="parameterHints",re[re.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",re[re.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",re[re.quickSuggestions=80]="quickSuggestions",re[re.quickSuggestionsDelay=81]="quickSuggestionsDelay",re[re.readOnly=82]="readOnly",re[re.renameOnType=83]="renameOnType",re[re.renderControlCharacters=84]="renderControlCharacters",re[re.renderFinalNewline=85]="renderFinalNewline",re[re.renderLineHighlight=86]="renderLineHighlight",re[re.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",re[re.renderValidationDecorations=88]="renderValidationDecorations",re[re.renderWhitespace=89]="renderWhitespace",re[re.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",re[re.roundedSelection=91]="roundedSelection",re[re.rulers=92]="rulers",re[re.scrollbar=93]="scrollbar",re[re.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",re[re.scrollBeyondLastLine=95]="scrollBeyondLastLine",re[re.scrollPredominantAxis=96]="scrollPredominantAxis",re[re.selectionClipboard=97]="selectionClipboard",re[re.selectionHighlight=98]="selectionHighlight",re[re.selectOnLineNumbers=99]="selectOnLineNumbers",re[re.showFoldingControls=100]="showFoldingControls",re[re.showUnused=101]="showUnused",re[re.snippetSuggestions=102]="snippetSuggestions",re[re.smartSelect=103]="smartSelect",re[re.smoothScrolling=104]="smoothScrolling",re[re.stickyScroll=105]="stickyScroll",re[re.stickyTabStops=106]="stickyTabStops",re[re.stopRenderingLineAfter=107]="stopRenderingLineAfter",re[re.suggest=108]="suggest",re[re.suggestFontSize=109]="suggestFontSize",re[re.suggestLineHeight=110]="suggestLineHeight",re[re.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",re[re.suggestSelection=112]="suggestSelection",re[re.tabCompletion=113]="tabCompletion",re[re.tabIndex=114]="tabIndex",re[re.unicodeHighlighting=115]="unicodeHighlighting",re[re.unusualLineTerminators=116]="unusualLineTerminators",re[re.useShadowDOM=117]="useShadowDOM",re[re.useTabStops=118]="useTabStops",re[re.wordSeparators=119]="wordSeparators",re[re.wordWrap=120]="wordWrap",re[re.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",re[re.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",re[re.wordWrapColumn=123]="wordWrapColumn",re[re.wordWrapOverride1=124]="wordWrapOverride1",re[re.wordWrapOverride2=125]="wordWrapOverride2",re[re.wrappingIndent=126]="wrappingIndent",re[re.wrappingStrategy=127]="wrappingStrategy",re[re.showDeprecated=128]="showDeprecated",re[re.inlayHints=129]="inlayHints",re[re.editorClassName=130]="editorClassName",re[re.pixelRatio=131]="pixelRatio",re[re.tabFocusMode=132]="tabFocusMode",re[re.layoutInfo=133]="layoutInfo",re[re.wrappingInfo=134]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(165,null)})),acceptSuggestionOnEnter:Oe(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(166,null),""],markdownDescription:l.localize(167,null)})),accessibilitySupport:Oe(new s),accessibilityPageSize:Oe(new p(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(168,null)})),ariaLabel:Oe(new h(4,"ariaLabel",l.localize(169,null))),autoClosingBrackets:Oe(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(170,null),l.localize(171,null),""],description:l.localize(172,null)})),autoClosingDelete:Oe(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(173,null),""],description:l.localize(174,null)})),autoClosingOvertype:Oe(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(175,null),""],description:l.localize(176,null)})),autoClosingQuotes:Oe(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(177,null),l.localize(178,null),""],description:l.localize(179,null)})),autoIndent:Oe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[l.localize(180,null),l.localize(181,null),l.localize(182,null),l.localize(183,null),l.localize(184,null)],description:l.localize(185,null)})),automaticLayout:Oe(new m(10,"automaticLayout",!1)),autoSurround:Oe(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(186,null),l.localize(187,null),l.localize(188,null),""],description:l.localize(189,null)})),bracketPairColorization:Oe(new F),bracketPairGuides:Oe(new H),stickyTabStops:Oe(new m(106,"stickyTabStops",!1,{description:l.localize(190,null)})),codeLens:Oe(new m(14,"codeLens",!0,{description:l.localize(191,null)})),codeLensFontFamily:Oe(new h(15,"codeLensFontFamily","",{description:l.localize(192,null)})),codeLensFontSize:Oe(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(193,null)})),colorDecorators:Oe(new m(17,"colorDecorators",!0,{description:l.localize(194,null)})),columnSelection:Oe(new m(18,"columnSelection",!1,{description:l.localize(195,null)})),comments:Oe(new n),contextmenu:Oe(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new m(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(196,null)})),cursorBlinking:Oe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:l.localize(197,null)})),cursorSmoothCaretAnimation:Oe(new m(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(198,null)})),cursorStyle:Oe(new o(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:l.localize(199,null)})),cursorSurroundingLines:Oe(new p(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(200,null)})),cursorSurroundingLinesStyle:Oe(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(201,null),l.localize(202,null)],description:l.localize(203,null)})),cursorWidth:Oe(new p(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(204,null)})),disableLayerHinting:Oe(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new m(30,"domReadOnly",!1)),dragAndDrop:Oe(new m(31,"dragAndDrop",!0,{description:l.localize(205,null)})),emptySelectionClipboard:Oe(new B),dropIntoEditor:Oe(new $e),stickyScroll:Oe(new Y),extraEditorClassName:Oe(new h(34,"extraEditorClassName","")),fastScrollSensitivity:Oe(new a(35,"fastScrollSensitivity",5,re=>re<=0?5:re,{markdownDescription:l.localize(206,null)})),find:Oe(new A),fixedOverflowWidgets:Oe(new m(37,"fixedOverflowWidgets",!1)),folding:Oe(new m(38,"folding",!0,{description:l.localize(207,null)})),foldingStrategy:Oe(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(208,null),l.localize(209,null)],description:l.localize(210,null)})),foldingHighlight:Oe(new m(40,"foldingHighlight",!0,{description:l.localize(211,null)})),foldingImportsByDefault:Oe(new m(41,"foldingImportsByDefault",!1,{description:l.localize(212,null)})),foldingMaximumRegions:Oe(new p(42,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(213,null)})),unfoldOnClickAfterEndOfLine:Oe(new m(43,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(214,null)})),fontFamily:Oe(new h(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(215,null)})),fontInfo:Oe(new U),fontLigatures2:Oe(new W),fontSize:Oe(new N),fontWeight:Oe(new G),formatOnPaste:Oe(new m(49,"formatOnPaste",!1,{description:l.localize(216,null)})),formatOnType:Oe(new m(50,"formatOnType",!1,{description:l.localize(217,null)})),glyphMargin:Oe(new m(51,"glyphMargin",!0,{description:l.localize(218,null)})),gotoLocation:Oe(new z),hideCursorInOverviewRuler:Oe(new m(53,"hideCursorInOverviewRuler",!1,{description:l.localize(219,null)})),hover:Oe(new O),inDiffEditor:Oe(new m(55,"inDiffEditor",!1)),letterSpacing:Oe(new a(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,re=>a.clamp(re,-5,20),{description:l.localize(220,null)})),lightbulb:Oe(new q),lineDecorationsWidth:Oe(new g(59,"lineDecorationsWidth",10)),lineHeight:Oe(new he),lineNumbers:Oe(new oe),lineNumbersMinChars:Oe(new p(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new m(63,"linkedEditing",!1,{description:l.localize(221,null)})),links:Oe(new m(64,"links",!0,{description:l.localize(222,null)})),matchBrackets:Oe(new u(65,"matchBrackets","always",["always","near","never"],{description:l.localize(223,null)})),minimap:Oe(new ve),mouseStyle:Oe(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new a(68,"mouseWheelScrollSensitivity",1,re=>re===0?1:re,{markdownDescription:l.localize(224,null)})),mouseWheelZoom:Oe(new m(69,"mouseWheelZoom",!1,{markdownDescription:l.localize(225,null)})),multiCursorMergeOverlapping:Oe(new m(70,"multiCursorMergeOverlapping",!0,{description:l.localize(226,null)})),multiCursorModifier:Oe(new o(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[l.localize(227,null),l.localize(228,null)],markdownDescription:l.localize(229,null)})),multiCursorPaste:Oe(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(230,null),l.localize(231,null)],markdownDescription:l.localize(232,null)})),occurrencesHighlight:Oe(new m(73,"occurrencesHighlight",!0,{description:l.localize(233,null)})),overviewRulerBorder:Oe(new m(74,"overviewRulerBorder",!0,{description:l.localize(234,null)})),overviewRulerLanes:Oe(new p(75,"overviewRulerLanes",3,0,3)),padding:Oe(new pe),parameterHints:Oe(new be),peekWidgetDefaultFocus:Oe(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(235,null),l.localize(236,null)],description:l.localize(237,null)})),definitionLinkOpensInPeek:Oe(new m(79,"definitionLinkOpensInPeek",!1,{description:l.localize(238,null)})),quickSuggestions:Oe(new Le),quickSuggestionsDelay:Oe(new p(81,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(239,null)})),readOnly:Oe(new m(82,"readOnly",!1)),renameOnType:Oe(new m(83,"renameOnType",!1,{description:l.localize(240,null),markdownDeprecationMessage:l.localize(241,null)})),renderControlCharacters:Oe(new m(84,"renderControlCharacters",!0,{description:l.localize(242,null),restricted:!0})),renderFinalNewline:Oe(new m(85,"renderFinalNewline",!0,{description:l.localize(243,null)})),renderLineHighlight:Oe(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(244,null)],description:l.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Oe(new m(87,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(246,null)})),renderValidationDecorations:Oe(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(247,null),l.localize(248,null),l.localize(249,null),""],description:l.localize(250,null)})),revealHorizontalRightPadding:Oe(new p(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new m(91,"roundedSelection",!0,{description:l.localize(251,null)})),rulers:Oe(new me),scrollbar:Oe(new ae),scrollBeyondLastColumn:Oe(new p(94,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(252,null)})),scrollBeyondLastLine:Oe(new m(95,"scrollBeyondLastLine",!0,{description:l.localize(253,null)})),scrollPredominantAxis:Oe(new m(96,"scrollPredominantAxis",!0,{description:l.localize(254,null)})),selectionClipboard:Oe(new m(97,"selectionClipboard",!0,{description:l.localize(255,null),included:t.isLinux})),selectionHighlight:Oe(new m(98,"selectionHighlight",!0,{description:l.localize(256,null)})),selectOnLineNumbers:Oe(new m(99,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),showUnused:Oe(new m(101,"showUnused",!0,{description:l.localize(261,null)})),showDeprecated:Oe(new m(128,"showDeprecated",!0,{description:l.localize(262,null)})),inlayHints:Oe(new Q),snippetSuggestions:Oe(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(263,null),l.localize(264,null),l.localize(265,null),l.localize(266,null)],description:l.localize(267,null)})),smartSelect:Oe(new de),smoothScrolling:Oe(new m(104,"smoothScrolling",!1,{description:l.localize(268,null)})),stopRenderingLineAfter:Oe(new p(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new X),inlineSuggest:Oe(new ie),suggestFontSize:Oe(new p(109,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new p(110,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new m(111,"suggestOnTriggerCharacters",!0,{description:l.localize(271,null)})),suggestSelection:Oe(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(272,null),l.localize(273,null),l.localize(274,null)],description:l.localize(275,null)})),tabCompletion:Oe(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(276,null),l.localize(277,null),l.localize(278,null)],description:l.localize(279,null)})),tabIndex:Oe(new p(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new ee),unusualLineTerminators:Oe(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(280,null),l.localize(281,null),l.localize(282,null)],description:l.localize(283,null)})),useShadowDOM:Oe(new m(117,"useShadowDOM",!0)),useTabStops:Oe(new m(118,"useTabStops",!0,{description:l.localize(284,null)})),wordSeparators:Oe(new h(119,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:l.localize(285,null)})),wordWrap:Oe(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(286,null),l.localize(287,null),l.localize(288,null),l.localize(289,null)],description:l.localize(290,null)})),wordWrapBreakAfterCharacters:Oe(new h(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new h(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new p(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(291,null)})),wordWrapOverride1:Oe(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Oe(new o(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ce,{enumDescriptions:[l.localize(292,null),l.localize(293,null),l.localize(294,null),l.localize(295,null)],description:l.localize(296,null)})),wrappingStrategy:Oe(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(297,null),l.localize(298,null)],description:l.localize(299,null)})),editorClassName:Oe(new M),pixelRatio:Oe(new Te),tabFocusMode:Oe(new we),layoutInfo:Oe(new V),wrappingInfo:Oe(new ye)}}),define(De[162],Ie([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[163],Ie([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[164],Ie([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[165],Ie([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[166],Ie([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(De[167],Ie([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(De[168],Ie([19,20]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(De[169],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[170],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[171],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(De[172],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[173],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[174],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[175],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[176],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[177],Ie([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[178],Ie([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(De[179],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[180],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[181],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[182],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[183],Ie([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[184],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[185],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[186],Ie([19,20]),function(J,e){return J.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[187],Ie([1,0,22,41,164,302]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(m){return m=m.trim(),m==="*"||_.test(m)}e.isValidVersionStr=w;function C(m){if(!w(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=m.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=C;function R(m){if(!m)return null;const v=m.majorBase,p=m.majorMustEqual,a=m.minorBase;let h=m.minorMustEqual;const i=m.patchBase;let u=m.patchMustEqual;m.hasCaret&&(v===0||(h=!1),u=!1);let o=0;if(m.preRelease){const r=I.exec(m.preRelease);if(r){const[,s,n,c]=r;o=Date.UTC(Number(s),Number(n)-1,Number(c))}}return{majorBase:v,majorMustEqual:p,minorBase:a,minorMustEqual:h,patchBase:i,patchMustEqual:u,isMinimum:m.hasGreaterEquals,notBefore:o}}e.normalizeVersion=R;function k(m,v,p){let a;typeof m=="string"?a=R(C(m)):a=m;let h;v instanceof Date?h=v.getTime():typeof v=="string"&&(h=new Date(v).getTime());let i;if(typeof p=="string"?i=R(C(p)):i=p,!a||!i)return!1;const u=a.majorBase,o=a.minorBase,r=a.patchBase;let s=i.majorBase,n=i.minorBase,c=i.patchBase;const d=i.notBefore;let f=i.majorMustEqual,y=i.minorMustEqual,L=i.patchMustEqual;return i.isMinimum?u>s?!0:u<s?!1:o>n?!0:o<n||h&&h<d?!1:r>=c:(u===1&&s===0&&(!f||!y||!L)&&(s=1,n=0,c=0,f=!0,y=!1,L=!1),u<s?!1:u>s?!f:o<n?!1:o>n?!y:r<c?!1:r>c?!L:!(h&&h<d))}e.isValidVersion=k;function S(m,v,p,a,h){const i=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return i.push([t.default.Error,D.localize(0,null)]),i;if(typeof a.name!="string")return i.push([t.default.Error,D.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([t.default.Error,D.localize(2,null,"version")]),i;if(!a.engines)return i.push([t.default.Error,D.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([t.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies<"u"&&!b(a.extensionDependencies))return i.push([t.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents<"u"){if(!b(a.activationEvents))return i.push([t.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof a.main>"u"&&typeof a.browser>"u")return i.push([t.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&i.push([t.default.Warning,D.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return i.push([t.default.Error,D.localize(9,null,"main")]),i;{const r=(0,l.joinPath)(p,a.main);(0,l.isEqualOrParent)(r,p)||i.push([t.default.Warning,D.localize(10,null,r.path,p.path)])}if(typeof a.activationEvents>"u")return i.push([t.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof a.browser<"u"){if(typeof a.browser!="string")return i.push([t.default.Error,D.localize(12,null,"browser")]),i;{const r=(0,l.joinPath)(p,a.browser);(0,l.isEqualOrParent)(r,p)||i.push([t.default.Warning,D.localize(13,null,r.path,p.path)])}if(typeof a.activationEvents>"u")return i.push([t.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!P.valid(a.version))return i.push([t.default.Error,D.localize(15,null)]),i;const u=[];if(!T(m,v,a,h,u))for(const r of u)i.push([t.default.Error,r]);return i}e.validateExtensionManifest=S;function T(m,v,p,a,h){return a||typeof p.main>"u"&&typeof p.browser>"u"?!0:g(m,v,p.engines.vscode,h)}e.isValidExtensionVersion=T;function E(m,v,p){return m==="*"||g(v,p,m)}e.isEngineValid=E;function g(m,v,p,a=[]){const h=R(C(p));if(!h)return a.push(D.localize(16,null,p)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(D.localize(17,null,p)),!1}else if(!h.majorMustEqual)return a.push(D.localize(18,null,p)),!1;return k(m,v,h)?!0:(a.push(D.localize(19,null,m,p)),!1)}function b(m){if(!Array.isArray(m))return!1;for(let v=0,p=m.length;v<p;v++)if(typeof m[v]!="string")return!1;return!0}}),define(De[115],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(D,P=[],_=!1){this.ctor=D,this.staticArguments=P,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=l}),define(De[82],Ie([1,0,115]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var D;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function P(I,w,C){w instanceof l.SyncDescriptor||(w=new l.SyncDescriptor(w,[],Boolean(C))),t.push([I,w])}e.registerSingleton=P;function _(){return t}e.getSingletonServiceDescriptors=_}),define(De[188],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(P,_){this.key=P,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=l;class t{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(const _ of this._nodes.values())_.outgoing.size===0&&P.push(_);return P}insertEdge(P,_){const I=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(_);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(P){const _=this._hashFn(P);this._nodes.delete(_);for(const I of this._nodes.values())I.outgoing.delete(_),I.incoming.delete(_)}lookupOrInsertNode(P){const _=this._hashFn(P);let I=this._nodes.get(_);return I||(I=new l(_,P),this._nodes.set(_,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){const P=[];for(const[_,I]of this._nodes)P.push(`${_}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,_]of this._nodes){const I=new Set([P]),w=this._findCycle(_,I);if(w)return w}}_findCycle(P,_){for(const[I,w]of P.outgoing){if(_.has(I))return[..._,I].join(" -> ");_.add(I);const C=this._findCycle(w,_);if(C)return C;_.delete(I)}}}e.Graph=t}),define(De[3],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=I})(l=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(_,I,w){I[l.DI_TARGET]===I?I[l.DI_DEPENDENCIES].push({id:_,index:w}):(I[l.DI_DEPENDENCIES]=[{id:_,index:w}],I[l.DI_TARGET]=I)}function D(_){if(l.serviceIds.has(_))return l.serviceIds.get(_);const I=function(w,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,w,R)};return I.toString=()=>_,l.serviceIds.set(_,I),I}e.createDecorator=D;function P(_){return _}e.refineServiceDecorator=P}),define(De[83],Ie([1,0,13,2,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function P(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=P;function _(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=_;var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function C(m,v){const p=Object.create(null);for(const a in m)R(p,a,m[a],v);return p}e.toValuesTree=C;function R(m,v,p,a){const h=v.split("."),i=h.pop();let u=m;for(let o=0;o<h.length;o++){const r=h[o];let s=u[r];switch(typeof s){case"undefined":s=u[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${v} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[i]=p}catch{a(`Ignoring ${v} as ${h.join(".")} is ${JSON.stringify(u)}`)}else a(`Ignoring ${v} as ${h.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function k(m,v){const p=v.split(".");S(m,p)}e.removeFromValueTree=k;function S(m,v){const p=v.shift();if(v.length===0){delete m[p];return}if(Object.keys(m).indexOf(p)!==-1){const a=m[p];typeof a=="object"&&!Array.isArray(a)&&(S(a,v),Object.keys(a).length===0&&delete m[p])}}function T(m,v,p){function a(u,o){let r=u;for(const s of o){if(typeof r!="object"||r===null)return;r=r[s]}return r}const h=v.split("."),i=a(m,h);return typeof i>"u"?p:i}e.getConfigurationValue=T;function E(m,v,p){Object.keys(v).forEach(a=>{a!=="__proto__"&&(a in m?l.isObject(m[a])&&l.isObject(v[a])?E(m[a],v[a],p):p&&(m[a]=v[a]):m[a]=v[a])})}e.merge=E;function g(m,v,p){const a=m.inspect(v),h=m.inspect(p);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:a.defaultValue}e.getMigratedSettingValue=g;function b(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(De[52],Ie([1,0,11,8,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",l.isMacintosh),P.set("isLinux",l.isLinux),P.set("isWindows",l.isWindows),P.set("isWeb",l.isWeb),P.set("isMacNative",l.isMacintosh&&!l.isWeb),P.set("isEdge",l.isEdge),P.set("isFirefox",l.isFirefox),P.set("isChrome",l.isChrome),P.set("isSafari",l.isSafari);const _=Object.prototype.hasOwnProperty;var I;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(A){return T.create(A)}static equals(A,W){return E.create(A,W)}static notEquals(A,W){return m.create(A,W)}static regex(A,W){return o.create(A,W)}static in(A,W){return g.create(A,W)}static notIn(A,W){return b.create(A,W)}static not(A){return v.create(A)}static and(...A){return n.create(A,null)}static or(...A){return c.create(A,null,!0)}static greater(A,W){return a.create(A,W)}static greaterEquals(A,W){return h.create(A,W)}static smaller(A,W){return i.create(A,W)}static smallerEquals(A,W){return u.create(A,W)}static deserialize(A,W=!1){if(!!A)return this._deserializeOrExpression(A,W)}static _deserializeOrExpression(A,W){const U=A.split("||");return c.create(U.map(N=>this._deserializeAndExpression(N,W)),null,!0)}static _deserializeAndExpression(A,W){const U=A.split("&&");return n.create(U.map(N=>this._deserializeOne(N,W)),null)}static _deserializeOne(A,W){if(A=A.trim(),A.indexOf("!=")>=0){const U=A.split("!=");return m.create(U[0].trim(),this._deserializeValue(U[1],W))}if(A.indexOf("==")>=0){const U=A.split("==");return E.create(U[0].trim(),this._deserializeValue(U[1],W))}if(A.indexOf("=~")>=0){const U=A.split("=~");return o.create(U[0].trim(),this._deserializeRegexValue(U[1],W))}if(A.indexOf(" not in ")>=0){const U=A.split(" not in ");return b.create(U[0].trim(),U[1].trim())}if(A.indexOf(" in ")>=0){const U=A.split(" in ");return g.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(A)){const U=A.split(">=");return h.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(A)){const U=A.split(">");return a.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(A)){const U=A.split("<=");return u.create(U[0].trim(),U[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(A)){const U=A.split("<");return i.create(U[0].trim(),U[1].trim())}return/^\!\s*/.test(A)?v.create(A.substr(1).trim()):T.create(A)}static _deserializeValue(A,W){if(A=A.trim(),A==="true")return!0;if(A==="false")return!1;const U=/^'([^']*)'$/.exec(A);return U?U[1].trim():A}static _deserializeRegexValue(A,W){if((0,t.isFalsyOrWhitespace)(A)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const U=A.indexOf("/"),N=A.lastIndexOf("/");if(U===N||U<0){if(W)throw new Error(`bad regexp-value '${A}', missing /-enclosure`);return console.warn(`bad regexp-value '${A}', missing /-enclosure`),null}const G=A.slice(U+1,N),z=A[N+1]==="i"?"i":"";try{return new RegExp(G,z)}catch(O){if(W)throw new Error(`bad regexp-value '${A}', parse error: ${O}`);return console.warn(`bad regexp-value '${A}', parse error: ${O}`),null}}}e.ContextKeyExpr=w;function C(B,A){const W=B?B.substituteConstants():void 0,U=A?A.substituteConstants():void 0;return!W&&!U?!0:!W||!U?!1:W.equals(U)}e.expressionsAreEqualWithConstantSubstitution=C;function R(B,A){return B.cmp(A)}class k{constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class S{constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class T{constructor(A,W){this.key=A,this.negated=W,this.type=2}static create(A,W=null){const U=P.get(A);return typeof U=="boolean"?U?S.INSTANCE:k.INSTANCE:new T(A,W)}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?S.INSTANCE:k.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class E{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=4}static create(A,W,U=null){if(typeof W=="boolean")return W?T.create(A,U):v.create(A,U);const N=P.get(A);return typeof N=="boolean"?W===(N?"true":"false")?S.INSTANCE:k.INSTANCE:new E(A,W,U)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const W=A?"true":"false";return this.value===W?S.INSTANCE:k.INSTANCE}return this}evaluate(A){return A.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(A){return A.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class g{constructor(A,W){this.key=A,this.valueKey=W,this.type=10,this.negated=null}static create(A,W){return new g(A,W)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.valueKey,A.key,A.valueKey)}equals(A){return A.type===this.type?this.key===A.key&&this.valueKey===A.valueKey:!1}substituteConstants(){return this}evaluate(A){const W=A.getValue(this.valueKey),U=A.getValue(this.key);return Array.isArray(W)?W.includes(U):typeof U=="string"&&typeof W=="object"&&W!==null?_.call(W,U):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(A){return A.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=g;class b{constructor(A,W){this.key=A,this.valueKey=W,this.type=11,this._negated=g.create(A,W)}static create(A,W){return new b(A,W)}cmp(A){return A.type!==this.type?this.type-A.type:this._negated.cmp(A._negated)}equals(A){return A.type===this.type?this._negated.equals(A._negated):!1}substituteConstants(){return this}evaluate(A){return!this._negated.evaluate(A)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(A){return A.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=b;class m{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=5}static create(A,W,U=null){if(typeof W=="boolean")return W?v.create(A,U):T.create(A,U);const N=P.get(A);return typeof N=="boolean"?W===(N?"true":"false")?k.INSTANCE:S.INSTANCE:new m(A,W,U)}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){const A=P.get(this.key);if(typeof A=="boolean"){const W=A?"true":"false";return this.value===W?k.INSTANCE:S.INSTANCE}return this}evaluate(A){return A.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(A){return A.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class v{constructor(A,W){this.key=A,this.negated=W,this.type=3}static create(A,W=null){const U=P.get(A);return typeof U=="boolean"?U?k.INSTANCE:S.INSTANCE:new v(A,W)}cmp(A){return A.type!==this.type?this.type-A.type:f(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=P.get(this.key);return typeof A=="boolean"?A?k.INSTANCE:S.INSTANCE:this}evaluate(A){return!A.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(A){return A.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function p(B,A){if(typeof B=="string"){const W=parseFloat(B);isNaN(W)||(B=W)}return typeof B=="string"||typeof B=="number"?A(B):k.INSTANCE}class a{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=12}static create(A,W,U=null){return p(W,N=>new a(A,N,U))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=a;class h{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=13}static create(A,W,U=null){return p(W,N=>new h(A,N,U))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(A){return A.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class i{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=14}static create(A,W,U=null){return p(W,N=>new i(A,N,U))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class u{constructor(A,W,U){this.key=A,this.value=W,this.negated=U,this.type=15}static create(A,W,U=null){return p(W,N=>new u(A,N,U))}cmp(A){return A.type!==this.type?this.type-A.type:y(this.key,this.value,A.key,A.value)}equals(A){return A.type===this.type?this.key===A.key&&this.value===A.value:!1}substituteConstants(){return this}evaluate(A){return typeof this.value=="string"?!1:parseFloat(A.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(A){return A.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class o{constructor(A,W){this.key=A,this.regexp=W,this.type=7,this.negated=null}static create(A,W){return new o(A,W)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.key<A.key)return-1;if(this.key>A.key)return 1;const W=this.regexp?this.regexp.source:"",U=A.regexp?A.regexp.source:"";return W<U?-1:W>U?1:0}equals(A){if(A.type===this.type){const W=this.regexp?this.regexp.source:"",U=A.regexp?A.regexp.source:"";return this.key===A.key&&W===U}return!1}substituteConstants(){return this}evaluate(A){const W=A.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const A=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${A}`}keys(){return[this.key]}map(A){return A.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=o;class r{constructor(A){this._actual=A,this.type=8}static create(A){return new r(A)}cmp(A){return A.type!==this.type?this.type-A.type:this._actual.cmp(A._actual)}equals(A){return A.type===this.type?this._actual.equals(A._actual):!1}substituteConstants(){return this}evaluate(A){return!this._actual.evaluate(A)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(A){return new r(this._actual.map(A))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function s(B){let A=null;for(let W=0,U=B.length;W<U;W++){const N=B[W].substituteConstants();if(B[W]!==N&&A===null){A=[];for(let G=0;G<W;G++)A[G]=B[G]}A!==null&&(A[W]=N)}return A===null?B:A}class n{constructor(A,W){this.expr=A,this.negated=W,this.type=6}static create(A,W){return n._normalizeArr(A,W)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let W=0,U=this.expr.length;W<U;W++){const N=R(this.expr[W],A.expr[W]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let W=0,U=this.expr.length;W<U;W++)if(!this.expr[W].equals(A.expr[W]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:n.create(A,this.negated)}evaluate(A){for(let W=0,U=this.expr.length;W<U;W++)if(!this.expr[W].evaluate(A))return!1;return!0}static _normalizeArr(A,W){const U=[];let N=!1;for(const G of A)if(!!G){if(G.type===1){N=!0;continue}if(G.type===0)return k.INSTANCE;if(G.type===6){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&N)return S.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(R);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==9)break;U.pop();const z=U.pop(),O=U.length===0,x=c.create(G.expr.map(V=>n.create([V,z],null)),null,O);x&&(U.push(x),U.sort(R))}return U.length===1?U[0]:new n(U,W)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const W of this.expr)A.push(...W.keys());return A}map(A){return new n(this.expr.map(W=>W.map(A)),null)}negate(){if(!this.negated){const A=[];for(const W of this.expr)A.push(W.negate());this.negated=c.create(A,this,!0)}return this.negated}}class c{constructor(A,W){this.expr=A,this.negated=W,this.type=9}static create(A,W,U){return c._normalizeArr(A,W,U)}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let W=0,U=this.expr.length;W<U;W++){const N=R(this.expr[W],A.expr[W]);if(N!==0)return N}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let W=0,U=this.expr.length;W<U;W++)if(!this.expr[W].equals(A.expr[W]))return!1;return!0}return!1}substituteConstants(){const A=s(this.expr);return A===this.expr?this:c.create(A,this.negated,!1)}evaluate(A){for(let W=0,U=this.expr.length;W<U;W++)if(this.expr[W].evaluate(A))return!0;return!1}static _normalizeArr(A,W,U){let N=[],G=!1;if(A){for(let z=0,O=A.length;z<O;z++){const x=A[z];if(!!x){if(x.type===0){G=!0;continue}if(x.type===1)return S.INSTANCE;if(x.type===9){N=N.concat(x.expr);continue}N.push(x)}}if(N.length===0&&G)return k.INSTANCE;N.sort(R)}if(N.length!==0){if(N.length===1)return N[0];for(let z=1;z<N.length;z++)N[z-1].equals(N[z])&&(N.splice(z,1),z--);if(N.length===1)return N[0];if(U){for(let z=0;z<N.length;z++)for(let O=z+1;O<N.length;O++)L(N[z],N[O])&&(N.splice(O,1),O--);if(N.length===1)return N[0]}return new c(N,W)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const W of this.expr)A.push(...W.keys());return A}map(A){return new c(this.expr.map(W=>W.map(A)),null)}negate(){if(!this.negated){const A=[];for(const W of this.expr)A.push(W.negate());for(;A.length>1;){const W=A.shift(),U=A.shift(),N=[];for(const z of M(W))for(const O of M(U))N.push(n.create([z,O],null));const G=A.length===0;A.unshift(c.create(N,null,G))}this.negated=A[0]}return this.negated}}class d extends T{constructor(A,W,U){super(A,null),this._defaultValue=W,typeof U=="object"?d._info.push({...U,key:A}):U!==!0&&d._info.push({key:A,description:U,type:W!=null?typeof W:void 0})}static all(){return d._info.values()}bindTo(A){return A.createKey(this.key,this._defaultValue)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return E.create(this.key,A)}notEqualsTo(A){return m.create(this.key,A)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(B,A){return B<A?-1:B>A?1:0}function y(B,A,W,U){return B<W?-1:B>W?1:A<U?-1:A>U?1:0}function L(B,A){if(A.type===6&&B.type!==9&&B.type!==6){for(const N of A.expr)if(B.equals(N))return!0}const W=B.negate(),U=M(W).concat(M(A));U.sort(R);for(let N=0;N<U.length;N++){const z=U[N].negate();for(let O=N+1;O<U.length;O++){const x=U[O];if(z.equals(x))return!0}}return!1}e.implies=L;function M(B){return B.type===9?B.expr:[B]}}),define(De[189],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(De[84],Ie([1,0,163,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function P(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function _(m,v){switch(m){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function I(m,v){return v==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function w(m,v,p){return I(v,p)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===p?!0:C(p).includes(m)}e.isTargetPlatformCompatible=w;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=R;var k;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var S;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var T;(function(m){m.Install="install",m.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var E;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(v,p){super(v),this.code=p,this.name=p}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,l.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,l.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService")}),define(De[190],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,l.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,l.createDecorator)("externalTerminal")}),define(De[191],Ie([1,0,44,12,9,11,101,29,109,165,190]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=C.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends S{openTerminal(a,h){return this.spawnTerminal(l,a,w.getWindowsShell(),h)}spawnTerminal(a,h,i,u){const o=h.windowsExec||T.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const r=D.basename(o).toLowerCase();if(r==="cmder"||r==="cmder.exe")return a.spawn(o,u?[u]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return o.indexOf(" ")>=0&&s.push('""'),s.push(o),(r==="wt"||r==="wt.exe")&&s.push("-d ."),new Promise((n,c)=>{const d=b(process),f=a.spawn(i,s,{cwd:u,env:d});f.on("error",c),f.on("exit",()=>n())})}runInTerminal(a,h,i,u,o){const r="windowsExec"in o&&o.windowsExec?o.windowsExec:T.getDefaultTerminalWindows();return new Promise((s,n)=>{const c=`"${h} - ${k}"`,d=`""${i.join('" "')}" & pause"`,f=["/c","start",c,"/wait",r,"/c",d],y=Object.assign({},b(process),u);Object.keys(y).filter(B=>y[B]===null).forEach(B=>delete y[B]);const L={cwd:h,env:y,windowsVerbatimArguments:!0};l.spawn(T.CMD,f,L).on("error",B=>{n(m(B))}),s(void 0)})}static getDefaultTerminalWindows(){if(!T._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return T._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=T,T.CMD="cmd.exe";class E extends S{openTerminal(a,h){return this.spawnTerminal(l,a,h)}runInTerminal(a,h,i,u,o){const r=o.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{if(r===R.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const c=r===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",f=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,J).fsPath,"-t",a||k,"-w",h];for(const M of i)f.push("-a"),f.push(M);if(u){const M=Object.assign({},b(process),u);for(const B in M){const A=M[B];A===null?(f.push("-u"),f.push(B)):(f.push("-e"),f.push(`${B}=${A}`))}}let y="";const L=l.spawn(E.OSASCRIPT,f);L.on("error",M=>{n(m(M))}),L.stderr.on("data",M=>{y+=M.toString()}),L.on("exit",M=>{if(M===0)s(void 0);else if(y){const B=y.split(`
`,1);n(new Error(B[0]))}else n(new Error(C.localize(1,null,c,M)))})}else n(new Error(C.localize(2,null,r)))})}spawnTerminal(a,h,i){const u=h.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((o,r)=>{const s=["-a",u];i&&s.push(i);const n=b(process),c=a.spawn("/usr/bin/open",s,{cwd:i,env:n});c.on("error",r),c.on("exit",()=>o())})}}e.MacExternalTerminalService=E,E.OSASCRIPT="/usr/bin/osascript";class g extends S{openTerminal(a,h){return this.spawnTerminal(l,a,h)}runInTerminal(a,h,i,u,o){const r=o.linuxExec?Promise.resolve(o.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{const c=[];r.then(d=>{d.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const f=`${v(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;c.push(`''${f}''`);const y=Object.assign({},b(process),u);Object.keys(y).filter(A=>y[A]===null).forEach(A=>delete y[A]);const L={cwd:h,env:y};let M="";const B=l.spawn(d,c,L);B.on("error",A=>{n(m(A))}),B.stderr.on("data",A=>{M+=A.toString()}),B.on("exit",A=>{if(A===0)s(void 0);else if(M){const W=M.split(`
`,1);n(new Error(W[0]))}else n(new Error(C.localize(4,null,d,A)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!P.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(h=>{a?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,h,i){const u=h.linuxExec?Promise.resolve(h.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,r)=>{u.then(s=>{const n=b(process),c=a.spawn(s,[],{cwd:i,env:n});c.on("error",r),c.on("exit",()=>o())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=C.localize(3,null);function b(p){const a={...p.env};return(0,_.sanitizeProcessEnvironment)(a),a}function m(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(C.localize(5,null,p.path)):p}function v(p){let a="";for(const h of p)h.indexOf(" ")>=0?a+='"'+h+'"':a+=h,a+=" ";return a}}),define(De[42],Ie([1,0,25,9,8,13,2,166,3]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var k;(function(z){z[z.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var S;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=T;function E(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=E;function g(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=g;function b(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function m(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=m;function v(z){return T(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var p;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(O,x){super(O),this.code=x}}e.FileSystemProviderError=a;function h(z,O){const x=new a(z.toString(),O);return u(x,O),x}e.createFileSystemProviderError=h;function i(z){return z||h((0,I.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=i;function u(z,O){return z.name=O?`${O} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=u;function o(z){if(!z)return p.Unknown;if(z instanceof a)return z.code;const O=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!O)return p.Unknown;switch(O[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=o;function r(z){if(z instanceof y)return z.fileOperationResult;switch(o(z)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(O,x,V){this.resource=O,this.operation=x,this.target=V}isOperation(O){return this.operation===O}}e.FileOperationEvent=n;var c;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(O,x){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const V=new Map;for(const q of O){const Y=V.get(q.type);switch(Y?Y.push([q.resource,q]):V.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,Y]of V)switch(q){case 1:this.added=l.TernarySearchTree.forUris(()=>x),this.added.fill(Y);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>x),this.updated.fill(Y);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>x),this.deleted.fill(Y);break}}contains(O,...x){return this.doContains(O,{includeChildren:!1},...x)}affects(O,...x){return this.doContains(O,{includeChildren:!0},...x)}doContains(O,x,...V){if(!O)return!1;const q=V.length>0;return!!((!q||V.includes(1))&&(this.added?.get(O)||x.includeChildren&&this.added?.findSuperstr(O))||(!q||V.includes(0))&&(this.updated?.get(O)||x.includeChildren&&this.updated?.findSuperstr(O))||(!q||V.includes(2))&&(this.deleted?.findSubstr(O)||x.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function f(z,O,x){return!z||!O||z===O||O.length>z.length?!1:(O.charAt(O.length-1)!==t.sep&&(O+=t.sep),x?(0,D.startsWithIgnoreCase)(z,O):z.indexOf(O)===0)}e.isParent=f;class y extends Error{constructor(O,x,V){super(O),this.fileOperationResult=x,this.options=V}}e.FileOperationError=y;class L extends y{constructor(O,x,V){super(O,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=L;var M;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=A;async function W(z,O){if(!O.hasProvider(_.URI.from({scheme:z.scheme})))return new Promise(x=>{const V=O.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===z.scheme&&q.added&&(V.dispose(),x())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(O){return(0,P.isNumber)(O)||(O=0),O<U.KB?(0,I.localize)(1,null,O.toFixed(0)):O<U.MB?(0,I.localize)(2,null,(O/U.KB).toFixed(2)):O<U.GB?(0,I.localize)(3,null,(O/U.MB).toFixed(2)):O<U.TB?(0,I.localize)(4,null,(O/U.GB).toFixed(2)):(0,I.localize)(5,null,(O/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var N;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function G(z){return{maxFileSize:z===0?300*U.MB:16*U.GB,maxHeapSize:z===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=G}),define(De[85],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...D){this._entries=new Map;for(const[P,_]of D)this.set(P,_)}set(D,P){const _=this._entries.get(D);return this._entries.set(D,P),_}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=l}),define(De[192],Ie([1,0,18,10,115,188,3,85]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const w=!1;class C extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class R{constructor(E=new I.ServiceCollection,g=!1,b){this._activeInstantiations=new Set,this._services=E,this._strict=g,this._parent=b,this._services.set(_.IInstantiationService,this)}createChild(E){return new R(E,this._strict,this)}invokeFunction(E,...g){const b=S.traceInvocation(E);let m=!1;try{return E({get:p=>{if(m)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(p,b);if(!a)throw new Error(`[invokeFunction] unknown service '${p}'`);return a}},...g)}finally{m=!0,b.stop()}}createInstance(E,...g){let b,m;return E instanceof D.SyncDescriptor?(b=S.traceCreation(E.ctor),m=this._createInstance(E.ctor,E.staticArguments.concat(g),b)):(b=S.traceCreation(E),m=this._createInstance(E,g,b)),b.stop(),m}_createInstance(E,g=[],b){const m=_._util.getServiceDependencies(E).sort((a,h)=>a.index-h.index),v=[];for(const a of m){const h=this._getOrCreateServiceInstance(a.id,b);h||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${a.id}.`,!1),v.push(h)}const p=m.length>0?m[0].index:g.length;if(g.length!==p){console.trace(`[createInstance] First service dependency of ${E.name} at position ${p+1} conflicts with ${g.length} static arguments`);const a=p-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,p)}return new E(...g,...v)}_setServiceInstance(E,g){if(this._services.get(E)instanceof D.SyncDescriptor)this._services.set(E,g);else if(this._parent)this._parent._setServiceInstance(E,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){const g=this._services.get(E);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):g}_getOrCreateServiceInstance(E,g){const b=this._getServiceInstanceOrDescriptor(E);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,b,g.branch(E,!0)):(g.branch(E,!1),b)}_safeCreateAndCacheServiceInstance(E,g,b){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,g,b)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,g,b){const m=new P.Graph(a=>a.id.toString());let v=0;const p=[{id:E,desc:g,_trace:b}];for(;p.length;){const a=p.pop();if(m.lookupOrInsertNode(a),v++>1e3)throw new C(m);for(const h of _._util.getServiceDependencies(a.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(h.id);if(i||this._throwIfStrict(`[createInstance] ${E} depends on ${h.id} which is NOT registered.`,!0),i instanceof D.SyncDescriptor){const u={id:h.id,desc:i,_trace:a._trace.branch(h.id,!0)};m.insertEdge(a,u),p.push(u)}}}for(;;){const a=m.roots();if(a.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:h}of a){if(this._getServiceInstanceOrDescriptor(h.id)instanceof D.SyncDescriptor){const u=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,u)}m.removeNode(h)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,g,b=[],m,v){if(this._services.get(E)instanceof D.SyncDescriptor)return this._createServiceInstance(g,b,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,g,b,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(E,g=[],b,m){if(b){const v=new l.IdleValue(()=>this._createInstance(E,g,m));return new Proxy(Object.create(null),{get(p,a){if(a in p)return p[a];const h=v.value;let i=h[a];return typeof i!="function"||(i=i.bind(h),p[a]=i),i},set(p,a,h){return v.value[a]=h,!0}})}else return this._createInstance(E,g,m)}_throwIfStrict(E,g){if(g&&console.warn(E),this._strict)throw new Error(E)}}e.InstantiationService=R;var k;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(k||(k={}));class S{constructor(E,g){this.type=E,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(E){return w?new S(1,E.name||E.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(E){return w?new S(0,E.name):S._None}branch(E,g){const b=new S(2,E.toString());return this._dep.push([E,g,b]),b}stop(){const E=Date.now()-this._start;S._totals+=E;let g=!1;function b(v,p){const a=[],h=new Array(v+1).join("	");for(const[i,u,o]of p._dep)if(u&&o){g=!0,a.push(`${h}CREATES -> ${i}`);const r=b(v+1,o);r&&a.push(r)}else a.push(`${h}uses -> ${i}`);return a.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(E>2||g)&&console.log(m.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(De[14],Ie([1,0,50,4,6,11,3]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function I(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function C(u,o,r){switch(o){case w.Trace:u.trace(r);break;case w.Debug:u.debug(r);break;case w.Info:u.info(r);break;case w.Warning:u.warn(r);break;case w.Error:u.error(r);break;case w.Critical:u.critical(r);break;default:throw new Error("Invalid log level")}}e.log=C;function R(u){let o="";for(let r=0;r<u.length;r++){let s=u[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}o+=(r>0?" ":"")+s}return o}e.format=R;class k extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class S extends k{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,R([o,...r]))}debug(o,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,R([o,...r]))}info(o,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,R([o,...r]))}warn(o,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,R([o,...r]))}error(o,...r){if(this.checkLogLevel(w.Error))if(o instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=o.stack,this.log(w.Error,R(s))}else this.log(w.Error,R([o,...r]))}critical(o,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,R([o,...r]))}flush(){}}e.AbstractMessageLogger=S;class T extends k{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!P.isWindows}trace(o,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...r):console.log(`[main ${I()}]`,o,...r))}debug(o,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...r):console.log(`[main ${I()}]`,o,...r))}info(o,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,o,...r):console.log(`[main ${I()}]`,o,...r))}warn(o,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,o,...r):console.warn(`[main ${I()}]`,o,...r))}error(o,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,o,...r):console.error(`[main ${I()}]`,o,...r))}critical(o,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,o,...r):console.error(`[main ${I()}]`,o,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class E extends k{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",o,...r)}debug(o,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...r)}info(o,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",o,...r)}warn(o,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",o,...r)}error(o,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",o,...r)}critical(o,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...r)}dispose(){}flush(){}}e.ConsoleLogger=E;class g extends k{constructor(o,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(r)}trace(o,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(o),...r])}debug(o,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(o),...r])}info(o,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(o),...r])}warn(o,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(o),...r])}error(o,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(o),...r])}critical(o,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(o),...r])}extractMessage(o){return typeof o=="string"?o:(0,l.toErrorMessage)(o,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class b extends k{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const r of this.logServices)r.setLevel(o);super.setLevel(o)}trace(o,...r){for(const s of this.logServices)s.trace(o,...r)}debug(o,...r){for(const s of this.logServices)s.debug(o,...r)}info(o,...r){for(const s of this.logServices)s.info(o,...r)}warn(o,...r){for(const s of this.logServices)s.warn(o,...r)}error(o,...r){for(const s of this.logServices)s.error(o,...r)}critical(o,...r){for(const s of this.logServices)s.critical(o,...r)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=b;class m extends D.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...r){this.logger.trace(o,...r)}debug(o,...r){this.logger.debug(o,...r)}info(o,...r){this.logger.info(o,...r)}warn(o,...r){this.logger.warn(o,...r)}error(o,...r){this.logger.error(o,...r)}critical(o,...r){this.logger.critical(o,...r)}flush(){this.logger.flush()}}e.LogService=m;class v extends D.Disposable{constructor(o,r){super(),this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,r){let s=this.loggers.get(o.toString());return s||(s=this.doCreateLogger(o,r?.always?w.Trace:this.logLevel,r),this.loggers.set(o.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class p{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return w.Info}trace(o,...r){}debug(o,...r){}info(o,...r){}warn(o,...r){}error(o,...r){}critical(o,...r){}dispose(){}flush(){}}e.NullLogService=p;function a(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const o=h(u.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function h(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=h;function i(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=i}),define(De[193],Ie([1,0,42,14]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,w,C,R,k){try{const S=await new Promise((E,g)=>{J(["spdlog"],E,g)});S.setFlushOn(t.LogLevel.Trace);const T=await S.createAsyncRotatingLogger(I,w,C,R);return k&&T.clearFormatters(),T}catch(S){console.error(S)}return null}function P(I,w,C){switch(w){case t.LogLevel.Trace:I.trace(C);break;case t.LogLevel.Debug:I.debug(C);break;case t.LogLevel.Info:I.info(C);break;case t.LogLevel.Warning:I.warn(C);break;case t.LogLevel.Error:I.error(C);break;case t.LogLevel.Critical:I.critical(C);break;default:throw new Error("Invalid log level")}}class _ extends t.AbstractMessageLogger{constructor(w,C,R,k,S){super(),this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(w,C,R,k),this._register(this.onDidChangeLogLevel(T=>{this._logger?.setLevel(T)}))}async _createSpdLogLogger(w,C,R,k){const S=R?6:1,T=30/S*l.ByteSize.MB,E=await D(w,C,T,S,k);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:g,message:b}of this.buffer)P(this._logger,g,b);this.buffer=[]}}log(w,C){this._logger?P(this._logger,w,C):this.getLevel()<=w&&this.buffer.push({level:w,message:C})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(De[116],Ie([1,0,41,167,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var _;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function C(E,g){return g-E}w.compare=C;const R=Object.create(null);R[w.Error]=(0,t.localize)(0,null),R[w.Warning]=(0,t.localize)(1,null),R[w.Info]=(0,t.localize)(2,null);function k(E){return R[E]||""}w.toString=k;function S(E){switch(E){case l.default.Error:return w.Error;case l.default.Warning:return w.Warning;case l.default.Info:return w.Info;case l.default.Ignore:return w.Hint}}w.fromSeverity=S;function T(E){switch(E){case w.Error:return l.default.Error;case w.Warning:return l.default.Warning;case w.Info:return l.default.Info;case w.Hint:return l.default.Ignore}}w.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(w){const C="";function R(S){return k(S,!0)}w.makeKey=R;function k(S,T){const E=[C];return S.source?E.push(S.source.replace("\xA6","\\\xA6")):E.push(C),S.code?typeof S.code=="string"?E.push(S.code.replace("\xA6","\\\xA6")):E.push(S.code.value.replace("\xA6","\\\xA6")):E.push(C),S.severity!==void 0&&S.severity!==null?E.push(_.toString(S.severity)):E.push(C),S.message&&T?E.push(S.message.replace("\xA6","\\\xA6")):E.push(C),S.startLineNumber!==void 0&&S.startLineNumber!==null?E.push(S.startLineNumber.toString()):E.push(C),S.startColumn!==void 0&&S.startColumn!==null?E.push(S.startColumn.toString()):E.push(C),S.endLineNumber!==void 0&&S.endLineNumber!==null?E.push(S.endLineNumber.toString()):E.push(C),S.endColumn!==void 0&&S.endColumn!==null?E.push(S.endColumn.toString()):E.push(C),E.push(C),E.join("\xA6")}w.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(De[194],Ie([1,0,4,41,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new w,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=I;class w{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=w}),define(De[117],Ie([1,0,6,8,2,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,P.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function _(R,k){return D.URI.isUri(R)?(0,t.equalsIgnoreCase)(R.scheme,k):(0,t.startsWithIgnoreCase)(R,k+":")}e.matchesScheme=_;function I(R,...k){return k.some(S=>_(R,S))}e.matchesSomeScheme=I;function w(R,k){return R.with({fragment:`${k.startLineNumber},${k.startColumn}${k.endLineNumber?`-${k.endLineNumber}${k.endColumn?`,${k.endColumn}`:""}`:""}`})}e.withSelection=w;function C(R){let k;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return S&&(k={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},R=R.with({fragment:""})),{selection:k,uri:R}}e.extractSelection=C}),define(De[195],Ie([1,0,12,11,40,22]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let _;if(typeof t.globals.vscode<"u"&&typeof t.globals.vscode.context<"u"){const I=t.globals.vscode.context.configuration();if(I)_=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const I=(0,P.dirname)(l.FileAccess.asFileUri("",J));_=J.__$__nodeRequire((0,P.joinPath)(I,"product.json").fsPath);const w=J.__$__nodeRequire((0,P.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(_,{nameShort:`${_.nameShort} Dev`,nameLong:`${_.nameLong} Dev`,dataFolderName:`${_.dataFolderName}-dev`,serverDataFolderName:_.serverDataFolderName?`${_.serverDataFolderName}-dev`:void 0}),Object.assign(_,{version:w.version})}else _={},Object.keys(_).length===0&&Object.assign(_,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=_}),define(De[196],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,l.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__param||function(J,e){return function(l,t){e(l,t,J)}};define(De[118],Ie([1,0,18,21,6,3]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,P.createDecorator)("progressService");var _;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let w=class extends D.Disposable{constructor(k,S){super(),this.deferred=new l.DeferredPromise,S.withProgress(k,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};w=qe([xe(1,e.IProgressService)],w),e.UnmanagedProgress=w;class C extends D.Disposable{constructor(k){super(),this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(k){this.stop();const S=++this.currentOperationId,T=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{S===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:S,token:T.token,stop:()=>this.doStop(S),isCurrent:()=>this.currentOperationId===S}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,P.createDecorator)("editorProgressService")}),define(De[43],Ie([1,0,48,13]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(_,I){l.ok(t.isString(_)),l.ok(t.isObject(I)),l.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,I)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new D}),define(De[119],Ie([1,0,4,43]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,C){this.schemasById[D(w)]=C,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new P;t.Registry.add(e.Extensions.JSONContribution,_)}),define(De[120],Ie([1,0,17,4,13,162,83,119,43]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=w.Registry.as(I.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const o=this.doRegisterConfigurations(i,u);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(i){const u=this.doDeregisterConfigurations(i);k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:i,remove:u}){const o=[];o.push(...this.doDeregisterConfigurations(u)),o.push(...this.doRegisterConfigurations(i,!1)),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,l.distinct)(o)})}registerDefaultConfigurations(i){const u=[],o=[];for(const{overrides:r,source:s}of i)for(const n in r)if(u.push(n),e.OVERRIDE_PROPERTY_REGEX.test(n)){const c=this.configurationDefaultsOverrides.get(n),d=c?.valuesSources??new Map;if(s)for(const M of Object.keys(r[n]))d.set(M,s);const f={...c?.value||{},...r[n]};this.configurationDefaultsOverrides.set(n,{source:s,value:f,valuesSources:d});const y=(0,_.getLanguageTagSettingPlainKey)(n),L={type:"object",default:f,description:P.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(s)?void 0:s,defaultValueSource:s};o.push(...g(n)),this.configurationProperties[n]=L,this.defaultLanguageConfigurationOverridesNode.properties[n]=L}else{this.configurationDefaultsOverrides.set(n,{value:r[n],source:s});const c=this.configurationProperties[n];c&&(this.updatePropertyDefaultValue(n,c),this.updateSchema(n,c))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const u=[];for(const{overrides:o,source:r}of i)for(const s in o){const n=this.configurationDefaultsOverrides.get(s),c=D.isString(r)?r:r?.id,d=D.isString(n?.source)?n?.source:n?.source?.id;if(c===d)if(u.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const f=this.configurationProperties[s];f&&(this.updatePropertyDefaultValue(s,f),this.updateSchema(s,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const u of i)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,u){const o=[];return i.forEach(r=>{o.push(...this.validateAndRegisterProperties(r,u,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),o}doDeregisterConfigurations(i){const u=[],o=r=>{if(r.properties)for(const s in r.properties){u.push(s);const n=this.configurationProperties[s];n?.policy?.name&&this.policyConfigurations.delete(n.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>o(s))};for(const r of i){o(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return u}validateAndRegisterProperties(i,u=!0,o,r,s=3){s=D.isUndefinedOrNull(i.scope)?s:i.scope;const n=[],c=i.properties;if(c)for(const f in c){const y=c[f];if(u&&p(f,y)){delete c[f];continue}if(y.source=o,y.defaultDefaultValue=c[f].default,this.updatePropertyDefaultValue(f,y),e.OVERRIDE_PROPERTY_REGEX.test(f)?y.scope=void 0:(y.scope=D.isUndefinedOrNull(y.scope)?s:y.scope,y.restricted=D.isUndefinedOrNull(y.restricted)?!!r?.includes(f):y.restricted),c[f].hasOwnProperty("included")&&!c[f].included){this.excludedConfigurationProperties[f]=c[f],delete c[f];continue}else this.configurationProperties[f]=c[f],c[f].policy?.name&&this.policyConfigurations.set(c[f].policy.name,f);!c[f].deprecationMessage&&c[f].markdownDeprecationMessage&&(c[f].deprecationMessage=c[f].markdownDeprecationMessage),n.push(f)}const d=i.allOf;if(d)for(const f of d)n.push(...this.validateAndRegisterProperties(f,u,o,r,s));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const u=o=>{const r=o.properties;if(r)for(const n in r)this.updateSchema(n,r[n]);o.allOf?.forEach(u)};u(i)}updateSchema(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.resourceLanguageSettingsSchema.properties[i]=u;break}}removeFromSchema(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const u=`[${i}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,o),e.allSettings.properties[u]=o,e.applicationSettings.properties[u]=o,e.machineSettings.properties[u]=o,e.machineOverridableSettings.properties[u]=o,e.windowSettings.properties[u]=o,e.resourceSettings.properties[u]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,u){const o=this.configurationDefaultsOverrides.get(i);let r=o?.value,s=o?.source;D.isUndefined(r)&&(r=u.defaultDefaultValue,s=void 0),D.isUndefined(r)&&(r=m(u.type)),u.default=r,u.defaultValueSource=s}}const T="\\[([^\\]]+)\\]",E=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(h){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let u=E.exec(h);for(;u?.length;){const o=u[1].trim();o&&i.push(o),u=E.exec(h)}}return(0,l.distinct)(i)}e.overrideIdentifiersFromKey=g;function b(h){return h.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=b;function m(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new S;w.Registry.add(e.Extensions.Configuration,v);function p(h,i){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?P.localize(7,null,h):v.getConfigurationProperties()[h]!==void 0?P.localize(8,null,h):i.policy?.name&&v.getPolicyConfigurations().get(i.policy?.name)!==void 0?P.localize(9,null,h,i.policy?.name,v.getPolicyConfigurations().get(i.policy?.name)):null:P.localize(6,null)}e.validateProperty=p;function a(){const h=[],i=v.getConfigurationProperties();for(const u of Object.keys(i))h.push([u,i[u].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=a}),define(De[197],Ie([1,0,17,4,143,6,25,24,13,2,83,120,43]),function(J,e,l,t,D,P,_,I,w,C,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(i={},u=[],o=[]){this._contents=i,this._keys=u,this._overrides=o,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,u){const o=this.getContentsForOverrideIdentifer(u);return o?i?(0,R.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const u=[];for(const o of this.overrides)o.identifiers.includes(i)&&u.push(...o.keys);return l.distinct(u)}getAllOverrideIdentifiers(){const i=[];for(const u of this.overrides)i.push(...u.identifiers);return l.distinct(i)}override(i){let u=this.overrideConfigurations.get(i);return u||(u=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,u)),u}merge(...i){const u=I.deepClone(this.contents),o=I.deepClone(this.overrides),r=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(u,s.contents);for(const n of s.overrides){const[c]=o.filter(d=>l.equals(d.identifiers,n.identifiers));c?(this.mergeContents(c.contents,n.contents),c.keys.push(...n.keys),c.keys=l.distinct(c.keys)):o.push(I.deepClone(n))}for(const n of s.keys)r.indexOf(n)===-1&&r.push(n)}return new T(u,r,o)}freeze(){return this.frozen=!0,this}clone(){return new T(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(i){const u=this.getContentsForOverrideIdentifer(i);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const o={};for(const r of l.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[r];const n=u[r];n&&(typeof s=="object"&&typeof n=="object"?(s=I.deepClone(s),this.mergeContents(s,n)):s=n),o[r]=s}return new T(o,this.keys,this.overrides)}mergeContents(i,u){for(const o of Object.keys(u)){if(o in i&&w.isObject(i[o])&&w.isObject(u[o])){this.mergeContents(i[o],u[o]);continue}i[o]=I.deepClone(u[o])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let u=null,o=null;const r=s=>{s&&(o?this.mergeContents(o,s):o=I.deepClone(s))};for(const s of this.overrides)l.equals(s.identifiers,[i])?u=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(u),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,u){this.addKey(i),(0,R.addToValueTree)(this.contents,i,u,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let u=this.keys.length;for(let o=0;o<u;o++)i.indexOf(this.keys[o])===0&&(u=o);this.keys.splice(u,1,i)}removeKey(i){const u=this.keys.indexOf(i);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=T;class E{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,u){if(!w.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,u)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,u){this._raw=i;const{contents:o,keys:r,overrides:s,restricted:n}=this.doParseRaw(i,u);this._configurationModel=new T(o,r,s),this._restrictedConfigurations=n||[]}doParseContent(i){let u={},o=null,r=[];const s=[],n=[];function c(f){Array.isArray(r)?r.push(f):o!==null&&(r[o]=f)}const d={onObjectBegin:()=>{const f={};c(f),s.push(r),r=f,o=null},onObjectProperty:f=>{o=f},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const f=[];c(f),s.push(r),r=f,o=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:c,onError:(f,y,L)=>{n.push({error:f,offset:y,length:L})}};if(i)try{D.visit(i,d),u=r[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return u}doParseRaw(i,u){const o=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,o,!0,u);i=r.raw;const s=(0,R.toValuesTree)(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),n=Object.keys(i),c=this.toOverrides(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:s,keys:n,overrides:c,restricted:r.restricted}}filter(i,u,o,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const s={},n=[];for(const c in i)if(k.OVERRIDE_PROPERTY_REGEX.test(c)&&o){const d=this.filter(i[c],u,!1,r);s[c]=d.raw,n.push(...d.restricted)}else{const d=u[c],f=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&n.push(c),(f===void 0||r.scopes===void 0||r.scopes.includes(f))&&(r.skipRestricted&&d?.restricted||(s[c]=i[c]))}return{raw:s,restricted:n}}toOverrides(i,u){const o=[];for(const r of Object.keys(i))if(k.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const n in i[r])s[n]=i[r][n];o.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,u)})}return o}}e.ConfigurationModelParser=E;class g extends P.Disposable{constructor(i,u,o,r){super(),this.userSettingsResource=i,this.scopes=u,this.fileService=r,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class b{constructor(i,u,o,r,s=new T,n=new T,c=new _.ResourceMap,d=new T,f=new _.ResourceMap,y=!0){this._defaultConfiguration=i,this._policyConfiguration=u,this._applicationConfiguration=o,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=f,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(i,u,o){return this.getConsolidatedConfigurationModel(i,u,o).getValue(i)}updateValue(i,u,o={}){let r;o.resource?(r=this._memoryConfigurationByResource.get(o.resource),r||(r=new T,this._memoryConfigurationByResource.set(o.resource,r))):r=this._memoryConfiguration,u===void 0?r.removeValue(i):r.setValue(i,u),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,u,o){const r=this.getConsolidatedConfigurationModel(i,u,o),s=this.getFolderConfigurationModelForResource(u.resource,o),n=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,c=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),f=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),y=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),L=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),M=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),B=o?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,A=s?u.overrideIdentifier?s.freeze().override(u.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,W=u.overrideIdentifier?n.override(u.overrideIdentifier).getValue(i):n.getValue(i),U=r.getValue(i),N=l.distinct(r.overrides.map(G=>G.identifiers).flat()).filter(G=>r.getOverrideValue(i,G)!==void 0);return{defaultValue:c,policyValue:d,applicationValue:f,userValue:y,userLocalValue:L,userRemoteValue:M,workspaceValue:B,workspaceFolderValue:A,memoryValue:W,value:U,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,application:f!==void 0?{value:f,override:u.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:s?.freeze().getValue(i),override:u.overrideIdentifier?s?.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:n.getValue(i),override:u.overrideIdentifier?n.getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(i){const u=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,u){this._folderConfigurations.set(i,u),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,u){const o=[];if(!u){const{added:r,updated:s,removed:n}=p(this._defaultConfiguration,i);u=[...r,...s,...n]}for(const r of u)for(const s of(0,k.overrideIdentifiersFromKey)(r)){const n=this._defaultConfiguration.getKeysForOverrideIdentifier(s),c=i.getKeysForOverrideIdentifier(s),d=[...c.filter(f=>n.indexOf(f)===-1),...n.filter(f=>c.indexOf(f)===-1),...n.filter(f=>!I.equals(this._defaultConfiguration.override(s).getValue(f),i.override(s).getValue(f)))];o.push([s,d])}return this.updateDefaultConfiguration(i),{keys:u,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:u,updated:o,removed:r}=p(this._policyConfiguration,i),s=[...u,...o,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:u,updated:o,removed:r,overrides:s}=p(this.applicationConfiguration,i),n=[...u,...o,...r];return n.length&&this.updateApplicationConfiguration(i),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:u,updated:o,removed:r,overrides:s}=p(this.localUserConfiguration,i),n=[...u,...o,...r];return n.length&&this.updateLocalUserConfiguration(i),{keys:n,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:u,updated:o,removed:r,overrides:s}=p(this.remoteUserConfiguration,i),n=[...u,...o,...r];return n.length&&this.updateRemoteUserConfiguration(i),{keys:n,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:u,updated:o,removed:r,overrides:s}=p(this.workspaceConfiguration,i),n=[...u,...o,...r];return n.length&&this.updateWorkspaceConfiguration(i),{keys:n,overrides:s}}compareAndUpdateFolderConfiguration(i,u){const o=this.folderConfigurations.get(i),{added:r,updated:s,removed:n,overrides:c}=p(o,u),d=[...r,...s,...n];return(d.length||!o)&&this.updateFolderConfiguration(i,u),{keys:d,overrides:c}}compareAndDeleteFolderConfiguration(i){const u=this.folderConfigurations.get(i);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:r,removed:s,overrides:n}=p(u,void 0);return{keys:[...o,...r,...s],overrides:n}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,u,o){let r=this.getConsolidatedConfigurationModelForResource(u,o);return u.overrideIdentifier&&(r=r.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},u){let o=this.getWorkspaceConsolidatedConfiguration();if(u&&i){const r=u.getFolder(i);r&&(o=this.getFolderConsolidatedConfiguration(r.uri)||o);const s=this._memoryConfigurationByResource.get(i);s&&(o=o.merge(s))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let u=this._foldersConsolidatedConfigurations.get(i);if(!u){const o=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(u=o.merge(r),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(i,u)):u=o}return u}getFolderConfigurationModelForResource(i,u){if(u&&i){const o=u.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,u)=>{const{contents:o,overrides:r,keys:s}=this._folderConfigurations.get(u);return i.push([u,{contents:o,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>i.add(u)),this.userConfiguration.freeze().keys.forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>u.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>u.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>u.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r))),[...u.values()]}static parse(i){const u=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),n=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((d,f)=>(d.set(C.URI.revive(f[0]),this.parseConfigurationModel(f[1])),d),new _.ResourceMap);return new b(u,o,r,s,new T,n,c,new T,new _.ResourceMap,!1)}static parseConfigurationModel(i){return new T(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=b;function m(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const i=new Set,u=new Map;for(const r of h)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,n])=>{const c=(0,_.getOrSet)(u,s,new Set);n.forEach(d=>c.add(d))});const o=[];return u.forEach((r,s)=>o.push([s,[...r.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=m;class v{constructor(i,u,o,r){this.change=i,this.previous=u,this.currentConfiguraiton=o,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(c=>s.add(c)),i.overrides.forEach(([,c])=>c.forEach(d=>s.add(d))),this.affectedKeys=[...s.values()];const n=new T;this.affectedKeys.forEach(c=>n.setValue(c,{})),this.affectedKeysTree=n.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(u){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,u,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,u,this.currentWorkspace);return!I.equals(o,r)}return!0}return!1}doesAffectedKeysTreeContains(i,u){let o=(0,R.toValuesTree)({[u]:!0},()=>{}),r;for(;typeof o=="object"&&(r=Object.keys(o)[0]);){if(i=i[r],!i)return!1;o=o[r]}return!0}}e.ConfigurationChangeEvent=v;function p(h,i){const{added:u,removed:o,updated:r}=a(i,h),s=[],n=h?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const d=c.filter(f=>!n.includes(f));for(const f of d)s.push([f,i.getKeysForOverrideIdentifier(f)])}if(h){const d=n.filter(f=>!c.includes(f));for(const f of d)s.push([f,h.getKeysForOverrideIdentifier(f)])}if(i&&h){for(const d of n)if(c.includes(d)){const f=a({contents:h.getOverrideValue(void 0,d)||{},keys:h.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});s.push([d,[...f.added,...f.removed,...f.updated]])}}return{added:u,removed:o,updated:r,overrides:s}}function a(h,i){const u=h?i?h.keys.filter(s=>i.keys.indexOf(s)===-1):[...h.keys]:[],o=i?h?i.keys.filter(s=>h.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(h&&i){for(const s of i.keys)if(h.keys.indexOf(s)!==-1){const n=(0,R.getConfigurationValue)(i.contents,s),c=(0,R.getConfigurationValue)(h.contents,s);I.equals(n,c)||r.push(s)}}return{added:u,removed:o,updated:r}}}),define(De[121],Ie([1,0,10,3]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends l.ErrorNoTelemetry{constructor(I,w=D.Unknown,C){super(I),this._message=I,this._code=w,this._detail=C,this.isHandled=w===D.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(I){return I instanceof P&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof P&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof P&&I.isHandled}}e.RemoteAuthorityResolverError=P}),define(De[122],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===l.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function D(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=D;function P(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=P;function _(C){const{host:R,port:k}=w(C);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:k}}e.parseAuthorityWithPort=_;function I(C,R){let{host:k,port:S}=w(C);return typeof S>"u"&&(S=R),{host:k,port:S}}e.parseAuthorityWithOptionalPort=I;function w(C){const R=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const k=C.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const S=C.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:C,port:void 0}}}),define(De[28],Ie([1,0,8,3,122]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=P;function _(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var w;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,b){if(typeof g>"u"||g===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof g=="string"||typeof b=="string"){const m=typeof g=="string"?g:g.value,v=typeof b=="string"?b:b.value;return l.equalsIgnoreCase(m,v)}return g._lower===b._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function R(E){return k(E)}e.isApplicationScopedExtension=R;function k(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function T(E,g){if(g){const b=`onResolveRemoteAuthority:${(0,D.getRemoteName)(g)}`;return E.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[198],Ie([1,0,8,84,28,11,2,10,40]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,l.compareIgnoreCase)(u.id,o.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{constructor(o,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=o.id}static create(o){const r=o.manifest?o.manifest.version:o.version,s=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new k(o.identifier,r,s)}static parse(o){const r=R.exec(o);return r&&r[1]&&r[2]?new k({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof k?C(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=k;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(u){const o=S.exec(u);return o&&o[1]?[g(o[1]),o[2]]:[g(u),void 0]}e.getIdAndVersion=T;function E(u,o){return`${u}.${o}`}e.getExtensionId=E;function g(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=g;function b(u,o){return g(E(u,o))}e.getGalleryExtensionId=b;function m(u,o){const r=[],s=n=>{for(const c of r)if(c.some(d=>C(o(d),o(n))))return c;return null};for(const n of u){const c=s(n);c?c.push(n):r.push([n])}return r}e.groupByExtension=m;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function p(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function a(u,o){const r=[],s=o.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const n=s.shift();if(n&&r.every(c=>!C(c.identifier,{id:n}))){const c=u.filter(d=>C(d.identifier,{id:n}));c.length===1&&(r.push(c[0]),s.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=a;async function h(u,o){if(!P.isLinux)return!1;let r;try{r=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){o.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(n))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function i(u,o){const r=await h(u,o),s=(0,t.getTargetPlatform)(r?"alpine":P.platform,w.arch);return o.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(De[199],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class l{constructor(){this.validators=new Map}vsda(){return new Promise((D,P)=>J(["vsda"],D,P))}async createNewMessage(D){try{const P=await this.vsda(),_=new P.validator;if(_){const I=String(l._nextId++);return this.validators.set(I,_),{id:I,data:_.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,P){if(!D.id)return!0;const _=this.validators.get(D.id);if(!_)return!1;this.validators.delete(D.id);try{return _.validate(P)==="ok"}catch{return!1}}async sign(D){try{const P=await this.vsda(),_=new P.signer;if(_)return _.sign(D)}catch{}return D}}e.SignService=l,l._nextId=1}),define(De[200],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,P,_=5){const I=P(w=>{const C=typeof w=="string"?w:w.data;let R=this._terminalBufferMap.get(D);if(R){R.data.push(C);return}const k=setTimeout(()=>this.flushBuffer(D),_);R={data:[C],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),I.dispose()}},this._terminalBufferMap.set(D,R)});return I}stopBuffering(D){this._terminalBufferMap.get(D)?.dispose()}flushBuffer(D){const P=this._terminalBufferMap.get(D);P&&(this._terminalBufferMap.delete(D),this._callback(D,P.data.join("")))}}e.TerminalDataBufferer=l}),define(De[201],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var l;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST_DARK="hcDark",P.HIGH_CONTRAST_LIGHT="hcLight"})(l=e.ColorScheme||(e.ColorScheme={}));function t(P){return P===l.HIGH_CONTRAST_DARK||P===l.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(P){return P===l.DARK||P===l.HIGH_CONTRAST_DARK}e.isDark=D}),define(De[86],Ie([1,0,75,4,6,3,43,201]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,P.createDecorator)("themeService");var w;(function(b){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}b.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function C(b){return{id:b}}e.themeColorFromId=C;var R;(function(b){function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||w.isThemeColor(r.color))}b.isThemeIcon=m;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function p(r){const s=v.exec(r);if(!s)return;const[,n]=s;return{id:n}}b.fromString=p;function a(r){return{id:r}}b.fromId=a;function h(r,s){let n=r.id;const c=n.lastIndexOf("~");return c!==-1&&(n=n.substring(0,c)),s&&(n=`${n}~${s}`),{id:n}}b.modify=h;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}b.getModifier=i;function u(r,s){return r.id===s.id&&r.color?.id===s.color?.id}b.isEqual=u;function o(r,s){return{id:r.id,color:s?C(s):void 0}}b.asThemeIcon=o,b.asClassNameArray=l.CSSIcon.asClassNameArray,b.asClassName=l.CSSIcon.asClassName,b.asCSSSelector=l.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function k(b){switch(b){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new S;_.Registry.add(e.Extensions.ThemingContribution,T);function E(b){return T.onColorThemeChange(b)}e.registerThemingParticipant=E;class g extends D.Disposable{constructor(m){super(),this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let p=this.theme.getColor(m);return p&&v&&(p=v(p,this.theme)),p?p.toString():null}}e.Themable=g}),define(De[123],Ie([1,0,4,11,3,14]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var _;(function(g){g.Http="http",g.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=k;function S(g,b){return b?b!==1&&g<1024:!t.isWindows&&g<1024}e.isPortPrivileged=S;class T{constructor(b,m,v){this.remoteAddress=b,this.localAddress=m,this._dispose=v,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let E=class{constructor(b){this.logService=b,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b){return this._tunnelProvider=b,b?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],m=Array.from(this._tunnels.values());for(const v of m){const p=Array.from(v.values());for(const a of p){const h=await a.value;h&&b.push(h)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:m}of b.values())await m.then(v=>v?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,m,v,p,a=!1,h,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${p}.`),!b)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(b,m,v,p,a,h,i);return u?u.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(o);return(o.tunnelRemoteHost!==m||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const m=this._tunnels.get(b.tunnelRemoteHost);if(m){const v=m.get(b.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,v))}}}}async tryDisposeTunnel(b,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${m}.`);const p=v.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(m),p}}async closeTunnel(b,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${m} `);const v=this._tunnels.get(b);if(v&&v.has(m)){const p=v.get(m);p.refcount=0,await this.tryDisposeTunnel(b,m,p)}}addTunnelToMap(b,m,v){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(b,m){const v=this._tunnels.get(b);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,m){const v=[b];R(b)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):k(b)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const p=v.map(a=>this._tunnels.get(a));for(const a of p){const h=a?.get(m);if(h)return h}}canTunnel(b){return!!C(b)}createWithProvider(b,m,v,p,a,h,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${p}.`);const u=v;this._factoryInProgress.add(u);const r={elevationRequired:a?S(p===void 0?v:p):!1},s={remoteAddress:{host:m,port:v},localAddressPort:p,privacy:h,public:h?h!==I.Private:void 0,protocol:i},n=b.forwardPort(s,r);return n?(this.addTunnelToMap(m,v,n),n.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),n}};E=qe([xe(0,P.ILogService)],E),e.AbstractTunnelService=E}),define(De[202],Ie([1,0,12]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(w){return w.scheme!==l.Schemas.file&&w.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=t;function D(w){if(w.folders.length)return w.folders.every(C=>t(C.uri))?w.folders[0].uri:void 0;if(w.configuration&&t(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=D;function P(w){return D(w)?.scheme}e.getVirtualWorkspaceScheme=P;function _(w){return D(w)?.authority}e.getVirtualWorkspaceAuthority=_;function I(w){return D(w)!==void 0}e.isVirtualWorkspace=I}),define(De[45],Ie([1,0,168,9,25,22,2,3,12]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function C(u){const o=u;return typeof o?.id=="string"&&_.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(u,o){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,t.basename)(u)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=u;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=R;function k(u){const o=u;return typeof o?.id=="string"&&_.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=k;function S(u){const o=u;if(o?.uri)return{id:o.id,uri:_.URI.revive(o.uri)};const r=u;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=S;var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function E(u){const o=u;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=E;function g(u){const o=u;return!!(o&&typeof o=="object"&&_.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=g;class b{constructor(o,r,s,n,c){this._id=o,this._transient=s,this._configuration=n,this._ignorePathCasing=c,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(o){this._id=o.id,this._configuration=o.configuration,this._transient=o.transient,this._ignorePathCasing=o._ignorePathCasing,this.folders=o.folders}get folders(){return this._folders}set folders(o){this._folders=o,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(o){this._configuration=o}getFolder(o){return o&&this._foldersMap.findSubstr(o)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const o of this.folders)this._foldersMap.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class m{constructor(o,r){this.raw=r,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,P.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function v(u){return new m({uri:u,index:0,name:(0,P.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,l.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(u,o){return P.extUriBiasedIgnorePathCase.isEqualOrParent(u,o.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function a(u){let o;return _.URI.isUri(u)?o=u:o=u.configuration,o?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=a;function h(u,o){return!p(u,o)&&!a(u)}e.isSavedWorkspace=h;function i(u){return(typeof u=="string"?(0,t.extname)(u):(0,P.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(De[87],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const P=this._idPool++;return this._data.set(P,D),this.logDebugInfo(),P}get(D,P){return this._data.has(D)?this._data.get(D)[P]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(De[46],Ie([1,0,12,22,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const w=this._providerInfo.get(I.scheme);return!(w===void 0||w&1024)})}$acceptProviderInfos(I,w){w===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,w)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(De[203],Ie([1,0,18]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(_,I,w){this._deferredPromises=new Map,this._id=_,this._shared=I,this._storage=w,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of C.values())R.complete()}catch(R){for(const k of C.values())k.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,I){let w=this._value[_];return typeof w>"u"&&(w=I),w}update(_,I){this._value[_]=I;const w=this._deferredPromises.get(_);if(w!==void 0)return w.p;const C=new l.DeferredPromise;return this._deferredPromises.set(_,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class D extends t{constructor(_,I){super(_.identifier.value,!0,I),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=D}),define(De[204],Ie([1,0,4,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new l.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,I,w,C){const k=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptModelChanged(I.value,w,C);this._onDidChangeNotebookDocument.fire(k)}$acceptDirtyStateChanged(_,I){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_)).acceptDirty(I)}$acceptModelSaved(_){const I=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(_));this._onDidSaveNotebookDocument.fire(I.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(De[15],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class t{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[205],Ie([1,0,28,4]),function(J,e,l,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,w){D.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(I.identifier),tt(this,D,w,"f"),Ue(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(I){return Ue(this,D,"f").get(this._id,I)}store(I,w){return Ue(this,D,"f").store(this._id,I,w)}delete(I){return Ue(this,D,"f").delete(this._id,I)}}e.ExtensionSecrets=P,D=new WeakMap}),define(De[124],Ie([1,0,3,4]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new t.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,I){this._level=_,this._productConfig=I||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(De[53],Ie([1,0,3,123,4,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(w){function C(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:k.protocol}}w.fromApiTunnel=C;function R(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==t.TunnelPrivacyId.ConstantPrivate&&k.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}w.fromServiceTunnel=R})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let I=class{constructor(C){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,k,S,T){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=qe([xe(0,P.IExtHostRpcService)],I),e.ExtHostTunnelService=I}),define(De[54],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class t{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=t}),define(De[206],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(w){let C=this.buffers.indexOf(w);return C<0&&(C=this.buffers.length,this.buffers.push(w)),C}}function D(I,w){if(w.serializeBuffersForPostMessage){const C=new t,R=(T,E)=>{if(E instanceof ArrayBuffer){const g=C.add(E);return{$$vscode_array_buffer_reference$$:!0,index:g}}else if(ArrayBuffer.isView(E)){const g=P(E);if(g){const b=C.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:g,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},k=JSON.stringify(I,R),S=C.buffers.map(T=>{const E=new Uint8Array(T);return l.VSBuffer.wrap(E)});return{message:k,buffers:S}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=D;function P(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(I,w){const C=w.map(S=>{const T=new ArrayBuffer(S.byteLength);return new Uint8Array(T).set(S.buffer),T}),R=w.length?(S,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const E=T,{index:g}=E,b=C[g];if(E.view)switch(E.view.type){case 1:return new Int8Array(b,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return T}:void 0;return{message:JSON.parse(I,R),arrayBuffers:C}}e.deserializeWebviewMessage=_}),define(De[207],Ie([1,0,107]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(P){return{transformIncoming:_=>_.scheme==="vscode-remote"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="file"?{scheme:"vscode-local",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoing:_=>_.scheme==="file"?{scheme:"vscode-remote",authority:P,path:_.path,query:_.query,fragment:_.fragment}:_.scheme==="vscode-local"?{scheme:"file",path:_.path,query:_.query,fragment:_.fragment}:_,transformOutgoingScheme:_=>_==="file"?"vscode-remote":_==="vscode-local"?"file":_}}function D(P){return new l.URITransformer(t(P))}e.createURITransformer=D}),define(De[125],Ie([1,0,178,13,2,6,3,43,42,17,12]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var S;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(S=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(O){const x=O;return!!x&&typeof x.getSelection=="function"&&!!x.onDidChangeSelection}e.isEditorPaneWithSelection=T;function E(O,x,V){for(const q of V.visibleEditorPanes)if(q.group.id===x&&O.matches(q.input))return q.getViewState()}e.findViewStateForEditor=E;function g(O){if(r(O))return!1;const x=O;return D.URI.isUri(x?.resource)}e.isResourceEditorInput=g;function b(O){if(r(O))return!1;const x=O;return x?.original!==void 0&&x.modified!==void 0}e.isResourceDiffEditorInput=b;function m(O){if(r(O)||b(O))return!1;const x=O;return x?.primary!==void 0&&x.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function v(O){if(r(O))return!1;const x=O;return x?x.resource===void 0||x.resource.scheme===R.Schemas.untitled||x.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;function p(O){if(r(O))return!1;const x=O;return D.URI.isUri(x?.base?.resource)&&D.URI.isUri(x?.input1?.resource)&&D.URI.isUri(x?.input2?.resource)&&D.URI.isUri(x?.result?.resource)}e.isResourceMergeEditorInput=p;var a;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var h;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(x,V){let q=this.mapIdToSaveSource.get(x);return q||(q={source:x,label:V},this.mapIdToSaveSource.set(x,q)),q.source}getSourceLabel(x){return this.mapIdToSaveSource.get(x)?.label??x}}e.SaveSourceRegistry=new i;var u;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class o extends P.Disposable{}e.AbstractEditorInput=o;function r(O){return O instanceof o}e.isEditorInput=r;function s(O){const x=O;return D.URI.isUri(x?.preferredResource)}function n(O){const x=O;return r(x?.primary)&&r(x?.secondary)}e.isSideBySideEditorInput=n;function c(O){const x=O;return r(x?.modified)&&r(x?.original)}e.isDiffEditorInput=c;function d(O){return r(O?.editor)}e.isEditorInputWithOptions=d;function f(O){const x=O;return d(O)&&x?.group!==void 0}e.isEditorInputWithOptionsAndGroup=f;function y(O){const x=O;return typeof x?.groupId=="number"&&r(x.editor)}e.isEditorIdentifier=y;var L;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(L=e.EditorCloseContext||(e.EditorCloseContext={}));var M;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(M=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class A{getOriginalUri(x,V){if(!x)return;if(p(x))return e.EditorResourceAccessor.getOriginalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===B.ANY)return this.getOriginalUri(Y,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===B.PRIMARY?Y:Q}}if(b(x)||m(x)||p(x))return;const q=s(x)?x.preferredResource:x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}getSideEditors(x){return n(x)||m(x)?{primary:x.primary,secondary:x.secondary}:c(x)||b(x)?{primary:x.modified,secondary:x.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(x,V){if(!x)return;if(p(x))return e.EditorResourceAccessor.getCanonicalUri(x.result,V);if(V?.supportSideBySide){const{primary:Y,secondary:Q}=this.getSideEditors(x);if(Y&&Q){if(V?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===B.ANY)return this.getCanonicalUri(Y,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Q,{filterByScheme:V.filterByScheme});x=V.supportSideBySide===B.PRIMARY?Y:Q}}if(b(x)||m(x)||p(x))return;const q=x.resource;return!q||!V||!V.filterByScheme?q:this.filterUri(q,V.filterByScheme)}filterUri(x,V){if(Array.isArray(V)){if(V.some(q=>x.scheme===q))return x}else if(V===x.scheme)return x}}e.EditorResourceAccessor=new A;var W;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(W=e.CloseDirection||(e.CloseDirection={}));class U{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(x){const V=this.instantiationService=x.get(_.IInstantiationService);for(const[q,Y]of this.editorSerializerConstructors)this.createEditorSerializer(q,Y,V);this.editorSerializerConstructors.clear()}createEditorSerializer(x,V,q){const Y=q.createInstance(V);this.editorSerializerInstances.set(x,Y)}registerFileEditorFactory(x){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=x}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(x,V){if(this.editorSerializerConstructors.has(x)||this.editorSerializerInstances.has(x))throw new Error(`A editor serializer with type ID '${x}' was already registered.`);return this.instantiationService?this.createEditorSerializer(x,V,this.instantiationService):this.editorSerializerConstructors.set(x,V),(0,P.toDisposable)(()=>{this.editorSerializerConstructors.delete(x),this.editorSerializerInstances.delete(x)})}getEditorSerializer(x){return this.editorSerializerInstances.get(typeof x=="string"?x:x.typeId)}}I.Registry.add(e.EditorExtensions.EditorFactory,new U);async function N(O,x){if(!O||!O.length)return[];const V=await Promise.all(O.map(async q=>{const Y=D.URI.revive(q.fileUri);if(!Y||!await x.canHandleResource(Y))return;let he=q.exists,ve=q.type;if(typeof he!="boolean"||typeof ve!="number")try{ve=(await x.stat(Y)).isDirectory?w.FileType.Directory:w.FileType.Unknown,he=!0}catch{he=!1}if(!he&&q.openOnlyIfExists||ve===w.FileType.Directory)return;const ne={...q.options,pinned:!0};let pe;return he?pe={resource:Y,options:ne}:pe={resource:Y,options:ne,forceUntitled:!0},pe}));return(0,C.coalesce)(V)}e.pathsToEditors=N;var G;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(G=e.EditorsOrder||(e.EditorsOrder={}));function z(O){const x=O;if(!x)return!1;const V=x;if(V.modified)return z(V.modified);const q=x;return!!(q.contributionsState&&q.viewState&&Array.isArray(q.cursorState))}e.isTextEditorViewState=z}),define(De[88],Ie([1,0,12,2]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(I,w){return I.scheme===l.Schemas.http||I.scheme===l.Schemas.https?I:(w&&w.authority&&w.isRemote&&I.scheme===l.Schemas.file&&(I=t.URI.from({scheme:l.Schemas.vscodeRemote,authority:w.authority,path:I.path})),t.URI.from({scheme:l.Schemas.https,authority:`${I.scheme}+${P(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=D;function P(I){return I.replace(/./g,w=>{const C=w.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?w:"-"+C.toString(16).padStart(4,"0")})}function _(I){return I.replace(/-([0-9a-f]{4})/g,(w,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=_}),define(De[208],Ie([1,0,4,6,88]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class P{constructor(I,w,C){this._proxy=I,this._editors=w,this._remoteInfo=C,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(w.onDidChangeVisibleTextEditors(()=>{const R=w.getVisibleTextEditors();for(const k of this._insets.values())R.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,w,C,R,k){let S;for(const p of this._editors.getVisibleTextEditors(!0))if(p.value===I){S=p;break}if(!S)throw new Error("not a visible editor");const T=this,E=this._handlePool++,g=new l.Emitter,b=new l.Emitter,m=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(p){return(0,D.asWebviewUri)(p,T._remoteInfo)}get cspSource(){return D.webviewGenericCspSource}set options(p){this._options=p,T._proxy.$setOptions(E,p)}get options(){return this._options}set html(p){this._html=p,T._proxy.$setHtml(E,p)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(p){return T._proxy.$postMessage(E,p)}},v=new class{constructor(){this.editor=I,this.line=w,this.height=C,this.webview=m,this.onDidDispose=b.event}dispose(){T._insets.has(E)&&(T._insets.delete(E),T._proxy.$disposeEditorInset(E),b.fire(),b.dispose(),g.dispose())}};return this._proxy.$createEditorInset(E,S.id,S.value.document.uri,w+1,C,R||{},k.identifier,k.extensionLocation),this._insets.set(E,{editor:I,inset:v,onDidReceiveMessage:g}),v}$onDidDispose(I){const w=this._insets.get(I);w&&w.inset.dispose()}$onDidReceiveMessage(I,w){this._insets.get(I)?.onDidReceiveMessage.fire(w)}}e.ExtHostEditorInsets=P}),define(De[126],Ie([1,0,4,18,179]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,w,C,R){const k={command:I};if(w&&Object.keys(w).length>0&&(k.arguments=w),this.internalSend("request",k),typeof R=="number"){const S=setTimeout(()=>{clearTimeout(S);const T=this.pendingRequests.get(k.seq);if(T){this.pendingRequests.delete(k.seq);const E={type:"response",seq:0,request_seq:k.seq,success:!1,command:I,message:(0,D.localize)(0,null,R,I)};T(E)}},R)}return C&&this.pendingRequests.set(k.seq,C),k.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,w){return I.type!=="event"||w.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback?.(I);break;case"request":this.requestCallback?.(I);break;case"response":{const w=I,C=this.pendingRequests.get(w.request_seq);C&&(this.pendingRequests.delete(w.request_seq),C(w));break}}}}internalSend(I,w){w.type=I,w.seq=this.sequence++,this.sendMessage(w)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((w,C)=>I.set(C,w)),await(0,t.timeout)(500),I.forEach((w,C)=>{w({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(De[209],Ie([1,0,180,52,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:l.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:l.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:l.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:l.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:l.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:l.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:l.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:l.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:l.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:l.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:l.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:l.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:l.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:l.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:l.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:l.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:l.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:l.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:l.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:l.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:l.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new t.RawContextKey("breakpointAccessType",void 0,{type:"string",description:l.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:l.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:l.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:l.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:l.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:l.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:l.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:l.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:l.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:l.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:l.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:l.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:l.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:l.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:l.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:l.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:l.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:l.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:l.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:l.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:l.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:l.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:l.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:l.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:l.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:l.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:l.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:l.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:l.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:l.localize(50,null)});const P=S=>l.localize(51,null,S);e.debuggerDisabledMessage=P,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:l.localize(52,null)};var _;(function(S){S[S.Inactive=0]="Inactive",S[S.Initializing=1]="Initializing",S[S.Stopped=2]="Stopped",S[S.Running=3]="Running"})(_=e.State||(e.State={}));function I(S){switch(S){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=I;var w;(function(S){S[S.Valid=0]="Valid",S[S.Unreadable=1]="Unreadable",S[S.Error=2]="Error"})(w=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(S){S[S.Initial=1]="Initial",S[S.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(S){S.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,D.createDecorator)(e.DEBUG_SERVICE_ID);var k;(function(S){S[S.CONDITION=0]="CONDITION",S[S.HIT_COUNT=1]="HIT_COUNT",S[S.LOG_MESSAGE=2]="LOG_MESSAGE"})(k=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[210],Ie([1,0,8,2,9,24,12]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function w(o,r,s){return o.replace(I,function(n,c){return r&&c.length>0&&c[0]!=="_"?n:s&&s.hasOwnProperty(c)?s[c]:n})}e.formatPII=w;function C(o){const r={};for(const s of Object.keys(o))s.startsWith("!")||(r[s]=o[s]);return r}e.filterExceptionsFromTelemetry=C;function R(o){return o.configuration.request==="attach"&&!k(o)&&(!o.parentSession||R(o.parentSession))}e.isSessionAttach=R;function k(o){let r=o.configuration.type;if(!!r)return r==="vslsShare"&&(r=o.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(r,"extensionhost")||(0,l.equalsIgnoreCase)(r,"pwa-extensionhost")?o:o.parentSession?k(o.parentSession):void 0}e.getExtensionHostDebugSession=k;function S(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=S;function T(o,r,s){let n,c=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=d.exec(o);){const y=f.index+1,L=y+f[0].length;if(y<=r&&L>=s){n=f[0],c=y;break}}if(n){const y=/\w+/g;let L=null;for(;(L=y.exec(n))&&!(L.index+1+c+L[0].length>=s););L&&(n=n.substring(0,y.lastIndex))}return n?{start:c,end:c+n.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(o){return!!(o&&o.match(E))}e.isUri=g;function b(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(g(o.path))return t.URI.parse(o.path);if((0,D.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function m(o){if(typeof o.path=="object"){const r=t.URI.revive(o.path);if(r)return r.scheme===_.Schemas.file?r.fsPath:r.toString()}return o.path}function v(o,r){const s=r?b:m,n=(0,P.deepClone)(o);return a(n,(c,d)=>{c&&d&&(d.path=s(d))}),n}e.convertToDAPaths=v;function p(o,r){const s=r?b:m,n=(0,P.deepClone)(o);return a(n,(c,d)=>{!c&&d&&(d.path=s(d))}),n}e.convertToVSCPaths=p;function a(o,r){switch(o.type){case"event":{const s=o;switch(s.event){case"output":r(!1,s.body.source);break;case"loadedSource":r(!1,s.body.source);break;case"breakpoint":r(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=o;switch(s.command){case"setBreakpoints":r(!0,s.arguments.source);break;case"breakpointLocations":r(!0,s.arguments.source);break;case"source":r(!0,s.arguments.source);break;case"gotoTargets":r(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(n=>r(!1,n));break;default:break}break}case"response":{const s=o;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(n=>r(!1,n.source));break;case"loadedSources":s.body.sources.forEach(n=>r(!1,n));break;case"scopes":s.body.scopes.forEach(n=>r(!1,n.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(n=>r(!1,n.source));break;case"setBreakpoints":s.body.breakpoints.forEach(n=>r(!1,n.source));break;case"disassemble":s.body?.instructions.forEach(c=>r(!1,c.location));break;default:break}break}}}function h(o){return o.filter(r=>!r.presentation?.hidden).sort((r,s)=>r.presentation?s.presentation?r.presentation.group?s.presentation.group?r.presentation.group!==s.presentation.group?r.presentation.group.localeCompare(s.presentation.group):i(r.presentation.order,s.presentation.order):-1:s.presentation.group?1:i(r.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=h;function i(o,r){return typeof o!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:o-r}async function u(o,r){const s=o.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(s!=="none"&&(await r.saveAll(),s==="allEditorsInActiveGroup")){const n=r.activeEditorPane;n&&n.input.resource?.scheme===_.Schemas.untitled&&await r.save({editor:n.input,groupId:n.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(De[211],Ie([1,0,29,44,181,212,9,8,24,11,84,126]),function(J,e,l,t,D,P,_,I,w,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class S extends k.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(v,p){this.outputStream=p,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,v.on("data",a=>this.handleData(a))}sendMessage(v){if(this.outputStream){const p=JSON.stringify(v);this.outputStream.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${S.TWO_CRLF}${p}`,"utf8")}}handleData(v){for(this.rawData=Buffer.concat([this.rawData,v]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const p=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+p))}continue}}else{const p=this.rawData.indexOf(S.TWO_CRLF);if(p!==-1){const h=this.rawData.toString("utf8",0,p).split(S.HEADER_LINESEPARATOR);for(const i of h){const u=i.split(S.HEADER_FIELDSEPARATOR);u[0]==="Content-Length"&&(this.contentLength=Number(u[1]))}this.rawData=this.rawData.slice(p+S.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=S,S.TWO_CRLF=`\r
\r
`,S.HEADER_LINESEPARATOR=/\r?\n/,S.HEADER_FIELDSEPARATOR=/: */;class T extends S{startSession(){return new Promise((v,p)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),v(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.socket.on("error",h=>{a?this._onError.fire(h):p(h)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=T;class E extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",v)}}e.SocketDebugAdapter=E;class g extends T{constructor(v){super(),this.adapterServer=v}createConnection(v){return P.createConnection(this.adapterServer.path,v)}}e.NamedPipeDebugAdapter=g;class b extends S{constructor(v,p,a){super(),this.adapterExecutable=v,this.debugType=p,this.outputService=a}async startSession(){const v=this.adapterExecutable.command,p=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(v)if(_.isAbsolute(v)){if(!await l.Promises.exists(v))throw new Error(D.localize(0,null,v))}else v.indexOf("/")<0&&v.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let h=process.env;if(a.env&&Object.keys(a.env).length>0&&(h=w.mixin(w.deepClone(process.env),a.env)),v==="node")if(Array.isArray(p)&&p.length>0){const u=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:h,execArgv:u?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(o.cwd=a.cwd);const r=t.fork(p[0],p.slice(1),o);if(!r.pid)throw new Error(D.localize(2,null,p[0]));this.serverProcess=r}else throw new Error(D.localize(3,null));else{const u={env:h};a.cwd&&(u.cwd=a.cwd),this.serverProcess=t.spawn(v,p,u)}this.serverProcess.on("error",u=>{this._onError.fire(u)}),this.serverProcess.on("exit",(u,o)=>{this._onExit.fire(u)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",u=>{this._onError.fire(u)}),this.serverProcess.stdin.on("error",u=>{this._onError.fire(u)});const i=this.outputService;if(i){const u=o=>o.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",o=>{i.getChannel(R.ExtensionsChannelId)?.append(u(o))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(h){this._onError.fire(h)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((v,p)=>{const a=t.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(h,i,u){if(h)return p(h)});a.on("exit",v),a.on("error",p)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(v,p){if(!v)return;const a=Object.create(null);v.runtime&&(v.runtime.indexOf("./")===0?a.runtime=_.join(p,v.runtime):a.runtime=v.runtime),v.runtimeArgs&&(a.runtimeArgs=v.runtimeArgs),v.program&&(_.isAbsolute(v.program)?a.program=v.program:a.program=_.join(p,v.program)),v.args&&(a.args=v.args);const h=v;return h.win&&(a.win=b.extract(h.win,p)),h.winx86&&(a.winx86=b.extract(h.winx86,p)),h.windows&&(a.windows=b.extract(h.windows,p)),h.osx&&(a.osx=b.extract(h.osx,p)),h.linux&&(a.linux=b.extract(h.linux,p)),a}static platformAdapterExecutable(v,p){let a=Object.create(null);p=p.toLowerCase();for(const s of v)if(s.contributes){const n=s.contributes.debuggers;n&&n.length>0&&n.filter(c=>typeof c.type=="string"&&I.equalsIgnoreCase(c.type,p)).forEach(c=>{const d=b.extract(c,s.extensionLocation.fsPath);a=w.mixin(a,d,s.isBuiltin)})}let h;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?h=a.winx86||a.win||a.windows:C.isWindows?h=a.win||a.windows:C.isMacintosh?h=a.osx:C.isLinux&&(h=a.linux),h=h||a;const i=h.program||a.program,u=h.args||a.args,o=h.runtime||a.runtime,r=h.runtimeArgs||a.runtimeArgs;if(o)return{type:"executable",command:o,args:(r||[]).concat(typeof i=="string"?[i]:[]).concat(u||[])};if(i)return{type:"executable",command:i,args:u||[]}}}e.ExecutableDebugAdapter=b}),define(De[213],Ie([1,0,44,31,11]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function P(C,R){return new Promise((k,S)=>{let T="";const E=l.spawn(C,R);E.pid&&E.stdout.on("data",g=>{T+=g.toString()}),E.on("error",g=>{S(g)}),E.on("close",g=>{k(T)})})}async function _(C){if(C)if(D.isWindows){const R=await new Promise((k,S)=>{J(["windows-process-tree"],k,S)});return new Promise(k=>{R.getProcessTree(C,S=>{k(!!S&&S.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(C)]).then(R=>{const k=R.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=_;var I;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(I||(I={}));function w(C,R,k,S,T){C=C.trim().toLowerCase();let E;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?E=1:C.indexOf("cmd.exe")>=0?E=0:C.indexOf("bash")>=0?E=2:D.isWindows?E=0:E=2;let g,b=" ";switch(E){case 1:if(g=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),S){const m=(0,t.getDriveLetter)(S);m&&(b+=`${m}:; `),b+=`cd ${g(S)}; `}if(T)for(const m in T){const v=T[m];v===null?b+=`Remove-Item env:${m}; `:b+=`\${env:${m}}='${v}'; `}if(R.length>0){const m=R.shift(),v=k?m:g(m);b+=v[0]==="'"?`& ${v} `:`${v} `;for(const p of R)b+=p==="<"||p===">"||k?p:g(p),b+=" "}break;case 0:if(g=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(v=>m.includes(v))||m.length===0?`"${m}"`:m),S){const m=(0,t.getDriveLetter)(S);m&&(b+=`${m}: && `),b+=`cd ${g(S)} && `}if(T){b+='cmd /C "';for(const m in T){let v=T[m];v===null?b+=`set "${m}=" && `:(v=v.replace(/[&^|<>]/g,p=>`^${p}`),b+=`set "${m}=${v}" && `)}}for(const m of R)b+=m==="<"||m===">"||k?m:g(m),b+=" ";T&&(b+='"');break;case 2:{g=v=>(v=v.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),v.length===0?'""':v);const m=v=>/[^\w@%\/+=,.:^-]/.test(v)?`'${v.replace(/'/g,"'\\''")}'`:v;if(S&&(b+=`cd ${g(S)} ; `),T){b+="/usr/bin/env";for(const v in T){const p=T[v];p===null?b+=` -u ${m(v)}`:b+=` ${m(`${v}=${p}`)}`}b+=" "}for(const v of R)b+=v==="<"||v===">"||k?v:g(v),b+=" ";break}}return b}e.prepareCommand=w}),define(De[127],Ie([1,0,23,36,60,100,12,9,11,52]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",P.Mimes.latex,P.Mimes.markdown,"image/png","image/jpeg",P.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[P.Mimes.latex,P.Mimes.markdown,"application/json",P.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var S;(function(n){n[n.Unconfirmed=1]="Unconfirmed",n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(S=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeCellLanguage=5]="ChangeCellLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var v;(function(n){n.scheme=_.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${c.join("")}]+`),f=7;function y(N,G){const z=G.toString(f),x=`${z.length<c.length?c[z.length-1]:"z"}${z}s${(0,l.encodeBase64)(l.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:n.scheme,fragment:x})}n.generate=y;function L(N){if(N.scheme!==n.scheme)return;const G=N.fragment.indexOf("s");if(G<0)return;const z=parseInt(N.fragment.substring(0,G).replace(d,""),f),O=(0,l.decodeBase64)(N.fragment.substring(G+1)).toString();if(!isNaN(z))return{handle:z,notebook:N.with({scheme:O,fragment:null})}}n.parse=L;const M=/^(\d{8,})(\w[\w\d+.-]*)$/;function B(N,G){return N.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${G??""},${N.scheme!==_.Schemas.file?N.scheme:""}`})}n.generateCellOutputUri=B;function A(N){if(N.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const G=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!G)return;const z=G[1]&&G[1]!==""?G[1]:void 0,O=G[2];return{outputId:z,notebook:N.with({scheme:O||_.Schemas.file,fragment:null})}}n.parseCellOutputUri=A;function W(N,G,z){return N.with({scheme:z,fragment:`ch${G.toString().padStart(7,"0")}${N.scheme!==_.Schemas.file?N.scheme:""}`})}n.generateCellUri=W;function U(N,G){if(N.scheme!==G)return;const z=M.exec(N.fragment);return z?{handle:Number(z[1]),notebook:N.with({scheme:N.fragment.substring(z[0].length)||_.Schemas.file,fragment:null})}:void 0}n.parseCellUri=U})(v=e.CellUri||(e.CellUri={}));const p=n=>w.isWindows?n.replace(/\//g,"\\"):n;class a{constructor(c=[],d=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=d,this.order=[...new Set(c)].map(f=>({pattern:f,matches:t.parse(p(f))}))}sort(c){const d=new Map(D.Iterable.map(c,y=>[y,p(y)]));let f=[];for(const{matches:y}of this.order)for(const[L,M]of d)if(y(M)){f.push(L),d.delete(L);break}return d.size&&(f=f.concat([...d.keys()].sort((y,L)=>this.defaultOrder.indexOf(y)-this.defaultOrder.indexOf(L)))),f}prioritize(c,d){const f=this.findIndex(c);if(f===-1){this.order.unshift({pattern:c,matches:t.parse(p(c))});return}const y=new Set(d.map(M=>this.findIndex(M,f)));y.delete(-1);const L=Array.from(y).sort();this.order.splice(f+1,0,...L.map(M=>this.order[M]));for(let M=L.length-1;M>=0;M--)this.order.splice(L[M],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,d=this.order.length){const f=p(c);for(let y=0;y<d;y++)if(this.order[y].matches(f))return y;return-1}}e.MimeTypeDisplayOrder=a;function h(n,c,d,f=(y,L)=>y===L){const y=[];function L(A,W,U){if(W===0&&U.length===0)return;const N=y[y.length-1];N&&N.start+N.deleteCount===A?(N.deleteCount+=W,N.toInsert.push(...U)):y.push({start:A,deleteCount:W,toInsert:U})}let M=0,B=0;for(;;){if(M===n.length){L(M,0,c.slice(B));break}if(B===c.length){L(M,n.length-M,[]);break}const A=n[M],W=c[B];if(f(A,W)){M+=1,B+=1;continue}d(W)?(L(M,1,[]),M+=1):(L(M,0,[W]),B+=1)}return y}e.diff=h,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(n){n.default="default",n.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(n){const c=n;return!!((typeof c.include=="string"||t.isRelativePattern(c.include))&&(typeof c.exclude=="string"||t.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=u;function o(n,c,d){if(Array.isArray(n.viewType)&&n.viewType.indexOf(c)>=0||n.viewType===c)return!0;if(n.filenamePattern){const f=u(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,y=u(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(t.match(f,(0,I.basename)(d.fsPath).toLowerCase()))return!(y&&t.match(y,(0,I.basename)(d.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(c){return`${s._prefix}${c}`}static parse(c){if(c.startsWith(s._prefix))return c.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(De[214],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(De[215],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=l;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t;function D(_){return Array.from(_.entries()).map(I=>[I[0],l(I[1].map)])}e.serializeEnvironmentVariableCollections=D;function P(_){return new Map(_.map(I=>[I[0],{map:t(I[1])}]))}e.deserializeEnvironmentVariableCollections=P}),define(De[64],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(P){P.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class D{constructor(_,I=_.length){if(this.path=_,this.viewEnd=I,_.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,I,w=_.parent){if(_.id===I)return new D([I]);const C=[_.id];for(let R=w;R&&R.id!==I;R=R.parent)C.push(R.id);return C.push(I),new D(C.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const I=_.indexOf("\0");return I===-1?_:_.slice(0,I)}static fromString(_){return new D(_.split("\0"))}static join(_,I){return new D([..._.path,I])}static joinToString(_,I){return _.toString()+"\0"+I}static compare(_,I){return _===I?0:I.startsWith(_+"\0")?2:_.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new D(this.path,_)}compare(_){if(typeof _=="string")return D.compare(this.toString(),_);for(let I=0;I<_.viewEnd&&I<this.viewEnd;I++)if(_.path[I]!==this.path[I])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=D}),define(De[65],Ie([1,0,2,35]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var D;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(D=e.TestResultState||(e.TestResultState={}));var P;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(P=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(s){s.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),s.deserialize=n=>({range:t.Range.lift(n.range),uri:l.URI.revive(n.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var I;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var w;(function(s){s.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&_.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&_.deserialize(n.location)})})(w=e.ITestErrorMessage||(e.ITestErrorMessage={}));var C;(function(s){s.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&_.serialize(n.location)}),s.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&_.deserialize(n.location)})})(C=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(s){s.serialize=n=>n.type===0?w.serialize(n):C.serialize(n),s.deserialize=n=>n.type===0?w.deserialize(n):C.deserialize(n)})(R=e.ITestMessage||(e.ITestMessage={}));var k;(function(s){s.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),s.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.serialize)}),s.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(R.deserialize)})})(k=e.ITestTaskState||(e.ITestTaskState={}));const S="\0",T=(s,n)=>s+S+n;e.namespaceTestTag=T;const E=s=>{const n=s.indexOf(S);return{ctrlId:s.slice(0,n),tagId:s.slice(n+1)}};e.denamespaceTestTag=E;var g;(function(s){s.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),s.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?l.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(g=e.ITestItem||(e.ITestItem={}));var b;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var m;(function(s){s.serialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:g.serialize(n.item)}),s.deserialize=n=>({controllerId:n.controllerId,expand:n.expand,parent:n.parent,item:g.deserialize(n.item)})})(m=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(s){s.serialize=n=>{let c;return n.item&&(c={},n.item.label!==void 0&&(c.label=n.item.label),n.item.tags!==void 0&&(c.tags=n.item.tags),n.item.busy!==void 0&&(c.busy=n.item.busy),n.item.uri!==void 0&&(c.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(c.range=n.item.range?.toJSON()),n.item.description!==void 0&&(c.description=n.item.description),n.item.error!==void 0&&(c.error=n.item.error),n.item.sortText!==void 0&&(c.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:c,docv:n.docv}},s.deserialize=n=>{let c;return n.item&&(c={},n.item.label!==void 0&&(c.label=n.item.label),n.item.tags!==void 0&&(c.tags=n.item.tags),n.item.busy!==void 0&&(c.busy=n.item.busy),n.item.range!==void 0&&(c.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(c.description=n.item.description),n.item.error!==void 0&&(c.error=n.item.error),n.item.sortText!==void 0&&(c.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:c,docv:n.docv}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const p=(s,n)=>{n.expand!==void 0&&(s.expand=n.expand),n.item!==void 0&&(s.item=s.item?Object.assign(s.item,n.item):n.item)};e.applyTestItemUpdate=p;var a;(function(s){s.serializeWithoutMessages=n=>({...m.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serializeWithoutMessages),retired:n.retired}),s.serialize=n=>({...m.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(k.serialize),retired:n.retired})})(a=e.TestResultItem||(e.TestResultItem={}));var h;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(h=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=n=>n.op===0?{op:n.op,item:m.deserialize(n.item)}:n.op===1?{op:n.op,item:v.deserialize(n.item)}:n,s.serialize=n=>n.op===0?{op:n.op,item:m.serialize(n.item)}:n.op===1?{op:n.op,item:v.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class o{add(n){}update(n){}remove(n,c){}complete(){}}e.IncrementalChangeCollector=o;class r{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const c=this.createChangeCollector();for(const d of n)switch(d.op){case 0:{const f=m.deserialize(d.item);if(f.parent){if(this.items.has(f.parent)){const y=this.items.get(f.parent);y.children.add(f.item.extId);const L=this.createItem(f,y);this.items.set(f.item.extId,L),c.add(L)}}else{const y=this.createItem(f);this.roots.add(y),this.items.set(f.item.extId,y),c.add(y)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=v.deserialize(d.item),y=this.items.get(f.extId);if(!y)break;f.expand!==void 0&&(y.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(y,f),c.update(y);break}case 2:{const f=this.items.get(d.itemId);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const y=[[d.itemId]];for(;y.length;)for(const L of y.pop()){const M=this.items.get(L);M&&(y.push(M.children),this.items.delete(L),c.remove(M,M!==f),M.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(d.itemId);break;case 3:this.updatePendingRoots(d.amount);break;case 5:this._tags.set(d.tag.id,d.tag);break;case 6:this._tags.delete(d.id);break}c.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new o}}e.AbstractIncrementalTestCollection=r}),define(De[89],Ie([1,0,18,4,6,48,65,64]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(m,v)=>m===v,R={range:(m,v)=>m===v?!0:!m||!v?!1:m.equalsRange(v),busy:C,label:C,description:C,error:C,tags:(m,v)=>!(m.length!==v.length||m.some(p=>!v.includes(p)))},k=(m,v)=>{let p;for(const[a,h]of Object.entries(R))h(m[a],v[a])||(p?p[a]=v[a]:p={[a]:v[a]});return p};class S extends D.Disposable{constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const p=this.diff[this.diff.length-1];if(p&&v.op===1){if(p.op===1&&p.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(p.item,v.item);return}if(p.op===0&&p.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(p.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,p){const a=this.tree.get(v);if(!!a){if((a.expandLevels===void 0||p>a.expandLevels)&&(a.expandLevels=p),a.expand===1){const h=this.resolveChildren(a);return h.isOpen()?this.expandChildren(a,p-1):h.wait().then(()=>this.expandChildren(a,p-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,p-1)):this.expandChildren(a,p-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,p){switch(p.op){case 3:this.removeItem(I.TestId.joinToString(v.fullId,p.id));break;case 0:this.upsertItem(p.item,v);break;case 5:for(const a of p.ops)this.onTestItemEvent(v,a);break;case 1:this.diffTagRefs(p.new,p.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:p.update,docv:this.options.getDocumentVersion(v.actual.uri)}});break;default:(0,P.assertNever)(p)}}upsertItem(v,p){const a=I.TestId.fromExtHostTestItem(v,this.root.id,p?.actual),h=this.options.getApiFor(v);h.parent&&h.parent!==p?.actual&&this.options.getChildren(h.parent).delete(v.id);let i=this.tree.get(a.toString());if(!i){i={fullId:a,actual:v,parent:p?a.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(v,p),this.pushDiff({op:0,item:{parent:i.parent&&i.parent.toString(),controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,i,p);return}if(i.actual===v){this.connectItem(v,i,p);return}const u=this.options.getChildren(i.actual),o=i.actual,r=k(this.options.toITestItem(o),this.options.toITestItem(v));this.options.getApiFor(o).listener=void 0,i.actual=v,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,o.tags,a.toString()),delete r.tags),this.onTestItemEvent(i,{op:4,update:r})),this.connectItemAndChildren(v,i,p);for(const[s,n]of u)this.options.getChildren(v).get(n.id)||this.removeItem(I.TestId.joinToString(a,n.id))}diffTagRefs(v,p,a){const h=new Set(p.map(i=>i.id));for(const i of v)h.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:a,item:{tags:v.map(i=>(0,_.namespaceTestTag)(this.options.controllerId,i.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const p=this.tags.get(v.id);p?p.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const p=this.tags.get(v);p&&!--p.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,p){this.options.getApiFor(v).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(v,p,a){this.setItemParent(v,a);const h=this.options.getApiFor(v);h.parent=a?.actual,h.listener=i=>this.onTestItemEvent(p,i),this.updateExpandability(p)}connectItemAndChildren(v,p,a){this.connectItem(v,p,a);for(const[h,i]of this.options.getChildren(v))this.upsertItem(i,p)}updateExpandability(v){let p;this._resolveHandler?v.resolveBarrier?p=v.resolveBarrier.isOpen()?3:2:p=v.actual.canResolveChildren?1:0:p=0,p!==v.expand&&(v.expand=p,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:p}}),p===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,p){if(p<0)return;const a=[];for(const[h,i]of this.options.getChildren(v.actual)){const u=this.expand(I.TestId.joinToString(v.fullId,i.id),p);(0,l.isThenable)(u)&&a.push(u)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const i=new l.Barrier;return i.open(),i}v.expand=2,this.pushExpandStateUpdate(v);const p=v.resolveBarrier=new l.Barrier,a=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let h;try{h=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(i){a(i)}return(0,l.isThenable)(h)?h.catch(a).then(()=>{p.open(),this.updateExpandability(v)}):(p.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const p=this.tree.get(v);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const a=[p];for(;a.length;){const h=a.pop();if(!!h){this.options.getApiFor(h.actual).listener=void 0;for(const i of h.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(h.fullId.toString());for(const[i,u]of this.options.getChildren(h.actual))a.push(this.tree.get(I.TestId.joinToString(h.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=S;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class E extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class g extends Error{constructor(v,p,a){super(`TestItem with ID "${v}" is from controller "${p}" and cannot be added as a child of an item from controller "${a}".`)}}e.MixedTestItemController=g;const b=(m,v,p)=>{let a=new Map;return{get size(){return a.size},forEach(h,i){for(const u of a.values())h.call(i,u,this)},[Symbol.iterator](){return a.entries()},replace(h){const i=new Map,u=new Set(a.keys()),o={op:5,ops:[]};for(const r of h){if(!(r instanceof p))throw new E(r.id);const s=v(r).controllerId;if(s!==m.controllerId)throw new g(r.id,s,m.controllerId);if(i.has(r.id))throw new T(r.id);i.set(r.id,r),u.delete(r.id),o.ops.push({op:0,item:r})}for(const r of u.keys())o.ops.push({op:3,id:r});m.listener?.(o),a=i},add(h){if(!(h instanceof p))throw new E(h.id);a.set(h.id,h),m.listener?.({op:0,item:h})},delete(h){a.delete(h)&&m.listener?.({op:3,id:h})},get(h){return a.get(h)},toJSON(){return Array.from(a.values())}}};e.createTestItemChildren=b}),define(De[128],Ie([1,0,89]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,D=(_,I)=>{const w={controllerId:I};return t.set(_,w),w};e.createPrivateApiFor=D;const P=_=>{const I=t.get(_);if(!I)throw new l.InvalidTestItemError(_?.id||"<unknown>");return I};e.getPrivateApiFor=P}),define(De[216],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,l.createDecorator)("configurationResolverService");var t;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(_,I){super(I),this.variable=_}}e.VariableError=D}),define(De[217],Ie([1,0,9,40,13,24,11,106,184,216,8]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,E,g,b){this._contributedVariables=new Map,this._context=T,this._labelService=E,this._userHomePromise=g,b&&(this._envVariablesPromise=b.then(m=>this.prepareEnv(m)))}prepareEnv(T){if(_.isWindows){const E=Object.create(null);return Object.keys(T).forEach(g=>{E[g.toLowerCase()]=T[g]}),E}return T}resolveWithEnvironment(T,E,g){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},E?E.uri:void 0,g)}async resolveAsync(T,E){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,T?T.uri:void 0,E)}async resolveAnyBase(T,E,g,b){const m=P.deepClone(E);_.isWindows&&m.windows?Object.keys(m.windows).forEach(p=>m[p]=m.windows[p]):_.isMacintosh&&m.osx?Object.keys(m.osx).forEach(p=>m[p]=m.osx[p]):_.isLinux&&m.linux&&Object.keys(m.linux).forEach(p=>m[p]=m.linux[p]),delete m.windows,delete m.osx,delete m.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,m,g,b)}async resolveAnyAsync(T,E,g){return this.resolveAnyBase(T,E,g)}async resolveAnyMap(T,E,g){const b=new Map;return{newConfig:await this.resolveAnyBase(T,E,g,b),resolvedVariables:b}}resolveWithInteractionReplace(T,E,g,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,E,g,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,E){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,E)}async recursiveResolve(T,E,g,b,m){if(D.isString(g))return this.resolveString(T,E,g,b,m);if(Array.isArray(g))return Promise.all(g.map(v=>this.recursiveResolve(T,E,v,b,m)));if(D.isObject(g)){const v=Object.create(null),p=await Promise.all(Object.keys(g).map(async a=>[await this.resolveString(T,E,a,b,m),await this.recursiveResolve(T,E,g[a],b,m)]));for(const[a,h]of p)v[a]=h;return v}return g}resolveString(T,E,g,b,m){return(0,R.replaceAsync)(g,k.VARIABLE_REGEXP,async(v,p)=>{if(p.includes(k.VARIABLE_LHS))return v;let a=await this.evaluateSingleVariable(T,v,p,E,b);return m?.set(p,a),a!==v&&D.isString(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.resolveString(T,E,a,b,m)),a})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,E,g,b,m){let v;const p=g.split(":");p.length>1&&(g=p[0],v=p[1]);const a=u=>{const o=this._context.getFilePath();if(o)return o;throw new C.VariableError(u,(0,w.localize)(0,null,E))},h=u=>{const o=a(u);if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new C.VariableError(u,(0,w.localize)(1,null,E,l.basename(o)))},i=u=>{if(v){const o=this._context.getFolderUri(v);if(o)return o;throw new C.VariableError(u,(0,w.localize)(2,null,E,v))}if(b)return b;throw this._context.getWorkspaceFolderCount()>1?new C.VariableError(u,(0,w.localize)(3,null,E)):new C.VariableError(u,(0,w.localize)(4,null,E))};switch(g){case"env":if(v){if(T.env){const u=T.env[_.isWindows?v.toLowerCase():v];if(D.isString(u))return u}return""}throw new C.VariableError(C.VariableKind.Env,(0,w.localize)(5,null,E));case"config":if(v){const u=this._context.getConfigurationValue(b,v);if(D.isUndefinedOrNull(u))throw new C.VariableError(C.VariableKind.Config,(0,w.localize)(6,null,E,v));if(D.isObject(u))throw new C.VariableError(C.VariableKind.Config,(0,w.localize)(7,null,E,v));return u}throw new C.VariableError(C.VariableKind.Config,(0,w.localize)(8,null,E));case"command":return this.resolveFromMap(C.VariableKind.Command,E,v,m,"command");case"input":return this.resolveFromMap(C.VariableKind.Input,E,v,m,"input");case"extensionInstallFolder":if(v){const u=await this._context.getExtension(v);if(!u)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,E,v));return this.fsPath(u.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,E));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(i(C.VariableKind.WorkspaceFolder)));case"cwd":return b||v?(0,I.normalizeDriveLetter)(this.fsPath(i(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(i(C.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,w.localize)(11,null,E))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new C.VariableError(C.VariableKind.LineNumber,(0,w.localize)(12,null,E))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new C.VariableError(C.VariableKind.SelectedText,(0,w.localize)(13,null,E))}case"file":return a(C.VariableKind.File);case"fileWorkspaceFolder":return h(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return b||v?l.relative(this.fsPath(i(C.VariableKind.RelativeFile)),a(C.VariableKind.RelativeFile)):a(C.VariableKind.RelativeFile);case"relativeFileDirname":{const u=l.dirname(a(C.VariableKind.RelativeFileDirname));if(b||v){const o=l.relative(this.fsPath(i(C.VariableKind.RelativeFileDirname)),u);return o.length===0?".":o}return u}case"fileDirname":return l.dirname(a(C.VariableKind.FileDirname));case"fileExtname":return l.extname(a(C.VariableKind.FileExtname));case"fileBasename":return l.basename(a(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=l.basename(a(C.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-l.extname(u).length)}case"fileDirnameBasename":return l.basename(l.dirname(a(C.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||E}case"execInstallFolder":{const u=this._context.getAppRoot();return u||E}case"pathSeparator":return l.sep;default:try{const u=v?`${g}:${v}`:g;return this.resolveFromMap(C.VariableKind.Unknown,E,u,m,void 0)}catch{return E}}}}resolveFromMap(T,E,g,b,m){if(g&&b){const v=m===void 0?b[g]:b[m+":"+g];if(typeof v=="string")return v;throw new C.VariableError(T,(0,w.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[129],Ie([1,0,3,125]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var D;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var P;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var I;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function C(E){const g=E;return(0,t.isEditorInput)(g?.editor)&&(0,t.isEditorInput)(g?.replacement)}e.isEditorReplacement=C;var R;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(k=e.OpenEditorContext||(e.OpenEditorContext={}));function S(E){const g=E;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=S;function T(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(De[218],Ie([1,0,3,129]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(P){const _=P;return typeof P=="number"||(0,t.isEditorGroup)(_)}e.isPreferredGroup=D}),define(De[219],Ie([1,0,3,189]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(t.IEnvironmentService)}),define(De[220],Ie([1,0,28,4,9]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(k){this.removedDueToLooping=k}}e.DeltaExtensionsResult=P;class _{constructor(k){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=k,this._initialize()}_initialize(){this._extensionDescriptions.sort(w),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const k of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(k.identifier))){console.error("Extension `"+k.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(k.identifier),k),this._extensionsArr.push(k),Array.isArray(k.activationEvents))for(let S of k.activationEvents)S==="onUri"&&(S=`onUri:${l.ExtensionIdentifier.toKey(k.identifier)}`),this._activationMap.has(S)||this._activationMap.set(S,[]),this._activationMap.get(S).push(k)}}set(k){this._extensionDescriptions=k,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(k,S){this._extensionDescriptions=C(this._extensionDescriptions,S),this._extensionDescriptions=this._extensionDescriptions.concat(k);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=C(this._extensionDescriptions,T.map(E=>E.identifier)),this._initialize(),this._onDidChange.fire(void 0),new P(T)}static _findLoopingExtensions(k){const S=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,v){this.addNode(m),this.addNode(v),this._arcs.has(m)?this._arcs.get(m).push(v):this._arcs.set(m,[v])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,v){const p=S.getArcs(m);for(let a=0;a<p.length;a++)if(!v.has(p[a]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const m of k){const v=l.ExtensionIdentifier.toKey(m.identifier);if(T.set(v,m),m.extensionDependencies)for(const p of m.extensionDependencies){const a=l.ExtensionIdentifier.toKey(p);S.addArc(v,a)}}const E=new Set;S.getNodes().filter(m=>S.getArcs(m).length===0).forEach(m=>E.add(m));const g=S.getNodes().filter(m=>!E.has(m));let b;do{b=!1;for(let m=0;m<g.length;m++){const v=g[m];S.hasOnlyGoodArcs(v,E)&&(g.splice(m,1),m--,E.add(v),b=!0)}}while(b);return g.map(m=>T.get(m))}containsActivationEvent(k){return this._activationMap.has(k)}containsExtension(k){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(k))}getExtensionDescriptionsForActivationEvent(k){const S=this._activationMap.get(k);return S?S.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(k){const S=this._extensionsMap.get(l.ExtensionIdentifier.toKey(k));return S||void 0}getExtensionDescriptionByUUID(k){for(const S of this._extensionsArr)if(S.uuid===k)return S}getExtensionDescriptionByIdOrUUID(k,S){return this.getExtensionDescription(k)??(S?this.getExtensionDescriptionByUUID(S):void 0)}}e.ExtensionDescriptionRegistry=_;var I;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(I||(I={}));function w(R,k){const S=R.isBuiltin?0:R.isUnderDevelopment?2:1,T=k.isBuiltin?0:k.isUnderDevelopment?2:1;if(S!==T)return S-T;const E=D.posix.basename(R.extensionLocation.path),g=D.posix.basename(k.extensionLocation.path);return E<g?-1:E>g?1:0}function C(R,k){const S=new Set;return k.forEach(T=>S.add(l.ExtensionIdentifier.toKey(T))),R.filter(T=>!S.has(l.ExtensionIdentifier.toKey(T.identifier)))}}),define(De[221],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var l;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(l=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class D{constructor(){this.type=2}serialize(k){k[D.ENV_KEY]="1"}}e.SocketExtHostConnection=D,D.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class P{constructor(){this.type=3}serialize(k){k[P.ENV_KEY]="1"}}e.MessagePortExtHostConnection=P,P.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function _(R){delete R[t.ENV_KEY],delete R[D.ENV_KEY],delete R[P.ENV_KEY]}function I(R,k){_(k),R.serialize(k)}e.writeExtHostConnection=I;function w(R){if(R[t.ENV_KEY])return C(R,new t(R[t.ENV_KEY]));if(R[D.ENV_KEY])return C(R,new D);if(R[P.ENV_KEY])return C(R,new P);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function C(R,k){return _(R),k}}),define(De[130],Ie([1,0,23]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var D;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function _(C){const R=l.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=_;function I(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=I;var w;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(w=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[27],Ie([1,0,4,2,3,28,198]),function(J,e,l,t,D,P,_){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class w{constructor(n){this.affinity=n,this.kind=1}equals(n){return this.kind===n.kind&&this.affinity===n.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class C{constructor(){this.kind=2,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=C;class R{constructor(){this.kind=3,this.affinity=0}equals(n){return this.kind===n.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class k{constructor(n){this.dependency=n}}e.MissingExtensionDependency=k;var S;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class E{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(n,c){const d=[],f=[],y=[],L=[],M=m(this._allExtensions),B=m(n),A=(G,z)=>G.extensionLocation.toString()===z.extensionLocation.toString()||G.isBuiltin===z.isBuiltin||G.isUserBuiltin===z.isUserBuiltin||G.isUnderDevelopment===z.isUnderDevelopment;for(const G of this._allExtensions){const z=B.get(P.ExtensionIdentifier.toKey(G.identifier));if(!z){d.push(G.identifier),M.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}if(!A(G,z)){d.push(G.identifier),M.delete(P.ExtensionIdentifier.toKey(G.identifier));continue}}for(const G of n){const z=M.get(P.ExtensionIdentifier.toKey(G.identifier));if(!z){f.push(G);continue}if(!A(z,G)){d.push(z.identifier),M.delete(P.ExtensionIdentifier.toKey(z.identifier));continue}}const W=b(this._myExtensions),U=b(c);for(const G of this._myExtensions)U.has(P.ExtensionIdentifier.toKey(G))||y.push(G);for(const G of c)W.has(P.ExtensionIdentifier.toKey(G))||L.push(G);const N={toRemove:d,toAdd:f,myToRemove:y,myToAdd:L};return this.delta(N),N}delta(n){const{toRemove:c,toAdd:d,myToRemove:f,myToAdd:y}=n,L=b(c),M=b(f);for(let B=0;B<this._allExtensions.length;B++)L.has(P.ExtensionIdentifier.toKey(this._allExtensions[B].identifier))&&(this._allExtensions.splice(B,1),B--);for(let B=0;B<this._myExtensions.length;B++)M.has(P.ExtensionIdentifier.toKey(this._myExtensions[B]))&&(this._myExtensions.splice(B,1),B--);for(const B of d)this._allExtensions.push(B);for(const B of y)this._myExtensions.push(B)}containsExtension(n){for(const c of this._myExtensions)if(P.ExtensionIdentifier.equals(c,n))return!0;return!1}}e.ExtensionHostExtensions=E;class g{constructor(n){if(this[I]="ExtensionIdentifierSet",this._map=new Map,this._toKey=P.ExtensionIdentifier.toKey,n)for(const c of n)this.add(c)}get size(){return this._map.size}add(n){return this._map.set(this._toKey(n),n),this}clear(){this._map.clear()}delete(n){return this._map.delete(this._toKey(n))}has(n){return this._map.has(this._toKey(n))}forEach(n,c){this._map.forEach(d=>n.call(c,d,d,this))}*entries(){for(const[n,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=g;function b(s){const n=new Set;for(const c of s)n.add(P.ExtensionIdentifier.toKey(c));return n}e.extensionIdentifiersArrayToSet=b;function m(s){const n=new Map;for(const c of s)n.set(P.ExtensionIdentifier.toKey(c.identifier),c);return n}function v(s,n){return s.enabledApiProposals?s.enabledApiProposals.includes(n):!1}e.isProposedApiEnabled=v;function p(s,n){if(!v(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=p;class a{constructor(n,c,d,f){this.codeLoadingTime=n,this.activateCallTime=c,this.activateResolvedTime=d,this.activationReason=f}}e.ActivationTimes=a;class h{constructor(n,c){this.description=n,this.value=c}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function u(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function o(s,n){return{identifier:new P.ExtensionIdentifier((0,_.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=o;class r{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(n){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(n,c){return Promise.resolve(0)}getInspectPorts(n,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(n,c){return Promise.resolve()}}e.NullExtensionService=r}),define(De[222],Ie([1,0,10,28,27,14,18]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class I{constructor(b,m,v,p){this.startup=b,this.codeLoadingTime=m,this.activateCallTime=v,this.activateResolvedTime=p}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class w{constructor(b){this._startup=b,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(b,m){return b===-1||m===-1?-1:m-b}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=w;class C{constructor(b,m,v,p,a,h){this.activationFailed=b,this.activationFailedError=m,this.activationTimes=v,this.module=p,this.exports=a,this.subscriptions=h}}e.ActivatedExtension=C;class R extends C{constructor(b){super(!1,null,b,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class k extends C{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class S extends C{constructor(b){super(!0,b,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=S;let T=class{constructor(b,m,v,p,a){this._logService=a,this._registry=b,this._resolvedExtensionsSet=new Set,m.forEach(h=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(h))),this._externalExtensionsMap=new Map,v.forEach(h=>this._externalExtensionsMap.set(t.ExtensionIdentifier.toKey(h),h)),this._host=p,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[b,m]of this._operations)m.dispose()}isActivated(b){const m=this._operations.get(t.ExtensionIdentifier.toKey(b));return Boolean(m&&m.value)}getActivatedExtension(b){const m=this._operations.get(t.ExtensionIdentifier.toKey(b));if(!m||!m.value)throw new Error(`Extension '${b.value}' is not known or not activated`);return m.value}async activateByEvent(b,m){if(this._alreadyActivatedEvents[b])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(b);await this._activateExtensions(v.map(p=>({id:p.identifier,reason:{startup:m,extensionId:p.identifier,activationEvent:b}}))),this._alreadyActivatedEvents[b]=!0}activateById(b,m){const v=this._registry.getExtensionDescription(b);if(!v)throw new Error(`Extension '${b}' is not known`);return this._activateExtensions([{id:v.identifier,reason:m}])}async _activateExtensions(b){const m=b.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(m.map(v=>v.wait()))}_handleActivationRequest(b){if(this._operations.has(t.ExtensionIdentifier.toKey(b.id)))return this._operations.get(t.ExtensionIdentifier.toKey(b.id));if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(b.id)))return this._createAndSaveOperation(b,null,[],null);const m=this._registry.getExtensionDescription(b.id);if(!m){const a=new Error(`Cannot activate unknown extension '${b.id.value}'`),h=this._createAndSaveOperation(b,null,[],new S(a));return this._host.onExtensionActivationError(b.id,a,new D.MissingExtensionDependency(b.id.value)),h}const v=[],p=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const a of p){if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(a)))continue;const h=this._operations.get(t.ExtensionIdentifier.toKey(a));if(h){v.push(h);continue}if(this._externalExtensionsMap.has(t.ExtensionIdentifier.toKey(a))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(t.ExtensionIdentifier.toKey(a)),reason:b.reason}));continue}const i=this._registry.getExtensionDescription(a);if(i){if(!i.main&&!i.browser)continue;v.push(this._handleActivationRequest({id:i.identifier,reason:b.reason}));continue}const u=m.displayName||m.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${a}'`),r=this._createAndSaveOperation(b,m.displayName,[],new S(o));return this._host.onExtensionActivationError(m.identifier,o,new D.MissingExtensionDependency(a)),r}return this._createAndSaveOperation(b,m.displayName,v,null)}_createAndSaveOperation(b,m,v,p){const a=new E(b.id,m,b.reason,v,p,this._host,this._logService);return this._operations.set(t.ExtensionIdentifier.toKey(b.id),a),a}};T=qe([xe(4,P.ILogService)],T),e.ExtensionsActivator=T;let E=class{constructor(b,m,v,p,a,h,i){this._id=b,this._displayName=m,this._reason=v,this._deps=p,this._value=a,this._host=h,this._logService=i,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let b=0;b<this._deps.length;b++){const m=this._deps[b];if(m.value&&!m.value.activationFailed){this._deps.splice(b,1),b--;continue}if(m.value&&m.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);v.detail=m.value.activationFailedError,this._value=new S(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(b=>b.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(b){const m=new Error;if(b&&b.name&&(m.name=b.name),b&&b.message?m.message=`Activating extension '${this._id.value}' failed: ${b.message}.`:m.message=`Activating extension '${this._id.value}' failed: ${b}.`,b&&b.stack&&(m.stack=b.stack),this._value=new S(m),this._isDisposed&&l.isCancellationError(b))return;this._host.onExtensionActivationError(this._id,m,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(b)}}};E=qe([xe(6,P.ILogService)],E)}),define(De[223],Ie([1,0,14,26,27]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends l.LogService{constructor(I,w){super(I.createLogger(w.logFile,{name:D.ExtensionHostLogFileName}))}};P=qe([xe(0,l.ILoggerService),xe(1,t.IExtHostInitDataService)],P),e.ExtHostLogService=P});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[7],Ie([1,0,17,10,105,25,100,8,13,2,34,42,121,27]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T){"use strict";var E,g,b,m,v,p,a,h,i,u,o,r,s,n,c,d,f,y,L,M,B,A,W;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function U(j){function $(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf($,j),Object.setPrototypeOf($.prototype,j.prototype),$}let N=p=class{constructor($){E.set(this,void 0),tt(this,E,$,"f")}static from(...$){let fe=$;return new p(function(){if(fe){for(const Pe of fe)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();fe=void 0}})}dispose(){typeof Ue(this,E,"f")=="function"&&(Ue(this,E,"f").call(this),tt(this,E,void 0,"f"))}};E=new WeakMap,N=p=qe([U],N),e.Disposable=N;let G=a=class{constructor($,fe){if($<0)throw(0,t.illegalArgument)("line must be non-negative");if(fe<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=$,this._character=fe}static Min(...$){if($.length===0)throw new TypeError;let fe=$[0];for(let Pe=1;Pe<$.length;Pe++){const Xe=$[Pe];Xe.isBefore(fe)&&(fe=Xe)}return fe}static Max(...$){if($.length===0)throw new TypeError;let fe=$[0];for(let Pe=1;Pe<$.length;Pe++){const Xe=$[Pe];Xe.isAfter(fe)&&(fe=Xe)}return fe}static isPosition($){if(!$)return!1;if($ instanceof a)return!0;const{line:fe,character:Pe}=$;return typeof fe=="number"&&typeof Pe=="number"}static of($){if($ instanceof a)return $;if(this.isPosition($))return new a($.line,$.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,fe=0){if($===null||fe===null)throw(0,t.illegalArgument)();let Pe;return typeof $>"u"?Pe=0:typeof $=="number"?Pe=$:(Pe=typeof $.lineDelta=="number"?$.lineDelta:0,fe=typeof $.characterDelta=="number"?$.characterDelta:0),Pe===0&&fe===0?this:new a(this.line+Pe,this.character+fe)}with($,fe=this.character){if($===null||fe===null)throw(0,t.illegalArgument)();let Pe;return typeof $>"u"?Pe=this.line:typeof $=="number"?Pe=$:(Pe=typeof $.line=="number"?$.line:this.line,fe=typeof $.character=="number"?$.character:this.character),Pe===this.line&&fe===this.character?this:new a(Pe,fe)}toJSON(){return{line:this.line,character:this.character}}};G=a=qe([U],G),e.Position=G;let z=h=class{constructor($,fe,Pe,Xe){let rt,dt;if(typeof $=="number"&&typeof fe=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(rt=new G($,fe),dt=new G(Pe,Xe)):G.isPosition($)&&G.isPosition(fe)&&(rt=G.of($),dt=G.of(fe)),!rt||!dt)throw new Error("Invalid arguments");rt.isBefore(dt)?(this._start=rt,this._end=dt):(this._start=dt,this._end=rt)}static isRange($){return $ instanceof h?!0:$?G.isPosition($.start)&&G.isPosition($.end):!1}static of($){if($ instanceof h)return $;if(this.isRange($))return new h($.start,$.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains($){return h.isRange($)?this.contains($.start)&&this.contains($.end):G.isPosition($)?!(G.of($).isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const fe=G.Max($.start,this._start),Pe=G.Min($.end,this._end);if(!fe.isAfter(Pe))return new h(fe,Pe)}union($){if(this.contains($))return this;if($.contains(this))return $;const fe=G.Min($.start,this._start),Pe=G.Max($.end,this.end);return new h(fe,Pe)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,fe=this.end){if($===null||fe===null)throw(0,t.illegalArgument)();let Pe;return $?G.isPosition($)?Pe=$:(Pe=$.start||this.start,fe=$.end||this.end):Pe=this.start,Pe.isEqual(this._start)&&fe.isEqual(this.end)?this:new h(Pe,fe)}toJSON(){return[this.start,this.end]}};z=h=qe([U],z),e.Range=z;let O=i=class extends z{constructor($,fe,Pe,Xe){let rt,dt;if(typeof $=="number"&&typeof fe=="number"&&typeof Pe=="number"&&typeof Xe=="number"?(rt=new G($,fe),dt=new G(Pe,Xe)):G.isPosition($)&&G.isPosition(fe)&&(rt=G.of($),dt=G.of(fe)),!rt||!dt)throw new Error("Invalid arguments");super(rt,dt),this._anchor=rt,this._active=dt}static isSelection($){return $ instanceof i?!0:$?z.isRange($)&&G.isPosition($.anchor)&&G.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};O=i=qe([U],O),e.Selection=O;class x{constructor($,fe,Pe){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,t.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z\-]+$/.test(Pe)))throw(0,t.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(fe),this.connectionToken=Pe}}e.ResolvedAuthority=x;class V extends Error{constructor($,fe=S.RemoteAuthorityResolverErrorCode.Unknown,Pe){super($),this._message=$,this._code=fe,this._detail=Pe,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable($,fe){return new V($,S.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable($){return new V($,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var q;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var Y;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Y=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Q=u=class{constructor($,fe){this._range=$,this._newText=fe}static isTextEdit($){return $ instanceof u?!0:$?z.isRange($)&&typeof $.newText=="string":!1}static replace($,fe){return new u($,fe)}static insert($,fe){return u.replace(new z($,$),fe)}static delete($){return u.replace($,"")}static setEndOfLine($){const fe=new u(new z(new G(0,0),new G(0,0)),"");return fe.newEol=$,fe}get range(){return this._range}set range($){if($&&!z.isRange($))throw(0,t.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,t.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,t.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Q=u=qe([U],Q),e.TextEdit=Q;let he=o=class{constructor($,fe){this.range=$,this.newCells=fe}static isNotebookCellEdit($){return $ instanceof o?!0:$?Vt.isNotebookRange($)&&Array.isArray($.newCells):!1}static replaceCells($,fe){return new o($,fe)}static insertCells($,fe){return new o(new Vt($,$),fe)}static deleteCells($){return new o($,[])}static updateCellMetadata($,fe){const Pe=new o(new Vt($,$),[]);return Pe.newCellMetadata=fe,Pe}static updateNotebookMetadata($){const fe=new o(new Vt(0,0),[]);return fe.newNotebookMetadata=$,fe}};he=o=qe([U],he),e.NotebookEdit=he;class ve{constructor($,fe){this.range=$,this.snippet=fe}static isSnippetTextEdit($){return $ instanceof ve?!0:$?z.isRange($.range)&&be.isSnippetString($.snippet):!1}}e.SnippetTextEdit=ve;var ne;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ne=e.FileEditType||(e.FileEditType={}));let pe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,fe,Pe,Xe){this._edits.push({_type:1,from:$,to:fe,options:Pe,metadata:Xe})}createFile($,fe,Pe){this._edits.push({_type:1,from:void 0,to:$,options:fe,metadata:Pe})}deleteFile($,fe,Pe){this._edits.push({_type:1,from:$,to:void 0,options:fe,metadata:Pe})}replaceNotebookMetadata($,fe,Pe){this._edits.push({_type:3,metadata:Pe,uri:$,edit:{editType:5,metadata:fe},notebookMetadata:fe})}replaceNotebookCells($,fe,Pe,Xe){const rt=fe.start,dt=fe.end;(rt!==dt||Pe.length>0)&&this._edits.push({_type:5,uri:$,index:rt,count:dt-rt,cells:Pe,metadata:Xe})}replaceNotebookCellMetadata($,fe,Pe,Xe){this._edits.push({_type:3,metadata:Xe,uri:$,edit:{editType:8,index:fe,metadata:Pe}})}replace($,fe,Pe,Xe){this._edits.push({_type:2,uri:$,edit:new Q(fe,Pe),metadata:Xe})}insert($,fe,Pe,Xe){this.replace($,new z(fe,fe),Pe,Xe)}delete($,fe,Pe){this.replace($,fe,"",Pe)}has($){return this._edits.some(fe=>fe._type===2&&fe.uri.toString()===$.toString())}set($,fe){if(fe)for(const Pe of fe)Pe&&(he.isNotebookCellEdit(Pe)?Pe.newCellMetadata?this.replaceNotebookCellMetadata($,Pe.range.start,Pe.newCellMetadata):Pe.newNotebookMetadata?this.replaceNotebookMetadata($,Pe.newNotebookMetadata):this.replaceNotebookCells($,Pe.range,Pe.newCells):ve.isSnippetTextEdit(Pe)?this._edits.push({_type:6,uri:$,range:Pe.range,edit:Pe.snippet}):this._edits.push({_type:2,uri:$,edit:Pe}));else{for(let Pe=0;Pe<this._edits.length;Pe++){const Xe=this._edits[Pe];Xe._type===2&&Xe.uri.toString()===$.toString()&&(this._edits[Pe]=void 0)}(0,l.coalesceInPlace)(this._edits)}}get($){const fe=[];for(const Pe of this._edits)Pe._type===2&&Pe.uri.toString()===$.toString()&&fe.push(Pe.edit);return fe}entries(){const $=new P.ResourceMap;for(const fe of this._edits)if(fe._type===2){let Pe=$.get(fe.uri);Pe||(Pe=[fe.uri,[]],$.set(fe.uri,Pe)),Pe[1].push(fe.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};pe=qe([U],pe),e.WorkspaceEdit=pe;let be=r=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof r?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=r._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,fe=this._tabstop++){if(typeof $=="function"){const Pe=new r;Pe._tabstop=this._tabstop,$(Pe),this._tabstop=Pe._tabstop,$=Pe.value}else $=r._escape($);return this.value+="${",this.value+=fe,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,fe=this._tabstop++){const Pe=$.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable($,fe){if(typeof fe=="function"){const Pe=new r;Pe._tabstop=this._tabstop,fe(Pe),this._tabstop=Pe._tabstop,fe=Pe.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};be=r=qe([U],be),e.SnippetString=be;var Te;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(Le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let We=s=class{constructor($,fe){if(this.uri=$,fe)if(z.isRange(fe))this.range=z.of(fe);else if(G.isPosition(fe))this.range=new z(fe,fe);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof s?!0:$?z.isRange($.range)&&C.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};We=s=qe([U],We),e.Location=We;let oe=class{constructor($,fe){this.location=$,this.message=fe}static is($){return $?typeof $.message=="string"&&$.location&&z.isRange($.location.range)&&C.URI.isUri($.location.uri):!1}static isEqual($,fe){return $===fe?!0:!$||!fe?!1:$.message===fe.message&&$.location.range.isEqual(fe.location.range)&&$.location.uri.toString()===fe.location.uri.toString()}};oe=qe([U],oe),e.DiagnosticRelatedInformation=oe;let le=class{constructor($,fe,Pe=Le.Error){if(!z.isRange($))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=$,this.message=fe,this.severity=Pe}toJSON(){return{severity:Le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,fe){return $===fe?!0:!$||!fe?!1:$.message===fe.message&&$.severity===fe.severity&&$.code===fe.code&&$.severity===fe.severity&&$.source===fe.source&&$.range.isEqual(fe.range)&&(0,l.equals)($.tags,fe.tags)&&(0,l.equals)($.relatedInformation,fe.relatedInformation,oe.isEqual)}};le=qe([U],le),e.Diagnostic=le;let me=class{constructor($,fe){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=fe}};me=qe([U],me),e.Hover=me;var Z;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ae=class{constructor($,fe=Z.Text){this.range=$,this.kind=fe}toJSON(){return{range:this.range,kind:Z[this.kind]}}};ae=qe([U],ae),e.DocumentHighlight=ae;var ee;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ee=e.SymbolKind||(e.SymbolKind={}));var ie;(function(j){j[j.Deprecated=1]="Deprecated"})(ie=e.SymbolTag||(e.SymbolTag={}));let F=n=class{constructor($,fe,Pe,Xe,rt){this.name=$,this.kind=fe,this.containerName=rt,typeof Pe=="string"&&(this.containerName=Pe),Xe instanceof We?this.location=Xe:Pe instanceof z&&(this.location=new We(Xe,Pe)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};F=n=qe([U],F),e.SymbolInformation=F;let H=c=class{constructor($,fe,Pe,Xe,rt){this.name=$,this.detail=fe,this.kind=Pe,this.range=Xe,this.selectionRange=rt,this.children=[],c.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children?.forEach(c.validate)}};H=c=qe([U],H),e.DocumentSymbol=H;var K;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let X=class{constructor($,fe){this.title=$,this.kind=fe}};X=qe([U],X),e.CodeAction=X;let de=d=class{constructor($){this.value=$}append($){return new d(this.value?this.value+d.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+d.sep)}};de.sep=".",de=d=qe([U],de),e.CodeActionKind=de,de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll");let we=class{constructor($,fe){if(this.range=$,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};we=qe([U],we),e.SelectionRange=we;class ce{constructor($,fe,Pe,Xe,rt,dt){this.kind=$,this.name=fe,this.detail=Pe,this.uri=Xe,this.range=rt,this.selectionRange=dt}}e.CallHierarchyItem=ce;class Ce{constructor($,fe){this.fromRanges=fe,this.from=$}}e.CallHierarchyIncomingCall=Ce;class ye{constructor($,fe){this.fromRanges=fe,this.to=$}}e.CallHierarchyOutgoingCall=ye;var $e;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ve=class{constructor($,fe){this.range=$,this.command=fe}get isResolved(){return!!this.command}};Ve=qe([U],Ve),e.CodeLens=Ve;let Ze=f=class{constructor($,fe=!1){g.set(this,void 0),tt(this,g,new D.MarkdownString($,{supportThemeIcons:fe}),"f")}static isMarkdownString($){return $ instanceof f?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Ue(this,g,"f").value}set value($){Ue(this,g,"f").value=$}get isTrusted(){return Ue(this,g,"f").isTrusted}set isTrusted($){Ue(this,g,"f").isTrusted=$}get supportThemeIcons(){return Ue(this,g,"f").supportThemeIcons}set supportThemeIcons($){Ue(this,g,"f").supportThemeIcons=$}get supportHtml(){return Ue(this,g,"f").supportHtml}set supportHtml($){Ue(this,g,"f").supportHtml=$}get baseUri(){return Ue(this,g,"f").baseUri}set baseUri($){Ue(this,g,"f").baseUri=$}appendText($){return Ue(this,g,"f").appendText($),this}appendMarkdown($){return Ue(this,g,"f").appendMarkdown($),this}appendCodeblock($,fe){return Ue(this,g,"f").appendCodeblock(fe??"",$),this}};g=new WeakMap,Ze=f=qe([U],Ze),e.MarkdownString=Ze;let Ye=class{constructor($,fe){this.label=$,this.documentation=fe}};Ye=qe([U],Ye),e.ParameterInformation=Ye;let Oe=class{constructor($,fe){this.label=$,this.documentation=fe,this.parameters=[]}};Oe=qe([U],Oe),e.SignatureInformation=Oe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([U],ot),e.SignatureHelp=ot;var re;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(re=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var se;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(se=e.InlayHintKind||(e.InlayHintKind={}));let Ee=class{constructor($){this.value=$}};Ee=qe([U],Ee),e.InlayHintLabelPart=Ee;let ue=class{constructor($,fe,Pe){this.position=$,this.label=fe,this.kind=Pe}};ue=qe([U],ue),e.InlayHint=ue;var ke;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ke=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var Be;(function(j){j[j.Deprecated=1]="Deprecated"})(Be=e.CompletionItemTag||(e.CompletionItemTag={}));let ze=class{constructor($,fe){this.label=$,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ze=qe([U],ze),e.CompletionItem=ze;let Qe=class{constructor($=[],fe=!1){this.items=$,this.isIncomplete=fe}};Qe=qe([U],Qe),e.CompletionList=Qe;let nt=class{constructor($,fe,Pe){this.insertText=$,this.range=fe,this.command=Pe}};nt=qe([U],nt),e.InlineSuggestion=nt;let ct=class{constructor($){this.commands=void 0,this.items=$}};ct=qe([U],ct),e.InlineSuggestionList=ct;let st=class{constructor($,fe,Pe){this.insertText=$,this.range=fe,this.command=Pe}};st=qe([U],st),e.InlineSuggestionNew=st;let et=class{constructor($,fe){this.items=$,this.commands=fe}};et=qe([U],et),e.InlineSuggestionsNew=et;var mt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(mt=e.ViewColumn||(e.ViewColumn={}));var wt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(wt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Dt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Dt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ft;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ge;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ge=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function $(fe){switch(fe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=$}(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor($,fe){if(fe&&!C.URI.isUri(fe))throw(0,t.illegalArgument)("target");if(!z.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.target=fe}};Nt=qe([U],Nt),e.DocumentLink=Nt;let Rt=class{constructor($,fe,Pe,Xe){this.red=$,this.green=fe,this.blue=Pe,this.alpha=Xe}};Rt=qe([U],Rt),e.Color=Rt;let Lt=class{constructor($,fe){if(fe&&!(fe instanceof Rt))throw(0,t.illegalArgument)("color");if(!z.isRange($)||$.isEmpty)throw(0,t.illegalArgument)("range");this.range=$,this.color=fe}};Lt=qe([U],Lt),e.ColorInformation=Lt;let vt=class{constructor($){if(!$||typeof $!="string")throw(0,t.illegalArgument)("label");this.label=$}};vt=qe([U],vt),e.ColorPresentation=vt;var It;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(It=e.ColorFormat||(e.ColorFormat={}));var Ae;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Ae=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Re;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Re=e.TerminalExitReason||(e.TerminalExitReason={}));class _e{constructor($,fe,Pe){if(this.startIndex=$,this.length=fe,this.tooltip=Pe,typeof $!="number"||$<0)throw(0,t.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,t.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=_e;var te;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(te=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor($){if(this.options=$,typeof $!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Fe;var je;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(je=e.TaskRevealKind||(e.TaskRevealKind={}));var it;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(it=e.TaskPanelKind||(e.TaskPanelKind={}));let Ke=y=class{constructor($,fe){if(this.label=fe,typeof $!="string"||typeof fe!="string")throw(0,t.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}get id(){return this._id}};Ke.Clean=new y("clean","Clean"),Ke.Build=new y("build","Build"),Ke.Rebuild=new y("rebuild","Rebuild"),Ke.Test=new y("test","Test"),Ke=y=qe([U],Ke),e.TaskGroup=Ke;function Je(j){let $="";for(let fe=0;fe<j.length;fe++)$+=j[fe].replace(/,/g,",,")+",";return $}let lt=class{constructor($,fe,Pe){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=$,fe!==void 0&&(Array.isArray(fe)?(this._args=fe,this._options=Pe):this._options=fe)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,t.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(const fe of this._args)$.push(fe);return Je($)}};lt=qe([U],lt),e.ProcessExecution=lt;let kt=class{constructor($,fe,Pe){if(this._args=[],Array.isArray(fe)){if(!$)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$,this._args=fe,this._options=Pe}else{if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$,this._options=fe}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,t.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const fe of this._args)$.push(typeof fe=="string"?fe:fe.value);return Je($)}};kt=qe([U],kt),e.ShellExecution=kt;var Et;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class St{constructor($){this._callback=$}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=St;let gt=L=class{constructor($,fe,Pe,Xe,rt,dt){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof fe=="string"?(this._name=this.name=fe,this._source=this.source=Pe,this.execution=Xe,ht=rt,this.__deprecated=!0):fe===yt.Global||fe===yt.Workspace?(this.target=fe,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=rt,ht=dt):(this.target=fe,this._name=this.name=Pe,this._source=this.source=Xe,this.execution=rt,ht=dt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof lt?this._definition={type:L.ProcessType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:L.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:L.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:L.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const fe=this._definition.type;(L.EmptyType===fe||L.ProcessType===fe||L.ShellType===fe||L.ExtensionCallbackType===fe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=L=qe([U],gt),e.Task=gt;var Tt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));let Qt=M=class{constructor($,fe=bt.None){this.collapsibleState=fe,C.URI.isUri($)?this.resourceUri=$:this.label=$}static isTreeItem($,fe){if($ instanceof M)return!0;const Pe=$;if(Pe.label!==void 0&&!(0,w.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,w.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,w.isString)(Pe.iconPath)&&!C.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,w.isString)(Pe.iconPath.id))){const Xe=Pe.iconPath;if(!Xe||!(0,w.isString)(Xe.light)&&!C.URI.isUri(Xe.light)&&!(0,w.isString)(Xe.dark)&&!C.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,w.isString)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!C.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,w.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<bt.None&&Pe.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,w.isString)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):Pe.checkboxState!==void 0&&((0,T.checkProposedApiEnabled)(fe,"treeItemCheckbox"),Pe.checkboxState!==qt.Checked&&Pe.checkboxState!==qt.Unchecked)?(console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1):!0}};Qt=M=qe([U],Qt),e.TreeItem=Qt;var bt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var qt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let xt=class{constructor($){this.value=$}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};xt=qe([U],xt),e.DataTransferItem=xt;let nn=class{constructor($){b.set(this,new Map);for(const[fe,Pe]of $??[]){const Xe=Ue(this,b,"f").get(fe);Xe?Xe.push(Pe):Ue(this,b,"f").set(fe,[Pe])}}get($){return Ue(this,b,"f").get($)?.[0]}set($,fe){Ue(this,b,"f").set($,[fe])}forEach($,fe){for(const[Pe,Xe]of Ue(this,b,"f"))for(const rt of Xe)$.call(fe,rt,Pe,this)}*[(b=new WeakMap,Symbol.iterator)](){for(const[$,fe]of Ue(this,b,"f"))for(const Pe of fe)yield[$,Pe]}};nn=qe([U],nn),e.DataTransfer=nn;let gn=class{constructor($){this.insertText=$}};gn=qe([U],gn),e.DocumentDropEdit=gn;let Pt=class{constructor($){this.insertText=$}};Pt=qe([U],Pt),e.DocumentPasteEdit=Pt;let Wt=class{constructor($,fe){this.id=$,this.color=fe}};Wt=qe([U],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let pn=class{constructor($){this.id=$}};pn=qe([U],pn),e.ThemeColor=pn;var rn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(rn=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Yt=class{constructor($,fe){if(typeof $!="string"&&(!$||!C.URI.isUri($)&&!C.URI.isUri($.uri)))throw(0,t.illegalArgument)("base");if(typeof fe!="string")throw(0,t.illegalArgument)("pattern");typeof $=="string"?this.baseUri=C.URI.file($):C.URI.isUri($)?this.baseUri=$:this.baseUri=$.uri,this.pattern=fe}get base(){return this._base}set base($){this._base=$,this._baseUri=C.URI.file($)}get baseUri(){return this._baseUri}set baseUri($){this._baseUri=$,this._base=$.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Yt=qe([U],Yt),e.RelativePattern=Yt;let ut=class{constructor($,fe,Pe,Xe){this.enabled=typeof $=="boolean"?$:!0,typeof fe=="string"&&(this.condition=fe),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};ut=qe([U],ut),e.Breakpoint=ut;let vn=class extends ut{constructor($,fe,Pe,Xe,rt){if(super(fe,Pe,Xe,rt),$===null)throw(0,t.illegalArgument)("location");this.location=$}};vn=qe([U],vn),e.SourceBreakpoint=vn;let $t=class extends ut{constructor($,fe,Pe,Xe,rt){super(fe,Pe,Xe,rt),this.functionName=$}};$t=qe([U],$t),e.FunctionBreakpoint=$t;let Gt=class extends ut{constructor($,fe,Pe,Xe,rt,dt,ht){if(super(Xe,rt,dt,ht),!fe)throw(0,t.illegalArgument)("dataId");this.label=$,this.dataId=fe,this.canPersist=Pe}};Gt=qe([U],Gt),e.DataBreakpoint=Gt;let sn=class{constructor($,fe,Pe){this.command=$,this.args=fe||[],this.options=Pe}};sn=qe([U],sn),e.DebugAdapterExecutable=sn;let bn=class{constructor($,fe){this.port=$,this.host=fe}};bn=qe([U],bn),e.DebugAdapterServer=bn;let on=class{constructor($){this.path=$}};on=qe([U],on),e.DebugAdapterNamedPipeServer=on;let wn=class{constructor($){this.implementation=$}};wn=qe([U],wn),e.DebugAdapterInlineImplementation=wn;let an=class{constructor($,fe){this.range=$,this.expression=fe}};an=qe([U],an),e.EvaluatableExpression=an;var cn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var On;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(On=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Jt=class{constructor($,fe){this.range=$,this.text=fe}};Jt=qe([U],Jt),e.InlineValueText=Jt;let Zt=class{constructor($,fe,Pe=!0){this.range=$,this.variableName=fe,this.caseSensitiveLookup=Pe}};Zt=qe([U],Zt),e.InlineValueVariableLookup=Zt;let En=class{constructor($,fe){this.range=$,this.expression=fe}};En=qe([U],En),e.InlineValueEvaluatableExpression=En;let Sn=class{constructor($,fe){this.frameId=$,this.stoppedLocation=fe}};Sn=qe([U],Sn),e.InlineValueContext=Sn;var en;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(en=e.FileChangeType||(e.FileChangeType={}));let _n=B=class extends Error{constructor($,fe=k.FileSystemProviderErrorCode.Unknown,Pe){super(C.URI.isUri($)?$.toString(!0):$),this.code=Pe?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,fe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}static FileExists($){return new B($,k.FileSystemProviderErrorCode.FileExists,B.FileExists)}static FileNotFound($){return new B($,k.FileSystemProviderErrorCode.FileNotFound,B.FileNotFound)}static FileNotADirectory($){return new B($,k.FileSystemProviderErrorCode.FileNotADirectory,B.FileNotADirectory)}static FileIsADirectory($){return new B($,k.FileSystemProviderErrorCode.FileIsADirectory,B.FileIsADirectory)}static NoPermissions($){return new B($,k.FileSystemProviderErrorCode.NoPermissions,B.NoPermissions)}static Unavailable($){return new B($,k.FileSystemProviderErrorCode.Unavailable,B.Unavailable)}};_n=B=qe([U],_n),e.FileSystemError=_n;let yn=class{constructor($,fe,Pe){this.start=$,this.end=fe,this.kind=Pe}};yn=qe([U],yn),e.FoldingRange=yn;var Fn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Nn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Nn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Cn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Cn=e.CommentMode||(e.CommentMode={}));var Tn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Tn=e.CommentThreadState||(e.CommentThreadState={}));class Pn{constructor($,fe=[]){this.tokenTypes=$,this.tokenModifiers=fe}}e.SemanticTokensLegend=Pn;function He(j){return typeof j>"u"||(0,w.isStringArray)(j)}class Bt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let fe=0,Pe=$.tokenTypes.length;fe<Pe;fe++)this._tokenTypeStrToInt.set($.tokenTypes[fe],fe);for(let fe=0,Pe=$.tokenModifiers.length;fe<Pe;fe++)this._tokenModifierStrToInt.set($.tokenModifiers[fe],fe)}}push($,fe,Pe,Xe,rt){if(typeof $=="number"&&typeof fe=="number"&&typeof Pe=="number"&&typeof Xe=="number"&&(typeof rt=="number"||typeof rt>"u"))return typeof rt>"u"&&(rt=0),this._pushEncoded($,fe,Pe,Xe,rt);if(z.isRange($)&&typeof fe=="string"&&He(Pe))return this._push($,fe,Pe);throw(0,t.illegalArgument)()}_push($,fe,Pe){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(fe))throw new Error("`tokenType` is not in the provided legend");const Xe=$.start.line,rt=$.start.character,dt=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(fe);let Ot=0;if(Pe)for(const zt of Pe){if(!this._tokenModifierStrToInt.has(zt))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(zt);Ot|=1<<Ht>>>0}this._pushEncoded(Xe,rt,dt,ht,Ot)}_pushEncoded($,fe,Pe,Xe,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&fe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ot=this._data.length/5|0;let zt=0,Ht=0;for(let jt=0;jt<Ot;jt++){let Kt=this._data[5*jt],In=this._data[5*jt+1];Kt===0?(Kt=zt,In+=Ht):Kt+=zt,this._data[5*jt]=Kt,this._data[5*jt+1]=In,zt=Kt,Ht=In}}let dt=$,ht=fe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Pe,this._data[this._dataLen++]=Xe,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=fe}static _sortAndDeltaEncode($){const fe=[],Pe=$.length/5|0;for(let ht=0;ht<Pe;ht++)fe[ht]=ht;fe.sort((ht,Ot)=>{const zt=$[5*ht],Ht=$[5*Ot];if(zt===Ht){const jt=$[5*ht+1],Kt=$[5*Ot+1];return jt-Kt}return zt-Ht});const Xe=new Uint32Array($.length);let rt=0,dt=0;for(let ht=0;ht<Pe;ht++){const Ot=5*fe[ht],zt=$[Ot+0],Ht=$[Ot+1],jt=$[Ot+2],Kt=$[Ot+3],In=$[Ot+4],Yn=zt-rt,_i=Yn===0?Ht-dt:Ht,kn=5*ht;Xe[kn+0]=Yn,Xe[kn+1]=_i,Xe[kn+2]=jt,Xe[kn+3]=Kt,Xe[kn+4]=In,rt=zt,dt=Ht}return Xe}build($){return this._dataIsSortedAndDeltaEncoded?new ln(new Uint32Array(this._data),$):new ln(Bt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Bt;class ln{constructor($,fe){this.resultId=fe,this.data=$}}e.SemanticTokens=ln;class pt{constructor($,fe,Pe){this.start=$,this.deleteCount=fe,this.data=Pe}}e.SemanticTokensEdit=pt;class Mn{constructor($,fe){this.resultId=fe,this.edits=$}}e.SemanticTokensEdits=Mn;var Un;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Un=e.DebugConsoleMode||(e.DebugConsoleMode={}));let tn=class{constructor(){}};tn.Back={iconPath:new Wt("arrow-left")},tn=qe([U],tn),e.QuickInputButtons=tn;var Bn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Bn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var un;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(un=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var zn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(zn=e.ExtensionKind||(e.ExtensionKind={}));class Wn{constructor($,fe,Pe){this.badge=$,this.tooltip=fe,this.color=Pe}static validate($){if($.badge){let fe=(0,I.nextCharLength)($.badge,0);if(fe<$.badge.length&&(fe+=(0,I.nextCharLength)($.badge,fe)),$.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Wn;let Dn=class{constructor($){this.kind=$}};Dn=qe([U],Dn),e.ColorTheme=Dn;var An;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor($,fe){if($<0)throw(0,t.illegalArgument)("start must be positive");if(fe<0)throw(0,t.illegalArgument)("end must be positive");$<=fe?(this._start=$,this._end=fe):(this._start=fe,this._end=$)}static isNotebookRange($){return $ instanceof Vt?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let fe=this._start,Pe=this._end;return $.start!==void 0&&(fe=$.start),$.end!==void 0&&(Pe=$.end),fe===this._start&&Pe===this._end?this:new Vt(fe,Pe)}}e.NotebookRange=Vt;class dn{constructor($,fe,Pe,Xe,rt,dt,ht){this.kind=$,this.value=fe,this.languageId=Pe,this.mime=Xe,this.outputs=rt??[],this.metadata=dt,this.executionSummary=ht,dn.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(fe=>dn.isNotebookCellData(fe))}static isNotebookCellData($){return!0}}e.NotebookCellData=dn;class $n{constructor($){this.cells=$}}e.NotebookData=$n;class Mt{constructor($,fe){this.data=$,this.mime=fe;const Pe=(0,_.normalizeMimeType)(fe,!0);if(!Pe)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}static isNotebookCellOutputItem($){return $ instanceof Mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const fe={name:$.name,message:$.message,stack:$.stack};return Mt.json(fe,"application/vnd.code.notebook.error")}static stdout($){return Mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,fe="application/octet-stream"){return new Mt($,fe)}static text($,fe=_.Mimes.text){const Pe=Ue(Mt,m,"f",v).encode(String($));return new Mt(Pe,fe)}static json($,fe="text/x-json"){const Pe=JSON.stringify($,void 0,"	");return Mt.text(Pe,fe)}}e.NotebookCellOutputItem=Mt,m=Mt,v={value:new TextEncoder};class hn{constructor($,fe,Pe){this.items=hn.ensureUniqueMimeTypes($,!0),typeof fe=="string"?(this.id=fe,this.metadata=Pe):(this.id=(0,R.generateUuid)(),this.metadata=fe??Pe)}static isNotebookCellOutput($){return $ instanceof hn?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&Array.isArray($.items)}static ensureUniqueMimeTypes($,fe=!1){const Pe=new Set,Xe=new Set;for(let rt=0;rt<$.length;rt++){const dt=$[rt],ht=(0,_.normalizeMimeType)(dt.mime);if(!Pe.has(ht)){Pe.add(ht);continue}Xe.add(rt),fe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Xe.size===0?$:$.filter((rt,dt)=>!Xe.has(dt))}}e.NotebookCellOutput=hn;var ge;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(ge=e.NotebookCellKind||(e.NotebookCellKind={}));var Se;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Se=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Me;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Me=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class _t{constructor($,fe){this.text=$,this.alignment=fe}}e.NotebookCellStatusBarItem=_t;var At;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(At=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class ti{constructor($,fe=[]){this.uri=$,this.provides=(0,l.asArray)(fe)}}e.NotebookRendererScript=ti;let Hn=class{constructor($,fe){this.label=$,this.timestamp=fe}};Hn=qe([U],Hn),e.TimelineItem=Hn;var ni;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(ni=e.ExtensionMode||(e.ExtensionMode={}));var ii;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ii=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ri;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ri=e.StandardTokenType||(e.StandardTokenType={}));class si{constructor($,fe){this.ranges=$,this.wordPattern=fe}}e.LinkedEditingRanges=si;class oi{constructor($,fe){this._port=$,this._autoForwardAction=fe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=oi;var ai;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(ai=e.TestResultState||(e.TestResultState={}));var ci;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ci=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xn=class{constructor($=void 0,fe=void 0,Pe=void 0){this.include=$,this.exclude=fe,this.profile=Pe}};xn=qe([U],xn),e.TestRunRequest=xn;let Vn=A=class{constructor($){this.message=$}static diff($,fe,Pe){const Xe=new A($);return Xe.expectedOutput=fe,Xe.actualOutput=Pe,Xe}};Vn=A=qe([U],Vn),e.TestMessage=Vn;let jn=class{constructor($){this.id=$}};jn=qe([U],jn),e.TestTag=jn;let fn=class{constructor($,fe){this.covered=$,this.total=fe}};fn=qe([U],fn),e.CoveredCount=fn;let qn=W=class{constructor($,fe,Pe,Xe){this.uri=$,this.statementCoverage=fe,this.branchCoverage=Pe,this.functionCoverage=Xe}static fromDetails($,fe){const Pe=new fn(0,0),Xe=new fn(0,0),rt=new fn(0,0);for(const ht of fe)if("branches"in ht){Pe.total+=1,Pe.covered+=ht.executionCount>0?1:0;for(const Ot of ht.branches)Xe.total+=1,Xe.covered+=Ot.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const dt=new W($,Pe,Xe.total>0?Xe:void 0,rt.total>0?rt:void 0);return dt.detailedCoverage=fe,dt}};qn=W=qe([U],qn),e.FileCoverage=qn;let Gn=class{constructor($,fe,Pe=[]){this.executionCount=$,this.location=fe,this.branches=Pe}};Gn=qe([U],Gn),e.StatementCoverage=Gn;let Kn=class{constructor($,fe){this.executionCount=$,this.location=fe}};Kn=qe([U],Kn),e.BranchCoverage=Kn;let Xn=class{constructor($,fe){this.executionCount=$,this.location=fe}};Xn=qe([U],Xn),e.FunctionCoverage=Xn;var li;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(li=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ui;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ui=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var di;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(di=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hi{constructor($,fe,Pe,Xe,rt,dt){this.kind=$,this.name=fe,this.detail=Pe,this.uri=Xe,this.range=rt,this.selectionRange=dt}}e.TypeHierarchyItem=hi;class fi{constructor($){this.uri=$}}e.TextTabInput=fi;class mi{constructor($,fe){this.original=$,this.modified=fe}}e.TextDiffTabInput=mi;class gi{constructor($,fe,Pe,Xe){this.base=$,this.input1=fe,this.input2=Pe,this.result=Xe}}e.TextMergeTabInput=gi;class pi{constructor($,fe){this.uri=$,this.viewType=fe}}e.CustomEditorTabInput=pi;class vi{constructor($){this.viewType=$}}e.WebviewEditorTabInput=vi;class bi{constructor($,fe){this.uri=$,this.notebookType=fe}}e.NotebookEditorTabInput=bi;class wi{constructor($,fe,Pe){this.original=$,this.modified=fe,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=wi;class Ei{constructor(){}}e.TerminalEditorTabInput=Ei;class Si{constructor($,fe){this.uri=$,this.inputBoxUri=fe}}e.InteractiveWindowInput=Si}),define(De[131],Ie([1,0,48,12,8,158,98,7,17]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function R(E,g){g?C.set(E,g):C.delete(E)}e.setWordDefinitionFor=R;function k(E){return C.get(E)}e.getWordDefinitionFor=k;class S extends P.MirrorTextModel{constructor(g,b,m,v,p,a,h,i){super(b,m,v,p),this._proxy=g,this._languageId=a,this._isDirty=h,this.notebook=i,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(g){return(0,w.equals)(this._lines,g)}get document(){if(!this._document){const g=this;this._document={get uri(){return g._uri},get fileName(){return g._uri.fsPath},get isUntitled(){return g._uri.scheme===t.Schemas.untitled},get languageId(){return g._languageId},get version(){return g._versionId},get isClosed(){return g._isDisposed},get isDirty(){return g._isDirty},save(){return g._save()},getText(b){return b?g._getTextInRange(b):g.getText()},get eol(){return g._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return g._lines.length},lineAt(b){return g._lineAt(b)},offsetAt(b){return g._offsetAt(b)},positionAt(b){return g._positionAt(b)},validateRange(b){return g._validateRange(b)},validatePosition(b){return g._validatePosition(b)},getWordRangeAtPosition(b,m){return g._getWordRangeAtPosition(b,m)}}}return Object.freeze(this._document)}_acceptLanguageId(g){(0,l.ok)(!this._isDisposed),this._languageId=g}_acceptIsDirty(g){(0,l.ok)(!this._isDisposed),this._isDirty=g}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(g){const b=this._validateRange(g);if(b.isEmpty)return"";if(b.isSingleLine)return this._lines[b.start.line].substring(b.start.character,b.end.character);const m=this._eol,v=b.start.line,p=b.end.line,a=[];a.push(this._lines[v].substring(b.start.character));for(let h=v+1;h<p;h++)a.push(this._lines[h]);return a.push(this._lines[p].substring(0,b.end.character)),a.join(m)}_lineAt(g){let b;if(g instanceof I.Position?b=g.line:typeof g=="number"&&(b=g),typeof b!="number"||b<0||b>=this._lines.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new T(b,this._lines[b],b===this._lines.length-1)}_offsetAt(g){return g=this._validatePosition(g),this._ensureLineStarts(),this._lineStarts.getPrefixSum(g.line-1)+g.character}_positionAt(g){g=Math.floor(g),g=Math.max(0,g),this._ensureLineStarts();const b=this._lineStarts.getIndexOf(g),m=this._lines[b.index].length;return new I.Position(b.index,Math.min(b.remainder,m))}_validateRange(g){if(!(g instanceof I.Range))throw new Error("Invalid argument");const b=this._validatePosition(g.start),m=this._validatePosition(g.end);return b===g.start&&m===g.end?g:new I.Range(b.line,b.character,m.line,m.character)}_validatePosition(g){if(!(g instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return g.with(0,0);let{line:b,character:m}=g,v=!1;if(b<0)b=0,m=0,v=!0;else if(b>=this._lines.length)b=this._lines.length-1,m=this._lines[b].length,v=!0;else{const p=this._lines[b].length;m<0?(m=0,v=!0):m>p&&(m=p,v=!0)}return v?new I.Position(b,m):g}_getWordRangeAtPosition(g,b){const m=this._validatePosition(g);if(!b)b=k(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(m.character+1,(0,_.ensureValidWordDefinition)(b),this._lines[m.line],0);if(v)return new I.Range(m.line,v.startColumn-1,m.line,v.endColumn-1)}}e.ExtHostDocumentData=S;class T{constructor(g,b,m){this._line=g,this._text=b,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(De[224],Ie([1,0,7,15,4]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let w;switch(I){case"light":w=l.ColorThemeKind.Light;break;case"hcDark":w=l.ColorThemeKind.HighContrast;break;case"hcLight":w=l.ColorThemeKind.HighContrastLight;break;default:w=l.ColorThemeKind.Dark}this._actual=new l.ColorTheme(w),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(De[16],Ie([1,0,17,23,105,25,144,80,24,13,2,35,63,116,128,125,127,64,65,218,7,59]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Ae){function Re(te){const{selectionStartLineNumber:Fe,selectionStartColumn:je,positionLineNumber:it,positionColumn:Ke}=te,Je=new a.Position(Fe-1,je-1),lt=new a.Position(it-1,Ke-1);return new a.Selection(Je,lt)}Ae.to=Re;function _e(te){const{anchor:Fe,active:je}=te;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ae.from=_e})(i=e.Selection||(e.Selection={}));var u;(function(Ae){function Re(te){if(!te)return;const{start:Fe,end:je}=te;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ae.from=Re;function _e(te){if(!te)return;const{startLineNumber:Fe,startColumn:je,endLineNumber:it,endColumn:Ke}=te;return new a.Range(Fe-1,je-1,it-1,Ke-1)}Ae.to=_e})(u=e.Range||(e.Range={}));var o;(function(Ae){function Re(_e){switch(_e){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ae.to=Re})(o=e.TokenType||(e.TokenType={}));var r;(function(Ae){function Re(te){return new a.Position(te.lineNumber-1,te.column-1)}Ae.to=Re;function _e(te){return{lineNumber:te.line+1,column:te.character+1}}Ae.from=_e})(r=e.Position||(e.Position={}));var s;(function(Ae){function Re(Fe,je){return(0,l.coalesce)((0,l.asArray)(Fe).map(it=>_e(it,je)))}Ae.from=Re;function _e(Fe,je){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:te(Fe.scheme,je),pattern:Ee.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function te(Fe,je){return je&&typeof Fe=="string"?je.transformOutgoingScheme(Fe):Fe}})(s=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Ae){function Re(te){switch(te){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ae.from=Re;function _e(te){switch(te){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ae.to=_e})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(Ae){function Re(te){let Fe;return te.code&&((0,C.isString)(te.code)||(0,C.isNumber)(te.code)?Fe=String(te.code):Fe={value:String(te.code.value),target:te.code.target}),{...u.from(te.range),message:te.message,source:te.source,code:Fe,severity:f.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(d.from),tags:Array.isArray(te.tags)?(0,l.coalesce)(te.tags.map(n.from)):void 0}}Ae.from=Re;function _e(te){const Fe=new a.Diagnostic(u.to(te),te.message,f.to(te.severity));return Fe.source=te.source,Fe.code=(0,C.isString)(te.code)?te.code:te.code?.value,Fe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(d.to),Fe.tags=te.tags&&(0,l.coalesce)(te.tags.map(n.to)),Fe}Ae.to=_e})(c=e.Diagnostic||(e.Diagnostic={}));var d;(function(Ae){function Re(te){return{...u.from(te.location.range),message:te.message,resource:te.location.uri}}Ae.from=Re;function _e(te){return new a.DiagnosticRelatedInformation(new a.Location(te.resource,u.to(te)),te.message)}Ae.to=_e})(d=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(Ae){function Re(te){switch(te){case a.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Ae.from=Re;function _e(te){switch(te){case T.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ae.to=_e})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var y;(function(Ae){function Re(te){return typeof te=="number"&&te>=a.ViewColumn.One?te-1:te===a.ViewColumn.Beside?p.SIDE_GROUP:p.ACTIVE_GROUP}Ae.from=Re;function _e(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=_e})(y=e.ViewColumn||(e.ViewColumn={}));function L(Ae){return typeof Ae.range<"u"}function M(Ae){return Ae.length===0?!0:!!L(Ae[0])}e.isDecorationOptionsArr=M;var B;(function(Ae){function Re(Ke){return Ke.map(Ae.from)}Ae.fromMany=Re;function _e(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function te(Ke){let Je;if(_e(Ke)){const{language:yt,value:St}=Ke;Je={value:"```"+yt+`
`+St+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ke)?Je={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?Je={value:Ke}:Je={value:""};const lt=Object.create(null);Je.uris=lt;const kt=yt=>{try{let St=R.URI.parse(yt,!0);St=St.with({query:Fe(St.query,lt)}),lt[yt]=St}catch{}return""},Et=new _.marked.Renderer;return Et.link=kt,Et.image=yt=>typeof yt=="string"?kt(D.parseHrefAndDimensions(yt).href):"",(0,_.marked)(Je.value,{renderer:Et}),Je}Ae.from=te;function Fe(Ke,Je){if(!Ke)return Ke;let lt;try{lt=(0,I.parse)(Ke)}catch{}if(!lt)return Ke;let kt=!1;return lt=(0,w.cloneAndChange)(lt,Et=>{if(R.URI.isUri(Et)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Je[yt]=Et,kt=!0,yt}else return}),kt?JSON.stringify(lt):Ke}function je(Ke){const Je=new a.MarkdownString(Ke.value,Ke.supportThemeIcons);return Je.isTrusted=Ke.isTrusted,Je.supportHtml=Ke.supportHtml,Je.baseUri=Ke.baseUri?R.URI.from(Ke.baseUri):void 0,Je}Ae.to=je;function it(Ke){if(!!Ke)return typeof Ke=="string"?Ke:Ae.from(Ke)}Ae.fromStrict=it})(B=e.MarkdownString||(e.MarkdownString={}));function A(Ae){return M(Ae)?Ae.map(Re=>({range:u.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?B.fromMany(Re.hoverMessage):Re.hoverMessage?B.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):Ae.map(Re=>({range:u.from(Re)}))}e.fromRangeOrRangeWithMessage=A;function W(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?R.URI.file(Ae):Ae}e.pathOrURIToURI=W;var U;(function(Ae){function Re(_e){return typeof _e>"u"?_e:{contentText:_e.contentText,contentIconPath:_e.contentIconPath?W(_e.contentIconPath):void 0,border:_e.border,borderColor:_e.borderColor,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,color:_e.color,backgroundColor:_e.backgroundColor,margin:_e.margin,width:_e.width,height:_e.height}}Ae.from=Re})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(Ae){function Re(_e){return typeof _e>"u"?_e:{backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?W(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?U.from(_e.before):void 0,after:_e.after?U.from(_e.after):void 0}}Ae.from=Re})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var G;(function(Ae){function Re(_e){if(typeof _e>"u")return _e;switch(_e){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Re})(G=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(Ae){function Re(_e){return{isWholeLine:_e.isWholeLine,rangeBehavior:_e.rangeBehavior?G.from(_e.rangeBehavior):void 0,overviewRulerLane:_e.overviewRulerLane,light:_e.light?N.from(_e.light):void 0,dark:_e.dark?N.from(_e.dark):void 0,backgroundColor:_e.backgroundColor,outline:_e.outline,outlineColor:_e.outlineColor,outlineStyle:_e.outlineStyle,outlineWidth:_e.outlineWidth,border:_e.border,borderColor:_e.borderColor,borderRadius:_e.borderRadius,borderSpacing:_e.borderSpacing,borderStyle:_e.borderStyle,borderWidth:_e.borderWidth,fontStyle:_e.fontStyle,fontWeight:_e.fontWeight,textDecoration:_e.textDecoration,cursor:_e.cursor,color:_e.color,opacity:_e.opacity,letterSpacing:_e.letterSpacing,gutterIconPath:_e.gutterIconPath?W(_e.gutterIconPath):void 0,gutterIconSize:_e.gutterIconSize,overviewRulerColor:_e.overviewRulerColor,before:_e.before?U.from(_e.before):void 0,after:_e.after?U.from(_e.after):void 0}}Ae.from=Re})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(Ae){function Re(te){return{text:te.newText,eol:te.newEol&&Ye.from(te.newEol),range:u.from(te.range)}}Ae.from=Re;function _e(te){const Fe=new a.TextEdit(u.to(te.range),te.text);return Fe.newEol=typeof te.eol>"u"?void 0:Ye.to(te.eol),Fe}Ae.to=_e})(O=e.TextEdit||(e.TextEdit={}));var x;(function(Ae){function Re(te,Fe,je){const it={edits:[]};if(te instanceof a.WorkspaceEdit){const Ke=new P.ResourceSet;for(const Je of te._allEntries())Je._type===1&&R.URI.isUri(Je.to)&&Je.from===void 0&&Ke.add(Je.to);for(const Je of te._allEntries())if(Je._type===1)it.edits.push({oldResource:Je.from,newResource:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2)it.edits.push({resource:Je.uri,textEdit:O.from(Je.edit),versionId:Ke.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata});else if(Je._type===6){if(!je){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Je);continue}it.edits.push({resource:Je.uri,textEdit:{range:u.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:Ke.has(Je.uri)?void 0:Fe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata})}else Je._type===3?it.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&it.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(nt.from)}})}return it}Ae.from=Re;function _e(te){const Fe=new a.WorkspaceEdit;for(const je of te.edits)je.textEdit?Fe.replace(R.URI.revive(je.resource),u.to(je.textEdit.range),je.textEdit.text):Fe.renameFile(R.URI.revive(je.oldResource),R.URI.revive(je.newResource),je.options);return Fe}Ae.to=_e})(x=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(Ae){const Re=Object.create(null);Re[a.SymbolKind.File]=0,Re[a.SymbolKind.Module]=1,Re[a.SymbolKind.Namespace]=2,Re[a.SymbolKind.Package]=3,Re[a.SymbolKind.Class]=4,Re[a.SymbolKind.Method]=5,Re[a.SymbolKind.Property]=6,Re[a.SymbolKind.Field]=7,Re[a.SymbolKind.Constructor]=8,Re[a.SymbolKind.Enum]=9,Re[a.SymbolKind.Interface]=10,Re[a.SymbolKind.Function]=11,Re[a.SymbolKind.Variable]=12,Re[a.SymbolKind.Constant]=13,Re[a.SymbolKind.String]=14,Re[a.SymbolKind.Number]=15,Re[a.SymbolKind.Boolean]=16,Re[a.SymbolKind.Array]=17,Re[a.SymbolKind.Object]=18,Re[a.SymbolKind.Key]=19,Re[a.SymbolKind.Null]=20,Re[a.SymbolKind.EnumMember]=21,Re[a.SymbolKind.Struct]=22,Re[a.SymbolKind.Event]=23,Re[a.SymbolKind.Operator]=24,Re[a.SymbolKind.TypeParameter]=25;function _e(Fe){return typeof Re[Fe]=="number"?Re[Fe]:6}Ae.from=_e;function te(Fe){for(const je in Re)if(Re[je]===Fe)return Number(je);return a.SymbolKind.Property}Ae.to=te})(V=e.SymbolKind||(e.SymbolKind={}));var q;(function(Ae){function Re(te){switch(te){case a.SymbolTag.Deprecated:return 1}}Ae.from=Re;function _e(te){switch(te){case 1:return a.SymbolTag.Deprecated}}Ae.to=_e})(q=e.SymbolTag||(e.SymbolTag={}));var Y;(function(Ae){function Re(te){return{name:te.name,kind:V.from(te.kind),tags:te.tags&&te.tags.map(q.from),containerName:te.containerName,location:pe.from(te.location)}}Ae.from=Re;function _e(te){const Fe=new a.SymbolInformation(te.name,V.to(te.kind),te.containerName,pe.to(te.location));return Fe.tags=te.tags&&te.tags.map(q.to),Fe}Ae.to=_e})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Q;(function(Ae){function Re(te){const Fe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:u.from(te.range),selectionRange:u.from(te.selectionRange),kind:V.from(te.kind),tags:te.tags?.map(q.from)??[]};return te.children&&(Fe.children=te.children.map(Re)),Fe}Ae.from=Re;function _e(te){const Fe=new a.DocumentSymbol(te.name,te.detail,V.to(te.kind),u.to(te.range),u.to(te.selectionRange));return(0,l.isNonEmptyArray)(te.tags)&&(Fe.tags=te.tags.map(q.to)),te.children&&(Fe.children=te.children.map(_e)),Fe}Ae.to=_e})(Q=e.DocumentSymbol||(e.DocumentSymbol={}));var he;(function(Ae){function Re(te){const Fe=new a.CallHierarchyItem(V.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Re;function _e(te,Fe,je){if(Fe=Fe??te._sessionId,je=je??te._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,name:te.name,detail:te.detail,kind:V.from(te.kind),uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(q.from)}}Ae.from=_e})(he=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ve;(function(Ae){function Re(_e){return new a.CallHierarchyIncomingCall(he.to(_e.from),_e.fromRanges.map(te=>u.to(te)))}Ae.to=Re})(ve=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(Ae){function Re(_e){return new a.CallHierarchyOutgoingCall(he.to(_e.to),_e.fromRanges.map(te=>u.to(te)))}Ae.to=Re})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Ae){function Re(te){return{range:te.range&&u.from(te.range),uri:te.uri}}Ae.from=Re;function _e(te){return new a.Location(R.URI.revive(te.uri),u.to(te.range))}Ae.to=_e})(pe=e.location||(e.location={}));var be;(function(Ae){function Re(te){const Fe=te,je=te;return{originSelectionRange:Fe.originSelectionRange?u.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:je.uri,range:u.from(Fe.targetRange?Fe.targetRange:je.range),targetSelectionRange:Fe.targetSelectionRange?u.from(Fe.targetSelectionRange):void 0}}Ae.from=Re;function _e(te){return{targetUri:R.URI.revive(te.uri),targetRange:u.to(te.range),targetSelectionRange:te.targetSelectionRange?u.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?u.to(te.originSelectionRange):void 0}}Ae.to=_e})(be=e.DefinitionLink||(e.DefinitionLink={}));var Te;(function(Ae){function Re(te){return{range:u.from(te.range),contents:B.fromMany(te.contents)}}Ae.from=Re;function _e(te){return new a.Hover(te.contents.map(B.to),u.to(te.range))}Ae.to=_e})(Te=e.Hover||(e.Hover={}));var Le;(function(Ae){function Re(te){return{range:u.from(te.range),expression:te.expression}}Ae.from=Re;function _e(te){return new a.EvaluatableExpression(u.to(te.range),te.expression)}Ae.to=_e})(Le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(Ae){function Re(te){if(te instanceof a.InlineValueText)return{type:"text",range:u.from(te.range),text:te.text};if(te instanceof a.InlineValueVariableLookup)return{type:"variable",range:u.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Re;function _e(te){switch(te.type){case"text":return{range:u.to(te.range),text:te.text};case"variable":return{range:u.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:u.to(te.range),expression:te.expression}}}Ae.to=_e})(We=e.InlineValue||(e.InlineValue={}));var oe;(function(Ae){function Re(te){return{frameId:te.frameId,stoppedLocation:u.from(te.stoppedLocation)}}Ae.from=Re;function _e(te){return new a.InlineValueContext(te.frameId,u.to(te.stoppedLocation))}Ae.to=_e})(oe=e.InlineValueContext||(e.InlineValueContext={}));var le;(function(Ae){function Re(te){return{range:u.from(te.range),kind:te.kind}}Ae.from=Re;function _e(te){return new a.DocumentHighlight(u.to(te.range),te.kind)}Ae.to=_e})(le=e.DocumentHighlight||(e.DocumentHighlight={}));var me;(function(Ae){function Re(_e){switch(_e){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ae.to=Re})(me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Z;(function(Ae){function Re(_e){return{triggerKind:me.to(_e.triggerKind),triggerCharacter:_e.triggerCharacter}}Ae.to=Re})(Z=e.CompletionContext||(e.CompletionContext={}));var ae;(function(Ae){function Re(te){switch(te){case a.CompletionItemTag.Deprecated:return 1}}Ae.from=Re;function _e(te){switch(te){case 1:return a.CompletionItemTag.Deprecated}}Ae.to=_e})(ae=e.CompletionItemTag||(e.CompletionItemTag={}));var ee;(function(Ae){const Re=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function _e(je){return Re.get(je)??9}Ae.from=_e;const te=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(je){return te.get(je)??a.CompletionItemKind.Property}Ae.to=Fe})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(Ae){function Re(_e,te){const Fe=new a.CompletionItem(_e.label);return Fe.insertText=_e.insertText,Fe.kind=ee.to(_e.kind),Fe.tags=_e.tags?.map(ae.to),Fe.detail=_e.detail,Fe.documentation=D.isMarkdownString(_e.documentation)?B.to(_e.documentation):_e.documentation,Fe.sortText=_e.sortText,Fe.filterText=_e.filterText,Fe.preselect=_e.preselect,Fe.commitCharacters=_e.commitCharacters,k.Range.isIRange(_e.range)?Fe.range=u.to(_e.range):typeof _e.range=="object"&&(Fe.range={inserting:u.to(_e.range.insert),replacing:u.to(_e.range.replace)}),Fe.keepWhitespace=typeof _e.insertTextRules>"u"?!1:Boolean(_e.insertTextRules&1),typeof _e.insertTextRules<"u"&&_e.insertTextRules&4?Fe.insertText=new a.SnippetString(_e.insertText):(Fe.insertText=_e.insertText,Fe.textEdit=Fe.range instanceof a.Range?new a.TextEdit(Fe.range,Fe.insertText):void 0),_e.additionalTextEdits&&_e.additionalTextEdits.length>0&&(Fe.additionalTextEdits=_e.additionalTextEdits.map(je=>O.to(je))),Fe.command=te&&_e.command?te.fromInternal(_e.command):void 0,Fe}Ae.to=Re})(ie=e.CompletionItem||(e.CompletionItem={}));var F;(function(Ae){function Re(te){return{label:te.label,documentation:B.fromStrict(te.documentation)}}Ae.from=Re;function _e(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation}}Ae.to=_e})(F=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(Ae){function Re(te){return{label:te.label,documentation:B.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(F.from):[],activeParameter:te.activeParameter}}Ae.from=Re;function _e(te){return{label:te.label,documentation:D.isMarkdownString(te.documentation)?B.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(F.to):[],activeParameter:te.activeParameter}}Ae.to=_e})(H=e.SignatureInformation||(e.SignatureInformation={}));var K;(function(Ae){function Re(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.from):[]}}Ae.from=Re;function _e(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(H.to):[]}}Ae.to=_e})(K=e.SignatureHelp||(e.SignatureHelp={}));var X;(function(Ae){function Re(_e,te){const Fe=new a.InlayHint(r.to(te.position),typeof te.label=="string"?te.label:te.label.map(de.to.bind(void 0,_e)),te.kind&&we.to(te.kind));return Fe.textEdits=te.textEdits&&te.textEdits.map(O.to),Fe.tooltip=D.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,Fe.paddingLeft=te.paddingLeft,Fe.paddingRight=te.paddingRight,Fe}Ae.to=Re})(X=e.InlayHint||(e.InlayHint={}));var de;(function(Ae){function Re(_e,te){const Fe=new a.InlayHintLabelPart(te.label);return Fe.tooltip=D.isMarkdownString(te.tooltip)?B.to(te.tooltip):te.tooltip,S.Command.is(te.command)&&(Fe.command=_e.fromInternal(te.command)),te.location&&(Fe.location=pe.to(te.location)),Fe}Ae.to=Re})(de=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Ae){function Re(te){return te}Ae.from=Re;function _e(te){return te}Ae.to=_e})(we=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Ae){function Re(te){return{range:u.from(te.range),url:te.target,tooltip:te.tooltip}}Ae.from=Re;function _e(te){let Fe;if(te.url)try{Fe=typeof te.url=="string"?R.URI.parse(te.url,!0):R.URI.revive(te.url)}catch{}return new a.DocumentLink(u.to(te.range),Fe)}Ae.to=_e})(ce=e.DocumentLink||(e.DocumentLink={}));var Ce;(function(Ae){function Re(te){const Fe=new a.ColorPresentation(te.label);return te.textEdit&&(Fe.textEdit=O.to(te.textEdit)),te.additionalTextEdits&&(Fe.additionalTextEdits=te.additionalTextEdits.map(je=>O.to(je))),Fe}Ae.to=Re;function _e(te){return{label:te.label,textEdit:te.textEdit?O.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Fe=>O.from(Fe)):void 0}}Ae.from=_e})(Ce=e.ColorPresentation||(e.ColorPresentation={}));var ye;(function(Ae){function Re(te){return new a.Color(te[0],te[1],te[2],te[3])}Ae.to=Re;function _e(te){return[te.red,te.green,te.blue,te.alpha]}Ae.from=_e})(ye=e.Color||(e.Color={}));var $e;(function(Ae){function Re(te){return{range:u.from(te.range)}}Ae.from=Re;function _e(te){return new a.SelectionRange(u.to(te.range))}Ae.to=_e})($e=e.SelectionRange||(e.SelectionRange={}));var Ve;(function(Ae){function Re(_e){switch(_e){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ae.to=Re})(Ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(Ae){function Re(te){switch(te){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Re;function _e(te){switch(te){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ae.to=_e})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ye;(function(Ae){function Re(te){if(te===a.EndOfLine.CRLF)return 1;if(te===a.EndOfLine.LF)return 0}Ae.from=Re;function _e(te){if(te===1)return a.EndOfLine.CRLF;if(te===0)return a.EndOfLine.LF}Ae.to=_e})(Ye=e.EndOfLine||(e.EndOfLine={}));var Oe;(function(Ae){function Re(_e){if(typeof _e=="object")return _e.viewId;switch(_e){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Re})(Oe=e.ProgressLocation||(e.ProgressLocation={}));var ot;(function(Ae){function Re(_e){const te={start:_e.start+1,end:_e.end+1};return _e.kind&&(te.kind=re.from(_e.kind)),te}Ae.from=Re})(ot=e.FoldingRange||(e.FoldingRange={}));var re;(function(Ae){function Re(_e){if(_e)switch(_e){case a.FoldingRangeKind.Comment:return S.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return S.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return S.FoldingRangeKind.Region}}Ae.from=Re})(re=e.FoldingRangeKind||(e.FoldingRangeKind={}));var se;(function(Ae){function Re(_e){if(_e)return{pinned:typeof _e.preview=="boolean"?!_e.preview:void 0,inactive:_e.background,preserveFocus:_e.preserveFocus,selection:typeof _e.selection=="object"?u.from(_e.selection):void 0,override:typeof _e.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Re})(se=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ee;(function(Ae){function Re(je){return je instanceof a.RelativePattern?je.toJSON():typeof je=="string"?je:_e(je)||te(je)?new a.RelativePattern(je.baseUri??je.base,je.pattern).toJSON():je}Ae.from=Re;function _e(je){const it=je;return it?R.URI.isUri(it.baseUri)&&typeof it.pattern=="string":!1}function te(je){const it=je;return it?typeof it.base=="string"&&typeof it.pattern=="string":!1}function Fe(je){return typeof je=="string"?je:new a.RelativePattern(R.URI.revive(je.baseUri),je.pattern)}Ae.to=Fe})(Ee=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Ae){function Re(_e){if(_e){if(Array.isArray(_e))return _e.map(Re);if(typeof _e=="string")return _e;{const te=_e;return{language:te.language,scheme:te.scheme,pattern:Ee.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Ae.from=Re})(ue=e.LanguageSelector||(e.LanguageSelector={}));var ke;(function(Ae){function Re(te){return{start:te.start,end:te.end}}Ae.from=Re;function _e(te){return new a.NotebookRange(te.start,te.end)}Ae.to=_e})(ke=e.NotebookRange||(e.NotebookRange={}));var Ne;(function(Ae){function Re(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Ae.to=Re;function _e(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Ae.from=_e})(Ne=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Re(_e){if(_e===b.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(_e===b.NotebookCellExecutionState.Pending)return;if(_e===b.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${_e}`)}Ae.to=Re})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Ae){function Re(te){switch(te){case a.NotebookCellKind.Markup:return b.CellKind.Markup;case a.NotebookCellKind.Code:default:return b.CellKind.Code}}Ae.from=Re;function _e(te){switch(te){case b.CellKind.Markup:return a.NotebookCellKind.Markup;case b.CellKind.Code:default:return a.NotebookCellKind.Code}}Ae.to=_e})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Qe;(function(Ae){function Re(te){const Fe={metadata:te.metadata??Object.create(null),cells:[]};for(const je of te.cells)a.NotebookCellData.validate(je),Fe.cells.push(nt.from(je));return Fe}Ae.from=Re;function _e(te){const Fe=new a.NotebookData(te.cells.map(nt.to));return(0,C.isEmptyObject)(te.metadata)||(Fe.metadata=te.metadata),Fe}Ae.to=_e})(Qe=e.NotebookData||(e.NotebookData={}));var nt;(function(Ae){function Re(te){return{cellKind:ze.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Ne.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(st.from):[]}}Ae.from=Re;function _e(te){return new a.NotebookCellData(ze.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(st.to):void 0,te.metadata,te.internalMetadata?Ne.to(te.internalMetadata):void 0)}Ae.to=_e})(nt=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(Ae){function Re(te){return{mime:te.mime,valueBytes:t.VSBuffer.wrap(te.data)}}Ae.from=Re;function _e(te){return new a.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}Ae.to=_e})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var st;(function(Ae){function Re(te){return{outputId:te.id,items:te.items.map(ct.from),metadata:te.metadata}}Ae.from=Re;function _e(te){const Fe=te.items.map(ct.to);return new a.NotebookCellOutput(Fe,te.outputId,te.metadata)}Ae.to=_e})(st=e.NotebookCellOutput||(e.NotebookCellOutput={}));var et;(function(Ae){function Re(Fe){return te(Fe)?{include:(0,C.withNullAsUndefined)(Ee.from(Fe.include)),exclude:(0,C.withNullAsUndefined)(Ee.from(Fe.exclude))}:(0,C.withNullAsUndefined)(Ee.from(Fe))}Ae.from=Re;function _e(Fe){return te(Fe)?{include:Ee.to(Fe.include),exclude:Ee.to(Fe.exclude)}:Ee.to(Fe)}Ae.to=_e;function te(Fe){const je=Fe;return je?!(0,C.isUndefinedOrNull)(je.include)&&!(0,C.isUndefinedOrNull)(je.exclude):!1}})(et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var mt;(function(Ae){function Re(_e,te,Fe){const je=typeof _e.command=="string"?{title:"",command:_e.command}:_e.command;return{alignment:_e.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(je,Fe),text:_e.text,tooltip:_e.tooltip,accessibilityInformation:_e.accessibilityInformation,priority:_e.priority}}Ae.from=Re})(mt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var wt;(function(Ae){function Re(_e){return{transientOutputs:_e?.transientOutputs??!1,transientCellMetadata:_e?.transientCellMetadata??{},transientDocumentMetadata:_e?.transientDocumentMetadata??{}}}Ae.from=Re})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ct;(function(Ae){function Re(te){return{uri:te.uri,provides:te.provides}}Ae.from=Re;function _e(te){return new a.NotebookRendererScript(R.URI.revive(te.uri),te.provides)}Ae.to=_e})(Ct=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(Ae){function Re(te){return{message:B.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:u.from(te.location.range),uri:te.location.uri}}}Ae.from=Re;function _e(te){const Fe=new a.TestMessage(typeof te.message=="string"?te.message:B.to(te.message));return Fe.actualOutput=te.actual,Fe.expectedOutput=te.expected,Fe.location=te.location?pe.to(te.location):void 0,Fe}Ae.to=_e})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(Ae){Ae.namespace=v.namespaceTestTag,Ae.denamespace=v.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Ae){function Re(te){const Fe=(0,E.getPrivateApiFor)(te).controllerId;return{extId:m.TestId.fromExtHostTestItem(te,Fe).toString(),label:te.label,uri:R.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(je=>Dt.namespace(Fe,je.id)),range:k.Range.lift(u.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&B.fromStrict(te.error)||null}}Ae.from=Re;function _e(te){return{parent:void 0,error:void 0,id:m.TestId.fromString(te.extId).localId,label:te.label,uri:R.URI.revive(te.uri),tags:(te.tags||[]).map(Fe=>{const{tagId:je}=Dt.denamespace(Fe);return new a.TestTag(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Ae.toPlain=_e})(Ft=e.TestItem||(e.TestItem={})),function(Ae){function Re(te){return{id:te.id}}Ae.from=Re;function _e(te){return new a.TestTag(te.id)}Ae.to=_e}(Dt=e.TestTag||(e.TestTag={}));var Ut;(function(Ae){const Re=(te,Fe)=>{const je=[];for(const[Ke,Je]of Fe)m.TestId.compare(Je.item.extId,Ke)===2&&(Fe.delete(Ke),je.push(Je));const it={...Ft.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(Je=>Je.type===0).map(ft.to)})),children:je.map(Ke=>Re(Ke,Fe))};for(const Ke of it.children)Ke.parent=it;return it};function _e(te){const Fe=[],je=new Map;for(const it of te.items)je.set(it.item.extId,it),te.request.targets.some(Ke=>Ke.controllerId===it.controllerId&&Ke.testIds.includes(it.item.extId))&&Fe.push(it);return{completedAt:te.completedAt,results:Fe.map(it=>Re(it,je))}}Ae.to=_e})(Ut=e.TestResults||(e.TestResults={}));var Ge;(function(Ae){function Re(je){return{covered:je.covered,total:je.covered}}function _e(je){return"line"in je?r.from(je):u.from(je)}function te(je){return"branches"in je?{count:je.executionCount,location:_e(je.location),type:1,branches:je.branches.length?je.branches.map(it=>({count:it.executionCount,location:it.location&&_e(it.location)})):void 0}:{type:0,count:je.executionCount,location:_e(je.location)}}Ae.fromDetailed=te;function Fe(je){return{uri:je.uri,statement:Re(je.statementCoverage),branch:je.branchCoverage&&Re(je.branchCoverage),function:je.functionCoverage&&Re(je.functionCoverage),details:je.detailedCoverage?.map(te)}}Ae.fromFile=Fe})(Ge=e.TestCoverage||(e.TestCoverage={}));var Nt;(function(Ae){function Re(_e){switch(_e){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ae.to=Re})(Nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Rt;(function(Ae){function Re(te){const Fe=new a.TypeHierarchyItem(V.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),u.to(te.range),u.to(te.selectionRange));return Fe._sessionId=te._sessionId,Fe._itemId=te._itemId,Fe}Ae.to=Re;function _e(te,Fe,je){if(Fe=Fe??te._sessionId,je=je??te._itemId,Fe===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:je,kind:V.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:u.from(te.range),selectionRange:u.from(te.selectionRange),tags:te.tags?.map(q.from)}}Ae.from=_e})(Rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Lt;(function(Ae){function Re(_e){if(!!_e)return{value:_e.value,tooltip:_e.tooltip}}Ae.from=Re})(Lt=e.ViewBadge||(e.ViewBadge={}));var vt;(function(Ae){function Re(_e,te){const Fe=_e.fileData;return Fe?new class extends a.DataTransferItem{asFile(){return{name:Fe.name,uri:R.URI.revive(Fe.uri),data:(0,h.once)(()=>te())}}}(""):new a.DataTransferItem(_e.asString)}Ae.toDataTransferItem=Re})(vt=e.DataTransferItem||(e.DataTransferItem={}));var It;(function(Ae){function Re(te,Fe){const je=te.items.map(([it,Ke],Je)=>[it,vt.toDataTransferItem(Ke,()=>Fe(Je))]);return new a.DataTransfer(je)}Ae.toDataTransfer=Re;async function _e(te){const Fe={items:[]},je=[];return te.forEach((it,Ke)=>{je.push((async()=>{const Je=await it.asString(),lt=it.asFile();Fe.items.push([Ke,{asString:Je,fileData:lt?{name:lt.name,uri:lt.uri}:void 0}])})())}),await Promise.all(je),Fe}Ae.toDataTransferDTO=_e})(It=e.DataTransfer||(e.DataTransfer={}))}),define(De[225],Ie([1,0,2,10,7,16,78]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(C,R,k,S={timeout:1500,errors:3}){this._logService=C,this._documents=R,this._mainThreadBulkEdits=k,this._thresholds=S,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(R,k,S)=>{const E={dispose:this._callbacks.push([R,k,C])};return Array.isArray(S)&&S.push(E),E}}async $participateInSave(C,R){const k=l.URI.revive(C);let S=!1;const T=setTimeout(()=>S=!0,this._thresholds.timeout),E=[];try{for(const g of[...this._callbacks]){if(S)break;const b=this._documents.getDocument(k),m=await this._deliverEventAsyncAndBlameBadListeners(g,{document:b,reason:P.TextDocumentSaveReason.to(R)});E.push(m)}}finally{clearTimeout(T)}return E}_deliverEventAsyncAndBlameBadListeners([C,R,k],S){const T=this._badListeners.get(C);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,C,R,S).then(()=>!0,E=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const g=this._badListeners.get(C);this._badListeners.set(C,g?g+1:1),typeof g=="number"&&g>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,R,k,S){const T=[],E=Date.now(),{document:g,reason:b}=S,{version:m}=g,v=Object.freeze({document:g,reason:b,waitUntil(p){if(Object.isFrozen(T))throw(0,t.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(p))}});try{R.apply(k,[v])}catch(p){return Promise.reject(p)}return Object.freeze(T),new Promise((p,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(h),p(i)}).catch(i=>{clearTimeout(h),a(i)})}).then(p=>{const a={edits:[]};for(const h of p)if(Array.isArray(h)&&h.every(i=>i instanceof D.TextEdit))for(const{newText:i,newEol:u,range:o}of h)a.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:o&&P.Range.from(o),text:i,eol:u&&P.EndOfLine.from(u)}});if(a.edits.length!==0)return m===g.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(De[226],Ie([1,0,12,2,16,7,127]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class I{constructor(k,S,T,E){this.start=k,this.deletedCount=S,this.deletedItems=T,this.items=E}asApiEvent(){return{range:new P.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class w{constructor(k,S,T){this.notebook=k,this._extHostDocument=S,this._cellData=T,this.handle=T.handle,this.uri=t.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(D.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(k,S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1,notebook:k}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const k=this,S=this._extHostDocument.getDocument(this.uri);if(!S)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this._cellData.cellKind),document:S.document,get mime(){return k._mime},set mime(E){k._mime=E},get outputs(){return k._outputs.slice(0)},get metadata(){return k._metadata},get executionSummary(){return k._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(k){this._outputs=k.map(D.NotebookCellOutput.to)}setOutputItems(k,S,T){const E=T.map(D.NotebookCellOutputItem.to),g=this._outputs.find(b=>b.id===k);g&&(S||(g.items.length=0),g.items.push(...E))}setMetadata(k){this._metadata=Object.freeze(k)}setInternalMetadata(k){this._internalMetadata=k,this._previousResult=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=w;class C{constructor(k,S,T,E,g){this._proxy=k,this._textDocumentsAndEditors=S,this._textDocuments=T,this.uri=E,this.handle=C._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=g.viewType,this._metadata=Object.freeze(g.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,g.cells]],!0,void 0),this._versionId=g.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const k=this,S={get uri(){return k.uri},get version(){return k._versionId},get notebookType(){return k._notebookType},get isDirty(){return k._isDirty},get isUntitled(){return k.uri.scheme===l.Schemas.untitled},get isClosed(){return k._disposed},get metadata(){return k._metadata},get cellCount(){return k._cells.length},cellAt(T){return T=k._validateIndex(T),k._cells[T].apiCell},getCells(T){return(T?k._getCells(T):k._cells).map(g=>g.apiCell)},save(){return k._save()}};this._notebook=Object.freeze(S)}return this._notebook}updateBackup(k){this._backup?.delete(),this._backup=k}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(k){k.metadata&&(this._metadata=Object.freeze({...this._metadata,...k.metadata}))}acceptDirty(k){this._isDirty=k}acceptModelChanged(k,S,T){this._versionId=k.versionId,this._isDirty=S,this.acceptDocumentPropertiesChanged({metadata:T});const E={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},g=[];for(const m of k.rawEvents)m.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(m.changes,!1,E.contentChanges):m.kind===_.NotebookCellsChangeType.Move?this._moveCell(m.index,m.newIdx,E.contentChanges):m.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(m.index,m.outputs),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(m.index,m.outputId,m.append,m.outputItems),g.push({cell:this._cells[m.index].apiCell,outputs:this._cells[m.index].apiCell.outputs})):m.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(m.index,m.language),g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document})):m.kind===_.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this._cells[m.index].apiCell,document:this._cells[m.index].apiCell.document}):m.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(m.index,m.mime):m.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(m.index,m.metadata),g.push({cell:this._cells[m.index].apiCell,metadata:this._cells[m.index].apiCell.metadata})):m.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(m.index,m.internalMetadata),g.push({cell:this._cells[m.index].apiCell,executionSummary:this._cells[m.index].apiCell.executionSummary}));const b=new Map;for(let m=0;m<g.length;m++){const v=g[m],p=b.get(v.cell);if(p===void 0){const a=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});b.set(v.cell,a-1)}else E.cellChanges[p]={...E.cellChanges[p],...v}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}_validateIndex(k){return k=k|0,k<0?0:k>=this._cells.length?this._cells.length-1:k}_validateRange(k){let S=k.start|0,T=k.end|0;return S<0&&(S=0),T>this._cells.length&&(T=this._cells.length),k.with({start:S,end:T})}_getCells(k){k=this._validateRange(k);const S=[];for(let T=k.start;T<k.end;T++)S.push(this._cells[T]);return S}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(k,S,T){if(this._disposed)return;const E=[],g=[],b=[];if(k.reverse().forEach(m=>{const p=m[2].map(i=>{const u=new w(this,this._textDocumentsAndEditors,i);return S||g.push(w.asModelAddData(this.apiNotebook,i)),u}),a=new I(m[0],m[1],[],p),h=this._cells.splice(m[0],m[1],...p);for(const i of h)b.push(i.uri),a.deletedItems.push(i.apiCell);E.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:b}),T)for(const m of E)T.push(m.asApiEvent())}_moveCell(k,S,T){const E=this._cells.splice(k,1);this._cells.splice(S,0,...E);const g=[new I(k,1,E.map(b=>b.apiCell),[]),new I(S,0,[],E)];for(const b of g)T.push(b.asApiEvent())}_setCellOutputs(k,S){this._cells[k].setOutputs(S)}_setCellOutputItems(k,S,T,E){this._cells[k].setOutputItems(S,T,E)}_changeCellLanguage(k,S){const T=this._cells[k];T.apiCell.document.languageId!==S&&this._textDocuments.$acceptModelLanguageChanged(T.uri,S)}_changeCellMime(k,S){const T=this._cells[k];T.apiCell.mime=S}_changeCellMetadata(k,S){this._cells[k].setMetadata(S)}_changeCellInternalMetadata(k,S){this._cells[k].setInternalMetadata(S)}getCellFromApiCell(k){return this._cells.find(S=>S.apiCell===k)}getCellFromIndex(k){return this._cells[k]}getCell(k){return this._cells.find(S=>S.handle===k)}getCellIndex(k){return this._cells.indexOf(k)}}e.ExtHostNotebookDocument=C,C._handlePool=0}),define(De[132],Ie([1,0,10,16,7]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(I,w,C,R,k,S){this.id=I,this._proxy=w,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=k,this._visibleRanges=R,this._viewColumn=S}get apiEditor(){if(!this._editor){const I=this;this._editor={get document(){return I.notebookData.apiNotebook},get notebook(){return I.notebookData.apiNotebook},get selection(){return I._selections[0]},set selection(w){this.selections=[w]},get selections(){return I._selections},set selections(w){if(!Array.isArray(w)||!w.every(D.NotebookRange.isNotebookRange))throw(0,l.illegalArgument)("selections");I._selections=w,I._trySetSelections(w)},get visibleRanges(){return I._visibleRanges},revealRange(w,C){I._proxy.$tryRevealRange(I.id,t.NotebookRange.from(w),C??D.NotebookEditorRevealType.Default)},get viewColumn(){return I._viewColumn}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(I){this._visible=I}_acceptVisibleRanges(I){this._visibleRanges=I}_acceptSelections(I){this._selections=I}_trySetSelections(I){this._proxy.$trySetSelections(this.id,I.map(t.NotebookRange.from))}_acceptViewColumn(I){this._viewColumn=I}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(De[227],Ie([1,0,4,14,16]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let P=class{constructor(I,w){this._logService=I,this._notebooksAndEditors=w,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(I,w){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,w);const C=this._notebooksAndEditors.getEditorById(I);w.visibleRanges&&C._acceptVisibleRanges(w.visibleRanges.ranges.map(D.NotebookRange.to)),w.selections&&C._acceptSelections(w.selections.selections.map(D.NotebookRange.to)),w.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),w.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const w in I)this._notebooksAndEditors.getEditorById(w)._acceptViewColumn(D.ViewColumn.to(I[w]))}};P=qe([xe(0,t.ILogService)],P),e.ExtHostNotebookEditors=P}),define(De[228],Ie([1,0,16,118,171,21,58,10]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class w{constructor(S){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=S}async withProgress(S,T,E){const g=this._handles++,{title:b,location:m,cancellable:v}=T,p={label:(0,D.localize)(0,null,S.displayName||S.name),id:S.identifier.value};return this._proxy.$startProgress(g,{location:l.ProgressLocation.from(m),title:b,source:p,cancellable:v},S.isUnderDevelopment?void 0:S.identifier.value).catch(I.onUnexpectedExternalError),this._withProgress(g,E,!!v)}_withProgress(S,T,E){let g;E&&(g=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(S,g));const b=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),g?.dispose()};let m;try{m=T(new R(this._proxy,S),E&&g?g.token:P.CancellationToken.None)}catch(v){throw b(S),v}return m.then(v=>b(S),v=>b(S)),m}$acceptProgressCanceled(S){const T=this._mapHandleToCancellationSource.get(S);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(S))}}e.ExtHostProgress=w;function C(k,S){return k.message=S.message,typeof S.increment=="number"&&(typeof k.increment=="number"?k.increment+=S.increment:k.increment=S.increment),k}class R extends t.Progress{constructor(S,T){super(E=>this.throttledReport(E)),this._proxy=S,this._handle=T}throttledReport(S){this._proxy.$progressReport(this._handle,S)}}qe([(0,_.throttle)(100,(k,S)=>C(k,S),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[133],Ie([1,0,35,128,64,89,65,16,2]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(p,a,h,i)=>{let u=a;return{enumerable:!0,configurable:!1,get(){return u},set(o){if(!h(u,o)){const r=u;u=o,p.listener?.(i(o,r))}}}},R=(p,a)=>p===a,k={range:(p,a)=>p===a?!0:!p||!a?!1:p.isEqual(a),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(p,a)=>!(p.length!==a.length||p.some(h=>!a.find(i=>h.id===i.id)))},S=p=>a=>({op:4,update:p(a)}),T=(p,a)=>({range:C(p,void 0,k.range,S(h=>({range:l.Range.lift(I.Range.from(h))}))),label:C(p,a,k.label,S(h=>({label:h}))),description:C(p,void 0,k.description,S(h=>({description:h}))),sortText:C(p,void 0,k.sortText,S(h=>({sortText:h}))),canResolveChildren:C(p,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:C(p,!1,k.busy,S(h=>({busy:h}))),error:C(p,void 0,k.error,S(h=>({error:I.MarkdownString.fromStrict(h)||null}))),tags:C(p,[],k.tags,(h,i)=>({op:1,new:h.map(I.TestTag.from),old:i.map(I.TestTag.from)}))}),E=p=>{const a=D.TestId.fromString(p.extId),h=new b(a.controllerId,a.localId,p.label,w.URI.revive(p.uri)||void 0);return h.range=I.Range.to(p.range||void 0),h.description=p.description||void 0,h.sortText=p.sortText||void 0,h.tags=p.tags.map(i=>I.TestTag.to({id:(0,_.denamespaceTestTag)(i).tagId})),h},g=p=>{let a;for(const h of p.tests){const i=E(h.item);(0,t.getPrivateApiFor)(i).parent=a,a=i}return a};e.toItemFromContext=g;class b{constructor(a,h,i,u){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,t.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof m?void 0:o.parent}},children:{value:(0,P.createTestItemChildren)(o,t.getPrivateApiFor,b),enumerable:!0,writable:!1},...T(o,i)})}}e.TestItemImpl=b;class m extends b{constructor(a,h){super(a,a,h,void 0)}}e.TestItemRootImpl=m;class v extends P.TestItemCollection{constructor(a,h,i){super({controllerId:a,getDocumentVersion:u=>i.getDocument(u)?.version,getApiFor:t.getPrivateApiFor,getChildren:u=>u.children,root:new m(a,h),toITestItem:I.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[134],Ie([1,0,48,10,93,16,7]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(S,T,E){const g=I._Keys.nextId();S.$registerTextEditorDecorationType(T.identifier,g,P.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:g,dispose(){S.$removeTextEditorDecorationType(g)}})}}e.TextEditorDecorationType=I,I._Keys=new D.IdGenerator("TextEditorDecorationType");class w{constructor(S,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=S,this._documentVersionId=S.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(S,T){this._throwIfFinalized();let E=null;if(S instanceof _.Position)E=new _.Range(S,S);else if(S instanceof _.Range)E=S;else throw new Error("Unrecognized location");this._pushEdit(E,T,!1)}insert(S,T){this._throwIfFinalized(),this._pushEdit(new _.Range(S,S),T,!0)}delete(S){this._throwIfFinalized();let T=null;if(S instanceof _.Range)T=S;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(S,T,E){const g=this._document.validateRange(S);this._collectedEdits.push({range:g,text:T,forceMoveMarkers:E})}setEndOfLine(S){if(this._throwIfFinalized(),S!==_.EndOfLine.LF&&S!==_.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=S}}e.TextEditorEdit=w;class C{constructor(S,T,E,g){this._proxy=S,this._id=T,this._accept(E),this._logService=g;const b=this;this.value={get tabSize(){return b._tabSize},set tabSize(m){b._setTabSize(m)},get insertSpaces(){return b._insertSpaces},set insertSpaces(m){b._setInsertSpaces(m)},get cursorStyle(){return b._cursorStyle},set cursorStyle(m){b._setCursorStyle(m)},get lineNumbers(){return b._lineNumbers},set lineNumbers(m){b._setLineNumbers(m)}}}_accept(S){this._tabSize=S.tabSize,this._insertSpaces=S.insertSpaces,this._cursorStyle=S.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(S.lineNumbers)}_validateTabSize(S){if(S==="auto")return"auto";if(typeof S=="number"){const T=Math.floor(S);return T>0?T:null}if(typeof S=="string"){const T=parseInt(S,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(S){const T=this._validateTabSize(S);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(S){return S==="auto"?"auto":S==="false"?!1:Boolean(S)}_setInsertSpaces(S){const T=this._validateInsertSpaces(S);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(S){this._cursorStyle!==S&&(this._cursorStyle=S,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:S})))}_setLineNumbers(S){this._lineNumbers!==S&&(this._lineNumbers=S,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(S)})))}assign(S){const T={};let E=!1;if(typeof S.tabSize<"u"){const g=this._validateTabSize(S.tabSize);g==="auto"?(E=!0,T.tabSize=g):typeof g=="number"&&this._tabSize!==g&&(this._tabSize=g,E=!0,T.tabSize=g)}if(typeof S.insertSpaces<"u"){const g=this._validateInsertSpaces(S.insertSpaces);g==="auto"?(E=!0,T.insertSpaces=g):this._insertSpaces!==g&&(this._insertSpaces=g,E=!0,T.insertSpaces=g)}typeof S.cursorStyle<"u"&&this._cursorStyle!==S.cursorStyle&&(this._cursorStyle=S.cursorStyle,E=!0,T.cursorStyle=S.cursorStyle),typeof S.lineNumbers<"u"&&this._lineNumbers!==S.lineNumbers&&(this._lineNumbers=S.lineNumbers,E=!0,T.lineNumbers=P.TextEditorLineNumbersStyle.from(S.lineNumbers)),E&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(S,T){T.catch(E=>{this._logService.warn(`ExtHostTextEditorOptions '${S}' failed:'`),this._logService.warn(E)})}}e.ExtHostTextEditorOptions=C;class R{constructor(S,T,E,g,b,m,v,p){this.id=S,this._proxy=T,this._logService=E,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=b,this._options=new C(this._proxy,this.id,m,E),this._visibleRanges=v,this._viewColumn=p;const a=this;this.value=Object.freeze({get document(){return g.getValue()},set document(h){throw(0,t.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(h){if(!(h instanceof _.Selection))throw(0,t.illegalArgument)("selection");a._selections=[h],a._trySetSelection()},get selections(){return a._selections},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof _.Selection)))throw(0,t.illegalArgument)("selections");a._selections=h,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(h){throw(0,t.readonly)("visibleRanges")},get options(){return a._options.value},set options(h){a._disposed||a._options.assign(h)},get viewColumn(){return a._viewColumn},set viewColumn(h){throw(0,t.readonly)("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new w(g.getValue(),i);return h(u),a._applyEdit(u)},insertSnippet(h,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!i||Array.isArray(i)&&i.length===0)o=a._selections.map(r=>P.Range.from(r));else if(i instanceof _.Position){const{lineNumber:r,column:s}=P.Position.from(i);o=[{startLineNumber:r,startColumn:s,endLineNumber:r,endColumn:s}]}else if(i instanceof _.Range)o=[P.Range.from(i)];else{o=[];for(const r of i)if(r instanceof _.Range)o.push(P.Range.from(r));else{const{lineNumber:s,column:n}=P.Position.from(r);o.push({startLineNumber:s,startColumn:n,endLineNumber:s,endColumn:n})}}return T.$tryInsertSnippet(S,g.getValue().version,h.value,o,u)},setDecorations(h,i){const u=i.length===0;u&&!a._hasDecorationsForKey.has(h.key)||(u?a._hasDecorationsForKey.delete(h.key):a._hasDecorationsForKey.add(h.key),a._runOnProxy(()=>{if(P.isDecorationOptionsArr(i))return T.$trySetDecorations(S,h.key,P.fromRangeOrRangeWithMessage(i));{const o=new Array(4*i.length);for(let r=0,s=i.length;r<s;r++){const n=i[r];o[4*r]=n.start.line+1,o[4*r+1]=n.start.character+1,o[4*r+2]=n.end.line+1,o[4*r+3]=n.end.character+1}return T.$trySetDecorationsFast(S,h.key,o)}}))},revealRange(h,i){a._runOnProxy(()=>T.$tryRevealRange(S,P.Range.from(h),i||_.TextEditorRevealType.Default))},show(h){T.$tryShowEditor(S,P.ViewColumn.from(h))},hide(){T.$tryHideEditor(S)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(S){(0,l.ok)(!this._disposed),this._options._accept(S)}_acceptVisibleRanges(S){(0,l.ok)(!this._disposed),this._visibleRanges=S}_acceptViewColumn(S){(0,l.ok)(!this._disposed),this._viewColumn=S}_acceptSelections(S){(0,l.ok)(!this._disposed),this._selections=S}async _trySetSelection(){const S=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,S)),this.value}_applyEdit(S){const T=S.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const E=T.edits.map(b=>b.range);E.sort((b,m)=>b.end.line===m.end.line?b.end.character===m.end.character?b.start.line===m.start.line?b.start.character-m.start.character:b.start.line-m.start.line:b.end.character-m.end.character:b.end.line-m.end.line);for(let b=0,m=E.length-1;b<m;b++){const v=E[b].end;if(E[b+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=T.edits.map(b=>({range:P.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,g,{setEndOfLine:typeof T.setEndOfLine=="number"?P.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(S){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):S().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=R}),define(De[229],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[230],Ie([1,0,185,10,41,84,119,43,28,229,196]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const k=I.Registry.as(_.Extensions.JSONContribution);class S{constructor(a,h,i){this._messageHandler=a,this._extension=h,this._extensionPointId=i}_msg(a,h){this._messageHandler({type:a,message:h,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(a){this._msg(D.default.Error,a)}warn(a){this._msg(D.default.Warning,a)}info(a){this._msg(D.default.Info,a)}}e.ExtensionMessageCollector=S;class T{constructor(a,h){this.added=a,this.removed=h}static _toSet(a){const h=new Set;for(let i=0,u=a.length;i<u;i++)h.add(w.ExtensionIdentifier.toKey(a[i].description.identifier));return h}static compute(a,h){if(!a||!a.length)return new T(h,[]);if(!h||!h.length)return new T([],a);const i=this._toSet(a),u=this._toSet(h),o=h.filter(s=>!i.has(w.ExtensionIdentifier.toKey(s.description.identifier))),r=a.filter(s=>!u.has(w.ExtensionIdentifier.toKey(s.description.identifier)));return new T(o,r)}}e.ExtensionPointUserDelta=T;class E{constructor(a,h){this.name=a,this.defaultExtensionKind=h,this._handler=null,this._users=null,this._delta=null}setHandler(a){if(this._handler!==null)throw new Error("Handler already set!");this._handler=a,this._handle()}acceptUsers(a){this._delta=T.compute(this._users,a),this._users=a,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(a){(0,t.onUnexpectedError)(a)}}}e.ExtensionPoint=E;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},b="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:w.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},activationEvents:{description:l.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:l.localize(31,null)},{label:"onUri",body:"onUri",description:l.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(36,null)},{label:"onRenderer",description:l.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(39,null)},{label:"*",description:l.localize(40,null),body:"*"}]}},badges:{type:"array",description:l.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(42,null)},href:{type:"string",description:l.localize(43,null)},description:{type:"string",description:l.localize(44,null)}}}},markdown:{type:"string",description:l.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:l.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:l.localize(49,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(50,null)},{body:["workspace"],description:l.localize(51,null)},{body:["ui","workspace"],description:l.localize(52,null)},{body:["workspace","ui"],description:l.localize(53,null)},{body:[],description:l.localize(54,null)}]},capabilities:{description:l.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(58,null),l.localize(59,null),l.localize(60,null)]},description:{type:"string",markdownDescription:l.localize(61,null)}}},untrustedWorkspaces:{description:l.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(64,null),l.localize(65,null),l.localize(66,null)]},restrictedConfigurations:{description:l.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(68,null)}}}}},sponsor:{description:l.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(71,null),type:"string"},"vscode:uninstall":{description:l.localize(72,null),type:"string"}}},icon:{type:"string",description:l.localize(73,null)}}};class m{constructor(){this._extensionPoints=new Map}registerExtensionPoint(a){if(this._extensionPoints.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const h=new E(a.extensionPoint,a.defaultExtensionKind);return this._extensionPoints.set(a.extensionPoint,h),e.schema.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,k.registerSchema(b,e.schema),h}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=m;const v={ExtensionsRegistry:"ExtensionsRegistry"};I.Registry.add(v.ExtensionsRegistry,new m),e.ExtensionsRegistry=I.Registry.as(v.ExtensionsRegistry),k.registerSchema(b,e.schema),k.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:l.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(De[231],Ie([1,0,182,13,24,230,52,4]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const w={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var C;(function(S){function T(E,g,b){if(!E)return;const m=t.isString(E.type)?E.type:void 0;if(!m||m.length===0){b.error(l.localize(3,null));return}const v=[];if(Array.isArray(E.required))for(const p of E.required)t.isString(p)&&v.push(p);return{extensionId:g.value,taskType:m,required:v,properties:E.properties?D.deepClone(E.properties):{},when:E.when?_.ContextKeyExpr.deserialize(E.when):void 0}}S.from=T})(C||(C={}));const R=P.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:l.localize(4,null),type:"array",items:w}});class k{constructor(){this._onDefinitionsChanged=new I.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,E)=>{R.setHandler((g,b)=>{this._schema=void 0;try{for(const m of b.removed){const v=m.value;for(const p of v)this.taskTypes&&p.type&&this.taskTypes[p.type]&&delete this.taskTypes[p.type]}for(const m of b.added){const v=m.value;for(const p of v){const a=C.from(p,m.description.identifier,m.collector);a&&(this.taskTypes[a.taskType]=a)}}(b.removed.length>0||b.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const E of this.all()){const g={type:"object",additionalProperties:!1};E.required.length>0&&(g.required=E.required.slice(0)),E.properties!==void 0?g.properties=D.deepClone(E.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[E.taskType]},T.push(g)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=k,e.TaskDefinitionRegistry=new k}),define(De[232],Ie([1,0,183,13,22,24,52,231]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,l.localize(0,null)),e.TASKS_CATEGORY={value:l.localize(1,null),original:"Tasks"};var w;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(w=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function G(z){if(!z)return N.Strong;switch(z.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=G}(w=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function G(z){switch(z.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=G}(R=e.RevealKind||(e.RevealKind={}));var k;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(k=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function G(z){switch(z.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=G}(k=e.RevealProblemKind||(e.RevealProblemKind={}));var S;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(S=e.PanelKind||(e.PanelKind={})),function(N){function G(z){switch(z.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=G}(S=e.PanelKind||(e.PanelKind={}));var T;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:k.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(N){function G(O){switch(O.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=G;function z(O){switch(O){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=z}(E=e.RuntimeType||(e.RuntimeType={}));var g;(function(N){function G(z){return t.isString(z)?z:z.value}N.value=G})(g=e.CommandString||(e.CommandString={}));var b;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function G(O){return O===N.Clean._id||O===N.Build._id||O===N.Rebuild._id||O===N.Test._id}N.is=G;function z(O){if(O!==void 0)return t.isString(O)?G(O)?{_id:O,isDefault:!1}:void 0:O}N.from=z})(b=e.TaskGroup||(e.TaskGroup={}));var m;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(m=e.TaskScope||(e.TaskScope={}));var v;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function G(z){switch(z){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=G})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(N){N.parallel="parallel",N.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var a;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(a=e.RunOnOptions||(e.RunOnOptions={}));var h;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h=e.RunOptions||(e.RunOptions={}));class i{constructor(G,z,O,x,V,q){this._label="",this._id=G,z&&(this._label=z),O&&(this.type=O),this.runOptions=x,this.configurationProperties=V,this._source=q}getDefinition(G){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const G={folder:this.getFolderId(),id:this._id};return JSON.stringify(G)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,z=!1){if(G===void 0)return!1;if(t.isString(G))return G===this._label||G===this.configurationProperties.identifier||z&&G===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),G&&(this._taskLoadMessages=this._taskLoadMessages.concat(G))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class u extends i{constructor(G,z,O,x,V,q,Y,Q){super(G,O,void 0,Y,Q,z),this.command={},this._source=z,this.hasDefinedMatchers=q,V&&(this.command=V)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case E.Shell:z="shell";break;case E.Process:z="process";break;case E.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(G){return G instanceof u}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:z};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(G){return new u(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.CustomTask=u;class o extends i{constructor(G,z,O,x,V,q,Y){super(G,O,x,q,Y,z),this._source=z,this.configures=V}static is(G){return G instanceof o}fromObject(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const G=this.getFolderId();if(!G)return;let z=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(z+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:z};return JSON.stringify(O)}}e.ConfiguringTask=o;class r extends i{constructor(G,z,O,x,V,q,Y,Q,he){super(G,O,x,Q,he,z),this.defines=V,this.hasDefinedMatchers=Y,this.command=q,this.icon=he.icon,this.hide=he.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof r}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.getFolderId(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(G){return new r(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.ContributedTask=r;class s extends i{constructor(G,z,O,x,V,q){super(G,O,x,V,q,z),this._source=z}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(G){return new s(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.InMemoryTask=s;var n;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(n=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(n=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class d{constructor(G){this._order=new Map;for(let z=0;z<G.length;z++)this._order.set(G[z].uri.toString(),z)}compare(G,z){const O=G.getWorkspaceFolder(),x=z.getWorkspaceFolder();if(O&&x){let V=this._order.get(O.uri.toString());V=V===void 0?0:V+1;let q=this._order.get(x.uri.toString());return q=q===void 0?0:q+1,V===q?G._label.localeCompare(z._label):V-q}else return!O&&x?-1:O&&!x?1:0}}e.TaskSorter=d;var f;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(N){N.SingleRun="singleRun",N.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var L;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function G(z,O,x,V,q){if(O){const Y={kind:z,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return z==="start"?(Y.terminalId=x,Y.resolvedVariables=V):z==="processStarted"?Y.processId=x:z==="processEnded"&&(Y.exitCode=x),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}N.create=G})(M=e.TaskEvent||(e.TaskEvent={}));var B;(function(N){function G(O){const x=Object.keys(O).sort();let V="";for(const q of x){let Y=O[q];Y instanceof Object?Y=G(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),V+=q+","+Y+","}return V}function z(O){const V={_key:G(O),type:O.taskType};return Object.assign(V,O),V}N.create=z})(B=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var A;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(A=e.TaskSettingId||(e.TaskSettingId={}));var W;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(W=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(N){function G(z,O){const x=I.TaskDefinitionRegistry.get(z.type);if(x===void 0){const Q=P.deepClone(z);return delete Q._key,B.create(Q)}const V=Object.create(null);V.type=x.taskType;const q=new Set;x.required.forEach(Q=>q.add(Q));const Y=x.properties;for(const Q of Object.keys(Y)){const he=z[Q];if(he!=null)V[Q]=he;else if(q.has(Q)){const ve=Y[Q];if(ve.default!==void 0)V[Q]=P.deepClone(ve.default);else switch(ve.type){case"boolean":V[Q]=!1;break;case"number":case"integer":V[Q]=0;break;case"string":V[Q]="";break;default:O.error(l.localize(2,null,JSON.stringify(z,void 0,0),Q));return}}}return B.create(V)}N.createTaskIdentifier=G})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[233],Ie([1,0,10]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,I)=>{this._actualOk=_,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,l.onUnexpectedError)(_))}then(_,I){return this._ensureActual().then(_,I)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=t;class D extends t{constructor(){super(),this._hasErr=!0,this._err=new l.CancellationError}}e.CanceledLazyPromise=D}),define(De[55],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const t=[];function D(I){const w=new l(I);return t[w.nid]=w,w}e.createProxyIdentifier=D;function P(I){return t[I].sid}e.getStringIdentifierForProxy=P;class _{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=_}),define(De[5],Ie([1,0,55]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var P;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(P=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var I;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(I=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class k{static mixin(b){return b._id=k._n++,b}}e.IdObject=k,k._n=0;var S;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.command="m",g.kindModifier="n"})(S=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,l.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,l.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,l.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,l.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,l.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,l.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,l.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,l.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,l.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,l.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,l.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,l.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,l.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,l.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,l.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,l.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,l.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,l.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,l.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,l.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,l.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,l.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,l.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,l.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,l.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,l.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,l.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,l.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,l.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,l.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,l.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,l.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,l.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,l.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,l.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,l.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,l.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,l.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,l.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,l.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,l.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,l.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,l.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,l.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,l.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,l.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,l.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,l.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,l.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,l.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,l.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,l.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,l.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,l.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,l.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,l.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,l.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,l.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,l.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,l.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,l.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,l.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[66],Ie([1,0,3,14,5,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(w,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=w.getProxy(D.MainContext.MainThreadTelemetry)}report(w,C,R){const k=this.getUsageKey(w,C);this._reportedUsages.has(k)||(this._reportedUsages.add(k),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${w}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:w}))}getUsageKey(w,C){return`${w}-${C.identifier.value}`}};_=qe([xe(0,P.IExtHostRpcService),xe(1,t.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(I,w,C){}})}),define(De[234],Ie([1,0,4,5,7,28]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(w){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=w.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(w){return this._providers=w,Promise.resolve()}async getSession(w,C,R,k={}){const S=P.ExtensionIdentifier.toKey(w.identifier),T=this._inFlightRequests.get(S)||[],E=[...R].sort().join(" ");let g=T.find(b=>b.providerId===C&&b.scopes===E);if(g)return g.result;{const b=this._getSession(w,S,C,R,k);g={providerId:C,scopes:E,result:b},T.push(g),this._inFlightRequests.set(S,T);try{await b}finally{const m=T.findIndex(v=>v.providerId===C&&v.scopes===E);m>-1&&(T.splice(m),this._inFlightRequests.set(S,T))}return b}}async _getSession(w,C,R,k,S={}){await this._proxy.$ensureProvider(R);const T=w.displayName||w.name;return this._proxy.$getSession(R,k,C,T,S)}async removeSession(w,C){const R=this._authenticationProviders.get(w);return R?R.provider.removeSession(C):this._proxy.$removeSession(w,C)}registerAuthenticationProvider(w,C,R,k){if(this._authenticationProviders.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this._authenticationProviders.set(w,{label:C,provider:R,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===w)||this._providers.push({id:w,label:C});const S=R.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(w,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(w,C,k?.supportsMultipleAccounts??!1),new D.Disposable(()=>{S.dispose(),this._authenticationProviders.delete(w);const T=this._providers.findIndex(E=>E.id===w);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(w)})}$createSession(w,C){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,C){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,C){const R=this._authenticationProviders.get(w);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,C){return this._onDidChangeSessions.fire({provider:{id:w,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(De[235],Ie([1,0,5,15,16,27]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(w,C){this._proxy=w.getProxy(l.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>C.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,C){const R=(0,P.isProposedApiEnabled)(C,"snippetWorkspaceEdit"),k=D.WorkspaceEdit.from(w,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(k)}};_=qe([xe(0,t.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(De[236],Ie([1,0,5]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(P){const _=P.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(I){return _.$writeText(I)}})}}e.ExtHostClipboard=t});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[37],Ie([1,0,13,7,16,24,5,17,14,80,35,49,2,6,3,15,133,23,55,50]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p){"use strict";var a,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(c,d){a.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,h.set(this,void 0),tt(this,a,c.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=d,tt(this,h,c.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,f=>{const y=this._apiCommands.get(f);return y?.result===r.Void?y:void 0},d),this._argumentProcessors=[{processArgument(f){return(0,C.revive)(f)}},{processArgument(f){return(0,P.cloneAndChange)(f,function(y){if(R.Range.isIRange(y))return D.Range.to(y);if(k.Position.isIPosition(y))return D.Position.to(y);if(R.Range.isIRange(y.range)&&S.URI.isUri(y.uri))return D.location.to(y);if(y instanceof m.VSBuffer)return y.buffer.buffer;if(!Array.isArray(y))return y})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const d=this.registerCommand(!1,c.id,async(...f)=>{const y=c.args.map((M,B)=>{if(!M.validate(f[B]))throw new Error(`Invalid argument '${M.name}' when running '${c.id}', received: ${f[B]}`);return M.convert(f[B])}),L=await this.executeCommand(c.internalId,...y);return c.result.convert(L,f,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,d,f,y,L,M){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:f,thisArg:y,description:L,extension:M}),c&&Ue(this,a,"f").$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&c&&Ue(this,a,"f").$unregisterCommand(d)})}executeCommand(c,...d){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,d,!0)}async _doExecuteCommand(c,d,f){if(this._commands.has(c))return Ue(this,a,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,d,!1);{let y=!1;const L=(0,P.cloneAndChange)(d,function(M){if(M instanceof t.Position)return D.Position.from(M);if(M instanceof t.Range)return D.Range.from(M);if(M instanceof t.Location)return D.location.from(M);if(t.NotebookRange.isNotebookRange(M))return D.NotebookRange.from(M);if(M instanceof ArrayBuffer)return y=!0,m.VSBuffer.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return y=!0,m.VSBuffer.wrap(M);if(M instanceof m.VSBuffer)return y=!0,M;if(!Array.isArray(M))return M});try{const M=await Ue(this,a,"f").$executeCommand(c,y?new v.SerializableObjectWithBuffers(L):L,f);return(0,C.revive)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this._doExecuteCommand(c,d,!1);throw M}}}async _executeContributedCommand(c,d,f){const y=this._commands.get(c);if(!y)throw new Error("Unknown command");this._reportTelemetry(y,c);const{callback:L,thisArg:M,description:B}=y;if(B)for(let A=0;A<B.args.length;A++)try{(0,l.validateConstraint)(d[A],B.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${B.args[A].name}' - ${B.args[A].description}`)}try{return await L.apply(M,d)}catch(A){if(c===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...d);W&&(c=W.command)}throw this._logService.error(A,c,y.extension?.identifier),f?new class extends Error{constructor(){super((0,p.toErrorMessage)(A)),this.id=c,this.source=y.extension?.displayName??y.extension?.name}}:A}}_reportTelemetry(c,d){!c.extension||c.extension.isBuiltin||Ue(this,h,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:d})}$executeContributedCommand(c,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(d=d.map(f=>this._argumentProcessors.reduce((y,L)=>L.processArgument(y),f)),this._executeContributedCommand(c,d,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Ue(this,a,"f").$getCommands().then(d=>(c&&(d=d.filter(f=>f[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[d,f]of this._commands){const{description:y}=f;y&&(c[d]=y)}return Promise.resolve(c)}};a=new WeakMap,h=new WeakMap,i=qe([xe(0,g.IExtHostRpcService),xe(1,w.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class u{constructor(c,d,f){this._commands=c,this._lookupApiCommand=d,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,d){if(!c)return;const f={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return f;const y=this._lookupApiCommand(c.command);if(y)f.id=y.internalId,f.arguments=y.args.map((L,M)=>L.convert(c.arguments&&c.arguments[M]));else if((0,I.isNonEmptyArray)(c.arguments)){const L=++this._cachIdPool;this._cache.set(L,c),d.add((0,T.toDisposable)(()=>{this._cache.delete(L),this._logService.trace("CommandsConverter#DISPOSE",L)})),f.$ident=L,f.id=this.delegatingCommandId,f.arguments=[L],this._logService.trace("CommandsConverter#CREATE",c.command,L)}return f}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const d=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class o{constructor(c,d,f,y){this.name=c,this.description=d,this.validate=f,this.convert=y}optional(){return new o(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,d){return new o(c??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",n=>S.URI.isUri(n),n=>n),o.Position=new o("position","A position in a text document",n=>t.Position.isPosition(n),D.Position.from),o.Range=new o("range","A range in a text document",n=>t.Range.isRange(n),D.Range.from),o.Selection=new o("selection","A selection in a text document",n=>t.Selection.isSelection(n),D.Selection.from),o.Number=new o("number","",n=>typeof n=="number",n=>n),o.String=new o("string","",n=>typeof n=="string",n=>n),o.CallHierarchyItem=new o("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,D.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,D.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",n=>n instanceof b.TestItemImpl,D.TestItem.from);class r{constructor(c,d){this.description=c,this.convert=d}}e.ApiCommandResult=r,r.Void=new r("no result",n=>n);class s{constructor(c,d,f,y,L){this.id=c,this.internalId=d,this.description=f,this.args=y,this.result=L}}e.ApiCommand=s}),define(De[237],Ie([1,0,2,16,7,63,37,17,113,117,12]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const k=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(t.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(g,b)=>{if((0,I.isFalsyOrEmpty)(g))return;class m extends D.SymbolInformation{static to(p){const a=new m(p.name,t.SymbolKind.to(p.kind),p.containerName||"",new D.Location(b[0],t.Range.to(p.range)));return a.detail=p.detail,a.range=a.location.range,a.selectionRange=t.Range.to(p.selectionRange),a.children=p.children?p.children.map(m.to):[],a}}return g.map(m.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",g=>typeof g=="string",g=>g),new _.ApiCommandArgument("options","Formatting options",g=>!0,g=>g)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(t.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(t.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(t.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",g=>Array.isArray(g)&&g.every(b=>D.Position.isPosition(b)),g=>g.map(t.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",g=>g.map(b=>{let m;for(const v of b.reverse())m=new D.SelectionRange(t.Range.to(v),m);return m}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",g=>g.map(t.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",g=>g.map(t.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",g=>{if(!!g)return{range:t.Range.to(g.range),placeholder:g.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",g=>{if(!!g){if(g.rejectReason)throw new Error(g.rejectReason);return t.WorkspaceEdit.to(g)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",g=>g.map(t.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new D.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const b=(0,w.decodeSemanticTokensDto)(g);if(b.type==="full")return new D.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",g=>{if(!!g)return new D.SemanticTokensLegend(g.tokenTypes,g.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",g=>{if(!g)return;const b=(0,w.decodeSemanticTokensDto)(g);if(b.type==="full")return new D.SemanticTokens(b.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(g,b,m)=>{if(!g)return new D.CompletionList([]);const v=g.suggestions.map(p=>t.CompletionItem.to(p,m));return new D.CompletionList(v,g.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",g=>{if(g)return t.SignatureHelp.to(g)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(g,b,m)=>T(v=>new D.CodeLens(t.Range.to(v.range),v.command&&m.fromInternal(v.command)))(g))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",g=>D.Range.isRange(g),g=>D.Selection.isSelection(g)?t.Selection.from(g):t.Range.from(g)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(g,b,m)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return m.fromInternal(v.command)}else{const p=new D.CodeAction(v.title,v.kind?new D.CodeActionKind(v.kind):void 0);return v.edit&&(p.edit=t.WorkspaceEdit.to(v.edit)),v.command&&(p.command=m.fromInternal(v.command)),p.isPreferred=v.isPreferred,p}})(g))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",g=>g?g.map(b=>new D.ColorInformation(t.Range.to(b.range),t.Color.to(b.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",g=>g instanceof D.Color,t.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",g=>!0,g=>({uri:g.uri,range:t.Range.from(g.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",g=>g?g.map(t.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(g,b,m)=>g.map(t.InlayHint.to.bind(void 0,m)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(g=>({viewType:g.viewType,displayName:g.displayName,options:{transientOutputs:g.options.transientOutputs,transientCellMetadata:g.options.transientCellMetadata,transientDocumentMetadata:g.options.transientDocumentMetadata},filenamePattern:g.filenamePattern.map(b=>t.NotebookExclusiveDocumentPattern.to(b))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",g=>g.map(t.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",g=>l.URI.isUri(g)||typeof g=="string"&&(0,C.matchesSomeScheme)(g,R.Schemas.http,R.Schemas.https),g=>g),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="number"||typeof g=="object",g=>g&&(typeof g=="number"?[t.ViewColumn.from(g),void 0]:[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",g=>g===void 0||typeof g=="object",g=>g&&[t.ViewColumn.from(g.viewColumn),t.TextEditorOpenOptions.from(g)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",g=>g.map(t.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class S{static register(b){k.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=S;function T(g){return b=>{if(Array.isArray(b))return b.map(g)}}function E(g){if(!Array.isArray(g))return;const b=[];for(const m of g)P.isLocationLink(m)?b.push(t.DefinitionLink.to(m)):b.push(t.location.to(m));return b}}),define(De[238],Ie([1,0,18,58,4,6,2,63,28,16,7,27,5]),function(J,e,l,t,D,P,_,I,w,C,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(E,g,b){const m=E.getProxy(S.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const c=this._commentControllers.get(n.handle);return c?c.value:n}else if(n&&n.$mid===7){const c=this._commentControllers.get(n.commentControlHandle);if(!c)return n;const d=c.getCommentThread(n.commentThreadHandle);return d?d.value:n}else if(n&&n.$mid===8){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const d=c.getCommentThread(n.thread.commentThreadHandle);return d?{thread:d.value,text:n.text}:n}else if(n&&n.$mid===9){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const d=c.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;const f=n.commentUniqueId,y=d.getCommentByUniqueId(f);return y||n}else if(n&&n.$mid===10){const c=this._commentControllers.get(n.thread.commentControlHandle);if(!c)return n;const d=c.getCommentThread(n.thread.commentThreadHandle);if(!d)return n;const f=n.text,y=n.commentUniqueId,L=d.getCommentByUniqueId(y);return L?(typeof L.body=="string"?L.body=f:L.body.value=f,L):n}return n}})}createCommentController(n,c,d){const f=v.handlePool++,y=new a(n,f,c,d);this._commentControllers.set(y.handle,y);const L=this._commentControllersByExtension.get(w.ExtensionIdentifier.toKey(n.identifier))||[];return L.push(y),this._commentControllersByExtension.set(w.ExtensionIdentifier.toKey(n.identifier),L),y.value}$createCommentThreadTemplate(n,c,d){const f=this._commentControllers.get(n);!f||f.$createCommentThreadTemplate(c,d)}async $updateCommentThreadTemplate(n,c,d){const f=this._commentControllers.get(n);!f||f.$updateCommentThreadTemplate(c,d)}$deleteCommentThread(n,c){this._commentControllers.get(n)?.$deleteCommentThread(c)}$provideCommentingRanges(n,c,d){const f=this._commentControllers.get(n);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const y=b.getDocument(_.URI.revive(c));return(0,l.asPromise)(()=>f.commentingRangeProvider.provideCommentingRanges(y,d)).then(L=>L?L.map(M=>C.Range.from(M)):void 0)}$toggleReaction(n,c,d,f,y){const L=this._commentControllers.get(n);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const M=L.getCommentThread(c);if(M){const B=M.getCommentByUniqueId(f.uniqueIdInThread);if(L!==void 0&&B&&L.reactionHandler)return L.reactionHandler(B,u(y))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class p{constructor(n,c,d,f,y,L,M,B){this._commentControllerHandle=c,this._id=d,this._uri=f,this._range=y,this._comments=L,this.extensionDescription=M,this._isTemplate=B,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),m.$createCommentThread(c,this.handle,this._id,this._uri,C.Range.from(this._range),M.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(c,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(W){A.range=W},get comments(){return A.comments},set comments(W){A.comments=W},get collapsibleState(){return A.collapsibleState},set collapsibleState(W){A.collapsibleState=W},get canReply(){return A.canReply},set canReply(W){A.canReply=W},get contextValue(){return A.contextValue},set contextValue(W){A.contextValue=W},get label(){return A.label},set label(W){A.label=W},get state(){return A.state},set state(W){A.state=W},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get state(){return(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(n){(0,k.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=n,this.modifications.state=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const n=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),c={};n("range")&&(c.range=C.Range.from(this._range)),n("label")&&(c.label=this.label),n("contextValue")&&(c.contextValue=this.contextValue??null),n("comments")&&(c.comments=this._comments.map(d=>h(this,d,this._commentsMap))),n("collapsibleState")&&(c.collapseState=o(this._collapseState)),n("canReply")&&(c.canReply=this.canReply),n("state")&&(c.state=r(this._state)),n("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(n){for(const c of this._commentsMap){const d=c[0],f=c[1];if(n===f)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}p._handlePool=0,qe([(0,t.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(n,c,d,f){this._extension=n,this._handle=c,this._id=d,this._label=f,this._threads=new Map,m.$registerCommentController(this.handle,d,f);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(L){y.options=L},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(L){y.commentingRangeProvider=L},get reactionHandler(){return y.reactionHandler},set reactionHandler(L){y.reactionHandler=L},createCommentThread(L,M,B){return y.createCommentThread(L,M,B).value},dispose:()=>{y.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(n){this._commentingRangeProvider=n,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,c,d,f){if(typeof n=="string"){const y=new p(this.id,this.handle,n,c,d,f,this._extension,!1);return this._threads.set(y.handle,y),y}else{const y=new p(this.id,this.handle,void 0,n,c,d,this._extension,!1);return this._threads.set(y.handle,y),y}}$createCommentThreadTemplate(n,c){const d=new p(this.id,this.handle,void 0,_.URI.revive(n),C.Range.to(c),[],this._extension,!0);return d.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(n,c){const d=this._threads.get(n);d&&(d.range=C.Range.to(c))}$deleteCommentThread(n){this._threads.get(n)?.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(s,n,c){let d=c.get(n);d||(d=++s.commentHandle,c.set(n,d));const f=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:d,body:typeof n.body=="string"?n.body:C.MarkdownString.from(n.body),userName:n.author.name,userIconPath:f,label:n.label,commentReactions:n.reactions?n.reactions.map(y=>i(y)):void 0,timestamp:n.timestamp?.toJSON()}}function i(s){return{label:s.label,iconPath:s.iconPath?C.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function u(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?_.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function o(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}function r(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return I.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return I.CommentThreadState.Resolved}return I.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(De[239],Ie([1,0,24,5,26,15]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(R,k){this._mainThreadConsole=R.getProxy(t.MainContext.MainThreadConsole),this._includeStack=k.consoleForward.includeStack,this._logNative=k.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,k){const S=this,T=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){S._handleConsoleCall(R,k,T,arguments)}})}_handleConsoleCall(R,k,S,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:k,arguments:w(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,S,T)}};_=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const I=1e5;function w(C,R){const k=[];if(C.length)for(let S=0;S<C.length;S++){let T=C[S];if(typeof T>"u")T="undefined";else if(T instanceof Error){const E=T;E.stack?T=E.stack:T=E.toString()}k.push(T)}if(R){const S=new Error().stack;S&&k.push({__$stack:S.split(`
`).slice(3).join(`
`)})}try{const S=(0,l.safeStringify)(k);return S.length>I?"Output omitted for a large object that exceeds the limits":S}catch(S){return`Output omitted for an object that cannot be inspected ('${S.toString()}')`}}}),define(De[135],Ie([1,0,2,5,7,3,15,14,17,8,9]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class Rn{constructor(T,E){this._logService=E,this._provider=new Map,this._proxy=T.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,E){const g=Rn._handlePool++;this._provider.set(g,{provider:T,extensionId:E}),this._proxy.$registerDecorationProvider(g,E.value);const b=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(g,null);return}const v=(0,w.asArray)(m);if(v.length<=Rn._maxEventSize){this._proxy.$onDidChange(g,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",E.value,v.length);const p=v.map(i=>({uri:i,rank:(0,C.count)(i.path,"/")})),a=(0,w.groupBy)(p,(i,u)=>i.rank-u.rank||(0,C.compare)(i.uri.path,u.uri.path)),h=[];e:for(const i of a){let u;for(const o of i){const r=(0,R.dirname)(o.uri.path);if(u!==r&&(u=r,h.push(o.uri)>=Rn._maxEventSize))break e}}this._proxy.$onDidChange(g,h)});return new D.Disposable(()=>{b?.dispose(),this._proxy.$unregisterDecorationProvider(g),this._provider.delete(g)})}async $provideDecorations(T,E,g){if(!this._provider.has(T))return Object.create(null);const b=Object.create(null),{provider:m,extensionId:v}=this._provider.get(T);return await Promise.all(E.map(async p=>{try{const{uri:a,id:h}=p,i=await Promise.resolve(m.provideFileDecoration(l.URI.revive(a),g));if(!i)return;try{D.FileDecoration.validate(i),b[h]=[i.propagate,i.tooltip,i.badge,i.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(a){this._logService.error(a)}})),b}};k._handlePool=0,k._maxEventSize=250,k=qe([xe(0,_.IExtHostRpcService),xe(1,I.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[240],Ie([1,0,169,116,2,5,7,16,4,14,25,46]),function(J,e,l,t,D,P,_,I,w,C,R,k){"use strict";var S,T,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class g{constructor(v,p,a,h,i,u){this._name=v,this._owner=p,this._maxDiagnosticsPerFile=a,S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),this._isDisposed=!1,tt(this,E,new R.ResourceMap(o=>h.getComparisonKey(o)),"f"),tt(this,S,i,"f"),tt(this,T,u,"f")}dispose(){this._isDisposed||(Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,S,"f")?.$clear(this._owner),Ue(this,E,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,p){if(!v){this.clear();return}this._checkDisposed();let a=[];if(D.URI.isUri(v)){if(!p){this.delete(v);return}Ue(this,E,"f").set(v,p.slice()),a=[v]}else if(Array.isArray(v)){a=[];let i;v=[...v].sort(g._compareIndexedTuplesByUri);for(const u of v){const[o,r]=u;if((!i||o.toString()!==i.toString())&&(i&&Ue(this,E,"f").get(i).length===0&&Ue(this,E,"f").delete(i),i=o,a.push(o),Ue(this,E,"f").set(o,[])),r)Ue(this,E,"f").get(o)?.push(...r);else{const s=Ue(this,E,"f").get(o);s&&(s.length=0)}}}if(Ue(this,T,"f").fire(a),!Ue(this,S,"f"))return;const h=[];for(const i of a){let u=[];const o=Ue(this,E,"f").get(i);if(o)if(o.length>this._maxDiagnosticsPerFile){u=[];const r=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const n of o)if(n.severity===r[s]&&u.push(I.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:t.MarkerSeverity.Info,message:(0,l.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=o.map(r=>I.Diagnostic.from(r));h.push([i,u])}Ue(this,S,"f").$changeMany(this._owner,h)}delete(v){this._checkDisposed(),Ue(this,T,"f").fire([v]),Ue(this,E,"f").delete(v),Ue(this,S,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Ue(this,T,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,S,"f")?.$clear(this._owner)}forEach(v,p){this._checkDisposed();for(const[a,h]of this)v.call(p,a,h,this)}*[(S=new WeakMap,T=new WeakMap,E=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Ue(this,E,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const p=Ue(this,E,"f").get(v);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Ue(this,E,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,p){return v[0].toString()<p[0].toString()?-1:v[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=g;let b=class mn{constructor(v,p,a){this._logService=p,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new w.DebounceEmitter({merge:h=>h.flat(),delay:50}),this.onDidChangeDiagnostics=w.Event.map(this._onDidChangeDiagnostics.event,mn._mapper),this._proxy=v.getProxy(P.MainContext.MainThreadDiagnostics)}static _mapper(v){const p=new R.ResourceMap;for(const a of v)p.set(a,a);return{uris:Object.freeze(Array.from(p.values()))}}createDiagnosticCollection(v,p){const{_collections:a,_proxy:h,_onDidChangeDiagnostics:i,_logService:u,_fileSystemInfoService:o}=this,r=new class{$changeMany(c,d){h.$changeMany(c,d),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,c,d.length===0?"CLEARING":d)}$clear(c){h.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,c)}dispose(){h.dispose()}};let s;if(!p)p="_generated_diagnostic_collection_name_#"+mn._idPool++,s=p;else if(!a.has(p))s=p;else{this._logService.warn(`DiagnosticCollection with name '${p}' does already exist.`);do s=p+mn._idPool++;while(a.has(s))}return new class extends g{constructor(){super(p,s,mn._maxDiagnosticsPerFile,o.extUri,r,i),a.set(s,this)}dispose(){super.dispose(),a.delete(s)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const p=new Map,a=[];for(const h of this._collections.values())h.forEach((i,u)=>{let o=p.get(i.toString());typeof o>"u"&&(o=a.length,p.set(i.toString(),o),a.push([i,[]])),a[o][1]=a[o][1].concat(...u)});return a}}_getDiagnostics(v){let p=[];for(const a of this._collections.values())a.has(v)&&(p=p.concat(a.get(v)));return p}$acceptMarkersChange(v){if(!this._mirrorCollection){const p="_generated_mirror",a=new g(p,p,mn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(p,a),this._mirrorCollection=a}for(const[p,a]of v)this._mirrorCollection.set(D.URI.revive(p),a.map(I.Diagnostic.to))}};b._idPool=0,b._maxDiagnosticsPerFile=1e3,b=qe([xe(1,C.ILogService),xe(2,k.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(De[241],Ie([1,0,2,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(_){this._proxy=_.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(I=>I?I.map(w=>l.URI.revive(w)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(I=>I?l.URI.revive(I):void 0)}}e.ExtHostDialogs=D}),define(De[242],Ie([1,0,10,2,7,5,12,21,8]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(k,S,T){this._documentsAndEditors=S,this._logService=T,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,S){if(Object.keys(_.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=C._handlePool++;this._documentContentProviders.set(T,S),this._proxy.$registerTextContentProvider(T,k);let E;return typeof S.onDidChange=="function"&&(E=S.onDidChange(g=>{if(g.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(g)&&this.$provideTextDocumentContent(T,g).then(b=>{if(!b&&typeof b!="string")return;const m=this._documentsAndEditors.getDocument(g);if(!m)return;const v=(0,w.splitLines)(b);if(!m.equalLines(v))return this._proxy.$onVirtualDocumentChange(g,b)},l.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(k,S){const T=this._documentContentProviders.get(k);return T?Promise.resolve(T.provideTextDocumentContent(t.URI.revive(S),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${S.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(De[243],Ie([1,0,4,6,2,5,131,16,13,24,7]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,E){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=E,this._documentsAndEditors.onDidRemoveDocuments(g=>{for(const b of g)this._onDidRemoveDocument.fire(b.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(g=>{for(const b of g)this._onDidAddDocument.fire(b.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const E=this._documentsAndEditors.getDocument(T);if(E)return E}getDocument(T){const E=this.getDocumentData(T);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return E.document}ensureDocumentData(T){const E=this._documentsAndEditors.getDocument(T);if(E)return Promise.resolve(E);let g=this._documentLoader.get(T.toString());return g||(g=this._proxy.$tryOpenDocument(T).then(b=>{this._documentLoader.delete(T.toString());const m=D.URI.revive(b);return(0,w.assertIsDefined)(this._documentsAndEditors.getDocument(m))},b=>(this._documentLoader.delete(T.toString()),Promise.reject(b))),this._documentLoader.set(T.toString(),g)),g}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(E=>D.URI.revive(E))}$acceptModelLanguageChanged(T,E){const g=D.URI.revive(T),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");this._onDidRemoveDocument.fire(b.document),b._acceptLanguageId(E),this._onDidAddDocument.fire(b.document)}$acceptModelSaved(T){const E=D.URI.revive(T),g=this._documentsAndEditors.getDocument(E);if(!g)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(g.document)}$acceptDirtyStateChanged(T,E){const g=D.URI.revive(T),b=this._documentsAndEditors.getDocument(g);if(!b)throw new Error("unknown document");b._acceptIsDirty(E),this._onDidChangeDocument.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,E,g){const b=D.URI.revive(T),m=this._documentsAndEditors.getDocument(b);if(!m)throw new Error("unknown document");m._acceptIsDirty(g),m.onEvents(E);let v;E.isUndoing?v=R.TextDocumentChangeReason.Undo:E.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:m.document,contentChanges:E.changes.map(p=>({range:I.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:v}))}setWordDefinitionFor(T,E){(0,_.setWordDefinitionFor)(T,E)}}e.ExtHostDocuments=k}),define(De[56],Ie([1,0,48,4,6,2,3,5,131,15,134,16,14,25,12,60,77]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(a,h){this._extHostRpc=a,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],i=[],u=[];if(a.removedDocuments)for(const o of a.removedDocuments){const r=P.URI.revive(o),s=this._documents.get(r);s?.unref()&&(this._documents.delete(r),h.push(s.value))}if(a.addedDocuments)for(const o of a.addedDocuments){const r=P.URI.revive(o.uri);let s=this._documents.get(r);if(s&&r.scheme!==E.Schemas.vscodeNotebookCell&&r.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);s||(s=new m(new w.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),r,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(r,s),i.push(s.value)),s.ref()}if(a.removedEditors)for(const o of a.removedEditors){const r=this._editors.get(o);this._editors.delete(o),r&&u.push(r)}if(a.addedEditors)for(const o of a.addedEditors){const r=P.URI.revive(o.documentUri);l.ok(this._documents.has(r),`document '${r}' does not exist`),l.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const s=this._documents.get(r).value,n=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new b.Lazy(()=>s.document),o.selections.map(k.Selection.to),o.options,o.visibleRanges.map(c=>k.Range.to(c)),typeof o.editorPosition=="number"?k.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,n)}a.newActiveEditor!==void 0&&(l.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,D.dispose)(h),(0,D.dispose)(u),a.removedDocuments&&this._onDidRemoveDocuments.fire(h),a.addedDocuments&&this._onDidAddDocuments.fire(i),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return g.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const h=this._editors.get(this._activeEditorId);return a?h:h?.value}allEditors(){return[...this._editors.values()]}};v=qe([xe(0,C.IExtHostRpcService),xe(1,S.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[57],Ie([1,0,16,5,2,4,3,7,15,13,76]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class k{constructor(b,m,v){this._activeTabIdGetter=v,this._parentGroup=m,this.acceptDtoUpdate(b)}get apiObject(){if(!this._apiObject){const b=this,m={get isActive(){return b._dto.id===b._activeTabIdGetter()},get label(){return b._dto.label},get input(){return b._input},get isDirty(){return b._dto.isDirty},get isPinned(){return b._dto.isPinned},get isPreview(){return b._dto.isPreview},get group(){return b._parentGroup.apiObject}};this._apiObject=Object.freeze(m)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(b){this._dto=b,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new I.TextTabInput(D.URI.revive(this._dto.input.uri));case 2:return new I.TextDiffTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified));case 3:return new I.TextMergeTabInput(D.URI.revive(this._dto.input.base),D.URI.revive(this._dto.input.input1),D.URI.revive(this._dto.input.input2),D.URI.revive(this._dto.input.result));case 6:return new I.CustomEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new I.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new I.NotebookEditorTabInput(D.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new I.NotebookDiffEditorTabInput(D.URI.revive(this._dto.input.original),D.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new I.TerminalEditorTabInput;case 9:return new I.InteractiveWindowInput(D.URI.revive(this._dto.input.uri),D.URI.revive(this._dto.input.inputBoxUri));default:return}}}class S{constructor(b,m){this._tabs=[],this._activeTabId="",this._dto=b,this._activeGroupIdGetter=m;for(const v of b.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new k(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const b=this,m={get isActive(){return b._dto.groupId===b._activeGroupIdGetter()},get viewColumn(){return l.ViewColumn.to(b._dto.viewColumn)},get activeTab(){return b._tabs.find(v=>v.tabId===b._activeTabId)?.apiObject},get tabs(){return Object.freeze(b._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(m)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(b){this._dto=b}acceptTabOperation(b){if(b.kind===0){const v=new k(b.tabDto,this,()=>this.activeTabId());return this._tabs.splice(b.index,0,v),b.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(b.kind===1){const v=this._tabs.splice(b.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(b.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this._tabs.splice(b.index,0,v),v}const m=this._tabs.find(v=>v.tabId===b.tabDto.id);if(!m)throw new Error("INVALID tab");return b.tabDto.isActive?this._activeTabId=b.tabDto.id:this._activeTabId===b.tabDto.id&&!b.tabDto.isActive&&(this._activeTabId=""),m.acceptDtoUpdate(b.tabDto),m}activeTabId(){return this._activeTabId}}let T=class{constructor(b){this._onDidChangeTabs=new P.Emitter,this._onDidChangeTabGroups=new P.Emitter,this._extHostTabGroups=[],this._proxy=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const b=this,m={onDidChangeTabGroups:b._onDidChangeTabGroups.event,onDidChangeTabs:b._onDidChangeTabs.event,get all(){return Object.freeze(b._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=b._activeGroupId;return(0,C.assertIsDefined)(b._extHostTabGroups.find(a=>a.groupId===v)?.apiObject)},close:async(v,p)=>{const a=Array.isArray(v)?v:[v];return a.length?E(a[0])?this._closeGroups(a,p):this._closeTabs(a,p):!0}};this._apiObject=Object.freeze(m)}return this._apiObject}$acceptEditorTabModel(b){const m=new Set(this._extHostTabGroups.map(o=>o.groupId)),v=new Set(b.map(o=>o.groupId)),p=(0,R.diffSets)(m,v),a=this._extHostTabGroups.filter(o=>p.removed.includes(o.groupId)).map(o=>o.apiObject),h=[],i=[];this._extHostTabGroups=b.map(o=>{const r=new S(o,()=>this._activeGroupId);return p.added.includes(r.groupId)?h.push(r.apiObject):i.push(r.apiObject),r});const u=(0,C.assertIsDefined)(b.find(o=>o.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:h,closed:a,changed:i}))}$acceptTabGroupUpdate(b){const m=this._extHostTabGroups.find(v=>v.groupId===b.groupId);if(!m)throw new Error("Update Group IPC call received before group creation.");m.acceptGroupDtoUpdate(b),b.isActive&&(this._activeGroupId=b.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[m.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const m=this._extHostTabGroups.find(p=>p.groupId===b.groupId);if(!m)throw new Error("Update Tabs IPC call received before group creation.");const v=m.acceptTabOperation(b);switch(b.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(b){for(const m of this._extHostTabGroups)for(const v of m.tabs)if(v.apiObject===b)return v}_findExtHostTabGroupFromApi(b){return this._extHostTabGroups.find(m=>m.apiObject===b)}async _closeTabs(b,m){const v=[];for(const p of b){const a=this._findExtHostTabFromApi(p);if(!a)throw new Error("Tab close: Invalid tab not found!");v.push(a.tabId)}return this._proxy.$closeTab(v,m)}async _closeGroups(b,m){const v=[];for(const p of b){const a=this._findExtHostTabGroupFromApi(p);if(!a)throw new Error("Group close: Invalid group not found!");v.push(a.groupId)}return this._proxy.$closeGroup(v,m)}};T=qe([xe(0,w.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function E(g){return g.tabs!==void 0}}),define(De[244],Ie([1,0,2,5,6,7,16,149,8,23,27]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this._schemes=[]}add(E){this._stateMachine=void 0,this._schemes.push(E)}delete(E){const g=this._schemes.indexOf(E);g>=0&&(this._schemes.splice(g,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const E=this._schemes.sort(),g=[];let b,m,v=14,p=14;for(const a of E){let h=b?(0,w.commonPrefixLength)(b,a):0;for(h===0?m=1:m=p;h<a.length;h++)h+1===a.length?(v=p,p=9):p+=1,g.push([m,a.toUpperCase().charCodeAt(h),p]),g.push([m,a.toLowerCase().charCodeAt(h),p]),m=p;b=a,p=v}g.push([9,58,10]),g.push([10,47,12]),this._stateMachine=new I.StateMachine(g)}}provideDocumentLinks(E){this._initStateMachine();const g=[],b=I.LinkComputer.computeLinks({getLineContent(m){return E.lineAt(m-1).text},getLineCount(){return E.lineCount}},this._stateMachine);for(const m of b){const v=_.DocumentLink.to(m);v.target&&g.push(v)}return g}}class S{constructor(E,g){this._extHostLanguageFeatures=g,this._linkProvider=new k,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(E,g,b,m={}){if(this._registeredSchemes.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(E,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(g),this._registeredSchemes.add(g),this._fsProvider.set(v,b);let p=2;m.isCaseSensitive&&(p+=1024),m.isReadonly&&(p+=2048),typeof b.copy=="function"&&(p+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,R.checkProposedApiEnabled)(E,"fsChunks"),p+=4),this._proxy.$registerFileSystemProvider(v,g,p).catch(h=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${g}`),console.error(h)});const a=b.onDidChangeFile(h=>{const i=[];for(const u of h){const{uri:o,type:r}=u;if(o.scheme!==g)continue;let s;switch(r){case P.FileChangeType.Changed:s=0;break;case P.FileChangeType.Created:s=1;break;case P.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:o,type:s})}this._proxy.$onFileSystemChange(v,i)});return(0,D.toDisposable)(()=>{a.dispose(),this._linkProvider.delete(g),this._registeredSchemes.delete(g),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(E){const{type:g,ctime:b,mtime:m,size:v,permissions:p}=E;return{type:g,ctime:b,mtime:m,size:v,permissions:p}}$stat(E,g){return Promise.resolve(this._getFsProvider(E).stat(l.URI.revive(g))).then(b=>S._asIStat(b))}$readdir(E,g){return Promise.resolve(this._getFsProvider(E).readDirectory(l.URI.revive(g)))}$readFile(E,g){return Promise.resolve(this._getFsProvider(E).readFile(l.URI.revive(g))).then(b=>C.VSBuffer.wrap(b))}$writeFile(E,g,b,m){return Promise.resolve(this._getFsProvider(E).writeFile(l.URI.revive(g),b.buffer,m))}$delete(E,g,b){return Promise.resolve(this._getFsProvider(E).delete(l.URI.revive(g),b))}$rename(E,g,b,m){return Promise.resolve(this._getFsProvider(E).rename(l.URI.revive(g),l.URI.revive(b),m))}$copy(E,g,b,m){const v=this._getFsProvider(E);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(g),l.URI.revive(b),m))}$mkdir(E,g){return Promise.resolve(this._getFsProvider(E).createDirectory(l.URI.revive(g)))}$watch(E,g,b,m){const v=this._getFsProvider(E).watch(l.URI.revive(b),m);this._watches.set(g,v)}$unwatch(E,g){const b=this._watches.get(g);b&&(b.dispose(),this._watches.delete(g))}$open(E,g,b){const m=this._getFsProvider(E);if(!m.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(m.open(l.URI.revive(g),b))}$close(E,g){const b=this._getFsProvider(E);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(g))}$read(E,g,b,m){const v=this._getFsProvider(E);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const p=C.VSBuffer.alloc(m);return Promise.resolve(v.read(g,b,p.buffer,0,m)).then(a=>p.slice(0,a))}$write(E,g,b,m){const v=this._getFsProvider(E);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(g,b,m.buffer,0,m.byteLength))}_getFsProvider(E){const g=this._fsProvider.get(E);if(!g){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return g}}e.ExtHostFileSystem=S}),define(De[67],Ie([1,0,5,42,7,23,3,15,46,6]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Xt{constructor(S,T){this._fileSystemProvider=new Map,this._proxy=S.getProxy(l.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(g){try{const b=E._fileSystemProvider.get(g.scheme);if(!b)return await E._proxy.$stat(g);await E._proxy.$ensureActivation(g.scheme);const m=await b.stat(g);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions}}catch(b){Xt._handleError(b)}},async readDirectory(g){try{const b=E._fileSystemProvider.get(g.scheme);return b?(await E._proxy.$ensureActivation(g.scheme),(await b.readDirectory(g)).slice()):await E._proxy.$readdir(g)}catch(b){return Xt._handleError(b)}},async createDirectory(g){try{return await E._proxy.$mkdir(g)}catch(b){return Xt._handleError(b)}},async readFile(g){try{const b=E._fileSystemProvider.get(g.scheme);return b?(await E._proxy.$ensureActivation(g.scheme),(await b.readFile(g)).slice()):(await E._proxy.$readFile(g)).buffer}catch(b){return Xt._handleError(b)}},async writeFile(g,b){try{return await E._proxy.$writeFile(g,P.VSBuffer.wrap(b))}catch(m){return Xt._handleError(m)}},async delete(g,b){try{const m=E._fileSystemProvider.get(g.scheme);return m?(await E._proxy.$ensureActivation(g.scheme),await m.delete(g,{recursive:!1,...b})):await E._proxy.$delete(g,{recursive:!1,useTrash:!1,...b})}catch(m){return Xt._handleError(m)}},async rename(g,b,m){try{return await E._proxy.$rename(g,b,{overwrite:!1,...m})}catch(v){return Xt._handleError(v)}},async copy(g,b,m){try{return await E._proxy.$copy(g,b,{overwrite:!1,...m})}catch(v){return Xt._handleError(v)}},isWritableFileSystem(g){const b=T.getCapabilities(g);if(typeof b=="number")return!(b&2048)}})}static _handleError(S){if(S instanceof D.FileSystemError)throw S;if(!(S instanceof Error))throw new D.FileSystemError(String(S));if(S.name==="ENOPRO")throw D.FileSystemError.Unavailable(S.message);switch(S.name){case t.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(S.message);case t.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(S.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(S.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(S.message);case t.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(S.message);case t.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(S.message);default:throw new D.FileSystemError(S.message,S.name)}}addFileSystemProvider(S,T){return this._fileSystemProvider.set(S,T),(0,C.toDisposable)(()=>this._fileSystemProvider.delete(S))}};R=qe([xe(0,I.IExtHostRpcService),xe(1,w.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(De[245],Ie([1,0,4,36,2,5,16,7,27]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(S,T,E,g,b,m,v,p){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter;const a=this.ensureWatching(S,E,b);this._config=0,m&&(this._config+=1),v&&(this._config+=2),p&&(this._config+=4);const h=(0,t.parse)(b),i=typeof b=="string",u=g(o=>{if(!m)for(const r of o.created){const s=D.URI.revive(r);h(s.fsPath)&&(!i||T.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!v)for(const r of o.changed){const s=D.URI.revive(r);h(s.fsPath)&&(!i||T.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!p)for(const r of o.deleted){const s=D.URI.revive(r);h(s.fsPath)&&(!i||T.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=I.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(S,T,E){const g=I.Disposable.from();if(typeof E=="string")return g;const b=S.getProxy(P.MainContext.MainThreadFileSystem);let m=!1;(E.pattern.includes(t.GLOBSTAR)||E.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const v=Math.random();return b.$watch(T.identifier.value,v,E.baseUri,{recursive:m,excludes:[]}),I.Disposable.from({dispose:()=>b.$unwatch(v)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(S,T,E){this._mainContext=S,this._logService=T,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(S,T,E,g,b,m){return new C(this._mainContext,S,T,this._onFileSystemEvent.event,_.GlobPattern.from(E),g,b,m)}$onFileEvent(S){this._onFileSystemEvent.fire(S)}$onDidRunFileOperation(S,T){switch(S){case 2:this._onDidRenameFile.fire(Object.freeze({files:T.map(E=>({oldUri:D.URI.revive(E.source),newUri:D.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:T.map(E=>D.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:T.map(E=>D.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(S){return this._createWillExecuteEvent(S,this._onWillRenameFile)}getOnWillCreateFileEvent(S){return this._createWillExecuteEvent(S,this._onWillCreateFile)}getOnWillDeleteFileEvent(S){return this._createWillExecuteEvent(S,this._onWillDeleteFile)}_createWillExecuteEvent(S,T){return(E,g,b)=>{const m=function(p){E.call(g,p)};return m.extension=S,T.event(m,void 0,b)}}async $onWillRunFileOperation(S,T,E,g){switch(S){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:T.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))},E,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:T.map(b=>D.URI.revive(b.target))},E,g);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:T.map(b=>D.URI.revive(b.target))},E,g)}}async _fireWillEvent(S,T,E,g){const b=new Set,m=[];if(await S.fireAsync(T,g,async(p,a)=>{const h=Date.now(),i=await Promise.resolve(p);i instanceof I.WorkspaceEdit&&(m.push([a.extension,i]),b.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-h>E&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||m.length===0)return;const v={edits:[]};for(const[p,a]of m){const{edits:h}=_.WorkspaceEdit.from(a,{getTextDocumentVersion:i=>this._extHostDocumentsAndEditors.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}},(0,w.isProposedApiEnabled)(p,"snippetWorkspaceEdit"));v.edits=v.edits.concat(h)}return{edit:v,extensionNames:Array.from(b)}}}e.ExtHostFileSystemEventService=R}),define(De[246],Ie([1,0,2,37]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(_,I,w,C,R){this._extHostNotebooks=I,this._textDocumentsAndEditors=w,this._commands=C;const k=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",S=>!0,S=>S),new t.ApiCommandArgument("resource","Interactive resource Uri",S=>!0,S=>S),new t.ApiCommandArgument("controllerId","Notebook controller Id",S=>!0,S=>S),new t.ApiCommandArgument("title","Interactive editor title",S=>!0,S=>S)],new t.ApiCommandResult("Notebook and input URI",S=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",S.notebookEditorId),S.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(S.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri),notebookEditor:T.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",S.notebookUri,S.inputUri),{notebookUri:l.URI.revive(S.notebookUri),inputUri:l.URI.revive(S.inputUri)}}));this._commands.registerApiCommand(k)}$willAddInteractiveDocument(_,I,w,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:w,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=D}),define(De[247],Ie([1,0,6,5]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(_){this._handlePool=0,this._proxy=_.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,_),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=D}),define(De[248],Ie([1,0,2,24,16,7,63,5,8,35,17,13,145,21,6,113,93,87,51,10,18,27]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentSymbols(F,H){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentSymbols(K,H);if(!(0,R.isFalsyOrEmpty)(X))return X[0]instanceof P.DocumentSymbol?X.map(D.DocumentSymbol.from):i._asDocumentSymbolTree(X)}static _asDocumentSymbolTree(F){F=F.slice(0).sort((X,de)=>{let we=X.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(X.location.range.end)),we});const H=[],K=[];for(const X of F){const de={name:X.name||"!!MISSING: name!!",kind:D.SymbolKind.from(X.kind),tags:X.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:D.Range.from(X.location.range),selectionRange:D.Range.from(X.location.range),children:[]};for(;;){if(K.length===0){K.push(de),H.push(de);break}const we=K[K.length-1];if(C.Range.containsRange(we.range,de.range)&&!C.Range.equalsRange(we.range,de.range)){we.children?.push(de),K.push(de);break}K.pop()}}return H}}class u{constructor(F,H,K){this._documents=F,this._commands=H,this._provider=K,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(F,H){const K=this._documents.getDocument(F),X=await this._provider.provideCodeLenses(K,H);if(!X||H.isCancellationRequested)return;const de=this._cache.add(X),we=new E.DisposableStore;this._disposables.set(de,we);const ce={cacheId:de,lenses:[]};for(let Ce=0;Ce<X.length;Ce++)ce.lenses.push({cacheId:[de,Ce],range:D.Range.from(X[Ce].range),command:this._commands.toInternal(X[Ce].command,we)});return ce}async resolveCodeLens(F,H){const K=F.cacheId&&this._cache.get(...F.cacheId);if(!K)return;let X;if(typeof this._provider.resolveCodeLens!="function"||K.isResolved?X=K:X=await this._provider.resolveCodeLens(K,H),X||(X=K),H.isCancellationRequested)return;const de=F.cacheId&&this._disposables.get(F.cacheId[0]);if(!!de)return F.command=this._commands.toInternal(X.command??u._badCmd,de),F}releaseCodeLenses(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(ie){return Array.isArray(ie)?ie.map(D.DefinitionLink.from):ie?[D.DefinitionLink.from(ie)]:[]}class r{constructor(F,H){this._documents=F,this._provider=H}async provideDefinition(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideDefinition(X,de,K);return o(we)}}class s{constructor(F,H){this._documents=F,this._provider=H}async provideDeclaration(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideDeclaration(X,de,K);return o(we)}}class n{constructor(F,H){this._documents=F,this._provider=H}async provideImplementation(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideImplementation(X,de,K);return o(we)}}class c{constructor(F,H){this._documents=F,this._provider=H}async provideTypeDefinition(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideTypeDefinition(X,de,K);return o(we)}}class d{constructor(F,H){this._documents=F,this._provider=H}async provideHover(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideHover(X,de,K);if(!(!we||(0,R.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=X.getWordRangeAtPosition(de)),we.range||(we.range=new P.Range(de,de)),D.Hover.from(we)}}class f{constructor(F,H){this._documents=F,this._provider=H}async provideEvaluatableExpression(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideEvaluatableExpression(X,de,K);if(we)return D.EvaluatableExpression.from(we)}}class y{constructor(F,H){this._documents=F,this._provider=H}async provideInlineValues(F,H,K,X){const de=this._documents.getDocument(F),we=await this._provider.provideInlineValues(de,D.Range.to(H),D.InlineValueContext.to(K),X);if(Array.isArray(we))return we.map(ce=>D.InlineValue.from(ce))}}class L{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentHighlights(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideDocumentHighlights(X,de,K);if(Array.isArray(we))return we.map(D.DocumentHighlight.from)}}class M{constructor(F,H){this._documents=F,this._provider=H}async provideLinkedEditingRanges(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.provideLinkedEditingRanges(X,de,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,R.coalesce)(we.ranges.map(D.Range.from)),wordPattern:we.wordPattern}}}class B{constructor(F,H){this._documents=F,this._provider=H}async provideReferences(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H),ce=await this._provider.provideReferences(de,we,K,X);if(Array.isArray(ce))return ce.map(D.location.from)}}class A{constructor(F,H,K,X,de,we,ce){this._documents=F,this._commands=H,this._diagnostics=K,this._provider=X,this._logService=de,this._extension=we,this._apiDeprecation=ce,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(F,H,K,X){const de=this._documents.getDocument(F),we=S.Selection.isISelection(H)?D.Selection.to(H):D.Range.to(H),ce=[];for(const Ye of this._diagnostics.getDiagnostics(F))if(we.intersection(Ye.range)&&ce.push(Ye)>A._maxCodeActionsPerFile)break;const Ce={diagnostics:ce,only:K.only?new P.CodeActionKind(K.only):void 0,triggerKind:D.CodeActionTriggerKind.to(K.trigger)},ye=await this._provider.provideCodeActions(de,we,Ce,X);if(!(0,R.isNonEmptyArray)(ye)||X.isCancellationRequested)return;const $e=this._cache.add(ye),Ve=new E.DisposableStore;this._disposables.set($e,Ve);const Ze=[];for(let Ye=0;Ye<ye.length;Ye++){const Oe=ye[Ye];!Oe||(A._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,Ve)})):(Ce.only&&(Oe.kind?Ce.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[$e,Ye],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,Ve),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(D.Diagnostic.from),edit:Oe.edit&&D.WorkspaceEdit.from(Oe.edit,void 0,(0,h.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:Oe.disabled?.reason})))}return{cacheId:$e,actions:Ze}}async resolveCodeAction(F,H){const[K,X]=F,de=this._cache.get(K,X);if(!de||A._isCommand(de)||!this._provider.resolveCodeAction)return;const we=await this._provider.resolveCodeAction(de,H)??de;return we?.edit?D.WorkspaceEdit.from(we.edit,void 0,(0,h.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}static _isCommand(F){return typeof F.command=="string"&&typeof F.title=="string"}}A._maxCodeActionsPerFile=1e3;class W{constructor(F,H,K,X){this._proxy=F,this._documents=H,this._provider=K,this._handle=X}async prepareDocumentPaste(F,H,K,X){if(!this._provider.prepareDocumentPaste)return;const de=this._documents.getDocument(F),we=H.map(Ce=>D.Range.to(Ce)),ce=D.DataTransfer.toDataTransfer(K,()=>{throw new p.NotImplementedError});return await this._provider.prepareDocumentPaste(de,we,ce,X),D.DataTransfer.toDataTransferDTO(ce)}async providePasteEdits(F,H,K,X,de){const we=this._documents.getDocument(H),ce=K.map($e=>D.Range.to($e)),Ce=D.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolvePasteFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentPasteEdits(we,ce,Ce,de);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class U{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentFormattingEdits(F,H,K){const X=this._documents.getDocument(F),de=await this._provider.provideDocumentFormattingEdits(X,H,K);if(Array.isArray(de))return de.map(D.TextEdit.from)}}class N{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeFormattingEdits(F,H,K,X){const de=this._documents.getDocument(F),we=D.Range.to(H),ce=await this._provider.provideDocumentRangeFormattingEdits(de,we,K,X);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class G{constructor(F,H){this._documents=F,this._provider=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,H,K,X,de){const we=this._documents.getDocument(F),ce=D.Position.to(H),Ce=await this._provider.provideOnTypeFormattingEdits(we,ce,K,X,de);if(Array.isArray(Ce))return Ce.map(D.TextEdit.from)}}class z{constructor(F,H){this._provider=F,this._logService=H,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,H){const K=await this._provider.provideWorkspaceSymbols(F,H);if(!(0,R.isNonEmptyArray)(K))return{symbols:[]};const X=this._cache.add(K),de={cacheId:X,symbols:[]};for(let we=0;we<K.length;we++){const ce=K[we];if(!ce||!ce.name){this._logService.warn("INVALID SymbolInformation",ce);continue}de.symbols.push({...D.WorkspaceSymbol.from(ce),cacheId:[X,we]})}return de}async resolveWorkspaceSymbol(F,H){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const K=this._cache.get(...F.cacheId);if(K){const X=await this._provider.resolveWorkspaceSymbol(K,H);return X&&(0,t.mixin)(F,D.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(F){this._cache.delete(F)}}class O{constructor(F,H,K){this._documents=F,this._provider=H,this._logService=K}static supportsResolving(F){return typeof F.prepareRename=="function"}async provideRenameEdits(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H);try{const ce=await this._provider.provideRenameEdits(de,we,K,X);return ce?D.WorkspaceEdit.from(ce):void 0}catch(ce){const Ce=O._asMessage(ce);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,H,K){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const X=this._documents.getDocument(F),de=D.Position.to(H);try{const we=await this._provider.prepareRename(X,de,K);let ce,Ce;if(P.Range.isRange(we)?(ce=we,Ce=X.getText(we)):(0,k.isObject)(we)&&(ce=we.range,Ce=we.placeholder),!ce||!Ce)return;if(ce.start.line>de.line||ce.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ce),text:Ce}}catch(we){const ce=O._asMessage(we);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(we)}}static _asMessage(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class x{constructor(F,H){this.resultId=F,this.tokens=H}}class V{constructor(F,H){this._documents=F,this._provider=H,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(F,H,K){const X=this._documents.getDocument(F),de=H!==0?this._previousResults.get(H):null;let we=typeof de?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(X,de.resultId,K):await this._provider.provideDocumentSemanticTokens(X,K);return de&&this._previousResults.delete(H),we?(we=V._fixProvidedSemanticTokens(we),this._send(V._convertToEdits(de,we),we)):null}async releaseDocumentSemanticColoring(F){this._previousResults.delete(F)}static _fixProvidedSemanticTokens(F){return V._isSemanticTokens(F)?V._isCorrectSemanticTokens(F)?F:new P.SemanticTokens(new Uint32Array(F.data),F.resultId):V._isSemanticTokensEdits(F)?V._isCorrectSemanticTokensEdits(F)?F:new P.SemanticTokensEdits(F.edits.map(H=>new P.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),F.resultId):F}static _isSemanticTokens(F){return F&&!!F.data}static _isCorrectSemanticTokens(F){return F.data instanceof Uint32Array}static _isSemanticTokensEdits(F){return F&&Array.isArray(F.edits)}static _isCorrectSemanticTokensEdits(F){for(const H of F.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(F,H){if(!V._isSemanticTokens(H)||!F||!F.tokens)return H;const K=F.tokens,X=K.length,de=H.data,we=de.length;let ce=0;const Ce=Math.min(X,we);for(;ce<Ce&&K[ce]===de[ce];)ce++;if(ce===X&&ce===we)return new P.SemanticTokensEdits([],H.resultId);let ye=0;const $e=Ce-ce;for(;ye<$e&&K[X-ye-1]===de[we-ye-1];)ye++;return new P.SemanticTokensEdits([{start:ce,deleteCount:X-ce-ye,data:de.subarray(ce,we-ye)}],H.resultId)}_send(F,H){if(V._isSemanticTokens(F)){const K=this._nextResultId++;return this._previousResults.set(K,new x(F.resultId,F.data)),(0,g.encodeSemanticTokensDto)({id:K,type:"full",data:F.data})}if(V._isSemanticTokensEdits(F)){const K=this._nextResultId++;return V._isSemanticTokens(H)?this._previousResults.set(K,new x(H.resultId,H.data)):this._previousResults.set(K,new x(F.resultId)),(0,g.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(F.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class q{constructor(F,H){this._documents=F,this._provider=H}async provideDocumentRangeSemanticTokens(F,H,K){const X=this._documents.getDocument(F),de=await this._provider.provideDocumentRangeSemanticTokens(X,D.Range.to(H),K);return de?this._send(de):null}_send(F){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}e.DocumentRangeSemanticTokensAdapter=q;class Y{constructor(F,H,K,X,de){this._documents=F,this._commands=H,this._provider=K,this._apiDeprecation=X,this._extension=de,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}async provideCompletionItems(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H),ce=de.getWordRangeAtPosition(we)||new P.Range(we,we),Ce=ce.with({end:we}),ye=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(de,we,X,D.CompletionContext.to(K));if(!$e||X.isCancellationRequested)return;const Ve=Array.isArray($e)?new P.CompletionList($e):$e,Ze=Y.supportsResolving(this._provider)?this._cache.add(Ve.items):this._cache.add([]),Ye=new E.DisposableStore;this._disposables.set(Ze,Ye);const Oe=[],ot={x:Ze,b:Oe,a:{replace:D.Range.from(ce),insert:D.Range.from(Ce)},c:Ve.isIncomplete||void 0,d:ye.elapsed()};for(let re=0;re<Ve.items.length;re++){const se=Ve.items[re],Ee=this._convertCompletionItem(se,[Ze,re],Ce,ce);Oe.push(Ee)}return ot}async resolveCompletionItem(F,H){if(typeof this._provider.resolveCompletionItem!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveCompletionItem(K,H);if(!!X)return this._convertCompletionItem(X,F)}releaseCompletionItems(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_convertCompletionItem(F,H,K,X){const de=this._disposables.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const we={x:H,a:F.label,b:F.kind!==void 0?D.CompletionItemKind.from(F.kind):void 0,n:F.tags&&F.tags.map(D.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:D.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters,l:F.additionalTextEdits&&F.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(F.command,de)};F.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),we.h=F.textEdit.newText):typeof F.insertText=="string"?we.h=F.insertText:F.insertText instanceof P.SnippetString&&(we.h=F.insertText.value,we.i|=4);let ce;return F.textEdit?ce=F.textEdit.range:F.range&&(ce=F.range),P.Range.isRange(ce)?we.j=D.Range.from(ce):ce&&(!K?.isEqual(ce.inserting)||!X?.isEqual(ce.replacing))&&(we.j={insert:D.Range.from(ce.inserting),replace:D.Range.from(ce.replacing)}),we}}class Q{async provideInlineCompletions(F,H,K,X){}disposeCompletions(F){}handleDidShowCompletionItem(F,H){}}class he extends Q{constructor(F,H,K,X){super(),this._extension=F,this._documents=H,this._provider=K,this._commands=X,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,h.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,h.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H),ce=await this._provider.provideInlineCompletionItems(de,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:D.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=this._isAdditionsProposedApiEnabled?Array.isArray(ce)?[]:ce.commands||[]:[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&($e||($e=new E.DisposableStore),Oe=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new E.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const K=this._references.get(F)?.items[H];K&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class ve extends Q{constructor(F,H,K,X){super(),this.extension=F,this._documents=H,this._provider=K,this._commands=X,this._references=new ne,this.isAdditionProposedApiEnabled=(0,h.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H),ce=await this._provider.provideInlineCompletionItems(de,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:D.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[K.triggerKind]},X);if(!ce||X.isCancellationRequested)return;const Ce=Array.isArray(ce)?ce:ce.items,ye=Array.isArray(ce)?[]:ce.commands||[];let $e;return{pid:this._references.createReferenceId({dispose(){$e?.dispose()},items:Ce}),items:Ce.map((Ze,Ye)=>{let Oe;Ze.command&&($e||($e=new E.DisposableStore),Oe=this._commands.toInternal(Ze.command,$e));const ot=Ze.insertText;return{insertText:typeof ot=="string"?ot:{snippet:ot.value},filterText:Ze.filterText,range:Ze.range?D.Range.from(Ze.range):void 0,command:Oe,idx:Ye,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ye.map(Ze=>($e||($e=new E.DisposableStore),this._commands.toInternal(Ze,$e)))}}disposeCompletions(F){this._references.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,H){const K=this._references.get(F)?.items[H];K&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(K)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(F){const H=this._idPool++;return this._references.set(H,F),H}disposeReferenceId(F){const H=this._references.get(F);return this._references.delete(F),H}get(F){return this._references.get(F)}}class pe{constructor(F,H){this._documents=F,this._provider=H,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(F,H,K,X){const de=this._documents.getDocument(F),we=D.Position.to(H),ce=this.reviveContext(K),Ce=await this._provider.provideSignatureHelp(de,we,X,ce);if(Ce){const ye=this._cache.add([Ce]);return{...D.SignatureHelp.from(Ce),id:ye}}}reviveContext(F){let H;if(F.activeSignatureHelp){const K=D.SignatureHelp.to(F.activeSignatureHelp),X=this._cache.get(F.activeSignatureHelp.id,0);X?(H=X,H.activeSignature=K.activeSignature,H.activeParameter=K.activeParameter):H=K}return{...F,activeSignatureHelp:H}}releaseSignatureHelp(F){this._cache.delete(F)}}class be{constructor(F,H,K,X,de){this._documents=F,this._commands=H,this._provider=K,this._logService=X,this._extension=de,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(F,H,K){const X=this._documents.getDocument(F),de=D.Range.to(H),we=await this._provider.provideInlayHints(X,de,K);if(!Array.isArray(we)||we.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${H}`);return}if(K.isCancellationRequested)return;const ce=this._cache.add(we);this._disposables.set(ce,new E.DisposableStore);const Ce={hints:[],cacheId:ce};for(let ye=0;ye<we.length;ye++)this._isValidInlayHint(we[ye],de)&&Ce.hints.push(this._convertInlayHint(we[ye],[ce,ye]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${H}`),Ce}async resolveInlayHint(F,H){if(typeof this._provider.resolveInlayHint!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveInlayHint(K,H);if(!!X&&!!this._isValidInlayHint(X))return this._convertInlayHint(X,F)}releaseHints(F){this._disposables.get(F)?.dispose(),this._disposables.delete(F),this._cache.delete(F)}_isValidInlayHint(F,H){return F.label.length===0||Array.isArray(F.label)&&F.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(H&&!H.contains(F.position))}_convertInlayHint(F,H){const K=this._disposables.get(H[0]);if(!K)throw Error("DisposableStore is missing...");const X={label:"",cacheId:H,tooltip:D.MarkdownString.fromStrict(F.tooltip),position:D.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(D.TextEdit.from),kind:F.kind&&D.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?X.label=F.label:X.label=F.label.map(de=>{const we={label:de.value};return we.tooltip=D.MarkdownString.fromStrict(de.tooltip),P.Location.isLocation(de.location)&&(we.location=D.location.from(de.location)),de.command&&(we.command=this._commands.toInternal(de.command,K)),we}),X}}class Te{constructor(F,H){this._documents=F,this._provider=H,this._cache=new m.Cache("DocumentLink")}async provideLinks(F,H){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentLinks(K,H);if(!(!Array.isArray(X)||X.length===0)&&!H.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:X.filter(Te._validateLink).map(D.DocumentLink.from)};{const de=this._cache.add(X),we={links:[],cacheId:de};for(let ce=0;ce<X.length;ce++){if(!Te._validateLink(X[ce]))continue;const Ce=D.DocumentLink.from(X[ce]);Ce.cacheId=[de,ce],we.links.push(Ce)}return we}}}static _validateLink(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,H){if(typeof this._provider.resolveDocumentLink!="function")return;const K=this._cache.get(...F);if(!K)return;const X=await this._provider.resolveDocumentLink(K,H);if(!(!X||!Te._validateLink(X)))return D.DocumentLink.from(X)}releaseLinks(F){this._cache.delete(F)}}class Le{constructor(F,H){this._documents=F,this._provider=H}async provideColors(F,H){const K=this._documents.getDocument(F),X=await this._provider.provideDocumentColors(K,H);return Array.isArray(X)?X.map(we=>({color:D.Color.from(we.color),range:D.Range.from(we.range)})):[]}async provideColorPresentations(F,H,K){const X=this._documents.getDocument(F),de=D.Range.to(H.range),we=D.Color.to(H.color),ce=await this._provider.provideColorPresentations(we,{document:X,range:de},K);if(!!Array.isArray(ce))return ce.map(D.ColorPresentation.from)}}class We{constructor(F,H){this._documents=F,this._provider=H}async provideFoldingRanges(F,H,K){const X=this._documents.getDocument(F),de=await this._provider.provideFoldingRanges(X,H,K);if(!!Array.isArray(de))return de.map(D.FoldingRange.from)}}class oe{constructor(F,H,K){this._documents=F,this._provider=H,this._logService=K}async provideSelectionRanges(F,H,K){const X=this._documents.getDocument(F),de=H.map(D.Position.to),we=await this._provider.provideSelectionRanges(X,de,K);if(!(0,R.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Ce=0;Ce<de.length;Ce++){const ye=[];ce.push(ye);let $e=de[Ce],Ve=we[Ce];for(;;){if(!Ve.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(D.SelectionRange.from(Ve)),!Ve.parent)break;$e=Ve.range,Ve=Ve.parent}}return ce}}class le{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.prepareCallHierarchy(X,de,K);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideCallsTo(F,H,K){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(X,K);if(!!de)return de.map(we=>({from:this._cacheAndConvertItem(F,we.from),fromRanges:we.fromRanges.map(ce=>D.Range.from(ce))}))}async provideCallsFrom(F,H,K){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(X,K);if(!!de)return de.map(we=>({to:this._cacheAndConvertItem(F,we.to),fromRanges:we.fromRanges.map(ce=>D.Range.from(ce))}))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const K=this._cache.get(F),X=D.CallHierarchyItem.from(H,F,K.size.toString(36));return K.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class me{constructor(F,H){this._documents=F,this._provider=H,this._idPool=new b.IdGenerator(""),this._cache=new Map}async prepareSession(F,H,K){const X=this._documents.getDocument(F),de=D.Position.to(H),we=await this._provider.prepareTypeHierarchy(X,de,K);if(!we)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(we)?we.map(Ce=>this._cacheAndConvertItem(ce,Ce)):[this._cacheAndConvertItem(ce,we)]}async provideSupertypes(F,H,K){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySupertypes(X,K);if(!!de)return de.map(we=>this._cacheAndConvertItem(F,we))}async provideSubtypes(F,H,K){const X=this._itemFromCache(F,H);if(!X)throw new Error("missing type hierarchy item");const de=await this._provider.provideTypeHierarchySubtypes(X,K);if(!!de)return de.map(we=>this._cacheAndConvertItem(F,we))}releaseSession(F){this._cache.delete(F)}_cacheAndConvertItem(F,H){const K=this._cache.get(F),X=D.TypeHierarchyItem.from(H,F,K.size.toString(36));return K.set(X._itemId,H),X}_itemFromCache(F,H){return this._cache.get(F)?.get(H)}}class Z{constructor(F,H,K,X){this._proxy=F,this._documents=H,this._provider=K,this._handle=X}async provideDocumentOnDropEdits(F,H,K,X,de){const we=this._documents.getDocument(H),ce=D.Position.to(K),Ce=D.DataTransfer.toDataTransfer(X,async $e=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,F,$e)).buffer),ye=await this._provider.provideDocumentDropEdits(we,ce,Ce,de);if(!!ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?D.WorkspaceEdit.from(ye.additionalEdit,void 0,!0):void 0}}}class ae{constructor(F,H){this.adapter=F,this.extension=H}}class ee{constructor(F,H,K,X,de,we,ce){this._adapter=new Map,this._uriTransformer=H,this._proxy=F.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=K,this._commands=X,this._diagnostics=de,this._logService=we,this._apiDeprecation=ce}_transformDocumentSelector(F){return D.DocumentSelector.from(F,this._uriTransformer)}_createDisposable(F){return new P.Disposable(()=>{this._adapter.delete(F),this._proxy.$unregister(F)})}_nextHandle(){return ee._handlePool++}async _withAdapter(F,H,K,X,de,we=!1){const ce=this._adapter.get(F);if(!ce||!(ce.adapter instanceof H))return X;const Ce=Date.now();we||this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const ye=K(ce.adapter,ce.extension);return Promise.resolve(ye).catch($e=>{(0,p.isCancellationError)($e)||(this._logService.error(`[${ce.extension.identifier.value}] provider FAILED`),this._logService.error($e))}).finally(()=>{we||this._logService.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-Ce}ms`)}),T.CancellationToken.isCancellationToken(de)?(0,a.raceCancellationError)(ye,de):ye}_addNewAdapter(F,H){const K=this._nextHandle();return this._adapter.set(K,new ae(F,H)),K}static _extLabel(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,H,K,X){const de=this._addNewAdapter(new i(this._documents,K),F),we=X&&X.label||ee._extLabel(F);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(H),we),this._createDisposable(de)}$provideDocumentSymbols(F,H,K){return this._withAdapter(F,i,X=>X.provideDocumentSymbols(l.URI.revive(H),K),void 0,K)}registerCodeLensProvider(F,H,K){const X=this._nextHandle(),de=typeof K.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new u(this._documents,this._commands.converter,K),F)),this._proxy.$registerCodeLensSupport(X,this._transformDocumentSelector(H),de);let we=this._createDisposable(X);if(de!==void 0){const ce=K.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(de));we=P.Disposable.from(we,ce)}return we}$provideCodeLenses(F,H,K){return this._withAdapter(F,u,X=>X.provideCodeLenses(l.URI.revive(H),K),void 0,K)}$resolveCodeLens(F,H,K){return this._withAdapter(F,u,X=>X.resolveCodeLens(H,K),void 0,void 0)}$releaseCodeLenses(F,H){this._withAdapter(F,u,K=>Promise.resolve(K.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(F,H,K){const X=this._addNewAdapter(new r(this._documents,K),F);return this._proxy.$registerDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDefinition(F,H,K,X){return this._withAdapter(F,r,de=>de.provideDefinition(l.URI.revive(H),K,X),[],X)}registerDeclarationProvider(F,H,K){const X=this._addNewAdapter(new s(this._documents,K),F);return this._proxy.$registerDeclarationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDeclaration(F,H,K,X){return this._withAdapter(F,s,de=>de.provideDeclaration(l.URI.revive(H),K,X),[],X)}registerImplementationProvider(F,H,K){const X=this._addNewAdapter(new n(this._documents,K),F);return this._proxy.$registerImplementationSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideImplementation(F,H,K,X){return this._withAdapter(F,n,de=>de.provideImplementation(l.URI.revive(H),K,X),[],X)}registerTypeDefinitionProvider(F,H,K){const X=this._addNewAdapter(new c(this._documents,K),F);return this._proxy.$registerTypeDefinitionSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideTypeDefinition(F,H,K,X){return this._withAdapter(F,c,de=>de.provideTypeDefinition(l.URI.revive(H),K,X),[],X)}registerHoverProvider(F,H,K,X){const de=this._addNewAdapter(new d(this._documents,K),F);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(H)),this._createDisposable(de)}$provideHover(F,H,K,X){return this._withAdapter(F,d,de=>de.provideHover(l.URI.revive(H),K,X),void 0,X)}registerEvaluatableExpressionProvider(F,H,K,X){const de=this._addNewAdapter(new f(this._documents,K),F);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(H)),this._createDisposable(de)}$provideEvaluatableExpression(F,H,K,X){return this._withAdapter(F,f,de=>de.provideEvaluatableExpression(l.URI.revive(H),K,X),void 0,X)}registerInlineValuesProvider(F,H,K,X){const de=typeof K.onDidChangeInlineValues=="function"?this._nextHandle():void 0,we=this._addNewAdapter(new y(this._documents,K),F);this._proxy.$registerInlineValuesProvider(we,this._transformDocumentSelector(H),de);let ce=this._createDisposable(we);if(de!==void 0){const Ce=K.onDidChangeInlineValues(ye=>this._proxy.$emitInlineValuesEvent(de));ce=P.Disposable.from(ce,Ce)}return ce}$provideInlineValues(F,H,K,X,de){return this._withAdapter(F,y,we=>we.provideInlineValues(l.URI.revive(H),K,X,de),void 0,de)}registerDocumentHighlightProvider(F,H,K){const X=this._addNewAdapter(new L(this._documents,K),F);return this._proxy.$registerDocumentHighlightProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentHighlights(F,H,K,X){return this._withAdapter(F,L,de=>de.provideDocumentHighlights(l.URI.revive(H),K,X),void 0,X)}registerLinkedEditingRangeProvider(F,H,K){const X=this._addNewAdapter(new M(this._documents,K),F);return this._proxy.$registerLinkedEditingRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideLinkedEditingRanges(F,H,K,X){return this._withAdapter(F,M,async de=>{const we=await de.provideLinkedEditingRanges(l.URI.revive(H),K,X);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ee._serializeRegExp(we.wordPattern):void 0}},void 0,X)}registerReferenceProvider(F,H,K){const X=this._addNewAdapter(new B(this._documents,K),F);return this._proxy.$registerReferenceSupport(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideReferences(F,H,K,X,de){return this._withAdapter(F,B,we=>we.provideReferences(l.URI.revive(H),K,X,de),void 0,de)}registerCodeActionProvider(F,H,K,X){const de=new E.DisposableStore,we=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,K,this._logService,F,this._apiDeprecation),F);return this._proxy.$registerQuickFixSupport(we,this._transformDocumentSelector(H),{providedKinds:X?.providedCodeActionKinds?.map(ce=>ce.value),documentation:X?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,de)}))},ee._extLabel(F),Boolean(K.resolveCodeAction)),de.add(this._createDisposable(we)),de}$provideCodeActions(F,H,K,X,de){return this._withAdapter(F,A,we=>we.provideCodeActions(l.URI.revive(H),K,X,de),void 0,de)}$resolveCodeAction(F,H,K){return this._withAdapter(F,A,X=>X.resolveCodeAction(H,K),void 0,void 0)}$releaseCodeActions(F,H){this._withAdapter(F,A,K=>Promise.resolve(K.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(F,H,K){const X=this._addNewAdapter(new U(this._documents,K),F);return this._proxy.$registerDocumentFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentFormattingEdits(F,H,K,X){return this._withAdapter(F,U,de=>de.provideDocumentFormattingEdits(l.URI.revive(H),K,X),void 0,X)}registerDocumentRangeFormattingEditProvider(F,H,K){const X=this._addNewAdapter(new N(this._documents,K),F);return this._proxy.$registerRangeFormattingSupport(X,this._transformDocumentSelector(H),F.identifier,F.displayName||F.name),this._createDisposable(X)}$provideDocumentRangeFormattingEdits(F,H,K,X,de){return this._withAdapter(F,N,we=>we.provideDocumentRangeFormattingEdits(l.URI.revive(H),K,X,de),void 0,de)}registerOnTypeFormattingEditProvider(F,H,K,X){const de=this._addNewAdapter(new G(this._documents,K),F);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(H),X,F.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(F,H,K,X,de,we){return this._withAdapter(F,G,ce=>ce.provideOnTypeFormattingEdits(l.URI.revive(H),K,X,de,we),void 0,we)}registerWorkspaceSymbolProvider(F,H){const K=this._addNewAdapter(new z(H,this._logService),F);return this._proxy.$registerNavigateTypeSupport(K,typeof H.resolveWorkspaceSymbol=="function"),this._createDisposable(K)}$provideWorkspaceSymbols(F,H,K){return this._withAdapter(F,z,X=>X.provideWorkspaceSymbols(H,K),{symbols:[]},K)}$resolveWorkspaceSymbol(F,H,K){return this._withAdapter(F,z,X=>X.resolveWorkspaceSymbol(H,K),void 0,void 0)}$releaseWorkspaceSymbols(F,H){this._withAdapter(F,z,K=>K.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(F,H,K){const X=this._addNewAdapter(new O(this._documents,K,this._logService),F);return this._proxy.$registerRenameSupport(X,this._transformDocumentSelector(H),O.supportsResolving(K)),this._createDisposable(X)}$provideRenameEdits(F,H,K,X,de){return this._withAdapter(F,O,we=>we.provideRenameEdits(l.URI.revive(H),K,X,de),void 0,de)}$resolveRenameLocation(F,H,K,X){return this._withAdapter(F,O,de=>de.resolveRenameLocation(l.URI.revive(H),K,X),void 0,X)}registerDocumentSemanticTokensProvider(F,H,K,X){const de=this._addNewAdapter(new V(this._documents,K),F),we=typeof K.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(H),X,we);let ce=this._createDisposable(de);if(we){const Ce=K.onDidChangeSemanticTokens(ye=>this._proxy.$emitDocumentSemanticTokensEvent(we));ce=P.Disposable.from(ce,Ce)}return ce}$provideDocumentSemanticTokens(F,H,K,X){return this._withAdapter(F,V,de=>de.provideDocumentSemanticTokens(l.URI.revive(H),K,X),null,X)}$releaseDocumentSemanticTokens(F,H){this._withAdapter(F,V,K=>K.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,H,K,X){const de=this._addNewAdapter(new q(this._documents,K),F);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(H),X),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(F,H,K,X){return this._withAdapter(F,q,de=>de.provideDocumentRangeSemanticTokens(l.URI.revive(H),K,X),null,X)}registerCompletionItemProvider(F,H,K,X){const de=this._addNewAdapter(new Y(this._documents,this._commands.converter,K,this._apiDeprecation,F),F);return this._proxy.$registerCompletionsProvider(de,this._transformDocumentSelector(H),X,Y.supportsResolving(K),`${F.identifier.value}(${X.join("")})`),this._createDisposable(de)}$provideCompletionItems(F,H,K,X,de){return this._withAdapter(F,Y,we=>we.provideCompletionItems(l.URI.revive(H),K,X,de),void 0,de)}$resolveCompletionItem(F,H,K){return this._withAdapter(F,Y,X=>X.resolveCompletionItem(H,K),void 0,K)}$releaseCompletionItems(F,H){this._withAdapter(F,Y,K=>K.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(F,H,K){const X=new he(F,this._documents,K,this._commands.converter),de=this._addNewAdapter(X,F);return this._proxy.$registerInlineCompletionsSupport(de,this._transformDocumentSelector(H),X.supportsHandleDidShowCompletionItem),this._createDisposable(de)}registerInlineCompletionsProviderNew(F,H,K){const X=this._addNewAdapter(new ve(F,this._documents,K,this._commands.converter),F);return this._proxy.$registerInlineCompletionsSupport(X,this._transformDocumentSelector(H),!0),this._createDisposable(X)}$provideInlineCompletions(F,H,K,X,de){return this._withAdapter(F,Q,we=>we.provideInlineCompletions(l.URI.revive(H),K,X,de),void 0,de)}$handleInlineCompletionDidShow(F,H,K){this._withAdapter(F,Q,async X=>{X.handleDidShowCompletionItem(H,K)},void 0,void 0)}$freeInlineCompletionsList(F,H){this._withAdapter(F,Q,async K=>{K.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(F,H,K,X){const de=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,we=this._addNewAdapter(new pe(this._documents,K),F);return this._proxy.$registerSignatureHelpProvider(we,this._transformDocumentSelector(H),de),this._createDisposable(we)}$provideSignatureHelp(F,H,K,X,de){return this._withAdapter(F,pe,we=>we.provideSignatureHelp(l.URI.revive(H),K,X,de),void 0,de)}$releaseSignatureHelp(F,H){this._withAdapter(F,pe,K=>K.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(F,H,K){const X=typeof K.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new be(this._documents,this._commands.converter,K,this._logService,F),F);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(H),typeof K.resolveInlayHint=="function",X,ee._extLabel(F));let we=this._createDisposable(de);if(X!==void 0){const ce=K.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(X));we=P.Disposable.from(we,ce)}return we}$provideInlayHints(F,H,K,X){return this._withAdapter(F,be,de=>de.provideInlayHints(l.URI.revive(H),K,X),void 0,X)}$resolveInlayHint(F,H,K){return this._withAdapter(F,be,X=>X.resolveInlayHint(H,K),void 0,K)}$releaseInlayHints(F,H){this._withAdapter(F,be,K=>K.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(F,H,K){const X=this._addNewAdapter(new Te(this._documents,K),F);return this._proxy.$registerDocumentLinkProvider(X,this._transformDocumentSelector(H),typeof K.resolveDocumentLink=="function"),this._createDisposable(X)}$provideDocumentLinks(F,H,K){return this._withAdapter(F,Te,X=>X.provideLinks(l.URI.revive(H),K),void 0,K,H.scheme==="output")}$resolveDocumentLink(F,H,K){return this._withAdapter(F,Te,X=>X.resolveLink(H,K),void 0,void 0,!0)}$releaseDocumentLinks(F,H){this._withAdapter(F,Te,K=>K.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(F,H,K){const X=this._addNewAdapter(new Le(this._documents,K),F);return this._proxy.$registerDocumentColorProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentColors(F,H,K){return this._withAdapter(F,Le,X=>X.provideColors(l.URI.revive(H),K),[],K)}$provideColorPresentations(F,H,K,X){return this._withAdapter(F,Le,de=>de.provideColorPresentations(l.URI.revive(H),K,X),void 0,X)}registerFoldingRangeProvider(F,H,K){const X=this._nextHandle(),de=typeof K.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(X,new ae(new We(this._documents,K),F)),this._proxy.$registerFoldingRangeProvider(X,this._transformDocumentSelector(H),de);let we=this._createDisposable(X);if(de!==void 0){const ce=K.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));we=P.Disposable.from(we,ce)}return we}$provideFoldingRanges(F,H,K,X){return this._withAdapter(F,We,de=>de.provideFoldingRanges(l.URI.revive(H),K,X),void 0,X)}registerSelectionRangeProvider(F,H,K){const X=this._addNewAdapter(new oe(this._documents,K,this._logService),F);return this._proxy.$registerSelectionRangeProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideSelectionRanges(F,H,K,X){return this._withAdapter(F,oe,de=>de.provideSelectionRanges(l.URI.revive(H),K,X),[],X)}registerCallHierarchyProvider(F,H,K){const X=this._addNewAdapter(new le(this._documents,K),F);return this._proxy.$registerCallHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareCallHierarchy(F,H,K,X){return this._withAdapter(F,le,de=>Promise.resolve(de.prepareSession(l.URI.revive(H),K,X)),void 0,X)}$provideCallHierarchyIncomingCalls(F,H,K,X){return this._withAdapter(F,le,de=>de.provideCallsTo(H,K,X),void 0,X)}$provideCallHierarchyOutgoingCalls(F,H,K,X){return this._withAdapter(F,le,de=>de.provideCallsFrom(H,K,X),void 0,X)}$releaseCallHierarchy(F,H){this._withAdapter(F,le,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(F,H,K){const X=this._addNewAdapter(new me(this._documents,K),F);return this._proxy.$registerTypeHierarchyProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$prepareTypeHierarchy(F,H,K,X){return this._withAdapter(F,me,de=>Promise.resolve(de.prepareSession(l.URI.revive(H),K,X)),void 0,X)}$provideTypeHierarchySupertypes(F,H,K,X){return this._withAdapter(F,me,de=>de.provideSupertypes(H,K,X),void 0,X)}$provideTypeHierarchySubtypes(F,H,K,X){return this._withAdapter(F,me,de=>de.provideSubtypes(H,K,X),void 0,X)}$releaseTypeHierarchy(F,H){this._withAdapter(F,me,K=>Promise.resolve(K.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(F,H,K){const X=this._nextHandle();return this._adapter.set(X,new ae(new Z(this._proxy,this._documents,K,X),F)),this._proxy.$registerDocumentOnDropEditProvider(X,this._transformDocumentSelector(H)),this._createDisposable(X)}$provideDocumentOnDropEdits(F,H,K,X,de,we){return this._withAdapter(F,Z,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(H,l.URI.revive(K),X,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(F,H,K,X){const de=this._nextHandle();return this._adapter.set(de,new ae(new W(this._proxy,this._documents,K,de),F)),this._proxy.$registerPasteEditProvider(de,this._transformDocumentSelector(H),!!K.prepareDocumentPaste,X.pasteMimeTypes),this._createDisposable(de)}$prepareDocumentPaste(F,H,K,X,de){return this._withAdapter(F,W,we=>we.prepareDocumentPaste(l.URI.revive(H),K,X,de),void 0,de)}$providePasteEdits(F,H,K,X,de,we){return this._withAdapter(F,W,ce=>ce.providePasteEdits(H,l.URI.revive(K),X,de,we),void 0,we)}static _serializeRegExp(F){return{pattern:F.source,flags:(0,w.regExpFlags)(F)}}static _serializeIndentationRule(F){return{decreaseIndentPattern:ee._serializeRegExp(F.decreaseIndentPattern),increaseIndentPattern:ee._serializeRegExp(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ee._serializeRegExp(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ee._serializeRegExp(F.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(F){return{beforeText:ee._serializeRegExp(F.beforeText),afterText:F.afterText?ee._serializeRegExp(F.afterText):void 0,previousLineText:F.previousLineText?ee._serializeRegExp(F.previousLineText):void 0,action:F.action}}static _serializeOnEnterRules(F){return F.map(ee._serializeOnEnterRule)}setLanguageConfiguration(F,H,K){const{wordPattern:X}=K;if(X&&(0,w.regExpLeadsToEndlessLoop)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this._documents.setWordDefinitionFor(H,X):this._documents.setWordDefinitionFor(H,void 0),K.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),K.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const de=this._nextHandle(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ee._serializeRegExp(K.wordPattern):void 0,indentationRules:K.indentationRules?ee._serializeIndentationRule(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ee._serializeOnEnterRules(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,H,we),this._createDisposable(de)}$setWordDefinitions(F){for(const H of F)this._documents.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ee,ee._handlePool=0}),define(De[249],Ie([1,0,5,16,7,41,18,6]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class w{constructor(R,k,S,T){this._documents=k,this._commands=S,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,k){await this._proxy.$changeLanguage(R,k);const S=this._documents.getDocumentData(R);if(!S)throw new Error(`document '${R.toString()}' NOT found`);return S.document}async tokenAtPosition(R,k){const S=R.version,T=t.Position.from(k),E=await this._proxy.$tokensAtPosition(R.uri,T),g={type:D.StandardTokenType.Other,range:R.getWordRangeAtPosition(k)??new D.Range(k.line,k.character,k.line,k.character)};if(!E)return g;const b={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!b.range.contains(k)||S!==R.version?g:b}createLanguageStatusItem(R,k,S){const T=this._handlePool++,E=this._proxy,g=this._ids,b=`${R.identifier.value}/${k}`;if(g.has(b))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);g.add(b);const m={selector:S,id:k,name:R.displayName??R.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const p=new I.DisposableStore,a=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{p.clear(),this._proxy.$setLanguageStatus(T,{id:b,name:m.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(m.selector,this._uriTransformer),label:m.text,detail:m.detail??"",severity:m.severity===D.LanguageStatusSeverity.Error?P.default.Error:m.severity===D.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:m.command&&this._commands.toInternal(m.command,p),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},h={dispose(){p.dispose(),v?.dispose(),E.$removeLanguageStatus(T),g.delete(b)},get id(){return m.id},get name(){return m.name},set name(i){m.name=i,a()},get selector(){return m.selector},set selector(i){m.selector=i,a()},get text(){return m.text},set text(i){m.text=i,a()},get detail(){return m.detail},set detail(i){m.detail=i,a()},get severity(){return m.severity},set severity(i){m.severity=i,a()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(i){m.accessibilityInformation=i,a()},get command(){return m.command},set command(i){m.command=i,a()},get busy(){return m.busy},set busy(i){m.busy=i,a()}};return a(),h}}e.ExtHostLanguages=w}),define(De[136],Ie([1,0,14,5,26,15,4]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends l.AbstractLoggerService{constructor(R,k){const S=new _.Emitter;super(k.logLevel,S.event),this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(S)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,k,S){return new w(this._proxy,R,k,S)}};I=qe([xe(0,P.IExtHostRpcService),xe(1,D.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class w extends l.AbstractMessageLogger{constructor(R,k,S,T){super(T?.always),this.proxy=R,this.file=k,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(S),this.proxy.$createLogger(k,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,k){const S=[[R,k]];this.isLoggerCreated?this.doLog(S):this.buffer.push(...S)}doLog(R){this.proxy.$log(this.file,R)}}}),define(De[250],Ie([1,0,5,14,27]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let _=class{constructor(w,C){this._logService=C,this._proxy=w.getProxy(l.MainContext.MainThreadMessageService)}showMessage(w,C,R,k,S){const T={source:{identifier:w.identifier,label:w.displayName||w.name}};let E;typeof k=="string"||P(k)?E=[k,...S]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,E=S),T.useCustom&&(0,D.checkProposedApiEnabled)(w,"resolvers");const g=[];for(let b=0;b<E.length;b++){const m=E[b];if(typeof m=="string")g.push({title:m,handle:b,isCloseAffordance:!1});else if(typeof m=="object"){const{title:v,isCloseAffordance:p}=m;g.push({title:v,isCloseAffordance:!!p,handle:b})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(C,R,T,g).then(b=>{if(typeof b=="number")return E[b]})}};_=qe([xe(1,t.ILogService)],_),e.ExtHostMessageService=_}),define(De[251],Ie([1,0,23,4,61,6,25,8,13,2,87,5,37,16,7,55,226,132]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class v{constructor(a,h,i,u,o){this._textDocumentsAndEditors=i,this._textDocuments=u,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,n=r.cell.handle,d=this._documents.get(s)?.getCell(n);if(d)return d.apiCell}return r}}),v._registerApiCommands(h)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const h=this._editors.get(a);if(!h)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(a){for(const[h,i]of this._editors)if(i.apiEditor===a)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,h){const i=this._documents.get(a);if(!i&&!h)throw new Error(`NO notebook document for '${a}'`);return i}_getProviderData(a){const h=this._notebookContentProviders.get(a);if(!h)throw new Error(`NO provider for '${a}'`);return h}registerNotebookContentProvider(a,h,i,u,o){if((0,I.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:a,provider:i});let r;return i.onDidChangeNotebookContentOptions&&(r=i.onDidChangeNotebookContentOptions(()=>{const s=T.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(h,s)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},h,T.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(a,o)),new E.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(a,h){if(!h)return;const i=h.filenamePattern.map(u=>T.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(h.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:h.displayName,filenamePattern:i,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,h,i){const u=v._notebookStatusBarItemProviderHandlePool++,o=typeof i.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,o,h);let r;return o!==void 0&&(r=i.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(o))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,o),r?.dispose()})}async createNotebookDocument(a){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&T.NotebookData.from(a.content)});return C.URI.revive(h)}async openNotebookDocument(a){const h=this._documents.get(a);if(h)return h.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(a),u=this._documents.get(C.URI.revive(i));return(0,w.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(a,h){C.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let i;typeof h=="object"?i={position:T.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(T.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:i={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,i),o=u&&this._editors.get(u)?.apiEditor;if(o)return o;throw u?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,h,i,u){const o=this._notebookStatusBarItemProviders.get(a),r=C.URI.revive(h),s=this._documents.get(r);if(!s||!o)return;const n=s.getCellFromIndex(i);if(!n)return;const c=await o.provideCellStatusBarItems(n.apiCell,u);if(!c)return;const d=new P.DisposableStore,f=this._statusBarCache.add([d]),L=(Array.isArray(c)?c:[c]).map(M=>T.NotebookStatusBarItem.from(M,this._commandsConverter,d));return{cacheId:f,items:L}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,h,i,u,o){if((0,I.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,i),this._notebookProxy.$registerNotebookSerializer(r,{id:a.identifier,location:a.extensionLocation},h,T.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(a,o)),(0,P.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(a,h,i){const u=this._notebookSerializer.get(a);if(!u)throw new Error("NO serializer found");const o=await u.deserializeNotebook(h.buffer,i);return new g.SerializableObjectWithBuffers(T.NotebookData.from(o))}async $notebookToData(a,h,i){const u=this._notebookSerializer.get(a);if(!u)throw new Error("NO serializer found");const o=await u.serializeNotebook(T.NotebookData.to(h.value),i);return l.VSBuffer.wrap(o)}async $openNotebook(a,h,i,u,o){const{provider:r}=this._getProviderData(a),s=await r.openNotebook(C.URI.revive(h),{backupId:i,untitledDocumentData:u?.buffer},o);return new g.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(T.NotebookCellData.from)})}async $saveNotebook(a,h,i){const u=this.getNotebookDocument(C.URI.revive(h)),{provider:o}=this._getProviderData(a);return await o.saveNotebook(u.apiNotebook,i),!0}async $saveNotebookAs(a,h,i,u){const o=this.getNotebookDocument(C.URI.revive(h)),{provider:r}=this._getProviderData(a);return await r.saveNotebookAs(C.URI.revive(i),o.apiNotebook,u),!0}async $backupNotebook(a,h,i){const u=this.getNotebookDocument(C.URI.revive(h)),o=this._getProviderData(a),r=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension),s=String((0,D.hash)([u.uri.toString(),this._backupIdPool++])),n=C.URI.joinPath(r,s),c=await o.provider.backupNotebook(u.apiNotebook,{destination:n},i);return u.updateBackup(c),c.id}_createExtHostEditor(a,h,i){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const u=new m.ExtHostNotebookEditor(h,this._notebookEditorsProxy,a,i.visibleRanges.map(T.NotebookRange.to),i.selections.map(T.NotebookRange.to),typeof i.viewColumn=="number"?T.ViewColumn.to(i.viewColumn):void 0);this._editors.set(h,u)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const i of a.value.removedDocuments){const u=C.URI.revive(i),o=this._documents.get(u);o&&(o.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(o.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===u.toString()&&this._editors.delete(r.id)}if(a.value.addedDocuments){const i=[];for(const u of a.value.addedDocuments){const o=C.URI.revive(u.uri);if(this._documents.has(o))throw new Error(`adding EXISTING notebook ${o} `);const r=new b.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,o,u);i.push(...u.cells.map(s=>b.ExtHostCell.asModelAddData(r.apiNotebook,s))),this._documents.get(o)?.dispose(),this._documents.set(o,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(a.value.addedEditors)for(const i of a.value.addedEditors){if(this._editors.has(i.id))return;const u=C.URI.revive(i.documentUri),o=this._documents.get(u);o&&this._createExtHostEditor(o,i.id,i)}const h=[];if(a.value.removedEditors)for(const i of a.value.removedEditors){const u=this._editors.get(i);u&&(this._editors.delete(i),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),h.push(u))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const i=new Set;this._visibleNotebookEditors.forEach(u=>i.add(u.id));for(const u of this._editors.values()){const o=i.has(u.id);u._acceptVisibility(o)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(a){const h=S.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new S.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new S.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>l.VSBuffer.wrap(o))],new S.ApiCommandResult("Notebook Data",o=>T.NotebookData.to(o.value))),u=new S.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new S.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new g.SerializableObjectWithBuffers(T.NotebookData.from(o)))],new S.ApiCommandResult("Bytes",o=>o.buffer));a.registerApiCommand(i),a.registerApiCommand(u)}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0}),define(De[252],Ie([1,0,17,18,21,4,6,25,2,28,14,5,37,16,7,88,214,27,55]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(r,s,n,c,d){this._initData=s,this._extHostNotebook=n,this._commands=c,this._logService=d,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new P.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(k.MainContext.MainThreadNotebookKernels);const f=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const L=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:L}}else if(y&&"notebookEditor"in y){const L=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:L}}return y})],S.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(r,s,n,c,d,f){for(const Y of this._kernelData.values())if(Y.controller.id===s&&C.ExtensionIdentifier.equals(r.identifier,Y.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const y=this._handlePool++,L=this;this._logService.trace(`NotebookController[${y}], CREATED by ${r.identifier.value}, ${s}`);const M=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${r.identifier}'`);let B=!1;const A=new _.DisposableStore,W=new P.Emitter,U=new P.Emitter,N={id:u(r.identifier,s),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:c||r.identifier.value,preloads:f?f.map(T.NotebookRendererScript.from):[]};let G=d??M,z;this._proxy.$addKernel(y,N).catch(Y=>{console.log(Y),B=!0});let O=0;const x=()=>{if(B)return;const Y=++O;Promise.resolve().then(()=>{Y===O&&this._proxy.$updateKernel(y,N)})},V=new I.ResourceMap,q={get id(){return s},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return N.label},set label(Y){N.label=Y??r.displayName??r.name,x()},get detail(){return N.detail??""},set detail(Y){N.detail=Y,x()},get description(){return N.description??""},set description(Y){N.description=Y,x()},get kind(){return(0,m.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind??""},set kind(Y){(0,m.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind=Y,x()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(Y){N.supportedLanguages=Y,x()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){N.supportsExecutionOrder=Y,x()},get rendererScripts(){return N.preloads?N.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(Y){G=Y??M},get interruptHandler(){return z},set interruptHandler(Y){z=Y,N.supportsInterrupt=Boolean(Y),x()},createNotebookCellExecution(Y){if(B)throw new Error("notebook controller is DISPOSED");if(!V.has(Y.notebook.uri))throw L._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(Q=>Q.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return L._createNotebookCellExecution(Y,u(r.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${y}], DISPOSED`),B=!0,this._kernelData.delete(y),A.dispose(),W.dispose(),U.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(Y,Q){L._proxy.$updateNotebookPriority(y,Y.uri,Q)},onDidReceiveMessage:U.event,postMessage(Y,Q){return(0,m.checkProposedApiEnabled)(r,"notebookMessaging"),L._proxy.$postMessage(y,Q&&L._extHostNotebook.getIdByEditor(Q),Y)},asWebviewUri(Y){return(0,m.checkProposedApiEnabled)(r,"notebookMessaging"),(0,g.asWebviewUri)(Y,L._initData.remote)}};return this._kernelData.set(y,{extensionId:r.identifier,controller:q,onDidReceiveMessage:U,onDidChangeSelection:W,associatedNotebooks:V}),q}getIdByController(r){for(const[s,n]of this._kernelData)if(n.controller===r)return u(n.extensionId,r.id);return null}$acceptNotebookAssociation(r,s,n){const c=this._kernelData.get(r);if(c){const d=this._extHostNotebook.getNotebookDocument(w.URI.revive(s));n?c.associatedNotebooks.set(d.uri,!0):c.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,d.uri.toString(),n),c.onDidChangeSelection.fire({selected:n,notebook:d.apiNotebook})}}async $executeCells(r,s,n){const c=this._kernelData.get(r);if(!c)return;const d=this._extHostNotebook.getNotebookDocument(w.URI.revive(s)),f=[];for(const y of n){const L=d.getCell(y);L&&f.push(L.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,d.uri.toString(),f.length),await c.controller.executeHandler.call(c.controller,f,d.apiNotebook,c.controller)}catch(y){this._logService.error(`NotebookController[${r}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(r,s,n){const c=this._kernelData.get(r);if(!c)return;const d=this._extHostNotebook.getNotebookDocument(w.URI.revive(s));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,d.apiNotebook);else for(const f of n){const y=d.getCell(f);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,n){const c=this._kernelData.get(r);if(!c)return;const d=this._extHostNotebook.getEditorById(s);c.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:n}))}$cellExecutionChanged(r,s,n){const d=this._extHostNotebook.getNotebookDocument(w.URI.revive(r)).getCell(s);if(d){const f=n?T.NotebookCellExecutionState.to(n):E.NotebookCellExecutionState.Idle;f!==void 0&&this._onDidChangeCellExecutionState.fire({cell:d.apiCell,state:f})}}_createNotebookCellExecution(r,s){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const d=new h(s,c,this._proxy);this._activeExecutions.set(c.uri,d);const f=d.onDidChangeState(()=>{d.state===a.Resolved&&(d.dispose(),f.dispose(),this._activeExecutions.delete(c.uri))});return d.asApiObject()}};p=qe([xe(4,R.ILogService)],p),e.ExtHostNotebookKernels=p;var a;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(a||(a={}));class h extends _.Disposable{constructor(r,s,n){super(),this._cell=s,this._proxy=n,this._handle=h.HANDLE++,this._onDidChangeState=new P.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=a.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new i(10,c=>this.update(c)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,r,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===a.Init)throw new Error("Must call start before modifying cell output");if(this._state===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._cell.notebook.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const n=E.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return n===s.items?T.NotebookCellOutput.from(s):T.NotebookCellOutput.from({items:n,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,n){const c=this.cellIndexToHandle(s),d=this.validateAndConvertOutputs((0,l.asArray)(r));return this.updateSoon({editType:b.CellExecutionUpdateType.Output,cellHandle:c,append:n,outputs:d})}async updateOutputItems(r,s,n){return r=E.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(r),!0),this.updateSoon({editType:b.CellExecutionUpdateType.OutputItems,items:r.map(T.NotebookCellOutputItem.from),outputId:s.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(n){r._executionOrder=n,r.update([{editType:b.CellExecutionUpdateType.ExecutionState,executionOrder:r._executionOrder}])},start(n){if(r._state===a.Resolved||r._state===a.Started)throw new Error("Cannot call start again");r._state=a.Started,r._onDidChangeState.fire(),r.update({editType:b.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,c){if(r._state===a.Resolved)throw new Error("Cannot call resolve twice");r._state=a.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._handle,new v.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:n}))},clearOutput(n){return r.verifyStateForOutput(),r.updateOutputs([],n,!1)},appendOutput(n,c){return r.verifyStateForOutput(),r.updateOutputs(n,c,!0)},replaceOutput(n,c){return r.verifyStateForOutput(),r.updateOutputs(n,c,!1)},appendOutputItems(n,c){return r.verifyStateForOutput(),r.updateOutputItems(n,c,!0)},replaceOutputItems(n,c){return r.verifyStateForOutput(),r.updateOutputItems(n,c,!1)}})}}h.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}function u(o,r){return`${o.value}/${r}`}e.createKernelId=u}),define(De[253],Ie([1,0,4,5,132]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(I,w){this._extHostNotebook=w,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,w,C){const R=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(w)?.fire({editor:R.apiEditor,message:C})}createRendererMessaging(I,w){if(!I.contributes?.notebookRenderer?.some(R=>R.id===w))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${w})`);return{onDidReceiveMessage:(R,k,S)=>this.getOrCreateEmitterFor(w).event(R,k,S),postMessage:(R,k)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,k]=[k,R]);const S=k&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.proxy.$postMessage(S?.id,w,R)}}}getOrCreateEmitterFor(I){let w=this._rendererMessageEmitters.get(I);return w||(w=new l.Emitter({onLastListenerRemove:()=>{w?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,w),w)}}e.ExtHostNotebookRenderers=P}),define(De[254],Ie([1,0,21,4,6,5,2,7,10,17,41,86]),function(J,e,l,t,D,P,_,I,w,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function S(T,E,g){const b=T.getProxy(P.MainContext.MainThreadQuickOpen);class m{constructor(s,n){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=n}showQuickPick(s,n,c=l.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(s),f=++this._instances,y=b.$show(f,{title:n?.title,placeHolder:n?.placeHolder,matchOnDescription:n?.matchOnDescription,matchOnDetail:n?.matchOnDetail,ignoreFocusLost:n?.ignoreFocusOut,canPickMany:n?.canPickMany},c),L={},M=y.then(()=>L);return Promise.race([M,d]).then(B=>{if(B!==L)return d.then(A=>{const W=[];for(let U=0;U<A.length;U++){const N=A[U];typeof N=="string"?W.push({label:N,handle:U}):N.kind===I.QuickPickItemKind.Separator?W.push({type:"separator",label:N.label}):W.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:U})}return n&&typeof n.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{n.onDidSelectItem(A[U])}),b.$setItems(f,W),y.then(U=>{if(typeof U=="number")return A[U];if(Array.isArray(U))return U.map(N=>A[N])})})}).then(void 0,B=>{if(!(0,w.isCancellationError)(B))return b.$setError(f,B),Promise.reject(B)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,n=l.CancellationToken.None){return this._validateInput=s?.validateInput,b.$input(s,typeof this._validateInput=="function",n).then(void 0,c=>{if(!(0,w.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(s){if(!this._validateInput)return;const n=await this._validateInput(s);if(!n||typeof n=="string")return n;let c;switch(n.severity){case I.InputBoxValidationSeverity.Info:c=R.default.Info;break;case I.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case I.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=n.message?R.default.Error:R.default.Ignore;break}return{content:n.message,severity:c}}async showWorkspaceFolderPick(s,n=l.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!c)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(f=>f.uri.toString()===c.uri.toString())}createQuickPick(s){const n=new u(s,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}createInputBox(s){const n=new o(s,()=>this._sessions.delete(n._id));return this._sessions.set(n._id,n),n}$onDidChangeValue(s,n){this._sessions.get(s)?._fireDidChangeValue(n)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,n){const c=this._sessions.get(s);c instanceof u&&c._fireDidChangeActive(n)}$onDidChangeSelection(s,n){const c=this._sessions.get(s);c instanceof u&&c._fireDidChangeSelection(n)}$onDidTriggerButton(s,n){this._sessions.get(s)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(s,n,c){const d=this._sessions.get(s);d instanceof u&&d._fireDidTriggerItemButton(n,c)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class v{constructor(s,n){this._extensionId=s,this._onDidDispose=n,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new t.Emitter,this._onDidChangeValueEmitter=new t.Emitter,this._onDidTriggerButtonEmitter=new t.Emitter,this._onDidHideEmitter=new t.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((n,c)=>{const d=n===I.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(d,n)}),this.update({buttons:s.map((n,c)=>({...i(n),tooltip:n.tooltip,handle:n===I.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const n=this._handlesToButtons.get(s);n&&this._onDidTriggerButtonEmitter.fire(n)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,D.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(s){if(!this._disposed){for(const n of Object.keys(s)){const c=s[n];this._pendingUpdate[n]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function p(r){if(r instanceof I.ThemeIcon)return{id:r.id};const s=h(r),n=a(r);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof n=="string"?_.URI.file(n):n}}function a(r){return typeof r=="object"&&"light"in r?r.light:r}function h(r){return typeof r=="object"&&"dark"in r?r.dark:r}function i(r){const s=p(r.iconPath);let n,c;return"id"in s?c=k.ThemeIcon.asClassName(s):n=s,{iconPath:n,iconClass:c}}class u extends v{constructor(s,n){super(s.identifier,n),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new t.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new t.Emitter,this._onDidTriggerItemButtonEmitter=new t.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((c,d)=>{this._handlesToItems.set(d,c),this._itemsToHandles.set(c,d)});const n=[];for(let c=0;c<s.length;c++){const d=s[c];d.kind===I.QuickPickItemKind.Separator?n.push({type:"separator",label:d.label}):n.push({handle:c,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((f,y)=>({...i(f),tooltip:f.tooltip,handle:y}))})}this.update({items:n})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(n=>this._itemsToHandles.has(n)),this.update({activeItems:this._activeItems.map(n=>this._itemsToHandles.get(n))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(n=>this._itemsToHandles.has(n)),this.update({selectedItems:this._selectedItems.map(n=>this._itemsToHandles.get(n))})}_fireDidChangeActive(s){const n=(0,C.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._activeItems=n,this._onDidChangeActiveEmitter.fire(n)}_fireDidChangeSelection(s){const n=(0,C.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._selectedItems=n,this._onDidChangeSelectionEmitter.fire(n)}_fireDidTriggerItemButton(s,n){const c=this._handlesToItems.get(s);if(!c||!c.buttons||!c.buttons.length)return;const d=c.buttons[n];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:c})}}class o extends v{constructor(s,n){super(s.identifier,n),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:R.default.Error}):this.update({validationMessage:s.message,severity:s.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new m(E,g)}e.createExtHostQuickOpen=S});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[255],Ie([1,0,2,4,58,6,18,5,17,103,14,28,86,16,27]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E){"use strict";var g,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(d){if(d)return typeof d.iconPath=="string"?l.URI.file(d.iconPath):l.URI.isUri(d.iconPath)||S.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function v(d,f){if(!d.iconPath&&!f.iconPath)return 0;if(d.iconPath){if(!f.iconPath)return 1}else return-1;const y=typeof d.iconPath=="string"?d.iconPath:l.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,L=typeof f.iconPath=="string"?f.iconPath:l.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,C.comparePaths)(y,L)}function p(d,f){let y=0;if(d.strikeThrough!==f.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==f.faded)return d.faded?1:-1;if(d.tooltip!==f.tooltip)return(d.tooltip||"").localeCompare(f.tooltip||"");if(y=v(d,f),y!==0)return y;if(d.light&&f.light)y=v(d.light,f.light);else{if(d.light)return 1;if(f.light)return-1}if(y!==0)return y;if(d.dark&&f.dark)y=v(d.dark,f.dark);else{if(d.dark)return 1;if(f.dark)return-1}return y}function a(d,f){if(d.command!==f.command)return d.command<f.command?-1:1;if(d.title!==f.title)return d.title<f.title?-1:1;if(d.tooltip!==f.tooltip){if(d.tooltip!==void 0&&f.tooltip!==void 0)return d.tooltip<f.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(d.arguments===f.arguments)return 0;if(d.arguments)if(f.arguments){if(d.arguments.length!==f.arguments.length)return d.arguments.length-f.arguments.length}else return 1;else return-1;for(let y=0;y<d.arguments.length;y++){const L=d.arguments[y],M=f.arguments[y];if(L!==M)return L<M?-1:1}return 0}function h(d,f){let y=(0,C.comparePaths)(d.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(y!==0)return y;if(d.command&&f.command)y=a(d.command,f.command);else{if(d.command)return 1;if(f.command)return-1}if(y!==0)return y;if(d.decorations&&f.decorations)y=p(d.decorations,f.decorations);else{if(d.decorations)return 1;if(f.decorations)return-1}return y}function i(d,f){for(let y=0;y<d.length;y++)if(d[y]!==f[y])return!1;return!0}function u(d,f){return d.command===f.command&&d.title===f.title&&d.tooltip===f.tooltip&&(d.arguments&&f.arguments?i(d.arguments,f.arguments):d.arguments===f.arguments)}function o(d,f){return(0,w.equals)(d,f,u)}class r{constructor(f,y,L){this._extension=f,this._sourceControlHandle=L,g.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,tt(this,g,y,"f")}get value(){return this._value}set value(f){f=f??"",Ue(this,g,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){Ue(this,g,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,Ue(this,g,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get enabled(){return this._enabled}set enabled(f){f=!!f,this._enabled!==f&&(this._enabled=f,Ue(this,g,"f").$setInputBoxEnablement(this._sourceControlHandle,f))}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,Ue(this,g,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,y){(0,E.checkProposedApiEnabled)(this._extension,"scmValidation"),Ue(this,g,"f").$showValidationMessage(this._sourceControlHandle,f,y)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=r,g=new WeakMap;class s{constructor(f,y,L,M,B){this._proxy=f,this._commands=y,this._sourceControlHandle=L,this._id=M,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,y){const L=this._resourceStatesCommandsMap.get(f);return L?(0,_.asPromise)(()=>this._commands.executeCommand(L.command,...L.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(h),L=(0,w.sortedDiff)(this._resourceSnapshot,f,h).map(A=>{const W=A.toInsert.map(U=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,U);const G=U.resourceUri;let z;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const pe=new P.DisposableStore;z=this._commands.converter.toInternal(U.command,pe),this._resourceStatesDisposablesMap.set(N,pe)}else this._resourceStatesCommandsMap.set(N,U.command);const O=m(U.decorations),x=U.decorations&&m(U.decorations.light)||O,V=U.decorations&&m(U.decorations.dark)||O,q=[x,V],Y=U.decorations&&U.decorations.tooltip||"",Q=U.decorations&&!!U.decorations.strikeThrough,he=U.decorations&&!!U.decorations.faded,ve=U.contextValue||"";return{rawResource:[N,G,q,Y,Q,he,ve,z],handle:N}});return{start:A.start,deleteCount:A.deleteCount,toInsert:W}}),M=L.map(({start:A,deleteCount:W,toInsert:U})=>[A,W,U.map(N=>N.rawResource)]),B=L.reverse();for(const{start:A,deleteCount:W,toInsert:U}of B){const N=U.map(z=>z.handle),G=this._handlesSnapshot.splice(A,W,...N);for(const z of G)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=f,M}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class n{constructor(f,y,L,M,B,A){this._extension=f,this._commands=L,this._id=M,this._label=B,this._rootUri=A,b.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new P.MutableDisposable,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,tt(this,b,y,"f"),this._inputBox=new r(f,Ue(this,b,"f"),this.handle),Ue(this,b,"f").$registerSourceControl(this.handle,M,B,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,Ue(this,b,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,Ue(this,b,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,Ue(this,b,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=f;const y=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);Ue(this,b,"f").$updateSourceControl(this.handle,{acceptInputCommand:y})}get actionButton(){return(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,E.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new P.DisposableStore,this._actionButton=f;const y=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),secondaryCommands:f.secondaryCommands?.map(L=>L.map(M=>this._commands.converter.toInternal(M,this._actionButtonDisposables.value))),description:f.description,enabled:f.enabled}:void 0;Ue(this,b,"f").$updateSourceControl(this.handle,{actionButton:y??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&o(this._statusBarCommands,f))return;this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=f;const y=(f||[]).map(L=>this._commands.converter.toInternal(L,this._statusBarDisposables.value));Ue(this,b,"f").$updateSourceControl(this.handle,{statusBarCommands:y})}get selected(){return this._selected}createResourceGroup(f,y){const L=new s(Ue(this,b,"f"),this._commands,this.handle,f,y),M=t.Event.once(L.onDidDispose)(()=>this.createdResourceGroups.delete(L));return this.createdResourceGroups.set(L,M),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const f=[],y=[];for(const[L,M]of this.createdResourceGroups){M.dispose();const B=L.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.updatedResourceGroups.delete(L),B.dispose(),this._groups.delete(L.handle),Ue(this,b,"f").$unregisterGroup(this.handle,L.handle)}),f.push([L.handle,L.id,L.label,L.features]);const A=L._takeResourceStateSnapshot();A.length>0&&y.push([L.handle,A]),this._groups.set(L.handle,L)}Ue(this,b,"f").$registerGroups(this.handle,f,y),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(y=>{const L=y._takeResourceStateSnapshot();L.length!==0&&f.push([y.handle,L])}),f.length>0&&Ue(this,b,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),Ue(this,b,"f").$unregisterSourceControl(this.handle)}}b=new WeakMap,n._handlePool=0,qe([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let c=class Jn{constructor(f,y,L){this._commands=y,this.logService=L,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const B=this._sourceControls.get(M.sourceControlHandle);if(!B)return M;const A=B.getResourceGroup(M.groupHandle);return A?A.getResourceState(M.handle):M}else if(M&&M.$mid===4){const B=this._sourceControls.get(M.sourceControlHandle);return B?B.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const B=this._sourceControls.get(M.handle);return B||M}return M}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,y,L,M){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,y,L,M),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const B=Jn._handlePool++,A=new n(f,this._proxy,this._commands,y,L,M);this._sourceControls.set(B,A);const W=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(f.identifier))||[];return W.push(A),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(f.identifier),W),A}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const y=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(f.identifier)),L=y&&y[y.length-1];return L&&L.inputBox}$provideOriginalResource(f,y,L){const M=l.URI.revive(y);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,M.toString());const B=this._sourceControls.get(f);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(M,L)).then(A=>A||null)}$onInputBoxValueChange(f,y){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const L=this._sourceControls.get(f);return L&&L.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(f,y,L,M){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,y,L);const B=this._sourceControls.get(f);if(!B)return Promise.resolve(void 0);const A=B.getResourceGroup(y);return A?A.$executeResourceCommand(L,M):Promise.resolve(void 0)}$validateInput(f,y,L){this.logService.trace("ExtHostSCM#$validateInput",f);const M=this._sourceControls.get(f);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>M.inputBox.validateInput(y,L)).then(B=>{if(!B)return Promise.resolve(void 0);const A=T.MarkdownString.fromStrict(B.message);return A?Promise.resolve([A,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};c._handlePool=0,c=qe([xe(2,R.ILogService)],c),e.ExtHostSCM=c}),define(De[90],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,w){return this._proxy.$getPassword(I,w)}store(I,w,C){return this._proxy.$setPassword(I,w,C)}delete(I,w){return this._proxy.$deletePassword(I,w)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[256],Ie([1,0,7,5,172,6,16,13]),function(J,e,l,t,D,P,_,I){"use strict";var w,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(E,g,b,m,v=l.StatusBarAlignment.Left,p){w.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,w,E,"f"),tt(this,C,g,"f"),this._entryId=R.ID_GEN++,this._extension=b,this._id=m,this._alignment=v,this._priority=this.validatePriority(p)}validatePriority(E){if(!!(0,I.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(E){this._text=E,this.update()}set name(E){this._name=E,this.update()}set tooltip(E){this._tooltip=E,this.update()}set color(E){this._color=E,this.update()}set backgroundColor(E){E&&!R.ALLOWED_BACKGROUND_COLORS.has(E.id)&&(E=void 0),this._backgroundColor=E,this.update()}set command(E){this._command?.fromApi!==E&&(this._internalCommandRegistration.clear(),typeof E=="string"?this._command={fromApi:E,internal:Ue(this,C,"f").toInternal({title:"",command:E},this._internalCommandRegistration)}:E?this._command={fromApi:E,internal:Ue(this,C,"f").toInternal(E,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(E){this._accessibilityInformation=E,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,w,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let E;this._extension?this._id?E=`${this._extension.identifier.value}.${this._id}`:E=this._extension.identifier.value:E=this._id;let g;this._name?g=this._name:g=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let b=this._color;this._backgroundColor&&(b=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const m=_.MarkdownString.fromStrict(this._tooltip);Ue(this,w,"f").$setEntry(this._entryId,E,g,this._text,m,this._command?.internal,b,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,w=new WeakMap,C=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(E){this._messages=[],this._item=E.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(E){const g={message:E};return this._messages.unshift(g),this._update(),new l.Disposable(()=>{const b=this._messages.indexOf(g);b>=0&&(this._messages.splice(b,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class S{constructor(E,g){this._proxy=E.getProxy(t.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(E,g,b,m){return new R(this._proxy,this._commands,E,g,b,m)}setStatusBarMessage(E,g){const b=this._statusMessage.setMessage(E);let m;return typeof g=="number"?m=setTimeout(()=>b.dispose(),g):typeof g<"u"&&g.then(()=>b.dispose(),()=>b.dispose()),new l.Disposable(()=>{b.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=S}),define(De[91],Ie([1,0,5,4,3]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,w){this._proxy.$registerExtensionStorageKeysToSync(I,w)}initializeExtensionStorage(I,w,C){return this._proxy.$initializeExtensionStorage(I,w).then(R=>R||C)}setValue(I,w,C){return this._proxy.$setValue(I,w,C)}$acceptValue(I,w,C){this._onDidChangeStorage.fire({shared:I,key:w,value:C})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(De[68],Ie([1,0,3,26,14,67,2]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let I=class{constructor(C,R,k){this._logService=R,this._extHostFileSystem=k,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(S=>this._value=S)}async _getWorkspaceStorageURI(C){return _.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,R=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(k){this._logService.error("[ExtHostStorage]",k);return}}workspaceValue(C){if(this._value)return _.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return _.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=qe([xe(0,t.IExtHostInitDataService),xe(1,D.ILogService),xe(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(De[137],Ie([1,0,3,5,15]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,l.createDecorator)("IExtHostTelemetryLogService");let P=class{constructor(I){this._telemetryShape=I.getProxy(t.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(I,w,C){this._telemetryShape.$logTelemetryToOutputChannel(`${I.identifier.value}/${w}`,C)}};P=qe([xe(0,D.IExtHostRpcService)],P),e.ExtHostTelemetryLogService=P}),define(De[38],Ie([1,0,4,5,3,2,15,6,7,173,10,215,21,34,200,86,13,18]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class v{constructor(n,c,d,f){this._proxy=n,this._id=c,this._creationOptions=d,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(L=>this._pidPromiseComplete=L);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(L,M=!0){y._checkDisposed(),y._proxy.$sendText(y._id,L,M)},show(L){y._checkDisposed(),y._proxy.$show(y._id,L)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(n,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,b.withNullAsUndefined)(n.shellPath),shellArgs:(0,b.withNullAsUndefined)(n.shellArgs),cwd:(0,b.withNullAsUndefined)(n.cwd),env:(0,b.withNullAsUndefined)(n.env),icon:(0,b.withNullAsUndefined)(o(n.iconPath)),color:g.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,b.withNullAsUndefined)(n.message),strictEnv:(0,b.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(n.location,c?.resolvedExtHostIdentifier),isTransient:(0,b.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,c,d,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,color:g.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(n,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(n,c){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in n?{viewColumn:n.viewColumn,preserveFocus:n.preserveFocus}:void 0:n}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitStatus(n,c){this._exitStatus=Object.freeze({code:n,reason:c})}setDimensions(n,c){return n===this._cols&&c===this._rows||n===0||c===0?!1:(this._cols=n,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=v;class p{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput?.(n)}resize(n,c){this._pty.setDimensions?.({columns:n,rows:c})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(n||void 0),n&&this._pty.setDimensions?.(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let a=1,h=class extends I.Disposable{constructor(n,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new E.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[d,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(n){return(n?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(n,c){const d=new v(this._proxy,(0,T.generateUuid)(),n,n.name),f=new p(n.pty);return d.createExtensionTerminal(n.location,this._serializeParentTerminal(n,c).resolvedExtHostIdentifier,o(n.iconPath),r(n.color)).then(y=>{const L=this._setupExtHostProcessListeners(y,f);this._terminalProcessDisposables[y]=L}),this._terminals.push(d),d.value}_serializeParentTerminal(n,c){if(c=c||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const d=n.location.parentTerminal;if(d){const f=this._terminals.find(y=>y.value===d);f&&(c.resolvedExtHostIdentifier=f._id)}}else n.location&&typeof n.location!="object"?c.location=n.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(n,c){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const f=new p(c),y=this._setupExtHostProcessListeners(n,f);this._terminalProcessDisposables[n]=y}async $acceptActiveTerminalChanged(n){const c=this._activeTerminal;if(n===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(n);d&&(this._activeTerminal=d,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,c){const d=this._getTerminalById(n);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:c})}async $acceptTerminalDimensions(n,c,d){const f=this._getTerminalById(n);f&&f.setDimensions(c,d)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(n,c,d){this._terminalProcesses.get(n)?.resize(c,d)}async $acceptTerminalTitleChange(n,c){const d=this._getTerminalById(n);d&&(d.name=c)}async $acceptTerminalClosed(n,c,d){const f=this._getTerminalObjectIndexById(this._terminals,n);if(f!==null){const y=this._terminals.splice(f,1)[0];y.setExitStatus(c,d),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(n,c,d,f){if(c){const M=this._getTerminalObjectIndexById(this._terminals,c);if(M!==null){this._terminals[M]._id=n,this._onDidOpenTerminal.fire(this.terminals[M]),this._terminals[M].isOpen=!0;return}}const y={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:P.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},L=new v(this._proxy,n,y,d);this._terminals.push(L),this._onDidOpenTerminal.fire(L.value),L.isOpen=!0}async $acceptTerminalProcessId(n,c){this._getTerminalById(n)?._setProcessId(c)}async $startExtensionTerminal(n,c){const d=this._getTerminalById(n);if(!d)return{message:(0,C.localize)(0,null,n)};d.isOpen||await new Promise(y=>{const L=this.onDidOpenTerminal(async M=>{M===d.value&&(L.dispose(),y())})});const f=this._terminalProcesses.get(n);f?f.startSendingEvents(c):this._extensionTerminalAwaitingStart[n]={initialDimensions:c}}_setupExtHostProcessListeners(n,c){const d=new I.DisposableStore;d.add(c.onProcessReady(y=>this._proxy.$sendProcessReady(n,y.pid,y.cwd))),d.add(c.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(n,y))),this._bufferer.startBuffering(n,c.onProcessData),d.add(c.onProcessExit(y=>this._onProcessExit(n,y))),this._terminalProcesses.set(n,c);const f=this._extensionTerminalAwaitingStart[n];return f&&c instanceof p&&(c.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),d}$acceptProcessAckDataEvent(n,c){this._terminalProcesses.get(n)?.acknowledgeDataEvent(c)}$acceptProcessInput(n,c){this._terminalProcesses.get(n)?.input(c)}$acceptTerminalInteraction(n){const c=this._getTerminalById(n);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(n,c,d){try{this._terminalProcesses.get(n)?.resize(c,d)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(n,c){this._terminalProcesses.get(n)?.shutdown(c)}$acceptProcessRequestInitialCwd(n){this._terminalProcesses.get(n)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(n,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(n){this._terminalProcesses.get(n)?.getCwd().then(c=>this._proxy.$sendProcessProperty(n,{type:"cwd",value:c}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new w.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,c,d){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,d),this._proxy.$registerProfileProvider(c,n.identifier.value),new w.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(n,c){const d=new S.CancellationTokenSource().token;let f=await this._profileProviders.get(n)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,c);return}this.createTerminalFromOptions(f.options,c)}}async $provideLinks(n,c){const d=this._getTerminalById(n);if(!d)return[];this._terminalLinkCache.delete(n),this._terminalLinkCancellationSource.get(n)?.dispose(!0);const y=new S.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,y);const L=[],M={terminal:d.value,line:c},B=[];for(const U of this._linkProviders)B.push(m.Promises.withAsyncBody(async N=>{y.token.onCancellationRequested(()=>N({provider:U,links:[]}));const G=await U.provideTerminalLinks(M,y.token)||[];y.token.isCancellationRequested||N({provider:U,links:G})}));const A=await Promise.all(B);if(y.token.isCancellationRequested)return[];const W=new Map;for(const U of A)U&&U.links.length>0&&L.push(...U.links.map(N=>{const G={id:a++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return W.set(G.id,{provider:U.provider,link:N}),G}));return this._terminalLinkCache.set(n,W),L}$activateLink(n,c){const d=this._terminalLinkCache.get(n)?.get(c);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(n,c){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const d=this._terminalProcessDisposables[n];d&&(d.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,c)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,c){const d=this._getTerminalObjectIndexById(n,c);return d!==null?n[d]:null}_getTerminalObjectIndexById(n,c){let d=null;return n.some((f,y)=>f._id===c?(d=y,!0):!1),d}getEnvironmentVariableCollection(n){let c=this._environmentVariableCollections.get(n.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(n.identifier.value,c)),c}_syncEnvironmentVariableCollection(n,c){const d=(0,k.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(n,c.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(n){n.forEach(c=>{const d=c[0],f=new i(c[1]);this._setEnvironmentVariableCollection(d,f)})}$acceptDefaultProfile(n,c){this._defaultProfile=n,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(n,c){this._environmentVariableCollections.set(n,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,c)})}};h=qe([xe(1,_.IExtHostRpcService)],h),e.BaseExtHostTerminalService=h;class i{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,c){this._setIfDiffers(n,{value:c,type:w.EnvironmentVariableMutatorType.Replace})}append(n,c){this._setIfDiffers(n,{value:c,type:w.EnvironmentVariableMutatorType.Append})}prepend(n,c){this._setIfDiffers(n,{value:c,type:w.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,c){const d=this.map.get(n);(!d||d.value!==c.value||d.type!==c.type)&&(this.map.set(n,c),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,c){this.map.forEach((d,f)=>n.call(c,f,d,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let u=class extends h{constructor(n){super(!1,n)}createTerminal(n,c,d){throw new R.NotSupportedError}createTerminalFromOptions(n,c){throw new R.NotSupportedError}};u=qe([xe(0,_.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function o(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return g.ThemeColor.isThemeColor(s)?s:void 0}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[257],Ie([1,0,17,23,21,4,59,61,6,24,13,34,5,15,133,16,7,64,89,65]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p){"use strict";var a,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(B,A,W){this.editors=W,this.resultsChangedEmitter=new P.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(S.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new o(this.proxy),A.registerArgumentProcessor({processArgument:U=>U?.$mid===13?(0,E.toItemFromContext)(U):U})}createTestController(B,A,W){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const U=new w.DisposableStore,N=U.add(new E.ExtHostTestItemCollection(B,A,this.editors));N.root.label=A;const G=new Map,z=this.proxy,O={items:N.root.children,get label(){return A},set label(V){A=V,N.root.label=V,z.$updateController(B,{label:A})},get refreshHandler(){return W},set refreshHandler(V){W=V,z.$updateController(B,{canRefresh:!!V})},get id(){return B},createRunProfile:(V,q,Y,Q,he)=>{let ve=(0,I.hash)(V);for(;G.has(ve);)ve++;return new y(this.proxy,G,B,ve,V,q,Y,Q,he)},createTestItem(V,q,Y){return new E.TestItemImpl(B,V,q,Y)},createTestRun:(V,q,Y=!0)=>this.runTracker.createTestRun(B,N,V,q,Y),set resolveHandler(V){N.resolveHandler=V},get resolveHandler(){return N.resolveHandler},dispose:()=>{U.dispose()}};z.$registerTestController(B,A,!!W),U.add((0,w.toDisposable)(()=>z.$unregisterTestController(B)));const x={controller:O,collection:N,profiles:G};return this.controllers.set(B,x),U.add((0,w.toDisposable)(()=>this.controllers.delete(B))),U.add(N.onDidGenerateDiff(V=>z.$publishDiff(B,V.map(p.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(B,A=D.CancellationToken.None){const W=r(B);if(!W)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(W.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(N=>m.TestId.fromExtHostTestItem(N,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:L[W.kind],profileId:W.profileId,controllerId:W.controllerId}],exclude:B.exclude?.map(N=>N.id)},A)}$provideFileCoverage(B,A,W){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===B?N.getCoverage(A):void 0)?.provideFileCoverage(W)??Promise.resolve([])}$resolveFileCoverage(B,A,W,U){return(0,l.mapFind)(this.runTracker.trackers,G=>G.id===B?G.getCoverage(A):void 0)?.resolveFileCoverage(W,U)??Promise.resolve([])}$configureRunProfile(B,A){this.controllers.get(B)?.profiles.get(A)?.configureHandler?.()}async $refreshTests(B,A){await this.controllers.get(B)?.controller.refreshHandler?.(A)}$publishTestResults(B){this.results=Object.freeze(B.map(A=>(0,C.deepFreeze)(g.TestResults.to(A))).concat(this.results).sort((A,W)=>W.completedAt-A.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,A){const W=this.controllers.get(m.TestId.fromString(B).controllerId)?.collection;W&&(await W.expand(B,A<0?1/0:A),W.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(p.TestsDiffOp.deserialize))}async $runControllerTests(B,A){return Promise.all(B.map(W=>this.runControllerTestRequest(W,A)))}async runControllerTestRequest(B,A){const W=this.controllers.get(B.controllerId);if(!W)return{};const{collection:U,profiles:N}=W,G=N.get(B.profileId);if(!G)return{};const z=B.testIds.map(q=>U.tree.get(q)).filter(R.isDefined),O=B.excludeExtIds.map(q=>W.collection.tree.get(q)).filter(R.isDefined).filter(q=>z.some(Y=>Y.fullId.compare(q.fullId)===2));if(!z.length)return{};const x=new b.TestRunRequest(z.some(q=>q.actual instanceof E.TestItemRootImpl)?void 0:z.map(q=>q.actual),O.map(q=>q.actual),G),V=this.runTracker.prepareForMainThreadTestRun(x,s.fromInternal(B,W.collection),A);try{return await G.runHandler(x,A),{}}catch(q){return{error:String(q)}}finally{V.isRunning&&!A.isCancellationRequested&&await P.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};i=qe([xe(0,T.IExtHostRpcService)],i),e.ExtHostTesting=i;class u extends w.Disposable{constructor(B,A,W){super(),this.dto=B,this.proxy=A,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new P.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(W)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const A=this.dto.id,W=this.dto.controllerId,U=(0,k.generateUuid)(),N=new n(this.proxy,A,U),G=V=>(q,...Y)=>{if(O){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),V(q,...Y))},z=(V,q)=>{const Y=q instanceof Array?q.map(g.TestMessage.from):[g.TestMessage.from(q)];if(V.uri&&V.range){const Q={range:g.Range.from(V.range),uri:V.uri};for(const he of Y)he.location=he.location||Q}this.proxy.$appendTestMessagesInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),Y)};let O=!1;const x={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return N.coverageProvider},set coverageProvider(V){N.coverageProvider=V},enqueued:G(V=>{this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),1)}),skipped:G(V=>{this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),5)}),started:G(V=>{this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),2)}),errored:G((V,q,Y)=>{z(V,q),this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),6,Y)}),failed:G((V,q,Y)=>{z(V,q),this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,W).toString(),4,Y)}),passed:G((V,q)=>{this.proxy.$updateTestStateInRun(A,U,m.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,q)}),appendOutput:(V,q,Y)=>{O||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(A,U,t.VSBuffer.fromString(V),q&&g.location.from(q),Y&&m.TestId.fromExtHostTestItem(Y,W).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(A,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:x,coverage:N}),this.proxy.$startedTestRunTask(A,{id:U,name:B,running:!0}),x}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(B){if(!(B instanceof E.TestItemImpl))throw new v.InvalidTestItemError(B.id);if(this.sharedTestIds.has(m.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const A=[],W=this.dto.colllection.root;for(;;){const U=g.TestItem.from(B);if(A.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),B===W))break;B=B.parent||W}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,A)}}class o{constructor(B){this.proxy=B,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(B,A,W){return this.getTracker(B,A,W)}cancelRunById(B){for(const A of this.tracked.values())if(A.id===B){A.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,A,W,U,N){const G=this.tracked.get(W);if(G)return G.createRun(U);const z=s.fromPublic(B,A,W,N),O=r(W);this.proxy.$startedExtensionTestRun({controllerId:B,profile:O&&{group:L[O.kind],id:O.profileId},exclude:W.exclude?.map(V=>m.TestId.fromExtHostTestItem(V,A.root.id).toString())??[],id:z.id,include:W.include?.map(V=>m.TestId.fromExtHostTestItem(V,A.root.id).toString())??[A.root.id],persist:N});const x=this.getTracker(W,z);return x.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),x.createRun(U)}getTracker(B,A,W){const U=new u(A,this.proxy,W);return this.tracked.set(B,U),U.onEnd(()=>this.tracked.delete(B)),U}}e.TestRunCoordinator=o;const r=M=>{if(!!M.profile){if(!(M.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class s{constructor(B,A,W,U,N,G){this.controllerId=B,this.id=A,this.isPersisted=N,this.colllection=G,this.includePrefix=W.map(z=>z+"\0"),this.excludePrefix=U.map(z=>z+"\0")}static fromPublic(B,A,W,U){return new s(B,(0,k.generateUuid)(),W.include?.map(N=>m.TestId.fromExtHostTestItem(N,B).toString())??[B],W.exclude?.map(N=>m.TestId.fromExtHostTestItem(N,B).toString())??[],U,A)}static fromInternal(B,A){return new s(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,A)}isIncluded(B){const A=m.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const W of this.excludePrefix)if(A===W||A.startsWith(W))return!1;for(const W of this.includePrefix)if(A===W||A.startsWith(W))return!0;return!1}}e.TestRunDto=s;class n{constructor(B,A,W){this.proxy=B,this.runId=A,this.taskId=W}set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(g.TestCoverage.fromFile)??[]}catch(A){throw this.fileCoverage=void 0,A}}async resolveFileCoverage(B,A){const W=await this.fileCoverage;let U=W?.[B];return!this._coverageProvider||!W||!U?[]:(U.detailedCoverage||(U=W[B]=await this._coverageProvider.resolveFileCoverage?.(U,A)??U),U.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class c extends p.IncrementalChangeCollector{constructor(B){super(),this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(B){this.added.add(B)}update(B){Object.assign(B.revived,g.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}if(this.updated.delete(B),B.parent&&this.alreadyRemoved.has(B.parent)){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:A,removed:W}=this;return{get added(){return[...B].map(U=>U.revived)},get updated(){return[...A].map(U=>U.revived)},get removed(){return[...W].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,A){return{...B,revived:g.TestItem.toPlain(B.item),depth:A?A.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=d;class f{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(A=>A.revived)},dispose:(0,_.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class y{constructor(B,A,W,U,N,G,z,O=!1,x=void 0){this.controllerId=W,this.profileId=U,this._label=N,this.kind=G,this.runHandler=z,this._isDefault=O,this._tag=x,a.set(this,void 0),h.set(this,void 0),tt(this,a,B,"f"),tt(this,h,A,"f"),A.set(U,this);const V=L[G];if(typeof V!="number")throw new Error(`Unknown TestRunProfile.group ${G}`);Ue(this,a,"f").$publishTestRunProfile({profileId:U,controllerId:W,tag:x?g.TestTag.namespace(this.controllerId,x.id):null,label:N,group:V,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(B){B!==this._label&&(this._label=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?g.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,Ue(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}dispose(){Ue(this,h,"f")?.delete(this.profileId)&&(tt(this,h,void 0,"f"),Ue(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=y,a=new WeakMap,h=new WeakMap;const L={[b.TestRunProfileKind.Coverage]:8,[b.TestRunProfileKind.Debug]:4,[b.TestRunProfileKind.Run]:2}}),define(De[258],Ie([1,0,17,4,5,134,16,7]),function(J,e,l,t,D,P,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class w{constructor(R,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new t.Emitter,this._onDidChangeTextEditorOptions=new t.Emitter,this._onDidChangeTextEditorVisibleRanges=new t.Emitter,this._onDidChangeTextEditorViewColumn=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(S=>this._onDidChangeVisibleTextEditors.fire(S)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(S=>this._onDidChangeActiveTextEditor.fire(S))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const k=this._extHostDocumentsAndEditors.allEditors();return R?k:k.map(S=>S.value)}async showTextDocument(R,k,S){let T;typeof k=="number"?T={position:_.ViewColumn.from(k),preserveFocus:S}:typeof k=="object"?T={position:_.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?_.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:T={preserveFocus:!1};const E=await this._proxy.$tryShowTextDocument(R.uri,T),g=E&&this._extHostDocumentsAndEditors.getEditor(E);if(g)return g.value;throw E?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,k){return new P.TextEditorDecorationType(this._proxy,R,k).value}$acceptEditorPropertiesChanged(R,k){const S=this._extHostDocumentsAndEditors.getEditor(R);if(!S)throw new Error("unknown text editor");if(k.options&&S._acceptOptions(k.options),k.selections){const T=k.selections.selections.map(_.Selection.to);S._acceptSelections(T)}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));S._acceptVisibleRanges(T)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:S.value,options:{...k.options,lineNumbers:_.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const T=I.TextEditorSelectionChangeKind.fromValue(k.selections.source),E=k.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:S.value,selections:E,kind:T})}if(k.visibleRanges){const T=l.coalesce(k.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:S.value,visibleRanges:T})}}$acceptEditorPositionData(R){for(const k in R){const S=this._extHostDocumentsAndEditors.getEditor(k);if(!S)throw new Error("Unknown text editor");const T=_.ViewColumn.to(R[k]);S.value.viewColumn!==T&&(S._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:S.value,viewColumn:T}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=w}),define(De[259],Ie([1,0,2,3,5,6,7,16,13]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(S,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=S.getProxy(D.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===11){const g=E.uri===void 0?void 0:l.URI.revive(E.uri);return this._itemsBySourceAndUriMap.get(E.source)?.get(R(g))?.get(E.handle)}return E}})}async $getTimeline(S,T,E,g){return this._providers.get(S)?.provideTimeline(l.URI.revive(T),E,g)}registerTimelineProvider(S,T,E,g){const b=new P.DisposableStore,m=this.convertTimelineItem(T.id,g,b).bind(this);let v;T.onDidChange&&(v=T.onDidChange(a=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:T.id}),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:S,onDidChange:void 0,async provideTimeline(a,h,i){h?.resetCache&&(b.clear(),p.get(T.id)?.clear());const u=await T.provideTimeline(a,h,i);if(u==null)return;const o=m(a,h);return{...u,source:T.id,items:u.items.map(o)}},dispose(){for(const a of p.values())a.get(T.id)?.clear();v?.dispose(),b.dispose()}})}convertTimelineItem(S,T,E){return(g,b)=>{let m;if(b?.cacheResults){let v=this._itemsBySourceAndUriMap.get(S);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(S,v));const p=R(g);m=v.get(p),m===void 0&&(m=new Map,v.set(p,m))}return v=>{const{iconPath:p,...a}=v,h=`${S}|${v.id??v.timestamp}`;m?.set(h,v);let i,u,o;v.iconPath&&(p instanceof _.ThemeIcon?o={id:p.id,color:p.color}:l.URI.isUri(p)?(i=p,u=p):{light:i,dark:u}=p);let r;return _.MarkdownString.isMarkdownString(a.tooltip)?r=I.MarkdownString.from(a.tooltip):(0,w.isString)(a.tooltip)?r=a.tooltip:_.MarkdownString.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=I.MarkdownString.from(a.detail)):(0,w.isString)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=a.detail),{...a,id:a.id??void 0,handle:h,source:S,command:v.command?T.toInternal(v.command,E):void 0,icon:i,iconDark:u,themeIcon:o,tooltip:r,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(S){if(this._providers.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this._proxy.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this._providers.set(S.id,S),(0,P.toDisposable)(()=>{for(const E of this._itemsBySourceAndUriMap.values())E.get(S.id)?.clear();this._providers.delete(S.id),this._proxy.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=C;function R(k){return k?.toString()}}),define(De[260],Ie([1,0,6,12,2,5]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(w){this._openers=new Map,this._proxy=w.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(w,C,R,k){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const S=k.schemes.find(T=>!_.supportedSchemes.has(T));if(S)throw new Error(`Scheme '${S}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,R),this._proxy.$registerUriOpener(C,k.schemes,w,k.label),(0,l.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(w,C,R){const k=this._openers.get(w);if(!k)throw new Error(`Unknown opener with id: ${w}`);const S=D.URI.revive(C);return k.canOpenExternalUri(S,R)}async $openUri(w,C,R){const k=this._openers.get(w);if(!k)throw new Error(`Unknown opener id: '${w}'`);return k.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(De[261],Ie([1,0,5,2,6,10,28]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.handles.has(_.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const k=I.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(C)),this.handlers.set(k,R),this._proxy.$registerUriHandler(k,C),(0,D.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(C)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(C,R){const k=this.handlers.get(C);if(!k)return Promise.resolve(void 0);try{k.handleUri(t.URI.revive(R))}catch(S){(0,P.onUnexpectedError)(S)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[69],Ie([1,0,4,12,2,187,206,88,5]),function(J,e,l,t,D,P,_,I,w){"use strict";var C,R,k,S,T,E,g,b,m,v,p,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(d,f,y,L,M,B,A){C.set(this,void 0),R.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),g.set(this,""),b.set(this,void 0),m.set(this,!1),v.set(this,!1),p.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new l.Emitter),this._onDidDispose=Ue(this,a,"f").event,tt(this,C,d,"f"),tt(this,R,f,"f"),tt(this,b,y,"f"),tt(this,S,L,"f"),tt(this,T,M,"f"),tt(this,E,B,"f"),tt(this,p,i(B),"f"),tt(this,k,A,"f")}dispose(){tt(this,m,!0,"f"),Ue(this,a,"f").fire(),Ue(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(d){return tt(this,v,!0,"f"),(0,I.asWebviewUri)(d,Ue(this,S,"f"))}get cspSource(){const d=Ue(this,E,"f").extensionLocation;if(d.scheme===t.Schemas.https||d.scheme===t.Schemas.http){let f=d.toString();return f.endsWith("/")||(f+="/"),f+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,g,"f")}set html(d){this.assertNotDisposed(),Ue(this,g,"f")!==d&&(tt(this,g,d,"f"),!Ue(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(d)&&(tt(this,v,!0,"f"),Ue(this,k,"f").report("Webview vscode-resource: uris",Ue(this,E,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,R,"f").$setHtml(Ue(this,C,"f"),d))}get options(){return this.assertNotDisposed(),Ue(this,b,"f")}set options(d){this.assertNotDisposed(),Ue(this,R,"f").$setOptions(Ue(this,C,"f"),r(Ue(this,E,"f"),Ue(this,T,"f"),d)),tt(this,b,d,"f")}async postMessage(d){if(Ue(this,m,"f"))return!1;const f=(0,_.serializeWebviewMessage)(d,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,R,"f").$postMessage(Ue(this,C,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Ue(this,m,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,C=new WeakMap,R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,g=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap,p=new WeakMap,a=new WeakMap;function i(c){try{const d=(0,P.normalizeVersion)((0,P.parseVersion)(c.engines.vscode));return!!d&&d.majorBase>=1&&d.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class u{constructor(d,f,y,L,M){this.remoteInfo=f,this.workspace=y,this._logService=L,this._deprecationService=M,this._webviews=new Map,this._webviewProxy=d.getProxy(w.MainContext.MainThreadWebviews)}$onMessage(d,f,y){const L=this.getWebview(d);if(L){const{message:M}=(0,_.deserializeWebviewMessage)(f,y.value);L._onMessageEmitter.fire(M)}}$onMissingCsp(d,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(d,f,y){const L=new h(d,this._webviewProxy,s(f),this.remoteInfo,this.workspace,y,this._deprecationService);return this._webviews.set(d,L),L._onDidDispose(()=>{this._webviews.delete(d)}),L}deleteWebview(d){this._webviews.delete(d)}getWebview(d){return this._webviews.get(d)}}e.ExtHostWebviews=u;function o(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=o;function r(c,d,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||n(c,d)}}e.serializeWebviewOptions=r;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(d=>D.URI.from(d))}}e.reviveOptions=s;function n(c,d){return[...(d?.getWorkspaceFolders()||[]).map(f=>f.uri),c.extensionLocation]}}),define(De[262],Ie([1,0,21,61,6,12,22,2,16,69,87,5,7]),function(J,e,l,t,D,P,_,I,w,C,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(i,u){this.document=i,this._storagePath=u,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,u){await this.getEdit(i).undo(),u||this.disposeBackup()}async redo(i,u){await this.getEdit(i).redo(),u||this.disposeBackup()}disposeEdits(i){for(const u of i)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=a(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const u=this._edits.get(i,0);if(!u)throw new Error("No edit found");return u}}class E{constructor(){this._documents=new Map}get(i,u){return this._documents.get(this.key(i,u))}add(i,u,o){const r=this.key(i,u.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${u.uri}`);const s=new T(u,o);return this._documents.set(r,s),s}delete(i,u){const o=this.key(i,u.uri);this._documents.delete(o)}key(i,u){return`${i}@@@${u}`}}var g;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(g||(g={}));class b{constructor(){this._providers=new Map}addTextProvider(i,u,o){return this.add(0,i,u,o)}addCustomProvider(i,u,o){return this.add(1,i,u,o)}get(i){return this._providers.get(i)}add(i,u,o,r){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:i,extension:o,provider:r}),new S.Disposable(()=>this._providers.delete(u))}}class m{constructor(i,u,o,r,s){this._extHostDocuments=u,this._extensionStoragePaths=o,this._extHostWebview=r,this._extHostWebviewPanels=s,this._editorProviders=new b,this._documents=new E,this._proxy=i.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,u,o,r){const s=new D.DisposableStore;return v(o)?(s.add(this._editorProviders.addTextProvider(u,i,o)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(i),u,r.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(i))):(s.add(this._editorProviders.addCustomProvider(u,i,o)),this.supportEditing(o)&&s.add(o.onDidChangeCustomDocument(n=>{const c=this.getCustomDocumentEntry(u,n.document.uri);if(p(n)){const d=c.addEdit(n);this._proxy.$onDidEdit(n.document.uri,u,d,n.label)}else this._proxy.$onContentChange(n.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(i),u,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(i))),S.Disposable.from(s,new S.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(i,u,o,r,s){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${u}'`);const c=I.URI.revive(i),d=await n.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:r?.buffer},s);let f;return this.supportEditing(n.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension)),this._documents.add(u,d,f),{editable:this.supportEditing(n.provider)}}async $disposeCustomDocument(i,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const r=I.URI.revive(i),{document:s}=this.getCustomDocumentEntry(u,r);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(i,u,o,r,s,n){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const d=w.ViewColumn.to(s),f=this._extHostWebview.createNewWebview(u,r.webviewOptions,c.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(u,o,r.title,d,r.panelOptions,f,!0),L=I.URI.revive(i);switch(c.type){case 1:{const{document:M}=this.getCustomDocumentEntry(o,L);return c.provider.resolveCustomEditor(M,y,n)}case 0:{const M=this._extHostDocuments.getDocument(L);return c.provider.resolveCustomTextEditor(M,y,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,u,o){this.getCustomDocumentEntry(u,i).disposeEdits(o)}async $onMoveCustomEditor(i,u,o){const r=this._editorProviders.get(o);if(!r)throw new Error(`No provider found for '${o}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const s=this._extHostWebviewPanels.getWebviewPanel(i);if(!s)throw new Error("No webview found");const n=I.URI.revive(u),c=this._extHostDocuments.getDocument(n);await r.provider.moveCustomTextEditor(c,s,l.CancellationToken.None)}async $undo(i,u,o,r){return this.getCustomDocumentEntry(u,i).undo(o,r)}async $redo(i,u,o,r){return this.getCustomDocumentEntry(u,i).redo(o,r)}async $revert(i,u,o){const r=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).revertCustomDocument(r.document,o),r.disposeBackup()}async $onSave(i,u,o){const r=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).saveCustomDocument(r.document,o),r.disposeBackup()}async $onSaveAs(i,u,o,r){const s=this.getCustomDocumentEntry(u,i);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,I.URI.revive(o),r)}async $backup(i,u,o){const r=this.getCustomDocumentEntry(u,i),n=await this.getCustomEditorProvider(u).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},o);return r.updateBackup(n),n.id}getCustomDocumentEntry(i,u){const o=this._documents.get(i,I.URI.revive(u));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(i){const o=this._editorProviders.get(i)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function v(h){return typeof h.resolveCustomTextEditor=="function"}function p(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function a(h){const i=h.scheme===P.Schemas.file||h.scheme===P.Schemas.untitled?h.fsPath:h.toString();return(0,t.hash)(i)+""}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[263],Ie([1,0,4,6,2,34,16,69,5,7]),function(J,e,l,t,D,P,_,I,w,C){"use strict";var R,k,S,T,E,g,b,m,v,p,a,h,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends t.Disposable{constructor(n,c,d,f){super(),R.set(this,void 0),k.set(this,void 0),S.set(this,void 0),T.set(this,void 0),E.set(this,void 0),g.set(this,void 0),b.set(this,void 0),m.set(this,void 0),v.set(this,!0),p.set(this,void 0),a.set(this,!1),h.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,h,"f").event,i.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,tt(this,R,n,"f"),tt(this,k,c,"f"),tt(this,T,d,"f"),tt(this,S,f.viewType,"f"),tt(this,E,f.panelOptions,"f"),tt(this,m,f.viewColumn,"f"),tt(this,g,f.title,"f"),tt(this,p,f.active,"f")}dispose(){Ue(this,a,"f")||(tt(this,a,!0,"f"),Ue(this,h,"f").fire(),Ue(this,k,"f").$disposeWebview(Ue(this,R,"f")),Ue(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,T,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,S,"f")}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(n){this.assertNotDisposed(),Ue(this,g,"f")!==n&&(tt(this,g,n,"f"),Ue(this,k,"f").$setTitle(Ue(this,R,"f"),n))}get iconPath(){return this.assertNotDisposed(),Ue(this,b,"f")}set iconPath(n){this.assertNotDisposed(),Ue(this,b,"f")!==n&&(tt(this,b,n,"f"),Ue(this,k,"f").$setIconPath(Ue(this,R,"f"),D.URI.isUri(n)?{light:n,dark:n}:n))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,m,"f")=="number"&&Ue(this,m,"f")<0))return Ue(this,m,"f")}get active(){return this.assertNotDisposed(),Ue(this,p,"f")}get visible(){return this.assertNotDisposed(),Ue(this,v,"f")}_updateViewState(n){Ue(this,a,"f")||(this.active!==n.active||this.visible!==n.visible||this.viewColumn!==n.viewColumn)&&(tt(this,p,n.active,"f"),tt(this,v,n.visible,"f"),tt(this,m,n.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(n,c){this.assertNotDisposed(),Ue(this,k,"f").$reveal(Ue(this,R,"f"),{viewColumn:typeof n>"u"?void 0:_.ViewColumn.from(n),preserveFocus:!!c})}assertNotDisposed(){if(Ue(this,a,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,g=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap,p=new WeakMap,a=new WeakMap,h=new WeakMap,i=new WeakMap;class o{constructor(n,c,d){this.webviews=c,this.workspace=d,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=n.getProxy(w.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(n,c,d,f,y={}){const L=typeof f=="object"?f.viewColumn:f,M={viewColumn:_.ViewColumn.from(L),preserveFocus:typeof f=="object"&&!!f.preserveFocus},B=(0,I.shouldSerializeBuffersForPostMessage)(n),A=o.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(n),A,c,{title:d,panelOptions:r(y),webviewOptions:(0,I.serializeWebviewOptions)(n,this.workspace,y),serializeBuffersForPostMessage:B},M);const W=this.webviews.createNewWebview(A,y,n);return this.createNewWebviewPanel(A,c,d,L,y,W,!0)}$onDidChangeWebviewPanelViewStates(n){const c=Object.keys(n);c.sort((d,f)=>{const y=n[d],L=n[f];return y.active?1:L.active?-1:+y.visible-+L.visible});for(const d of c){const f=this.getWebviewPanel(d);if(!f)continue;const y=n[d];f._updateViewState({active:y.active,visible:y.visible,viewColumn:_.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(n){this.getWebviewPanel(n)?.dispose(),this._webviewPanels.delete(n),this.webviews.deleteWebview(n)}registerWebviewPanelSerializer(n,c,d){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:d,extension:n}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(n)}),new C.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(n,c,d,f){const y=this._serializers.get(c);if(!y)throw new Error(`No serializer found for '${c}'`);const{serializer:L,extension:M}=y,B=this.webviews.createNewWebview(n,d.webviewOptions,M),A=this.createNewWebviewPanel(n,c,d.title,f,d.panelOptions,B,d.active);await L.deserializeWebviewPanel(A,d.state)}createNewWebviewPanel(n,c,d,f,y,L,M){const B=new u(n,this._proxy,L,{viewType:c,title:d,viewColumn:f,panelOptions:y,active:M});return this._webviewPanels.set(n,B),B}getWebviewPanel(n){return this._webviewPanels.get(n)}}e.ExtHostWebviewPanels=o;function r(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[264],Ie([1,0,4,6,69,16,5,7]),function(J,e,l,t,D,P,_,I){"use strict";var w,C,R,k,S,T,E,g,b,m,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends t.Disposable{constructor(i,u,o,r,s,n,c){super(),w.set(this,void 0),C.set(this,void 0),R.set(this,void 0),k.set(this,void 0),S.set(this,!1),T.set(this,void 0),E.set(this,void 0),g.set(this,void 0),b.set(this,void 0),m.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Ue(this,m,"f").event,v.set(this,this._register(new l.Emitter)),this.onDidDispose=Ue(this,v,"f").event,tt(this,R,o,"f"),tt(this,E,r,"f"),tt(this,w,i,"f"),tt(this,C,u,"f"),tt(this,k,s,"f"),tt(this,T,c,"f")}dispose(){Ue(this,S,"f")||(tt(this,S,!0,"f"),Ue(this,v,"f").fire(),Ue(this,k,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,E,"f")}set title(i){this.assertNotDisposed(),Ue(this,E,"f")!==i&&(tt(this,E,i,"f"),Ue(this,C,"f").$setWebviewViewTitle(Ue(this,w,"f"),i))}get description(){return this.assertNotDisposed(),Ue(this,g,"f")}set description(i){this.assertNotDisposed(),Ue(this,g,"f")!==i&&(tt(this,g,i,"f"),Ue(this,C,"f").$setWebviewViewDescription(Ue(this,w,"f"),i))}get visible(){return Ue(this,T,"f")}get webview(){return Ue(this,k,"f")}get viewType(){return Ue(this,R,"f")}_setVisible(i){i===Ue(this,T,"f")||Ue(this,S,"f")||(tt(this,T,i,"f"),Ue(this,m,"f").fire())}get badge(){return this.assertNotDisposed(),Ue(this,b,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Ue(this,b,"f")?.value&&i?.tooltip===Ue(this,b,"f")?.tooltip)&&(tt(this,b,P.ViewBadge.from(i),"f"),Ue(this,C,"f").$setWebviewViewBadge(Ue(this,w,"f"),i))}show(i){this.assertNotDisposed(),Ue(this,C,"f").$show(Ue(this,w,"f"),!!i)}assertNotDisposed(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}w=new WeakMap,C=new WeakMap,R=new WeakMap,k=new WeakMap,S=new WeakMap,T=new WeakMap,E=new WeakMap,g=new WeakMap,b=new WeakMap,m=new WeakMap,v=new WeakMap;class a{constructor(i,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,o,r){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:o,extension:i}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(i),u,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(i)}),new I.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,o,r,s){const n=this._viewProviders.get(u);if(!n)throw new Error(`No view provider found for '${u}'`);const{provider:c,extension:d}=n,f=this._extHostWebview.createNewWebview(i,{},d),y=new p(i,this._proxy,u,o,f,d,!0);this._webviewViews.set(i,y),await c.resolveWebviewView(y,{state:r},s)}async $onDidChangeWebviewViewVisibility(i,u){this.getWebviewView(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.getWebviewView(i);this._webviewViews.delete(i),u.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const u=this._webviewViews.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=a}),define(De[138],Ie([1,0,4,5,2,12,8,3,15]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Zn{constructor(k){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zn.InitialState,this._proxy=k.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(S=>this.$onDidChangeWindowFocus(S))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state={...this._state,focused:k},this._onDidChangeWindowState.fire(this._state))}openUri(k,S){let T;if(typeof k=="string"){T=k;try{k=D.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,_.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,T,S)}async asExternalUri(k,S){if((0,_.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(k,S);return D.URI.from(T)}};C.InitialState={focused:!0},C=qe([xe(0,w.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(De[265],Ie([1,0,112,266,62,37,2,14,45]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(S,T,E){this._commands=S,this.logService=T,this._ipcHandlePath=E,this._server=t.createServer((g,b)=>this.onRequest(g,b)),this.setup().catch(g=>(T.error(g),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",S=>this.logService.error(S))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(S,T){const E=(b,m)=>{T.writeHead(b,{"content-type":"application/json"}),T.end(JSON.stringify(m||null),v=>v&&this.logService.error(v))},g=[];S.setEncoding("utf8"),S.on("data",b=>g.push(b)),S.on("end",async()=>{try{const b=JSON.parse(g.join(""));let m;switch(b.type){case"open":m=await this.open(b);break;case"openExternal":m=await this.openExternal(b);break;case"status":m=await this.getStatus(b);break;case"extensionManagement":m=await this.manageExtensions(b);break;default:E(404,`Unknown message type: ${b.type}`);break}E(200,m)}catch(b){const m=b instanceof Error?b.message:JSON.stringify(b);E(500,m),this.logService.error("Error while processing pipe request",b)}})}async open(S){const{fileURIs:T,folderURIs:E,forceNewWindow:g,diffMode:b,mergeMode:m,addMode:v,forceReuseWindow:p,gotoLineMode:a,waitMarkerFilePath:h,remoteAuthority:i}=S,u=[];if(Array.isArray(E))for(const n of E)try{u.push({folderUri:_.URI.parse(n)})}catch{}if(Array.isArray(T))for(const n of T)try{(0,w.hasWorkspaceFileExtension)(n)?u.push({workspaceUri:_.URI.parse(n)}):u.push({fileUri:_.URI.parse(n)})}catch{}const o=h?_.URI.file(h):void 0,s={forceNewWindow:g,diffMode:b,mergeMode:m,addMode:v,gotoLineMode:a,forceReuseWindow:p,preferNewWindow:!p&&!o&&!v,waitMarkerFileURI:o,remoteAuthority:i};return this._commands.executeCommand("_remoteCLI.windowOpen",u,s),""}async openExternal(S){for(const T of S.uris){const E=_.URI.parse(T),g=E.scheme==="file"?E:T;await this._commands.executeCommand("_remoteCLI.openExternal",g)}}async manageExtensions(S){const T=g=>g?.map(b=>/\.vsix$/i.test(b)?_.URI.parse(b):b),E={list:S.list,install:T(S.install),uninstall:T(S.uninstall),force:S.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",E)}async getStatus(S){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let R=class extends C{constructor(S,T){super(S,T,(0,l.createRandomIPCHandle)())}};R=qe([xe(0,P.IExtHostCommands),xe(1,I.ILogService)],R),e.CLIServer=R}),define(De[267],Ie([1,0,239,26,15]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const P=1024*1024;let _=class extends l.AbstractExtHostConsoleForwarder{constructor(w,C){super(w,C),this._isMakingConsoleCall=!1,this._wrapStream("stderr","error"),this._wrapStream("stdout","log")}_nativeConsoleLogMessage(w,C,R){const k=w==="error"||w==="warn"?process.stderr:process.stdout;this._isMakingConsoleCall=!0,k.write(`
START_NATIVE_LOG
`),C.apply(console,R),k.write(`
END_NATIVE_LOG
`),this._isMakingConsoleCall=!1}_wrapStream(w,C){const R=process[w],k=R.write;let S="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(T,E,g)=>{if(!this._isMakingConsoleCall){S+=T.toString(E);const b=S.length>P?S.length:S.lastIndexOf(`
`);b!==-1&&(console[C](S.slice(0,b)),S=S.slice(b+1))}k.call(R,T,E,g)}})}};_=qe([xe(0,D.IExtHostRpcService),xe(1,t.IExtHostInitDataService)],_),e.ExtHostConsoleForwarder=_}),define(De[268],Ie([1,0,9,81,34,37,6,5,2,15]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends _.Disposable{constructor(S,T){super();const E=S.getProxy(I.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async g=>{const b=w.URI.file((0,l.join)((0,t.tmpdir)(),(0,D.generateUuid)()));return await E.$download(g,b),b})}};R=qe([xe(0,C.IExtHostRpcService),xe(1,P.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(De[269],Ie([1,0,136,12,193,34]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class _ extends l.ExtHostLoggerService{doCreateLogger(w,C,R){return w.scheme===t.Schemas.file?new D.SpdLogLogger(R?.name||(0,P.generateUuid)(),w.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,C):super.doCreateLogger(w,C,R)}}e.ExtHostLoggerService=_}),define(De[270],Ie([1,0,62,9,2,68,6,12,18,29]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends P.ExtensionStoragePaths{constructor(){super(...arguments),this._workspaceStorageLock=null}async _getWorkspaceStorageURI(i){const u=await super._getWorkspaceStorageURI(i);if(u.scheme!==I.Schemas.file)return u;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${u.fsPath}.`),u;const o=u.fsPath;let r=0;do{let s;r===0?s=o:s=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${r}`:`${o}-${r}`,await k(s);const n=t.join(s,"vscode.lock"),c=await g(this._logService,n,!1);if(c)return this._workspaceStorageLock=c,process.on("exit",()=>{c.dispose()}),D.URI.file(s);r++}while(r<10);return u}onWillDeactivateAll(){this._workspaceStorageLock?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function k(h){try{await C.Promises.stat(h);return}catch{}try{await C.Promises.mkdir(h,{recursive:!0})}catch{}}const S=1e3,T=10*60*1e3;class E extends _.Disposable{constructor(i,u){super(),this.logService=i,this.filename=u,this._timer=this._register(new w.IntervalTimer),this._timer.cancelAndSet(async()=>{const o=await b(i,u);(!o||o.pid!==process.pid)&&(i.info(`Lock '${u}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(u,new Date,new Date)}catch(r){i.error(r),i.info(`Lock '${u}': Could not update mtime.`)}},S)}dispose(){super.dispose();try{l.unlinkSync(this.filename)}catch{}}async setWillRelease(i){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const u={pid:process.pid,willReleaseAt:Date.now()+i};await C.Promises.writeFile(this.filename,JSON.stringify(u),{flag:"w"})}catch(u){this.logService.error(u)}}}async function g(h,i,u){try{const r={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(i,JSON.stringify(r),{flag:"wx"})}catch(r){h.error(r)}const o=await b(h,i);return!o||o.pid!==process.pid?u?(h.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),p(h,i)):(h.info(`Lock '${i}': Lock acquired.`),new E(h,i))}async function b(h,i){let u;try{u=await C.Promises.readFile(i)}catch(o){return h.error(o),null}try{return JSON.parse(String(u))}catch(o){return h.error(o),null}}async function m(h,i){let u;try{u=await C.Promises.stat(i)}catch(o){return h.error(o),0}return u.mtime.getTime()}function v(h){try{return process.kill(h,0),!0}catch{return!1}}async function p(h,i){const u=await b(h,i);if(!u)return h.info(`Lock '${i}': Could not read pid of lock holder.`),a(h,i);if(u.willReleaseAt){let c=u.willReleaseAt-Date.now();if(c<5e3){for(c>0?h.info(`Lock '${i}': The lockfile is scheduled to be released in ${c} ms.`):h.info(`Lock '${i}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,w.timeout)(Math.min(100,c)),await m(h,i)===0)return a(h,i);c=u.willReleaseAt-Date.now()}return a(h,i)}}if(!v(u.pid))return h.info(`Lock '${i}': The pid ${u.pid} appears to be gone.`),a(h,i);const o=await m(h,i),r=Date.now()-o;if(r<=T)return h.info(`Lock '${i}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;h.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,w.timeout)(2e3);const s=await m(h,i),n=Date.now()-s;return n<=T?(h.info(`Lock '${i}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null):(h.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),a(h,i))}async function a(h,i){h.info(`Lock '${i}': Deleting a stale lock.`);try{await C.Promises.unlink(i)}catch{}return g(h,i,!0)}}),define(De[271],Ie([1,0,34,15,38]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let P=class extends D.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,w,C){return this.createTerminalFromOptions({name:I,shellPath:w,shellArgs:C})}createTerminalFromOptions(I,w){const C=new D.ExtHostTerminal(this._proxy,(0,l.generateUuid)(),I,I.name);return this._terminals.push(C),C.create(I,this._serializeParentTerminal(I,w)),C.value}};P=qe([xe(0,t.IExtHostRpcService)],P),e.ExtHostTerminalService=P}),define(De[272],Ie([1,0,5,15,177,6,26,2,44,22,29,7,11,53,4,123,94,14]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class v extends g.DisposableTunnel{}function p(c){const d=c.trim().split(`
`),f=[];return d.forEach(L=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);M&&M.length>=3&&f.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),f.reduce((L,M)=>(L[M.socket]=M,L),{})}e.getSockets=p;function a(...c){const d=[].concat(...c.map(i));return[...new Map(d.filter(f=>f.st==="0A").map(f=>{const y=f.local_address.split(":");return{socket:parseInt(f.inode,10),ip:h(y[0]),port:parseInt(y[1],16)}}).map(f=>[f.ip+":"+f.port,f])).values()]}e.loadListeningPorts=a;function h(c){let d="";if(c.length===8)for(let f=c.length-2;f>=0;f-=2)d+=parseInt(c.substr(f,2),16),f!==0&&(d+=".");else for(let f=c.length-4;f>=0;f-=4)d+=parseInt(c.substr(f,4),16).toString(16),f!==0&&(d+=":");return d}e.parseIpAddress=h;function i(c){const d=c.trim().split(`
`),f=d.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return d.map(L=>L.trim().split(/\s+/).reduce((M,B,A)=>(M[f[A]||A]=B,M),{}))}e.loadConnectionTable=i;function u(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function o(c){const d=c.trim().split(`
`),f=[];return d.forEach(y=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);L&&L.length>=4&&f.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),f}e.getRootProcesses=o;async function r(c,d,f){const y=f.reduce((M,B)=>(M[B.pid]=B,M),{}),L=[];return c.forEach(({socket:M,ip:B,port:A})=>{const W=d[M]?d[M].pid:void 0,U=W?y[W]?.cmd:void 0;W&&U&&!u(U)&&L.push({host:B,port:A,detail:U,pid:W})}),L}e.findPorts=r;function s(c,d,f){const y=new Map,L=o(d);for(const M of c){const B=f.get(M.port);if(B){y.set(M.port,B);continue}const A=L.find(W=>W.cmd.includes(`${M.port}`));if(A){let W=A,U;do U=L.find(N=>N.ppid===W.pid),U&&(W=U);while(U);y.set(M.port,{host:M.ip,port:M.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else y.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=s;let n=class extends P.Disposable{constructor(d,f,y){super(),this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new E.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=d.getProxy(l.MainContext.MainThreadTunnelService),S.isLinux&&f.remote.isRemote&&f.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(d,f){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(f,d.displayName);if(y){const L=new v(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(L),L}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(d){return Math.max(d*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(d,f){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:d,provider:f}),this._proxy.$registerPortsAttributesProvider(d,y),new k.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(d,f,y,L,M){const B=[];for(const W of d){const U=this._portAttributesProviders.get(W);if(!U)return[];B.push(...await Promise.all(f.map(async N=>U.provider.providePortAttributes(N,y,L,M))))}const A=B.filter(W=>!!W);return A.length>0?A.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(d){if(d&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=d;const f=new b.MovingAverage;let y;for(;this._candidateFindingEnabled;){const L=new Date().getTime(),M=(await this.findCandidatePorts()).filter(A=>(0,g.isLocalhost)(A.host)||(0,g.isAllInterfaces)(A.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(A=>A.port).join(", ")}`);const B=new Date().getTime()-L;f.update(B),(!y||JSON.stringify(y)!==JSON.stringify(M))&&(y=M,await this._proxy.$onFoundNewCandidates(y)),await new Promise(A=>setTimeout(()=>A(),this.calculateDelay(f.value)))}}async setTunnelFactory(d){if(d){if(d.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this._showCandidatePort=d.showCandidatePort,this._proxy.$setCandidateFilter()),d.tunnelFactory){this._forwardPortProvider=d.tunnelFactory;let f=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]);const y=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:f}:void 0;this._proxy.$setTunnelProvider(y)}}else this._forwardPortProvider=void 0;return(0,P.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(d,f){if(this._extensionTunnels.has(d.host)){const y=this._extensionTunnels.get(d.host);y.has(d.port)&&(f&&y.get(d.port).disposeListener.dispose(),await y.get(d.port).tunnel.dispose(),y.delete(d.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(d,f){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(d,f);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const L=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(d.remoteAddress.host)||this._extensionTunnels.set(d.remoteAddress.host,new Map);const M=this._register(L.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(L.remoteAddress))));return this._extensionTunnels.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:L,disposeListener:M}),T.TunnelDtoConverter.fromApiTunnel(L)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(d){const f=await Promise.all(d.map(L=>this._showCandidatePort(L.host,L.port,L.detail??""))),y=d.filter((L,M)=>f[M]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(L=>L.port).join(", ")} to ${y.map(L=>L.port).join(", ")}`),y}async findCandidatePorts(){let d="",f="";try{d=await R.Promises.readFile("/proc/net/tcp","utf8"),f=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const y=a(d,f),L=await new Promise(z=>{(0,w.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(O,x,V)=>{z(x)})}),M=p(L),B=await R.Promises.readdir("/proc"),A=[];for(const z of B)try{const O=Number(z),x=C.joinPath(I.URI.file("/proc"),z);if((await R.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(O)){const q=await R.Promises.readlink(C.joinPath(x,"cwd").fsPath),Y=await R.Promises.readFile(C.joinPath(x,"cmdline").fsPath,"utf8");A.push({pid:O,cwd:q,cmd:Y})}}catch{}const W=[],U=y.filter(z=>{const O=M[z.socket];return O||W.push(z),O}),N=r(U,M,A);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const z=await new Promise(O=>{(0,w.exec)("ps -F -A -l | grep root",(x,V,q)=>{O(V)})});this._foundRootPorts=s(W,z,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return N.then(z=>G?z.concat(G):z)}};n=qe([xe(0,t.IExtHostRpcService),xe(1,_.IExtHostInitDataService),xe(2,m.ILogService)],n),e.ExtHostTunnelService=n}),define(De[273],Ie([1,0,18,23,21,10,4,6,107,233,55]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function S(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const T="$$ref$$",E={[T]:-1};class g{constructor(L,M){this.jsonString=L,this.referencedBuffers=M}}function b(y,L=null,M=!1){const B=[];return{jsonString:(M?S:JSON.stringify)(y,(W,U)=>{if(typeof U>"u")return E;if(typeof U=="object"){if(U instanceof t.VSBuffer){const N=B.push(U)-1;return{[T]:N}}if(L)return L(W,U)}return U}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=b;function m(y,L,M){return JSON.parse(y,(B,A)=>{if(A){const W=A[T];if(typeof W=="number")return L[W];if(M&&A.$mid===1)return M.transformIncoming(A)}return A})}e.parseJsonAndRestoreBufferRefs=m;function v(y,L){return JSON.stringify(y,L)}function p(y){return y?(L,M)=>M&&M.$mid===1?y.transformOutgoing(M):M:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class r extends I.Disposable{constructor(L,M=null,B=null){super(),this[k]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=L,this._logger=M,this._uriTransformer=B,this._uriReplacer=p(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,W=R.ProxyIdentifier.count;A<W;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(L=>{this._pendingRPCReplies[L].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(L){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(L){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(L){this._responsiveState!==L&&(this._responsiveState=L,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(L){return this._uriTransformer?(0,w.transformIncomingURIs)(L,this._uriTransformer):L}getProxy(L){const{nid:M,sid:B}=L;return this._proxies[M]||(this._proxies[M]=this._createProxy(M,B)),this._proxies[M]}_createProxy(L,M){const B={get:(A,W)=>(typeof W=="string"&&!A[W]&&W.charCodeAt(0)===36&&(A[W]=(...U)=>this._remoteCall(L,W,U)),W===o?M:A[W])};return new Proxy(Object.create(null),B)}set(L,M){return this._locals[L.nid]=M,M}assertRegistered(L){for(let M=0,B=L.length;M<B;M++){const A=L[M];if(!this._locals[A.nid])throw new Error(`Missing proxy instance ${A.sid}`)}}_receiveOneMessage(L){if(this._isDisposed)return;const M=L.byteLength,B=s.read(L,0),A=B.readUInt8(),W=B.readUInt32();switch(A){case 1:case 2:{let{rpcId:U,method:N,args:G}=c.deserializeRequestJSONArgs(B);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(M,W,U,N,G,A===2);break}case 3:case 4:{let{rpcId:U,method:N,args:G}=c.deserializeRequestMixedArgs(B);this._uriTransformer&&(G=(0,w.transformIncomingURIs)(G,this._uriTransformer)),this._receiveRequest(M,W,U,N,G,A===4);break}case 5:{this._logger?.logIncoming(M,W,0,"ack"),this._onDidReceiveAcknowledge(W);break}case 6:{this._receiveCancel(M,W);break}case 7:{this._receiveReply(M,W,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(B);this._uriTransformer&&(U=(0,w.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(M,W,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(M,W,U);break}case 8:{const U=c.deserializeReplyOKVSBuffer(B);this._receiveReply(M,W,U);break}case 11:{let U=c.deserializeReplyErrError(B);this._uriTransformer&&(U=(0,w.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(M,W,U);break}case 12:{this._receiveReplyErr(M,W,void 0);break}default:console.error("received unexpected message"),console.error(L)}}_receiveRequest(L,M,B,A,W,U){this._logger?.logIncoming(L,M,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(B)}.${A}(`,W);const N=String(M);let G,z;if(U){const x=new D.CancellationTokenSource;W.push(x.token),G=this._invokeHandler(B,A,W),z=()=>x.cancel()}else G=this._invokeHandler(B,A,W),z=i;this._cancelInvokedHandlers[N]=z;const O=c.serializeAcknowledged(M);this._logger?.logOutgoing(O.byteLength,M,1,"ack"),this._protocol.send(O),G.then(x=>{delete this._cancelInvokedHandlers[N];const V=c.serializeReplyOK(M,x,this._uriReplacer);this._logger?.logOutgoing(V.byteLength,M,1,"reply:",x),this._protocol.send(V)},x=>{delete this._cancelInvokedHandlers[N];const V=c.serializeReplyErr(M,x);this._logger?.logOutgoing(V.byteLength,M,1,"replyErr:",x),this._protocol.send(V)})}_receiveCancel(L,M){this._logger?.logIncoming(L,M,1,"receiveCancel");const B=String(M);this._cancelInvokedHandlers[B]?.()}_receiveReply(L,M,B){this._logger?.logIncoming(L,M,0,"receiveReply:",B);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const W=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],W.resolveOk(B)}_receiveReplyErr(L,M,B){this._logger?.logIncoming(L,M,0,"receiveReplyErr:",B);const A=String(M);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const W=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let U;B&&(B.$isError?(U=new Error,U.name=B.name,U.message=B.message,U.stack=B.stack):U=B),W.resolveErr(U)}_invokeHandler(L,M,B){try{return Promise.resolve(this._doInvokeHandler(L,M,B))}catch(A){return Promise.reject(A)}}_doInvokeHandler(L,M,B){const A=this._locals[L];if(!A)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const W=A[M];if(typeof W!="function")throw new Error("Unknown method "+M+" on actor "+(0,R.getStringIdentifierForProxy)(L));return W.apply(A,B)}_remoteCall(L,M,B){if(this._isDisposed)return new C.CanceledLazyPromise;let A=null;if(B.length>0&&D.CancellationToken.isCancellationToken(B[B.length-1])&&(A=B.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const W=c.serializeRequestArguments(B,this._uriReplacer),U=++this._lastMessageId,N=String(U),G=new C.LazyPromise;A&&A.onCancellationRequested(()=>{const O=c.serializeCancel(U);this._logger?.logOutgoing(O.byteLength,U,0,"cancel"),this._protocol.send(c.serializeCancel(U))}),this._pendingRPCReplies[N]=G,this._onWillSendRequest(U);const z=c.serializeRequest(U,L,M,W,!!A);return this._logger?.logOutgoing(z.byteLength,U,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${M}(`,B),this._protocol.send(z),G}}e.RPCProtocol=r,k=u,r.UNRESPONSIVE_TIME=3*1e3;class s{constructor(L,M){this._buff=L,this._offset=M}static alloc(L,M,B){const A=new s(t.VSBuffer.alloc(B+1+4),0);return A.writeUInt8(L),A.writeUInt32(M),A}static read(L,M){return new s(L,M)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(L){this._buff.writeUInt8(L,this._offset),this._offset+=1}readUInt8(){const L=this._buff.readUInt8(this._offset);return this._offset+=1,L}writeUInt32(L){this._buff.writeUInt32BE(L,this._offset),this._offset+=4}readUInt32(){const L=this._buff.readUInt32BE(this._offset);return this._offset+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this._buff.writeUInt8(L.byteLength,this._offset),this._offset+=1,this._buff.set(L,this._offset),this._offset+=L.byteLength}readShortString(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readLongString(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+L).toString();return this._offset+=L,B}writeBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this._buff.writeUInt32BE(L.byteLength,this._offset),this._offset+=4,this._buff.set(L,this._offset),this._offset+=L.byteLength}readVSBuffer(){const L=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+L);return this._offset+=L,M}static sizeMixedArray(L){let M=0;M+=1;for(let B=0,A=L.length;B<A;B++){const W=L[B];switch(M+=1,W.type){case 1:M+=this.sizeLongString(W.value);break;case 2:M+=this.sizeVSBuffer(W.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(W.value);for(let U=0;U<W.buffers.length;++U)M+=this.sizeVSBuffer(W.buffers[U]);break;case 4:break}}return M}writeMixedArray(L){this._buff.writeUInt8(L.length,this._offset),this._offset+=1;for(let M=0,B=L.length;M<B;M++){const A=L[M];switch(A.type){case 1:this.writeUInt8(1),this.writeLongString(A.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A.value);break;case 3:this.writeUInt8(3),this.writeUInt32(A.buffers.length),this.writeLongString(A.value);for(let W=0;W<A.buffers.length;++W)this.writeBuffer(A.buffers[W]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this._buff.readUInt8(this._offset);this._offset+=1;const M=new Array(L);for(let B=0;B<L;B++)switch(this.readUInt8()){case 1:M[B]=this.readLongString();break;case 2:M[B]=this.readVSBuffer();break;case 3:{const W=this.readUInt32(),U=this.readLongString(),N=[];for(let G=0;G<W;++G)N.push(this.readVSBuffer());M[B]=new R.SerializableObjectWithBuffers(m(U,N,null));break}case 4:M[B]=void 0;break}return M}}s.sizeUInt32=4;var n;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(n||(n={}));class c{static _useMixedArgSerialization(L){for(let M=0,B=L.length;M<B;M++)if(L[M]instanceof t.VSBuffer||L[M]instanceof R.SerializableObjectWithBuffers||typeof L[M]>"u")return!0;return!1}static serializeRequestArguments(L,M){if(this._useMixedArgSerialization(L)){const B=[];for(let A=0,W=L.length;A<W;A++){const U=L[A];if(U instanceof t.VSBuffer)B[A]={type:2,value:U};else if(typeof U>"u")B[A]={type:4};else if(U instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:G}=b(U.value,M);B[A]={type:3,value:t.VSBuffer.fromString(N),buffers:G}}else B[A]={type:1,value:t.VSBuffer.fromString(v(U,M))}}return{type:1,args:B}}return{type:0,args:v(L,M)}}static serializeRequest(L,M,B,A,W){switch(A.type){case 0:return this._requestJSONArgs(L,M,B,A.args,W);case 1:return this._requestMixedArgs(L,M,B,A.args,W)}}static _requestJSONArgs(L,M,B,A,W){const U=t.VSBuffer.fromString(B),N=t.VSBuffer.fromString(A);let G=0;G+=s.sizeUInt8(),G+=s.sizeShortString(U),G+=s.sizeLongString(N);const z=s.alloc(W?2:1,L,G);return z.writeUInt8(M),z.writeShortString(U),z.writeLongString(N),z.buffer}static deserializeRequestJSONArgs(L){const M=L.readUInt8(),B=L.readShortString(),A=L.readLongString();return{rpcId:M,method:B,args:JSON.parse(A)}}static _requestMixedArgs(L,M,B,A,W){const U=t.VSBuffer.fromString(B);let N=0;N+=s.sizeUInt8(),N+=s.sizeShortString(U),N+=s.sizeMixedArray(A);const G=s.alloc(W?4:3,L,N);return G.writeUInt8(M),G.writeShortString(U),G.writeMixedArray(A),G.buffer}static deserializeRequestMixedArgs(L){const M=L.readUInt8(),B=L.readShortString(),A=L.readMixedArray(),W=new Array(A.length);for(let U=0,N=A.length;U<N;U++){const G=A[U];typeof G=="string"?W[U]=JSON.parse(G):W[U]=G}return{rpcId:M,method:B,args:W}}static serializeAcknowledged(L){return s.alloc(5,L,0).buffer}static serializeCancel(L){return s.alloc(6,L,0).buffer}static serializeReplyOK(L,M,B){if(typeof M>"u")return this._serializeReplyOKEmpty(L);if(M instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(L,M);if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:A,referencedBuffers:W}=b(M.value,B,!0);return this._serializeReplyOKJSONWithBuffers(L,A,W)}else return this._serializeReplyOKJSON(L,S(M,B))}static _serializeReplyOKEmpty(L){return s.alloc(7,L,0).buffer}static _serializeReplyOKVSBuffer(L,M){let B=0;B+=s.sizeVSBuffer(M);const A=s.alloc(8,L,B);return A.writeVSBuffer(M),A.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static _serializeReplyOKJSON(L,M){const B=t.VSBuffer.fromString(M);let A=0;A+=s.sizeLongString(B);const W=s.alloc(9,L,A);return W.writeLongString(B),W.buffer}static _serializeReplyOKJSONWithBuffers(L,M,B){const A=t.VSBuffer.fromString(M);let W=0;W+=s.sizeUInt32,W+=s.sizeLongString(A);for(const N of B)W+=s.sizeVSBuffer(N);const U=s.alloc(10,L,W);U.writeUInt32(B.length),U.writeLongString(A);for(const N of B)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(L){const M=L.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(L,M){const B=L.readUInt32(),A=L.readLongString(),W=[];for(let U=0;U<B;++U)W.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(m(A,W,M))}static serializeReplyErr(L,M){const B=M?S(P.transformErrorForSerialization(M),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(L);const A=t.VSBuffer.fromString(B);let W=0;W+=s.sizeLongString(A);const U=s.alloc(11,L,W);return U.writeLongString(A),U.buffer}static deserializeReplyErrError(L){const M=L.readLongString();return JSON.parse(M)}static _serializeReplyErrEmpty(L){return s.alloc(12,L,0).buffer}}var d;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(De[274],Ie([1,0,4,43,52,3,42,10,18]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,P.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new l.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new l.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(E){this.channels.has(E.id)||(this.channels.set(E.id,E),this._onDidRegisterChannel.fire(E.id))}getChannels(){const E=[];return this.channels.forEach(g=>E.push(g)),E}getChannel(E){return this.channels.get(E)}removeChannel(E){this.channels.delete(E),this._onDidRemoveChannel.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new R);function k(T,E,g,b,m){return(0,w.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(g,b);const p=t.Registry.as(e.Extensions.OutputChannels);try{await S(g,1,b,m,v),p.registerChannel({id:T,label:E,file:g,log:!0})}catch(a){(0,I.isCancellationError)(a)||m.error("Error while registering log channel",g.toString(),(0,I.getErrorMessage)(a))}})}e.registerLogChannel=k;async function S(T,E,g,b,m){if(!await g.exists(T)){if(m.isCancellationRequested)throw new I.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");b.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,w.timeout)(1e3,m),await S(T,E+1,g,b,m)}}}),define(De[139],Ie([1,0,5,6,3,15,14,274,67,26,46,152,23,13]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends t.Disposable{constructor(m,v,p,a){super(),this.id=m,this.name=v,this.logger=p,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(m){this.append(m+`
`)}append(m){this.write(m),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,m)}replace(m){const v=this.offset;this.write(m),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(m,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:v))}hide(){this.proxy.$close(this.id)}write(m){this.offset+=S.VSBuffer.fromString(m).byteLength,this.logger.info(m)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let g=class{constructor(m,v,p,a,h){this.extHostFileSystem=p,this.extHostFileSystemInfo=a,this.loggerService=h,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[v,p]of this.channels)p.visible=v===this.visibleChannelId}createOutputChannel(m,v,p){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const a=this.doCreateOutputChannel(m,v,p);return a.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(m,a)}async doCreateOutputChannel(m,v,p){const a=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(a,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(m,!1,h,v,p.identifier.value);return new E(u,m,i,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(m,v){let p=!1;const a=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return m},append(h){a(),v.then(i=>i.append(h))},appendLine(h){a(),v.then(i=>i.appendLine(h))},clear(){a(),v.then(h=>h.clear())},replace(h){a(),v.then(i=>i.replace(h))},show(h,i){a(),v.then(u=>u.show(h,i))},hide(){a(),v.then(h=>h.hide())},dispose(){p=!0,v.then(h=>h.dispose())}}}};g=qe([xe(0,P.IExtHostRpcService),xe(1,C.IExtHostInitDataService),xe(2,w.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,_.ILoggerService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(De[275],Ie([1,0,3]),function(J,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(De[276],Ie([1,0,31,12,9,11,22,2,3,202,45,219,275]),function(J,e,l,t,D,P,_,I,w,C,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,w.createDecorator)("pathService");let T=class ei{constructor(g,b,m,v){this.localUserHome=g,this.remoteAgentService=b,this.environmentService=m,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||P.OS)(),this.resolveUserHome=(async()=>{const p=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=p?.userHome??g})()}hasValidBasename(g,b,m){return typeof b=="string"||typeof b>"u"?this.resolveOS.then(v=>this.doHasValidBasename(g,v,b)):this.doHasValidBasename(g,b,m)}doHasValidBasename(g,b,m){return g.scheme===t.Schemas.file||g.scheme===t.Schemas.vscodeRemote?(0,l.isValidBasename)(m??(0,_.basename)(g),b===1):!0}get defaultUriScheme(){return ei.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(g,b){if(g.remoteAuthority)return t.Schemas.vscodeRemote;const m=(0,C.getVirtualWorkspaceScheme)(b.getWorkspace());if(m)return m;const v=b.getWorkspace().folders[0];if(v)return v.uri.scheme;const p=b.getWorkspace().configuration;return p?p.scheme:t.Schemas.file}userHome(g){return g?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(g=>g===1?D.win32:D.posix)}async fileURI(g){let b="";if(await this.resolveOS===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const v=g.indexOf("/",2);v===-1?(b=g.substring(2),g="/"):(b=g.substring(2,v),g=g.substring(v)||"/")}return I.URI.from({scheme:t.Schemas.file,authority:b,path:g,query:"",fragment:""})}};T=qe([xe(1,S.IRemoteAgentService),xe(2,k.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(De[70],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(_,I){this.line=_,this.character=I}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,I){return new l(0,0)}with(_){return new l(0,0)}}e.Position=l;class t{constructor(_,I,w,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(_,I),this.end=new l(w,C)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new t(0,0,0,0)}with(_){return new t(0,0,0,0)}}e.Range=t;var D;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[30],Ie([1,0,17,36,24,31,8,3,9,10,70,18]),function(J,e,l,t,D,P,_,I,w,C,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const S="\u27EA ",T=" characters skipped \u27EB",E=(S.length+T.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var g;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(g=e.SearchProviderType||(e.SearchProviderType={}));var b;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function m(q){return!!q.preview}e.resultIsMatch=m;function v(q){return!!q.resource}e.isFileMatch=v;function p(q){return!!q.message}e.isProgressMessage=p;var a;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(Y){this.resource=Y,this.results=[]}}e.FileMatch=h;class i{constructor(Y,Q,he){this.ranges=Q;const ve=Array.isArray(Q)?Q:[Q];if(he&&he.matchLines===1&&u(ve)){Y=(0,_.getNLines)(Y,he.matchLines);let ne="",pe=0,be=0;const Te=Math.floor(he.charsPerLine/5),Le=[];for(const We of ve){const oe=Math.max(We.startColumn-Te,0),le=We.startColumn+he.charsPerLine;if(oe>be+Te+E){const me=S+(oe-be)+T;ne+=me+Y.slice(oe,le),pe+=oe-(be+me.length)}else ne+=Y.slice(be,le);Le.push(new r(0,We.startColumn-pe,We.endColumn-pe)),be=le}this.preview={text:ne,matches:Array.isArray(this.ranges)?Le:Le[0]}}else{const ne=Array.isArray(Q)?Q[0].startLineNumber:Q.startLineNumber;this.preview={text:Y,matches:(0,l.mapArrayOrNot)(Q,pe=>new o(pe.startLineNumber-ne,pe.startColumn,pe.endLineNumber-ne,pe.endColumn))}}}}e.TextSearchMatch=i;function u(q){const Y=q[0].startLineNumber;for(const Q of q)if(Q.startLineNumber!==Y||Q.endLineNumber!==Y)return!1;return!0}class o{constructor(Y,Q,he,ve){this.startLineNumber=Y,this.startColumn=Q,this.endLineNumber=he,this.endColumn=ve}}e.SearchRange=o;class r extends o{constructor(Y,Q,he){super(Y,Q,Y,he)}}e.OneLineRange=r;var s;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function n(q,Y=!0){const Q=q&&q.files&&q.files.exclude,he=Y&&q&&q.search&&q.search.exclude;if(!Q&&!he)return;if(!Q||!he)return Q||he;let ve=Object.create(null);return ve=D.mixin(ve,D.deepClone(Q)),ve=D.mixin(ve,D.deepClone(he),!0),ve}e.getExcludes=n;function c(q,Y){return q.excludePattern&&t.match(q.excludePattern,Y)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,Y)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(Q=>{const he=Q.folder.fsPath;if(P.isEqualOrParent(Y,he)){const ve=w.relative(he,Y);return!Q.includePattern||!!t.match(Q.includePattern,ve)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var d;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(Y,Q){super(Y),this.code=Q}}e.SearchError=f;function y(q){const Y=q.message;if((0,C.isCancellationError)(q))return new f(Y,d.canceled);try{const Q=JSON.parse(Y);return new f(Q.message,Q.code)}catch{return new f(Y,d.other)}}e.deserializeSearchError=y;function L(q){const Y={message:q.message,code:q.code};return new Error(JSON.stringify(Y))}e.serializeSearchError=L;function M(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=M;function B(q){return q.type==="success"}e.isSerializedSearchSuccess=B;function A(q){return!!q.path}e.isSerializedFileMatch=A;function W(q,Y){const Q=q.searchPath?q.searchPath:q.relativePath;return(0,_.fuzzyContains)(Q,Y)}e.isFilePatternMatch=W;class U{constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function N(q,Y){const Q={...q||{},...Y||{}};return Object.keys(Q).filter(he=>{const ve=Q[he];return typeof ve=="boolean"&&ve})}e.resolvePatternsForProvider=N;class G{constructor(Y,Q){this._parsedIncludeExpression=null,this._excludeExpression={...Y.excludePattern||{},...Q.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let he=Y.includePattern;Q.includePattern&&(he?he={...he,...Q.includePattern}:he=Q.includePattern),he&&(this._parsedIncludeExpression=t.parse(he))}matchesExcludesSync(Y,Q,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,he))}includedInQuerySync(Y,Q,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,Q,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Y,Q,he))}includedInQuery(Y,Q,he){const ve=this._parsedExcludeExpression(Y,Q,he),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Y,Q,he):!0;return(0,k.isThenable)(ve)?ve.then(pe=>pe?!1:ne()):ne()}hasSiblingExcludeClauses(){return z(this._excludeExpression)}}e.QueryGlobTester=G;function z(q){for(const Y in q)if(typeof q[Y]!="boolean")return!0;return!1}function O(q){if(!q)return;let Y;return Q=>(Y||(Y=(q()||Promise.resolve([])).then(he=>he?V(he):{})),Y.then(he=>!!he[Q]))}e.hasSiblingPromiseFn=O;function x(q){if(!q)return;let Y;return Q=>{if(!Y){const he=q();Y=he?V(he):{}}return!!Y[Q]}}e.hasSiblingFn=x;function V(q){const Y={};for(const Q of q)Y[Q]=!0;return Y}}),define(De[32],Ie([1,0,17,18,21,4,6,25,12,94,22,8,13,2,175,3,14,194,45,46,26,15,16,7,54,30,5]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h,i,u,o,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(A,W,U){return new R.ExtUri(N=>y(N,U)).isEqual(A,W)}function c(A,W,U){return n(A.uri,W.uri,U)?0:(0,k.compare)(A.uri.toString(),W.uri.toString())}function d(A,W,U){return A.index!==W.index?A.index<W.index?-1:1:n(A.uri,W.uri,U)?(0,k.compare)(A.name,W.name):(0,k.compare)(A.uri.toString(),W.uri.toString())}function f(A,W,U,N){const G=A.slice(0).sort((O,x)=>U(O,x,N)),z=W.slice(0).sort((O,x)=>U(O,x,N));return(0,l.delta)(G,z,(O,x)=>U(O,x,N))}function y(A,W){const U=W.getCapabilities(A.scheme);return!(U&&U&1024)}class L extends v.Workspace{constructor(W,U,N,G,z,O,x){super(W,N.map(V=>new v.WorkspaceFolder(V)),G,z,x),this._name=U,this._isUntitled=O,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris(x),N.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(W,U,N,G){if(!W)return{workspace:null,added:[],removed:[]};const{id:z,name:O,folders:x,configuration:V,transient:q,isUntitled:Y}=W,Q=[],he=U;U?x.forEach((be,Te)=>{const Le=T.URI.revive(be.uri),We=L._findFolder(N||U,Le,G);We?(We.name=be.name,We.index=be.index,Q.push(We)):Q.push({uri:Le,name:be.name,index:Te})}):Q.push(...x.map(({uri:be,name:Te,index:Le})=>({uri:T.URI.revive(be),name:Te,index:Le}))),Q.sort((be,Te)=>be.index<Te.index?-1:1);const ve=new L(z,O,Q,!!q,V?T.URI.revive(V):null,!!Y,be=>y(be,G)),{added:ne,removed:pe}=f(he?he.workspaceFolders:[],ve.workspaceFolders,c,G);return{workspace:ve,added:ne,removed:pe}}static _findFolder(W,U,N){for(let G=0;G<W.folders.length;G++){const z=W.workspaceFolders[G];if(n(z.uri,U,N))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,U){return U&&this._structure.get(W)&&(W=(0,R.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let M=class{constructor(W,U,N,G,z){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new P.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=G,this._extHostFileSystemInfo=N,this._uriTransformerService=z,this._requestIdProvider=new C.Counter,this._barrier=new t.Barrier,this._proxy=W.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(s.MainContext.MainThreadMessageService);const O=U.workspace;this._confirmedWorkspace=O?new L(O.id,O.name,[],!!O.transient,O.configuration?T.URI.revive(O.configuration):null,!!O.isUntitled,x=>y(x,N)):void 0}$initializeWorkspace(W,U){this._trusted=U,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:w.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,N,...G){const z=[];if(Array.isArray(G)&&G.forEach(Y=>{T.URI.isUri(Y.uri)&&!z.some(Q=>n(Q.uri,Y.uri,this._extHostFileSystemInfo))&&z.push({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri)})}),this._unconfirmedWorkspace||[U,N].some(Y=>typeof Y!="number"||Y<0)||N===0&&z.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+N>O.length)return!1;const x=O.slice(0);x.splice(U,N,...z.map(Y=>({uri:Y.uri,name:Y.name||(0,R.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<x.length;Y++){const Q=x[Y];if(x.some((he,ve)=>ve!==Y&&n(Q.uri,he.uri,this._extHostFileSystemInfo)))return!1}x.forEach((Y,Q)=>Y.index=Q);const{added:V,removed:q}=f(O,x,d,this._extHostFileSystemInfo);if(V.length===0&&q.length===0)return!1;if(this._proxy){const Y=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(Y,U,N,z).then(void 0,Q=>{this._unconfirmedWorkspace=void 0;const he={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Y,Q.toString()),he,[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(W,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let N,G="";if(typeof W=="string"?(N=T.URI.file(W),G=W):typeof W<"u"&&(N=W,G=W.fsPath),!N)return G;const z=this.getWorkspaceFolder(N,!0);if(!z)return G;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let O=(0,R.relativePath)(z.uri,N);return U&&z.name&&(O=`${z.name}/${O}`),O}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=L.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:N,removed:G}=L.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:N,removed:G}))}findFiles(W,U,N,G,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let O;if(U===null?O=!1:U&&(typeof U=="string"?O=U:O=U.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=B(i.GlobPattern.from(W));return this._proxy.$startFileSearch((0,S.withUndefinedAsNull)(x),(0,S.withUndefinedAsNull)(V),(0,S.withUndefinedAsNull)(O),(0,S.withUndefinedAsNull)(N),z).then(q=>Array.isArray(q)?q.map(Y=>T.URI.revive(Y)):[])}async findTextInFiles(W,U,N,G,z=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),x=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:V,folder:q}=B(i.GlobPattern.from(U.include)),Y=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Q={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:x,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:V,excludePattern:Y},he=!1;if(this._activeSearchCallbacks[O]=ve=>{if(he)return;const ne=T.URI.revive(ve.resource);ve.results.forEach(pe=>{(0,r.resultIsMatch)(pe)?N({uri:ne,preview:{text:pe.preview.text,matches:(0,l.mapArrayOrNot)(pe.preview.matches,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,l.mapArrayOrNot)(pe.ranges,be=>new u.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:ne,text:pe.text,lineNumber:pe.lineNumber})})},z.isCancellationRequested)return{};try{const ve=await this._proxy.$startTextSearch(W,(0,S.withUndefinedAsNull)(q),Q,O,z);return delete this._activeSearchCallbacks[O],ve||{}}catch(ve){throw delete this._activeSearchCallbacks[O],ve}}$handleTextSearchResult(W,U){this._activeSearchCallbacks[U]?.(W)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(W,U){if(this._editSessionIdentityProviders.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this._editSessionIdentityProviders.set(W,U);const N=this._uriTransformerService.transformOutgoingScheme(W),G=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(G,N),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(W),this._proxy.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(W,U){this._logService.info("Getting edit session identifier for workspaceFolder",W);const N=await this.resolveWorkspaceFolder(T.URI.revive(W));if(!N){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const G=this._editSessionIdentityProviders.get(N.uri.scheme);if(this._logService.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!G),!G)return;const z=await G.provideEditSessionIdentity(N,U);if(this._logService.info("Provider returned edit session identifier: ",z),!!z)return z}};M=qe([xe(0,h.IExtHostRpcService),xe(1,a.IExtHostInitDataService),xe(2,p.IExtHostFileSystemInfo),xe(3,b.ILogService),xe(4,o.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function B(A){let W,U;return A&&(typeof A=="string"?W=A:(W=A.pattern,U=T.URI.revive(A.baseUri))),{includePattern:W,folder:U}}}),define(De[33],Ie([1,0,24,4,32,5,7,197,120,13,18,3,15,14,2]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function g(u,o){if(o){const r=o.split(".");let s=u;for(let n=0;s&&n<r.length;n++)s=s[r[n]];return s}}function b(u){return u instanceof E.URI}function m(u){return u&&u.uri instanceof E.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function p(u){return u&&u.uri instanceof E.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function a(u){if(b(u))return{resource:u};if(m(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(p(u))return{resource:u.uri};if(u===null)return{resource:null}}let h=class{constructor(o,r,s){this._proxy=o.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new i(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,r){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(o,r))}};h=qe([xe(0,S.IExtHostRpcService),xe(1,D.IExtHostWorkspace),xe(2,T.ILogService)],h),e.ExtHostConfiguration=h;class i{constructor(o,r,s,n){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=n,this._extHostWorkspace=r,this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,r){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,s))}getConfiguration(o,r,s){const n=a(r)||{},c=this._toReadonlyValue(o?g(this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,n,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,n,s?.identifier);function d(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(y){return typeof g(c,y)<"u"},get:(y,L)=>{this._validateConfigurationAccess(o?`${o}.${y}`:y,n,s?.identifier);let M=g(c,y);if(typeof M>"u")M=L;else{let B;const A=(W,U)=>{let N;const G=()=>{B=B||(0,l.deepClone)(c),N=N||g(B,U)};return(0,C.isObject)(W)?new Proxy(W,{get:(z,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return G(),()=>N;if(B)return N=N||g(B,U),N[O];const x=z[O];return typeof O=="string"?A(x,`${U}.${O}`):x},set:(z,O,x)=>(G(),N&&(N[O]=x),!0),deleteProperty:(z,O)=>(G(),N&&delete N[O],!0),defineProperty:(z,O,x)=>(G(),N&&Object.defineProperty(N,O,x),!0)}):W};M=A(M,y)}return M},update:(y,L,M,B)=>{y=o?`${o}.${y}`:y;const A=d(M);return L!==void 0?this._proxy.$updateConfigurationOption(A,y,L,n,B):this._proxy.$removeConfigurationOption(A,y,n,B)},inspect:y=>{y=o?`${o}.${y}`:y;const L=(0,l.deepClone)(this._configuration.inspect(y,n,this._extHostWorkspace.workspace));if(L)return{key:y,defaultValue:L.policy?.value??L.default?.value,globalValue:L.user?.value??L.application?.value,workspaceValue:L.workspace?.value,workspaceFolderValue:L.workspaceFolder?.value,defaultLanguageValue:L.default?.override,globalLanguageValue:L.user?.override??L.application?.override,workspaceLanguageValue:L.workspace?.override,workspaceFolderLanguageValue:L.workspaceFolder?.override,languageIds:L.overrideIdentifiers}}};return typeof c=="object"&&(0,l.mixin)(f,c,!1),Object.freeze(f)}_toReadonlyValue(o){const r=s=>(0,C.isObject)(s)?new Proxy(s,{get:(n,c)=>r(n[c]),set:(n,c,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(n,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(n,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:n=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return r(o)}_validateConfigurationAccess(o,r,s){const n=w.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),c=s?`[${s.value}] `:"";if(n===4){typeof r?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(n===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,r){const s=new I.ConfigurationChangeEvent(o,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(n,c)=>s.affectsConfiguration(n,a(c))})}_toMap(o){return o.reduce((r,s)=>(r.set(s[0],s[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[71],Ie([1,0,2,18,4,5,7,32,56,33,21,38,15,26,3,12,11,14,66,232,10]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(U){function N(z){if(z!=null)return z}U.from=N;function G(z){if(z!=null)return z}U.to=G})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(U){function N(z){if(z!=null)return z}U.from=N;function G(z){if(z!=null)return z}U.to=G})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(U){function N(z){if(z!=null)return z}U.from=N;function G(z){if(z!=null)return z}U.to=G})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(U){function N(O){if(O){const x=O;return x&&!!x.process}else return!1}U.is=N;function G(O){if(O==null)return;const x={process:O.process,args:O.args};return O.options&&(x.options=o.from(O.options)),x}U.from=G;function z(O){if(O!=null)return new _.ProcessExecution(O.process,O.args,O.options)}U.to=z})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(U){function N(z){if(z!=null)return z}U.from=N;function G(z){if(z!=null)return z}U.to=G})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var n;(function(U){function N(O){if(O){const x=O;return x&&(!!x.commandLine||!!x.command)}else return!1}U.is=N;function G(O){if(O==null)return;const x={};return O.commandLine!==void 0?x.commandLine=O.commandLine:(x.command=O.command,x.args=O.args),O.options&&(x.options=s.from(O.options)),x}U.from=G;function z(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new _.ShellExecution(O.commandLine,O.options):new _.ShellExecution(O.command,O.args?O.args:[],O.options)}U.to=z})(n=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(U){function N(O){if(O){const x=O;return x&&x.customExecution==="customExecution"}else return!1}U.is=N;function G(O){return{customExecution:"customExecution"}}U.from=G;function z(O,x){return x.get(O)}U.to=z})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(U){function N(G,z){let O;return G.scope!==void 0&&typeof G.scope!="number"?O=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===_.TaskScope.Workspace&&z&&z.workspaceFile?O=z.workspaceFile:O=p.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:O}}U.from=N})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(U){function N(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}U.from=N})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(U){function N(O,x){if(O==null)return[];const V=[];for(const q of O){const Y=G(q,x);Y&&V.push(Y)}return V}U.fromMany=N;function G(O,x){if(O==null)return;let V;O.execution instanceof _.ProcessExecution?V=r.from(O.execution):O.execution instanceof _.ShellExecution?V=n.from(O.execution):O.execution&&O.execution instanceof _.CustomExecution&&(V=c.from(O.execution));const q=i.from(O.definition);let Y;return O.scope?typeof O.scope=="number"?Y=O.scope:Y=O.scope.uri:Y=_.TaskScope.Workspace,!q||!Y?void 0:{_id:O._id,definition:q,name:O.name,source:{extensionId:x.identifier.value,label:O.source,scope:Y},execution:V,isBackground:O.isBackground,group:f.from(O.group),presentationOptions:u.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=G;async function z(O,x,V){if(O==null)return;let q;r.is(O.execution)?q=r.to(O.execution):n.is(O.execution)?q=n.to(O.execution):c.is(O.execution)&&(q=c.to(O._id,V));const Y=i.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await x.resolveWorkspaceFolder(l.URI.revive(O.source.scope)):Q=_.TaskScope.Workspace),!Y||!Q)return;const he=new _.Task(Y,Q,O.name,O.source.label,q,O.problemMatchers);return O.isBackground!==void 0&&(he.isBackground=O.isBackground),O.group!==void 0&&(he.group=_.TaskGroup.from(O.group._id),he.group&&O.group.isDefault&&(he.group=new _.TaskGroup(he.group.id,he.group.label),O.group.isDefault===!0&&(he.group.isDefault=O.group.isDefault))),O.presentationOptions&&(he.presentationOptions=u.to(O.presentationOptions)),O._id&&(he._id=O._id),O.detail&&(he.detail=O.detail),he}U.to=z})(y=e.TaskDTO||(e.TaskDTO={}));var L;(function(U){function N(z){return z}U.from=N;function G(z){if(!!z)return Object.assign(Object.create(null),z)}U.to=G})(L=e.TaskFilterDTO||(e.TaskFilterDTO={}));class M{constructor(N,G,z){this._id=G,this._task=z,h.set(this,void 0),tt(this,h,N,"f")}get task(){return this._task}terminate(){Ue(this,h,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}h=new WeakMap;var B;(function(U){function N(G){return{id:G._id,task:void 0}}U.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let A=class{constructor(N,G,z,O,x,V,q,Y){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=N.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=O,this._configurationService=x,this._terminalService=V,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=q,this._deprecationService=Y,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,G,z){if(!z)return new _.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:G,provider:z,extension:N}),this._proxy.$registerTaskProvider(O,G),new _.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(N,G){this._proxy.$registerTaskSystem(N,G)}fetchTasks(N){return this._proxy.$fetchTasks(L.from(N)).then(async G=>{const z=[];for(const O of G){const x=await y.to(O,this._workspaceProvider,this._providedCustomExecutions2);x&&z.push(x)}return z})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(G=>N.push(G)),N}terminateTask(N){if(!(N instanceof M))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,G,z){const O=this._providedCustomExecutions2.get(N.id);O&&(this._activeCustomExecutions2.set(N.id,O),this._terminalService.attachPtyToTerminal(G,await O.callback(z))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const G=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const G=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:G,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const G=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:N.exitCode})}$provideTasks(N,G){const z=this._handlers.get(N);if(!z)return Promise.reject(new Error("no handler found"));const O=[],x=(0,t.asPromise)(()=>z.provider.provideTasks(R.CancellationToken.None)).then(V=>this.provideTasksInternal(G,O,z,V));return new Promise(V=>{x.then(q=>{Promise.all(O).then(()=>{V(q)})})})}async $resolveTask(N,G){const z=this._handlers.get(N);if(!z)return Promise.reject(new Error("no handler found"));if(G.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${z.type}].`);const O=await y.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const x=await z.provider.resolveTask(O,R.CancellationToken.None);if(!x)return;this.checkDeprecation(x,z);const V=y.from(x,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(V.execution)&&await this.addCustomExecution(V,x,!0),await this.resolveTaskInternal(V)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,G,z){const O=await this._proxy.$createTaskId(N);!z&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,G.execution)),this._providedCustomExecutions2.set(O,G.execution)}async getTaskExecution(N,G){if(typeof N=="string"){const x=this._taskExecutionPromises.get(N);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}const z=this._taskExecutionPromises.get(N.id);if(z)return z;const O=new Promise((x,V)=>{function q(Y,Q,he){he?x(new M(Y,Q.id,he)):V("Unexpected: Task does not exist.")}G?q(this,N,G):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(Y=>q(this,N,Y))});return this._taskExecutionPromises.set(N.id,O),O.then(x=>(this._taskExecutions.set(N.id,x),x),x=>Promise.reject(x))}checkDeprecation(N,G){N._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const z=this._notProvidedCustomExecutions.values();let O=z.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=z.next()}};A=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,I.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,C.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,m.ILogService),xe(7,v.IExtHostApiDeprecationService)],A),e.ExtHostTaskBase=A;let W=class extends A{constructor(N,G,z,O,x,V,q,Y){super(N,G,z,O,x,V,q,Y),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(N,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const z=y.from(G,N);if(z===void 0)throw new Error("Task is not valid");if(c.is(z.execution))await this.addCustomExecution(z,G,!1);else throw new a.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),G);return this._proxy.$executeTask(z).catch(x=>{throw new Error(x)}),O}provideTasksInternal(N,G,z,O){const x=[];if(O)for(const V of O){this.checkDeprecation(V,z),(!V.definition||!N[V.definition.type])&&this._logService.warn(`The task [${V.source}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`);const q=y.from(V,z.extension);q&&c.is(q.execution)?(x.push(q),G.push(this.addCustomExecution(q,V,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:z.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,G,z){}};W=qe([xe(0,S.IExtHostRpcService),xe(1,T.IExtHostInitDataService),xe(2,I.IExtHostWorkspace),xe(3,w.IExtHostDocumentsAndEditors),xe(4,C.IExtHostConfiguration),xe(5,k.IExtHostTerminalService),xe(6,m.ILogService),xe(7,v.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(De[277],Ie([1,0,9,21,50,36,22,51,30]),function(J,e,l,t,D,P,_,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(S,T,E){this.config=S,this.provider=T,this.sessionToken=E,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=S.filePattern,this.includePattern=S.includePattern&&P.parse(S.includePattern),this.maxResults=S.maxResults||void 0,this.exists=S.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=S.excludePattern&&P.parse(S.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(S=>S.cancel()),this.activeCancellationTokens=new Set}search(S){const T=this.config.folderQueries||[];return new Promise((E,g)=>{const b=m=>{this.resultCount++,S(m)};if(this.isCanceled)return E({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const v=m.toString(),p=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,p)||this.matchFile(b,{base:m,basename:p})}),Promise.all(T.map(m=>this.searchInFolder(m,b))).then(m=>{E({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{g(new Error((0,D.toErrorMessage)(m)))})})}async searchInFolder(S,T){const E=new t.CancellationTokenSource,g=this.getSearchOptionsForFolder(S),b=this.initDirectoryTree(),m=new w.QueryGlobTester(this.config,S),v=!m.hasSiblingExcludeClauses();let p;try{this.activeCancellationTokens.add(E),p=I.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},g,E.token),h=p.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(u=>{const o=l.posix.relative(S.folder.path,u.path);if(v){const r=l.basename(u.path);this.matchFile(T,{base:S.folder,relativePath:o,basename:r});return}this.addDirectoryEntries(b,S.folder,o,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(b,m,T),{providerTime:h,postProcessTime:i.elapsed()})}finally{E.dispose(),this.activeCancellationTokens.delete(E)}}getSearchOptionsForFolder(S){const T=(0,w.resolvePatternsForProvider)(this.config.includePattern,S.includePattern),E=(0,w.resolvePatternsForProvider)(this.config.excludePattern,S.excludePattern);return{folder:S.folder,excludes:E,includes:T,useIgnoreFiles:!S.disregardIgnoreFiles,useGlobalIgnoreFiles:!S.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!S.disregardParentIgnoreFiles,followSymlinks:!S.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const S={rootEntries:[],pathToEntries:Object.create(null)};return S.pathToEntries["."]=S.rootEntries,S}addDirectoryEntries({pathToEntries:S},T,E,g){if(E===this.filePattern){const m=l.basename(this.filePattern);this.matchFile(g,{base:T,relativePath:this.filePattern,basename:m})}function b(m){const v=l.basename(m),p=l.dirname(m);let a=S[p];a||(a=S[p]=[],b(p)),a.push({base:T,relativePath:m,basename:v})}b(E)}matchDirectoryTree({rootEntries:S,pathToEntries:T},E,g){const b=this,m=this.filePattern;function v(p){const a=(0,w.hasSiblingFn)(()=>p.map(h=>h.basename));for(let h=0,i=p.length;h<i;h++){const u=p[h],{relativePath:o,basename:r}=u;if(E.matchesExcludesSync(o,r,m!==r?a:void 0))continue;const s=T[o];if(s)v(s);else{if(o===m)continue;b.matchFile(g,u)}if(b.isLimitHit)break}}v(S)}matchFile(S,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||S(T))}}class R{constructor(){this.sessions=new Map}fileSearch(S,T,E,g){const b=this.getSessionTokenSource(S.cacheKey),m=new C(S,T,b&&b.token);let v=0;const p=a=>{v+=a.length,E(a.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(m,R.BATCH_SIZE,p,g).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:a.stats}}))}clearCache(S){this.getSessionTokenSource(S)?.cancel()}getSessionTokenSource(S){if(!!S)return this.sessions.has(S)||this.sessions.set(S,new t.CancellationTokenSource),this.sessions.get(S)}rawMatchToSearchItem(S){return S.relativePath?{resource:_.joinPath(S.base,S.relativePath)}:{resource:S.base}}doSearch(S,T,E,g){g.onCancellationRequested(()=>{S.cancel()});const b=v=>{v&&(m.push(v),T>0&&m.length>=T&&(E(m),m=[]))};let m=[];return S.search(b).then(v=>(m.length&&E(m),v),v=>(m.length&&E(m),Promise.reject(v)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[278],Ie([1,0,17,76,36,106,25,12,9,22,8,13,2,159,186,83,14,45,129,276,30]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(f,y,L,M,B){this.configurationService=f,this.workspaceContextService=y,this.editorGroupsService=L,this.logService=M,this.pathService=B}text(f,y,L={}){f=this.getContentPattern(f,L);const M=this.configurationService.getValue(),B=y&&y.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep);return{...this.commonQuery(y?.map(m.toWorkspaceFolder),L),type:2,contentPattern:f,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:M.search.usePCRE2||B||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}getContentPattern(f,y){const L=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const M={...f,wordSeparators:L.editor.wordSeparators};return this.isCaseSensitive(f,y)&&(M.isCaseSensitive=!0),this.isMultiline(f)&&(M.isMultiline=!0),M}file(f,y={}){return{...this.commonQuery(f,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(f,y){return f?(f=Array.isArray(f)?f.map(s):s(f),y?this.parseSearchPaths(f):{pattern:u(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],y={}){const L=this.handleIncludeExclude(y.includePattern,y.expandPatterns),M=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),B=f.length>1,A=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,y,M)):f.map(N=>this.getFolderQueryForRoot(N,y,M,B))).filter(N=>!!N),W={_reason:y._reason,folderQueries:A,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:M.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(x=>x.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const G=N.filter(O=>(0,a.pathIncludedInQuery)(W,O.fsPath)),z=this.commonQueryFromFileList(G);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...W,...z}}const U=y.extraFileResources&&y.extraFileResources.filter(N=>(0,a.pathIncludedInQuery)(W,N.fsPath));return W.extraFileResources=U&&U.length?U:void 0,W}commonQueryFromFileList(f){const y=[],L=new _.ResourceMap,M={};let B=!1;return f.forEach(A=>{if(A.scheme===I.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(A)){const U=this.workspaceContextService.getWorkspaceFolder(A)?.uri??A.with({path:w.dirname(A.fsPath)});let N=L.get(U);N||(B=!0,N={folder:U,includePattern:{}},y.push(N),L.set(U,N));const G=w.relative(U.fsPath,A.fsPath);(0,k.assertIsDefined)(N.includePattern)[G.replace(/\\/g,"/")]=!0}else A.fsPath&&(B=!0,M[A.fsPath]=!0)}),{folderQueries:y,includePattern:M,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(f,y){if(y.isSmartCase){if(f.isRegExp){if(R.containsUppercaseCharacter(f.pattern,!0))return!0}else if(R.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,T.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const y=z=>w.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),M=(Array.isArray(f)?f:o(f)).map(z=>{const O=this.pathService.resolvedUserHome;return O?(0,P.untildify)(z,O.scheme===I.Schemas.file?O.fsPath:O.path):z}),B=t.groupBy(M,z=>y(z)?"searchPaths":"exprSegments"),A=(B.exprSegments||[]).map(z=>R.rtrim(z,"/")).map(z=>R.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),W={},U=this.expandSearchPathPatterns(B.searchPaths||[]);U&&U.length&&(W.searchPaths=U);const N=l.flatten(A),G=u(...N);return G&&(W.pattern=G),W}getExcludesForFolder(f,y){return y.disregardExcludeSettings?void 0:(0,a.getExcludes)(f,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const y=l.flatten(f.map(M=>{let{pathPortion:B,globPortion:A}=i(M);A&&(A=n(A));const W=this.expandOneSearchPath(B);return l.flatten(W.map(U=>this.resolveOneSearchPathPattern(U,A)))})),L=new Map;return y.forEach(M=>{const B=M.searchPath.toString(),A=L.get(B);A?M.pattern&&(A.pattern=A.pattern||{},A.pattern[M.pattern]=!0):L.set(B,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(L.values())}expandOneSearchPath(f){if(w.isAbsolute(f)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==I.Schemas.file?[{searchPath:y[0].uri.with({path:f})}]:[{searchPath:S.URI.file(w.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=s(f),f.startsWith("../")||f===".."){const M=w.posix.resolve(y.path,f);return[{searchPath:y.with({path:M})}]}const L=n(f);return[{searchPath:y,pattern:L}]}else{if(f==="./"||f===".\\")return[];{const y=f.replace(/^\.[\/\\]/,""),M=this.workspaceContextService.getWorkspace().folders.map(B=>{const A=y.match(new RegExp(`^${R.escapeRegExpCharacters(B.name)}(?:/(.*)|$)`));return A?{match:A,folder:B}:null}).filter(k.isDefined);if(M.length)return M.map(B=>{const A=B.match[1];return{searchPath:B.folder.uri,pattern:A&&n(A)}});{const B=f.match(/\.[\/\\](.+)[\/\\]?/),A=B?B[1]:f,W=E.localize(0,null,A);throw new Error(W)}}}}resolveOneSearchPathPattern(f,y){const L=f.pattern&&y?`${f.pattern}/${y}`:f.pattern||y,M=[{searchPath:f.searchPath,pattern:L}];return L&&!L.endsWith("**")&&M.push({searchPath:f.searchPath,pattern:L+"/**"}),M}getFolderQueryForSearchPath(f,y,L){const M=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(f.searchPath),y,L,!1);return M?{...M,includePattern:f.pattern}:null}getFolderQueryForRoot(f,y,L,M){let B;const A=S.URI.isUri(f)?f:f.uri;if(L.searchPaths){const z=L.searchPaths.filter(O=>(0,C.isEqual)(O.searchPath,A))[0];if(z&&!z.pattern)return null;z&&(B=z.pattern)}const W=this.configurationService.getValue({resource:A}),N={...this.getExcludesForFolder(W,y)||{},...B||{}},G=S.URI.isUri(f)?(0,C.basename)(f):f.name;return{folder:A,folderName:M?G:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!W.search.followSymlinks}}};h=qe([xe(0,g.IConfigurationService),xe(1,m.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,b.ILogService),xe(4,p.IPathService)],h),e.QueryBuilder=h;function i(d){const f=d.match(/[\*\{\}\(\)\[\]\?]/);if(f){const y=f.index,L=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let M=d.substr(0,L.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:d.substr((L.index||0)+1)}}}return{pathPortion:d}}function u(...d){return d.length?d.reduce((f,y)=>(f[y]=!0,f),Object.create(null)):void 0}function o(d){return D.splitGlobAware(d,",").map(f=>f.trim()).filter(f=>!!f.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function s(d){return d.replace(/\\/g,"/")}function n(d){return s(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(d,f){d=l.distinct(d,M=>M.toString());const y=[],L=f.getWorkspace();return d&&d.forEach(M=>{let B;if(f.getWorkbenchState()===2)B=(0,C.relativePath)(L.folders[0].uri,M),B&&B!=="."&&(B="./"+B);else{const A=f.getWorkspaceFolder(M);if(A){const W=A.name;if(L.folders.filter(N=>N.name===W).length===1){const N=(0,C.relativePath)(A.uri,M);N===""?B=`./${A.name}`:B=`./${A.name}/${N}`}else B=M.fsPath}}B&&y.push(B)}),y}e.resolveResourcesForSearchIncludes=c}),define(De[279],Ie([1,0,22,2,21,10,3,278,30,45]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function k(g,b){const m=b.activationEvents;if(!m)return Promise.resolve(void 0);const v=[],p=[];for(const r of m)if(/^workspaceContains:/.test(r)){const s=r.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||g.forceUsingSearch?p.push(s):v.push(s)}if(v.length===0&&p.length===0)return Promise.resolve(void 0);let a;const h=new Promise((r,s)=>{a=r}),i=r=>a({activationEvent:r}),u=Promise.all(v.map(r=>S(g,r,i))).then(()=>{}),o=T(g,b.identifier,p,i);return Promise.all([u,o]).then(()=>{a(void 0)}),h}e.checkActivateWorkspaceContainsExtension=k;async function S(g,b,m){for(const v of g.folders)if(await g.exists(l.joinPath(t.URI.revive(v),b))){m(`workspaceContains:${b}`);return}}async function T(g,b,m,v){if(m.length===0)return Promise.resolve(void 0);const p=new D.CancellationTokenSource,a=g.checkExists(g.folders,m,p.token),h=setTimeout(async()=>{p.cancel(),g.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},R);let i=!1;try{i=await a}catch(u){P.isCancellationError(u)||P.onUnexpectedError(u)}p.dispose(),clearTimeout(h),i&&v(`workspaceContains:${m.join(",")}`)}function E(g,b,m,v){const p=g.get(_.IInstantiationService),a=g.get(w.ISearchService),i=p.createInstance(I.QueryBuilder).file(b.map(u=>(0,C.toWorkspaceFolder)(t.URI.revive(u))),{_reason:"checkExists",includePattern:m,exists:!0});return a.fileSearch(i,v).then(u=>!!u.limitHit,u=>P.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=E});var tt=this&&this.__classPrivateFieldSet||function(J,e,l,t,D){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?D.call(J,l):D?D.value=l:e.set(J,l),l},Ue=this&&this.__classPrivateFieldGet||function(J,e,l,t){if(l==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!t:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?t:l==="a"?t.call(J):t?t.value:e.get(J)};define(De[39],Ie([1,0,170,9,72,22,18,6,25,2,14,5,33,222,91,32,27,220,10,28,23,203,7,121,3,26,68,15,85,53,38,4,279,90,205,12]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h,i,u,o,r,s,n,c,d,f,y,L,M,B,A){"use strict";var W,U,N;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let G=class Ln extends I.Disposable{constructor(Q,he,ve,ne,pe,be,Te,Le,We,oe){super(),this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=he,this._extHostContext=ve,this._initData=Te,this._extHostWorkspace=ne,this._extHostConfiguration=pe,this._logService=be,this._extHostTunnelService=We,this._extHostTerminalService=oe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new m.ExtensionDescriptionRegistry(this._initData.allExtensions);const le=(0,b.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new m.ExtensionDescriptionRegistry(x(this._globalRegistry,le)),this._storage=new E.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Le,this._instaService=Q.createChild(new c.ServiceCollection([E.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));let me=[],Z=[];this._initData.remote.isRemote&&(me=this._initData.allExtensions.filter(ee=>!ee.main&&!ee.browser).map(ee=>ee.identifier),Z=this._initData.allExtensions.filter(ee=>!le.has(p.ExtensionIdentifier.toKey(ee.identifier.value))).filter(ee=>(ee.main||ee.browser)&&ee.api==="none").map(ee=>ee.identifier));const ae=(0,b.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,me,Z,{onExtensionActivationError:(ee,ie,F)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ee,v.transformErrorForSerialization(ie),F)},actualActivateExtension:async(ee,ie)=>{if(ae.has(p.ExtensionIdentifier.toKey(ee)))return await this._mainThreadExtensionsProxy.$activateExtension(ee,ie),new T.HostExtension;const F=this._myRegistry.getExtensionDescription(ee);return this._activateExtension(F,ie)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Q){v.onUnexpectedError(Q)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let Q=[];try{Q=this._myRegistry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch{}await Promise.all(Q)}terminate(Q,he=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${Q}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const ve=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),ve]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${he}`):this._logService.info(`Extension host exiting with code ${he}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(he)})}isActivated(Q){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Q):!1}async getExtension(Q){const he=await this._mainThreadExtensionsProxy.$getExtension(Q);let ve;if(he?.browserNlsBundleUris){ve={};for(const ne of Object.keys(he.browserNlsBundleUris))ve[ne]=C.URI.revive(he.browserNlsBundleUris[ne])}return he&&{...he,identifier:new p.ExtensionIdentifier(he.identifier.value),extensionLocation:C.URI.revive(he.extensionLocation),browserNlsBundleUris:ve}}_activateByEvent(Q,he){return this._activator.activateByEvent(Q,he)}_activateById(Q,he){return this._activator.activateById(Q,he)}activateByIdWithErrors(Q,he){return this._activateById(Q,he).then(()=>{const ve=this._activator.getActivatedExtension(Q);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Q=>this._myRegistry)}getExtensionExports(Q){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Q).exports:null}async _realPathExtensionUri(Q){if(Q.scheme!==A.Schemas.file)return Q;const he=await this._hostUtils.realpath(Q.fsPath);return C.URI.file(he)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(Q=>new q(Q))),this._extensionPathIndex}async _createExtensionPathIndex(Q){const he=w.TernarySearchTree.forUris(ve=>P.extUriBiasedIgnorePathCase.ignorePathCasing(ve));return await Promise.all(Q.map(async ve=>{if(this._getEntryPoint(ve)){const ne=await this._realPathExtensionUri(ve.extensionLocation);he.set(ne,ve)}})),he}_deactivate(Q){let he=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Q))return he;const ve=this._activator.getActivatedExtension(Q);if(!ve)return he;try{typeof ve.module.deactivate=="function"&&(he=Promise.resolve(ve.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${Q.value}':`),this._logService.error(ne)}try{(0,I.dispose)(ve.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Q.value}':`),this._logService.error(ne)}return he}async _activateExtension(Q,he){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Q.identifier),this._doActivateExtension(Q,he).then(ve=>{const ne=ve.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Q.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,he),this._logExtensionActivationTimes(Q,he,"success",ne),ve},ve=>{throw this._logExtensionActivationTimes(Q,he,"failure"),ve})}_logExtensionActivationTimes(Q,he,ve,ne){const pe=z(Q,he);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ne||{},outcome:ve})}_doActivateExtension(Q,he){const ve=z(Q,he);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ve);const ne=this._getEntryPoint(Q);if(!ne)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Q.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${Q.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this._logService.flush();const pe=new T.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this._loadCommonJSModule(Q,(0,P.joinPath)(Q.extensionLocation,ne),pe),this._loadExtensionContext(Q)]).then(be=>(D.mark(`code/extHost/willActivateExtension/${Q.identifier.value}`),Ln._callActivate(this._logService,Q.identifier,be[0],be[1],pe))).then(be=>(D.mark(`code/extHost/didActivateExtension/${Q.identifier.value}`),be))}_loadExtensionContext(Q){const he=new h.ExtensionGlobalMemento(Q,this._storage),ve=new h.ExtensionMemento(Q.identifier.value,!1,this._storage),ne=new B.ExtensionSecrets(Q,this._secretState),pe=Q.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,be=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Q.identifier.value}`),Promise.all([he.whenReady,ve.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let Le,We;const oe=(0,b.isProposedApiEnabled)(Q,"ipc")?this._initData.messagePorts?.get(p.ExtensionIdentifier.toKey(Q.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:ve,secrets:ne,subscriptions:[],get extensionUri(){return Q.extensionLocation},get extensionPath(){return Q.extensionLocation.fsPath},asAbsolutePath(le){return t.join(Q.extensionLocation.fsPath,le)},get storagePath(){return Te._storagePath.workspaceValue(Q)?.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(Q).fsPath},get logPath(){return t.join(Te._initData.logsLocation.fsPath,Q.identifier.value)},get logUri(){return C.URI.joinPath(Te._initData.logsLocation,Q.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(Q)},get globalStorageUri(){return Te._storagePath.globalValue(Q)},get extensionMode(){return pe},get extension(){return Le===void 0&&(Le=new O(Te,Q.identifier,Q,be,!1)),Le},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(Q,"extensionRuntime"),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(Q)},get messagePassingProtocol(){if(!We){if(!oe)return;const le=y.Event.buffer(y.Event.fromDOMEventEmitter(oe,"message",me=>me.data));oe.start(),We={onDidReceiveMessage:le,postMessage:oe.postMessage.bind(oe)}}return We}})})}static _callActivate(Q,he,ve,ne,pe){return ve=ve||{activate:void 0,deactivate:void 0},this._callActivateOptional(Q,he,ve,ne,pe).then(be=>new T.ActivatedExtension(!1,null,pe.build(),ve,be,ne.subscriptions))}static _callActivateOptional(Q,he,ve,ne,pe){if(typeof ve.activate=="function")try{pe.activateCallStart(),Q.trace(`ExtensionService#_callActivateOptional ${he.value}`);const be=typeof global=="object"?global:self,Te=ve.activate.apply(be,[ne]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Te).then(Le=>(pe.activateResolveStop(),Le))}catch(be){return Promise.reject(be)}else return Promise.resolve(ve)}_activateOneStartupFinished(Q,he){this._activateById(Q.identifier,{startup:!1,extensionId:Q.identifier,activationEvent:he}).then(void 0,ve=>{this._logService.error(ve)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const Q of this._myRegistry.getAllExtensionDescriptions())if(Q.activationEvents)for(const he of Q.activationEvents)he==="onStartupFinished"&&this._activateOneStartupFinished(Q,he)}_handleEagerExtensions(){const Q=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const he=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ve=this._handleWorkspaceContainsEagerExtensions(he),ne=Promise.all([Q,ve]).then(()=>{});return Promise.race([ne,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(Q){return Q.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(he=>this._handleWorkspaceContainsEagerExtension(Q,he))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Q,he){if(this.isActivated(he.identifier))return;const ve=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:Q.map(be=>be.uri),forceUsingSearch:ve,exists:be=>this._hostUtils.exists(be.fsPath),checkExists:(be,Te,Le)=>this._mainThreadWorkspaceProxy.$checkExists(be,Te,Le)},pe=await(0,L.checkActivateWorkspaceContainsExtension)(ne,he);if(!!pe)return this._activateById(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:pe.activationEvent}).then(void 0,be=>this._logService.error(be))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Q){throw console.error(Q),Q}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Q,extensionTestsLocationURI:he}=this._initData.environment;if(!Q||!he)throw new Error(l.localize(0,null));const ve=await this._loadCommonJSModule(null,he,new T.ExtensionActivationTimesBuilder(!1));if(!ve||typeof ve.run!="function")throw new Error(l.localize(1,null,he.toString()));return new Promise((ne,pe)=>{const be=(We,oe)=>{We?pe(We):ne(typeof oe=="number"&&oe>0?1:0)},Te=(0,P.originalFSPath)(he),Le=ve.run(Te,be);Le&&Le.then&&Le.then(()=>{ne(0)}).catch(We=>{pe(We instanceof Error&&We.stack?We.stack:String(We))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Q,he){return this._resolvers[Q]=he,(0,I.toDisposable)(()=>{delete this._resolvers[Q]})}async _activateAndGetResolver(Q){const he=Q.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const ve=Q.substr(0,he);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this._resolvers[ve]}}async $resolveAuthority(Q,he){this._logService.info(`$resolveAuthority invoked for authority (${V(Q)})`);const{authorityPrefix:ve,resolver:ne}=await this._activateAndGetResolver(Q);if(!ne)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ve}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),D.mark(`code/extHost/willResolveAuthority/${ve}`);const pe=await ne.resolve(Q,{resolveAttempt:he});D.mark(`code/extHost/didResolveAuthorityOK/${ve}`);const be={authority:Q,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},Te={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:be,options:Te,tunnelInformation:{environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures}}}}catch(pe){if(D.mark(`code/extHost/didResolveAuthorityError/${ve}`),pe instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(Q,he){this._logService.info(`$getCanonicalURI invoked for authority (${V(Q)})`);const{resolver:ve}=await this._activateAndGetResolver(Q);if(!ve)return null;const ne=C.URI.revive(he);if(typeof ve.getCanonicalURI>"u")return ne;const pe=await(0,_.asPromise)(()=>ve.getCanonicalURI(ne));return pe||ne}static _applyExtensionsDelta(Q,he,ve){const ne=new m.ExtensionDescriptionRegistry(Q.getAllExtensionDescriptions());ne.deltaExtensions(ve.toAdd,ve.toRemove);const pe=(0,b.extensionIdentifiersArrayToSet)(he.getAllExtensionDescriptions().map(Te=>Te.identifier));for(const Te of ve.myToRemove)pe.delete(p.ExtensionIdentifier.toKey(Te));for(const Te of ve.myToAdd)pe.add(p.ExtensionIdentifier.toKey(Te));const be=x(ne,pe);return{globalRegistry:ne,myExtensions:be}}$startExtensionHost(Q){Q.toAdd.forEach(ne=>ne.extensionLocation=C.URI.revive(ne.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Ln._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q);return this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),this._startExtensionHost()}$activateByEvent(Q,he){return he===1?this._activateByEvent(Q,!1):this._readyToRunExtensions.wait().then(ve=>this._activateByEvent(Q,!1))}async $activate(Q,he){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(Q)?(await this._activateById(Q,he),!0):!1}async $deltaExtensions(Q){Q.toAdd.forEach(be=>be.extensionLocation=C.URI.revive(be.extensionLocation));const{globalRegistry:he,myExtensions:ve}=Ln._applyExtensionsDelta(this._globalRegistry,this._myRegistry,Q),ne=await this._createExtensionPathIndex(ve);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(he.getAllExtensionDescriptions()),this._myRegistry.set(ve),Promise.resolve(void 0)}async $test_latency(Q){return Q}async $test_up(Q){return Q.byteLength}async $test_down(Q){const he=a.VSBuffer.alloc(Q),ve=Math.random()%256;for(let ne=0;ne<Q;ne++)he.writeUInt8(ve,ne);return he}async $updateRemoteConnectionData(Q){this._remoteConnectionData=Q,this._onDidChangeRemoteConnectionData.fire()}};G=qe([xe(0,o.IInstantiationService),xe(1,e.IHostUtils),xe(2,n.IExtHostRpcService),xe(3,g.IExtHostWorkspace),xe(4,S.IExtHostConfiguration),xe(5,R.ILogService),xe(6,r.IExtHostInitDataService),xe(7,s.IExtensionStoragePaths),xe(8,d.IExtHostTunnelService),xe(9,f.IExtHostTerminalService)],G),e.AbstractExtHostExtensionService=G;function z(Y,Q){return{id:Y.identifier.value,name:Y.name,extensionVersion:Y.version,publisherDisplayName:Y.publisher,activationEvents:Y.activationEvents?Y.activationEvents.join(","):null,isBuiltin:Y.isBuiltin,reason:Q.activationEvent,reasonId:Q.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class O{constructor(Q,he,ve,ne,pe){W.set(this,void 0),U.set(this,void 0),N.set(this,void 0),tt(this,W,Q,"f"),tt(this,U,he,"f"),tt(this,N,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=t.normalize((0,P.originalFSPath)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=ne,this.isFromDifferentExtensionHost=pe}get isActive(){return Ue(this,W,"f").isActivated(Ue(this,N,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,W,"f").getExtensionExports(Ue(this,N,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,W,"f").activateByIdWithErrors(Ue(this,N,"f"),{startup:!1,extensionId:Ue(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,W=new WeakMap,U=new WeakMap,N=new WeakMap;function x(Y,Q){return Y.getAllExtensionDescriptions().filter(he=>Q.has(p.ExtensionIdentifier.toKey(he.identifier)))}function V(Y){const Q=Y.indexOf("+");return Q===-1?Y:Y.substring(0,Q)}class q{constructor(Q){this._searchTree=Q}setSearchTree(Q){this._searchTree=Q}findSubstr(Q){return this._searchTree.findSubstr(Q)}forEach(Q){return this._searchTree.forEach(Q)}}e.ExtensionPaths=q}),define(De[280],Ie([1,0,72,2,5,33,27,28,15,26,3,39,40,14,8]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let g=class{constructor(h,i,u,o,r,s,n){this._apiFactory=h,this._extensionRegistry=i,this._instaService=u,this._extHostConfiguration=o,this._extHostExtensionService=r,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,i,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(v,i)),this.register(this._instaService.createInstance(b)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,i,this._initData.environment.appUriScheme))}register(h){if("nodeModuleName"in h)if(Array.isArray(h.nodeModuleName))for(const i of h.nodeModuleName)this._factories.set(i,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(i=>h.alternativeModuleName(i))}};g=qe([xe(2,R.IInstantiationService),xe(3,P.IExtHostConfiguration),xe(4,k.IExtHostExtensionService),xe(5,C.IExtHostInitDataService),xe(6,T.ILogService)],g),e.RequireInterceptor=g;let b=class Qn{constructor(h){if(h.environment.appRoot&&Qn.aliased.size){const i=(0,E.escapeRegExpCharacters)(this.forceForwardSlashes(h.environment.appRoot.fsPath)),u="[a-z0-9_.-]",o=`@${u}+\\/${u}+|${u}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${r}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(h){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(h));if(!i)return;const[,u,o,r]=i,s=Qn.aliased.get(o);if(s!==void 0)return console.warn(`${o} as been renamed to ${s}, please update your imports`),u+s+r}forceForwardSlashes(h){return h.replace(/\\/g,"/")}};b.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=qe([xe(0,C.IExtHostInitDataService)],b);class m{constructor(h,i,u,o,r){this._apiFactory=h,this._extensionPaths=i,this._extensionRegistry=u,this._configProvider=o,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,i){const u=this._extensionPaths.findSubstr(i);if(u){let o=this._extApiImpl.get(I.ExtensionIdentifier.toKey(u.identifier));return o||(o=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(u.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((r,s)=>o+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(h,i,u){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(D.MainContext.MainThreadTelemetry);const{environment:o}=u,r=i.getProxy(D.MainContext.MainThreadKeytar);if(o.appRoot){let s=o.appRoot.fsPath;S.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,n)=>r.$getPassword(s,n),setPassword:(s,n,c)=>r.$setPassword(s,n,c),deletePassword:(s,n)=>r.$deletePassword(s,n),findPassword:s=>r.$findPassword(s),findCredentials(s){return r.$findCredentials(s)}}}load(h,i){const u=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const i=h.length;if(i<=7||!this.alternativeNames)return;const u=i-7;if((h.charAt(u)==="/"||h.charAt(u)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};v=qe([xe(1,w.IExtHostRpcService),xe(2,C.IExtHostInitDataService)],v);let p=class{constructor(h,i,u){this._extensionPaths=h,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(D.MainContext.MainThreadTelemetry);const o=u.getProxy(D.MainContext.MainThreadWindow);this._impl=(r,s)=>{const n=t.URI.parse(r);return s?this.callOriginal(r,s):n.scheme==="http"||n.scheme==="https"?o.$openUri(n,r,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?o.$openUri(n,r,{}):this.callOriginal(r,s)}}load(h,i,u){const o=this._extensionPaths.findSubstr(i);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=u(h),this._impl}callOriginal(h,i){return this.sendNoForwardTelemetry(),this._original(h,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=qe([xe(2,w.IExtHostRpcService)],p)}),define(De[47],Ie([1,0,77,6,9,40,3,56,57,39,7,32,217,33]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class E extends S.AbstractVariableResolverService{constructor(m,v,p,a,h,i,u){function o(){if(p){const r=p.activeEditor();if(r)return r.document.uri;const s=a.tabGroups.all.find(n=>n.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.TextDiffTabInput||s.input instanceof R.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof R.TextTabInput||s.input instanceof R.NotebookEditorTabInput||s.input instanceof R.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:r=>{const s=i.folders.filter(n=>n.name===r);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(r,s)=>h.getConfiguration(void 0,r).get(s),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=o();if(r)return D.normalize(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const r=o();if(r){const s=v.getWorkspaceFolder(r);if(s)return D.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(p){const r=p.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(p){const r=p.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>m.getExtension(r)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(P.env))}}let g=class extends t.Disposable{constructor(m,v,p,a,h){super(),this.extensionService=m,this.workspaceService=v,this.editorService=p,this.configurationService=a,this.editorTabs=h,this._resolver=new l.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),o={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async r=>{o.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new E(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,o,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};g=qe([xe(0,C.IExtHostExtensionService),xe(1,k.IExtHostWorkspace),xe(2,I.IExtHostDocumentsAndEditors),xe(3,T.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs)],g),e.ExtHostVariableResolverProviderService=g}),define(De[73],Ie([1,0,18,4,13,2,3,5,57,39,15,7,32,126,210,33,47]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let m=class{constructor(o,r,s,n,c,d){this._workspaceService=r,this._extensionService=s,this._configurationService=n,this._editorTabs=c,this._variableResolver=d,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new t.Emitter,this._onDidTerminateDebugSession=new t.Emitter,this._onDidChangeActiveDebugSession=new t.Emitter,this._onDidReceiveDebugSessionCustomEvent=new t.Emitter,this._debugServiceProxy=o.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new t.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new p(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(f=>{f.onDidChange(y=>{this.registerAllDebugTypes(f)}),this.registerAllDebugTypes(f)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,r){const s=o;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let n=`debug:${encodeURIComponent(s.path||"")}`,c="?";return r&&(n+=`${c}session=${encodeURIComponent(r.id)}`,c="&"),n+=`${c}ref=${s.sourceReference}`,P.URI.parse(n)}else{if(s.path)return P.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const r=[];for(const s of o.getAllExtensionDescriptions())if(s.contributes){const n=s.contributes.debuggers;if(n&&n.length>0)for(const c of n)(0,E.isDebuggerMainContribution)(c)&&r.push(c.type)}this._debugServiceProxy.$registerDebugTypes(r)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(r=>o.push(r)),o}addBreakpoints(o){this.startBreakpoints();const r=o.filter(c=>{const d=c.id;return this._breakpoints.has(d)?!1:(this._breakpoints.set(d,c),!0)});this.fireBreakpointChanges(r,[],[]);const s=[],n=new Map;for(const c of r)if(c instanceof k.SourceBreakpoint){let d=n.get(c.location.uri.toString());d||(d={type:"sourceMulti",uri:c.location.uri,lines:[]},n.set(c.location.uri.toString(),d),s.push(d)),d.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof k.FunctionBreakpoint&&s.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(o){this.startBreakpoints();const r=o.filter(d=>this._breakpoints.delete(d.id));this.fireBreakpointChanges([],r,[]);const s=r.filter(d=>d instanceof k.SourceBreakpoint).map(d=>d.id),n=r.filter(d=>d instanceof k.FunctionBreakpoint).map(d=>d.id),c=r.filter(d=>d instanceof k.DataBreakpoint).map(d=>d.id);return this._debugServiceProxy.$unregisterBreakpoints(s,n,c)}startDebugging(o,r,s){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,r,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,r,s){if(!r)return new k.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:n,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,s,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,n),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(o,r,s){if(!s)return new k.Disposable(()=>{});if(!this.definesDebugType(o,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:n,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,n),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(o,r){if(!r)return new k.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:s,factory:r}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==r)})}async $runInTerminal(o,r){return Promise.resolve(void 0)}async $substituteVariables(o,r){let s;const n=await this.getFolder(o);return n&&(s={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,r)}createDebugAdapter(o,r){if(o.type==="implementation")return new h(o.implementation)}createSignService(){}async $startDASession(o,r){const s=this,n=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const d=this.convertToDto(c),f=this.createDebugAdapter(d,n);if(!f)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const y=f;return this._debugAdapters.set(o,y),this.getDebugAdapterTrackers(n).then(L=>(L&&this._debugAdaptersTrackers.set(o,L),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const B=M,A={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(B.arguments.value);A.body={signature:W},y.sendResponse(A)}else throw new Error("no signer")}catch(W){A.success=!1,A.message=W.message,y.sendResponse(A)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(M),M=(0,E.convertToVSCPaths)(M,!0),s._debugServiceProxy.$acceptDAMessage(o,M)}),y.onError(M=>{L&&L.onError&&L.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),y.onExit(M=>{L&&L.onExit&&L.onExit((0,D.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,D.withNullAsUndefined)(M),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),y.startSession()))})}$sendDAMessage(o,r){r=(0,E.convertToDAPaths)(r,!1);const s=this._debugAdaptersTrackers.get(o);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(r),this._debugAdapters.get(o)?.sendMessage(r)}$stopDASession(o){const r=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),r&&r.onWillStopSession&&r.onWillStopSession();const s=this._debugAdapters.get(o);return this._debugAdapters.delete(o),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const r=[],s=[],n=[];if(o.added)for(const c of o.added){const d=c.id;if(d&&!this._breakpoints.has(d)){let f;if(c.type==="function")f=new k.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")f=new k.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const y=P.URI.revive(c.uri);f=new k.SourceBreakpoint(new k.Location(y,new k.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}f._id=d,this._breakpoints.set(d,f),r.push(f)}}if(o.removed)for(const c of o.removed){const d=this._breakpoints.get(c);d&&(this._breakpoints.delete(c),s.push(d))}if(o.changed){for(const c of o.changed)if(c.id){const d=this._breakpoints.get(c.id);if(d){if(d instanceof k.FunctionBreakpoint&&c.type==="function"){const f=d;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.functionName=c.functionName}else if(d instanceof k.SourceBreakpoint&&c.type==="source"){const f=d;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.location=new k.Location(P.URI.revive(c.uri),new k.Position(c.line,c.character))}n.push(d)}}}this.fireBreakpointChanges(r,s,n)}$provideDebugConfigurations(o,r,s){return(0,l.asPromise)(async()=>{const n=this.getConfigProviderByHandle(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(r);return n.provideDebugConfigurations(c,s)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(o,r,s,n){return(0,l.asPromise)(async()=>{const c=this.getConfigProviderByHandle(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.getFolder(r);return c.resolveDebugConfiguration(d,s,n)})}$resolveDebugConfigurationWithSubstitutedVariables(o,r,s,n){return(0,l.asPromise)(async()=>{const c=this.getConfigProviderByHandle(o);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.getFolder(r);return c.resolveDebugConfigurationWithSubstitutedVariables(d,s,n)})}async $provideDebugAdapter(o,r){const s=this.getAdapterDescriptorFactoryByHandle(o);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(r);return this.getAdapterDescriptor(s,n).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(o){const r=await this.getSession(o);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(o){const r=await this.getSession(o);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,r){(await this.getSession(o))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(o,r){const n={session:await this.getSession(o),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const r=this._adapterFactories.filter(s=>s.type===o);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(o){const r=this._adapterFactories.filter(s=>s.handle===o);if(r.length>0)return r[0].factory}getConfigProviderByHandle(o){const r=this._configProviders.filter(s=>s.handle===o);if(r.length>0)return r[0].provider}definesDebugType(o,r){if(o.contributes){const s=o.contributes.debuggers;if(s&&s.length>0){for(const n of s)if(n.label&&n.type&&n.type===r)return!0}}return!1}getDebugAdapterTrackers(o){const s=o.configuration.type,n=this._trackerFactories.filter(c=>c.type===s||c.type==="*").map(c=>(0,l.asPromise)(()=>c.factory.createDebugAdapterTracker(o)).then(d=>d,d=>null));return Promise.race([Promise.all(n).then(c=>{const d=c.filter(f=>!!f);if(d.length>0)return new a(d)}),new Promise((c,d)=>{const f=setTimeout(()=>{clearTimeout(f),d(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(o,r){const s=r.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new k.DebugAdapterServer(s));if(o){const c=await this._extensionService.getExtensionRegistry();return(0,l.asPromise)(()=>o.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,c))).then(d=>{if(d)return d})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,n))}daExecutableFromPackage(o,r){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,r,s){(o.length>0||r.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:r,changed:s}))}async getSession(o){if(o)if(typeof o=="string"){const r=this._debugSessions.get(o);if(r)return r}else{let r=this._debugSessions.get(o.id);if(!r){const s=await this.getFolder(o.folderUri),n=o.parent?this._debugSessions.get(o.parent):void 0;r=new v(this._debugServiceProxy,o.id,o.type,o.name,s,o.configuration,n),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(o){if(o){const r=P.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};m=qe([xe(0,R.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,C.IExtHostExtensionService),xe(3,g.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,b.IExtHostVariableResolverProvider)],m),e.ExtHostDebugServiceBase=m;class v{constructor(o,r,s,n,c,d,f){this._debugServiceProxy=o,this._id=r,this._type=s,this._name=n,this._workspaceFolder=c,this._configuration=d,this._parentSession=f}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,r)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=v;class p{constructor(o){this.value=Object.freeze({append(r){o.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=p;class a{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(r=>r.onError?r.onError(o):void 0)}onExit(o,r){this.trackers.forEach(s=>s.onExit?s.onExit(o,r):void 0)}}class h extends T.AbstractDebugAdapter{constructor(o){super(),this.implementation=o,o.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends m{constructor(o,r,s,n,c,d){super(o,r,s,n,c,d)}};i=qe([xe(0,R.IExtHostRpcService),xe(1,S.IExtHostWorkspace),xe(2,C.IExtHostExtensionService),xe(3,g.IExtHostConfiguration),xe(4,w.IExtHostEditorTabs),xe(5,b.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(De[281],Ie([1,0,10,72,2,5,273,14,82,85,26,192,15,54,39]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class g{constructor(m,v,p,a,h){this._hostUtils=p,this._rpcProtocol=new _.RPCProtocol(m,null,a),v=g._transform(v,this._rpcProtocol);const i=new C.ServiceCollection(...(0,w.getSingletonServiceDescriptors)());i.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:h}),i.set(S.IExtHostRpcService,new S.ExtHostRpcService(this._rpcProtocol)),i.set(T.IURITransformerService,new T.URITransformerService(a)),i.set(E.IHostUtils,p);const u=new k.InstantiationService(i,!0);this._logService=u.invokeFunction(n=>n.get(I.ILogService)),t.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=u.invokeFunction(n=>n.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(n=>{Error.prepareStackTrace=(c,d)=>{let f="",y,L;for(const M of d)f+=`
	at ${M.toString()}`,L=M.getFileName(),!y&&L&&(y=n.findSubstr(D.URI.file(L)));return o.set(c,y),`${c.name||"Error"}: ${c.message||""}${f}`}});const r=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);l.setUnexpectedErrorHandler(n=>{const c=l.transformErrorForSerialization(n),d=o.get(n);d?r.$onExtensionRuntimeError(d.identifier,c):s.$onUnexpectedError(c)})}async asBrowserUri(m){const v=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService);return D.URI.revive(await v.$asBrowserUri(m))}terminate(m){this._extensionService.terminate(m)}static _transform(m,v){m.allExtensions.forEach(a=>{a.extensionLocation=D.URI.revive(v.transformIncomingURIs(a.extensionLocation));const h={};a.browserNlsBundleUris&&(Object.keys(a.browserNlsBundleUris).forEach(i=>h[i]=D.URI.revive(v.transformIncomingURIs(a.browserNlsBundleUris[i]))),a.browserNlsBundleUris=h)}),m.environment.appRoot=D.URI.revive(v.transformIncomingURIs(m.environment.appRoot));const p=m.environment.extensionDevelopmentLocationURI;return p&&(m.environment.extensionDevelopmentLocationURI=p.map(a=>D.URI.revive(v.transformIncomingURIs(a)))),m.environment.extensionTestsLocationURI=D.URI.revive(v.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=D.URI.revive(v.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=D.URI.revive(v.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=D.URI.revive(v.transformIncomingURIs(m.logsLocation)),m.logFile=D.URI.revive(v.transformIncomingURIs(m.logFile)),m.workspace=v.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=g}),define(De[282],Ie([1,0,18,11,176,191,199,73,57,39,15,38,7,47,32,211,213,33]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let v=class extends I.ExtHostDebugServiceBase{constructor(u,o,r,s,n,c,d){super(u,o,r,s,c,d),this._terminalService=n,this._integratedTerminalInstances=new h}createDebugAdapter(u,o){switch(u.type){case"server":return new g.SocketDebugAdapter(u);case"pipeServer":return new g.NamedPipeDebugAdapter(u);case"executable":return new g.ExecutableDebugAdapter(u,o.type)}return super.createDebugAdapter(u,o)}daExecutableFromPackage(u,o){const r=g.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),u.type);if(r)return new S.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new _.SignService}async $runInTerminal(u,o){if(u.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(W=>{this._integratedTerminalInstances.onTerminalClosed(W)}));const r=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),c=u.title||D.localize(0,null),d=JSON.stringify({shell:s,shellArgs:n});let f=await this._integratedTerminalInstances.checkout(d,c),y,L=!1;if(f)y=u.cwd;else{const W={shellPath:s,shellArgs:n,cwd:u.cwd,name:c,iconPath:new S.ThemeIcon("debug")};L=!0,f=this._terminalService.createTerminalFromOptions(W,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,d)}f.show(!0);const M=await f.processId;L?await new Promise(W=>setTimeout(W,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):t.isWindows?f.sendText("cls"):f.sendText("clear"));const B=(0,b.prepareCommand)(s,u.args,!!u.argsCanBeInterpretedByShell,y,u.env);f.sendText(B);const A=this.onDidTerminateDebugSession(W=>{W.id===o&&(this._integratedTerminalInstances.free(f),A.dispose())});return M}else if(u.kind==="external")return a(u,await this._configurationService.getConfigProvider());return super.$runInTerminal(u,o)}};v=qe([xe(0,R.IExtHostRpcService),xe(1,E.IExtHostWorkspace),xe(2,C.IExtHostExtensionService),xe(3,m.IExtHostConfiguration),xe(4,k.IExtHostTerminalService),xe(5,w.IExtHostEditorTabs),xe(6,T.IExtHostVariableResolverProvider)],v),e.ExtHostDebugService=v;let p;function a(i,u){if(!p)if(t.isWindows)p=new P.WindowsExternalTerminalService;else if(t.isMacintosh)p=new P.MacExternalTerminalService;else if(t.isLinux)p=new P.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const o=u.getConfiguration("terminal");return p.runInTerminal(i.title,i.cwd,i.args,i.env||{},o.external||{})}e.runInExternalTerminal=a;class h{constructor(){this._terminalInstances=new Map}async checkout(u,o){const s=[...this._terminalInstances.entries()].map(([n,c])=>(0,l.createCancelablePromise)(async d=>{if(n.name!==o||c.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await n.processId))return null;const f=Date.now();return c.lastUsedAt+h.minUseDelay>f||d.isCancellationRequested||c.config!==u?null:(c.lastUsedAt=f,n)}));return await(0,l.firstParallel)(s,n=>!!n)}insert(u,o){this._terminalInstances.set(u,{lastUsedAt:Date.now(),config:o})}free(u){const o=this._terminalInstances.get(u);o&&(o.lastUsedAt=-1)}onTerminalClosed(u){this._terminalInstances.delete(u)}}h.minUseDelay=1e3}),define(De[283],Ie([1,0,9,2,109,32,56,33,45,38,15,26,71,12,14,66,22,81,47]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends S.ExtHostTaskBase{constructor(h,i,u,o,r,s,n,c,d){super(h,i,u,o,r,s,n,c),this.workspaceService=u,this.variableResolver=d,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(h,i){const u=i;if(!i.execution&&u._id===void 0)throw new Error("Tasks to execute must include an execution");if(u._id!==void 0){const o=S.TaskHandleDTO.from(u,this.workspaceService),r=await this._proxy.$getTaskExecution(o);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(r,i);return this._proxy.$executeTask(o).catch(()=>{}),s}else{const o=S.TaskDTO.from(i,h);if(o===void 0)return Promise.reject(new Error("Task is not valid"));S.CustomExecutionDTO.is(o.execution)&&await this.addCustomExecution(o,i,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(o),i);return this._proxy.$executeTask(o).catch(()=>{}),r}}provideTasksInternal(h,i,u,o){const r=[];if(o)for(const s of o){this.checkDeprecation(s,u),(!s.definition||!h[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=S.TaskDTO.from(s,u.extension);n&&(r.push(n),S.CustomExecutionDTO.is(n.execution)&&i.push(this.addCustomExecution(n,s,!0)))}return{tasks:r,extension:u.extension}}async resolveTaskInternal(h){return h}async getAFolder(h){let i=h&&h.length>0?h[0]:void 0;if(!i){const u=t.URI.file((0,m.homedir)());i=new w.WorkspaceFolder({uri:u,name:b.basename(u),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(h,i){const u=t.URI.revive(h),o={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(u),s=await this._workspaceProvider.getWorkspaceFolders2()??[],n=await this.variableResolver.getResolver(),c=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(s);for(const d of i.variables)o.variables[d]=await n.resolveAsync(c,d);if(i.process!==void 0){let d;if(i.process.path!==void 0){d=i.process.path.split(l.delimiter);for(let f=0;f<d.length;f++)d[f]=await n.resolveAsync(c,d[f])}o.process=await D.win32.findExecutable(await n.resolveAsync(c,i.process.name),i.process.cwd!==void 0?await n.resolveAsync(c,i.process.cwd):void 0,d)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(h,i,u){return D.win32.findExecutable(h,i,u)}};p=qe([xe(0,R.IExtHostRpcService),xe(1,k.IExtHostInitDataService),xe(2,P.IExtHostWorkspace),xe(3,_.IExtHostDocumentsAndEditors),xe(4,I.IExtHostConfiguration),xe(5,C.IExtHostTerminalService),xe(6,E.ILogService),xe(7,g.IExtHostApiDeprecationService),xe(8,v.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(De[284],Ie([1,0,81,47]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class D extends t.ExtHostVariableResolverProviderService{homeDir(){return(0,l.homedir)()}}e.NodeExtHostVariableResolverProviderService=D}),define(De[140],Ie([1,0,17,18,21,50,12,9,22,2,30]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(v,p,a,h){this.query=v,this.provider=p,this.fileUtils=a,this.processType=h,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,p){const a=this.query.folderQueries||[],h=new D.CancellationTokenSource;return p.onCancellationRequested(()=>h.cancel()),new Promise((i,u)=>{this.collector=new T(v);let o=!1;const r=(s,n)=>{if(!o&&!this.isLimitHit){const c=this.resultSize(s);g(s)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,o=!0,h.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const d=this.resultSize(s);this.resultCount+=d,(d>0||!g(s))&&this.collector.add(s,n)}};Promise.all(a.map((s,n)=>this.searchInFolder(s,c=>r(c,n),h.token))).then(s=>{h.dispose(),this.collector.flush();const n=s.some(c=>!!c&&!!c.limitHit);i({limitHit:this.isLimitHit||n,messages:(0,l.flatten)(s.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},s=>{h.dispose();const n=(0,P.toErrorMessage)(s);u(new Error(n))})})}resultSize(v){return g(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,p){const a=Array.isArray(v.ranges)?v.ranges:[v.ranges],h=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:a.slice(0,p),preview:{matches:h.slice(0,p),text:v.preview.text},uri:v.uri}}async searchInFolder(v,p,a){const h=new R.QueryGlobTester(this.query,v),i=[],u={report:s=>{if(!this.validateProviderResult(s))return;const n=v.folder.scheme===_.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(w.dirname(s.uri))):void 0,c=w.relativePath(v.folder,s.uri);if(c){const d=h.includedInQuery(c,I.basename(c),n);(0,t.isThenable)(d)?i.push(d.then(f=>{f&&p(s)})):d&&p(s)}}},o=this.getSearchOptionsForFolder(v),r=await this.provider.provideTextSearchResults(S(this.query.contentPattern),o,u,a);return i.length&&await Promise.all(i),r}validateProviderResult(v){if(g(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const p=(0,R.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),a=(0,R.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),h={folder:C.URI.from(v.folder),excludes:a,includes:p,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return h.usePCRE2=this.query.usePCRE2,h}}e.TextSearchManager=k;function S(m){return{isCaseSensitive:m.isCaseSensitive||!1,isRegExp:m.isRegExp||!1,isWordMatch:m.isWordMatch||!1,isMultiline:m.isMultiline||!1,pattern:m.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,p=>this.sendItems(p))}add(v,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!w.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(E(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function E(m){return g(m)?{preview:{matches:(0,l.mapArrayOrNot)(m.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:m.preview.text},ranges:(0,l.mapArrayOrNot)(m.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:m.text,lineNumber:m.lineNumber}}function g(m){return!!m.preview}e.extensionResultIsMatch=g;class b{constructor(v,p){this.maxBatchSize=v,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,p){!v||this.addItemToBatch(v,p)}addItems(v,p){!v||this.addItemsToBatch(v,p)}addItemToBatch(v,p){this.batch.push(v),this.batchSize+=p,this.onUpdate()}addItemsToBatch(v,p){this.batch=this.batch.concat(v),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(De[74],Ie([1,0,6,5,3,277,15,54,14,2,140]),function(J,e,l,t,D,P,_,I,w,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let k=class{constructor(g,b,m){this.extHostRpc=g,this._uriTransformer=b,this._logService=m,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(g){return this._uriTransformer.transformOutgoingScheme(g)}registerTextSearchProvider(g,b){if(this._textSearchUsedSchemes.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this._textSearchUsedSchemes.add(g);const m=this._handlePool++;return this._textSearchProvider.set(m,b),this._proxy.$registerTextSearchProvider(m,this._transformScheme(g)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(g),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(g,b){if(this._fileSearchUsedSchemes.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this._fileSearchUsedSchemes.add(g);const m=this._handlePool++;return this._fileSearchProvider.set(m,b),this._proxy.$registerFileSearchProvider(m,this._transformScheme(g)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(g),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(g,b,m,v){const p=S(m),a=this._fileSearchProvider.get(g);if(a)return this._fileSearchManager.fileSearch(p,a,h=>{this._proxy.$handleFileMatch(g,b,h.map(i=>i.resource))},v);throw new Error("unknown provider: "+g)}$clearCache(g){return this._fileSearchManager.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,b,m,v){const p=this._textSearchProvider.get(g);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const a=S(m);return this.createTextSearchManager(a,p).search(i=>this._proxy.$handleTextMatch(g,b,i),v)}$enableExtensionHostSearch(){}createTextSearchManager(g,b){return new R.TextSearchManager(g,b,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m},"textSearchProvider")}};k=qe([xe(0,_.IExtHostRpcService),xe(1,I.IURITransformerService),xe(2,w.ILogService)],k),e.ExtHostSearch=k;function S(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(T),extraFileResources:E.extraFileResources&&E.extraFileResources.map(g=>C.URI.revive(g))}}e.reviveQuery=S;function T(E){return{...E,folder:C.URI.revive(E.folder)}}}),define(De[285],Ie([1,0,82,139,32,135,33,37,56,38,71,73,74,91,53,66,138,67,46,90,124,57,136,14,223,47,137]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h,i,u,o,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,!0),(0,l.registerSingleton)(u.ILogService,o.ExtHostLogService,!0),(0,l.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService,!1),(0,l.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands,!1),(0,l.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,l.registerSingleton)(m.IExtHostConsumerFileSystem,m.ExtHostConsumerFileSystem,!1),(0,l.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,!1),(0,l.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations,!1),(0,l.registerSingleton)(w.IExtHostDocumentsAndEditors,w.ExtHostDocumentsAndEditors,!1),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,l.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,!0),(0,l.registerSingleton)(S.IExtHostSearch,S.ExtHostSearch,!1),(0,l.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,l.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,l.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,!1),(0,l.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,!1),(0,l.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,!1),(0,l.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState,!1),(0,l.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry,!1),(0,l.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,l.registerSingleton)(h.IExtHostEditorTabs,h.ExtHostEditorTabs,!1),(0,l.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,!1)}),define(De[92],Ie([1,0,17,14,30,70]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function _(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=_;function I(k,S,T,E){const g=(0,l.mapArrayOrNot)(T,w),b=new D.TextSearchMatch(S,g,E),m=b.preview.matches;return{ranges:(0,l.mapArrayOrNot)(g,C),uri:k,preview:{text:b.preview.text,matches:(0,l.mapArrayOrNot)(m,C)}}}e.createTextSearchResult=I;function w(k){return new D.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function C(k){return new P.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let R=class{constructor(S,T){this.prefix=S,this.logService=T}appendLine(S){this.logService.debug(`${this.prefix}#search`,S)}};R=qe([xe(1,t.ILogService)],R),e.OutputChannel=R}),define(De[286],Ie([1,0,44,9,79,31,11,8,92,287]),function(J,e,l,t,D,P,_,I,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(p,a,h,i){const u=S(p,a,h,i),o=a.folder.fsPath;return{cmd:l.spawn(R,u.args,{cwd:o}),rgDiskPath:R,siblingClauses:u.siblingClauses,rgArgs:u,cwd:o}}e.spawnRipgrepCmd=k;function S(p,a,h,i){const u=["--files","--hidden","--case-sensitive"];E([a],h,!1).forEach(r=>{const s=(0,w.anchorGlob)(r);if(u.push("-g",s),_.isMacintosh){const n=(0,D.normalizeNFD)(s);n!==s&&u.push("-g",n)}});const o=T([a],i,void 0,!1);return o.globArgs.forEach(r=>{const s=`!${(0,w.anchorGlob)(r)}`;if(u.push("-g",s),_.isMacintosh){const n=(0,D.normalizeNFD)(s);n!==s&&u.push("-g",n)}}),a.disregardIgnoreFiles!==!1?u.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&u.push("--no-ignore-parent"),a.ignoreSymlinks||u.push("--follow"),p.exists&&u.push("--quiet"),u.push("--no-config"),a.disregardGlobalIgnoreFiles&&u.push("--no-ignore-global"),{args:u,siblingClauses:o.siblingClauses}}function T(p,a,h,i=!0){const u=[];let o={};return p.forEach(r=>{const s=Object.assign({},r.excludePattern||{},a||{}),n=g(s,i?r.folder.fsPath:void 0,h);u.push(...n.globArgs),n.siblingClauses&&(o=Object.assign(o,n.siblingClauses))}),{globArgs:u,siblingClauses:o}}e.foldersToRgExcludeGlobs=T;function E(p,a,h=!0){const i=[];return p.forEach(u=>{const o=Object.assign({},a||{},u.includePattern||{}),r=g(o,h?u.folder.fsPath:void 0);i.push(...r.globArgs)}),i}e.foldersToIncludeGlobs=E;function g(p,a,h){const i=[],u={};return Object.keys(p).forEach(o=>{if(h&&h.has(o)||!o)return;const r=p[o];o=m(a?b(a,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof r=="boolean"&&r?(o.startsWith("\\\\")&&(o+="**"),i.push(v(o))):r&&r.when&&(u[o]=r)}),{globArgs:i,siblingClauses:u}}function b(p,a){return t.isAbsolute(a)?a:t.join(p,a)}e.getAbsoluteGlob=b;function m(p){return p=I.rtrim(p,"\\"),I.rtrim(p,"/")}function v(p){return P.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=v}),define(De[288],Ie([1,0,44,62,9,289,17,50,36,79,31,11,51,8,13,29,30,286,104]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(o=>o())});class a{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&w.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,v.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&w.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(s=>{const n=Object.assign({},s.excludePattern||{},this.config.excludePattern||{}),c=s.folder.fsPath;r.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==c).forEach(d=>{(0,R.isEqualOrParent)(d,c)&&(n[D.relative(c,d)]=!0)}),this.folderExcludePatterns.set(c,new i(n,c))})}cancel(){this.isCanceled=!0,p.forEach(r=>r())}walk(r,s,n,c,d){if(this.fileWalkSW=S.StopWatch.create(!1),this.isCanceled)return d(null,this.isLimitHit);s.forEach(f=>{const y=D.basename(f.fsPath);this.globalExcludePattern&&this.globalExcludePattern(f.fsPath,y)||this.matchFile(n,{relativePath:f.fsPath,searchPath:void 0})}),this.cmdSW=S.StopWatch.create(!1),this.parallel(r,(f,y)=>{this.call(this.cmdTraversal,this,f,n,c,L=>{if(L){const M=(0,I.toErrorMessage)(L);console.error(M),this.errors.push(M),y(L,void 0)}else y(null,void 0)})},(f,y)=>{this.fileWalkSW.stop();const L=f?_.coalesce(f)[0]:null;d(L,this.isLimitHit)})}parallel(r,s,n){const c=new Array(r.length),d=new Array(r.length);let f=!1,y=0;if(r.length===0)return n(null,[]);r.forEach((L,M)=>{s(L,(B,A)=>{if(B?(f=!0,c[M]=null,d[M]=B):(c[M]=A,d[M]=null),++y===r.length)return n(f?d:null,c)})})}call(r,s,...n){try{r.apply(s,n)}catch(c){n[n.length-1](c)}}cmdTraversal(r,s,n,c){const d=r.folder.fsPath,f=k.isMacintosh,y=()=>W&&W.kill();p.add(y);let L=z=>{p.delete(y),L=()=>{},c(z)},M="";const B=this.initDirectoryTree(),A=(0,m.spawnRipgrepCmd)(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression),W=A.cmd,U=!Object.keys(A.siblingClauses).length,N=A.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let G=`${A.rgDiskPath} ${N}
 - cwd: ${A.cwd}`;A.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(A.rgArgs.siblingClauses)}`),n({message:G}),this.cmdResultCount=0,this.collectStdout(W,"utf8",n,(z,O,x)=>{if(z){L(z);return}if(this.isLimitHit){L();return}const q=(M+(f?C.normalizeNFC(O||""):O)).split(`
`);if(x){const Y=q.length;q[Y-1]=q[Y-1].trim(),q[Y-1]||q.pop()}else M=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=q.length,U){for(const Y of q)if(this.matchFile(s,{base:d,relativePath:Y,searchPath:this.getSearchPath(r,Y)}),this.isLimitHit){y();break}(x||this.isLimitHit)&&L();return}this.addDirectoryEntries(r,B,d,q,s),x&&(this.matchDirectoryTree(B,d,s),L())})}spawnFindCmd(r){const s=this.folderExcludePatterns.get(r.folder.fsPath),n=s.getBasenameTerms(),c=s.getPathTerms(),d=["-L","."];if(n.length||c.length){d.push("-not","(","(");for(const f of n)d.push("-name",f),d.push("-o");for(const f of c)d.push("-path",f),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),l.spawn("find",d,{cwd:r.folder.fsPath})}readStdout(r,s,n){let c="";this.collectStdout(r,s,()=>{},(d,f,y)=>{if(d){n(d);return}c+=f,y&&n(null,c)})}collectStdout(r,s,n,c){let d=(L,M,B)=>{(L||B)&&(d=()=>{},this.cmdSW?.stop()),c(L,M,B)},f=!1;r.stdout?(this.forwardData(r.stdout,s,d),r.stdout.once("data",()=>f=!0)):n({message:"stdout is null"});let y;r.stderr?y=this.collectData(r.stderr):n({message:"stderr is null"}),r.on("error",L=>{d(L)}),r.on("close",L=>{let M;!f&&(M=this.decodeData(y,s))&&u(M)?d(new Error(`command failed with error code ${L}: ${this.decodeData(y,s)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),d(null,"",!0))})}forwardData(r,s,n){const c=new P.StringDecoder(s);return r.on("data",d=>{n(null,c.write(d))}),c}collectData(r){const s=[];return r.on("data",n=>{s.push(n)}),s}decodeData(r,s){const n=new P.StringDecoder(s);return r.map(c=>n.write(c)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:s},n,c,d){c.indexOf(this.filePattern)!==-1&&this.matchFile(d,{base:n,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const f=y=>{const L=D.basename(y),M=D.dirname(y);let B=s[M];B||(B=s[M]=[],f(M)),B.push({base:n,relativePath:y,basename:L,searchPath:this.getSearchPath(r,y)})};c.forEach(f)}matchDirectoryTree({rootEntries:r,pathToEntries:s},n,c){const d=this,f=this.folderExcludePatterns.get(n),y=this.filePattern;function L(M){d.directoriesWalked++;const B=(0,b.hasSiblingFn)(()=>M.map(A=>A.basename));for(let A=0,W=M.length;A<W;A++){const U=M[A],{relativePath:N,basename:G}=U;if(f.test(N,G,y!==G?B:void 0))continue;const z=s[N];if(z)L(z);else{if(d.filesWalked++,N===y)continue;d.matchFile(c,U)}if(d.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,s,n,c,d){const f=r.folder,y=(0,b.hasSiblingFn)(()=>n);this.parallel(n,(L,M)=>{if(this.isCanceled||this.isLimitHit)return M(null);const B=s?[s,L].join(D.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(B,L,this.config.filePattern!==L?y:void 0))return M(null);const A=[f.fsPath,B].join(D.sep);t.lstat(A,(W,U)=>{if(W||this.isCanceled||this.isLimitHit)return M(null);this.statLinkIfNeeded(A,U,(N,G)=>N||this.isCanceled||this.isLimitHit?M(null):G.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(A,U,(z,O)=>z||this.isCanceled||this.isLimitHit||(O=O||"",this.walkedPaths[O])?M(null):(this.walkedPaths[O]=!0,g.Promises.readdir(A).then(x=>{if(this.isCanceled||this.isLimitHit)return M(null);this.doWalk(r,B,x,c,V=>M(V||null))},x=>{M(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&E.isNumber(G.size)&&G.size>this.maxFilesize||this.matchFile(c,{base:f.fsPath,relativePath:B,searchPath:this.getSearchPath(r,B)}),M(null,void 0)))})},L=>{const M=L&&_.coalesce(L);return d(M&&M.length>0?M[0]:void 0)})}matchFile(r,s){this.isFileMatch(s)&&(!this.includePattern||this.includePattern(s.relativePath,D.basename(s.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(s))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,b.isFilePatternMatch)(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,s,n){return s.isSymbolicLink()?t.stat(r,n):n(null,s)}realPathIfNeeded(r,s,n){return s.isSymbolicLink()?t.realpath(r,(c,d)=>c?n(c):n(null,d)):n(null,r)}getSearchPath(r,s){return r.folderName?D.join(r.folderName,s):s}}e.FileWalker=a;class h{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new a(r)}search(r,s,n){this.walker.walk(this.folderQueries,this.extraFiles,r,s,(c,d)=>{n(c,{limitHit:d,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=h;class i{constructor(r,s){this.expression=r,this.root=s,this.init(r)}init(r){let s,n;Object.keys(r).filter(c=>r[c]).forEach(c=>{D.isAbsolute(c)?(s=s||w.getEmptyExpression(),s[c]=r[c]):(n=n||w.getEmptyExpression(),n[c]=r[c])}),this.absoluteParsedExpr=s&&w.parse(s,{trimForExclusions:!0}),this.relativeParsedExpr=n&&w.parse(n,{trimForExclusions:!0})}test(r,s,n){return this.relativeParsedExpr&&this.relativeParsedExpr(r,s,n)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,r),s,n)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...w.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...w.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...w.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...w.getPathTerms(this.relativeParsedExpr)),r}}function u(o){const r=o.trim().split(`
`),s=r[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return T.uppercaseFirstLetter(r[r.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=u}),define(De[290],Ie([1,0,95,23]),function(J,e,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(o){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===o)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const P=512,_=512,I=512*8,w=512*128;var C;(function(o){o[o.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(r,s){super(r),this.decodeStreamErrorKind=s}}e.DecodeStreamError=R;class k{constructor(r){this.iconvLiteDecoder=r}static async create(r){let s;if(r!==e.UTF8)s=(await new Promise((c,d)=>{J(["@vscode/iconv-lite-umd"],c,d)})).getDecoder(g(r));else{const n=new TextDecoder;s={write(c){return n.decode(c,{stream:!0})},end(){return n.decode()}}}return new k(s)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function S(o,r){const s=r.minBytesRequiredForDetection??r.guessEncoding?I:_;return new Promise((n,c)=>{const d=(0,l.newWriteableStream)(A=>A.join("")),f=[];let y=0,L,M;const B=async()=>{try{const A=await u({buffer:t.VSBuffer.concat(f),bytesRead:y},r.guessEncoding);if(A.seemsBinary&&r.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);A.encoding=await r.overwriteEncoding(A.encoding),L=await k.create(A.encoding);const W=L.write(t.VSBuffer.concat(f).buffer);d.write(W),f.length=0,y=0,n({stream:d,detected:A})}catch(A){M?.dispose(),d.destroy(),c(A)}};M=(0,l.listenStream)(o,{onData:async A=>{L?d.write(L.write(A.buffer)):(f.push(A),y+=A.byteLength,y>=s&&(o.pause(),await B(),setTimeout(()=>o.resume())))},onError:A=>d.error(A),onEnd:async()=>{L||await B(),d.end(L?.end())}})})}e.toDecodeStream=S;async function T(o,r,s){const c=(await new Promise((y,L)=>{J(["@vscode/iconv-lite-umd"],y,L)})).getEncoder(g(r),s);let d=!1,f=!1;return{read(){if(f)return null;const y=o.read();if(typeof y!="string"){if(f=!0,!d&&s?.addBOM)switch(r){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=c.end();return L&&L.length>0?(d=!0,t.VSBuffer.wrap(L)):null}return d=!0,t.VSBuffer.wrap(c.write(y))}}}e.toEncodeReadable=T;async function E(o){return(await new Promise((s,n)=>{J(["@vscode/iconv-lite-umd"],s,n)})).encodingExists(g(o))}e.encodingExists=E;function g(o){return o===e.UTF8_with_bom||o===null?e.UTF8:o}e.toNodeEncoding=g;function b(o,r){if(!o||r<e.UTF16be_BOM.length)return null;const s=o.readUInt8(0),n=o.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const c=o.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const m=["ascii","utf-16","utf-32"];async function v(o){const r=await new Promise((f,y)=>{J(["jschardet"],f,y)}),s=o.slice(0,w),n=h(s.buffer),c=r.detect(n);if(!c||!c.encoding)return null;const d=c.encoding.toLowerCase();return 0<=m.indexOf(d)?null:a(c.encoding)}const p={ibm866:"cp866",big5:"cp950"};function a(o){const r=o.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[r]||r}function h(o){let r="";for(let s=0;s<o.length;s++)r+=String.fromCharCode(o[s]);return r}function i(o){switch(o){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const r=o.match(/windows(\d+)/);return r?"windows-"+r[1]:o}}}e.toCanonicalName=i;function u({buffer:o,bytesRead:r},s){let n=b(o,r),c=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&o){let d=!0,f=!0,y=!1;for(let L=0;L<r&&L<P;L++){const M=L%2===1,B=o.readUInt8(L)===0;if(B&&(y=!0),d&&(M&&!B||!M&&B)&&(d=!1),f&&(M&&B||!M&&!B)&&(f=!1),B&&!d&&!f)break}y&&(d?n=e.UTF16le:f?n=e.UTF16be:c=!0)}return s&&!c&&!n&&o?v(o.slice(0,r)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:c,encoding:n}}e.detectEncodingFromBuffer=u,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[141],Ie([1,0,290,29,140]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class P extends D.TextSearchManager{constructor(I,w,C=t,R="searchProcess"){super(I,w,{readdir:k=>C.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,l.toCanonicalName)(k)},R)}}e.NativeTextSearchManager=P}),define(De[291],Ie([1,0]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class l{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(D){if(D&&this._dragOperations.has(D)){const P=this._dragOperations.get(D);return this._dragOperations.delete(D),P}}addDragOperationTransfer(D,P){this._dragOperations.set(D,P)}getRenderedTreeElement(D){if(this._renderedElements.has(D))return this._renderedElements.get(D)}addRenderedTreeItemElement(D,P){this._renderedElements.set(D,P)}removeRenderedTreeItemElement(D){this._renderedElements.has(D)&&this._renderedElements.delete(D)}}e.TreeviewsService=l}),define(De[292],Ie([1,0,174,7,22,2,4,6,18,7,13,17,16,21,291,27]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(p,a){if((0,R.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let h;return Array.isArray(p.highlights)&&(h=p.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),h=h.length?h:void 0),{label:p.label,highlights:h}}}class m{constructor(a,h,i){this._proxy=a,this.commands=h,this.logService=i,this.treeViews=new Map,this.treeDragAndDropService=new E.TreeviewsService;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}h.registerArgumentProcessor({processArgument:o=>u(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(r=>u(r)?this.convertArgument(r):r):o})}registerTreeDataProvider(a,h,i){const u=this.createTreeView(a,{treeDataProvider:h},i);return{dispose:()=>u.dispose()}}createTreeView(a,h,i){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=h.dragAndDropController?.dropMimeTypes??[],o=h.dragAndDropController?.dragMimeTypes??[],r=!!h.dragAndDropController?.handleDrag,s=!!h.dragAndDropController?.handleDrop,n=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:r,hasHandleDrop:s}),c=this.createExtHostTreeView(a,h,i);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,g.checkProposedApiEnabled)(i,"treeItemCheckbox"),c.onDidChangeTreeCheckbox},get message(){return c.message},set message(d){c.message=d},get title(){return c.title},set title(d){c.title=d},get description(){return c.description},set description(d){c.description=d},get badge(){return c.badge},set badge(d){c.badge=d},reveal:(d,f)=>c.reveal(d,f),dispose:async()=>{await n,this.treeViews.delete(a),c.dispose()}}}$getChildren(a,h){const i=this.treeViews.get(a);return i?i.getChildren(h):Promise.reject(new Error((0,l.localize)(0,null,a)))}async $handleDrop(a,h,i,u,o,r,s,n){const c=this.treeViews.get(a);if(!c)return Promise.reject(new Error((0,l.localize)(1,null,a)));const d=S.DataTransfer.toDataTransfer(i,async f=>(await this._proxy.$resolveDropFileData(a,h,f)).buffer);return s===a&&n&&await this.addAdditionalTransferItems(d,c,n,o,r),c.onDrop(d,u,o)}async addAdditionalTransferItems(a,h,i,u,o){const r=this.treeDragAndDropService.removeDragOperationTransfer(o);if(r)(await r)?.forEach((s,n)=>{s&&a.set(n,s)});else if(o&&h.handleDrag){const s=h.handleDrag(i,a,u);this.treeDragAndDropService.addDragOperationTransfer(o,s),await s}return a}async $handleDrag(a,h,i,u){const o=this.treeViews.get(a);if(!o)return Promise.reject(new Error((0,l.localize)(2,null,a)));const r=await this.addAdditionalTransferItems(new t.DataTransfer,o,h,u,i);if(!!r)return S.DataTransfer.toDataTransferDTO(r)}async $hasResolve(a){const h=this.treeViews.get(a);if(!h)throw new Error((0,l.localize)(3,null,a));return h.hasResolve}$resolve(a,h,i){const u=this.treeViews.get(a);if(!u)throw new Error((0,l.localize)(4,null,a));return u.resolveTreeItem(h,i)}$setExpanded(a,h,i){const u=this.treeViews.get(a);if(!u)throw new Error((0,l.localize)(5,null,a));u.setExpanded(h,i)}$setSelection(a,h){const i=this.treeViews.get(a);if(!i)throw new Error((0,l.localize)(6,null,a));i.setSelection(h)}$setFocus(a,h){const i=this.treeViews.get(a);if(!i)throw new Error((0,l.localize)(7,null,a));i.setFocus(h)}$setVisible(a,h){const i=this.treeViews.get(a);if(!i)throw new Error((0,l.localize)(8,null,a));i.setVisible(h)}$changeCheckboxState(a,h){const i=this.treeViews.get(a);if(!i)throw new Error((0,l.localize)(9,null,a));i.setCheckboxState(h)}createExtHostTreeView(a,h,i){const u=new v(a,h,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(a,u),u}convertArgument(a){const h=this.treeViews.get(a.$treeViewId);return h&&"$treeItemHandle"in a?h.getExtensionElement(a.$treeItemHandle):h&&"$focusedTreeItem"in a&&a.$focusedTreeItem?h.focusedElement:null}}e.ExtHostTreeViews=m;class v extends I.Disposable{constructor(a,h,i,u,o,r){if(super(),this.viewId=a,this.proxy=i,this.commands=u,this.logService=o,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,r.contributes&&r.contributes.views)for(const c in r.contributes.views)for(const d of r.contributes.views[c])d.id===a&&(this._title=d.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let s,n;this._register(_.Event.debounce(this._onDidChangeData.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(s||(s=new Promise(f=>n=f),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0)(({message:c,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=n;return s=null,this.refresh(d).then(()=>f())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(a){const h=a?this.getExtensionElement(a):void 0;if(a&&!h)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let i=this.getChildrenNodes(a);return i||(i=await this.fetchChildrenNodes(h)),i?i.map(u=>u.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,h){h=h||{select:!0,focus:!1};const i=(0,R.isUndefinedOrNull)(h.select)?!0:h.select,u=(0,R.isUndefinedOrNull)(h.focus)?!1:h.focus,o=(0,R.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(n=>n.item)},{select:i,focus:u,expand:o})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:i,focus:u,expand:o})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}get badge(){return this._badge}set badge(a){this._badge?.value===a?.value&&this._badge?.tooltip===a?.tooltip||(this._badge=S.ViewBadge.from(a),this.proxy.$setBadge(this.viewId,a))}setExpanded(a,h){const i=this.getExtensionElement(a);i&&(h?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(a){(0,k.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(a){this._focusedHandle=a}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(a){const h=(await Promise.all(a.map(async i=>{const u=this.getExtensionElement(i.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:i.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);h.forEach(i=>{i.treeItem.checkboxState=i.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:h.map(i=>[i.extensionItem,i.newState])})}async handleDrag(a,h,i){const u=[];for(const o of a){const r=this.getExtensionElement(o);r&&u.push(r)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,h,i),h}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,h,i){const u=h?this.getExtensionElement(h):void 0;if(!(!u&&h||!this.dndController?.handleDrop))return(0,w.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,a,i):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,h){if(!this.dataProvider.resolveTreeItem)return;const i=this.elements.get(a);if(i){const u=this.nodes.get(i);if(u){const o=await this.dataProvider.resolveTreeItem(u.extensionItem,i,h)??u.extensionItem;return this.validateTreeItem(o),u.item.tooltip=this.getTooltip(o.tooltip),u.item.command=this.getCommand(u.disposableStore,o.command),u.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(h=>h?this.resolveUnknownParentChain(h).then(i=>this.resolveTreeNode(h,i[i.length-1]).then(u=>(i.push(u),i))):Promise.resolve([]))}resolveParent(a){const h=this.nodes.get(a);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,w.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,h){const i=this.nodes.get(a);return i?Promise.resolve(i):(0,w.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(u=>this.createHandle(a,u,h,!0)).then(u=>this.getChildren(h?h.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const r=this.nodes.get(o);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(a){if(a){let h;if(typeof a=="string"){const i=this.getExtensionElement(a);h=i?this.nodes.get(i):void 0}else h=a;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const h=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const i=a?this.nodes.get(a):void 0,u=await this.dataProvider.getChildren(a);if(h.token.isCancellationRequested)return;const o=await Promise.all((0,k.coalesce)(u||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,i):null}));return h.token.isCancellationRequested?void 0:(0,k.coalesce)(o)}finally{h.dispose()}}refresh(a){if(a.some(i=>!i))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const i=this.getHandlesToRefresh(a);if(i.length)return this.refreshHandles(i)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const h=new Set,i=a.map(o=>this.nodes.get(o));for(const o of i)if(o&&!h.has(o.item.handle)){let r=o;for(;r&&r.parent&&i.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&h.add(o.item.handle)}const u=[];return h.forEach(o=>{const r=this.elements.get(o);if(r){const s=this.nodes.get(r);s&&(!s.parent||!h.has(s.parent.item.handle))&&u.push(o)}}),u}refreshHandles(a){const h={};return Promise.all(a.map(i=>this.refreshNode(i).then(u=>{u&&(h[i]=u.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(a){const h=this.getExtensionElement(a);if(h){const i=this.nodes.get(h);if(i)return this.clearChildren(h),(0,w.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(u=>{if(u){const o=this.createTreeNode(h,u,i.parent);return this.updateNodeCache(h,o,i,i.parent),i.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,h,i){const u=this.createTreeNode(a,h,i);if(h.id&&this.elements.has(u.item.handle))throw new Error((0,l.localize)(10,null,h.id));return this.addNodeToCache(a,u),this.addNodeToParentCache(u,i),u}getTooltip(a){return C.MarkdownString.isMarkdownString(a)?S.MarkdownString.from(a):a}getCommand(a,h){return h?{...this.commands.toInternal(h,a),originalId:h.command}:void 0}getCheckbox(a){return a.checkboxState!==void 0?a.checkboxState===C.TreeItemCheckboxState.Checked:void 0}validateTreeItem(a){if(!C.TreeItem.isTreeItem(a,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(a,h,i){this.validateTreeItem(h);const u=new I.DisposableStore,o=this.createHandle(a,h,i),r=this.getLightIconPath(h);return{item:{handle:o,parentHandle:i?i.item.handle:void 0,label:b(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(u,h.command),contextValue:h.contextValue,icon:r,iconDark:this.getDarkIconPath(h)||r,themeIcon:this.getThemeIcon(h),collapsibleState:(0,R.isUndefinedOrNull)(h.collapsibleState)?C.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation,checkboxChecked:this.getCheckbox(h)},extensionItem:h,parent:i,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(a){return a.iconPath instanceof C.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:h,label:i,resourceUri:u},o,r){if(h)return`${v.ID_HANDLE_PREFIX}/${h}`;const s=b(i,this.extension),n=o?o.item.handle:v.LABEL_HANDLE_PREFIX;let c=s?s.label:u?(0,D.basename)(u):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const d=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,f=this.getChildrenNodes(o)||[];let y,L=0;do{if(y=`${n}/${L}:${c}`,r||!this.elements.has(y)||d===y)break;L++}while(L<=f.length);return y}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon))return typeof a.iconPath=="string"||P.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof C.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return P.URI.isUri(a)?a:P.URI.file(a)}addNodeToCache(a,h){this.elements.set(h.item.handle,a),this.nodes.set(a,h)}updateNodeCache(a,h,i,u){this.elements.delete(h.item.handle),this.nodes.delete(a),h.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(a,h);const o=this.getChildrenNodes(u)||[],r=o.filter(s=>s.item.handle===i.item.handle)[0];r&&o.splice(o.indexOf(r),1,h)}addNodeToParentCache(a,h){h?(h.children||(h.children=[]),h.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const h=this.nodes.get(a);if(h){if(h.children)for(const i of h.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}h.children=void 0}}else this.clearAll()}clear(a){const h=this.nodes.get(a);if(h){if(h.children)for(const i of h.children){const u=this.elements.get(i.item.handle);u&&this.clear(u)}this.nodes.delete(a),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[293],Ie([1,0,21,10,4,41,2,114,99,148,157,42,5,130,237,236,37,238,33,240,241,242,225,243,56,39,244,245,248,249,250,139,228,254,255,256,91,38,258,292,16,7,261,69,138,32,208,247,122,135,71,73,74,14,54,15,26,251,224,53,66,234,259,68,67,264,262,263,235,46,257,260,90,57,124,252,70,253,12,117,227,204,246,6,27,209,137]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a,h,i,u,o,r,s,n,c,d,f,y,L,M,B,A,W,U,N,G,z,O,x,V,q,Y,Q,he,ve,ne,pe,be,Te,Le,We,oe,le,me,Z,ae,ee,ie,F,H,K,X,de,we,ce,Ce,ye,$e,Ve,Ze,Ye,Oe,ot,re,se,Ee,ue,ke,Ne,Be,ze,Qe,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ct(st){const et=st.get(le.IExtHostInitDataService),mt=st.get(Ce.IExtHostFileSystemInfo),wt=st.get(K.IExtHostConsumerFileSystem),Ct=st.get(r.IExtHostExtensionService),ft=st.get(Y.IExtHostWorkspace),Dt=st.get(Ye.IExtHostTelemetry),Ft=st.get(v.IExtHostConfiguration),Ut=st.get(We.IURITransformerService),Ge=st.get(oe.IExtHostRpcService),Nt=st.get(W.IExtHostStorage),Rt=st.get(H.IExtensionStoragePaths),Lt=st.get(Le.ILoggerService),vt=st.get(Le.ILogService),It=st.get(ae.IExtHostTunnelService),Ae=st.get(nt.IExtHostTelemetryLogService),Re=st.get(ee.IExtHostApiDeprecationService),_e=st.get(q.IExtHostWindow),te=st.get(Ve.IExtHostSecretState),Fe=st.get(Ze.IExtHostEditorTabs);Ge.set(S.ExtHostContext.ExtHostFileSystemInfo,mt),Ge.set(S.ExtHostContext.ExtHostLogLevelServiceShape,Lt),Ge.set(S.ExtHostContext.ExtHostWorkspace,ft),Ge.set(S.ExtHostContext.ExtHostConfiguration,Ft),Ge.set(S.ExtHostContext.ExtHostExtensionService,Ct),Ge.set(S.ExtHostContext.ExtHostStorage,Nt),Ge.set(S.ExtHostContext.ExtHostTunnelService,It),Ge.set(S.ExtHostContext.ExtHostWindow,_e),Ge.set(S.ExtHostContext.ExtHostSecretState,te),Ge.set(S.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(S.ExtHostContext.ExtHostEditorTabs,Fe);const je=Ge.set(S.ExtHostContext.ExtHostDecorations,st.get(ne.IExtHostDecorations)),it=Ge.set(S.ExtHostContext.ExtHostDocumentsAndEditors,st.get(o.IExtHostDocumentsAndEditors)),Ke=Ge.set(S.ExtHostContext.ExtHostCommands,st.get(b.IExtHostCommands)),Je=Ge.set(S.ExtHostContext.ExtHostTerminalService,st.get(U.IExtHostTerminalService)),lt=Ge.set(S.ExtHostContext.ExtHostDebugService,st.get(be.IExtHostDebugService)),kt=Ge.set(S.ExtHostContext.ExtHostSearch,st.get(Te.IExtHostSearch)),Et=Ge.set(S.ExtHostContext.ExtHostTask,st.get(pe.IExtHostTask)),yt=Ge.set(S.ExtHostContext.ExtHostOutputService,st.get(y.IExtHostOutputService)),St=Ge.set(S.ExtHostContext.ExtHostUrls,new x.ExtHostUrls(Ge)),gt=Ge.set(S.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ge,it)),Tt=Ge.set(S.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Ge,it,vt)),Qt=Ge.set(S.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(vt,gt,Ge.getProxy(S.MainContext.MainThreadBulkEdits))),bt=Ge.set(S.ExtHostContext.ExtHostNotebook,new me.ExtHostNotebookController(Ge,Ke,it,gt,Rt)),qt=Ge.set(S.ExtHostContext.ExtHostNotebookDocuments,new ke.ExtHostNotebookDocuments(bt)),xt=Ge.set(S.ExtHostContext.ExtHostNotebookEditors,new ue.ExtHostNotebookEditors(vt,bt)),nn=Ge.set(S.ExtHostContext.ExtHostNotebookKernels,new Oe.ExtHostNotebookKernels(Ge,et,bt,Ke,vt)),gn=Ge.set(S.ExtHostContext.ExtHostNotebookRenderers,new re.ExtHostNotebookRenderers(Ge,bt)),Pt=Ge.set(S.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ge,it)),Wt=Ge.set(S.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Ge.getProxy(S.MainContext.MainThreadTreeViews),Ke,vt)),pn=Ge.set(S.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(Ge.getProxy(S.MainContext.MainThreadEditorInsets),Pt,et.remote)),rn=Ge.set(S.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Ge,vt,mt)),Yt=Ge.set(S.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(Ge,gt,Ke.converter,Ut)),ut=Ge.set(S.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Ut,gt,Ke,rn,vt,Re)),vn=Ge.set(S.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ge,ut)),$t=Ge.set(S.ExtHostContext.ExtHostFileSystemEventService,new n.ExtHostFileSystemEventService(Ge,vt,it)),Gt=Ge.set(S.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Ge,ft,Ke)),sn=Ge.set(S.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(Ge,Ke,vt)),bn=Ge.set(S.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Ge,Ke,gt)),on=Ge.set(S.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Ge.getProxy(S.MainContext.MainThreadProgress))),wn=Ge.set(S.ExtHostContext.ExtHosLabelService,new he.ExtHostLabelService(Ge)),an=Ge.set(S.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(Ge)),cn=Ge.set(S.ExtHostContext.ExtHostAuthentication,new ie.ExtHostAuthentication(Ge)),On=Ge.set(S.ExtHostContext.ExtHostTimeline,new F.ExtHostTimeline(Ge,Ke)),Jt=Ge.set(S.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Ge,et.remote,ft,vt,Re)),Zt=Ge.set(S.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ge,Jt,ft)),En=Ge.set(S.ExtHostContext.ExtHostCustomEditors,new de.ExtHostCustomEditors(Ge,gt,Rt,Jt,Zt)),Sn=Ge.set(S.ExtHostContext.ExtHostWebviewViews,new X.ExtHostWebviewViews(Ge,Jt)),en=Ge.set(S.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(Ge,Ke,it)),_n=Ge.set(S.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Ge));Ge.set(S.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ge,bt,it,Ke,vt));const yn=Object.values(S.ExtHostContext);Ge.assertRegistered(yn);const Fn=new ce.ExtHostBulkEdits(Ge,it),Nn=new g.ExtHostClipboard(Ge),Cn=new f.ExtHostMessageService(Ge,vt),Tn=new a.ExtHostDialogs(Ge),Pn=new A.ExtHostStatusBar(Ge,Ke.converter);return E.ExtHostApiCommands.register(Ke),function(He,Bt,ln){const pt=function(){let ge=!He.isUnderDevelopment;function Se(){ge||(vt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")Se();else{const _t=at;typeof _t.scheme>"u"&&Se(),typeof _t.exclusive=="boolean"&&(0,ze.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Mn={getSession(ge,Se,Me){return cn.getSession(He,ge,Se,Me)},async hasSession(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"authSession"),!!await cn.getSession(He,ge,Se,{silent:!0})},get onDidChangeSessions(){return cn.onDidChangeSessions},registerAuthenticationProvider(ge,Se,Me,at){return cn.registerAuthenticationProvider(ge,Se,Me,at)}},Un={registerCommand(ge,Se,Me){return Ke.registerCommand(!0,ge,Se,Me,void 0,He)},registerTextEditorCommand(ge,Se,Me){return Ke.registerCommand(!0,ge,(...at)=>{const _t=Pt.getActiveTextEditor();if(!_t){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return _t.edit(At=>{Se.apply(Me,[_t,At,...at])}).then(At=>{At||vt.warn("Edits from command "+ge+" were not applied.")},At=>{vt.warn("An error occurred while running command "+ge,At)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,Se,Me)=>((0,ze.checkProposedApiEnabled)(He,"diffCommand"),Ke.registerCommand(!0,ge,async(...at)=>{const _t=it.activeEditor(!0);if(!_t){vt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const At=await Pt.getDiffInformation(_t.id);Se.apply(Me,[At,...at])},void 0,void 0,He)),executeCommand(ge,...Se){return Ke.executeCommand(ge,...Se)},getCommands(ge=!1){return Ke.getCommands(ge)}},tn={get machineId(){return et.telemetryInfo.machineId},get sessionId(){return et.telemetryInfo.sessionId},get language(){return et.environment.appLanguage},get appName(){return et.environment.appName},get appRoot(){return et.environment.appRoot?.fsPath??""},get appHost(){return et.environment.appHost},get uriScheme(){return et.environment.appUriScheme},get clipboard(){return Nn.value},get shell(){return Je.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ge=Date.now()-new Date(et.telemetryInfo.firstSessionDate).getTime();return isNaN(ge)?!1:ge<1e3*60*60*24},openExternal(ge,Se){return _e.openUri(ge,{allowTunneling:!!et.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===et.environment.appUriScheme)return St.createAppUri(ge);try{return await _e.asExternalUri(ge,{allowTunneling:!!et.remote.authority})}catch(Se){if((0,Ee.matchesScheme)(ge,se.Schemas.http)||(0,Ee.matchesScheme)(ge,se.Schemas.https))return ge;throw Se}},get remoteName(){return(0,ve.getRemoteName)(et.remote.authority)},get remoteAuthority(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),et.remote.authority},get uiKind(){return et.uiKind}};et.environment.extensionTestsLocationURI||Object.freeze(tn);const Bn={createTestController(ge,Se,Me){return en.createTestController(ge,Se,Me)},createTestObserver(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),en.createTestObserver()},runTests(ge){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),en.runTests(ge)},get onDidChangeTestResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),en.onResultsChanged},get testResults(){return(0,ze.checkProposedApiEnabled)(He,"testObserver"),en.results}},un=et.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,zn={getExtension(ge,Se){(0,ze.isProposedApiEnabled)(He,"extensionsAny")||(Se=!1);const Me=Bt.mine.getExtensionDescription(ge);if(Me)return new r.Extension(Ct,He.identifier,Me,un,!1);if(Se){const at=Bt.all.getExtensionDescription(ge);if(at)return new r.Extension(Ct,He.identifier,at,un,!0)}},get all(){const ge=[];for(const Se of Bt.mine.getAllExtensionDescriptions())ge.push(new r.Extension(Ct,He.identifier,Se,un,!1));return ge},get allAcrossExtensionHosts(){(0,ze.checkProposedApiEnabled)(He,"extensionsAny");const ge=new ze.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Se=[];for(const Me of Bt.all.getAllExtensionDescriptions()){const at=!ge.has(Me.identifier);Se.push(new r.Extension(Ct,He.identifier,Me,un,at))}return Se},get onDidChange(){return(0,ze.isProposedApiEnabled)(He,"extensionsAny")?D.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},Wn={createDiagnosticCollection(ge){return rn.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return rn.onDidChangeDiagnostics},getDiagnostics:ge=>rn.getDiagnostics(ge),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(ge,Se){return Yt.changeLanguage(ge.uri,Se)},match(ge,Se){const Me=gt.getDocumentData(Se.uri)?.notebook;return(0,R.score)(z.LanguageSelector.from(ge),Se.uri,Se.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Se,Me){return ut.registerCodeActionProvider(He,pt(ge),Se,Me)},registerDocumentPasteEditProvider(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,pt(ge),Se,Me)},registerCodeLensProvider(ge,Se){return ut.registerCodeLensProvider(He,pt(ge),Se)},registerDefinitionProvider(ge,Se){return ut.registerDefinitionProvider(He,pt(ge),Se)},registerDeclarationProvider(ge,Se){return ut.registerDeclarationProvider(He,pt(ge),Se)},registerImplementationProvider(ge,Se){return ut.registerImplementationProvider(He,pt(ge),Se)},registerTypeDefinitionProvider(ge,Se){return ut.registerTypeDefinitionProvider(He,pt(ge),Se)},registerHoverProvider(ge,Se){return ut.registerHoverProvider(He,pt(ge),Se,He.identifier)},registerEvaluatableExpressionProvider(ge,Se){return ut.registerEvaluatableExpressionProvider(He,pt(ge),Se,He.identifier)},registerInlineValuesProvider(ge,Se){return ut.registerInlineValuesProvider(He,pt(ge),Se,He.identifier)},registerDocumentHighlightProvider(ge,Se){return ut.registerDocumentHighlightProvider(He,pt(ge),Se)},registerLinkedEditingRangeProvider(ge,Se){return ut.registerLinkedEditingRangeProvider(He,pt(ge),Se)},registerReferenceProvider(ge,Se){return ut.registerReferenceProvider(He,pt(ge),Se)},registerRenameProvider(ge,Se){return ut.registerRenameProvider(He,pt(ge),Se)},registerDocumentSymbolProvider(ge,Se,Me){return ut.registerDocumentSymbolProvider(He,pt(ge),Se,Me)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,Se){return ut.registerDocumentFormattingEditProvider(He,pt(ge),Se)},registerDocumentRangeFormattingEditProvider(ge,Se){return ut.registerDocumentRangeFormattingEditProvider(He,pt(ge),Se)},registerOnTypeFormattingEditProvider(ge,Se,Me,...at){return ut.registerOnTypeFormattingEditProvider(He,pt(ge),Se,[Me].concat(at))},registerDocumentSemanticTokensProvider(ge,Se,Me){return ut.registerDocumentSemanticTokensProvider(He,pt(ge),Se,Me)},registerDocumentRangeSemanticTokensProvider(ge,Se,Me){return ut.registerDocumentRangeSemanticTokensProvider(He,pt(ge),Se,Me)},registerSignatureHelpProvider(ge,Se,Me,...at){return typeof Me=="object"?ut.registerSignatureHelpProvider(He,pt(ge),Se,Me):ut.registerSignatureHelpProvider(He,pt(ge),Se,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(ge,Se,...Me){return ut.registerCompletionItemProvider(He,pt(ge),Se,Me)},registerInlineCompletionItemProvider(ge,Se){return Se.handleDidShowCompletionItem&&(0,ze.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,pt(ge),Se)},registerInlineCompletionItemProviderNew(ge,Se){if((0,ze.checkProposedApiEnabled)(He,"inlineCompletionsNew"),Se.handleDidShowCompletionItem&&!(0,ze.isProposedApiEnabled)(He,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(He,pt(ge),Se)},registerDocumentLinkProvider(ge,Se){return ut.registerDocumentLinkProvider(He,pt(ge),Se)},registerColorProvider(ge,Se){return ut.registerColorProvider(He,pt(ge),Se)},registerFoldingRangeProvider(ge,Se){return ut.registerFoldingRangeProvider(He,pt(ge),Se)},registerSelectionRangeProvider(ge,Se){return ut.registerSelectionRangeProvider(He,ge,Se)},registerCallHierarchyProvider(ge,Se){return ut.registerCallHierarchyProvider(He,ge,Se)},registerTypeHierarchyProvider(ge,Se){return ut.registerTypeHierarchyProvider(He,ge,Se)},setLanguageConfiguration:(ge,Se)=>ut.setLanguageConfiguration(He,ge,Se),getTokenInformationAtPosition(ge,Se){return(0,ze.checkProposedApiEnabled)(He,"tokenInformation"),Yt.tokenAtPosition(ge,Se)},registerInlayHintsProvider(ge,Se){return ut.registerInlayHintsProvider(He,ge,Se)},createLanguageStatusItem(ge,Se){return Yt.createLanguageStatusItem(He,ge,Se)},registerDocumentDropEditProvider(ge,Se){return ut.registerDocumentOnDropEditProvider(He,ge,Se)}},Dn={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return Je.activeTerminal},get terminals(){return Je.terminals},async showTextDocument(ge,Se,Me){const at=await(_.URI.isUri(ge)?Promise.resolve(An.openTextDocument(ge)):Promise.resolve(ge));return Pt.showTextDocument(at,Se,Me)},createTextEditorDecorationType(ge){return Pt.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,Se,Me){return Pt.onDidChangeActiveTextEditor(ge,Se,Me)},onDidChangeVisibleTextEditors(ge,Se,Me){return Pt.onDidChangeVisibleTextEditors(ge,Se,Me)},onDidChangeTextEditorSelection(ge,Se,Me){return Pt.onDidChangeTextEditorSelection(ge,Se,Me)},onDidChangeTextEditorOptions(ge,Se,Me){return Pt.onDidChangeTextEditorOptions(ge,Se,Me)},onDidChangeTextEditorVisibleRanges(ge,Se,Me){return Pt.onDidChangeTextEditorVisibleRanges(ge,Se,Me)},onDidChangeTextEditorViewColumn(ge,Se,Me){return Pt.onDidChangeTextEditorViewColumn(ge,Se,Me)},onDidCloseTerminal(ge,Se,Me){return Je.onDidCloseTerminal(ge,Se,Me)},onDidOpenTerminal(ge,Se,Me){return Je.onDidOpenTerminal(ge,Se,Me)},onDidChangeActiveTerminal(ge,Se,Me){return Je.onDidChangeActiveTerminal(ge,Se,Me)},onDidChangeTerminalDimensions(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"terminalDimensions"),Je.onDidChangeTerminalDimensions(ge,Se,Me)},onDidChangeTerminalState(ge,Se,Me){return Je.onDidChangeTerminalState(ge,Se,Me)},onDidWriteTerminalData(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Je.onDidWriteTerminalData(ge,Se,Me)},get state(){return _e.state},onDidChangeWindowState(ge,Se,Me){return _e.onDidChangeWindowState(ge,Se,Me)},showInformationMessage(ge,...Se){return Cn.showMessage(He,P.default.Info,ge,Se[0],Se.slice(1))},showWarningMessage(ge,...Se){return Cn.showMessage(He,P.default.Warning,ge,Se[0],Se.slice(1))},showErrorMessage(ge,...Se){return Cn.showMessage(He,P.default.Error,ge,Se[0],Se.slice(1))},showQuickPick(ge,Se,Me){return Gt.showQuickPick(ge,Se,Me)},showWorkspaceFolderPick(ge){return Gt.showWorkspaceFolderPick(ge)},showInputBox(ge,Se){return Gt.showInput(ge,Se)},showOpenDialog(ge){return Tn.showOpenDialog(ge)},showSaveDialog(ge){return Tn.showSaveDialog(ge)},createStatusBarItem(ge,Se,Me){let at,_t,At;return typeof ge=="string"?(at=ge,_t=Se,At=Me):(_t=ge,At=Se),Pn.createStatusBarEntry(He,at,_t,At)},setStatusBarMessage(ge,Se){return Pn.setStatusBarMessage(ge,Se)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),on.withProgress(He,{location:O.ProgressLocation.SourceControl},(Se,Me)=>ge({report(at){}}))},withProgress(ge,Se){return on.withProgress(He,ge,Se)},createOutputChannel(ge,Se){return yt.createOutputChannel(ge,Se,He)},createWebviewPanel(ge,Se,Me,at){return Zt.createWebviewPanel(He,ge,Se,Me,at)},createWebviewTextEditorInset(ge,Se,Me,at){return(0,ze.checkProposedApiEnabled)(He,"editorInsets"),pn.createWebviewEditorInset(ge,Se,Me,at,He)},createTerminal(ge,Se,Me){return typeof ge=="object"?"pty"in ge?Je.createExtensionTerminal(ge):Je.createTerminalFromOptions(ge):Je.createTerminal(ge,Se,Me)},registerTerminalLinkProvider(ge){return Je.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Se){return Je.registerProfileProvider(He,ge,Se)},registerTreeDataProvider(ge,Se){return Wt.registerTreeDataProvider(ge,Se,He)},createTreeView(ge,Se){return Wt.createTreeView(ge,Se,He)},registerWebviewPanelSerializer:(ge,Se)=>Zt.registerWebviewPanelSerializer(He,ge,Se),registerCustomEditorProvider:(ge,Se,Me={})=>En.registerCustomEditorProvider(He,ge,Se,Me),registerFileDecorationProvider(ge){return je.registerFileDecorationProvider(ge,He.identifier)},registerUriHandler(ge){return St.registerUriHandler(He.identifier,ge)},createQuickPick(){return Gt.createQuickPick(He)},createInputBox(){return Gt.createInputBox(He)},get activeColorTheme(){return an.activeColorTheme},onDidChangeActiveColorTheme(ge,Se,Me){return an.onDidChangeActiveColorTheme(ge,Se,Me)},registerWebviewViewProvider(ge,Se,Me){return Sn.registerWebviewViewProvider(He,ge,Se,Me?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Se,Me){return bt.onDidChangeActiveNotebookEditor(ge,Se,Me)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Se,Me){return xt.onDidChangeNotebookEditorSelection(ge,Se,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Se,Me){return xt.onDidChangeNotebookEditorVisibleRanges(ge,Se,Me)},showNotebookDocument(ge,Se){return _.URI.isUri(ge)&&Re.report("window.showNotebookDocument(uri)",He,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),bt.showNotebookDocument(ge,Se)},registerExternalUriOpener(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"externalUriOpener"),_n.registerExternalUriOpener(He.identifier,ge,Se,Me)},get tabGroups(){return Fe.tabGroups},logTelemetryToOutputChannel(ge,Se){(0,ze.checkProposedApiEnabled)(He,"telemetryLog"),Ae.logToTelemetryOutputChannel(He,ge,Se)}},An={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return ft.getWorkspaceFolder(ge)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ge){throw t.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,Se,...Me)=>ft.updateWorkspaceFolders(He,ge,Se||0,...Me),onDidChangeWorkspaceFolders:function(ge,Se,Me){return ft.onDidChangeWorkspace(ge,Se,Me)},asRelativePath:(ge,Se)=>ft.getRelativePath(ge,Se),findFiles:(ge,Se,Me,at)=>ft.findFiles(ge,Se,Me,He.identifier,at),findTextInFiles:(ge,Se,Me,at)=>{(0,ze.checkProposedApiEnabled)(He,"findTextInFiles");let _t,At;return typeof Se=="object"?(_t=Se,At=Me):(_t={},At=Se,at=Me),ft.findTextInFiles(ge,_t||{},At,He.identifier,at)},saveAll:ge=>ft.saveAll(ge),applyEdit(ge){return Fn.applyWorkspaceEdit(ge,He)},createFileSystemWatcher:(ge,Se,Me,at)=>$t.createFileSystemWatcher(ft,He,ge,Se,Me,at),get textDocuments(){return gt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let Se;const Me=ge;if(typeof ge=="string")Se=Promise.resolve(_.URI.file(ge));else if(_.URI.isUri(ge))Se=Promise.resolve(ge);else if(!Me||typeof Me=="object")Se=gt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(at=>gt.ensureDocumentData(at).then(_t=>_t.document))},onDidOpenTextDocument:(ge,Se,Me)=>gt.onDidAddDocument(ge,Se,Me),onDidCloseTextDocument:(ge,Se,Me)=>gt.onDidRemoveDocument(ge,Se,Me),onDidChangeTextDocument:(ge,Se,Me)=>gt.onDidChangeDocument(ge,Se,Me),onDidSaveTextDocument:(ge,Se,Me)=>gt.onDidSaveDocument(ge,Se,Me),onWillSaveTextDocument:(ge,Se,Me)=>Qt.getOnWillSaveTextDocumentEvent(He)(ge,Se,Me),get notebookDocuments(){return bt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Se){let Me;if(_.URI.isUri(ge))Me=ge,await bt.openNotebookDocument(ge);else if(typeof ge=="string")Me=_.URI.revive(await bt.createNotebookDocument({viewType:ge,content:Se}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Se,Me){return qt.onDidSaveNotebookDocument(ge,Se,Me)},onDidChangeNotebookDocument(ge,Se,Me){return qt.onDidChangeNotebookDocument(ge,Se,Me)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Se,Me,at){return bt.registerNotebookSerializer(He,ge,Se,Me,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(ge,Se,Me,at)=>((0,ze.checkProposedApiEnabled)(He,"notebookContentProvider"),Re.report("workspace.registerNotebookContentProvider",He,"The notebookContentProvider API is not on track for finalization and will be removed."),bt.registerNotebookContentProvider(He,ge,Se,Me,(0,ze.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(ge,Se,Me)=>ln.onDidChangeConfiguration(ge,Se,Me),getConfiguration(ge,Se){return Se=arguments.length===1?void 0:Se,ln.getConfiguration(ge,Se,He)},registerTextDocumentContentProvider(ge,Se){return Tt.registerTextDocumentContentProvider(ge,Se)},registerTaskProvider:(ge,Se)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,ge,Se)),registerFileSystemProvider(ge,Se,Me){return(0,Be.combinedDisposable)(vn.registerFileSystemProvider(He,ge,Se,Me),wt.addFileSystemProvider(ge,Se))},get fs(){return wt.value},registerFileSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"fileSearchProvider"),kt.registerFileSearchProvider(ge,Se)),registerTextSearchProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"textSearchProvider"),kt.registerTextSearchProvider(ge,Se)),registerRemoteAuthorityResolver:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),Ct.registerRemoteAuthorityResolver(ge,Se)),registerResourceLabelFormatter:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),wn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Se,Me)=>$t.onDidCreateFile(ge,Se,Me),onDidDeleteFiles:(ge,Se,Me)=>$t.onDidDeleteFile(ge,Se,Me),onDidRenameFiles:(ge,Se,Me)=>$t.onDidRenameFile(ge,Se,Me),onWillCreateFiles:(ge,Se,Me)=>$t.getOnWillCreateFileEvent(He)(ge,Se,Me),onWillDeleteFiles:(ge,Se,Me)=>$t.getOnWillDeleteFileEvent(He)(ge,Se,Me),onWillRenameFiles:(ge,Se,Me)=>$t.getOnWillRenameFileEvent(He)(ge,Se,Me),openTunnel:ge=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),It.openTunnel(He,ge).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,ze.checkProposedApiEnabled)(He,"resolvers"),It.getTunnels()},onDidChangeTunnels:(ge,Se,Me)=>((0,ze.checkProposedApiEnabled)(He,"resolvers"),It.onDidChangeTunnels(ge,Se,Me)),registerPortAttributesProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"portsAttributes"),It.registerPortsAttributesProvider(ge,Se)),registerTimelineProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"timeline"),On.registerTimelineProvider(ge,Se,He.identifier,Ke.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ge=>((0,ze.checkProposedApiEnabled)(He,"workspaceTrust"),ft.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Se,Me)=>ft.onDidGrantWorkspaceTrust(ge,Se,Me),registerEditSessionIdentityProvider:(ge,Se)=>((0,ze.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ge,Se))},Vt={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),sn.getLastInputBox(He)},createSourceControl(ge,Se,Me){return sn.createSourceControl(He,ge,Se,Me)}},dn={createCommentController(ge,Se){return bn.createCommentController(He,ge,Se)}},$n={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,Se,Me){return lt.onDidStartDebugSession(ge,Se,Me)},onDidTerminateDebugSession(ge,Se,Me){return lt.onDidTerminateDebugSession(ge,Se,Me)},onDidChangeActiveDebugSession(ge,Se,Me){return lt.onDidChangeActiveDebugSession(ge,Se,Me)},onDidReceiveDebugSessionCustomEvent(ge,Se,Me){return lt.onDidReceiveDebugSessionCustomEvent(ge,Se,Me)},onDidChangeBreakpoints(ge,Se,Me){return lt.onDidChangeBreakpoints(ge,Se,Me)},registerDebugConfigurationProvider(ge,Se,Me){return lt.registerDebugConfigurationProvider(ge,Se,Me||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Se){return lt.registerDebugAdapterDescriptorFactory(He,ge,Se)},registerDebugAdapterTrackerFactory(ge,Se){return lt.registerDebugAdapterTrackerFactory(ge,Se)},startDebugging(ge,Se,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(ge,Se,{parentSession:Me}):lt.startDebugging(ge,Se,Me||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,Se){return lt.asDebugSourceUri(ge,Se)}},Mt={registerTaskProvider:(ge,Se)=>Et.registerTaskProvider(He,ge,Se),fetchTasks:ge=>Et.fetchTasks(ge),executeTask:ge=>Et.executeTask(He,ge),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ge,Se,Me)=>Et.onDidStartTask(ge,Se,Me),onDidEndTask:(ge,Se,Me)=>Et.onDidEndTask(ge,Se,Me),onDidStartTaskProcess:(ge,Se,Me)=>Et.onDidStartTaskProcess(ge,Se,Me),onDidEndTaskProcess:(ge,Se,Me)=>Et.onDidEndTaskProcess(ge,Se,Me)},hn={createNotebookController(ge,Se,Me,at,_t){return nn.createNotebookController(He,ge,Se,Me,at,(0,ze.isProposedApiEnabled)(He,"notebookMessaging")?_t:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Se)=>bt.registerNotebookCellStatusBarItemProvider(He,ge,Se),createRendererMessaging(ge){return gn.createRendererMessaging(He,ge)},onDidChangeNotebookCellExecutionState(ge,Se,Me){return(0,ze.checkProposedApiEnabled)(He,"notebookCellExecutionState"),nn.onDidChangeNotebookCellExecutionState(ge,Se,Me)}};return{version:et.version,authentication:Mn,commands:Un,comments:dn,debug:$n,env:tn,extensions:zn,languages:Wn,notebooks:hn,scm:Vt,tasks:Mt,tests:Bn,window:Dn,workspace:An,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:S.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:D.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:C.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,SnippetTextEdit:O.SnippetTextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItem2:O.TreeItem,TreeItemCheckboxState:O.TreeItemCheckboxState,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:ot.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=ct}),define(De[294],Ie([1,0,266,303,304,2,305]),function(J,e,l,t,D,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(k,S,T,E,g,b){const m=b.environment.useHostProxy,v=typeof m=="boolean"?m:!b.remote.isRemote,p=(0,_.createProxyResolver)({resolveProxy:h=>k.resolveProxy(h),getHttpProxySetting:()=>S.getConfiguration("http").get("proxy"),log:(h,i,...u)=>{switch(h){case _.LogLevel.Trace:E.trace(i,...u);break;case _.LogLevel.Debug:E.debug(i,...u);break;case _.LogLevel.Info:E.info(i,...u);break;case _.LogLevel.Warning:E.warn(i,...u);break;case _.LogLevel.Error:E.error(i,...u);break;case _.LogLevel.Critical:E.critical(i,...u);break;case _.LogLevel.Off:break;default:o(h,i,u);break}function o(r,s,...n){E.error("Unknown log level",r),E.error(s,...n)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:v,env:process.env}),a=w(S,p);return R(T,a)}e.connectProxyResolver=I;function w(k,S){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(g=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(g=>{E.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"off"},E,!0)),on:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"on"},E,!0)),override:Object.assign({},l,(0,_.createHttpPatch)(l,S,{config:"override"},E,!0)),onRequest:Object.assign({},l,(0,_.createHttpPatch)(l,S,T,E,!0)),default:Object.assign(l,(0,_.createHttpPatch)(l,S,T,E,!1))},https:{off:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"off"},E,!0)),on:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"on"},E,!0)),override:Object.assign({},t,(0,_.createHttpPatch)(t,S,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,_.createHttpPatch)(t,S,T,E,!0)),default:Object.assign(t,(0,_.createHttpPatch)(t,S,T,E,!1))},tls:Object.assign(D,(0,_.createTlsPatch)(D))}}const C=new Map;function R(k,S){return k.getExtensionPathIndex().then(T=>{const E=J.__$__nodeRequire("module"),g=E._load;E._load=function(m,v,p){if(m==="tls")return S.tls;if(m!=="http"&&m!=="https")return g.apply(this,arguments);const a=S[m],h=T.findSubstr(P.URI.file(v.filename));let i=C.get(h);if(i||C.set(h,i={}),!i[m]){const u=a.default;i[m]={...u}}return i[m]}})}}),define(De[295],Ie([1,0,72,293,280,294,39,268,2,12,7,265,108,267]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends D.RequireInterceptor{_installInterceptor(){const m=this,v=J.__$__nodeRequire("module"),p=v._load;v._load=function(u,o,r){return u=h(u),m._factories.has(u)?m._factories.get(u).load(u,w.URI.file((0,S.realpathSync)(o.filename)),s=>p.apply(this,[s,o,r])):p.apply(this,arguments)};const a=v._resolveLookupPaths;v._resolveLookupPaths=(i,u)=>a.call(this,h(i),u);const h=i=>{for(const u of m._alternatives){const o=u(i);if(o){i=o;break}}return i}}}class g extends _.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(T.ExtHostConsoleForwarder);const m=this._instaService.invokeFunction(t.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(I.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const a=this._instaService.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}await this._instaService.createInstance(E,m,{mine:this._myRegistry,all:this._globalRegistry}).install(),l.mark("code/extHost/didInitAPI");const p=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,p,this,this._logService,this._mainThreadTelemetryProxy,this._initData),l.mark("code/extHost/didInitProxyResolver")}_getEntryPoint(m){return m.main}_loadCommonJSModule(m,v,p){if(v.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${v}', must be of file-scheme`);let a=null;p.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${v.toString(!0)}`),this._logService.flush();const h=m?.identifier.value;try{h&&l.mark(`code/extHost/willLoadExtensionCode/${h}`),a=J.__$__nodeRequire(v.fsPath)}catch(i){return Promise.reject(i)}finally{h&&l.mark(`code/extHost/didLoadExtensionCode/${h}`),p.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(m){if(!!this._initData.remote.isRemote)for(const v in m){const p=m[v];p===null?delete process.env[v]:process.env[v]=p}}}e.ExtHostExtensionService=g}),define(De[142],Ie([1,0,44,306,289,17,76,36,9,8,2,30,70,307,287,92]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(f){this.outputChannel=f}provideTextSearchResults(f,y,L,M){return this.outputChannel.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((B,A)=>{M.onCancellationRequested(()=>V());const W=u(f,y),U=y.folder.fsPath,N=W.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${b} ${N}
 - cwd: ${U}`);let G=l.spawn(b,W,{cwd:U});G.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),A((0,k.serializeSearchError)(new k.SearchError(ve&&ve.message,k.SearchErrorCode.rgProcessError)))});let z=!1;const O=new a(y.maxResults,U,y.previewOptions);O.on("result",ve=>{z=!0,Y="",L.report(ve)});let x=!1;const V=()=>{x=!0,G?.kill(),O?.cancel()};let q=!1;O.on("hitLimit",()=>{q=!0,V()});let Y="";G.stdout.on("data",ve=>{O.handleData(ve),z||(Y+=ve)});let Q=!1;G.stdout.once("data",()=>Q=!0);let he="";G.stderr.on("data",ve=>{const ne=ve.toString();this.outputChannel.appendLine(ne),he.length+ne.length<1e6&&(he+=ne)}),G.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(z?"Got result from parser":"No result from parser"),Y&&this.outputChannel.appendLine(`Got data without result: ${Y}`),this.outputChannel.appendLine(""),x)B({limitHit:q});else{O.flush(),G=null;let ve;he&&!Q&&(ve=v(he))?A((0,k.serializeSearchError)(new k.SearchError(ve.message,ve.code))):B({limitHit:q})}})})}}e.RipgrepTextSearchEngine=m;function v(d){const f=d.split(`
`),y=f[0].trim();if(f.some(M=>M.startsWith("regex parse error")))return new k.SearchError(p(f),k.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new k.SearchError(`Unknown encoding: ${L[1]}`,k.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new k.SearchError(y.charAt(0).toUpperCase()+y.substr(1),k.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new k.SearchError(y.charAt(0).toUpperCase()+y.substr(1),k.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(y,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=v;function p(d){const f=["Regex parse error"],y=d.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const M=L.split(":")[1];f.push(":"+M)}}return f.join("")}e.buildRegexParseError=p;class a extends t.EventEmitter{constructor(f,y,L){super(),this.maxResults=f,this.rootFolder=y,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(f,y){return super.on(f,y),this}handleData(f){if(this.isDone)return;const y=typeof f=="string"?f:this.stringDecoder.write(f);this.handleDecodedData(y)}handleDecodedData(f){let y=f.indexOf(`
`);const L=this.remainder+f;if(y>=0)y+=this.remainder.length;else{this.remainder=L;return}let M=0;for(;y>=0;)this.handleLine(L.substring(M,y).trim()),M=y+1,y=L.indexOf(`
`,M);this.remainder=L.substring(M)}handleLine(f){if(this.isDone||!f)return;let y;try{y=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(y.type==="match"){const L=h(y.data.path),M=R.URI.file(w.join(this.rootFolder,L)),B=this.createTextSearchMatch(y.data,M);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=h(y.data.path),M=R.URI.file(w.join(this.rootFolder,L));this.createTextSearchContext(y.data,M).forEach(A=>this.onResult(A))}}createTextSearchMatch(f,y){const L=f.line_number-1,M=h(f.lines),B=Buffer.from(M);let A=0,W=0,U=L;f.submatches.length===0&&f.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.coalesce)(f.submatches.map((G,z)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const O=h(G.match),x=B.slice(A,G.start).toString().length,V=W+x,q=i(O),Y=U,Q=q.numLines+Y,he=q.numLines>0?q.lastLineLength:q.lastLineLength+V;return A=G.end,W=he,U=Q,new S.Range(Y,V,Q,he)}));return(0,g.createTextSearchResult)(y,M,N,this.previewOptions)}createTextSearchContext(f,y){const L=h(f.lines),M=f.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((B,A)=>({text:B,uri:y,lineNumber:M+A}))}onResult(f){this.emit("result",f)}}e.RipgrepParser=a;function h(d){return d.bytes?Buffer.from(d.bytes,"base64").toString():d.text}function i(d){const f=/\n/g;let y=0,L=-1,M;for(;M=f.exec(d);)y++,L=M.index;const B=L>=0?d.length-L-1:d.length;return{numLines:y,lastLineLength:B}}function u(d,f){const y=["--hidden"];y.push(d.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:M}=(0,_.groupBy)(f.includes,A=>A.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const A=new Set;M.forEach(W=>{A.add(W)}),y.push("-g","!*"),A.forEach(W=>{o(W).map(g.anchorGlob).forEach(U=>{y.push("-g",U)})})}L&&L.length&&L.forEach(A=>{y.push("-g",A)}),f.excludes.map(g.anchorGlob).forEach(A=>y.push("-g",`!${A}`)),f.maxFileSize&&y.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),f.followSymlinks&&y.push("--follow"),f.encoding&&f.encoding!=="utf8"&&y.push("--encoding",f.encoding),d.pattern==="--"&&(d.isRegExp=!0,d.pattern="\\-\\-"),d.isMultiline&&!d.isRegExp&&(d.pattern=(0,C.escapeRegExpCharacters)(d.pattern),d.isRegExp=!0),f.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),d.isRegExp&&(d.pattern=r(d.pattern),y.push("--engine","auto"));let B;if(d.isWordMatch){const W=(0,C.createRegExp)(d.pattern,!!d.isRegExp,{wholeWord:d.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",W)}else if(d.isRegExp){let A=n(d.pattern);A=c(A),y.push("--regexp",A)}else B=d.pattern,y.push("--fixed-strings");return y.push("--no-config"),f.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),d.isMultiline&&y.push("--multiline"),f.beforeContext&&y.push("--before-context",f.beforeContext+""),f.afterContext&&y.push("--after-context",f.afterContext+""),y.push("--"),B&&y.push(B),y.push("."),y}function o(d){const f=(0,I.splitGlobAware)(d,"/");return f.map((y,L)=>f.slice(0,L+1).join("/"))}e.spreadGlobComponents=o;function r(d){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;d.match(f);)d=d.replace(f,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;d.match(y);)d=d.replace(y,"$1\\x{$2}");return d}e.unicodeEscapesToPCRE2=r;const s=d=>d.type==="Assertion"&&d.kind==="lookbehind";function n(d){let f;try{f=new T.RegExpParser().parsePattern(d)}catch{return d}let y="",L=0;const M=(W,U,N)=>{y+=d.slice(L,W)+N,L=U},B=[];return new T.RegExpVisitor({onCharacterEnter(W){if(W.raw!=="\\n")return;const U=B[0];if(!U)M(W.start,W.end,"\\r?\\n");else if(!B.some(s))if(U.type==="CharacterClass")if(U.negate){const N=d.slice(U.start+2,W.start)+d.slice(W.end,U.end-1);U.parent?.type==="Quantifier"?M(U.start,U.end,N?`[^${N}]`:"."):M(U.start,U.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=d.slice(U.start+1,W.start)+d.slice(W.end,U.end-1);M(U.start,U.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else U.type==="Quantifier"&&M(W.start,W.end,"(?:\\r?\\n)")},onQuantifierEnter(W){B.unshift(W)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(W){B.unshift(W)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(W){B.unshift(W)},onCharacterClassLeave(){B.shift()},onAssertionEnter(W){s(W)&&B.push(W)},onAssertionLeave(W){B[0]===W&&B.shift()}}).visit(f),y+=d.slice(L),y}e.fixRegexNewline=n;function c(d){return d.replace(/\n/g,"\\r?\\n")}e.fixNewline=c}),define(De[296],Ie([1,0,21,142,118,12]),function(J,e,l,t,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class _{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,R,k,S){const T=new t.RipgrepTextSearchEngine(this.outputChannel);if(R.folder.scheme===P.Schemas.vscodeUserData){const E={...R,folder:R.folder.with({scheme:P.Schemas.file})},g=new D.Progress(b=>k.report({...b,uri:b.uri.with({scheme:R.folder.scheme})}));return this.withToken(S,b=>T.provideTextSearchResults(C,E,g,b))}else return this.withToken(S,E=>T.provideTextSearchResults(C,R,k,E))}async withToken(C,R){const k=I(C);this.inProgress.add(k);const S=await R(k.token);return this.inProgress.delete(k),S}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=_;function I(w){const C=new l.CancellationTokenSource;return w.onCancellationRequested(()=>C.cancel()),C}}),define(De[297],Ie([1,0,29,142,141]),function(J,e,l,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class P{constructor(w){this.query=w}search(w,C,R){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){R({message:T})}},S=new D.NativeTextSearchManager(this.query,new t.RipgrepTextSearchEngine(k),l);return new Promise((T,E)=>S.search(g=>{C(g.map(_))},w).then(g=>T({limitHit:g.limitHit,type:"success",stats:g.stats}),E))}}e.TextSearchEngineAdapter=P;function _(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((w,C)=>{if(C.ranges){const R=C;return w+(Array.isArray(R.ranges)?R.ranges.length:1)}else return w+1},0)}}}),define(De[298],Ie([1,0,17,18,10,4,104,9,51,2,42,30,288,297]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let h;const i=m(a),u=new P.Emitter({onFirstListenerDidAdd:()=>{h=(0,t.createCancelablePromise)(o=>this.doFileSearchWithEngine(S.Engine,i,r=>u.fire(r),o)),h.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return u.event}textSearch(a){let h;const i=m(a),u=new P.Emitter({onFirstListenerDidAdd:()=>{h=(0,t.createCancelablePromise)(o=>this.ripgrepTextSearch(i,r=>u.fire(r),o)),h.then(o=>u.fire(o),o=>u.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{h.cancel()}});return u.event}ripgrepTextSearch(a,h,i){return a.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new T.TextSearchEngineAdapter(a).search(i,h,h)}doFileSearch(a,h,i){return this.doFileSearchWithEngine(S.Engine,a,h,i)}doFileSearchWithEngine(a,h,i,u,o=E.BATCH_SIZE){let r=0;const s=c=>{Array.isArray(c)?(r+=c.length,i(c.map(d=>this.rawMatchToSearchItem(d)))):c.relativePath?(r++,i(this.rawMatchToSearchItem(c))):i(c)};if(h.sortByScore){let c=this.trySortedSearchFromCache(h,s,u);if(!c){const d=h.maxResults?Object.assign({},h,{maxResults:null}):h,f=new a(d);c=this.doSortedSearch(f,h,i,s,u)}return new Promise((d,f)=>{c.then(([y,L])=>{const M=L.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(M,i,o),d(y)},f)})}const n=new a(h);return this.doSearch(n,s,o,u).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.processType,fromCache:!1,resultCount:r,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,I.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,h,i,u,o){const r=new P.Emitter;let s=(0,t.createCancelablePromise)(c=>{let d=[];const f=y=>{Array.isArray(y)?d=y:(u(y),r.fire(y))};return this.doSearch(a,f,-1,c).then(y=>[y,d])}),n;if(h.cacheKey){n=this.getOrCreateCache(h.cacheKey);const c={promise:s,event:r.event,resolved:!1};n.resultsToSearchCache[h.filePattern||""]=c,s.then(()=>{c.resolved=!0},d=>{delete n.resultsToSearchCache[h.filePattern||""]}),s=this.preventCancellation(s)}return s.then(([c,d])=>{const f=n?n.scorerCache:Object.create(null),y=(typeof h.maxResults!="number"||h.maxResults>0)&&w.StopWatch.create(!1);return this.sortResults(h,d,f,o).then(L=>{const M=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:M,fromCache:!1,type:this.processType,workspaceFolderCount:h.folderQueries.length,resultCount:L.length},messages:c.messages,limitHit:c.limitHit||typeof h.maxResults=="number"&&d.length>h.maxResults},L]})})}getOrCreateCache(a){const h=this.caches[a];return h||(this.caches[a]=new g)}trySortedSearchFromCache(a,h,i){const u=a.cacheKey&&this.caches[a.cacheKey];if(!u)return;const o=this.getResultsFromCache(u,a.filePattern||"",h,i);if(o)return o.then(([r,s,n])=>{const c=w.StopWatch.create(!1);return this.sortResults(a,s,u.scorerCache,i).then(d=>{const f=c.elapsed(),y={fromCache:!0,detailStats:n,type:this.processType,resultCount:s.length,sortingTime:f};return[{type:"success",limitHit:r.limitHit||typeof a.maxResults=="number"&&s.length>a.maxResults,stats:y},d]})})}sortResults(a,h,i,u){const o=(0,_.prepareQuery)(a.filePattern||""),r=(n,c)=>(0,_.compareItemsByFuzzyScore)(n,c,o,!0,b,i),s=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return l.topAsync(h,r,s,1e4,u)}sendProgress(a,h,i){if(i&&i>0)for(let u=0;u<a.length;u+=i)h(a.slice(u,u+i));else h(a)}getResultsFromCache(a,h,i,u){const o=w.StopWatch.create(!1),r=h.indexOf(I.sep)>=0;let s;for(const f in a.resultsToSearchCache)if(h.startsWith(f)){if(r&&f.indexOf(I.sep)<0&&f!=="")continue;const y=a.resultsToSearchCache[f];s={promise:this.preventCancellation(y.promise),event:y.event,resolved:y.resolved};break}if(!s)return null;const n=o.elapsed(),c=w.StopWatch.create(!1),d=s.event(i);return u&&u.onCancellationRequested(()=>{d.dispose()}),s.promise.then(([f,y])=>{if(u&&u.isCancellationRequested)throw(0,D.canceled)();const L=[],M=(0,_.prepareQuery)(h).normalizedLowercase;for(const B of y)!(0,k.isFilePatternMatch)(B,M)||L.push(B);return[f,L,{cacheWasResolved:s.resolved,cacheLookupTime:n,cacheFilterTime:c.elapsed(),cacheEntryCount:y.length}]})}doSearch(a,h,i,u){return new Promise((o,r)=>{let s=[];u?.onCancellationRequested(()=>a.cancel()),a.search(n=>{n&&(i?(s.push(n),i>0&&s.length>=i&&(h(s),s=[])):h(n))},n=>{h(n)},(n,c)=>{s.length&&h(s),n?r(n):o(c)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(h,i){return a.then(h,i)}catch(h){return this.then(void 0,h)}finally(h){return a.finally(h)}}}}e.SearchService=E,E.BATCH_SIZE=512;class g{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(p){return(0,I.basename)(p.relativePath)}getItemDescription(p){return(0,I.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function m(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(a=>C.URI.revive(a))}}function v(p){return{...p,folder:C.URI.revive(p.folder)}}}),define(De[299],Ie([1,0,6,12,2,29,14,26,15,74,54,30,298,296,92,141]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends C.ExtHostSearch{constructor(v,p,a,h){super(v,a,h),this._pfs=P,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const i=new E.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new T.RipgrepSearchProvider(i)),p.remote.isRemote&&p.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const v=new E.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(t.Schemas.file,new T.RipgrepSearchProvider(v)),this.registerInternalFileSearchProvider(t.Schemas.file,new S.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(v,p){const a=this._handlePool++;return this._internalFileSearchProvider=p,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(v)),(0,l.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(v,p,a,h){const i=(0,C.reviveQuery)(a);return v===this._internalFileSearchHandle?this.doInternalFileSearch(v,p,i,h):super.$provideFileSearchResults(v,p,a,h)}doInternalFileSearch(v,p,a,h){const i=u=>{if((0,k.isSerializedFileMatch)(u)&&(u=[u]),Array.isArray(u)){this._proxy.$handleFileMatch(v,p,u.map(o=>D.URI.file(o.path)));return}u.message&&this._logService.debug("ExtHostSearch",u.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,i,h)}$clearCache(v){return this._internalFileSearchProvider?.clearCache(v),super.$clearCache(v)}createTextSearchManager(v,p){return new g.NativeTextSearchManager(v,p,void 0,"textSearchProvider")}};b=qe([xe(0,w.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,R.IURITransformerService),xe(3,_.ILogService)],b),e.NativeExtHostSearch=b}),define(De[300],Ie([1,0,82,271,283,282,299,295,272,73,39,74,71,38,53,68,270,269,14,284,47]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m,v,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(R.IExtHostExtensionService,I.ExtHostExtensionService,!1),(0,l.registerSingleton)(v.ILoggerService,m.ExtHostLoggerService,!0),(0,l.registerSingleton)(g.IExtensionStoragePaths,b.ExtensionStoragePaths,!1),(0,l.registerSingleton)(C.IExtHostDebugService,P.ExtHostDebugService,!1),(0,l.registerSingleton)(k.IExtHostSearch,_.NativeExtHostSearch,!1),(0,l.registerSingleton)(S.IExtHostTask,D.ExtHostTask,!1),(0,l.registerSingleton)(T.IExtHostTerminalService,t.ExtHostTerminalService,!1),(0,l.registerSingleton)(E.IExtHostTunnelService,w.ExtHostTunnelService,!1),(0,l.registerSingleton)(a.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService,!1)}),define(De[308],Ie([1,0,212,309,72,10,111,112,195,130,281,23,29,108,18,114,207,221,285,300]),function(J,e,l,t,D,P,_,I,w,C,R,k,S,T,E,g,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const v=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=J.__$__nodeRequire("module"),n=s._load;s._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return n.apply(this,arguments)}})();const p=process.exit.bind(process);function a(s){process.exit=function(n){if(s)p(n);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let h=function(s){p()};function i(){const s=(0,m.readExtHostConnection)(process.env);if(s.type===3)return new Promise((n,c)=>{const d=f=>{const y=f[0],L=new _.BufferedEmitter;y.on("message",M=>L.fire(k.VSBuffer.wrap(M.data))),y.on("close",()=>{h("renderer closed the MessagePort")}),y.start(),n({onMessage:L.event,send:M=>y.postMessage(M.buffer)})};if(global.vscodePorts){const f=global.vscodePorts;delete global.vscodePorts,d(f)}else global.vscodePortsCallback=d});if(s.type===2)return new Promise((n,c)=>{let d=null;const f=setTimeout(()=>{h("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,M=new E.ProcessTimeRunOnceScheduler(()=>h("renderer disconnected for too long (1)"),y),B=new E.ProcessTimeRunOnceScheduler(()=>h("renderer disconnected for too long (2)"),L);process.on("message",(W,U)=>{if(W&&W.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const N=k.VSBuffer.wrap(Buffer.from(W.initialDataChunk,"base64"));let G;if(W.skipWebSocketFrames)G=new I.NodeSocket(U,"extHost-socket");else{const z=k.VSBuffer.wrap(Buffer.from(W.inflateBytes,"base64"));G=new I.WebSocketNodeSocket(new I.NodeSocket(U,"extHost-socket"),W.permessageDeflate,z,!1)}d?(M.cancel(),B.cancel(),d.beginAcceptReconnection(G,N),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(f),d=new _.PersistentProtocol(G,N),d.sendResume(),d.onDidDispose(()=>h("renderer disconnected")),n(d),d.onSocketClose(()=>{M.schedule()}))}if(W&&W.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(B.isScheduled())return;M.isScheduled()&&B.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(A)});{const n=s.pipeName;return new Promise((c,d)=>{const f=l.createConnection(n,()=>{f.removeListener("error",d);const y=new _.PersistentProtocol(new I.NodeSocket(f,"extHost-renderer"));y.sendResume(),c(y)});f.once("error",d),f.on("close",()=>{h("renderer closed the socket")})})}}async function u(){const s=await i();return new class{constructor(){this._onMessage=new _.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{(0,C.isMessageOfType)(n,2)?(this._terminating=!0,h("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}async drain(){if(s.drain)return s.drain()}}}function o(s){return new Promise(n=>{const c=s.onMessage(d=>{c.dispose();const f=JSON.parse(d.toString()),y=f.commit,L=w.default.commit;if(y&&L&&y!==L&&p(55),f.parentPid){let M=0;setInterval(function(){try{process.kill(f.parentPid,0),M=0}catch(A){A&&A.code==="EPERM"?(M++,M>=3&&h(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${A.message} (code: ${A.code}) (errno: ${A.errno})`)):h(`parent process ${f.parentPid} does not exist anymore: ${A.message} (code: ${A.code}) (errno: ${A.errno})`)}},1e3);let B;try{B=J.__$__nodeRequire("native-watchdog"),B.start(f.parentPid)}catch(A){(0,P.onUnexpectedError)(A)}}s.send((0,C.createMessageOfType)(0)),n({protocol:s,initData:f})});s.send((0,C.createMessageOfType)(1))})}async function r(){const s=[];process.on("unhandledRejection",(M,B)=>{s.push(B),setTimeout(()=>{const A=s.indexOf(B);A>=0&&B.catch(W=>{s.splice(A,1),(0,P.isCancellationError)(W)||(console.warn(`rejected promise not handled within 1 second: ${W}`),W&&W.stack&&console.warn(`stack trace: ${W.stack}`),M&&(0,P.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const B=s.indexOf(M);B>=0&&s.splice(B,1)}),process.on("uncaughtException",function(M){(0,P.onUnexpectedError)(M)}),D.mark("code/extHost/willConnectToRenderer");const n=await u();D.mark("code/extHost/didConnectToRenderer");const c=await o(n);D.mark("code/extHost/didWaitForInitData");const{initData:d}=c;a(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=v.useHostProxy!==void 0?v.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,g.boolean)(v.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(B){p(B)}exists(B){return S.Promises.exists(B)}realpath(B){return(0,T.realpath)(B)}};let y=null;d.remote.authority&&v.transformURIs&&(y=(0,b.createURITransformer)(d.remote.authority));const L=new R.ExtensionHostMain(c.protocol,d,f,y);h=M=>L.terminate(M)}e.startExtensionHostProcess=r,r().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ecad25c181c084a505add3e76b34932f0bcc4b25/core/vs/workbench/api/node/extensionHostProcess.js.map
