/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ne){for(var e=[],o=0,y=ne.length;o<y;o++)e[o]=Ce[ne[o]];return e};define(Ce[71],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(_,P){const E=Object.create(null);for(const k of _){const O=P(k);let w=E[O];w||(w=E[O]=[]),w.push(k)}return E}e.groupBy=o;function y(_,P){const E=[],k=[];for(const O of _)P.has(O)||E.push(O);for(const O of P)_.has(O)||k.push(O);return{removed:E,added:k}}e.diffSets=y;function b(_,P){const E=[],k=[];for(const[O,w]of _)P.has(O)||E.push(w);for(const[O,w]of P)_.has(O)||k.push(w);return{removed:E,added:k}}e.diffMaps=b;class M{constructor(){this.map=new Map}add(P,E){let k=this.map.get(P);k||(k=new Set,this.map.set(P,k)),k.add(E)}delete(P,E){const k=this.map.get(P);!k||(k.delete(E),k.size===0&&this.map.delete(P))}forEach(P,E){const k=this.map.get(P);!k||k.forEach(E)}}e.SetMap=M}),define(Ce[55],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(_){return(P,E,k)=>{let O=null,w=null;if(typeof k.value=="function"?(O="value",w=k.value):typeof k.get=="function"&&(O="get",w=k.get),!w)throw new Error("not supported");k[O]=_(w,E)}}e.createDecorator=o;function y(_,P,E){let k=null,O=null;if(typeof E.value=="function"?(k="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",O=E.get),!O)throw new Error("not supported");const w=`$memoize$${P}`;E[k]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[w]}}e.memoize=y;function b(_,P,E){return o((k,O)=>{const w=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...I){this[m]||(this[m]=E?E():void 0),clearTimeout(this[w]),P&&(this[m]=P(this[m],...I),I=[this[m]]),this[w]=setTimeout(()=>{k.apply(this,I),this[m]=E?E():void 0},_)}})}e.debounce=b;function M(_,P,E){return o((k,O)=>{const w=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,I=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...a){if(this[m]||(this[m]=E?E():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...a)),this[f])return;const h=this[I]+_;h<=Date.now()?(this[I]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[I]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0},h-Date.now()))}})}e.throttle=M}),define(Ce[72],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(Ce[106],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function _(t,u=!1){let n=0;const r=t.length;let s="",i=0,l=16,S=0;function p(N){let L=0,q=0;for(;L<N;){const W=t.charCodeAt(n);if(W>=48&&W<=57)q=q*16+W-48;else if(W>=65&&W<=70)q=q*16+W-65+10;else if(W>=97&&W<=102)q=q*16+W-97+10;else break;n++,L++}return L<N&&(q=-1),q}function T(N){n=N,s="",i=0,l=16,S=0}function U(){const N=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&k(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&k(t.charCodeAt(n)))for(n++;n<t.length&&k(t.charCodeAt(n));)n++;else return S=3,t.substring(N,n);let L=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&k(t.charCodeAt(n))){for(n++;n<t.length&&k(t.charCodeAt(n));)n++;L=n}else S=3;return t.substring(N,L)}function j(){let N="",L=n;for(;;){if(n>=r){N+=t.substring(L,n),S=2;break}const q=t.charCodeAt(n);if(q===34){N+=t.substring(L,n),n++;break}if(q===92){if(N+=t.substring(L,n),n++,n>=r){S=2;break}switch(t.charCodeAt(n++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const R=p(4);R>=0?N+=String.fromCharCode(R):S=4;break}default:S=5}L=n;continue}if(q>=0&&q<=31)if(E(q)){N+=t.substring(L,n),S=2;break}else S=6;n++}return N}function x(){if(s="",S=0,i=n,n>=r)return i=r,l=17;let N=t.charCodeAt(n);if(P(N)){do n++,s+=String.fromCharCode(N),N=t.charCodeAt(n);while(P(N));return l=15}if(E(N))return n++,s+=String.fromCharCode(N),N===13&&t.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(N){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=j(),l=10;case 47:{const L=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<r&&!E(t.charCodeAt(n));)n++;return s=t.substring(L,n),l=12}if(t.charCodeAt(n+1)===42){n+=2;const q=r-1;let W=!1;for(;n<q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,S=1),s=t.substring(L,n),l=13}return s+=String.fromCharCode(N),n++,l=16}case 45:if(s+=String.fromCharCode(N),n++,n===r||!k(t.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),l=11;default:for(;n<r&&C(N);)n++,N=t.charCodeAt(n);if(i!==n){switch(s=t.substring(i,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(N),n++,l=16}}function C(N){if(P(N)||E(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let N;do N=x();while(N>=12&&N<=15);return N}return{setPosition:T,getPosition:()=>n,scan:u?z:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>i,getTokenLength:()=>n-i,getTokenError:()=>S}}e.createScanner=_;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function w(t,u){const n=[],r=new Object;let s;const i={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(p,T,U,j){i.value=p,i.offset=T,i.length=U,i.type=j,i.colonOffset=void 0,s=i}try{A(t,{onObjectBegin:(p,T)=>{if(u<=p)throw r;s=void 0,l=u>p,n.push("")},onObjectProperty:(p,T,U)=>{if(u<T||(S(p,T,U,"property"),n[n.length-1]=p,u<=T+U))throw r},onObjectEnd:(p,T)=>{if(u<=p)throw r;s=void 0,n.pop()},onArrayBegin:(p,T)=>{if(u<=p)throw r;s=void 0,n.push(0)},onArrayEnd:(p,T)=>{if(u<=p)throw r;s=void 0,n.pop()},onLiteralValue:(p,T,U)=>{if(u<T||(S(p,T,U,v(p)),u<=T+U))throw r},onSeparator:(p,T,U)=>{if(u<=T)throw r;if(p===":"&&s&&s.type==="property")s.colonOffset=T,l=!1,s=void 0;else if(p===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:s,isAtPropertyKey:l,matches:p=>{let T=0;for(let U=0;T<p.length&&U<n.length;U++)if(p[T]===n[U]||p[T]==="*")T++;else if(p[T]!=="**")return!1;return T===p.length}}}e.getLocation=w;function m(t,u=[],n=M.DEFAULT){let r=null,s=[];const i=[];function l(p){Array.isArray(s)?s.push(p):r!==null&&(s[r]=p)}return A(t,{onObjectBegin:()=>{const p={};l(p),i.push(s),s=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{s=i.pop()},onArrayBegin:()=>{const p=[];l(p),i.push(s),s=p,r=null},onArrayEnd:()=>{s=i.pop()},onLiteralValue:l,onError:(p,T,U)=>{u.push({error:p,offset:T,length:U})}},n),s[0]}e.parse=m;function I(t,u=[],n=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function i(p){return r.children.push(p),p}A(t,{onObjectBegin:p=>{r=i({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,T,U)=>{r=i({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:T,length:U,parent:r})},onObjectEnd:(p,T)=>{r.length=p+T-r.offset,r=r.parent,s(p+T)},onArrayBegin:(p,T)=>{r=i({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,T)=>{r.length=p+T-r.offset,r=r.parent,s(p+T)},onLiteralValue:(p,T,U)=>{i({type:v(p),offset:T,length:U,parent:r,value:p}),s(T+U)},onSeparator:(p,T,U)=>{r.type==="property"&&(p===":"?r.colonOffset=T:p===","&&s(T))},onError:(p,T,U)=>{u.push({error:p,offset:T,length:U})}},n);const S=r.children[0];return S&&delete S.parent,S}e.parseTree=I;function f(t,u){if(!t)return;let n=t;for(const r of u)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const i of n.children)if(Array.isArray(i.children)&&i.children[0].value===r){n=i.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function a(t){if(!t.parent||!t.parent.children)return[];const u=a(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;u.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&u.push(n)}return u}e.getNodePath=a;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const u=Object.create(null);for(const n of t.children){const r=n.children[1];r&&(u[n.children[0].value]=h(r))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function d(t,u,n=!1){return u>=t.offset&&u<t.offset+t.length||n&&u===t.offset+t.length}e.contains=d;function g(t,u,n=!1){if(d(t,u,n)){const r=t.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=u;s++){const i=g(r[s],u,n);if(i)return i}return t}}e.findNodeAtOffset=g;function A(t,u,n=M.DEFAULT){const r=_(t,!1);function s(ve){return ve?()=>ve(r.getTokenOffset(),r.getTokenLength()):()=>!0}function i(ve){return ve?we=>ve(we,r.getTokenOffset(),r.getTokenLength()):()=>!0}const l=s(u.onObjectBegin),S=i(u.onObjectProperty),p=s(u.onObjectEnd),T=s(u.onArrayBegin),U=s(u.onArrayEnd),j=i(u.onLiteralValue),x=i(u.onSeparator),C=s(u.onComment),z=i(u.onError),N=n&&n.disallowComments,L=n&&n.allowTrailingComma;function q(){for(;;){const ve=r.scan();switch(r.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:N||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ve){case 12:case 13:N?W(10):C();break;case 16:W(1);break;case 15:case 14:break;default:return ve}}}function W(ve,we=[],re=[]){if(z(ve),we.length+re.length>0){let Ee=r.getToken();for(;Ee!==17;){if(we.indexOf(Ee)!==-1){q();break}else if(re.indexOf(Ee)!==-1)break;Ee=q()}}}function R(ve){const we=r.getTokenValue();return ve?j(we):S(we),q(),!0}function Z(){switch(r.getToken()){case 11:{let ve=0;try{ve=JSON.parse(r.getTokenValue()),typeof ve!="number"&&(W(2),ve=0)}catch{W(2)}j(ve);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return q(),!0}function le(){return r.getToken()!==10?(W(3,[],[2,5]),!1):(R(!1),r.getToken()===6?(x(":"),q(),ee()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function oe(){l(),q();let ve=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(ve||W(4,[],[]),x(","),q(),r.getToken()===2&&L)break}else ve&&W(6,[],[]);le()||W(4,[],[2,5]),ve=!0}return p(),r.getToken()!==2?W(7,[2],[]):q(),!0}function ue(){T(),q();let ve=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(ve||W(4,[],[]),x(","),q(),r.getToken()===4&&L)break}else ve&&W(6,[],[]);ee()||W(4,[],[4,5]),ve=!0}return U(),r.getToken()!==4?W(8,[4],[]):q(),!0}function ee(){switch(r.getToken()){case 3:return ue();case 1:return oe();case 10:return R(!0);default:return Z()}}return q(),r.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):ee()?(r.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=A;function c(t,u){const n=_(t),r=[];let s,i=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:i!==l&&r.push(t.substring(i,l)),u!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,u)),i=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=c;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[107],Ie([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Te,_e){for(var ye=0;ye<_e.length;ye++){var ae=_e[ye];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function o(Te,_e,ye){return _e&&e(Te.prototype,_e),ye&&e(Te,ye),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function y(Te,_e){if(!!Te){if(typeof Te=="string")return b(Te,_e);var ye=Object.prototype.toString.call(Te).slice(8,-1);if(ye==="Object"&&Te.constructor&&(ye=Te.constructor.name),ye==="Map"||ye==="Set")return Array.from(Te);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return b(Te,_e)}}function b(Te,_e){(_e==null||_e>Te.length)&&(_e=Te.length);for(var ye=0,ae=new Array(_e);ye<_e;ye++)ae[ye]=Te[ye];return ae}function M(Te,_e){var ye=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ye)return(ye=ye.call(Te)).next.bind(ye);if(Array.isArray(Te)||(ye=y(Te))||_e&&Te&&typeof Te.length=="number"){ye&&(Te=ye);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function P(Te){ne.defaults=Te}var E=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(_e){return m[_e]};function f(Te,_e){if(_e){if(E.test(Te))return Te.replace(k,I)}else if(O.test(Te))return Te.replace(w,I);return Te}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Te){return Te.replace(a,function(_e,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(Te,_e){Te=typeof Te=="string"?Te:Te.source,_e=_e||"";var ye={replace:function(ce,Q){return Q=Q.source||Q,Q=Q.replace(d,"$1"),Te=Te.replace(ce,Q),ye},getRegex:function(){return new RegExp(Te,_e)}};return ye}var A=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Te,_e,ye){if(Te){var ae;try{ae=decodeURIComponent(h(ye)).replace(A,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!c.test(ye)&&(ye=s(_e,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,_e){t[" "+Te]||(u.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=p(Te,"/",!0)),Te=t[" "+Te];var ye=Te.indexOf(":")===-1;return _e.substring(0,2)==="//"?ye?_e:Te.replace(n,"$1")+_e:_e.charAt(0)==="/"?ye?_e:Te.replace(r,"$1")+_e:Te+_e}var i={exec:function(){}};function l(Te){for(var _e=1,ye,ae;_e<arguments.length;_e++){ye=arguments[_e];for(ae in ye)Object.prototype.hasOwnProperty.call(ye,ae)&&(Te[ae]=ye[ae])}return Te}function S(Te,_e){var ye=Te.replace(/\|/g,function(Q,J,D){for(var B=!1,H=J;--H>=0&&D[H]==="\\";)B=!B;return B?"|":" |"}),ae=ye.split(/ \|/),ce=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;ce<ae.length;ce++)ae[ce]=ae[ce].trim().replace(/\\\|/g,"|");return ae}function p(Te,_e,ye){var ae=Te.length;if(ae===0)return"";for(var ce=0;ce<ae;){var Q=Te.charAt(ae-ce-1);if(Q===_e&&!ye)ce++;else if(Q!==_e&&ye)ce++;else break}return Te.slice(0,ae-ce)}function T(Te,_e){if(Te.indexOf(_e[1])===-1)return-1;for(var ye=Te.length,ae=0,ce=0;ce<ye;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===_e[0])ae++;else if(Te[ce]===_e[1]&&(ae--,ae<0))return ce;return-1}function U(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Te,_e){if(_e<1)return"";for(var ye="";_e>1;)_e&1&&(ye+=Te),_e>>=1,Te+=Te;return ye+Te}function x(Te,_e,ye,ae){var ce=_e.href,Q=_e.title?f(_e.title):null,J=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var D={type:"link",raw:ye,href:ce,title:Q,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,D}return{type:"image",raw:ye,href:ce,title:Q,text:f(J)}}function C(Te,_e){var ye=Te.match(/^(\s+)(?:```)/);if(ye===null)return _e;var ae=ye[1];return _e.split(`
`).map(function(ce){var Q=ce.match(/^\s+/);if(Q===null)return ce;var J=Q[0];return J.length>=ae.length?ce.slice(ae.length):ce}).join(`
`)}var z=function(){function Te(ye){this.options=ye||ne.defaults}var _e=Te.prototype;return _e.space=function(ae){var ce=this.rules.block.newline.exec(ae);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},_e.code=function(ae){var ce=this.rules.block.code.exec(ae);if(ce){var Q=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:p(Q,`
`)}}},_e.fences=function(ae){var ce=this.rules.block.fences.exec(ae);if(ce){var Q=ce[0],J=C(Q,ce[3]||"");return{type:"code",raw:Q,lang:ce[2]?ce[2].trim():ce[2],text:J}}},_e.heading=function(ae){var ce=this.rules.block.heading.exec(ae);if(ce){var Q=ce[2].trim();if(/#$/.test(Q)){var J=p(Q,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Q=J.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Q,tokens:this.lexer.inline(Q)}}},_e.hr=function(ae){var ce=this.rules.block.hr.exec(ae);if(ce)return{type:"hr",raw:ce[0]}},_e.blockquote=function(ae){var ce=this.rules.block.blockquote.exec(ae);if(ce){var Q=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},_e.list=function(ae){var ce=this.rules.block.list.exec(ae);if(ce){var Q,J,D,B,H,V,te,de,Y,pe,ge,Ne,Be=ce[1].trim(),Ye=Be.length>1,Ge={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var ke=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ce=ke.exec(ae))||this.rules.block.hr.test(ae)));){if(Q=ce[0],ae=ae.substring(Q.length),de=ce[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ge=de.trimLeft()):(B=ce[2].search(/[^ ]/),B=B>4?1:B,ge=de.slice(B),B+=ce[1].length),V=!1,!de&&/^ *$/.test(Y)&&(Q+=Y+`
`,ae=ae.substring(Y.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),fe=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(pe=ae.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(de)||fe.test(de)||nt.test(de)||G.test(ae)));){if(de.search(/[^ ]/)>=B||!de.trim())ge+=`
`+de.slice(B);else if(!V)ge+=`
`+de;else break;!V&&!de.trim()&&(V=!0),Q+=pe+`
`,ae=ae.substring(pe.length+1)}Ge.loose||(te?Ge.loose=!0:/\n *\n *$/.test(Q)&&(te=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(ge),J&&(D=J[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Q,task:!!J,checked:D,loose:!1,text:ge}),Ge.raw+=Q}Ge.items[Ge.items.length-1].raw=Q.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var He=Ge.items[H].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=He.every(function(Ke){for(var We=Ke.raw.split(""),it=0,st=M(We),dt;!(dt=st()).done;){var at=dt.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&He.length&&Ze&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},_e.html=function(ae){var ce=this.rules.block.html.exec(ae);if(ce){var Q={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Q.type="paragraph",Q.text=J,Q.tokens=this.lexer.inline(J)}return Q}},_e.def=function(ae){var ce=this.rules.block.def.exec(ae);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Q=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:ce[0],href:ce[2],title:ce[3]}}},_e.table=function(ae){var ce=this.rules.block.table.exec(ae);if(ce){var Q={type:"table",header:S(ce[1]).map(function(te){return{text:te}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=ce[0];var J=Q.align.length,D,B,H,V;for(D=0;D<J;D++)/^ *-+: *$/.test(Q.align[D])?Q.align[D]="right":/^ *:-+: *$/.test(Q.align[D])?Q.align[D]="center":/^ *:-+ *$/.test(Q.align[D])?Q.align[D]="left":Q.align[D]=null;for(J=Q.rows.length,D=0;D<J;D++)Q.rows[D]=S(Q.rows[D],Q.header.length).map(function(te){return{text:te}});for(J=Q.header.length,B=0;B<J;B++)Q.header[B].tokens=this.lexer.inline(Q.header[B].text);for(J=Q.rows.length,B=0;B<J;B++)for(V=Q.rows[B],H=0;H<V.length;H++)V[H].tokens=this.lexer.inline(V[H].text);return Q}}},_e.lheading=function(ae){var ce=this.rules.block.lheading.exec(ae);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},_e.paragraph=function(ae){var ce=this.rules.block.paragraph.exec(ae);if(ce){var Q=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Q,tokens:this.lexer.inline(Q)}}},_e.text=function(ae){var ce=this.rules.block.text.exec(ae);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},_e.escape=function(ae){var ce=this.rules.inline.escape.exec(ae);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},_e.tag=function(ae){var ce=this.rules.inline.tag.exec(ae);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},_e.link=function(ae){var ce=this.rules.inline.link.exec(ae);if(ce){var Q=ce[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var J=p(Q.slice(0,-1),"\\");if((Q.length-J.length)%2===0)return}else{var D=T(ce[2],"()");if(D>-1){var B=ce[0].indexOf("!")===0?5:4,H=B+ce[1].length+D;ce[2]=ce[2].substring(0,D),ce[0]=ce[0].substring(0,H).trim(),ce[3]=""}}var V=ce[2],te="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);de&&(V=de[1],te=de[3])}else te=ce[3]?ce[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(Q)?V=V.slice(1):V=V.slice(1,-1)),x(ce,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:te&&te.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},_e.reflink=function(ae,ce){var Q;if((Q=this.rules.inline.reflink.exec(ae))||(Q=this.rules.inline.nolink.exec(ae))){var J=(Q[2]||Q[1]).replace(/\s+/g," ");if(J=ce[J.toLowerCase()],!J||!J.href){var D=Q[0].charAt(0);return{type:"text",raw:D,text:D}}return x(Q,J,Q[0],this.lexer)}},_e.emStrong=function(ae,ce,Q){Q===void 0&&(Q="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var D=J[1]||J[2]||"";if(!D||D&&(Q===""||this.rules.inline.punctuation.exec(Q))){var B=J[0].length-1,H,V,te=B,de=0,Y=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ce=ce.slice(-1*ae.length+B);(J=Y.exec(ce))!=null;)if(H=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!H){if(V=H.length,J[3]||J[4]){te+=V;continue}else if((J[5]||J[6])&&B%3&&!((B+V)%3)){de+=V;continue}if(te-=V,!(te>0)){if(V=Math.min(V,V+te+de),Math.min(B,V)%2){var pe=ae.slice(1,B+J.index+V);return{type:"em",raw:ae.slice(0,B+J.index+V+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ge=ae.slice(2,B+J.index+V-1);return{type:"strong",raw:ae.slice(0,B+J.index+V+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}}}}},_e.codespan=function(ae){var ce=this.rules.inline.code.exec(ae);if(ce){var Q=ce[2].replace(/\n/g," "),J=/[^ ]/.test(Q),D=/^ /.test(Q)&&/ $/.test(Q);return J&&D&&(Q=Q.substring(1,Q.length-1)),Q=f(Q,!0),{type:"codespan",raw:ce[0],text:Q}}},_e.br=function(ae){var ce=this.rules.inline.br.exec(ae);if(ce)return{type:"br",raw:ce[0]}},_e.del=function(ae){var ce=this.rules.inline.del.exec(ae);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},_e.autolink=function(ae,ce){var Q=this.rules.inline.autolink.exec(ae);if(Q){var J,D;return Q[2]==="@"?(J=f(this.options.mangle?ce(Q[1]):Q[1]),D="mailto:"+J):(J=f(Q[1]),D=J),{type:"link",raw:Q[0],text:J,href:D,tokens:[{type:"text",raw:J,text:J}]}}},_e.url=function(ae,ce){var Q;if(Q=this.rules.inline.url.exec(ae)){var J,D;if(Q[2]==="@")J=f(this.options.mangle?ce(Q[0]):Q[0]),D="mailto:"+J;else{var B;do B=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(B!==Q[0]);J=f(Q[0]),Q[1]==="www."?D="http://"+J:D=J}return{type:"link",raw:Q[0],text:J,href:D,tokens:[{type:"text",raw:J,text:J}]}}},_e.inlineText=function(ae,ce){var Q=this.rules.inline.text.exec(ae);if(Q){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]:J=f(this.options.smartypants?ce(Q[0]):Q[0]),{type:"text",raw:Q[0],text:J}}},Te}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:i,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=g(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=g(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=g(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=g(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=g(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=g(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=l({},N),N.gfm=l({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=g(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=g(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=l({},N.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:i,paragraph:g(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:i,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:i,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=g(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=g(N._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=g(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=g(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=g(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=g(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=g(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=g(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=g(L.reflink).replace("label",L._label).replace("ref",N._label).getRegex(),L.nolink=g(L.nolink).replace("ref",N._label).getRegex(),L.reflinkSearch=g(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=l({},L),L.pedantic=l({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=l({},L.normal,{escape:g(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=g(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=l({},L.gfm,{br:g(L.br).replace("{2,}","*").getRegex(),text:g(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Te){var _e="",ye,ae,ce=Te.length;for(ye=0;ye<ce;ye++)ae=Te.charCodeAt(ye),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var R=function(){function Te(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ne.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:N.normal,inline:L.normal};this.options.pedantic?(ae.block=N.pedantic,ae.inline=L.pedantic):this.options.gfm&&(ae.block=N.gfm,this.options.breaks?ae.inline=L.breaks:ae.inline=L.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,ce){var Q=new Te(ce);return Q.lex(ae)},Te.lexInline=function(ae,ce){var Q=new Te(ce);return Q.inlineTokens(ae)};var _e=Te.prototype;return _e.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},_e.blockTokens=function(ae,ce){var Q=this;ce===void 0&&(ce=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(te,de,Y){return de+"    ".repeat(Y.length)});for(var J,D,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(te){return(J=te.call({lexer:Q},ae,ce))?(ae=ae.substring(J.raw.length),ce.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),D=ce[ce.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+J.raw,D.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=D.text):ce.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),D=ce[ce.length-1],D&&(D.type==="paragraph"||D.type==="text")?(D.raw+=`
`+J.raw,D.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=D.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var te=1/0,de=ae.slice(1),Y=void 0;Q.options.extensions.startBlock.forEach(function(pe){Y=pe.call({lexer:this},de),typeof Y=="number"&&Y>=0&&(te=Math.min(te,Y))}),te<1/0&&te>=0&&(B=ae.substring(0,te+1))}(),this.state.top&&(J=this.tokenizer.paragraph(B))){D=ce[ce.length-1],H&&D.type==="paragraph"?(D.raw+=`
`+J.raw,D.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):ce.push(J),H=B.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),D=ce[ce.length-1],D&&D.type==="text"?(D.raw+=`
`+J.raw,D.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=D.text):ce.push(J);continue}if(ae){var V="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,ce},_e.inline=function(ae,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ae,tokens:ce}),ce},_e.inlineTokens=function(ae,ce){var Q=this;ce===void 0&&(ce=[]);var J,D,B,H=ae,V,te,de;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Y.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,V.index)+"["+j("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,V.index)+"["+j("a",V[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,V.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(te||(de=""),te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(J=ge.call({lexer:Q},ae,ce))?(ae=ae.substring(J.raw.length),ce.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),D=ce[ce.length-1],D&&J.type==="text"&&D.type==="text"?(D.raw+=J.raw,D.text+=J.text):ce.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),D=ce[ce.length-1],D&&J.type==="text"&&D.type==="text"?(D.raw+=J.raw,D.text+=J.text):ce.push(J);continue}if(J=this.tokenizer.emStrong(ae,H,de)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.autolink(ae,W)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,W))){ae=ae.substring(J.raw.length),ce.push(J);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;Q.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(B=ae.substring(0,ge+1))}(),J=this.tokenizer.inlineText(B,q)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(de=J.raw.slice(-1)),te=!0,D=ce[ce.length-1],D&&D.type==="text"?(D.raw+=J.raw,D.text+=J.text):ce.push(J);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},o(Te,null,[{key:"rules",get:function(){return{block:N,inline:L}}}]),Te}(),Z=function(){function Te(ye){this.options=ye||ne.defaults}var _e=Te.prototype;return _e.code=function(ae,ce,Q){var J=(ce||"").match(/\S*/)[0];if(this.options.highlight){var D=this.options.highlight(ae,J);D!=null&&D!==ae&&(Q=!0,ae=D)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+f(J,!0)+'">'+(Q?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(Q?ae:f(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,ce,Q,J){if(this.options.headerIds){var D=this.options.headerPrefix+J.slug(Q);return"<h"+ce+' id="'+D+'">'+ae+"</h"+ce+`>
`}return"<h"+ce+">"+ae+"</h"+ce+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,ce,Q){var J=ce?"ol":"ul",D=ce&&Q!==1?' start="'+Q+'"':"";return"<"+J+D+`>
`+ae+"</"+J+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ce+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,ce){var Q=ce.header?"th":"td",J=ce.align?"<"+Q+' align="'+ce.align+'">':"<"+Q+">";return J+ae+("</"+Q+`>
`)},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,ce,Q){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<a href="'+f(ae)+'"';return ce&&(J+=' title="'+ce+'"'),J+=">"+Q+"</a>",J},_e.image=function(ae,ce,Q){if(ae=v(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<img src="'+ae+'" alt="'+Q+'"';return ce&&(J+=' title="'+ce+'"'),J+=this.options.xhtml?"/>":">",J},_e.text=function(ae){return ae},Te}(),le=function(){function Te(){}var _e=Te.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,ce,Q){return""+Q},_e.image=function(ae,ce,Q){return""+Q},_e.br=function(){return""},Te}(),oe=function(){function Te(){this.seen={}}var _e=Te.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,ce){var Q=ae,J=0;if(this.seen.hasOwnProperty(Q)){J=this.seen[ae];do J++,Q=ae+"-"+J;while(this.seen.hasOwnProperty(Q))}return ce||(this.seen[ae]=J,this.seen[Q]=0),Q},_e.slug=function(ae,ce){ce===void 0&&(ce={});var Q=this.serialize(ae);return this.getNextSafeSlug(Q,ce.dryrun)},Te}(),ue=function(){function Te(ye){this.options=ye||ne.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new oe}Te.parse=function(ae,ce){var Q=new Te(ce);return Q.parse(ae)},Te.parseInline=function(ae,ce){var Q=new Te(ce);return Q.parseInline(ae)};var _e=Te.prototype;return _e.parse=function(ae,ce){ce===void 0&&(ce=!0);var Q="",J,D,B,H,V,te,de,Y,pe,ge,Ne,Be,Ye,Ge,ke,nt,G,X,fe,Ue=ae.length;for(J=0;J<Ue;J++){if(ge=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){Q+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,h(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Y="",de="",H=ge.header.length,D=0;D<H;D++)de+=this.renderer.tablecell(this.parseInline(ge.header[D].tokens),{header:!0,align:ge.align[D]});for(Y+=this.renderer.tablerow(de),pe="",H=ge.rows.length,D=0;D<H;D++){for(te=ge.rows[D],de="",V=te.length,B=0;B<V;B++)de+=this.renderer.tablecell(this.parseInline(te[B].tokens),{header:!1,align:ge.align[B]});pe+=this.renderer.tablerow(de)}Q+=this.renderer.table(Y,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),Q+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Ye=ge.loose,H=ge.items.length,pe="",D=0;D<H;D++)ke=ge.items[D],nt=ke.checked,G=ke.task,Ge="",ke.task&&(X=this.renderer.checkbox(nt),Ye?ke.tokens.length>0&&ke.tokens[0].type==="paragraph"?(ke.tokens[0].text=X+" "+ke.tokens[0].text,ke.tokens[0].tokens&&ke.tokens[0].tokens.length>0&&ke.tokens[0].tokens[0].type==="text"&&(ke.tokens[0].tokens[0].text=X+" "+ke.tokens[0].tokens[0].text)):ke.tokens.unshift({type:"text",text:X}):Ge+=X),Ge+=this.parse(ke.tokens,Ye),pe+=this.renderer.listitem(Ge,G,nt);Q+=this.renderer.list(pe,Ne,Be);continue}case"html":{Q+=this.renderer.html(ge.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;J+1<Ue&&ae[J+1].type==="text";)ge=ae[++J],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);Q+=ce?this.renderer.paragraph(pe):pe;continue}default:{var He='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return Q},_e.parseInline=function(ae,ce){ce=ce||this.renderer;var Q="",J,D,B,H=ae.length;for(J=0;J<H;J++){if(D=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[D.type]&&(B=this.options.extensions.renderers[D.type].call({parser:this},D),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(D.type))){Q+=B||"";continue}switch(D.type){case"escape":{Q+=ce.text(D.text);break}case"html":{Q+=ce.html(D.text);break}case"link":{Q+=ce.link(D.href,D.title,this.parseInline(D.tokens,ce));break}case"image":{Q+=ce.image(D.href,D.title,D.text);break}case"strong":{Q+=ce.strong(this.parseInline(D.tokens,ce));break}case"em":{Q+=ce.em(this.parseInline(D.tokens,ce));break}case"codespan":{Q+=ce.codespan(D.text);break}case"br":{Q+=ce.br();break}case"del":{Q+=ce.del(this.parseInline(D.tokens,ce));break}case"text":{Q+=ce.text(D.text);break}default:{var V='Token with "'+D.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return Q},Te}();function ee(Te,_e,ye){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof _e=="function"&&(ye=_e,_e=null),_e=l({},ee.defaults,_e||{}),U(_e),ye){var ae=_e.highlight,ce;try{ce=R.lex(Te,_e)}catch(H){return ye(H)}var Q=function(V){var te;if(!V)try{_e.walkTokens&&ee.walkTokens(ce,_e.walkTokens),te=ue.parse(ce,_e)}catch(de){V=de}return _e.highlight=ae,V?ye(V):ye(null,te)};if(!ae||ae.length<3||(delete _e.highlight,!ce.length))return Q();var J=0;ee.walkTokens(ce,function(H){H.type==="code"&&(J++,setTimeout(function(){ae(H.text,H.lang,function(V,te){if(V)return Q(V);te!=null&&te!==H.text&&(H.text=te,H.escaped=!0),J--,J===0&&Q()})},0))}),J===0&&Q();return}function D(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(H.message+"",!0)+"</pre>";throw H}try{var B=R.lex(Te,_e);if(_e.walkTokens){if(_e.async)return Promise.all(ee.walkTokens(B,_e.walkTokens)).then(function(){return ue.parse(B,_e)}).catch(D);ee.walkTokens(B,_e.walkTokens)}return ue.parse(B,_e)}catch(H){D(H)}}ee.options=ee.setOptions=function(Te){return l(ee.defaults,Te),P(ee.defaults),ee},ee.getDefaults=_,ee.defaults=ne.defaults,ee.use=function(){for(var Te=arguments.length,_e=new Array(Te),ye=0;ye<Te;ye++)_e[ye]=arguments[ye];var ae=l.apply(void 0,[{}].concat(_e)),ce=ee.defaults.extensions||{renderers:{},childTokens:{}},Q;_e.forEach(function(J){if(J.extensions&&(Q=!0,J.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ce.renderers?ce.renderers[B.name]:null;H?ce.renderers[B.name]=function(){for(var V=arguments.length,te=new Array(V),de=0;de<V;de++)te[de]=arguments[de];var Y=B.renderer.apply(this,te);return Y===!1&&(Y=H.apply(this,te)),Y}:ce.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[B.level]?ce[B.level].unshift(B.tokenizer):ce[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ce.startBlock?ce.startBlock.push(B.start):ce.startBlock=[B.start]:B.level==="inline"&&(ce.startInline?ce.startInline.push(B.start):ce.startInline=[B.start]))}B.childTokens&&(ce.childTokens[B.name]=B.childTokens)})),J.renderer&&function(){var B=ee.defaults.renderer||new Z,H=function(de){var Y=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.renderer[de].apply(B,ge);return Be===!1&&(Be=Y.apply(B,ge)),Be}};for(var V in J.renderer)H(V);ae.renderer=B}(),J.tokenizer&&function(){var B=ee.defaults.tokenizer||new z,H=function(de){var Y=B[de];B[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.tokenizer[de].apply(B,ge);return Be===!1&&(Be=Y.apply(B,ge)),Be}};for(var V in J.tokenizer)H(V);ae.tokenizer=B}(),J.walkTokens){var D=ee.defaults.walkTokens;ae.walkTokens=function(B){var H=[];return H.push(J.walkTokens.call(this,B)),D&&(H=H.concat(D.call(this,B))),H}}Q&&(ae.extensions=ce),ee.setOptions(ae)})},ee.walkTokens=function(Te,_e){for(var ye=[],ae=function(){var D=Q.value;switch(ye=ye.concat(_e.call(ee,D)),D.type){case"table":{for(var B=M(D.header),H;!(H=B()).done;){var V=H.value;ye=ye.concat(ee.walkTokens(V.tokens,_e))}for(var te=M(D.rows),de;!(de=te()).done;)for(var Y=de.value,pe=M(Y),ge;!(ge=pe()).done;){var Ne=ge.value;ye=ye.concat(ee.walkTokens(Ne.tokens,_e))}break}case"list":{ye=ye.concat(ee.walkTokens(D.items,_e));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[D.type]?ee.defaults.extensions.childTokens[D.type].forEach(function(Be){ye=ye.concat(ee.walkTokens(D[Be],_e))}):D.tokens&&(ye=ye.concat(ee.walkTokens(D.tokens,_e)))}},ce=M(Te),Q;!(Q=ce()).done;)ae();return ye},ee.parseInline=function(Te,_e){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");_e=l({},ee.defaults,_e||{}),U(_e);try{var ye=R.lexInline(Te,_e);return _e.walkTokens&&ee.walkTokens(ye,_e.walkTokens),ue.parseInline(ye,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},ee.Parser=ue,ee.parser=ue.parse,ee.Renderer=Z,ee.TextRenderer=le,ee.Lexer=R,ee.lexer=R.lex,ee.Tokenizer=z,ee.Slugger=oe,ee.parse=ee;var ve=ee.options,we=ee.setOptions,re=ee.use,Ee=ee.walkTokens,Pe=ee.parseInline,Fe=ee,ze=ue.parse,Qe=R.lex;ne.Lexer=R,ne.Parser=ue,ne.Renderer=Z,ne.Slugger=oe,ne.TextRenderer=le,ne.Tokenizer=z,ne.getDefaults=_,ne.lexer=Qe,ne.marked=ee,ne.options=ve,ne.parse=Fe,ne.parseInline=Pe,ne.parser=ze,ne.setOptions=we,ne.use=re,ne.walkTokens=Ee,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ce[108],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,E,k){return Math.min(Math.max(P,E),k)}e.clamp=o;function y(P,E){return(E+P%E)%E}e.rot=y;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class M{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class _{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const k=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ne(b){const M=[];typeof b=="number"&&M.push("code/timeOrigin",b);function _(E){M.push(E,Date.now())}function P(){const E=[];for(let k=0;k<M.length;k+=2)E.push({name:M[k],startTime:M[k+1]});return E}return{mark:_,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const _ of performance.getEntriesByType("mark"))M.push({name:_.name,startTime:Math.round(b+_.startTime)});return M}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function o(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=o(y))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var y in o)(typeof exports=="object"?exports:ne)[y]=o[y]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function o(y){if(e[y])return e[y].exports;var b=e[y]={i:y,l:!1,exports:{}};return ne[y].call(b.exports,b,b.exports,o),b.l=!0,b.exports}return o.m=ne,o.c=e,o.d=function(y,b,M){o.o(y,b)||Object.defineProperty(y,b,{enumerable:!0,get:M})},o.r=function(y){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(y,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(y,"__esModule",{value:!0})},o.t=function(y,b){if(1&b&&(y=o(y)),8&b||4&b&&typeof y=="object"&&y&&y.__esModule)return y;var M=Object.create(null);if(o.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:y}),2&b&&typeof y!="string")for(var _ in y)o.d(M,_,function(P){return y[P]}.bind(null,_));return M},o.n=function(y){var b=y&&y.__esModule?function(){return y.default}:function(){return y};return o.d(b,"a",b),b},o.o=function(y,b){return Object.prototype.hasOwnProperty.call(y,b)},o.p="",o(o.s=0)}([function(ne,e,o){(function(y){var b;e=ne.exports=re,b=typeof y=="object"&&y.env&&y.env.NODE_DEBUG&&/\bsemver\b/i.test(y.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],k=0,O=k++;E[O]="0|[1-9]\\d*";var w=k++;E[w]="[0-9]+";var m=k++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=k++;E[I]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var f=k++;E[f]="("+E[w]+")\\.("+E[w]+")\\.("+E[w]+")";var a=k++;E[a]="(?:"+E[O]+"|"+E[m]+")";var h=k++;E[h]="(?:"+E[w]+"|"+E[m]+")";var d=k++;E[d]="(?:-("+E[a]+"(?:\\."+E[a]+")*))";var g=k++;E[g]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var A=k++;E[A]="[0-9A-Za-z-]+";var c=k++;E[c]="(?:\\+("+E[A]+"(?:\\."+E[A]+")*))";var v=k++,t="v?"+E[I]+E[d]+"?"+E[c]+"?";E[v]="^"+t+"$";var u="[v=\\s]*"+E[f]+E[g]+"?"+E[c]+"?",n=k++;E[n]="^"+u+"$";var r=k++;E[r]="((?:<|>)?=?)";var s=k++;E[s]=E[w]+"|x|X|\\*";var i=k++;E[i]=E[O]+"|x|X|\\*";var l=k++;E[l]="[v=\\s]*("+E[i]+")(?:\\.("+E[i]+")(?:\\.("+E[i]+")(?:"+E[d]+")?"+E[c]+"?)?)?";var S=k++;E[S]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[g]+")?"+E[c]+"?)?)?";var p=k++;E[p]="^"+E[r]+"\\s*"+E[l]+"$";var T=k++;E[T]="^"+E[r]+"\\s*"+E[S]+"$";var U=k++;E[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;E[j]="(?:~>?)";var x=k++;E[x]="(\\s*)"+E[j]+"\\s+",P[x]=new RegExp(E[x],"g");var C=k++;E[C]="^"+E[j]+E[l]+"$";var z=k++;E[z]="^"+E[j]+E[S]+"$";var N=k++;E[N]="(?:\\^)";var L=k++;E[L]="(\\s*)"+E[N]+"\\s+",P[L]=new RegExp(E[L],"g");var q=k++;E[q]="^"+E[N]+E[l]+"$";var W=k++;E[W]="^"+E[N]+E[S]+"$";var R=k++;E[R]="^"+E[r]+"\\s*("+u+")$|^$";var Z=k++;E[Z]="^"+E[r]+"\\s*("+t+")$|^$";var le=k++;E[le]="(\\s*)"+E[r]+"\\s*("+u+"|"+E[l]+")",P[le]=new RegExp(E[le],"g");var oe=k++;E[oe]="^\\s*("+E[l]+")\\s+-\\s+("+E[l]+")\\s*$";var ue=k++;E[ue]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var ee=k++;E[ee]="(<|>)?=?\\s*\\*";for(var ve=0;ve<35;ve++)b(ve,E[ve]),P[ve]||(P[ve]=new RegExp(E[ve]));function we(Y,pe){if(Y instanceof re)return Y;if(typeof Y!="string"||Y.length>M||!(pe?P[n]:P[v]).test(Y))return null;try{return new re(Y,pe)}catch{return null}}function re(Y,pe){if(Y instanceof re){if(Y.loose===pe)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(Y,pe);b("SemVer",Y,pe),this.loose=pe;var ge=Y.trim().match(pe?P[n]:P[v]);if(!ge)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<_)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=we,e.valid=function(Y,pe){var ge=we(Y,pe);return ge?ge.version:null},e.clean=function(Y,pe){var ge=we(Y.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(Y){return b("SemVer.compare",this.version,this.loose,Y),Y instanceof re||(Y=new re(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},re.prototype.compareMain=function(Y){return Y instanceof re||(Y=new re(Y,this.loose)),Pe(this.major,Y.major)||Pe(this.minor,Y.minor)||Pe(this.patch,Y.patch)},re.prototype.comparePre=function(Y){if(Y instanceof re||(Y=new re(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Y.prerelease[pe];if(b("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Pe(ge,Ne)}while(++pe)},re.prototype.inc=function(Y,pe){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new re(Y,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Y,pe){if(Te(Y,pe))return null;var ge=we(Y),Ne=we(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Pe;var Ee=/^[0-9]+$/;function Pe(Y,pe){var ge=Ee.test(Y),Ne=Ee.test(pe);return ge&&Ne&&(Y=+Y,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Y<pe?-1:Y>pe?1:0}function Fe(Y,pe,ge){return new re(Y,ge).compare(new re(pe,ge))}function ze(Y,pe,ge){return Fe(Y,pe,ge)>0}function Qe(Y,pe,ge){return Fe(Y,pe,ge)<0}function Te(Y,pe,ge){return Fe(Y,pe,ge)===0}function _e(Y,pe,ge){return Fe(Y,pe,ge)!==0}function ye(Y,pe,ge){return Fe(Y,pe,ge)>=0}function ae(Y,pe,ge){return Fe(Y,pe,ge)<=0}function ce(Y,pe,ge,Ne){var Be;switch(pe){case"===":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Be=Y===ge;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof ge=="object"&&(ge=ge.version),Be=Y!==ge;break;case"":case"=":case"==":Be=Te(Y,ge,Ne);break;case"!=":Be=_e(Y,ge,Ne);break;case">":Be=ze(Y,ge,Ne);break;case">=":Be=ye(Y,ge,Ne);break;case"<":Be=Qe(Y,ge,Ne);break;case"<=":Be=ae(Y,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function Q(Y,pe){if(Y instanceof Q){if(Y.loose===pe)return Y;Y=Y.value}if(!(this instanceof Q))return new Q(Y,pe);b("comparator",Y,pe),this.loose=pe,this.parse(Y),this.semver===J?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(Y,pe){return Pe(pe,Y)},e.major=function(Y,pe){return new re(Y,pe).major},e.minor=function(Y,pe){return new re(Y,pe).minor},e.patch=function(Y,pe){return new re(Y,pe).patch},e.compare=Fe,e.compareLoose=function(Y,pe){return Fe(Y,pe,!0)},e.rcompare=function(Y,pe,ge){return Fe(pe,Y,ge)},e.sort=function(Y,pe){return Y.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Y,pe){return Y.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=ze,e.lt=Qe,e.eq=Te,e.neq=_e,e.gte=ye,e.lte=ae,e.cmp=ce,e.Comparator=Q;var J={};function D(Y,pe){if(Y instanceof D)return Y.loose===pe?Y:new D(Y.raw,pe);if(Y instanceof Q)return new D(Y.value,pe);if(!(this instanceof D))return new D(Y,pe);if(this.loose=pe,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function B(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function H(Y,pe,ge,Ne,Be,Ye,Ge,ke,nt,G,X,fe,Ue){return((pe=B(ge)?"":B(Ne)?">="+ge+".0.0":B(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(ke=B(nt)?"":B(G)?"<"+(+nt+1)+".0.0":B(X)?"<"+nt+"."+(+G+1)+".0":fe?"<="+nt+"."+G+"."+X+"-"+fe:"<="+ke)).trim()}function V(Y,pe){for(var ge=0;ge<Y.length;ge++)if(!Y[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Y.length;ge++)if(b(Y[ge].semver),Y[ge].semver!==J&&Y[ge].semver.prerelease.length>0){var Ne=Y[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function te(Y,pe,ge){try{pe=new D(pe,ge)}catch{return!1}return pe.test(Y)}function de(Y,pe,ge,Ne){var Be,Ye,Ge,ke,nt;switch(Y=new re(Y,Ne),pe=new D(pe,Ne),ge){case">":Be=ze,Ye=ae,Ge=Qe,ke=">",nt=">=";break;case"<":Be=Qe,Ye=ye,Ge=ze,ke="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(te(Y,pe,Ne))return!1;for(var G=0;G<pe.set.length;++G){var X=pe.set[G],fe=null,Ue=null;if(X.forEach(function(He){He.semver===J&&(He=new Q(">=0.0.0")),fe=fe||He,Ue=Ue||He,Be(He.semver,fe.semver,Ne)?fe=He:Ge(He.semver,Ue.semver,Ne)&&(Ue=He)}),fe.operator===ke||fe.operator===nt||(!Ue.operator||Ue.operator===ke)&&Ye(Y,Ue.semver)||Ue.operator===nt&&Ge(Y,Ue.semver))return!1}return!0}Q.prototype.parse=function(Y){var pe=this.loose?P[R]:P[Z],ge=Y.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Y);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=J},Q.prototype.toString=function(){return this.value},Q.prototype.test=function(Y){return b("Comparator.test",Y,this.loose),this.semver===J||(typeof Y=="string"&&(Y=new re(Y,this.loose)),ce(Y,this.operator,this.semver,this.loose))},Q.prototype.intersects=function(Y,pe){if(!(Y instanceof Q))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new D(Y.value,pe),te(this.value,ge,pe);if(Y.operator==="")return ge=new D(this.value,pe),te(Y.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ye=this.semver.version===Y.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),ke=ce(this.semver,"<",Y.semver,pe)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),nt=ce(this.semver,">",Y.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Ne||Be||Ye&&Ge||ke||nt},e.Range=D,D.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},D.prototype.toString=function(){return this.range},D.prototype.parseRange=function(Y){var pe=this.loose;Y=Y.trim(),b("range",Y,pe);var ge=pe?P[ue]:P[oe];Y=Y.replace(ge,H),b("hyphen replace",Y),Y=Y.replace(P[le],"$1$2$3"),b("comparator trim",Y,P[le]),Y=(Y=(Y=Y.replace(P[x],"$1~")).replace(P[L],"$1^")).split(/\s+/).join(" ");var Ne=pe?P[R]:P[Z],Be=Y.split(" ").map(function(Ye){return function(Ge,ke){return b("comp",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){b("caret",fe,Ue);var He=Ue?P[W]:P[q];return fe.replace(He,function(Ze,Ke,We,it,st){var dt;return b("caret",fe,Ze,Ke,We,it,st),B(Ke)?dt="":B(We)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=Ke==="0"?">="+Ke+"."+We+".0 <"+Ke+"."+(+We+1)+".0":">="+Ke+"."+We+".0 <"+(+Ke+1)+".0.0":st?(b("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?We==="0"?">="+Ke+"."+We+"."+it+st+" <"+Ke+"."+We+"."+(+it+1):">="+Ke+"."+We+"."+it+st+" <"+Ke+"."+(+We+1)+".0":">="+Ke+"."+We+"."+it+st+" <"+(+Ke+1)+".0.0"):(b("no pr"),dt=Ke==="0"?We==="0"?">="+Ke+"."+We+"."+it+" <"+Ke+"."+We+"."+(+it+1):">="+Ke+"."+We+"."+it+" <"+Ke+"."+(+We+1)+".0":">="+Ke+"."+We+"."+it+" <"+(+Ke+1)+".0.0"),b("caret return",dt),dt})}(X,G)}).join(" ")}(Ge,ke),b("caret",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){var He=Ue?P[z]:P[C];return fe.replace(He,function(Ze,Ke,We,it,st){var dt;return b("tilde",fe,Ze,Ke,We,it,st),B(Ke)?dt="":B(We)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(it)?dt=">="+Ke+"."+We+".0 <"+Ke+"."+(+We+1)+".0":st?(b("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+We+"."+it+st+" <"+Ke+"."+(+We+1)+".0"):dt=">="+Ke+"."+We+"."+it+" <"+Ke+"."+(+We+1)+".0",b("tilde return",dt),dt})}(X,G)}).join(" ")}(Ge,ke),b("tildes",Ge),Ge=function(nt,G){return b("replaceXRanges",nt,G),nt.split(/\s+/).map(function(X){return function(fe,Ue){fe=fe.trim();var He=Ue?P[T]:P[p];return fe.replace(He,function(Ze,Ke,We,it,st,dt){b("xRange",fe,Ze,Ke,We,it,st,dt);var at=B(We),rt=at||B(it),_t=rt||B(st);return Ke==="="&&_t&&(Ke=""),at?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&_t?(rt&&(it=0),_t&&(st=0),Ke===">"?(Ke=">=",rt?(We=+We+1,it=0,st=0):_t&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",rt?We=+We+1:it=+it+1),Ze=Ke+We+"."+it+"."+st):rt?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":_t&&(Ze=">="+We+"."+it+".0 <"+We+"."+(+it+1)+".0"),b("xRange return",Ze),Ze})}(X,G)}).join(" ")}(Ge,ke),b("xrange",Ge),Ge=function(nt,G){return b("replaceStars",nt,G),nt.trim().replace(P[ee],"")}(Ge,ke),b("stars",Ge),Ge}(Ye,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Ne)})),Be=Be.map(function(Ye){return new Q(Ye,pe)})},D.prototype.intersects=function(Y,pe){if(!(Y instanceof D))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Y.set.some(function(Be){return Be.every(function(Ye){return Ne.intersects(Ye,pe)})})})})},e.toComparators=function(Y,pe){return new D(Y,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},D.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new re(Y,this.loose));for(var pe=0;pe<this.set.length;pe++)if(V(this.set[pe],Y))return!0;return!1},e.satisfies=te,e.maxSatisfying=function(Y,pe,ge){var Ne=null,Be=null;try{var Ye=new D(pe,ge)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new re(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(Y,pe,ge){var Ne=null,Be=null;try{var Ye=new D(pe,ge)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new re(Ne=Ge,ge)))}),Ne},e.validRange=function(Y,pe){try{return new D(Y,pe).range||"*"}catch{return null}},e.ltr=function(Y,pe,ge){return de(Y,pe,"<",ge)},e.gtr=function(Y,pe,ge){return de(Y,pe,">",ge)},e.outside=de,e.prerelease=function(Y,pe){var ge=we(Y,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Y,pe,ge){return Y=new D(Y,ge),pe=new D(pe,ge),Y.intersects(pe)},e.coerce=function(Y){if(Y instanceof re)return Y;if(typeof Y!="string")return null;var pe=Y.match(P[U]);return pe==null?null:we((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,o(1))},function(ne,e){var o,y,b=ne.exports={};function M(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function P(h){if(o===setTimeout)return setTimeout(h,0);if((o===M||!o)&&setTimeout)return o=setTimeout,setTimeout(h,0);try{return o(h,0)}catch{try{return o.call(null,h,0)}catch{return o.call(this,h,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:M}catch{o=M}try{y=typeof clearTimeout=="function"?clearTimeout:_}catch{y=_}})();var E,k=[],O=!1,w=-1;function m(){O&&E&&(O=!1,E.length?k=E.concat(k):w=-1,k.length&&I())}function I(){if(!O){var h=P(m);O=!0;for(var d=k.length;d;){for(E=k,k=[];++w<d;)E&&E[w].run();w=-1,d=k.length}E=null,O=!1,function(g){if(y===clearTimeout)return clearTimeout(g);if((y===_||!y)&&clearTimeout)return y=clearTimeout,clearTimeout(g);try{y(g)}catch{try{return y.call(null,g)}catch{return y.call(this,g)}}}(h)}}function f(h,d){this.fun=h,this.array=d}function a(){}b.nextTick=function(h){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];k.push(new f(h,d)),k.length!==1||O||P(I)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=a,b.addListener=a,b.once=a,b.off=a,b.removeListener=a,b.removeAllListeners=a,b.emit=a,b.prependListener=a,b.prependOnceListener=a,b.listeners=function(h){return[]},b.binding=function(h){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(h){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Ce[109],Ie([1,0,11,7]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(c){const v=c;return v?typeof v.read=="function":!1}e.isReadable=b;function M(c){const v=c;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function _(c){const v=c;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=_;function P(c,v){return new E(c,v)}e.newWriteableStream=P;class E{constructor(v,t){this.reducer=v,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v<"u"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(t=>t(v))}emitError(v){this.listeners.error.length===0?(0,o.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(t=>t(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,t){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(v,t){if(this.state.destroyed)return;let u;switch(v){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(t);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(c,v){const t=[];let u;for(;(u=c.read())!==null;)t.push(u);return v(t)}e.consumeReadable=k;function O(c,v,t){const u=[];let n;for(;(n=c.read())!==null&&u.length<t;)u.push(n);return n===null&&u.length>0?v(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return c.read()}}}e.peekReadable=O;function w(c,v){return new Promise((t,u)=>{const n=[];m(c,{onData:r=>{v&&n.push(r)},onError:r=>{v?u(r):t(void 0)},onEnd:()=>{t(v?v(n):void 0)}})})}e.consumeStream=w;function m(c,v){let t=!1;return c.on("error",u=>{t||v.onError(u)}),c.on("end",()=>{t||v.onEnd()}),c.on("data",u=>{t||v.onData(u)}),(0,y.toDisposable)(()=>t=!0)}e.listenStream=m;function I(c,v){return new Promise((t,u)=>{const n=new y.DisposableStore,r=[],s=S=>{if(r.push(S),r.length>v)return n.dispose(),c.pause(),t({stream:c,buffer:r,ended:!1})},i=S=>u(S),l=()=>t({stream:c,buffer:r,ended:!0});n.add((0,y.toDisposable)(()=>c.removeListener("error",i))),c.on("error",i),n.add((0,y.toDisposable)(()=>c.removeListener("end",l))),c.on("end",l),n.add((0,y.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=I;function f(c,v){const t=P(v);return t.end(c),t}e.toStream=f;function a(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function h(c){let v=!1;return{read:()=>v?null:(v=!0,c)}}e.toReadable=h;function d(c,v,t){const u=P(t);return m(c,{onData:n=>u.write(v.data(n)),onError:n=>u.error(v.error?v.error(n):n),onEnd:()=>u.end()}),u}e.transform=d;function g(c,v,t){let u=!1;return{read:()=>{const n=v.read();return u?n:(u=!0,n!==null?t([c,n]):c)}}}e.prefixedReadable=g;function A(c,v,t){let u=!1;const n=P(t);return m(v,{onData:r=>u?n.write(r):(u=!0,n.write(t([c,r]))),onError:r=>n.error(r),onEnd:()=>{u||(u=!0,n.write(c)),n.end()}}),n}e.prefixedStream=A}),define(Ce[23],Ie([1,0,109]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let b,M;class _{constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}static alloc(S){return y?new _(Buffer.allocUnsafe(S)):new _(new Uint8Array(S))}static wrap(S){return y&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new _(S)}static fromString(S,p){return!(p?.dontUseNodeBuffer||!1)&&y?new _(Buffer.from(S)):(b||(b=new TextEncoder),new _(b.encode(S)))}static fromByteArray(S){const p=_.alloc(S.length);for(let T=0,U=S.length;T<U;T++)p.buffer[T]=S[T];return p}static concat(S,p){if(typeof p>"u"){p=0;for(let j=0,x=S.length;j<x;j++)p+=S[j].byteLength}const T=_.alloc(p);let U=0;for(let j=0,x=S.length;j<x;j++){const C=S[j];T.set(C,U),U+=C.byteLength}return T}clone(){const S=_.alloc(this.byteLength);return S.set(this),S}toString(){return y?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(S,p){return new _(this.buffer.subarray(S,p))}set(S,p){if(S instanceof _)this.buffer.set(S.buffer,p);else if(S instanceof Uint8Array)this.buffer.set(S,p);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),p);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return k(this.buffer,S)}writeUInt32BE(S,p){O(this.buffer,S,p)}readUInt32LE(S){return w(this.buffer,S)}writeUInt32LE(S,p){m(this.buffer,S,p)}readUInt8(S){return I(this.buffer,S)}writeUInt8(S,p){f(this.buffer,S,p)}}e.VSBuffer=_;function P(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0}e.readUInt16LE=P;function E(l,S,p){l[p+0]=S&255,S=S>>>8,l[p+1]=S&255}e.writeUInt16LE=E;function k(l,S){return l[S]*2**24+l[S+1]*2**16+l[S+2]*2**8+l[S+3]}e.readUInt32BE=k;function O(l,S,p){l[p+3]=S,S=S>>>8,l[p+2]=S,S=S>>>8,l[p+1]=S,S=S>>>8,l[p]=S}e.writeUInt32BE=O;function w(l,S){return l[S+0]<<0>>>0|l[S+1]<<8>>>0|l[S+2]<<16>>>0|l[S+3]<<24>>>0}e.readUInt32LE=w;function m(l,S,p){l[p+0]=S&255,S=S>>>8,l[p+1]=S&255,S=S>>>8,l[p+2]=S&255,S=S>>>8,l[p+3]=S&255}e.writeUInt32LE=m;function I(l,S){return l[S]}e.readUInt8=I;function f(l,S,p){l[p]=S}e.writeUInt8=f;function a(l){return o.consumeReadable(l,S=>_.concat(S))}e.readableToBuffer=a;function h(l){return o.toReadable(l)}e.bufferToReadable=h;function d(l){return o.consumeStream(l,S=>_.concat(S))}e.streamToBuffer=d;async function g(l){return l.ended?_.concat(l.buffer):_.concat([...l.buffer,await d(l.stream)])}e.bufferedStreamToBuffer=g;function A(l){return o.toStream(l,S=>_.concat(S))}e.bufferToStream=A;function c(l){return o.transform(l,{data:S=>typeof S=="string"?_.fromString(S):_.wrap(S)},S=>_.concat(S))}e.streamToBufferReadableStream=c;function v(l){return o.newWriteableStream(S=>_.concat(S),l)}e.newWriteableBufferStream=v;function t(l,S){return o.prefixedReadable(l,S,p=>_.concat(p))}e.prefixedBufferReadable=t;function u(l,S){return o.prefixedStream(l,S,p=>_.concat(p))}e.prefixedBufferStream=u;function n(l){let S=0,p=0,T=0;const U=new Uint8Array(Math.floor(l.length/4*3)),j=C=>{switch(p){case 3:U[T++]=S|C,p=0;break;case 2:U[T++]=S|C>>>2,S=C<<6,p=3;break;case 1:U[T++]=S|C>>>4,S=C<<4,p=2;break;default:S=C<<2,p=1}};for(let C=0;C<l.length;C++){const z=l.charCodeAt(C);if(z>=65&&z<=90)j(z-65);else if(z>=97&&z<=122)j(z-97+26);else if(z>=48&&z<=57)j(z-48+52);else if(z===43||z===45)j(62);else if(z===47||z===95)j(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${l[C]}`)}}const x=T;for(;p>0;)j(0);return _.wrap(U).slice(0,x)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function i({buffer:l},S=!0,p=!1){const T=p?s:r;let U="";const j=l.byteLength%3;let x=0;for(;x<l.byteLength-j;x+=3){const C=l[x+0],z=l[x+1],N=l[x+2];U+=T[C>>>2],U+=T[(C<<4|z>>>4)&63],U+=T[(z<<2|N>>>6)&63],U+=T[N&63]}if(j===1){const C=l[x+0];U+=T[C>>>2],U+=T[C<<4&63],S&&(U+="==")}else if(j===2){const C=l[x+0],z=l[x+1];U+=T[C>>>2],U+=T[(C<<4|z>>>4)&63],U+=T[z<<2&63],S&&(U+="=")}return U}e.encodeBase64=i}),define(Ce[42],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(b){return o.test(b)}e.isUUID=y,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),_=[];for(let P=0;P<256;P++)_.push(P.toString(16).padStart(2,"0"));return function(){b(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,k="";return k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k}}()}),define(Ce[110],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[111],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class y{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let E=0,k=P.notIn.length;E<k;E++)switch(P.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,E){if(P.getTokenCount()===0)return!0;const k=P.findTokenIndexAtOffset(E-2),O=P.getStandardTokenType(k);return this.isOK(O)}_findNeutralCharacterInRange(P,E){for(let k=P;k<=E;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=y;class b{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of P)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=b;function M(_,P,E){_.has(P)?_.get(P).push(E):_.set(P,[E])}}),define(Ce[112],Ie([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ce[113],Ie([1,0,112]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,b=y*60,M=b*24,_=M*7,P=M*30,E=M*365;function k(w,m,I){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,o.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,o.localize)(1,null);let a;return f<y?(a=f,m?a===1?I?(0,o.localize)(2,null,a):(0,o.localize)(3,null,a):I?(0,o.localize)(4,null,a):(0,o.localize)(5,null,a):a===1?I?(0,o.localize)(6,null,a):(0,o.localize)(7,null,a):I?(0,o.localize)(8,null,a):(0,o.localize)(9,null,a)):f<b?(a=Math.floor(f/y),m?a===1?I?(0,o.localize)(10,null,a):(0,o.localize)(11,null,a):I?(0,o.localize)(12,null,a):(0,o.localize)(13,null,a):a===1?I?(0,o.localize)(14,null,a):(0,o.localize)(15,null,a):I?(0,o.localize)(16,null,a):(0,o.localize)(17,null,a)):f<M?(a=Math.floor(f/b),m?a===1?I?(0,o.localize)(18,null,a):(0,o.localize)(19,null,a):I?(0,o.localize)(20,null,a):(0,o.localize)(21,null,a):a===1?I?(0,o.localize)(22,null,a):(0,o.localize)(23,null,a):I?(0,o.localize)(24,null,a):(0,o.localize)(25,null,a)):f<_?(a=Math.floor(f/M),m?a===1?(0,o.localize)(26,null,a):(0,o.localize)(27,null,a):a===1?(0,o.localize)(28,null,a):(0,o.localize)(29,null,a)):f<P?(a=Math.floor(f/_),m?a===1?I?(0,o.localize)(30,null,a):(0,o.localize)(31,null,a):I?(0,o.localize)(32,null,a):(0,o.localize)(33,null,a):a===1?I?(0,o.localize)(34,null,a):(0,o.localize)(35,null,a):I?(0,o.localize)(36,null,a):(0,o.localize)(37,null,a)):f<E?(a=Math.floor(f/P),m?a===1?I?(0,o.localize)(38,null,a):(0,o.localize)(39,null,a):I?(0,o.localize)(40,null,a):(0,o.localize)(41,null,a):a===1?I?(0,o.localize)(42,null,a):(0,o.localize)(43,null,a):I?(0,o.localize)(44,null,a):(0,o.localize)(45,null,a)):(a=Math.floor(f/E),m?a===1?I?(0,o.localize)(46,null,a):(0,o.localize)(47,null,a):I?(0,o.localize)(48,null,a):(0,o.localize)(49,null,a):a===1?I?(0,o.localize)(50,null,a):(0,o.localize)(51,null,a):I?(0,o.localize)(52,null,a):(0,o.localize)(53,null,a))}e.fromNow=k;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[114],Ie([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ie([1,0,16,10,114]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,m){return m&&(w.stack||w.stacktrace)?b.localize(0,null,P(w),_(w.stack)||_(w.stacktrace)):P(w)}function _(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?b.localize(1,null,w.message):w.message||b.localize(2,null)}function E(w=null,m=!1){if(!w)return b.localize(3,null);if(Array.isArray(w)){const I=o.coalesce(w),f=E(I[0],m);return I.length>1?b.localize(4,null,f,I.length):f}if(y.isString(w))return w;if(w.detail){const I=w.detail;if(I.error)return M(I.error,m);if(I.exception)return M(I.exception,m)}return w.stack?M(w,m):w.message?w.message:b.localize(5,null)}e.toErrorMessage=E;function k(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(w,m){let I;return typeof w=="string"?I=new Error(w):I=w,I.actions=m,I}e.createErrorWithActions=O}),define(Ce[73],Ie([1,0,19]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const w=(0,o.extname)(O),m=y[w.toLowerCase()];return m!==void 0?m:_(O)}e.getMediaOrTextMime=M;function _(O){const w=(0,o.extname)(O);return b[w.toLowerCase()]}e.getMediaMime=_;function P(O){for(const w in b)if(b[w]===O)return w}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function k(O,w){const m=E.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:O}e.normalizeMimeType=k}),define(Ce[37],Ie([1,0,19,21,9,10]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function P(s){return s.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function E(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,i=o.posix.sep){if(!s)return"";const l=s.length,S=s.charCodeAt(0);if(_(S)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let T=3;const U=T;for(;T<l&&!_(s.charCodeAt(T));T++);if(U!==T&&!_(s.charCodeAt(T+1))){for(T+=1;T<l;T++)if(_(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,i)}}return i}else if(d(S)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<l;p++)if(_(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=k;function O(s){if(!y.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let l=2;const S=l;for(;l<s.length&&(i=s.charCodeAt(l),i!==92);l++);return!(S===l||(i=s.charCodeAt(l+1),isNaN(i)||i===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,i=y.isWindows){const l=i?w:m;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||i&&I.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function a(s,i,l){const S=s===i;return!l||S?S:!s||!i?!1:(0,b.equalsIgnoreCase)(s,i)}e.isEqual=a;function h(s,i,l,S=o.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(l){if(!(0,b.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let T=i.length;return i.charAt(i.length-1)===S&&T--,s.charAt(T)===S}return i.charAt(i.length-1)!==S&&(i+=S),s.indexOf(i)===0}e.isEqualOrParent=h;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function g(s,i){return y.isWindows&&s.endsWith(":")&&(s+=o.sep),(0,o.isAbsolute)(s)||(s=(0,o.join)(i,s)),s=(0,o.normalize)(s),y.isWindows?(s=(0,b.rtrim)(s,o.sep),s.endsWith(":")&&(s+=o.sep)):(s=(0,b.rtrim)(s,o.sep),s||(s=o.sep)),s}e.sanitizeFilePath=g;function A(s){const i=(0,o.normalize)(s);return y.isWindows?s.length>3?!1:c(i)&&(s.length===2||i.charCodeAt(2)===92):i===o.posix.sep}e.isRootOrDriveLetter=A;function c(s,i=y.isWindows){return i?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function v(s){return c(s)?s[0]:void 0}e.getDriveLetter=v;function t(s,i,l){return i.length>s.length?-1:s===i?0:(l&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function u(s){const i=s.split(":");let l,S,p;for(const T of i){const U=Number(T);(0,M.isNumber)(U)?S===void 0?S=U:p===void 0&&(p=U):l=l?[l,T].join(":"):T}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:S!==void 0?S:void 0,column:p!==void 0?p:S!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,i,l=8){let S="";for(let T=0;T<l;T++)S+=n.charAt(Math.floor(Math.random()*n.length));let p;return i?p=`${i}-${S}`:p=S,s?(0,o.join)(s,p):p}e.randomPath=r}),define(Ce[25],Ie([1,0,16,9]),function(ne,e,o,y){"use strict";var b,M,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,r,s){let i=n.get(r);return i===void 0&&(i=s,n.set(r,i)),i}e.getOrSet=P;function E(n){const r=[];return n.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=E;function k(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=k;class O{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=O;class w{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,y.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class m{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const i=this._value.charCodeAt(s);if(!(i===47||this._splitOnBackslash&&i===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,y.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var I;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,y.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(h||(h={}));class d{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new d(new f(r,s))}static forPaths(r=!1){return new d(new m(void 0,!r))}static forStrings(){return new d(new O)}static forConfigKeys(){return new d(new w)}clear(){this._root=void 0}fill(r,s){if(s){const i=s.slice(0);(0,o.shuffle)(i);for(const l of i)this.set(l,r)}else{const i=r.slice(0);(0,o.shuffle)(i);for(const l of i)this.set(l[0],l[1])}}set(r,s){const i=this._iter.reset(r);let l;this._root||(this._root=new a,this._root.segment=i.value());const S=[];for(l=this._root;;){const T=i.cmp(l.segment);if(T>0)l.left||(l.left=new a,l.left.segment=i.value()),S.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new a,l.right.segment=i.value()),S.push([1,l]),l=l.right;else if(i.hasNext())i.next(),l.mid||(l.mid=new a,l.mid.segment=i.value()),S.push([0,l]),l=l.mid;else break}const p=l.value;l.value=s,l.key=r;for(let T=S.length-1;T>=0;T--){const U=S[T][1];U.updateHeight();const j=U.balanceFactor();if(j<-1||j>1){const x=S[T][0],C=S[T+1][0];if(x===1&&C===1)S[T][1]=U.rotateLeft();else if(x===-1&&C===-1)S[T][1]=U.rotateRight();else if(x===1&&C===-1)U.right=S[T+1][1]=S[T+1][1].rotateRight(),S[T][1]=U.rotateLeft();else if(x===-1&&C===1)U.left=S[T+1][1]=S[T+1][1].rotateLeft(),S[T][1]=U.rotateRight();else throw new Error;if(T>0)switch(S[T-1][0]){case-1:S[T-1][1].left=S[T][1];break;case 1:S[T-1][1].right=S[T][1];break;case 0:S[T-1][1].mid=S[T][1];break}else this._root=S[0][1]}}return p}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),l=[];let S=this._root;for(;S;){const p=i.cmp(S.segment);if(p>0)l.push([-1,S]),S=S.left;else if(p<0)l.push([1,S]),S=S.right;else if(i.hasNext())i.next(),l.push([0,S]),S=S.mid;else break}if(!!S){if(s?(S.left=void 0,S.mid=void 0,S.right=void 0,S.height=1):(S.key=void 0,S.value=void 0),!S.mid&&!S.value)if(S.left&&S.right){const p=this._min(S.right),{key:T,value:U,segment:j}=p;this._delete(p.key,!1),S.key=T,S.value=U,S.segment=j}else{const p=S.left??S.right;if(l.length>0){const[T,U]=l[l.length-1];switch(T){case-1:U.left=p;break;case 0:U.mid=p;break;case 1:U.right=p;break}}else this._root=p}for(let p=l.length-1;p>=0;p--){const T=l[p][1];T.updateHeight();const U=T.balanceFactor();if(U>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),l[p][1]=T.rotateLeft()):U<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),l[p][1]=T.rotateRight()),p>0)switch(l[p-1][0]){case-1:l[p-1][1].left=l[p][1];break;case 1:l[p-1][1].right=l[p][1];break;case 0:l[p-1][1].mid=l[p][1];break}else this._root=l[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let i=this._root,l;for(;i;){const S=s.cmp(i.segment);if(S>0)i=i.left;else if(S<0)i=i.right;else if(s.hasNext())s.next(),l=i.value||l,i=i.mid;else break}return i&&i.value||l}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const l=s.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const i=s.balanceFactor();return i<-1||i>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=d;class g{constructor(r,s){this.uri=r,this.value=s}}class A{constructor(r,s){this[b]="ResourceMap",r instanceof A?(this.map=new Map(r.map),this.toKey=s??A.defaultToKey):(this.map=new Map,this.toKey=r??A.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new g(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[i,l]of this.map)r(l.value,l.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=A,A.defaultToKey=n=>n.toString();class c{constructor(r,s){this[M]="ResourceSet",!r||typeof r=="function"?this._map=new A(r):(this._map=new A(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((i,l)=>r.call(s,l,l,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var v;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let l=this._map.get(r);if(l)l.value=s,i!==0&&this.touch(l,i);else{switch(l={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let l=this._head;for(;l;){if(s?r.bind(s)(l.value,l.key,this):r(l.value,l.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const S={value:i.key,done:!1};return i=i.next,S}else return{value:void 0,done:!0}}};return l}values(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const S={value:i.value,done:!1};return i=i.next,S}else return{value:void 0,done:!0}}};return l}entries(){const r=this,s=this._state;let i=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const S={value:[i.key,i.value],done:!1};return i=i.next,S}else return{value:void 0,done:!0}}};return l}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(i.previous=l,l.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,l=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=l,l.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=t;class u extends t{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ce[115],Ie([1,0,25,9]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...Q){return function(J,D){for(let B=0,H=Q.length;B<H;B++){const V=Q[B](J,D);if(V)return V}return null}}e.or=b,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Q,J,D){if(!D||D.length<J.length)return null;let B;return Q?B=y.startsWithIgnoreCase(D,J):B=D.indexOf(J)===0,B?J.length>0?[{start:0,end:J.length}]:[]:null}function _(Q,J){const D=J.toLowerCase().indexOf(Q.toLowerCase());return D===-1?null:[{start:D,end:D+Q.length}]}e.matchesContiguousSubString=_;function P(Q,J){return E(Q.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=P;function E(Q,J,D,B){if(D===Q.length)return[];if(B===J.length)return null;if(Q[D]===J[B]){let H=null;return(H=E(Q,J,D+1,B+1))?d({start:B,end:B+1},H):null}return E(Q,J,D,B+1)}function k(Q){return 97<=Q&&Q<=122}function O(Q){return 65<=Q&&Q<=90}e.isUpper=O;function w(Q){return 48<=Q&&Q<=57}function m(Q){return Q===32||Q===9||Q===10||Q===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Q=>I.add(Q.charCodeAt(0)));function f(Q){return m(Q)||I.has(Q)}function a(Q,J){return Q===J||f(Q)&&f(J)}function h(Q){return k(Q)||O(Q)||w(Q)}function d(Q,J){return J.length===0?J=[Q]:Q.end===J[0].start?J[0].start=Q.start:J.unshift(Q),J}function g(Q,J){for(let D=J;D<Q.length;D++){const B=Q.charCodeAt(D);if(O(B)||w(B)||D>0&&!h(Q.charCodeAt(D-1)))return D}return Q.length}function A(Q,J,D,B){if(D===Q.length)return[];if(B===J.length)return null;if(Q[D]!==J[B].toLowerCase())return null;{let H=null,V=B+1;for(H=A(Q,J,D+1,B+1);!H&&(V=g(J,V))<J.length;)H=A(Q,J,D+1,V),V++;return H===null?null:d({start:B,end:B+1},H)}}function c(Q){let J=0,D=0,B=0,H=0,V=0;for(let ge=0;ge<Q.length;ge++)V=Q.charCodeAt(ge),O(V)&&J++,k(V)&&D++,h(V)&&B++,w(V)&&H++;const te=J/Q.length,de=D/Q.length,Y=B/Q.length,pe=H/Q.length;return{upperPercent:te,lowerPercent:de,alphaPercent:Y,numericPercent:pe}}function v(Q){const{upperPercent:J,lowerPercent:D}=Q;return D===0&&J>.6}function t(Q){const{upperPercent:J,lowerPercent:D,alphaPercent:B,numericPercent:H}=Q;return D>.2&&J<.8&&B>.6&&H<.2}function u(Q){let J=0,D=0,B=0,H=0;for(let V=0;V<Q.length;V++)B=Q.charCodeAt(V),O(B)&&J++,k(B)&&D++,m(B)&&H++;return(J===0||D===0)&&H===0?Q.length<=30:J<=5}function n(Q,J){if(!J||(J=J.trim(),J.length===0)||!u(Q)||J.length>60)return null;const D=c(J);if(!t(D)){if(!v(D))return null;J=J.toLowerCase()}let B=null,H=0;for(Q=Q.toLowerCase();H<J.length&&(B=A(Q,J,0,H))===null;)H=g(J,H+1);return B}e.matchesCamelCase=n;function r(Q,J,D=!1){if(!J||J.length===0)return null;let B=null,H=0;for(Q=Q.toLowerCase(),J=J.toLowerCase();H<J.length&&(B=s(Q,J,0,H,D))===null;)H=i(J,H+1);return B}e.matchesWords=r;function s(Q,J,D,B,H){if(D===Q.length)return[];if(B===J.length)return null;if(a(Q.charCodeAt(D),J.charCodeAt(B))){let V=null,te=B+1;if(V=s(Q,J,D+1,B+1,H),!H)for(;!V&&(te=i(J,te))<J.length;)V=s(Q,J,D+1,te,H),te++;return V?Q.charCodeAt(D)!==J.charCodeAt(B)?V:d({start:B,end:B+1},V):null}else return null}function i(Q,J){for(let D=J;D<Q.length;D++)if(f(Q.charCodeAt(D))||D>0&&f(Q.charCodeAt(D-1)))return D;return Q.length}const l=b(e.matchesPrefix,n,_),S=b(e.matchesPrefix,n,P),p=new o.LRUCache(1e4);function T(Q,J,D=!1){if(typeof Q!="string"||typeof J!="string")return null;let B=p.get(Q);B||(B=new RegExp(y.convertSimple2RegExpPattern(Q),"i"),p.set(Q,B));const H=B.exec(J);return H?[{start:H.index,end:H.index+H[0].length}]:D?S(Q,J):l(Q,J)}e.matchesFuzzy=T;function U(Q,J){const D=ze(Q,Q.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return D?x(D):null}e.matchesFuzzy2=U;function j(Q,J,D,B,H,V){const te=Math.min(13,Q.length);for(;D<te;D++){const de=ze(Q,J,D,B,H,V,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,V]}e.anyScore=j;function x(Q){if(typeof Q>"u")return[];const J=[],D=Q[1];for(let B=Q.length-1;B>1;B--){const H=Q[B]+D,V=J[J.length-1];V&&V.end===H?V.end=H+1:J.push({start:H,end:H+1})}return J}e.createMatches=x;const C=128;function z(){const Q=[],J=[];for(let D=0;D<=C;D++)J[D]=0;for(let D=0;D<=C;D++)Q.push(J.slice(0));return Q}function N(Q){const J=[];for(let D=0;D<=Q;D++)J[D]=0;return J}const L=N(2*C),q=N(2*C),W=z(),R=z(),Z=z(),le=!1;function oe(Q,J,D,B,H){function V(de,Y,pe=" "){for(;de.length<Y;)de=pe+de;return de}let te=` |   |${B.split("").map(de=>V(de,3)).join("|")}
`;for(let de=0;de<=D;de++)de===0?te+=" |":te+=`${J[de-1]}|`,te+=Q[de].slice(0,H+1).map(Y=>V(Y.toString(),3)).join("|")+`
`;return te}function ue(Q,J,D,B){Q=Q.substr(J),D=D.substr(B),console.log(oe(R,Q,Q.length,D,D.length)),console.log(oe(Z,Q,Q.length,D,D.length)),console.log(oe(W,Q,Q.length,D,D.length))}function ee(Q,J){if(J<0||J>=Q.length)return!1;const D=Q.codePointAt(J);switch(D){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(D)}}function ve(Q,J){if(J<0||J>=Q.length)return!1;switch(Q.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function we(Q,J,D){return J[Q]!==D[Q]}function re(Q,J,D,B,H,V,te=!1){for(;J<D&&H<V;)Q[J]===B[H]&&(te&&(L[J]=H),J+=1),H+=1;return J===D}e.isPatternInWord=re;var Ee;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(Q){Q.Default=[-100,0];function J(D){return!D||D.length===2&&D[0]===-100&&D[1]===0}Q.isDefault=J})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,D){this.firstMatchCanBeWeak=J,this.boostFullMatch=D}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ze(Q,J,D,B,H,V,te=Fe.default){const de=Q.length>C?C:Q.length,Y=B.length>C?C:B.length;if(D>=de||V>=Y||de-D>Y-V||!re(J,D,de,H,V,Y,!0))return;Qe(de,Y,D,V,J,H);let pe=1,ge=1,Ne=D,Be=V;const Ye=[!1];for(pe=1,Ne=D;Ne<de;pe++,Ne++){const X=L[Ne],fe=q[Ne],Ue=Ne+1<de?q[Ne+1]:Y;for(ge=X-V+1,Be=X;Be<Ue;ge++,Be++){let He=Number.MIN_SAFE_INTEGER,Ze=!1;Be<=fe&&(He=Te(Q,J,Ne,D,B,H,Be,Y,V,W[pe-1][ge-1]===0,Ye));let Ke=0;He!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=He+R[pe-1][ge-1]);const We=Be>X,it=We?R[pe][ge-1]+(W[pe][ge-1]>0?-5:0):0,st=Be>X+1&&W[pe][ge-1]>0,dt=st?R[pe][ge-2]+(W[pe][ge-2]>0?-5:0):0;if(st&&(!We||dt>=it)&&(!Ze||dt>=Ke))R[pe][ge]=dt,Z[pe][ge]=3,W[pe][ge]=0;else if(We&&(!Ze||it>=Ke))R[pe][ge]=it,Z[pe][ge]=2,W[pe][ge]=0;else if(Ze)R[pe][ge]=Ke,Z[pe][ge]=1,W[pe][ge]=W[pe-1][ge-1]+1;else throw new Error("not possible")}}if(le&&ue(Q,D,B,V),!Ye[0]&&!te.firstMatchCanBeWeak)return;pe--,ge--;const Ge=[R[pe][ge],V];let ke=0,nt=0;for(;pe>=1;){let X=ge;do{const fe=Z[pe][X];if(fe===3)X=X-2;else if(fe===2)X=X-1;else break}while(X>=1);ke>1&&J[D+pe-1]===H[V+ge-1]&&!we(X+V-1,B,H)&&ke+1>W[pe][X]&&(X=ge),X===ge?ke++:ke=1,nt||(nt=X),pe--,ge=X-1,Ge.push(ge)}Y===de&&te.boostFullMatch&&(Ge[0]+=2);const G=nt-de;return Ge[0]-=G,Ge}e.fuzzyScore=ze;function Qe(Q,J,D,B,H,V){let te=Q-1,de=J-1;for(;te>=D&&de>=B;)H[te]===V[de]&&(q[te]=de,te--),de--}function Te(Q,J,D,B,H,V,te,de,Y,pe,ge){if(J[D]!==V[te])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return te===D-B?Ne=Q[D]===H[te]?7:5:we(te,H,V)&&(te===0||!we(te-1,H,V))?(Ne=Q[D]===H[te]?7:5,Be=!0):ee(V,te)&&(te===0||!ee(V,te-1))?Ne=5:(ee(V,te-1)||ve(V,te-1))&&(Ne=5,Be=!0),Ne>1&&D===B&&(ge[0]=!0),Be||(Be=we(te,H,V)||ee(V,te-1)||ve(V,te-1)),D===B?te>Y&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,te+1===de&&(Ne-=Be?3:5),Ne}function _e(Q,J,D,B,H,V,te){return ae(Q,J,D,B,H,V,!0,te)}e.fuzzyScoreGracefulAggressive=_e;function ye(Q,J,D,B,H,V,te){return ae(Q,J,D,B,H,V,!1,te)}e.fuzzyScoreGraceful=ye;function ae(Q,J,D,B,H,V,te,de){let Y=ze(Q,J,D,B,H,V,de);if(Y&&!te)return Y;if(Q.length>=3){const pe=Math.min(7,Q.length-1);for(let ge=D+1;ge<pe;ge++){const Ne=ce(Q,ge);if(Ne){const Be=ze(Ne,Ne.toLowerCase(),D,B,H,V,de);Be&&(Be[0]-=3,(!Y||Be[0]>Y[0])&&(Y=Be))}}}return Y}function ce(Q,J){if(J+1>=Q.length)return;const D=Q[J],B=Q[J+1];if(D!==B)return Q.slice(0,J)+B+D+Q.slice(J+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(o.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${M.source}`,"g");function E(h){return h.replace(P,(d,g)=>g?d:`\\${d}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${M.source}`,"g");function O(h){return h.replace(k,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(w,(d,g,A,c)=>A?d:g||c||"")}e.stripIcons=m;function I(h){const d=h.indexOf(e.iconStartMarker);return d===-1?{text:h}:f(h,d)}e.parseLabelWithIcons=I;function f(h,d){const g=[];let A="";function c(l){if(l){A+=l;for(const S of l)g.push(u)}}let v=-1,t="",u=0,n,r,s=d;const i=h.length;for(c(h.substr(0,d));s<i;)n=h[s],r=h[s+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(v=s,c(t),t=e.iconStartMarker,s++):n===")"&&v!==-1?(u+=s-v+1,v=-1,t=""):v!==-1?_.test(n)?t+=n:(c(t),v=-1,t=""):c(n),s++;return c(t),{text:A,iconOffsets:g}}function a(h,d,g=!1){const{text:A,iconOffsets:c}=d;if(!c||c.length===0)return(0,y.matchesFuzzy)(h,A,g);const v=(0,b.ltrim)(A," "),t=A.length-v.length,u=(0,y.matchesFuzzy)(h,v,g);if(u)for(const n of u){const r=c[n.start+t]+t;n.start+=r,n.end+=r}return u}e.matchesFuzzyIconAware=a}),define(Ce[29],Ie([1,0,9]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(y||(y={})),function(b){const M="error",_="warning",P="warn",E="info",k="ignore";function O(m){return m?o.equalsIgnoreCase(M,m)?b.Error:o.equalsIgnoreCase(_,m)||o.equalsIgnoreCase(P,m)?b.Warning:o.equalsIgnoreCase(E,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=O;function w(m){switch(m){case b.Error:return M;case b.Warning:return _;case b.Info:return E;default:return k}}b.toString=w}(y||(y={})),e.default=y}),define(Ce[74],Ie([1,0,23,9,2]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,P)}e.stringify=M;function _(k){let O=JSON.parse(k);return O=E(O),O}e.parse=_;function P(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,y.regExpFlags)(O)}:O}function E(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return b.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof o.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=E(k[w],O+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=E(k[w],O+1))}return k}e.revive=E}),define(Ce[12],Ie([1,0,21,2]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${b.vscodeRemoteResource}`}set(k,O,w){this._hosts[k]=O,this._ports[k]=w}setConnectionToken(k,O){this._connectionTokens[k]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const O=k.authority;let w=this._hosts[O];w&&w.indexOf(":")!==-1&&(w=`[${w}]`);const m=this._ports[O],I=this._connectionTokens[O];let f=`path=${encodeURIComponent(k.path)}`;return typeof I=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),y.URI.from({scheme:o.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${w}:${m}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new M;class _{asBrowserUri(k,O){const w=this.toUri(k,O);return w.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(w):w.scheme===b.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${b.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?w.with({scheme:b.vscodeFileResource,authority:w.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):w}asFileUri(k,O){const w=this.toUri(k,O);return w.scheme===b.vscodeFileResource?w.with({scheme:b.file,authority:w.authority!==_.FALLBACK_AUTHORITY?w.authority:null,query:null,fragment:null}):w}toUri(k,O){return y.URI.isUri(k)?k:y.URI.parse(O.toUrl(k))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var P;(function(E){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function w(I){let f;typeof I=="string"?f=new URL(I).searchParams:I instanceof URL?f=I.searchParams:y.URI.isUri(I)&&(f=new URL(I.toString(!0)).searchParams);const a=f?.get(O);if(!!a)return k.get(a)}E.getHeadersFromQuery=w;function m(I,f,a){if(!globalThis.crossOriginIsolated)return;const h=f&&a?"3":a?"2":"1";I instanceof URLSearchParams?I.set(O,h):I[O]=h}E.addSearchParam=m})(P=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,37,12,19,21,9,2]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=E;class k{constructor(f){this._ignorePathCasing=f}compare(f,a,h=!1){return f===a?0:(0,_.compare)(this.getComparisonKey(f,h),this.getComparisonKey(a,h))}isEqual(f,a,h=!1){return f===a?!0:!f||!a?!1:this.getComparisonKey(f,h)===this.getComparisonKey(a,h)}getComparisonKey(f,a=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,a,h=!1){if(f.scheme===a.scheme){if(f.scheme===y.Schemas.file)return o.isEqualOrParent(E(f),E(a),this._ignorePathCasing(f))&&f.query===a.query&&(h||f.fragment===a.fragment);if((0,e.isEqualAuthority)(f.authority,a.authority))return o.isEqualOrParent(f.path,a.path,this._ignorePathCasing(f),"/")&&f.query===a.query&&(h||f.fragment===a.fragment)}return!1}joinPath(f,...a){return P.URI.joinPath(f,...a)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return b.posix.basename(f.path)}extname(f){return b.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let a;return f.scheme===y.Schemas.file?a=P.URI.file(b.dirname(E(f))).path:(a=b.posix.dirname(f.path),f.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),a="/")),f.with({path:a})}normalizePath(f){if(!f.path.length)return f;let a;return f.scheme===y.Schemas.file?a=P.URI.file(b.normalize(E(f))).path:a=b.posix.normalize(f.path),f.with({path:a})}relativePath(f,a){if(f.scheme!==a.scheme||!(0,e.isEqualAuthority)(f.authority,a.authority))return;if(f.scheme===y.Schemas.file){const g=b.relative(E(f),E(a));return M.isWindows?o.toSlashes(g):g}let h=f.path||"/";const d=a.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const A=Math.min(h.length,d.length);g<A&&!(h.charCodeAt(g)!==d.charCodeAt(g)&&h.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);h=d.substr(0,g)+h.substr(g)}return b.posix.relative(h,d)}resolvePath(f,a){if(f.scheme===y.Schemas.file){const h=P.URI.file(b.resolve(E(f),a));return f.with({authority:h.authority,path:h.path})}return a=o.toPosixPath(a),f.with({path:b.posix.resolve(f.path,a)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,a){return f===a||f!==void 0&&a!==void 0&&(0,_.equalsIgnoreCase)(f,a)}hasTrailingPathSeparator(f,a=b.sep){if(f.scheme===y.Schemas.file){const h=E(f);return h.length>o.getRoot(h).length&&h[h.length-1]===a}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,a=b.sep){return(0,e.hasTrailingPathSeparator)(f,a)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,a=b.sep){let h=!1;if(f.scheme===y.Schemas.file){const d=E(f);h=d!==void 0&&d.length===o.getRoot(d).length&&d[d.length-1]===a}else{a="/";const d=f.path;h=d.length===1&&d.charCodeAt(d.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,a)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(I=>I.scheme===y.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(I,f){const a=[];for(let h=0;h<I.length;h++){const d=f(I[h]);I.some((g,A)=>A===h?!1:(0,e.isEqualOrParent)(d,f(g)))||a.push(I[h])}return a}e.distinctParents=O;var w;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function f(a){const h=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(A=>{const[c,v]=A.split(":");c&&v&&h.set(c,v)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&h.set(I.META_DATA_MIME,g),h}I.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function m(I,f,a){if(f){let h=I.path;return h&&h[0]!==b.posix.sep&&(h=b.posix.sep+h),I.with({scheme:a,authority:f,path:h})}return I.with({scheme:a})}e.toLocalResource=m}),define(Ce[14],Ie([1,0,20,11,5,7,22,21]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(we){return!!we&&typeof we.then=="function"}e.isThenable=E;function k(we){const re=new o.CancellationTokenSource,Ee=we(re.token),Pe=new Promise((Fe,ze)=>{const Qe=re.token.onCancellationRequested(()=>{Qe.dispose(),re.dispose(),ze(new y.CancellationError)});Promise.resolve(Ee).then(Te=>{Qe.dispose(),re.dispose(),Fe(Te)},Te=>{Qe.dispose(),re.dispose(),ze(Te)})});return new class{cancel(){re.cancel()}then(Fe,ze){return Pe.then(Fe,ze)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=k;function O(we,re,Ee){return new Promise((Pe,Fe)=>{const ze=re.onCancellationRequested(()=>{ze.dispose(),Pe(Ee)});we.then(Pe,Fe).finally(()=>ze.dispose())})}e.raceCancellation=O;function w(we,re){return new Promise((Ee,Pe)=>{const Fe=re.onCancellationRequested(()=>{Fe.dispose(),Pe(new y.CancellationError)});we.then(Ee,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=w;async function m(we){let re=-1;const Ee=we.map((Fe,ze)=>Fe.then(Qe=>(re=ze,Qe))),Pe=await Promise.race(Ee);return we.forEach((Fe,ze)=>{ze!==re&&Fe.cancel()}),Pe}e.raceCancellablePromises=m;function I(we,re,Ee){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),Ee?.()},re);return Promise.race([we.finally(()=>clearTimeout(Fe)),new Promise(ze=>Pe=ze)])}e.raceTimeout=I;function f(we){return new Promise((re,Ee)=>{const Pe=we();E(Pe)?Pe.then(re,Ee):re(Pe)})}e.asPromise=f;class a{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(re){if(this.activePromise){if(this.queuedPromiseFactory=re,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=re(),new Promise((Ee,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ee(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=a;class h{constructor(){this.current=Promise.resolve(null)}queue(re){return this.current=this.current.then(()=>re(),()=>re())}}e.Sequencer=h;class d{constructor(){this.promiseMap=new Map}queue(re,Ee){const Fe=(this.promiseMap.get(re)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(re)===Fe&&this.promiseMap.delete(re)});return this.promiseMap.set(re,Fe),Fe}}e.SequencerByKey=d;const g=(we,re)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,re()},we);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},A=we=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,we())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(re){this.defaultDelay=re,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(re,Ee=this.defaultDelay){this.task=re,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,ze)=>{this.doResolve=Fe,this.doReject=ze}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?A(Pe):g(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class v{constructor(re){this.delayer=new c(re),this.throttler=new a}trigger(re,Ee){return this.delayer.trigger(()=>this.throttler.queue(re),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class t{constructor(){this._isOpen=!1,this._promise=new Promise((re,Ee)=>{this._completePromise=re})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class u extends t{constructor(re){super(),this._timeout=setTimeout(()=>this.open(),re)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(we,re){return re?new Promise((Ee,Pe)=>{const Fe=setTimeout(()=>{ze.dispose(),Ee()},we),ze=re.onCancellationRequested(()=>{clearTimeout(Fe),ze.dispose(),Pe(new y.CancellationError)})}):k(Ee=>n(we,Ee))}e.timeout=n;function r(we,re=0){const Ee=setTimeout(we,re);return(0,M.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=r;function s(we){const re=[];let Ee=0;const Pe=we.length;function Fe(){return Ee<Pe?we[Ee++]():null}function ze(Qe){Qe!=null&&re.push(Qe);const Te=Fe();return Te?Te.then(ze):Promise.resolve(re)}return Promise.resolve(null).then(ze)}e.sequence=s;function i(we,re=Pe=>!!Pe,Ee=null){let Pe=0;const Fe=we.length,ze=()=>{if(Pe>=Fe)return Promise.resolve(Ee);const Qe=we[Pe++];return Promise.resolve(Qe()).then(_e=>re(_e)?Promise.resolve(_e):ze())};return ze()}e.first=i;function l(we,re=Pe=>!!Pe,Ee=null){if(we.length===0)return Promise.resolve(Ee);let Pe=we.length;const Fe=()=>{Pe=-1;for(const ze of we)ze.cancel?.()};return new Promise((ze,Qe)=>{for(const Te of we)Te.then(_e=>{--Pe>=0&&re(_e)?(Fe(),ze(_e)):Pe===0&&ze(Ee)}).catch(_e=>{--Pe>=0&&(Fe(),Qe(_e))})})}e.firstParallel=l;class S{constructor(re){this._size=0,this.maxDegreeOfParalellism=re,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(re){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:re,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const re=this.outstandingPromises.shift();this.runningPromises++;const Ee=re.factory();Ee.then(re.c,re.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=S;class p extends S{constructor(){super(1)}}e.Queue=p;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const re=new Z;return this.drainers.add(re),re.p}isDrained(){for(const[,re]of this.queues)if(re.size>0)return!1;return!0}queueFor(re,Ee=_.extUri){const Pe=Ee.getComparisonKey(re);let Fe=this.queues.get(Pe);return Fe||(Fe=new p,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const re of this.drainers)re.complete();this.drainers.clear()}dispose(){for(const[,re]of this.queues)re.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(re,Ee){this._token=-1,typeof re=="function"&&typeof Ee=="number"&&this.setIfNotSet(re,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(re,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,re()},Ee)}setIfNotSet(re,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,re()},Ee))}}e.TimeoutTimer=U;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(re,Ee){this.cancel(),this._token=setInterval(()=>{re()},Ee)}}e.IntervalTimer=j;class x{constructor(re,Ee){this.timeoutToken=-1,this.runner=re,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(re=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,re)}get delay(){return this.timeout}set delay(re){this.timeout=re}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class C{constructor(re,Ee){Ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=re,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(re=this.timeout){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(re/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=C;class z extends x{constructor(re,Ee){super(re,Ee),this.units=[]}work(re){this.units.push(re),this.isScheduled()||this.schedule()}doRun(){const re=this.units;this.units=[],this.runner?.(re)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class N extends M.Disposable{constructor(re,Ee){super(),this.options=re,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(re){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+re.length>this.options.maxBufferedWork)return!1}else if(this.pending+re.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...re),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=we=>{(0,P.setTimeout0)(()=>{if(re)return;const Ee=Date.now()+15;we(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.runWhenIdle=(we,re)=>{const Ee=requestIdleCallback(we,typeof re=="number"?{timeout:re}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class L{constructor(re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=L;async function q(we,re,Ee){let Pe;for(let Fe=0;Fe<Ee;Fe++)try{return await we()}catch(ze){Pe=ze,await n(re)}throw Pe}e.retry=q;class W{hasPending(re){return this._pending?typeof re=="number"?this._pending.taskId===re:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(re,Ee,Pe){return this._pending={taskId:re,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(re),()=>this.donePending(re)),Ee}donePending(re){this._pending&&re===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const re=this._next;this._next=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}setNext(re){if(this._next)this._next.run=re;else{let Ee,Pe;const Fe=new Promise((ze,Qe)=>{Ee=ze,Pe=Qe});this._next={run:re,promise:Fe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class R{constructor(re,Ee=()=>Date.now()){this.interval=re,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const re=this.nowFn();return re-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=re,this.value=0),this.value++,this.value}}e.IntervalCounter=R;class Z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((re,Ee)=>{this.completeCallback=re,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(re){return new Promise(Ee=>{this.completeCallback(re),this.resolved=!0,Ee()})}error(re){return new Promise(Ee=>{this.errorCallback(re),this.rejected=!0,Ee()})}cancel(){new Promise(re=>{this.errorCallback(new y.CancellationError),this.rejected=!0,re()})}}e.DeferredPromise=Z;var le;(function(we){async function re(Pe){let Fe;const ze=await Promise.all(Pe.map(Qe=>Qe.then(Te=>Te,Te=>{Fe||(Fe=Te)})));if(typeof Fe<"u")throw Fe;return ze}we.settled=re;function Ee(Pe){return new Promise(async(Fe,ze)=>{try{await Pe(Fe,ze)}catch(Qe){ze(Qe)}})}we.withAsyncBody=Ee})(le=e.Promises||(e.Promises={}));var oe;(function(we){we[we.Initial=0]="Initial",we[we.DoneOK=1]="DoneOK",we[we.DoneError=2]="DoneError"})(oe||(oe={}));class ue{constructor(re){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(re(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(re){return new ue(Ee=>{Ee.emitMany(re)})}static fromPromise(re){return new ue(async Ee=>{Ee.emitMany(await re)})}static fromPromises(re){return new ue(async Ee=>{await Promise.all(re.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(re){return new ue(async Ee=>{await Promise.all(re.map(async Pe=>{for await(const Fe of Pe)Ee.emitOne(Fe)}))})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(re<this._results.length)return{done:!1,value:this._results[re++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(re,Ee){return new ue(async Pe=>{for await(const Fe of re)Pe.emitOne(Ee(Fe))})}map(re){return ue.map(this,re)}static filter(re,Ee){return new ue(async Pe=>{for await(const Fe of re)Ee(Fe)&&Pe.emitOne(Fe)})}filter(re){return ue.filter(this,re)}static coalesce(re){return ue.filter(re,Ee=>!!Ee)}coalesce(){return ue.coalesce(this)}static async toPromise(re){const Ee=[];for await(const Pe of re)Ee.push(Pe);return Ee}toPromise(){return ue.toPromise(this)}emitOne(re){this._state===0&&(this._results.push(re),this._onStateChanged.fire())}emitMany(re){this._state===0&&(this._results=this._results.concat(re),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(re){this._state===0&&(this._state=2,this._error=re,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class ee extends ue{constructor(re,Ee){super(Ee),this._source=re}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ee;function ve(we){const re=new o.CancellationTokenSource,Ee=we(re.token);return new ee(re,async Pe=>{const Fe=re.token.onCancellationRequested(()=>{Fe.dispose(),re.dispose(),Pe.reject(new y.CancellationError)});try{for await(const ze of Ee){if(re.token.isCancellationRequested)return;Pe.emitOne(ze)}Fe.dispose(),re.dispose()}catch(ze){Fe.dispose(),re.dispose(),Pe.reject(ze)}})}e.createCancelableAsyncIterable=ve}),define(Ce[118],Ie([1,0,14,19]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new o.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(p,T,U=!1){const j=p||"",x=T||"",C=b.value.collator.compare(j,x);return b.value.collatorIsNumeric&&C===0&&j!==x?j<x?-1:1:C}e.compareFileNames=P;function E(p,T){const U=M.value.collator;return p=p||"",T=T||"",v(U,p,T)}e.compareFileNamesDefault=E;function k(p,T){const U=M.value.collator;return p=p||"",T=T||"",r(p,T)||v(U,p,T)}e.compareFileNamesUpper=k;function O(p,T){const U=M.value.collator;return p=p||"",T=T||"",n(p,T)||v(U,p,T)}e.compareFileNamesLower=O;function w(p,T){return p=p||"",T=T||"",p===T?0:p<T?-1:1}e.compareFileNamesUnicode=w;function m(p,T,U=!1){U||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase());const[j,x]=A(p),[C,z]=A(T);return j!==C?j<C?-1:1:x===z?0:x<z?-1:1}e.noIntlCompareFileNames=m;function I(p,T){const[U,j]=A(p),[x,C]=A(T);let z=b.value.collator.compare(j,C);if(z===0){if(b.value.collatorIsNumeric&&j!==C)return j<C?-1:1;if(z=b.value.collator.compare(U,x),b.value.collatorIsNumeric&&z===0&&U!==x)return U<x?-1:1}return z}e.compareFileExtensions=I;function f(p,T){p=p||"",T=T||"";const U=c(p),j=c(T),x=M.value.collator,C=_.value.collator;return v(C,U,j)||v(x,p,T)}e.compareFileExtensionsDefault=f;function a(p,T){p=p||"",T=T||"";const U=c(p),j=c(T),x=M.value.collator,C=_.value.collator;return v(C,U,j)||r(p,T)||v(x,p,T)}e.compareFileExtensionsUpper=a;function h(p,T){p=p||"",T=T||"";const U=c(p),j=c(T),x=M.value.collator,C=_.value.collator;return v(C,U,j)||n(p,T)||v(x,p,T)}e.compareFileExtensionsLower=h;function d(p,T){p=p||"",T=T||"";const U=c(p).toLowerCase(),j=c(T).toLowerCase();return U!==j?U<j?-1:1:p!==T?p<T?-1:1:0}e.compareFileExtensionsUnicode=d;const g=/^(.*?)(\.([^.]*))?$/;function A(p,T=!1){const U=p?g.exec(p):[];let j=[U&&U[1]||"",U&&U[3]||""];return T&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function c(p){const T=p?g.exec(p):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function v(p,T,U){const j=p.compare(T,U);return j!==0?j:T.length!==U.length?T.length<U.length?-1:1:0}function t(p){const T=p.charAt(0);return T.toLocaleUpperCase()!==T}function u(p){const T=p.charAt(0);return T.toLocaleLowerCase()!==T}function n(p,T){return t(p)&&u(T)?-1:u(p)&&t(T)?1:0}function r(p,T){return u(p)&&t(T)?-1:t(p)&&u(T)?1:0}function s(p,T,U=!1){return U||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase()),p===T?0:p<T?-1:1}function i(p,T,U=!1){const j=p.split(y.sep),x=T.split(y.sep),C=j.length-1,z=x.length-1;let N,L;for(let q=0;;q++){if(N=C===q,L=z===q,N&&L)return P(j[q],x[q],U);if(N)return-1;if(L)return 1;const W=s(j[q],x[q],U);if(W!==0)return W}}e.comparePaths=i;function l(p,T,U){const j=p.toLowerCase(),x=T.toLowerCase(),C=S(p,T,U);if(C)return C;const z=j.endsWith(U),N=x.endsWith(U);if(z!==N)return z?-1:1;const L=P(j,x);return L!==0?L:j.localeCompare(x)}e.compareAnything=l;function S(p,T,U){const j=p.toLowerCase(),x=T.toLowerCase(),C=j.startsWith(U),z=x.startsWith(U);if(C!==z)return C?-1:1;if(C&&z){if(j.length<x.length)return-1;if(j.length>x.length)return 1}return 0}e.compareByPrefix=S}),define(Ce[34],Ie([1,0,16,14,37,25,19,21,9]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",m=/\//g;function I(Z,le){switch(Z){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${le?`|${O}${w}+`:""})*?`}}function f(Z,le){if(!Z)return[];const oe=[];let ue=!1,ee=!1,ve="";for(const we of Z){switch(we){case le:if(!ue&&!ee){oe.push(ve),ve="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ve+=we}return ve&&oe.push(ve),oe}e.splitGlobAware=f;function a(Z){if(!Z)return"";let le="";const oe=f(Z,e.GLOB_SPLIT);if(oe.every(ue=>ue===e.GLOBSTAR))le=".*";else{let ue=!1;oe.forEach((ee,ve)=>{if(ee===e.GLOBSTAR){if(ue)return;le+=I(2,ve===oe.length-1)}else{let we=!1,re="",Ee=!1,Pe="";for(const Fe of ee){if(Fe!=="}"&&we){re+=Fe;continue}if(Ee&&(Fe!=="]"||!Pe)){let ze;Fe==="-"?ze=Fe:(Fe==="^"||Fe==="!")&&!Pe?ze="^":Fe===e.GLOB_SPLIT?ze="":ze=(0,E.escapeRegExpCharacters)(Fe),Pe+=ze;continue}switch(Fe){case"{":we=!0;continue;case"[":Ee=!0;continue;case"}":{le+=`(?:${f(re,",").map(Te=>a(Te)).join("|")})`,we=!1,re="";break}case"]":{le+="["+Pe+"]",Ee=!1,Pe="";break}case"?":le+=w;continue;case"*":le+=I(1);continue;default:le+=(0,E.escapeRegExpCharacters)(Fe)}}ve<oe.length-1&&(oe[ve+1]!==e.GLOBSTAR||ve+2<oe.length)&&(le+=O)}ue=ee===e.GLOBSTAR})}return le}const h=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),u=function(){return!1},n=function(){return null};function r(Z,le){if(!Z)return n;let oe;typeof Z!="string"?oe=Z.pattern:oe=Z,oe=oe.trim();const ue=`${oe}_${!!le.trimForExclusions}`;let ee=t.get(ue);if(ee)return s(ee,Z);let ve;return h.test(oe)?ee=l(oe.substr(4),oe):(ve=d.exec(i(oe,le)))?ee=S(ve[1],oe):(le.trimForExclusions?A:g).test(oe)?ee=p(oe,le):(ve=c.exec(i(oe,le)))?ee=T(ve[1].substr(1),oe,!0):(ve=v.exec(i(oe,le)))?ee=T(ve[1],oe,!1):ee=U(oe),t.set(ue,ee),s(ee,Z)}function s(Z,le){if(typeof le=="string")return Z;const oe=function(ue,ee){return(0,b.isEqualOrParent)(ue,le.base,!P.isLinux)?Z(ue.substr(le.base.length+1),ee):null};return oe.allBasenames=Z.allBasenames,oe.allPaths=Z.allPaths,oe.basenames=Z.basenames,oe.patterns=Z.patterns,oe}function i(Z,le){return le.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function l(Z,le){return function(oe,ue){return typeof oe=="string"&&oe.endsWith(Z)?le:null}}function S(Z,le){const oe=`/${Z}`,ue=`\\${Z}`,ee=function(we,re){return typeof we!="string"?null:re?re===Z?le:null:we===Z||we.endsWith(oe)||we.endsWith(ue)?le:null},ve=[Z];return ee.basenames=ve,ee.patterns=[le],ee.allBasenames=ve,ee}function p(Z,le){const oe=W(Z.slice(1,-1).split(",").map(re=>r(re,le)).filter(re=>re!==n),Z),ue=oe.length;if(!ue)return n;if(ue===1)return oe[0];const ee=function(re,Ee){for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++)if(oe[Pe](re,Ee))return Z;return null},ve=oe.find(re=>!!re.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const we=oe.reduce((re,Ee)=>Ee.allPaths?re.concat(Ee.allPaths):re,[]);return we.length&&(ee.allPaths=we),ee}function T(Z,le,oe){const ue=_.sep===_.posix.sep,ee=ue?Z:Z.replace(m,_.sep),ve=_.sep+ee,we=_.posix.sep+Z;let re;return oe?re=function(Ee,Pe){return typeof Ee=="string"&&(Ee===ee||Ee.endsWith(ve)||!ue&&(Ee===Z||Ee.endsWith(we)))?le:null}:re=function(Ee,Pe){return typeof Ee=="string"&&(Ee===ee||!ue&&Ee===Z)?le:null},re.allPaths=[(oe?"*/":"./")+Z],re}function U(Z){try{const le=new RegExp(`^${a(Z)}$`);return function(oe){return le.lastIndex=0,typeof oe=="string"&&le.test(oe)?Z:null}}catch{return n}}function j(Z,le,oe){return!Z||typeof le!="string"?!1:x(Z)(le,void 0,oe)}e.match=j;function x(Z,le={}){if(!Z)return u;if(typeof Z=="string"||C(Z)){const oe=r(Z,le);if(oe===n)return u;const ue=function(ee,ve){return!!oe(ee,ve)};return oe.allBasenames&&(ue.allBasenames=oe.allBasenames),oe.allPaths&&(ue.allPaths=oe.allPaths),ue}return L(Z,le)}e.parse=x;function C(Z){const le=Z;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}e.isRelativePattern=C;function z(Z){return Z.allBasenames||[]}e.getBasenameTerms=z;function N(Z){return Z.allPaths||[]}e.getPathTerms=N;function L(Z,le){const oe=W(Object.getOwnPropertyNames(Z).map(re=>q(re,Z[re],le)).filter(re=>re!==n)),ue=oe.length;if(!ue)return n;if(!oe.some(re=>!!re.requiresSiblings)){if(ue===1)return oe[0];const re=function(Fe,ze){let Qe;for(let Te=0,_e=oe.length;Te<_e;Te++){const ye=oe[Te](Fe,ze);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&(Qe||(Qe=[]),Qe.push(ye))}return Qe?(async()=>{for(const Te of Qe){const _e=await Te;if(typeof _e=="string")return _e}return null})():null},Ee=oe.find(Fe=>!!Fe.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const Pe=oe.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return Pe.length&&(re.allPaths=Pe),re}const ee=function(re,Ee,Pe){let Fe,ze;for(let Qe=0,Te=oe.length;Qe<Te;Qe++){const _e=oe[Qe];_e.requiresSiblings&&Pe&&(Ee||(Ee=(0,_.basename)(re)),Fe||(Fe=Ee.substr(0,Ee.length-(0,_.extname)(re).length)));const ye=_e(re,Ee,Fe,Pe);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&(ze||(ze=[]),ze.push(ye))}return ze?(async()=>{for(const Qe of ze){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},ve=oe.find(re=>!!re.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const we=oe.reduce((re,Ee)=>Ee.allPaths?re.concat(Ee.allPaths):re,[]);return we.length&&(ee.allPaths=we),ee}function q(Z,le,oe){if(le===!1)return n;const ue=r(Z,oe);if(ue===n)return n;if(typeof le=="boolean")return ue;if(le){const ee=le.when;if(typeof ee=="string"){const ve=(we,re,Ee,Pe)=>{if(!Pe||!ue(we,re))return null;const Fe=ee.replace("$(basename)",Ee),ze=Pe(Fe);return(0,y.isThenable)(ze)?ze.then(Qe=>Qe?Z:null):ze?Z:null};return ve.requiresSiblings=!0,ve}}return ue}function W(Z,le){const oe=Z.filter(re=>!!re.basenames);if(oe.length<2)return Z;const ue=oe.reduce((re,Ee)=>{const Pe=Ee.basenames;return Pe?re.concat(Pe):re},[]);let ee;if(le){ee=[];for(let re=0,Ee=ue.length;re<Ee;re++)ee.push(le)}else ee=oe.reduce((re,Ee)=>{const Pe=Ee.patterns;return Pe?re.concat(Pe):re},[]);const ve=function(re,Ee){if(typeof re!="string")return null;if(!Ee){let Fe;for(Fe=re.length;Fe>0;Fe--){const ze=re.charCodeAt(Fe-1);if(ze===47||ze===92)break}Ee=re.substr(Fe)}const Pe=ue.indexOf(Ee);return Pe!==-1?ee[Pe]:null};ve.basenames=ue,ve.patterns=ee,ve.allBasenames=ue;const we=Z.filter(re=>!re.basenames);return we.push(ve),we}function R(Z,le){return(0,o.equals)(Z,le,(oe,ue)=>typeof oe=="string"&&typeof ue=="string"?oe===ue:typeof oe!="string"&&typeof ue!="string"?oe.base===ue.base&&oe.pattern===ue.pattern:!1)}e.patternsEquals=R}),define(Ce[75],Ie([1,0,11,116,22,9,2]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",g=!1){if(this.value=d,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(d,g=0){return this.value+=m(this.supportThemeIcons?(0,y.escapeIcons)(d):d).replace(/([ \t]+)/g,(A,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,g){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(d,g,A){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(d),")"),A&&(this.value+=` "${this._escape(this._escape(A,'"'),")")}"`),this.value+=")",this}_escape(d,g){const A=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return d.replace(A,(c,v)=>d.charAt(v-1)!=="\\"?`\\${c}`:c)}}e.MarkdownString=E;function k(h){return O(h)?!h.value:Array.isArray(h)?h.every(k):!0}e.isEmptyMarkdownString=k;function O(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(h,d){return h===d?!0:!h||!d?!1:h.value===d.value&&h.isTrusted===d.isTrusted&&h.supportThemeIcons===d.supportThemeIcons&&h.supportHtml===d.supportHtml&&(h.baseUri===d.baseUri||!!h.baseUri&&!!d.baseUri&&(0,b.isEqual)(_.URI.from(h.baseUri),_.URI.from(d.baseUri)))}e.markdownStringEqual=w;function m(h){return h.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function I(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function f(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function a(h){const d=[],g=h.split("|").map(c=>c.trim());h=g[0];const A=g[1];if(A){const c=/height=(\d+)/.exec(A),v=/width=(\d+)/.exec(A),t=c?c[1]:"",u=v?v[1]:"",n=isFinite(parseInt(u)),r=isFinite(parseInt(t));n&&d.push(`width="${u}"`),r&&d.push(`height="${t}"`)}return{href:h,dimensions:d}}e.parseHrefAndDimensions=a}),define(Ce[76],Ie([1,0,16,37,19,21,22,9]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,r){const{os:s,tildify:i,relative:l}=r;if(l){const T=k(n,l,s);if(typeof T=="string")return T}let S=n.fsPath;if(s===1&&!M.isWindows?S=S.replace(/\//g,"\\"):s!==1&&M.isWindows&&(S=S.replace(/\\/g,"/")),s!==1&&i?.userHome){const T=i.userHome.fsPath;let U;n.scheme!==i.userHome.scheme&&n.path.startsWith(b.posix.sep)?U=i.userHome.with({path:n.path}).fsPath:U=n.fsPath,S=m(U,T,s)}return(s===1?b.win32:b.posix).normalize(O(S,s===1))}e.getPathLabel=E;function k(n,r,s){const i=s===1?b.win32:b.posix,l=s===3?_.extUri:_.extUriIgnorePathCase,S=r.getWorkspace(),p=(0,o.firstOrDefault)(S.folders);if(!p)return;n.scheme!==p.uri.scheme&&n.path.startsWith(b.posix.sep)&&(n=p.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let U;if(l.isEqual(T.uri,n)?U="":U=l.relativePath(T.uri,n)??"",U&&(U=i.normalize(U)),S.folders.length>1&&!r.noPrefix){const j=T.name?T.name:l.basenameOrAuthority(T.uri);U=U?`${j} \u2022 ${U}`:j}return U}function O(n,r=M.isWindows){return(0,y.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=O;let w=Object.create(null);function m(n,r,s=M.OS){if(s===1||!n||!r)return n;let i=w.original===r?w.normalized:void 0;i||(i=r,M.isWindows&&(i=(0,y.toSlashes)(i)),i=`${(0,P.rtrim)(i,b.posix.sep)}${b.posix.sep}`,w={original:r,normalized:i});let l=n;return M.isWindows&&(l=(0,y.toSlashes)(l)),(s===3?l.startsWith(i):(0,P.startsWithIgnoreCase)(l,i))?`~/${l.substr(i.length)}`:n}e.tildify=m;function I(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=I;const f="\u2026",a="\\\\",h="~";function d(n,r=b.sep){const s=new Array(n.length);let i=!1;for(let l=0;l<n.length;l++){const S=n[l];if(S===""){s[l]=`.${r}`;continue}if(!S){s[l]=S;continue}i=!0;let p="",T=S;T.indexOf(a)===0?(p=T.substr(0,T.indexOf(a)+a.length),T=T.substr(T.indexOf(a)+a.length)):T.indexOf(r)===0?(p=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(h)===0&&(p=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length));const U=T.split(r);for(let j=1;i&&j<=U.length;j++)for(let x=U.length-j;i&&x>=0;x--){i=!1;let C=U.slice(x,x+j).join(r);for(let z=0;!i&&z<n.length;z++)if(z!==l&&n[z]&&n[z].indexOf(C)>-1){const N=x+j===U.length,L=x>0&&n[z].indexOf(r)>-1?r+C:C,q=n[z].endsWith(L);i=!N||q}if(!i){let z="";(U[0].endsWith(":")||p!=="")&&(x===1&&(x=0,j++,C=U[0]+r+C),x>0&&(z=U[0]+r),z=p+z),x>0&&(z=z+f+r),z=z+C,x+j<U.length&&(z=z+r+f),s[l]=z}}i&&(s[l]=S)}return s}e.shorten=d;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function A(n,r=Object.create(null)){const s=[];let i=!1,l="";for(const S of n)if(S==="$"||i&&S==="{")l&&s.push({value:l,type:g.TEXT}),l="",i=!0;else if(S==="}"&&i){const p=r[l];if(typeof p=="string")p.length&&s.push({value:p,type:g.VARIABLE});else if(p){const T=s[s.length-1];(!T||T.type!==g.SEPARATOR)&&s.push({value:p.label,type:g.SEPARATOR})}l="",i=!1}else l+=S;return l&&!i&&s.push({value:l,type:g.TEXT}),s.filter((S,p)=>{if(S.type===g.SEPARATOR){const T=s[p-1],U=s[p+1];return[T,U].every(j=>j&&(j.type===g.VARIABLE||j.type===g.TEXT)&&j.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=A;function c(n,r){return M.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function v(n,r){return M.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function u(n){const r=n.indexOf("/")!==-1?b.posix:b.win32,s=r.basename(n),i=r.dirname(n);return s.length?{name:s,parentPath:i}:{name:i,parentPath:""}}e.splitName=u}),define(Ce[119],Ie([1,0,2]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(O){return O.toJSON()}class b{constructor(w){this._uriTransformer=w}transformIncoming(w){const m=this._uriTransformer.transformIncoming(w);return m===w?w:y(o.URI.from(m))}transformOutgoing(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:y(o.URI.from(m))}transformOutgoingURI(w){const m=this._uriTransformer.transformOutgoing(w);return m===w?w:o.URI.from(m)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,w,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof o.URI)return w.transformOutgoing(O);for(const I in O)if(Object.hasOwnProperty.call(O,I)){const f=M(O[I],w,m+1);f!==null&&(O[I]=f)}}return null}function _(O,w){const m=M(O,w,0);return m===null?O:m}e.transformOutgoingURIs=_;function P(O,w,m,I){if(!O||I>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?o.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const a=P(O[f],w,m,I+1);a!==null&&(O[f]=a)}}return null}function E(O,w){const m=P(O,w,!1,0);return m===null?O:m}e.transformIncomingURIs=E;function k(O,w){const m=P(O,w,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(Ce[120],Ie([1,0,34,19]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(M,_,P,E,k,O){if(Array.isArray(M)){let w=0;for(const m of M){const I=b(m,_,P,E,k,O);if(I===10)return I;I>w&&(w=I)}return w}else{if(typeof M=="string")return E?M==="*"?5:M===P?10:0:0;if(M){const{language:w,pattern:m,scheme:I,hasAccessToAllModels:f,notebookType:a}=M;if(!E&&!f)return 0;a&&k&&(_=k);let h=0;if(I)if(I===_.scheme)h=10;else if(I==="*")h=5;else return 0;if(w)if(w===P)h=10;else if(w==="*")h=Math.max(h,5);else return 0;if(a)if(a===O)h=10;else if(a==="*"&&O!==void 0)h=Math.max(h,5);else return 0;if(m){let d;if(typeof m=="string"?d=m:d={...m,base:(0,y.normalize)(m.base)},d===_.fsPath||(0,o.match)(d,_.fsPath))h=10;else return 0}return h}else return 0}}e.score=b}),define(Ce[77],Ie([1,0,23,21]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(b||(b={}));function M(w){for(let m=0,I=w.length;m<I;m+=4){const f=w[m+0],a=w[m+1],h=w[m+2],d=w[m+3];w[m+0]=d,w[m+1]=h,w[m+2]=a,w[m+3]=f}}function _(w){const m=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return y.isLittleEndian()||M(m),o.VSBuffer.wrap(m)}function P(w){const m=w.buffer;if(y.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const I=new Uint8Array(m.byteLength);return I.set(m),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function E(w){const m=new Uint32Array(k(w));let I=0;if(m[I++]=w.id,w.type==="full")m[I++]=1,m[I++]=w.data.length,m.set(w.data,I),I+=w.data.length;else{m[I++]=2,m[I++]=w.deltas.length;for(const f of w.deltas)m[I++]=f.start,m[I++]=f.deleteCount,f.data?(m[I++]=f.data.length,m.set(f.data,I),I+=f.data.length):m[I++]=0}return _(m)}e.encodeSemanticTokensDto=E;function k(w){let m=0;if(m+=1+1,w.type==="full")m+=1+w.data.length;else{m+=1,m+=(1+1+1)*w.deltas.length;for(const I of w.deltas)I.data&&(m+=I.data.length)}return m}function O(w){const m=P(w);let I=0;const f=m[I++];if(m[I++]===1){const g=m[I++],A=m.subarray(I,I+g);return I+=g,{id:f,type:"full",data:A}}const h=m[I++],d=[];for(let g=0;g<h;g++){const A=m[I++],c=m[I++],v=m[I++];let t;v>0&&(t=m.subarray(I,I+v),I+=v),d[g]={start:A,deleteCount:c,data:t}}return{id:f,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ce[121],Ie([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,21,123,16,26,110]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return I(X,fe)}compute(X,fe,Ue){return Ue}}class m{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=m;function I(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new m(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const Ue=Array.isArray(G)&&Array.isArray(X)&&M.equals(G,X);return new m(X,!Ue)}let fe=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const He=I(G[Ue],X[Ue]);He.didChange&&(G[Ue]=He.newValue,fe=!0)}return new m(G,fe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return I(X,fe)}validate(X){return this.defaultValue}}class a{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return I(X,fe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,fe,Ue){return Ue}}function h(G,X){return typeof G>"u"?X:G==="false"?!1:Boolean(G)}e.boolean=h;class d extends a{constructor(X,fe,Ue,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Ue),super(X,fe,Ue,He)}validate(X){return h(X,this.defaultValue)}}function g(G,X,fe,Ue){if(typeof G>"u")return X;let He=parseInt(G,10);return isNaN(He)?X:(He=Math.max(fe,He),He=Math.min(Ue,He),He|0)}e.clampedInt=g;class A extends a{constructor(X,fe,Ue,He,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=He,Ke.maximum=Ze),super(X,fe,Ue,Ke),this.minimum=He,this.maximum=Ze}static clampedInt(X,fe,Ue,He){return g(X,fe,Ue,He)}validate(X){return A.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class c extends a{constructor(X,fe,Ue,He,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(X,fe,Ue,Ze),this.validationFn=He}static clamp(X,fe,Ue){return X<fe?fe:X>Ue?Ue:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X>"u")return fe;const Ue=parseFloat(X);return isNaN(Ue)?fe:Ue}validate(X){return this.validationFn(c.float(X,this.defaultValue))}}class v extends a{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Ue,He=void 0){typeof He<"u"&&(He.type="string",He.default=Ue),super(X,fe,Ue,He)}validate(X){return v.string(X,this.defaultValue)}}function t(G,X,fe){return typeof G!="string"||fe.indexOf(G)===-1?X:G}e.stringSet=t;class u extends a{constructor(X,fe,Ue,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=He,Ze.default=Ue),super(X,fe,Ue,Ze),this._allowedValues=He}validate(X){return t(X,this.defaultValue,this._allowedValues)}}class n extends w{constructor(X,fe,Ue,He,Ze,Ke,We=void 0){typeof We<"u"&&(We.type="string",We.enum=Ze,We.default=He),super(X,fe,Ue,We),this._allowedValues=Ze,this._convert=Ke}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function r(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Ue){return Ue===0?X.accessibilitySupport:Ue}}class i extends w{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:o.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:h(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function S(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(G){switch(G){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function U(G){switch(G){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class j extends f{constructor(){super(130)}compute(X,fe,Ue){const He=["monaco-editor"];return fe.get(34)&&He.push(fe.get(34)),X.extraEditorClassName&&He.push(X.extraEditorClassName),fe.get(67)==="default"?He.push("mouse-default"):fe.get(67)==="copy"&&He.push("mouse-copy"),fe.get(101)&&He.push("showUnused"),fe.get(128)&&He.push("showDeprecated"),He.join(" ")}}class x extends d{constructor(){super(33,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(X,fe,Ue){return Ue&&X.emptySelectionClipboard}}class C extends w{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:o.localize(16,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:o.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:h(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(fe.loop,this.defaultValue.loop)}}}class z extends w{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.ON:X:Boolean(X)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class N extends f{constructor(){super(45)}compute(X,fe,Ue){return X.fontInfo}}class L extends a{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(X){const fe=c.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(fe,6,100)}compute(X,fe,Ue){return X.fontInfo.fontSize}}class q extends w{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:q.MINIMUM_VALUE,maximum:q.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:q.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(A.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,q.MINIMUM_VALUE,q.MAXIMUM_VALUE))}}q.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],q.MINIMUM_VALUE=1,q.MAXIMUM_VALUE=1e3;class W extends w{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:o.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:t(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??t(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??t(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??t(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??t(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??t(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class R extends w{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:o.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),delay:A.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:h(fe.sticky,this.defaultValue.sticky),above:h(fe.above,this.defaultValue.above)}}}var Z;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(Z=e.RenderMinimap||(e.RenderMinimap={}));class le extends f{constructor(){super(133)}compute(X,fe,Ue){return le.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?fe-1:0,He=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),Ze=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:Ze}}static _computeMinimapLayout(X,fe){const Ue=X.outerWidth,He=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Ke=fe.stableMinimapLayoutInput,We=Ke&&X.outerHeight===Ke.outerHeight&&X.lineHeight===Ke.lineHeight&&X.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ke.pixelRatio&&X.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&X.minimap.enabled===Ke.minimap.enabled&&X.minimap.side===Ke.minimap.side&&X.minimap.size===Ke.minimap.size&&X.minimap.showSlider===Ke.minimap.showSlider&&X.minimap.renderCharacters===Ke.minimap.renderCharacters&&X.minimap.maxColumn===Ke.minimap.maxColumn&&X.minimap.scale===Ke.minimap.scale&&X.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&X.isViewportWrapping===Ke.isViewportWrapping,it=X.lineHeight,st=X.typicalHalfwidthCharacterWidth,dt=X.scrollBeyondLastLine,at=X.minimap.renderCharacters;let rt=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const _t=X.minimap.maxColumn,Ot=X.minimap.size,Ft=X.minimap.side,mt=X.verticalScrollbarWidth,yt=X.viewLineCount,Nt=X.remainingWidth,Ut=X.isViewportWrapping,Ve=at?2:3;let Mt=Math.floor(Ze*He);const Pt=Mt/Ze;let At=!1,pt=!1,Dt=Ve*rt,Se=rt/Ze,De=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeyondLastLine:ct,desiredRatio:Ct,minimapLineCount:Et}=le.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:dt,height:He,lineHeight:it,pixelRatio:Ze});if(yt/Et>1)At=!0,pt=!0,rt=1,Dt=1,Se=rt/Ze;else{let bt=!1,ft=rt+1;if(Ot==="fit"){const It=Math.ceil((yt+ct)*Dt);Ut&&We&&Nt<=fe.stableFitRemainingWidth?(bt=!0,ft=fe.stableFitMaxMinimapScale):bt=It>Mt}if(Ot==="fill"||bt){At=!0;const It=rt;Dt=Math.min(it*Ze,Math.max(1,Math.floor(1/Ct))),Ut&&We&&Nt<=fe.stableFitRemainingWidth&&(ft=fe.stableFitMaxMinimapScale),rt=Math.min(ft,Math.max(1,Math.floor(Dt/Ve))),rt>It&&(De=Math.min(2,rt/It)),Se=rt/Ze/De,Mt=Math.ceil(Math.max(Xe,yt+ct)*Dt),Ut?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=Nt,fe.stableFitMaxMinimapScale=rt):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(_t*Se),K=Math.min(me,Math.max(0,Math.floor((Nt-mt-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*K);const Le=Ae/Ze;Ae=Math.floor(Ae*De);const et=at?1:2,je=Ft==="left"?0:Ue-K-mt;return{renderMinimap:et,minimapLeft:je,minimapWidth:K,minimapHeightIsEditorHeight:At,minimapIsSampling:pt,minimapScale:rt,minimapLineHeight:Dt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Pt}}static computeLayout(X,fe){const Ue=fe.outerWidth|0,He=fe.outerHeight|0,Ze=fe.lineHeight|0,Ke=fe.lineNumbersDigitCount|0,We=fe.typicalHalfwidthCharacterWidth,it=fe.maxDigitWidth,st=fe.pixelRatio,dt=fe.viewLineCount,at=X.get(125),rt=at==="inherit"?X.get(124):at,_t=rt==="inherit"?X.get(120):rt,Ot=X.get(123),Ft=X.get(2),mt=fe.isDominatedByLongLines,yt=X.get(51),Nt=X.get(61).renderType!==0,Ut=X.get(62),Ve=X.get(95),Mt=X.get(66),Pt=X.get(93),At=Pt.verticalScrollbarSize,pt=Pt.verticalHasArrows,Dt=Pt.arrowSize,Se=Pt.horizontalScrollbarSize,De=X.get(59),me=X.get(38),K=X.get(100)!=="never";let Ae;if(typeof De=="string"&&/^\d+(\.\d+)?ch$/.test(De)){const Ht=parseFloat(De.substr(0,De.length-2));Ae=A.clampedInt(Ht*We,0,0,1e3)}else Ae=A.clampedInt(De,0,0,1e3);me&&K&&(Ae+=16);let Le=0;if(Nt){const Ht=Math.max(Ke,Ut);Le=Math.round(Ht*it)}let et=0;yt&&(et=Ze);let je=0,Xe=je+et,ct=Xe+Le,Ct=ct+Ae;const Et=Ue-et-Le-Ae;let St=!1,bt=!1,ft=-1;Ft!==2&&(rt==="inherit"&&mt?(St=!0,bt=!0):_t==="on"||_t==="bounded"?bt=!0:_t==="wordWrapColumn"&&(ft=Ot));const It=le._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:Ze,typicalHalfwidthCharacterWidth:We,pixelRatio:st,scrollBeyondLastLine:Ve,minimap:Mt,verticalScrollbarWidth:At,viewLineCount:dt,remainingWidth:Et,isViewportWrapping:bt},fe.memory||new O);It.renderMinimap!==0&&It.minimapLeft===0&&(je+=It.minimapWidth,Xe+=It.minimapWidth,ct+=It.minimapWidth,Ct+=It.minimapWidth);const Qt=Et-It.minimapWidth,vt=Math.max(1,Math.floor((Qt-At-2)/We)),qt=pt?Dt:0;return bt&&(ft=Math.max(1,vt),_t==="bounded"&&(ft=Math.min(ft,Ot))),{width:Ue,height:He,glyphMarginLeft:je,glyphMarginWidth:et,lineNumbersLeft:Xe,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:Ct,contentWidth:Qt,minimap:It,viewportColumn:vt,isWordWrapMinified:St,isViewportWrapping:bt,wrappingColumn:ft,verticalScrollbarWidth:At,horizontalScrollbarHeight:Se,overviewRuler:{top:qt,width:At,height:He-2*qt,right:0}}}}e.EditorLayoutInfoComputer=le;class oe extends w{constructor(){const X={enabled:!0};super(58,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:o.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class ue extends w{constructor(){const X={enabled:!1,maxLineCount:5};super(105,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:o.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:o.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),maxLineCount:A.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ee extends w{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:o.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(47,null),o.localize(48,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(49,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:o.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:o.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:o.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:t(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:A.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(fe.fontFamily,this.defaultValue.fontFamily),padding:h(fe.padding,this.defaultValue.padding)}}}class ve extends c{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>c.clamp(X,0,150),{markdownDescription:o.localize(54,null)})}compute(X,fe,Ue){return X.fontInfo.lineHeight}}class we extends w{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:o.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:o.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(57,null),o.localize(58,null),o.localize(59,null)],default:X.size,description:o.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:o.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:o.localize(62,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:o.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:o.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),autohide:h(fe.autohide,this.defaultValue.autohide),size:t(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(fe.side,this.defaultValue.side,["right","left"]),showSlider:t(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(fe.renderCharacters,this.defaultValue.renderCharacters),scale:A.clampedInt(fe.scale,1,1,3),maxColumn:A.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(G){return G==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ee extends w{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(67,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:A.clampedInt(fe.top,0,0,1e3),bottom:A.clampedInt(fe.bottom,0,0,1e3)}}}class Pe extends w{constructor(){const X={enabled:!0,cycle:!1};super(77,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:o.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:o.localize(69,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),cycle:h(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,fe,Ue){return X.pixelRatio}}class ze extends w{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(70,null),o.localize(71,null),o.localize(72,null)]}];super(80,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:o.localize(73,null)},comments:{anyOf:fe,default:X.comments,description:o.localize(74,null)},other:{anyOf:fe,default:X.other,description:o.localize(75,null)}},default:X,markdownDescription:o.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const st=X?"on":"off";return{comments:st,strings:st,other:st}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:He}=X,Ze=["on","inline","off"];let Ke,We,it;return typeof fe=="boolean"?Ke=fe?"on":"off":Ke=t(fe,this.defaultValue.other,Ze),typeof Ue=="boolean"?We=Ue?"on":"off":We=t(Ue,this.defaultValue.comments,Ze),typeof He=="boolean"?it=He?"on":"off":it=t(He,this.defaultValue.strings,Ze),{other:Ke,comments:We,strings:it}}}var Qe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends w{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(77,null),o.localize(78,null),o.localize(79,null),o.localize(80,null)],default:"on",description:o.localize(81,null)})}validate(X){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(fe=4,Ue=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function _e(G){const X=G.get(88);return X==="editable"?G.get(82):X!=="on"}e.filterValidationDecorations=_e;class ye extends w{constructor(){const X=[],fe={type:"number",description:o.localize(82,null)};super(92,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:o.localize(83,null),format:"color-hex"}}}]},default:X,description:o.localize(84,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Ue of X)if(typeof Ue=="number")fe.push({column:A.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;fe.push({column:A.clampedInt(He.column,0,0,1e4),color:He.color})}return fe.sort((Ue,He)=>Ue.column-He.column),fe}return this.defaultValue}}function ae(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ce extends w{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(85,null),o.localize(86,null),o.localize(87,null)],default:"auto",description:o.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(89,null),o.localize(90,null),o.localize(91,null)],default:"auto",description:o.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:o.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:o.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:o.localize(95,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Ue=A.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=A.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:A.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:h(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:A.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:A.clampedInt(fe.verticalSliderSize,He,0,1e3),scrollByPage:h(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends w{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:o.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:o.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:o.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:o.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:o.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:o.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:o.localize(102,null)}})}applyUpdate(X,fe){let Ue=!1;fe.allowedCharacters&&X&&(_.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&X&&(_.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Ue=!0));const He=super.applyUpdate(X,fe);return Ue?new m(He.newValue,!0):He}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:H(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,fe){if(typeof X!="object"||!X)return fe;const Ue={};for(const[He,Ze]of Object.entries(X))Ze===!0&&(Ue[He]=!0);return Ue}}class J extends w{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:o.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),mode:t(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class D extends w{constructor(){const X={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:o.localize(105,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:h(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends w{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(106,null),o.localize(107,null),o.localize(108,null)],default:X.bracketPairs,description:o.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(110,null),o.localize(111,null),o.localize(112,null)],default:X.bracketPairsHorizontal,description:o.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:o.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:o.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(116,null),o.localize(117,null),o.localize(118,null)],default:X.highlightActiveIndentation,description:o.localize(119,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:H(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(G,X,fe){const Ue=fe.indexOf(G);return Ue===-1?X:fe[Ue]}class V extends w{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(120,null),o.localize(121,null)],default:X.insertMode,description:o.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:o.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:o.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:o.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:o.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:o.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:o.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:o.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:o.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:t(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(fe.showIcons,this.defaultValue.showIcons),showStatusBar:h(fe.showStatusBar,this.defaultValue.showStatusBar),preview:h(fe.preview,this.defaultValue.preview),previewMode:t(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(fe.showMethods,this.defaultValue.showMethods),showFunctions:h(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:h(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(fe.showFields,this.defaultValue.showFields),showVariables:h(fe.showVariables,this.defaultValue.showVariables),showClasses:h(fe.showClasses,this.defaultValue.showClasses),showStructs:h(fe.showStructs,this.defaultValue.showStructs),showInterfaces:h(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:h(fe.showModules,this.defaultValue.showModules),showProperties:h(fe.showProperties,this.defaultValue.showProperties),showEvents:h(fe.showEvents,this.defaultValue.showEvents),showOperators:h(fe.showOperators,this.defaultValue.showOperators),showUnits:h(fe.showUnits,this.defaultValue.showUnits),showValues:h(fe.showValues,this.defaultValue.showValues),showConstants:h(fe.showConstants,this.defaultValue.showConstants),showEnums:h(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:h(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(fe.showKeywords,this.defaultValue.showKeywords),showWords:h(fe.showWords,this.defaultValue.showWords),showColors:h(fe.showColors,this.defaultValue.showColors),showFiles:h(fe.showFiles,this.defaultValue.showFiles),showReferences:h(fe.showReferences,this.defaultValue.showReferences),showFolders:h(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:h(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(fe.showSnippets,this.defaultValue.showSnippets),showUsers:h(fe.showUsers,this.defaultValue.showUsers),showIssues:h(fe.showIssues,this.defaultValue.showIssues)}}}class te extends w{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(163,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends f{constructor(){super(132)}compute(X,fe,Ue){return fe.get(82)?!0:X.tabFocusMode}}var Y;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function pe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,fe,Ue){const He=fe.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ne extends w{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(164,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Ye:y.isLinux?Ge:Be,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.extraEditorClassName=34]="extraEditorClassName",G[G.fastScrollSensitivity=35]="fastScrollSensitivity",G[G.find=36]="find",G[G.fixedOverflowWidgets=37]="fixedOverflowWidgets",G[G.folding=38]="folding",G[G.foldingStrategy=39]="foldingStrategy",G[G.foldingHighlight=40]="foldingHighlight",G[G.foldingImportsByDefault=41]="foldingImportsByDefault",G[G.foldingMaximumRegions=42]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=44]="fontFamily",G[G.fontInfo=45]="fontInfo",G[G.fontLigatures=46]="fontLigatures",G[G.fontSize=47]="fontSize",G[G.fontWeight=48]="fontWeight",G[G.formatOnPaste=49]="formatOnPaste",G[G.formatOnType=50]="formatOnType",G[G.glyphMargin=51]="glyphMargin",G[G.gotoLocation=52]="gotoLocation",G[G.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",G[G.hover=54]="hover",G[G.inDiffEditor=55]="inDiffEditor",G[G.inlineSuggest=56]="inlineSuggest",G[G.letterSpacing=57]="letterSpacing",G[G.lightbulb=58]="lightbulb",G[G.lineDecorationsWidth=59]="lineDecorationsWidth",G[G.lineHeight=60]="lineHeight",G[G.lineNumbers=61]="lineNumbers",G[G.lineNumbersMinChars=62]="lineNumbersMinChars",G[G.linkedEditing=63]="linkedEditing",G[G.links=64]="links",G[G.matchBrackets=65]="matchBrackets",G[G.minimap=66]="minimap",G[G.mouseStyle=67]="mouseStyle",G[G.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=69]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",G[G.multiCursorModifier=71]="multiCursorModifier",G[G.multiCursorPaste=72]="multiCursorPaste",G[G.occurrencesHighlight=73]="occurrencesHighlight",G[G.overviewRulerBorder=74]="overviewRulerBorder",G[G.overviewRulerLanes=75]="overviewRulerLanes",G[G.padding=76]="padding",G[G.parameterHints=77]="parameterHints",G[G.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",G[G.quickSuggestions=80]="quickSuggestions",G[G.quickSuggestionsDelay=81]="quickSuggestionsDelay",G[G.readOnly=82]="readOnly",G[G.renameOnType=83]="renameOnType",G[G.renderControlCharacters=84]="renderControlCharacters",G[G.renderFinalNewline=85]="renderFinalNewline",G[G.renderLineHighlight=86]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=88]="renderValidationDecorations",G[G.renderWhitespace=89]="renderWhitespace",G[G.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",G[G.roundedSelection=91]="roundedSelection",G[G.rulers=92]="rulers",G[G.scrollbar=93]="scrollbar",G[G.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=95]="scrollBeyondLastLine",G[G.scrollPredominantAxis=96]="scrollPredominantAxis",G[G.selectionClipboard=97]="selectionClipboard",G[G.selectionHighlight=98]="selectionHighlight",G[G.selectOnLineNumbers=99]="selectOnLineNumbers",G[G.showFoldingControls=100]="showFoldingControls",G[G.showUnused=101]="showUnused",G[G.snippetSuggestions=102]="snippetSuggestions",G[G.smartSelect=103]="smartSelect",G[G.smoothScrolling=104]="smoothScrolling",G[G.stickyScroll=105]="stickyScroll",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(165,null)})),acceptSuggestionOnEnter:ke(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(166,null),""],markdownDescription:o.localize(167,null)})),accessibilitySupport:ke(new s),accessibilityPageSize:ke(new A(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(168,null)})),ariaLabel:ke(new v(4,"ariaLabel",o.localize(169,null))),autoClosingBrackets:ke(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(170,null),o.localize(171,null),""],description:o.localize(172,null)})),autoClosingDelete:ke(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(173,null),""],description:o.localize(174,null)})),autoClosingOvertype:ke(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(175,null),""],description:o.localize(176,null)})),autoClosingQuotes:ke(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(177,null),o.localize(178,null),""],description:o.localize(179,null)})),autoIndent:ke(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[o.localize(180,null),o.localize(181,null),o.localize(182,null),o.localize(183,null),o.localize(184,null)],description:o.localize(185,null)})),automaticLayout:ke(new d(10,"automaticLayout",!1)),autoSurround:ke(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(186,null),o.localize(187,null),o.localize(188,null),""],description:o.localize(189,null)})),bracketPairColorization:ke(new D),bracketPairGuides:ke(new B),stickyTabStops:ke(new d(106,"stickyTabStops",!1,{description:o.localize(190,null)})),codeLens:ke(new d(14,"codeLens",!0,{description:o.localize(191,null)})),codeLensFontFamily:ke(new v(15,"codeLensFontFamily","",{description:o.localize(192,null)})),codeLensFontSize:ke(new A(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(193,null)})),colorDecorators:ke(new d(17,"colorDecorators",!0,{description:o.localize(194,null)})),columnSelection:ke(new d(18,"columnSelection",!1,{description:o.localize(195,null)})),comments:ke(new i),contextmenu:ke(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new d(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(196,null)})),cursorBlinking:ke(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],S,{description:o.localize(197,null)})),cursorSmoothCaretAnimation:ke(new d(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(198,null)})),cursorStyle:ke(new n(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:o.localize(199,null)})),cursorSurroundingLines:ke(new A(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(200,null)})),cursorSurroundingLinesStyle:ke(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(201,null),o.localize(202,null)],description:o.localize(203,null)})),cursorWidth:ke(new A(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(204,null)})),disableLayerHinting:ke(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new d(30,"domReadOnly",!1)),dragAndDrop:ke(new d(31,"dragAndDrop",!0,{description:o.localize(205,null)})),emptySelectionClipboard:ke(new x),dropIntoEditor:ke(new Ne),stickyScroll:ke(new ue),extraEditorClassName:ke(new v(34,"extraEditorClassName","")),fastScrollSensitivity:ke(new c(35,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:o.localize(206,null)})),find:ke(new C),fixedOverflowWidgets:ke(new d(37,"fixedOverflowWidgets",!1)),folding:ke(new d(38,"folding",!0,{description:o.localize(207,null)})),foldingStrategy:ke(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(208,null),o.localize(209,null)],description:o.localize(210,null)})),foldingHighlight:ke(new d(40,"foldingHighlight",!0,{description:o.localize(211,null)})),foldingImportsByDefault:ke(new d(41,"foldingImportsByDefault",!1,{description:o.localize(212,null)})),foldingMaximumRegions:ke(new A(42,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(213,null)})),unfoldOnClickAfterEndOfLine:ke(new d(43,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(214,null)})),fontFamily:ke(new v(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(215,null)})),fontInfo:ke(new N),fontLigatures2:ke(new z),fontSize:ke(new L),fontWeight:ke(new q),formatOnPaste:ke(new d(49,"formatOnPaste",!1,{description:o.localize(216,null)})),formatOnType:ke(new d(50,"formatOnType",!1,{description:o.localize(217,null)})),glyphMargin:ke(new d(51,"glyphMargin",!0,{description:o.localize(218,null)})),gotoLocation:ke(new W),hideCursorInOverviewRuler:ke(new d(53,"hideCursorInOverviewRuler",!1,{description:o.localize(219,null)})),hover:ke(new R),inDiffEditor:ke(new d(55,"inDiffEditor",!1)),letterSpacing:ke(new c(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>c.clamp(G,-5,20),{description:o.localize(220,null)})),lightbulb:ke(new oe),lineDecorationsWidth:ke(new a(59,"lineDecorationsWidth",10)),lineHeight:ke(new ve),lineNumbers:ke(new Te),lineNumbersMinChars:ke(new A(62,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new d(63,"linkedEditing",!1,{description:o.localize(221,null)})),links:ke(new d(64,"links",!0,{description:o.localize(222,null)})),matchBrackets:ke(new u(65,"matchBrackets","always",["always","near","never"],{description:o.localize(223,null)})),minimap:ke(new we),mouseStyle:ke(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new c(68,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:o.localize(224,null)})),mouseWheelZoom:ke(new d(69,"mouseWheelZoom",!1,{markdownDescription:o.localize(225,null)})),multiCursorMergeOverlapping:ke(new d(70,"multiCursorMergeOverlapping",!0,{description:o.localize(226,null)})),multiCursorModifier:ke(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[o.localize(227,null),o.localize(228,null)],markdownDescription:o.localize(229,null)})),multiCursorPaste:ke(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(230,null),o.localize(231,null)],markdownDescription:o.localize(232,null)})),occurrencesHighlight:ke(new d(73,"occurrencesHighlight",!0,{description:o.localize(233,null)})),overviewRulerBorder:ke(new d(74,"overviewRulerBorder",!0,{description:o.localize(234,null)})),overviewRulerLanes:ke(new A(75,"overviewRulerLanes",3,0,3)),padding:ke(new Ee),parameterHints:ke(new Pe),peekWidgetDefaultFocus:ke(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(235,null),o.localize(236,null)],description:o.localize(237,null)})),definitionLinkOpensInPeek:ke(new d(79,"definitionLinkOpensInPeek",!1,{description:o.localize(238,null)})),quickSuggestions:ke(new ze),quickSuggestionsDelay:ke(new A(81,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(239,null)})),readOnly:ke(new d(82,"readOnly",!1)),renameOnType:ke(new d(83,"renameOnType",!1,{description:o.localize(240,null),markdownDeprecationMessage:o.localize(241,null)})),renderControlCharacters:ke(new d(84,"renderControlCharacters",!0,{description:o.localize(242,null),restricted:!0})),renderFinalNewline:ke(new d(85,"renderFinalNewline",!0,{description:o.localize(243,null)})),renderLineHighlight:ke(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(244,null)],description:o.localize(245,null)})),renderLineHighlightOnlyWhenFocus:ke(new d(87,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(246,null)})),renderValidationDecorations:ke(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(247,null),o.localize(248,null),o.localize(249,null),""],description:o.localize(250,null)})),revealHorizontalRightPadding:ke(new A(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new d(91,"roundedSelection",!0,{description:o.localize(251,null)})),rulers:ke(new ye),scrollbar:ke(new ce),scrollBeyondLastColumn:ke(new A(94,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(252,null)})),scrollBeyondLastLine:ke(new d(95,"scrollBeyondLastLine",!0,{description:o.localize(253,null)})),scrollPredominantAxis:ke(new d(96,"scrollPredominantAxis",!0,{description:o.localize(254,null)})),selectionClipboard:ke(new d(97,"selectionClipboard",!0,{description:o.localize(255,null),included:y.isLinux})),selectionHighlight:ke(new d(98,"selectionHighlight",!0,{description:o.localize(256,null)})),selectOnLineNumbers:ke(new d(99,"selectOnLineNumbers",!0)),showFoldingControls:ke(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(257,null),o.localize(258,null),o.localize(259,null)],description:o.localize(260,null)})),showUnused:ke(new d(101,"showUnused",!0,{description:o.localize(261,null)})),showDeprecated:ke(new d(128,"showDeprecated",!0,{description:o.localize(262,null)})),inlayHints:ke(new ee),snippetSuggestions:ke(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(263,null),o.localize(264,null),o.localize(265,null),o.localize(266,null)],description:o.localize(267,null)})),smartSelect:ke(new te),smoothScrolling:ke(new d(104,"smoothScrolling",!1,{description:o.localize(268,null)})),stopRenderingLineAfter:ke(new A(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new V),inlineSuggest:ke(new J),suggestFontSize:ke(new A(109,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new A(110,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new d(111,"suggestOnTriggerCharacters",!0,{description:o.localize(271,null)})),suggestSelection:ke(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(272,null),o.localize(273,null),o.localize(274,null)],description:o.localize(275,null)})),tabCompletion:ke(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(276,null),o.localize(277,null),o.localize(278,null)],description:o.localize(279,null)})),tabIndex:ke(new A(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new Q),unusualLineTerminators:ke(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(280,null),o.localize(281,null),o.localize(282,null)],description:o.localize(283,null)})),useShadowDOM:ke(new d(117,"useShadowDOM",!0)),useTabStops:ke(new d(118,"useTabStops",!0,{description:o.localize(284,null)})),wordSeparators:ke(new v(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:o.localize(285,null)})),wordWrap:ke(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(286,null),o.localize(287,null),o.localize(288,null),o.localize(289,null)],description:o.localize(290,null)})),wordWrapBreakAfterCharacters:ke(new v(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new v(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new A(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(291,null)})),wordWrapOverride1:ke(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[o.localize(292,null),o.localize(293,null),o.localize(294,null),o.localize(295,null)],description:o.localize(296,null)})),wrappingStrategy:ke(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(297,null),o.localize(298,null)],description:o.localize(299,null)})),editorClassName:ke(new j),pixelRatio:ke(new Fe),tabFocusMode:ke(new de),layoutInfo:ke(new le),wrappingInfo:ke(new ge)}}),define(Ce[124],Ie([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,239]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||_.test(d)}e.isValidVersionStr=E;function k(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(_);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function O(d){if(!d)return null;const g=d.majorBase,A=d.majorMustEqual,c=d.minorBase;let v=d.minorMustEqual;const t=d.patchBase;let u=d.patchMustEqual;d.hasCaret&&(g===0||(v=!1),u=!1);let n=0;if(d.preRelease){const r=P.exec(d.preRelease);if(r){const[,s,i,l]=r;n=Date.UTC(Number(s),Number(i)-1,Number(l))}}return{majorBase:g,majorMustEqual:A,minorBase:c,minorMustEqual:v,patchBase:t,patchMustEqual:u,isMinimum:d.hasGreaterEquals,notBefore:n}}e.normalizeVersion=O;function w(d,g,A){let c;typeof d=="string"?c=O(k(d)):c=d;let v;g instanceof Date?v=g.getTime():typeof g=="string"&&(v=new Date(g).getTime());let t;if(typeof A=="string"?t=O(k(A)):t=A,!c||!t)return!1;const u=c.majorBase,n=c.minorBase,r=c.patchBase;let s=t.majorBase,i=t.minorBase,l=t.patchBase;const S=t.notBefore;let p=t.majorMustEqual,T=t.minorMustEqual,U=t.patchMustEqual;return t.isMinimum?u>s?!0:u<s?!1:n>i?!0:n<i||v&&v<S?!1:r>=l:(u===1&&s===0&&(!p||!T||!U)&&(s=1,i=0,l=0,p=!0,T=!1,U=!1),u<s?!1:u>s?!p:n<i?!1:n>i?!T:r<l?!1:r>l?!U:!(v&&v<S))}e.isValidVersion=w;function m(d,g,A,c,v){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([y.default.Error,b.localize(0,null)]),t;if(typeof c.name!="string")return t.push([y.default.Error,b.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([y.default.Error,b.localize(2,null,"version")]),t;if(!c.engines)return t.push([y.default.Error,b.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([y.default.Error,b.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!h(c.extensionDependencies))return t.push([y.default.Error,b.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!h(c.activationEvents))return t.push([y.default.Error,b.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([y.default.Error,b.localize(7,null,"activationEvents","main")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([y.default.Warning,b.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([y.default.Error,b.localize(9,null,"main")]),t;{const r=(0,o.joinPath)(A,c.main);(0,o.isEqualOrParent)(r,A)||t.push([y.default.Warning,b.localize(10,null,r.path,A.path)])}if(typeof c.activationEvents>"u")return t.push([y.default.Error,b.localize(11,null,"activationEvents","main")]),t}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([y.default.Error,b.localize(12,null,"browser")]),t;{const r=(0,o.joinPath)(A,c.browser);(0,o.isEqualOrParent)(r,A)||t.push([y.default.Warning,b.localize(13,null,r.path,A.path)])}if(typeof c.activationEvents>"u")return t.push([y.default.Error,b.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(c.version))return t.push([y.default.Error,b.localize(15,null)]),t;const u=[];if(!I(d,g,c,v,u))for(const r of u)t.push([y.default.Error,r]);return t}e.validateExtensionManifest=m;function I(d,g,A,c,v){return c||typeof A.main>"u"&&typeof A.browser>"u"?!0:a(d,g,A.engines.vscode,v)}e.isValidExtensionVersion=I;function f(d,g,A){return d==="*"||a(g,A,d)}e.isEngineValid=f;function a(d,g,A,c=[]){const v=O(k(A));if(!v)return c.push(b.localize(16,null,A)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(b.localize(17,null,A)),!1}else if(!v.majorMustEqual)return c.push(b.localize(18,null,A)),!1;return w(d,g,v)?!0:(c.push(b.localize(19,null,d,A)),!1)}function h(d){if(!Array.isArray(d))return!1;for(let g=0,A=d.length;g<A;g++)if(typeof d[g]!="string")return!1;return!0}}),define(Ce[78],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(b,M=[],_=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=o}),define(Ce[56],Ie([1,0,78]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const y=[];var b;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(b=e.InstantiationType||(e.InstantiationType={}));function M(P,E,k){E instanceof o.SyncDescriptor||(E=new o.SyncDescriptor(E,[],Boolean(k))),y.push([P,E])}e.registerSingleton=M;function _(){return y}e.getSingletonServiceDescriptors=_}),define(Ce[146],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(M,_){this.key=M,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class y{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const _ of this._nodes.values())_.outgoing.size===0&&M.push(_);return M}insertEdge(M,_){const P=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(_);P.outgoing.set(E.key,E),E.incoming.set(P.key,P)}removeNode(M){const _=this._hashFn(M);this._nodes.delete(_);for(const P of this._nodes.values())P.outgoing.delete(_),P.incoming.delete(_)}lookupOrInsertNode(M){const _=this._hashFn(M);let P=this._nodes.get(_);return P||(P=new o(_,M),this._nodes.set(_,P)),P}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[_,P]of this._nodes)M.push(`${_}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,_]of this._nodes){const P=new Set([M]),E=this._findCycle(_,P);if(E)return E}}_findCycle(M,_){for(const[P,E]of M.outgoing){if(_.has(P))return[..._,P].join(" -> ");_.add(P);const k=this._findCycle(E,_);if(k)return k;_.delete(P)}}}e.Graph=y}),define(Ce[3],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=P})(o=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function y(_,P,E){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:_,index:E}):(P[o.DI_DEPENDENCIES]=[{id:_,index:E}],P[o.DI_TARGET]=P)}function b(_){if(o.serviceIds.has(_))return o.serviceIds.get(_);const P=function(E,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(P,E,O)};return P.toString=()=>_,o.serviceIds.set(_,P),P}e.createDecorator=b;function M(_){return _}e.refineServiceDecorator=M}),define(Ce[57],Ie([1,0,10,2,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function M(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof y.URI)}e.isConfigurationOverrides=M;function _(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof y.URI)}e.isConfigurationUpdateOverrides=_;var P;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function k(d,g){const A=Object.create(null);for(const c in d)O(A,c,d[c],g);return A}e.toValuesTree=k;function O(d,g,A,c){const v=g.split("."),t=v.pop();let u=d;for(let n=0;n<v.length;n++){const r=v[n];let s=u[r];switch(typeof s){case"undefined":s=u[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${g} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[t]=A}catch{c(`Ignoring ${g} as ${v.join(".")} is ${JSON.stringify(u)}`)}else c(`Ignoring ${g} as ${v.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=O;function w(d,g){const A=g.split(".");m(d,A)}e.removeFromValueTree=w;function m(d,g){const A=g.shift();if(g.length===0){delete d[A];return}if(Object.keys(d).indexOf(A)!==-1){const c=d[A];typeof c=="object"&&!Array.isArray(c)&&(m(c,g),Object.keys(c).length===0&&delete d[A])}}function I(d,g,A){function c(u,n){let r=u;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const v=g.split("."),t=c(d,v);return typeof t>"u"?A:t}e.getConfigurationValue=I;function f(d,g,A){Object.keys(g).forEach(c=>{c!=="__proto__"&&(c in d?o.isObject(d[c])&&o.isObject(g[c])?f(d[c],g[c],A):A&&(d[c]=g[c]):d[c]=g[c])})}e.merge=f;function a(d,g,A){const c=d.inspect(g),v=d.inspect(A);return typeof c.userValue<"u"||typeof c.workspaceValue<"u"||typeof c.workspaceFolderValue<"u"?c.value:typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:c.defaultValue}e.getMigratedSettingValue=a;function h(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(Ce[38],Ie([1,0,21,9,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",o.isMacintosh),M.set("isLinux",o.isLinux),M.set("isWindows",o.isWindows),M.set("isWeb",o.isWeb),M.set("isMacNative",o.isMacintosh&&!o.isWeb),M.set("isEdge",o.isEdge),M.set("isFirefox",o.isFirefox),M.set("isChrome",o.isChrome),M.set("isSafari",o.isSafari);const _=Object.prototype.hasOwnProperty;var P;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(C){return I.create(C)}static equals(C,z){return f.create(C,z)}static notEquals(C,z){return d.create(C,z)}static regex(C,z){return n.create(C,z)}static in(C,z){return a.create(C,z)}static notIn(C,z){return h.create(C,z)}static not(C){return g.create(C)}static and(...C){return i.create(C,null)}static or(...C){return l.create(C,null,!0)}static greater(C,z){return c.create(C,z)}static greaterEquals(C,z){return v.create(C,z)}static smaller(C,z){return t.create(C,z)}static smallerEquals(C,z){return u.create(C,z)}static deserialize(C,z=!1){if(!!C)return this._deserializeOrExpression(C,z)}static _deserializeOrExpression(C,z){const N=C.split("||");return l.create(N.map(L=>this._deserializeAndExpression(L,z)),null,!0)}static _deserializeAndExpression(C,z){const N=C.split("&&");return i.create(N.map(L=>this._deserializeOne(L,z)),null)}static _deserializeOne(C,z){if(C=C.trim(),C.indexOf("!=")>=0){const N=C.split("!=");return d.create(N[0].trim(),this._deserializeValue(N[1],z))}if(C.indexOf("==")>=0){const N=C.split("==");return f.create(N[0].trim(),this._deserializeValue(N[1],z))}if(C.indexOf("=~")>=0){const N=C.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],z))}if(C.indexOf(" not in ")>=0){const N=C.split(" not in ");return h.create(N[0].trim(),N[1].trim())}if(C.indexOf(" in ")>=0){const N=C.split(" in ");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const N=C.split(">=");return v.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const N=C.split(">");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const N=C.split("<=");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const N=C.split("<");return t.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(C)?g.create(C.substr(1).trim()):I.create(C)}static _deserializeValue(C,z){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;const N=/^'([^']*)'$/.exec(C);return N?N[1].trim():C}static _deserializeRegexValue(C,z){if((0,y.isFalsyOrWhitespace)(C)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const N=C.indexOf("/"),L=C.lastIndexOf("/");if(N===L||N<0){if(z)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}const q=C.slice(N+1,L),W=C[L+1]==="i"?"i":"";try{return new RegExp(q,W)}catch(R){if(z)throw new Error(`bad regexp-value '${C}', parse error: ${R}`);return console.warn(`bad regexp-value '${C}', parse error: ${R}`),null}}}e.ContextKeyExpr=E;function k(x,C){const z=x?x.substituteConstants():void 0,N=C?C.substituteConstants():void 0;return!z&&!N?!0:!z||!N?!1:z.equals(N)}e.expressionsAreEqualWithConstantSubstitution=k;function O(x,C){return x.cmp(C)}class w{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class I{constructor(C,z){this.key=C,this.negated=z,this.type=2}static create(C,z=null){const N=M.get(C);return typeof N=="boolean"?N?m.INSTANCE:w.INSTANCE:new I(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?m.INSTANCE:w.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class f{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=4}static create(C,z,N=null){if(typeof z=="boolean")return z?I.create(C,N):g.create(C,N);const L=M.get(C);return typeof L=="boolean"?z===(L?"true":"false")?m.INSTANCE:w.INSTANCE:new f(C,z,N)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const z=C?"true":"false";return this.value===z?m.INSTANCE:w.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class a{constructor(C,z){this.key=C,this.valueKey=z,this.type=10,this.negated=null}static create(C,z){return new a(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const z=C.getValue(this.valueKey),N=C.getValue(this.key);return Array.isArray(z)?z.includes(N):typeof N=="string"&&typeof z=="object"&&z!==null?_.call(z,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=a;class h{constructor(C,z){this.key=C,this.valueKey=z,this.type=11,this._negated=a.create(C,z)}static create(C,z){return new h(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class d{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=5}static create(C,z,N=null){if(typeof z=="boolean")return z?g.create(C,N):I.create(C,N);const L=M.get(C);return typeof L=="boolean"?z===(L?"true":"false")?w.INSTANCE:m.INSTANCE:new d(C,z,N)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const z=C?"true":"false";return this.value===z?w.INSTANCE:m.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=d;class g{constructor(C,z){this.key=C,this.negated=z,this.type=3}static create(C,z=null){const N=M.get(C);return typeof N=="boolean"?N?w.INSTANCE:m.INSTANCE:new g(C,z)}cmp(C){return C.type!==this.type?this.type-C.type:p(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?w.INSTANCE:m.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function A(x,C){if(typeof x=="string"){const z=parseFloat(x);isNaN(z)||(x=z)}return typeof x=="string"||typeof x=="number"?C(x):w.INSTANCE}class c{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=12}static create(C,z,N=null){return A(z,L=>new c(C,L,N))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class v{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=13}static create(C,z,N=null){return A(z,L=>new v(C,L,N))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class t{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=14}static create(C,z,N=null){return A(z,L=>new t(C,L,N))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class u{constructor(C,z,N){this.key=C,this.value=z,this.negated=N,this.type=15}static create(C,z,N=null){return A(z,L=>new u(C,L,N))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{constructor(C,z){this.key=C,this.regexp=z,this.type=7,this.negated=null}static create(C,z){return new n(C,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const z=this.regexp?this.regexp.source:"",N=C.regexp?C.regexp.source:"";return z<N?-1:z>N?1:0}equals(C){if(C.type===this.type){const z=this.regexp?this.regexp.source:"",N=C.regexp?C.regexp.source:"";return this.key===C.key&&z===N}return!1}substituteConstants(){return this}evaluate(C){const z=C.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class r{constructor(C){this._actual=C,this.type=8}static create(C){return new r(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new r(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function s(x){let C=null;for(let z=0,N=x.length;z<N;z++){const L=x[z].substituteConstants();if(x[z]!==L&&C===null){C=[];for(let q=0;q<z;q++)C[q]=x[q]}C!==null&&(C[z]=L)}return C===null?x:C}class i{constructor(C,z){this.expr=C,this.negated=z,this.type=6}static create(C,z){return i._normalizeArr(C,z)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let z=0,N=this.expr.length;z<N;z++){const L=O(this.expr[z],C.expr[z]);if(L!==0)return L}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let z=0,N=this.expr.length;z<N;z++)if(!this.expr[z].equals(C.expr[z]))return!1;return!0}return!1}substituteConstants(){const C=s(this.expr);return C===this.expr?this:i.create(C,this.negated)}evaluate(C){for(let z=0,N=this.expr.length;z<N;z++)if(!this.expr[z].evaluate(C))return!1;return!0}static _normalizeArr(C,z){const N=[];let L=!1;for(const q of C)if(!!q){if(q.type===1){L=!0;continue}if(q.type===0)return w.INSTANCE;if(q.type===6){N.push(...q.expr);continue}N.push(q)}if(N.length===0&&L)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(O);for(let q=1;q<N.length;q++)N[q-1].equals(N[q])&&(N.splice(q,1),q--);if(N.length===1)return N[0];for(;N.length>1;){const q=N[N.length-1];if(q.type!==9)break;N.pop();const W=N.pop(),R=N.length===0,Z=l.create(q.expr.map(le=>i.create([le,W],null)),null,R);Z&&(N.push(Z),N.sort(O))}return N.length===1?N[0]:new i(N,z)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const z of this.expr)C.push(...z.keys());return C}map(C){return new i(this.expr.map(z=>z.map(C)),null)}negate(){if(!this.negated){const C=[];for(const z of this.expr)C.push(z.negate());this.negated=l.create(C,this,!0)}return this.negated}}class l{constructor(C,z){this.expr=C,this.negated=z,this.type=9}static create(C,z,N){return l._normalizeArr(C,z,N)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let z=0,N=this.expr.length;z<N;z++){const L=O(this.expr[z],C.expr[z]);if(L!==0)return L}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let z=0,N=this.expr.length;z<N;z++)if(!this.expr[z].equals(C.expr[z]))return!1;return!0}return!1}substituteConstants(){const C=s(this.expr);return C===this.expr?this:l.create(C,this.negated,!1)}evaluate(C){for(let z=0,N=this.expr.length;z<N;z++)if(this.expr[z].evaluate(C))return!0;return!1}static _normalizeArr(C,z,N){let L=[],q=!1;if(C){for(let W=0,R=C.length;W<R;W++){const Z=C[W];if(!!Z){if(Z.type===0){q=!0;continue}if(Z.type===1)return m.INSTANCE;if(Z.type===9){L=L.concat(Z.expr);continue}L.push(Z)}}if(L.length===0&&q)return w.INSTANCE;L.sort(O)}if(L.length!==0){if(L.length===1)return L[0];for(let W=1;W<L.length;W++)L[W-1].equals(L[W])&&(L.splice(W,1),W--);if(L.length===1)return L[0];if(N){for(let W=0;W<L.length;W++)for(let R=W+1;R<L.length;R++)U(L[W],L[R])&&(L.splice(R,1),R--);if(L.length===1)return L[0]}return new l(L,z)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const z of this.expr)C.push(...z.keys());return C}map(C){return new l(this.expr.map(z=>z.map(C)),null)}negate(){if(!this.negated){const C=[];for(const z of this.expr)C.push(z.negate());for(;C.length>1;){const z=C.shift(),N=C.shift(),L=[];for(const W of j(z))for(const R of j(N))L.push(i.create([W,R],null));const q=C.length===0;C.unshift(l.create(L,null,q))}this.negated=C[0]}return this.negated}}class S extends I{constructor(C,z,N){super(C,null),this._defaultValue=z,typeof N=="object"?S._info.push({...N,key:C}):N!==!0&&S._info.push({key:C,description:N,type:z!=null?typeof z:void 0})}static all(){return S._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return f.create(this.key,C)}notEqualsTo(C){return d.create(this.key,C)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(x,C){return x<C?-1:x>C?1:0}function T(x,C,z,N){return x<z?-1:x>z?1:C<N?-1:C>N?1:0}function U(x,C){if(C.type===6&&x.type!==9&&x.type!==6){for(const L of C.expr)if(x.equals(L))return!0}const z=x.negate(),N=j(z).concat(j(C));N.sort(O);for(let L=0;L<N.length;L++){const W=N[L].negate();for(let R=L+1;R<N.length;R++){const Z=N[R];if(W.equals(Z))return!0}}return!1}e.implies=U;function j(x){return x.type===9?x.expr:[x]}}),define(Ce[147],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[79],Ie([1,0,125,3]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function _(d,g){switch(d){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function P(d,g){return g==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(d,g,A){return P(g,A)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===A?!0:k(A).includes(d)}e.isTargetPlatformCompatible=E;function k(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var I;(function(d){d.Install="install",d.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var f;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var a;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(g,A){super(g),this.code=A,this.name=A}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,y.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(Ce[39],Ie([1,0,25,19,9,10,2,127,3]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(W){return W.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var w;(function(W){W[W.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=I;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function a(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=a;function h(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function d(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=d;function g(W){return I(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var A;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(R,Z){super(R),this.code=Z}}e.FileSystemProviderError=c;function v(W,R){const Z=new c(W.toString(),R);return u(Z,R),Z}e.createFileSystemProviderError=v;function t(W){return W||v((0,P.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=t;function u(W,R){return W.name=R?`${R} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=u;function n(W){if(!W)return A.Unknown;if(W instanceof c)return W.code;const R=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!R)return A.Unknown;switch(R[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=n;function r(W){if(W instanceof T)return W.fileOperationResult;switch(n(W)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(R,Z,le){this.resource=R,this.operation=Z,this.target=le}isOperation(R){return this.operation===R}}e.FileOperationEvent=i;var l;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class S{constructor(R,Z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=R;const le=new Map;for(const oe of R){const ue=le.get(oe.type);switch(ue?ue.push([oe.resource,oe]):le.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,ue]of le)switch(oe){case 1:this.added=o.TernarySearchTree.forUris(()=>Z),this.added.fill(ue);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>Z),this.updated.fill(ue);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>Z),this.deleted.fill(ue);break}}contains(R,...Z){return this.doContains(R,{includeChildren:!1},...Z)}affects(R,...Z){return this.doContains(R,{includeChildren:!0},...Z)}doContains(R,Z,...le){if(!R)return!1;const oe=le.length>0;return!!((!oe||le.includes(1))&&(this.added?.get(R)||Z.includeChildren&&this.added?.findSuperstr(R))||(!oe||le.includes(0))&&(this.updated?.get(R)||Z.includeChildren&&this.updated?.findSuperstr(R))||(!oe||le.includes(2))&&(this.deleted?.findSubstr(R)||Z.includeChildren&&this.deleted?.findSuperstr(R)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=S;function p(W,R,Z){return!W||!R||W===R||R.length>W.length?!1:(R.charAt(R.length-1)!==y.sep&&(R+=y.sep),Z?(0,b.startsWithIgnoreCase)(W,R):W.indexOf(R)===0)}e.isParent=p;class T extends Error{constructor(R,Z,le){super(R),this.fileOperationResult=Z,this.options=le}}e.FileOperationError=T;class U extends T{constructor(R,Z,le){super(R,2,le),this.stat=Z}}e.NotModifiedSinceFileOperationError=U;var j;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function C(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=C;async function z(W,R){if(!R.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(Z=>{const le=R.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===W.scheme&&oe.added&&(le.dispose(),Z())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(R){return(0,M.isNumber)(R)||(R=0),R<N.KB?(0,P.localize)(1,null,R.toFixed(0)):R<N.MB?(0,P.localize)(2,null,(R/N.KB).toFixed(2)):R<N.GB?(0,P.localize)(3,null,(R/N.MB).toFixed(2)):R<N.TB?(0,P.localize)(4,null,(R/N.GB).toFixed(2)):(0,P.localize)(5,null,(R/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var L;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function q(W){return{maxFileSize:W===0?300*N.MB:16*N.GB,maxHeapSize:W===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=q}),define(Ce[58],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...b){this._entries=new Map;for(const[M,_]of b)this.set(M,_)}set(b,M){const _=this._entries.get(b);return this._entries.set(b,M),_}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=o}),define(Ce[148],Ie([1,0,14,11,78,146,3,58]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new P.ServiceCollection,a=!1,h){this._activeInstantiations=new Set,this._services=f,this._strict=a,this._parent=h,this._services.set(_.IInstantiationService,this)}createChild(f){return new O(f,this._strict,this)}invokeFunction(f,...a){const h=m.traceInvocation(f);let d=!1;try{return f({get:A=>{if(d)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(A,h);if(!c)throw new Error(`[invokeFunction] unknown service '${A}'`);return c}},...a)}finally{d=!0,h.stop()}}createInstance(f,...a){let h,d;return f instanceof b.SyncDescriptor?(h=m.traceCreation(f.ctor),d=this._createInstance(f.ctor,f.staticArguments.concat(a),h)):(h=m.traceCreation(f),d=this._createInstance(f,a,h)),h.stop(),d}_createInstance(f,a=[],h){const d=_._util.getServiceDependencies(f).sort((c,v)=>c.index-v.index),g=[];for(const c of d){const v=this._getOrCreateServiceInstance(c.id,h);v||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${c.id}.`,!1),g.push(v)}const A=d.length>0?d[0].index:a.length;if(a.length!==A){console.trace(`[createInstance] First service dependency of ${f.name} at position ${A+1} conflicts with ${a.length} static arguments`);const c=A-a.length;c>0?a=a.concat(new Array(c)):a=a.slice(0,A)}return new f(...a,...g)}_setServiceInstance(f,a){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,a);else if(this._parent)this._parent._setServiceInstance(f,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const a=this._services.get(f);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):a}_getOrCreateServiceInstance(f,a){const h=this._getServiceInstanceOrDescriptor(f);return h instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,h,a.branch(f,!0)):(a.branch(f,!1),h)}_safeCreateAndCacheServiceInstance(f,a,h){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,a,h)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,a,h){const d=new M.Graph(c=>c.id.toString());let g=0;const A=[{id:f,desc:a,_trace:h}];for(;A.length;){const c=A.pop();if(d.lookupOrInsertNode(c),g++>1e3)throw new k(d);for(const v of _._util.getServiceDependencies(c.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(v.id);if(t||this._throwIfStrict(`[createInstance] ${f} depends on ${v.id} which is NOT registered.`,!0),t instanceof b.SyncDescriptor){const u={id:v.id,desc:t,_trace:c._trace.branch(v.id,!0)};d.insertEdge(c,u),A.push(u)}}}for(;;){const c=d.roots();if(c.length===0){if(!d.isEmpty())throw new k(d);break}for(const{data:v}of c){if(this._getServiceInstanceOrDescriptor(v.id)instanceof b.SyncDescriptor){const u=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,u)}d.removeNode(v)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,a,h=[],d,g){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(a,h,d,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,a,h,d,g);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(f,a=[],h,d){if(h){const g=new o.IdleValue(()=>this._createInstance(f,a,d));return new Proxy(Object.create(null),{get(A,c){if(c in A)return A[c];const v=g.value;let t=v[c];return typeof t!="function"||(t=t.bind(v),A[c]=t),t},set(A,c,v){return g.value[c]=v,!0}})}else return this._createInstance(f,a,d)}_throwIfStrict(f,a){if(a&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=O;var w;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(w||(w={}));class m{constructor(f,a){this.type=f,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return E?new m(0,f.name):m._None}branch(f,a){const h=new m(2,f.toString());return this._dep.push([f,a,h]),h}stop(){const f=Date.now()-this._start;m._totals+=f;let a=!1;function h(g,A){const c=[],v=new Array(g+1).join("	");for(const[t,u,n]of A._dep)if(u&&n){a=!0,c.push(`${v}CREATES -> ${t}`);const r=h(g+1,n);r&&c.push(r)}else c.push(`${v}uses -> ${t}`);return c.join(`
`)}const d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||a)&&console.log(d.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Ce[15],Ie([1,0,43,5,7,21,3]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function P(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function k(u,n,r){switch(n){case E.Trace:u.trace(r);break;case E.Debug:u.debug(r);break;case E.Info:u.info(r);break;case E.Warning:u.warn(r);break;case E.Error:u.error(r);break;case E.Critical:u.critical(r);break;default:throw new Error("Invalid log level")}}e.log=k;function O(u){let n="";for(let r=0;r<u.length;r++){let s=u[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=O;class w extends b.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class m extends w{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([n,...r]))}debug(n,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([n,...r]))}info(n,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,O([n,...r]))}warn(n,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([n,...r]))}error(n,...r){if(this.checkLogLevel(E.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(E.Error,O(s))}else this.log(E.Error,O([n,...r]))}critical(n,...r){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([n,...r]))}flush(){}}e.AbstractMessageLogger=m;class I extends w{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!M.isWindows}trace(n,...r){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}debug(n,...r){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}info(n,...r){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${P()}]\x1B[0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}warn(n,...r){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${P()}]\x1B[0m`,n,...r):console.warn(`[main ${P()}]`,n,...r))}error(n,...r){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${P()}]\x1B[0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}critical(n,...r){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${P()}]\x1B[0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class f extends w{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class a extends w{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,o.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class h extends w{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=h;class d extends b.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=d;class g extends b.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?E.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class A{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=A;function c(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const n=v(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function v(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=v;function t(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[80],Ie([1,0,29,128,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(f,a){return a-f}E.compare=k;const O=Object.create(null);O[E.Error]=(0,y.localize)(0,null),O[E.Warning]=(0,y.localize)(1,null),O[E.Info]=(0,y.localize)(2,null);function w(f){return O[f]||""}E.toString=w;function m(f){switch(f){case o.default.Error:return E.Error;case o.default.Warning:return E.Warning;case o.default.Info:return E.Info;case o.default.Ignore:return E.Hint}}E.fromSeverity=m;function I(f){switch(f){case E.Error:return o.default.Error;case E.Warning:return o.default.Warning;case E.Info:return o.default.Info;case E.Hint:return o.default.Ignore}}E.toSeverity=I}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(E){const k="";function O(m){return w(m,!0)}E.makeKey=O;function w(m,I){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(_.toString(m.severity)):f.push(k),m.message&&I?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}E.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(Ce[149],Ie([1,0,5,29,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=(0,b.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new E,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=P;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(Ce[81],Ie([1,0,7,9,2,3]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function _(O,w){return b.URI.isUri(O)?(0,y.equalsIgnoreCase)(O.scheme,w):(0,y.startsWithIgnoreCase)(O,w+":")}e.matchesScheme=_;function P(O,...w){return w.some(m=>_(O,m))}e.matchesSomeScheme=P;function E(O,w){return O.with({fragment:`${w.startLineNumber},${w.startColumn}${w.endLineNumber?`-${w.endLineNumber}${w.endColumn?`,${w.endColumn}`:""}`:""}`})}e.withSelection=E;function k(O){let w;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(w={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:w,uri:O}}e.extractSelection=k}),define(Ce[150],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(ne,e,o,y){var b=arguments.length,M=b<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,o):y,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ne,e,o,y);else for(var P=ne.length-1;P>=0;P--)(_=ne[P])&&(M=(b<3?_(M):b>3?_(e,o,M):_(e,o))||M);return b>3&&M&&Object.defineProperty(e,o,M),M},$e=this&&this.__param||function(ne,e){return function(o,y){e(o,y,ne)}};define(Ce[151],Ie([1,0,14,20,7,3]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var _;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let E=class extends b.Disposable{constructor(w,m){super(),this.deferred=new o.DeferredPromise,m.withProgress(w,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};E=xe([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends b.Disposable{constructor(w){super(),this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(w){this.stop();const m=++this.currentOperationId,I=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:I.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,44,10]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(_,P){o.ok(y.isString(_)),o.ok(y.isObject(P)),o.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,P)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new b}),define(Ce[82],Ie([1,0,5,30]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[b(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new M;y.Registry.add(e.Extensions.JSONContribution,_)}),define(Ce[83],Ie([1,0,16,5,10,124,57,82,30]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=E.Registry.as(P.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const n=this.doRegisterConfigurations(t,u);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const u=this.doDeregisterConfigurations(t);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(t,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(n)})}registerDefaultConfigurations(t){const u=[],n=[];for(const{overrides:r,source:s}of t)for(const i in r)if(u.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){const l=this.configurationDefaultsOverrides.get(i),S=l?.valuesSources??new Map;if(s)for(const j of Object.keys(r[i]))S.set(j,s);const p={...l?.value||{},...r[i]};this.configurationDefaultsOverrides.set(i,{source:s,value:p,valuesSources:S});const T=(0,_.getLanguageTagSettingPlainKey)(i),U={type:"object",default:p,description:M.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:b.isString(s)?void 0:s,defaultValueSource:s};n.push(...a(i)),this.configurationProperties[i]=U,this.defaultLanguageConfigurationOverridesNode.properties[i]=U}else{this.configurationDefaultsOverrides.set(i,{value:r[i],source:s});const l=this.configurationProperties[i];l&&(this.updatePropertyDefaultValue(i,l),this.updateSchema(i,l))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const u=[];for(const{overrides:n,source:r}of t)for(const s in n){const i=this.configurationDefaultsOverrides.get(s),l=b.isString(r)?r:r?.id,S=b.isString(i?.source)?i?.source:i?.source?.id;if(l===S)if(u.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u){const n=[];return t.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,u,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(t){const u=[],n=r=>{if(r.properties)for(const s in r.properties){u.push(s);const i=this.configurationProperties[s];i?.policy?.name&&this.policyConfigurations.delete(i.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of t){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return u}validateAndRegisterProperties(t,u=!0,n,r,s=3){s=b.isUndefinedOrNull(t.scope)?s:t.scope;const i=[],l=t.properties;if(l)for(const p in l){const T=l[p];if(u&&A(p,T)){delete l[p];continue}if(T.source=n,T.defaultDefaultValue=l[p].default,this.updatePropertyDefaultValue(p,T),e.OVERRIDE_PROPERTY_REGEX.test(p)?T.scope=void 0:(T.scope=b.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=b.isUndefinedOrNull(T.restricted)?!!r?.includes(p):T.restricted),l[p].hasOwnProperty("included")&&!l[p].included){this.excludedConfigurationProperties[p]=l[p],delete l[p];continue}else this.configurationProperties[p]=l[p],l[p].policy?.name&&this.policyConfigurations.set(l[p].policy.name,p);!l[p].deprecationMessage&&l[p].markdownDeprecationMessage&&(l[p].deprecationMessage=l[p].markdownDeprecationMessage),i.push(p)}const S=t.allOf;if(S)for(const p of S)i.push(...this.validateAndRegisterProperties(p,u,n,r,s));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=n=>{const r=n.properties;if(r)for(const i in r)this.updateSchema(i,r[i]);n.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const n=this.configurationDefaultsOverrides.get(t);let r=n?.value,s=n?.source;b.isUndefined(r)&&(r=u.defaultDefaultValue,s=void 0),b.isUndefined(r)&&(r=d(u.type)),u.default=r,u.defaultValueSource=s}}const I="\\[([^\\]]+)\\]",f=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let u=f.exec(v);for(;u?.length;){const n=u[1].trim();n&&t.push(n),u=f.exec(v)}}return(0,o.distinct)(t)}e.overrideIdentifiersFromKey=a;function h(v){return v.reduce((t,u)=>`${t}[${u}]`,"")}e.keyFromOverrideIdentifiers=h;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function A(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):g.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,v,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=A;function c(){const v=[],t=g.getConfigurationProperties();for(const u of Object.keys(t))v.push([u,t[u].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=c}),define(Ce[152],Ie([1,0,16,5,106,7,25,26,10,2,57,83,30]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(t={},u=[],n=[]){this._contents=t,this._keys=u,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,u){const n=this.getContentsForOverrideIdentifer(u);return n?t?(0,O.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const u=[];for(const n of this.overrides)n.identifiers.includes(t)&&u.push(...n.keys);return o.distinct(u)}getAllOverrideIdentifiers(){const t=[];for(const u of this.overrides)t.push(...u.identifiers);return o.distinct(t)}override(t){let u=this.overrideConfigurations.get(t);return u||(u=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,u)),u}merge(...t){const u=P.deepClone(this.contents),n=P.deepClone(this.overrides),r=[...this.keys];for(const s of t)if(!s.isEmpty()){this.mergeContents(u,s.contents);for(const i of s.overrides){const[l]=n.filter(S=>o.equals(S.identifiers,i.identifiers));l?(this.mergeContents(l.contents,i.contents),l.keys.push(...i.keys),l.keys=o.distinct(l.keys)):n.push(P.deepClone(i))}for(const i of s.keys)r.indexOf(i)===-1&&r.push(i)}return new I(u,r,n)}freeze(){return this.frozen=!0,this}clone(){return new I(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const n={};for(const r of o.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[r];const i=u[r];i&&(typeof s=="object"&&typeof i=="object"?(s=P.deepClone(s),this.mergeContents(s,i)):s=i),n[r]=s}return new I(n,this.keys,this.overrides)}mergeContents(t,u){for(const n of Object.keys(u)){if(n in t&&E.isObject(t[n])&&E.isObject(u[n])){this.mergeContents(t[n],u[n]);continue}t[n]=P.deepClone(u[n])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let u=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=P.deepClone(s))};for(const s of this.overrides)o.equals(s.identifiers,[t])?u=s.contents:s.identifiers.includes(t)&&r(s.contents);return r(u),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,O.addToValueTree)(this.contents,t,u,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,O.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let n=0;n<u;n++)t.indexOf(this.keys[n])===0&&(u=n);this.keys.splice(u,1,t)}removeKey(t){const u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=I;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!E.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:n,keys:r,overrides:s,restricted:i}=this.doParseRaw(t,u);this._configurationModel=new I(n,r,s),this._restrictedConfigurations=i||[]}doParseContent(t){let u={},n=null,r=[];const s=[],i=[];function l(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}const S={onObjectBegin:()=>{const p={};l(p),s.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const p=[];l(p),s.push(r),r=p,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:l,onError:(p,T,U)=>{i.push({error:p,offset:T,length:U})}};if(t)try{b.visit(t,S),u=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return u}doParseRaw(t,u){const n=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,n,!0,u);t=r.raw;const s=(0,O.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),i=Object.keys(t),l=this.toOverrides(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:s,keys:i,overrides:l,restricted:r.restricted}}filter(t,u,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const s={},i=[];for(const l in t)if(w.OVERRIDE_PROPERTY_REGEX.test(l)&&n){const S=this.filter(t[l],u,!1,r);s[l]=S.raw,i.push(...S.restricted)}else{const S=u[l],p=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&i.push(l),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&S?.restricted||(s[l]=t[l]))}return{raw:s,restricted:i}}toOverrides(t,u){const n=[];for(const r of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const i in t[r])s[i]=t[r][i];n.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,O.toValuesTree)(s,u)})}return n}}e.ConfigurationModelParser=f;class a extends M.Disposable{constructor(t,u,n,r){super(),this.userSettingsResource=t,this.scopes=u,this.fileService=r,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.any(y.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),y.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=a;class h{constructor(t,u,n,r,s=new I,i=new I,l=new _.ResourceMap,S=new I,p=new _.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=u,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=l,this._memoryConfiguration=S,this._memoryConfigurationByResource=p,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,u,n){return this.getConsolidatedConfigurationModel(t,u,n).getValue(t)}updateValue(t,u,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new I,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,u===void 0?r.removeValue(t):r.setValue(t,u),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,n){const r=this.getConsolidatedConfigurationModel(t,u,n),s=this.getFolderConfigurationModelForResource(u.resource,n),i=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,l=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(t),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(t),T=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),U=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),j=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),x=n?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,C=s?u.overrideIdentifier?s.freeze().override(u.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,z=u.overrideIdentifier?i.override(u.overrideIdentifier).getValue(t):i.getValue(t),N=r.getValue(t),L=o.distinct(r.overrides.map(q=>q.identifiers).flat()).filter(q=>r.getOverrideValue(t,q)!==void 0);return{defaultValue:l,policyValue:S,applicationValue:p,userValue:T,userLocalValue:U,userRemoteValue:j,workspaceValue:x,workspaceFolderValue:C,memoryValue:z,value:N,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,policy:S!==void 0?{value:S}:void 0,application:p!==void 0?{value:p,override:u.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,workspaceFolder:C!==void 0?{value:s?.freeze().getValue(t),override:u.overrideIdentifier?s?.freeze().getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:i.getValue(t),override:u.overrideIdentifier?i.getOverrideValue(t,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const n=[];if(!u){const{added:r,updated:s,removed:i}=A(this._defaultConfiguration,t);u=[...r,...s,...i]}for(const r of u)for(const s of(0,w.overrideIdentifiersFromKey)(r)){const i=this._defaultConfiguration.getKeysForOverrideIdentifier(s),l=t.getKeysForOverrideIdentifier(s),S=[...l.filter(p=>i.indexOf(p)===-1),...i.filter(p=>l.indexOf(p)===-1),...i.filter(p=>!P.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];n.push([s,S])}return this.updateDefaultConfiguration(t),{keys:u,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:u,updated:n,removed:r}=A(this._policyConfiguration,t),s=[...u,...n,...r];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:u,updated:n,removed:r,overrides:s}=A(this.applicationConfiguration,t),i=[...u,...n,...r];return i.length&&this.updateApplicationConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:n,removed:r,overrides:s}=A(this.localUserConfiguration,t),i=[...u,...n,...r];return i.length&&this.updateLocalUserConfiguration(t),{keys:i,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:n,removed:r,overrides:s}=A(this.remoteUserConfiguration,t),i=[...u,...n,...r];return i.length&&this.updateRemoteUserConfiguration(t),{keys:i,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:n,removed:r,overrides:s}=A(this.workspaceConfiguration,t),i=[...u,...n,...r];return i.length&&this.updateWorkspaceConfiguration(t),{keys:i,overrides:s}}compareAndUpdateFolderConfiguration(t,u){const n=this.folderConfigurations.get(t),{added:r,updated:s,removed:i,overrides:l}=A(n,u),S=[...r,...s,...i];return(S.length||!n)&&this.updateFolderConfiguration(t,u),{keys:S,overrides:l}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:s,overrides:i}=A(u,void 0);return{keys:[...n,...r,...s],overrides:i}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,u,n){let r=this.getConsolidatedConfigurationModelForResource(u,n);return u.overrideIdentifier&&(r=r.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:t},u){let n=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const r=u.getFolder(t);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(t);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(u=n.merge(r),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=n}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const n=u.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(u);return t.push([u,{contents:n,overrides:r,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>u.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>u.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>u.add(r))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.policy),r=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((S,p)=>(S.set(k.URI.revive(p[0]),this.parseConfigurationModel(p[1])),S),new _.ResourceMap);return new h(u,n,r,s,new I,i,l,new I,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new I(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function d(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,u=new Map;for(const r of v)r.keys.forEach(s=>t.add(s)),r.overrides.forEach(([s,i])=>{const l=(0,_.getOrSet)(u,s,new Set);i.forEach(S=>l.add(S))});const n=[];return u.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=d;class g{constructor(t,u,n,r){this.change=t,this.previous=u,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(l=>s.add(l)),t.overrides.forEach(([,l])=>l.forEach(S=>s.add(S))),this.affectedKeys=[...s.values()];const i=new I;this.affectedKeys.forEach(l=>i.setValue(l,{})),this.affectedKeysTree=i.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!P.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let n=(0,O.toValuesTree)({[u]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(t=t[r],!t)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=g;function A(v,t){const{added:u,removed:n,updated:r}=c(t,v),s=[],i=v?.getAllOverrideIdentifiers()||[],l=t?.getAllOverrideIdentifiers()||[];if(t){const S=l.filter(p=>!i.includes(p));for(const p of S)s.push([p,t.getKeysForOverrideIdentifier(p)])}if(v){const S=i.filter(p=>!l.includes(p));for(const p of S)s.push([p,v.getKeysForOverrideIdentifier(p)])}if(t&&v){for(const S of i)if(l.includes(S)){const p=c({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:t.getOverrideValue(void 0,S)||{},keys:t.getKeysForOverrideIdentifier(S)});s.push([S,[...p.added,...p.removed,...p.updated]])}}return{added:u,removed:n,updated:r,overrides:s}}function c(v,t){const u=v?t?v.keys.filter(s=>t.keys.indexOf(s)===-1):[...v.keys]:[],n=t?v?t.keys.filter(s=>v.keys.indexOf(s)===-1):[...t.keys]:[],r=[];if(v&&t){for(const s of t.keys)if(v.keys.indexOf(s)!==-1){const i=(0,O.getConfigurationValue)(t.contents,s),l=(0,O.getConfigurationValue)(v.contents,s);P.equals(i,l)||r.push(s)}}return{added:u,removed:n,updated:r}}}),define(Ce[84],Ie([1,0,11,3]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var b;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends o.ErrorNoTelemetry{constructor(P,E=b.Unknown,k){super(P),this._message=P,this._code=E,this._detail=k,this.isHandled=E===b.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(P){return P instanceof M&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof M&&P._code===b.NoResolverFound}static isHandled(P){return P instanceof M&&P.isHandled}}e.RemoteAuthorityResolverError=M}),define(Ce[85],Ie([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function y(k){return k.scheme===o.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=y;function b(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=b;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function _(k){const{host:O,port:w}=E(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=_;function P(k,O){let{host:w,port:m}=E(k);return typeof m>"u"&&(m=O),{host:w,port:m}}e.parseAuthorityWithOptionalPort=P;function E(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ce[27],Ie([1,0,9,3,85]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function _(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const d=typeof a=="string"?a:a.value,g=typeof h=="string"?h:h.value;return o.equalsIgnoreCase(d,g)}return a._lower===h._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.ExtensionIdentifier=k;function O(f){return w(f)}e.isApplicationScopedExtension=O;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function I(f,a){if(a){const h=`onResolveRemoteAuthority:${(0,b.getRemoteName)(a)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[153],Ie([1,0,9,79,27,21,2,11,59]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,o.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new w(n.identifier,r,s)}static parse(n){const r=O.exec(n);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof w?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(u){const n=m.exec(u);return n&&n[1]?[a(n[1]),n[2]]:[a(u),void 0]}e.getIdAndVersion=I;function f(u,n){return`${u}.${n}`}e.getExtensionId=f;function a(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function h(u,n){return a(f(u,n))}e.getGalleryExtensionId=h;function d(u,n){const r=[],s=i=>{for(const l of r)if(l.some(S=>k(n(S),n(i))))return l;return null};for(const i of u){const l=s(i);l?l.push(i):r.push([i])}return r}e.groupByExtension=d;function g(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function A(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function c(u,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const i=s.shift();if(i&&r.every(l=>!k(l.identifier,{id:i}))){const l=u.filter(S=>k(S.identifier,{id:i}));l.length===1&&(r.push(l[0]),s.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=c;async function v(u,n){if(!M.isLinux)return!1;let r;try{r=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(i))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=v;async function t(u,n){const r=await v(u,n),s=(0,y.getTargetPlatform)(r?"alpine":M.platform,E.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Ce[154],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,M,_=5){const P=M(E=>{const k=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(b);if(O){O.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(b),_);O={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(b),P.dispose()}},this._terminalBufferMap.set(b,O)});return P}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const M=this._terminalBufferMap.get(b);M&&(this._terminalBufferMap.delete(b),this._callback(b,M.data.join("")))}}e.TerminalDataBufferer=o}),define(Ce[155],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function y(M){return M===o.HIGH_CONTRAST_DARK||M===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=y;function b(M){return M===o.DARK||M===o.HIGH_CONTRAST_DARK}e.isDark=b}),define(Ce[60],Ie([1,0,117,5,7,3,30,155]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var E;(function(h){function d(g){return g&&typeof g=="object"&&typeof g.id=="string"}h.isThemeColor=d})(E=e.ThemeColor||(e.ThemeColor={}));function k(h){return{id:h}}e.themeColorFromId=k;var O;(function(h){function d(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||E.isThemeColor(r.color))}h.isThemeIcon=d;const g=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function A(r){const s=g.exec(r);if(!s)return;const[,i]=s;return{id:i}}h.fromString=A;function c(r){return{id:r}}h.fromId=c;function v(r,s){let i=r.id;const l=i.lastIndexOf("~");return l!==-1&&(i=i.substring(0,l)),s&&(i=`${i}~${s}`),{id:i}}h.modify=v;function t(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}h.getModifier=t;function u(r,s){return r.id===s.id&&r.color?.id===s.color?.id}h.isEqual=u;function n(r,s){return{id:r.id,color:s?k(s):void 0}}h.asThemeIcon=n,h.asClassNameArray=o.CSSIcon.asClassNameArray,h.asClassName=o.CSSIcon.asClassName,h.asCSSSelector=o.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function w(h){switch(h){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,b.toDisposable)(()=>{const g=this.themingParticipants.indexOf(d);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const I=new m;_.Registry.add(e.Extensions.ThemingContribution,I);function f(h){return I.onColorThemeChange(h)}e.registerThemingParticipant=f;class a extends b.Disposable{constructor(d){super(),this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,g){let A=this.theme.getColor(d);return A&&g&&(A=g(A,this.theme)),A?A.toString():null}}e.Themable=a}),define(Ce[156],Ie([1,0,5,21,3,15]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var _;(function(a){a.Http="http",a.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function m(a,h){return h?h!==1&&a<1024:!y.isWindows&&a<1024}e.isPortPrivileged=m;class I{constructor(h,d,g){this.remoteAddress=h,this.localAddress=d,this._dispose=g,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let f=class{constructor(h){this.logService=h,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],d=Array.from(this._tunnels.values());for(const g of d){const A=Array.from(g.values());for(const c of A){const v=await c.value;v&&h.push(v)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:d}of h.values())await d.then(g=>g?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,d,g,A,c=!1,v,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${A}.`),!h)return;if(d||(d="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(h,d,g,A,c,v,t);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==d||n.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const d=this._tunnels.get(h.tunnelRemoteHost);if(d){const g=d.get(h.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,g))}}}}async tryDisposeTunnel(h,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${d}.`);const A=g.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(d),A}}async closeTunnel(h,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${d} `);const g=this._tunnels.get(h);if(g&&g.has(d)){const A=g.get(d);A.refcount=0,await this.tryDisposeTunnel(h,d,A)}}addTunnelToMap(h,d,g){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(h,d){const g=this._tunnels.get(h);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,d){const g=[h];O(h)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(h)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const A=g.map(c=>this._tunnels.get(c));for(const c of A){const v=c?.get(d);if(v)return v}}canTunnel(h){return!!k(h)}createWithProvider(h,d,g,A,c,v,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${A}.`);const u=g;this._factoryInProgress.add(u);const r={elevationRequired:c?m(A===void 0?g:A):!1},s={remoteAddress:{host:d,port:g},localAddressPort:A,privacy:v,public:v?v!==P.Private:void 0,protocol:t},i=h.forwardPort(s,r);return i?(this.addTunnelToMap(d,g,i),i.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),i}};f=xe([$e(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(Ce[157],Ie([1,0,12]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function y(E){return E.scheme!==o.Schemas.file&&E.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=y;function b(E){if(E.folders.length)return E.folders.every(k=>y(k.uri))?E.folders[0].uri:void 0;if(E.configuration&&y(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=b;function M(E){return b(E)?.scheme}e.getVirtualWorkspaceScheme=M;function _(E){return b(E)?.authority}e.getVirtualWorkspaceAuthority=_;function P(E){return b(E)!==void 0}e.isVirtualWorkspace=P}),define(Ce[45],Ie([1,0,129,19,25,22,2,3,12]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function k(u){const n=u;return typeof n?.id=="string"&&_.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(u,n){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,y.basename)(u)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=u;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=O;function w(u){const n=u;return typeof n?.id=="string"&&_.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=w;function m(u){const n=u;if(n?.uri)return{id:n.id,uri:_.URI.revive(n.uri)};const r=u;if(r?.configPath)return{id:r.id,configPath:_.URI.revive(r.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=m;var I;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function f(u){const n=u;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function a(u){const n=u;return!!(n&&typeof n=="object"&&_.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(n,r,s,i,l){this._id=n,this._transient=s,this._configuration=i,this._ignorePathCasing=l,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class d{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(u){return new d({uri:u,index:0,name:(0,M.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function A(u,n){return M.extUriBiasedIgnorePathCase.isEqualOrParent(u,n.untitledWorkspacesHome)}e.isUntitledWorkspace=A;function c(u){let n;return _.URI.isUri(u)?n=u:n=u.configuration,n?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=c;function v(u,n){return!A(u,n)&&!c(u)}e.isSavedWorkspace=v;function t(u){return(typeof u=="string"?(0,y.extname)(u):(0,M.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const M=this._idPool++;return this._data.set(M,b),this.logDebugInfo(),M}get(b,M){return this._data.has(b)?this._data.get(b)[M]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(Ce[35],Ie([1,0,12,22,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new y.ExtUri(P=>{const E=this._providerInfo.get(P.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(P,E){E===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,E)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[28],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(Ce[158],Ie([1,0,14]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class y{constructor(_,P,E){this._deferredPromises=new Map,this._id=_,this._shared=P,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of k.values())O.complete()}catch(O){for(const w of k.values())w.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,P){let E=this._value[_];return typeof E>"u"&&(E=P),E}update(_,P){this._value[_]=P;const E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const k=new o.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=y;class b extends y{constructor(_,P){super(_.identifier.value,!0,P),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=b}),define(Ce[159],Ie([1,0,5,2]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,P,E,k){const w=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptModelChanged(P.value,E,k);this._onDidChangeNotebookDocument.fire(w)}$acceptDirtyStateChanged(_,P){this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptDirty(P)}$acceptModelSaved(_){const P=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_));this._onDidSaveNotebookDocument.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(Ce[13],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class y{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=y});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[160],Ie([1,0,27,5]),function(ne,e,o,y){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(P,E){b.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(P.identifier),Je(this,b,E,"f"),Oe(this,b,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(P){return Oe(this,b,"f").get(this._id,P)}store(P,E){return Oe(this,b,"f").store(this._id,P,E)}delete(P){return Oe(this,b,"f").delete(this._id,P)}}e.ExtensionSecrets=M,b=new WeakMap}),define(Ce[86],Ie([1,0,3,5]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new y.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,P){this._level=_,this._productConfig=P||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,156,5,13]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(E){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:w.protocol}}E.fromApiTunnel=k;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==y.TunnelPrivacyId.ConstantPrivate&&w.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}E.fromServiceTunnel=O})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=class{constructor(k){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,w,m,I){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=xe([$e(0,M.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(Ce[46],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class y{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=y}),define(Ce[161],Ie([1,0,23]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class y{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function b(P,E){if(E.serializeBuffersForPostMessage){const k=new y,O=(I,f)=>{if(f instanceof ArrayBuffer){const a=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(f)){const a=M(f);if(a){const h=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:a,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(P,O),m=k.buffers.map(I=>{const f=new Uint8Array(I);return o.VSBuffer.wrap(f)});return{message:w,buffers:m}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=b;function M(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(P,E){const k=E.map(m=>{const I=new ArrayBuffer(m.byteLength);return new Uint8Array(I).set(m.buffer),I}),O=E.length?(m,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const f=I,{index:a}=f,h=k[a];if(f.view)switch(f.view.type){case 1:return new Int8Array(h,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return I}:void 0;return{message:JSON.parse(P,O),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(Ce[87],Ie([1,0,137,10,2,7,3,30,39,16,12]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(R){R[R.PROGRAMMATIC=1]="PROGRAMMATIC",R[R.USER=2]="USER",R[R.EDIT=3]="EDIT",R[R.NAVIGATION=4]="NAVIGATION",R[R.JUMP=5]="JUMP"})(w=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(R){R[R.IDENTICAL=1]="IDENTICAL",R[R.SIMILAR=2]="SIMILAR",R[R.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function I(R){const Z=R;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=I;function f(R,Z,le){for(const oe of le.visibleEditorPanes)if(oe.group.id===Z&&R.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function a(R){if(r(R))return!1;const Z=R;return b.URI.isUri(Z?.resource)}e.isResourceEditorInput=a;function h(R){if(r(R))return!1;const Z=R;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=h;function d(R){if(r(R)||h(R))return!1;const Z=R;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function g(R){if(r(R))return!1;const Z=R;return Z?Z.resource===void 0||Z.resource.scheme===O.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function A(R){if(r(R))return!1;const Z=R;return b.URI.isUri(Z?.base?.resource)&&b.URI.isUri(Z?.input1?.resource)&&b.URI.isUri(Z?.input2?.resource)&&b.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=A;var c;(function(R){R[R.SHORT=0]="SHORT",R[R.MEDIUM=1]="MEDIUM",R[R.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var v;(function(R){R[R.EXPLICIT=1]="EXPLICIT",R[R.AUTO=2]="AUTO",R[R.FOCUS_CHANGE=3]="FOCUS_CHANGE",R[R.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));class t{constructor(){this.mapIdToSaveSource=new Map}registerSource(Z,le){let oe=this.mapIdToSaveSource.get(Z);return oe||(oe={source:Z,label:le},this.mapIdToSaveSource.set(Z,oe)),oe.source}getSourceLabel(Z){return this.mapIdToSaveSource.get(Z)?.label??Z}}e.SaveSourceRegistry=new t;var u;(function(R){R[R.None=0]="None",R[R.Readonly=2]="Readonly",R[R.Untitled=4]="Untitled",R[R.Singleton=8]="Singleton",R[R.RequiresTrust=16]="RequiresTrust",R[R.CanSplitInGroup=32]="CanSplitInGroup",R[R.ForceDescription=64]="ForceDescription",R[R.CanDropIntoEditor=128]="CanDropIntoEditor",R[R.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends M.Disposable{}e.AbstractEditorInput=n;function r(R){return R instanceof n}e.isEditorInput=r;function s(R){const Z=R;return b.URI.isUri(Z?.preferredResource)}function i(R){const Z=R;return r(Z?.primary)&&r(Z?.secondary)}e.isSideBySideEditorInput=i;function l(R){const Z=R;return r(Z?.modified)&&r(Z?.original)}e.isDiffEditorInput=l;function S(R){return r(R?.editor)}e.isEditorInputWithOptions=S;function p(R){const Z=R;return S(R)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function T(R){const Z=R;return typeof Z?.groupId=="number"&&r(Z.editor)}e.isEditorIdentifier=T;var U;(function(R){R[R.UNKNOWN=0]="UNKNOWN",R[R.REPLACE=1]="REPLACE",R[R.MOVE=2]="MOVE",R[R.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var j;(function(R){R[R.GROUP_ACTIVE=0]="GROUP_ACTIVE",R[R.GROUP_INDEX=1]="GROUP_INDEX",R[R.GROUP_LOCKED=2]="GROUP_LOCKED",R[R.EDITOR_OPEN=3]="EDITOR_OPEN",R[R.EDITOR_CLOSE=4]="EDITOR_CLOSE",R[R.EDITOR_MOVE=5]="EDITOR_MOVE",R[R.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",R[R.EDITOR_LABEL=7]="EDITOR_LABEL",R[R.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",R[R.EDITOR_PIN=9]="EDITOR_PIN",R[R.EDITOR_STICKY=10]="EDITOR_STICKY",R[R.EDITOR_DIRTY=11]="EDITOR_DIRTY",R[R.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(R){R[R.PRIMARY=1]="PRIMARY",R[R.SECONDARY=2]="SECONDARY",R[R.BOTH=3]="BOTH",R[R.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class C{getOriginalUri(Z,le){if(!Z)return;if(A(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,le);if(le?.supportSideBySide){const{primary:ue,secondary:ee}=this.getSideEditors(Z);if(ue&&ee){if(le?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:le.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===x.ANY)return this.getOriginalUri(ue,{filterByScheme:le.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:le.filterByScheme});Z=le.supportSideBySide===x.PRIMARY?ue:ee}}if(h(Z)||d(Z)||A(Z))return;const oe=s(Z)?Z.preferredResource:Z.resource;return!oe||!le||!le.filterByScheme?oe:this.filterUri(oe,le.filterByScheme)}getSideEditors(Z){return i(Z)||d(Z)?{primary:Z.primary,secondary:Z.secondary}:l(Z)||h(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,le){if(!Z)return;if(A(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,le);if(le?.supportSideBySide){const{primary:ue,secondary:ee}=this.getSideEditors(Z);if(ue&&ee){if(le?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:le.filterByScheme})};if(le?.supportSideBySide===x.ANY)return this.getCanonicalUri(ue,{filterByScheme:le.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:le.filterByScheme});Z=le.supportSideBySide===x.PRIMARY?ue:ee}}if(h(Z)||d(Z)||A(Z))return;const oe=Z.resource;return!oe||!le||!le.filterByScheme?oe:this.filterUri(oe,le.filterByScheme)}filterUri(Z,le){if(Array.isArray(le)){if(le.some(oe=>Z.scheme===oe))return Z}else if(le===Z.scheme)return Z}}e.EditorResourceAccessor=new C;var z;(function(R){R[R.LEFT=0]="LEFT",R[R.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class N{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Z){const le=this.instantiationService=Z.get(_.IInstantiationService);for(const[oe,ue]of this.editorSerializerConstructors)this.createEditorSerializer(oe,ue,le);this.editorSerializerConstructors.clear()}createEditorSerializer(Z,le,oe){const ue=oe.createInstance(le);this.editorSerializerInstances.set(Z,ue)}registerFileEditorFactory(Z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Z}getFileEditorFactory(){return(0,y.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Z,le){if(this.editorSerializerConstructors.has(Z)||this.editorSerializerInstances.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Z,le,this.instantiationService):this.editorSerializerConstructors.set(Z,le),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(Z),this.editorSerializerInstances.delete(Z)})}getEditorSerializer(Z){return this.editorSerializerInstances.get(typeof Z=="string"?Z:Z.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new N);async function L(R,Z){if(!R||!R.length)return[];const le=await Promise.all(R.map(async oe=>{const ue=b.URI.revive(oe.fileUri);if(!ue||!await Z.canHandleResource(ue))return;let ve=oe.exists,we=oe.type;if(typeof ve!="boolean"||typeof we!="number")try{we=(await Z.stat(ue)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ve=!0}catch{ve=!1}if(!ve&&oe.openOnlyIfExists||we===E.FileType.Directory)return;const re={...oe.options,pinned:!0};let Ee;return ve?Ee={resource:ue,options:re}:Ee={resource:ue,options:re,forceUntitled:!0},Ee}));return(0,k.coalesce)(le)}e.pathsToEditors=L;var q;(function(R){R[R.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",R[R.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function W(R){const Z=R;if(!Z)return!1;const le=Z;if(le.modified)return W(le.modified);const oe=Z;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=W}),define(Ce[63],Ie([1,0,12,2]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(P,E){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(E&&E.authority&&E.isRemote&&P.scheme===o.Schemas.file&&(P=y.URI.from({scheme:o.Schemas.vscodeRemote,authority:E.authority,path:P.path})),y.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${M(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=b;function M(P){return P.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function _(P){return P.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=_}),define(Ce[162],Ie([1,0,5,7,63]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(P,E,k){this._proxy=P,this._editors=E,this._remoteInfo=k,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const w of this._insets.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,E,k,O,w){let m;for(const A of this._editors.getVisibleTextEditors(!0))if(A.value===P){m=A;break}if(!m)throw new Error("not a visible editor");const I=this,f=this._handlePool++,a=new o.Emitter,h=new o.Emitter,d=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(A){return(0,b.asWebviewUri)(A,I._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(A){this._options=A,I._proxy.$setOptions(f,A)}get options(){return this._options}set html(A){this._html=A,I._proxy.$setHtml(f,A)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(A){return I._proxy.$postMessage(f,A)}},g=new class{constructor(){this.editor=P,this.line=E,this.height=k,this.webview=d,this.onDidDispose=h.event}dispose(){I._insets.has(f)&&(I._insets.delete(f),I._proxy.$disposeEditorInset(f),h.fire(),h.dispose(),a.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,k,O||{},w.identifier,w.extensionLocation),this._insets.set(f,{editor:P,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(P){const E=this._insets.get(P);E&&E.inset.dispose()}$onDidReceiveMessage(P,E){this._insets.get(P)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=M}),define(Ce[163],Ie([1,0,5,14,138]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,E,k,O){const w={command:P};if(E&&Object.keys(E).length>0&&(w.arguments=E),this.internalSend("request",w),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const I=this.pendingRequests.get(w.seq);if(I){this.pendingRequests.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,b.localize)(0,null,O,P)};I(f)}},O)}return k&&this.pendingRequests.set(w.seq,k),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,E){return P.type!=="event"||E.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,y.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback?.(P);break;case"request":this.requestCallback?.(P);break;case"response":{const E=P,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}}internalSend(P,E){E.type=P,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((E,k)=>P.set(k,E)),await(0,y.timeout)(500),P.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ce[164],Ie([1,0,139,38,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new y.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new y.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new y.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new y.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new y.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new y.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new y.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new y.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new y.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new y.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new y.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new y.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new y.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new y.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new y.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new y.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new y.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new y.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new y.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new y.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new y.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new y.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new y.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new y.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new y.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new y.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new y.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new y.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new y.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new y.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new y.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new y.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new y.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new y.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new y.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new y.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new y.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new y.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new y.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new y.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new y.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new y.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new y.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new y.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new y.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new y.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new y.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new y.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new y.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new y.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new y.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const M=m=>o.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function P(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var w;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[165],Ie([1,0,9,2,19,26,12]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function E(n,r,s){return n.replace(P,function(i,l){return r&&l.length>0&&l[0]!=="_"?i:s&&s.hasOwnProperty(l)?s[l]:i})}e.formatPII=E;function k(n){const r={};for(const s of Object.keys(n))s.startsWith("!")||(r[s]=n[s]);return r}e.filterExceptionsFromTelemetry=k;function O(n){return n.configuration.request==="attach"&&!w(n)&&(!n.parentSession||O(n.parentSession))}e.isSessionAttach=O;function w(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(r,"extensionhost")||(0,o.equalsIgnoreCase)(r,"pwa-extensionhost")?n:n.parentSession?w(n.parentSession):void 0}e.getExtensionHostDebugSession=w;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function I(n,r,s){let i,l=0;const S=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=S.exec(n);){const T=p.index+1,U=T+p[0].length;if(T<=r&&U>=s){i=p[0],l=T;break}}if(i){const T=/\w+/g;let U=null;for(;(U=T.exec(i))&&!(U.index+1+l+U[0].length>=s););U&&(i=i.substring(0,T.lastIndex))}return i?{start:l,end:l+i.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(f))}e.isUri=a;function h(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return y.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return y.URI.file(n.path)}return n.path}function d(n){if(typeof n.path=="object"){const r=y.URI.revive(n.path);if(r)return r.scheme===_.Schemas.file?r.fsPath:r.toString()}return n.path}function g(n,r){const s=r?h:d,i=(0,M.deepClone)(n);return c(i,(l,S)=>{l&&S&&(S.path=s(S))}),i}e.convertToDAPaths=g;function A(n,r){const s=r?h:d,i=(0,M.deepClone)(n);return c(i,(l,S)=>{!l&&S&&(S.path=s(S))}),i}e.convertToVSCPaths=A;function c(n,r){switch(n.type){case"event":{const s=n;switch(s.event){case"output":r(!1,s.body.source);break;case"loadedSource":r(!1,s.body.source);break;case"breakpoint":r(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=n;switch(s.command){case"setBreakpoints":r(!0,s.arguments.source);break;case"breakpointLocations":r(!0,s.arguments.source);break;case"source":r(!0,s.arguments.source);break;case"gotoTargets":r(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(i=>r(!1,i));break;default:break}break}case"response":{const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(i=>r(!1,i.source));break;case"loadedSources":s.body.sources.forEach(i=>r(!1,i));break;case"scopes":s.body.scopes.forEach(i=>r(!1,i.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(i=>r(!1,i.source));break;case"setBreakpoints":s.body.breakpoints.forEach(i=>r(!1,i.source));break;case"disassemble":s.body?.instructions.forEach(l=>r(!1,l.location));break;default:break}break}}}function v(n){return n.filter(r=>!r.presentation?.hidden).sort((r,s)=>r.presentation?s.presentation?r.presentation.group?s.presentation.group?r.presentation.group!==s.presentation.group?r.presentation.group.localeCompare(s.presentation.group):t(r.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(r.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=v;function t(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}async function u(n,r){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(s!=="none"&&(await r.saveAll(),s==="allEditorsInActiveGroup")){const i=r.activeEditorPane;i&&i.input.resource?.scheme===_.Schemas.untitled&&await r.save({editor:i.input,groupId:i.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[88],Ie([1,0,23,34,166,73,12,19,21,38]),function(ne,e,o,y,b,M,_,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(i){i[i.Markup=1]="Markup",i[i.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(i){i[i.Running=1]="Running",i[i.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(i){i[i.Unconfirmed=1]="Unconfirmed",i[i.Pending=2]="Pending",i[i.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(i){i[i.WithHardKernelDependency=0]="WithHardKernelDependency",i[i.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",i[i.Pure=2]="Pure",i[i.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(i){i.Always="always",i.Never="never",i.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(i){i[i.ModelChange=1]="ModelChange",i[i.Move=2]="Move",i[i.ChangeCellLanguage=5]="ChangeCellLanguage",i[i.Initialize=6]="Initialize",i[i.ChangeCellMetadata=7]="ChangeCellMetadata",i[i.Output=8]="Output",i[i.OutputItem=9]="OutputItem",i[i.ChangeCellContent=10]="ChangeCellContent",i[i.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",i[i.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",i[i.ChangeCellMime=13]="ChangeCellMime",i[i.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(i){i[i.Handle=0]="Handle",i[i.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(i){i[i.Replace=1]="Replace",i[i.Output=2]="Output",i[i.Metadata=3]="Metadata",i[i.CellLanguage=4]="CellLanguage",i[i.DocumentMetadata=5]="DocumentMetadata",i[i.Move=6]="Move",i[i.OutputItems=7]="OutputItems",i[i.PartialMetadata=8]="PartialMetadata",i[i.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var g;(function(i){i.scheme=_.Schemas.vscodeNotebookCell;const l=["W","X","Y","Z","a","b","c","d","e","f"],S=new RegExp(`^[${l.join("")}]+`),p=7;function T(L,q){const W=q.toString(p),Z=`${W.length<l.length?l[W.length-1]:"z"}${W}s${(0,o.encodeBase64)(o.VSBuffer.fromString(L.scheme),!0,!0)}`;return L.with({scheme:i.scheme,fragment:Z})}i.generate=T;function U(L){if(L.scheme!==i.scheme)return;const q=L.fragment.indexOf("s");if(q<0)return;const W=parseInt(L.fragment.substring(0,q).replace(S,""),p),R=(0,o.decodeBase64)(L.fragment.substring(q+1)).toString();if(!isNaN(W))return{handle:W,notebook:L.with({scheme:R,fragment:null})}}i.parse=U;const j=/^(\d{8,})(\w[\w\d+.-]*)$/;function x(L,q){return L.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${L.scheme!==_.Schemas.file?L.scheme:""}`})}i.generateCellOutputUri=x;function C(L){if(L.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(L.fragment);if(!q)return;const W=q[1]&&q[1]!==""?q[1]:void 0,R=q[2];return{outputId:W,notebook:L.with({scheme:R||_.Schemas.file,fragment:null})}}i.parseCellOutputUri=C;function z(L,q,W){return L.with({scheme:W,fragment:`ch${q.toString().padStart(7,"0")}${L.scheme!==_.Schemas.file?L.scheme:""}`})}i.generateCellUri=z;function N(L,q){if(L.scheme!==q)return;const W=j.exec(L.fragment);return W?{handle:Number(W[1]),notebook:L.with({scheme:L.fragment.substring(W[0].length)||_.Schemas.file,fragment:null})}:void 0}i.parseCellUri=N})(g=e.CellUri||(e.CellUri={}));const A=i=>E.isWindows?i.replace(/\//g,"\\"):i;class c{constructor(l=[],S=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=S,this.order=[...new Set(l)].map(p=>({pattern:p,matches:y.parse(A(p))}))}sort(l){const S=new Map(b.Iterable.map(l,T=>[T,A(T)]));let p=[];for(const{matches:T}of this.order)for(const[U,j]of S)if(T(j)){p.push(U),S.delete(U);break}return S.size&&(p=p.concat([...S.keys()].sort((T,U)=>this.defaultOrder.indexOf(T)-this.defaultOrder.indexOf(U)))),p}prioritize(l,S){const p=this.findIndex(l);if(p===-1){this.order.unshift({pattern:l,matches:y.parse(A(l))});return}const T=new Set(S.map(j=>this.findIndex(j,p)));T.delete(-1);const U=Array.from(T).sort();this.order.splice(p+1,0,...U.map(j=>this.order[j]));for(let j=U.length-1;j>=0;j--)this.order.splice(U[j],1)}toArray(){return this.order.map(l=>l.pattern)}findIndex(l,S=this.order.length){const p=A(l);for(let T=0;T<S;T++)if(this.order[T].matches(p))return T;return-1}}e.MimeTypeDisplayOrder=c;function v(i,l,S,p=(T,U)=>T===U){const T=[];function U(C,z,N){if(z===0&&N.length===0)return;const L=T[T.length-1];L&&L.start+L.deleteCount===C?(L.deleteCount+=z,L.toInsert.push(...N)):T.push({start:C,deleteCount:z,toInsert:N})}let j=0,x=0;for(;;){if(j===i.length){U(j,0,l.slice(x));break}if(x===l.length){U(j,i.length-j,[]);break}const C=i[j],z=l[x];if(p(C,z)){j+=1,x+=1;continue}S(z)?(U(j,1,[]),j+=1):(U(j,0,[z]),x+=1)}return T}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(i){i.default="default",i.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(i){const l=i;return!!((typeof l.include=="string"||y.isRelativePattern(l.include))&&(typeof l.exclude=="string"||y.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=u;function n(i,l,S){if(Array.isArray(i.viewType)&&i.viewType.indexOf(l)>=0||i.viewType===l)return!0;if(i.filenamePattern){const p=u(i.filenamePattern)?i.filenamePattern.include:i.filenamePattern,T=u(i.filenamePattern)?i.filenamePattern.exclude:void 0;if(y.match(p,(0,P.basename)(S.fsPath).toLowerCase()))return!(T&&y.match(T,(0,P.basename)(S.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(i){i[i.Left=1]="Left",i[i.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(l){return`${s._prefix}${l}`}static parse(l){if(l.startsWith(s._prefix))return l.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ce[167],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var y;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(y=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(Ce[168],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=o;function y(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=y;function b(_){return Array.from(_.entries()).map(P=>[P[0],o(P[1].map)])}e.serializeEnvironmentVariableCollections=b;function M(_){return new Map(_.map(P=>[P[0],{map:y(P[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[47],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(M){M.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var y;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(y=e.TestPosition||(e.TestPosition={}));class b{constructor(_,P=_.length){if(this.path=_,this.viewEnd=P,_.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,P,E=_.parent){if(_.id===P)return new b([P]);const k=[_.id];for(let O=E;O&&O.id!==P;O=O.parent)k.push(O.id);return k.push(P),new b(k.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const P=_.indexOf("\0");return P===-1?_:_.slice(0,P)}static fromString(_){return new b(_.split("\0"))}static join(_,P){return new b([..._.path,P])}static joinToString(_,P){return _.toString()+"\0"+P}static compare(_,P){return _===P?0:P.startsWith(_+"\0")?2:_.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new b(this.path,_)}compare(_){if(typeof _=="string")return b.compare(this.toString(),_);for(let P=0;P<_.viewEnd&&P<this.viewEnd;P++)if(_.path[P]!==this.path[P])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=b}),define(Ce[48],Ie([1,0,2,49]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var M;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(s){s.serialize=i=>({range:i.range.toJSON(),uri:i.uri.toJSON()}),s.deserialize=i=>({range:y.Range.lift(i.range),uri:o.URI.revive(i.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var P;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var E;(function(s){s.serialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&_.serialize(i.location)}),s.deserialize=i=>({message:i.message,type:0,expected:i.expected,actual:i.actual,location:i.location&&_.deserialize(i.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var k;(function(s){s.serialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&_.serialize(i.location)}),s.deserialize=i=>({message:i.message,type:1,offset:i.offset,length:i.length,location:i.location&&_.deserialize(i.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(s){s.serialize=i=>i.type===0?E.serialize(i):k.serialize(i),s.deserialize=i=>i.type===0?E.deserialize(i):k.deserialize(i)})(O=e.ITestMessage||(e.ITestMessage={}));var w;(function(s){s.serializeWithoutMessages=i=>({state:i.state,duration:i.duration,messages:[]}),s.serialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(O.serialize)}),s.deserialize=i=>({state:i.state,duration:i.duration,messages:i.messages.map(O.deserialize)})})(w=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",I=(s,i)=>s+m+i;e.namespaceTestTag=I;const f=s=>{const i=s.indexOf(m);return{ctrlId:s.slice(0,i),tagId:s.slice(i+1)}};e.denamespaceTestTag=f;var a;(function(s){s.serialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?.toJSON(),range:i.range?.toJSON()||null,description:i.description,error:i.error,sortText:i.sortText}),s.deserialize=i=>({extId:i.extId,label:i.label,tags:i.tags,busy:i.busy,children:void 0,uri:i.uri?o.URI.revive(i.uri):void 0,range:i.range?y.Range.lift(i.range):null,description:i.description,error:i.error,sortText:i.sortText})})(a=e.ITestItem||(e.ITestItem={}));var h;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var d;(function(s){s.serialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:a.serialize(i.item)}),s.deserialize=i=>({controllerId:i.controllerId,expand:i.expand,parent:i.parent,item:a.deserialize(i.item)})})(d=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=i=>{let l;return i.item&&(l={},i.item.label!==void 0&&(l.label=i.item.label),i.item.tags!==void 0&&(l.tags=i.item.tags),i.item.busy!==void 0&&(l.busy=i.item.busy),i.item.uri!==void 0&&(l.uri=i.item.uri?.toJSON()),i.item.range!==void 0&&(l.range=i.item.range?.toJSON()),i.item.description!==void 0&&(l.description=i.item.description),i.item.error!==void 0&&(l.error=i.item.error),i.item.sortText!==void 0&&(l.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:l,docv:i.docv}},s.deserialize=i=>{let l;return i.item&&(l={},i.item.label!==void 0&&(l.label=i.item.label),i.item.tags!==void 0&&(l.tags=i.item.tags),i.item.busy!==void 0&&(l.busy=i.item.busy),i.item.range!==void 0&&(l.range=i.item.range?y.Range.lift(i.item.range):null),i.item.description!==void 0&&(l.description=i.item.description),i.item.error!==void 0&&(l.error=i.item.error),i.item.sortText!==void 0&&(l.sortText=i.item.sortText)),{extId:i.extId,expand:i.expand,item:l,docv:i.docv}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const A=(s,i)=>{i.expand!==void 0&&(s.expand=i.expand),i.item!==void 0&&(s.item=s.item?Object.assign(s.item,i.item):i.item)};e.applyTestItemUpdate=A;var c;(function(s){s.serializeWithoutMessages=i=>({...d.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(w.serializeWithoutMessages),retired:i.retired}),s.serialize=i=>({...d.serialize(i),ownComputedState:i.ownComputedState,computedState:i.computedState,tasks:i.tasks.map(w.serialize),retired:i.retired})})(c=e.TestResultItem||(e.TestResultItem={}));var v;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(v=e.DetailType||(e.DetailType={}));var t;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(t=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=i=>i.op===0?{op:i.op,item:d.deserialize(i.item)}:i.op===1?{op:i.op,item:g.deserialize(i.item)}:i,s.serialize=i=>i.op===0?{op:i.op,item:d.serialize(i.item)}:i.op===1?{op:i.op,item:g.serialize(i.item)}:i})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(i){}update(i){}remove(i,l){}complete(){}}e.IncrementalChangeCollector=n;class r{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const l=this.createChangeCollector();for(const S of i)switch(S.op){case 0:{const p=d.deserialize(S.item);if(p.parent){if(this.items.has(p.parent)){const T=this.items.get(p.parent);T.children.add(p.item.extId);const U=this.createItem(p,T);this.items.set(p.item.extId,U),l.add(U)}}else{const T=this.createItem(p);this.roots.add(T),this.items.set(p.item.extId,T),l.add(T)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=g.deserialize(S.item),T=this.items.get(p.extId);if(!T)break;p.expand!==void 0&&(T.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(T,p),l.update(T);break}case 2:{const p=this.items.get(S.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const T=[[S.itemId]];for(;T.length;)for(const U of T.pop()){const j=this.items.get(U);j&&(T.push(j.children),this.items.delete(U),l.remove(j,j!==p),j.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(S.itemId);break;case 3:this.updatePendingRoots(S.amount);break;case 5:this._tags.set(S.tag.id,S.tag);break;case 6:this._tags.delete(S.id);break}l.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=r}),define(Ce[64],Ie([1,0,14,5,7,44,48,47]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(d,g)=>d===g,O={range:(d,g)=>d===g?!0:!d||!g?!1:d.equalsRange(g),busy:k,label:k,description:k,error:k,tags:(d,g)=>!(d.length!==g.length||d.some(A=>!g.includes(A)))},w=(d,g)=>{let A;for(const[c,v]of Object.entries(O))v(d[c],g[c])||(A?A[c]=g[c]:A={[c]:g[c]});return A};class m extends b.Disposable{constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new y.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const A of this.tree.values())this.updateExpandability(A)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const A=this.diff[this.diff.length-1];if(A&&g.op===1){if(A.op===1&&A.item.extId===g.item.extId){(0,_.applyTestItemUpdate)(A.item,g.item);return}if(A.op===0&&A.item.item.extId===g.item.extId){(0,_.applyTestItemUpdate)(A.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,A){const c=this.tree.get(g);if(!!c){if((c.expandLevels===void 0||A>c.expandLevels)&&(c.expandLevels=A),c.expand===1){const v=this.resolveChildren(c);return v.isOpen()?this.expandChildren(c,A-1):v.wait().then(()=>this.expandChildren(c,A-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.expandChildren(c,A-1)):this.expandChildren(c,A-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,A){switch(A.op){case 3:this.removeItem(P.TestId.joinToString(g.fullId,A.id));break;case 0:this.upsertItem(A.item,g);break;case 5:for(const c of A.ops)this.onTestItemEvent(g,c);break;case 1:this.diffTagRefs(A.new,A.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:A.update,docv:this.options.getDocumentVersion(g.actual.uri)}});break;default:(0,M.assertNever)(A)}}upsertItem(g,A){const c=P.TestId.fromExtHostTestItem(g,this.root.id,A?.actual),v=this.options.getApiFor(g);v.parent&&v.parent!==A?.actual&&this.options.getChildren(v.parent).delete(g.id);let t=this.tree.get(c.toString());if(!t){t={fullId:c,actual:g,parent:A?c.parentId:null,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(g,A),this.pushDiff({op:0,item:{parent:t.parent&&t.parent.toString(),controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,t,A);return}if(t.actual===g){this.connectItem(g,t,A);return}const u=this.options.getChildren(t.actual),n=t.actual,r=w(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,t.actual=g,t.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,c.toString()),delete r.tags),this.onTestItemEvent(t,{op:4,update:r})),this.connectItemAndChildren(g,t,A);for(const[s,i]of u)this.options.getChildren(g).get(i.id)||this.removeItem(P.TestId.joinToString(c,i.id))}diffTagRefs(g,A,c){const v=new Set(A.map(t=>t.id));for(const t of g)v.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:c,item:{tags:g.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const A=this.tags.get(g.id);A?A.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const A=this.tags.get(g);A&&!--A.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,A){this.options.getApiFor(g).parent=A&&A.actual!==this.root?A.actual:void 0}connectItem(g,A,c){this.setItemParent(g,c);const v=this.options.getApiFor(g);v.parent=c?.actual,v.listener=t=>this.onTestItemEvent(A,t),this.updateExpandability(A)}connectItemAndChildren(g,A,c){this.connectItem(g,A,c);for(const[v,t]of this.options.getChildren(g))this.upsertItem(t,A)}updateExpandability(g){let A;this._resolveHandler?g.resolveBarrier?A=g.resolveBarrier.isOpen()?3:2:A=g.actual.canResolveChildren?1:0:A=0,A!==g.expand&&(g.expand=A,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:A}}),A===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,A){if(A<0)return;const c=[];for(const[v,t]of this.options.getChildren(g.actual)){const u=this.expand(P.TestId.joinToString(g.fullId,t.id),A);(0,o.isThenable)(u)&&c.push(u)}if(c.length)return Promise.all(c).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const t=new o.Barrier;return t.open(),t}g.expand=2,this.pushExpandStateUpdate(g);const A=g.resolveBarrier=new o.Barrier,c=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let v;try{v=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(t){c(t)}return(0,o.isThenable)(v)?v.catch(c).then(()=>{A.open(),this.updateExpandability(g)}):(A.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const A=this.tree.get(g);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const c=[A];for(;c.length;){const v=c.pop();if(!!v){this.options.getApiFor(v.actual).listener=void 0;for(const t of v.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(v.fullId.toString());for(const[t,u]of this.options.getChildren(v.actual))c.push(this.tree.get(P.TestId.joinToString(v.fullId,u.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class I extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=I;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class a extends Error{constructor(g,A,c){super(`TestItem with ID "${g}" is from controller "${A}" and cannot be added as a child of an item from controller "${c}".`)}}e.MixedTestItemController=a;const h=(d,g,A)=>{let c=new Map;return{get size(){return c.size},forEach(v,t){for(const u of c.values())v.call(t,u,this)},[Symbol.iterator](){return c.entries()},replace(v){const t=new Map,u=new Set(c.keys()),n={op:5,ops:[]};for(const r of v){if(!(r instanceof A))throw new f(r.id);const s=g(r).controllerId;if(s!==d.controllerId)throw new a(r.id,s,d.controllerId);if(t.has(r.id))throw new I(r.id);t.set(r.id,r),u.delete(r.id),n.ops.push({op:0,item:r})}for(const r of u.keys())n.ops.push({op:3,id:r});d.listener?.(n),c=t},add(v){if(!(v instanceof A))throw new f(v.id);c.set(v.id,v),d.listener?.({op:0,item:v})},delete(v){c.delete(v)&&d.listener?.({op:3,id:v})},get(v){return c.get(v)},toJSON(){return Array.from(c.values())}}};e.createTestItemChildren=h}),define(Ce[89],Ie([1,0,64]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const y=new WeakMap,b=(_,P)=>{const E={controllerId:P};return y.set(_,E),E};e.createPrivateApiFor=b;const M=_=>{const P=y.get(_);if(!P)throw new o.InvalidTestItemError(_?.id||"<unknown>");return P};e.getPrivateApiFor=M}),define(Ce[169],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var y;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(y=e.VariableKind||(e.VariableKind={}));class b extends Error{constructor(_,P){super(P),this.variable=_}}e.VariableError=b}),define(Ce[170],Ie([1,0,19,59,10,26,21,76,142,169,9]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(I,f,a,h){this._contributedVariables=new Map,this._context=I,this._labelService=f,this._userHomePromise=a,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(I){if(_.isWindows){const f=Object.create(null);return Object.keys(I).forEach(a=>{f[a.toLowerCase()]=I[a]}),f}return I}resolveWithEnvironment(I,f,a){return this.recursiveResolve({env:this.prepareEnv(I),userHome:void 0},f?f.uri:void 0,a)}async resolveAsync(I,f){const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,I?I.uri:void 0,f)}async resolveAnyBase(I,f,a,h){const d=M.deepClone(f);_.isWindows&&d.windows?Object.keys(d.windows).forEach(A=>d[A]=d.windows[A]):_.isMacintosh&&d.osx?Object.keys(d.osx).forEach(A=>d[A]=d.osx[A]):_.isLinux&&d.linux&&Object.keys(d.linux).forEach(A=>d[A]=d.linux[A]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,I?I.uri:void 0,d,a,h)}async resolveAnyAsync(I,f,a){return this.resolveAnyBase(I,f,a)}async resolveAnyMap(I,f,a){const h=new Map;return{newConfig:await this.resolveAnyBase(I,f,a,h),resolvedVariables:h}}resolveWithInteractionReplace(I,f,a,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,f,a,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,f){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,f)}async recursiveResolve(I,f,a,h,d){if(b.isString(a))return this.resolveString(I,f,a,h,d);if(Array.isArray(a))return Promise.all(a.map(g=>this.recursiveResolve(I,f,g,h,d)));if(b.isObject(a)){const g=Object.create(null),A=await Promise.all(Object.keys(a).map(async c=>[await this.resolveString(I,f,c,h,d),await this.recursiveResolve(I,f,a[c],h,d)]));for(const[c,v]of A)g[c]=v;return g}return a}resolveString(I,f,a,h,d){return(0,O.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,A)=>{if(A.includes(w.VARIABLE_LHS))return g;let c=await this.evaluateSingleVariable(I,g,A,f,h);return d?.set(A,c),c!==g&&b.isString(c)&&c.match(w.VARIABLE_REGEXP)&&(c=await this.resolveString(I,f,c,h,d)),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}async evaluateSingleVariable(I,f,a,h,d){let g;const A=a.split(":");A.length>1&&(a=A[0],g=A[1]);const c=u=>{const n=this._context.getFilePath();if(n)return n;throw new k.VariableError(u,(0,E.localize)(0,null,f))},v=u=>{const n=c(u);if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new k.VariableError(u,(0,E.localize)(1,null,f,o.basename(n)))},t=u=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new k.VariableError(u,(0,E.localize)(2,null,f,g))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(u,(0,E.localize)(3,null,f)):new k.VariableError(u,(0,E.localize)(4,null,f))};switch(a){case"env":if(g){if(I.env){const u=I.env[_.isWindows?g.toLowerCase():g];if(b.isString(u))return u}return""}throw new k.VariableError(k.VariableKind.Env,(0,E.localize)(5,null,f));case"config":if(g){const u=this._context.getConfigurationValue(h,g);if(b.isUndefinedOrNull(u))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(6,null,f,g));if(b.isObject(u))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(7,null,f,g));return u}throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(8,null,f));case"command":return this.resolveFromMap(k.VariableKind.Command,f,g,d,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,f,g,d,"input");case"extensionInstallFolder":if(g){const u=await this._context.getExtension(g);if(!u)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,f,g));return this.fsPath(u.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,f));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.WorkspaceFolder)));case"cwd":return h||g?(0,P.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.Cwd))):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(t(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(I.userHome)return I.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,E.localize)(11,null,f))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new k.VariableError(k.VariableKind.LineNumber,(0,E.localize)(12,null,f))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new k.VariableError(k.VariableKind.SelectedText,(0,E.localize)(13,null,f))}case"file":return c(k.VariableKind.File);case"fileWorkspaceFolder":return v(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||g?o.relative(this.fsPath(t(k.VariableKind.RelativeFile)),c(k.VariableKind.RelativeFile)):c(k.VariableKind.RelativeFile);case"relativeFileDirname":{const u=o.dirname(c(k.VariableKind.RelativeFileDirname));if(h||g){const n=o.relative(this.fsPath(t(k.VariableKind.RelativeFileDirname)),u);return n.length===0?".":n}return u}case"fileDirname":return o.dirname(c(k.VariableKind.FileDirname));case"fileExtname":return o.extname(c(k.VariableKind.FileExtname));case"fileBasename":return o.basename(c(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=o.basename(c(k.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-o.extname(u).length)}case"fileDirnameBasename":return o.basename(o.dirname(c(k.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||f}case"execInstallFolder":{const u=this._context.getAppRoot();return u||f}case"pathSeparator":return o.sep;default:try{const u=g?`${a}:${g}`:a;return this.resolveFromMap(k.VariableKind.Unknown,f,u,d,void 0)}catch{return f}}}}resolveFromMap(I,f,a,h,d){if(a&&h){const g=d===void 0?h[a]:h[d+":"+a];if(typeof g=="string")return g;throw new k.VariableError(I,(0,E.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[90],Ie([1,0,3,87]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var b;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const a=f;return(0,y.isEditorInput)(a?.editor)&&(0,y.isEditorInput)(a?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const a=f;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=m;function I(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(Ce[171],Ie([1,0,3,90]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(M){const _=M;return typeof M=="number"||(0,y.isEditorGroup)(_)}e.isPreferredGroup=b}),define(Ce[172],Ie([1,0,3,147]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(y.IEnvironmentService)}),define(Ce[173],Ie([1,0,27,5,19]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class _{constructor(w){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=w,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const w of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(w.identifier),w),this._extensionsArr.push(w),Array.isArray(w.activationEvents))for(let m of w.activationEvents)m==="onUri"&&(m=`onUri:${o.ExtensionIdentifier.toKey(w.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(w)}}set(w){this._extensionDescriptions=w,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(w,m){this._extensionDescriptions=k(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(w);const I=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,I.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(I)}static _findLoopingExtensions(w){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(d){this._nodesSet.has(d)||(this._nodesSet.add(d),this._nodesArr.push(d))}addArc(d,g){this.addNode(d),this.addNode(g),this._arcs.has(d)?this._arcs.get(d).push(g):this._arcs.set(d,[g])}getArcs(d){return this._arcs.has(d)?this._arcs.get(d):[]}hasOnlyGoodArcs(d,g){const A=m.getArcs(d);for(let c=0;c<A.length;c++)if(!g.has(A[c]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const d of w){const g=o.ExtensionIdentifier.toKey(d.identifier);if(I.set(g,d),d.extensionDependencies)for(const A of d.extensionDependencies){const c=o.ExtensionIdentifier.toKey(A);m.addArc(g,c)}}const f=new Set;m.getNodes().filter(d=>m.getArcs(d).length===0).forEach(d=>f.add(d));const a=m.getNodes().filter(d=>!f.has(d));let h;do{h=!1;for(let d=0;d<a.length;d++){const g=a[d];m.hasOnlyGoodArcs(g,f)&&(a.splice(d,1),d--,f.add(g),h=!0)}}while(h);return a.map(d=>I.get(d))}containsActivationEvent(w){return this._activationMap.has(w)}containsExtension(w){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const m=this._activationMap.get(w);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(w){const m=this._extensionsMap.get(o.ExtensionIdentifier.toKey(w));return m||void 0}getExtensionDescriptionByUUID(w){for(const m of this._extensionsArr)if(m.uuid===w)return m}getExtensionDescriptionByIdOrUUID(w,m){return this.getExtensionDescription(w)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var P;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(P||(P={}));function E(O,w){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,I=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(m!==I)return m-I;const f=b.posix.basename(O.extensionLocation.path),a=b.posix.basename(w.extensionLocation.path);return f<a?-1:f>a?1:0}function k(O,w){const m=new Set;return w.forEach(I=>m.add(o.ExtensionIdentifier.toKey(I))),O.filter(I=>!m.has(o.ExtensionIdentifier.toKey(I.identifier)))}}),define(Ce[91],Ie([1,0,23]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var y;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var b;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function _(k){const O=o.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=_;function P(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=P;var E;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[24],Ie([1,0,5,2,3,27,153]),function(ne,e,o,y,b,M,_){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class E{constructor(i){this.affinity=i,this.kind=1}equals(i){return this.kind===i.kind&&this.affinity===i.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class k{constructor(){this.kind=2,this.affinity=0}equals(i){return this.kind===i.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(i){return this.kind===i.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(i){this.dependency=i}}e.MissingExtensionDependency=w;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(i,l){const S=[],p=[],T=[],U=[],j=d(this._allExtensions),x=d(i),C=(q,W)=>q.extensionLocation.toString()===W.extensionLocation.toString()||q.isBuiltin===W.isBuiltin||q.isUserBuiltin===W.isUserBuiltin||q.isUnderDevelopment===W.isUnderDevelopment;for(const q of this._allExtensions){const W=x.get(M.ExtensionIdentifier.toKey(q.identifier));if(!W){S.push(q.identifier),j.delete(M.ExtensionIdentifier.toKey(q.identifier));continue}if(!C(q,W)){S.push(q.identifier),j.delete(M.ExtensionIdentifier.toKey(q.identifier));continue}}for(const q of i){const W=j.get(M.ExtensionIdentifier.toKey(q.identifier));if(!W){p.push(q);continue}if(!C(W,q)){S.push(W.identifier),j.delete(M.ExtensionIdentifier.toKey(W.identifier));continue}}const z=h(this._myExtensions),N=h(l);for(const q of this._myExtensions)N.has(M.ExtensionIdentifier.toKey(q))||T.push(q);for(const q of l)z.has(M.ExtensionIdentifier.toKey(q))||U.push(q);const L={toRemove:S,toAdd:p,myToRemove:T,myToAdd:U};return this.delta(L),L}delta(i){const{toRemove:l,toAdd:S,myToRemove:p,myToAdd:T}=i,U=h(l),j=h(p);for(let x=0;x<this._allExtensions.length;x++)U.has(M.ExtensionIdentifier.toKey(this._allExtensions[x].identifier))&&(this._allExtensions.splice(x,1),x--);for(let x=0;x<this._myExtensions.length;x++)j.has(M.ExtensionIdentifier.toKey(this._myExtensions[x]))&&(this._myExtensions.splice(x,1),x--);for(const x of S)this._allExtensions.push(x);for(const x of T)this._myExtensions.push(x)}containsExtension(i){for(const l of this._myExtensions)if(M.ExtensionIdentifier.equals(l,i))return!0;return!1}}e.ExtensionHostExtensions=f;class a{constructor(i){if(this[P]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,i)for(const l of i)this.add(l)}get size(){return this._map.size}add(i){return this._map.set(this._toKey(i),i),this}clear(){this._map.clear()}delete(i){return this._map.delete(this._toKey(i))}has(i){return this._map.has(this._toKey(i))}forEach(i,l){this._map.forEach(S=>i.call(l,S,S,this))}*entries(){for(const[i,l]of this._map)yield[l,l]}keys(){return this._map.values()}values(){return this._map.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=a;function h(s){const i=new Set;for(const l of s)i.add(M.ExtensionIdentifier.toKey(l));return i}e.extensionIdentifiersArrayToSet=h;function d(s){const i=new Map;for(const l of s)i.set(M.ExtensionIdentifier.toKey(l.identifier),l);return i}function g(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}e.isProposedApiEnabled=g;function A(s,i){if(!g(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=A;class c{constructor(i,l,S,p){this.codeLoadingTime=i,this.activateCallTime=l,this.activateResolvedTime=S,this.activationReason=p}}e.ActivationTimes=c;class v{constructor(i,l){this.description=i,this.value=l}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function u(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(s,i){return{identifier:new M.ExtensionIdentifier((0,_.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=n;class r{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(i){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(i,l){return Promise.resolve(0)}getInspectPorts(i,l){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(i,l){return Promise.resolve()}}e.NullExtensionService=r}),define(Ce[174],Ie([1,0,11,27,24,15,14]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class P{constructor(h,d,g,A){this.startup=h,this.codeLoadingTime=d,this.activateCallTime=g,this.activateResolvedTime=A}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class E{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,d){return h===-1||d===-1?-1:d-h}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class k{constructor(h,d,g,A,c,v){this.activationFailed=h,this.activationFailedError=d,this.activationTimes=g,this.module=A,this.exports=c,this.subscriptions=v}}e.ActivatedExtension=k;class O extends k{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class w extends k{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class m extends k{constructor(h){super(!0,h,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let I=class{constructor(h,d,g,A,c){this._logService=c,this._registry=h,this._resolvedExtensionsSet=new Set,d.forEach(v=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(v))),this._externalExtensionsMap=new Map,g.forEach(v=>this._externalExtensionsMap.set(y.ExtensionIdentifier.toKey(v),v)),this._host=A,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,d]of this._operations)d.dispose()}isActivated(h){const d=this._operations.get(y.ExtensionIdentifier.toKey(h));return Boolean(d&&d.value)}getActivatedExtension(h){const d=this._operations.get(y.ExtensionIdentifier.toKey(h));if(!d||!d.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return d.value}async activateByEvent(h,d){if(this._alreadyActivatedEvents[h])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(g.map(A=>({id:A.identifier,reason:{startup:d,extensionId:A.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,d){const g=this._registry.getExtensionDescription(h);if(!g)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:g.identifier,reason:d}])}async _activateExtensions(h){const d=h.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(d.map(g=>g.wait()))}_handleActivationRequest(h){if(this._operations.has(y.ExtensionIdentifier.toKey(h.id)))return this._operations.get(y.ExtensionIdentifier.toKey(h.id));if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(h.id)))return this._createAndSaveOperation(h,null,[],null);const d=this._registry.getExtensionDescription(h.id);if(!d){const c=new Error(`Cannot activate unknown extension '${h.id.value}'`),v=this._createAndSaveOperation(h,null,[],new m(c));return this._host.onExtensionActivationError(h.id,c,new b.MissingExtensionDependency(h.id.value)),v}const g=[],A=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const c of A){if(this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(c)))continue;const v=this._operations.get(y.ExtensionIdentifier.toKey(c));if(v){g.push(v);continue}if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(c))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(y.ExtensionIdentifier.toKey(c)),reason:h.reason}));continue}const t=this._registry.getExtensionDescription(c);if(t){if(!t.main&&!t.browser)continue;g.push(this._handleActivationRequest({id:t.identifier,reason:h.reason}));continue}const u=d.displayName||d.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${c}'`),r=this._createAndSaveOperation(h,d.displayName,[],new m(n));return this._host.onExtensionActivationError(d.identifier,n,new b.MissingExtensionDependency(c)),r}return this._createAndSaveOperation(h,d.displayName,g,null)}_createAndSaveOperation(h,d,g,A){const c=new f(h.id,d,h.reason,g,A,this._host,this._logService);return this._operations.set(y.ExtensionIdentifier.toKey(h.id),c),c}};I=xe([$e(4,M.ILogService)],I),e.ExtensionsActivator=I;let f=class{constructor(h,d,g,A,c,v,t){this._id=h,this._displayName=d,this._reason=g,this._deps=A,this._value=c,this._host=v,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const d=this._deps[h];if(d.value&&!d.value.activationFailed){this._deps.splice(h,1),h--;continue}if(d.value&&d.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);g.detail=d.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const d=new Error;if(h&&h.name&&(d.name=h.name),h&&h.message?d.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:d.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(d.stack=h.stack),this._value=new m(d),this._isDisposed&&o.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,d,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=xe([$e(6,M.ILogService)],f)}),define(Ce[175],Ie([1,0,15,28,24]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends o.LogService{constructor(P,E){super(P.createLogger(E.logFile,{name:b.ExtensionHostLogFileName}))}};M=xe([$e(0,o.ILoggerService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[6],Ie([1,0,16,11,75,25,73,9,10,2,42,39,84,24]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I){"use strict";var f,a,h,d,g,A,c,v,t,u,n,r,s,i,l,S,p,T,U,j,x,C,z;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function N($){function F(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(F,$),Object.setPrototypeOf(F.prototype,$.prototype),F}let L=A=class{constructor(F){f.set(this,void 0),Je(this,f,F,"f")}static from(...F){let ie=F;return new A(function(){if(ie){for(const be of ie)be&&typeof be.dispose=="function"&&be.dispose();ie=void 0}})}dispose(){typeof Oe(this,f,"f")=="function"&&(Oe(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,L=A=xe([N],L),e.Disposable=L;let q=c=class{constructor(F,ie){if(F<0)throw(0,y.illegalArgument)("line must be non-negative");if(ie<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=F,this._character=ie}static Min(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let be=1;be<F.length;be++){const qe=F[be];qe.isBefore(ie)&&(ie=qe)}return ie}static Max(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let be=1;be<F.length;be++){const qe=F[be];qe.isAfter(ie)&&(ie=qe)}return ie}static isPosition(F){if(!F)return!1;if(F instanceof c)return!0;const{line:ie,character:be}=F;return typeof ie=="number"&&typeof be=="number"}static of(F){if(F instanceof c)return F;if(this.isPosition(F))return new c(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ie=0){if(F===null||ie===null)throw(0,y.illegalArgument)();let be;return typeof F>"u"?be=0:typeof F=="number"?be=F:(be=typeof F.lineDelta=="number"?F.lineDelta:0,ie=typeof F.characterDelta=="number"?F.characterDelta:0),be===0&&ie===0?this:new c(this.line+be,this.character+ie)}with(F,ie=this.character){if(F===null||ie===null)throw(0,y.illegalArgument)();let be;return typeof F>"u"?be=this.line:typeof F=="number"?be=F:(be=typeof F.line=="number"?F.line:this.line,ie=typeof F.character=="number"?F.character:this.character),be===this.line&&ie===this.character?this:new c(be,ie)}toJSON(){return{line:this.line,character:this.character}}};q=c=xe([N],q),e.Position=q;let W=v=class{constructor(F,ie,be,qe){let tt,ut;if(typeof F=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof qe=="number"?(tt=new q(F,ie),ut=new q(be,qe)):q.isPosition(F)&&q.isPosition(ie)&&(tt=q.of(F),ut=q.of(ie)),!tt||!ut)throw new Error("Invalid arguments");tt.isBefore(ut)?(this._start=tt,this._end=ut):(this._start=ut,this._end=tt)}static isRange(F){return F instanceof v?!0:F?q.isPosition(F.start)&&q.isPosition(F.end):!1}static of(F){if(F instanceof v)return F;if(this.isRange(F))return new v(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(F){return v.isRange(F)?this.contains(F.start)&&this.contains(F.end):q.isPosition(F)?!(q.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ie=q.Max(F.start,this._start),be=q.Min(F.end,this._end);if(!ie.isAfter(be))return new v(ie,be)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ie=q.Min(F.start,this._start),be=q.Max(F.end,this.end);return new v(ie,be)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ie=this.end){if(F===null||ie===null)throw(0,y.illegalArgument)();let be;return F?q.isPosition(F)?be=F:(be=F.start||this.start,ie=F.end||this.end):be=this.start,be.isEqual(this._start)&&ie.isEqual(this.end)?this:new v(be,ie)}toJSON(){return[this.start,this.end]}};W=v=xe([N],W),e.Range=W;let R=t=class extends W{constructor(F,ie,be,qe){let tt,ut;if(typeof F=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof qe=="number"?(tt=new q(F,ie),ut=new q(be,qe)):q.isPosition(F)&&q.isPosition(ie)&&(tt=q.of(F),ut=q.of(ie)),!tt||!ut)throw new Error("Invalid arguments");super(tt,ut),this._anchor=tt,this._active=ut}static isSelection(F){return F instanceof t?!0:F?W.isRange(F)&&q.isPosition(F.anchor)&&q.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};R=t=xe([N],R),e.Selection=R;class Z{constructor(F,ie,be){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,y.illegalArgument)("port");if(typeof be<"u"&&(typeof be!="string"||be.length===0||!/^[0-9A-Za-z\-]+$/.test(be)))throw(0,y.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(ie),this.connectionToken=be}}e.ResolvedAuthority=Z;class le extends Error{constructor(F,ie=m.RemoteAuthorityResolverErrorCode.Unknown,be){super(F),this._message=F,this._code=ie,this._detail=be,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,le.prototype)}static NotAvailable(F,ie){return new le(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(F){return new le(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=le;var oe;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var ue;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(ue=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=u=class{constructor(F,ie){this._range=F,this._newText=ie}static isTextEdit(F){return F instanceof u?!0:F?W.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ie){return new u(F,ie)}static insert(F,ie){return u.replace(new W(F,F),ie)}static delete(F){return u.replace(F,"")}static setEndOfLine(F){const ie=new u(new W(new q(0,0),new q(0,0)),"");return ie.newEol=F,ie}get range(){return this._range}set range(F){if(F&&!W.isRange(F))throw(0,y.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,y.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,y.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=u=xe([N],ee),e.TextEdit=ee;let ve=n=class{constructor(F,ie){this.range=F,this.newCells=ie}static isNotebookCellEdit(F){return F instanceof n?!0:F?Vt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ie){return new n(F,ie)}static insertCells(F,ie){return new n(new Vt(F,F),ie)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,ie){const be=new n(new Vt(F,F),[]);return be.newCellMetadata=ie,be}static updateNotebookMetadata(F){const ie=new n(new Vt(0,0),[]);return ie.newNotebookMetadata=F,ie}};ve=n=xe([N],ve),e.NotebookEdit=ve;class we{constructor(F,ie){this.range=F,this.snippet=ie}static isSnippetTextEdit(F){return F instanceof we?!0:F?W.isRange(F.range)&&Pe.isSnippetString(F.snippet):!1}}e.SnippetTextEdit=we;var re;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(re=e.FileEditType||(e.FileEditType={}));let Ee=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ie,be,qe){this._edits.push({_type:1,from:F,to:ie,options:be,metadata:qe})}createFile(F,ie,be){this._edits.push({_type:1,from:void 0,to:F,options:ie,metadata:be})}deleteFile(F,ie,be){this._edits.push({_type:1,from:F,to:void 0,options:ie,metadata:be})}replaceNotebookMetadata(F,ie,be){this._edits.push({_type:3,metadata:be,uri:F,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(F,ie,be,qe){const tt=ie.start,ut=ie.end;(tt!==ut||be.length>0)&&this._edits.push({_type:5,uri:F,index:tt,count:ut-tt,cells:be,metadata:qe})}replaceNotebookCellMetadata(F,ie,be,qe){this._edits.push({_type:3,metadata:qe,uri:F,edit:{editType:8,index:ie,metadata:be}})}replace(F,ie,be,qe){this._edits.push({_type:2,uri:F,edit:new ee(ie,be),metadata:qe})}insert(F,ie,be,qe){this.replace(F,new W(ie,ie),be,qe)}delete(F,ie,be){this.replace(F,ie,"",be)}has(F){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===F.toString())}set(F,ie){if(ie)for(const be of ie)be&&(ve.isNotebookCellEdit(be)?be.newCellMetadata?this.replaceNotebookCellMetadata(F,be.range.start,be.newCellMetadata):be.newNotebookMetadata?this.replaceNotebookMetadata(F,be.newNotebookMetadata):this.replaceNotebookCells(F,be.range,be.newCells):we.isSnippetTextEdit(be)?this._edits.push({_type:6,uri:F,range:be.range,edit:be.snippet}):this._edits.push({_type:2,uri:F,edit:be}));else{for(let be=0;be<this._edits.length;be++){const qe=this._edits[be];qe._type===2&&qe.uri.toString()===F.toString()&&(this._edits[be]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(F){const ie=[];for(const be of this._edits)be._type===2&&be.uri.toString()===F.toString()&&ie.push(be.edit);return ie}entries(){const F=new M.ResourceMap;for(const ie of this._edits)if(ie._type===2){let be=F.get(ie.uri);be||(be=[ie.uri,[]],F.set(ie.uri,be)),be[1].push(ie.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ee=xe([N],Ee),e.WorkspaceEdit=Ee;let Pe=r=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof r?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=r._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ie=this._tabstop++){if(typeof F=="function"){const be=new r;be._tabstop=this._tabstop,F(be),this._tabstop=be._tabstop,F=be.value}else F=r._escape(F);return this.value+="${",this.value+=ie,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ie=this._tabstop++){const be=F.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=be,this.value+="|}",this}appendVariable(F,ie){if(typeof ie=="function"){const be=new r;be._tabstop=this._tabstop,ie(be),this._tabstop=be._tabstop,ie=be.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Pe=r=xe([N],Pe),e.SnippetString=Pe;var Fe;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(Fe=e.DiagnosticTag||(e.DiagnosticTag={}));var ze;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(ze=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Qe=s=class{constructor(F,ie){if(this.uri=F,ie)if(W.isRange(ie))this.range=W.of(ie);else if(q.isPosition(ie))this.range=new W(ie,ie);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof s?!0:F?W.isRange(F.range)&&k.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Qe=s=xe([N],Qe),e.Location=Qe;let Te=class{constructor(F,ie){this.location=F,this.message=ie}static is(F){return F?typeof F.message=="string"&&F.location&&W.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.location.range.isEqual(ie.location.range)&&F.location.uri.toString()===ie.location.uri.toString()}};Te=xe([N],Te),e.DiagnosticRelatedInformation=Te;let _e=class{constructor(F,ie,be=ze.Error){if(!W.isRange(F))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=F,this.message=ie,this.severity=be}toJSON(){return{severity:ze[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.severity===ie.severity&&F.code===ie.code&&F.severity===ie.severity&&F.source===ie.source&&F.range.isEqual(ie.range)&&(0,o.equals)(F.tags,ie.tags)&&(0,o.equals)(F.relatedInformation,ie.relatedInformation,Te.isEqual)}};_e=xe([N],_e),e.Diagnostic=_e;let ye=class{constructor(F,ie){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ie}};ye=xe([N],ye),e.Hover=ye;var ae;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ce=class{constructor(F,ie=ae.Text){this.range=F,this.kind=ie}toJSON(){return{range:this.range,kind:ae[this.kind]}}};ce=xe([N],ce),e.DocumentHighlight=ce;var Q;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var J;(function($){$[$.Deprecated=1]="Deprecated"})(J=e.SymbolTag||(e.SymbolTag={}));let D=i=class{constructor(F,ie,be,qe,tt){this.name=F,this.kind=ie,this.containerName=tt,typeof be=="string"&&(this.containerName=be),qe instanceof Qe?this.location=qe:be instanceof W&&(this.location=new Qe(qe,be)),i.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};D=i=xe([N],D),e.SymbolInformation=D;let B=l=class{constructor(F,ie,be,qe,tt){this.name=F,this.detail=ie,this.kind=be,this.range=qe,this.selectionRange=tt,this.children=[],l.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(l.validate)}};B=l=xe([N],B),e.DocumentSymbol=B;var H;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(H=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let V=class{constructor(F,ie){this.title=F,this.kind=ie}};V=xe([N],V),e.CodeAction=V;let te=S=class{constructor(F){this.value=F}append(F){return new S(this.value?this.value+S.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+S.sep)}};te.sep=".",te=S=xe([N],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let de=class{constructor(F,ie){if(this.range=F,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=xe([N],de),e.SelectionRange=de;class Y{constructor(F,ie,be,qe,tt,ut){this.kind=F,this.name=ie,this.detail=be,this.uri=qe,this.range=tt,this.selectionRange=ut}}e.CallHierarchyItem=Y;class pe{constructor(F,ie){this.fromRanges=ie,this.from=F}}e.CallHierarchyIncomingCall=pe;class ge{constructor(F,ie){this.fromRanges=ie,this.to=F}}e.CallHierarchyOutgoingCall=ge;var Ne;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(Ne=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Be=class{constructor(F,ie){this.range=F,this.command=ie}get isResolved(){return!!this.command}};Be=xe([N],Be),e.CodeLens=Be;let Ye=p=class{constructor(F,ie=!1){a.set(this,void 0),Je(this,a,new b.MarkdownString(F,{supportThemeIcons:ie}),"f")}static isMarkdownString(F){return F instanceof p?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return Oe(this,a,"f").value}set value(F){Oe(this,a,"f").value=F}get isTrusted(){return Oe(this,a,"f").isTrusted}set isTrusted(F){Oe(this,a,"f").isTrusted=F}get supportThemeIcons(){return Oe(this,a,"f").supportThemeIcons}set supportThemeIcons(F){Oe(this,a,"f").supportThemeIcons=F}get supportHtml(){return Oe(this,a,"f").supportHtml}set supportHtml(F){Oe(this,a,"f").supportHtml=F}get baseUri(){return Oe(this,a,"f").baseUri}set baseUri(F){Oe(this,a,"f").baseUri=F}appendText(F){return Oe(this,a,"f").appendText(F),this}appendMarkdown(F){return Oe(this,a,"f").appendMarkdown(F),this}appendCodeblock(F,ie){return Oe(this,a,"f").appendCodeblock(ie??"",F),this}};a=new WeakMap,Ye=p=xe([N],Ye),e.MarkdownString=Ye;let Ge=class{constructor(F,ie){this.label=F,this.documentation=ie}};Ge=xe([N],Ge),e.ParameterInformation=Ge;let ke=class{constructor(F,ie){this.label=F,this.documentation=ie,this.parameters=[]}};ke=xe([N],ke),e.SignatureInformation=ke;let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};nt=xe([N],nt),e.SignatureHelp=nt;var G;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(G=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let fe=class{constructor(F){this.value=F}};fe=xe([N],fe),e.InlayHintLabelPart=fe;let Ue=class{constructor(F,ie,be){this.position=F,this.label=ie,this.kind=be}};Ue=xe([N],Ue),e.InlayHint=Ue;var He;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ze;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function($){$[$.Deprecated=1]="Deprecated"})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));let We=class{constructor(F,ie){this.label=F,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ze[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};We=xe([N],We),e.CompletionItem=We;let it=class{constructor(F=[],ie=!1){this.items=F,this.isIncomplete=ie}};it=xe([N],it),e.CompletionList=it;let st=class{constructor(F,ie,be){this.insertText=F,this.range=ie,this.command=be}};st=xe([N],st),e.InlineSuggestion=st;let dt=class{constructor(F){this.commands=void 0,this.items=F}};dt=xe([N],dt),e.InlineSuggestionList=dt;let at=class{constructor(F,ie,be){this.insertText=F,this.range=ie,this.command=be}};at=xe([N],at),e.InlineSuggestionNew=at;let rt=class{constructor(F,ie){this.items=F,this.commands=ie}};rt=xe([N],rt),e.InlineSuggestionsNew=rt;var _t;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(_t=e.ViewColumn||(e.ViewColumn={}));var Ot;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ft;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(Ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var mt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(mt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var yt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(yt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Nt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Nt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ut;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Ut=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ve;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ve=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function F(ie){switch(ie){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=F}(Nt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(F,ie){if(ie&&!k.URI.isUri(ie))throw(0,y.illegalArgument)("target");if(!W.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.target=ie}};Mt=xe([N],Mt),e.DocumentLink=Mt;let Pt=class{constructor(F,ie,be,qe){this.red=F,this.green=ie,this.blue=be,this.alpha=qe}};Pt=xe([N],Pt),e.Color=Pt;let At=class{constructor(F,ie){if(ie&&!(ie instanceof Pt))throw(0,y.illegalArgument)("color");if(!W.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.color=ie}};At=xe([N],At),e.ColorInformation=At;let pt=class{constructor(F){if(!F||typeof F!="string")throw(0,y.illegalArgument)("label");this.label=F}};pt=xe([N],pt),e.ColorPresentation=pt;var Dt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Dt=e.ColorFormat||(e.ColorFormat={}));var Se;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(Se=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var De;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(De=e.TerminalExitReason||(e.TerminalExitReason={}));class me{constructor(F,ie,be){if(this.startIndex=F,this.length=ie,this.tooltip=be,typeof F!="number"||F<0)throw(0,y.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,y.illegalArgument)("length");if(be!==void 0&&typeof be!="string")throw(0,y.illegalArgument)("tooltip")}}e.TerminalLink=me;var K;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(K=e.TerminalLocation||(e.TerminalLocation={}));class Ae{constructor(F){if(this.options=F,typeof F!="object")throw(0,y.illegalArgument)("options")}}e.TerminalProfile=Ae;var Le;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var et;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(et=e.TaskPanelKind||(e.TaskPanelKind={}));let je=T=class{constructor(F,ie){if(this.label=ie,typeof F!="string"||typeof ie!="string")throw(0,y.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}get id(){return this._id}};je.Clean=new T("clean","Clean"),je.Build=new T("build","Build"),je.Rebuild=new T("rebuild","Rebuild"),je.Test=new T("test","Test"),je=T=xe([N],je),e.TaskGroup=je;function Xe($){let F="";for(let ie=0;ie<$.length;ie++)F+=$[ie].replace(/,/g,",,")+",";return F}let ct=class{constructor(F,ie,be){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=F,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=be):this._options=ie)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)F.push(ie);return Xe(F)}};ct=xe([N],ct),e.ProcessExecution=ct;let Ct=class{constructor(F,ie,be){if(this._args=[],Array.isArray(ie)){if(!F)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F,this._args=ie,this._options=be}else{if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)F.push(typeof ie=="string"?ie:ie.value);return Xe(F)}};Ct=xe([N],Ct),e.ShellExecution=Ct;var Et;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var St;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class bt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=bt;let ft=U=class{constructor(F,ie,be,qe,tt,ut){this.__deprecated=!1,this._definition=this.definition=F;let ht;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=be,this.execution=qe,ht=tt,this.__deprecated=!0):ie===St.Global||ie===St.Workspace?(this.target=ie,this._name=this.name=be,this._source=this.source=qe,this.execution=tt,ht=ut):(this.target=ie,this._name=this.name=be,this._source=this.source=qe,this.execution=tt,ht=ut),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ct?this._definition={type:U.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ct?this._definition={type:U.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:U.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:U.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ie=this._definition.type;(U.EmptyType===ie||U.ProcessType===ie||U.ShellType===ie||U.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};ft.ExtensionCallbackType="customExecution",ft.ProcessType="process",ft.ShellType="shell",ft.EmptyType="$empty",ft=U=xe([N],ft),e.Task=ft;var It;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(It=e.ProgressLocation||(e.ProgressLocation={}));let Qt=j=class{constructor(F,ie=vt.None){this.collapsibleState=ie,k.URI.isUri(F)?this.resourceUri=F:this.label=F}static isTreeItem(F,ie){if(F instanceof j)return!0;const be=F;if(be.label!==void 0&&!(0,E.isString)(be.label)&&!be.label?.label)return console.log("INVALID tree item, invalid label",be.label),!1;if(be.id!==void 0&&!(0,E.isString)(be.id))return console.log("INVALID tree item, invalid id",be.id),!1;if(be.iconPath!==void 0&&!(0,E.isString)(be.iconPath)&&!k.URI.isUri(be.iconPath)&&(!be.iconPath||!(0,E.isString)(be.iconPath.id))){const qe=be.iconPath;if(!qe||!(0,E.isString)(qe.light)&&!k.URI.isUri(qe.light)&&!(0,E.isString)(qe.dark)&&!k.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",be.iconPath),!1}return be.description!==void 0&&!(0,E.isString)(be.description)&&typeof be.description!="boolean"?(console.log("INVALID tree item, invalid description",be.description),!1):be.resourceUri!==void 0&&!k.URI.isUri(be.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",be.resourceUri),!1):be.tooltip!==void 0&&!(0,E.isString)(be.tooltip)&&!(be.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",be.tooltip),!1):be.command!==void 0&&!be.command.command?(console.log("INVALID tree item, invalid command",be.command),!1):be.collapsibleState!==void 0&&be.collapsibleState<vt.None&&be.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",be.collapsibleState),!1):be.contextValue!==void 0&&!(0,E.isString)(be.contextValue)?(console.log("INVALID tree item, invalid contextValue",be.contextValue),!1):be.accessibilityInformation!==void 0&&!be.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",be.accessibilityInformation),!1):be.checkboxState!==void 0&&((0,I.checkProposedApiEnabled)(ie,"treeItemCheckbox"),be.checkboxState!==qt.Checked&&be.checkboxState!==qt.Unchecked)?(console.log("INVALID tree item, invalid checkboxState",be.checkboxState),!1):!0}};Qt=j=xe([N],Qt),e.TreeItem=Qt;var vt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(vt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var qt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(qt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Ht=class{constructor(F){this.value=F}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Ht=xe([N],Ht),e.DataTransferItem=Ht;let ii=class{constructor(F){h.set(this,new Map);for(const[ie,be]of F??[]){const qe=Oe(this,h,"f").get(ie);qe?qe.push(be):Oe(this,h,"f").set(ie,[be])}}get(F){return Oe(this,h,"f").get(F)?.[0]}set(F,ie){Oe(this,h,"f").set(F,[ie])}forEach(F,ie){for(const[be,qe]of Oe(this,h,"f"))for(const tt of qe)F.call(ie,tt,be,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[F,ie]of Oe(this,h,"f"))for(const be of ie)yield[F,be]}};ii=xe([N],ii),e.DataTransfer=ii;let mi=class{constructor(F){this.insertText=F}};mi=xe([N],mi),e.DocumentDropEdit=mi;let kt=class{constructor(F){this.insertText=F}};kt=xe([N],kt),e.DocumentPasteEdit=kt;let zt=class{constructor(F,ie){this.id=F,this.color=ie}};zt=xe([N],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let gi=class{constructor(F){this.id=F}};gi=xe([N],gi),e.ThemeColor=gi;var ni;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(ni=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Yt=class{constructor(F,ie){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,y.illegalArgument)("base");if(typeof ie!="string")throw(0,y.illegalArgument)("pattern");typeof F=="string"?this.baseUri=k.URI.file(F):k.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ie}get base(){return this._base}set base(F){this._base=F,this._baseUri=k.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Yt=xe([N],Yt),e.RelativePattern=Yt;let lt=class{constructor(F,ie,be,qe){this.enabled=typeof F=="boolean"?F:!0,typeof ie=="string"&&(this.condition=ie),typeof be=="string"&&(this.hitCondition=be),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};lt=xe([N],lt),e.Breakpoint=lt;let pi=class extends lt{constructor(F,ie,be,qe,tt){if(super(ie,be,qe,tt),F===null)throw(0,y.illegalArgument)("location");this.location=F}};pi=xe([N],pi),e.SourceBreakpoint=pi;let $t=class extends lt{constructor(F,ie,be,qe,tt){super(ie,be,qe,tt),this.functionName=F}};$t=xe([N],$t),e.FunctionBreakpoint=$t;let Kt=class extends lt{constructor(F,ie,be,qe,tt,ut,ht){if(super(qe,tt,ut,ht),!ie)throw(0,y.illegalArgument)("dataId");this.label=F,this.dataId=ie,this.canPersist=be}};Kt=xe([N],Kt),e.DataBreakpoint=Kt;let ri=class{constructor(F,ie,be){this.command=F,this.args=ie||[],this.options=be}};ri=xe([N],ri),e.DebugAdapterExecutable=ri;let vi=class{constructor(F,ie){this.port=F,this.host=ie}};vi=xe([N],vi),e.DebugAdapterServer=vi;let si=class{constructor(F){this.path=F}};si=xe([N],si),e.DebugAdapterNamedPipeServer=si;let Ei=class{constructor(F){this.implementation=F}};Ei=xe([N],Ei),e.DebugAdapterInlineImplementation=Ei;let oi=class{constructor(F,ie){this.range=F,this.expression=ie}};oi=xe([N],oi),e.EvaluatableExpression=oi;var ai;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(ai=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Oi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Oi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Jt=class{constructor(F,ie){this.range=F,this.text=ie}};Jt=xe([N],Jt),e.InlineValueText=Jt;let Zt=class{constructor(F,ie,be=!0){this.range=F,this.variableName=ie,this.caseSensitiveLookup=be}};Zt=xe([N],Zt),e.InlineValueVariableLookup=Zt;let bi=class{constructor(F,ie){this.range=F,this.expression=ie}};bi=xe([N],bi),e.InlineValueEvaluatableExpression=bi;let wi=class{constructor(F,ie){this.frameId=F,this.stoppedLocation=ie}};wi=xe([N],wi),e.InlineValueContext=wi;var ei;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(ei=e.FileChangeType||(e.FileChangeType={}));let Si=x=class extends Error{constructor(F,ie=w.FileSystemProviderErrorCode.Unknown,be){super(k.URI.isUri(F)?F.toString(!0):F),this.code=be?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof be=="function"&&Error.captureStackTrace(this,be)}static FileExists(F){return new x(F,w.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(F){return new x(F,w.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(F){return new x(F,w.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(F){return new x(F,w.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(F){return new x(F,w.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(F){return new x(F,w.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}};Si=x=xe([N],Si),e.FileSystemError=Si;let _i=class{constructor(F,ie,be){this.start=F,this.end=ie,this.kind=be}};_i=xe([N],_i),e.FoldingRange=_i;var Fi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ni;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yi;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(yi=e.CommentMode||(e.CommentMode={}));var ki;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ti{constructor(F,ie=[]){this.tokenTypes=F,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ti;function Me($){return typeof $>"u"||(0,E.isStringArray)($)}class Bt{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ie=0,be=F.tokenTypes.length;ie<be;ie++)this._tokenTypeStrToInt.set(F.tokenTypes[ie],ie);for(let ie=0,be=F.tokenModifiers.length;ie<be;ie++)this._tokenModifierStrToInt.set(F.tokenModifiers[ie],ie)}}push(F,ie,be,qe,tt){if(typeof F=="number"&&typeof ie=="number"&&typeof be=="number"&&typeof qe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(F,ie,be,qe,tt);if(W.isRange(F)&&typeof ie=="string"&&Me(be))return this._push(F,ie,be);throw(0,y.illegalArgument)()}_push(F,ie,be){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const qe=F.start.line,tt=F.start.character,ut=F.end.character-F.start.character,ht=this._tokenTypeStrToInt.get(ie);let Rt=0;if(be)for(const xt of be){if(!this._tokenModifierStrToInt.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(xt);Rt|=1<<Wt>>>0}this._pushEncoded(qe,tt,ut,ht,Rt)}_pushEncoded(F,ie,be,qe,tt){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let xt=0,Wt=0;for(let jt=0;jt<Rt;jt++){let Gt=this._data[5*jt],Ci=this._data[5*jt+1];Gt===0?(Gt=xt,Ci+=Wt):Gt+=xt,this._data[5*jt]=Gt,this._data[5*jt+1]=Ci,xt=Gt,Wt=Ci}}let ut=F,ht=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ut-=this._prevLine,ut===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ut,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=be,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=tt,this._prevLine=F,this._prevChar=ie}static _sortAndDeltaEncode(F){const ie=[],be=F.length/5|0;for(let ht=0;ht<be;ht++)ie[ht]=ht;ie.sort((ht,Rt)=>{const xt=F[5*ht],Wt=F[5*Rt];if(xt===Wt){const jt=F[5*ht+1],Gt=F[5*Rt+1];return jt-Gt}return xt-Wt});const qe=new Uint32Array(F.length);let tt=0,ut=0;for(let ht=0;ht<be;ht++){const Rt=5*ie[ht],xt=F[Rt+0],Wt=F[Rt+1],jt=F[Rt+2],Gt=F[Rt+3],Ci=F[Rt+4],Qi=xt-tt,_n=Qi===0?Wt-ut:Wt,Ii=5*ht;qe[Ii+0]=Qi,qe[Ii+1]=_n,qe[Ii+2]=jt,qe[Ii+3]=Gt,qe[Ii+4]=Ci,tt=xt,ut=Wt}return qe}build(F){return this._dataIsSortedAndDeltaEncoded?new ci(new Uint32Array(this._data),F):new ci(Bt._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Bt;class ci{constructor(F,ie){this.resultId=ie,this.data=F}}e.SemanticTokens=ci;class gt{constructor(F,ie,be){this.start=F,this.deleteCount=ie,this.data=be}}e.SemanticTokensEdit=gt;class Mi{constructor(F,ie){this.resultId=ie,this.edits=F}}e.SemanticTokensEdits=Mi;var Li;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Li=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ti=class{constructor(){}};ti.Back={iconPath:new zt("arrow-left")},ti=xe([N],ti),e.QuickInputButtons=ti;var Ui;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var li;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(li=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Bi;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Bi=e.ExtensionKind||(e.ExtensionKind={}));class xi{constructor(F,ie,be){this.badge=F,this.tooltip=ie,this.color=be}static validate(F){if(F.badge){let ie=(0,P.nextCharLength)(F.badge,0);if(ie<F.badge.length&&(ie+=(0,P.nextCharLength)(F.badge,ie)),F.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=xi;let Di=class{constructor(F){this.kind=F}};Di=xe([N],Di),e.ColorTheme=Di;var Pi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Pi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(F,ie){if(F<0)throw(0,y.illegalArgument)("start must be positive");if(ie<0)throw(0,y.illegalArgument)("end must be positive");F<=ie?(this._start=F,this._end=ie):(this._start=ie,this._end=F)}static isNotebookRange(F){return F instanceof Vt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let ie=this._start,be=this._end;return F.start!==void 0&&(ie=F.start),F.end!==void 0&&(be=F.end),ie===this._start&&be===this._end?this:new Vt(ie,be)}}e.NotebookRange=Vt;class ui{constructor(F,ie,be,qe,tt,ut,ht){this.kind=F,this.value=ie,this.languageId=be,this.mime=qe,this.outputs=tt??[],this.metadata=ut,this.executionSummary=ht,ui.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ie=>ui.isNotebookCellData(ie))}static isNotebookCellData(F){return!0}}e.NotebookCellData=ui;class zi{constructor(F){this.cells=F}}e.NotebookData=zi;class Lt{constructor(F,ie){this.data=F,this.mime=ie;const be=(0,_.normalizeMimeType)(ie,!0);if(!be)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=be}static isNotebookCellOutputItem(F){return F instanceof Lt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ie={name:F.name,message:F.message,stack:F.stack};return Lt.json(ie,"application/vnd.code.notebook.error")}static stdout(F){return Lt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Lt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ie="application/octet-stream"){return new Lt(F,ie)}static text(F,ie=_.Mimes.text){const be=Oe(Lt,d,"f",g).encode(String(F));return new Lt(be,ie)}static json(F,ie="text/x-json"){const be=JSON.stringify(F,void 0,"	");return Lt.text(be,ie)}}e.NotebookCellOutputItem=Lt,d=Lt,g={value:new TextEncoder};class di{constructor(F,ie,be){this.items=di.ensureUniqueMimeTypes(F,!0),typeof ie=="string"?(this.id=ie,this.metadata=be):(this.id=(0,O.generateUuid)(),this.metadata=ie??be)}static isNotebookCellOutput(F){return F instanceof di?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ie=!1){const be=new Set,qe=new Set;for(let tt=0;tt<F.length;tt++){const ut=F[tt],ht=(0,_.normalizeMimeType)(ut.mime);if(!be.has(ht)){be.add(ht);continue}qe.add(tt),ie&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return qe.size===0?F:F.filter((tt,ut)=>!qe.has(ut))}}e.NotebookCellOutput=di;var se;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(he=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Re;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Re=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ot;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(ot=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class wt{constructor(F,ie){this.text=F,this.alignment=ie}}e.NotebookCellStatusBarItem=wt;var Tt;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Tt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class en{constructor(F,ie=[]){this.uri=F,this.provides=(0,o.asArray)(ie)}}e.NotebookRendererScript=en;let $i=class{constructor(F,ie){this.label=F,this.timestamp=ie}};$i=xe([N],$i),e.TimelineItem=$i;var tn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(tn=e.ExtensionMode||(e.ExtensionMode={}));var nn;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(nn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var rn;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(rn=e.StandardTokenType||(e.StandardTokenType={}));class sn{constructor(F,ie){this.ranges=F,this.wordPattern=ie}}e.LinkedEditingRanges=sn;class on{constructor(F,ie){this._port=F,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=on;var an;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(an=e.TestResultState||(e.TestResultState={}));var cn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(cn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(F=void 0,ie=void 0,be=void 0){this.include=F,this.exclude=ie,this.profile=be}};Wi=xe([N],Wi),e.TestRunRequest=Wi;let Hi=C=class{constructor(F){this.message=F}static diff(F,ie,be){const qe=new C(F);return qe.expectedOutput=ie,qe.actualOutput=be,qe}};Hi=C=xe([N],Hi),e.TestMessage=Hi;let Vi=class{constructor(F){this.id=F}};Vi=xe([N],Vi),e.TestTag=Vi;let hi=class{constructor(F,ie){this.covered=F,this.total=ie}};hi=xe([N],hi),e.CoveredCount=hi;let ji=z=class{constructor(F,ie,be,qe){this.uri=F,this.statementCoverage=ie,this.branchCoverage=be,this.functionCoverage=qe}static fromDetails(F,ie){const be=new hi(0,0),qe=new hi(0,0),tt=new hi(0,0);for(const ht of ie)if("branches"in ht){be.total+=1,be.covered+=ht.executionCount>0?1:0;for(const Rt of ht.branches)qe.total+=1,qe.covered+=Rt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const ut=new z(F,be,qe.total>0?qe:void 0,tt.total>0?tt:void 0);return ut.detailedCoverage=ie,ut}};ji=z=xe([N],ji),e.FileCoverage=ji;let qi=class{constructor(F,ie,be=[]){this.executionCount=F,this.location=ie,this.branches=be}};qi=xe([N],qi),e.StatementCoverage=qi;let Ki=class{constructor(F,ie){this.executionCount=F,this.location=ie}};Ki=xe([N],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(F,ie){this.executionCount=F,this.location=ie}};Gi=xe([N],Gi),e.FunctionCoverage=Gi;var ln;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(ln=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var un;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(un=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var dn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hn{constructor(F,ie,be,qe,tt,ut){this.kind=F,this.name=ie,this.detail=be,this.uri=qe,this.range=tt,this.selectionRange=ut}}e.TypeHierarchyItem=hn;class fn{constructor(F){this.uri=F}}e.TextTabInput=fn;class mn{constructor(F,ie){this.original=F,this.modified=ie}}e.TextDiffTabInput=mn;class gn{constructor(F,ie,be,qe){this.base=F,this.input1=ie,this.input2=be,this.result=qe}}e.TextMergeTabInput=gn;class pn{constructor(F,ie){this.uri=F,this.viewType=ie}}e.CustomEditorTabInput=pn;class vn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=vn;class En{constructor(F,ie){this.uri=F,this.notebookType=ie}}e.NotebookEditorTabInput=En;class bn{constructor(F,ie,be){this.original=F,this.modified=ie,this.notebookType=be}}e.NotebookDiffEditorTabInput=bn;class wn{constructor(){}}e.TerminalEditorTabInput=wn;class Sn{constructor(F,ie){this.uri=F,this.inputBoxUri=ie}}e.InteractiveWindowInput=Sn}),define(Ce[92],Ie([1,0,44,12,9,240,123,6,16]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,a){a?k.set(f,a):k.delete(f)}e.setWordDefinitionFor=O;function w(f){return k.get(f)}e.getWordDefinitionFor=w;class m extends M.MirrorTextModel{constructor(a,h,d,g,A,c,v,t){super(h,d,g,A),this._proxy=a,this._languageId=c,this._isDirty=v,this.notebook=t,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,E.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===y.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},save(){return a._save()},getText(h){return h?a._getTextInRange(h):a.getText()},get eol(){return a._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(h){return a._lineAt(h)},offsetAt(h){return a._offsetAt(h)},positionAt(h){return a._positionAt(h)},validateRange(h){return a._validateRange(h)},validatePosition(h){return a._validatePosition(h)},getWordRangeAtPosition(h,d){return a._getWordRangeAtPosition(h,d)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,o.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,o.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const h=this._validateRange(a);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const d=this._eol,g=h.start.line,A=h.end.line,c=[];c.push(this._lines[g].substring(h.start.character));for(let v=g+1;v<A;v++)c.push(this._lines[v]);return c.push(this._lines[A].substring(0,h.end.character)),c.join(d)}_lineAt(a){let h;if(a instanceof P.Position?h=a.line:typeof a=="number"&&(h=a),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new I(h,this._lines[h],h===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getPrefixSum(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(a),d=this._lines[h.index].length;return new P.Position(h.index,Math.min(h.remainder,d))}_validateRange(a){if(!(a instanceof P.Range))throw new Error("Invalid argument");const h=this._validatePosition(a.start),d=this._validatePosition(a.end);return h===a.start&&d===a.end?a:new P.Range(h.line,h.character,d.line,d.character)}_validatePosition(a){if(!(a instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:h,character:d}=a,g=!1;if(h<0)h=0,d=0,g=!0;else if(h>=this._lines.length)h=this._lines.length-1,d=this._lines[h].length,g=!0;else{const A=this._lines[h].length;d<0?(d=0,g=!0):d>A&&(d=A,g=!0)}return g?new P.Position(h,d):a}_getWordRangeAtPosition(a,h){const d=this._validatePosition(a);if(!h)h=w(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const g=(0,_.getWordAtText)(d.character+1,(0,_.ensureValidWordDefinition)(h),this._lines[d.line],0);if(g)return new P.Range(d.line,g.startColumn-1,d.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class I{constructor(a,h,d){this._line=a,this._text=h,this._isLastLine=d}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(Ce[176],Ie([1,0,6,13,5]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(P){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let E;switch(P){case"light":E=o.ColorThemeKind.Light;break;case"hcDark":E=o.ColorThemeKind.HighContrast;break;case"hcLight":E=o.ColorThemeKind.HighContrastLight;break;default:E=o.ColorThemeKind.Dark}this._actual=new o.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=xe([$e(0,y.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],Ie([1,0,16,23,75,25,107,74,26,10,2,49,65,80,89,87,88,47,48,171,6,177]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function De(K){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:et,positionColumn:je}=K,Xe=new c.Position(Ae-1,Le-1),ct=new c.Position(et-1,je-1);return new c.Selection(Xe,ct)}Se.to=De;function me(K){const{anchor:Ae,active:Le}=K;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=me})(t=e.Selection||(e.Selection={}));var u;(function(Se){function De(K){if(!K)return;const{start:Ae,end:Le}=K;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=De;function me(K){if(!K)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:et,endColumn:je}=K;return new c.Range(Ae-1,Le-1,et-1,je-1)}Se.to=me})(u=e.Range||(e.Range={}));var n;(function(Se){function De(me){switch(me){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Se.to=De})(n=e.TokenType||(e.TokenType={}));var r;(function(Se){function De(K){return new c.Position(K.lineNumber-1,K.column-1)}Se.to=De;function me(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=me})(r=e.Position||(e.Position={}));var s;(function(Se){function De(Ae,Le){return(0,o.coalesce)((0,o.asArray)(Ae).map(et=>me(et,Le)))}Se.from=De;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:K(Ae.scheme,Le),pattern:fe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function K(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(Se){function De(K){switch(K){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Se.from=De;function me(K){switch(K){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Se.to=me})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var l;(function(Se){function De(K){let Ae;return K.code&&((0,k.isString)(K.code)||(0,k.isNumber)(K.code)?Ae=String(K.code):Ae={value:String(K.code.value),target:K.code.target}),{...u.from(K.range),message:K.message,source:K.source,code:Ae,severity:p.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(S.from),tags:Array.isArray(K.tags)?(0,o.coalesce)(K.tags.map(i.from)):void 0}}Se.from=De;function me(K){const Ae=new c.Diagnostic(u.to(K),K.message,p.to(K.severity));return Ae.source=K.source,Ae.code=(0,k.isString)(K.code)?K.code:K.code?.value,Ae.relatedInformation=K.relatedInformation&&K.relatedInformation.map(S.to),Ae.tags=K.tags&&(0,o.coalesce)(K.tags.map(i.to)),Ae}Se.to=me})(l=e.Diagnostic||(e.Diagnostic={}));var S;(function(Se){function De(K){return{...u.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=De;function me(K){return new c.DiagnosticRelatedInformation(new c.Location(K.resource,u.to(K)),K.message)}Se.to=me})(S=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Se){function De(K){switch(K){case c.DiagnosticSeverity.Error:return I.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return I.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return I.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return I.MarkerSeverity.Hint}return I.MarkerSeverity.Error}Se.from=De;function me(K){switch(K){case I.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case I.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case I.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case I.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Se.to=me})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(Se){function De(K){return typeof K=="number"&&K>=c.ViewColumn.One?K-1:K===c.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}Se.from=De;function me(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=me})(T=e.ViewColumn||(e.ViewColumn={}));function U(Se){return typeof Se.range<"u"}function j(Se){return Se.length===0?!0:!!U(Se[0])}e.isDecorationOptionsArr=j;var x;(function(Se){function De(je){return je.map(Se.from)}Se.fromMany=De;function me(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function K(je){let Xe;if(me(je)){const{language:St,value:bt}=je;Xe={value:"```"+St+`
`+bt+"\n```\n"}}else c.MarkdownString.isMarkdownString(je)?Xe={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?Xe={value:je}:Xe={value:""};const ct=Object.create(null);Xe.uris=ct;const Ct=St=>{try{let bt=O.URI.parse(St,!0);bt=bt.with({query:Ae(bt.query,ct)}),ct[St]=bt}catch{}return""},Et=new _.marked.Renderer;return Et.link=Ct,Et.image=St=>typeof St=="string"?Ct(b.parseHrefAndDimensions(St).href):"",(0,_.marked)(Xe.value,{renderer:Et}),Xe}Se.from=K;function Ae(je,Xe){if(!je)return je;let ct;try{ct=(0,P.parse)(je)}catch{}if(!ct)return je;let Ct=!1;return ct=(0,E.cloneAndChange)(ct,Et=>{if(O.URI.isUri(Et)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[St]=Et,Ct=!0,St}else return}),Ct?JSON.stringify(ct):je}function Le(je){const Xe=new c.MarkdownString(je.value,je.supportThemeIcons);return Xe.isTrusted=je.isTrusted,Xe.supportHtml=je.supportHtml,Xe.baseUri=je.baseUri?O.URI.from(je.baseUri):void 0,Xe}Se.to=Le;function et(je){if(!!je)return typeof je=="string"?je:Se.from(je)}Se.fromStrict=et})(x=e.MarkdownString||(e.MarkdownString={}));function C(Se){return j(Se)?Se.map(De=>({range:u.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?x.fromMany(De.hoverMessage):De.hoverMessage?x.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:u.from(De)}))}e.fromRangeOrRangeWithMessage=C;function z(Se){return typeof Se>"u"?Se:typeof Se=="string"?O.URI.file(Se):Se}e.pathOrURIToURI=z;var N;(function(Se){function De(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?z(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Se.from=De})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(Se){function De(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Se.from=De})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(Se){function De(me){if(typeof me>"u")return me;switch(me){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function De(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?L.from(me.light):void 0,dark:me.dark?L.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?N.from(me.before):void 0,after:me.after?N.from(me.after):void 0}}Se.from=De})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var R;(function(Se){function De(K){return{text:K.newText,eol:K.newEol&&Ge.from(K.newEol),range:u.from(K.range)}}Se.from=De;function me(K){const Ae=new c.TextEdit(u.to(K.range),K.text);return Ae.newEol=typeof K.eol>"u"?void 0:Ge.to(K.eol),Ae}Se.to=me})(R=e.TextEdit||(e.TextEdit={}));var Z;(function(Se){function De(K,Ae,Le){const et={edits:[]};if(K instanceof c.WorkspaceEdit){const je=new M.ResourceSet;for(const Xe of K._allEntries())Xe._type===1&&O.URI.isUri(Xe.to)&&Xe.from===void 0&&je.add(Xe.to);for(const Xe of K._allEntries())if(Xe._type===1)et.edits.push({oldResource:Xe.from,newResource:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2)et.edits.push({resource:Xe.uri,textEdit:R.from(Xe.edit),versionId:je.has(Xe.uri)?void 0:Ae?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata});else if(Xe._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Xe);continue}et.edits.push({resource:Xe.uri,textEdit:{range:u.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:je.has(Xe.uri)?void 0:Ae?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata})}else Xe._type===3?et.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&et.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(st.from)}})}return et}Se.from=De;function me(K){const Ae=new c.WorkspaceEdit;for(const Le of K.edits)Le.textEdit?Ae.replace(O.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Ae}Se.to=me})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(Se){const De=Object.create(null);De[c.SymbolKind.File]=0,De[c.SymbolKind.Module]=1,De[c.SymbolKind.Namespace]=2,De[c.SymbolKind.Package]=3,De[c.SymbolKind.Class]=4,De[c.SymbolKind.Method]=5,De[c.SymbolKind.Property]=6,De[c.SymbolKind.Field]=7,De[c.SymbolKind.Constructor]=8,De[c.SymbolKind.Enum]=9,De[c.SymbolKind.Interface]=10,De[c.SymbolKind.Function]=11,De[c.SymbolKind.Variable]=12,De[c.SymbolKind.Constant]=13,De[c.SymbolKind.String]=14,De[c.SymbolKind.Number]=15,De[c.SymbolKind.Boolean]=16,De[c.SymbolKind.Array]=17,De[c.SymbolKind.Object]=18,De[c.SymbolKind.Key]=19,De[c.SymbolKind.Null]=20,De[c.SymbolKind.EnumMember]=21,De[c.SymbolKind.Struct]=22,De[c.SymbolKind.Event]=23,De[c.SymbolKind.Operator]=24,De[c.SymbolKind.TypeParameter]=25;function me(Ae){return typeof De[Ae]=="number"?De[Ae]:6}Se.from=me;function K(Ae){for(const Le in De)if(De[Le]===Ae)return Number(Le);return c.SymbolKind.Property}Se.to=K})(le=e.SymbolKind||(e.SymbolKind={}));var oe;(function(Se){function De(K){switch(K){case c.SymbolTag.Deprecated:return 1}}Se.from=De;function me(K){switch(K){case 1:return c.SymbolTag.Deprecated}}Se.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var ue;(function(Se){function De(K){return{name:K.name,kind:le.from(K.kind),tags:K.tags&&K.tags.map(oe.from),containerName:K.containerName,location:Ee.from(K.location)}}Se.from=De;function me(K){const Ae=new c.SymbolInformation(K.name,le.to(K.kind),K.containerName,Ee.to(K.location));return Ae.tags=K.tags&&K.tags.map(oe.to),Ae}Se.to=me})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ee;(function(Se){function De(K){const Ae={name:K.name||"!!MISSING: name!!",detail:K.detail,range:u.from(K.range),selectionRange:u.from(K.selectionRange),kind:le.from(K.kind),tags:K.tags?.map(oe.from)??[]};return K.children&&(Ae.children=K.children.map(De)),Ae}Se.from=De;function me(K){const Ae=new c.DocumentSymbol(K.name,K.detail,le.to(K.kind),u.to(K.range),u.to(K.selectionRange));return(0,o.isNonEmptyArray)(K.tags)&&(Ae.tags=K.tags.map(oe.to)),K.children&&(Ae.children=K.children.map(me)),Ae}Se.to=me})(ee=e.DocumentSymbol||(e.DocumentSymbol={}));var ve;(function(Se){function De(K){const Ae=new c.CallHierarchyItem(le.to(K.kind),K.name,K.detail||"",O.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}Se.to=De;function me(K,Ae,Le){if(Ae=Ae??K._sessionId,Le=Le??K._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:K.name,detail:K.detail,kind:le.from(K.kind),uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(oe.from)}}Se.from=me})(ve=e.CallHierarchyItem||(e.CallHierarchyItem={}));var we;(function(Se){function De(me){return new c.CallHierarchyIncomingCall(ve.to(me.from),me.fromRanges.map(K=>u.to(K)))}Se.to=De})(we=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var re;(function(Se){function De(me){return new c.CallHierarchyOutgoingCall(ve.to(me.to),me.fromRanges.map(K=>u.to(K)))}Se.to=De})(re=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Se){function De(K){return{range:K.range&&u.from(K.range),uri:K.uri}}Se.from=De;function me(K){return new c.Location(O.URI.revive(K.uri),u.to(K.range))}Se.to=me})(Ee=e.location||(e.location={}));var Pe;(function(Se){function De(K){const Ae=K,Le=K;return{originSelectionRange:Ae.originSelectionRange?u.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:u.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?u.from(Ae.targetSelectionRange):void 0}}Se.from=De;function me(K){return{targetUri:O.URI.revive(K.uri),targetRange:u.to(K.range),targetSelectionRange:K.targetSelectionRange?u.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?u.to(K.originSelectionRange):void 0}}Se.to=me})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function De(K){return{range:u.from(K.range),contents:x.fromMany(K.contents)}}Se.from=De;function me(K){return new c.Hover(K.contents.map(x.to),u.to(K.range))}Se.to=me})(Fe=e.Hover||(e.Hover={}));var ze;(function(Se){function De(K){return{range:u.from(K.range),expression:K.expression}}Se.from=De;function me(K){return new c.EvaluatableExpression(u.to(K.range),K.expression)}Se.to=me})(ze=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(Se){function De(K){if(K instanceof c.InlineValueText)return{type:"text",range:u.from(K.range),text:K.text};if(K instanceof c.InlineValueVariableLookup)return{type:"variable",range:u.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function me(K){switch(K.type){case"text":return{range:u.to(K.range),text:K.text};case"variable":return{range:u.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:u.to(K.range),expression:K.expression}}}Se.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Te;(function(Se){function De(K){return{frameId:K.frameId,stoppedLocation:u.from(K.stoppedLocation)}}Se.from=De;function me(K){return new c.InlineValueContext(K.frameId,u.to(K.stoppedLocation))}Se.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var _e;(function(Se){function De(K){return{range:u.from(K.range),kind:K.kind}}Se.from=De;function me(K){return new c.DocumentHighlight(u.to(K.range),K.kind)}Se.to=me})(_e=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Se){function De(me){switch(me){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Se.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function De(me){return{triggerKind:ye.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Se.to=De})(ae=e.CompletionContext||(e.CompletionContext={}));var ce;(function(Se){function De(K){switch(K){case c.CompletionItemTag.Deprecated:return 1}}Se.from=De;function me(K){switch(K){case 1:return c.CompletionItemTag.Deprecated}}Se.to=me})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(Se){const De=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function me(Le){return De.get(Le)??9}Se.from=me;const K=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Ae(Le){return K.get(Le)??c.CompletionItemKind.Property}Se.to=Ae})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Se){function De(me,K){const Ae=new c.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=Q.to(me.kind),Ae.tags=me.tags?.map(ce.to),Ae.detail=me.detail,Ae.documentation=b.isMarkdownString(me.documentation)?x.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,w.Range.isIRange(me.range)?Ae.range=u.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new c.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof c.Range?new c.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>R.to(Le))),Ae.command=K&&me.command?K.fromInternal(me.command):void 0,Ae}Se.to=De})(J=e.CompletionItem||(e.CompletionItem={}));var D;(function(Se){function De(K){return{label:K.label,documentation:x.fromStrict(K.documentation)}}Se.from=De;function me(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?x.to(K.documentation):K.documentation}}Se.to=me})(D=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(Se){function De(K){return{label:K.label,documentation:x.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(D.from):[],activeParameter:K.activeParameter}}Se.from=De;function me(K){return{label:K.label,documentation:b.isMarkdownString(K.documentation)?x.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(D.to):[],activeParameter:K.activeParameter}}Se.to=me})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.from):[]}}Se.from=De;function me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(B.to):[]}}Se.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var V;(function(Se){function De(me,K){const Ae=new c.InlayHint(r.to(K.position),typeof K.label=="string"?K.label:K.label.map(te.to.bind(void 0,me)),K.kind&&de.to(K.kind));return Ae.textEdits=K.textEdits&&K.textEdits.map(R.to),Ae.tooltip=b.isMarkdownString(K.tooltip)?x.to(K.tooltip):K.tooltip,Ae.paddingLeft=K.paddingLeft,Ae.paddingRight=K.paddingRight,Ae}Se.to=De})(V=e.InlayHint||(e.InlayHint={}));var te;(function(Se){function De(me,K){const Ae=new c.InlayHintLabelPart(K.label);return Ae.tooltip=b.isMarkdownString(K.tooltip)?x.to(K.tooltip):K.tooltip,m.Command.is(K.command)&&(Ae.command=me.fromInternal(K.command)),K.location&&(Ae.location=Ee.to(K.location)),Ae}Se.to=De})(te=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(Se){function De(K){return K}Se.from=De;function me(K){return K}Se.to=me})(de=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(Se){function De(K){return{range:u.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=De;function me(K){let Ae;if(K.url)try{Ae=typeof K.url=="string"?O.URI.parse(K.url,!0):O.URI.revive(K.url)}catch{}return new c.DocumentLink(u.to(K.range),Ae)}Se.to=me})(Y=e.DocumentLink||(e.DocumentLink={}));var pe;(function(Se){function De(K){const Ae=new c.ColorPresentation(K.label);return K.textEdit&&(Ae.textEdit=R.to(K.textEdit)),K.additionalTextEdits&&(Ae.additionalTextEdits=K.additionalTextEdits.map(Le=>R.to(Le))),Ae}Se.to=De;function me(K){return{label:K.label,textEdit:K.textEdit?R.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ae=>R.from(Ae)):void 0}}Se.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(Se){function De(K){return new c.Color(K[0],K[1],K[2],K[3])}Se.to=De;function me(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(Se){function De(K){return{range:u.from(K.range)}}Se.from=De;function me(K){return new c.SelectionRange(u.to(K.range))}Se.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(Se){function De(me){switch(me){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Se.to=De})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function De(K){switch(K){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function me(K){switch(K){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Se.to=me})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(Se){function De(K){if(K===c.EndOfLine.CRLF)return 1;if(K===c.EndOfLine.LF)return 0}Se.from=De;function me(K){if(K===1)return c.EndOfLine.CRLF;if(K===0)return c.EndOfLine.LF}Se.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var ke;(function(Se){function De(me){if(typeof me=="object")return me.viewId;switch(me){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(ke=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(Se){function De(me){const K={start:me.start+1,end:me.end+1};return me.kind&&(K.kind=G.from(me.kind)),K}Se.from=De})(nt=e.FoldingRange||(e.FoldingRange={}));var G;(function(Se){function De(me){if(me)switch(me){case c.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Se.from=De})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Se){function De(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?a.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(Se){function De(Le){return Le instanceof c.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||K(Le)?new c.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=De;function me(Le){const et=Le;return et?O.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function K(Le){const et=Le;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new c.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function De(me){if(me){if(Array.isArray(me))return me.map(De);if(typeof me=="string")return me;{const K=me;return{language:K.language,scheme:K.scheme,pattern:fe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=De})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(Se){function De(K){return{start:K.start,end:K.end}}Se.from=De;function me(K){return new c.NotebookRange(K.start,K.end)}Se.to=me})(He=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(Se){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=De;function me(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Se){function De(me){if(me===h.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(me===h.NotebookCellExecutionState.Pending)return;if(me===h.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Se.to=De})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(Se){function De(K){switch(K){case c.NotebookCellKind.Markup:return h.CellKind.Markup;case c.NotebookCellKind.Code:default:return h.CellKind.Code}}Se.from=De;function me(K){switch(K){case h.CellKind.Markup:return c.NotebookCellKind.Markup;case h.CellKind.Code:default:return c.NotebookCellKind.Code}}Se.to=me})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Se){function De(K){const Ae={metadata:K.metadata??Object.create(null),cells:[]};for(const Le of K.cells)c.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=De;function me(K){const Ae=new c.NotebookData(K.cells.map(st.to));return(0,k.isEmptyObject)(K.metadata)||(Ae.metadata=K.metadata),Ae}Se.to=me})(it=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function De(K){return{cellKind:We.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ze.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(at.from):[]}}Se.from=De;function me(K){return new c.NotebookCellData(We.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(at.to):void 0,K.metadata,K.internalMetadata?Ze.to(K.internalMetadata):void 0)}Se.to=me})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function De(K){return{mime:K.mime,valueBytes:y.VSBuffer.wrap(K.data)}}Se.from=De;function me(K){return new c.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Se.to=me})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(Se){function De(K){return{outputId:K.id,items:K.items.map(dt.from),metadata:K.metadata}}Se.from=De;function me(K){const Ae=K.items.map(dt.to);return new c.NotebookCellOutput(Ae,K.outputId,K.metadata)}Se.to=me})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Se){function De(Ae){return K(Ae)?{include:(0,k.withNullAsUndefined)(fe.from(Ae.include)),exclude:(0,k.withNullAsUndefined)(fe.from(Ae.exclude))}:(0,k.withNullAsUndefined)(fe.from(Ae))}Se.from=De;function me(Ae){return K(Ae)?{include:fe.to(Ae.include),exclude:fe.to(Ae.exclude)}:fe.to(Ae)}Se.to=me;function K(Ae){const Le=Ae;return Le?!(0,k.isUndefinedOrNull)(Le.include)&&!(0,k.isUndefinedOrNull)(Le.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(Se){function De(me,K,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Se.from=De})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(Se){function De(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Se.from=De})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Se){function De(K){return{uri:K.uri,provides:K.provides}}Se.from=De;function me(K){return new c.NotebookRendererScript(O.URI.revive(K.uri),K.provides)}Se.to=me})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Se){function De(K){return{message:x.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:u.from(K.location.range),uri:K.location.uri}}}Se.from=De;function me(K){const Ae=new c.TestMessage(typeof K.message=="string"?K.message:x.to(K.message));return Ae.actualOutput=K.actual,Ae.expectedOutput=K.expected,Ae.location=K.location?Ee.to(K.location):void 0,Ae}Se.to=me})(mt=e.TestMessage||(e.TestMessage={}));var yt;(function(Se){Se.namespace=g.namespaceTestTag,Se.denamespace=g.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var Nt;(function(Se){function De(K){const Ae=(0,f.getPrivateApiFor)(K).controllerId;return{extId:d.TestId.fromExtHostTestItem(K,Ae).toString(),label:K.label,uri:O.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Le=>yt.namespace(Ae,Le.id)),range:w.Range.lift(u.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&x.fromStrict(K.error)||null}}Se.from=De;function me(K){return{parent:void 0,error:void 0,id:d.TestId.fromString(K.extId).localId,label:K.label,uri:O.URI.revive(K.uri),tags:(K.tags||[]).map(Ae=>{const{tagId:Le}=yt.denamespace(Ae);return new c.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=me})(Nt=e.TestItem||(e.TestItem={})),function(Se){function De(K){return{id:K.id}}Se.from=De;function me(K){return new c.TestTag(K.id)}Se.to=me}(yt=e.TestTag||(e.TestTag={}));var Ut;(function(Se){const De=(K,Ae)=>{const Le=[];for(const[je,Xe]of Ae)d.TestId.compare(Xe.item.extId,je)===2&&(Ae.delete(je),Le.push(Xe));const et={...Nt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(Xe=>Xe.type===0).map(mt.to)})),children:Le.map(je=>De(je,Ae))};for(const je of et.children)je.parent=et;return et};function me(K){const Ae=[],Le=new Map;for(const et of K.items)Le.set(et.item.extId,et),K.request.targets.some(je=>je.controllerId===et.controllerId&&je.testIds.includes(et.item.extId))&&Ae.push(et);return{completedAt:K.completedAt,results:Ae.map(et=>De(et,Le))}}Se.to=me})(Ut=e.TestResults||(e.TestResults={}));var Ve;(function(Se){function De(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?r.from(Le):u.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&me(et.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}Se.fromDetailed=K;function Ae(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}Se.fromFile=Ae})(Ve=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Se){function De(me){switch(me){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Se.to=De})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Se){function De(K){const Ae=new c.TypeHierarchyItem(le.to(K.kind),K.name,K.detail||"",O.URI.revive(K.uri),u.to(K.range),u.to(K.selectionRange));return Ae._sessionId=K._sessionId,Ae._itemId=K._itemId,Ae}Se.to=De;function me(K,Ae,Le){if(Ae=Ae??K._sessionId,Le=Le??K._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:le.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:u.from(K.range),selectionRange:u.from(K.selectionRange),tags:K.tags?.map(oe.from)}}Se.from=me})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var At;(function(Se){function De(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Se.from=De})(At=e.ViewBadge||(e.ViewBadge={}));var pt;(function(Se){function De(me,K){const Ae=me.fileData;return Ae?new class extends c.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,v.once)(()=>K())}}}(""):new c.DataTransferItem(me.asString)}Se.toDataTransferItem=De})(pt=e.DataTransferItem||(e.DataTransferItem={}));var Dt;(function(Se){function De(K,Ae){const Le=K.items.map(([et,je],Xe)=>[et,pt.toDataTransferItem(je,()=>Ae(Xe))]);return new c.DataTransfer(Le)}Se.toDataTransfer=De;async function me(K){const Ae={items:[]},Le=[];return K.forEach((et,je)=>{Le.push((async()=>{const Xe=await et.asString(),ct=et.asFile();Ae.items.push([je,{asString:Xe,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=me})(Dt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[178],Ie([1,0,2,11,6,8,241]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,O,w,m={timeout:1500,errors:3}){this._logService=k,this._documents=O,this._mainThreadBulkEdits=w,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(O,w,m)=>{const f={dispose:this._callbacks.push([O,w,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const w=o.URI.revive(k);let m=!1;const I=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const a of[...this._callbacks]){if(m)break;const h=this._documents.getDocument(w),d=await this._deliverEventAsyncAndBlameBadListeners(a,{document:h,reason:M.TextDocumentSaveReason.to(O)});f.push(d)}}finally{clearTimeout(I)}return f}_deliverEventAsyncAndBlameBadListeners([k,O,w],m){const I=this._badListeners.get(k);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,k,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,O,w,m){const I=[],f=Date.now(),{document:a,reason:h}=m,{version:d}=a,g=Object.freeze({document:a,reason:h,waitUntil(A){if(Object.isFrozen(I))throw(0,y.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(A))}});try{O.apply(w,[g])}catch(A){return Promise.reject(A)}return Object.freeze(I),new Promise((A,c)=>{const v=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),A(t)}).catch(t=>{clearTimeout(v),c(t)})}).then(A=>{const c={edits:[]};for(const v of A)if(Array.isArray(v)&&v.every(t=>t instanceof b.TextEdit))for(const{newText:t,newEol:u,range:n}of v)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:t,eol:u&&M.EndOfLine.from(u)}});if(c.edits.length!==0)return d===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ce[179],Ie([1,0,12,2,8,6,88]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,m,I,f){this.start=w,this.deletedCount=m,this.deletedItems=I,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class E{constructor(w,m,I){this.notebook=w,this._extHostDocument=m,this._cellData=I,this.handle=I.handle,this.uri=y.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}static asModelAddData(w,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return w._mime},set mime(f){w._mime=f},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(w){this._outputs=w.map(b.NotebookCellOutput.to)}setOutputItems(w,m,I){const f=I.map(b.NotebookCellOutputItem.to),a=this._outputs.find(h=>h.id===w);a&&(m||(a.items.length=0),a.items.push(...f))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=E;class k{constructor(w,m,I,f,a){this._proxy=w,this._textDocumentsAndEditors=m,this._textDocuments=I,this.uri=f,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=a.viewType,this._metadata=Object.freeze(a.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,a.cells]],!0,void 0),this._versionId=a.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this,m={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===o.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(I){return I=w._validateIndex(I),w._cells[I].apiCell},getCells(I){return(I?w._getCells(I):w._cells).map(a=>a.apiCell)},save(){return w._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,m,I){this._versionId=w.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:I});const f={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},a=[];for(const d of w.rawEvents)d.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1,f.contentChanges):d.kind===_.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx,f.contentChanges):d.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(d.index,d.outputs),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems),a.push({cell:this._cells[d.index].apiCell,outputs:this._cells[d.index].apiCell.outputs})):d.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(d.index,d.language),a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document})):d.kind===_.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this._cells[d.index].apiCell,document:this._cells[d.index].apiCell.document}):d.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(d.index,d.metadata),a.push({cell:this._cells[d.index].apiCell,metadata:this._cells[d.index].apiCell.metadata})):d.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(d.index,d.internalMetadata),a.push({cell:this._cells[d.index].apiCell,executionSummary:this._cells[d.index].apiCell.executionSummary}));const h=new Map;for(let d=0;d<a.length;d++){const g=a[d],A=h.get(g.cell);if(A===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});h.set(g.cell,c-1)}else f.cellChanges[A]={...f.cellChanges[A],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let m=w.start|0,I=w.end|0;return m<0&&(m=0),I>this._cells.length&&(I=this._cells.length),w.with({start:m,end:I})}_getCells(w){w=this._validateRange(w);const m=[];for(let I=w.start;I<w.end;I++)m.push(this._cells[I]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,m,I){if(this._disposed)return;const f=[],a=[],h=[];if(w.reverse().forEach(d=>{const A=d[2].map(t=>{const u=new E(this,this._textDocumentsAndEditors,t);return m||a.push(E.asModelAddData(this.apiNotebook,t)),u}),c=new P(d[0],d[1],[],A),v=this._cells.splice(d[0],d[1],...A);for(const t of v)h.push(t.uri),c.deletedItems.push(t.apiCell);f.push(c)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:h}),I)for(const d of f)I.push(d.asApiEvent())}_moveCell(w,m,I){const f=this._cells.splice(w,1);this._cells.splice(m,0,...f);const a=[new P(w,1,f.map(h=>h.apiCell),[]),new P(m,0,[],f)];for(const h of a)I.push(h.asApiEvent())}_setCellOutputs(w,m){this._cells[w].setOutputs(m)}_setCellOutputItems(w,m,I,f){this._cells[w].setOutputItems(m,I,f)}_changeCellLanguage(w,m){const I=this._cells[w];I.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(I.uri,m)}_changeCellMime(w,m){const I=this._cells[w];I.apiCell.mime=m}_changeCellMetadata(w,m){this._cells[w].setMetadata(m)}_changeCellInternalMetadata(w,m){this._cells[w].setInternalMetadata(m)}getCellFromApiCell(w){return this._cells.find(m=>m.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(m=>m.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(Ce[93],Ie([1,0,11,8,6]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(P,E,k,O,w,m){this.id=P,this._proxy=E,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=w,this._visibleRanges=O,this._viewColumn=m}get apiEditor(){if(!this._editor){const P=this;this._editor={get document(){return P.notebookData.apiNotebook},get notebook(){return P.notebookData.apiNotebook},get selection(){return P._selections[0]},set selection(E){this.selections=[E]},get selections(){return P._selections},set selections(E){if(!Array.isArray(E)||!E.every(b.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");P._selections=E,P._trySetSelections(E)},get visibleRanges(){return P._visibleRanges},revealRange(E,k){P._proxy.$tryRevealRange(P.id,y.NotebookRange.from(E),k??b.NotebookEditorRevealType.Default)},get viewColumn(){return P._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(P){this._visible=P}_acceptVisibleRanges(P){this._visibleRanges=P}_acceptSelections(P){this._selections=P}_trySetSelections(P){this._proxy.$trySetSelections(this.id,P.map(y.NotebookRange.from))}_acceptViewColumn(P){this._viewColumn=P}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[180],Ie([1,0,5,15,8]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(P,E){this._logService=P,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(P,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,E);const k=this._notebooksAndEditors.getEditorById(P);E.visibleRanges&&k._acceptVisibleRanges(E.visibleRanges.ranges.map(b.NotebookRange.to)),E.selections&&k._acceptSelections(E.selections.selections.map(b.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const E in P)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(b.ViewColumn.to(P[E]))}};M=xe([$e(0,y.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[181],Ie([1,0,8,151,132,20,55,11]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,I,f){const a=this._handles++,{title:h,location:d,cancellable:g}=I,A={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(a,{location:o.ProgressLocation.from(d),title:h,source:A,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(a,f,!!g)}_withProgress(m,I,f){let a;f&&(a=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,a));const h=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),a?.dispose()};let d;try{d=I(new O(this._proxy,m),f&&a?a.token:M.CancellationToken.None)}catch(g){throw h(m),g}return d.then(g=>h(m),g=>h(m)),d}$acceptProgressCanceled(m){const I=this._mapHandleToCancellationSource.get(m);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function k(w,m){return w.message=m.message,typeof m.increment=="number"&&(typeof w.increment=="number"?w.increment+=m.increment:w.increment=m.increment),w}class O extends y.Progress{constructor(m,I){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=I}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}xe([(0,_.throttle)(100,(w,m)=>k(w,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[94],Ie([1,0,49,89,47,64,48,8,2]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(A,c,v,t)=>{let u=c;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!v(u,n)){const r=u;u=n,A.listener?.(t(n,r))}}}},O=(A,c)=>A===c,w={range:(A,c)=>A===c?!0:!A||!c?!1:A.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(A,c)=>!(A.length!==c.length||A.some(v=>!c.find(t=>v.id===t.id)))},m=A=>c=>({op:4,update:A(c)}),I=(A,c)=>({range:k(A,void 0,w.range,m(v=>({range:o.Range.lift(P.Range.from(v))}))),label:k(A,c,w.label,m(v=>({label:v}))),description:k(A,void 0,w.description,m(v=>({description:v}))),sortText:k(A,void 0,w.sortText,m(v=>({sortText:v}))),canResolveChildren:k(A,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:k(A,!1,w.busy,m(v=>({busy:v}))),error:k(A,void 0,w.error,m(v=>({error:P.MarkdownString.fromStrict(v)||null}))),tags:k(A,[],w.tags,(v,t)=>({op:1,new:v.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),f=A=>{const c=b.TestId.fromString(A.extId),v=new h(c.controllerId,c.localId,A.label,E.URI.revive(A.uri)||void 0);return v.range=P.Range.to(A.range||void 0),v.description=A.description||void 0,v.sortText=A.sortText||void 0,v.tags=A.tags.map(t=>P.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),v},a=A=>{let c;for(const v of A.tests){const t=f(v.item);(0,y.getPrivateApiFor)(t).parent=c,c=t}return c};e.toItemFromContext=a;class h{constructor(c,v,t,u){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const n=(0,y.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof d?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,y.getPrivateApiFor,h),enumerable:!0,writable:!1},...I(n,t)})}}e.TestItemImpl=h;class d extends h{constructor(c,v){super(c,c,v,void 0)}}e.TestItemRootImpl=d;class g extends M.TestItemCollection{constructor(c,v,t){super({controllerId:c,getDocumentVersion:u=>t.getDocument(u)?.version,getApiFor:y.getPrivateApiFor,getChildren:u=>u.children,root:new d(c,v),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[95],Ie([1,0,44,11,72,8,6]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(m,I,f){const a=P._Keys.nextId();m.$registerTextEditorDecorationType(I.identifier,a,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:a,dispose(){m.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=P,P._Keys=new b.IdGenerator("TextEditorDecorationType");class E{constructor(m,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,I){this._throwIfFinalized();let f=null;if(m instanceof _.Position)f=new _.Range(m,m);else if(m instanceof _.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,I,!1)}insert(m,I){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),I,!0)}delete(m){this._throwIfFinalized();let I=null;if(m instanceof _.Range)I=m;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(m,I,f){const a=this._document.validateRange(m);this._collectedEdits.push({range:a,text:I,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class k{constructor(m,I,f,a){this._proxy=m,this._id=I,this._accept(f),this._logService=a;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(d){h._setTabSize(d)},get insertSpaces(){return h._insertSpaces},set insertSpaces(d){h._setInsertSpaces(d)},get cursorStyle(){return h._cursorStyle},set cursorStyle(d){h._setCursorStyle(d)},get lineNumbers(){return h._lineNumbers},set lineNumbers(d){h._setLineNumbers(d)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const I=Math.floor(m);return I>0?I:null}if(typeof m=="string"){const I=parseInt(m,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(m){const I=this._validateTabSize(m);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const I=this._validateInsertSpaces(m);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const I={};let f=!1;if(typeof m.tabSize<"u"){const a=this._validateTabSize(m.tabSize);a==="auto"?(f=!0,I.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,f=!0,I.tabSize=a)}if(typeof m.insertSpaces<"u"){const a=this._validateInsertSpaces(m.insertSpaces);a==="auto"?(f=!0,I.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,f=!0,I.insertSpaces=a)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,I.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,I.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(m,I){I.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,I,f,a,h,d,g,A){this.id=m,this._proxy=I,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new k(this._proxy,this.id,d,f),this._visibleRanges=g,this._viewColumn=A;const c=this;this.value=Object.freeze({get document(){return a.getValue()},set document(v){throw(0,y.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(v){if(!(v instanceof _.Selection))throw(0,y.illegalArgument)("selection");c._selections=[v],c._trySetSelection()},get selections(){return c._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof _.Selection)))throw(0,y.illegalArgument)("selections");c._selections=v,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(v){throw(0,y.readonly)("visibleRanges")},get options(){return c._options.value},set options(v){c._disposed||c._options.assign(v)},get viewColumn(){return c._viewColumn},set viewColumn(v){throw(0,y.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(a.getValue(),t);return v(u),c._applyEdit(u)},insertSnippet(v,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=c._selections.map(r=>M.Range.from(r));else if(t instanceof _.Position){const{lineNumber:r,column:s}=M.Position.from(t);n=[{startLineNumber:r,startColumn:s,endLineNumber:r,endColumn:s}]}else if(t instanceof _.Range)n=[M.Range.from(t)];else{n=[];for(const r of t)if(r instanceof _.Range)n.push(M.Range.from(r));else{const{lineNumber:s,column:i}=M.Position.from(r);n.push({startLineNumber:s,startColumn:i,endLineNumber:s,endColumn:i})}}return I.$tryInsertSnippet(m,a.getValue().version,v.value,n,u)},setDecorations(v,t){const u=t.length===0;u&&!c._hasDecorationsForKey.has(v.key)||(u?c._hasDecorationsForKey.delete(v.key):c._hasDecorationsForKey.add(v.key),c._runOnProxy(()=>{if(M.isDecorationOptionsArr(t))return I.$trySetDecorations(m,v.key,M.fromRangeOrRangeWithMessage(t));{const n=new Array(4*t.length);for(let r=0,s=t.length;r<s;r++){const i=t[r];n[4*r]=i.start.line+1,n[4*r+1]=i.start.character+1,n[4*r+2]=i.end.line+1,n[4*r+3]=i.end.character+1}return I.$trySetDecorationsFast(m,v.key,n)}}))},revealRange(v,t){c._runOnProxy(()=>I.$tryRevealRange(m,M.Range.from(v),t||_.TextEditorRevealType.Default))},show(v){I.$tryShowEditor(m,M.ViewColumn.from(v))},hide(){I.$tryHideEditor(m)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,o.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,o.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,o.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,o.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const I=m.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const f=I.edits.map(h=>h.range);f.sort((h,d)=>h.end.line===d.end.line?h.end.character===d.end.character?h.start.line===d.start.line?h.start.character-d.start.character:h.start.line-d.start.line:h.end.character-d.end.character:h.end.line-d.end.line);for(let h=0,d=f.length-1;h<d;h++){const g=f[h].end;if(f[h+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=I.edits.map(h=>({range:M.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,a,{setEndOfLine:typeof I.setEndOfLine=="number"?M.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=O}),define(Ce[182],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[183],Ie([1,0,143,11,29,79,82,30,27,182,150]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=P.Registry.as(_.Extensions.JSONContribution);class m{constructor(c,v,t){this._messageHandler=c,this._extension=v,this._extensionPointId=t}_msg(c,v){this._messageHandler({type:c,message:v,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(c){this._msg(b.default.Error,c)}warn(c){this._msg(b.default.Warning,c)}info(c){this._msg(b.default.Info,c)}}e.ExtensionMessageCollector=m;class I{constructor(c,v){this.added=c,this.removed=v}static _toSet(c){const v=new Set;for(let t=0,u=c.length;t<u;t++)v.add(E.ExtensionIdentifier.toKey(c[t].description.identifier));return v}static compute(c,v){if(!c||!c.length)return new I(v,[]);if(!v||!v.length)return new I([],c);const t=this._toSet(c),u=this._toSet(v),n=v.filter(s=>!t.has(E.ExtensionIdentifier.toKey(s.description.identifier))),r=c.filter(s=>!u.has(E.ExtensionIdentifier.toKey(s.description.identifier)));return new I(n,r)}}e.ExtensionPointUserDelta=I;class f{constructor(c,v){this.name=c,this.defaultExtensionKind=v,this._handler=null,this._users=null,this._delta=null}setHandler(c){if(this._handler!==null)throw new Error("Handler already set!");this._handler=c,this._handle()}acceptUsers(c){this._delta=I.compute(this._users,c),this._users=c,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(c){(0,y.onUnexpectedError)(c)}}}e.ExtensionPoint=f;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:o.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:o.localize(31,null)},{label:"onUri",body:"onUri",description:o.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(36,null)},{label:"onRenderer",description:o.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(39,null)},{label:"*",description:o.localize(40,null),body:"*"}]}},badges:{type:"array",description:o.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(42,null)},href:{type:"string",description:o.localize(43,null)},description:{type:"string",description:o.localize(44,null)}}}},markdown:{type:"string",description:o.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(49,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(50,null)},{body:["workspace"],description:o.localize(51,null)},{body:["ui","workspace"],description:o.localize(52,null)},{body:["workspace","ui"],description:o.localize(53,null)},{body:[],description:o.localize(54,null)}]},capabilities:{description:o.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(58,null),o.localize(59,null),o.localize(60,null)]},description:{type:"string",markdownDescription:o.localize(61,null)}}},untrustedWorkspaces:{description:o.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(64,null),o.localize(65,null),o.localize(66,null)]},restrictedConfigurations:{description:o.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(68,null)}}}}},sponsor:{description:o.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(71,null),type:"string"},"vscode:uninstall":{description:o.localize(72,null),type:"string"}}},icon:{type:"string",description:o.localize(73,null)}}};class d{constructor(){this._extensionPoints=new Map}registerExtensionPoint(c){if(this._extensionPoints.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const v=new f(c.extensionPoint,c.defaultExtensionKind);return this._extensionPoints.set(c.extensionPoint,v),e.schema.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,w.registerSchema(h,e.schema),v}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=d;const g={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(g.ExtensionsRegistry,new d),e.ExtensionsRegistry=P.Registry.as(g.ExtensionsRegistry),w.registerSchema(h,e.schema),w.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[184],Ie([1,0,140,10,26,183,38,5]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var k;(function(m){function I(f,a,h){if(!f)return;const d=y.isString(f.type)?f.type:void 0;if(!d||d.length===0){h.error(o.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const A of f.required)y.isString(A)&&g.push(A);return{extensionId:a.value,taskType:d,required:g,properties:f.properties?b.deepClone(f.properties):{},when:f.when?_.ContextKeyExpr.deserialize(f.when):void 0}}m.from=I})(k||(k={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:E}});class w{constructor(){this._onDefinitionsChanged=new P.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,f)=>{O.setHandler((a,h)=>{this._schema=void 0;try{for(const d of h.removed){const g=d.value;for(const A of g)this.taskTypes&&A.type&&this.taskTypes[A.type]&&delete this.taskTypes[A.type]}for(const d of h.added){const g=d.value;for(const A of g){const c=k.from(A,d.description.identifier,d.collector);c&&(this.taskTypes[c.taskType]=c)}}(h.removed.length>0||h.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const f of this.all()){const a={type:"object",additionalProperties:!1};f.required.length>0&&(a.required=f.required.slice(0)),f.properties!==void 0?a.properties=b.deepClone(f.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[f.taskType]},I.push(a)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=w,e.TaskDefinitionRegistry=new w}),define(Ce[185],Ie([1,0,141,10,22,26,38,184]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var E;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function q(W){if(!W)return L.Strong;switch(W.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=q}(E=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(L){function q(W){switch(W.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=q}(O=e.RevealKind||(e.RevealKind={}));var w;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(L){function q(W){switch(W.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=q}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(L){function q(W){switch(W.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=q}(m=e.PanelKind||(e.PanelKind={}));var I;(function(L){L.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(L){function q(R){switch(R.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=q;function W(R){switch(R){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=W}(f=e.RuntimeType||(e.RuntimeType={}));var a;(function(L){function q(W){return y.isString(W)?W:W.value}L.value=q})(a=e.CommandString||(e.CommandString={}));var h;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function q(R){return R===L.Clean._id||R===L.Build._id||R===L.Rebuild._id||R===L.Test._id}L.is=q;function W(R){if(R!==void 0)return y.isString(R)?q(R)?{_id:R,isDefault:!1}:void 0:R}L.from=W})(h=e.TaskGroup||(e.TaskGroup={}));var d;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var g;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function q(W){switch(W){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=q})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var A;(function(L){L.parallel="parallel",L.sequence="sequence"})(A=e.DependsOrder||(e.DependsOrder={}));var c;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(c=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(q,W,R,Z,le,oe){this._label="",this._id=q,W&&(this._label=W),R&&(this.type=R),this.runOptions=Z,this.configurationProperties=le,this._source=oe}getDefinition(q){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const q={folder:this.getFolderId(),id:this._id};return JSON.stringify(q)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(q,W=!1){if(q===void 0)return!1;if(y.isString(q))return q===this._label||q===this.configurationProperties.identifier||W&&q===this._id;const R=this.getDefinition(!0);return R!==void 0&&R._key===q._key}getQualifiedLabel(){const q=this.getWorkspaceFolder();return q?`${this._label} (${q.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(q){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),q&&(this._taskLoadMessages=this._taskLoadMessages.concat(q))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class u extends t{constructor(q,W,R,Z,le,oe,ue,ee){super(q,R,void 0,ue,ee,W),this.command={},this._source=W,this.hasDefinedMatchers=oe,le&&(this.command=le)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(q=!1){if(q&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case f.Shell:W="shell";break;case f.Process:W="process";break;case f.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(q){return q instanceof u}getMapKey(){const q=this._source.config.workspaceFolder;return q?`${q.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const R={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:W};return JSON.stringify(R)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(q){return new u(q._id,q._source,q._label,q.type,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.CustomTask=u;class n extends t{constructor(q,W,R,Z,le,oe,ue){super(q,R,Z,oe,ue,W),this._source=W,this.configures=le}static is(q){return q instanceof n}fromObject(q){return q}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const q=this.getFolderId();if(!q)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const R={type:e.CUSTOMIZED_TASK_TYPE,folder:q,id:W};return JSON.stringify(R)}}e.ConfiguringTask=n;class r extends t{constructor(q,W,R,Z,le,oe,ue,ee,ve){super(q,R,Z,ee,ve,W),this.defines=le,this.hasDefinedMatchers=ue,this.command=oe,this.icon=ve.icon,this.hide=ve.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(q){return q instanceof r}getMapKey(){const q=this._source.workspaceFolder;return q?`${this._source.scope.toString()}|${q.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const q={type:"contributed",scope:this._source.scope,id:this._id};return q.folder=this.getFolderId(),JSON.stringify(q)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(q){return new r(q._id,q._source,q._label,q.type,q.defines,q.command,q.hasDefinedMatchers,q.runOptions,q.configurationProperties)}}e.ContributedTask=r;class s extends t{constructor(q,W,R,Z,le,oe){super(q,R,Z,le,oe,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(q){return q instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(q){return new s(q._id,q._source,q._label,q.type,q.runOptions,q.configurationProperties)}}e.InMemoryTask=s;var i;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(i=e.ExecutionEngine||(e.ExecutionEngine={})),function(L){L._default=L.Terminal}(i=e.ExecutionEngine||(e.ExecutionEngine={}));var l;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(l=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class S{constructor(q){this._order=new Map;for(let W=0;W<q.length;W++)this._order.set(q[W].uri.toString(),W)}compare(q,W){const R=q.getWorkspaceFolder(),Z=W.getWorkspaceFolder();if(R&&Z){let le=this._order.get(R.uri.toString());le=le===void 0?0:le+1;let oe=this._order.get(Z.uri.toString());return oe=oe===void 0?0:oe+1,le===oe?q._label.localeCompare(W._label):le-oe}else return!R&&Z?-1:R&&!Z?1:0}}e.TaskSorter=S;var p;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(L){L.SingleRun="singleRun",L.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var U;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(L){function q(W,R,Z,le,oe){if(R){const ue={kind:W,taskId:R._id,taskName:R.configurationProperties.name,runType:R.configurationProperties.isBackground?"background":"singleRun",group:R.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:R};return W==="start"?(ue.terminalId=Z,ue.resolvedVariables=le):W==="processStarted"?ue.processId=Z:W==="processEnded"&&(ue.exitCode=Z),Object.freeze(ue)}else return Object.freeze({kind:"changed"})}L.create=q})(j=e.TaskEvent||(e.TaskEvent={}));var x;(function(L){function q(R){const Z=Object.keys(R).sort();let le="";for(const oe of Z){let ue=R[oe];ue instanceof Object?ue=q(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),le+=oe+","+ue+","}return le}function W(R){const le={_key:q(R),type:R.taskType};return Object.assign(le,R),le}L.create=W})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var C;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})(C=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var N;(function(L){function q(W,R){const Z=P.TaskDefinitionRegistry.get(W.type);if(Z===void 0){const ee=M.deepClone(W);return delete ee._key,x.create(ee)}const le=Object.create(null);le.type=Z.taskType;const oe=new Set;Z.required.forEach(ee=>oe.add(ee));const ue=Z.properties;for(const ee of Object.keys(ue)){const ve=W[ee];if(ve!=null)le[ee]=ve;else if(oe.has(ee)){const we=ue[ee];if(we.default!==void 0)le[ee]=M.deepClone(we.default);else switch(we.type){case"boolean":le[ee]=!1;break;case"number":case"integer":le[ee]=0;break;case"string":le[ee]="";break;default:R.error(o.localize(2,null,JSON.stringify(W,void 0,0),ee));return}}}return x.create(le)}L.createTaskIdentifier=q})(N=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[186],Ie([1,0,11]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,P)=>{this._actualOk=_,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,o.onUnexpectedError)(_))}then(_,P){return this._ensureActual().then(_,P)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=y;class b extends y{constructor(){super(),this._hasErr=!0,this._err=new o.CancellationError}}e.CanceledLazyPromise=b}),define(Ce[40],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const y=[];function b(P){const E=new o(P);return y[E.nid]=E,E}e.createProxyIdentifier=b;function M(P){return y[P].sid}e.getStringIdentifierForProxy=M;class _{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=_}),define(Ce[4],Ie([1,0,40]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var y;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var b;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(b=e.TabInputKind||(e.TabInputKind={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(h){return h._id=w._n++,h}}e.IdObject=w,w._n=0;var m;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ce[66],Ie([1,0,3,15,4,13]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(b.MainContext.MainThreadTelemetry)}report(E,k,O){const w=this.getUsageKey(E,k);this._reportedUsages.has(w)||(this._reportedUsages.add(w),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};_=xe([$e(0,M.IExtHostRpcService),$e(1,y.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(P,E,k){}})}),define(Ce[187],Ie([1,0,5,4,6,27]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,O,w={}){const m=M.ExtensionIdentifier.toKey(E.identifier),I=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let a=I.find(h=>h.providerId===k&&h.scopes===f);if(a)return a.result;{const h=this._getSession(E,m,k,O,w);a={providerId:k,scopes:f,result:h},I.push(a),this._inFlightRequests.set(m,I);try{await h}finally{const d=I.findIndex(g=>g.providerId===k&&g.scopes===f);d>-1&&(I.splice(d),this._inFlightRequests.set(m,I))}return h}}async _getSession(E,k,O,w,m={}){await this._proxy.$ensureProvider(O);const I=E.displayName||E.name;return this._proxy.$getSession(O,w,k,I,m)}async removeSession(E,k){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,O,w){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:O,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===E)||this._providers.push({id:E,label:k});const m=O.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(E,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,w?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const I=this._providers.findIndex(f=>f.id===E);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ce[188],Ie([1,0,4,13,8,24]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(E,k){this._proxy=E.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>k.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,k){const O=(0,M.isProposedApiEnabled)(k,"snippetWorkspaceEdit"),w=b.WorkspaceEdit.from(E,this._versionInformationProvider,O);return this._proxy.$tryApplyWorkspaceEdit(w)}};_=xe([$e(0,y.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ce[189],Ie([1,0,4]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(M){const _=M.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(P){return _.$writeText(P)}})}}e.ExtHostClipboard=y});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[36],Ie([1,0,10,6,8,26,4,16,15,74,49,242,2,7,3,13,94,23,40,43]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A){"use strict";var c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(l,S){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,v.set(this,void 0),Je(this,c,l.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=S,Je(this,v,l.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const T=this._apiCommands.get(p);return T?.result===r.Void?T:void 0},S),this._argumentProcessors=[{processArgument(p){return(0,k.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(T){if(O.Range.isIRange(T))return b.Range.to(T);if(w.Position.isIPosition(T))return b.Position.to(T);if(O.Range.isIRange(T.range)&&m.URI.isUri(T.uri))return b.location.to(T);if(T instanceof d.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const S=this.registerCommand(!1,l.id,async(...p)=>{const T=l.args.map((j,x)=>{if(!j.validate(p[x]))throw new Error(`Invalid argument '${j.name}' when running '${l.id}', received: ${p[x]}`);return j.convert(p[x])}),U=await this.executeCommand(l.internalId,...T);return l.result.convert(U,p,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new y.Disposable(()=>{S.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,S,p,T,U,j){if(this._logService.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this._commands.has(S))throw new Error(`command '${S}' already exists`);return this._commands.set(S,{callback:p,thisArg:T,description:U,extension:j}),l&&Oe(this,c,"f").$registerCommand(S),new y.Disposable(()=>{this._commands.delete(S)&&l&&Oe(this,c,"f").$unregisterCommand(S)})}executeCommand(l,...S){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,S,!0)}async _doExecuteCommand(l,S,p){if(this._commands.has(l))return Oe(this,c,"f").$fireCommandActivationEvent(l),this._executeContributedCommand(l,S,!1);{let T=!1;const U=(0,M.cloneAndChange)(S,function(j){if(j instanceof y.Position)return b.Position.from(j);if(j instanceof y.Range)return b.Range.from(j);if(j instanceof y.Location)return b.location.from(j);if(y.NotebookRange.isNotebookRange(j))return b.NotebookRange.from(j);if(j instanceof ArrayBuffer)return T=!0,d.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return T=!0,d.VSBuffer.wrap(j);if(j instanceof d.VSBuffer)return T=!0,j;if(!Array.isArray(j))return j});try{const j=await Oe(this,c,"f").$executeCommand(l,T?new g.SerializableObjectWithBuffers(U):U,p);return(0,k.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(l,S,!1);throw j}}}async _executeContributedCommand(l,S,p){const T=this._commands.get(l);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,l);const{callback:U,thisArg:j,description:x}=T;if(x)for(let C=0;C<x.args.length;C++)try{(0,o.validateConstraint)(S[C],x.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${x.args[C].name}' - ${x.args[C].description}`)}try{return await U.apply(j,S)}catch(C){if(l===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...S);z&&(l=z.command)}throw this._logService.error(C,l,T.extension?.identifier),p?new class extends Error{constructor(){super((0,A.toErrorMessage)(C)),this.id=l,this.source=T.extension?.displayName??T.extension?.name}}:C}}_reportTelemetry(l,S){!l.extension||l.extension.isBuiltin||Oe(this,v,"f").$publicLog2("Extension:ActionExecuted",{extensionId:l.extension.identifier.value,id:S})}$executeContributedCommand(l,...S){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(S=S.map(p=>this._argumentProcessors.reduce((T,U)=>U.processArgument(T),p)),this._executeContributedCommand(l,S,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),Oe(this,c,"f").$getCommands().then(S=>(l&&(S=S.filter(p=>p[0]!=="_")),S))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(const[S,p]of this._commands){const{description:T}=p;T&&(l[S]=T)}return Promise.resolve(l)}};c=new WeakMap,v=new WeakMap,t=xe([$e(0,a.IExtHostRpcService),$e(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(l,S,p){this._commands=l,this._lookupApiCommand=S,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,S){if(!l)return;const p={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return p;const T=this._lookupApiCommand(l.command);if(T)p.id=T.internalId,p.arguments=T.args.map((U,j)=>U.convert(l.arguments&&l.arguments[j]));else if((0,P.isNonEmptyArray)(l.arguments)){const U=++this._cachIdPool;this._cache.set(U,l),S.add((0,I.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),p.$ident=U,p.id=this.delegatingCommandId,p.arguments=[U],this._logService.trace("CommandsConverter#CREATE",l.command,U)}return p}fromInternal(l){return typeof l.$ident=="number"?this._cache.get(l.$ident):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const S=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],S?S.command:"MISSING"),S?this._commands.executeCommand(S.command,...S.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(l,S,p,T){this.name=l,this.description=S,this.validate=p,this.convert=T}optional(){return new n(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,S){return new n(l??this.name,S??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",i=>m.URI.isUri(i),i=>i),n.Position=new n("position","A position in a text document",i=>y.Position.isPosition(i),b.Position.from),n.Range=new n("range","A range in a text document",i=>y.Range.isRange(i),b.Range.from),n.Selection=new n("selection","A selection in a text document",i=>y.Selection.isSelection(i),b.Selection.from),n.Number=new n("number","",i=>typeof i=="number",i=>i),n.String=new n("string","",i=>typeof i=="string",i=>i),n.CallHierarchyItem=new n("item","A call hierarchy item",i=>i instanceof y.CallHierarchyItem,b.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",i=>i instanceof y.TypeHierarchyItem,b.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",i=>i instanceof h.TestItemImpl,b.TestItem.from);class r{constructor(l,S){this.description=l,this.convert=S}}e.ApiCommandResult=r,r.Void=new r("no result",i=>i);class s{constructor(l,S,p,T,U){this.id=l,this.internalId=S,this.description=p,this.args=T,this.result=U}}e.ApiCommand=s}),define(Ce[190],Ie([1,0,2,8,6,65,36,16,77,81,12]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(y.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,h)=>{if((0,P.isFalsyOrEmpty)(a))return;class d extends b.SymbolInformation{static to(A){const c=new d(A.name,y.SymbolKind.to(A.kind),A.containerName||"",new b.Location(h[0],y.Range.to(A.range)));return c.detail=A.detail,c.range=c.location.range,c.selectionRange=y.Range.to(A.selectionRange),c.children=A.children?A.children.map(d.to):[],c}}return a.map(d.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new _.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(y.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(y.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(y.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(h=>b.Position.isPosition(h)),a=>a.map(y.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(h=>{let d;for(const g of h.reverse())d=new b.SelectionRange(y.Range.to(g),d);return d}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(y.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(y.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:y.Range.to(a.range),placeholder:a.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new b.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const h=(0,E.decodeSemanticTokensDto)(a);if(h.type==="full")return new b.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new b.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const h=(0,E.decodeSemanticTokensDto)(a);if(h.type==="full")return new b.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,h,d)=>{if(!a)return new b.CompletionList([]);const g=a.suggestions.map(A=>y.CompletionItem.to(A,d));return new b.CompletionList(g,a.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,h,d)=>I(g=>new b.CodeLens(y.Range.to(g.range),g.command&&d.fromInternal(g.command)))(a))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>b.Range.isRange(a),a=>b.Selection.isSelection(a)?y.Selection.from(a):y.Range.from(a)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,h,d)=>I(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const A=new b.CodeAction(g.title,g.kind?new b.CodeActionKind(g.kind):void 0);return g.edit&&(A.edit=y.WorkspaceEdit.to(g.edit)),g.command&&(A.command=d.fromInternal(g.command)),A.isPreferred=g.isPreferred,A}})(a))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(h=>new b.ColorInformation(y.Range.to(h.range),y.Color.to(h.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",a=>a instanceof b.Color,y.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,h,d)=>a.map(y.InlayHint.to.bind(void 0,d)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(h=>y.NotebookExclusiveDocumentPattern.to(h))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(y.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>o.URI.isUri(a)||typeof a=="string"&&(0,k.matchesSomeScheme)(a,O.Schemas.http,O.Schemas.https),a=>a),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",a=>a.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(h){w.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=m;function I(a){return h=>{if(Array.isArray(h))return h.map(a)}}function f(a){if(!Array.isArray(a))return;const h=[];for(const d of a)M.isLocationLink(d)?h.push(y.DefinitionLink.to(d)):h.push(y.location.to(d));return h}}),define(Ce[191],Ie([1,0,14,55,5,7,2,65,27,8,6,24,4]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(f,a,h){const d=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const l=this._commentControllers.get(i.handle);return l?l.value:i}else if(i&&i.$mid===7){const l=this._commentControllers.get(i.commentControlHandle);if(!l)return i;const S=l.getCommentThread(i.commentThreadHandle);return S?S.value:i}else if(i&&i.$mid===8){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const S=l.getCommentThread(i.thread.commentThreadHandle);return S?{thread:S.value,text:i.text}:i}else if(i&&i.$mid===9){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const S=l.getCommentThread(i.thread.commentThreadHandle);if(!S)return i;const p=i.commentUniqueId,T=S.getCommentByUniqueId(p);return T||i}else if(i&&i.$mid===10){const l=this._commentControllers.get(i.thread.commentControlHandle);if(!l)return i;const S=l.getCommentThread(i.thread.commentThreadHandle);if(!S)return i;const p=i.text,T=i.commentUniqueId,U=S.getCommentByUniqueId(T);return U?(typeof U.body=="string"?U.body=p:U.body.value=p,U):i}return i}})}createCommentController(i,l,S){const p=g.handlePool++,T=new c(i,p,l,S);this._commentControllers.set(T.handle,T);const U=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(i.identifier))||[];return U.push(T),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(i.identifier),U),T.value}$createCommentThreadTemplate(i,l,S){const p=this._commentControllers.get(i);!p||p.$createCommentThreadTemplate(l,S)}async $updateCommentThreadTemplate(i,l,S){const p=this._commentControllers.get(i);!p||p.$updateCommentThreadTemplate(l,S)}$deleteCommentThread(i,l){this._commentControllers.get(i)?.$deleteCommentThread(l)}$provideCommentingRanges(i,l,S){const p=this._commentControllers.get(i);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const T=h.getDocument(_.URI.revive(l));return(0,o.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(T,S)).then(U=>U?U.map(j=>k.Range.from(j)):void 0)}$toggleReaction(i,l,S,p,T){const U=this._commentControllers.get(i);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const j=U.getCommentThread(l);if(j){const x=j.getCommentByUniqueId(p.uniqueIdInThread);if(U!==void 0&&x&&U.reactionHandler)return U.reactionHandler(x,u(T))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class A{constructor(i,l,S,p,T,U,j,x){this._commentControllerHandle=l,this._id=S,this._uri=p,this._range=T,this._comments=U,this.extensionDescription=j,this._isTemplate=x,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),d.$createCommentThread(l,this.handle,this._id,this._uri,k.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{d.$deleteCommentThread(l,this.handle)}});const C=this;this.value={get uri(){return C.uri},get range(){return C.range},set range(z){C.range=z},get comments(){return C.comments},set comments(z){C.comments=z},get collapsibleState(){return C.collapsibleState},set collapsibleState(z){C.collapsibleState=z},get canReply(){return C.canReply},set canReply(z){C.canReply=z},get contextValue(){return C.contextValue},set contextValue(z){C.contextValue=z},get label(){return C.label},set label(z){C.label=z},get state(){return C.state},set state(z){C.state=z},dispose:()=>{C.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(i){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=i,this.modifications.state=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const i=S=>Object.prototype.hasOwnProperty.call(this.modifications,S),l={};i("range")&&(l.range=k.Range.from(this._range)),i("label")&&(l.label=this.label),i("contextValue")&&(l.contextValue=this.contextValue??null),i("comments")&&(l.comments=this._comments.map(S=>v(this,S,this._commentsMap))),i("collapsibleState")&&(l.collapseState=n(this._collapseState)),i("canReply")&&(l.canReply=this.canReply),i("state")&&(l.state=r(this._state)),i("isTemplate")&&(l.isTemplate=this._isTemplate),this.modifications={},d.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(i){for(const l of this._commentsMap){const S=l[0],p=l[1];if(i===p)return S}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}A._handlePool=0,xe([(0,y.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(i,l,S,p){this._extension=i,this._handle=l,this._id=S,this._label=p,this._threads=new Map,d.$registerCommentController(this.handle,S,p);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(U){T.options=U},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(U){T.commentingRangeProvider=U},get reactionHandler(){return T.reactionHandler},set reactionHandler(U){T.reactionHandler=U},createCommentThread(U,j,x){return T.createCommentThread(U,j,x).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,d.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,l,S,p){if(typeof i=="string"){const T=new A(this.id,this.handle,i,l,S,p,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new A(this.id,this.handle,void 0,i,l,S,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(i,l){const S=new A(this.id,this.handle,void 0,_.URI.revive(i),k.Range.to(l),[],this._extension,!0);return S.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(S.handle,S),S}$updateCommentThreadTemplate(i,l){const S=this._threads.get(i);S&&(S.range=k.Range.to(l))}$deleteCommentThread(i){this._threads.get(i)?.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function v(s,i,l){let S=l.get(i);S||(S=++s.commentHandle,l.set(i,S));const p=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:S,body:typeof i.body=="string"?i.body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:p,label:i.label,commentReactions:i.reactions?i.reactions.map(T=>t(T)):void 0,timestamp:i.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function u(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?_.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function n(s){if(s!==void 0)switch(s){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function r(s){if(s!==void 0)switch(s){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new g}e.createExtHostComments=I}),define(Ce[192],Ie([1,0,26,4,28,13]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(O,w){this._mainThreadConsole=O.getProxy(y.MainContext.MainThreadConsole),this._includeStack=w.consoleForward.includeStack,this._logNative=w.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,w){const m=this,I=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,w,I,arguments)}})}_handleConsoleCall(O,w,m,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:w,arguments:E(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,I)}};_=xe([$e(0,M.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const P=1e5;function E(k,O){const w=[];if(k.length)for(let m=0;m<k.length;m++){let I=k[m];if(typeof I>"u")I="undefined";else if(I instanceof Error){const f=I;f.stack?I=f.stack:I=f.toString()}w.push(I)}if(O){const m=new Error().stack;m&&w.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,o.safeStringify)(w);return m.length>P?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[96],Ie([1,0,2,4,6,3,13,15,16,9,19]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Ai{constructor(I,f){this._logService=f,this._provider=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,f){const a=Ai._handlePool++;this._provider.set(a,{provider:I,extensionId:f}),this._proxy.$registerDecorationProvider(a,f.value);const h=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(d=>{if(!d){this._proxy.$onDidChange(a,null);return}const g=(0,E.asArray)(d);if(g.length<=Ai._maxEventSize){this._proxy.$onDidChange(a,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const A=g.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),c=(0,E.groupBy)(A,(t,u)=>t.rank-u.rank||(0,k.compare)(t.uri.path,u.uri.path)),v=[];e:for(const t of c){let u;for(const n of t){const r=(0,O.dirname)(n.uri.path);if(u!==r&&(u=r,v.push(n.uri)>=Ai._maxEventSize))break e}}this._proxy.$onDidChange(a,v)});return new b.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(I,f,a){if(!this._provider.has(I))return Object.create(null);const h=Object.create(null),{provider:d,extensionId:g}=this._provider.get(I);return await Promise.all(f.map(async A=>{try{const{uri:c,id:v}=A,t=await Promise.resolve(d.provideFileDecoration(o.URI.revive(c),a));if(!t)return;try{b.FileDecoration.validate(t),h[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${g.value}': ${u}`)}}catch(c){this._logService.error(c)}})),h}};w._handlePool=0,w._maxEventSize=250,w=xe([$e(0,_.IExtHostRpcService),$e(1,P.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[193],Ie([1,0,130,80,2,4,6,8,5,15,25,35]),function(ne,e,o,y,b,M,_,P,E,k,O,w){"use strict";var m,I,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,A,c,v,t,u){this._name=g,this._owner=A,this._maxDiagnosticsPerFile=c,m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new O.ResourceMap(n=>v.getComparisonKey(n)),"f"),Je(this,m,t,"f"),Je(this,I,u,"f")}dispose(){this._isDisposed||(Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,A){if(!g){this.clear();return}this._checkDisposed();let c=[];if(b.URI.isUri(g)){if(!A){this.delete(g);return}Oe(this,f,"f").set(g,A.slice()),c=[g]}else if(Array.isArray(g)){c=[];let t;g=[...g].sort(a._compareIndexedTuplesByUri);for(const u of g){const[n,r]=u;if((!t||n.toString()!==t.toString())&&(t&&Oe(this,f,"f").get(t).length===0&&Oe(this,f,"f").delete(t),t=n,c.push(n),Oe(this,f,"f").set(n,[])),r)Oe(this,f,"f").get(n)?.push(...r);else{const s=Oe(this,f,"f").get(n);s&&(s.length=0)}}}if(Oe(this,I,"f").fire(c),!Oe(this,m,"f"))return;const v=[];for(const t of c){let u=[];const n=Oe(this,f,"f").get(t);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const r=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const i of n)if(i.severity===r[s]&&u.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:y.MarkerSeverity.Info,message:(0,o.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(r=>P.Diagnostic.from(r));v.push([t,u])}Oe(this,m,"f").$changeMany(this._owner,v)}delete(g){this._checkDisposed(),Oe(this,I,"f").fire([g]),Oe(this,f,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,A){this._checkDisposed();for(const[c,v]of this)g.call(A,c,v,this)}*[(m=new WeakMap,I=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const A=Oe(this,f,"f").get(g);return Array.isArray(A)?Object.freeze(A.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,A){return g[0].toString()<A[0].toString()?-1:g[0].toString()>A[0].toString()?1:0}}e.DiagnosticCollection=a;let h=class fi{constructor(g,A,c){this._logService=A,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(g){const A=new O.ResourceMap;for(const c of g)A.set(c,c);return{uris:Object.freeze(Array.from(A.values()))}}createDiagnosticCollection(g,A){const{_collections:c,_proxy:v,_onDidChangeDiagnostics:t,_logService:u,_fileSystemInfoService:n}=this,r=new class{$changeMany(l,S){v.$changeMany(l,S),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,l,S.length===0?"CLEARING":S)}$clear(l){v.$clear(l),u.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,l)}dispose(){v.dispose()}};let s;if(!A)A="_generated_diagnostic_collection_name_#"+fi._idPool++,s=A;else if(!c.has(A))s=A;else{this._logService.warn(`DiagnosticCollection with name '${A}' does already exist.`);do s=A+fi._idPool++;while(c.has(s))}return new class extends a{constructor(){super(A,s,fi._maxDiagnosticsPerFile,n.extUri,r,t),c.set(s,this)}dispose(){super.dispose(),c.delete(s)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const A=new Map,c=[];for(const v of this._collections.values())v.forEach((t,u)=>{let n=A.get(t.toString());typeof n>"u"&&(n=c.length,A.set(t.toString(),n),c.push([t,[]])),c[n][1]=c[n][1].concat(...u)});return c}}_getDiagnostics(g){let A=[];for(const c of this._collections.values())c.has(g)&&(A=A.concat(c.get(g)));return A}$acceptMarkersChange(g){if(!this._mirrorCollection){const A="_generated_mirror",c=new a(A,A,fi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(A,c),this._mirrorCollection=c}for(const[A,c]of g)this._mirrorCollection.set(b.URI.revive(A),c.map(P.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=xe([$e(1,k.ILogService),$e(2,w.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(Ce[194],Ie([1,0,2,4]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(_){this._proxy=_.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(P=>P?P.map(E=>o.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(P=>P?o.URI.revive(P):void 0)}}e.ExtHostDialogs=b}),define(Ce[195],Ie([1,0,11,2,6,4,12,20,9]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,m,I){this._documentsAndEditors=m,this._logService=I,this._documentContentProviders=new Map,this._proxy=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,m){if(Object.keys(_.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const I=k._handlePool++;this._documentContentProviders.set(I,m),this._proxy.$registerTextContentProvider(I,w);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(a=>{if(a.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(I,a).then(h=>{if(!h&&typeof h!="string")return;const d=this._documentsAndEditors.getDocument(a);if(!d)return;const g=(0,E.splitLines)(h);if(!d.equalLines(g))return this._proxy.$onVirtualDocumentChange(a,h)},o.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,m){const I=this._documentContentProviders.get(w);return I?Promise.resolve(I.provideTextDocumentContent(y.URI.revive(m),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ce[196],Ie([1,0,5,7,2,4,92,8,10,26,6]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(I,f){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(a=>{for(const h of a)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(a=>{for(const h of a)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const f=this._documentsAndEditors.getDocument(I);if(f)return f}getDocument(I){const f=this.getDocumentData(I);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return f.document}ensureDocumentData(I){const f=this._documentsAndEditors.getDocument(I);if(f)return Promise.resolve(f);let a=this._documentLoader.get(I.toString());return a||(a=this._proxy.$tryOpenDocument(I).then(h=>{this._documentLoader.delete(I.toString());const d=b.URI.revive(h);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(d))},h=>(this._documentLoader.delete(I.toString()),Promise.reject(h))),this._documentLoader.set(I.toString(),a)),a}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(f=>b.URI.revive(f))}$acceptModelLanguageChanged(I,f){const a=b.URI.revive(I),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(I){const f=b.URI.revive(I),a=this._documentsAndEditors.getDocument(f);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(a.document)}$acceptDirtyStateChanged(I,f){const a=b.URI.revive(I),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,f,a){const h=b.URI.revive(I),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(a),d.onEvents(f);let g;f.isUndoing?g=O.TextDocumentChangeReason.Undo:f.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:d.document,contentChanges:f.changes.map(A=>({range:P.Range.to(A.range),rangeOffset:A.rangeOffset,rangeLength:A.rangeLength,text:A.text})),reason:g}))}setWordDefinitionFor(I,f){(0,_.setWordDefinitionFor)(I,f)}}e.ExtHostDocuments=w}),define(Ce[50],Ie([1,0,44,5,7,2,3,4,92,13,95,8,15,25,12,166,197]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(c,v){this._extHostRpc=c,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const v=[],t=[],u=[];if(c.removedDocuments)for(const n of c.removedDocuments){const r=M.URI.revive(n),s=this._documents.get(r);s?.unref()&&(this._documents.delete(r),v.push(s.value))}if(c.addedDocuments)for(const n of c.addedDocuments){const r=M.URI.revive(n.uri);let s=this._documents.get(r);if(s&&r.scheme!==f.Schemas.vscodeNotebookCell&&r.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);s||(s=new d(new E.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),r,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(r,s),t.push(s.value)),s.ref()}if(c.removedEditors)for(const n of c.removedEditors){const r=this._editors.get(n);this._editors.delete(n),r&&u.push(r)}if(c.addedEditors)for(const n of c.addedEditors){const r=M.URI.revive(n.documentUri);o.ok(this._documents.has(r),`document '${r}' does not exist`),o.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(r).value,i=new O.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>s.document),n.selections.map(w.Selection.to),n.options,n.visibleRanges.map(l=>w.Range.to(l)),typeof n.editorPosition=="number"?w.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,i)}c.newActiveEditor!==void 0&&(o.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,b.dispose)(v),(0,b.dispose)(u),c.removedDocuments&&this._onDidRemoveDocuments.fire(v),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return a.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return c?v:v?.value}allEditors(){return[...this._editors.values()]}};g=xe([$e(0,k.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,13,10,71]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class w{constructor(h,d,g){this._activeTabIdGetter=g,this._parentGroup=d,this.acceptDtoUpdate(h)}get apiObject(){if(!this._apiObject){const h=this,d={get isActive(){return h._dto.id===h._activeTabIdGetter()},get label(){return h._dto.label},get input(){return h._input},get isDirty(){return h._dto.isDirty},get isPinned(){return h._dto.isPinned},get isPreview(){return h._dto.isPreview},get group(){return h._parentGroup.apiObject}};this._apiObject=Object.freeze(d)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(h){this._dto=h,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new P.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new P.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new P.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new P.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new P.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new P.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(h,d){this._tabs=[],this._activeTabId="",this._dto=h,this._activeGroupIdGetter=d;for(const g of h.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const h=this,d={get isActive(){return h._dto.groupId===h._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(h._dto.viewColumn)},get activeTab(){return h._tabs.find(g=>g.tabId===h._activeTabId)?.apiObject},get tabs(){return Object.freeze(h._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(d)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(h){this._dto=h}acceptTabOperation(h){if(h.kind===0){const g=new w(h.tabDto,this,()=>this.activeTabId());return this._tabs.splice(h.index,0,g),h.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(h.kind===1){const g=this._tabs.splice(h.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(h.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this._tabs.splice(h.index,0,g),g}const d=this._tabs.find(g=>g.tabId===h.tabDto.id);if(!d)throw new Error("INVALID tab");return h.tabDto.isActive?this._activeTabId=h.tabDto.id:this._activeTabId===h.tabDto.id&&!h.tabDto.isActive&&(this._activeTabId=""),d.acceptDtoUpdate(h.tabDto),d}activeTabId(){return this._activeTabId}}let I=class{constructor(h){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=h.getProxy(y.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const h=this,d={onDidChangeTabGroups:h._onDidChangeTabGroups.event,onDidChangeTabs:h._onDidChangeTabs.event,get all(){return Object.freeze(h._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=h._activeGroupId;return(0,k.assertIsDefined)(h._extHostTabGroups.find(c=>c.groupId===g)?.apiObject)},close:async(g,A)=>{const c=Array.isArray(g)?g:[g];return c.length?f(c[0])?this._closeGroups(c,A):this._closeTabs(c,A):!0}};this._apiObject=Object.freeze(d)}return this._apiObject}$acceptEditorTabModel(h){const d=new Set(this._extHostTabGroups.map(n=>n.groupId)),g=new Set(h.map(n=>n.groupId)),A=(0,O.diffSets)(d,g),c=this._extHostTabGroups.filter(n=>A.removed.includes(n.groupId)).map(n=>n.apiObject),v=[],t=[];this._extHostTabGroups=h.map(n=>{const r=new m(n,()=>this._activeGroupId);return A.added.includes(r.groupId)?v.push(r.apiObject):t.push(r.apiObject),r});const u=(0,k.assertIsDefined)(h.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:v,closed:c,changed:t}))}$acceptTabGroupUpdate(h){const d=this._extHostTabGroups.find(g=>g.groupId===h.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(h),h.isActive&&(this._activeGroupId=h.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const d=this._extHostTabGroups.find(A=>A.groupId===h.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const g=d.acceptTabOperation(h);switch(h.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(h){for(const d of this._extHostTabGroups)for(const g of d.tabs)if(g.apiObject===h)return g}_findExtHostTabGroupFromApi(h){return this._extHostTabGroups.find(d=>d.apiObject===h)}async _closeTabs(h,d){const g=[];for(const A of h){const c=this._findExtHostTabFromApi(A);if(!c)throw new Error("Tab close: Invalid tab not found!");g.push(c.tabId)}return this._proxy.$closeTab(g,d)}async _closeGroups(h,d){const g=[];for(const A of h){const c=this._findExtHostTabGroupFromApi(A);if(!c)throw new Error("Group close: Invalid group not found!");g.push(c.groupId)}return this._proxy.$closeGroup(g,d)}};I=xe([$e(0,E.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function f(a){return a.tabs!==void 0}}),define(Ce[198],Ie([1,0,2,4,7,6,8,243,9,23,24]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const a=this._schemes.indexOf(f);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),a=[];let h,d,g=14,A=14;for(const c of f){let v=h?(0,E.commonPrefixLength)(h,c):0;for(v===0?d=1:d=A;v<c.length;v++)v+1===c.length?(g=A,A=9):A+=1,a.push([d,c.toUpperCase().charCodeAt(v),A]),a.push([d,c.toLowerCase().charCodeAt(v),A]),d=A;h=c,A=g}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new P.StateMachine(a)}}provideDocumentLinks(f){this._initStateMachine();const a=[],h=P.LinkComputer.computeLinks({getLineContent(d){return f.lineAt(d-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const d of h){const g=_.DocumentLink.to(d);g.target&&a.push(g)}return a}}class m{constructor(f,a){this._extHostLanguageFeatures=a,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,a,h,d={}){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(g,h);let A=2;d.isCaseSensitive&&(A+=1024),d.isReadonly&&(A+=2048),typeof h.copy=="function"&&(A+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),A+=4),this._proxy.$registerFileSystemProvider(g,a,A).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${a}`),console.error(v)});const c=h.onDidChangeFile(v=>{const t=[];for(const u of v){const{uri:n,type:r}=u;if(n.scheme!==a)continue;let s;switch(r){case M.FileChangeType.Changed:s=0;break;case M.FileChangeType.Created:s=1;break;case M.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:n,type:s})}this._proxy.$onFileSystemChange(g,t)});return(0,b.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:a,ctime:h,mtime:d,size:g,permissions:A}=f;return{type:a,ctime:h,mtime:d,size:g,permissions:A}}$stat(f,a){return Promise.resolve(this._getFsProvider(f).stat(o.URI.revive(a))).then(h=>m._asIStat(h))}$readdir(f,a){return Promise.resolve(this._getFsProvider(f).readDirectory(o.URI.revive(a)))}$readFile(f,a){return Promise.resolve(this._getFsProvider(f).readFile(o.URI.revive(a))).then(h=>k.VSBuffer.wrap(h))}$writeFile(f,a,h,d){return Promise.resolve(this._getFsProvider(f).writeFile(o.URI.revive(a),h.buffer,d))}$delete(f,a,h){return Promise.resolve(this._getFsProvider(f).delete(o.URI.revive(a),h))}$rename(f,a,h,d){return Promise.resolve(this._getFsProvider(f).rename(o.URI.revive(a),o.URI.revive(h),d))}$copy(f,a,h,d){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(o.URI.revive(a),o.URI.revive(h),d))}$mkdir(f,a){return Promise.resolve(this._getFsProvider(f).createDirectory(o.URI.revive(a)))}$watch(f,a,h,d){const g=this._getFsProvider(f).watch(o.URI.revive(h),d);this._watches.set(a,g)}$unwatch(f,a){const h=this._watches.get(a);h&&(h.dispose(),this._watches.delete(a))}$open(f,a,h){const d=this._getFsProvider(f);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(o.URI.revive(a),h))}$close(f,a){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(a))}$read(f,a,h,d){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const A=k.VSBuffer.alloc(d);return Promise.resolve(g.read(a,h,A.buffer,0,d)).then(c=>A.slice(0,c))}$write(f,a,h,d){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,h,d.buffer,0,d.byteLength))}_getFsProvider(f){const a=this._fsProvider.get(f);if(!a){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return a}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,39,6,23,3,13,35,7]),function(ne,e,o,y,b,M,_,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Xt{constructor(m,I){this._fileSystemProvider=new Map,this._proxy=m.getProxy(o.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(a){try{const h=f._fileSystemProvider.get(a.scheme);if(!h)return await f._proxy.$stat(a);await f._proxy.$ensureActivation(a.scheme);const d=await h.stat(a);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(h){Xt._handleError(h)}},async readDirectory(a){try{const h=f._fileSystemProvider.get(a.scheme);return h?(await f._proxy.$ensureActivation(a.scheme),(await h.readDirectory(a)).slice()):await f._proxy.$readdir(a)}catch(h){return Xt._handleError(h)}},async createDirectory(a){try{return await f._proxy.$mkdir(a)}catch(h){return Xt._handleError(h)}},async readFile(a){try{const h=f._fileSystemProvider.get(a.scheme);return h?(await f._proxy.$ensureActivation(a.scheme),(await h.readFile(a)).slice()):(await f._proxy.$readFile(a)).buffer}catch(h){return Xt._handleError(h)}},async writeFile(a,h){try{return await f._proxy.$writeFile(a,M.VSBuffer.wrap(h))}catch(d){return Xt._handleError(d)}},async delete(a,h){try{const d=f._fileSystemProvider.get(a.scheme);return d?(await f._proxy.$ensureActivation(a.scheme),await d.delete(a,{recursive:!1,...h})):await f._proxy.$delete(a,{recursive:!1,useTrash:!1,...h})}catch(d){return Xt._handleError(d)}},async rename(a,h,d){try{return await f._proxy.$rename(a,h,{overwrite:!1,...d})}catch(g){return Xt._handleError(g)}},async copy(a,h,d){try{return await f._proxy.$copy(a,h,{overwrite:!1,...d})}catch(g){return Xt._handleError(g)}},isWritableFileSystem(a){const h=I.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case y.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case y.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case y.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case y.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,I){return this._fileSystemProvider.set(m,I),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=xe([$e(0,P.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[199],Ie([1,0,5,34,2,4,8,6,24]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(m,I,f,a,h,d,g,A){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const c=this.ensureWatching(m,f,h);this._config=0,d&&(this._config+=1),g&&(this._config+=2),A&&(this._config+=4);const v=(0,y.parse)(h),t=typeof h=="string",u=a(n=>{if(!d)for(const r of n.created){const s=b.URI.revive(r);v(s.fsPath)&&(!t||I.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(const r of n.changed){const s=b.URI.revive(r);v(s.fsPath)&&(!t||I.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!A)for(const r of n.deleted){const s=b.URI.revive(r);v(s.fsPath)&&(!t||I.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=P.Disposable.from(c,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,I,f){const a=P.Disposable.from();if(typeof f=="string")return a;const h=m.getProxy(M.MainContext.MainThreadFileSystem);let d=!1;(f.pattern.includes(y.GLOBSTAR)||f.pattern.includes(y.GLOB_SPLIT))&&(d=!0);const g=Math.random();return h.$watch(I.identifier.value,g,f.baseUri,{recursive:d,excludes:[]}),P.Disposable.from({dispose:()=>h.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class O{constructor(m,I,f){this._mainContext=m,this._logService=I,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,I,f,a,h,d){return new k(this._mainContext,m,I,this._onFileSystemEvent.event,_.GlobPattern.from(f),a,h,d)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,I){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(f=>({oldUri:b.URI.revive(f.source),newUri:b.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,I){return(f,a,h)=>{const d=function(A){f.call(a,A)};return d.extension=m,I.event(d,void 0,h)}}async $onWillRunFileOperation(m,I,f,a){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:b.URI.revive(h.source),newUri:b.URI.revive(h.target)}))},f,a);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>b.URI.revive(h.target))},f,a);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>b.URI.revive(h.target))},f,a)}}async _fireWillEvent(m,I,f,a){const h=new Set,d=[];if(await m.fireAsync(I,a,async(A,c)=>{const v=Date.now(),t=await Promise.resolve(A);t instanceof P.WorkspaceEdit&&(d.push([c.extension,t]),h.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-v>f&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),a.isCancellationRequested||d.length===0)return;const g={edits:[]};for(const[A,c]of d){const{edits:v}=_.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this._extHostDocumentsAndEditors.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(A,"snippetWorkspaceEdit"));g.edits=g.edits.concat(v)}return{edit:g,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=O}),define(Ce[200],Ie([1,0,2,36]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(_,P,E,k,O){this._extHostNotebooks=P,this._textDocumentsAndEditors=E,this._commands=k;const w=new y.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new y.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new y.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new y.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new y.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new y.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri),notebookEditor:I.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(w)}$willAddInteractiveDocument(_,P,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:E,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=b}),define(Ce[201],Ie([1,0,7,4]),function(ne,e,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(_){this._handlePool=0,this._proxy=_.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,_),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=b}),define(Ce[202],Ie([1,0,2,26,8,6,65,4,9,49,16,10,244,20,7,77,72,61,203,11,14,24]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(D,B){this._documents=D,this._provider=B}async provideDocumentSymbols(D,B){const H=this._documents.getDocument(D),V=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(V))return V[0]instanceof M.DocumentSymbol?V.map(b.DocumentSymbol.from):t._asDocumentSymbolTree(V)}static _asDocumentSymbolTree(D){D=D.slice(0).sort((V,te)=>{let de=V.location.range.start.compareTo(te.location.range.start);return de===0&&(de=te.location.range.end.compareTo(V.location.range.end)),de});const B=[],H=[];for(const V of D){const te={name:V.name||"!!MISSING: name!!",kind:b.SymbolKind.from(V.kind),tags:V.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:b.Range.from(V.location.range),selectionRange:b.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(te),B.push(te);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,te.range)&&!k.Range.equalsRange(de.range,te.range)){de.children?.push(te),H.push(te);break}H.pop()}}return B}}class u{constructor(D,B,H){this._documents=D,this._commands=B,this._provider=H,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(D,B){const H=this._documents.getDocument(D),V=await this._provider.provideCodeLenses(H,B);if(!V||B.isCancellationRequested)return;const te=this._cache.add(V),de=new f.DisposableStore;this._disposables.set(te,de);const Y={cacheId:te,lenses:[]};for(let pe=0;pe<V.length;pe++)Y.lenses.push({cacheId:[te,pe],range:b.Range.from(V[pe].range),command:this._commands.toInternal(V[pe].command,de)});return Y}async resolveCodeLens(D,B){const H=D.cacheId&&this._cache.get(...D.cacheId);if(!H)return;let V;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?V=H:V=await this._provider.resolveCodeLens(H,B),V||(V=H),B.isCancellationRequested)return;const te=D.cacheId&&this._disposables.get(D.cacheId[0]);if(!!te)return D.command=this._commands.toInternal(V.command??u._badCmd,te),D}releaseCodeLenses(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(J){return Array.isArray(J)?J.map(b.DefinitionLink.from):J?[b.DefinitionLink.from(J)]:[]}class r{constructor(D,B){this._documents=D,this._provider=B}async provideDefinition(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideDefinition(V,te,H);return n(de)}}class s{constructor(D,B){this._documents=D,this._provider=B}async provideDeclaration(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideDeclaration(V,te,H);return n(de)}}class i{constructor(D,B){this._documents=D,this._provider=B}async provideImplementation(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideImplementation(V,te,H);return n(de)}}class l{constructor(D,B){this._documents=D,this._provider=B}async provideTypeDefinition(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideTypeDefinition(V,te,H);return n(de)}}class S{constructor(D,B){this._documents=D,this._provider=B}async provideHover(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideHover(V,te,H);if(!(!de||(0,O.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=V.getWordRangeAtPosition(te)),de.range||(de.range=new M.Range(te,te)),b.Hover.from(de)}}class p{constructor(D,B){this._documents=D,this._provider=B}async provideEvaluatableExpression(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideEvaluatableExpression(V,te,H);if(de)return b.EvaluatableExpression.from(de)}}class T{constructor(D,B){this._documents=D,this._provider=B}async provideInlineValues(D,B,H,V){const te=this._documents.getDocument(D),de=await this._provider.provideInlineValues(te,b.Range.to(B),b.InlineValueContext.to(H),V);if(Array.isArray(de))return de.map(Y=>b.InlineValue.from(Y))}}class U{constructor(D,B){this._documents=D,this._provider=B}async provideDocumentHighlights(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideDocumentHighlights(V,te,H);if(Array.isArray(de))return de.map(b.DocumentHighlight.from)}}class j{constructor(D,B){this._documents=D,this._provider=B}async provideLinkedEditingRanges(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.provideLinkedEditingRanges(V,te,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,O.coalesce)(de.ranges.map(b.Range.from)),wordPattern:de.wordPattern}}}class x{constructor(D,B){this._documents=D,this._provider=B}async provideReferences(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B),Y=await this._provider.provideReferences(te,de,H,V);if(Array.isArray(Y))return Y.map(b.location.from)}}class C{constructor(D,B,H,V,te,de,Y){this._documents=D,this._commands=B,this._diagnostics=H,this._provider=V,this._logService=te,this._extension=de,this._apiDeprecation=Y,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(D,B,H,V){const te=this._documents.getDocument(D),de=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),Y=[];for(const Ge of this._diagnostics.getDiagnostics(D))if(de.intersection(Ge.range)&&Y.push(Ge)>C._maxCodeActionsPerFile)break;const pe={diagnostics:Y,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:b.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(te,de,pe,V);if(!(0,O.isNonEmptyArray)(ge)||V.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Ye=[];for(let Ge=0;Ge<ge.length;Ge++){const ke=ge[Ge];!ke||(C._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Be)})):(pe.only&&(ke.kind?pe.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Ne,Ge],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Be),diagnostics:ke.diagnostics&&ke.diagnostics.map(b.Diagnostic.from),edit:ke.edit&&b.WorkspaceEdit.from(ke.edit,void 0,(0,v.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ne,actions:Ye}}async resolveCodeAction(D,B){const[H,V]=D,te=this._cache.get(H,V);if(!te||C._isCommand(te)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(te,B)??te;return de?.edit?b.WorkspaceEdit.from(de.edit,void 0,(0,v.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}static _isCommand(D){return typeof D.command=="string"&&typeof D.title=="string"}}C._maxCodeActionsPerFile=1e3;class z{constructor(D,B,H,V){this._proxy=D,this._documents=B,this._provider=H,this._handle=V}async prepareDocumentPaste(D,B,H,V){if(!this._provider.prepareDocumentPaste)return;const te=this._documents.getDocument(D),de=B.map(pe=>b.Range.to(pe)),Y=b.DataTransfer.toDataTransfer(H,()=>{throw new A.NotImplementedError});return await this._provider.prepareDocumentPaste(te,de,Y,V),b.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(D,B,H,V,te){const de=this._documents.getDocument(B),Y=H.map(Ne=>b.Range.to(Ne)),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,D,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,Y,pe,te);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class N{constructor(D,B){this._documents=D,this._provider=B}async provideDocumentFormattingEdits(D,B,H){const V=this._documents.getDocument(D),te=await this._provider.provideDocumentFormattingEdits(V,B,H);if(Array.isArray(te))return te.map(b.TextEdit.from)}}class L{constructor(D,B){this._documents=D,this._provider=B}async provideDocumentRangeFormattingEdits(D,B,H,V){const te=this._documents.getDocument(D),de=b.Range.to(B),Y=await this._provider.provideDocumentRangeFormattingEdits(te,de,H,V);if(Array.isArray(Y))return Y.map(b.TextEdit.from)}}class q{constructor(D,B){this._documents=D,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,B,H,V,te){const de=this._documents.getDocument(D),Y=b.Position.to(B),pe=await this._provider.provideOnTypeFormattingEdits(de,Y,H,V,te);if(Array.isArray(pe))return pe.map(b.TextEdit.from)}}class W{constructor(D,B){this._provider=D,this._logService=B,this._cache=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,B){const H=await this._provider.provideWorkspaceSymbols(D,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const V=this._cache.add(H),te={cacheId:V,symbols:[]};for(let de=0;de<H.length;de++){const Y=H[de];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}te.symbols.push({...b.WorkspaceSymbol.from(Y),cacheId:[V,de]})}return te}async resolveWorkspaceSymbol(D,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const H=this._cache.get(...D.cacheId);if(H){const V=await this._provider.resolveWorkspaceSymbol(H,B);return V&&(0,y.mixin)(D,b.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(D){this._cache.delete(D)}}class R{constructor(D,B,H){this._documents=D,this._provider=B,this._logService=H}static supportsResolving(D){return typeof D.prepareRename=="function"}async provideRenameEdits(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B);try{const Y=await this._provider.provideRenameEdits(te,de,H,V);return Y?b.WorkspaceEdit.from(Y):void 0}catch(Y){const pe=R._asMessage(Y);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(D,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const V=this._documents.getDocument(D),te=b.Position.to(B);try{const de=await this._provider.prepareRename(V,te,H);let Y,pe;if(M.Range.isRange(de)?(Y=de,pe=V.getText(de)):(0,w.isObject)(de)&&(Y=de.range,pe=de.placeholder),!Y||!pe)return;if(Y.start.line>te.line||Y.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(Y),text:pe}}catch(de){const Y=R._asMessage(de);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class Z{constructor(D,B){this.resultId=D,this.tokens=B}}class le{constructor(D,B){this._documents=D,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(D,B,H){const V=this._documents.getDocument(D),te=B!==0?this._previousResults.get(B):null;let de=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(V,te.resultId,H):await this._provider.provideDocumentSemanticTokens(V,H);return te&&this._previousResults.delete(B),de?(de=le._fixProvidedSemanticTokens(de),this._send(le._convertToEdits(te,de),de)):null}async releaseDocumentSemanticColoring(D){this._previousResults.delete(D)}static _fixProvidedSemanticTokens(D){return le._isSemanticTokens(D)?le._isCorrectSemanticTokens(D)?D:new M.SemanticTokens(new Uint32Array(D.data),D.resultId):le._isSemanticTokensEdits(D)?le._isCorrectSemanticTokensEdits(D)?D:new M.SemanticTokensEdits(D.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),D.resultId):D}static _isSemanticTokens(D){return D&&!!D.data}static _isCorrectSemanticTokens(D){return D.data instanceof Uint32Array}static _isSemanticTokensEdits(D){return D&&Array.isArray(D.edits)}static _isCorrectSemanticTokensEdits(D){for(const B of D.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(D,B){if(!le._isSemanticTokens(B)||!D||!D.tokens)return B;const H=D.tokens,V=H.length,te=B.data,de=te.length;let Y=0;const pe=Math.min(V,de);for(;Y<pe&&H[Y]===te[Y];)Y++;if(Y===V&&Y===de)return new M.SemanticTokensEdits([],B.resultId);let ge=0;const Ne=pe-Y;for(;ge<Ne&&H[V-ge-1]===te[de-ge-1];)ge++;return new M.SemanticTokensEdits([{start:Y,deleteCount:V-Y-ge,data:te.subarray(Y,de-ge)}],B.resultId)}_send(D,B){if(le._isSemanticTokens(D)){const H=this._nextResultId++;return this._previousResults.set(H,new Z(D.resultId,D.data)),(0,a.encodeSemanticTokensDto)({id:H,type:"full",data:D.data})}if(le._isSemanticTokensEdits(D)){const H=this._nextResultId++;return le._isSemanticTokens(B)?this._previousResults.set(H,new Z(B.resultId,B.data)):this._previousResults.set(H,new Z(D.resultId)),(0,a.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(D.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}e.DocumentSemanticTokensAdapter=le;class oe{constructor(D,B){this._documents=D,this._provider=B}async provideDocumentRangeSemanticTokens(D,B,H){const V=this._documents.getDocument(D),te=await this._provider.provideDocumentRangeSemanticTokens(V,b.Range.to(B),H);return te?this._send(te):null}_send(D){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class ue{constructor(D,B,H,V,te){this._documents=D,this._commands=B,this._provider=H,this._apiDeprecation=V,this._extension=te,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}async provideCompletionItems(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B),Y=te.getWordRangeAtPosition(de)||new M.Range(de,de),pe=Y.with({end:de}),ge=new g.StopWatch(!0),Ne=await this._provider.provideCompletionItems(te,de,V,b.CompletionContext.to(H));if(!Ne||V.isCancellationRequested)return;const Be=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Ye=ue.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Ye,Ge);const ke=[],nt={x:Ye,b:ke,a:{replace:b.Range.from(Y),insert:b.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<Be.items.length;G++){const X=Be.items[G],fe=this._convertCompletionItem(X,[Ye,G],pe,Y);ke.push(fe)}return nt}async resolveCompletionItem(D,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...D);if(!H)return;const V=await this._provider.resolveCompletionItem(H,B);if(!!V)return this._convertCompletionItem(V,D)}releaseCompletionItems(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}_convertCompletionItem(D,B,H,V){const te=this._disposables.get(B[0]);if(!te)throw Error("DisposableStore is missing...");const de={x:B,a:D.label,b:D.kind!==void 0?b.CompletionItemKind.from(D.kind):void 0,n:D.tags&&D.tags.map(b.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:b.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters,l:D.additionalTextEdits&&D.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(D.command,te)};D.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=D.textEdit.newText):typeof D.insertText=="string"?de.h=D.insertText:D.insertText instanceof M.SnippetString&&(de.h=D.insertText.value,de.i|=4);let Y;return D.textEdit?Y=D.textEdit.range:D.range&&(Y=D.range),M.Range.isRange(Y)?de.j=b.Range.from(Y):Y&&(!H?.isEqual(Y.inserting)||!V?.isEqual(Y.replacing))&&(de.j={insert:b.Range.from(Y.inserting),replace:b.Range.from(Y.replacing)}),de}}class ee{async provideInlineCompletions(D,B,H,V){}disposeCompletions(D){}handleDidShowCompletionItem(D,B){}}class ve extends ee{constructor(D,B,H,V){super(),this._extension=D,this._documents=B,this._provider=H,this._commands=V,this._references=new re,this._isAdditionsProposedApiEnabled=(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,v.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B),Y=await this._provider.provideInlineCompletionItems(te,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Y||V.isCancellationRequested)return;const pe=Array.isArray(Y)?Y:Y.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Y)?[]:Y.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Ge)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?b.Range.from(Ye.range):void 0,command:ke,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(D){this._references.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const H=this._references.get(D)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class we extends ee{constructor(D,B,H,V){super(),this.extension=D,this._documents=B,this._provider=H,this._commands=V,this._references=new re,this.isAdditionProposedApiEnabled=(0,v.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B),Y=await this._provider.provideInlineCompletionItems(te,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},V);if(!Y||V.isCancellationRequested)return;const pe=Array.isArray(Y)?Y:Y.items,ge=Array.isArray(Y)?[]:Y.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Ge)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?b.Range.from(Ye.range):void 0,command:ke,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(D){this._references.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const H=this._references.get(D)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class re{constructor(){this._references=new Map,this._idPool=1}createReferenceId(D){const B=this._idPool++;return this._references.set(B,D),B}disposeReferenceId(D){const B=this._references.get(D);return this._references.delete(D),B}get(D){return this._references.get(D)}}class Ee{constructor(D,B){this._documents=D,this._provider=B,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(D,B,H,V){const te=this._documents.getDocument(D),de=b.Position.to(B),Y=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(te,de,V,Y);if(pe){const ge=this._cache.add([pe]);return{...b.SignatureHelp.from(pe),id:ge}}}reviveContext(D){let B;if(D.activeSignatureHelp){const H=b.SignatureHelp.to(D.activeSignatureHelp),V=this._cache.get(D.activeSignatureHelp.id,0);V?(B=V,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...D,activeSignatureHelp:B}}releaseSignatureHelp(D){this._cache.delete(D)}}class Pe{constructor(D,B,H,V,te){this._documents=D,this._commands=B,this._provider=H,this._logService=V,this._extension=te,this._cache=new d.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(D,B,H){const V=this._documents.getDocument(D),te=b.Range.to(B),de=await this._provider.provideInlayHints(V,te,H);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Y=this._cache.add(de);this._disposables.set(Y,new f.DisposableStore);const pe={hints:[],cacheId:Y};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],te)&&pe.hints.push(this._convertInlayHint(de[ge],[Y,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),pe}async resolveInlayHint(D,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...D);if(!H)return;const V=await this._provider.resolveInlayHint(H,B);if(!!V&&!!this._isValidInlayHint(V))return this._convertInlayHint(V,D)}releaseHints(D){this._disposables.get(D)?.dispose(),this._disposables.delete(D),this._cache.delete(D)}_isValidInlayHint(D,B){return D.label.length===0||Array.isArray(D.label)&&D.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(B&&!B.contains(D.position))}_convertInlayHint(D,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(D.tooltip),position:b.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(b.TextEdit.from),kind:D.kind&&b.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?V.label=D.label:V.label=D.label.map(te=>{const de={label:te.value};return de.tooltip=b.MarkdownString.fromStrict(te.tooltip),M.Location.isLocation(te.location)&&(de.location=b.location.from(te.location)),te.command&&(de.command=this._commands.toInternal(te.command,H)),de}),V}}class Fe{constructor(D,B){this._documents=D,this._provider=B,this._cache=new d.Cache("DocumentLink")}async provideLinks(D,B){const H=this._documents.getDocument(D),V=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(V)||V.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:V.filter(Fe._validateLink).map(b.DocumentLink.from)};{const te=this._cache.add(V),de={links:[],cacheId:te};for(let Y=0;Y<V.length;Y++){if(!Fe._validateLink(V[Y]))continue;const pe=b.DocumentLink.from(V[Y]);pe.cacheId=[te,Y],de.links.push(pe)}return de}}}static _validateLink(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...D);if(!H)return;const V=await this._provider.resolveDocumentLink(H,B);if(!(!V||!Fe._validateLink(V)))return b.DocumentLink.from(V)}releaseLinks(D){this._cache.delete(D)}}class ze{constructor(D,B){this._documents=D,this._provider=B}async provideColors(D,B){const H=this._documents.getDocument(D),V=await this._provider.provideDocumentColors(H,B);return Array.isArray(V)?V.map(de=>({color:b.Color.from(de.color),range:b.Range.from(de.range)})):[]}async provideColorPresentations(D,B,H){const V=this._documents.getDocument(D),te=b.Range.to(B.range),de=b.Color.to(B.color),Y=await this._provider.provideColorPresentations(de,{document:V,range:te},H);if(!!Array.isArray(Y))return Y.map(b.ColorPresentation.from)}}class Qe{constructor(D,B){this._documents=D,this._provider=B}async provideFoldingRanges(D,B,H){const V=this._documents.getDocument(D),te=await this._provider.provideFoldingRanges(V,B,H);if(!!Array.isArray(te))return te.map(b.FoldingRange.from)}}class Te{constructor(D,B,H){this._documents=D,this._provider=B,this._logService=H}async provideSelectionRanges(D,B,H){const V=this._documents.getDocument(D),te=B.map(b.Position.to),de=await this._provider.provideSelectionRanges(V,te,H);if(!(0,O.isNonEmptyArray)(de))return[];if(de.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let pe=0;pe<te.length;pe++){const ge=[];Y.push(ge);let Ne=te[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(b.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Y}}class _e{constructor(D,B){this._documents=D,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.prepareCallHierarchy(V,te,H);if(!de)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Y,pe)):[this._cacheAndConvertItem(Y,de)]}async provideCallsTo(D,B,H){const V=this._itemFromCache(D,B);if(!V)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(V,H);if(!!te)return te.map(de=>({from:this._cacheAndConvertItem(D,de.from),fromRanges:de.fromRanges.map(Y=>b.Range.from(Y))}))}async provideCallsFrom(D,B,H){const V=this._itemFromCache(D,B);if(!V)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(V,H);if(!!te)return te.map(de=>({to:this._cacheAndConvertItem(D,de.to),fromRanges:de.fromRanges.map(Y=>b.Range.from(Y))}))}releaseSession(D){this._cache.delete(D)}_cacheAndConvertItem(D,B){const H=this._cache.get(D),V=b.CallHierarchyItem.from(B,D,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(D,B){return this._cache.get(D)?.get(B)}}class ye{constructor(D,B){this._documents=D,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(D,B,H){const V=this._documents.getDocument(D),te=b.Position.to(B),de=await this._provider.prepareTypeHierarchy(V,te,H);if(!de)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Y,pe)):[this._cacheAndConvertItem(Y,de)]}async provideSupertypes(D,B,H){const V=this._itemFromCache(D,B);if(!V)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(V,H);if(!!te)return te.map(de=>this._cacheAndConvertItem(D,de))}async provideSubtypes(D,B,H){const V=this._itemFromCache(D,B);if(!V)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(V,H);if(!!te)return te.map(de=>this._cacheAndConvertItem(D,de))}releaseSession(D){this._cache.delete(D)}_cacheAndConvertItem(D,B){const H=this._cache.get(D),V=b.TypeHierarchyItem.from(B,D,H.size.toString(36));return H.set(V._itemId,B),V}_itemFromCache(D,B){return this._cache.get(D)?.get(B)}}class ae{constructor(D,B,H,V){this._proxy=D,this._documents=B,this._provider=H,this._handle=V}async provideDocumentOnDropEdits(D,B,H,V,te){const de=this._documents.getDocument(B),Y=b.Position.to(H),pe=b.DataTransfer.toDataTransfer(V,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,D,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(de,Y,pe,te);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ce{constructor(D,B){this.adapter=D,this.extension=B}}class Q{constructor(D,B,H,V,te,de,Y){this._adapter=new Map,this._uriTransformer=B,this._proxy=D.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=V,this._diagnostics=te,this._logService=de,this._apiDeprecation=Y}_transformDocumentSelector(D){return b.DocumentSelector.from(D,this._uriTransformer)}_createDisposable(D){return new M.Disposable(()=>{this._adapter.delete(D),this._proxy.$unregister(D)})}_nextHandle(){return Q._handlePool++}async _withAdapter(D,B,H,V,te,de=!1){const Y=this._adapter.get(D);if(!Y||!(Y.adapter instanceof B))return V;const pe=Date.now();de||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(Y.adapter,Y.extension);return Promise.resolve(ge).catch(Ne=>{(0,A.isCancellationError)(Ne)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),I.CancellationToken.isCancellationToken(te)?(0,c.raceCancellationError)(ge,te):ge}_addNewAdapter(D,B){const H=this._nextHandle();return this._adapter.set(H,new ce(D,B)),H}static _extLabel(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,B,H,V){const te=this._addNewAdapter(new t(this._documents,H),D),de=V&&V.label||Q._extLabel(D);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(B),de),this._createDisposable(te)}$provideDocumentSymbols(D,B,H){return this._withAdapter(D,t,V=>V.provideDocumentSymbols(o.URI.revive(B),H),void 0,H)}registerCodeLensProvider(D,B,H){const V=this._nextHandle(),te=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(V,new ce(new u(this._documents,this._commands.converter,H),D)),this._proxy.$registerCodeLensSupport(V,this._transformDocumentSelector(B),te);let de=this._createDisposable(V);if(te!==void 0){const Y=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(te));de=M.Disposable.from(de,Y)}return de}$provideCodeLenses(D,B,H){return this._withAdapter(D,u,V=>V.provideCodeLenses(o.URI.revive(B),H),void 0,H)}$resolveCodeLens(D,B,H){return this._withAdapter(D,u,V=>V.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(D,B){this._withAdapter(D,u,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(D,B,H){const V=this._addNewAdapter(new r(this._documents,H),D);return this._proxy.$registerDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDefinition(D,B,H,V){return this._withAdapter(D,r,te=>te.provideDefinition(o.URI.revive(B),H,V),[],V)}registerDeclarationProvider(D,B,H){const V=this._addNewAdapter(new s(this._documents,H),D);return this._proxy.$registerDeclarationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDeclaration(D,B,H,V){return this._withAdapter(D,s,te=>te.provideDeclaration(o.URI.revive(B),H,V),[],V)}registerImplementationProvider(D,B,H){const V=this._addNewAdapter(new i(this._documents,H),D);return this._proxy.$registerImplementationSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideImplementation(D,B,H,V){return this._withAdapter(D,i,te=>te.provideImplementation(o.URI.revive(B),H,V),[],V)}registerTypeDefinitionProvider(D,B,H){const V=this._addNewAdapter(new l(this._documents,H),D);return this._proxy.$registerTypeDefinitionSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideTypeDefinition(D,B,H,V){return this._withAdapter(D,l,te=>te.provideTypeDefinition(o.URI.revive(B),H,V),[],V)}registerHoverProvider(D,B,H,V){const te=this._addNewAdapter(new S(this._documents,H),D);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideHover(D,B,H,V){return this._withAdapter(D,S,te=>te.provideHover(o.URI.revive(B),H,V),void 0,V)}registerEvaluatableExpressionProvider(D,B,H,V){const te=this._addNewAdapter(new p(this._documents,H),D);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(B)),this._createDisposable(te)}$provideEvaluatableExpression(D,B,H,V){return this._withAdapter(D,p,te=>te.provideEvaluatableExpression(o.URI.revive(B),H,V),void 0,V)}registerInlineValuesProvider(D,B,H,V){const te=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new T(this._documents,H),D);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(B),te);let Y=this._createDisposable(de);if(te!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(te));Y=M.Disposable.from(Y,pe)}return Y}$provideInlineValues(D,B,H,V,te){return this._withAdapter(D,T,de=>de.provideInlineValues(o.URI.revive(B),H,V,te),void 0,te)}registerDocumentHighlightProvider(D,B,H){const V=this._addNewAdapter(new U(this._documents,H),D);return this._proxy.$registerDocumentHighlightProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentHighlights(D,B,H,V){return this._withAdapter(D,U,te=>te.provideDocumentHighlights(o.URI.revive(B),H,V),void 0,V)}registerLinkedEditingRangeProvider(D,B,H){const V=this._addNewAdapter(new j(this._documents,H),D);return this._proxy.$registerLinkedEditingRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideLinkedEditingRanges(D,B,H,V){return this._withAdapter(D,j,async te=>{const de=await te.provideLinkedEditingRanges(o.URI.revive(B),H,V);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Q._serializeRegExp(de.wordPattern):void 0}},void 0,V)}registerReferenceProvider(D,B,H){const V=this._addNewAdapter(new x(this._documents,H),D);return this._proxy.$registerReferenceSupport(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideReferences(D,B,H,V,te){return this._withAdapter(D,x,de=>de.provideReferences(o.URI.revive(B),H,V,te),void 0,te)}registerCodeActionProvider(D,B,H,V){const te=new f.DisposableStore,de=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,H,this._logService,D,this._apiDeprecation),D);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(B),{providedKinds:V?.providedCodeActionKinds?.map(Y=>Y.value),documentation:V?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,te)}))},Q._extLabel(D),Boolean(H.resolveCodeAction)),te.add(this._createDisposable(de)),te}$provideCodeActions(D,B,H,V,te){return this._withAdapter(D,C,de=>de.provideCodeActions(o.URI.revive(B),H,V,te),void 0,te)}$resolveCodeAction(D,B,H){return this._withAdapter(D,C,V=>V.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(D,B){this._withAdapter(D,C,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(D,B,H){const V=this._addNewAdapter(new N(this._documents,H),D);return this._proxy.$registerDocumentFormattingSupport(V,this._transformDocumentSelector(B),D.identifier,D.displayName||D.name),this._createDisposable(V)}$provideDocumentFormattingEdits(D,B,H,V){return this._withAdapter(D,N,te=>te.provideDocumentFormattingEdits(o.URI.revive(B),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(D,B,H){const V=this._addNewAdapter(new L(this._documents,H),D);return this._proxy.$registerRangeFormattingSupport(V,this._transformDocumentSelector(B),D.identifier,D.displayName||D.name),this._createDisposable(V)}$provideDocumentRangeFormattingEdits(D,B,H,V,te){return this._withAdapter(D,L,de=>de.provideDocumentRangeFormattingEdits(o.URI.revive(B),H,V,te),void 0,te)}registerOnTypeFormattingEditProvider(D,B,H,V){const te=this._addNewAdapter(new q(this._documents,H),D);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(B),V,D.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(D,B,H,V,te,de){return this._withAdapter(D,q,Y=>Y.provideOnTypeFormattingEdits(o.URI.revive(B),H,V,te,de),void 0,de)}registerWorkspaceSymbolProvider(D,B){const H=this._addNewAdapter(new W(B,this._logService),D);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(D,B,H){return this._withAdapter(D,W,V=>V.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(D,B,H){return this._withAdapter(D,W,V=>V.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(D,B){this._withAdapter(D,W,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(D,B,H){const V=this._addNewAdapter(new R(this._documents,H,this._logService),D);return this._proxy.$registerRenameSupport(V,this._transformDocumentSelector(B),R.supportsResolving(H)),this._createDisposable(V)}$provideRenameEdits(D,B,H,V,te){return this._withAdapter(D,R,de=>de.provideRenameEdits(o.URI.revive(B),H,V,te),void 0,te)}$resolveRenameLocation(D,B,H,V){return this._withAdapter(D,R,te=>te.resolveRenameLocation(o.URI.revive(B),H,V),void 0,V)}registerDocumentSemanticTokensProvider(D,B,H,V){const te=this._addNewAdapter(new le(this._documents,H),D),de=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(B),V,de);let Y=this._createDisposable(te);if(de){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));Y=M.Disposable.from(Y,pe)}return Y}$provideDocumentSemanticTokens(D,B,H,V){return this._withAdapter(D,le,te=>te.provideDocumentSemanticTokens(o.URI.revive(B),H,V),null,V)}$releaseDocumentSemanticTokens(D,B){this._withAdapter(D,le,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,B,H,V){const te=this._addNewAdapter(new oe(this._documents,H),D);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(B),V),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(D,B,H,V){return this._withAdapter(D,oe,te=>te.provideDocumentRangeSemanticTokens(o.URI.revive(B),H,V),null,V)}registerCompletionItemProvider(D,B,H,V){const te=this._addNewAdapter(new ue(this._documents,this._commands.converter,H,this._apiDeprecation,D),D);return this._proxy.$registerCompletionsProvider(te,this._transformDocumentSelector(B),V,ue.supportsResolving(H),`${D.identifier.value}(${V.join("")})`),this._createDisposable(te)}$provideCompletionItems(D,B,H,V,te){return this._withAdapter(D,ue,de=>de.provideCompletionItems(o.URI.revive(B),H,V,te),void 0,te)}$resolveCompletionItem(D,B,H){return this._withAdapter(D,ue,V=>V.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(D,B){this._withAdapter(D,ue,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(D,B,H){const V=new ve(D,this._documents,H,this._commands.converter),te=this._addNewAdapter(V,D);return this._proxy.$registerInlineCompletionsSupport(te,this._transformDocumentSelector(B),V.supportsHandleDidShowCompletionItem),this._createDisposable(te)}registerInlineCompletionsProviderNew(D,B,H){const V=this._addNewAdapter(new we(D,this._documents,H,this._commands.converter),D);return this._proxy.$registerInlineCompletionsSupport(V,this._transformDocumentSelector(B),!0),this._createDisposable(V)}$provideInlineCompletions(D,B,H,V,te){return this._withAdapter(D,ee,de=>de.provideInlineCompletions(o.URI.revive(B),H,V,te),void 0,te)}$handleInlineCompletionDidShow(D,B,H){this._withAdapter(D,ee,async V=>{V.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(D,B){this._withAdapter(D,ee,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(D,B,H,V){const te=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,de=this._addNewAdapter(new Ee(this._documents,H),D);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(B),te),this._createDisposable(de)}$provideSignatureHelp(D,B,H,V,te){return this._withAdapter(D,Ee,de=>de.provideSignatureHelp(o.URI.revive(B),H,V,te),void 0,te)}$releaseSignatureHelp(D,B){this._withAdapter(D,Ee,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(D,B,H){const V=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new Pe(this._documents,this._commands.converter,H,this._logService,D),D);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",V,Q._extLabel(D));let de=this._createDisposable(te);if(V!==void 0){const Y=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(V));de=M.Disposable.from(de,Y)}return de}$provideInlayHints(D,B,H,V){return this._withAdapter(D,Pe,te=>te.provideInlayHints(o.URI.revive(B),H,V),void 0,V)}$resolveInlayHint(D,B,H){return this._withAdapter(D,Pe,V=>V.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(D,B){this._withAdapter(D,Pe,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(D,B,H){const V=this._addNewAdapter(new Fe(this._documents,H),D);return this._proxy.$registerDocumentLinkProvider(V,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(V)}$provideDocumentLinks(D,B,H){return this._withAdapter(D,Fe,V=>V.provideLinks(o.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(D,B,H){return this._withAdapter(D,Fe,V=>V.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(D,B){this._withAdapter(D,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(D,B,H){const V=this._addNewAdapter(new ze(this._documents,H),D);return this._proxy.$registerDocumentColorProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentColors(D,B,H){return this._withAdapter(D,ze,V=>V.provideColors(o.URI.revive(B),H),[],H)}$provideColorPresentations(D,B,H,V){return this._withAdapter(D,ze,te=>te.provideColorPresentations(o.URI.revive(B),H,V),void 0,V)}registerFoldingRangeProvider(D,B,H){const V=this._nextHandle(),te=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(V,new ce(new Qe(this._documents,H),D)),this._proxy.$registerFoldingRangeProvider(V,this._transformDocumentSelector(B),te);let de=this._createDisposable(V);if(te!==void 0){const Y=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));de=M.Disposable.from(de,Y)}return de}$provideFoldingRanges(D,B,H,V){return this._withAdapter(D,Qe,te=>te.provideFoldingRanges(o.URI.revive(B),H,V),void 0,V)}registerSelectionRangeProvider(D,B,H){const V=this._addNewAdapter(new Te(this._documents,H,this._logService),D);return this._proxy.$registerSelectionRangeProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideSelectionRanges(D,B,H,V){return this._withAdapter(D,Te,te=>te.provideSelectionRanges(o.URI.revive(B),H,V),[],V)}registerCallHierarchyProvider(D,B,H){const V=this._addNewAdapter(new _e(this._documents,H),D);return this._proxy.$registerCallHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareCallHierarchy(D,B,H,V){return this._withAdapter(D,_e,te=>Promise.resolve(te.prepareSession(o.URI.revive(B),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(D,B,H,V){return this._withAdapter(D,_e,te=>te.provideCallsTo(B,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(D,B,H,V){return this._withAdapter(D,_e,te=>te.provideCallsFrom(B,H,V),void 0,V)}$releaseCallHierarchy(D,B){this._withAdapter(D,_e,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(D,B,H){const V=this._addNewAdapter(new ye(this._documents,H),D);return this._proxy.$registerTypeHierarchyProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$prepareTypeHierarchy(D,B,H,V){return this._withAdapter(D,ye,te=>Promise.resolve(te.prepareSession(o.URI.revive(B),H,V)),void 0,V)}$provideTypeHierarchySupertypes(D,B,H,V){return this._withAdapter(D,ye,te=>te.provideSupertypes(B,H,V),void 0,V)}$provideTypeHierarchySubtypes(D,B,H,V){return this._withAdapter(D,ye,te=>te.provideSubtypes(B,H,V),void 0,V)}$releaseTypeHierarchy(D,B){this._withAdapter(D,ye,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(D,B,H){const V=this._nextHandle();return this._adapter.set(V,new ce(new ae(this._proxy,this._documents,H,V),D)),this._proxy.$registerDocumentOnDropEditProvider(V,this._transformDocumentSelector(B)),this._createDisposable(V)}$provideDocumentOnDropEdits(D,B,H,V,te,de){return this._withAdapter(D,ae,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(B,o.URI.revive(H),V,te,de)),void 0,void 0)}registerDocumentPasteEditProvider(D,B,H,V){const te=this._nextHandle();return this._adapter.set(te,new ce(new z(this._proxy,this._documents,H,te),D)),this._proxy.$registerPasteEditProvider(te,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,V.pasteMimeTypes),this._createDisposable(te)}$prepareDocumentPaste(D,B,H,V,te){return this._withAdapter(D,z,de=>de.prepareDocumentPaste(o.URI.revive(B),H,V,te),void 0,te)}$providePasteEdits(D,B,H,V,te,de){return this._withAdapter(D,z,Y=>Y.providePasteEdits(B,o.URI.revive(H),V,te,de),void 0,de)}static _serializeRegExp(D){return{pattern:D.source,flags:(0,E.regExpFlags)(D)}}static _serializeIndentationRule(D){return{decreaseIndentPattern:Q._serializeRegExp(D.decreaseIndentPattern),increaseIndentPattern:Q._serializeRegExp(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?Q._serializeRegExp(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?Q._serializeRegExp(D.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(D){return{beforeText:Q._serializeRegExp(D.beforeText),afterText:D.afterText?Q._serializeRegExp(D.afterText):void 0,previousLineText:D.previousLineText?Q._serializeRegExp(D.previousLineText):void 0,action:D.action}}static _serializeOnEnterRules(D){return D.map(Q._serializeOnEnterRule)}setLanguageConfiguration(D,B,H){const{wordPattern:V}=H;if(V&&(0,E.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this._documents.setWordDefinitionFor(B,V):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const te=this._nextHandle(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Q._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Q._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Q._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(te,B,de),this._createDisposable(te)}$setWordDefinitions(D){for(const B of D)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=Q,Q._handlePool=0}),define(Ce[204],Ie([1,0,4,8,6,29,14,7]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,w,m,I){this._documents=w,this._commands=m,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,w){await this._proxy.$changeLanguage(O,w);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,w){const m=O.version,I=y.Position.from(w),f=await this._proxy.$tokensAtPosition(O.uri,I),a={type:b.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new b.Range(w.line,w.character,w.line,w.character)};if(!f)return a;const h={range:y.Range.to(f.range),type:y.TokenType.to(f.type)};return!h.range.contains(w)||m!==O.version?a:h}createLanguageStatusItem(O,w,m){const I=this._handlePool++,f=this._proxy,a=this._ids,h=`${O.identifier.value}/${w}`;if(a.has(h))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(h);const d={selector:m,id:w,name:O.displayName??O.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const A=new P.DisposableStore,c=()=>{g?.dispose(),g=(0,_.disposableTimeout)(()=>{A.clear(),this._proxy.$setLanguageStatus(I,{id:h,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:y.DocumentSelector.from(d.selector,this._uriTransformer),label:d.text,detail:d.detail??"",severity:d.severity===b.LanguageStatusSeverity.Error?M.default.Error:d.severity===b.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:d.command&&this._commands.toInternal(d.command,A),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},v={dispose(){A.dispose(),g?.dispose(),f.$removeLanguageStatus(I),a.delete(h)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,c()},get selector(){return d.selector},set selector(t){d.selector=t,c()},get text(){return d.text},set text(t){d.text=t,c()},get detail(){return d.detail},set detail(t){d.detail=t,c()},get severity(){return d.severity},set severity(t){d.severity=t,c()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,c()},get command(){return d.command},set command(t){d.command=t,c()},get busy(){return d.busy},set busy(t){d.busy=t,c()}};return c(),v}}e.ExtHostLanguages=E}),define(Ce[205],Ie([1,0,15,4,28,13,5]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends o.AbstractLoggerService{constructor(O,w){const m=new _.Emitter;super(w.logLevel,m.event),this._proxy=O.getProxy(y.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,w,m){return new E(this._proxy,O,w,m)}};P=xe([$e(0,M.IExtHostRpcService),$e(1,b.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class E extends o.AbstractMessageLogger{constructor(O,w,m,I){super(I?.always),this.proxy=O,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(w,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,w){const m=[[O,w]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ce[206],Ie([1,0,4,15,24]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(P){return P&&P.title}let _=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(o.MainContext.MainThreadMessageService)}showMessage(E,k,O,w,m){const I={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof w=="string"||M(w)?f=[w,...m]:(I.modal=w?.modal,I.useCustom=w?.useCustom,I.detail=w?.detail,f=m),I.useCustom&&(0,b.checkProposedApiEnabled)(E,"resolvers");const a=[];for(let h=0;h<f.length;h++){const d=f[h];if(typeof d=="string")a.push({title:d,handle:h,isCloseAffordance:!1});else if(typeof d=="object"){const{title:g,isCloseAffordance:A}=d;a.push({title:g,isCloseAffordance:!!A,handle:h})}else this._logService.warn("Invalid message item:",d)}return this._proxy.$showMessage(k,O,I,a).then(h=>{if(typeof h=="number")return f[h]})}};_=xe([$e(1,y.ILogService)],_),e.ExtHostMessageService=_}),define(Ce[207],Ie([1,0,23,5,97,7,25,9,10,2,61,4,36,8,6,40,179,93]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class g{constructor(c,v,t,u,n){this._textDocumentsAndEditors=t,this._textDocuments=u,this._extensionStoragePaths=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new O.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,i=r.cell.handle,S=this._documents.get(s)?.getCell(i);if(S)return S.apiCell}return r}}),g._registerApiCommands(v)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const v=this._editors.get(c);if(!v)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return v}getIdByEditor(c){for(const[v,t]of this._editors)if(t.apiEditor===c)return v}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,v){const t=this._documents.get(c);if(!t&&!v)throw new Error(`NO notebook document for '${c}'`);return t}_getProviderData(c){const v=this._notebookContentProviders.get(c);if(!v)throw new Error(`NO provider for '${c}'`);return v}registerNotebookContentProvider(c,v,t,u,n){if((0,P.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(v))throw new Error(`Notebook provider for '${v}' already registered`);this._notebookContentProviders.set(v,{extension:c,provider:t});let r;return t.onDidChangeNotebookContentOptions&&(r=t.onDidChangeNotebookContentOptions(()=>{const s=I.NotebookDocumentContentOptions.from(t.options);this._notebookProxy.$updateNotebookProviderOptions(v,s)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},v,I.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(c,n)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(v),this._notebookProxy.$unregisterNotebookProvider(v)})}static _convertNotebookRegistrationData(c,v){if(!v)return;const t=v.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(v.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:v.displayName,filenamePattern:t,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,v,t){const u=g._notebookStatusBarItemProviderHandlePool++,n=typeof t.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,t),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,n,v);let r;return n!==void 0&&(r=t.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(n))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,n),r?.dispose()})}async createNotebookDocument(c){const v=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&I.NotebookData.from(c.content)});return k.URI.revive(v)}async openNotebookDocument(c){const v=this._documents.get(c);if(v)return v.apiNotebook;const t=await this._notebookDocumentsProxy.$tryOpenNotebook(c),u=this._documents.get(k.URI.revive(t));return(0,E.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(c,v){k.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let t;typeof v=="object"?t={position:I.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(I.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:t={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,t),n=u&&this._editors.get(u)?.apiEditor;if(n)return n;throw u?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,v,t,u){const n=this._notebookStatusBarItemProviders.get(c),r=k.URI.revive(v),s=this._documents.get(r);if(!s||!n)return;const i=s.getCellFromIndex(t);if(!i)return;const l=await n.provideCellStatusBarItems(i.apiCell,u);if(!l)return;const S=new M.DisposableStore,p=this._statusBarCache.add([S]),U=(Array.isArray(l)?l:[l]).map(j=>I.NotebookStatusBarItem.from(j,this._commandsConverter,S));return{cacheId:p,items:U}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,v,t,u,n){if((0,P.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,t),this._notebookProxy.$registerNotebookSerializer(r,{id:c.identifier,location:c.extensionLocation},v,I.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(c,n)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(c,v,t){const u=this._notebookSerializer.get(c);if(!u)throw new Error("NO serializer found");const n=await u.deserializeNotebook(v.buffer,t);return new a.SerializableObjectWithBuffers(I.NotebookData.from(n))}async $notebookToData(c,v,t){const u=this._notebookSerializer.get(c);if(!u)throw new Error("NO serializer found");const n=await u.serializeNotebook(I.NotebookData.to(v.value),t);return o.VSBuffer.wrap(n)}async $openNotebook(c,v,t,u,n){const{provider:r}=this._getProviderData(c),s=await r.openNotebook(k.URI.revive(v),{backupId:t,untitledDocumentData:u?.buffer},n);return new a.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(I.NotebookCellData.from)})}async $saveNotebook(c,v,t){const u=this.getNotebookDocument(k.URI.revive(v)),{provider:n}=this._getProviderData(c);return await n.saveNotebook(u.apiNotebook,t),!0}async $saveNotebookAs(c,v,t,u){const n=this.getNotebookDocument(k.URI.revive(v)),{provider:r}=this._getProviderData(c);return await r.saveNotebookAs(k.URI.revive(t),n.apiNotebook,u),!0}async $backupNotebook(c,v,t){const u=this.getNotebookDocument(k.URI.revive(v)),n=this._getProviderData(c),r=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension),s=String((0,b.hash)([u.uri.toString(),this._backupIdPool++])),i=k.URI.joinPath(r,s),l=await n.provider.backupNotebook(u.apiNotebook,{destination:i},t);return u.updateBackup(l),l.id}_createExtHostEditor(c,v,t){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const u=new d.ExtHostNotebookEditor(v,this._notebookEditorsProxy,c,t.visibleRanges.map(I.NotebookRange.to),t.selections.map(I.NotebookRange.to),typeof t.viewColumn=="number"?I.ViewColumn.to(t.viewColumn):void 0);this._editors.set(v,u)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const t of c.value.removedDocuments){const u=k.URI.revive(t),n=this._documents.get(u);n&&(n.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===u.toString()&&this._editors.delete(r.id)}if(c.value.addedDocuments){const t=[];for(const u of c.value.addedDocuments){const n=k.URI.revive(u.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const r=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,n,u);t.push(...u.cells.map(s=>h.ExtHostCell.asModelAddData(r.apiNotebook,s))),this._documents.get(n)?.dispose(),this._documents.set(n,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(c.value.addedEditors)for(const t of c.value.addedEditors){if(this._editors.has(t.id))return;const u=k.URI.revive(t.documentUri),n=this._documents.get(u);n&&this._createExtHostEditor(n,t.id,t)}const v=[];if(c.value.removedEditors)for(const t of c.value.removedEditors){const u=this._editors.get(t);u&&(this._editors.delete(t),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),v.push(u))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const t=new Set;this._visibleNotebookEditors.forEach(u=>t.add(u.id));for(const u of this._editors.values()){const n=t.has(u.id);u._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(c){const v=m.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new m.ApiCommandArgument("data","Bytes to convert to data",n=>n instanceof Uint8Array,n=>o.VSBuffer.wrap(n))],new m.ApiCommandResult("Notebook Data",n=>I.NotebookData.to(n.value))),u=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",n=>!0,n=>new a.SerializableObjectWithBuffers(I.NotebookData.from(n)))],new m.ApiCommandResult("Bytes",n=>n.buffer));c.registerApiCommand(t),c.registerApiCommand(u)}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0}),define(Ce[208],Ie([1,0,16,14,20,5,7,25,2,27,15,4,36,8,6,63,167,24,40]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(r,s,i,l,S){this._initData=s,this._extHostNotebook=i,this._commands=l,this._logService=S,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(w.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return T})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(r,s,i,l,S,p){for(const ue of this._kernelData.values())if(ue.controller.id===s&&k.ExtensionIdentifier.equals(r.identifier,ue.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,U=this;this._logService.trace(`NotebookController[${T}], CREATED by ${r.identifier.value}, ${s}`);const j=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${r.identifier}'`);let x=!1;const C=new _.DisposableStore,z=new M.Emitter,N=new M.Emitter,L={id:u(r.identifier,s),notebookType:i,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:l||r.identifier.value,preloads:p?p.map(I.NotebookRendererScript.from):[]};let q=S??j,W;this._proxy.$addKernel(T,L).catch(ue=>{console.log(ue),x=!0});let R=0;const Z=()=>{if(x)return;const ue=++R;Promise.resolve().then(()=>{ue===R&&this._proxy.$updateKernel(T,L)})},le=new P.ResourceMap,oe={get id(){return s},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return L.label},set label(ue){L.label=ue??r.displayName??r.name,Z()},get detail(){return L.detail??""},set detail(ue){L.detail=ue,Z()},get description(){return L.description??""},set description(ue){L.description=ue,Z()},get kind(){return(0,d.checkProposedApiEnabled)(r,"notebookControllerKind"),L.kind??""},set kind(ue){(0,d.checkProposedApiEnabled)(r,"notebookControllerKind"),L.kind=ue,Z()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(ue){L.supportedLanguages=ue,Z()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){L.supportsExecutionOrder=ue,Z()},get rendererScripts(){return L.preloads?L.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ue){q=ue??j},get interruptHandler(){return W},set interruptHandler(ue){W=ue,L.supportsInterrupt=Boolean(ue),Z()},createNotebookCellExecution(ue){if(x)throw new Error("notebook controller is DISPOSED");if(!le.has(ue.notebook.uri))throw U._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return U._createNotebookCellExecution(ue,u(r.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${T}], DISPOSED`),x=!0,this._kernelData.delete(T),C.dispose(),z.dispose(),N.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(ue,ee){U._proxy.$updateNotebookPriority(T,ue.uri,ee)},onDidReceiveMessage:N.event,postMessage(ue,ee){return(0,d.checkProposedApiEnabled)(r,"notebookMessaging"),U._proxy.$postMessage(T,ee&&U._extHostNotebook.getIdByEditor(ee),ue)},asWebviewUri(ue){return(0,d.checkProposedApiEnabled)(r,"notebookMessaging"),(0,a.asWebviewUri)(ue,U._initData.remote)}};return this._kernelData.set(T,{extensionId:r.identifier,controller:oe,onDidReceiveMessage:N,onDidChangeSelection:z,associatedNotebooks:le}),oe}getIdByController(r){for(const[s,i]of this._kernelData)if(i.controller===r)return u(i.extensionId,r.id);return null}$acceptNotebookAssociation(r,s,i){const l=this._kernelData.get(r);if(l){const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));i?l.associatedNotebooks.set(S.uri,!0):l.associatedNotebooks.delete(S.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,S.uri.toString(),i),l.onDidChangeSelection.fire({selected:i,notebook:S.apiNotebook})}}async $executeCells(r,s,i){const l=this._kernelData.get(r);if(!l)return;const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)),p=[];for(const T of i){const U=S.getCell(T);U&&p.push(U.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,S.uri.toString(),p.length),await l.controller.executeHandler.call(l.controller,p,S.apiNotebook,l.controller)}catch(T){this._logService.error(`NotebookController[${r}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(r,s,i){const l=this._kernelData.get(r);if(!l)return;const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,S.apiNotebook);else for(const p of i){const T=S.getCell(p);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,i){const l=this._kernelData.get(r);if(!l)return;const S=this._extHostNotebook.getEditorById(s);l.onDidReceiveMessage.fire(Object.freeze({editor:S.apiEditor,message:i}))}$cellExecutionChanged(r,s,i){const S=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)).getCell(s);if(S){const p=i?I.NotebookCellExecutionState.to(i):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:S.apiCell,state:p})}}_createNotebookCellExecution(r,s){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const S=new v(s,l,this._proxy);this._activeExecutions.set(l.uri,S);const p=S.onDidChangeState(()=>{S.state===c.Resolved&&(S.dispose(),p.dispose(),this._activeExecutions.delete(l.uri))});return S.asApiObject()}};A=xe([$e(4,O.ILogService)],A),e.ExtHostNotebookKernels=A;var c;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(c||(c={}));class v extends _.Disposable{constructor(r,s,i){super(),this._cell=s,this._proxy=i,this._handle=v.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new t(10,l=>this.update(l)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,r,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._cell.notebook.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,i){const l=this.cellIndexToHandle(s),S=this.validateAndConvertOutputs((0,o.asArray)(r));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,cellHandle:l,append:i,outputs:S})}async updateOutputItems(r,s,i){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(r),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:r.map(I.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(i){r._executionOrder=i,r.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:r._executionOrder}])},start(i){if(r._state===c.Resolved||r._state===c.Started)throw new Error("Cannot call start again");r._state=c.Started,r._onDidChangeState.fire(),r.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,l){if(r._state===c.Resolved)throw new Error("Cannot call resolve twice");r._state=c.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._handle,new g.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:i}))},clearOutput(i){return r.verifyStateForOutput(),r.updateOutputs([],i,!1)},appendOutput(i,l){return r.verifyStateForOutput(),r.updateOutputs(i,l,!0)},replaceOutput(i,l){return r.verifyStateForOutput(),r.updateOutputs(i,l,!1)},appendOutputItems(i,l){return r.verifyStateForOutput(),r.updateOutputItems(i,l,!0)},replaceOutputItems(i,l){return r.verifyStateForOutput(),r.updateOutputItems(i,l,!1)}})}}v.HANDLE=0;class t{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new y.DeferredPromise,this.startedTimer=Date.now(),(0,y.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}function u(n,r){return`${n.value}/${r}`}e.createKernelId=u}),define(Ce[209],Ie([1,0,5,4,93]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(P,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(y.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,E,k){const O=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(P,E){if(!P.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,w,m)=>this.getOrCreateEmitterFor(E).event(O,w,m),postMessage:(O,w)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const m=w&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(m?.id,E,O)}}}getOrCreateEmitterFor(P){let E=this._rendererMessageEmitters.get(P);return E||(E=new o.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,E),E)}}e.ExtHostNotebookRenderers=M}),define(Ce[210],Ie([1,0,20,5,7,4,2,6,11,16,29,60]),function(ne,e,o,y,b,M,_,P,E,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(I,f,a){const h=I.getProxy(M.MainContext.MainThreadQuickOpen);class d{constructor(s,i){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=i}showQuickPick(s,i,l=o.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(s),p=++this._instances,T=h.$show(p,{title:i?.title,placeHolder:i?.placeHolder,matchOnDescription:i?.matchOnDescription,matchOnDetail:i?.matchOnDetail,ignoreFocusLost:i?.ignoreFocusOut,canPickMany:i?.canPickMany},l),U={},j=T.then(()=>U);return Promise.race([j,S]).then(x=>{if(x!==U)return S.then(C=>{const z=[];for(let N=0;N<C.length;N++){const L=C[N];typeof L=="string"?z.push({label:L,handle:N}):L.kind===P.QuickPickItemKind.Separator?z.push({type:"separator",label:L.label}):z.push({label:L.label,description:L.description,detail:L.detail,picked:L.picked,alwaysShow:L.alwaysShow,handle:N})}return i&&typeof i.onDidSelectItem=="function"&&(this._onDidSelectItem=N=>{i.onDidSelectItem(C[N])}),h.$setItems(p,z),T.then(N=>{if(typeof N=="number")return C[N];if(Array.isArray(N))return N.map(L=>C[L])})})}).then(void 0,x=>{if(!(0,E.isCancellationError)(x))return h.$setError(p,x),Promise.reject(x)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,i=o.CancellationToken.None){return this._validateInput=s?.validateInput,h.$input(s,typeof this._validateInput=="function",i).then(void 0,l=>{if(!(0,E.isCancellationError)(l))return Promise.reject(l)})}async $validateInput(s){if(!this._validateInput)return;const i=await this._validateInput(s);if(!i||typeof i=="string")return i;let l;switch(i.severity){case P.InputBoxValidationSeverity.Info:l=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:l=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:l=O.default.Error;break;default:l=i.message?O.default.Error:O.default.Ignore;break}return{content:i.message,severity:l}}async showWorkspaceFolderPick(s,i=o.CancellationToken.None){const l=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!l)return;const S=await this._workspace.getWorkspaceFolders2();if(!!S)return S.find(p=>p.uri.toString()===l.uri.toString())}createQuickPick(s){const i=new u(s,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}createInputBox(s){const i=new n(s,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}$onDidChangeValue(s,i){this._sessions.get(s)?._fireDidChangeValue(i)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,i){const l=this._sessions.get(s);l instanceof u&&l._fireDidChangeActive(i)}$onDidChangeSelection(s,i){const l=this._sessions.get(s);l instanceof u&&l._fireDidChangeSelection(i)}$onDidTriggerButton(s,i){this._sessions.get(s)?._fireDidTriggerButton(i)}$onDidTriggerItemButton(s,i,l){const S=this._sessions.get(s);S instanceof u&&S._fireDidTriggerItemButton(i,l)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class g{constructor(s,i){this._extensionId=s,this._onDidDispose=i,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((i,l)=>{const S=i===P.QuickInputButtons.Back?-1:l;this._handlesToButtons.set(S,i)}),this.update({buttons:s.map((i,l)=>({...t(i),tooltip:i.tooltip,handle:i===P.QuickInputButtons.Back?-1:l}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const i=this._handlesToButtons.get(s);i&&this._onDidTriggerButtonEmitter.fire(i)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(s){if(!this._disposed){for(const i of Object.keys(s)){const l=s[i];this._pendingUpdate[i]=l===void 0?null:l}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function A(r){if(r instanceof P.ThemeIcon)return{id:r.id};const s=v(r),i=c(r);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof i=="string"?_.URI.file(i):i}}function c(r){return typeof r=="object"&&"light"in r?r.light:r}function v(r){return typeof r=="object"&&"dark"in r?r.dark:r}function t(r){const s=A(r.iconPath);let i,l;return"id"in s?l=w.ThemeIcon.asClassName(s):i=s,{iconPath:i,iconClass:l}}class u extends g{constructor(s,i){super(s.identifier,i),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((l,S)=>{this._handlesToItems.set(S,l),this._itemsToHandles.set(l,S)});const i=[];for(let l=0;l<s.length;l++){const S=s[l];S.kind===P.QuickPickItemKind.Separator?i.push({type:"separator",label:S.label}):i.push({handle:l,label:S.label,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,buttons:S.buttons?.map((p,T)=>({...t(p),tooltip:p.tooltip,handle:T}))})}this.update({items:i})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(i=>this._itemsToHandles.has(i)),this.update({activeItems:this._activeItems.map(i=>this._itemsToHandles.get(i))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(i=>this._itemsToHandles.has(i)),this.update({selectedItems:this._selectedItems.map(i=>this._itemsToHandles.get(i))})}_fireDidChangeActive(s){const i=(0,k.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._activeItems=i,this._onDidChangeActiveEmitter.fire(i)}_fireDidChangeSelection(s){const i=(0,k.coalesce)(s.map(l=>this._handlesToItems.get(l)));this._selectedItems=i,this._onDidChangeSelectionEmitter.fire(i)}_fireDidTriggerItemButton(s,i){const l=this._handlesToItems.get(s);if(!l||!l.buttons||!l.buttons.length)return;const S=l.buttons[i];S&&this._onDidTriggerItemButtonEmitter.fire({button:S,item:l})}}class n extends g{constructor(s,i){super(s.identifier,i),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:O.default.Error}):this.update({validationMessage:s.message,severity:s.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new d(f,a)}e.createExtHostQuickOpen=m});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[211],Ie([1,0,2,5,55,7,14,4,16,118,15,27,60,8,24]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f){"use strict";var a,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(S){if(S)return typeof S.iconPath=="string"?o.URI.file(S.iconPath):o.URI.isUri(S.iconPath)||m.ThemeIcon.isThemeIcon(S.iconPath)?S.iconPath:void 0}function g(S,p){if(!S.iconPath&&!p.iconPath)return 0;if(S.iconPath){if(!p.iconPath)return 1}else return-1;const T=typeof S.iconPath=="string"?S.iconPath:o.URI.isUri(S.iconPath)?S.iconPath.fsPath:S.iconPath.id,U=typeof p.iconPath=="string"?p.iconPath:o.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,k.comparePaths)(T,U)}function A(S,p){let T=0;if(S.strikeThrough!==p.strikeThrough)return S.strikeThrough?1:-1;if(S.faded!==p.faded)return S.faded?1:-1;if(S.tooltip!==p.tooltip)return(S.tooltip||"").localeCompare(p.tooltip||"");if(T=g(S,p),T!==0)return T;if(S.light&&p.light)T=g(S.light,p.light);else{if(S.light)return 1;if(p.light)return-1}if(T!==0)return T;if(S.dark&&p.dark)T=g(S.dark,p.dark);else{if(S.dark)return 1;if(p.dark)return-1}return T}function c(S,p){if(S.command!==p.command)return S.command<p.command?-1:1;if(S.title!==p.title)return S.title<p.title?-1:1;if(S.tooltip!==p.tooltip){if(S.tooltip!==void 0&&p.tooltip!==void 0)return S.tooltip<p.tooltip?-1:1;if(S.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(S.arguments===p.arguments)return 0;if(S.arguments)if(p.arguments){if(S.arguments.length!==p.arguments.length)return S.arguments.length-p.arguments.length}else return 1;else return-1;for(let T=0;T<S.arguments.length;T++){const U=S.arguments[T],j=p.arguments[T];if(U!==j)return U<j?-1:1}return 0}function v(S,p){let T=(0,k.comparePaths)(S.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(T!==0)return T;if(S.command&&p.command)T=c(S.command,p.command);else{if(S.command)return 1;if(p.command)return-1}if(T!==0)return T;if(S.decorations&&p.decorations)T=A(S.decorations,p.decorations);else{if(S.decorations)return 1;if(p.decorations)return-1}return T}function t(S,p){for(let T=0;T<S.length;T++)if(S[T]!==p[T])return!1;return!0}function u(S,p){return S.command===p.command&&S.title===p.title&&S.tooltip===p.tooltip&&(S.arguments&&p.arguments?t(S.arguments,p.arguments):S.arguments===p.arguments)}function n(S,p){return(0,E.equals)(S,p,u)}class r{constructor(p,T,U){this._extension=p,this._sourceControlHandle=U,a.set(this,void 0),this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,a,T,"f")}get value(){return this._value}set value(p){p=p??"",Oe(this,a,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,a,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,a,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,a,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,a,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,T){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,a,"f").$showValidationMessage(this._sourceControlHandle,p,T)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=r,a=new WeakMap;class s{constructor(p,T,U,j,x){this._proxy=p,this._commands=T,this._sourceControlHandle=U,this._id=j,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,T){const U=this._resourceStatesCommandsMap.get(p);return U?(0,_.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(v),U=(0,E.sortedDiff)(this._resourceSnapshot,p,v).map(C=>{const z=C.toInsert.map(N=>{const L=this._resourceHandlePool++;this._resourceStatesMap.set(L,N);const q=N.resourceUri;let W;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const Ee=new M.DisposableStore;W=this._commands.converter.toInternal(N.command,Ee),this._resourceStatesDisposablesMap.set(L,Ee)}else this._resourceStatesCommandsMap.set(L,N.command);const R=d(N.decorations),Z=N.decorations&&d(N.decorations.light)||R,le=N.decorations&&d(N.decorations.dark)||R,oe=[Z,le],ue=N.decorations&&N.decorations.tooltip||"",ee=N.decorations&&!!N.decorations.strikeThrough,ve=N.decorations&&!!N.decorations.faded,we=N.contextValue||"";return{rawResource:[L,q,oe,ue,ee,ve,we,W],handle:L}});return{start:C.start,deleteCount:C.deleteCount,toInsert:z}}),j=U.map(({start:C,deleteCount:z,toInsert:N})=>[C,z,N.map(L=>L.rawResource)]),x=U.reverse();for(const{start:C,deleteCount:z,toInsert:N}of x){const L=N.map(W=>W.handle),q=this._handlesSnapshot.splice(C,z,...L);for(const W of q)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=p,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(p,T,U,j,x,C){this._extension=p,this._commands=U,this._id=j,this._label=x,this._rootUri=C,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,h,T,"f"),this._inputBox=new r(p,Oe(this,h,"f"),this.handle),Oe(this,h,"f").$registerSourceControl(this.handle,j,x,C)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,h,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=p;const T=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=p;const T=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(U=>U.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,h,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&n(this._statusBarCommands,p))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=p;const T=(p||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}createResourceGroup(p,T){const U=new s(Oe(this,h,"f"),this._commands,this.handle,p,T),j=y.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,j),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const p=[],T=[];for(const[U,j]of this.createdResourceGroups){j.dispose();const x=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});y.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),x.dispose(),this._groups.delete(U.handle),Oe(this,h,"f").$unregisterGroup(this.handle,U.handle)}),p.push([U.handle,U.id,U.label,U.features]);const C=U._takeResourceStateSnapshot();C.length>0&&T.push([U.handle,C]),this._groups.set(U.handle,U)}Oe(this,h,"f").$registerGroups(this.handle,p,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(T=>{const U=T._takeResourceStateSnapshot();U.length!==0&&p.push([T.handle,U])}),p.length>0&&Oe(this,h,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,i._handlePool=0,xe([(0,b.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),xe([(0,b.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let l=class Yi{constructor(p,T,U){this._commands=T,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=p.getProxy(P.MainContext.MainThreadSCM),this._telemetry=p.getProxy(P.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const x=this._sourceControls.get(j.sourceControlHandle);if(!x)return j;const C=x.getResourceGroup(j.groupHandle);return C?C.getResourceState(j.handle):j}else if(j&&j.$mid===4){const x=this._sourceControls.get(j.sourceControlHandle);return x?x.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const x=this._sourceControls.get(j.handle);return x||j}return j}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,T,U,j){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,T,U,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const x=Yi._handlePool++,C=new i(p,this._proxy,this._commands,T,U,j);this._sourceControls.set(x,C);const z=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(p.identifier))||[];return z.push(C),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(p.identifier),z),C}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const T=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(p.identifier)),U=T&&T[T.length-1];return U&&U.inputBox}$provideOriginalResource(p,T,U){const j=o.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,j.toString());const x=this._sourceControls.get(p);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(j,U)).then(C=>C||null)}$onInputBoxValueChange(p,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const U=this._sourceControls.get(p);return U&&U.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(p,T,U,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,T,U);const x=this._sourceControls.get(p);if(!x)return Promise.resolve(void 0);const C=x.getResourceGroup(T);return C?C.$executeResourceCommand(U,j):Promise.resolve(void 0)}$validateInput(p,T,U){this.logService.trace("ExtHostSCM#$validateInput",p);const j=this._sourceControls.get(p);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>j.inputBox.validateInput(T,U)).then(x=>{if(!x)return Promise.resolve(void 0);const C=I.MarkdownString.fromStrict(x.message);return C?Promise.resolve([C,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};l._handlePool=0,l=xe([$e(2,O.ILogService)],l),e.ExtHostSCM=l}),define(Ce[67],Ie([1,0,4,5,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(P){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,E){return this._proxy.$getPassword(P,E)}store(P,E,k){return this._proxy.$setPassword(P,E,k)}delete(P,E){return this._proxy.$deletePassword(P,E)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[212],Ie([1,0,6,4,133,7,8,10]),function(ne,e,o,y,b,M,_,P){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,a,h,d,g=o.StatusBarAlignment.Left,A){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,E,f,"f"),Je(this,k,a,"f"),this._entryId=O.ID_GEN++,this._extension=h,this._id=d,this._alignment=g,this._priority=this.validatePriority(A)}validatePriority(f){if(!!(0,P.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let a;this._name?a=this._name:a=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const d=_.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,a,this._text,d,this._command?.internal,h,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,k=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const a={message:f};return this._messages.unshift(a),this._update(),new o.Disposable(()=>{const h=this._messages.indexOf(a);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,a){this._proxy=f.getProxy(y.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new w(this)}createStatusBarEntry(f,a,h,d){return new O(this._proxy,this._commands,f,a,h,d)}setStatusBarMessage(f,a){const h=this._statusMessage.setMessage(f);let d;return typeof a=="number"?d=setTimeout(()=>h.dispose(),a):typeof a<"u"&&a.then(()=>h.dispose(),()=>h.dispose()),new o.Disposable(()=>{h.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=m}),define(Ce[68],Ie([1,0,4,5,3]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(P){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,E){this._proxy.$registerExtensionStorageKeysToSync(P,E)}initializeExtensionStorage(P,E,k){return this._proxy.$initializeExtensionStorage(P,E).then(O=>O||k)}setValue(P,E,k){return this._proxy.$setValue(P,E,k)}$acceptValue(P,E,k){this._onDidChangeStorage.fire({shared:P,key:E,value:k})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(Ce[69],Ie([1,0,3,28,15,52,2]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,O,w){this._logService=O,this._extHostFileSystem=w,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(k){return _.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,O=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=xe([$e(0,y.IExtHostInitDataService),$e(1,b.ILogService),$e(2,M.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(Ce[98],Ie([1,0,3,4,13]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,o.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(P){this._telemetryShape=P.getProxy(y.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(P,E,k){this._telemetryShape.$logTelemetryToOutputChannel(`${P.identifier.value}/${E}`,k)}};M=xe([$e(0,b.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(Ce[53],Ie([1,0,5,4,3,2,13,7,6,134,11,168,20,42,154,60,10,14]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class g{constructor(i,l,S,p){this._proxy=i,this._id=l,this._creationOptions=S,this._name=p,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(U,j=!0){T._checkDisposed(),T._proxy.$sendText(T._id,U,j)},show(U){T._checkDisposed(),T._proxy.$show(T._id,U)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(i,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,h.withNullAsUndefined)(i.shellPath),shellArgs:(0,h.withNullAsUndefined)(i.shellArgs),cwd:(0,h.withNullAsUndefined)(i.cwd),env:(0,h.withNullAsUndefined)(i.env),icon:(0,h.withNullAsUndefined)(n(i.iconPath)),color:a.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,h.withNullAsUndefined)(i.message),strictEnv:(0,h.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(i.location,l?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,l,S,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:S,color:a.ThemeColor.isThemeColor(p)?p.id:void 0,location:this._serializeParentTerminal(i,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(i,l){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in i?{viewColumn:i.viewColumn,preserveFocus:i.preserveFocus}:void 0:i}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitStatus(i,l){this._exitStatus=Object.freeze({code:i,reason:l})}setDimensions(i,l){return i===this._cols&&l===this._rows||i===0||l===0?!1:(this._cols=i,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=g;class A{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput?.(i)}resize(i,l){this._pty.setDimensions?.({columns:i,rows:l})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(i||void 0),i&&this._pty.setDimensions?.(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let c=1,v=class extends P.Disposable{constructor(i,l){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[S,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,l){const S=new g(this._proxy,(0,I.generateUuid)(),i,i.name),p=new A(i.pty);return S.createExtensionTerminal(i.location,this._serializeParentTerminal(i,l).resolvedExtHostIdentifier,n(i.iconPath),r(i.color)).then(T=>{const U=this._setupExtHostProcessListeners(T,p);this._terminalProcessDisposables[T]=U}),this._terminals.push(S),S.value}_serializeParentTerminal(i,l){if(l=l||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const S=i.location.parentTerminal;if(S){const p=this._terminals.find(T=>T.value===S);p&&(l.resolvedExtHostIdentifier=p._id)}}else i.location&&typeof i.location!="object"?l.location=i.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(i,l){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const p=new A(l),T=this._setupExtHostProcessListeners(i,p);this._terminalProcessDisposables[i]=T}async $acceptActiveTerminalChanged(i){const l=this._activeTerminal;if(i===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const S=this._getTerminalById(i);S&&(this._activeTerminal=S,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,l){const S=this._getTerminalById(i);S&&this._onDidWriteTerminalData.fire({terminal:S.value,data:l})}async $acceptTerminalDimensions(i,l,S){const p=this._getTerminalById(i);p&&p.setDimensions(l,S)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(i,l,S){this._terminalProcesses.get(i)?.resize(l,S)}async $acceptTerminalTitleChange(i,l){const S=this._getTerminalById(i);S&&(S.name=l)}async $acceptTerminalClosed(i,l,S){const p=this._getTerminalObjectIndexById(this._terminals,i);if(p!==null){const T=this._terminals.splice(p,1)[0];T.setExitStatus(l,S),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(i,l,S,p){if(l){const j=this._getTerminalObjectIndexById(this._terminals,l);if(j!==null){this._terminals[j]._id=i,this._onDidOpenTerminal.fire(this.terminals[j]),this._terminals[j].isOpen=!0;return}}const T={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:M.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},U=new g(this._proxy,i,T,S);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(i,l){this._getTerminalById(i)?._setProcessId(l)}async $startExtensionTerminal(i,l){const S=this._getTerminalById(i);if(!S)return{message:(0,k.localize)(0,null,i)};S.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async j=>{j===S.value&&(U.dispose(),T())})});const p=this._terminalProcesses.get(i);p?p.startSendingEvents(l):this._extensionTerminalAwaitingStart[i]={initialDimensions:l}}_setupExtHostProcessListeners(i,l){const S=new P.DisposableStore;S.add(l.onProcessReady(T=>this._proxy.$sendProcessReady(i,T.pid,T.cwd))),S.add(l.onDidChangeProperty(T=>this._proxy.$sendProcessProperty(i,T))),this._bufferer.startBuffering(i,l.onProcessData),S.add(l.onProcessExit(T=>this._onProcessExit(i,T))),this._terminalProcesses.set(i,l);const p=this._extensionTerminalAwaitingStart[i];return p&&l instanceof A&&(l.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),S}$acceptProcessAckDataEvent(i,l){this._terminalProcesses.get(i)?.acknowledgeDataEvent(l)}$acceptProcessInput(i,l){this._terminalProcesses.get(i)?.input(l)}$acceptTerminalInteraction(i){const l=this._getTerminalById(i);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(i,l,S){try{this._terminalProcesses.get(i)?.resize(l,S)}catch(p){if(p.code!=="EPIPE"&&p.code!=="ERR_IPC_CHANNEL_CLOSED")throw p}}$acceptProcessShutdown(i,l){this._terminalProcesses.get(i)?.shutdown(l)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(i,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(l=>this._proxy.$sendProcessProperty(i,{type:"cwd",value:l}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,l,S){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,S),this._proxy.$registerProfileProvider(l,i.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(i,l){const S=new m.CancellationTokenSource().token;let p=await this._profileProviders.get(i)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(p&&!("options"in p)&&(p={options:p}),!p||!("options"in p))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in p.options){this.createExtensionTerminal(p.options,l);return}this.createTerminalFromOptions(p.options,l)}}async $provideLinks(i,l){const S=this._getTerminalById(i);if(!S)return[];this._terminalLinkCache.delete(i),this._terminalLinkCancellationSource.get(i)?.dispose(!0);const T=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,T);const U=[],j={terminal:S.value,line:l},x=[];for(const N of this._linkProviders)x.push(d.Promises.withAsyncBody(async L=>{T.token.onCancellationRequested(()=>L({provider:N,links:[]}));const q=await N.provideTerminalLinks(j,T.token)||[];T.token.isCancellationRequested||L({provider:N,links:q})}));const C=await Promise.all(x);if(T.token.isCancellationRequested)return[];const z=new Map;for(const N of C)N&&N.links.length>0&&U.push(...N.links.map(L=>{const q={id:c++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return z.set(q.id,{provider:N.provider,link:L}),q}));return this._terminalLinkCache.set(i,z),U}$activateLink(i,l){const S=this._terminalLinkCache.get(i)?.get(l);!S||S.provider.handleTerminalLink(S.link)}_onProcessExit(i,l){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const S=this._terminalProcessDisposables[i];S&&(S.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,l)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,l){const S=this._getTerminalObjectIndexById(i,l);return S!==null?i[S]:null}_getTerminalObjectIndexById(i,l){let S=null;return i.some((p,T)=>p._id===l?(S=T,!0):!1),S}getEnvironmentVariableCollection(i){let l=this._environmentVariableCollections.get(i.identifier.value);return l||(l=new t,this._setEnvironmentVariableCollection(i.identifier.value,l)),l}_syncEnvironmentVariableCollection(i,l){const S=(0,w.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(i,l.persistent,S.length===0?void 0:S)}$initEnvironmentVariableCollections(i){i.forEach(l=>{const S=l[0],p=new t(l[1]);this._setEnvironmentVariableCollection(S,p)})}$acceptDefaultProfile(i,l){this._defaultProfile=i,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(i,l){this._environmentVariableCollections.set(i,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,l)})}};v=xe([$e(1,_.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class t{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,l){this._setIfDiffers(i,{value:l,type:E.EnvironmentVariableMutatorType.Replace})}append(i,l){this._setIfDiffers(i,{value:l,type:E.EnvironmentVariableMutatorType.Append})}prepend(i,l){this._setIfDiffers(i,{value:l,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,l){const S=this.map.get(i);(!S||S.value!==l.value||S.type!==l.type)&&(this.map.set(i,l),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,l){this.map.forEach((S,p)=>i.call(l,p,S,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=t;let u=class extends v{constructor(i){super(!1,i)}createTerminal(i,l,S){throw new O.NotSupportedError}createTerminalFromOptions(i,l){throw new O.NotSupportedError}};u=xe([$e(0,_.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function n(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return a.ThemeColor.isThemeColor(s)?s:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[213],Ie([1,0,16,23,20,5,177,97,7,26,10,42,4,13,94,8,6,47,64,48]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A){"use strict";var c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(x,C,z){this.editors=z,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=x.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new n(this.proxy),C.registerArgumentProcessor({processArgument:N=>N?.$mid===13?(0,f.toItemFromContext)(N):N})}createTestController(x,C,z){if(this.controllers.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const N=new E.DisposableStore,L=N.add(new f.ExtHostTestItemCollection(x,C,this.editors));L.root.label=C;const q=new Map,W=this.proxy,R={items:L.root.children,get label(){return C},set label(le){C=le,L.root.label=le,W.$updateController(x,{label:C})},get refreshHandler(){return z},set refreshHandler(le){z=le,W.$updateController(x,{canRefresh:!!le})},get id(){return x},createRunProfile:(le,oe,ue,ee,ve)=>{let we=(0,P.hash)(le);for(;q.has(we);)we++;return new T(this.proxy,q,x,we,le,oe,ue,ee,ve)},createTestItem(le,oe,ue){return new f.TestItemImpl(x,le,oe,ue)},createTestRun:(le,oe,ue=!0)=>this.runTracker.createTestRun(x,L,le,oe,ue),set resolveHandler(le){L.resolveHandler=le},get resolveHandler(){return L.resolveHandler},dispose:()=>{N.dispose()}};W.$registerTestController(x,C,!!z),N.add((0,E.toDisposable)(()=>W.$unregisterTestController(x)));const Z={controller:R,collection:L,profiles:q};return this.controllers.set(x,Z),N.add((0,E.toDisposable)(()=>this.controllers.delete(x))),N.add(L.onDidGenerateDiff(le=>W.$publishDiff(x,le.map(A.TestsDiffOp.serialize)))),R}createTestObserver(){return this.observer.checkout()}async runTests(x,C=b.CancellationToken.None){const z=r(x);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.controllers.get(z.controllerId);if(!N)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:x.include?.map(L=>d.TestId.fromExtHostTestItem(L,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:U[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:x.exclude?.map(L=>L.id)},C)}$provideFileCoverage(x,C,z){return(0,o.mapFind)(this.runTracker.trackers,L=>L.id===x?L.getCoverage(C):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(x,C,z,N){return(0,o.mapFind)(this.runTracker.trackers,q=>q.id===x?q.getCoverage(C):void 0)?.resolveFileCoverage(z,N)??Promise.resolve([])}$configureRunProfile(x,C){this.controllers.get(x)?.profiles.get(C)?.configureHandler?.()}async $refreshTests(x,C){await this.controllers.get(x)?.controller.refreshHandler?.(C)}$publishTestResults(x){this.results=Object.freeze(x.map(C=>(0,k.deepFreeze)(a.TestResults.to(C))).concat(this.results).sort((C,z)=>z.completedAt-C.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(x,C){const z=this.controllers.get(d.TestId.fromString(x).controllerId)?.collection;z&&(await z.expand(x,C<0?1/0:C),z.flushDiff())}$acceptDiff(x){this.observer.applyDiff(x.map(A.TestsDiffOp.deserialize))}async $runControllerTests(x,C){return Promise.all(x.map(z=>this.runControllerTestRequest(z,C)))}async runControllerTestRequest(x,C){const z=this.controllers.get(x.controllerId);if(!z)return{};const{collection:N,profiles:L}=z,q=L.get(x.profileId);if(!q)return{};const W=x.testIds.map(oe=>N.tree.get(oe)).filter(O.isDefined),R=x.excludeExtIds.map(oe=>z.collection.tree.get(oe)).filter(O.isDefined).filter(oe=>W.some(ue=>ue.fullId.compare(oe.fullId)===2));if(!W.length)return{};const Z=new h.TestRunRequest(W.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:W.map(oe=>oe.actual),R.map(oe=>oe.actual),q),le=this.runTracker.prepareForMainThreadTestRun(Z,s.fromInternal(x,z.collection),C);try{return await q.runHandler(Z,C),{}}catch(oe){return{error:String(oe)}}finally{le.isRunning&&!C.isCancellationRequested&&await M.Event.toPromise(le.onEnd),le.dispose()}}$cancelExtensionTestRun(x){x===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(x)}};t=xe([$e(0,I.IExtHostRpcService)],t),e.ExtHostTesting=t;class u extends E.Disposable{constructor(x,C,z){super(),this.dto=x,this.proxy=C,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(x){return this.tasks.get(x)?.coverage}createRun(x){const C=this.dto.id,z=this.dto.controllerId,N=(0,w.generateUuid)(),L=new i(this.proxy,C,N),q=le=>(oe,...ue)=>{if(R){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),le(oe,...ue))},W=(le,oe)=>{const ue=oe instanceof Array?oe.map(a.TestMessage.from):[a.TestMessage.from(oe)];if(le.uri&&le.range){const ee={range:a.Range.from(le.range),uri:le.uri};for(const ve of ue)ve.location=ve.location||ee}this.proxy.$appendTestMessagesInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),ue)};let R=!1;const Z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:x,get coverageProvider(){return L.coverageProvider},set coverageProvider(le){L.coverageProvider=le},enqueued:q(le=>{this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),1)}),skipped:q(le=>{this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),5)}),started:q(le=>{this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),2)}),errored:q((le,oe,ue)=>{W(le,oe),this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),6,ue)}),failed:q((le,oe,ue)=>{W(le,oe),this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,z).toString(),4,ue)}),passed:q((le,oe)=>{this.proxy.$updateTestStateInRun(C,N,d.TestId.fromExtHostTestItem(le,this.dto.controllerId).toString(),3,oe)}),appendOutput:(le,oe,ue)=>{R||(ue&&(this.dto.isIncluded(ue)?this.ensureTestIsKnown(ue):ue=void 0),this.proxy.$appendOutputToRun(C,N,y.VSBuffer.fromString(le),oe&&a.location.from(oe),ue&&d.TestId.fromExtHostTestItem(ue,z).toString()))},end:()=>{R||(R=!0,this.proxy.$finishedTestRunTask(C,N),this.tasks.delete(N),this.isRunning||this.dispose())}};return this.tasks.set(N,{run:Z,coverage:L}),this.proxy.$startedTestRunTask(C,{id:N,name:x,running:!0}),Z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(x){if(!(x instanceof f.TestItemImpl))throw new g.InvalidTestItemError(x.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString()))return;const C=[],z=this.dto.colllection.root;for(;;){const N=a.TestItem.from(x);if(C.unshift(N),this.sharedTestIds.has(N.extId)||(this.sharedTestIds.add(N.extId),x===z))break;x=x.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,C)}}class n{constructor(x){this.proxy=x,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(x,C,z){return this.getTracker(x,C,z)}cancelRunById(x){for(const C of this.tracked.values())if(C.id===x){C.dispose();return}}cancelAllRuns(){for(const x of this.tracked.values())x.dispose()}createTestRun(x,C,z,N,L){const q=this.tracked.get(z);if(q)return q.createRun(N);const W=s.fromPublic(x,C,z,L),R=r(z);this.proxy.$startedExtensionTestRun({controllerId:x,profile:R&&{group:U[R.kind],id:R.profileId},exclude:z.exclude?.map(le=>d.TestId.fromExtHostTestItem(le,C.root.id).toString())??[],id:W.id,include:z.include?.map(le=>d.TestId.fromExtHostTestItem(le,C.root.id).toString())??[C.root.id],persist:L});const Z=this.getTracker(z,W);return Z.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),Z.createRun(N)}getTracker(x,C,z){const N=new u(C,this.proxy,z);return this.tracked.set(x,N),N.onEnd(()=>this.tracked.delete(x)),N}}e.TestRunCoordinator=n;const r=j=>{if(!!j.profile){if(!(j.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class s{constructor(x,C,z,N,L,q){this.controllerId=x,this.id=C,this.isPersisted=L,this.colllection=q,this.includePrefix=z.map(W=>W+"\0"),this.excludePrefix=N.map(W=>W+"\0")}static fromPublic(x,C,z,N){return new s(x,(0,w.generateUuid)(),z.include?.map(L=>d.TestId.fromExtHostTestItem(L,x).toString())??[x],z.exclude?.map(L=>d.TestId.fromExtHostTestItem(L,x).toString())??[],N,C)}static fromInternal(x,C){return new s(x.controllerId,x.runId,x.testIds,x.excludeExtIds,!0,C)}isIncluded(x){const C=d.TestId.fromExtHostTestItem(x,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(C===z||C.startsWith(z))return!1;for(const z of this.includePrefix)if(C===z||C.startsWith(z))return!0;return!1}}e.TestRunDto=s;class i{constructor(x,C,z){this.proxy=x,this.runId=C,this.taskId=z}set coverageProvider(x){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!x||(this._coverageProvider=x,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(x){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(x))());try{return(await this.fileCoverage)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.fileCoverage=void 0,C}}async resolveFileCoverage(x,C){const z=await this.fileCoverage;let N=z?.[x];return!this._coverageProvider||!z||!N?[]:(N.detailedCoverage||(N=z[x]=await this._coverageProvider.resolveFileCoverage?.(N,C)??N),N.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class l extends A.IncrementalChangeCollector{constructor(x){super(),this.emitter=x,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(x){this.added.add(x)}update(x){Object.assign(x.revived,a.TestItem.toPlain(x.item)),this.added.has(x)||this.updated.add(x)}remove(x){if(this.added.has(x)){this.added.delete(x);return}if(this.updated.delete(x),x.parent&&this.alreadyRemoved.has(x.parent)){this.alreadyRemoved.add(x.item.extId);return}this.removed.add(x)}getChangeEvent(){const{added:x,updated:C,removed:z}=this;return{get added(){return[...x].map(N=>N.revived)},get updated(){return[...C].map(N=>N.revived)},get removed(){return[...z].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class S extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(x){return this.items.get(x)}getMirroredTestDataByReference(x){return this.items.get(x.id)}createItem(x,C){return{...x,revived:a.TestItem.toPlain(x.item),depth:C?C.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=S;class p{constructor(x){this.proxy=x}checkout(){this.current||(this.current=this.createObserverData());const x=this.current;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map(C=>C.revived)},dispose:(0,_.once)(()=>{--x.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(x){return this.current?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.current?.tests.apply(x)}createObserverData(){const x=new S;return this.proxy.$subscribeToDiffs(),{observers:0,tests:x}}}class T{constructor(x,C,z,N,L,q,W,R=!1,Z=void 0){this.controllerId=z,this.profileId=N,this._label=L,this.kind=q,this.runHandler=W,this._isDefault=R,this._tag=Z,c.set(this,void 0),v.set(this,void 0),Je(this,c,x,"f"),Je(this,v,C,"f"),C.set(N,this);const le=U[q];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);Oe(this,c,"f").$publishTestRunProfile({profileId:N,controllerId:z,tag:Z?a.TestTag.namespace(this.controllerId,Z.id):null,label:L,group:le,isDefault:R,hasConfigurationHandler:!1})}get label(){return this._label}set label(x){x!==this._label&&(this._label=x,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:x}))}get isDefault(){return this._isDefault}set isDefault(x){x!==this._isDefault&&(this._isDefault=x,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:x?a.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(x){x!==this._configureHandler&&(this._configureHandler=x,Oe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!x}))}dispose(){Oe(this,v,"f")?.delete(this.profileId)&&(Je(this,v,void 0,"f"),Oe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,c=new WeakMap,v=new WeakMap;const U={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ce[214],Ie([1,0,16,5,4,95,8,6]),function(ne,e,o,y,b,M,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new y.Emitter,this._onDidChangeTextEditorOptions=new y.Emitter,this._onDidChangeTextEditorVisibleRanges=new y.Emitter,this._onDidChangeTextEditorViewColumn=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const w=this._extHostDocumentsAndEditors.allEditors();return O?w:w.map(m=>m.value)}async showTextDocument(O,w,m){let I;typeof w=="number"?I={position:_.ViewColumn.from(w),preserveFocus:m}:typeof w=="object"?I={position:_.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?_.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:I={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,I),a=f&&this._extHostDocumentsAndEditors.getEditor(f);if(a)return a.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new M.TextEditorDecorationType(this._proxy,O,w).value}$acceptEditorPropertiesChanged(O,w){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(w.options&&m._acceptOptions(w.options),w.selections){const I=w.selections.selections.map(_.Selection.to);m._acceptSelections(I)}if(w.visibleRanges){const I=o.coalesce(w.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(I)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...w.options,lineNumbers:_.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const I=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:I})}if(w.visibleRanges){const I=o.coalesce(w.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:I})}}$acceptEditorPositionData(O){for(const w in O){const m=this._extHostDocumentsAndEditors.getEditor(w);if(!m)throw new Error("Unknown text editor");const I=_.ViewColumn.to(O[w]);m.value.viewColumn!==I&&(m._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:I}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(Ce[215],Ie([1,0,2,3,4,7,6,8,10]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class k{constructor(m,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const a=f.uri===void 0?void 0:o.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(a))?.get(f.handle)}return f}})}async $getTimeline(m,I,f,a){return this._providers.get(m)?.provideTimeline(o.URI.revive(I),f,a)}registerTimelineProvider(m,I,f,a){const h=new M.DisposableStore,d=this.convertTimelineItem(I.id,a,h).bind(this);let g;I.onDidChange&&(g=I.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:I.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:m,onDidChange:void 0,async provideTimeline(c,v,t){v?.resetCache&&(h.clear(),A.get(I.id)?.clear());const u=await I.provideTimeline(c,v,t);if(u==null)return;const n=d(c,v);return{...u,source:I.id,items:u.items.map(n)}},dispose(){for(const c of A.values())c.get(I.id)?.clear();g?.dispose(),h.dispose()}})}convertTimelineItem(m,I,f){return(a,h)=>{let d;if(h?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const A=O(a);d=g.get(A),d===void 0&&(d=new Map,g.set(A,d))}return g=>{const{iconPath:A,...c}=g,v=`${m}|${g.id??g.timestamp}`;d?.set(v,g);let t,u,n;g.iconPath&&(A instanceof _.ThemeIcon?n={id:A.id,color:A.color}:o.URI.isUri(A)?(t=A,u=A):{light:t,dark:u}=A);let r;return _.MarkdownString.isMarkdownString(c.tooltip)?r=P.MarkdownString.from(c.tooltip):(0,E.isString)(c.tooltip)?r=c.tooltip:_.MarkdownString.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=P.MarkdownString.from(c.detail)):(0,E.isString)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=c.detail),{...c,id:c.id??void 0,handle:v,source:m,command:g.command?I.toInternal(g.command,f):void 0,icon:t,iconDark:u,themeIcon:n,tooltip:r,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function O(w){return w?.toString()}}),define(Ce[216],Ie([1,0,7,12,2,4]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,O,w){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=w.schemes.find(I=>!_.supportedSchemes.has(I));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,O),this._proxy.$registerUriOpener(k,w.schemes,E,w.label),(0,o.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,O){const w=this._openers.get(E);if(!w)throw new Error(`Unknown opener with id: ${E}`);const m=b.URI.revive(k);return w.canOpenExternalUri(m,O)}async $openUri(E,k,O){const w=this._openers.get(E);if(!w)throw new Error(`Unknown opener id: '${E}'`);return w.openExternalUri(b.URI.revive(k.resolvedUri),{sourceUri:b.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(Ce[217],Ie([1,0,4,2,7,11,27]),function(ne,e,o,y,b,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=P.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(w,O),this._proxy.$registerUriHandler(w,k),(0,b.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(k,O){const w=this.handlers.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(y.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return y.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=P,P.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[54],Ie([1,0,5,12,2,145,161,63,4]),function(ne,e,o,y,b,M,_,P,E){"use strict";var k,O,w,m,I,f,a,h,d,g,A,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(S,p,T,U,j,x,C){k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),a.set(this,""),h.set(this,void 0),d.set(this,!1),g.set(this,!1),A.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new o.Emitter),this._onDidDispose=Oe(this,c,"f").event,Je(this,k,S,"f"),Je(this,O,p,"f"),Je(this,h,T,"f"),Je(this,m,U,"f"),Je(this,I,j,"f"),Je(this,f,x,"f"),Je(this,A,t(x),"f"),Je(this,w,C,"f")}dispose(){Je(this,d,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(S){return Je(this,g,!0,"f"),(0,P.asWebviewUri)(S,Oe(this,m,"f"))}get cspSource(){const S=Oe(this,f,"f").extensionLocation;if(S.scheme===y.Schemas.https||S.scheme===y.Schemas.http){let p=S.toString();return p.endsWith("/")||(p+="/"),p+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(S){this.assertNotDisposed(),Oe(this,a,"f")!==S&&(Je(this,a,S,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(S)&&(Je(this,g,!0,"f"),Oe(this,w,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,k,"f"),S))}get options(){return this.assertNotDisposed(),Oe(this,h,"f")}set options(S){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,k,"f"),r(Oe(this,f,"f"),Oe(this,I,"f"),S)),Je(this,h,S,"f")}async postMessage(S){if(Oe(this,d,"f"))return!1;const p=(0,_.serializeWebviewMessage)(S,{serializeBuffersForPostMessage:Oe(this,A,"f")});return Oe(this,O,"f").$postMessage(Oe(this,k,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,d,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,k=new WeakMap,O=new WeakMap,w=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,a=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,A=new WeakMap,c=new WeakMap;function t(l){try{const S=(0,M.normalizeVersion)((0,M.parseVersion)(l.engines.vscode));return!!S&&S.majorBase>=1&&S.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class u{constructor(S,p,T,U,j){this.remoteInfo=p,this.workspace=T,this._logService=U,this._deprecationService=j,this._webviews=new Map,this._webviewProxy=S.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(S,p,T){const U=this.getWebview(S);if(U){const{message:j}=(0,_.deserializeWebviewMessage)(p,T.value);U._onMessageEmitter.fire(j)}}$onMissingCsp(S,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(S,p,T){const U=new v(S,this._webviewProxy,s(p),this.remoteInfo,this.workspace,T,this._deprecationService);return this._webviews.set(S,U),U._onDidDispose(()=>{this._webviews.delete(S)}),U}deleteWebview(S){this._webviews.delete(S)}getWebview(S){return this._webviews.get(S)}}e.ExtHostWebviews=u;function n(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=n;function r(l,S,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||i(l,S)}}e.serializeWebviewOptions=r;function s(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(S=>b.URI.from(S))}}e.reviveOptions=s;function i(l,S){return[...(S?.getWorkspaceFolders()||[]).map(p=>p.uri),l.extensionLocation]}}),define(Ce[218],Ie([1,0,20,97,7,12,22,2,8,54,61,4,6]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(t,u){this.document=t,this._storagePath=u,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,u){await this.getEdit(t).undo(),u||this.disposeBackup()}async redo(t,u){await this.getEdit(t).redo(),u||this.disposeBackup()}disposeEdits(t){for(const u of t)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const u=this._edits.get(t,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(t,u){return this._documents.get(this.key(t,u))}add(t,u,n){const r=this.key(t,u.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${u.uri}`);const s=new I(u,n);return this._documents.set(r,s),s}delete(t,u){const n=this.key(t,u.uri);this._documents.delete(n)}key(t,u){return`${t}@@@${u}`}}var a;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(a||(a={}));class h{constructor(){this._providers=new Map}addTextProvider(t,u,n){return this.add(0,t,u,n)}addCustomProvider(t,u,n){return this.add(1,t,u,n)}get(t){return this._providers.get(t)}add(t,u,n,r){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:t,extension:n,provider:r}),new m.Disposable(()=>this._providers.delete(u))}}class d{constructor(t,u,n,r,s){this._extHostDocuments=u,this._extensionStoragePaths=n,this._extHostWebview=r,this._extHostWebviewPanels=s,this._editorProviders=new h,this._documents=new f,this._proxy=t.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,u,n,r){const s=new b.DisposableStore;return g(n)?(s.add(this._editorProviders.addTextProvider(u,t,n)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),u,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(u,t,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(i=>{const l=this.getCustomDocumentEntry(u,i.document.uri);if(A(i)){const S=l.addEdit(i);this._proxy.$onDidEdit(i.document.uri,u,S,i.label)}else this._proxy.$onContentChange(i.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),u,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(t,u,n,r,s){const i=this._editorProviders.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${u}'`);const l=P.URI.revive(t),S=await i.provider.openCustomDocument(l,{backupId:n,untitledDocumentData:r?.buffer},s);let p;return this.supportEditing(i.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(i.extension)??this._extensionStoragePaths.globalValue(i.extension)),this._documents.add(u,S,p),{editable:this.supportEditing(i.provider)}}async $disposeCustomDocument(t,u){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${u}'`);const r=P.URI.revive(t),{document:s}=this.getCustomDocumentEntry(u,r);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(t,u,n,r,s,i){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);const S=E.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(u,r.webviewOptions,l.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(u,n,r.title,S,r.panelOptions,p,!0),U=P.URI.revive(t);switch(l.type){case 1:{const{document:j}=this.getCustomDocumentEntry(n,U);return l.provider.resolveCustomEditor(j,T,i)}case 0:{const j=this._extHostDocuments.getDocument(U);return l.provider.resolveCustomTextEditor(j,T,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,u,n){this.getCustomDocumentEntry(u,t).disposeEdits(n)}async $onMoveCustomEditor(t,u,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const i=P.URI.revive(u),l=this._extHostDocuments.getDocument(i);await r.provider.moveCustomTextEditor(l,s,o.CancellationToken.None)}async $undo(t,u,n,r){return this.getCustomDocumentEntry(u,t).undo(n,r)}async $redo(t,u,n,r){return this.getCustomDocumentEntry(u,t).redo(n,r)}async $revert(t,u,n){const r=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(t,u,n){const r=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(t,u,n,r){const s=this.getCustomDocumentEntry(u,t);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,P.URI.revive(n),r)}async $backup(t,u,n){const r=this.getCustomDocumentEntry(u,t),i=await this.getCustomEditorProvider(u).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(i),i.id}getCustomDocumentEntry(t,u){const n=this._documents.get(t,P.URI.revive(u));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(t){const n=this._editorProviders.get(t)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=d;function g(v){return typeof v.resolveCustomTextEditor=="function"}function A(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function c(v){const t=v.scheme===M.Schemas.file||v.scheme===M.Schemas.untitled?v.fsPath:v.toString();return(0,y.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[219],Ie([1,0,5,7,2,42,8,54,4,6]),function(ne,e,o,y,b,M,_,P,E,k){"use strict";var O,w,m,I,f,a,h,d,g,A,c,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends y.Disposable{constructor(i,l,S,p){super(),O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),a.set(this,void 0),h.set(this,void 0),d.set(this,void 0),g.set(this,!0),A.set(this,void 0),c.set(this,!1),v.set(this,this._register(new o.Emitter)),this.onDidDispose=Oe(this,v,"f").event,t.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,i,"f"),Je(this,w,l,"f"),Je(this,I,S,"f"),Je(this,m,p.viewType,"f"),Je(this,f,p.panelOptions,"f"),Je(this,d,p.viewColumn,"f"),Je(this,a,p.title,"f"),Je(this,A,p.active,"f")}dispose(){Oe(this,c,"f")||(Je(this,c,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,I,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,a,"f")}set title(i){this.assertNotDisposed(),Oe(this,a,"f")!==i&&(Je(this,a,i,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),i))}get iconPath(){return this.assertNotDisposed(),Oe(this,h,"f")}set iconPath(i){this.assertNotDisposed(),Oe(this,h,"f")!==i&&(Je(this,h,i,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),b.URI.isUri(i)?{light:i,dark:i}:i))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,d,"f")=="number"&&Oe(this,d,"f")<0))return Oe(this,d,"f")}get active(){return this.assertNotDisposed(),Oe(this,A,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(i){Oe(this,c,"f")||(this.active!==i.active||this.visible!==i.visible||this.viewColumn!==i.viewColumn)&&(Je(this,A,i.active,"f"),Je(this,g,i.visible,"f"),Je(this,d,i.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(i,l){this.assertNotDisposed(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof i>"u"?void 0:_.ViewColumn.from(i),preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,a=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,A=new WeakMap,c=new WeakMap,v=new WeakMap,t=new WeakMap;class n{constructor(i,l,S){this.webviews=l,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=i.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(i,l,S,p,T={}){const U=typeof p=="object"?p.viewColumn:p,j={viewColumn:_.ViewColumn.from(U),preserveFocus:typeof p=="object"&&!!p.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(i),C=n.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(i),C,l,{title:S,panelOptions:r(T),webviewOptions:(0,P.serializeWebviewOptions)(i,this.workspace,T),serializeBuffersForPostMessage:x},j);const z=this.webviews.createNewWebview(C,T,i);return this.createNewWebviewPanel(C,l,S,U,T,z,!0)}$onDidChangeWebviewPanelViewStates(i){const l=Object.keys(i);l.sort((S,p)=>{const T=i[S],U=i[p];return T.active?1:U.active?-1:+T.visible-+U.visible});for(const S of l){const p=this.getWebviewPanel(S);if(!p)continue;const T=i[S];p._updateViewState({active:T.active,visible:T.visible,viewColumn:_.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(i){this.getWebviewPanel(i)?.dispose(),this._webviewPanels.delete(i),this.webviews.deleteWebview(i)}registerWebviewPanelSerializer(i,l,S){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:S,extension:i}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(i)}),new k.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(i,l,S,p){const T=this._serializers.get(l);if(!T)throw new Error(`No serializer found for '${l}'`);const{serializer:U,extension:j}=T,x=this.webviews.createNewWebview(i,S.webviewOptions,j),C=this.createNewWebviewPanel(i,l,S.title,p,S.panelOptions,x,S.active);await U.deserializeWebviewPanel(C,S.state)}createNewWebviewPanel(i,l,S,p,T,U,j){const x=new u(i,this._proxy,U,{viewType:l,title:S,viewColumn:p,panelOptions:T,active:j});return this._webviewPanels.set(i,x),x}getWebviewPanel(i){return this._webviewPanels.get(i)}}e.ExtHostWebviewPanels=n;function r(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[220],Ie([1,0,5,7,54,8,4,6]),function(ne,e,o,y,b,M,_,P){"use strict";var E,k,O,w,m,I,f,a,h,d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends y.Disposable{constructor(t,u,n,r,s,i,l){super(),E.set(this,void 0),k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),m.set(this,!1),I.set(this,void 0),f.set(this,void 0),a.set(this,void 0),h.set(this,void 0),d.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=Oe(this,d,"f").event,g.set(this,this._register(new o.Emitter)),this.onDidDispose=Oe(this,g,"f").event,Je(this,O,n,"f"),Je(this,f,r,"f"),Je(this,E,t,"f"),Je(this,k,u,"f"),Je(this,w,s,"f"),Je(this,I,l,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,g,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(t){this.assertNotDisposed(),Oe(this,f,"f")!==t&&(Je(this,f,t,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(t){this.assertNotDisposed(),Oe(this,a,"f")!==t&&(Je(this,a,t,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,I,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,I,"f")||Oe(this,m,"f")||(Je(this,I,t,"f"),Oe(this,d,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,h,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,h,"f")?.value&&t?.tooltip===Oe(this,h,"f")?.tooltip)&&(Je(this,h,M.ViewBadge.from(t),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,k,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,k=new WeakMap,O=new WeakMap,w=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,a=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap;class c{constructor(t,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,u,n,r){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:n,extension:t}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(t),u,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(t,u,n,r,s){const i=this._viewProviders.get(u);if(!i)throw new Error(`No view provider found for '${u}'`);const{provider:l,extension:S}=i,p=this._extHostWebview.createNewWebview(t,{},S),T=new A(t,this._proxy,u,n,p,S,!0);this._webviewViews.set(t,T),await l.resolveWebviewView(T,{state:r},s)}async $onDidChangeWebviewViewVisibility(t,u){this.getWebviewView(t)._setVisible(u)}async $disposeWebviewView(t){const u=this.getWebviewView(t);this._webviewViews.delete(t),u.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const u=this._webviewViews.get(t);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=c}),define(Ce[99],Ie([1,0,5,4,2,12,9,3,13]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Ji{constructor(w){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=w.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,m){let I;if(typeof w=="string"){I=w;try{w=b.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,_.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,I,m)}async asExternalUri(w,m){if((0,_.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(w,m);return b.URI.from(I)}};k.InitialState={focused:!0},k=xe([$e(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ce[221],Ie([1,0,192,28,13]),function(ne,e,o,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends o.AbstractExtHostConsoleForwarder{constructor(P,E){super(P,E)}_nativeConsoleLogMessage(P,E,k){E.apply(console,k)}};M=xe([$e(0,b.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[222],Ie([1,0,14,23,20,11,5,7,119,186,40]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(T,U){try{return JSON.stringify(T,U)}catch{return"null"}}const I="$$ref$$",f={[I]:-1};class a{constructor(U,j){this.jsonString=U,this.referencedBuffers=j}}function h(T,U=null,j=!1){const x=[];return{jsonString:(j?m:JSON.stringify)(T,(z,N)=>{if(typeof N>"u")return f;if(typeof N=="object"){if(N instanceof y.VSBuffer){const L=x.push(N)-1;return{[I]:L}}if(U)return U(z,N)}return N}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=h;function d(T,U,j){return JSON.parse(T,(x,C)=>{if(C){const z=C[I];if(typeof z=="number")return U[z];if(j&&C.$mid===1)return j.transformIncoming(C)}return C})}e.parseJsonAndRestoreBufferRefs=d;function g(T,U){return JSON.stringify(T,U)}function A(T){return T?(U,j)=>j&&j.$mid===1?T.transformOutgoing(j):j:null}var c;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class r extends P.Disposable{constructor(U,j=null,x=null){super(),this[w]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=j,this._uriTransformer=x,this._uriReplacer=A(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let C=0,z=O.ProxyIdentifier.count;C<z;C++)this._locals[C]=null,this._proxies[C]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(C=>this._receiveOneMessage(C))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,E.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:j,sid:x}=U;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,x)),this._proxies[j]}_createProxy(U,j){const x={get:(C,z)=>(typeof z=="string"&&!C[z]&&z.charCodeAt(0)===36&&(C[z]=(...N)=>this._remoteCall(U,z,N)),z===n?j:C[z])};return new Proxy(Object.create(null),x)}set(U,j){return this._locals[U.nid]=j,j}assertRegistered(U){for(let j=0,x=U.length;j<x;j++){const C=U[j];if(!this._locals[C.nid])throw new Error(`Missing proxy instance ${C.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const j=U.byteLength,x=s.read(U,0),C=x.readUInt8(),z=x.readUInt32();switch(C){case 1:case 2:{let{rpcId:N,method:L,args:q}=l.deserializeRequestJSONArgs(x);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(j,z,N,L,q,C===2);break}case 3:case 4:{let{rpcId:N,method:L,args:q}=l.deserializeRequestMixedArgs(x);this._uriTransformer&&(q=(0,E.transformIncomingURIs)(q,this._uriTransformer)),this._receiveRequest(j,z,N,L,q,C===4);break}case 5:{this._logger?.logIncoming(j,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(j,z);break}case 7:{this._receiveReply(j,z,void 0);break}case 9:{let N=l.deserializeReplyOKJSON(x);this._uriTransformer&&(N=(0,E.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(j,z,N);break}case 10:{const N=l.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(j,z,N);break}case 8:{const N=l.deserializeReplyOKVSBuffer(x);this._receiveReply(j,z,N);break}case 11:{let N=l.deserializeReplyErrError(x);this._uriTransformer&&(N=(0,E.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(j,z,N);break}case 12:{this._receiveReplyErr(j,z,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,j,x,C,z,N){this._logger?.logIncoming(U,j,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(x)}.${C}(`,z);const L=String(j);let q,W;if(N){const Z=new b.CancellationTokenSource;z.push(Z.token),q=this._invokeHandler(x,C,z),W=()=>Z.cancel()}else q=this._invokeHandler(x,C,z),W=t;this._cancelInvokedHandlers[L]=W;const R=l.serializeAcknowledged(j);this._logger?.logOutgoing(R.byteLength,j,1,"ack"),this._protocol.send(R),q.then(Z=>{delete this._cancelInvokedHandlers[L];const le=l.serializeReplyOK(j,Z,this._uriReplacer);this._logger?.logOutgoing(le.byteLength,j,1,"reply:",Z),this._protocol.send(le)},Z=>{delete this._cancelInvokedHandlers[L];const le=l.serializeReplyErr(j,Z);this._logger?.logOutgoing(le.byteLength,j,1,"replyErr:",Z),this._protocol.send(le)})}_receiveCancel(U,j){this._logger?.logIncoming(U,j,1,"receiveCancel");const x=String(j);this._cancelInvokedHandlers[x]?.()}_receiveReply(U,j,x){this._logger?.logIncoming(U,j,0,"receiveReply:",x);const C=String(j);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const z=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],z.resolveOk(x)}_receiveReplyErr(U,j,x){this._logger?.logIncoming(U,j,0,"receiveReplyErr:",x);const C=String(j);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const z=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C];let N;x&&(x.$isError?(N=new Error,N.name=x.name,N.message=x.message,N.stack=x.stack):N=x),z.resolveErr(N)}_invokeHandler(U,j,x){try{return Promise.resolve(this._doInvokeHandler(U,j,x))}catch(C){return Promise.reject(C)}}_doInvokeHandler(U,j,x){const C=this._locals[U];if(!C)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(U));const z=C[j];if(typeof z!="function")throw new Error("Unknown method "+j+" on actor "+(0,O.getStringIdentifierForProxy)(U));return z.apply(C,x)}_remoteCall(U,j,x){if(this._isDisposed)return new k.CanceledLazyPromise;let C=null;if(x.length>0&&b.CancellationToken.isCancellationToken(x[x.length-1])&&(C=x.pop()),C&&C.isCancellationRequested)return Promise.reject(M.canceled());const z=l.serializeRequestArguments(x,this._uriReplacer),N=++this._lastMessageId,L=String(N),q=new k.LazyPromise;C&&C.onCancellationRequested(()=>{const R=l.serializeCancel(N);this._logger?.logOutgoing(R.byteLength,N,0,"cancel"),this._protocol.send(l.serializeCancel(N))}),this._pendingRPCReplies[L]=q,this._onWillSendRequest(N);const W=l.serializeRequest(N,U,j,z,!!C);return this._logger?.logOutgoing(W.byteLength,N,0,`request: ${(0,O.getStringIdentifierForProxy)(U)}.${j}(`,x),this._protocol.send(W),q}}e.RPCProtocol=r,w=u,r.UNRESPONSIVE_TIME=3*1e3;class s{constructor(U,j){this._buff=U,this._offset=j}static alloc(U,j,x){const C=new s(y.VSBuffer.alloc(x+1+4),0);return C.writeUInt8(U),C.writeUInt32(j),C}static read(U,j){return new s(U,j)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,j}static sizeMixedArray(U){let j=0;j+=1;for(let x=0,C=U.length;x<C;x++){const z=U[x];switch(j+=1,z.type){case 1:j+=this.sizeLongString(z.value);break;case 2:j+=this.sizeVSBuffer(z.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(z.value);for(let N=0;N<z.buffers.length;++N)j+=this.sizeVSBuffer(z.buffers[N]);break;case 4:break}}return j}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let j=0,x=U.length;j<x;j++){const C=U[j];switch(C.type){case 1:this.writeUInt8(1),this.writeLongString(C.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C.value);break;case 3:this.writeUInt8(3),this.writeUInt32(C.buffers.length),this.writeLongString(C.value);for(let z=0;z<C.buffers.length;++z)this.writeBuffer(C.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(U);for(let x=0;x<U;x++)switch(this.readUInt8()){case 1:j[x]=this.readLongString();break;case 2:j[x]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),N=this.readLongString(),L=[];for(let q=0;q<z;++q)L.push(this.readVSBuffer());j[x]=new O.SerializableObjectWithBuffers(d(N,L,null));break}case 4:j[x]=void 0;break}return j}}s.sizeUInt32=4;var i;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(i||(i={}));class l{static _useMixedArgSerialization(U){for(let j=0,x=U.length;j<x;j++)if(U[j]instanceof y.VSBuffer||U[j]instanceof O.SerializableObjectWithBuffers||typeof U[j]>"u")return!0;return!1}static serializeRequestArguments(U,j){if(this._useMixedArgSerialization(U)){const x=[];for(let C=0,z=U.length;C<z;C++){const N=U[C];if(N instanceof y.VSBuffer)x[C]={type:2,value:N};else if(typeof N>"u")x[C]={type:4};else if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:q}=h(N.value,j);x[C]={type:3,value:y.VSBuffer.fromString(L),buffers:q}}else x[C]={type:1,value:y.VSBuffer.fromString(g(N,j))}}return{type:1,args:x}}return{type:0,args:g(U,j)}}static serializeRequest(U,j,x,C,z){switch(C.type){case 0:return this._requestJSONArgs(U,j,x,C.args,z);case 1:return this._requestMixedArgs(U,j,x,C.args,z)}}static _requestJSONArgs(U,j,x,C,z){const N=y.VSBuffer.fromString(x),L=y.VSBuffer.fromString(C);let q=0;q+=s.sizeUInt8(),q+=s.sizeShortString(N),q+=s.sizeLongString(L);const W=s.alloc(z?2:1,U,q);return W.writeUInt8(j),W.writeShortString(N),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(U){const j=U.readUInt8(),x=U.readShortString(),C=U.readLongString();return{rpcId:j,method:x,args:JSON.parse(C)}}static _requestMixedArgs(U,j,x,C,z){const N=y.VSBuffer.fromString(x);let L=0;L+=s.sizeUInt8(),L+=s.sizeShortString(N),L+=s.sizeMixedArray(C);const q=s.alloc(z?4:3,U,L);return q.writeUInt8(j),q.writeShortString(N),q.writeMixedArray(C),q.buffer}static deserializeRequestMixedArgs(U){const j=U.readUInt8(),x=U.readShortString(),C=U.readMixedArray(),z=new Array(C.length);for(let N=0,L=C.length;N<L;N++){const q=C[N];typeof q=="string"?z[N]=JSON.parse(q):z[N]=q}return{rpcId:j,method:x,args:z}}static serializeAcknowledged(U){return s.alloc(5,U,0).buffer}static serializeCancel(U){return s.alloc(6,U,0).buffer}static serializeReplyOK(U,j,x){if(typeof j>"u")return this._serializeReplyOKEmpty(U);if(j instanceof y.VSBuffer)return this._serializeReplyOKVSBuffer(U,j);if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:C,referencedBuffers:z}=h(j.value,x,!0);return this._serializeReplyOKJSONWithBuffers(U,C,z)}else return this._serializeReplyOKJSON(U,m(j,x))}static _serializeReplyOKEmpty(U){return s.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,j){let x=0;x+=s.sizeVSBuffer(j);const C=s.alloc(8,U,x);return C.writeVSBuffer(j),C.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,j){const x=y.VSBuffer.fromString(j);let C=0;C+=s.sizeLongString(x);const z=s.alloc(9,U,C);return z.writeLongString(x),z.buffer}static _serializeReplyOKJSONWithBuffers(U,j,x){const C=y.VSBuffer.fromString(j);let z=0;z+=s.sizeUInt32,z+=s.sizeLongString(C);for(const L of x)z+=s.sizeVSBuffer(L);const N=s.alloc(10,U,z);N.writeUInt32(x.length),N.writeLongString(C);for(const L of x)N.writeBuffer(L);return N.buffer}static deserializeReplyOKJSON(U){const j=U.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(U,j){const x=U.readUInt32(),C=U.readLongString(),z=[];for(let N=0;N<x;++N)z.push(U.readVSBuffer());return new O.SerializableObjectWithBuffers(d(C,z,j))}static serializeReplyErr(U,j){const x=j?m(M.transformErrorForSerialization(j),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(U);const C=y.VSBuffer.fromString(x);let z=0;z+=s.sizeLongString(C);const N=s.alloc(11,U,z);return N.writeLongString(C),N.buffer}static deserializeReplyErrError(U){const j=U.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(U){return s.alloc(12,U,0).buffer}}var S;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(S||(S={}));var p;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[223],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(M){const _=P=>{self.removeEventListener("message",_);const E=P.data;Object.defineProperties(self,{postMessage:{value(k,O){E.postMessage(k,O)}},onmessage:{get(){return E.onmessage},set(k){E.onmessage=k}}}),E.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",_)}.toString();class y extends EventTarget{constructor(M,_,P){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${o})('${_}'))`,k=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(k),w=new MessageChannel,m=O,I={type:"_newWorker",id:m,port:w.port2,url:O,options:P};M(I,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const a=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",f=>{const a=new MessageEvent("message",{data:f.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=y}),define(Ce[224],Ie([1,0,5,30,38,3,39,11,14]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new o.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new o.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(a=>f.push(a)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}y.Registry.add(e.Extensions.OutputChannels,new O);function w(I,f,a,h,d){return(0,E.createCancelablePromise)(async g=>{await(0,_.whenProviderRegistered)(a,h);const A=y.Registry.as(e.Extensions.OutputChannels);try{await m(a,1,h,d,g),A.registerChannel({id:I,label:f,file:a,log:!0})}catch(c){(0,P.isCancellationError)(c)||d.error("Error while registering log channel",a.toString(),(0,P.getErrorMessage)(c))}})}e.registerLogChannel=w;async function m(I,f,a,h,d){if(!await a.exists(I)){if(d.isCancellationRequested)throw new P.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,E.timeout)(1e3,d),await m(I,f+1,a,h,d)}}}),define(Ce[100],Ie([1,0,4,7,3,13,15,224,52,28,35,113,23,10]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends y.Disposable{constructor(d,g,A,c){super(),this.id=d,this.name=g,this.logger=A,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(d){this.append(d+`
`)}append(d){this.write(d),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const d=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,d)}replace(d){const g=this.offset;this.write(d),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(d,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof d=="boolean"?d:g))}hide(){this.proxy.$close(this.id)}write(d){this.offset+=m.VSBuffer.fromString(d).byteLength,this.logger.info(d)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let a=class{constructor(d,g,A,c,v){this.extHostFileSystem=A,this.extHostFileSystemInfo=c,this.loggerService=v,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=d.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.visibleChannelId=d;for(const[g,A]of this.channels)A.visible=g===this.visibleChannelId}createOutputChannel(d,g,A){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if((0,I.isString)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(d,g,A);return c.then(v=>{this.channels.set(v.id,v),v.visible=v.id===this.visibleChannelId}),this.createExtHostOutputChannel(d,c)}async doCreateOutputChannel(d,g,A){const c=await this.createOutputDirectory(),v=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(v,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(d,!1,v,g,A.identifier.value);return new f(u,d,t,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(d,g){let A=!1;const c=()=>{if(A)throw new Error("Channel has been closed")};return{get name(){return d},append(v){c(),g.then(t=>t.append(v))},appendLine(v){c(),g.then(t=>t.appendLine(v))},clear(){c(),g.then(v=>v.clear())},replace(v){c(),g.then(t=>t.replace(v))},show(v,t){c(),g.then(u=>u.show(v,t))},hide(){c(),g.then(v=>v.hide())},dispose(){A=!0,g.then(v=>v.dispose())}}}};a=xe([$e(0,M.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,E.IExtHostConsumerFileSystem),$e(3,O.IExtHostFileSystemInfo),$e(4,_.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(Ce[225],Ie([1,0,3]),function(ne,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(Ce[226],Ie([1,0,37,12,19,21,22,2,3,157,45,172,225]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let I=class Zi{constructor(a,h,d,g){this.localUserHome=a,this.remoteAgentService=h,this.environmentService=d,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome??a})()}hasValidBasename(a,h,d){return typeof h=="string"||typeof h>"u"?this.resolveOS.then(g=>this.doHasValidBasename(a,g,h)):this.doHasValidBasename(a,h,d)}doHasValidBasename(a,h,d){return a.scheme===y.Schemas.file||a.scheme===y.Schemas.vscodeRemote?(0,o.isValidBasename)(d??(0,_.basename)(a),h===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(a,h){if(a.remoteAuthority)return y.Schemas.vscodeRemote;const d=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(d)return d;const g=h.getWorkspace().folders[0];if(g)return g.uri.scheme;const A=h.getWorkspace().configuration;return A?A.scheme:y.Schemas.file}userHome(a){return a?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(a=>a===1?b.win32:b.posix)}async fileURI(a){let h="";if(await this.resolveOS===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(h=a.substring(2),a="/"):(h=a.substring(2,g),a=a.substring(g)||"/")}return P.URI.from({scheme:y.Schemas.file,authority:h,path:a,query:"",fragment:""})}};I=xe([$e(1,m.IRemoteAgentService),$e(2,w.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(Ce[101],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(_,P){this.line=_,this.character=P}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,P){return new o(0,0)}with(_){return new o(0,0)}}e.Position=o;class y{constructor(_,P,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(_,P),this.end=new o(E,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new y(0,0,0,0)}with(_){return new y(0,0,0,0)}}e.Range=y;var b;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[41],Ie([1,0,16,34,26,37,9,3,19,11,101,14]),function(ne,e,o,y,b,M,_,P,E,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",I=" characters skipped \u27EB",f=(m.length+I.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var a;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function d(oe){return!!oe.preview}e.resultIsMatch=d;function g(oe){return!!oe.resource}e.isFileMatch=g;function A(oe){return!!oe.message}e.isProgressMessage=A;var c;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=v;class t{constructor(ue,ee,ve){this.ranges=ee;const we=Array.isArray(ee)?ee:[ee];if(ve&&ve.matchLines===1&&u(we)){ue=(0,_.getNLines)(ue,ve.matchLines);let re="",Ee=0,Pe=0;const Fe=Math.floor(ve.charsPerLine/5),ze=[];for(const Qe of we){const Te=Math.max(Qe.startColumn-Fe,0),_e=Qe.startColumn+ve.charsPerLine;if(Te>Pe+Fe+f){const ye=m+(Te-Pe)+I;re+=ye+ue.slice(Te,_e),Ee+=Te-(Pe+ye.length)}else re+=ue.slice(Pe,_e);ze.push(new r(0,Qe.startColumn-Ee,Qe.endColumn-Ee)),Pe=_e}this.preview={text:re,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const re=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ue,matches:(0,o.mapArrayOrNot)(ee,Ee=>new n(Ee.startLineNumber-re,Ee.startColumn,Ee.endLineNumber-re,Ee.endColumn))}}}}e.TextSearchMatch=t;function u(oe){const ue=oe[0].startLineNumber;for(const ee of oe)if(ee.startLineNumber!==ue||ee.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,ee,ve,we){this.startLineNumber=ue,this.startColumn=ee,this.endLineNumber=ve,this.endColumn=we}}e.SearchRange=n;class r extends n{constructor(ue,ee,ve){super(ue,ee,ue,ve)}}e.OneLineRange=r;var s;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function i(oe,ue=!0){const ee=oe&&oe.files&&oe.files.exclude,ve=ue&&oe&&oe.search&&oe.search.exclude;if(!ee&&!ve)return;if(!ee||!ve)return ee||ve;let we=Object.create(null);return we=b.mixin(we,b.deepClone(ee)),we=b.mixin(we,b.deepClone(ve),!0),we}e.getExcludes=i;function l(oe,ue){return oe.excludePattern&&y.match(oe.excludePattern,ue)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&y.match(oe.includePattern,ue)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ee=>{const ve=ee.folder.fsPath;if(M.isEqualOrParent(ue,ve)){const we=E.relative(ve,ue);return!ee.includePattern||!!y.match(ee.includePattern,we)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var S;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(S=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(ue,ee){super(ue),this.code=ee}}e.SearchError=p;function T(oe){const ue=oe.message;if((0,k.isCancellationError)(oe))return new p(ue,S.canceled);try{const ee=JSON.parse(ue);return new p(ee.message,ee.code)}catch{return new p(ue,S.other)}}e.deserializeSearchError=T;function U(oe){const ue={message:oe.message,code:oe.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=U;function j(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=j;function x(oe){return oe.type==="success"}e.isSerializedSearchSuccess=x;function C(oe){return!!oe.path}e.isSerializedFileMatch=C;function z(oe,ue){const ee=oe.searchPath?oe.searchPath:oe.relativePath;return(0,_.fuzzyContains)(ee,ue)}e.isFilePatternMatch=z;class N{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function L(oe,ue){const ee={...oe||{},...ue||{}};return Object.keys(ee).filter(ve=>{const we=ee[ve];return typeof we=="boolean"&&we})}e.resolvePatternsForProvider=L;class q{constructor(ue,ee){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...ee.excludePattern||{}},this._parsedExcludeExpression=y.parse(this._excludeExpression);let ve=ue.includePattern;ee.includePattern&&(ve?ve={...ve,...ee.includePattern}:ve=ee.includePattern),ve&&(this._parsedIncludeExpression=y.parse(ve))}matchesExcludesSync(ue,ee,ve){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ee,ve))}includedInQuerySync(ue,ee,ve){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,ee,ve)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,ee,ve))}includedInQuery(ue,ee,ve){const we=this._parsedExcludeExpression(ue,ee,ve),re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,ee,ve):!0;return(0,w.isThenable)(we)?we.then(Ee=>Ee?!1:re()):re()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=q;function W(oe){for(const ue in oe)if(typeof oe[ue]!="boolean")return!0;return!1}function R(oe){if(!oe)return;let ue;return ee=>(ue||(ue=(oe()||Promise.resolve([])).then(ve=>ve?le(ve):{})),ue.then(ve=>!!ve[ee]))}e.hasSiblingPromiseFn=R;function Z(oe){if(!oe)return;let ue;return ee=>{if(!ue){const ve=oe();ue=ve?le(ve):{}}return!!ue[ee]}}e.hasSiblingFn=Z;function le(oe){const ue={};for(const ee of oe)ue[ee]=!0;return ue}}),define(Ce[31],Ie([1,0,16,14,20,5,7,25,12,108,22,9,10,2,136,3,15,149,45,35,28,13,8,6,46,41,4]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v,t,u,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(C,z,N){return new O.ExtUri(L=>T(L,N)).isEqual(C,z)}function l(C,z,N){return i(C.uri,z.uri,N)?0:(0,w.compare)(C.uri.toString(),z.uri.toString())}function S(C,z,N){return C.index!==z.index?C.index<z.index?-1:1:i(C.uri,z.uri,N)?(0,w.compare)(C.name,z.name):(0,w.compare)(C.uri.toString(),z.uri.toString())}function p(C,z,N,L){const q=C.slice(0).sort((R,Z)=>N(R,Z,L)),W=z.slice(0).sort((R,Z)=>N(R,Z,L));return(0,o.delta)(q,W,(R,Z)=>N(R,Z,L))}function T(C,z){const N=z.getCapabilities(C.scheme);return!(N&&N&1024)}class U extends g.Workspace{constructor(z,N,L,q,W,R,Z){super(z,L.map(le=>new g.WorkspaceFolder(le)),q,W,Z),this._name=N,this._isUntitled=R,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(Z),L.forEach(le=>{this._workspaceFolders.push(le),this._structure.set(le.uri,le)})}static toExtHostWorkspace(z,N,L,q){if(!z)return{workspace:null,added:[],removed:[]};const{id:W,name:R,folders:Z,configuration:le,transient:oe,isUntitled:ue}=z,ee=[],ve=N;N?Z.forEach((Pe,Fe)=>{const ze=I.URI.revive(Pe.uri),Qe=U._findFolder(L||N,ze,q);Qe?(Qe.name=Pe.name,Qe.index=Pe.index,ee.push(Qe)):ee.push({uri:ze,name:Pe.name,index:Fe})}):ee.push(...Z.map(({uri:Pe,name:Fe,index:ze})=>({uri:I.URI.revive(Pe),name:Fe,index:ze}))),ee.sort((Pe,Fe)=>Pe.index<Fe.index?-1:1);const we=new U(W,R,ee,!!oe,le?I.URI.revive(le):null,!!ue,Pe=>T(Pe,q)),{added:re,removed:Ee}=p(ve?ve.workspaceFolders:[],we.workspaceFolders,l,q);return{workspace:we,added:re,removed:Ee}}static _findFolder(z,N,L){for(let q=0;q<z.folders.length;q++){const W=z.workspaceFolders[q];if(i(W.uri,N,L))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,N){return N&&this._structure.get(z)&&(z=(0,O.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let j=class{constructor(z,N,L,q,W){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=q,this._extHostFileSystemInfo=L,this._uriTransformerService=W,this._requestIdProvider=new k.Counter,this._barrier=new y.Barrier,this._proxy=z.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(s.MainContext.MainThreadMessageService);const R=N.workspace;this._confirmedWorkspace=R?new U(R.id,R.name,[],!!R.transient,R.configuration?I.URI.revive(R.configuration):null,!!R.isUntitled,Z=>T(Z,L)):void 0}$initializeWorkspace(z,N){this._trusted=N,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?I.URI.from({scheme:E.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,N,L,...q){const W=[];if(Array.isArray(q)&&q.forEach(ue=>{I.URI.isUri(ue.uri)&&!W.some(ee=>i(ee.uri,ue.uri,this._extHostFileSystemInfo))&&W.push({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[N,L].some(ue=>typeof ue!="number"||ue<0)||L===0&&W.length===0)return!1;const R=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+L>R.length)return!1;const Z=R.slice(0);Z.splice(N,L,...W.map(ue=>({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<Z.length;ue++){const ee=Z[ue];if(Z.some((ve,we)=>we!==ue&&i(ee.uri,ve.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((ue,ee)=>ue.index=ee);const{added:le,removed:oe}=p(R,Z,S,this._extHostFileSystemInfo);if(le.length===0&&oe.length===0)return!1;if(this._proxy){const ue=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(ue,N,L,W).then(void 0,ee=>{this._unconfirmedWorkspace=void 0;const ve={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(d.Severity.Error,(0,f.localize)(0,null,ue,ee.toString()),ve,[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(z,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,N)}async getWorkspaceFolder2(z,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,N)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,N){let L,q="";if(typeof z=="string"?(L=I.URI.file(z),q=z):typeof z<"u"&&(L=z,q=z.fsPath),!L)return q;const W=this.getWorkspaceFolder(L,!0);if(!W)return q;typeof N>"u"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let R=(0,O.relativePath)(W.uri,L);return N&&W.name&&(R=`${W.name}/${R}`),R}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=U.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:N,added:L,removed:q}=U.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:q}))}findFiles(z,N,L,q,W=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let R;if(N===null?R=!1:N&&(typeof N=="string"?R=N:R=N.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:le}=x(t.GlobPattern.from(z));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(Z),(0,m.withUndefinedAsNull)(le),(0,m.withUndefinedAsNull)(R),(0,m.withUndefinedAsNull)(L),W).then(oe=>Array.isArray(oe)?oe.map(ue=>I.URI.revive(ue)):[])}async findTextInFiles(z,N,L,q,W=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const R=this._requestIdProvider.getNext(),Z=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:le,folder:oe}=x(t.GlobPattern.from(N.include)),ue=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,ee={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:Z,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:le,excludePattern:ue},ve=!1;if(this._activeSearchCallbacks[R]=we=>{if(ve)return;const re=I.URI.revive(we.resource);we.results.forEach(Ee=>{(0,r.resultIsMatch)(Ee)?L({uri:re,preview:{text:Ee.preview.text,matches:(0,o.mapArrayOrNot)(Ee.preview.matches,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,o.mapArrayOrNot)(Ee.ranges,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):L({uri:re,text:Ee.text,lineNumber:Ee.lineNumber})})},W.isCancellationRequested)return{};try{const we=await this._proxy.$startTextSearch(z,(0,m.withUndefinedAsNull)(oe),ee,R,W);return delete this._activeSearchCallbacks[R],we||{}}catch(we){throw delete this._activeSearchCallbacks[R],we}}$handleTextSearchResult(z,N){this._activeSearchCallbacks[N]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,N){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,N);const L=this._uriTransformerService.transformOutgoingScheme(z),q=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(q,L),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(q)})}async $getEditSessionIdentifier(z,N){this._logService.info("Getting edit session identifier for workspaceFolder",z);const L=await this.resolveWorkspaceFolder(I.URI.revive(z));if(!L){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const q=this._editSessionIdentityProviders.get(L.uri.scheme);if(this._logService.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!q),!q)return;const W=await q.provideEditSessionIdentity(L,N);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};j=xe([$e(0,v.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,A.IExtHostFileSystemInfo),$e(3,h.ILogService),$e(4,n.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function x(C){let z,N;return C&&(typeof C=="string"?z=C:(z=C.pattern,N=I.URI.revive(C.baseUri))),{includePattern:z,folder:N}}}),define(Ce[32],Ie([1,0,26,5,31,4,6,152,83,10,14,3,13,15,2]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(u,n){if(n){const r=n.split(".");let s=u;for(let i=0;s&&i<r.length;i++)s=s[r[i]];return s}}function h(u){return u instanceof f.URI}function d(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function g(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function A(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function c(u){if(h(u))return{resource:u};if(d(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(g(u))return{overrideIdentifier:u.languageId};if(A(u))return{resource:u.uri};if(u===null)return{resource:null}}let v=class{constructor(n,r,s){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=s,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new t(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,r){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,r))}};v=xe([$e(0,m.IExtHostRpcService),$e(1,b.IExtHostWorkspace),$e(2,I.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(n,r,s,i){this._onDidChangeConfiguration=new y.Emitter,this._proxy=n,this._logService=i,this._extHostWorkspace=r,this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,r){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,s))}getConfiguration(n,r,s){const i=c(r)||{},l=this._toReadonlyValue(n?a(this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,i,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,i,s?.identifier);function S(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(T){return typeof a(l,T)<"u"},get:(T,U)=>{this._validateConfigurationAccess(n?`${n}.${T}`:T,i,s?.identifier);let j=a(l,T);if(typeof j>"u")j=U;else{let x;const C=(z,N)=>{let L;const q=()=>{x=x||(0,o.deepClone)(l),L=L||a(x,N)};return(0,k.isObject)(z)?new Proxy(z,{get:(W,R)=>{if(typeof R=="string"&&R.toLowerCase()==="tojson")return q(),()=>L;if(x)return L=L||a(x,N),L[R];const Z=W[R];return typeof R=="string"?C(Z,`${N}.${R}`):Z},set:(W,R,Z)=>(q(),L&&(L[R]=Z),!0),deleteProperty:(W,R)=>(q(),L&&delete L[R],!0),defineProperty:(W,R,Z)=>(q(),L&&Object.defineProperty(L,R,Z),!0)}):z};j=C(j,T)}return j},update:(T,U,j,x)=>{T=n?`${n}.${T}`:T;const C=S(j);return U!==void 0?this._proxy.$updateConfigurationOption(C,T,U,i,x):this._proxy.$removeConfigurationOption(C,T,i,x)},inspect:T=>{T=n?`${n}.${T}`:T;const U=(0,o.deepClone)(this._configuration.inspect(T,i,this._extHostWorkspace.workspace));if(U)return{key:T,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof l=="object"&&(0,o.mixin)(p,l,!1),Object.freeze(p)}_toReadonlyValue(n){const r=s=>(0,k.isObject)(s)?new Proxy(s,{get:(i,l)=>r(i[l]),set:(i,l,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(i,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(i,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:i=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return r(n)}_validateConfigurationAccess(n,r,s){const i=E.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),l=s?`[${s.value}] `:"";if(i===4){typeof r?.resource>"u"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(i===3){r?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,r){const s=new P.ConfigurationChangeEvent(n,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(i,l)=>s.affectsConfiguration(i,c(l))})}_toMap(n){return n.reduce((r,s)=>(r.set(s[0],s[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[102],Ie([1,0,2,14,5,4,6,31,50,32,20,53,13,28,3,12,21,15,66,185,11]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(N){function L(W){if(W!=null)return W}N.from=L;function q(W){if(W!=null)return W}N.to=q})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(N){function L(W){if(W!=null)return W}N.from=L;function q(W){if(W!=null)return W}N.to=q})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(N){function L(W){if(W!=null)return W}N.from=L;function q(W){if(W!=null)return W}N.to=q})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(N){function L(R){if(R){const Z=R;return Z&&!!Z.process}else return!1}N.is=L;function q(R){if(R==null)return;const Z={process:R.process,args:R.args};return R.options&&(Z.options=n.from(R.options)),Z}N.from=q;function W(R){if(R!=null)return new _.ProcessExecution(R.process,R.args,R.options)}N.to=W})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(N){function L(W){if(W!=null)return W}N.from=L;function q(W){if(W!=null)return W}N.to=q})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var i;(function(N){function L(R){if(R){const Z=R;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}N.is=L;function q(R){if(R==null)return;const Z={};return R.commandLine!==void 0?Z.commandLine=R.commandLine:(Z.command=R.command,Z.args=R.args),R.options&&(Z.options=s.from(R.options)),Z}N.from=q;function W(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new _.ShellExecution(R.commandLine,R.options):new _.ShellExecution(R.command,R.args?R.args:[],R.options)}N.to=W})(i=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(N){function L(R){if(R){const Z=R;return Z&&Z.customExecution==="customExecution"}else return!1}N.is=L;function q(R){return{customExecution:"customExecution"}}N.from=q;function W(R,Z){return Z.get(R)}N.to=W})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(N){function L(q,W){let R;return q.scope!==void 0&&typeof q.scope!="number"?R=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?R=W.workspaceFile:R=A.USER_TASKS_GROUP_KEY),{id:q._id,workspaceFolder:R}}N.from=L})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(N){function L(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}N.from=L})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(N){function L(R,Z){if(R==null)return[];const le=[];for(const oe of R){const ue=q(oe,Z);ue&&le.push(ue)}return le}N.fromMany=L;function q(R,Z){if(R==null)return;let le;R.execution instanceof _.ProcessExecution?le=r.from(R.execution):R.execution instanceof _.ShellExecution?le=i.from(R.execution):R.execution&&R.execution instanceof _.CustomExecution&&(le=l.from(R.execution));const oe=t.from(R.definition);let ue;return R.scope?typeof R.scope=="number"?ue=R.scope:ue=R.scope.uri:ue=_.TaskScope.Workspace,!oe||!ue?void 0:{_id:R._id,definition:oe,name:R.name,source:{extensionId:Z.identifier.value,label:R.source,scope:ue},execution:le,isBackground:R.isBackground,group:p.from(R.group),presentationOptions:u.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}N.from=q;async function W(R,Z,le){if(R==null)return;let oe;r.is(R.execution)?oe=r.to(R.execution):i.is(R.execution)?oe=i.to(R.execution):l.is(R.execution)&&(oe=l.to(R._id,le));const ue=t.to(R.definition);let ee;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?ee=R.source.scope:ee=await Z.resolveWorkspaceFolder(o.URI.revive(R.source.scope)):ee=_.TaskScope.Workspace),!ue||!ee)return;const ve=new _.Task(ue,ee,R.name,R.source.label,oe,R.problemMatchers);return R.isBackground!==void 0&&(ve.isBackground=R.isBackground),R.group!==void 0&&(ve.group=_.TaskGroup.from(R.group._id),ve.group&&R.group.isDefault&&(ve.group=new _.TaskGroup(ve.group.id,ve.group.label),R.group.isDefault===!0&&(ve.group.isDefault=R.group.isDefault))),R.presentationOptions&&(ve.presentationOptions=u.to(R.presentationOptions)),R._id&&(ve._id=R._id),R.detail&&(ve.detail=R.detail),ve}N.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var U;(function(N){function L(W){return W}N.from=L;function q(W){if(!!W)return Object.assign(Object.create(null),W)}N.to=q})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(L,q,W){this._id=q,this._task=W,v.set(this,void 0),Je(this,v,L,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}v=new WeakMap;var x;(function(N){function L(q){return{id:q._id,task:void 0}}N.from=L})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let C=class{constructor(L,q,W,R,Z,le,oe,ue){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=L.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=R,this._configurationService=Z,this._terminalService=le,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=ue,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(L,q,W){if(!W)return new _.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:q,provider:W,extension:L}),this._proxy.$registerTaskProvider(R,q),new _.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(L,q){this._proxy.$registerTaskSystem(L,q)}fetchTasks(L){return this._proxy.$fetchTasks(U.from(L)).then(async q=>{const W=[];for(const R of q){const Z=await T.to(R,this._workspaceProvider,this._providedCustomExecutions2);Z&&W.push(Z)}return W})}get taskExecutions(){const L=[];return this._taskExecutions.forEach(q=>L.push(q)),L}terminateTask(L){if(!(L instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(L._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(L,q,W){const R=this._providedCustomExecutions2.get(L.id);R&&(this._activeCustomExecutions2.set(L.id,R),this._terminalService.attachPtyToTerminal(q,await R.callback(W))),this._lastStartedTask=L.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(L)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(L){const q=await this.getTaskExecution(L);this._taskExecutionPromises.delete(L.id),this._taskExecutions.delete(L.id),this.customExecutionComplete(L),this._onDidTerminateTask.fire({execution:q})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(L){const q=await this.getTaskExecution(L.id);this._onDidTaskProcessStarted.fire({execution:q,processId:L.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(L){const q=await this.getTaskExecution(L.id);this._onDidTaskProcessEnded.fire({execution:q,exitCode:L.exitCode})}$provideTasks(L,q){const W=this._handlers.get(L);if(!W)return Promise.reject(new Error("no handler found"));const R=[],Z=(0,y.asPromise)(()=>W.provider.provideTasks(O.CancellationToken.None)).then(le=>this.provideTasksInternal(q,R,W,le));return new Promise(le=>{Z.then(oe=>{Promise.all(R).then(()=>{le(oe)})})})}async $resolveTask(L,q){const W=this._handlers.get(L);if(!W)return Promise.reject(new Error("no handler found"));if(q.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${W.type}].`);const R=await T.to(q,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const Z=await W.provider.resolveTask(R,O.CancellationToken.None);if(!Z)return;this.checkDeprecation(Z,W);const le=T.from(Z,W.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(le.execution)&&await this.addCustomExecution(le,Z,!0),await this.resolveTaskInternal(le)}nextHandle(){return this._handleCounter++}async addCustomExecution(L,q,W){const R=await this._proxy.$createTaskId(L);!W&&!this._providedCustomExecutions2.has(R)&&(this._notProvidedCustomExecutions.add(R),this._activeCustomExecutions2.set(R,q.execution)),this._providedCustomExecutions2.set(R,q.execution)}async getTaskExecution(L,q){if(typeof L=="string"){const Z=this._taskExecutionPromises.get(L);if(!Z)throw new Error("Unexpected: The specified task is missing an execution");return Z}const W=this._taskExecutionPromises.get(L.id);if(W)return W;const R=new Promise((Z,le)=>{function oe(ue,ee,ve){ve?Z(new j(ue,ee.id,ve)):le("Unexpected: Task does not exist.")}q?oe(this,L,q):T.to(L.task,this._workspaceProvider,this._providedCustomExecutions2).then(ue=>oe(this,L,ue))});return this._taskExecutionPromises.set(L.id,R),R.then(Z=>(this._taskExecutions.set(L.id,Z),Z),Z=>Promise.reject(Z))}checkDeprecation(L,q){L._deprecated&&this._deprecationService.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(L){this._activeCustomExecutions2.get(L.id)&&this._activeCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.has(L.id)&&this._lastStartedTask!==L.id&&(this._providedCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.delete(L.id));const W=this._notProvidedCustomExecutions.values();let R=W.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=W.next()}};C=xe([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,d.ILogService),$e(7,g.IExtHostApiDeprecationService)],C),e.ExtHostTaskBase=C;let z=class extends C{constructor(L,q,W,R,Z,le,oe,ue){super(L,q,W,R,Z,le,oe,ue),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(L,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(q,L);if(W===void 0)throw new Error("Task is not valid");if(l.is(W.execution))await this.addCustomExecution(W,q,!1);else throw new c.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),q);return this._proxy.$executeTask(W).catch(Z=>{throw new Error(Z)}),R}provideTasksInternal(L,q,W,R){const Z=[];if(R)for(const le of R){this.checkDeprecation(le,W),(!le.definition||!L[le.definition.type])&&this._logService.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=T.from(le,W.extension);oe&&l.is(oe.execution)?(Z.push(oe),q.push(this.addCustomExecution(oe,le,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:W.extension}}async resolveTaskInternal(L){if(l.is(L.execution))return L;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(L,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,q,W){}};z=xe([$e(0,m.IExtHostRpcService),$e(1,I.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,d.ILogService),$e(7,g.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[227],Ie([1,0,19,20,43,34,22,203,41]),function(ne,e,o,y,b,M,_,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,I,f){this.config=m,this.provider=I,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const I=this.config.folderQueries||[];return new Promise((f,a)=>{const h=d=>{this.resultCount++,m(d)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(d=>{const g=d.toString(),A=o.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,A)||this.matchFile(h,{base:d,basename:A})}),Promise.all(I.map(d=>this.searchInFolder(d,h))).then(d=>{f({limitHit:this.isLimitHit,stats:d[0]||void 0})},d=>{a(new Error((0,b.toErrorMessage)(d)))})})}async searchInFolder(m,I){const f=new y.CancellationTokenSource,a=this.getSearchOptionsForFolder(m),h=this.initDirectoryTree(),d=new E.QueryGlobTester(this.config,m),g=!d.hasSiblingExcludeClauses();let A;try{this.activeCancellationTokens.add(f),A=P.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,f.token),v=A.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(u=>{const n=o.posix.relative(m.folder.path,u.path);if(g){const r=o.basename(u.path);this.matchFile(I,{base:m.folder,relativePath:n,basename:r});return}this.addDirectoryEntries(h,m.folder,n,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,d,I),{providerTime:v,postProcessTime:t.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const I=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:I,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},I,f,a){if(f===this.filePattern){const d=o.basename(this.filePattern);this.matchFile(a,{base:I,relativePath:this.filePattern,basename:d})}function h(d){const g=o.basename(d),A=o.dirname(d);let c=m[A];c||(c=m[A]=[],h(A)),c.push({base:I,relativePath:d,basename:g})}h(f)}matchDirectoryTree({rootEntries:m,pathToEntries:I},f,a){const h=this,d=this.filePattern;function g(A){const c=(0,E.hasSiblingFn)(()=>A.map(v=>v.basename));for(let v=0,t=A.length;v<t;v++){const u=A[v],{relativePath:n,basename:r}=u;if(f.matchesExcludesSync(n,r,d!==r?c:void 0))continue;const s=I[n];if(s)g(s);else{if(n===d)continue;h.matchFile(a,u)}if(h.isLimitHit)break}}g(m)}matchFile(m,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(I))}}class O{constructor(){this.sessions=new Map}fileSearch(m,I,f,a){const h=this.getSessionTokenSource(m.cacheKey),d=new k(m,I,h&&h.token);let g=0;const A=c=>{g+=c.length,f(c.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(d,O.BATCH_SIZE,A,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:c.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new y.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,I,f,a){a.onCancellationRequested(()=>{m.cancel()});const h=g=>{g&&(d.push(g),I>0&&d.length>=I&&(f(d),d=[]))};let d=[];return m.search(h).then(g=>(d.length&&f(d),g),g=>(d.length&&f(d),Promise.reject(g)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ce[228],Ie([1,0,16,71,34,76,25,12,19,22,9,10,2,245,144,57,15,45,90,226,41]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(p,T,U,j,x){this.configurationService=p,this.workspaceContextService=T,this.editorGroupsService=U,this.logService=j,this.pathService=x}text(p,T,U={}){p=this.getContentPattern(p,U);const j=this.configurationService.getValue(),x=T&&T.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(T?.map(d.toWorkspaceFolder),U),type:2,contentPattern:p,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:j.search.usePCRE2||x||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(p,T){const U=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const j={...p,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(p,T)&&(j.isCaseSensitive=!0),this.isMultiline(p)&&(j.isMultiline=!0),j}file(p,T={}){return{...this.commonQuery(p,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(p,T){return p?(p=Array.isArray(p)?p.map(s):s(p),T?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],T={}){const U=this.handleIncludeExclude(T.includePattern,T.expandPatterns),j=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),x=p.length>1,C=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,T,j)):p.map(L=>this.getFolderQueryForRoot(L,T,j,x))).filter(L=>!!L),z={_reason:T._reason,folderQueries:C,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:j.pattern,includePattern:U.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const L=o.coalesce(o.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(Z=>Z.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const q=L.filter(R=>(0,c.pathIncludedInQuery)(z,R.fsPath)),W=this.commonQueryFromFileList(q);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const N=T.extraFileResources&&T.extraFileResources.filter(L=>(0,c.pathIncludedInQuery)(z,L.fsPath));return z.extraFileResources=N&&N.length?N:void 0,z}commonQueryFromFileList(p){const T=[],U=new _.ResourceMap,j={};let x=!1;return p.forEach(C=>{if(C.scheme===P.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(C)){const N=this.workspaceContextService.getWorkspaceFolder(C)?.uri??C.with({path:E.dirname(C.fsPath)});let L=U.get(N);L||(x=!0,L={folder:N,includePattern:{}},T.push(L),U.set(N,L));const q=E.relative(N.fsPath,C.fsPath);(0,w.assertIsDefined)(L.includePattern)[q.replace(/\\/g,"/")]=!0}else C.fsPath&&(x=!0,j[C.fsPath]=!0)}),{folderQueries:T,includePattern:j,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(p,T){if(T.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,I.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const T=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),j=(Array.isArray(p)?p:n(p)).map(W=>{const R=this.pathService.resolvedUserHome;return R?(0,M.untildify)(W,R.scheme===P.Schemas.file?R.fsPath:R.path):W}),x=y.groupBy(j,W=>T(W)?"searchPaths":"exprSegments"),C=(x.exprSegments||[]).map(W=>O.rtrim(W,"/")).map(W=>O.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),r(W))),z={},N=this.expandSearchPathPatterns(x.searchPaths||[]);N&&N.length&&(z.searchPaths=N);const L=o.flatten(C),q=u(...L);return q&&(z.pattern=q),z}getExcludesForFolder(p,T){return T.disregardExcludeSettings?void 0:(0,c.getExcludes)(p,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const T=o.flatten(p.map(j=>{let{pathPortion:x,globPortion:C}=t(j);C&&(C=i(C));const z=this.expandOneSearchPath(x);return o.flatten(z.map(N=>this.resolveOneSearchPathPattern(N,C)))})),U=new Map;return T.forEach(j=>{const x=j.searchPath.toString(),C=U.get(x);C?j.pattern&&(C.pattern=C.pattern||{},C.pattern[j.pattern]=!0):U.set(x,{searchPath:j.searchPath,pattern:j.pattern?u(j.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(p){if(E.isAbsolute(p)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==P.Schemas.file?[{searchPath:T[0].uri.with({path:p})}]:[{searchPath:m.URI.file(E.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=s(p),p.startsWith("../")||p===".."){const j=E.posix.resolve(T.path,p);return[{searchPath:T.with({path:j})}]}const U=i(p);return[{searchPath:T,pattern:U}]}else{if(p==="./"||p===".\\")return[];{const T=p.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(x=>{const C=T.match(new RegExp(`^${O.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return C?{match:C,folder:x}:null}).filter(w.isDefined);if(j.length)return j.map(x=>{const C=x.match[1];return{searchPath:x.folder.uri,pattern:C&&i(C)}});{const x=p.match(/\.[\/\\](.+)[\/\\]?/),C=x?x[1]:p,z=f.localize(0,null,C);throw new Error(z)}}}}resolveOneSearchPathPattern(p,T){const U=p.pattern&&T?`${p.pattern}/${T}`:p.pattern||T,j=[{searchPath:p.searchPath,pattern:U}];return U&&!U.endsWith("**")&&j.push({searchPath:p.searchPath,pattern:U+"/**"}),j}getFolderQueryForSearchPath(p,T,U){const j=this.getFolderQueryForRoot((0,d.toWorkspaceFolder)(p.searchPath),T,U,!1);return j?{...j,includePattern:p.pattern}:null}getFolderQueryForRoot(p,T,U,j){let x;const C=m.URI.isUri(p)?p:p.uri;if(U.searchPaths){const W=U.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,C))[0];if(W&&!W.pattern)return null;W&&(x=W.pattern)}const z=this.configurationService.getValue({resource:C}),L={...this.getExcludesForFolder(z,T)||{},...x||{}},q=m.URI.isUri(p)?(0,k.basename)(p):p.name;return{folder:C,folderName:j?q:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!z.search.followSymlinks}}};v=xe([$e(0,a.IConfigurationService),$e(1,d.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,h.ILogService),$e(4,A.IPathService)],v),e.QueryBuilder=v;function t(S){const p=S.match(/[\*\{\}\(\)\[\]\?]/);if(p){const T=p.index,U=S.substr(0,T).match(/[/|\\][^/\\]*$/);if(U){let j=S.substr(0,U.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:S.substr((U.index||0)+1)}}}return{pathPortion:S}}function u(...S){return S.length?S.reduce((p,T)=>(p[T]=!0,p),Object.create(null)):void 0}function n(S){return b.splitGlobAware(S,",").map(p=>p.trim()).filter(p=>!!p.length)}function r(S){return[`**/${S}/**`,`**/${S}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(S){return S.replace(/\\/g,"/")}function i(S){return s(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(S,p){S=o.distinct(S,j=>j.toString());const T=[],U=p.getWorkspace();return S&&S.forEach(j=>{let x;if(p.getWorkbenchState()===2)x=(0,k.relativePath)(U.folders[0].uri,j),x&&x!=="."&&(x="./"+x);else{const C=p.getWorkspaceFolder(j);if(C){const z=C.name;if(U.folders.filter(L=>L.name===z).length===1){const L=(0,k.relativePath)(C.uri,j);L===""?x=`./${C.name}`:x=`./${C.name}/${L}`}else x=j.fsPath}}x&&T.push(x)}),T}e.resolveResourcesForSearchIncludes=l}),define(Ce[229],Ie([1,0,22,2,20,11,3,228,41,45]),function(ne,e,o,y,b,M,_,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(a,h){const d=h.activationEvents;if(!d)return Promise.resolve(void 0);const g=[],A=[];for(const r of d)if(/^workspaceContains:/.test(r)){const s=r.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||a.forceUsingSearch?A.push(s):g.push(s)}if(g.length===0&&A.length===0)return Promise.resolve(void 0);let c;const v=new Promise((r,s)=>{c=r}),t=r=>c({activationEvent:r}),u=Promise.all(g.map(r=>m(a,r,t))).then(()=>{}),n=I(a,h.identifier,A,t);return Promise.all([u,n]).then(()=>{c(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function m(a,h,d){for(const g of a.folders)if(await a.exists(o.joinPath(y.URI.revive(g),h))){d(`workspaceContains:${h}`);return}}async function I(a,h,d,g){if(d.length===0)return Promise.resolve(void 0);const A=new b.CancellationTokenSource,c=a.checkExists(a.folders,d,A.token),v=setTimeout(async()=>{A.cancel(),a.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await c}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}A.dispose(),clearTimeout(v),t&&g(`workspaceContains:${d.join(",")}`)}function f(a,h,d,g){const A=a.get(_.IInstantiationService),c=a.get(E.ISearchService),t=A.createInstance(P.QueryBuilder).file(h.map(u=>(0,k.toWorkspaceFolder)(y.URI.revive(u))),{_reason:"checkExists",includePattern:d,exists:!0});return c.fileSearch(t,g).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ne,e,o,y,b){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!b:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?b.call(ne,o):b?b.value=o:e.set(ne,o),o},Oe=this&&this.__classPrivateFieldGet||function(ne,e,o,y){if(o==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?y:o==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[33],Ie([1,0,131,19,70,22,14,7,25,2,15,4,32,174,68,31,24,173,11,27,23,158,6,84,3,28,69,13,58,62,53,5,229,67,160,12]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v,t,u,n,r,s,i,l,S,p,T,U,j,x,C){"use strict";var z,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let q=class Ri extends P.Disposable{constructor(ee,ve,we,re,Ee,Pe,Fe,ze,Qe,Te){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=ve,this._extHostContext=we,this._initData=Fe,this._extHostWorkspace=re,this._extHostConfiguration=Ee,this._logService=Pe,this._extHostTunnelService=Qe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new d.ExtensionDescriptionRegistry(this._initData.allExtensions);const _e=(0,h.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new d.ExtensionDescriptionRegistry(Z(this._globalRegistry,_e)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=ze,this._instaService=ee.createChild(new l.ServiceCollection([f.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let ye=[],ae=[];this._initData.remote.isRemote&&(ye=this._initData.allExtensions.filter(Q=>!Q.main&&!Q.browser).map(Q=>Q.identifier),ae=this._initData.allExtensions.filter(Q=>!_e.has(A.ExtensionIdentifier.toKey(Q.identifier.value))).filter(Q=>(Q.main||Q.browser)&&Q.api==="none").map(Q=>Q.identifier));const ce=(0,h.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,ye,ae,{onExtensionActivationError:(Q,J,D)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,g.transformErrorForSerialization(J),D)},actualActivateExtension:async(Q,J)=>{if(ce.has(A.ExtensionIdentifier.toKey(Q)))return await this._mainThreadExtensionsProxy.$activateExtension(Q,J),new I.HostExtension;const D=this._myRegistry.getExtensionDescription(Q);return this._activateExtension(D,J)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ee){g.onUnexpectedError(ee)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ee=[];try{ee=this._myRegistry.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this._deactivate(Ee))}catch{}await Promise.all(ee)}terminate(ee,ve=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ee}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(re=>{this._logService.error(re)}),this._extHostContext.dispose();const we=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),we]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${ve}`):this._logService.info(`Extension host exiting with code ${ve}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(ve)})}isActivated(ee){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ee):!1}async getExtension(ee){const ve=await this._mainThreadExtensionsProxy.$getExtension(ee);let we;if(ve?.browserNlsBundleUris){we={};for(const re of Object.keys(ve.browserNlsBundleUris))we[re]=k.URI.revive(ve.browserNlsBundleUris[re])}return ve&&{...ve,identifier:new A.ExtensionIdentifier(ve.identifier.value),extensionLocation:k.URI.revive(ve.extensionLocation),browserNlsBundleUris:we}}_activateByEvent(ee,ve){return this._activator.activateByEvent(ee,ve)}_activateById(ee,ve){return this._activator.activateById(ee,ve)}activateByIdWithErrors(ee,ve){return this._activateById(ee,ve).then(()=>{const we=this._activator.getActivatedExtension(ee);if(we.activationFailed)return Promise.reject(we.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ee=>this._myRegistry)}getExtensionExports(ee){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ee).exports:null}async _realPathExtensionUri(ee){if(ee.scheme!==C.Schemas.file)return ee;const ve=await this._hostUtils.realpath(ee.fsPath);return k.URI.file(ve)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ee=>new oe(ee))),this._extensionPathIndex}async _createExtensionPathIndex(ee){const ve=E.TernarySearchTree.forUris(we=>M.extUriBiasedIgnorePathCase.ignorePathCasing(we));return await Promise.all(ee.map(async we=>{if(this._getEntryPoint(we)){const re=await this._realPathExtensionUri(we.extensionLocation);ve.set(re,we)}})),ve}_deactivate(ee){let ve=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ee))return ve;const we=this._activator.getActivatedExtension(ee);if(!we)return ve;try{typeof we.module.deactivate=="function"&&(ve=Promise.resolve(we.module.deactivate()).then(void 0,re=>(this._logService.error(re),Promise.resolve(void 0))))}catch(re){this._logService.error(`An error occurred when deactivating the extension '${ee.value}':`),this._logService.error(re)}try{(0,P.dispose)(we.subscriptions)}catch(re){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this._logService.error(re)}return ve}async _activateExtension(ee,ve){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ee.identifier),this._doActivateExtension(ee,ve).then(we=>{const re=we.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ee.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,ve),this._logExtensionActivationTimes(ee,ve,"success",re),we},we=>{throw this._logExtensionActivationTimes(ee,ve,"failure"),we})}_logExtensionActivationTimes(ee,ve,we,re){const Ee=W(ee,ve);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ee,...re||{},outcome:we})}_doActivateExtension(ee,ve){const we=W(ee,ve);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",we);const re=this._getEntryPoint(ee);if(!re)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${ve.startup}, activationEvent: '${ve.activationEvent}'${ee.identifier.value!==ve.extensionId.value?`, root cause: ${ve.extensionId.value}`:""}`),this._logService.flush();const Ee=new I.ExtensionActivationTimesBuilder(ve.startup);return Promise.all([this._loadCommonJSModule(ee,(0,M.joinPath)(ee.extensionLocation,re),Ee),this._loadExtensionContext(ee)]).then(Pe=>(b.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),Ri._callActivate(this._logService,ee.identifier,Pe[0],Pe[1],Ee))).then(Pe=>(b.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Pe))}_loadExtensionContext(ee){const ve=new v.ExtensionGlobalMemento(ee,this._storage),we=new v.ExtensionMemento(ee.identifier.value,!1,this._storage),re=new x.ExtensionSecrets(ee,this._secretState),Ee=ee.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([ve.whenReady,we.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let ze,Qe;const Te=(0,h.isProposedApiEnabled)(ee,"ipc")?this._initData.messagePorts?.get(A.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:we,secrets:re,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(_e){return y.join(ee.extensionLocation.fsPath,_e)},get storagePath(){return Fe._storagePath.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(ee).fsPath},get logPath(){return y.join(Fe._initData.logsLocation.fsPath,ee.identifier.value)},get logUri(){return k.URI.joinPath(Fe._initData.logsLocation,ee.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(ee)},get globalStorageUri(){return Fe._storagePath.globalValue(ee)},get extensionMode(){return Ee},get extension(){return ze===void 0&&(ze=new R(Fe,ee.identifier,ee,Pe,!1)),ze},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(ee,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!Qe){if(!Te)return;const _e=T.Event.buffer(T.Event.fromDOMEventEmitter(Te,"message",ye=>ye.data));Te.start(),Qe={onDidReceiveMessage:_e,postMessage:Te.postMessage.bind(Te)}}return Qe}})})}static _callActivate(ee,ve,we,re,Ee){return we=we||{activate:void 0,deactivate:void 0},this._callActivateOptional(ee,ve,we,re,Ee).then(Pe=>new I.ActivatedExtension(!1,null,Ee.build(),we,Pe,re.subscriptions))}static _callActivateOptional(ee,ve,we,re,Ee){if(typeof we.activate=="function")try{Ee.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${ve.value}`);const Pe=typeof global=="object"?global:self,Fe=we.activate.apply(Pe,[re]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Fe).then(ze=>(Ee.activateResolveStop(),ze))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(we)}_activateOneStartupFinished(ee,ve){this._activateById(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:ve}).then(void 0,we=>{this._logService.error(we)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const ee of this._myRegistry.getAllExtensionDescriptions())if(ee.activationEvents)for(const ve of ee.activationEvents)ve==="onStartupFinished"&&this._activateOneStartupFinished(ee,ve)}_handleEagerExtensions(){const ee=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const ve=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],we=this._handleWorkspaceContainsEagerExtensions(ve),re=Promise.all([ee,we]).then(()=>{});return Promise.race([re,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(ve=>this._handleWorkspaceContainsEagerExtension(ee,ve))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ee,ve){if(this.isActivated(ve.identifier))return;const we=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={logService:this._logService,folders:ee.map(Pe=>Pe.uri),forceUsingSearch:we,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,ze)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,ze)},Ee=await(0,U.checkActivateWorkspaceContainsExtension)(re,ve);if(!!Ee)return this._activateById(ve.identifier,{startup:!0,extensionId:ve.identifier,activationEvent:Ee.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ee){throw console.error(ee),ee}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:ve}=this._initData.environment;if(!ee||!ve)throw new Error(o.localize(0,null));const we=await this._loadCommonJSModule(null,ve,new I.ExtensionActivationTimesBuilder(!1));if(!we||typeof we.run!="function")throw new Error(o.localize(1,null,ve.toString()));return new Promise((re,Ee)=>{const Pe=(Qe,Te)=>{Qe?Ee(Qe):re(typeof Te=="number"&&Te>0?1:0)},Fe=(0,M.originalFSPath)(ve),ze=we.run(Fe,Pe);ze&&ze.then&&ze.then(()=>{re(0)}).catch(Qe=>{Ee(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,ve){return this._resolvers[ee]=ve,(0,P.toDisposable)(()=>{delete this._resolvers[ee]})}async _activateAndGetResolver(ee){const ve=ee.indexOf("+");if(ve===-1)throw new Error("Not an authority that can be resolved!");const we=ee.substr(0,ve);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${we}`,!1),{authorityPrefix:we,resolver:this._resolvers[we]}}async $resolveAuthority(ee,ve){this._logService.info(`$resolveAuthority invoked for authority (${le(ee)})`);const{authorityPrefix:we,resolver:re}=await this._activateAndGetResolver(ee);if(!re)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${we}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(re)),b.mark(`code/extHost/willResolveAuthority/${we}`);const Ee=await re.resolve(ee,{resolveAttempt:ve});b.mark(`code/extHost/didResolveAuthorityOK/${we}`);const Pe={authority:ee,host:Ee.host,port:Ee.port,connectionToken:Ee.connectionToken},Fe={extensionHostEnv:Ee.extensionHostEnv,isTrusted:Ee.isTrusted,authenticationSession:Ee.authenticationSessionForInitializingExtensions?{id:Ee.authenticationSessionForInitializingExtensions.id,providerId:Ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:Ee.environmentTunnels,features:Ee.tunnelFeatures}}}}catch(Ee){if(b.mark(`code/extHost/didResolveAuthorityError/${we}`),Ee instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Ee._code,message:Ee._message,detail:Ee._detail}};throw Ee}}async $getCanonicalURI(ee,ve){this._logService.info(`$getCanonicalURI invoked for authority (${le(ee)})`);const{resolver:we}=await this._activateAndGetResolver(ee);if(!we)return null;const re=k.URI.revive(ve);if(typeof we.getCanonicalURI>"u")return re;const Ee=await(0,_.asPromise)(()=>we.getCanonicalURI(re));return Ee||re}static _applyExtensionsDelta(ee,ve,we){const re=new d.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());re.deltaExtensions(we.toAdd,we.toRemove);const Ee=(0,h.extensionIdentifiersArrayToSet)(ve.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of we.myToRemove)Ee.delete(A.ExtensionIdentifier.toKey(Fe));for(const Fe of we.myToAdd)Ee.add(A.ExtensionIdentifier.toKey(Fe));const Pe=Z(re,Ee);return{globalRegistry:re,myExtensions:Pe}}$startExtensionHost(ee){ee.toAdd.forEach(re=>re.extensionLocation=k.URI.revive(re.extensionLocation));const{globalRegistry:ve,myExtensions:we}=Ri._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee);return this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(we),this._startExtensionHost()}$activateByEvent(ee,ve){return ve===1?this._activateByEvent(ee,!1):this._readyToRunExtensions.wait().then(we=>this._activateByEvent(ee,!1))}async $activate(ee,ve){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ee)?(await this._activateById(ee,ve),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Pe=>Pe.extensionLocation=k.URI.revive(Pe.extensionLocation));const{globalRegistry:ve,myExtensions:we}=Ri._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ee),re=await this._createExtensionPathIndex(we);return(await this.getExtensionPathIndex()).setSearchTree(re),this._globalRegistry.set(ve.getAllExtensionDescriptions()),this._myRegistry.set(we),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const ve=c.VSBuffer.alloc(ee),we=Math.random()%256;for(let re=0;re<ee;re++)ve.writeUInt8(we,re);return ve}async $updateRemoteConnectionData(ee){this._remoteConnectionData=ee,this._onDidChangeRemoteConnectionData.fire()}};q=xe([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,i.IExtHostRpcService),$e(3,a.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,O.ILogService),$e(6,r.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,S.IExtHostTunnelService),$e(9,p.IExtHostTerminalService)],q),e.AbstractExtHostExtensionService=q;function W(ue,ee){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class R{constructor(ee,ve,we,re,Ee){z.set(this,void 0),N.set(this,void 0),L.set(this,void 0),Je(this,z,ee,"f"),Je(this,N,ve,"f"),Je(this,L,we.identifier,"f"),this.id=we.identifier.value,this.extensionUri=we.extensionLocation,this.extensionPath=y.normalize((0,M.originalFSPath)(we.extensionLocation)),this.packageJSON=we,this.extensionKind=re,this.isFromDifferentExtensionHost=Ee}get isActive(){return Oe(this,z,"f").isActivated(Oe(this,L,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,z,"f").getExtensionExports(Oe(this,L,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,z,"f").activateByIdWithErrors(Oe(this,L,"f"),{startup:!1,extensionId:Oe(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=R,z=new WeakMap,N=new WeakMap,L=new WeakMap;function Z(ue,ee){return ue.getAllExtensionDescriptions().filter(ve=>ee.has(A.ExtensionIdentifier.toKey(ve.identifier)))}function le(ue){const ee=ue.indexOf("+");return ee===-1?ue:ue.substring(0,ee)}class oe{constructor(ee){this._searchTree=ee}setSearchTree(ee){this._searchTree=ee}findSubstr(ee){return this._searchTree.findSubstr(ee)}forEach(ee){return this._searchTree.forEach(ee)}}e.ExtensionPaths=oe}),define(Ce[230],Ie([1,0,70,2,4,32,24,27,13,28,3,33,59,15,9]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,u,n,r,s,i){this._apiFactory=v,this._extensionRegistry=t,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const v=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,t,this._extensionRegistry,v,this._logService)),this.register(this._instaService.createInstance(g,t)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,t,this._initData.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this._factories.set(t,v);else this._factories.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this._alternatives.push(t=>v.alternativeModuleName(t))}};a=xe([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,w.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,I.ILogService)],a),e.RequireInterceptor=a;let h=class Xi{constructor(v){if(v.environment.appRoot&&Xi.aliased.size){const t=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(v.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${r}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(v){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(v));if(!t)return;const[,u,n,r]=t,s=Xi.aliased.get(n);if(s!==void 0)return console.warn(`${n} as been renamed to ${s}, please update your imports`),u+s+r}forceForwardSlashes(v){return v.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=xe([$e(0,k.IExtHostInitDataService)],h);class d{constructor(v,t,u,n,r){this._apiFactory=v,this._extensionPaths=t,this._extensionRegistry=u,this._configProvider=n,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(v,t){const u=this._extensionPaths.findSubstr(t);if(u){let n=this._extApiImpl.get(P.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((r,s)=>n+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(v,t,u){this._extensionPaths=v,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(b.MainContext.MainThreadTelemetry);const{environment:n}=u,r=t.getProxy(b.MainContext.MainThreadKeytar);if(n.appRoot){let s=n.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,i)=>r.$getPassword(s,i),setPassword:(s,i,l)=>r.$setPassword(s,i,l),deletePassword:(s,i)=>r.$deletePassword(s,i),findPassword:s=>r.$findPassword(s),findCredentials(s){return r.$findCredentials(s)}}}load(v,t){const u=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(v){const t=v.length;if(t<=7||!this.alternativeNames)return;const u=t-7;if((v.charAt(u)==="/"||v.charAt(u)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.alternativeNames.has(v)))return"keytar"}};g=xe([$e(1,E.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],g);let A=class{constructor(v,t,u){this._extensionPaths=v,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(b.MainContext.MainThreadTelemetry);const n=u.getProxy(b.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=y.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?n.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?n.$openUri(i,r,{}):this.callOriginal(r,s)}}load(v,t,u){const n=this._extensionPaths.findSubstr(t);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(v),this._impl}callOriginal(v,t){return this.sendNoForwardTelemetry(),this._original(v,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=xe([$e(2,E.IExtHostRpcService)],A)}),define(Ce[103],Ie([1,0,197,7,19,59,3,50,51,33,6,31,170,32]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(d,g,A,c,v,t,u){function n(){if(A){const r=A.activeEditor();if(r)return r.document.uri;const s=c.tabGroups.all.find(i=>i.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof O.TextDiffTabInput||s.input instanceof O.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof O.TextTabInput||s.input instanceof O.NotebookEditorTabInput||s.input instanceof O.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:r=>{const s=t.folders.filter(i=>i.name===r);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(r,s)=>v.getConfiguration(void 0,r).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=n();if(r)return b.normalize(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const r=n();if(r){const s=g.getWorkspaceFolder(r);if(s)return b.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(A){const r=A.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(A){const r=A.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>d.getExtension(r)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let a=class extends y.Disposable{constructor(d,g,A,c,v){super(),this.extensionService=d,this.workspaceService=g,this.editorService=A,this.configurationService=c,this.editorTabs=v,this._resolver=new o.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async r=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};a=xe([$e(0,k.IExtHostExtensionService),$e(1,w.IExtHostWorkspace),$e(2,P.IExtHostDocumentsAndEditors),$e(3,I.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[104],Ie([1,0,14,5,10,2,3,4,51,33,13,6,31,163,165,32,103]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let d=class{constructor(n,r,s,i,l,S){this._workspaceService=r,this._extensionService=s,this._configurationService=i,this._editorTabs=l,this._variableResolver=S,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=n.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new A(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(T=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,r){const s=n;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let i=`debug:${encodeURIComponent(s.path||"")}`,l="?";return r&&(i+=`${l}session=${encodeURIComponent(r.id)}`,l="&"),i+=`${l}ref=${s.sourceReference}`,M.URI.parse(i)}else{if(s.path)return M.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const r=[];for(const s of n.getAllExtensionDescriptions())if(s.contributes){const i=s.contributes.debuggers;if(i&&i.length>0)for(const l of i)(0,f.isDebuggerMainContribution)(l)&&r.push(l.type)}this._debugServiceProxy.$registerDebugTypes(r)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(r=>n.push(r)),n}addBreakpoints(n){this.startBreakpoints();const r=n.filter(l=>{const S=l.id;return this._breakpoints.has(S)?!1:(this._breakpoints.set(S,l),!0)});this.fireBreakpointChanges(r,[],[]);const s=[],i=new Map;for(const l of r)if(l instanceof w.SourceBreakpoint){let S=i.get(l.location.uri.toString());S||(S={type:"sourceMulti",uri:l.location.uri,lines:[]},i.set(l.location.uri.toString(),S),s.push(S)),S.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof w.FunctionBreakpoint&&s.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(n){this.startBreakpoints();const r=n.filter(S=>this._breakpoints.delete(S.id));this.fireBreakpointChanges([],r,[]);const s=r.filter(S=>S instanceof w.SourceBreakpoint).map(S=>S.id),i=r.filter(S=>S instanceof w.FunctionBreakpoint).map(S=>S.id),l=r.filter(S=>S instanceof w.DataBreakpoint).map(S=>S.id);return this._debugServiceProxy.$unregisterBreakpoints(s,i,l)}startDebugging(n,r,s){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,r,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,r,s){if(!r)return new w.Disposable(()=>{});const i=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:i,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,s,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,i),new w.Disposable(()=>{this._configProviders=this._configProviders.filter(l=>l.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(i)})}registerDebugAdapterDescriptorFactory(n,r,s){if(!s)return new w.Disposable(()=>{});if(!this.definesDebugType(n,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const i=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:i,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,i),new w.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(l=>l.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(i)})}registerDebugAdapterTrackerFactory(n,r){if(!r)return new w.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:s,factory:r}),new w.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(i=>i.factory!==r)})}async $runInTerminal(n,r){return Promise.resolve(void 0)}async $substituteVariables(n,r){let s;const i=await this.getFolder(n);return i&&(s={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,r)}createDebugAdapter(n,r){if(n.type==="implementation")return new v(n.implementation)}createSignService(){}async $startDASession(n,r){const s=this,i=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(i.type),i).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${i.type}' (extension might have failed to activate)`);const S=this.convertToDto(l),p=this.createDebugAdapter(S,i);if(!p)throw new Error(`Couldn't create a debug adapter for type '${i.type}'.`);const T=p;return this._debugAdapters.set(n,T),this.getDebugAdapterTrackers(i).then(U=>(U&&this._debugAdaptersTrackers.set(n,U),T.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const x=j,C={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(x.arguments.value);C.body={signature:z},T.sendResponse(C)}else throw new Error("no signer")}catch(z){C.success=!1,C.message=z.message,T.sendResponse(C)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(j),j=(0,f.convertToVSCPaths)(j,!0),s._debugServiceProxy.$acceptDAMessage(n,j)}),T.onError(j=>{U&&U.onError&&U.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),T.onExit(j=>{U&&U.onExit&&U.onExit((0,b.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,b.withNullAsUndefined)(j),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),T.startSession()))})}$sendDAMessage(n,r){r=(0,f.convertToDAPaths)(r,!1);const s=this._debugAdaptersTrackers.get(n);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(r),this._debugAdapters.get(n)?.sendMessage(r)}$stopDASession(n){const r=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),r&&r.onWillStopSession&&r.onWillStopSession();const s=this._debugAdapters.get(n);return this._debugAdapters.delete(n),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const r=[],s=[],i=[];if(n.added)for(const l of n.added){const S=l.id;if(S&&!this._breakpoints.has(S)){let p;if(l.type==="function")p=new w.FunctionBreakpoint(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")p=new w.DataBreakpoint(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const T=M.URI.revive(l.uri);p=new w.SourceBreakpoint(new w.Location(T,new w.Position(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}p._id=S,this._breakpoints.set(S,p),r.push(p)}}if(n.removed)for(const l of n.removed){const S=this._breakpoints.get(l);S&&(this._breakpoints.delete(l),s.push(S))}if(n.changed){for(const l of n.changed)if(l.id){const S=this._breakpoints.get(l.id);if(S){if(S instanceof w.FunctionBreakpoint&&l.type==="function"){const p=S;p.enabled=l.enabled,p.condition=l.condition,p.hitCondition=l.hitCondition,p.logMessage=l.logMessage,p.functionName=l.functionName}else if(S instanceof w.SourceBreakpoint&&l.type==="source"){const p=S;p.enabled=l.enabled,p.condition=l.condition,p.hitCondition=l.hitCondition,p.logMessage=l.logMessage,p.location=new w.Location(M.URI.revive(l.uri),new w.Position(l.line,l.character))}i.push(S)}}}this.fireBreakpointChanges(r,s,i)}$provideDebugConfigurations(n,r,s){return(0,o.asPromise)(async()=>{const i=this.getConfigProviderByHandle(n);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.getFolder(r);return i.provideDebugConfigurations(l,s)}).then(i=>{if(!i)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return i})}$resolveDebugConfiguration(n,r,s,i){return(0,o.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.getFolder(r);return l.resolveDebugConfiguration(S,s,i)})}$resolveDebugConfigurationWithSubstitutedVariables(n,r,s,i){return(0,o.asPromise)(async()=>{const l=this.getConfigProviderByHandle(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.getFolder(r);return l.resolveDebugConfigurationWithSubstitutedVariables(S,s,i)})}async $provideDebugAdapter(n,r){const s=this.getAdapterDescriptorFactoryByHandle(n);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const i=await this.getSession(r);return this.getAdapterDescriptor(s,i).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${i.type}'`);return this.convertToDto(l)})}async $acceptDebugSessionStarted(n){const r=await this.getSession(n);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(n){const r=await this.getSession(n);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,r){(await this.getSession(n))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(n,r){const i={session:await this.getSession(n),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(i)}convertToDto(n){if(n instanceof w.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof w.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const r=this._adapterFactories.filter(s=>s.type===n);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(n){const r=this._adapterFactories.filter(s=>s.handle===n);if(r.length>0)return r[0].factory}getConfigProviderByHandle(n){const r=this._configProviders.filter(s=>s.handle===n);if(r.length>0)return r[0].provider}definesDebugType(n,r){if(n.contributes){const s=n.contributes.debuggers;if(s&&s.length>0){for(const i of s)if(i.label&&i.type&&i.type===r)return!0}}return!1}getDebugAdapterTrackers(n){const s=n.configuration.type,i=this._trackerFactories.filter(l=>l.type===s||l.type==="*").map(l=>(0,o.asPromise)(()=>l.factory.createDebugAdapterTracker(n)).then(S=>S,S=>null));return Promise.race([Promise.all(i).then(l=>{const S=l.filter(p=>!!p);if(S.length>0)return new c(S)}),new Promise((l,S)=>{const p=setTimeout(()=>{clearTimeout(p),S(new Error("timeout"))},1e3)})]).catch(l=>{})}async getAdapterDescriptor(n,r){const s=r.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new w.DebugAdapterServer(s));if(n){const l=await this._extensionService.getExtensionRegistry();return(0,o.asPromise)(()=>n.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,l))).then(S=>{if(S)return S})}const i=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,i))}daExecutableFromPackage(n,r){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,r,s){(n.length>0||r.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:r,changed:s}))}async getSession(n){if(n)if(typeof n=="string"){const r=this._debugSessions.get(n);if(r)return r}else{let r=this._debugSessions.get(n.id);if(!r){const s=await this.getFolder(n.folderUri),i=n.parent?this._debugSessions.get(n.parent):void 0;r=new g(this._debugServiceProxy,n.id,n.type,n.name,s,n.configuration,i),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(n){if(n){const r=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};d=xe([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,h.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class g{constructor(n,r,s,i,l,S,p){this._debugServiceProxy=n,this._id=r,this._type=s,this._name=i,this._workspaceFolder=l,this._configuration=S,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,r)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=g;class A{constructor(n){this.value=Object.freeze({append(r){n.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=A;class c{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(r=>r.onError?r.onError(n):void 0)}onExit(n,r){this.trackers.forEach(s=>s.onExit?s.onExit(n,r):void 0)}}class v extends I.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(n,r,s,i,l,S){super(n,r,s,i,l,S)}};t=xe([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,a.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,h.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[231],Ie([1,0,11,70,2,4,222,15,56,58,28,148,13,46,33]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class a{constructor(d,g,A,c,v){this._hostUtils=A,this._rpcProtocol=new _.RPCProtocol(d,null,c),g=a._transform(g,this._rpcProtocol);const t=new k.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:v}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),t.set(I.IURITransformerService,new I.URITransformerService(c)),t.set(f.IHostUtils,A);const u=new w.InstantiationService(t,!0);this._logService=u.invokeFunction(i=>i.get(P.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=u.invokeFunction(i=>i.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(i=>{Error.prepareStackTrace=(l,S)=>{let p="",T,U;for(const j of S)p+=`
	at ${j.toString()}`,U=j.getFileName(),!T&&U&&(T=i.findSubstr(b.URI.file(U)));return n.set(l,T),`${l.name||"Error"}: ${l.message||""}${p}`}});const r=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(i=>{const l=o.transformErrorForSerialization(i),S=n.get(i);S?r.$onExtensionRuntimeError(S.identifier,l):s.$onUnexpectedError(l)})}async asBrowserUri(d){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return b.URI.revive(await g.$asBrowserUri(d))}terminate(d){this._extensionService.terminate(d)}static _transform(d,g){d.allExtensions.forEach(c=>{c.extensionLocation=b.URI.revive(g.transformIncomingURIs(c.extensionLocation));const v={};c.browserNlsBundleUris&&(Object.keys(c.browserNlsBundleUris).forEach(t=>v[t]=b.URI.revive(g.transformIncomingURIs(c.browserNlsBundleUris[t]))),c.browserNlsBundleUris=v)}),d.environment.appRoot=b.URI.revive(g.transformIncomingURIs(d.environment.appRoot));const A=d.environment.extensionDevelopmentLocationURI;return A&&(d.environment.extensionDevelopmentLocationURI=A.map(c=>b.URI.revive(g.transformIncomingURIs(c)))),d.environment.extensionTestsLocationURI=b.URI.revive(g.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=b.URI.revive(g.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=b.URI.revive(g.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=b.URI.revive(g.transformIncomingURIs(d.logsLocation)),d.logFile=b.URI.revive(g.transformIncomingURIs(d.logFile)),d.workspace=g.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=a}),define(Ce[232],Ie([1,0,16,14,20,43,12,19,22,2,41]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,A,c,v){this.query=g,this.provider=A,this.fileUtils=c,this.processType=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,A){const c=this.query.folderQueries||[],v=new b.CancellationTokenSource;return A.onCancellationRequested(()=>v.cancel()),new Promise((t,u)=>{this.collector=new I(g);let n=!1;const r=(s,i)=>{if(!n&&!this.isLimitHit){const l=this.resultSize(s);a(s)&&typeof this.query.maxResults=="number"&&this.resultCount+l>this.query.maxResults&&(this.isLimitHit=!0,n=!0,v.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const S=this.resultSize(s);this.resultCount+=S,(S>0||!a(s))&&this.collector.add(s,i)}};Promise.all(c.map((s,i)=>this.searchInFolder(s,l=>r(l,i),v.token))).then(s=>{v.dispose(),this.collector.flush();const i=s.some(l=>!!l&&!!l.limitHit);t({limitHit:this.isLimitHit||i,messages:(0,o.flatten)(s.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.processType}})},s=>{v.dispose();const i=(0,M.toErrorMessage)(s);u(new Error(i))})})}resultSize(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,A){const c=Array.isArray(g.ranges)?g.ranges:[g.ranges],v=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:c.slice(0,A),preview:{matches:v.slice(0,A),text:g.preview.text},uri:g.uri}}async searchInFolder(g,A,c){const v=new O.QueryGlobTester(this.query,g),t=[],u={report:s=>{if(!this.validateProviderResult(s))return;const i=g.folder.scheme===_.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(s.uri))):void 0,l=E.relativePath(g.folder,s.uri);if(l){const S=v.includedInQuery(l,P.basename(l),i);(0,y.isThenable)(S)?t.push(S.then(p=>{p&&A(s)})):S&&A(s)}}},n=this.getSearchOptionsForFolder(g),r=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,c);return t.length&&await Promise.all(t),r}validateProviderResult(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const A=(0,O.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),c=(0,O.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),v={folder:k.URI.from(g.folder),excludes:c,includes:A,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return v.usePCRE2=this.query.usePCRE2,v}}e.TextSearchManager=w;function m(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class I{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new h(512,A=>this.sendItems(A))}add(g,A){this._currentFileMatch&&(this._currentFolderIdx!==A||!E.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=A,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=I;function f(d){return a(d)?{preview:{matches:(0,o.mapArrayOrNot)(d.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:d.preview.text},ranges:(0,o.mapArrayOrNot)(d.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function a(d){return!!d.preview}e.extensionResultIsMatch=a;class h{constructor(g,A){this.maxBatchSize=g,this.cb=A,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,A){!g||this.addItemToBatch(g,A)}addItems(g,A){!g||this.addItemsToBatch(g,A)}addItemToBatch(g,A){this.batch.push(g),this.batchSize+=A,this.onUpdate()}addItemsToBatch(g,A){this.batch=this.batch.concat(g),this.batchSize+=A,this.onUpdate()}onUpdate(){this.totalNumberCompleted<h.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},h.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=h,h.TIMEOUT=4e3,h.START_BATCH_AFTER_COUNT=50}),define(Ce[105],Ie([1,0,7,4,3,227,13,46,15,2,232]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let w=class{constructor(a,h,d){this.extHostRpc=a,this._uriTransformer=h,this._logService=d,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,h){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const d=this._handlePool++;return this._textSearchProvider.set(d,h),this._proxy.$registerTextSearchProvider(d,this._transformScheme(a)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}registerFileSearchProvider(a,h){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const d=this._handlePool++;return this._fileSearchProvider.set(d,h),this._proxy.$registerFileSearchProvider(d,this._transformScheme(a)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(d),this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(a,h,d,g){const A=m(d),c=this._fileSearchProvider.get(a);if(c)return this._fileSearchManager.fileSearch(A,c,v=>{this._proxy.$handleFileMatch(a,h,v.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,h,d,g){const A=this._textSearchProvider.get(a);if(!A||!A.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=m(d);return this.createTextSearchManager(c,A).search(t=>this._proxy.$handleTextMatch(a,h,t),g)}$enableExtensionHostSearch(){}createTextSearchManager(a,h){return new O.TextSearchManager(a,h,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};w=xe([$e(0,_.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,E.ILogService)],w),e.ExtHostSearch=w;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(I),extraFileResources:f.extraFileResources&&f.extraFileResources.map(a=>k.URI.revive(a))}}e.reviveQuery=m;function I(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[233],Ie([1,0,56,100,31,96,32,36,50,53,102,104,105,68,62,66,99,52,35,67,86,51,205,15,175,103,98]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v,t,u,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(u.ILoggerService,t.ExtHostLoggerService,!0),(0,o.registerSingleton)(u.ILogService,n.ExtHostLogService,!0),(0,o.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,!1),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,!1),(0,o.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,o.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,!1),(0,o.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,!1),(0,o.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,o.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,o.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,!1),(0,o.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService,!0),(0,o.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,o.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,!1),(0,o.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,o.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,o.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,o.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,!1),(0,o.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace,!1),(0,o.registerSingleton)(A.IExtHostSecretState,A.ExtHostSecretState,!1),(0,o.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry,!1),(0,o.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,o.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,!1),(0,o.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,!1)}),define(Ce[234],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const M=this._dragOperations.get(b);return this._dragOperations.delete(b),M}}addDragOperationTransfer(b,M){this._dragOperations.set(b,M)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,M){this._renderedElements.set(b,M)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=o}),define(Ce[235],Ie([1,0,135,6,22,2,5,7,14,6,10,16,8,20,234,24]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(A,c){if((0,O.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let v;return Array.isArray(A.highlights)&&(v=A.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),v=v.length?v:void 0),{label:A.label,highlights:v}}}class d{constructor(c,v,t){this._proxy=c,this.commands=v,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function u(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}v.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(r=>u(r)?this.convertArgument(r):r):n})}registerTreeDataProvider(c,v,t){const u=this.createTreeView(c,{treeDataProvider:v},t);return{dispose:()=>u.dispose()}}createTreeView(c,v,t){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=v.dragAndDropController?.dropMimeTypes??[],n=v.dragAndDropController?.dragMimeTypes??[],r=!!v.dragAndDropController?.handleDrag,s=!!v.dragAndDropController?.handleDrop,i=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:r,hasHandleDrop:s}),l=this.createExtHostTreeView(c,v,t);return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,a.checkProposedApiEnabled)(t,"treeItemCheckbox"),l.onDidChangeTreeCheckbox},get message(){return l.message},set message(S){l.message=S},get title(){return l.title},set title(S){l.title=S},get description(){return l.description},set description(S){l.description=S},get badge(){return l.badge},set badge(S){l.badge=S},reveal:(S,p)=>l.reveal(S,p),dispose:async()=>{await i,this.treeViews.delete(c),l.dispose()}}}$getChildren(c,v){const t=this.treeViews.get(c);return t?t.getChildren(v):Promise.reject(new Error((0,o.localize)(0,null,c)))}async $handleDrop(c,v,t,u,n,r,s,i){const l=this.treeViews.get(c);if(!l)return Promise.reject(new Error((0,o.localize)(1,null,c)));const S=m.DataTransfer.toDataTransfer(t,async p=>(await this._proxy.$resolveDropFileData(c,v,p)).buffer);return s===c&&i&&await this.addAdditionalTransferItems(S,l,i,n,r),l.onDrop(S,u,n)}async addAdditionalTransferItems(c,v,t,u,n){const r=this.treeDragAndDropService.removeDragOperationTransfer(n);if(r)(await r)?.forEach((s,i)=>{s&&c.set(i,s)});else if(n&&v.handleDrag){const s=v.handleDrag(t,c,u);this.treeDragAndDropService.addDragOperationTransfer(n,s),await s}return c}async $handleDrag(c,v,t,u){const n=this.treeViews.get(c);if(!n)return Promise.reject(new Error((0,o.localize)(2,null,c)));const r=await this.addAdditionalTransferItems(new y.DataTransfer,n,v,u,t);if(!!r)return m.DataTransfer.toDataTransferDTO(r)}async $hasResolve(c){const v=this.treeViews.get(c);if(!v)throw new Error((0,o.localize)(3,null,c));return v.hasResolve}$resolve(c,v,t){const u=this.treeViews.get(c);if(!u)throw new Error((0,o.localize)(4,null,c));return u.resolveTreeItem(v,t)}$setExpanded(c,v,t){const u=this.treeViews.get(c);if(!u)throw new Error((0,o.localize)(5,null,c));u.setExpanded(v,t)}$setSelection(c,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,o.localize)(6,null,c));t.setSelection(v)}$setFocus(c,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,o.localize)(7,null,c));t.setFocus(v)}$setVisible(c,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,o.localize)(8,null,c));t.setVisible(v)}$changeCheckboxState(c,v){const t=this.treeViews.get(c);if(!t)throw new Error((0,o.localize)(9,null,c));t.setCheckboxState(v)}createExtHostTreeView(c,v,t){const u=new g(c,v,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(c,u),u}convertArgument(c){const v=this.treeViews.get(c.$treeViewId);return v&&"$treeItemHandle"in c?v.getExtensionElement(c.$treeItemHandle):v&&"$focusedTreeItem"in c&&c.$focusedTreeItem?v.focusedElement:null}}e.ExtHostTreeViews=d;class g extends P.Disposable{constructor(c,v,t,u,n,r){if(super(),this.viewId=c,this.proxy=t,this.commands=u,this.logService=n,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,r.contributes&&r.contributes.views)for(const l in r.contributes.views)for(const S of r.contributes.views[l])S.id===c&&(this._title=S.name);this.dataProvider=v.treeDataProvider,this.dndController=v.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let s,i;this._register(_.Event.debounce(this._onDidChangeData.event,(l,S)=>(l||(l={message:!1,elements:[]}),S.element!==!1&&(s||(s=new Promise(p=>i=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(S.element)?l.elements.push(...S.element):l.elements.push(S.element)),S.message&&(l.message=!0),l),200,!0)(({message:l,elements:S})=>{S.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=i;return s=null,this.refresh(S).then(()=>p())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,O.isUndefinedOrNull)(c))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(c){const v=c?this.getExtensionElement(c):void 0;if(c&&!v)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(c);return t||(t=await this.fetchChildrenNodes(v)),t?t.map(u=>u.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,v){v=v||{select:!0,focus:!1};const t=(0,O.isUndefinedOrNull)(v.select)?!0:v.select,u=(0,O.isUndefinedOrNull)(v.focus)?!1:v.focus,n=(0,O.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(r=>this.resolveTreeNode(c,r[r.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:r.map(i=>i.item)},{select:t,focus:u,expand:n})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:u,expand:n})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}get badge(){return this._badge}set badge(c){this._badge?.value===c?.value&&this._badge?.tooltip===c?.tooltip||(this._badge=m.ViewBadge.from(c),this.proxy.$setBadge(this.viewId,c))}setExpanded(c,v){const t=this.getExtensionElement(c);t&&(v?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(c){(0,w.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(c){this._focusedHandle=c}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(c){const v=(await Promise.all(c.map(async t=>{const u=this.getExtensionElement(t.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);v.forEach(t=>{t.treeItem.checkboxState=t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:v.map(t=>[t.extensionItem,t.newState])})}async handleDrag(c,v,t){const u=[];for(const n of c){const r=this.getExtensionElement(n);r&&u.push(r)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,v,t),v}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(c,v,t){const u=v?this.getExtensionElement(v):void 0;if(!(!u&&v||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,c,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,v){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(c);if(t){const u=this.nodes.get(t);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,t,v)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(v=>v?this.resolveUnknownParentChain(v).then(t=>this.resolveTreeNode(v,t[t.length-1]).then(u=>(t.push(u),t))):Promise.resolve([]))}resolveParent(c){const v=this.nodes.get(c);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,v){const t=this.nodes.get(c);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(u=>this.createHandle(c,u,v,!0)).then(u=>this.getChildren(v?v.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const r=this.nodes.get(n);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(c){if(c){let v;if(typeof c=="string"){const t=this.getExtensionElement(c);v=t?this.nodes.get(t):void 0}else v=c;return v&&v.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const v=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=c?this.nodes.get(c):void 0,u=await this.dataProvider.getChildren(c);if(v.token.isCancellationRequested)return;const n=await Promise.all((0,w.coalesce)(u||[]).map(async r=>{const s=await this.dataProvider.getTreeItem(r);return s&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(r,s,t):null}));return v.token.isCancellationRequested?void 0:(0,w.coalesce)(n)}finally{v.dispose()}}refresh(c){if(c.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(c);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const v=new Set,t=c.map(n=>this.nodes.get(n));for(const n of t)if(n&&!v.has(n.item.handle)){let r=n;for(;r&&r.parent&&t.findIndex(s=>r&&r.parent&&s&&s.item.handle===r.parent.item.handle)===-1;){const s=this.elements.get(r.parent.item.handle);r=s?this.nodes.get(s):void 0}r&&!r.parent&&v.add(n.item.handle)}const u=[];return v.forEach(n=>{const r=this.elements.get(n);if(r){const s=this.nodes.get(r);s&&(!s.parent||!v.has(s.parent.item.handle))&&u.push(n)}}),u}refreshHandles(c){const v={};return Promise.all(c.map(t=>this.refreshNode(t).then(u=>{u&&(v[t]=u.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(c){const v=this.getExtensionElement(c);if(v){const t=this.nodes.get(v);if(t)return this.clearChildren(v),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(u=>{if(u){const n=this.createTreeNode(v,u,t.parent);return this.updateNodeCache(v,n,t,t.parent),t.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,v,t){const u=this.createTreeNode(c,v,t);if(v.id&&this.elements.has(u.item.handle))throw new Error((0,o.localize)(10,null,v.id));return this.addNodeToCache(c,u),this.addNodeToParentCache(u,t),u}getTooltip(c){return k.MarkdownString.isMarkdownString(c)?m.MarkdownString.from(c):c}getCommand(c,v){return v?{...this.commands.toInternal(v,c),originalId:v.command}:void 0}getCheckbox(c){return c.checkboxState!==void 0?c.checkboxState===k.TreeItemCheckboxState.Checked:void 0}validateTreeItem(c){if(!k.TreeItem.isTreeItem(c,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(c,v,t){this.validateTreeItem(v);const u=new P.DisposableStore,n=this.createHandle(c,v,t),r=this.getLightIconPath(v);return{item:{handle:n,parentHandle:t?t.item.handle:void 0,label:h(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(u,v.command),contextValue:v.contextValue,icon:r,iconDark:this.getDarkIconPath(v)||r,themeIcon:this.getThemeIcon(v),collapsibleState:(0,O.isUndefinedOrNull)(v.collapsibleState)?k.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation,checkboxChecked:this.getCheckbox(v)},extensionItem:v,parent:t,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(c){return c.iconPath instanceof k.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:v,label:t,resourceUri:u},n,r){if(v)return`${g.ID_HANDLE_PREFIX}/${v}`;const s=h(t,this.extension),i=n?n.item.handle:g.LABEL_HANDLE_PREFIX;let l=s?s.label:u?(0,b.basename)(u):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const S=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,p=this.getChildrenNodes(n)||[];let T,U=0;do{if(T=`${i}/${U}:${l}`,r||!this.elements.has(T)||S===T)break;U++}while(U<=p.length);return T}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon))return typeof c.iconPath=="string"||M.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return M.URI.isUri(c)?c:M.URI.file(c)}addNodeToCache(c,v){this.elements.set(v.item.handle,c),this.nodes.set(c,v)}updateNodeCache(c,v,t,u){this.elements.delete(v.item.handle),this.nodes.delete(c),v.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(c,v);const n=this.getChildrenNodes(u)||[],r=n.filter(s=>s.item.handle===t.item.handle)[0];r&&n.splice(n.indexOf(r),1,v)}addNodeToParentCache(c,v){v?(v.children||(v.children=[]),v.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const v=this.nodes.get(c);if(v){if(v.children)for(const t of v.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}v.children=void 0}}else this.clearAll()}clear(c){const v=this.nodes.get(c);if(v){if(v.children)for(const t of v.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}this.nodes.delete(c),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(Ce[236],Ie([1,0,20,11,5,29,2,122,246,111,120,39,4,91,190,189,36,191,32,193,194,195,178,196,50,33,198,199,202,204,206,100,181,210,211,212,68,53,214,235,8,6,217,54,99,31,162,201,85,96,102,104,105,15,46,13,28,207,176,62,66,187,215,69,52,220,218,219,188,35,213,216,67,51,86,208,101,209,12,81,180,159,200,7,24,164,98]),function(ne,e,o,y,b,M,_,P,E,k,O,w,m,I,f,a,h,d,g,A,c,v,t,u,n,r,s,i,l,S,p,T,U,j,x,C,z,N,L,q,W,R,Z,le,oe,ue,ee,ve,we,re,Ee,Pe,Fe,ze,Qe,Te,_e,ye,ae,ce,Q,J,D,B,H,V,te,de,Y,pe,ge,Ne,Be,Ye,Ge,ke,nt,G,X,fe,Ue,He,Ze,Ke,We,it,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function dt(at){const rt=at.get(_e.IExtHostInitDataService),_t=at.get(pe.IExtHostFileSystemInfo),Ot=at.get(H.IExtHostConsumerFileSystem),Ft=at.get(r.IExtHostExtensionService),mt=at.get(ue.IExtHostWorkspace),yt=at.get(Ge.IExtHostTelemetry),Nt=at.get(g.IExtHostConfiguration),Ut=at.get(Qe.IURITransformerService),Ve=at.get(Te.IExtHostRpcService),Mt=at.get(z.IExtHostStorage),Pt=at.get(B.IExtensionStoragePaths),At=at.get(ze.ILoggerService),pt=at.get(ze.ILogService),Dt=at.get(ce.IExtHostTunnelService),Se=at.get(st.IExtHostTelemetryLogService),De=at.get(Q.IExtHostApiDeprecationService),me=at.get(oe.IExtHostWindow),K=at.get(Be.IExtHostSecretState),Ae=at.get(Ye.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,_t),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,At),Ve.set(m.ExtHostContext.ExtHostWorkspace,mt),Ve.set(m.ExtHostContext.ExtHostConfiguration,Nt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ve.set(m.ExtHostContext.ExtHostStorage,Mt),Ve.set(m.ExtHostContext.ExtHostTunnelService,Dt),Ve.set(m.ExtHostContext.ExtHostWindow,me),Ve.set(m.ExtHostContext.ExtHostSecretState,K),Ve.set(m.ExtHostContext.ExtHostTelemetry,yt),Ve.set(m.ExtHostContext.ExtHostEditorTabs,Ae);const Le=Ve.set(m.ExtHostContext.ExtHostDecorations,at.get(re.IExtHostDecorations)),et=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),je=Ve.set(m.ExtHostContext.ExtHostCommands,at.get(h.IExtHostCommands)),Xe=Ve.set(m.ExtHostContext.ExtHostTerminalService,at.get(N.IExtHostTerminalService)),ct=Ve.set(m.ExtHostContext.ExtHostDebugService,at.get(Pe.IExtHostDebugService)),Ct=Ve.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),Et=Ve.set(m.ExtHostContext.ExtHostTask,at.get(Ee.IExtHostTask)),St=Ve.set(m.ExtHostContext.ExtHostOutputService,at.get(T.IExtHostOutputService)),bt=Ve.set(m.ExtHostContext.ExtHostUrls,new Z.ExtHostUrls(Ve)),ft=Ve.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ve,et)),It=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ve,et,pt)),Qt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(pt,ft,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),vt=Ve.set(m.ExtHostContext.ExtHostNotebook,new ye.ExtHostNotebookController(Ve,je,et,ft,Pt)),qt=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(vt)),Ht=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(pt,vt)),ii=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(Ve,rt,vt,je,pt)),mi=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(Ve,vt)),kt=Ve.set(m.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ve,et)),zt=Ve.set(m.ExtHostContext.ExtHostTreeViews,new q.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),je,pt)),gi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),kt,rt.remote)),ni=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(Ve,pt,_t)),Yt=Ve.set(m.ExtHostContext.ExtHostLanguages,new S.ExtHostLanguages(Ve,ft,je.converter,Ut)),lt=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ve,Ut,ft,je,ni,pt,De)),pi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ve,lt)),$t=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new i.ExtHostFileSystemEventService(Ve,pt,et)),Kt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ve,mt,je)),ri=Ve.set(m.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Ve,je,pt)),vi=Ve.set(m.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ve,je,ft)),si=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),Ei=Ve.set(m.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(Ve)),oi=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ai=Ve.set(m.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(Ve)),Oi=Ve.set(m.ExtHostContext.ExtHostTimeline,new D.ExtHostTimeline(Ve,je)),Jt=Ve.set(m.ExtHostContext.ExtHostWebviews,new le.ExtHostWebviews(Ve,rt.remote,mt,pt,De)),Zt=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new de.ExtHostWebviewPanels(Ve,Jt,mt)),bi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new te.ExtHostCustomEditors(Ve,ft,Pt,Jt,Zt)),wi=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new V.ExtHostWebviewViews(Ve,Jt)),ei=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,je,et)),Si=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(Ve,vt,et,je,pt));const _i=Object.values(m.ExtHostContext);Ve.assertRegistered(_i);const Fi=new Y.ExtHostBulkEdits(Ve,et),Ni=new a.ExtHostClipboard(Ve),yi=new p.ExtHostMessageService(Ve,pt),ki=new c.ExtHostDialogs(Ve),Ti=new C.ExtHostStatusBar(Ve,je.converter);return f.ExtHostApiCommands.register(je),function(Me,Bt,ci){const gt=function(){let se=!Me.isUnderDevelopment;function he(){se||(pt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")he();else{const wt=ot;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),Mi={getSession(se,he,Re){return ai.getSession(Me,se,he,Re)},async hasSession(se,he){return(0,We.checkProposedApiEnabled)(Me,"authSession"),!!await ai.getSession(Me,se,he,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(se,he,Re,ot){return ai.registerAuthenticationProvider(se,he,Re,ot)}},Li={registerCommand(se,he,Re){return je.registerCommand(!0,se,he,Re,void 0,Me)},registerTextEditorCommand(se,he,Re){return je.registerCommand(!0,se,(...ot)=>{const wt=kt.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}return wt.edit(Tt=>{he.apply(Re,[wt,Tt,...ot])}).then(Tt=>{Tt||pt.warn("Edits from command "+se+" were not applied.")},Tt=>{pt.warn("An error occurred while running command "+se,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"diffCommand"),je.registerCommand(!0,se,async(...ot)=>{const wt=et.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Tt=await kt.getDiffInformation(wt.id);he.apply(Re,[Tt,...ot])},void 0,void 0,Me)),executeCommand(se,...he){return je.executeCommand(se,...he)},getCommands(se=!1){return je.getCommands(se)}},ti={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Ni.value},get shell(){return Xe.getDefaultShell(!1)},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const se=Date.now()-new Date(rt.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,he){return me.openUri(se,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===rt.environment.appUriScheme)return bt.createAppUri(se);try{return await me.asExternalUri(se,{allowTunneling:!!rt.remote.authority})}catch(he){if((0,fe.matchesScheme)(se,X.Schemas.http)||(0,fe.matchesScheme)(se,X.Schemas.https))return se;throw he}},get remoteName(){return(0,we.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind}};rt.environment.extensionTestsLocationURI||Object.freeze(ti);const Ui={createTestController(se,he,Re){return ei.createTestController(se,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ei.createTestObserver()},runTests(se){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ei.runTests(se)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ei.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ei.results}},li=rt.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,Bi={getExtension(se,he){(0,We.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Bt.mine.getExtensionDescription(se);if(Re)return new r.Extension(Ft,Me.identifier,Re,li,!1);if(he){const ot=Bt.all.getExtensionDescription(se);if(ot)return new r.Extension(Ft,Me.identifier,ot,li,!0)}},get all(){const se=[];for(const he of Bt.mine.getAllExtensionDescriptions())se.push(new r.Extension(Ft,Me.identifier,he,li,!1));return se},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Me,"extensionsAny");const se=new We.ExtensionIdentifierSet(Bt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Bt.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);he.push(new r.Extension(Ft,Me.identifier,Re,li,ot))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Me,"extensionsAny")?b.Event.any(Bt.mine.onDidChange,Bt.all.onDidChange):Bt.mine.onDidChange}},xi={createDiagnosticCollection(se){return ni.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return ni.onDidChangeDiagnostics},getDiagnostics:se=>ni.getDiagnostics(se),getLanguages(){return Yt.getLanguages()},setTextDocumentLanguage(se,he){return Yt.changeLanguage(se.uri,he)},match(se,he){const Re=ft.getDocumentData(he.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(se),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,he,Re){return lt.registerCodeActionProvider(Me,gt(se),he,Re)},registerDocumentPasteEditProvider(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"documentPaste"),lt.registerDocumentPasteEditProvider(Me,gt(se),he,Re)},registerCodeLensProvider(se,he){return lt.registerCodeLensProvider(Me,gt(se),he)},registerDefinitionProvider(se,he){return lt.registerDefinitionProvider(Me,gt(se),he)},registerDeclarationProvider(se,he){return lt.registerDeclarationProvider(Me,gt(se),he)},registerImplementationProvider(se,he){return lt.registerImplementationProvider(Me,gt(se),he)},registerTypeDefinitionProvider(se,he){return lt.registerTypeDefinitionProvider(Me,gt(se),he)},registerHoverProvider(se,he){return lt.registerHoverProvider(Me,gt(se),he,Me.identifier)},registerEvaluatableExpressionProvider(se,he){return lt.registerEvaluatableExpressionProvider(Me,gt(se),he,Me.identifier)},registerInlineValuesProvider(se,he){return lt.registerInlineValuesProvider(Me,gt(se),he,Me.identifier)},registerDocumentHighlightProvider(se,he){return lt.registerDocumentHighlightProvider(Me,gt(se),he)},registerLinkedEditingRangeProvider(se,he){return lt.registerLinkedEditingRangeProvider(Me,gt(se),he)},registerReferenceProvider(se,he){return lt.registerReferenceProvider(Me,gt(se),he)},registerRenameProvider(se,he){return lt.registerRenameProvider(Me,gt(se),he)},registerDocumentSymbolProvider(se,he,Re){return lt.registerDocumentSymbolProvider(Me,gt(se),he,Re)},registerWorkspaceSymbolProvider(se){return lt.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,he){return lt.registerDocumentFormattingEditProvider(Me,gt(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return lt.registerDocumentRangeFormattingEditProvider(Me,gt(se),he)},registerOnTypeFormattingEditProvider(se,he,Re,...ot){return lt.registerOnTypeFormattingEditProvider(Me,gt(se),he,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,he,Re){return lt.registerDocumentSemanticTokensProvider(Me,gt(se),he,Re)},registerDocumentRangeSemanticTokensProvider(se,he,Re){return lt.registerDocumentRangeSemanticTokensProvider(Me,gt(se),he,Re)},registerSignatureHelpProvider(se,he,Re,...ot){return typeof Re=="object"?lt.registerSignatureHelpProvider(Me,gt(se),he,Re):lt.registerSignatureHelpProvider(Me,gt(se),he,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,he,...Re){return lt.registerCompletionItemProvider(Me,gt(se),he,Re)},registerInlineCompletionItemProvider(se,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Me,gt(se),he)},registerInlineCompletionItemProviderNew(se,he){if((0,We.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,We.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(Me,gt(se),he)},registerDocumentLinkProvider(se,he){return lt.registerDocumentLinkProvider(Me,gt(se),he)},registerColorProvider(se,he){return lt.registerColorProvider(Me,gt(se),he)},registerFoldingRangeProvider(se,he){return lt.registerFoldingRangeProvider(Me,gt(se),he)},registerSelectionRangeProvider(se,he){return lt.registerSelectionRangeProvider(Me,se,he)},registerCallHierarchyProvider(se,he){return lt.registerCallHierarchyProvider(Me,se,he)},registerTypeHierarchyProvider(se,he){return lt.registerTypeHierarchyProvider(Me,se,he)},setLanguageConfiguration:(se,he)=>lt.setLanguageConfiguration(Me,se,he),getTokenInformationAtPosition(se,he){return(0,We.checkProposedApiEnabled)(Me,"tokenInformation"),Yt.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return lt.registerInlayHintsProvider(Me,se,he)},createLanguageStatusItem(se,he){return Yt.createLanguageStatusItem(Me,se,he)},registerDocumentDropEditProvider(se,he){return lt.registerDocumentOnDropEditProvider(Me,se,he)}},Di={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(se,he,Re){const ot=await(_.URI.isUri(se)?Promise.resolve(Pi.openTextDocument(se)):Promise.resolve(se));return kt.showTextDocument(ot,he,Re)},createTextEditorDecorationType(se){return kt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,he,Re){return kt.onDidChangeActiveTextEditor(se,he,Re)},onDidChangeVisibleTextEditors(se,he,Re){return kt.onDidChangeVisibleTextEditors(se,he,Re)},onDidChangeTextEditorSelection(se,he,Re){return kt.onDidChangeTextEditorSelection(se,he,Re)},onDidChangeTextEditorOptions(se,he,Re){return kt.onDidChangeTextEditorOptions(se,he,Re)},onDidChangeTextEditorVisibleRanges(se,he,Re){return kt.onDidChangeTextEditorVisibleRanges(se,he,Re)},onDidChangeTextEditorViewColumn(se,he,Re){return kt.onDidChangeTextEditorViewColumn(se,he,Re)},onDidCloseTerminal(se,he,Re){return Xe.onDidCloseTerminal(se,he,Re)},onDidOpenTerminal(se,he,Re){return Xe.onDidOpenTerminal(se,he,Re)},onDidChangeActiveTerminal(se,he,Re){return Xe.onDidChangeActiveTerminal(se,he,Re)},onDidChangeTerminalDimensions(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDimensions"),Xe.onDidChangeTerminalDimensions(se,he,Re)},onDidChangeTerminalState(se,he,Re){return Xe.onDidChangeTerminalState(se,he,Re)},onDidWriteTerminalData(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Xe.onDidWriteTerminalData(se,he,Re)},get state(){return me.state},onDidChangeWindowState(se,he,Re){return me.onDidChangeWindowState(se,he,Re)},showInformationMessage(se,...he){return yi.showMessage(Me,M.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return yi.showMessage(Me,M.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return yi.showMessage(Me,M.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Re){return Kt.showQuickPick(se,he,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,he){return Kt.showInput(se,he)},showOpenDialog(se){return ki.showOpenDialog(se)},showSaveDialog(se){return ki.showSaveDialog(se)},createStatusBarItem(se,he,Re){let ot,wt,Tt;return typeof se=="string"?(ot=se,wt=he,Tt=Re):(wt=se,Tt=he),Ti.createStatusBarEntry(Me,ot,wt,Tt)},setStatusBarMessage(se,he){return Ti.setStatusBarMessage(se,he)},withScmProgress(se){return De.report("window.withScmProgress",Me,"Use 'withProgress' instead."),si.withProgress(Me,{location:R.ProgressLocation.SourceControl},(he,Re)=>se({report(ot){}}))},withProgress(se,he){return si.withProgress(Me,se,he)},createOutputChannel(se,he){return St.createOutputChannel(se,he,Me)},createWebviewPanel(se,he,Re,ot){return Zt.createWebviewPanel(Me,se,he,Re,ot)},createWebviewTextEditorInset(se,he,Re,ot){return(0,We.checkProposedApiEnabled)(Me,"editorInsets"),gi.createWebviewEditorInset(se,he,Re,ot,Me)},createTerminal(se,he,Re){return typeof se=="object"?"pty"in se?Xe.createExtensionTerminal(se):Xe.createTerminalFromOptions(se):Xe.createTerminal(se,he,Re)},registerTerminalLinkProvider(se){return Xe.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return Xe.registerProfileProvider(Me,se,he)},registerTreeDataProvider(se,he){return zt.registerTreeDataProvider(se,he,Me)},createTreeView(se,he){return zt.createTreeView(se,he,Me)},registerWebviewPanelSerializer:(se,he)=>Zt.registerWebviewPanelSerializer(Me,se,he),registerCustomEditorProvider:(se,he,Re={})=>bi.registerCustomEditorProvider(Me,se,he,Re),registerFileDecorationProvider(se){return Le.registerFileDecorationProvider(se,Me.identifier)},registerUriHandler(se){return bt.registerUriHandler(Me.identifier,se)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return oi.activeColorTheme},onDidChangeActiveColorTheme(se,he,Re){return oi.onDidChangeActiveColorTheme(se,he,Re)},registerWebviewViewProvider(se,he,Re){return wi.registerWebviewViewProvider(Me,se,he,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Re){return vt.onDidChangeActiveNotebookEditor(se,he,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Re){return Ht.onDidChangeNotebookEditorSelection(se,he,Re)},onDidChangeNotebookEditorVisibleRanges(se,he,Re){return Ht.onDidChangeNotebookEditorVisibleRanges(se,he,Re)},showNotebookDocument(se,he){return _.URI.isUri(se)&&De.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"externalUriOpener"),Si.registerExternalUriOpener(Me.identifier,se,he,Re)},get tabGroups(){return Ae.tabGroups},logTelemetryToOutputChannel(se,he){(0,We.checkProposedApiEnabled)(Me,"telemetryLog"),Se.logToTelemetryOutputChannel(Me,se,he)}},Pi={get rootPath(){return De.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw y.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw y.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw y.readonly()},updateWorkspaceFolders:(se,he,...Re)=>mt.updateWorkspaceFolders(Me,se,he||0,...Re),onDidChangeWorkspaceFolders:function(se,he,Re){return mt.onDidChangeWorkspace(se,he,Re)},asRelativePath:(se,he)=>mt.getRelativePath(se,he),findFiles:(se,he,Re,ot)=>mt.findFiles(se,he,Re,Me.identifier,ot),findTextInFiles:(se,he,Re,ot)=>{(0,We.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Tt;return typeof he=="object"?(wt=he,Tt=Re):(wt={},Tt=he,ot=Re),mt.findTextInFiles(se,wt||{},Tt,Me.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se){return Fi.applyWorkspaceEdit(se,Me)},createFileSystemWatcher:(se,he,Re,ot)=>$t.createFileSystemWatcher(mt,Me,se,he,Re,ot),get textDocuments(){return ft.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw y.readonly()},openTextDocument(se){let he;const Re=se;if(typeof se=="string")he=Promise.resolve(_.URI.file(se));else if(_.URI.isUri(se))he=Promise.resolve(se);else if(!Re||typeof Re=="object")he=ft.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ot=>ft.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(se,he,Re)=>ft.onDidAddDocument(se,he,Re),onDidCloseTextDocument:(se,he,Re)=>ft.onDidRemoveDocument(se,he,Re),onDidChangeTextDocument:(se,he,Re)=>ft.onDidChangeDocument(se,he,Re),onDidSaveTextDocument:(se,he,Re)=>ft.onDidSaveDocument(se,he,Re),onWillSaveTextDocument:(se,he,Re)=>Qt.getOnWillSaveTextDocumentEvent(Me)(se,he,Re),get notebookDocuments(){return vt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Re;if(_.URI.isUri(se))Re=se,await vt.openNotebookDocument(se);else if(typeof se=="string")Re=_.URI.revive(await vt.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,he,Re){return qt.onDidSaveNotebookDocument(se,he,Re)},onDidChangeNotebookDocument(se,he,Re){return qt.onDidChangeNotebookDocument(se,he,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Re,ot){return vt.registerNotebookSerializer(Me,se,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,he,Re,ot)=>((0,We.checkProposedApiEnabled)(Me,"notebookContentProvider"),De.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Me,se,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,he,Re)=>ci.onDidChangeConfiguration(se,he,Re),getConfiguration(se,he){return he=arguments.length===1?void 0:he,ci.getConfiguration(se,he,Me)},registerTextDocumentContentProvider(se,he){return It.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(De.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Me,se,he)),registerFileSystemProvider(se,he,Re){return(0,Ke.combinedDisposable)(pi.registerFileSystemProvider(Me,se,he,Re),Ot.addFileSystemProvider(se,he))},get fs(){return Ot.value},registerFileSearchProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ct.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"textSearchProvider"),Ct.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Ft.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Re)=>$t.onDidCreateFile(se,he,Re),onDidDeleteFiles:(se,he,Re)=>$t.onDidDeleteFile(se,he,Re),onDidRenameFiles:(se,he,Re)=>$t.onDidRenameFile(se,he,Re),onWillCreateFiles:(se,he,Re)=>$t.getOnWillCreateFileEvent(Me)(se,he,Re),onWillDeleteFiles:(se,he,Re)=>$t.getOnWillDeleteFileEvent(Me)(se,he,Re),onWillRenameFiles:(se,he,Re)=>$t.getOnWillRenameFileEvent(Me)(se,he,Re),openTunnel:se=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Dt.openTunnel(Me,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),Dt.getTunnels()},onDidChangeTunnels:(se,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Dt.onDidChangeTunnels(se,he,Re)),registerPortAttributesProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"portsAttributes"),Dt.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"timeline"),Oi.registerTimelineProvider(se,he,Me.identifier,je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,We.checkProposedApiEnabled)(Me,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Re)=>mt.onDidGrantWorkspaceTrust(se,he,Re),registerEditSessionIdentityProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,he))},Vt={get inputBox(){return De.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ri.getLastInputBox(Me)},createSourceControl(se,he,Re){return ri.createSourceControl(Me,se,he,Re)}},ui={createCommentController(se,he){return vi.createCommentController(Me,se,he)}},zi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(se,he,Re){return ct.onDidStartDebugSession(se,he,Re)},onDidTerminateDebugSession(se,he,Re){return ct.onDidTerminateDebugSession(se,he,Re)},onDidChangeActiveDebugSession(se,he,Re){return ct.onDidChangeActiveDebugSession(se,he,Re)},onDidReceiveDebugSessionCustomEvent(se,he,Re){return ct.onDidReceiveDebugSessionCustomEvent(se,he,Re)},onDidChangeBreakpoints(se,he,Re){return ct.onDidChangeBreakpoints(se,he,Re)},registerDebugConfigurationProvider(se,he,Re){return ct.registerDebugConfigurationProvider(se,he,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return ct.registerDebugAdapterDescriptorFactory(Me,se,he)},registerDebugAdapterTrackerFactory(se,he){return ct.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(se,he,{parentSession:Re}):ct.startDebugging(se,he,Re||{})},stopDebugging(se){return ct.stopDebugging(se)},addBreakpoints(se){return ct.addBreakpoints(se)},removeBreakpoints(se){return ct.removeBreakpoints(se)},asDebugSourceUri(se,he){return ct.asDebugSourceUri(se,he)}},Lt={registerTaskProvider:(se,he)=>Et.registerTaskProvider(Me,se,he),fetchTasks:se=>Et.fetchTasks(se),executeTask:se=>Et.executeTask(Me,se),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(se,he,Re)=>Et.onDidStartTask(se,he,Re),onDidEndTask:(se,he,Re)=>Et.onDidEndTask(se,he,Re),onDidStartTaskProcess:(se,he,Re)=>Et.onDidStartTaskProcess(se,he,Re),onDidEndTaskProcess:(se,he,Re)=>Et.onDidEndTaskProcess(se,he,Re)},di={createNotebookController(se,he,Re,ot,wt){return ii.createNotebookController(Me,se,he,Re,ot,(0,We.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>vt.registerNotebookCellStatusBarItemProvider(Me,se,he),createRendererMessaging(se){return mi.createRendererMessaging(Me,se)},onDidChangeNotebookCellExecutionState(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(se,he,Re)}};return{version:rt.version,authentication:Mi,commands:Li,comments:ui,debug:zi,env:ti,extensions:Bi,languages:xi,notebooks:di,scm:Vt,tasks:Lt,tests:Ui,window:Di,workspace:Pi,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:y.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CommentThreadState:R.CommentThreadState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:R.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionItemNew:R.InlineSuggestionNew,InlineCompletionList:R.InlineSuggestionList,InlineCompletionListNew:R.InlineSuggestionsNew,Hover:R.Hover,IndentAction:k.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TerminalLink:R.TerminalLink,TerminalLocation:R.TerminalLocation,TerminalProfile:R.TerminalProfile,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,SnippetTextEdit:R.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,TextDocumentChangeReason:R.TextDocumentChangeReason,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItem2:R.TreeItem,TreeItemCheckboxState:R.TreeItemCheckboxState,TreeItemCollapsibleState:R.TreeItemCollapsibleState,TypeHierarchyItem:R.TypeHierarchyItem,UIKind:I.UIKind,Uri:_.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,DocumentDropEdit:R.DocumentDropEdit,DocumentPasteEdit:R.DocumentPasteEdit,InlayHint:R.InlayHint,InlayHintLabelPart:R.InlayHintLabelPart,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,NotebookEdit:R.NotebookEdit,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestResultState:R.TestResultState,TestRunRequest:R.TestRunRequest,TestMessage:R.TestMessage,TestTag:R.TestTag,TestRunProfileKind:R.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:R.DataTransfer,DataTransferItem:R.DataTransferItem,CoveredCount:R.CoveredCount,FileCoverage:R.FileCoverage,StatementCoverage:R.StatementCoverage,BranchCoverage:R.BranchCoverage,FunctionCoverage:R.FunctionCoverage,WorkspaceTrustState:R.WorkspaceTrustState,LanguageStatusSeverity:R.LanguageStatusSeverity,QuickPickItemKind:R.QuickPickItemKind,InputBoxValidationSeverity:R.InputBoxValidationSeverity,TabInputText:R.TextTabInput,TabInputTextDiff:R.TextDiffTabInput,TabInputTextMerge:R.TextMergeTabInput,TabInputCustom:R.CustomEditorTabInput,TabInputNotebook:R.NotebookEditorTabInput,TabInputNotebookDiff:R.NotebookDiffEditorTabInput,TabInputWebview:R.WebviewEditorTabInput,TabInputTerminal:R.TerminalEditorTabInput,TabInputInteractiveWindow:R.InteractiveWindowInput,TerminalExitReason:R.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=dt}),define(Ce[237],Ie([1,0,236,33,2,230,6,14,221,21]),function(ne,e,o,y,b,M,_,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class O extends M.RequireInterceptor{_installInterceptor(){}getModule(f,a){for(const h of this._alternatives){const d=h(f);if(d){f=d;break}}if(this._factories.has(f))return this._factories.get(f).load(f,a,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class w extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(O,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,a,h){a=a.with({path:m(a.path,".js")});const d=f?.identifier.value;d&&performance.mark(`code/extHost/willFetchExtensionCode/${d}`);const g=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(a)),A=await fetch(g.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d}`),A.status!==200)throw new Error(A.statusText);const c=await A.text(),v=`${a.toString(!0)}#vscode-extension`,t=`${c}
//# sourceURL=${v}`;let u;try{u=new Function("module","exports","require",t)}catch(l){throw console.error(d?`Loading code for extension ${d} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${a.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}const n=await this.fetchTranslatedStrings(f),r={},s={exports:r},i=l=>{if(l==="vscode-nls-web-data")return n;const S=this._fakeModules.getModule(l,a);if(S===void 0)throw new Error(`Cannot load module '${l}'`);return S};try{return h.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d}`),u(s,r,i),s.exports!==r?s.exports:r}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const a=Date.now()+f;for(;Date.now()<a&&!("__jsDebugIsReady"in globalThis);)await(0,P.timeout)(10)}async fetchTranslatedStrings(f){let a={};if(!f)return{};const h=k.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[k.Language.value()]??f.browserNlsBundleUris?.en;if(f&&h)try{const d=await fetch(h.toString(!0));if(!d.ok)throw new Error(await d.text());a=await d.json()}catch(d){try{console.error(`Failed to load translations for ${f.identifier.value} from ${h}: ${d.message}`);const g=f.browserNlsBundleUris?.en;if(g){const A=await fetch(g.toString(!0));if(!A.ok)throw new Error(await A.text());a=await A.json()}throw new Error("No English strings found")}catch(g){console.error(g)}}return a}}e.ExtHostExtensionService=w;function m(I,f){return I.endsWith(f)?I:I+f}}),define(Ce[238],Ie([1,0,56,33,69,237]),function(ne,e,o,y,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(y.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,o.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths,!1)}),define(Ce[247],Ie([1,0,23,5,91,231,223,19,70,12,2,233,238]),function(ne,e,o,y,b,M,_,P,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function I(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function a(t){self.fetch=async function(u,n){return u instanceof Request||I(String(u))&&(u=(await t(O.URI.parse(String(u)))).toString(!0)),f(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,r,s,i){(async()=>(I(n.toString())&&(n=(await t(O.URI.parse(n.toString()))).toString(!0)),super.open(u,n,r??!0,s,i)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=k.FileAccess.asBrowserUri(O.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(p){function T(x){return typeof x=="string"||x instanceof URL?String(x).replace(/^file:\/\//i,"vscode-file://vscode-app"):x}const U=fetch.bind(self);self.fetch=function(x,C){return x instanceof Request?U(x,C):U(T(x),C)},self.XMLHttpRequest=class extends XMLHttpRequest{open(x,C,z,N,L){return super.open(x,T(C),z??!0,N,L)}};const j=importScripts.bind(self);self.importScripts=(...x)=>{j(...x.map(T))},j(p)}.toString()}('${u}'))`;n=n||{},n.name=n.name||P.basename(u.toString());const i=new Blob([s],{type:"application/javascript"}),l=URL.createObjectURL(i);return new t(l,n)}}else self.Worker=class extends _.NestedWorker{constructor(t,u){super(m,t,{name:P.basename(t.toString()),...u})}};const h=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class d{constructor(){const u=new MessageChannel,n=new y.Emitter;let r=!1;m(u.port2,[u.port2]),u.port1.onmessage=s=>{const{data:i}=s;if(!(i instanceof ArrayBuffer)){console.warn("UNKNOWN data received",i);return}const l=o.VSBuffer.wrap(new Uint8Array(i,0,i.byteLength));if((0,b.isMessageOfType)(l,2)){r=!0,A("received terminate message from renderer");return}n.fire(l)},this.protocol={onMessage:n.event,send:s=>{if(!r){const i=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);u.port1.postMessage(i,[i])}}}}}function g(t){return new Promise(u=>{const n=t.onMessage(r=>{n.dispose();const s=JSON.parse(r.toString());t.send((0,b.createMessageOfType)(0)),u({protocol:t,initData:s})});t.send((0,b.createMessageOfType)(1))})}let A=t=>w();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){E.mark("code/extHost/willConnectToRenderer");const t=new d;return{onmessage(u){!c(u)||g(t.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const r=new M.ExtensionHostMain(n.protocol,n.initData,h,null,u.data);a(s=>r.asBrowserUri(s)),A=s=>r.terminate(s)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ecad25c181c084a505add3e76b34932f0bcc4b25/core/vs/workbench/api/worker/extensionHostWorker.js.map
